/* OAuth1Support.c generated by valac 0.52.10, the Vala compiler
 * generated from OAuth1Support.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2017 Jens Georg <mail@jensge.org>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "shotwell-plugin-common.h"
#include <libsoup/soup.h>
#include "shotwell-plugin-dev-1.0.h"

#define _g_free0(var) (var = (g_free (var), NULL))
#define _publishing_rest_support_argument_unref0(var) ((var == NULL) ? NULL : (var = (publishing_rest_support_argument_unref (var), NULL)))
#define _publishing_rest_support_session_unref0(var) ((var == NULL) ? NULL : (var = (publishing_rest_support_session_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PublishingRESTSupportOAuth1SessionPrivate {
	gchar* request_phase_token;
	gchar* request_phase_token_secret;
	gchar* access_phase_token;
	gchar* access_phase_token_secret;
	gchar* username;
	gchar* consumer_key;
	gchar* consumer_secret;
};

struct _PublishingRESTSupportOAuth1UploadTransactionPrivate {
	PublishingRESTSupportArgument** auth_header_fields;
	gint auth_header_fields_length1;
	gint _auth_header_fields_size_;
};

static gint PublishingRESTSupportOAuth1Session_private_offset;
static gpointer publishing_rest_support_oauth1_session_parent_class = NULL;
static gpointer publishing_rest_support_oauth1_transaction_parent_class = NULL;
static gint PublishingRESTSupportOAuth1UploadTransaction_private_offset;
static gpointer publishing_rest_support_oauth1_upload_transaction_parent_class = NULL;

#define PUBLISHING_REST_SUPPORT_OAUTH1_ENCODE_RFC_3986_EXTRA "!*'();:@&=+$,/?%#[] \\"
static gboolean publishing_rest_support_oauth1_session_real_is_authenticated (PublishingRESTSupportSession* base);
static void _vala_array_add4 (PublishingRESTSupportArgument** * array,
                       gint* length,
                       gint* size,
                       PublishingRESTSupportArgument* value);
static void publishing_rest_support_oauth1_session_finalize (PublishingRESTSupportSession * obj);
static GType publishing_rest_support_oauth1_session_get_type_once (void);
static void publishing_rest_support_oauth1_transaction_setup_arguments (PublishingRESTSupportOAuth1Transaction* self);
static void publishing_rest_support_oauth1_transaction_real_execute (PublishingRESTSupportTransaction* base,
                                                              GError** error);
static GType publishing_rest_support_oauth1_transaction_get_type_once (void);
static void _vala_array_add5 (PublishingRESTSupportArgument** * array,
                       gint* length,
                       gint* size,
                       PublishingRESTSupportArgument* value);
static void publishing_rest_support_oauth1_upload_transaction_finalize (PublishingRESTSupportTransaction * obj);
static GType publishing_rest_support_oauth1_upload_transaction_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
publishing_rest_support_oauth1_session_get_instance_private (PublishingRESTSupportOAuth1Session* self)
{
	return G_STRUCT_MEMBER_P (self, PublishingRESTSupportOAuth1Session_private_offset);
}

PublishingRESTSupportOAuth1Session*
publishing_rest_support_oauth1_session_construct (GType object_type,
                                                  const gchar* endpoint_uri)
{
	PublishingRESTSupportOAuth1Session* self = NULL;
#line 21 "../plugins/common/OAuth1Support.vala"
	self = (PublishingRESTSupportOAuth1Session*) publishing_rest_support_session_construct (object_type, endpoint_uri);
#line 20 "../plugins/common/OAuth1Support.vala"
	return self;
#line 91 "OAuth1Support.c"
}

PublishingRESTSupportOAuth1Session*
publishing_rest_support_oauth1_session_new (const gchar* endpoint_uri)
{
#line 20 "../plugins/common/OAuth1Support.vala"
	return publishing_rest_support_oauth1_session_construct (PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION, endpoint_uri);
#line 99 "OAuth1Support.c"
}

static gboolean
publishing_rest_support_oauth1_session_real_is_authenticated (PublishingRESTSupportSession* base)
{
	PublishingRESTSupportOAuth1Session * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean result = FALSE;
#line 24 "../plugins/common/OAuth1Support.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION, PublishingRESTSupportOAuth1Session);
#line 25 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = self->priv->access_phase_token;
#line 25 "../plugins/common/OAuth1Support.vala"
	if (_tmp2_ != NULL) {
#line 116 "OAuth1Support.c"
		const gchar* _tmp3_;
#line 25 "../plugins/common/OAuth1Support.vala"
		_tmp3_ = self->priv->access_phase_token_secret;
#line 25 "../plugins/common/OAuth1Support.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 122 "OAuth1Support.c"
	} else {
#line 25 "../plugins/common/OAuth1Support.vala"
		_tmp1_ = FALSE;
#line 126 "OAuth1Support.c"
	}
#line 25 "../plugins/common/OAuth1Support.vala"
	if (_tmp1_) {
#line 130 "OAuth1Support.c"
		const gchar* _tmp4_;
#line 26 "../plugins/common/OAuth1Support.vala"
		_tmp4_ = self->priv->username;
#line 26 "../plugins/common/OAuth1Support.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 136 "OAuth1Support.c"
	} else {
#line 25 "../plugins/common/OAuth1Support.vala"
		_tmp0_ = FALSE;
#line 140 "OAuth1Support.c"
	}
#line 25 "../plugins/common/OAuth1Support.vala"
	result = _tmp0_;
#line 25 "../plugins/common/OAuth1Support.vala"
	return result;
#line 146 "OAuth1Support.c"
}

void
publishing_rest_support_oauth1_session_authenticate_from_persistent_credentials (PublishingRESTSupportOAuth1Session* self,
                                                                                 const gchar* token,
                                                                                 const gchar* secret,
                                                                                 const gchar* username)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 29 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self));
#line 29 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (token != NULL);
#line 29 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (secret != NULL);
#line 29 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (username != NULL);
#line 31 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = g_strdup (token);
#line 31 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->access_phase_token);
#line 31 "../plugins/common/OAuth1Support.vala"
	self->priv->access_phase_token = _tmp0_;
#line 32 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = g_strdup (secret);
#line 32 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->access_phase_token_secret);
#line 32 "../plugins/common/OAuth1Support.vala"
	self->priv->access_phase_token_secret = _tmp1_;
#line 33 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = g_strdup (username);
#line 33 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->username);
#line 33 "../plugins/common/OAuth1Support.vala"
	self->priv->username = _tmp2_;
#line 35 "../plugins/common/OAuth1Support.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_SESSION, PublishingRESTSupportSession), "authenticated");
#line 186 "OAuth1Support.c"
}

void
publishing_rest_support_oauth1_session_deauthenticate (PublishingRESTSupportOAuth1Session* self)
{
#line 38 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self));
#line 39 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->access_phase_token);
#line 39 "../plugins/common/OAuth1Support.vala"
	self->priv->access_phase_token = NULL;
#line 40 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->access_phase_token_secret);
#line 40 "../plugins/common/OAuth1Support.vala"
	self->priv->access_phase_token_secret = NULL;
#line 41 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->username);
#line 41 "../plugins/common/OAuth1Support.vala"
	self->priv->username = NULL;
#line 206 "OAuth1Support.c"
}

void
publishing_rest_support_oauth1_session_set_api_credentials (PublishingRESTSupportOAuth1Session* self,
                                                            const gchar* consumer_key,
                                                            const gchar* consumer_secret)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 44 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self));
#line 44 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (consumer_key != NULL);
#line 44 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (consumer_secret != NULL);
#line 45 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = g_strdup (consumer_key);
#line 45 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->consumer_key);
#line 45 "../plugins/common/OAuth1Support.vala"
	self->priv->consumer_key = _tmp0_;
#line 46 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = g_strdup (consumer_secret);
#line 46 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->consumer_secret);
#line 46 "../plugins/common/OAuth1Support.vala"
	self->priv->consumer_secret = _tmp1_;
#line 234 "OAuth1Support.c"
}

static gpointer
_publishing_rest_support_argument_ref0 (gpointer self)
{
#line 58 "../plugins/common/OAuth1Support.vala"
	return self ? publishing_rest_support_argument_ref (self) : NULL;
#line 242 "OAuth1Support.c"
}

static void
_vala_array_add4 (PublishingRESTSupportArgument** * array,
                  gint* length,
                  gint* size,
                  PublishingRESTSupportArgument* value)
{
#line 59 "../plugins/common/OAuth1Support.vala"
	if ((*length) == (*size)) {
#line 59 "../plugins/common/OAuth1Support.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 59 "../plugins/common/OAuth1Support.vala"
		*array = g_renew (PublishingRESTSupportArgument*, *array, (*size) + 1);
#line 257 "OAuth1Support.c"
	}
#line 59 "../plugins/common/OAuth1Support.vala"
	(*array)[(*length)++] = value;
#line 59 "../plugins/common/OAuth1Support.vala"
	(*array)[*length] = NULL;
#line 263 "OAuth1Support.c"
}

gchar*
publishing_rest_support_oauth1_session_sign_transaction (PublishingRESTSupportOAuth1Session* self,
                                                         PublishingRESTSupportTransaction* txn,
                                                         PublishingRESTSupportArgument** extra_arguments,
                                                         gint extra_arguments_length1)
{
	gchar* http_method = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	PublishingRESTSupportArgument** base_string_arguments = NULL;
	gint _tmp4_ = 0;
	PublishingRESTSupportArgument** _tmp5_;
	gint base_string_arguments_length1;
	gint _base_string_arguments_size_;
	PublishingRESTSupportArgument** sorted_args = NULL;
	PublishingRESTSupportArgument** _tmp9_;
	gint _tmp9__length1;
	gint _tmp10_ = 0;
	PublishingRESTSupportArgument** _tmp11_;
	gint sorted_args_length1;
	gint _sorted_args_size_;
	gchar* arguments_string = NULL;
	PublishingRESTSupportArgument** _tmp12_;
	gint _tmp12__length1;
	gchar* _tmp13_;
	gchar* signing_key = NULL;
	const gchar* _tmp14_;
	gchar* signature_base_string = NULL;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	const gchar* _tmp44_;
	gchar* signature = NULL;
	const gchar* _tmp45_;
	gchar* _tmp46_;
	const gchar* _tmp47_;
	gchar* _tmp48_;
	const gchar* _tmp49_;
	gchar* result = NULL;
#line 49 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self), NULL);
#line 49 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_IS_TRANSACTION (txn), NULL);
#line 51 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = publishing_rest_support_http_method_to_string (publishing_rest_support_transaction_get_method (txn));
#line 51 "../plugins/common/OAuth1Support.vala"
	http_method = _tmp0_;
#line 53 "../plugins/common/OAuth1Support.vala"
	g_debug ("OAuth1Support.vala:53: signing transaction with parameters:");
#line 54 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = http_method;
#line 54 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = g_strconcat ("HTTP method = ", _tmp1_, NULL);
#line 54 "../plugins/common/OAuth1Support.vala"
	_tmp3_ = _tmp2_;
#line 54 "../plugins/common/OAuth1Support.vala"
	g_debug ("OAuth1Support.vala:54: %s", _tmp3_);
#line 54 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp3_);
#line 56 "../plugins/common/OAuth1Support.vala"
	_tmp5_ = publishing_rest_support_transaction_get_arguments (txn, &_tmp4_);
#line 56 "../plugins/common/OAuth1Support.vala"
	base_string_arguments = _tmp5_;
#line 56 "../plugins/common/OAuth1Support.vala"
	base_string_arguments_length1 = _tmp4_;
#line 56 "../plugins/common/OAuth1Support.vala"
	_base_string_arguments_size_ = base_string_arguments_length1;
#line 348 "OAuth1Support.c"
	{
		PublishingRESTSupportArgument** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 58 "../plugins/common/OAuth1Support.vala"
		arg_collection = extra_arguments;
#line 58 "../plugins/common/OAuth1Support.vala"
		arg_collection_length1 = extra_arguments_length1;
#line 58 "../plugins/common/OAuth1Support.vala"
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 360 "OAuth1Support.c"
			PublishingRESTSupportArgument* _tmp6_;
			PublishingRESTSupportArgument* arg = NULL;
#line 58 "../plugins/common/OAuth1Support.vala"
			_tmp6_ = _publishing_rest_support_argument_ref0 (arg_collection[arg_it]);
#line 58 "../plugins/common/OAuth1Support.vala"
			arg = _tmp6_;
#line 367 "OAuth1Support.c"
			{
				PublishingRESTSupportArgument* _tmp7_;
				PublishingRESTSupportArgument* _tmp8_;
#line 59 "../plugins/common/OAuth1Support.vala"
				_tmp7_ = arg;
#line 59 "../plugins/common/OAuth1Support.vala"
				_tmp8_ = _publishing_rest_support_argument_ref0 (_tmp7_);
#line 59 "../plugins/common/OAuth1Support.vala"
				_vala_array_add4 (&base_string_arguments, &base_string_arguments_length1, &_base_string_arguments_size_, _tmp8_);
#line 58 "../plugins/common/OAuth1Support.vala"
				_publishing_rest_support_argument_unref0 (arg);
#line 379 "OAuth1Support.c"
			}
		}
	}
#line 62 "../plugins/common/OAuth1Support.vala"
	_tmp9_ = base_string_arguments;
#line 62 "../plugins/common/OAuth1Support.vala"
	_tmp9__length1 = base_string_arguments_length1;
#line 62 "../plugins/common/OAuth1Support.vala"
	_tmp11_ = publishing_rest_support_argument_sort (_tmp9_, (gint) _tmp9__length1, &_tmp10_);
#line 62 "../plugins/common/OAuth1Support.vala"
	sorted_args = _tmp11_;
#line 62 "../plugins/common/OAuth1Support.vala"
	sorted_args_length1 = _tmp10_;
#line 62 "../plugins/common/OAuth1Support.vala"
	_sorted_args_size_ = sorted_args_length1;
#line 65 "../plugins/common/OAuth1Support.vala"
	_tmp12_ = sorted_args;
#line 65 "../plugins/common/OAuth1Support.vala"
	_tmp12__length1 = sorted_args_length1;
#line 65 "../plugins/common/OAuth1Support.vala"
	_tmp13_ = publishing_rest_support_argument_serialize_for_sbs (_tmp12_, (gint) _tmp12__length1);
#line 65 "../plugins/common/OAuth1Support.vala"
	arguments_string = _tmp13_;
#line 67 "../plugins/common/OAuth1Support.vala"
	signing_key = NULL;
#line 68 "../plugins/common/OAuth1Support.vala"
	_tmp14_ = self->priv->access_phase_token_secret;
#line 68 "../plugins/common/OAuth1Support.vala"
	if (_tmp14_ != NULL) {
#line 409 "OAuth1Support.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
#line 69 "../plugins/common/OAuth1Support.vala"
		g_debug ("OAuth1Support.vala:69: access phase token secret available; using it a" \
"s signing key");
#line 71 "../plugins/common/OAuth1Support.vala"
		_tmp15_ = self->priv->consumer_secret;
#line 71 "../plugins/common/OAuth1Support.vala"
		_tmp16_ = g_strconcat (_tmp15_, "&", NULL);
#line 71 "../plugins/common/OAuth1Support.vala"
		_tmp17_ = _tmp16_;
#line 71 "../plugins/common/OAuth1Support.vala"
		_tmp18_ = self->priv->access_phase_token_secret;
#line 71 "../plugins/common/OAuth1Support.vala"
		_tmp19_ = g_strconcat (_tmp17_, _tmp18_, NULL);
#line 71 "../plugins/common/OAuth1Support.vala"
		_g_free0 (signing_key);
#line 71 "../plugins/common/OAuth1Support.vala"
		signing_key = _tmp19_;
#line 71 "../plugins/common/OAuth1Support.vala"
		_g_free0 (_tmp17_);
#line 433 "OAuth1Support.c"
	} else {
		const gchar* _tmp20_;
#line 72 "../plugins/common/OAuth1Support.vala"
		_tmp20_ = self->priv->request_phase_token_secret;
#line 72 "../plugins/common/OAuth1Support.vala"
		if (_tmp20_ != NULL) {
#line 440 "OAuth1Support.c"
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			const gchar* _tmp24_;
			gchar* _tmp25_;
#line 73 "../plugins/common/OAuth1Support.vala"
			g_debug ("OAuth1Support.vala:73: request phase token secret available; using it " \
"as signing key");
#line 75 "../plugins/common/OAuth1Support.vala"
			_tmp21_ = self->priv->consumer_secret;
#line 75 "../plugins/common/OAuth1Support.vala"
			_tmp22_ = g_strconcat (_tmp21_, "&", NULL);
#line 75 "../plugins/common/OAuth1Support.vala"
			_tmp23_ = _tmp22_;
#line 75 "../plugins/common/OAuth1Support.vala"
			_tmp24_ = self->priv->request_phase_token_secret;
#line 75 "../plugins/common/OAuth1Support.vala"
			_tmp25_ = g_strconcat (_tmp23_, _tmp24_, NULL);
#line 75 "../plugins/common/OAuth1Support.vala"
			_g_free0 (signing_key);
#line 75 "../plugins/common/OAuth1Support.vala"
			signing_key = _tmp25_;
#line 75 "../plugins/common/OAuth1Support.vala"
			_g_free0 (_tmp23_);
#line 464 "OAuth1Support.c"
		} else {
			const gchar* _tmp26_;
			gchar* _tmp27_;
#line 77 "../plugins/common/OAuth1Support.vala"
			g_debug ("OAuth1Support.vala:77: %s", "neither access phase nor request phase token secrets available; using " \
"API " "key as signing key");
#line 80 "../plugins/common/OAuth1Support.vala"
			_tmp26_ = self->priv->consumer_secret;
#line 80 "../plugins/common/OAuth1Support.vala"
			_tmp27_ = g_strconcat (_tmp26_, "&", NULL);
#line 80 "../plugins/common/OAuth1Support.vala"
			_g_free0 (signing_key);
#line 80 "../plugins/common/OAuth1Support.vala"
			signing_key = _tmp27_;
#line 478 "OAuth1Support.c"
		}
	}
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp28_ = http_method;
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp29_ = g_strconcat (_tmp28_, "&", NULL);
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp30_ = _tmp29_;
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp31_ = publishing_rest_support_transaction_get_endpoint_url (txn);
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp32_ = _tmp31_;
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp33_ = soup_uri_encode (_tmp32_, PUBLISHING_REST_SUPPORT_OAUTH1_ENCODE_RFC_3986_EXTRA);
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp34_ = _tmp33_;
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp35_ = g_strconcat (_tmp30_, _tmp34_, NULL);
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp36_ = _tmp35_;
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp37_ = g_strconcat (_tmp36_, "&", NULL);
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp38_ = _tmp37_;
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp39_ = arguments_string;
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp40_ = soup_uri_encode (_tmp39_, PUBLISHING_REST_SUPPORT_OAUTH1_ENCODE_RFC_3986_EXTRA);
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp41_ = _tmp40_;
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp42_ = g_strconcat (_tmp38_, _tmp41_, NULL);
#line 83 "../plugins/common/OAuth1Support.vala"
	_tmp43_ = _tmp42_;
#line 83 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp41_);
#line 83 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp38_);
#line 83 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp36_);
#line 83 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp34_);
#line 83 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp32_);
#line 83 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp30_);
#line 83 "../plugins/common/OAuth1Support.vala"
	signature_base_string = _tmp43_;
#line 87 "../plugins/common/OAuth1Support.vala"
	g_debug ("OAuth1Support.vala:87: signature base string = '%s'", signature_base_string);
#line 89 "../plugins/common/OAuth1Support.vala"
	_tmp44_ = signing_key;
#line 89 "../plugins/common/OAuth1Support.vala"
	g_debug ("OAuth1Support.vala:89: signing key = '%s'", _tmp44_);
#line 92 "../plugins/common/OAuth1Support.vala"
	_tmp45_ = signing_key;
#line 92 "../plugins/common/OAuth1Support.vala"
	_tmp46_ = publishing_rest_support_hmac_sha1 (_tmp45_, signature_base_string);
#line 92 "../plugins/common/OAuth1Support.vala"
	signature = _tmp46_;
#line 93 "../plugins/common/OAuth1Support.vala"
	_tmp47_ = signature;
#line 93 "../plugins/common/OAuth1Support.vala"
	_tmp48_ = soup_uri_encode (_tmp47_, PUBLISHING_REST_SUPPORT_OAUTH1_ENCODE_RFC_3986_EXTRA);
#line 93 "../plugins/common/OAuth1Support.vala"
	_g_free0 (signature);
#line 93 "../plugins/common/OAuth1Support.vala"
	signature = _tmp48_;
#line 95 "../plugins/common/OAuth1Support.vala"
	_tmp49_ = signature;
#line 95 "../plugins/common/OAuth1Support.vala"
	g_debug ("OAuth1Support.vala:95: signature = '%s'", _tmp49_);
#line 97 "../plugins/common/OAuth1Support.vala"
	result = signature;
#line 97 "../plugins/common/OAuth1Support.vala"
	_g_free0 (signature_base_string);
#line 97 "../plugins/common/OAuth1Support.vala"
	_g_free0 (signing_key);
#line 97 "../plugins/common/OAuth1Support.vala"
	_g_free0 (arguments_string);
#line 97 "../plugins/common/OAuth1Support.vala"
	sorted_args = (_vala_array_free (sorted_args, sorted_args_length1, (GDestroyNotify) publishing_rest_support_argument_unref), NULL);
#line 97 "../plugins/common/OAuth1Support.vala"
	base_string_arguments = (_vala_array_free (base_string_arguments, base_string_arguments_length1, (GDestroyNotify) publishing_rest_support_argument_unref), NULL);
#line 97 "../plugins/common/OAuth1Support.vala"
	_g_free0 (http_method);
#line 97 "../plugins/common/OAuth1Support.vala"
	return result;
#line 567 "OAuth1Support.c"
}

void
publishing_rest_support_oauth1_session_set_request_phase_credentials (PublishingRESTSupportOAuth1Session* self,
                                                                      const gchar* token,
                                                                      const gchar* secret)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 100 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self));
#line 100 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (token != NULL);
#line 100 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (secret != NULL);
#line 101 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = g_strdup (token);
#line 101 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->request_phase_token);
#line 101 "../plugins/common/OAuth1Support.vala"
	self->priv->request_phase_token = _tmp0_;
#line 102 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = g_strdup (secret);
#line 102 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->request_phase_token_secret);
#line 102 "../plugins/common/OAuth1Support.vala"
	self->priv->request_phase_token_secret = _tmp1_;
#line 595 "OAuth1Support.c"
}

void
publishing_rest_support_oauth1_session_set_access_phase_credentials (PublishingRESTSupportOAuth1Session* self,
                                                                     const gchar* token,
                                                                     const gchar* secret,
                                                                     const gchar* username)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 105 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self));
#line 105 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (token != NULL);
#line 105 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (secret != NULL);
#line 105 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (username != NULL);
#line 106 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = g_strdup (token);
#line 106 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->access_phase_token);
#line 106 "../plugins/common/OAuth1Support.vala"
	self->priv->access_phase_token = _tmp0_;
#line 107 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = g_strdup (secret);
#line 107 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->access_phase_token_secret);
#line 107 "../plugins/common/OAuth1Support.vala"
	self->priv->access_phase_token_secret = _tmp1_;
#line 108 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = g_strdup (username);
#line 108 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->username);
#line 108 "../plugins/common/OAuth1Support.vala"
	self->priv->username = _tmp2_;
#line 110 "../plugins/common/OAuth1Support.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_SESSION, PublishingRESTSupportSession), "authenticated");
#line 635 "OAuth1Support.c"
}

gchar*
publishing_rest_support_oauth1_session_get_oauth_nonce (PublishingRESTSupportOAuth1Session* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 113 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self), NULL);
#line 114 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, g_get_real_time ());
#line 114 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = _tmp0_;
#line 114 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = g_compute_checksum_for_string (G_CHECKSUM_MD5, _tmp1_, (gsize) -1);
#line 114 "../plugins/common/OAuth1Support.vala"
	_tmp3_ = _tmp2_;
#line 114 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp1_);
#line 114 "../plugins/common/OAuth1Support.vala"
	result = _tmp3_;
#line 114 "../plugins/common/OAuth1Support.vala"
	return result;
#line 662 "OAuth1Support.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
#line 1447 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1447 "glib-2.0.vapi"
	end = _tmp0_;
#line 1448 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1448 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1449 "glib-2.0.vapi"
		result = maxlen;
#line 1449 "glib-2.0.vapi"
		return result;
#line 685 "OAuth1Support.c"
	} else {
		gchar* _tmp2_;
#line 1451 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1451 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1451 "glib-2.0.vapi"
		return result;
#line 694 "OAuth1Support.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1460 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 713 "OAuth1Support.c"
	} else {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 717 "OAuth1Support.c"
	}
#line 1460 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1462 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 723 "OAuth1Support.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1464 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1464 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1464 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 733 "OAuth1Support.c"
	}
#line 1467 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1469 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 741 "OAuth1Support.c"
	} else {
#line 1471 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 745 "OAuth1Support.c"
	}
#line 1473 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1474 "glib-2.0.vapi"
		len = string_length - offset;
#line 751 "OAuth1Support.c"
	}
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1477 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1477 "glib-2.0.vapi"
	result = _tmp3_;
#line 1477 "glib-2.0.vapi"
	return result;
#line 761 "OAuth1Support.c"
}

gchar*
publishing_rest_support_oauth1_session_get_oauth_timestamp (PublishingRESTSupportOAuth1Session* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 118 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self), NULL);
#line 119 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, g_get_real_time ());
#line 119 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = _tmp0_;
#line 119 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = string_substring (_tmp1_, (glong) 0, (glong) 10);
#line 119 "../plugins/common/OAuth1Support.vala"
	_tmp3_ = _tmp2_;
#line 119 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp1_);
#line 119 "../plugins/common/OAuth1Support.vala"
	result = _tmp3_;
#line 119 "../plugins/common/OAuth1Support.vala"
	return result;
#line 788 "OAuth1Support.c"
}

gchar*
publishing_rest_support_oauth1_session_get_consumer_key (PublishingRESTSupportOAuth1Session* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
#line 122 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self), NULL);
#line 123 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = self->priv->consumer_key;
#line 123 "../plugins/common/OAuth1Support.vala"
	_vala_assert (_tmp0_ != NULL, "consumer_key != null");
#line 124 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = self->priv->consumer_key;
#line 124 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 124 "../plugins/common/OAuth1Support.vala"
	result = _tmp2_;
#line 124 "../plugins/common/OAuth1Support.vala"
	return result;
#line 812 "OAuth1Support.c"
}

gchar*
publishing_rest_support_oauth1_session_get_request_phase_token (PublishingRESTSupportOAuth1Session* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
#line 127 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self), NULL);
#line 128 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = self->priv->request_phase_token;
#line 128 "../plugins/common/OAuth1Support.vala"
	_vala_assert (_tmp0_ != NULL, "request_phase_token != null");
#line 129 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = self->priv->request_phase_token;
#line 129 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 129 "../plugins/common/OAuth1Support.vala"
	result = _tmp2_;
#line 129 "../plugins/common/OAuth1Support.vala"
	return result;
#line 836 "OAuth1Support.c"
}

gchar*
publishing_rest_support_oauth1_session_get_access_phase_token (PublishingRESTSupportOAuth1Session* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
#line 132 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self), NULL);
#line 133 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = self->priv->access_phase_token;
#line 133 "../plugins/common/OAuth1Support.vala"
	_vala_assert (_tmp0_ != NULL, "access_phase_token != null");
#line 134 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = self->priv->access_phase_token;
#line 134 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 134 "../plugins/common/OAuth1Support.vala"
	result = _tmp2_;
#line 134 "../plugins/common/OAuth1Support.vala"
	return result;
#line 860 "OAuth1Support.c"
}

gboolean
publishing_rest_support_oauth1_session_has_access_phase_token (PublishingRESTSupportOAuth1Session* self)
{
	const gchar* _tmp0_;
	gboolean result = FALSE;
#line 137 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self), FALSE);
#line 138 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = self->priv->access_phase_token;
#line 138 "../plugins/common/OAuth1Support.vala"
	result = _tmp0_ != NULL;
#line 138 "../plugins/common/OAuth1Support.vala"
	return result;
#line 876 "OAuth1Support.c"
}

gchar*
publishing_rest_support_oauth1_session_get_access_phase_token_secret (PublishingRESTSupportOAuth1Session* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
#line 141 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self), NULL);
#line 142 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = self->priv->access_phase_token_secret;
#line 142 "../plugins/common/OAuth1Support.vala"
	_vala_assert (_tmp0_ != NULL, "access_phase_token_secret != null");
#line 143 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = self->priv->access_phase_token_secret;
#line 143 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 143 "../plugins/common/OAuth1Support.vala"
	result = _tmp2_;
#line 143 "../plugins/common/OAuth1Support.vala"
	return result;
#line 900 "OAuth1Support.c"
}

gchar*
publishing_rest_support_oauth1_session_get_username (PublishingRESTSupportOAuth1Session* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 146 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (self), NULL);
#line 147 "../plugins/common/OAuth1Support.vala"
	_vala_assert (publishing_rest_support_session_is_authenticated (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_SESSION, PublishingRESTSupportSession)), "is_authenticated()");
#line 148 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = self->priv->username;
#line 148 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 148 "../plugins/common/OAuth1Support.vala"
	result = _tmp1_;
#line 148 "../plugins/common/OAuth1Support.vala"
	return result;
#line 921 "OAuth1Support.c"
}

static void
publishing_rest_support_oauth1_session_class_init (PublishingRESTSupportOAuth1SessionClass * klass,
                                                   gpointer klass_data)
{
#line 11 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_session_parent_class = g_type_class_peek_parent (klass);
#line 11 "../plugins/common/OAuth1Support.vala"
	((PublishingRESTSupportSessionClass *) klass)->finalize = publishing_rest_support_oauth1_session_finalize;
#line 11 "../plugins/common/OAuth1Support.vala"
	g_type_class_adjust_private_offset (klass, &PublishingRESTSupportOAuth1Session_private_offset);
#line 11 "../plugins/common/OAuth1Support.vala"
	((PublishingRESTSupportSessionClass *) klass)->is_authenticated = (gboolean (*) (PublishingRESTSupportSession*)) publishing_rest_support_oauth1_session_real_is_authenticated;
#line 936 "OAuth1Support.c"
}

static void
publishing_rest_support_oauth1_session_instance_init (PublishingRESTSupportOAuth1Session * self,
                                                      gpointer klass)
{
#line 11 "../plugins/common/OAuth1Support.vala"
	self->priv = publishing_rest_support_oauth1_session_get_instance_private (self);
#line 12 "../plugins/common/OAuth1Support.vala"
	self->priv->request_phase_token = NULL;
#line 13 "../plugins/common/OAuth1Support.vala"
	self->priv->request_phase_token_secret = NULL;
#line 14 "../plugins/common/OAuth1Support.vala"
	self->priv->access_phase_token = NULL;
#line 15 "../plugins/common/OAuth1Support.vala"
	self->priv->access_phase_token_secret = NULL;
#line 16 "../plugins/common/OAuth1Support.vala"
	self->priv->username = NULL;
#line 17 "../plugins/common/OAuth1Support.vala"
	self->priv->consumer_key = NULL;
#line 18 "../plugins/common/OAuth1Support.vala"
	self->priv->consumer_secret = NULL;
#line 959 "OAuth1Support.c"
}

static void
publishing_rest_support_oauth1_session_finalize (PublishingRESTSupportSession * obj)
{
	PublishingRESTSupportOAuth1Session * self;
#line 11 "../plugins/common/OAuth1Support.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION, PublishingRESTSupportOAuth1Session);
#line 12 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->request_phase_token);
#line 13 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->request_phase_token_secret);
#line 14 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->access_phase_token);
#line 15 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->access_phase_token_secret);
#line 16 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->username);
#line 17 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->consumer_key);
#line 18 "../plugins/common/OAuth1Support.vala"
	_g_free0 (self->priv->consumer_secret);
#line 11 "../plugins/common/OAuth1Support.vala"
	PUBLISHING_REST_SUPPORT_SESSION_CLASS (publishing_rest_support_oauth1_session_parent_class)->finalize (obj);
#line 984 "OAuth1Support.c"
}

static GType
publishing_rest_support_oauth1_session_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingRESTSupportOAuth1SessionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_rest_support_oauth1_session_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingRESTSupportOAuth1Session), 0, (GInstanceInitFunc) publishing_rest_support_oauth1_session_instance_init, NULL };
	GType publishing_rest_support_oauth1_session_type_id;
	publishing_rest_support_oauth1_session_type_id = g_type_register_static (PUBLISHING_REST_SUPPORT_TYPE_SESSION, "PublishingRESTSupportOAuth1Session", &g_define_type_info, 0);
	PublishingRESTSupportOAuth1Session_private_offset = g_type_add_instance_private (publishing_rest_support_oauth1_session_type_id, sizeof (PublishingRESTSupportOAuth1SessionPrivate));
	return publishing_rest_support_oauth1_session_type_id;
}

GType
publishing_rest_support_oauth1_session_get_type (void)
{
	static volatile gsize publishing_rest_support_oauth1_session_type_id__volatile = 0;
	if (g_once_init_enter (&publishing_rest_support_oauth1_session_type_id__volatile)) {
		GType publishing_rest_support_oauth1_session_type_id;
		publishing_rest_support_oauth1_session_type_id = publishing_rest_support_oauth1_session_get_type_once ();
		g_once_init_leave (&publishing_rest_support_oauth1_session_type_id__volatile, publishing_rest_support_oauth1_session_type_id);
	}
	return publishing_rest_support_oauth1_session_type_id__volatile;
}

PublishingRESTSupportOAuth1Transaction*
publishing_rest_support_oauth1_transaction_construct (GType object_type,
                                                      PublishingRESTSupportOAuth1Session* session,
                                                      PublishingRESTSupportHttpMethod method)
{
	PublishingRESTSupportOAuth1Transaction* self = NULL;
#line 153 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (session), NULL);
#line 155 "../plugins/common/OAuth1Support.vala"
	self = (PublishingRESTSupportOAuth1Transaction*) publishing_rest_support_transaction_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (session, PUBLISHING_REST_SUPPORT_TYPE_SESSION, PublishingRESTSupportSession), method);
#line 156 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_transaction_setup_arguments (self);
#line 153 "../plugins/common/OAuth1Support.vala"
	return self;
#line 1023 "OAuth1Support.c"
}

PublishingRESTSupportOAuth1Transaction*
publishing_rest_support_oauth1_transaction_new (PublishingRESTSupportOAuth1Session* session,
                                                PublishingRESTSupportHttpMethod method)
{
#line 153 "../plugins/common/OAuth1Support.vala"
	return publishing_rest_support_oauth1_transaction_construct (PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_TRANSACTION, session, method);
#line 1032 "OAuth1Support.c"
}

PublishingRESTSupportOAuth1Transaction*
publishing_rest_support_oauth1_transaction_construct_with_uri (GType object_type,
                                                               PublishingRESTSupportOAuth1Session* session,
                                                               const gchar* uri,
                                                               PublishingRESTSupportHttpMethod method)
{
	PublishingRESTSupportOAuth1Transaction* self = NULL;
#line 159 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (session), NULL);
#line 159 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 161 "../plugins/common/OAuth1Support.vala"
	self = (PublishingRESTSupportOAuth1Transaction*) publishing_rest_support_transaction_construct_with_endpoint_url (object_type, G_TYPE_CHECK_INSTANCE_CAST (session, PUBLISHING_REST_SUPPORT_TYPE_SESSION, PublishingRESTSupportSession), uri, method);
#line 162 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_transaction_setup_arguments (self);
#line 159 "../plugins/common/OAuth1Support.vala"
	return self;
#line 1052 "OAuth1Support.c"
}

PublishingRESTSupportOAuth1Transaction*
publishing_rest_support_oauth1_transaction_new_with_uri (PublishingRESTSupportOAuth1Session* session,
                                                         const gchar* uri,
                                                         PublishingRESTSupportHttpMethod method)
{
#line 159 "../plugins/common/OAuth1Support.vala"
	return publishing_rest_support_oauth1_transaction_construct_with_uri (PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_TRANSACTION, session, uri, method);
#line 1062 "OAuth1Support.c"
}

static void
publishing_rest_support_oauth1_transaction_setup_arguments (PublishingRESTSupportOAuth1Transaction* self)
{
	PublishingRESTSupportOAuth1Session* session = NULL;
	PublishingRESTSupportSession* _tmp0_;
	PublishingRESTSupportOAuth1Session* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	PublishingRESTSupportOAuth1Session* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	PublishingRESTSupportOAuth1Session* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	PublishingRESTSupportOAuth1Session* _tmp10_;
#line 165 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_TRANSACTION (self));
#line 166 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = publishing_rest_support_transaction_get_parent_session (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction));
#line 166 "../plugins/common/OAuth1Support.vala"
	session = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION, PublishingRESTSupportOAuth1Session);
#line 168 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = session;
#line 168 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = publishing_rest_support_oauth1_session_get_oauth_nonce (_tmp1_);
#line 168 "../plugins/common/OAuth1Support.vala"
	_tmp3_ = _tmp2_;
#line 168 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_nonce", _tmp3_);
#line 168 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp3_);
#line 169 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_signature_method", "HMAC-SHA1");
#line 170 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_version", "1.0");
#line 171 "../plugins/common/OAuth1Support.vala"
	_tmp4_ = session;
#line 171 "../plugins/common/OAuth1Support.vala"
	_tmp5_ = publishing_rest_support_oauth1_session_get_oauth_timestamp (_tmp4_);
#line 171 "../plugins/common/OAuth1Support.vala"
	_tmp6_ = _tmp5_;
#line 171 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_timestamp", _tmp6_);
#line 171 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp6_);
#line 172 "../plugins/common/OAuth1Support.vala"
	_tmp7_ = session;
#line 172 "../plugins/common/OAuth1Support.vala"
	_tmp8_ = publishing_rest_support_oauth1_session_get_consumer_key (_tmp7_);
#line 172 "../plugins/common/OAuth1Support.vala"
	_tmp9_ = _tmp8_;
#line 172 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_consumer_key", _tmp9_);
#line 172 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp9_);
#line 173 "../plugins/common/OAuth1Support.vala"
	_tmp10_ = session;
#line 173 "../plugins/common/OAuth1Support.vala"
	if (publishing_rest_support_oauth1_session_has_access_phase_token (_tmp10_)) {
#line 1124 "OAuth1Support.c"
		PublishingRESTSupportOAuth1Session* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 174 "../plugins/common/OAuth1Support.vala"
		_tmp11_ = session;
#line 174 "../plugins/common/OAuth1Support.vala"
		_tmp12_ = publishing_rest_support_oauth1_session_get_access_phase_token (_tmp11_);
#line 174 "../plugins/common/OAuth1Support.vala"
		_tmp13_ = _tmp12_;
#line 174 "../plugins/common/OAuth1Support.vala"
		publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_token", _tmp13_);
#line 174 "../plugins/common/OAuth1Support.vala"
		_g_free0 (_tmp13_);
#line 1138 "OAuth1Support.c"
	}
#line 165 "../plugins/common/OAuth1Support.vala"
	_publishing_rest_support_session_unref0 (session);
#line 1142 "OAuth1Support.c"
}

static void
publishing_rest_support_oauth1_transaction_real_execute (PublishingRESTSupportTransaction* base,
                                                         GError** error)
{
	PublishingRESTSupportOAuth1Transaction * self;
	gchar* signature = NULL;
	PublishingRESTSupportSession* _tmp0_;
	PublishingRESTSupportOAuth1Session* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 179 "../plugins/common/OAuth1Support.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_TRANSACTION, PublishingRESTSupportOAuth1Transaction);
#line 180 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = publishing_rest_support_transaction_get_parent_session (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction));
#line 180 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION, PublishingRESTSupportOAuth1Session);
#line 180 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = publishing_rest_support_oauth1_session_sign_transaction (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), NULL, (gint) 0);
#line 180 "../plugins/common/OAuth1Support.vala"
	_tmp3_ = _tmp2_;
#line 180 "../plugins/common/OAuth1Support.vala"
	_publishing_rest_support_session_unref0 (_tmp1_);
#line 180 "../plugins/common/OAuth1Support.vala"
	signature = _tmp3_;
#line 181 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_signature", signature);
#line 183 "../plugins/common/OAuth1Support.vala"
	PUBLISHING_REST_SUPPORT_TRANSACTION_CLASS (publishing_rest_support_oauth1_transaction_parent_class)->execute (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), &_inner_error0_);
#line 183 "../plugins/common/OAuth1Support.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../plugins/common/OAuth1Support.vala"
		if (_inner_error0_->domain == SPIT_PUBLISHING_PUBLISHING_ERROR) {
#line 183 "../plugins/common/OAuth1Support.vala"
			g_propagate_error (error, _inner_error0_);
#line 183 "../plugins/common/OAuth1Support.vala"
			_g_free0 (signature);
#line 183 "../plugins/common/OAuth1Support.vala"
			return;
#line 1184 "OAuth1Support.c"
		} else {
#line 183 "../plugins/common/OAuth1Support.vala"
			_g_free0 (signature);
#line 183 "../plugins/common/OAuth1Support.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 183 "../plugins/common/OAuth1Support.vala"
			g_clear_error (&_inner_error0_);
#line 183 "../plugins/common/OAuth1Support.vala"
			return;
#line 1194 "OAuth1Support.c"
		}
	}
#line 179 "../plugins/common/OAuth1Support.vala"
	_g_free0 (signature);
#line 1199 "OAuth1Support.c"
}

static void
publishing_rest_support_oauth1_transaction_class_init (PublishingRESTSupportOAuth1TransactionClass * klass,
                                                       gpointer klass_data)
{
#line 152 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_transaction_parent_class = g_type_class_peek_parent (klass);
#line 152 "../plugins/common/OAuth1Support.vala"
	((PublishingRESTSupportTransactionClass *) klass)->execute = (void (*) (PublishingRESTSupportTransaction*, GError**)) publishing_rest_support_oauth1_transaction_real_execute;
#line 1210 "OAuth1Support.c"
}

static void
publishing_rest_support_oauth1_transaction_instance_init (PublishingRESTSupportOAuth1Transaction * self,
                                                          gpointer klass)
{
}

static GType
publishing_rest_support_oauth1_transaction_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingRESTSupportOAuth1TransactionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_rest_support_oauth1_transaction_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingRESTSupportOAuth1Transaction), 0, (GInstanceInitFunc) publishing_rest_support_oauth1_transaction_instance_init, NULL };
	GType publishing_rest_support_oauth1_transaction_type_id;
	publishing_rest_support_oauth1_transaction_type_id = g_type_register_static (PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, "PublishingRESTSupportOAuth1Transaction", &g_define_type_info, 0);
	return publishing_rest_support_oauth1_transaction_type_id;
}

GType
publishing_rest_support_oauth1_transaction_get_type (void)
{
	static volatile gsize publishing_rest_support_oauth1_transaction_type_id__volatile = 0;
	if (g_once_init_enter (&publishing_rest_support_oauth1_transaction_type_id__volatile)) {
		GType publishing_rest_support_oauth1_transaction_type_id;
		publishing_rest_support_oauth1_transaction_type_id = publishing_rest_support_oauth1_transaction_get_type_once ();
		g_once_init_leave (&publishing_rest_support_oauth1_transaction_type_id__volatile, publishing_rest_support_oauth1_transaction_type_id);
	}
	return publishing_rest_support_oauth1_transaction_type_id__volatile;
}

static inline gpointer
publishing_rest_support_oauth1_upload_transaction_get_instance_private (PublishingRESTSupportOAuth1UploadTransaction* self)
{
	return G_STRUCT_MEMBER_P (self, PublishingRESTSupportOAuth1UploadTransaction_private_offset);
}

PublishingRESTSupportOAuth1UploadTransaction*
publishing_rest_support_oauth1_upload_transaction_construct (GType object_type,
                                                             PublishingRESTSupportOAuth1Session* session,
                                                             SpitPublishingPublishable* publishable,
                                                             const gchar* endpoint_uri)
{
	PublishingRESTSupportOAuth1UploadTransaction* self = NULL;
	PublishingRESTSupportArgument** _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 191 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_SESSION (session), NULL);
#line 191 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (publishable, SPIT_PUBLISHING_TYPE_PUBLISHABLE), NULL);
#line 191 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (endpoint_uri != NULL, NULL);
#line 194 "../plugins/common/OAuth1Support.vala"
	self = (PublishingRESTSupportOAuth1UploadTransaction*) publishing_rest_support_upload_transaction_construct_with_endpoint_url (object_type, G_TYPE_CHECK_INSTANCE_CAST (session, PUBLISHING_REST_SUPPORT_TYPE_SESSION, PublishingRESTSupportSession), publishable, endpoint_uri);
#line 196 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = g_new0 (PublishingRESTSupportArgument*, 0 + 1);
#line 196 "../plugins/common/OAuth1Support.vala"
	self->priv->auth_header_fields = (_vala_array_free (self->priv->auth_header_fields, self->priv->auth_header_fields_length1, (GDestroyNotify) publishing_rest_support_argument_unref), NULL);
#line 196 "../plugins/common/OAuth1Support.vala"
	self->priv->auth_header_fields = _tmp0_;
#line 196 "../plugins/common/OAuth1Support.vala"
	self->priv->auth_header_fields_length1 = 0;
#line 196 "../plugins/common/OAuth1Support.vala"
	self->priv->_auth_header_fields_size_ = self->priv->auth_header_fields_length1;
#line 197 "../plugins/common/OAuth1Support.vala"
	self->session = session;
#line 199 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = publishing_rest_support_oauth1_session_get_oauth_nonce (session);
#line 199 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = _tmp1_;
#line 199 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_upload_transaction_add_authorization_header_field (self, "oauth_nonce", _tmp2_);
#line 199 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp2_);
#line 200 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_upload_transaction_add_authorization_header_field (self, "oauth_signature_method", "HMAC-SHA1");
#line 201 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_upload_transaction_add_authorization_header_field (self, "oauth_version", "1.0");
#line 202 "../plugins/common/OAuth1Support.vala"
	_tmp3_ = publishing_rest_support_oauth1_session_get_oauth_timestamp (session);
#line 202 "../plugins/common/OAuth1Support.vala"
	_tmp4_ = _tmp3_;
#line 202 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_upload_transaction_add_authorization_header_field (self, "oauth_timestamp", _tmp4_);
#line 202 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp4_);
#line 203 "../plugins/common/OAuth1Support.vala"
	_tmp5_ = publishing_rest_support_oauth1_session_get_consumer_key (session);
#line 203 "../plugins/common/OAuth1Support.vala"
	_tmp6_ = _tmp5_;
#line 203 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_upload_transaction_add_authorization_header_field (self, "oauth_consumer_key", _tmp6_);
#line 203 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp6_);
#line 204 "../plugins/common/OAuth1Support.vala"
	_tmp7_ = publishing_rest_support_oauth1_session_get_access_phase_token (session);
#line 204 "../plugins/common/OAuth1Support.vala"
	_tmp8_ = _tmp7_;
#line 204 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_upload_transaction_add_authorization_header_field (self, "oauth_token", _tmp8_);
#line 204 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp8_);
#line 191 "../plugins/common/OAuth1Support.vala"
	return self;
#line 1320 "OAuth1Support.c"
}

PublishingRESTSupportOAuth1UploadTransaction*
publishing_rest_support_oauth1_upload_transaction_new (PublishingRESTSupportOAuth1Session* session,
                                                       SpitPublishingPublishable* publishable,
                                                       const gchar* endpoint_uri)
{
#line 191 "../plugins/common/OAuth1Support.vala"
	return publishing_rest_support_oauth1_upload_transaction_construct (PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_UPLOAD_TRANSACTION, session, publishable, endpoint_uri);
#line 1330 "OAuth1Support.c"
}

static void
_vala_array_add5 (PublishingRESTSupportArgument** * array,
                  gint* length,
                  gint* size,
                  PublishingRESTSupportArgument* value)
{
#line 208 "../plugins/common/OAuth1Support.vala"
	if ((*length) == (*size)) {
#line 208 "../plugins/common/OAuth1Support.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 208 "../plugins/common/OAuth1Support.vala"
		*array = g_renew (PublishingRESTSupportArgument*, *array, (*size) + 1);
#line 1345 "OAuth1Support.c"
	}
#line 208 "../plugins/common/OAuth1Support.vala"
	(*array)[(*length)++] = value;
#line 208 "../plugins/common/OAuth1Support.vala"
	(*array)[*length] = NULL;
#line 1351 "OAuth1Support.c"
}

void
publishing_rest_support_oauth1_upload_transaction_add_authorization_header_field (PublishingRESTSupportOAuth1UploadTransaction* self,
                                                                                  const gchar* key,
                                                                                  const gchar* value)
{
	PublishingRESTSupportArgument* _tmp0_;
#line 207 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_UPLOAD_TRANSACTION (self));
#line 207 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (key != NULL);
#line 207 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (value != NULL);
#line 208 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = publishing_rest_support_argument_new (key, value);
#line 208 "../plugins/common/OAuth1Support.vala"
	_vala_array_add5 (&self->priv->auth_header_fields, &self->priv->auth_header_fields_length1, &self->priv->_auth_header_fields_size_, _tmp0_);
#line 1370 "OAuth1Support.c"
}

gchar*
publishing_rest_support_oauth1_upload_transaction_get_authorization_header_string (PublishingRESTSupportOAuth1UploadTransaction* self)
{
	PublishingRESTSupportArgument** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 211 "../plugins/common/OAuth1Support.vala"
	g_return_val_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_UPLOAD_TRANSACTION (self), NULL);
#line 212 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = self->priv->auth_header_fields;
#line 212 "../plugins/common/OAuth1Support.vala"
	_tmp0__length1 = self->priv->auth_header_fields_length1;
#line 212 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = publishing_rest_support_argument_serialize_list (_tmp0_, (gint) _tmp0__length1, FALSE, TRUE, ", ");
#line 212 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = _tmp1_;
#line 212 "../plugins/common/OAuth1Support.vala"
	_tmp3_ = g_strconcat ("OAuth ", _tmp2_, NULL);
#line 212 "../plugins/common/OAuth1Support.vala"
	_tmp4_ = _tmp3_;
#line 212 "../plugins/common/OAuth1Support.vala"
	_g_free0 (_tmp2_);
#line 212 "../plugins/common/OAuth1Support.vala"
	result = _tmp4_;
#line 212 "../plugins/common/OAuth1Support.vala"
	return result;
#line 1403 "OAuth1Support.c"
}

void
publishing_rest_support_oauth1_upload_transaction_authorize (PublishingRESTSupportOAuth1UploadTransaction* self)
{
	gchar* signature = NULL;
	PublishingRESTSupportOAuth1Session* _tmp0_;
	PublishingRESTSupportArgument** _tmp1_;
	gint _tmp1__length1;
	gchar* _tmp2_;
	gchar* authorization_header = NULL;
	gchar* _tmp3_;
#line 215 "../plugins/common/OAuth1Support.vala"
	g_return_if_fail (PUBLISHING_REST_SUPPORT_OAUTH1_IS_UPLOAD_TRANSACTION (self));
#line 216 "../plugins/common/OAuth1Support.vala"
	_tmp0_ = self->session;
#line 216 "../plugins/common/OAuth1Support.vala"
	_tmp1_ = self->priv->auth_header_fields;
#line 216 "../plugins/common/OAuth1Support.vala"
	_tmp1__length1 = self->priv->auth_header_fields_length1;
#line 216 "../plugins/common/OAuth1Support.vala"
	_tmp2_ = publishing_rest_support_oauth1_session_sign_transaction (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), _tmp1_, (gint) _tmp1__length1);
#line 216 "../plugins/common/OAuth1Support.vala"
	signature = _tmp2_;
#line 217 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_upload_transaction_add_authorization_header_field (self, "oauth_signature", signature);
#line 220 "../plugins/common/OAuth1Support.vala"
	_tmp3_ = publishing_rest_support_oauth1_upload_transaction_get_authorization_header_string (self);
#line 220 "../plugins/common/OAuth1Support.vala"
	authorization_header = _tmp3_;
#line 222 "../plugins/common/OAuth1Support.vala"
	g_debug ("OAuth1Support.vala:222: executing upload transaction: authorization he" \
"ader string = '%s'", authorization_header);
#line 224 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_transaction_add_header (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "Authorization", authorization_header);
#line 215 "../plugins/common/OAuth1Support.vala"
	_g_free0 (authorization_header);
#line 215 "../plugins/common/OAuth1Support.vala"
	_g_free0 (signature);
#line 1442 "OAuth1Support.c"
}

static void
publishing_rest_support_oauth1_upload_transaction_class_init (PublishingRESTSupportOAuth1UploadTransactionClass * klass,
                                                              gpointer klass_data)
{
#line 187 "../plugins/common/OAuth1Support.vala"
	publishing_rest_support_oauth1_upload_transaction_parent_class = g_type_class_peek_parent (klass);
#line 187 "../plugins/common/OAuth1Support.vala"
	((PublishingRESTSupportTransactionClass *) klass)->finalize = publishing_rest_support_oauth1_upload_transaction_finalize;
#line 187 "../plugins/common/OAuth1Support.vala"
	g_type_class_adjust_private_offset (klass, &PublishingRESTSupportOAuth1UploadTransaction_private_offset);
#line 1455 "OAuth1Support.c"
}

static void
publishing_rest_support_oauth1_upload_transaction_instance_init (PublishingRESTSupportOAuth1UploadTransaction * self,
                                                                 gpointer klass)
{
#line 187 "../plugins/common/OAuth1Support.vala"
	self->priv = publishing_rest_support_oauth1_upload_transaction_get_instance_private (self);
#line 1464 "OAuth1Support.c"
}

static void
publishing_rest_support_oauth1_upload_transaction_finalize (PublishingRESTSupportTransaction * obj)
{
	PublishingRESTSupportOAuth1UploadTransaction * self;
#line 187 "../plugins/common/OAuth1Support.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_UPLOAD_TRANSACTION, PublishingRESTSupportOAuth1UploadTransaction);
#line 189 "../plugins/common/OAuth1Support.vala"
	self->priv->auth_header_fields = (_vala_array_free (self->priv->auth_header_fields, self->priv->auth_header_fields_length1, (GDestroyNotify) publishing_rest_support_argument_unref), NULL);
#line 187 "../plugins/common/OAuth1Support.vala"
	PUBLISHING_REST_SUPPORT_TRANSACTION_CLASS (publishing_rest_support_oauth1_upload_transaction_parent_class)->finalize (obj);
#line 1477 "OAuth1Support.c"
}

static GType
publishing_rest_support_oauth1_upload_transaction_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingRESTSupportOAuth1UploadTransactionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_rest_support_oauth1_upload_transaction_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingRESTSupportOAuth1UploadTransaction), 0, (GInstanceInitFunc) publishing_rest_support_oauth1_upload_transaction_instance_init, NULL };
	GType publishing_rest_support_oauth1_upload_transaction_type_id;
	publishing_rest_support_oauth1_upload_transaction_type_id = g_type_register_static (PUBLISHING_REST_SUPPORT_TYPE_UPLOAD_TRANSACTION, "PublishingRESTSupportOAuth1UploadTransaction", &g_define_type_info, 0);
	PublishingRESTSupportOAuth1UploadTransaction_private_offset = g_type_add_instance_private (publishing_rest_support_oauth1_upload_transaction_type_id, sizeof (PublishingRESTSupportOAuth1UploadTransactionPrivate));
	return publishing_rest_support_oauth1_upload_transaction_type_id;
}

GType
publishing_rest_support_oauth1_upload_transaction_get_type (void)
{
	static volatile gsize publishing_rest_support_oauth1_upload_transaction_type_id__volatile = 0;
	if (g_once_init_enter (&publishing_rest_support_oauth1_upload_transaction_type_id__volatile)) {
		GType publishing_rest_support_oauth1_upload_transaction_type_id;
		publishing_rest_support_oauth1_upload_transaction_type_id = publishing_rest_support_oauth1_upload_transaction_get_type_once ();
		g_once_init_leave (&publishing_rest_support_oauth1_upload_transaction_type_id__volatile, publishing_rest_support_oauth1_upload_transaction_type_id);
	}
	return publishing_rest_support_oauth1_upload_transaction_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

