/* ChessEffect.c generated by valac 0.52.10, the Vala compiler
 * generated from ChessEffect.vala, do not modify */

/* Copyright 2013 Jens Bav
 * Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "shotwell-transitions.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "shotwell-plugin-dev-1.0.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define TYPE_CHESS_EFFECT_DESCRIPTOR (chess_effect_descriptor_get_type ())
#define CHESS_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_EFFECT_DESCRIPTOR, ChessEffectDescriptor))
#define CHESS_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_EFFECT_DESCRIPTOR, ChessEffectDescriptorClass))
#define IS_CHESS_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_EFFECT_DESCRIPTOR))
#define IS_CHESS_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_EFFECT_DESCRIPTOR))
#define CHESS_EFFECT_DESCRIPTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_EFFECT_DESCRIPTOR, ChessEffectDescriptorClass))

typedef struct _ChessEffectDescriptor ChessEffectDescriptor;
typedef struct _ChessEffectDescriptorClass ChessEffectDescriptorClass;
typedef struct _ChessEffectDescriptorPrivate ChessEffectDescriptorPrivate;
enum  {
	CHESS_EFFECT_DESCRIPTOR_0_PROPERTY,
	CHESS_EFFECT_DESCRIPTOR_NUM_PROPERTIES
};
static GParamSpec* chess_effect_descriptor_properties[CHESS_EFFECT_DESCRIPTOR_NUM_PROPERTIES];

#define TYPE_CHESS_EFFECT (chess_effect_get_type ())
#define CHESS_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_EFFECT, ChessEffect))
#define CHESS_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_EFFECT, ChessEffectClass))
#define IS_CHESS_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_EFFECT))
#define IS_CHESS_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_EFFECT))
#define CHESS_EFFECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_EFFECT, ChessEffectClass))

typedef struct _ChessEffect ChessEffect;
typedef struct _ChessEffectClass ChessEffectClass;
typedef struct _ChessEffectPrivate ChessEffectPrivate;
enum  {
	CHESS_EFFECT_0_PROPERTY,
	CHESS_EFFECT_NUM_PROPERTIES
};
static GParamSpec* chess_effect_properties[CHESS_EFFECT_NUM_PROPERTIES];

struct _ChessEffectDescriptor {
	ShotwellTransitionDescriptor parent_instance;
	ChessEffectDescriptorPrivate * priv;
};

struct _ChessEffectDescriptorClass {
	ShotwellTransitionDescriptorClass parent_class;
};

struct _ChessEffect {
	GObject parent_instance;
	ChessEffectPrivate * priv;
};

struct _ChessEffectClass {
	GObjectClass parent_class;
};

struct _ChessEffectPrivate {
	gdouble square_count_x;
	gdouble square_count_y;
};

static gpointer chess_effect_descriptor_parent_class = NULL;
static gint ChessEffect_private_offset;
static gpointer chess_effect_parent_class = NULL;
static SpitTransitionsEffectIface * chess_effect_spit_transitions_effect_parent_iface = NULL;

GType chess_effect_descriptor_get_type (void) G_GNUC_CONST ;
ChessEffectDescriptor* chess_effect_descriptor_new (GFile* resource_directory);
ChessEffectDescriptor* chess_effect_descriptor_construct (GType object_type,
                                                          GFile* resource_directory);
static const gchar* chess_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base);
static const gchar* chess_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base);
static SpitTransitionsEffect* chess_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                                            SpitHostInterface* host);
ChessEffect* chess_effect_new (void);
ChessEffect* chess_effect_construct (GType object_type);
GType chess_effect_get_type (void) G_GNUC_CONST ;
static GType chess_effect_descriptor_get_type_once (void);
#define CHESS_EFFECT_DESIRED_FPS 25
#define CHESS_EFFECT_MIN_FPS 10
#define CHESS_EFFECT_SQUARE_SIZE 100
static void chess_effect_real_get_fps (SpitTransitionsEffect* base,
                                gint* desired_fps,
                                gint* min_fps);
static void chess_effect_real_start (SpitTransitionsEffect* base,
                              SpitTransitionsVisuals* visuals,
                              SpitTransitionsMotion* motion);
static gboolean chess_effect_real_needs_clear_background (SpitTransitionsEffect* base);
static void chess_effect_real_paint (SpitTransitionsEffect* base,
                              SpitTransitionsVisuals* visuals,
                              SpitTransitionsMotion* motion,
                              cairo_t* ctx,
                              gint width,
                              gint height,
                              gint frame_number);
static void chess_effect_real_advance (SpitTransitionsEffect* base,
                                SpitTransitionsVisuals* visuals,
                                SpitTransitionsMotion* motion,
                                gint frame_number);
static void chess_effect_real_cancel (SpitTransitionsEffect* base);
static void chess_effect_finalize (GObject * obj);
static GType chess_effect_get_type_once (void);

ChessEffectDescriptor*
chess_effect_descriptor_construct (GType object_type,
                                   GFile* resource_directory)
{
	ChessEffectDescriptor * self = NULL;
#line 11 "../plugins/shotwell-transitions/ChessEffect.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (resource_directory, g_file_get_type ()), NULL);
#line 12 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = (ChessEffectDescriptor*) shotwell_transition_descriptor_construct (object_type, resource_directory);
#line 11 "../plugins/shotwell-transitions/ChessEffect.vala"
	return self;
#line 134 "ChessEffect.c"
}

ChessEffectDescriptor*
chess_effect_descriptor_new (GFile* resource_directory)
{
#line 11 "../plugins/shotwell-transitions/ChessEffect.vala"
	return chess_effect_descriptor_construct (TYPE_CHESS_EFFECT_DESCRIPTOR, resource_directory);
#line 142 "ChessEffect.c"
}

static const gchar*
chess_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base)
{
	ChessEffectDescriptor * self;
	const gchar* result = NULL;
#line 15 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CHESS_EFFECT_DESCRIPTOR, ChessEffectDescriptor);
#line 16 "../plugins/shotwell-transitions/ChessEffect.vala"
	result = "org.gnome.shotwell.transitions.chess";
#line 16 "../plugins/shotwell-transitions/ChessEffect.vala"
	return result;
#line 156 "ChessEffect.c"
}

static const gchar*
chess_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base)
{
	ChessEffectDescriptor * self;
	const gchar* result = NULL;
#line 19 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CHESS_EFFECT_DESCRIPTOR, ChessEffectDescriptor);
#line 20 "../plugins/shotwell-transitions/ChessEffect.vala"
	result = _ ("Chess");
#line 20 "../plugins/shotwell-transitions/ChessEffect.vala"
	return result;
#line 170 "ChessEffect.c"
}

static SpitTransitionsEffect*
chess_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                     SpitHostInterface* host)
{
	ChessEffectDescriptor * self;
	ChessEffect* _tmp0_;
	SpitTransitionsEffect* result = NULL;
#line 23 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CHESS_EFFECT_DESCRIPTOR, ChessEffectDescriptor);
#line 23 "../plugins/shotwell-transitions/ChessEffect.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (host, SPIT_TYPE_HOST_INTERFACE), NULL);
#line 24 "../plugins/shotwell-transitions/ChessEffect.vala"
	_tmp0_ = chess_effect_new ();
#line 24 "../plugins/shotwell-transitions/ChessEffect.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SPIT_TRANSITIONS_TYPE_EFFECT, SpitTransitionsEffect);
#line 24 "../plugins/shotwell-transitions/ChessEffect.vala"
	return result;
#line 190 "ChessEffect.c"
}

static void
chess_effect_descriptor_class_init (ChessEffectDescriptorClass * klass,
                                    gpointer klass_data)
{
#line 10 "../plugins/shotwell-transitions/ChessEffect.vala"
	chess_effect_descriptor_parent_class = g_type_class_peek_parent (klass);
#line 10 "../plugins/shotwell-transitions/ChessEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_id = (const gchar* (*) (ShotwellTransitionDescriptor*)) chess_effect_descriptor_real_get_id;
#line 10 "../plugins/shotwell-transitions/ChessEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_pluggable_name = (const gchar* (*) (ShotwellTransitionDescriptor*)) chess_effect_descriptor_real_get_pluggable_name;
#line 10 "../plugins/shotwell-transitions/ChessEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->create = (SpitTransitionsEffect* (*) (ShotwellTransitionDescriptor*, SpitHostInterface*)) chess_effect_descriptor_real_create;
#line 205 "ChessEffect.c"
}

static void
chess_effect_descriptor_instance_init (ChessEffectDescriptor * self,
                                       gpointer klass)
{
}

static GType
chess_effect_descriptor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessEffectDescriptorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_effect_descriptor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessEffectDescriptor), 0, (GInstanceInitFunc) chess_effect_descriptor_instance_init, NULL };
	GType chess_effect_descriptor_type_id;
	chess_effect_descriptor_type_id = g_type_register_static (TYPE_SHOTWELL_TRANSITION_DESCRIPTOR, "ChessEffectDescriptor", &g_define_type_info, 0);
	return chess_effect_descriptor_type_id;
}

GType
chess_effect_descriptor_get_type (void)
{
	static volatile gsize chess_effect_descriptor_type_id__volatile = 0;
	if (g_once_init_enter (&chess_effect_descriptor_type_id__volatile)) {
		GType chess_effect_descriptor_type_id;
		chess_effect_descriptor_type_id = chess_effect_descriptor_get_type_once ();
		g_once_init_leave (&chess_effect_descriptor_type_id__volatile, chess_effect_descriptor_type_id);
	}
	return chess_effect_descriptor_type_id__volatile;
}

static inline gpointer
chess_effect_get_instance_private (ChessEffect* self)
{
	return G_STRUCT_MEMBER_P (self, ChessEffect_private_offset);
}

ChessEffect*
chess_effect_construct (GType object_type)
{
	ChessEffect * self = NULL;
#line 35 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = (ChessEffect*) g_object_new (object_type, NULL);
#line 35 "../plugins/shotwell-transitions/ChessEffect.vala"
	return self;
#line 249 "ChessEffect.c"
}

ChessEffect*
chess_effect_new (void)
{
#line 35 "../plugins/shotwell-transitions/ChessEffect.vala"
	return chess_effect_construct (TYPE_CHESS_EFFECT);
#line 257 "ChessEffect.c"
}

static void
chess_effect_real_get_fps (SpitTransitionsEffect* base,
                           gint* desired_fps,
                           gint* min_fps)
{
	ChessEffect * self;
	gint _vala_desired_fps = 0;
	gint _vala_min_fps = 0;
#line 38 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CHESS_EFFECT, ChessEffect);
#line 39 "../plugins/shotwell-transitions/ChessEffect.vala"
	_vala_desired_fps = CHESS_EFFECT_DESIRED_FPS;
#line 40 "../plugins/shotwell-transitions/ChessEffect.vala"
	_vala_min_fps = CHESS_EFFECT_MIN_FPS;
#line 38 "../plugins/shotwell-transitions/ChessEffect.vala"
	if (desired_fps) {
#line 38 "../plugins/shotwell-transitions/ChessEffect.vala"
		*desired_fps = _vala_desired_fps;
#line 278 "ChessEffect.c"
	}
#line 38 "../plugins/shotwell-transitions/ChessEffect.vala"
	if (min_fps) {
#line 38 "../plugins/shotwell-transitions/ChessEffect.vala"
		*min_fps = _vala_min_fps;
#line 284 "ChessEffect.c"
	}
}

static void
chess_effect_real_start (SpitTransitionsEffect* base,
                         SpitTransitionsVisuals* visuals,
                         SpitTransitionsMotion* motion)
{
	ChessEffect * self;
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _tmp3_;
#line 43 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CHESS_EFFECT, ChessEffect);
#line 43 "../plugins/shotwell-transitions/ChessEffect.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (visuals, SPIT_TRANSITIONS_TYPE_VISUALS));
#line 43 "../plugins/shotwell-transitions/ChessEffect.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (motion, SPIT_TRANSITIONS_TYPE_MOTION));
#line 44 "../plugins/shotwell-transitions/ChessEffect.vala"
	spit_transitions_visuals_get_to_pos (visuals, &_tmp0_);
#line 44 "../plugins/shotwell-transitions/ChessEffect.vala"
	_tmp1_ = _tmp0_;
#line 44 "../plugins/shotwell-transitions/ChessEffect.vala"
	self->priv->square_count_y = (gdouble) ((_tmp1_.height / CHESS_EFFECT_SQUARE_SIZE) + 2);
#line 45 "../plugins/shotwell-transitions/ChessEffect.vala"
	spit_transitions_visuals_get_to_pos (visuals, &_tmp2_);
#line 45 "../plugins/shotwell-transitions/ChessEffect.vala"
	_tmp3_ = _tmp2_;
#line 45 "../plugins/shotwell-transitions/ChessEffect.vala"
	self->priv->square_count_x = (gdouble) ((_tmp3_.width / CHESS_EFFECT_SQUARE_SIZE) + 2);
#line 316 "ChessEffect.c"
}

static gboolean
chess_effect_real_needs_clear_background (SpitTransitionsEffect* base)
{
	ChessEffect * self;
	gboolean result = FALSE;
#line 48 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CHESS_EFFECT, ChessEffect);
#line 49 "../plugins/shotwell-transitions/ChessEffect.vala"
	result = TRUE;
#line 49 "../plugins/shotwell-transitions/ChessEffect.vala"
	return result;
#line 330 "ChessEffect.c"
}

static void
chess_effect_real_paint (SpitTransitionsEffect* base,
                         SpitTransitionsVisuals* visuals,
                         SpitTransitionsMotion* motion,
                         cairo_t* ctx,
                         gint width,
                         gint height,
                         gint frame_number)
{
	ChessEffect * self;
	gdouble alpha = 0.0;
	gdouble size = 0.0;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
#line 52 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CHESS_EFFECT, ChessEffect);
#line 52 "../plugins/shotwell-transitions/ChessEffect.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (visuals, SPIT_TRANSITIONS_TYPE_VISUALS));
#line 52 "../plugins/shotwell-transitions/ChessEffect.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (motion, SPIT_TRANSITIONS_TYPE_MOTION));
#line 52 "../plugins/shotwell-transitions/ChessEffect.vala"
	g_return_if_fail (ctx != NULL);
#line 54 "../plugins/shotwell-transitions/ChessEffect.vala"
	alpha = spit_transitions_motion_get_alpha (motion, frame_number);
#line 55 "../plugins/shotwell-transitions/ChessEffect.vala"
	size = (2 * alpha) * CHESS_EFFECT_SQUARE_SIZE;
#line 56 "../plugins/shotwell-transitions/ChessEffect.vala"
	_tmp0_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 56 "../plugins/shotwell-transitions/ChessEffect.vala"
	_tmp1_ = _tmp0_;
#line 56 "../plugins/shotwell-transitions/ChessEffect.vala"
	if (_tmp1_ != NULL) {
#line 367 "ChessEffect.c"
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkRectangle _tmp4_ = {0};
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_ = {0};
		GdkRectangle _tmp7_;
#line 57 "../plugins/shotwell-transitions/ChessEffect.vala"
		_tmp2_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 57 "../plugins/shotwell-transitions/ChessEffect.vala"
		_tmp3_ = _tmp2_;
#line 57 "../plugins/shotwell-transitions/ChessEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp4_);
#line 57 "../plugins/shotwell-transitions/ChessEffect.vala"
		_tmp5_ = _tmp4_;
#line 57 "../plugins/shotwell-transitions/ChessEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp6_);
#line 57 "../plugins/shotwell-transitions/ChessEffect.vala"
		_tmp7_ = _tmp6_;
#line 57 "../plugins/shotwell-transitions/ChessEffect.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp3_, (gdouble) _tmp5_.x, (gdouble) _tmp7_.y);
#line 59 "../plugins/shotwell-transitions/ChessEffect.vala"
		cairo_paint_with_alpha (ctx, 1 - alpha);
#line 390 "ChessEffect.c"
	}
#line 62 "../plugins/shotwell-transitions/ChessEffect.vala"
	_tmp8_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 62 "../plugins/shotwell-transitions/ChessEffect.vala"
	_tmp9_ = _tmp8_;
#line 62 "../plugins/shotwell-transitions/ChessEffect.vala"
	if (_tmp9_ != NULL) {
#line 398 "ChessEffect.c"
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkRectangle _tmp12_ = {0};
		GdkRectangle _tmp13_;
		GdkRectangle _tmp14_ = {0};
		GdkRectangle _tmp15_;
#line 63 "../plugins/shotwell-transitions/ChessEffect.vala"
		_tmp10_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 63 "../plugins/shotwell-transitions/ChessEffect.vala"
		_tmp11_ = _tmp10_;
#line 63 "../plugins/shotwell-transitions/ChessEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp12_);
#line 63 "../plugins/shotwell-transitions/ChessEffect.vala"
		_tmp13_ = _tmp12_;
#line 63 "../plugins/shotwell-transitions/ChessEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp14_);
#line 63 "../plugins/shotwell-transitions/ChessEffect.vala"
		_tmp15_ = _tmp14_;
#line 63 "../plugins/shotwell-transitions/ChessEffect.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp11_, (gdouble) _tmp13_.x, (gdouble) _tmp15_.y);
#line 419 "ChessEffect.c"
		{
			gdouble y = 0.0;
#line 64 "../plugins/shotwell-transitions/ChessEffect.vala"
			y = (gdouble) 0;
#line 424 "ChessEffect.c"
			{
				gboolean _tmp16_ = FALSE;
#line 64 "../plugins/shotwell-transitions/ChessEffect.vala"
				_tmp16_ = TRUE;
#line 64 "../plugins/shotwell-transitions/ChessEffect.vala"
				while (TRUE) {
#line 64 "../plugins/shotwell-transitions/ChessEffect.vala"
					if (!_tmp16_) {
#line 433 "ChessEffect.c"
						gdouble _tmp17_;
#line 64 "../plugins/shotwell-transitions/ChessEffect.vala"
						_tmp17_ = y;
#line 64 "../plugins/shotwell-transitions/ChessEffect.vala"
						y = _tmp17_ + 1;
#line 439 "ChessEffect.c"
					}
#line 64 "../plugins/shotwell-transitions/ChessEffect.vala"
					_tmp16_ = FALSE;
#line 64 "../plugins/shotwell-transitions/ChessEffect.vala"
					if (!(y <= self->priv->square_count_y)) {
#line 64 "../plugins/shotwell-transitions/ChessEffect.vala"
						break;
#line 447 "ChessEffect.c"
					}
					{
						gdouble x = 0.0;
#line 65 "../plugins/shotwell-transitions/ChessEffect.vala"
						x = (gdouble) 0;
#line 453 "ChessEffect.c"
						{
							gboolean _tmp18_ = FALSE;
#line 65 "../plugins/shotwell-transitions/ChessEffect.vala"
							_tmp18_ = TRUE;
#line 65 "../plugins/shotwell-transitions/ChessEffect.vala"
							while (TRUE) {
#line 460 "ChessEffect.c"
								gdouble _tmp20_ = 0.0;
								gdouble translation = 0.0;
								SpitTransitionsDirection _tmp21_;
								SpitTransitionsDirection _tmp22_;
#line 65 "../plugins/shotwell-transitions/ChessEffect.vala"
								if (!_tmp18_) {
#line 467 "ChessEffect.c"
									gdouble _tmp19_;
#line 65 "../plugins/shotwell-transitions/ChessEffect.vala"
									_tmp19_ = x;
#line 65 "../plugins/shotwell-transitions/ChessEffect.vala"
									x = _tmp19_ + 1;
#line 473 "ChessEffect.c"
								}
#line 65 "../plugins/shotwell-transitions/ChessEffect.vala"
								_tmp18_ = FALSE;
#line 65 "../plugins/shotwell-transitions/ChessEffect.vala"
								if (!(x <= self->priv->square_count_x)) {
#line 65 "../plugins/shotwell-transitions/ChessEffect.vala"
									break;
#line 481 "ChessEffect.c"
								}
#line 66 "../plugins/shotwell-transitions/ChessEffect.vala"
								if (fmod (x + y, 2) == ((gdouble) 0)) {
#line 66 "../plugins/shotwell-transitions/ChessEffect.vala"
									_tmp20_ = (-1.5) * CHESS_EFFECT_SQUARE_SIZE;
#line 487 "ChessEffect.c"
								} else {
#line 66 "../plugins/shotwell-transitions/ChessEffect.vala"
									_tmp20_ = 1.5 * CHESS_EFFECT_SQUARE_SIZE;
#line 491 "ChessEffect.c"
								}
#line 66 "../plugins/shotwell-transitions/ChessEffect.vala"
								translation = _tmp20_;
#line 67 "../plugins/shotwell-transitions/ChessEffect.vala"
								_tmp21_ = spit_transitions_motion_get_direction (motion);
#line 67 "../plugins/shotwell-transitions/ChessEffect.vala"
								_tmp22_ = _tmp21_;
#line 67 "../plugins/shotwell-transitions/ChessEffect.vala"
								if (_tmp22_ == SPIT_TRANSITIONS_DIRECTION_FORWARD) {
#line 501 "ChessEffect.c"
									GdkRectangle _tmp23_ = {0};
									GdkRectangle _tmp24_;
									GdkRectangle _tmp25_ = {0};
									GdkRectangle _tmp26_;
#line 68 "../plugins/shotwell-transitions/ChessEffect.vala"
									spit_transitions_visuals_get_to_pos (visuals, &_tmp23_);
#line 68 "../plugins/shotwell-transitions/ChessEffect.vala"
									_tmp24_ = _tmp23_;
#line 68 "../plugins/shotwell-transitions/ChessEffect.vala"
									spit_transitions_visuals_get_to_pos (visuals, &_tmp25_);
#line 68 "../plugins/shotwell-transitions/ChessEffect.vala"
									_tmp26_ = _tmp25_;
#line 68 "../plugins/shotwell-transitions/ChessEffect.vala"
									cairo_rectangle (ctx, (_tmp24_.x + translation) + (x * CHESS_EFFECT_SQUARE_SIZE), _tmp26_.y + (y * CHESS_EFFECT_SQUARE_SIZE), size, (gdouble) CHESS_EFFECT_SQUARE_SIZE);
#line 516 "ChessEffect.c"
								} else {
									GdkRectangle _tmp27_ = {0};
									GdkRectangle _tmp28_;
									GdkRectangle _tmp29_ = {0};
									GdkRectangle _tmp30_;
									GdkRectangle _tmp31_ = {0};
									GdkRectangle _tmp32_;
#line 71 "../plugins/shotwell-transitions/ChessEffect.vala"
									spit_transitions_visuals_get_to_pos (visuals, &_tmp27_);
#line 71 "../plugins/shotwell-transitions/ChessEffect.vala"
									_tmp28_ = _tmp27_;
#line 71 "../plugins/shotwell-transitions/ChessEffect.vala"
									spit_transitions_visuals_get_to_pos (visuals, &_tmp29_);
#line 71 "../plugins/shotwell-transitions/ChessEffect.vala"
									_tmp30_ = _tmp29_;
#line 71 "../plugins/shotwell-transitions/ChessEffect.vala"
									spit_transitions_visuals_get_to_pos (visuals, &_tmp31_);
#line 71 "../plugins/shotwell-transitions/ChessEffect.vala"
									_tmp32_ = _tmp31_;
#line 71 "../plugins/shotwell-transitions/ChessEffect.vala"
									cairo_rectangle (ctx, (((_tmp28_.x + _tmp30_.width) + translation) - (x * CHESS_EFFECT_SQUARE_SIZE)) - size, _tmp32_.y + (y * CHESS_EFFECT_SQUARE_SIZE), size, (gdouble) CHESS_EFFECT_SQUARE_SIZE);
#line 538 "ChessEffect.c"
								}
							}
						}
					}
				}
			}
		}
#line 78 "../plugins/shotwell-transitions/ChessEffect.vala"
		cairo_clip (ctx);
#line 79 "../plugins/shotwell-transitions/ChessEffect.vala"
		cairo_paint_with_alpha (ctx, alpha);
#line 550 "ChessEffect.c"
	}
}

static void
chess_effect_real_advance (SpitTransitionsEffect* base,
                           SpitTransitionsVisuals* visuals,
                           SpitTransitionsMotion* motion,
                           gint frame_number)
{
	ChessEffect * self;
#line 83 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CHESS_EFFECT, ChessEffect);
#line 83 "../plugins/shotwell-transitions/ChessEffect.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (visuals, SPIT_TRANSITIONS_TYPE_VISUALS));
#line 83 "../plugins/shotwell-transitions/ChessEffect.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (motion, SPIT_TRANSITIONS_TYPE_MOTION));
#line 567 "ChessEffect.c"
}

static void
chess_effect_real_cancel (SpitTransitionsEffect* base)
{
	ChessEffect * self;
#line 86 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CHESS_EFFECT, ChessEffect);
#line 576 "ChessEffect.c"
}

static void
chess_effect_class_init (ChessEffectClass * klass,
                         gpointer klass_data)
{
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	chess_effect_parent_class = g_type_class_peek_parent (klass);
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	g_type_class_adjust_private_offset (klass, &ChessEffect_private_offset);
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_effect_finalize;
#line 589 "ChessEffect.c"
}

static void
chess_effect_spit_transitions_effect_interface_init (SpitTransitionsEffectIface * iface,
                                                     gpointer iface_data)
{
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	chess_effect_spit_transitions_effect_parent_iface = g_type_interface_peek_parent (iface);
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	iface->get_fps = (void (*) (SpitTransitionsEffect*, gint*, gint*)) chess_effect_real_get_fps;
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	iface->start = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*)) chess_effect_real_start;
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	iface->needs_clear_background = (gboolean (*) (SpitTransitionsEffect*)) chess_effect_real_needs_clear_background;
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	iface->paint = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, cairo_t*, gint, gint, gint)) chess_effect_real_paint;
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	iface->advance = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, gint)) chess_effect_real_advance;
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	iface->cancel = (void (*) (SpitTransitionsEffect*)) chess_effect_real_cancel;
#line 610 "ChessEffect.c"
}

static void
chess_effect_instance_init (ChessEffect * self,
                            gpointer klass)
{
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	self->priv = chess_effect_get_instance_private (self);
#line 619 "ChessEffect.c"
}

static void
chess_effect_finalize (GObject * obj)
{
	ChessEffect * self;
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_EFFECT, ChessEffect);
#line 28 "../plugins/shotwell-transitions/ChessEffect.vala"
	G_OBJECT_CLASS (chess_effect_parent_class)->finalize (obj);
#line 630 "ChessEffect.c"
}

static GType
chess_effect_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessEffectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_effect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessEffect), 0, (GInstanceInitFunc) chess_effect_instance_init, NULL };
	static const GInterfaceInfo spit_transitions_effect_info = { (GInterfaceInitFunc) chess_effect_spit_transitions_effect_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType chess_effect_type_id;
	chess_effect_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessEffect", &g_define_type_info, 0);
	g_type_add_interface_static (chess_effect_type_id, SPIT_TRANSITIONS_TYPE_EFFECT, &spit_transitions_effect_info);
	ChessEffect_private_offset = g_type_add_instance_private (chess_effect_type_id, sizeof (ChessEffectPrivate));
	return chess_effect_type_id;
}

GType
chess_effect_get_type (void)
{
	static volatile gsize chess_effect_type_id__volatile = 0;
	if (g_once_init_enter (&chess_effect_type_id__volatile)) {
		GType chess_effect_type_id;
		chess_effect_type_id = chess_effect_get_type_once ();
		g_once_init_leave (&chess_effect_type_id__volatile, chess_effect_type_id);
	}
	return chess_effect_type_id__volatile;
}

