/* ProgressPaneWidget.c generated by valac 0.52.10, the Vala compiler
 * generated from ProgressPaneWidget.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2019 Jens Georg <mail@jensge.org>
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include "shotwell-internal-publishing-gui.h"
#include <gtk/gtk.h>
#include "shotwell-plugin-dev-1.0.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>

enum  {
	PUBLISHING_UI_PROGRESS_PANE_0_PROPERTY,
	PUBLISHING_UI_PROGRESS_PANE_NUM_PROPERTIES
};
static GParamSpec* publishing_ui_progress_pane_properties[PUBLISHING_UI_PROGRESS_PANE_NUM_PROPERTIES];

struct _PublishingUIProgressPanePrivate {
	GtkProgressBar* progress_bar;
};

static gint PublishingUIProgressPane_private_offset;
static gpointer publishing_ui_progress_pane_parent_class = NULL;
static SpitPublishingDialogPaneIface * publishing_ui_progress_pane_spit_publishing_dialog_pane_parent_iface = NULL;

static GtkWidget* publishing_ui_progress_pane_real_get_widget (SpitPublishingDialogPane* base);
static SpitPublishingDialogPaneGeometryOptions publishing_ui_progress_pane_real_get_preferred_geometry (SpitPublishingDialogPane* base);
static void publishing_ui_progress_pane_real_on_pane_installed (SpitPublishingDialogPane* base);
static void publishing_ui_progress_pane_real_on_pane_uninstalled (SpitPublishingDialogPane* base);
static void publishing_ui_progress_pane_finalize (GObject * obj);
static GType publishing_ui_progress_pane_get_type_once (void);

static inline gpointer
publishing_ui_progress_pane_get_instance_private (PublishingUIProgressPane* self)
{
	return G_STRUCT_MEMBER_P (self, PublishingUIProgressPane_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 16 "../src/publishing/ProgressPaneWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 54 "ProgressPaneWidget.c"
}

static GtkWidget*
publishing_ui_progress_pane_real_get_widget (SpitPublishingDialogPane* base)
{
	PublishingUIProgressPane * self;
	GtkWidget* _tmp0_;
	GtkWidget* result = NULL;
#line 15 "../src/publishing/ProgressPaneWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_UI_TYPE_PROGRESS_PANE, PublishingUIProgressPane);
#line 16 "../src/publishing/ProgressPaneWidget.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 16 "../src/publishing/ProgressPaneWidget.vala"
	result = _tmp0_;
#line 16 "../src/publishing/ProgressPaneWidget.vala"
	return result;
#line 71 "ProgressPaneWidget.c"
}

static SpitPublishingDialogPaneGeometryOptions
publishing_ui_progress_pane_real_get_preferred_geometry (SpitPublishingDialogPane* base)
{
	PublishingUIProgressPane * self;
	SpitPublishingDialogPaneGeometryOptions result = 0;
#line 19 "../src/publishing/ProgressPaneWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_UI_TYPE_PROGRESS_PANE, PublishingUIProgressPane);
#line 20 "../src/publishing/ProgressPaneWidget.vala"
	result = SPIT_PUBLISHING_DIALOG_PANE_GEOMETRY_OPTIONS_NONE;
#line 20 "../src/publishing/ProgressPaneWidget.vala"
	return result;
#line 85 "ProgressPaneWidget.c"
}

static void
publishing_ui_progress_pane_real_on_pane_installed (SpitPublishingDialogPane* base)
{
	PublishingUIProgressPane * self;
#line 23 "../src/publishing/ProgressPaneWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_UI_TYPE_PROGRESS_PANE, PublishingUIProgressPane);
#line 94 "ProgressPaneWidget.c"
}

static void
publishing_ui_progress_pane_real_on_pane_uninstalled (SpitPublishingDialogPane* base)
{
	PublishingUIProgressPane * self;
#line 26 "../src/publishing/ProgressPaneWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_UI_TYPE_PROGRESS_PANE, PublishingUIProgressPane);
#line 103 "ProgressPaneWidget.c"
}

void
publishing_ui_progress_pane_set_text (PublishingUIProgressPane* self,
                                      const gchar* text)
{
	GtkProgressBar* _tmp0_;
#line 29 "../src/publishing/ProgressPaneWidget.vala"
	g_return_if_fail (PUBLISHING_UI_IS_PROGRESS_PANE (self));
#line 29 "../src/publishing/ProgressPaneWidget.vala"
	g_return_if_fail (text != NULL);
#line 30 "../src/publishing/ProgressPaneWidget.vala"
	_tmp0_ = self->priv->progress_bar;
#line 30 "../src/publishing/ProgressPaneWidget.vala"
	gtk_progress_bar_set_text (_tmp0_, text);
#line 119 "ProgressPaneWidget.c"
}

void
publishing_ui_progress_pane_set_progress (PublishingUIProgressPane* self,
                                          gdouble progress)
{
	GtkProgressBar* _tmp0_;
#line 33 "../src/publishing/ProgressPaneWidget.vala"
	g_return_if_fail (PUBLISHING_UI_IS_PROGRESS_PANE (self));
#line 34 "../src/publishing/ProgressPaneWidget.vala"
	_tmp0_ = self->priv->progress_bar;
#line 34 "../src/publishing/ProgressPaneWidget.vala"
	gtk_progress_bar_set_fraction (_tmp0_, progress);
#line 133 "ProgressPaneWidget.c"
}

void
publishing_ui_progress_pane_set_status (PublishingUIProgressPane* self,
                                        const gchar* status_text,
                                        gdouble progress)
{
	GtkProgressBar* _tmp0_;
	const gchar* _tmp1_;
#line 37 "../src/publishing/ProgressPaneWidget.vala"
	g_return_if_fail (PUBLISHING_UI_IS_PROGRESS_PANE (self));
#line 37 "../src/publishing/ProgressPaneWidget.vala"
	g_return_if_fail (status_text != NULL);
#line 38 "../src/publishing/ProgressPaneWidget.vala"
	_tmp0_ = self->priv->progress_bar;
#line 38 "../src/publishing/ProgressPaneWidget.vala"
	_tmp1_ = gtk_progress_bar_get_text (_tmp0_);
#line 38 "../src/publishing/ProgressPaneWidget.vala"
	if (g_strcmp0 (status_text, _tmp1_) != 0) {
#line 153 "ProgressPaneWidget.c"
		GtkProgressBar* _tmp2_;
#line 39 "../src/publishing/ProgressPaneWidget.vala"
		_tmp2_ = self->priv->progress_bar;
#line 39 "../src/publishing/ProgressPaneWidget.vala"
		gtk_progress_bar_set_text (_tmp2_, status_text);
#line 159 "ProgressPaneWidget.c"
	}
#line 41 "../src/publishing/ProgressPaneWidget.vala"
	publishing_ui_progress_pane_set_progress (self, progress);
#line 163 "ProgressPaneWidget.c"
}

PublishingUIProgressPane*
publishing_ui_progress_pane_construct (GType object_type)
{
	PublishingUIProgressPane * self = NULL;
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	self = (PublishingUIProgressPane*) g_object_new (object_type, NULL);
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	return self;
#line 174 "ProgressPaneWidget.c"
}

PublishingUIProgressPane*
publishing_ui_progress_pane_new (void)
{
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	return publishing_ui_progress_pane_construct (PUBLISHING_UI_TYPE_PROGRESS_PANE);
#line 182 "ProgressPaneWidget.c"
}

static void
publishing_ui_progress_pane_class_init (PublishingUIProgressPaneClass * klass,
                                        gpointer klass_data)
{
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	publishing_ui_progress_pane_parent_class = g_type_class_peek_parent (klass);
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	g_type_class_adjust_private_offset (klass, &PublishingUIProgressPane_private_offset);
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = publishing_ui_progress_pane_finalize;
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Shotwell/ui/progress_pane_widget.ui");
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "progress_bar", FALSE, PublishingUIProgressPane_private_offset + G_STRUCT_OFFSET (PublishingUIProgressPanePrivate, progress_bar));
#line 199 "ProgressPaneWidget.c"
}

static void
publishing_ui_progress_pane_spit_publishing_dialog_pane_interface_init (SpitPublishingDialogPaneIface * iface,
                                                                        gpointer iface_data)
{
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	publishing_ui_progress_pane_spit_publishing_dialog_pane_parent_iface = g_type_interface_peek_parent (iface);
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	iface->get_widget = (GtkWidget* (*) (SpitPublishingDialogPane*)) publishing_ui_progress_pane_real_get_widget;
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	iface->get_preferred_geometry = (SpitPublishingDialogPaneGeometryOptions (*) (SpitPublishingDialogPane*)) publishing_ui_progress_pane_real_get_preferred_geometry;
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	iface->on_pane_installed = (void (*) (SpitPublishingDialogPane*)) publishing_ui_progress_pane_real_on_pane_installed;
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	iface->on_pane_uninstalled = (void (*) (SpitPublishingDialogPane*)) publishing_ui_progress_pane_real_on_pane_uninstalled;
#line 216 "ProgressPaneWidget.c"
}

static void
publishing_ui_progress_pane_instance_init (PublishingUIProgressPane * self,
                                           gpointer klass)
{
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	self->priv = publishing_ui_progress_pane_get_instance_private (self);
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 227 "ProgressPaneWidget.c"
}

static void
publishing_ui_progress_pane_finalize (GObject * obj)
{
	PublishingUIProgressPane * self;
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_UI_TYPE_PROGRESS_PANE, PublishingUIProgressPane);
#line 11 "../src/publishing/ProgressPaneWidget.vala"
	G_OBJECT_CLASS (publishing_ui_progress_pane_parent_class)->finalize (obj);
#line 238 "ProgressPaneWidget.c"
}

static GType
publishing_ui_progress_pane_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingUIProgressPaneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_ui_progress_pane_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingUIProgressPane), 0, (GInstanceInitFunc) publishing_ui_progress_pane_instance_init, NULL };
	static const GInterfaceInfo spit_publishing_dialog_pane_info = { (GInterfaceInitFunc) publishing_ui_progress_pane_spit_publishing_dialog_pane_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType publishing_ui_progress_pane_type_id;
	publishing_ui_progress_pane_type_id = g_type_register_static (gtk_box_get_type (), "PublishingUIProgressPane", &g_define_type_info, 0);
	g_type_add_interface_static (publishing_ui_progress_pane_type_id, SPIT_PUBLISHING_TYPE_DIALOG_PANE, &spit_publishing_dialog_pane_info);
	PublishingUIProgressPane_private_offset = g_type_add_instance_private (publishing_ui_progress_pane_type_id, sizeof (PublishingUIProgressPanePrivate));
	return publishing_ui_progress_pane_type_id;
}

GType
publishing_ui_progress_pane_get_type (void)
{
	static volatile gsize publishing_ui_progress_pane_type_id__volatile = 0;
	if (g_once_init_enter (&publishing_ui_progress_pane_type_id__volatile)) {
		GType publishing_ui_progress_pane_type_id;
		publishing_ui_progress_pane_type_id = publishing_ui_progress_pane_get_type_once ();
		g_once_init_leave (&publishing_ui_progress_pane_type_id__volatile, publishing_ui_progress_pane_type_id);
	}
	return publishing_ui_progress_pane_type_id__volatile;
}

