/* MediaInterfaces.c generated by valac 0.52.10, the Vala compiler
 * generated from MediaInterfaces.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/**/
/* Going forward, Shotwell will use MediaInterfaces, which allow for various operations and features*/
/* to be added only to the MediaSources that support them (or make sense for).  For example, adding*/
/* a library-mode photo or video to an Event makes perfect sense, but does not make sense for a*/
/* direct-mode photo.  All three are MediaSources, and to make DirectPhoto descend from another*/
/* base class is only inviting chaos and a tremendous amount of replicated code.*/
/**/
/* A key point to make of all MediaInterfaces is that they require MediaSource as a base class.*/
/* Thus, any code dealing with one of these interfaces knows they are also dealing with a*/
/* MediaSource.*/
/**/
/* TODO: Make Eventable and Taggable interfaces, which are the only types Event and Tag will deal*/
/* with (rather than MediaSources).*/
/**/
/* TODO: Make Trashable interface, which are much like Flaggable.*/
/**/
/* TODO: ContainerSources may also have specific needs in the future; an interface-based system*/
/* may make sense as well when that need arises.*/
/**/
/**/
/* TransactionController*/
/**/
/* Because many operations in Shotwell need to be performed on collections of objects all at once,*/
/* and that most of these objects are backed by a database, the TransactionController object gives */
/* a way to generically group a series of operations on one or more similar objects into a single*/
/* transaction. This class is listed here because it's used by the various media interfaces to offer*/
/* multiple operations.*/
/**/
/* begin() and commit() may be called multiple times in layering fashion.  The implementation*/
/* accounts for this.  If either throws an exception it should be assumed that the object is in*/
/* a "clean" state; that is, if begin() throws an exception, there is no need to call commit(),*/
/* and if commit() throws an exception, it does not need to be called again to revert the object*/
/* state.*/
/**/
/* This means that any user who calls begin() *must* match it with a corresponding commit(), even*/
/* if there is an error during the transaction.  It is up to the user to back out any undesired*/
/* changes.*/
/**/
/* Because of the nature of this object, it's assumed that every object type will share one*/
/* between all callers.*/
/**/
/* The object is thread-safe.  There is no guarantee that the underlying persistent store is,*/
/* however.*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>
#include <gee.h>
#include <gio/gio.h>
#include <time.h>

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;
typedef struct _TransactionControllerPrivate TransactionControllerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecTransactionController ParamSpecTransactionController;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TransactionController {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TransactionControllerPrivate * priv;
};

struct _TransactionControllerClass {
	GTypeClass parent_class;
	void (*finalize) (TransactionController *self);
	void (*begin_impl) (TransactionController* self, GError** error);
	void (*commit_impl) (TransactionController* self, GError** error);
};

struct _TransactionControllerPrivate {
	gint count;
	GRecMutex __lock_count;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _ParamSpecTransactionController {
	GParamSpec parent_instance;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

static gint TransactionController_private_offset;
static gpointer transaction_controller_parent_class = NULL;

gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_transaction_controller (GValue* value,
                                       gpointer v_object);
void value_take_transaction_controller (GValue* value,
                                        gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TransactionController, transaction_controller_unref)
void transaction_controller_begin_impl (TransactionController* self,
                                        GError** error);
void transaction_controller_commit_impl (TransactionController* self,
                                         GError** error);
void transaction_controller_begin (TransactionController* self);
GQuark database_error_quark (void);
void app_window_database_error (GError* err);
void app_window_panic (const gchar* msg);
static void transaction_controller_real_begin_impl (TransactionController* self,
                                             GError** error);
void transaction_controller_commit (TransactionController* self);
static void transaction_controller_real_commit_impl (TransactionController* self,
                                              GError** error);
TransactionController* transaction_controller_construct (GType object_type);
static void transaction_controller_finalize (TransactionController * obj);
static GType transaction_controller_get_type_once (void);
GType data_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
GType data_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
GType thumbnail_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailSource, g_object_unref)
GType media_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSource, g_object_unref)
GType flaggable_get_type (void) G_GNUC_CONST ;
gboolean flaggable_is_flagged (Flaggable* self);
void flaggable_mark_flagged (Flaggable* self);
void flaggable_mark_unflagged (Flaggable* self);
void flaggable_mark_many_flagged_unflagged (GeeCollection* flag,
                                            GeeCollection* unflag,
                                            TransactionController* controller,
                                            GError** error);
static GType flaggable_get_type_once (void);
GType monitorable_get_type (void) G_GNUC_CONST ;
gboolean monitorable_is_offline (Monitorable* self);
void monitorable_mark_online (Monitorable* self);
void monitorable_mark_offline (Monitorable* self);
void monitorable_mark_many_online_offline (GeeCollection* online,
                                           GeeCollection* offline,
                                           TransactionController* controller,
                                           GError** error);
void monitorable_set_master_file (Monitorable* self,
                                  GFile* file);
void monitorable_set_many_master_file (GeeMap* map,
                                       TransactionController* controller,
                                       GError** error);
void monitorable_set_master_timestamp (Monitorable* self,
                                       GFileInfo* info);
void monitorable_set_many_master_timestamp (GeeMap* map,
                                            TransactionController* controller,
                                            GError** error);
static GType monitorable_get_type_once (void);
GType dateable_get_type (void) G_GNUC_CONST ;
void dateable_set_exposure_time (Dateable* self,
                                 time_t target_time);
time_t dateable_get_exposure_time (Dateable* self);
static GType dateable_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
transaction_controller_get_instance_private (TransactionController* self)
{
	return G_STRUCT_MEMBER_P (self, TransactionController_private_offset);
}

void
transaction_controller_begin (TransactionController* self)
{
	GError* _inner_error0_ = NULL;
#line 60 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (self));
#line 288 "MediaInterfaces.c"
	{
#line 61 "../src/MediaInterfaces.vala"
		g_rec_mutex_lock (&self->priv->__lock_count);
#line 292 "MediaInterfaces.c"
		{
			gint _tmp0_;
#line 62 "../src/MediaInterfaces.vala"
			_tmp0_ = self->priv->count;
#line 62 "../src/MediaInterfaces.vala"
			self->priv->count = _tmp0_ + 1;
#line 62 "../src/MediaInterfaces.vala"
			if (_tmp0_ != 0) {
#line 301 "MediaInterfaces.c"
				{
#line 61 "../src/MediaInterfaces.vala"
					g_rec_mutex_unlock (&self->priv->__lock_count);
#line 305 "MediaInterfaces.c"
				}
#line 63 "../src/MediaInterfaces.vala"
				return;
#line 309 "MediaInterfaces.c"
			}
			{
#line 66 "../src/MediaInterfaces.vala"
				transaction_controller_begin_impl (self, &_inner_error0_);
#line 66 "../src/MediaInterfaces.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 316 "MediaInterfaces.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* err = NULL;
				gint _tmp1_;
				GError* _tmp2_;
#line 65 "../src/MediaInterfaces.vala"
				err = _inner_error0_;
#line 65 "../src/MediaInterfaces.vala"
				_inner_error0_ = NULL;
#line 69 "../src/MediaInterfaces.vala"
				_tmp1_ = self->priv->count;
#line 69 "../src/MediaInterfaces.vala"
				self->priv->count = _tmp1_ - 1;
#line 71 "../src/MediaInterfaces.vala"
				_tmp2_ = err;
#line 71 "../src/MediaInterfaces.vala"
				if (_tmp2_->domain == DATABASE_ERROR) {
#line 338 "MediaInterfaces.c"
					GError* _tmp3_;
#line 72 "../src/MediaInterfaces.vala"
					_tmp3_ = err;
#line 72 "../src/MediaInterfaces.vala"
					app_window_database_error ((GError*) _tmp3_);
#line 344 "MediaInterfaces.c"
				} else {
					GError* _tmp4_;
					const gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
#line 74 "../src/MediaInterfaces.vala"
					_tmp4_ = err;
#line 74 "../src/MediaInterfaces.vala"
					_tmp5_ = _tmp4_->message;
#line 74 "../src/MediaInterfaces.vala"
					_tmp6_ = g_strdup_printf ("%s", _tmp5_);
#line 74 "../src/MediaInterfaces.vala"
					_tmp7_ = _tmp6_;
#line 74 "../src/MediaInterfaces.vala"
					app_window_panic (_tmp7_);
#line 74 "../src/MediaInterfaces.vala"
					_g_free0 (_tmp7_);
#line 362 "MediaInterfaces.c"
				}
#line 65 "../src/MediaInterfaces.vala"
				_g_error_free0 (err);
#line 366 "MediaInterfaces.c"
			}
			__finally1:
#line 65 "../src/MediaInterfaces.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "../src/MediaInterfaces.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../src/MediaInterfaces.vala"
				g_clear_error (&_inner_error0_);
#line 65 "../src/MediaInterfaces.vala"
				return;
#line 377 "MediaInterfaces.c"
			}
		}
		__finally0:
		{
#line 61 "../src/MediaInterfaces.vala"
			g_rec_mutex_unlock (&self->priv->__lock_count);
#line 384 "MediaInterfaces.c"
		}
#line 61 "../src/MediaInterfaces.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../src/MediaInterfaces.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 61 "../src/MediaInterfaces.vala"
			g_clear_error (&_inner_error0_);
#line 61 "../src/MediaInterfaces.vala"
			return;
#line 394 "MediaInterfaces.c"
		}
	}
}

static void
transaction_controller_real_begin_impl (TransactionController* self,
                                        GError** error)
{
#line 80 "../src/MediaInterfaces.vala"
	g_critical ("Type `%s' does not implement abstract method `transaction_controller_begin_impl'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 80 "../src/MediaInterfaces.vala"
	return;
#line 407 "MediaInterfaces.c"
}

void
transaction_controller_begin_impl (TransactionController* self,
                                   GError** error)
{
	TransactionControllerClass* _klass_;
#line 80 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (self));
#line 80 "../src/MediaInterfaces.vala"
	_klass_ = TRANSACTION_CONTROLLER_GET_CLASS (self);
#line 80 "../src/MediaInterfaces.vala"
	if (_klass_->begin_impl) {
#line 80 "../src/MediaInterfaces.vala"
		_klass_->begin_impl (self, error);
#line 423 "MediaInterfaces.c"
	}
}

void
transaction_controller_commit (TransactionController* self)
{
	GError* _inner_error0_ = NULL;
#line 82 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (self));
#line 433 "MediaInterfaces.c"
	{
#line 83 "../src/MediaInterfaces.vala"
		g_rec_mutex_lock (&self->priv->__lock_count);
#line 437 "MediaInterfaces.c"
		{
			gint _tmp0_;
#line 84 "../src/MediaInterfaces.vala"
			_vala_assert (self->priv->count > 0, "count > 0");
#line 85 "../src/MediaInterfaces.vala"
			self->priv->count = self->priv->count - 1;
#line 85 "../src/MediaInterfaces.vala"
			_tmp0_ = self->priv->count;
#line 85 "../src/MediaInterfaces.vala"
			if (_tmp0_ != 0) {
#line 448 "MediaInterfaces.c"
				{
#line 83 "../src/MediaInterfaces.vala"
					g_rec_mutex_unlock (&self->priv->__lock_count);
#line 452 "MediaInterfaces.c"
				}
#line 86 "../src/MediaInterfaces.vala"
				return;
#line 456 "MediaInterfaces.c"
			}
			{
#line 90 "../src/MediaInterfaces.vala"
				transaction_controller_commit_impl (self, &_inner_error0_);
#line 90 "../src/MediaInterfaces.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 463 "MediaInterfaces.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* err = NULL;
				GError* _tmp1_;
#line 89 "../src/MediaInterfaces.vala"
				err = _inner_error0_;
#line 89 "../src/MediaInterfaces.vala"
				_inner_error0_ = NULL;
#line 92 "../src/MediaInterfaces.vala"
				_tmp1_ = err;
#line 92 "../src/MediaInterfaces.vala"
				if (_tmp1_->domain == DATABASE_ERROR) {
#line 480 "MediaInterfaces.c"
					GError* _tmp2_;
#line 93 "../src/MediaInterfaces.vala"
					_tmp2_ = err;
#line 93 "../src/MediaInterfaces.vala"
					app_window_database_error ((GError*) _tmp2_);
#line 486 "MediaInterfaces.c"
				} else {
					GError* _tmp3_;
					const gchar* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
#line 95 "../src/MediaInterfaces.vala"
					_tmp3_ = err;
#line 95 "../src/MediaInterfaces.vala"
					_tmp4_ = _tmp3_->message;
#line 95 "../src/MediaInterfaces.vala"
					_tmp5_ = g_strdup_printf ("%s", _tmp4_);
#line 95 "../src/MediaInterfaces.vala"
					_tmp6_ = _tmp5_;
#line 95 "../src/MediaInterfaces.vala"
					app_window_panic (_tmp6_);
#line 95 "../src/MediaInterfaces.vala"
					_g_free0 (_tmp6_);
#line 504 "MediaInterfaces.c"
				}
#line 89 "../src/MediaInterfaces.vala"
				_g_error_free0 (err);
#line 508 "MediaInterfaces.c"
			}
			__finally1:
#line 89 "../src/MediaInterfaces.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 89 "../src/MediaInterfaces.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 89 "../src/MediaInterfaces.vala"
				g_clear_error (&_inner_error0_);
#line 89 "../src/MediaInterfaces.vala"
				return;
#line 519 "MediaInterfaces.c"
			}
		}
		__finally0:
		{
#line 83 "../src/MediaInterfaces.vala"
			g_rec_mutex_unlock (&self->priv->__lock_count);
#line 526 "MediaInterfaces.c"
		}
#line 83 "../src/MediaInterfaces.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 83 "../src/MediaInterfaces.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "../src/MediaInterfaces.vala"
			g_clear_error (&_inner_error0_);
#line 83 "../src/MediaInterfaces.vala"
			return;
#line 536 "MediaInterfaces.c"
		}
	}
}

static void
transaction_controller_real_commit_impl (TransactionController* self,
                                         GError** error)
{
#line 101 "../src/MediaInterfaces.vala"
	g_critical ("Type `%s' does not implement abstract method `transaction_controller_commit_impl'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 101 "../src/MediaInterfaces.vala"
	return;
#line 549 "MediaInterfaces.c"
}

void
transaction_controller_commit_impl (TransactionController* self,
                                    GError** error)
{
	TransactionControllerClass* _klass_;
#line 101 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (self));
#line 101 "../src/MediaInterfaces.vala"
	_klass_ = TRANSACTION_CONTROLLER_GET_CLASS (self);
#line 101 "../src/MediaInterfaces.vala"
	if (_klass_->commit_impl) {
#line 101 "../src/MediaInterfaces.vala"
		_klass_->commit_impl (self, error);
#line 565 "MediaInterfaces.c"
	}
}

TransactionController*
transaction_controller_construct (GType object_type)
{
	TransactionController* self = NULL;
#line 51 "../src/MediaInterfaces.vala"
	self = (TransactionController*) g_type_create_instance (object_type);
#line 51 "../src/MediaInterfaces.vala"
	return self;
#line 577 "MediaInterfaces.c"
}

static void
value_transaction_controller_init (GValue* value)
{
#line 51 "../src/MediaInterfaces.vala"
	value->data[0].v_pointer = NULL;
#line 585 "MediaInterfaces.c"
}

static void
value_transaction_controller_free_value (GValue* value)
{
#line 51 "../src/MediaInterfaces.vala"
	if (value->data[0].v_pointer) {
#line 51 "../src/MediaInterfaces.vala"
		transaction_controller_unref (value->data[0].v_pointer);
#line 595 "MediaInterfaces.c"
	}
}

static void
value_transaction_controller_copy_value (const GValue* src_value,
                                         GValue* dest_value)
{
#line 51 "../src/MediaInterfaces.vala"
	if (src_value->data[0].v_pointer) {
#line 51 "../src/MediaInterfaces.vala"
		dest_value->data[0].v_pointer = transaction_controller_ref (src_value->data[0].v_pointer);
#line 607 "MediaInterfaces.c"
	} else {
#line 51 "../src/MediaInterfaces.vala"
		dest_value->data[0].v_pointer = NULL;
#line 611 "MediaInterfaces.c"
	}
}

static gpointer
value_transaction_controller_peek_pointer (const GValue* value)
{
#line 51 "../src/MediaInterfaces.vala"
	return value->data[0].v_pointer;
#line 620 "MediaInterfaces.c"
}

static gchar*
value_transaction_controller_collect_value (GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
#line 51 "../src/MediaInterfaces.vala"
	if (collect_values[0].v_pointer) {
#line 631 "MediaInterfaces.c"
		TransactionController * object;
		object = collect_values[0].v_pointer;
#line 51 "../src/MediaInterfaces.vala"
		if (object->parent_instance.g_class == NULL) {
#line 51 "../src/MediaInterfaces.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 638 "MediaInterfaces.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 51 "../src/MediaInterfaces.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 642 "MediaInterfaces.c"
		}
#line 51 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = transaction_controller_ref (object);
#line 646 "MediaInterfaces.c"
	} else {
#line 51 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = NULL;
#line 650 "MediaInterfaces.c"
	}
#line 51 "../src/MediaInterfaces.vala"
	return NULL;
#line 654 "MediaInterfaces.c"
}

static gchar*
value_transaction_controller_lcopy_value (const GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	TransactionController ** object_p;
	object_p = collect_values[0].v_pointer;
#line 51 "../src/MediaInterfaces.vala"
	if (!object_p) {
#line 51 "../src/MediaInterfaces.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 669 "MediaInterfaces.c"
	}
#line 51 "../src/MediaInterfaces.vala"
	if (!value->data[0].v_pointer) {
#line 51 "../src/MediaInterfaces.vala"
		*object_p = NULL;
#line 675 "MediaInterfaces.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 51 "../src/MediaInterfaces.vala"
		*object_p = value->data[0].v_pointer;
#line 679 "MediaInterfaces.c"
	} else {
#line 51 "../src/MediaInterfaces.vala"
		*object_p = transaction_controller_ref (value->data[0].v_pointer);
#line 683 "MediaInterfaces.c"
	}
#line 51 "../src/MediaInterfaces.vala"
	return NULL;
#line 687 "MediaInterfaces.c"
}

GParamSpec*
param_spec_transaction_controller (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags)
{
	ParamSpecTransactionController* spec;
#line 51 "../src/MediaInterfaces.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TRANSACTION_CONTROLLER), NULL);
#line 51 "../src/MediaInterfaces.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 51 "../src/MediaInterfaces.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 51 "../src/MediaInterfaces.vala"
	return G_PARAM_SPEC (spec);
#line 706 "MediaInterfaces.c"
}

gpointer
value_get_transaction_controller (const GValue* value)
{
#line 51 "../src/MediaInterfaces.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSACTION_CONTROLLER), NULL);
#line 51 "../src/MediaInterfaces.vala"
	return value->data[0].v_pointer;
#line 716 "MediaInterfaces.c"
}

void
value_set_transaction_controller (GValue* value,
                                  gpointer v_object)
{
	TransactionController * old;
#line 51 "../src/MediaInterfaces.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSACTION_CONTROLLER));
#line 51 "../src/MediaInterfaces.vala"
	old = value->data[0].v_pointer;
#line 51 "../src/MediaInterfaces.vala"
	if (v_object) {
#line 51 "../src/MediaInterfaces.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TRANSACTION_CONTROLLER));
#line 51 "../src/MediaInterfaces.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 51 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = v_object;
#line 51 "../src/MediaInterfaces.vala"
		transaction_controller_ref (value->data[0].v_pointer);
#line 738 "MediaInterfaces.c"
	} else {
#line 51 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = NULL;
#line 742 "MediaInterfaces.c"
	}
#line 51 "../src/MediaInterfaces.vala"
	if (old) {
#line 51 "../src/MediaInterfaces.vala"
		transaction_controller_unref (old);
#line 748 "MediaInterfaces.c"
	}
}

void
value_take_transaction_controller (GValue* value,
                                   gpointer v_object)
{
	TransactionController * old;
#line 51 "../src/MediaInterfaces.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSACTION_CONTROLLER));
#line 51 "../src/MediaInterfaces.vala"
	old = value->data[0].v_pointer;
#line 51 "../src/MediaInterfaces.vala"
	if (v_object) {
#line 51 "../src/MediaInterfaces.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TRANSACTION_CONTROLLER));
#line 51 "../src/MediaInterfaces.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 51 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = v_object;
#line 769 "MediaInterfaces.c"
	} else {
#line 51 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = NULL;
#line 773 "MediaInterfaces.c"
	}
#line 51 "../src/MediaInterfaces.vala"
	if (old) {
#line 51 "../src/MediaInterfaces.vala"
		transaction_controller_unref (old);
#line 779 "MediaInterfaces.c"
	}
}

static void
transaction_controller_class_init (TransactionControllerClass * klass,
                                   gpointer klass_data)
{
#line 51 "../src/MediaInterfaces.vala"
	transaction_controller_parent_class = g_type_class_peek_parent (klass);
#line 51 "../src/MediaInterfaces.vala"
	((TransactionControllerClass *) klass)->finalize = transaction_controller_finalize;
#line 51 "../src/MediaInterfaces.vala"
	g_type_class_adjust_private_offset (klass, &TransactionController_private_offset);
#line 51 "../src/MediaInterfaces.vala"
	((TransactionControllerClass *) klass)->begin_impl = (void (*) (TransactionController*, GError**)) transaction_controller_real_begin_impl;
#line 51 "../src/MediaInterfaces.vala"
	((TransactionControllerClass *) klass)->commit_impl = (void (*) (TransactionController*, GError**)) transaction_controller_real_commit_impl;
#line 797 "MediaInterfaces.c"
}

static void
transaction_controller_instance_init (TransactionController * self,
                                      gpointer klass)
{
#line 51 "../src/MediaInterfaces.vala"
	self->priv = transaction_controller_get_instance_private (self);
#line 52 "../src/MediaInterfaces.vala"
	g_rec_mutex_init (&self->priv->__lock_count);
#line 52 "../src/MediaInterfaces.vala"
	self->priv->count = 0;
#line 51 "../src/MediaInterfaces.vala"
	self->ref_count = 1;
#line 812 "MediaInterfaces.c"
}

static void
transaction_controller_finalize (TransactionController * obj)
{
	TransactionController * self;
	GError* _inner_error0_ = NULL;
#line 51 "../src/MediaInterfaces.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TRANSACTION_CONTROLLER, TransactionController);
#line 51 "../src/MediaInterfaces.vala"
	g_signal_handlers_destroy (self);
#line 824 "MediaInterfaces.c"
	{
#line 55 "../src/MediaInterfaces.vala"
		g_rec_mutex_lock (&self->priv->__lock_count);
#line 828 "MediaInterfaces.c"
		{
#line 56 "../src/MediaInterfaces.vala"
			_vala_assert (self->priv->count == 0, "count == 0");
#line 832 "MediaInterfaces.c"
		}
		__finally0:
		{
#line 55 "../src/MediaInterfaces.vala"
			g_rec_mutex_unlock (&self->priv->__lock_count);
#line 838 "MediaInterfaces.c"
		}
#line 55 "../src/MediaInterfaces.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "../src/MediaInterfaces.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 55 "../src/MediaInterfaces.vala"
			g_clear_error (&_inner_error0_);
#line 846 "MediaInterfaces.c"
		}
	}
#line 52 "../src/MediaInterfaces.vala"
	g_rec_mutex_clear (&self->priv->__lock_count);
#line 851 "MediaInterfaces.c"
}

static GType
transaction_controller_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_transaction_controller_init, value_transaction_controller_free_value, value_transaction_controller_copy_value, value_transaction_controller_peek_pointer, "p", value_transaction_controller_collect_value, "p", value_transaction_controller_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TransactionControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) transaction_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TransactionController), 0, (GInstanceInitFunc) transaction_controller_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType transaction_controller_type_id;
	transaction_controller_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TransactionController", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	TransactionController_private_offset = g_type_add_instance_private (transaction_controller_type_id, sizeof (TransactionControllerPrivate));
	return transaction_controller_type_id;
}

GType
transaction_controller_get_type (void)
{
	static volatile gsize transaction_controller_type_id__volatile = 0;
	if (g_once_init_enter (&transaction_controller_type_id__volatile)) {
		GType transaction_controller_type_id;
		transaction_controller_type_id = transaction_controller_get_type_once ();
		g_once_init_leave (&transaction_controller_type_id__volatile, transaction_controller_type_id);
	}
	return transaction_controller_type_id__volatile;
}

gpointer
transaction_controller_ref (gpointer instance)
{
	TransactionController * self;
	self = instance;
#line 51 "../src/MediaInterfaces.vala"
	g_atomic_int_inc (&self->ref_count);
#line 51 "../src/MediaInterfaces.vala"
	return instance;
#line 887 "MediaInterfaces.c"
}

void
transaction_controller_unref (gpointer instance)
{
	TransactionController * self;
	self = instance;
#line 51 "../src/MediaInterfaces.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 51 "../src/MediaInterfaces.vala"
		TRANSACTION_CONTROLLER_GET_CLASS (self)->finalize (self);
#line 51 "../src/MediaInterfaces.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 901 "MediaInterfaces.c"
	}
}

gboolean
flaggable_is_flagged (Flaggable* self)
{
	FlaggableIface* _iface_;
#line 112 "../src/MediaInterfaces.vala"
	g_return_val_if_fail (IS_FLAGGABLE (self), FALSE);
#line 112 "../src/MediaInterfaces.vala"
	_iface_ = FLAGGABLE_GET_INTERFACE (self);
#line 112 "../src/MediaInterfaces.vala"
	if (_iface_->is_flagged) {
#line 112 "../src/MediaInterfaces.vala"
		return _iface_->is_flagged (self);
#line 917 "MediaInterfaces.c"
	}
#line 112 "../src/MediaInterfaces.vala"
	return FALSE;
#line 921 "MediaInterfaces.c"
}

void
flaggable_mark_flagged (Flaggable* self)
{
	FlaggableIface* _iface_;
#line 114 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_FLAGGABLE (self));
#line 114 "../src/MediaInterfaces.vala"
	_iface_ = FLAGGABLE_GET_INTERFACE (self);
#line 114 "../src/MediaInterfaces.vala"
	if (_iface_->mark_flagged) {
#line 114 "../src/MediaInterfaces.vala"
		_iface_->mark_flagged (self);
#line 936 "MediaInterfaces.c"
	}
}

void
flaggable_mark_unflagged (Flaggable* self)
{
	FlaggableIface* _iface_;
#line 116 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_FLAGGABLE (self));
#line 116 "../src/MediaInterfaces.vala"
	_iface_ = FLAGGABLE_GET_INTERFACE (self);
#line 116 "../src/MediaInterfaces.vala"
	if (_iface_->mark_unflagged) {
#line 116 "../src/MediaInterfaces.vala"
		_iface_->mark_unflagged (self);
#line 952 "MediaInterfaces.c"
	}
}

void
flaggable_mark_many_flagged_unflagged (GeeCollection* flag,
                                       GeeCollection* unflag,
                                       TransactionController* controller,
                                       GError** error)
{
#line 118 "../src/MediaInterfaces.vala"
	g_return_if_fail ((flag == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (flag, GEE_TYPE_COLLECTION));
#line 118 "../src/MediaInterfaces.vala"
	g_return_if_fail ((unflag == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (unflag, GEE_TYPE_COLLECTION));
#line 118 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (controller));
#line 120 "../src/MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 122 "../src/MediaInterfaces.vala"
	if (flag != NULL) {
#line 972 "MediaInterfaces.c"
		{
			GeeIterator* _flaggable_it = NULL;
			GeeIterator* _tmp0_;
#line 123 "../src/MediaInterfaces.vala"
			_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (flag, GEE_TYPE_ITERABLE, GeeIterable));
#line 123 "../src/MediaInterfaces.vala"
			_flaggable_it = _tmp0_;
#line 123 "../src/MediaInterfaces.vala"
			while (TRUE) {
#line 982 "MediaInterfaces.c"
				GeeIterator* _tmp1_;
				Flaggable* flaggable = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Flaggable* _tmp4_;
#line 123 "../src/MediaInterfaces.vala"
				_tmp1_ = _flaggable_it;
#line 123 "../src/MediaInterfaces.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 123 "../src/MediaInterfaces.vala"
					break;
#line 994 "MediaInterfaces.c"
				}
#line 123 "../src/MediaInterfaces.vala"
				_tmp2_ = _flaggable_it;
#line 123 "../src/MediaInterfaces.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 123 "../src/MediaInterfaces.vala"
				flaggable = (Flaggable*) _tmp3_;
#line 124 "../src/MediaInterfaces.vala"
				_tmp4_ = flaggable;
#line 124 "../src/MediaInterfaces.vala"
				flaggable_mark_flagged (_tmp4_);
#line 123 "../src/MediaInterfaces.vala"
				_g_object_unref0 (flaggable);
#line 1008 "MediaInterfaces.c"
			}
#line 123 "../src/MediaInterfaces.vala"
			_g_object_unref0 (_flaggable_it);
#line 1012 "MediaInterfaces.c"
		}
	}
#line 127 "../src/MediaInterfaces.vala"
	if (unflag != NULL) {
#line 1017 "MediaInterfaces.c"
		{
			GeeIterator* _flaggable_it = NULL;
			GeeIterator* _tmp5_;
#line 128 "../src/MediaInterfaces.vala"
			_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (unflag, GEE_TYPE_ITERABLE, GeeIterable));
#line 128 "../src/MediaInterfaces.vala"
			_flaggable_it = _tmp5_;
#line 128 "../src/MediaInterfaces.vala"
			while (TRUE) {
#line 1027 "MediaInterfaces.c"
				GeeIterator* _tmp6_;
				Flaggable* flaggable = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				Flaggable* _tmp9_;
#line 128 "../src/MediaInterfaces.vala"
				_tmp6_ = _flaggable_it;
#line 128 "../src/MediaInterfaces.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 128 "../src/MediaInterfaces.vala"
					break;
#line 1039 "MediaInterfaces.c"
				}
#line 128 "../src/MediaInterfaces.vala"
				_tmp7_ = _flaggable_it;
#line 128 "../src/MediaInterfaces.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 128 "../src/MediaInterfaces.vala"
				flaggable = (Flaggable*) _tmp8_;
#line 129 "../src/MediaInterfaces.vala"
				_tmp9_ = flaggable;
#line 129 "../src/MediaInterfaces.vala"
				flaggable_mark_unflagged (_tmp9_);
#line 128 "../src/MediaInterfaces.vala"
				_g_object_unref0 (flaggable);
#line 1053 "MediaInterfaces.c"
			}
#line 128 "../src/MediaInterfaces.vala"
			_g_object_unref0 (_flaggable_it);
#line 1057 "MediaInterfaces.c"
		}
	}
#line 132 "../src/MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 1062 "MediaInterfaces.c"
}

static void
flaggable_default_init (FlaggableIface * iface,
                        gpointer iface_data)
{
}

static GType
flaggable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FlaggableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) flaggable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType flaggable_type_id;
	flaggable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Flaggable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (flaggable_type_id, TYPE_MEDIA_SOURCE);
	return flaggable_type_id;
}

GType
flaggable_get_type (void)
{
	static volatile gsize flaggable_type_id__volatile = 0;
	if (g_once_init_enter (&flaggable_type_id__volatile)) {
		GType flaggable_type_id;
		flaggable_type_id = flaggable_get_type_once ();
		g_once_init_leave (&flaggable_type_id__volatile, flaggable_type_id);
	}
	return flaggable_type_id__volatile;
}

gboolean
monitorable_is_offline (Monitorable* self)
{
	MonitorableIface* _iface_;
#line 150 "../src/MediaInterfaces.vala"
	g_return_val_if_fail (IS_MONITORABLE (self), FALSE);
#line 150 "../src/MediaInterfaces.vala"
	_iface_ = MONITORABLE_GET_INTERFACE (self);
#line 150 "../src/MediaInterfaces.vala"
	if (_iface_->is_offline) {
#line 150 "../src/MediaInterfaces.vala"
		return _iface_->is_offline (self);
#line 1105 "MediaInterfaces.c"
	}
#line 150 "../src/MediaInterfaces.vala"
	return FALSE;
#line 1109 "MediaInterfaces.c"
}

void
monitorable_mark_online (Monitorable* self)
{
	MonitorableIface* _iface_;
#line 152 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_MONITORABLE (self));
#line 152 "../src/MediaInterfaces.vala"
	_iface_ = MONITORABLE_GET_INTERFACE (self);
#line 152 "../src/MediaInterfaces.vala"
	if (_iface_->mark_online) {
#line 152 "../src/MediaInterfaces.vala"
		_iface_->mark_online (self);
#line 1124 "MediaInterfaces.c"
	}
}

void
monitorable_mark_offline (Monitorable* self)
{
	MonitorableIface* _iface_;
#line 154 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_MONITORABLE (self));
#line 154 "../src/MediaInterfaces.vala"
	_iface_ = MONITORABLE_GET_INTERFACE (self);
#line 154 "../src/MediaInterfaces.vala"
	if (_iface_->mark_offline) {
#line 154 "../src/MediaInterfaces.vala"
		_iface_->mark_offline (self);
#line 1140 "MediaInterfaces.c"
	}
}

void
monitorable_mark_many_online_offline (GeeCollection* online,
                                      GeeCollection* offline,
                                      TransactionController* controller,
                                      GError** error)
{
#line 156 "../src/MediaInterfaces.vala"
	g_return_if_fail ((online == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (online, GEE_TYPE_COLLECTION));
#line 156 "../src/MediaInterfaces.vala"
	g_return_if_fail ((offline == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (offline, GEE_TYPE_COLLECTION));
#line 156 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (controller));
#line 158 "../src/MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 160 "../src/MediaInterfaces.vala"
	if (online != NULL) {
#line 1160 "MediaInterfaces.c"
		{
			GeeIterator* _monitorable_it = NULL;
			GeeIterator* _tmp0_;
#line 161 "../src/MediaInterfaces.vala"
			_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (online, GEE_TYPE_ITERABLE, GeeIterable));
#line 161 "../src/MediaInterfaces.vala"
			_monitorable_it = _tmp0_;
#line 161 "../src/MediaInterfaces.vala"
			while (TRUE) {
#line 1170 "MediaInterfaces.c"
				GeeIterator* _tmp1_;
				Monitorable* monitorable = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Monitorable* _tmp4_;
#line 161 "../src/MediaInterfaces.vala"
				_tmp1_ = _monitorable_it;
#line 161 "../src/MediaInterfaces.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 161 "../src/MediaInterfaces.vala"
					break;
#line 1182 "MediaInterfaces.c"
				}
#line 161 "../src/MediaInterfaces.vala"
				_tmp2_ = _monitorable_it;
#line 161 "../src/MediaInterfaces.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 161 "../src/MediaInterfaces.vala"
				monitorable = (Monitorable*) _tmp3_;
#line 162 "../src/MediaInterfaces.vala"
				_tmp4_ = monitorable;
#line 162 "../src/MediaInterfaces.vala"
				monitorable_mark_online (_tmp4_);
#line 161 "../src/MediaInterfaces.vala"
				_g_object_unref0 (monitorable);
#line 1196 "MediaInterfaces.c"
			}
#line 161 "../src/MediaInterfaces.vala"
			_g_object_unref0 (_monitorable_it);
#line 1200 "MediaInterfaces.c"
		}
	}
#line 165 "../src/MediaInterfaces.vala"
	if (offline != NULL) {
#line 1205 "MediaInterfaces.c"
		{
			GeeIterator* _monitorable_it = NULL;
			GeeIterator* _tmp5_;
#line 166 "../src/MediaInterfaces.vala"
			_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (offline, GEE_TYPE_ITERABLE, GeeIterable));
#line 166 "../src/MediaInterfaces.vala"
			_monitorable_it = _tmp5_;
#line 166 "../src/MediaInterfaces.vala"
			while (TRUE) {
#line 1215 "MediaInterfaces.c"
				GeeIterator* _tmp6_;
				Monitorable* monitorable = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				Monitorable* _tmp9_;
#line 166 "../src/MediaInterfaces.vala"
				_tmp6_ = _monitorable_it;
#line 166 "../src/MediaInterfaces.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 166 "../src/MediaInterfaces.vala"
					break;
#line 1227 "MediaInterfaces.c"
				}
#line 166 "../src/MediaInterfaces.vala"
				_tmp7_ = _monitorable_it;
#line 166 "../src/MediaInterfaces.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 166 "../src/MediaInterfaces.vala"
				monitorable = (Monitorable*) _tmp8_;
#line 167 "../src/MediaInterfaces.vala"
				_tmp9_ = monitorable;
#line 167 "../src/MediaInterfaces.vala"
				monitorable_mark_offline (_tmp9_);
#line 166 "../src/MediaInterfaces.vala"
				_g_object_unref0 (monitorable);
#line 1241 "MediaInterfaces.c"
			}
#line 166 "../src/MediaInterfaces.vala"
			_g_object_unref0 (_monitorable_it);
#line 1245 "MediaInterfaces.c"
		}
	}
#line 170 "../src/MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 1250 "MediaInterfaces.c"
}

void
monitorable_set_master_file (Monitorable* self,
                             GFile* file)
{
	MonitorableIface* _iface_;
#line 173 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_MONITORABLE (self));
#line 173 "../src/MediaInterfaces.vala"
	_iface_ = MONITORABLE_GET_INTERFACE (self);
#line 173 "../src/MediaInterfaces.vala"
	if (_iface_->set_master_file) {
#line 173 "../src/MediaInterfaces.vala"
		_iface_->set_master_file (self, file);
#line 1266 "MediaInterfaces.c"
	}
}

void
monitorable_set_many_master_file (GeeMap* map,
                                  TransactionController* controller,
                                  GError** error)
{
	GeeMapIterator* map_iter = NULL;
	GeeMapIterator* _tmp0_;
#line 175 "../src/MediaInterfaces.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 175 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (controller));
#line 177 "../src/MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 179 "../src/MediaInterfaces.vala"
	_tmp0_ = gee_map_map_iterator (map);
#line 179 "../src/MediaInterfaces.vala"
	map_iter = _tmp0_;
#line 180 "../src/MediaInterfaces.vala"
	while (TRUE) {
#line 1289 "MediaInterfaces.c"
		GeeMapIterator* _tmp1_;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		Monitorable* _tmp4_;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		GFile* _tmp7_;
#line 180 "../src/MediaInterfaces.vala"
		_tmp1_ = map_iter;
#line 180 "../src/MediaInterfaces.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 180 "../src/MediaInterfaces.vala"
			break;
#line 1303 "MediaInterfaces.c"
		}
#line 181 "../src/MediaInterfaces.vala"
		_tmp2_ = map_iter;
#line 181 "../src/MediaInterfaces.vala"
		_tmp3_ = gee_map_iterator_get_key (_tmp2_);
#line 181 "../src/MediaInterfaces.vala"
		_tmp4_ = (Monitorable*) _tmp3_;
#line 181 "../src/MediaInterfaces.vala"
		_tmp5_ = map_iter;
#line 181 "../src/MediaInterfaces.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 181 "../src/MediaInterfaces.vala"
		_tmp7_ = (GFile*) _tmp6_;
#line 181 "../src/MediaInterfaces.vala"
		monitorable_set_master_file (_tmp4_, _tmp7_);
#line 181 "../src/MediaInterfaces.vala"
		_g_object_unref0 (_tmp7_);
#line 181 "../src/MediaInterfaces.vala"
		_g_object_unref0 (_tmp4_);
#line 1323 "MediaInterfaces.c"
	}
#line 183 "../src/MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 175 "../src/MediaInterfaces.vala"
	_g_object_unref0 (map_iter);
#line 1329 "MediaInterfaces.c"
}

void
monitorable_set_master_timestamp (Monitorable* self,
                                  GFileInfo* info)
{
	MonitorableIface* _iface_;
#line 186 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_MONITORABLE (self));
#line 186 "../src/MediaInterfaces.vala"
	_iface_ = MONITORABLE_GET_INTERFACE (self);
#line 186 "../src/MediaInterfaces.vala"
	if (_iface_->set_master_timestamp) {
#line 186 "../src/MediaInterfaces.vala"
		_iface_->set_master_timestamp (self, info);
#line 1345 "MediaInterfaces.c"
	}
}

void
monitorable_set_many_master_timestamp (GeeMap* map,
                                       TransactionController* controller,
                                       GError** error)
{
	GeeMapIterator* map_iter = NULL;
	GeeMapIterator* _tmp0_;
#line 188 "../src/MediaInterfaces.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 188 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (controller));
#line 190 "../src/MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 192 "../src/MediaInterfaces.vala"
	_tmp0_ = gee_map_map_iterator (map);
#line 192 "../src/MediaInterfaces.vala"
	map_iter = _tmp0_;
#line 193 "../src/MediaInterfaces.vala"
	while (TRUE) {
#line 1368 "MediaInterfaces.c"
		GeeMapIterator* _tmp1_;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		Monitorable* _tmp4_;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		GFileInfo* _tmp7_;
#line 193 "../src/MediaInterfaces.vala"
		_tmp1_ = map_iter;
#line 193 "../src/MediaInterfaces.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 193 "../src/MediaInterfaces.vala"
			break;
#line 1382 "MediaInterfaces.c"
		}
#line 194 "../src/MediaInterfaces.vala"
		_tmp2_ = map_iter;
#line 194 "../src/MediaInterfaces.vala"
		_tmp3_ = gee_map_iterator_get_key (_tmp2_);
#line 194 "../src/MediaInterfaces.vala"
		_tmp4_ = (Monitorable*) _tmp3_;
#line 194 "../src/MediaInterfaces.vala"
		_tmp5_ = map_iter;
#line 194 "../src/MediaInterfaces.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 194 "../src/MediaInterfaces.vala"
		_tmp7_ = (GFileInfo*) _tmp6_;
#line 194 "../src/MediaInterfaces.vala"
		monitorable_set_master_timestamp (_tmp4_, _tmp7_);
#line 194 "../src/MediaInterfaces.vala"
		_g_object_unref0 (_tmp7_);
#line 194 "../src/MediaInterfaces.vala"
		_g_object_unref0 (_tmp4_);
#line 1402 "MediaInterfaces.c"
	}
#line 196 "../src/MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 188 "../src/MediaInterfaces.vala"
	_g_object_unref0 (map_iter);
#line 1408 "MediaInterfaces.c"
}

static void
monitorable_default_init (MonitorableIface * iface,
                          gpointer iface_data)
{
}

static GType
monitorable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MonitorableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) monitorable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType monitorable_type_id;
	monitorable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Monitorable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (monitorable_type_id, TYPE_MEDIA_SOURCE);
	return monitorable_type_id;
}

GType
monitorable_get_type (void)
{
	static volatile gsize monitorable_type_id__volatile = 0;
	if (g_once_init_enter (&monitorable_type_id__volatile)) {
		GType monitorable_type_id;
		monitorable_type_id = monitorable_get_type_once ();
		g_once_init_leave (&monitorable_type_id__volatile, monitorable_type_id);
	}
	return monitorable_type_id__volatile;
}

void
dateable_set_exposure_time (Dateable* self,
                            time_t target_time)
{
	DateableIface* _iface_;
#line 209 "../src/MediaInterfaces.vala"
	g_return_if_fail (IS_DATEABLE (self));
#line 209 "../src/MediaInterfaces.vala"
	_iface_ = DATEABLE_GET_INTERFACE (self);
#line 209 "../src/MediaInterfaces.vala"
	if (_iface_->set_exposure_time) {
#line 209 "../src/MediaInterfaces.vala"
		_iface_->set_exposure_time (self, target_time);
#line 1452 "MediaInterfaces.c"
	}
}

time_t
dateable_get_exposure_time (Dateable* self)
{
	DateableIface* _iface_;
#line 211 "../src/MediaInterfaces.vala"
	g_return_val_if_fail (IS_DATEABLE (self), 0);
#line 211 "../src/MediaInterfaces.vala"
	_iface_ = DATEABLE_GET_INTERFACE (self);
#line 211 "../src/MediaInterfaces.vala"
	if (_iface_->get_exposure_time) {
#line 211 "../src/MediaInterfaces.vala"
		return _iface_->get_exposure_time (self);
#line 1468 "MediaInterfaces.c"
	}
#line 211 "../src/MediaInterfaces.vala"
	return 0;
#line 1472 "MediaInterfaces.c"
}

static void
dateable_default_init (DateableIface * iface,
                       gpointer iface_data)
{
}

static GType
dateable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DateableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dateable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType dateable_type_id;
	dateable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Dateable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (dateable_type_id, TYPE_MEDIA_SOURCE);
	return dateable_type_id;
}

GType
dateable_get_type (void)
{
	static volatile gsize dateable_type_id__volatile = 0;
	if (g_once_init_enter (&dateable_type_id__volatile)) {
		GType dateable_type_id;
		dateable_type_id = dateable_get_type_once ();
		g_once_init_leave (&dateable_type_id__volatile, dateable_type_id);
	}
	return dateable_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

