/* DiscoveredCamera.c generated by valac 0.52.10, the Vala compiler
 * generated from DiscoveredCamera.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <gphoto2/gphoto2-camera.h>
#include <shotwell-gphoto-helper.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gphoto2/gphoto2-port-info-list.h>
#include <gphoto2/gphoto2-abilities-list.h>
#include <gphoto2/gphoto2-result.h>
#include <gphoto2/gphoto2-port-result.h>
#include <gio/gio.h>
#include <gudev/gudev.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define TYPE_DISCOVERED_CAMERA (discovered_camera_get_type ())
#define DISCOVERED_CAMERA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DISCOVERED_CAMERA, DiscoveredCamera))
#define DISCOVERED_CAMERA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DISCOVERED_CAMERA, DiscoveredCameraClass))
#define IS_DISCOVERED_CAMERA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DISCOVERED_CAMERA))
#define IS_DISCOVERED_CAMERA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DISCOVERED_CAMERA))
#define DISCOVERED_CAMERA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DISCOVERED_CAMERA, DiscoveredCameraClass))

typedef struct _DiscoveredCamera DiscoveredCamera;
typedef struct _DiscoveredCameraClass DiscoveredCameraClass;
typedef struct _DiscoveredCameraPrivate DiscoveredCameraPrivate;
#define _gp_camera_unref0(var) ((var == NULL) ? NULL : (var = (gp_camera_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _discovered_camera_unref0(var) ((var == NULL) ? NULL : (var = (discovered_camera_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _ParamSpecDiscoveredCamera ParamSpecDiscoveredCamera;

struct _DiscoveredCamera {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DiscoveredCameraPrivate * priv;
	Camera* gcamera;
	gchar* uri;
	gchar* display_name;
	gchar* icon;
};

struct _DiscoveredCameraClass {
	GTypeClass parent_class;
	void (*finalize) (DiscoveredCamera *self);
};

struct _DiscoveredCameraPrivate {
	gchar* port;
	gchar* camera_name;
	gchar** mount_uris;
	gint mount_uris_length1;
	gint _mount_uris_size_;
};

typedef enum  {
	GPHOTO_ERROR_LIBRARY
} GPhotoError;
#define GPHOTO_ERROR gphoto_error_quark ()
struct _ParamSpecDiscoveredCamera {
	GParamSpec parent_instance;
};

static gint DiscoveredCamera_private_offset;
static gpointer discovered_camera_parent_class = NULL;

gpointer discovered_camera_ref (gpointer instance);
void discovered_camera_unref (gpointer instance);
GParamSpec* param_spec_discovered_camera (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_discovered_camera (GValue* value,
                                  gpointer v_object);
void value_take_discovered_camera (GValue* value,
                                   gpointer v_object);
gpointer value_get_discovered_camera (const GValue* value);
GType discovered_camera_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DiscoveredCamera, discovered_camera_unref)
GQuark gphoto_error_quark (void);
DiscoveredCamera* discovered_camera_new (const gchar* name,
                                         const gchar* port,
                                         GPPortInfo port_info,
                                         CameraAbilities camera_abilities,
                                         GError** error);
DiscoveredCamera* discovered_camera_construct (GType object_type,
                                               const gchar* name,
                                               const gchar* port,
                                               GPPortInfo port_info,
                                               CameraAbilities camera_abilities,
                                               GError** error);
static void _vala_array_add68 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add69 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gchar* discovered_camera_get_port_path (DiscoveredCamera* self,
                                        const gchar* port);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _vala_array_add70 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add71 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
GMount* discovered_camera_get_mount (DiscoveredCamera* self);
static void discovered_camera_finalize (DiscoveredCamera * obj);
static GType discovered_camera_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
discovered_camera_get_instance_private (DiscoveredCamera* self)
{
	return G_STRUCT_MEMBER_P (self, DiscoveredCamera_private_offset);
}

static void
_vala_array_add68 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 23 "../src/camera/DiscoveredCamera.vala"
	if ((*length) == (*size)) {
#line 23 "../src/camera/DiscoveredCamera.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 23 "../src/camera/DiscoveredCamera.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 153 "DiscoveredCamera.c"
	}
#line 23 "../src/camera/DiscoveredCamera.vala"
	(*array)[(*length)++] = value;
#line 23 "../src/camera/DiscoveredCamera.vala"
	(*array)[*length] = NULL;
#line 159 "DiscoveredCamera.c"
}

static void
_vala_array_add69 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 24 "../src/camera/DiscoveredCamera.vala"
	if ((*length) == (*size)) {
#line 24 "../src/camera/DiscoveredCamera.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 24 "../src/camera/DiscoveredCamera.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 174 "DiscoveredCamera.c"
	}
#line 24 "../src/camera/DiscoveredCamera.vala"
	(*array)[(*length)++] = value;
#line 24 "../src/camera/DiscoveredCamera.vala"
	(*array)[*length] = NULL;
#line 180 "DiscoveredCamera.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 48 "../src/camera/DiscoveredCamera.vala"
	return self ? g_object_ref (self) : NULL;
#line 188 "DiscoveredCamera.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 48 "../src/camera/DiscoveredCamera.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 196 "DiscoveredCamera.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 48 "../src/camera/DiscoveredCamera.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 204 "DiscoveredCamera.c"
}

static void
_vala_array_add70 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 62 "../src/camera/DiscoveredCamera.vala"
	if ((*length) == (*size)) {
#line 62 "../src/camera/DiscoveredCamera.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 62 "../src/camera/DiscoveredCamera.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 219 "DiscoveredCamera.c"
	}
#line 62 "../src/camera/DiscoveredCamera.vala"
	(*array)[(*length)++] = value;
#line 62 "../src/camera/DiscoveredCamera.vala"
	(*array)[*length] = NULL;
#line 225 "DiscoveredCamera.c"
}

static void
_vala_array_add71 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 63 "../src/camera/DiscoveredCamera.vala"
	if ((*length) == (*size)) {
#line 63 "../src/camera/DiscoveredCamera.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 63 "../src/camera/DiscoveredCamera.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 240 "DiscoveredCamera.c"
	}
#line 63 "../src/camera/DiscoveredCamera.vala"
	(*array)[(*length)++] = value;
#line 63 "../src/camera/DiscoveredCamera.vala"
	(*array)[*length] = NULL;
#line 246 "DiscoveredCamera.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
#line 1447 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1447 "glib-2.0.vapi"
	end = _tmp0_;
#line 1448 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1448 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1449 "glib-2.0.vapi"
		result = maxlen;
#line 1449 "glib-2.0.vapi"
		return result;
#line 269 "DiscoveredCamera.c"
	} else {
		gchar* _tmp2_;
#line 1451 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1451 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1451 "glib-2.0.vapi"
		return result;
#line 278 "DiscoveredCamera.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1460 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 297 "DiscoveredCamera.c"
	} else {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 301 "DiscoveredCamera.c"
	}
#line 1460 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1462 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 307 "DiscoveredCamera.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1464 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1464 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1464 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 317 "DiscoveredCamera.c"
	}
#line 1467 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1469 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 325 "DiscoveredCamera.c"
	} else {
#line 1471 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 329 "DiscoveredCamera.c"
	}
#line 1473 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1474 "glib-2.0.vapi"
		len = string_length - offset;
#line 335 "DiscoveredCamera.c"
	}
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1477 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1477 "glib-2.0.vapi"
	result = _tmp3_;
#line 1477 "glib-2.0.vapi"
	return result;
#line 345 "DiscoveredCamera.c"
}

DiscoveredCamera*
discovered_camera_construct (GType object_type,
                             const gchar* name,
                             const gchar* port,
                             GPPortInfo port_info,
                             CameraAbilities camera_abilities,
                             GError** error)
{
	DiscoveredCamera* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	int res = 0;
	Camera* _tmp7_ = NULL;
	int _tmp8_;
	Camera* _tmp11_;
	Camera* _tmp14_;
	gchar* path = NULL;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp78_;
	GError* _inner_error0_ = NULL;
#line 17 "../src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 17 "../src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (port != NULL, NULL);
#line 17 "../src/camera/DiscoveredCamera.vala"
	self = (DiscoveredCamera*) g_type_create_instance (object_type);
#line 18 "../src/camera/DiscoveredCamera.vala"
	_tmp0_ = g_strdup (port);
#line 18 "../src/camera/DiscoveredCamera.vala"
	_g_free0 (self->priv->port);
#line 18 "../src/camera/DiscoveredCamera.vala"
	self->priv->port = _tmp0_;
#line 19 "../src/camera/DiscoveredCamera.vala"
	_tmp1_ = g_strdup (name);
#line 19 "../src/camera/DiscoveredCamera.vala"
	_g_free0 (self->priv->camera_name);
#line 19 "../src/camera/DiscoveredCamera.vala"
	self->priv->camera_name = _tmp1_;
#line 20 "../src/camera/DiscoveredCamera.vala"
	_tmp2_ = g_strdup_printf ("gphoto2://[%s]", port);
#line 20 "../src/camera/DiscoveredCamera.vala"
	_g_free0 (self->uri);
#line 20 "../src/camera/DiscoveredCamera.vala"
	self->uri = _tmp2_;
#line 22 "../src/camera/DiscoveredCamera.vala"
	_tmp3_ = g_new0 (gchar*, 0 + 1);
#line 22 "../src/camera/DiscoveredCamera.vala"
	self->priv->mount_uris = (_vala_array_free (self->priv->mount_uris, self->priv->mount_uris_length1, (GDestroyNotify) g_free), NULL);
#line 22 "../src/camera/DiscoveredCamera.vala"
	self->priv->mount_uris = _tmp3_;
#line 22 "../src/camera/DiscoveredCamera.vala"
	self->priv->mount_uris_length1 = 0;
#line 22 "../src/camera/DiscoveredCamera.vala"
	self->priv->_mount_uris_size_ = self->priv->mount_uris_length1;
#line 23 "../src/camera/DiscoveredCamera.vala"
	_tmp4_ = self->uri;
#line 23 "../src/camera/DiscoveredCamera.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 23 "../src/camera/DiscoveredCamera.vala"
	_vala_array_add68 (&self->priv->mount_uris, &self->priv->mount_uris_length1, &self->priv->_mount_uris_size_, _tmp5_);
#line 24 "../src/camera/DiscoveredCamera.vala"
	_tmp6_ = g_strdup_printf ("mtp://[%s]", port);
#line 24 "../src/camera/DiscoveredCamera.vala"
	_vala_array_add69 (&self->priv->mount_uris, &self->priv->mount_uris_length1, &self->priv->_mount_uris_size_, _tmp6_);
#line 26 "../src/camera/DiscoveredCamera.vala"
	_tmp8_ = gp_camera_new (&_tmp7_);
#line 26 "../src/camera/DiscoveredCamera.vala"
	_gp_camera_unref0 (self->gcamera);
#line 26 "../src/camera/DiscoveredCamera.vala"
	self->gcamera = _tmp7_;
#line 26 "../src/camera/DiscoveredCamera.vala"
	res = _tmp8_;
#line 28 "../src/camera/DiscoveredCamera.vala"
	if (res != GP_OK) {
#line 428 "DiscoveredCamera.c"
		const gchar* _tmp9_;
		GError* _tmp10_;
#line 29 "../src/camera/DiscoveredCamera.vala"
		_tmp9_ = gp_port_result_as_string (res);
#line 29 "../src/camera/DiscoveredCamera.vala"
		_tmp10_ = g_error_new (GPHOTO_ERROR, GPHOTO_ERROR_LIBRARY, "[%d] Unable to create camera object for %s: %s", (gint) res, name, _tmp9_);
#line 29 "../src/camera/DiscoveredCamera.vala"
		_inner_error0_ = _tmp10_;
#line 29 "../src/camera/DiscoveredCamera.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 29 "../src/camera/DiscoveredCamera.vala"
			g_propagate_error (error, _inner_error0_);
#line 29 "../src/camera/DiscoveredCamera.vala"
			_discovered_camera_unref0 (self);
#line 29 "../src/camera/DiscoveredCamera.vala"
			return NULL;
#line 445 "DiscoveredCamera.c"
		} else {
#line 29 "../src/camera/DiscoveredCamera.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 29 "../src/camera/DiscoveredCamera.vala"
			g_clear_error (&_inner_error0_);
#line 29 "../src/camera/DiscoveredCamera.vala"
			return NULL;
#line 453 "DiscoveredCamera.c"
		}
	}
#line 33 "../src/camera/DiscoveredCamera.vala"
	_tmp11_ = self->gcamera;
#line 33 "../src/camera/DiscoveredCamera.vala"
	res = gp_camera_set_abilities (_tmp11_, camera_abilities);
#line 34 "../src/camera/DiscoveredCamera.vala"
	if (res != GP_OK) {
#line 462 "DiscoveredCamera.c"
		const gchar* _tmp12_;
		GError* _tmp13_;
#line 35 "../src/camera/DiscoveredCamera.vala"
		_tmp12_ = gp_port_result_as_string (res);
#line 35 "../src/camera/DiscoveredCamera.vala"
		_tmp13_ = g_error_new (GPHOTO_ERROR, GPHOTO_ERROR_LIBRARY, "[%d] Unable to set camera abilities for %s: %s", (gint) res, name, _tmp12_);
#line 35 "../src/camera/DiscoveredCamera.vala"
		_inner_error0_ = _tmp13_;
#line 35 "../src/camera/DiscoveredCamera.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 35 "../src/camera/DiscoveredCamera.vala"
			g_propagate_error (error, _inner_error0_);
#line 35 "../src/camera/DiscoveredCamera.vala"
			_discovered_camera_unref0 (self);
#line 35 "../src/camera/DiscoveredCamera.vala"
			return NULL;
#line 479 "DiscoveredCamera.c"
		} else {
#line 35 "../src/camera/DiscoveredCamera.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 35 "../src/camera/DiscoveredCamera.vala"
			g_clear_error (&_inner_error0_);
#line 35 "../src/camera/DiscoveredCamera.vala"
			return NULL;
#line 487 "DiscoveredCamera.c"
		}
	}
#line 39 "../src/camera/DiscoveredCamera.vala"
	_tmp14_ = self->gcamera;
#line 39 "../src/camera/DiscoveredCamera.vala"
	res = gp_camera_set_port_info (_tmp14_, port_info);
#line 40 "../src/camera/DiscoveredCamera.vala"
	if (res != GP_OK) {
#line 496 "DiscoveredCamera.c"
		const gchar* _tmp15_;
		GError* _tmp16_;
#line 41 "../src/camera/DiscoveredCamera.vala"
		_tmp15_ = gp_port_result_as_string (res);
#line 41 "../src/camera/DiscoveredCamera.vala"
		_tmp16_ = g_error_new (GPHOTO_ERROR, GPHOTO_ERROR_LIBRARY, "[%d] Unable to set port infor for %s: %s", (gint) res, name, _tmp15_);
#line 41 "../src/camera/DiscoveredCamera.vala"
		_inner_error0_ = _tmp16_;
#line 41 "../src/camera/DiscoveredCamera.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 41 "../src/camera/DiscoveredCamera.vala"
			g_propagate_error (error, _inner_error0_);
#line 41 "../src/camera/DiscoveredCamera.vala"
			_discovered_camera_unref0 (self);
#line 41 "../src/camera/DiscoveredCamera.vala"
			return NULL;
#line 513 "DiscoveredCamera.c"
		} else {
#line 41 "../src/camera/DiscoveredCamera.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 41 "../src/camera/DiscoveredCamera.vala"
			g_clear_error (&_inner_error0_);
#line 41 "../src/camera/DiscoveredCamera.vala"
			return NULL;
#line 521 "DiscoveredCamera.c"
		}
	}
#line 45 "../src/camera/DiscoveredCamera.vala"
	_tmp17_ = discovered_camera_get_port_path (self, port);
#line 45 "../src/camera/DiscoveredCamera.vala"
	path = _tmp17_;
#line 46 "../src/camera/DiscoveredCamera.vala"
	_tmp18_ = path;
#line 46 "../src/camera/DiscoveredCamera.vala"
	if (_tmp18_ != NULL) {
#line 532 "DiscoveredCamera.c"
		GVolumeMonitor* monitor = NULL;
		GVolumeMonitor* _tmp19_;
		GVolumeMonitor* _tmp20_;
		GList* _tmp21_;
		GUdevClient* client = NULL;
		GUdevClient* _tmp34_;
		GUdevDevice* device = NULL;
		GUdevClient* _tmp35_;
		const gchar* _tmp36_;
		GUdevDevice* _tmp37_;
		gchar* serial = NULL;
		GUdevDevice* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		const gchar* _tmp41_;
		gchar* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		const gchar* _tmp45_;
		const gchar* _tmp49_;
#line 47 "../src/camera/DiscoveredCamera.vala"
		_tmp19_ = g_volume_monitor_get ();
#line 47 "../src/camera/DiscoveredCamera.vala"
		monitor = _tmp19_;
#line 48 "../src/camera/DiscoveredCamera.vala"
		_tmp20_ = monitor;
#line 48 "../src/camera/DiscoveredCamera.vala"
		_tmp21_ = g_volume_monitor_get_volumes (_tmp20_);
#line 561 "DiscoveredCamera.c"
		{
			GList* volume_collection = NULL;
			GList* volume_it = NULL;
#line 48 "../src/camera/DiscoveredCamera.vala"
			volume_collection = _tmp21_;
#line 48 "../src/camera/DiscoveredCamera.vala"
			for (volume_it = volume_collection; volume_it != NULL; volume_it = volume_it->next) {
#line 569 "DiscoveredCamera.c"
				GVolume* _tmp22_;
				GVolume* volume = NULL;
#line 48 "../src/camera/DiscoveredCamera.vala"
				_tmp22_ = _g_object_ref0 ((GVolume*) volume_it->data);
#line 48 "../src/camera/DiscoveredCamera.vala"
				volume = _tmp22_;
#line 576 "DiscoveredCamera.c"
				{
					GVolume* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					const gchar* _tmp26_;
					gboolean _tmp27_;
#line 49 "../src/camera/DiscoveredCamera.vala"
					_tmp23_ = volume;
#line 49 "../src/camera/DiscoveredCamera.vala"
					_tmp24_ = g_volume_get_identifier (_tmp23_, G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE);
#line 49 "../src/camera/DiscoveredCamera.vala"
					_tmp25_ = _tmp24_;
#line 49 "../src/camera/DiscoveredCamera.vala"
					_tmp26_ = path;
#line 49 "../src/camera/DiscoveredCamera.vala"
					_tmp27_ = g_strcmp0 (_tmp25_, _tmp26_) == 0;
#line 49 "../src/camera/DiscoveredCamera.vala"
					_g_free0 (_tmp25_);
#line 49 "../src/camera/DiscoveredCamera.vala"
					if (_tmp27_) {
#line 597 "DiscoveredCamera.c"
						GVolume* _tmp28_;
						gchar* _tmp29_;
						GVolume* _tmp30_;
						GIcon* _tmp31_;
						GIcon* _tmp32_;
						gchar* _tmp33_;
#line 50 "../src/camera/DiscoveredCamera.vala"
						_tmp28_ = volume;
#line 50 "../src/camera/DiscoveredCamera.vala"
						_tmp29_ = g_volume_get_name (_tmp28_);
#line 50 "../src/camera/DiscoveredCamera.vala"
						_g_free0 (self->display_name);
#line 50 "../src/camera/DiscoveredCamera.vala"
						self->display_name = _tmp29_;
#line 51 "../src/camera/DiscoveredCamera.vala"
						_tmp30_ = volume;
#line 51 "../src/camera/DiscoveredCamera.vala"
						_tmp31_ = g_volume_get_symbolic_icon (_tmp30_);
#line 51 "../src/camera/DiscoveredCamera.vala"
						_tmp32_ = _tmp31_;
#line 51 "../src/camera/DiscoveredCamera.vala"
						_tmp33_ = g_icon_to_string (_tmp32_);
#line 51 "../src/camera/DiscoveredCamera.vala"
						_g_free0 (self->icon);
#line 51 "../src/camera/DiscoveredCamera.vala"
						self->icon = _tmp33_;
#line 51 "../src/camera/DiscoveredCamera.vala"
						_g_object_unref0 (_tmp32_);
#line 626 "DiscoveredCamera.c"
					}
#line 48 "../src/camera/DiscoveredCamera.vala"
					_g_object_unref0 (volume);
#line 630 "DiscoveredCamera.c"
				}
			}
#line 48 "../src/camera/DiscoveredCamera.vala"
			(volume_collection == NULL) ? NULL : (volume_collection = (_g_list_free__g_object_unref0_ (volume_collection), NULL));
#line 635 "DiscoveredCamera.c"
		}
#line 56 "../src/camera/DiscoveredCamera.vala"
		_tmp34_ = g_udev_client_new (NULL);
#line 56 "../src/camera/DiscoveredCamera.vala"
		client = _tmp34_;
#line 57 "../src/camera/DiscoveredCamera.vala"
		_tmp35_ = client;
#line 57 "../src/camera/DiscoveredCamera.vala"
		_tmp36_ = path;
#line 57 "../src/camera/DiscoveredCamera.vala"
		_tmp37_ = g_udev_client_query_by_device_file (_tmp35_, _tmp36_);
#line 57 "../src/camera/DiscoveredCamera.vala"
		device = _tmp37_;
#line 61 "../src/camera/DiscoveredCamera.vala"
		_tmp38_ = device;
#line 61 "../src/camera/DiscoveredCamera.vala"
		_tmp39_ = g_udev_device_get_property (_tmp38_, "ID_SERIAL");
#line 61 "../src/camera/DiscoveredCamera.vala"
		_tmp40_ = g_strdup (_tmp39_);
#line 61 "../src/camera/DiscoveredCamera.vala"
		serial = _tmp40_;
#line 62 "../src/camera/DiscoveredCamera.vala"
		_tmp41_ = serial;
#line 62 "../src/camera/DiscoveredCamera.vala"
		_tmp42_ = g_strdup_printf ("gphoto2://%s", _tmp41_);
#line 62 "../src/camera/DiscoveredCamera.vala"
		_vala_array_add70 (&self->priv->mount_uris, &self->priv->mount_uris_length1, &self->priv->_mount_uris_size_, _tmp42_);
#line 63 "../src/camera/DiscoveredCamera.vala"
		_tmp43_ = serial;
#line 63 "../src/camera/DiscoveredCamera.vala"
		_tmp44_ = g_strdup_printf ("mtp://%s", _tmp43_);
#line 63 "../src/camera/DiscoveredCamera.vala"
		_vala_array_add71 (&self->priv->mount_uris, &self->priv->mount_uris_length1, &self->priv->_mount_uris_size_, _tmp44_);
#line 66 "../src/camera/DiscoveredCamera.vala"
		_tmp45_ = self->display_name;
#line 66 "../src/camera/DiscoveredCamera.vala"
		if (_tmp45_ == NULL) {
#line 673 "DiscoveredCamera.c"
			GUdevDevice* _tmp46_;
			const gchar* _tmp47_;
			gchar* _tmp48_;
#line 67 "../src/camera/DiscoveredCamera.vala"
			_tmp46_ = device;
#line 67 "../src/camera/DiscoveredCamera.vala"
			_tmp47_ = g_udev_device_get_sysfs_attr (_tmp46_, "product");
#line 67 "../src/camera/DiscoveredCamera.vala"
			_tmp48_ = g_strdup (_tmp47_);
#line 67 "../src/camera/DiscoveredCamera.vala"
			_g_free0 (self->display_name);
#line 67 "../src/camera/DiscoveredCamera.vala"
			self->display_name = _tmp48_;
#line 687 "DiscoveredCamera.c"
		}
#line 70 "../src/camera/DiscoveredCamera.vala"
		_tmp49_ = self->display_name;
#line 70 "../src/camera/DiscoveredCamera.vala"
		if (_tmp49_ == NULL) {
#line 693 "DiscoveredCamera.c"
			GUdevDevice* _tmp50_;
			const gchar* _tmp51_;
			gchar* _tmp52_;
#line 71 "../src/camera/DiscoveredCamera.vala"
			_tmp50_ = device;
#line 71 "../src/camera/DiscoveredCamera.vala"
			_tmp51_ = g_udev_device_get_property (_tmp50_, "ID_MODEL");
#line 71 "../src/camera/DiscoveredCamera.vala"
			_tmp52_ = g_strdup (_tmp51_);
#line 71 "../src/camera/DiscoveredCamera.vala"
			_g_free0 (self->display_name);
#line 71 "../src/camera/DiscoveredCamera.vala"
			self->display_name = _tmp52_;
#line 707 "DiscoveredCamera.c"
		}
#line 46 "../src/camera/DiscoveredCamera.vala"
		_g_free0 (serial);
#line 46 "../src/camera/DiscoveredCamera.vala"
		_g_object_unref0 (device);
#line 46 "../src/camera/DiscoveredCamera.vala"
		_g_object_unref0 (client);
#line 46 "../src/camera/DiscoveredCamera.vala"
		_g_object_unref0 (monitor);
#line 717 "DiscoveredCamera.c"
	}
#line 76 "../src/camera/DiscoveredCamera.vala"
	if (g_str_has_prefix (port, "disk:")) {
#line 721 "DiscoveredCamera.c"
		{
			GMount* mount = NULL;
			gchar* _tmp53_;
			gchar* _tmp54_;
			GFile* _tmp55_;
			GFile* _tmp56_;
			GMount* _tmp57_;
			GMount* _tmp58_;
			GVolume* volume = NULL;
			GMount* _tmp59_;
			GVolume* _tmp60_;
			GVolume* _tmp61_;
#line 78 "../src/camera/DiscoveredCamera.vala"
			_tmp53_ = string_substring (port, (glong) 5, (glong) -1);
#line 78 "../src/camera/DiscoveredCamera.vala"
			_tmp54_ = _tmp53_;
#line 78 "../src/camera/DiscoveredCamera.vala"
			_tmp55_ = g_file_new_for_path (_tmp54_);
#line 78 "../src/camera/DiscoveredCamera.vala"
			_tmp56_ = _tmp55_;
#line 78 "../src/camera/DiscoveredCamera.vala"
			_tmp57_ = g_file_find_enclosing_mount (_tmp56_, NULL, &_inner_error0_);
#line 78 "../src/camera/DiscoveredCamera.vala"
			_tmp58_ = _tmp57_;
#line 78 "../src/camera/DiscoveredCamera.vala"
			_g_object_unref0 (_tmp56_);
#line 78 "../src/camera/DiscoveredCamera.vala"
			_g_free0 (_tmp54_);
#line 78 "../src/camera/DiscoveredCamera.vala"
			mount = _tmp58_;
#line 78 "../src/camera/DiscoveredCamera.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 754 "DiscoveredCamera.c"
				goto __catch0_g_error;
			}
#line 79 "../src/camera/DiscoveredCamera.vala"
			_tmp59_ = mount;
#line 79 "../src/camera/DiscoveredCamera.vala"
			_tmp60_ = g_mount_get_volume (_tmp59_);
#line 79 "../src/camera/DiscoveredCamera.vala"
			volume = _tmp60_;
#line 80 "../src/camera/DiscoveredCamera.vala"
			_tmp61_ = volume;
#line 80 "../src/camera/DiscoveredCamera.vala"
			if (_tmp61_ != NULL) {
#line 767 "DiscoveredCamera.c"
				GVolume* _tmp62_;
				gchar* _tmp63_;
				gchar* _tmp64_;
				gchar* _tmp65_;
				GVolume* _tmp66_;
				GIcon* _tmp67_;
				GIcon* _tmp68_;
				gchar* _tmp69_;
#line 82 "../src/camera/DiscoveredCamera.vala"
				_tmp62_ = volume;
#line 82 "../src/camera/DiscoveredCamera.vala"
				_tmp63_ = g_volume_get_name (_tmp62_);
#line 82 "../src/camera/DiscoveredCamera.vala"
				_tmp64_ = _tmp63_;
#line 82 "../src/camera/DiscoveredCamera.vala"
				_tmp65_ = g_strdup_printf (_ ("%s (%s)"), name, _tmp64_);
#line 82 "../src/camera/DiscoveredCamera.vala"
				_g_free0 (self->display_name);
#line 82 "../src/camera/DiscoveredCamera.vala"
				self->display_name = _tmp65_;
#line 82 "../src/camera/DiscoveredCamera.vala"
				_g_free0 (_tmp64_);
#line 83 "../src/camera/DiscoveredCamera.vala"
				_tmp66_ = volume;
#line 83 "../src/camera/DiscoveredCamera.vala"
				_tmp67_ = g_volume_get_symbolic_icon (_tmp66_);
#line 83 "../src/camera/DiscoveredCamera.vala"
				_tmp68_ = _tmp67_;
#line 83 "../src/camera/DiscoveredCamera.vala"
				_tmp69_ = g_icon_to_string (_tmp68_);
#line 83 "../src/camera/DiscoveredCamera.vala"
				_g_free0 (self->icon);
#line 83 "../src/camera/DiscoveredCamera.vala"
				self->icon = _tmp69_;
#line 83 "../src/camera/DiscoveredCamera.vala"
				_g_object_unref0 (_tmp68_);
#line 804 "DiscoveredCamera.c"
			} else {
				GMount* _tmp70_;
				gchar* _tmp71_;
				gchar* _tmp72_;
				gchar* _tmp73_;
				GMount* _tmp74_;
				GIcon* _tmp75_;
				GIcon* _tmp76_;
				gchar* _tmp77_;
#line 86 "../src/camera/DiscoveredCamera.vala"
				_tmp70_ = mount;
#line 86 "../src/camera/DiscoveredCamera.vala"
				_tmp71_ = g_mount_get_name (_tmp70_);
#line 86 "../src/camera/DiscoveredCamera.vala"
				_tmp72_ = _tmp71_;
#line 86 "../src/camera/DiscoveredCamera.vala"
				_tmp73_ = g_strdup_printf (_ ("%s (%s)"), name, _tmp72_);
#line 86 "../src/camera/DiscoveredCamera.vala"
				_g_free0 (self->display_name);
#line 86 "../src/camera/DiscoveredCamera.vala"
				self->display_name = _tmp73_;
#line 86 "../src/camera/DiscoveredCamera.vala"
				_g_free0 (_tmp72_);
#line 87 "../src/camera/DiscoveredCamera.vala"
				_tmp74_ = mount;
#line 87 "../src/camera/DiscoveredCamera.vala"
				_tmp75_ = g_mount_get_symbolic_icon (_tmp74_);
#line 87 "../src/camera/DiscoveredCamera.vala"
				_tmp76_ = _tmp75_;
#line 87 "../src/camera/DiscoveredCamera.vala"
				_tmp77_ = g_icon_to_string (_tmp76_);
#line 87 "../src/camera/DiscoveredCamera.vala"
				_g_free0 (self->icon);
#line 87 "../src/camera/DiscoveredCamera.vala"
				self->icon = _tmp77_;
#line 87 "../src/camera/DiscoveredCamera.vala"
				_g_object_unref0 (_tmp76_);
#line 842 "DiscoveredCamera.c"
			}
#line 77 "../src/camera/DiscoveredCamera.vala"
			_g_object_unref0 (volume);
#line 77 "../src/camera/DiscoveredCamera.vala"
			_g_object_unref0 (mount);
#line 848 "DiscoveredCamera.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 77 "../src/camera/DiscoveredCamera.vala"
			g_clear_error (&_inner_error0_);
#line 855 "DiscoveredCamera.c"
		}
		__finally0:
#line 77 "../src/camera/DiscoveredCamera.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/camera/DiscoveredCamera.vala"
			if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 77 "../src/camera/DiscoveredCamera.vala"
				g_propagate_error (error, _inner_error0_);
#line 77 "../src/camera/DiscoveredCamera.vala"
				_g_free0 (path);
#line 77 "../src/camera/DiscoveredCamera.vala"
				_discovered_camera_unref0 (self);
#line 77 "../src/camera/DiscoveredCamera.vala"
				return NULL;
#line 870 "DiscoveredCamera.c"
			} else {
#line 77 "../src/camera/DiscoveredCamera.vala"
				_g_free0 (path);
#line 77 "../src/camera/DiscoveredCamera.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../src/camera/DiscoveredCamera.vala"
				g_clear_error (&_inner_error0_);
#line 77 "../src/camera/DiscoveredCamera.vala"
				return NULL;
#line 880 "DiscoveredCamera.c"
			}
		}
	}
#line 93 "../src/camera/DiscoveredCamera.vala"
	_tmp78_ = self->display_name;
#line 93 "../src/camera/DiscoveredCamera.vala"
	if (_tmp78_ == NULL) {
#line 888 "DiscoveredCamera.c"
		const gchar* _tmp79_;
		gchar* _tmp80_;
#line 94 "../src/camera/DiscoveredCamera.vala"
		_tmp79_ = self->priv->camera_name;
#line 94 "../src/camera/DiscoveredCamera.vala"
		_tmp80_ = g_strdup (_tmp79_);
#line 94 "../src/camera/DiscoveredCamera.vala"
		_g_free0 (self->display_name);
#line 94 "../src/camera/DiscoveredCamera.vala"
		self->display_name = _tmp80_;
#line 899 "DiscoveredCamera.c"
	}
#line 17 "../src/camera/DiscoveredCamera.vala"
	_g_free0 (path);
#line 17 "../src/camera/DiscoveredCamera.vala"
	return self;
#line 905 "DiscoveredCamera.c"
}

DiscoveredCamera*
discovered_camera_new (const gchar* name,
                       const gchar* port,
                       GPPortInfo port_info,
                       CameraAbilities camera_abilities,
                       GError** error)
{
#line 17 "../src/camera/DiscoveredCamera.vala"
	return discovered_camera_construct (TYPE_DISCOVERED_CAMERA, name, port, port_info, camera_abilities, error);
#line 917 "DiscoveredCamera.c"
}

GMount*
discovered_camera_get_mount (DiscoveredCamera* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	GError* _inner_error0_ = NULL;
	GMount* result = NULL;
#line 98 "../src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (IS_DISCOVERED_CAMERA (self), NULL);
#line 99 "../src/camera/DiscoveredCamera.vala"
	_tmp0_ = self->priv->mount_uris;
#line 99 "../src/camera/DiscoveredCamera.vala"
	_tmp0__length1 = self->priv->mount_uris_length1;
#line 933 "DiscoveredCamera.c"
	{
		gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 99 "../src/camera/DiscoveredCamera.vala"
		uri_collection = _tmp0_;
#line 99 "../src/camera/DiscoveredCamera.vala"
		uri_collection_length1 = _tmp0__length1;
#line 99 "../src/camera/DiscoveredCamera.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 945 "DiscoveredCamera.c"
			gchar* _tmp1_;
			gchar* uri = NULL;
#line 99 "../src/camera/DiscoveredCamera.vala"
			_tmp1_ = g_strdup (uri_collection[uri_it]);
#line 99 "../src/camera/DiscoveredCamera.vala"
			uri = _tmp1_;
#line 952 "DiscoveredCamera.c"
			{
				GFile* f = NULL;
				const gchar* _tmp2_;
				GFile* _tmp3_;
#line 100 "../src/camera/DiscoveredCamera.vala"
				_tmp2_ = uri;
#line 100 "../src/camera/DiscoveredCamera.vala"
				_tmp3_ = g_file_new_for_uri (_tmp2_);
#line 100 "../src/camera/DiscoveredCamera.vala"
				f = _tmp3_;
#line 963 "DiscoveredCamera.c"
				{
					GMount* mount = NULL;
					GFile* _tmp4_;
					GMount* _tmp5_;
					GMount* _tmp6_;
#line 102 "../src/camera/DiscoveredCamera.vala"
					_tmp4_ = f;
#line 102 "../src/camera/DiscoveredCamera.vala"
					_tmp5_ = g_file_find_enclosing_mount (_tmp4_, NULL, &_inner_error0_);
#line 102 "../src/camera/DiscoveredCamera.vala"
					mount = _tmp5_;
#line 102 "../src/camera/DiscoveredCamera.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 977 "DiscoveredCamera.c"
						goto __catch0_g_error;
					}
#line 103 "../src/camera/DiscoveredCamera.vala"
					_tmp6_ = mount;
#line 103 "../src/camera/DiscoveredCamera.vala"
					if (_tmp6_ != NULL) {
#line 104 "../src/camera/DiscoveredCamera.vala"
						result = mount;
#line 104 "../src/camera/DiscoveredCamera.vala"
						_g_object_unref0 (f);
#line 104 "../src/camera/DiscoveredCamera.vala"
						_g_free0 (uri);
#line 104 "../src/camera/DiscoveredCamera.vala"
						return result;
#line 992 "DiscoveredCamera.c"
					}
#line 101 "../src/camera/DiscoveredCamera.vala"
					_g_object_unref0 (mount);
#line 996 "DiscoveredCamera.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
#line 101 "../src/camera/DiscoveredCamera.vala"
					g_clear_error (&_inner_error0_);
#line 1003 "DiscoveredCamera.c"
				}
				__finally0:
#line 101 "../src/camera/DiscoveredCamera.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 101 "../src/camera/DiscoveredCamera.vala"
					_g_object_unref0 (f);
#line 101 "../src/camera/DiscoveredCamera.vala"
					_g_free0 (uri);
#line 101 "../src/camera/DiscoveredCamera.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 101 "../src/camera/DiscoveredCamera.vala"
					g_clear_error (&_inner_error0_);
#line 101 "../src/camera/DiscoveredCamera.vala"
					return NULL;
#line 1018 "DiscoveredCamera.c"
				}
#line 99 "../src/camera/DiscoveredCamera.vala"
				_g_object_unref0 (f);
#line 99 "../src/camera/DiscoveredCamera.vala"
				_g_free0 (uri);
#line 1024 "DiscoveredCamera.c"
			}
		}
	}
#line 108 "../src/camera/DiscoveredCamera.vala"
	result = NULL;
#line 108 "../src/camera/DiscoveredCamera.vala"
	return result;
#line 1032 "DiscoveredCamera.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1054 "DiscoveredCamera.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1058 "DiscoveredCamera.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1064 "DiscoveredCamera.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1068 "DiscoveredCamera.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1072 "DiscoveredCamera.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 1080 "DiscoveredCamera.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1108 "DiscoveredCamera.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 1117 "DiscoveredCamera.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1131 "DiscoveredCamera.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 1140 "DiscoveredCamera.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 1154 "DiscoveredCamera.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1163 "DiscoveredCamera.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 1172 "DiscoveredCamera.c"
}

static gchar*
discovered_camera_get_port_path (DiscoveredCamera* self,
                                 const gchar* port)
{
	gchar* _tmp0_ = NULL;
	gchar* result = NULL;
#line 111 "../src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (IS_DISCOVERED_CAMERA (self), NULL);
#line 111 "../src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (port != NULL, NULL);
#line 113 "../src/camera/DiscoveredCamera.vala"
	if (g_str_has_prefix (port, "usb:")) {
#line 1187 "DiscoveredCamera.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 114 "../src/camera/DiscoveredCamera.vala"
		_tmp1_ = string_substring (port, (glong) 4, (glong) -1);
#line 114 "../src/camera/DiscoveredCamera.vala"
		_tmp2_ = _tmp1_;
#line 114 "../src/camera/DiscoveredCamera.vala"
		_tmp3_ = string_replace (_tmp2_, ",", "/");
#line 114 "../src/camera/DiscoveredCamera.vala"
		_tmp4_ = _tmp3_;
#line 114 "../src/camera/DiscoveredCamera.vala"
		_tmp5_ = g_strdup_printf ("/dev/bus/usb/%s", _tmp4_);
#line 114 "../src/camera/DiscoveredCamera.vala"
		_g_free0 (_tmp0_);
#line 114 "../src/camera/DiscoveredCamera.vala"
		_tmp0_ = _tmp5_;
#line 114 "../src/camera/DiscoveredCamera.vala"
		_g_free0 (_tmp4_);
#line 114 "../src/camera/DiscoveredCamera.vala"
		_g_free0 (_tmp2_);
#line 1211 "DiscoveredCamera.c"
	} else {
#line 114 "../src/camera/DiscoveredCamera.vala"
		_g_free0 (_tmp0_);
#line 114 "../src/camera/DiscoveredCamera.vala"
		_tmp0_ = NULL;
#line 1217 "DiscoveredCamera.c"
	}
#line 113 "../src/camera/DiscoveredCamera.vala"
	result = _tmp0_;
#line 113 "../src/camera/DiscoveredCamera.vala"
	return result;
#line 1223 "DiscoveredCamera.c"
}

static void
value_discovered_camera_init (GValue* value)
{
#line 7 "../src/camera/DiscoveredCamera.vala"
	value->data[0].v_pointer = NULL;
#line 1231 "DiscoveredCamera.c"
}

static void
value_discovered_camera_free_value (GValue* value)
{
#line 7 "../src/camera/DiscoveredCamera.vala"
	if (value->data[0].v_pointer) {
#line 7 "../src/camera/DiscoveredCamera.vala"
		discovered_camera_unref (value->data[0].v_pointer);
#line 1241 "DiscoveredCamera.c"
	}
}

static void
value_discovered_camera_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 7 "../src/camera/DiscoveredCamera.vala"
	if (src_value->data[0].v_pointer) {
#line 7 "../src/camera/DiscoveredCamera.vala"
		dest_value->data[0].v_pointer = discovered_camera_ref (src_value->data[0].v_pointer);
#line 1253 "DiscoveredCamera.c"
	} else {
#line 7 "../src/camera/DiscoveredCamera.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1257 "DiscoveredCamera.c"
	}
}

static gpointer
value_discovered_camera_peek_pointer (const GValue* value)
{
#line 7 "../src/camera/DiscoveredCamera.vala"
	return value->data[0].v_pointer;
#line 1266 "DiscoveredCamera.c"
}

static gchar*
value_discovered_camera_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 7 "../src/camera/DiscoveredCamera.vala"
	if (collect_values[0].v_pointer) {
#line 1277 "DiscoveredCamera.c"
		DiscoveredCamera * object;
		object = collect_values[0].v_pointer;
#line 7 "../src/camera/DiscoveredCamera.vala"
		if (object->parent_instance.g_class == NULL) {
#line 7 "../src/camera/DiscoveredCamera.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1284 "DiscoveredCamera.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 7 "../src/camera/DiscoveredCamera.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1288 "DiscoveredCamera.c"
		}
#line 7 "../src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = discovered_camera_ref (object);
#line 1292 "DiscoveredCamera.c"
	} else {
#line 7 "../src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = NULL;
#line 1296 "DiscoveredCamera.c"
	}
#line 7 "../src/camera/DiscoveredCamera.vala"
	return NULL;
#line 1300 "DiscoveredCamera.c"
}

static gchar*
value_discovered_camera_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	DiscoveredCamera ** object_p;
	object_p = collect_values[0].v_pointer;
#line 7 "../src/camera/DiscoveredCamera.vala"
	if (!object_p) {
#line 7 "../src/camera/DiscoveredCamera.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1315 "DiscoveredCamera.c"
	}
#line 7 "../src/camera/DiscoveredCamera.vala"
	if (!value->data[0].v_pointer) {
#line 7 "../src/camera/DiscoveredCamera.vala"
		*object_p = NULL;
#line 1321 "DiscoveredCamera.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 7 "../src/camera/DiscoveredCamera.vala"
		*object_p = value->data[0].v_pointer;
#line 1325 "DiscoveredCamera.c"
	} else {
#line 7 "../src/camera/DiscoveredCamera.vala"
		*object_p = discovered_camera_ref (value->data[0].v_pointer);
#line 1329 "DiscoveredCamera.c"
	}
#line 7 "../src/camera/DiscoveredCamera.vala"
	return NULL;
#line 1333 "DiscoveredCamera.c"
}

GParamSpec*
param_spec_discovered_camera (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	ParamSpecDiscoveredCamera* spec;
#line 7 "../src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DISCOVERED_CAMERA), NULL);
#line 7 "../src/camera/DiscoveredCamera.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 7 "../src/camera/DiscoveredCamera.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 7 "../src/camera/DiscoveredCamera.vala"
	return G_PARAM_SPEC (spec);
#line 1352 "DiscoveredCamera.c"
}

gpointer
value_get_discovered_camera (const GValue* value)
{
#line 7 "../src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DISCOVERED_CAMERA), NULL);
#line 7 "../src/camera/DiscoveredCamera.vala"
	return value->data[0].v_pointer;
#line 1362 "DiscoveredCamera.c"
}

void
value_set_discovered_camera (GValue* value,
                             gpointer v_object)
{
	DiscoveredCamera * old;
#line 7 "../src/camera/DiscoveredCamera.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DISCOVERED_CAMERA));
#line 7 "../src/camera/DiscoveredCamera.vala"
	old = value->data[0].v_pointer;
#line 7 "../src/camera/DiscoveredCamera.vala"
	if (v_object) {
#line 7 "../src/camera/DiscoveredCamera.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DISCOVERED_CAMERA));
#line 7 "../src/camera/DiscoveredCamera.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 7 "../src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = v_object;
#line 7 "../src/camera/DiscoveredCamera.vala"
		discovered_camera_ref (value->data[0].v_pointer);
#line 1384 "DiscoveredCamera.c"
	} else {
#line 7 "../src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = NULL;
#line 1388 "DiscoveredCamera.c"
	}
#line 7 "../src/camera/DiscoveredCamera.vala"
	if (old) {
#line 7 "../src/camera/DiscoveredCamera.vala"
		discovered_camera_unref (old);
#line 1394 "DiscoveredCamera.c"
	}
}

void
value_take_discovered_camera (GValue* value,
                              gpointer v_object)
{
	DiscoveredCamera * old;
#line 7 "../src/camera/DiscoveredCamera.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DISCOVERED_CAMERA));
#line 7 "../src/camera/DiscoveredCamera.vala"
	old = value->data[0].v_pointer;
#line 7 "../src/camera/DiscoveredCamera.vala"
	if (v_object) {
#line 7 "../src/camera/DiscoveredCamera.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DISCOVERED_CAMERA));
#line 7 "../src/camera/DiscoveredCamera.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 7 "../src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = v_object;
#line 1415 "DiscoveredCamera.c"
	} else {
#line 7 "../src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = NULL;
#line 1419 "DiscoveredCamera.c"
	}
#line 7 "../src/camera/DiscoveredCamera.vala"
	if (old) {
#line 7 "../src/camera/DiscoveredCamera.vala"
		discovered_camera_unref (old);
#line 1425 "DiscoveredCamera.c"
	}
}

static void
discovered_camera_class_init (DiscoveredCameraClass * klass,
                              gpointer klass_data)
{
#line 7 "../src/camera/DiscoveredCamera.vala"
	discovered_camera_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/camera/DiscoveredCamera.vala"
	((DiscoveredCameraClass *) klass)->finalize = discovered_camera_finalize;
#line 7 "../src/camera/DiscoveredCamera.vala"
	g_type_class_adjust_private_offset (klass, &DiscoveredCamera_private_offset);
#line 1439 "DiscoveredCamera.c"
}

static void
discovered_camera_instance_init (DiscoveredCamera * self,
                                 gpointer klass)
{
#line 7 "../src/camera/DiscoveredCamera.vala"
	self->priv = discovered_camera_get_instance_private (self);
#line 7 "../src/camera/DiscoveredCamera.vala"
	self->ref_count = 1;
#line 1450 "DiscoveredCamera.c"
}

static void
discovered_camera_finalize (DiscoveredCamera * obj)
{
	DiscoveredCamera * self;
#line 7 "../src/camera/DiscoveredCamera.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DISCOVERED_CAMERA, DiscoveredCamera);
#line 7 "../src/camera/DiscoveredCamera.vala"
	g_signal_handlers_destroy (self);
#line 8 "../src/camera/DiscoveredCamera.vala"
	_gp_camera_unref0 (self->gcamera);
#line 9 "../src/camera/DiscoveredCamera.vala"
	_g_free0 (self->uri);
#line 10 "../src/camera/DiscoveredCamera.vala"
	_g_free0 (self->display_name);
#line 11 "../src/camera/DiscoveredCamera.vala"
	_g_free0 (self->icon);
#line 13 "../src/camera/DiscoveredCamera.vala"
	_g_free0 (self->priv->port);
#line 14 "../src/camera/DiscoveredCamera.vala"
	_g_free0 (self->priv->camera_name);
#line 15 "../src/camera/DiscoveredCamera.vala"
	self->priv->mount_uris = (_vala_array_free (self->priv->mount_uris, self->priv->mount_uris_length1, (GDestroyNotify) g_free), NULL);
#line 1475 "DiscoveredCamera.c"
}

static GType
discovered_camera_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_discovered_camera_init, value_discovered_camera_free_value, value_discovered_camera_copy_value, value_discovered_camera_peek_pointer, "p", value_discovered_camera_collect_value, "p", value_discovered_camera_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (DiscoveredCameraClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) discovered_camera_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiscoveredCamera), 0, (GInstanceInitFunc) discovered_camera_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType discovered_camera_type_id;
	discovered_camera_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DiscoveredCamera", &g_define_type_info, &g_define_type_fundamental_info, 0);
	DiscoveredCamera_private_offset = g_type_add_instance_private (discovered_camera_type_id, sizeof (DiscoveredCameraPrivate));
	return discovered_camera_type_id;
}

GType
discovered_camera_get_type (void)
{
	static volatile gsize discovered_camera_type_id__volatile = 0;
	if (g_once_init_enter (&discovered_camera_type_id__volatile)) {
		GType discovered_camera_type_id;
		discovered_camera_type_id = discovered_camera_get_type_once ();
		g_once_init_leave (&discovered_camera_type_id__volatile, discovered_camera_type_id);
	}
	return discovered_camera_type_id__volatile;
}

gpointer
discovered_camera_ref (gpointer instance)
{
	DiscoveredCamera * self;
	self = instance;
#line 7 "../src/camera/DiscoveredCamera.vala"
	g_atomic_int_inc (&self->ref_count);
#line 7 "../src/camera/DiscoveredCamera.vala"
	return instance;
#line 1511 "DiscoveredCamera.c"
}

void
discovered_camera_unref (gpointer instance)
{
	DiscoveredCamera * self;
	self = instance;
#line 7 "../src/camera/DiscoveredCamera.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 7 "../src/camera/DiscoveredCamera.vala"
		DISCOVERED_CAMERA_GET_CLASS (self)->finalize (self);
#line 7 "../src/camera/DiscoveredCamera.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1525 "DiscoveredCamera.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

