/* Alteration.c generated by valac 0.52.10, the Vala compiler
 * generated from Alteration.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/**/
/* Alteration represents a description of what has changed in the DataObject (reported via the*/
/* "altered" signal).  Since the descriptions can vary wildly depending on the semantics of each*/
/* DataObject, no assumptions or requirements are placed on Alteration other than it must have*/
/* one or more "subjects", each with a "detail".  Subscribers to the "altered" signal can query*/
/* the Alteration object to determine if the change is important to them.*/
/**/
/* Alteration is an immutable type.  This means it's possible to store const Alterations of oft-used*/
/* values for reuse.*/
/**/
/* Alterations may be compressed, merging their subjects and details into a new aggregated*/
/* Alteration.  Generally this is handled automatically by DataObject and DataCollection, when*/
/* necessary.*/
/**/
/* NOTE: subjects and details should be ASCII labels (as in, plain-old ASCII, no code pages).*/
/* They are treated as case-sensitive strings.*/
/**/
/* Recommended subjects include: image, thumbnail, metadata.*/
/**/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;
typedef struct _AlterationPrivate AlterationPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecAlteration ParamSpecAlteration;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Alteration {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AlterationPrivate * priv;
};

struct _AlterationClass {
	GTypeClass parent_class;
	void (*finalize) (Alteration *self);
};

struct _AlterationPrivate {
	gchar* subject;
	gchar* detail;
	GeeMultiMap* map;
};

struct _ParamSpecAlteration {
	GParamSpec parent_instance;
};

static gint Alteration_private_offset;
static gpointer alteration_parent_class = NULL;

gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Alteration, alteration_unref)
Alteration* alteration_new (const gchar* subject,
                            const gchar* detail);
Alteration* alteration_construct (GType object_type,
                                  const gchar* subject,
                                  const gchar* detail);
static void alteration_add_detail (Alteration* self,
                            const gchar* sub,
                            const gchar* det);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type,
                                            const gchar* list);
Alteration* alteration_new_from_array (gchar** array,
                                       gint array_length1);
Alteration* alteration_construct_from_array (GType object_type,
                                             gchar** array,
                                             gint array_length1);
static Alteration* alteration_new_from_map (GeeMultiMap* map);
static Alteration* alteration_construct_from_map (GType object_type,
                                           GeeMultiMap* map);
static GeeMultiMap* alteration_create_map (Alteration* self);
static guint alteration_case_hash (const gchar* a);
static guint _alteration_case_hash_gee_hash_data_func (gconstpointer v,
                                                gpointer self);
static gboolean alteration_case_equal (const gchar* a,
                                const gchar* b);
static gboolean _alteration_case_equal_gee_equal_data_func (gconstpointer a,
                                                     gconstpointer b,
                                                     gpointer self);
static inline gboolean alteration_equal_values (const gchar* str1,
                                  const gchar* str2);
static inline guint alteration_hash_value (const gchar* str);
gboolean alteration_has_subject (Alteration* self,
                                 const gchar* subject);
gboolean alteration_has_detail (Alteration* self,
                                const gchar* subject,
                                const gchar* detail);
GeeCollection* alteration_get_details (Alteration* self,
                                       const gchar* subject);
gchar* alteration_to_string (Alteration* self);
gboolean alteration_contains_any (Alteration* self,
                                  Alteration* other);
gboolean alteration_equals (Alteration* self,
                            Alteration* other);
static void alteration_multimap_add_all (GeeMultiMap* dest,
                                  GeeMultiMap* src);
Alteration* alteration_compress (Alteration* self,
                                 Alteration* other);
static void alteration_finalize (Alteration * obj);
static GType alteration_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
alteration_get_instance_private (Alteration* self)
{
	return G_STRUCT_MEMBER_P (self, Alteration_private_offset);
}

Alteration*
alteration_construct (GType object_type,
                      const gchar* subject,
                      const gchar* detail)
{
	Alteration* self = NULL;
#line 32 "../src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, NULL);
#line 32 "../src/core/Alteration.vala"
	g_return_val_if_fail (detail != NULL, NULL);
#line 32 "../src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 33 "../src/core/Alteration.vala"
	alteration_add_detail (self, subject, detail);
#line 32 "../src/core/Alteration.vala"
	return self;
#line 174 "Alteration.c"
}

Alteration*
alteration_new (const gchar* subject,
                const gchar* detail)
{
#line 32 "../src/core/Alteration.vala"
	return alteration_construct (TYPE_ALTERATION, subject, detail);
#line 183 "Alteration.c"
}

Alteration*
alteration_construct_from_list (GType object_type,
                                const gchar* list)
{
	Alteration* self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar** pairs = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint pairs_length1;
	gint _pairs_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
#line 38 "../src/core/Alteration.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 38 "../src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 38 "../src/core/Alteration.vala"
	_tmp0_ = strlen (list);
#line 38 "../src/core/Alteration.vala"
	_tmp1_ = _tmp0_;
#line 38 "../src/core/Alteration.vala"
	_vala_return_val_if_fail (_tmp1_ > 0, "list.length > 0", NULL);
#line 39 "../src/core/Alteration.vala"
	_tmp3_ = _tmp2_ = g_strsplit (list, ",", 0);
#line 39 "../src/core/Alteration.vala"
	pairs = _tmp3_;
#line 39 "../src/core/Alteration.vala"
	pairs_length1 = _vala_array_length (_tmp2_);
#line 39 "../src/core/Alteration.vala"
	_pairs_size_ = pairs_length1;
#line 40 "../src/core/Alteration.vala"
	_tmp4_ = pairs;
#line 40 "../src/core/Alteration.vala"
	_tmp4__length1 = pairs_length1;
#line 40 "../src/core/Alteration.vala"
	_vala_assert (_tmp4__length1 >= 1, "pairs.length >= 1");
#line 42 "../src/core/Alteration.vala"
	_tmp5_ = pairs;
#line 42 "../src/core/Alteration.vala"
	_tmp5__length1 = pairs_length1;
#line 230 "Alteration.c"
	{
		gchar** pair_collection = NULL;
		gint pair_collection_length1 = 0;
		gint _pair_collection_size_ = 0;
		gint pair_it = 0;
#line 42 "../src/core/Alteration.vala"
		pair_collection = _tmp5_;
#line 42 "../src/core/Alteration.vala"
		pair_collection_length1 = _tmp5__length1;
#line 42 "../src/core/Alteration.vala"
		for (pair_it = 0; pair_it < pair_collection_length1; pair_it = pair_it + 1) {
#line 242 "Alteration.c"
			gchar* _tmp6_;
			gchar* pair = NULL;
#line 42 "../src/core/Alteration.vala"
			_tmp6_ = g_strdup (pair_collection[pair_it]);
#line 42 "../src/core/Alteration.vala"
			pair = _tmp6_;
#line 249 "Alteration.c"
			{
				gchar** subject_detail = NULL;
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gchar** _tmp9_;
				gint subject_detail_length1;
				gint _subject_detail_size_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				gchar** _tmp11_;
				gint _tmp11__length1;
				const gchar* _tmp12_;
				gchar** _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp14_;
#line 43 "../src/core/Alteration.vala"
				_tmp7_ = pair;
#line 43 "../src/core/Alteration.vala"
				_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, ":", 2);
#line 43 "../src/core/Alteration.vala"
				subject_detail = _tmp9_;
#line 43 "../src/core/Alteration.vala"
				subject_detail_length1 = _vala_array_length (_tmp8_);
#line 43 "../src/core/Alteration.vala"
				_subject_detail_size_ = subject_detail_length1;
#line 44 "../src/core/Alteration.vala"
				_tmp10_ = subject_detail;
#line 44 "../src/core/Alteration.vala"
				_tmp10__length1 = subject_detail_length1;
#line 44 "../src/core/Alteration.vala"
				_vala_assert (_tmp10__length1 == 2, "subject_detail.length == 2");
#line 46 "../src/core/Alteration.vala"
				_tmp11_ = subject_detail;
#line 46 "../src/core/Alteration.vala"
				_tmp11__length1 = subject_detail_length1;
#line 46 "../src/core/Alteration.vala"
				_tmp12_ = _tmp11_[0];
#line 46 "../src/core/Alteration.vala"
				_tmp13_ = subject_detail;
#line 46 "../src/core/Alteration.vala"
				_tmp13__length1 = subject_detail_length1;
#line 46 "../src/core/Alteration.vala"
				_tmp14_ = _tmp13_[1];
#line 46 "../src/core/Alteration.vala"
				alteration_add_detail (self, _tmp12_, _tmp14_);
#line 42 "../src/core/Alteration.vala"
				subject_detail = (_vala_array_free (subject_detail, subject_detail_length1, (GDestroyNotify) g_free), NULL);
#line 42 "../src/core/Alteration.vala"
				_g_free0 (pair);
#line 299 "Alteration.c"
			}
		}
	}
#line 38 "../src/core/Alteration.vala"
	pairs = (_vala_array_free (pairs, pairs_length1, (GDestroyNotify) g_free), NULL);
#line 38 "../src/core/Alteration.vala"
	return self;
#line 307 "Alteration.c"
}

Alteration*
alteration_new_from_list (const gchar* list)
{
#line 38 "../src/core/Alteration.vala"
	return alteration_construct_from_list (TYPE_ALTERATION, list);
#line 315 "Alteration.c"
}

Alteration*
alteration_construct_from_array (GType object_type,
                                 gchar** array,
                                 gint array_length1)
{
	Alteration* self = NULL;
#line 52 "../src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 52 "../src/core/Alteration.vala"
	_vala_return_val_if_fail (array_length1 > 0, "array.length > 0", NULL);
#line 328 "Alteration.c"
	{
		gchar** pair_collection = NULL;
		gint pair_collection_length1 = 0;
		gint _pair_collection_size_ = 0;
		gint pair_it = 0;
#line 53 "../src/core/Alteration.vala"
		pair_collection = array;
#line 53 "../src/core/Alteration.vala"
		pair_collection_length1 = array_length1;
#line 53 "../src/core/Alteration.vala"
		for (pair_it = 0; pair_it < pair_collection_length1; pair_it = pair_it + 1) {
#line 340 "Alteration.c"
			gchar* _tmp0_;
			gchar* pair = NULL;
#line 53 "../src/core/Alteration.vala"
			_tmp0_ = g_strdup (pair_collection[pair_it]);
#line 53 "../src/core/Alteration.vala"
			pair = _tmp0_;
#line 347 "Alteration.c"
			{
				gchar** subject_detail = NULL;
				const gchar* _tmp1_;
				gchar** _tmp2_;
				gchar** _tmp3_;
				gint subject_detail_length1;
				gint _subject_detail_size_;
				gchar** _tmp4_;
				gint _tmp4__length1;
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp6_;
				gchar** _tmp7_;
				gint _tmp7__length1;
				const gchar* _tmp8_;
#line 54 "../src/core/Alteration.vala"
				_tmp1_ = pair;
#line 54 "../src/core/Alteration.vala"
				_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, ":", 2);
#line 54 "../src/core/Alteration.vala"
				subject_detail = _tmp3_;
#line 54 "../src/core/Alteration.vala"
				subject_detail_length1 = _vala_array_length (_tmp2_);
#line 54 "../src/core/Alteration.vala"
				_subject_detail_size_ = subject_detail_length1;
#line 55 "../src/core/Alteration.vala"
				_tmp4_ = subject_detail;
#line 55 "../src/core/Alteration.vala"
				_tmp4__length1 = subject_detail_length1;
#line 55 "../src/core/Alteration.vala"
				_vala_assert (_tmp4__length1 == 2, "subject_detail.length == 2");
#line 57 "../src/core/Alteration.vala"
				_tmp5_ = subject_detail;
#line 57 "../src/core/Alteration.vala"
				_tmp5__length1 = subject_detail_length1;
#line 57 "../src/core/Alteration.vala"
				_tmp6_ = _tmp5_[0];
#line 57 "../src/core/Alteration.vala"
				_tmp7_ = subject_detail;
#line 57 "../src/core/Alteration.vala"
				_tmp7__length1 = subject_detail_length1;
#line 57 "../src/core/Alteration.vala"
				_tmp8_ = _tmp7_[1];
#line 57 "../src/core/Alteration.vala"
				alteration_add_detail (self, _tmp6_, _tmp8_);
#line 53 "../src/core/Alteration.vala"
				subject_detail = (_vala_array_free (subject_detail, subject_detail_length1, (GDestroyNotify) g_free), NULL);
#line 53 "../src/core/Alteration.vala"
				_g_free0 (pair);
#line 397 "Alteration.c"
			}
		}
	}
#line 52 "../src/core/Alteration.vala"
	return self;
#line 403 "Alteration.c"
}

Alteration*
alteration_new_from_array (gchar** array,
                           gint array_length1)
{
#line 52 "../src/core/Alteration.vala"
	return alteration_construct_from_array (TYPE_ALTERATION, array, array_length1);
#line 412 "Alteration.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 63 "../src/core/Alteration.vala"
	return self ? g_object_ref (self) : NULL;
#line 420 "Alteration.c"
}

static Alteration*
alteration_construct_from_map (GType object_type,
                               GeeMultiMap* map)
{
	Alteration* self = NULL;
	GeeMultiMap* _tmp0_;
#line 62 "../src/core/Alteration.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MULTI_MAP), NULL);
#line 62 "../src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 63 "../src/core/Alteration.vala"
	_tmp0_ = _g_object_ref0 (map);
#line 63 "../src/core/Alteration.vala"
	_g_object_unref0 (self->priv->map);
#line 63 "../src/core/Alteration.vala"
	self->priv->map = _tmp0_;
#line 62 "../src/core/Alteration.vala"
	return self;
#line 441 "Alteration.c"
}

static Alteration*
alteration_new_from_map (GeeMultiMap* map)
{
#line 62 "../src/core/Alteration.vala"
	return alteration_construct_from_map (TYPE_ALTERATION, map);
#line 449 "Alteration.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 470 "Alteration.c"
}

static void
alteration_add_detail (Alteration* self,
                       const gchar* sub,
                       const gchar* det)
{
	gchar* subject = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* detail = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	GeeMultiMap* _tmp16_;
	const gchar* _tmp18_;
	GeeMultiMap* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
#line 66 "../src/core/Alteration.vala"
	g_return_if_fail (IS_ALTERATION (self));
#line 66 "../src/core/Alteration.vala"
	g_return_if_fail (sub != NULL);
#line 66 "../src/core/Alteration.vala"
	g_return_if_fail (det != NULL);
#line 68 "../src/core/Alteration.vala"
	_tmp0_ = string_strip (sub);
#line 68 "../src/core/Alteration.vala"
	subject = _tmp0_;
#line 69 "../src/core/Alteration.vala"
	_tmp1_ = subject;
#line 69 "../src/core/Alteration.vala"
	_tmp2_ = strlen (_tmp1_);
#line 69 "../src/core/Alteration.vala"
	_tmp3_ = _tmp2_;
#line 69 "../src/core/Alteration.vala"
	_vala_assert (_tmp3_ > 0, "subject.length > 0");
#line 71 "../src/core/Alteration.vala"
	_tmp4_ = string_strip (det);
#line 71 "../src/core/Alteration.vala"
	detail = _tmp4_;
#line 72 "../src/core/Alteration.vala"
	_tmp5_ = detail;
#line 72 "../src/core/Alteration.vala"
	_tmp6_ = strlen (_tmp5_);
#line 72 "../src/core/Alteration.vala"
	_tmp7_ = _tmp6_;
#line 72 "../src/core/Alteration.vala"
	_vala_assert (_tmp7_ > 0, "detail.length > 0");
#line 75 "../src/core/Alteration.vala"
	_tmp9_ = self->priv->subject;
#line 75 "../src/core/Alteration.vala"
	if (_tmp9_ == NULL) {
#line 529 "Alteration.c"
		GeeMultiMap* _tmp10_;
#line 75 "../src/core/Alteration.vala"
		_tmp10_ = self->priv->map;
#line 75 "../src/core/Alteration.vala"
		_tmp8_ = _tmp10_ == NULL;
#line 535 "Alteration.c"
	} else {
#line 75 "../src/core/Alteration.vala"
		_tmp8_ = FALSE;
#line 539 "Alteration.c"
	}
#line 75 "../src/core/Alteration.vala"
	if (_tmp8_) {
#line 543 "Alteration.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 76 "../src/core/Alteration.vala"
		_tmp11_ = self->priv->detail;
#line 76 "../src/core/Alteration.vala"
		_vala_assert (_tmp11_ == NULL, "this.detail == null");
#line 78 "../src/core/Alteration.vala"
		_tmp12_ = subject;
#line 78 "../src/core/Alteration.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 78 "../src/core/Alteration.vala"
		_g_free0 (self->priv->subject);
#line 78 "../src/core/Alteration.vala"
		self->priv->subject = _tmp13_;
#line 79 "../src/core/Alteration.vala"
		_tmp14_ = detail;
#line 79 "../src/core/Alteration.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 79 "../src/core/Alteration.vala"
		_g_free0 (self->priv->detail);
#line 79 "../src/core/Alteration.vala"
		self->priv->detail = _tmp15_;
#line 81 "../src/core/Alteration.vala"
		_g_free0 (detail);
#line 81 "../src/core/Alteration.vala"
		_g_free0 (subject);
#line 81 "../src/core/Alteration.vala"
		return;
#line 575 "Alteration.c"
	}
#line 85 "../src/core/Alteration.vala"
	_tmp16_ = self->priv->map;
#line 85 "../src/core/Alteration.vala"
	if (_tmp16_ == NULL) {
#line 581 "Alteration.c"
		GeeMultiMap* _tmp17_;
#line 86 "../src/core/Alteration.vala"
		_tmp17_ = alteration_create_map (self);
#line 86 "../src/core/Alteration.vala"
		_g_object_unref0 (self->priv->map);
#line 86 "../src/core/Alteration.vala"
		self->priv->map = _tmp17_;
#line 589 "Alteration.c"
	}
#line 89 "../src/core/Alteration.vala"
	_tmp18_ = self->priv->subject;
#line 89 "../src/core/Alteration.vala"
	if (_tmp18_ != NULL) {
#line 595 "Alteration.c"
		const gchar* _tmp19_;
		GeeMultiMap* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
#line 90 "../src/core/Alteration.vala"
		_tmp19_ = self->priv->detail;
#line 90 "../src/core/Alteration.vala"
		_vala_assert (_tmp19_ != NULL, "this.detail != null");
#line 92 "../src/core/Alteration.vala"
		_tmp20_ = self->priv->map;
#line 92 "../src/core/Alteration.vala"
		_tmp21_ = self->priv->subject;
#line 92 "../src/core/Alteration.vala"
		_tmp22_ = self->priv->detail;
#line 92 "../src/core/Alteration.vala"
		gee_multi_map_set (_tmp20_, _tmp21_, _tmp22_);
#line 93 "../src/core/Alteration.vala"
		_g_free0 (self->priv->subject);
#line 93 "../src/core/Alteration.vala"
		self->priv->subject = NULL;
#line 94 "../src/core/Alteration.vala"
		_g_free0 (self->priv->detail);
#line 94 "../src/core/Alteration.vala"
		self->priv->detail = NULL;
#line 620 "Alteration.c"
	}
#line 98 "../src/core/Alteration.vala"
	_tmp23_ = self->priv->map;
#line 98 "../src/core/Alteration.vala"
	_tmp24_ = subject;
#line 98 "../src/core/Alteration.vala"
	_tmp25_ = detail;
#line 98 "../src/core/Alteration.vala"
	gee_multi_map_set (_tmp23_, _tmp24_, _tmp25_);
#line 66 "../src/core/Alteration.vala"
	_g_free0 (detail);
#line 66 "../src/core/Alteration.vala"
	_g_free0 (subject);
#line 634 "Alteration.c"
}

static guint
_alteration_case_hash_gee_hash_data_func (gconstpointer v,
                                          gpointer self)
{
	guint result;
	result = alteration_case_hash ((const gchar*) v);
#line 102 "../src/core/Alteration.vala"
	return result;
#line 645 "Alteration.c"
}

static gboolean
_alteration_case_equal_gee_equal_data_func (gconstpointer a,
                                            gconstpointer b,
                                            gpointer self)
{
	gboolean result;
	result = alteration_case_equal ((const gchar*) a, (const gchar*) b);
#line 102 "../src/core/Alteration.vala"
	return result;
#line 657 "Alteration.c"
}

static GeeMultiMap*
alteration_create_map (Alteration* self)
{
	GeeHashMultiMap* _tmp0_;
	GeeMultiMap* result = NULL;
#line 101 "../src/core/Alteration.vala"
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
#line 102 "../src/core/Alteration.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _alteration_case_hash_gee_hash_data_func, NULL, NULL, _alteration_case_equal_gee_equal_data_func, NULL, NULL, _alteration_case_hash_gee_hash_data_func, NULL, NULL, _alteration_case_equal_gee_equal_data_func, NULL, NULL);
#line 102 "../src/core/Alteration.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 102 "../src/core/Alteration.vala"
	return result;
#line 673 "Alteration.c"
}

static gboolean
alteration_case_equal (const gchar* a,
                       const gchar* b)
{
	gboolean result = FALSE;
#line 106 "../src/core/Alteration.vala"
	result = alteration_equal_values (a, b);
#line 106 "../src/core/Alteration.vala"
	return result;
#line 685 "Alteration.c"
}

static guint
alteration_case_hash (const gchar* a)
{
	guint result = 0U;
#line 110 "../src/core/Alteration.vala"
	result = alteration_hash_value (a);
#line 110 "../src/core/Alteration.vala"
	return result;
#line 696 "Alteration.c"
}

static inline gboolean
alteration_equal_values (const gchar* str1,
                         const gchar* str2)
{
	gboolean result = FALSE;
#line 113 "../src/core/Alteration.vala"
	g_return_val_if_fail (str1 != NULL, FALSE);
#line 113 "../src/core/Alteration.vala"
	g_return_val_if_fail (str2 != NULL, FALSE);
#line 114 "../src/core/Alteration.vala"
	result = g_ascii_strcasecmp (str1, str2) == 0;
#line 114 "../src/core/Alteration.vala"
	return result;
#line 712 "Alteration.c"
}

static inline guint
alteration_hash_value (const gchar* str)
{
	GHashFunc _tmp0_;
	guint result = 0U;
#line 117 "../src/core/Alteration.vala"
	g_return_val_if_fail (str != NULL, 0U);
#line 118 "../src/core/Alteration.vala"
	_tmp0_ = g_str_hash;
#line 118 "../src/core/Alteration.vala"
	result = _tmp0_ (str);
#line 118 "../src/core/Alteration.vala"
	return result;
#line 728 "Alteration.c"
}

gboolean
alteration_has_subject (Alteration* self,
                        const gchar* subject)
{
	const gchar* _tmp0_;
	GeeMultiMap* _tmp2_;
	GeeSet* keys = NULL;
	GeeMultiMap* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	gboolean result = FALSE;
#line 121 "../src/core/Alteration.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 121 "../src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, FALSE);
#line 122 "../src/core/Alteration.vala"
	_tmp0_ = self->priv->subject;
#line 122 "../src/core/Alteration.vala"
	if (_tmp0_ != NULL) {
#line 750 "Alteration.c"
		const gchar* _tmp1_;
#line 123 "../src/core/Alteration.vala"
		_tmp1_ = self->priv->subject;
#line 123 "../src/core/Alteration.vala"
		result = alteration_equal_values (_tmp1_, subject);
#line 123 "../src/core/Alteration.vala"
		return result;
#line 758 "Alteration.c"
	}
#line 125 "../src/core/Alteration.vala"
	_tmp2_ = self->priv->map;
#line 125 "../src/core/Alteration.vala"
	_vala_assert (_tmp2_ != NULL, "map != null");
#line 126 "../src/core/Alteration.vala"
	_tmp3_ = self->priv->map;
#line 126 "../src/core/Alteration.vala"
	_tmp4_ = gee_multi_map_get_keys (_tmp3_);
#line 126 "../src/core/Alteration.vala"
	keys = _tmp4_;
#line 127 "../src/core/Alteration.vala"
	_tmp5_ = keys;
#line 127 "../src/core/Alteration.vala"
	if (_tmp5_ != NULL) {
#line 774 "Alteration.c"
		{
			GeeIterator* _key_it = NULL;
			GeeSet* _tmp6_;
			GeeIterator* _tmp7_;
#line 128 "../src/core/Alteration.vala"
			_tmp6_ = keys;
#line 128 "../src/core/Alteration.vala"
			_tmp7_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ITERABLE, GeeIterable));
#line 128 "../src/core/Alteration.vala"
			_key_it = _tmp7_;
#line 128 "../src/core/Alteration.vala"
			while (TRUE) {
#line 787 "Alteration.c"
				GeeIterator* _tmp8_;
				gchar* key = NULL;
				GeeIterator* _tmp9_;
				gpointer _tmp10_;
				const gchar* _tmp11_;
#line 128 "../src/core/Alteration.vala"
				_tmp8_ = _key_it;
#line 128 "../src/core/Alteration.vala"
				if (!gee_iterator_next (_tmp8_)) {
#line 128 "../src/core/Alteration.vala"
					break;
#line 799 "Alteration.c"
				}
#line 128 "../src/core/Alteration.vala"
				_tmp9_ = _key_it;
#line 128 "../src/core/Alteration.vala"
				_tmp10_ = gee_iterator_get (_tmp9_);
#line 128 "../src/core/Alteration.vala"
				key = (gchar*) _tmp10_;
#line 129 "../src/core/Alteration.vala"
				_tmp11_ = key;
#line 129 "../src/core/Alteration.vala"
				if (alteration_equal_values (_tmp11_, subject)) {
#line 130 "../src/core/Alteration.vala"
					result = TRUE;
#line 130 "../src/core/Alteration.vala"
					_g_free0 (key);
#line 130 "../src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 130 "../src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 130 "../src/core/Alteration.vala"
					return result;
#line 821 "Alteration.c"
				}
#line 128 "../src/core/Alteration.vala"
				_g_free0 (key);
#line 825 "Alteration.c"
			}
#line 128 "../src/core/Alteration.vala"
			_g_object_unref0 (_key_it);
#line 829 "Alteration.c"
		}
	}
#line 134 "../src/core/Alteration.vala"
	result = FALSE;
#line 134 "../src/core/Alteration.vala"
	_g_object_unref0 (keys);
#line 134 "../src/core/Alteration.vala"
	return result;
#line 838 "Alteration.c"
}

gboolean
alteration_has_detail (Alteration* self,
                       const gchar* subject,
                       const gchar* detail)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GeeMultiMap* _tmp6_;
	GeeCollection* values = NULL;
	GeeMultiMap* _tmp7_;
	GeeCollection* _tmp8_;
	GeeCollection* _tmp9_;
	gboolean result = FALSE;
#line 137 "../src/core/Alteration.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 137 "../src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, FALSE);
#line 137 "../src/core/Alteration.vala"
	g_return_val_if_fail (detail != NULL, FALSE);
#line 138 "../src/core/Alteration.vala"
	_tmp1_ = self->priv->subject;
#line 138 "../src/core/Alteration.vala"
	if (_tmp1_ != NULL) {
#line 864 "Alteration.c"
		const gchar* _tmp2_;
#line 138 "../src/core/Alteration.vala"
		_tmp2_ = self->priv->detail;
#line 138 "../src/core/Alteration.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 870 "Alteration.c"
	} else {
#line 138 "../src/core/Alteration.vala"
		_tmp0_ = FALSE;
#line 874 "Alteration.c"
	}
#line 138 "../src/core/Alteration.vala"
	if (_tmp0_) {
#line 878 "Alteration.c"
		gboolean _tmp3_ = FALSE;
		const gchar* _tmp4_;
#line 139 "../src/core/Alteration.vala"
		_tmp4_ = self->priv->subject;
#line 139 "../src/core/Alteration.vala"
		if (alteration_equal_values (_tmp4_, subject)) {
#line 885 "Alteration.c"
			const gchar* _tmp5_;
#line 139 "../src/core/Alteration.vala"
			_tmp5_ = self->priv->detail;
#line 139 "../src/core/Alteration.vala"
			_tmp3_ = alteration_equal_values (_tmp5_, detail);
#line 891 "Alteration.c"
		} else {
#line 139 "../src/core/Alteration.vala"
			_tmp3_ = FALSE;
#line 895 "Alteration.c"
		}
#line 139 "../src/core/Alteration.vala"
		result = _tmp3_;
#line 139 "../src/core/Alteration.vala"
		return result;
#line 901 "Alteration.c"
	}
#line 141 "../src/core/Alteration.vala"
	_tmp6_ = self->priv->map;
#line 141 "../src/core/Alteration.vala"
	_vala_assert (_tmp6_ != NULL, "map != null");
#line 142 "../src/core/Alteration.vala"
	_tmp7_ = self->priv->map;
#line 142 "../src/core/Alteration.vala"
	_tmp8_ = gee_multi_map_get (_tmp7_, subject);
#line 142 "../src/core/Alteration.vala"
	values = _tmp8_;
#line 143 "../src/core/Alteration.vala"
	_tmp9_ = values;
#line 143 "../src/core/Alteration.vala"
	if (_tmp9_ != NULL) {
#line 917 "Alteration.c"
		{
			GeeIterator* _value_it = NULL;
			GeeCollection* _tmp10_;
			GeeIterator* _tmp11_;
#line 144 "../src/core/Alteration.vala"
			_tmp10_ = values;
#line 144 "../src/core/Alteration.vala"
			_tmp11_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ITERABLE, GeeIterable));
#line 144 "../src/core/Alteration.vala"
			_value_it = _tmp11_;
#line 144 "../src/core/Alteration.vala"
			while (TRUE) {
#line 930 "Alteration.c"
				GeeIterator* _tmp12_;
				gchar* value = NULL;
				GeeIterator* _tmp13_;
				gpointer _tmp14_;
				const gchar* _tmp15_;
#line 144 "../src/core/Alteration.vala"
				_tmp12_ = _value_it;
#line 144 "../src/core/Alteration.vala"
				if (!gee_iterator_next (_tmp12_)) {
#line 144 "../src/core/Alteration.vala"
					break;
#line 942 "Alteration.c"
				}
#line 144 "../src/core/Alteration.vala"
				_tmp13_ = _value_it;
#line 144 "../src/core/Alteration.vala"
				_tmp14_ = gee_iterator_get (_tmp13_);
#line 144 "../src/core/Alteration.vala"
				value = (gchar*) _tmp14_;
#line 145 "../src/core/Alteration.vala"
				_tmp15_ = value;
#line 145 "../src/core/Alteration.vala"
				if (alteration_equal_values (_tmp15_, detail)) {
#line 146 "../src/core/Alteration.vala"
					result = TRUE;
#line 146 "../src/core/Alteration.vala"
					_g_free0 (value);
#line 146 "../src/core/Alteration.vala"
					_g_object_unref0 (_value_it);
#line 146 "../src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 146 "../src/core/Alteration.vala"
					return result;
#line 964 "Alteration.c"
				}
#line 144 "../src/core/Alteration.vala"
				_g_free0 (value);
#line 968 "Alteration.c"
			}
#line 144 "../src/core/Alteration.vala"
			_g_object_unref0 (_value_it);
#line 972 "Alteration.c"
		}
	}
#line 150 "../src/core/Alteration.vala"
	result = FALSE;
#line 150 "../src/core/Alteration.vala"
	_g_object_unref0 (values);
#line 150 "../src/core/Alteration.vala"
	return result;
#line 981 "Alteration.c"
}

GeeCollection*
alteration_get_details (Alteration* self,
                        const gchar* subject)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	GeeCollection* _tmp8_ = NULL;
	GeeMultiMap* _tmp9_;
	GeeCollection* result = NULL;
#line 153 "../src/core/Alteration.vala"
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
#line 153 "../src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, NULL);
#line 154 "../src/core/Alteration.vala"
	_tmp2_ = self->priv->subject;
#line 154 "../src/core/Alteration.vala"
	if (_tmp2_ != NULL) {
#line 1002 "Alteration.c"
		const gchar* _tmp3_;
#line 154 "../src/core/Alteration.vala"
		_tmp3_ = self->priv->detail;
#line 154 "../src/core/Alteration.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 1008 "Alteration.c"
	} else {
#line 154 "../src/core/Alteration.vala"
		_tmp1_ = FALSE;
#line 1012 "Alteration.c"
	}
#line 154 "../src/core/Alteration.vala"
	if (_tmp1_) {
#line 1016 "Alteration.c"
		const gchar* _tmp4_;
#line 154 "../src/core/Alteration.vala"
		_tmp4_ = self->priv->subject;
#line 154 "../src/core/Alteration.vala"
		_tmp0_ = alteration_equal_values (_tmp4_, subject);
#line 1022 "Alteration.c"
	} else {
#line 154 "../src/core/Alteration.vala"
		_tmp0_ = FALSE;
#line 1026 "Alteration.c"
	}
#line 154 "../src/core/Alteration.vala"
	if (_tmp0_) {
#line 1030 "Alteration.c"
		GeeArrayList* details = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		const gchar* _tmp7_;
#line 155 "../src/core/Alteration.vala"
		_tmp5_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 155 "../src/core/Alteration.vala"
		details = _tmp5_;
#line 156 "../src/core/Alteration.vala"
		_tmp6_ = details;
#line 156 "../src/core/Alteration.vala"
		_tmp7_ = self->priv->detail;
#line 156 "../src/core/Alteration.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp7_);
#line 158 "../src/core/Alteration.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (details, GEE_TYPE_COLLECTION, GeeCollection);
#line 158 "../src/core/Alteration.vala"
		return result;
#line 1049 "Alteration.c"
	}
#line 161 "../src/core/Alteration.vala"
	_tmp9_ = self->priv->map;
#line 161 "../src/core/Alteration.vala"
	if (_tmp9_ != NULL) {
#line 1055 "Alteration.c"
		GeeMultiMap* _tmp10_;
		GeeCollection* _tmp11_;
#line 161 "../src/core/Alteration.vala"
		_tmp10_ = self->priv->map;
#line 161 "../src/core/Alteration.vala"
		_tmp11_ = gee_multi_map_get (_tmp10_, subject);
#line 161 "../src/core/Alteration.vala"
		_g_object_unref0 (_tmp8_);
#line 161 "../src/core/Alteration.vala"
		_tmp8_ = _tmp11_;
#line 1066 "Alteration.c"
	} else {
#line 161 "../src/core/Alteration.vala"
		_g_object_unref0 (_tmp8_);
#line 161 "../src/core/Alteration.vala"
		_tmp8_ = NULL;
#line 1072 "Alteration.c"
	}
#line 161 "../src/core/Alteration.vala"
	result = _tmp8_;
#line 161 "../src/core/Alteration.vala"
	return result;
#line 1078 "Alteration.c"
}

gchar*
alteration_to_string (Alteration* self)
{
	const gchar* _tmp0_;
	GeeMultiMap* _tmp5_;
	gchar* str = NULL;
	gchar* _tmp6_;
	gchar* result = NULL;
#line 164 "../src/core/Alteration.vala"
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
#line 165 "../src/core/Alteration.vala"
	_tmp0_ = self->priv->subject;
#line 165 "../src/core/Alteration.vala"
	if (_tmp0_ != NULL) {
#line 1095 "Alteration.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 166 "../src/core/Alteration.vala"
		_tmp1_ = self->priv->detail;
#line 166 "../src/core/Alteration.vala"
		_vala_assert (_tmp1_ != NULL, "detail != null");
#line 168 "../src/core/Alteration.vala"
		_tmp2_ = self->priv->subject;
#line 168 "../src/core/Alteration.vala"
		_tmp3_ = self->priv->detail;
#line 168 "../src/core/Alteration.vala"
		_tmp4_ = g_strdup_printf ("%s:%s", _tmp2_, _tmp3_);
#line 168 "../src/core/Alteration.vala"
		result = _tmp4_;
#line 168 "../src/core/Alteration.vala"
		return result;
#line 1114 "Alteration.c"
	}
#line 171 "../src/core/Alteration.vala"
	_tmp5_ = self->priv->map;
#line 171 "../src/core/Alteration.vala"
	_vala_assert (_tmp5_ != NULL, "map != null");
#line 173 "../src/core/Alteration.vala"
	_tmp6_ = g_strdup ("");
#line 173 "../src/core/Alteration.vala"
	str = _tmp6_;
#line 1124 "Alteration.c"
	{
		GeeIterator* _key_it = NULL;
		GeeMultiMap* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 174 "../src/core/Alteration.vala"
		_tmp7_ = self->priv->map;
#line 174 "../src/core/Alteration.vala"
		_tmp8_ = gee_multi_map_get_keys (_tmp7_);
#line 174 "../src/core/Alteration.vala"
		_tmp9_ = _tmp8_;
#line 174 "../src/core/Alteration.vala"
		_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 174 "../src/core/Alteration.vala"
		_tmp11_ = _tmp10_;
#line 174 "../src/core/Alteration.vala"
		_g_object_unref0 (_tmp9_);
#line 174 "../src/core/Alteration.vala"
		_key_it = _tmp11_;
#line 174 "../src/core/Alteration.vala"
		while (TRUE) {
#line 1148 "Alteration.c"
			GeeIterator* _tmp12_;
			gchar* key = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
#line 174 "../src/core/Alteration.vala"
			_tmp12_ = _key_it;
#line 174 "../src/core/Alteration.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 174 "../src/core/Alteration.vala"
				break;
#line 1159 "Alteration.c"
			}
#line 174 "../src/core/Alteration.vala"
			_tmp13_ = _key_it;
#line 174 "../src/core/Alteration.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 174 "../src/core/Alteration.vala"
			key = (gchar*) _tmp14_;
#line 1167 "Alteration.c"
			{
				GeeIterator* _value_it = NULL;
				GeeMultiMap* _tmp15_;
				const gchar* _tmp16_;
				GeeCollection* _tmp17_;
				GeeCollection* _tmp18_;
				GeeIterator* _tmp19_;
				GeeIterator* _tmp20_;
#line 175 "../src/core/Alteration.vala"
				_tmp15_ = self->priv->map;
#line 175 "../src/core/Alteration.vala"
				_tmp16_ = key;
#line 175 "../src/core/Alteration.vala"
				_tmp17_ = gee_multi_map_get (_tmp15_, _tmp16_);
#line 175 "../src/core/Alteration.vala"
				_tmp18_ = _tmp17_;
#line 175 "../src/core/Alteration.vala"
				_tmp19_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ITERABLE, GeeIterable));
#line 175 "../src/core/Alteration.vala"
				_tmp20_ = _tmp19_;
#line 175 "../src/core/Alteration.vala"
				_g_object_unref0 (_tmp18_);
#line 175 "../src/core/Alteration.vala"
				_value_it = _tmp20_;
#line 175 "../src/core/Alteration.vala"
				while (TRUE) {
#line 1194 "Alteration.c"
					GeeIterator* _tmp21_;
					gchar* value = NULL;
					GeeIterator* _tmp22_;
					gpointer _tmp23_;
					const gchar* _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
#line 175 "../src/core/Alteration.vala"
					_tmp21_ = _value_it;
#line 175 "../src/core/Alteration.vala"
					if (!gee_iterator_next (_tmp21_)) {
#line 175 "../src/core/Alteration.vala"
						break;
#line 1214 "Alteration.c"
					}
#line 175 "../src/core/Alteration.vala"
					_tmp22_ = _value_it;
#line 175 "../src/core/Alteration.vala"
					_tmp23_ = gee_iterator_get (_tmp22_);
#line 175 "../src/core/Alteration.vala"
					value = (gchar*) _tmp23_;
#line 176 "../src/core/Alteration.vala"
					_tmp24_ = str;
#line 176 "../src/core/Alteration.vala"
					_tmp25_ = strlen (_tmp24_);
#line 176 "../src/core/Alteration.vala"
					_tmp26_ = _tmp25_;
#line 176 "../src/core/Alteration.vala"
					if (_tmp26_ != 0) {
#line 1230 "Alteration.c"
						const gchar* _tmp27_;
						gchar* _tmp28_;
#line 177 "../src/core/Alteration.vala"
						_tmp27_ = str;
#line 177 "../src/core/Alteration.vala"
						_tmp28_ = g_strconcat (_tmp27_, ", ", NULL);
#line 177 "../src/core/Alteration.vala"
						_g_free0 (str);
#line 177 "../src/core/Alteration.vala"
						str = _tmp28_;
#line 1241 "Alteration.c"
					}
#line 179 "../src/core/Alteration.vala"
					_tmp29_ = str;
#line 179 "../src/core/Alteration.vala"
					_tmp30_ = key;
#line 179 "../src/core/Alteration.vala"
					_tmp31_ = value;
#line 179 "../src/core/Alteration.vala"
					_tmp32_ = g_strdup_printf ("%s:%s", _tmp30_, _tmp31_);
#line 179 "../src/core/Alteration.vala"
					_tmp33_ = _tmp32_;
#line 179 "../src/core/Alteration.vala"
					_tmp34_ = g_strconcat (_tmp29_, _tmp33_, NULL);
#line 179 "../src/core/Alteration.vala"
					_g_free0 (str);
#line 179 "../src/core/Alteration.vala"
					str = _tmp34_;
#line 179 "../src/core/Alteration.vala"
					_g_free0 (_tmp33_);
#line 175 "../src/core/Alteration.vala"
					_g_free0 (value);
#line 1263 "Alteration.c"
				}
#line 175 "../src/core/Alteration.vala"
				_g_object_unref0 (_value_it);
#line 1267 "Alteration.c"
			}
#line 174 "../src/core/Alteration.vala"
			_g_free0 (key);
#line 1271 "Alteration.c"
		}
#line 174 "../src/core/Alteration.vala"
		_g_object_unref0 (_key_it);
#line 1275 "Alteration.c"
	}
#line 183 "../src/core/Alteration.vala"
	result = str;
#line 183 "../src/core/Alteration.vala"
	return result;
#line 1281 "Alteration.c"
}

gboolean
alteration_contains_any (Alteration* self,
                         Alteration* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	GeeMultiMap* _tmp14_;
	gboolean _tmp42_ = FALSE;
	GeeMultiMap* _tmp43_;
	gboolean result = FALSE;
#line 187 "../src/core/Alteration.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 187 "../src/core/Alteration.vala"
	g_return_val_if_fail (IS_ALTERATION (other), FALSE);
#line 189 "../src/core/Alteration.vala"
	if (self == other) {
#line 190 "../src/core/Alteration.vala"
		result = TRUE;
#line 190 "../src/core/Alteration.vala"
		return result;
#line 1308 "Alteration.c"
	}
#line 193 "../src/core/Alteration.vala"
	_tmp3_ = self->priv->subject;
#line 193 "../src/core/Alteration.vala"
	if (_tmp3_ != NULL) {
#line 1314 "Alteration.c"
		const gchar* _tmp4_;
#line 193 "../src/core/Alteration.vala"
		_tmp4_ = other->priv->subject;
#line 193 "../src/core/Alteration.vala"
		_tmp2_ = _tmp4_ != NULL;
#line 1320 "Alteration.c"
	} else {
#line 193 "../src/core/Alteration.vala"
		_tmp2_ = FALSE;
#line 1324 "Alteration.c"
	}
#line 193 "../src/core/Alteration.vala"
	if (_tmp2_) {
#line 1328 "Alteration.c"
		const gchar* _tmp5_;
#line 193 "../src/core/Alteration.vala"
		_tmp5_ = self->priv->detail;
#line 193 "../src/core/Alteration.vala"
		_tmp1_ = _tmp5_ != NULL;
#line 1334 "Alteration.c"
	} else {
#line 193 "../src/core/Alteration.vala"
		_tmp1_ = FALSE;
#line 1338 "Alteration.c"
	}
#line 193 "../src/core/Alteration.vala"
	if (_tmp1_) {
#line 1342 "Alteration.c"
		const gchar* _tmp6_;
#line 193 "../src/core/Alteration.vala"
		_tmp6_ = other->priv->detail;
#line 193 "../src/core/Alteration.vala"
		_tmp0_ = _tmp6_ != NULL;
#line 1348 "Alteration.c"
	} else {
#line 193 "../src/core/Alteration.vala"
		_tmp0_ = FALSE;
#line 1352 "Alteration.c"
	}
#line 193 "../src/core/Alteration.vala"
	if (_tmp0_) {
#line 1356 "Alteration.c"
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 194 "../src/core/Alteration.vala"
		_tmp8_ = self->priv->subject;
#line 194 "../src/core/Alteration.vala"
		_tmp9_ = other->priv->subject;
#line 194 "../src/core/Alteration.vala"
		if (alteration_equal_values (_tmp8_, _tmp9_)) {
#line 1366 "Alteration.c"
			const gchar* _tmp10_;
			const gchar* _tmp11_;
#line 194 "../src/core/Alteration.vala"
			_tmp10_ = self->priv->detail;
#line 194 "../src/core/Alteration.vala"
			_tmp11_ = other->priv->detail;
#line 194 "../src/core/Alteration.vala"
			_tmp7_ = alteration_equal_values (_tmp10_, _tmp11_);
#line 1375 "Alteration.c"
		} else {
#line 194 "../src/core/Alteration.vala"
			_tmp7_ = FALSE;
#line 1379 "Alteration.c"
		}
#line 194 "../src/core/Alteration.vala"
		result = _tmp7_;
#line 194 "../src/core/Alteration.vala"
		return result;
#line 1385 "Alteration.c"
	}
#line 197 "../src/core/Alteration.vala"
	_tmp14_ = self->priv->map;
#line 197 "../src/core/Alteration.vala"
	if (_tmp14_ != NULL) {
#line 1391 "Alteration.c"
		GeeMultiMap* _tmp15_;
#line 197 "../src/core/Alteration.vala"
		_tmp15_ = other->priv->map;
#line 197 "../src/core/Alteration.vala"
		_tmp13_ = _tmp15_ == NULL;
#line 1397 "Alteration.c"
	} else {
#line 197 "../src/core/Alteration.vala"
		_tmp13_ = FALSE;
#line 1401 "Alteration.c"
	}
#line 197 "../src/core/Alteration.vala"
	if (_tmp13_) {
#line 197 "../src/core/Alteration.vala"
		_tmp12_ = TRUE;
#line 1407 "Alteration.c"
	} else {
		gboolean _tmp16_ = FALSE;
		GeeMultiMap* _tmp17_;
#line 197 "../src/core/Alteration.vala"
		_tmp17_ = self->priv->map;
#line 197 "../src/core/Alteration.vala"
		if (_tmp17_ == NULL) {
#line 1415 "Alteration.c"
			GeeMultiMap* _tmp18_;
#line 197 "../src/core/Alteration.vala"
			_tmp18_ = other->priv->map;
#line 197 "../src/core/Alteration.vala"
			_tmp16_ = _tmp18_ != NULL;
#line 1421 "Alteration.c"
		} else {
#line 197 "../src/core/Alteration.vala"
			_tmp16_ = FALSE;
#line 1425 "Alteration.c"
		}
#line 197 "../src/core/Alteration.vala"
		_tmp12_ = _tmp16_;
#line 1429 "Alteration.c"
	}
#line 197 "../src/core/Alteration.vala"
	if (_tmp12_) {
#line 1433 "Alteration.c"
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		gchar* single_subject = NULL;
		gchar* _tmp23_;
		const gchar* _tmp24_ = NULL;
		const gchar* _tmp25_;
		gchar* single_detail = NULL;
		gchar* _tmp28_;
		GeeMultiMap* _tmp29_ = NULL;
		GeeMultiMap* _tmp30_;
		GeeMultiMap* multimap = NULL;
		GeeMultiMap* _tmp33_;
		gboolean _tmp34_ = FALSE;
		GeeMultiMap* _tmp35_;
		const gchar* _tmp36_;
#line 198 "../src/core/Alteration.vala"
		_tmp20_ = self->priv->subject;
#line 198 "../src/core/Alteration.vala"
		if (_tmp20_ != NULL) {
#line 1453 "Alteration.c"
			const gchar* _tmp21_;
#line 198 "../src/core/Alteration.vala"
			_tmp21_ = self->priv->subject;
#line 198 "../src/core/Alteration.vala"
			_tmp19_ = _tmp21_;
#line 1459 "Alteration.c"
		} else {
			const gchar* _tmp22_;
#line 198 "../src/core/Alteration.vala"
			_tmp22_ = other->priv->subject;
#line 198 "../src/core/Alteration.vala"
			_tmp19_ = _tmp22_;
#line 1466 "Alteration.c"
		}
#line 198 "../src/core/Alteration.vala"
		_tmp23_ = g_strdup (_tmp19_);
#line 198 "../src/core/Alteration.vala"
		single_subject = _tmp23_;
#line 199 "../src/core/Alteration.vala"
		_tmp25_ = self->priv->detail;
#line 199 "../src/core/Alteration.vala"
		if (_tmp25_ != NULL) {
#line 1476 "Alteration.c"
			const gchar* _tmp26_;
#line 199 "../src/core/Alteration.vala"
			_tmp26_ = self->priv->detail;
#line 199 "../src/core/Alteration.vala"
			_tmp24_ = _tmp26_;
#line 1482 "Alteration.c"
		} else {
			const gchar* _tmp27_;
#line 199 "../src/core/Alteration.vala"
			_tmp27_ = other->priv->detail;
#line 199 "../src/core/Alteration.vala"
			_tmp24_ = _tmp27_;
#line 1489 "Alteration.c"
		}
#line 199 "../src/core/Alteration.vala"
		_tmp28_ = g_strdup (_tmp24_);
#line 199 "../src/core/Alteration.vala"
		single_detail = _tmp28_;
#line 200 "../src/core/Alteration.vala"
		_tmp30_ = self->priv->map;
#line 200 "../src/core/Alteration.vala"
		if (_tmp30_ != NULL) {
#line 1499 "Alteration.c"
			GeeMultiMap* _tmp31_;
#line 200 "../src/core/Alteration.vala"
			_tmp31_ = self->priv->map;
#line 200 "../src/core/Alteration.vala"
			_tmp29_ = _tmp31_;
#line 1505 "Alteration.c"
		} else {
			GeeMultiMap* _tmp32_;
#line 200 "../src/core/Alteration.vala"
			_tmp32_ = other->priv->map;
#line 200 "../src/core/Alteration.vala"
			_tmp29_ = _tmp32_;
#line 1512 "Alteration.c"
		}
#line 200 "../src/core/Alteration.vala"
		_tmp33_ = _g_object_ref0 (_tmp29_);
#line 200 "../src/core/Alteration.vala"
		multimap = _tmp33_;
#line 202 "../src/core/Alteration.vala"
		_tmp35_ = multimap;
#line 202 "../src/core/Alteration.vala"
		_tmp36_ = single_subject;
#line 202 "../src/core/Alteration.vala"
		if (gee_multi_map_contains (_tmp35_, _tmp36_)) {
#line 1524 "Alteration.c"
			GeeMultiMap* _tmp37_;
			const gchar* _tmp38_;
			GeeCollection* _tmp39_;
			GeeCollection* _tmp40_;
			const gchar* _tmp41_;
#line 202 "../src/core/Alteration.vala"
			_tmp37_ = self->priv->map;
#line 202 "../src/core/Alteration.vala"
			_tmp38_ = single_subject;
#line 202 "../src/core/Alteration.vala"
			_tmp39_ = gee_multi_map_get (_tmp37_, _tmp38_);
#line 202 "../src/core/Alteration.vala"
			_tmp40_ = _tmp39_;
#line 202 "../src/core/Alteration.vala"
			_tmp41_ = single_detail;
#line 202 "../src/core/Alteration.vala"
			_tmp34_ = gee_collection_contains (_tmp40_, _tmp41_);
#line 202 "../src/core/Alteration.vala"
			_g_object_unref0 (_tmp40_);
#line 1544 "Alteration.c"
		} else {
#line 202 "../src/core/Alteration.vala"
			_tmp34_ = FALSE;
#line 1548 "Alteration.c"
		}
#line 202 "../src/core/Alteration.vala"
		result = _tmp34_;
#line 202 "../src/core/Alteration.vala"
		_g_object_unref0 (multimap);
#line 202 "../src/core/Alteration.vala"
		_g_free0 (single_detail);
#line 202 "../src/core/Alteration.vala"
		_g_free0 (single_subject);
#line 202 "../src/core/Alteration.vala"
		return result;
#line 1560 "Alteration.c"
	}
#line 206 "../src/core/Alteration.vala"
	_tmp43_ = self->priv->map;
#line 206 "../src/core/Alteration.vala"
	if (_tmp43_ != NULL) {
#line 1566 "Alteration.c"
		GeeMultiMap* _tmp44_;
#line 206 "../src/core/Alteration.vala"
		_tmp44_ = other->priv->map;
#line 206 "../src/core/Alteration.vala"
		_tmp42_ = _tmp44_ != NULL;
#line 1572 "Alteration.c"
	} else {
#line 206 "../src/core/Alteration.vala"
		_tmp42_ = FALSE;
#line 1576 "Alteration.c"
	}
#line 206 "../src/core/Alteration.vala"
	if (_tmp42_) {
#line 1580 "Alteration.c"
		GeeSet* keys = NULL;
		GeeMultiMap* _tmp45_;
		GeeSet* _tmp46_;
		GeeSet* _tmp47_;
		GeeSet* other_keys = NULL;
		GeeMultiMap* _tmp48_;
		GeeSet* _tmp49_;
		GeeSet* _tmp50_;
#line 207 "../src/core/Alteration.vala"
		_tmp45_ = self->priv->map;
#line 207 "../src/core/Alteration.vala"
		_tmp46_ = gee_multi_map_get_keys (_tmp45_);
#line 207 "../src/core/Alteration.vala"
		keys = _tmp46_;
#line 208 "../src/core/Alteration.vala"
		_tmp47_ = keys;
#line 208 "../src/core/Alteration.vala"
		_vala_assert (_tmp47_ != NULL, "keys != null");
#line 209 "../src/core/Alteration.vala"
		_tmp48_ = other->priv->map;
#line 209 "../src/core/Alteration.vala"
		_tmp49_ = gee_multi_map_get_keys (_tmp48_);
#line 209 "../src/core/Alteration.vala"
		other_keys = _tmp49_;
#line 210 "../src/core/Alteration.vala"
		_tmp50_ = other_keys;
#line 210 "../src/core/Alteration.vala"
		_vala_assert (_tmp50_ != NULL, "other_keys != null");
#line 1609 "Alteration.c"
		{
			GeeIterator* _subject_it = NULL;
			GeeSet* _tmp51_;
			GeeIterator* _tmp52_;
#line 212 "../src/core/Alteration.vala"
			_tmp51_ = other_keys;
#line 212 "../src/core/Alteration.vala"
			_tmp52_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_ITERABLE, GeeIterable));
#line 212 "../src/core/Alteration.vala"
			_subject_it = _tmp52_;
#line 212 "../src/core/Alteration.vala"
			while (TRUE) {
#line 1622 "Alteration.c"
				GeeIterator* _tmp53_;
				gchar* subject = NULL;
				GeeIterator* _tmp54_;
				gpointer _tmp55_;
				GeeSet* _tmp56_;
				const gchar* _tmp57_;
				GeeCollection* details = NULL;
				GeeMultiMap* _tmp58_;
				const gchar* _tmp59_;
				GeeCollection* _tmp60_;
				GeeCollection* other_details = NULL;
				GeeMultiMap* _tmp61_;
				const gchar* _tmp62_;
				GeeCollection* _tmp63_;
				gboolean _tmp64_ = FALSE;
				GeeCollection* _tmp65_;
#line 212 "../src/core/Alteration.vala"
				_tmp53_ = _subject_it;
#line 212 "../src/core/Alteration.vala"
				if (!gee_iterator_next (_tmp53_)) {
#line 212 "../src/core/Alteration.vala"
					break;
#line 1645 "Alteration.c"
				}
#line 212 "../src/core/Alteration.vala"
				_tmp54_ = _subject_it;
#line 212 "../src/core/Alteration.vala"
				_tmp55_ = gee_iterator_get (_tmp54_);
#line 212 "../src/core/Alteration.vala"
				subject = (gchar*) _tmp55_;
#line 213 "../src/core/Alteration.vala"
				_tmp56_ = keys;
#line 213 "../src/core/Alteration.vala"
				_tmp57_ = subject;
#line 213 "../src/core/Alteration.vala"
				if (!gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_COLLECTION, GeeCollection), _tmp57_)) {
#line 214 "../src/core/Alteration.vala"
					_g_free0 (subject);
#line 214 "../src/core/Alteration.vala"
					continue;
#line 1663 "Alteration.c"
				}
#line 216 "../src/core/Alteration.vala"
				_tmp58_ = self->priv->map;
#line 216 "../src/core/Alteration.vala"
				_tmp59_ = subject;
#line 216 "../src/core/Alteration.vala"
				_tmp60_ = gee_multi_map_get (_tmp58_, _tmp59_);
#line 216 "../src/core/Alteration.vala"
				details = _tmp60_;
#line 217 "../src/core/Alteration.vala"
				_tmp61_ = other->priv->map;
#line 217 "../src/core/Alteration.vala"
				_tmp62_ = subject;
#line 217 "../src/core/Alteration.vala"
				_tmp63_ = gee_multi_map_get (_tmp61_, _tmp62_);
#line 217 "../src/core/Alteration.vala"
				other_details = _tmp63_;
#line 219 "../src/core/Alteration.vala"
				_tmp65_ = details;
#line 219 "../src/core/Alteration.vala"
				if (_tmp65_ != NULL) {
#line 1685 "Alteration.c"
					GeeCollection* _tmp66_;
#line 219 "../src/core/Alteration.vala"
					_tmp66_ = other_details;
#line 219 "../src/core/Alteration.vala"
					_tmp64_ = _tmp66_ != NULL;
#line 1691 "Alteration.c"
				} else {
#line 219 "../src/core/Alteration.vala"
					_tmp64_ = FALSE;
#line 1695 "Alteration.c"
				}
#line 219 "../src/core/Alteration.vala"
				if (_tmp64_) {
#line 1699 "Alteration.c"
					{
						GeeIterator* _detail_it = NULL;
						GeeCollection* _tmp67_;
						GeeIterator* _tmp68_;
#line 220 "../src/core/Alteration.vala"
						_tmp67_ = other_details;
#line 220 "../src/core/Alteration.vala"
						_tmp68_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, GEE_TYPE_ITERABLE, GeeIterable));
#line 220 "../src/core/Alteration.vala"
						_detail_it = _tmp68_;
#line 220 "../src/core/Alteration.vala"
						while (TRUE) {
#line 1712 "Alteration.c"
							GeeIterator* _tmp69_;
							gchar* detail = NULL;
							GeeIterator* _tmp70_;
							gpointer _tmp71_;
							GeeCollection* _tmp72_;
							const gchar* _tmp73_;
#line 220 "../src/core/Alteration.vala"
							_tmp69_ = _detail_it;
#line 220 "../src/core/Alteration.vala"
							if (!gee_iterator_next (_tmp69_)) {
#line 220 "../src/core/Alteration.vala"
								break;
#line 1725 "Alteration.c"
							}
#line 220 "../src/core/Alteration.vala"
							_tmp70_ = _detail_it;
#line 220 "../src/core/Alteration.vala"
							_tmp71_ = gee_iterator_get (_tmp70_);
#line 220 "../src/core/Alteration.vala"
							detail = (gchar*) _tmp71_;
#line 221 "../src/core/Alteration.vala"
							_tmp72_ = details;
#line 221 "../src/core/Alteration.vala"
							_tmp73_ = detail;
#line 221 "../src/core/Alteration.vala"
							if (gee_collection_contains (_tmp72_, _tmp73_)) {
#line 222 "../src/core/Alteration.vala"
								result = TRUE;
#line 222 "../src/core/Alteration.vala"
								_g_free0 (detail);
#line 222 "../src/core/Alteration.vala"
								_g_object_unref0 (_detail_it);
#line 222 "../src/core/Alteration.vala"
								_g_object_unref0 (other_details);
#line 222 "../src/core/Alteration.vala"
								_g_object_unref0 (details);
#line 222 "../src/core/Alteration.vala"
								_g_free0 (subject);
#line 222 "../src/core/Alteration.vala"
								_g_object_unref0 (_subject_it);
#line 222 "../src/core/Alteration.vala"
								_g_object_unref0 (other_keys);
#line 222 "../src/core/Alteration.vala"
								_g_object_unref0 (keys);
#line 222 "../src/core/Alteration.vala"
								return result;
#line 1759 "Alteration.c"
							}
#line 220 "../src/core/Alteration.vala"
							_g_free0 (detail);
#line 1763 "Alteration.c"
						}
#line 220 "../src/core/Alteration.vala"
						_g_object_unref0 (_detail_it);
#line 1767 "Alteration.c"
					}
				}
#line 212 "../src/core/Alteration.vala"
				_g_object_unref0 (other_details);
#line 212 "../src/core/Alteration.vala"
				_g_object_unref0 (details);
#line 212 "../src/core/Alteration.vala"
				_g_free0 (subject);
#line 1776 "Alteration.c"
			}
#line 212 "../src/core/Alteration.vala"
			_g_object_unref0 (_subject_it);
#line 1780 "Alteration.c"
		}
#line 206 "../src/core/Alteration.vala"
		_g_object_unref0 (other_keys);
#line 206 "../src/core/Alteration.vala"
		_g_object_unref0 (keys);
#line 1786 "Alteration.c"
	}
#line 228 "../src/core/Alteration.vala"
	result = FALSE;
#line 228 "../src/core/Alteration.vala"
	return result;
#line 1792 "Alteration.c"
}

gboolean
alteration_equals (Alteration* self,
                   Alteration* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp12_ = FALSE;
	GeeMultiMap* _tmp13_;
	gboolean result = FALSE;
#line 231 "../src/core/Alteration.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 231 "../src/core/Alteration.vala"
	g_return_val_if_fail (IS_ALTERATION (other), FALSE);
#line 233 "../src/core/Alteration.vala"
	if (self == other) {
#line 234 "../src/core/Alteration.vala"
		result = TRUE;
#line 234 "../src/core/Alteration.vala"
		return result;
#line 1816 "Alteration.c"
	}
#line 237 "../src/core/Alteration.vala"
	_tmp3_ = self->priv->subject;
#line 237 "../src/core/Alteration.vala"
	if (_tmp3_ != NULL) {
#line 1822 "Alteration.c"
		const gchar* _tmp4_;
#line 237 "../src/core/Alteration.vala"
		_tmp4_ = other->priv->subject;
#line 237 "../src/core/Alteration.vala"
		_tmp2_ = _tmp4_ != NULL;
#line 1828 "Alteration.c"
	} else {
#line 237 "../src/core/Alteration.vala"
		_tmp2_ = FALSE;
#line 1832 "Alteration.c"
	}
#line 237 "../src/core/Alteration.vala"
	if (_tmp2_) {
#line 1836 "Alteration.c"
		const gchar* _tmp5_;
#line 237 "../src/core/Alteration.vala"
		_tmp5_ = self->priv->detail;
#line 237 "../src/core/Alteration.vala"
		_tmp1_ = _tmp5_ != NULL;
#line 1842 "Alteration.c"
	} else {
#line 237 "../src/core/Alteration.vala"
		_tmp1_ = FALSE;
#line 1846 "Alteration.c"
	}
#line 237 "../src/core/Alteration.vala"
	if (_tmp1_) {
#line 1850 "Alteration.c"
		const gchar* _tmp6_;
#line 237 "../src/core/Alteration.vala"
		_tmp6_ = other->priv->detail;
#line 237 "../src/core/Alteration.vala"
		_tmp0_ = _tmp6_ != NULL;
#line 1856 "Alteration.c"
	} else {
#line 237 "../src/core/Alteration.vala"
		_tmp0_ = FALSE;
#line 1860 "Alteration.c"
	}
#line 237 "../src/core/Alteration.vala"
	if (_tmp0_) {
#line 1864 "Alteration.c"
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 238 "../src/core/Alteration.vala"
		_tmp8_ = self->priv->subject;
#line 238 "../src/core/Alteration.vala"
		_tmp9_ = other->priv->subject;
#line 238 "../src/core/Alteration.vala"
		if (alteration_equal_values (_tmp8_, _tmp9_)) {
#line 1874 "Alteration.c"
			const gchar* _tmp10_;
			const gchar* _tmp11_;
#line 238 "../src/core/Alteration.vala"
			_tmp10_ = self->priv->detail;
#line 238 "../src/core/Alteration.vala"
			_tmp11_ = other->priv->detail;
#line 238 "../src/core/Alteration.vala"
			_tmp7_ = alteration_equal_values (_tmp10_, _tmp11_);
#line 1883 "Alteration.c"
		} else {
#line 238 "../src/core/Alteration.vala"
			_tmp7_ = FALSE;
#line 1887 "Alteration.c"
		}
#line 238 "../src/core/Alteration.vala"
		result = _tmp7_;
#line 238 "../src/core/Alteration.vala"
		return result;
#line 1893 "Alteration.c"
	}
#line 241 "../src/core/Alteration.vala"
	_tmp13_ = self->priv->map;
#line 241 "../src/core/Alteration.vala"
	if (_tmp13_ != NULL) {
#line 1899 "Alteration.c"
		GeeMultiMap* _tmp14_;
#line 241 "../src/core/Alteration.vala"
		_tmp14_ = other->priv->map;
#line 241 "../src/core/Alteration.vala"
		_tmp12_ = _tmp14_ != NULL;
#line 1905 "Alteration.c"
	} else {
#line 241 "../src/core/Alteration.vala"
		_tmp12_ = FALSE;
#line 1909 "Alteration.c"
	}
#line 241 "../src/core/Alteration.vala"
	if (_tmp12_) {
#line 1913 "Alteration.c"
		GeeSet* keys = NULL;
		GeeMultiMap* _tmp15_;
		GeeSet* _tmp16_;
		GeeSet* _tmp17_;
		GeeSet* other_keys = NULL;
		GeeMultiMap* _tmp18_;
		GeeSet* _tmp19_;
		GeeSet* _tmp20_;
		GeeSet* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		GeeSet* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		GeeSet* _tmp27_;
		GeeSet* _tmp28_;
		GeeSet* _tmp29_;
		GeeSet* _tmp30_;
#line 243 "../src/core/Alteration.vala"
		_tmp15_ = self->priv->map;
#line 243 "../src/core/Alteration.vala"
		_tmp16_ = gee_multi_map_get_keys (_tmp15_);
#line 243 "../src/core/Alteration.vala"
		keys = _tmp16_;
#line 244 "../src/core/Alteration.vala"
		_tmp17_ = keys;
#line 244 "../src/core/Alteration.vala"
		_vala_assert (_tmp17_ != NULL, "keys != null");
#line 245 "../src/core/Alteration.vala"
		_tmp18_ = other->priv->map;
#line 245 "../src/core/Alteration.vala"
		_tmp19_ = gee_multi_map_get_keys (_tmp18_);
#line 245 "../src/core/Alteration.vala"
		other_keys = _tmp19_;
#line 246 "../src/core/Alteration.vala"
		_tmp20_ = other_keys;
#line 246 "../src/core/Alteration.vala"
		_vala_assert (_tmp20_ != NULL, "other_keys != null");
#line 248 "../src/core/Alteration.vala"
		_tmp21_ = keys;
#line 248 "../src/core/Alteration.vala"
		_tmp22_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection));
#line 248 "../src/core/Alteration.vala"
		_tmp23_ = _tmp22_;
#line 248 "../src/core/Alteration.vala"
		_tmp24_ = other_keys;
#line 248 "../src/core/Alteration.vala"
		_tmp25_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_COLLECTION, GeeCollection));
#line 248 "../src/core/Alteration.vala"
		_tmp26_ = _tmp25_;
#line 248 "../src/core/Alteration.vala"
		if (_tmp23_ != _tmp26_) {
#line 249 "../src/core/Alteration.vala"
			result = FALSE;
#line 249 "../src/core/Alteration.vala"
			_g_object_unref0 (other_keys);
#line 249 "../src/core/Alteration.vala"
			_g_object_unref0 (keys);
#line 249 "../src/core/Alteration.vala"
			return result;
#line 1974 "Alteration.c"
		}
#line 251 "../src/core/Alteration.vala"
		_tmp27_ = keys;
#line 251 "../src/core/Alteration.vala"
		_tmp28_ = other_keys;
#line 251 "../src/core/Alteration.vala"
		if (!gee_collection_contains_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_COLLECTION, GeeCollection))) {
#line 252 "../src/core/Alteration.vala"
			result = FALSE;
#line 252 "../src/core/Alteration.vala"
			_g_object_unref0 (other_keys);
#line 252 "../src/core/Alteration.vala"
			_g_object_unref0 (keys);
#line 252 "../src/core/Alteration.vala"
			return result;
#line 1990 "Alteration.c"
		}
#line 254 "../src/core/Alteration.vala"
		_tmp29_ = other_keys;
#line 254 "../src/core/Alteration.vala"
		_tmp30_ = keys;
#line 254 "../src/core/Alteration.vala"
		if (!gee_collection_contains_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_COLLECTION, GeeCollection))) {
#line 255 "../src/core/Alteration.vala"
			result = FALSE;
#line 255 "../src/core/Alteration.vala"
			_g_object_unref0 (other_keys);
#line 255 "../src/core/Alteration.vala"
			_g_object_unref0 (keys);
#line 255 "../src/core/Alteration.vala"
			return result;
#line 2006 "Alteration.c"
		}
		{
			GeeIterator* _key_it = NULL;
			GeeSet* _tmp31_;
			GeeIterator* _tmp32_;
#line 257 "../src/core/Alteration.vala"
			_tmp31_ = keys;
#line 257 "../src/core/Alteration.vala"
			_tmp32_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_ITERABLE, GeeIterable));
#line 257 "../src/core/Alteration.vala"
			_key_it = _tmp32_;
#line 257 "../src/core/Alteration.vala"
			while (TRUE) {
#line 2020 "Alteration.c"
				GeeIterator* _tmp33_;
				gchar* key = NULL;
				GeeIterator* _tmp34_;
				gpointer _tmp35_;
				GeeCollection* values = NULL;
				GeeMultiMap* _tmp36_;
				const gchar* _tmp37_;
				GeeCollection* _tmp38_;
				GeeCollection* other_values = NULL;
				GeeMultiMap* _tmp39_;
				const gchar* _tmp40_;
				GeeCollection* _tmp41_;
				GeeCollection* _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				GeeCollection* _tmp45_;
				gint _tmp46_;
				gint _tmp47_;
				GeeCollection* _tmp48_;
				GeeCollection* _tmp49_;
				GeeCollection* _tmp50_;
				GeeCollection* _tmp51_;
#line 257 "../src/core/Alteration.vala"
				_tmp33_ = _key_it;
#line 257 "../src/core/Alteration.vala"
				if (!gee_iterator_next (_tmp33_)) {
#line 257 "../src/core/Alteration.vala"
					break;
#line 2049 "Alteration.c"
				}
#line 257 "../src/core/Alteration.vala"
				_tmp34_ = _key_it;
#line 257 "../src/core/Alteration.vala"
				_tmp35_ = gee_iterator_get (_tmp34_);
#line 257 "../src/core/Alteration.vala"
				key = (gchar*) _tmp35_;
#line 258 "../src/core/Alteration.vala"
				_tmp36_ = self->priv->map;
#line 258 "../src/core/Alteration.vala"
				_tmp37_ = key;
#line 258 "../src/core/Alteration.vala"
				_tmp38_ = gee_multi_map_get (_tmp36_, _tmp37_);
#line 258 "../src/core/Alteration.vala"
				values = _tmp38_;
#line 259 "../src/core/Alteration.vala"
				_tmp39_ = other->priv->map;
#line 259 "../src/core/Alteration.vala"
				_tmp40_ = key;
#line 259 "../src/core/Alteration.vala"
				_tmp41_ = gee_multi_map_get (_tmp39_, _tmp40_);
#line 259 "../src/core/Alteration.vala"
				other_values = _tmp41_;
#line 261 "../src/core/Alteration.vala"
				_tmp42_ = values;
#line 261 "../src/core/Alteration.vala"
				_tmp43_ = gee_collection_get_size (_tmp42_);
#line 261 "../src/core/Alteration.vala"
				_tmp44_ = _tmp43_;
#line 261 "../src/core/Alteration.vala"
				_tmp45_ = other_values;
#line 261 "../src/core/Alteration.vala"
				_tmp46_ = gee_collection_get_size (_tmp45_);
#line 261 "../src/core/Alteration.vala"
				_tmp47_ = _tmp46_;
#line 261 "../src/core/Alteration.vala"
				if (_tmp44_ != _tmp47_) {
#line 262 "../src/core/Alteration.vala"
					result = FALSE;
#line 262 "../src/core/Alteration.vala"
					_g_object_unref0 (other_values);
#line 262 "../src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 262 "../src/core/Alteration.vala"
					_g_free0 (key);
#line 262 "../src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 262 "../src/core/Alteration.vala"
					_g_object_unref0 (other_keys);
#line 262 "../src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 262 "../src/core/Alteration.vala"
					return result;
#line 2103 "Alteration.c"
				}
#line 264 "../src/core/Alteration.vala"
				_tmp48_ = values;
#line 264 "../src/core/Alteration.vala"
				_tmp49_ = other_values;
#line 264 "../src/core/Alteration.vala"
				if (!gee_collection_contains_all (_tmp48_, _tmp49_)) {
#line 265 "../src/core/Alteration.vala"
					result = FALSE;
#line 265 "../src/core/Alteration.vala"
					_g_object_unref0 (other_values);
#line 265 "../src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 265 "../src/core/Alteration.vala"
					_g_free0 (key);
#line 265 "../src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 265 "../src/core/Alteration.vala"
					_g_object_unref0 (other_keys);
#line 265 "../src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 265 "../src/core/Alteration.vala"
					return result;
#line 2127 "Alteration.c"
				}
#line 267 "../src/core/Alteration.vala"
				_tmp50_ = other_values;
#line 267 "../src/core/Alteration.vala"
				_tmp51_ = values;
#line 267 "../src/core/Alteration.vala"
				if (!gee_collection_contains_all (_tmp50_, _tmp51_)) {
#line 268 "../src/core/Alteration.vala"
					result = FALSE;
#line 268 "../src/core/Alteration.vala"
					_g_object_unref0 (other_values);
#line 268 "../src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 268 "../src/core/Alteration.vala"
					_g_free0 (key);
#line 268 "../src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 268 "../src/core/Alteration.vala"
					_g_object_unref0 (other_keys);
#line 268 "../src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 268 "../src/core/Alteration.vala"
					return result;
#line 2151 "Alteration.c"
				}
#line 257 "../src/core/Alteration.vala"
				_g_object_unref0 (other_values);
#line 257 "../src/core/Alteration.vala"
				_g_object_unref0 (values);
#line 257 "../src/core/Alteration.vala"
				_g_free0 (key);
#line 2159 "Alteration.c"
			}
#line 257 "../src/core/Alteration.vala"
			_g_object_unref0 (_key_it);
#line 2163 "Alteration.c"
		}
#line 272 "../src/core/Alteration.vala"
		result = TRUE;
#line 272 "../src/core/Alteration.vala"
		_g_object_unref0 (other_keys);
#line 272 "../src/core/Alteration.vala"
		_g_object_unref0 (keys);
#line 272 "../src/core/Alteration.vala"
		return result;
#line 2173 "Alteration.c"
	}
#line 276 "../src/core/Alteration.vala"
	result = FALSE;
#line 276 "../src/core/Alteration.vala"
	return result;
#line 2179 "Alteration.c"
}

static void
alteration_multimap_add_all (GeeMultiMap* dest,
                             GeeMultiMap* src)
{
	GeeSet* keys = NULL;
	GeeSet* _tmp0_;
#line 279 "../src/core/Alteration.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dest, GEE_TYPE_MULTI_MAP));
#line 279 "../src/core/Alteration.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (src, GEE_TYPE_MULTI_MAP));
#line 281 "../src/core/Alteration.vala"
	_tmp0_ = gee_multi_map_get_keys (src);
#line 281 "../src/core/Alteration.vala"
	keys = _tmp0_;
#line 2196 "Alteration.c"
	{
		GeeIterator* _key_it = NULL;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 282 "../src/core/Alteration.vala"
		_tmp1_ = keys;
#line 282 "../src/core/Alteration.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 282 "../src/core/Alteration.vala"
		_key_it = _tmp2_;
#line 282 "../src/core/Alteration.vala"
		while (TRUE) {
#line 2209 "Alteration.c"
			GeeIterator* _tmp3_;
			gchar* key = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GeeCollection* values = NULL;
			const gchar* _tmp6_;
			GeeCollection* _tmp7_;
#line 282 "../src/core/Alteration.vala"
			_tmp3_ = _key_it;
#line 282 "../src/core/Alteration.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 282 "../src/core/Alteration.vala"
				break;
#line 2223 "Alteration.c"
			}
#line 282 "../src/core/Alteration.vala"
			_tmp4_ = _key_it;
#line 282 "../src/core/Alteration.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 282 "../src/core/Alteration.vala"
			key = (gchar*) _tmp5_;
#line 283 "../src/core/Alteration.vala"
			_tmp6_ = key;
#line 283 "../src/core/Alteration.vala"
			_tmp7_ = gee_multi_map_get (src, _tmp6_);
#line 283 "../src/core/Alteration.vala"
			values = _tmp7_;
#line 2237 "Alteration.c"
			{
				GeeIterator* _value_it = NULL;
				GeeCollection* _tmp8_;
				GeeIterator* _tmp9_;
#line 284 "../src/core/Alteration.vala"
				_tmp8_ = values;
#line 284 "../src/core/Alteration.vala"
				_tmp9_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ITERABLE, GeeIterable));
#line 284 "../src/core/Alteration.vala"
				_value_it = _tmp9_;
#line 284 "../src/core/Alteration.vala"
				while (TRUE) {
#line 2250 "Alteration.c"
					GeeIterator* _tmp10_;
					gchar* value = NULL;
					GeeIterator* _tmp11_;
					gpointer _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
#line 284 "../src/core/Alteration.vala"
					_tmp10_ = _value_it;
#line 284 "../src/core/Alteration.vala"
					if (!gee_iterator_next (_tmp10_)) {
#line 284 "../src/core/Alteration.vala"
						break;
#line 2263 "Alteration.c"
					}
#line 284 "../src/core/Alteration.vala"
					_tmp11_ = _value_it;
#line 284 "../src/core/Alteration.vala"
					_tmp12_ = gee_iterator_get (_tmp11_);
#line 284 "../src/core/Alteration.vala"
					value = (gchar*) _tmp12_;
#line 285 "../src/core/Alteration.vala"
					_tmp13_ = key;
#line 285 "../src/core/Alteration.vala"
					_tmp14_ = value;
#line 285 "../src/core/Alteration.vala"
					gee_multi_map_set (dest, _tmp13_, _tmp14_);
#line 284 "../src/core/Alteration.vala"
					_g_free0 (value);
#line 2279 "Alteration.c"
				}
#line 284 "../src/core/Alteration.vala"
				_g_object_unref0 (_value_it);
#line 2283 "Alteration.c"
			}
#line 282 "../src/core/Alteration.vala"
			_g_object_unref0 (values);
#line 282 "../src/core/Alteration.vala"
			_g_free0 (key);
#line 2289 "Alteration.c"
		}
#line 282 "../src/core/Alteration.vala"
		_g_object_unref0 (_key_it);
#line 2293 "Alteration.c"
	}
#line 279 "../src/core/Alteration.vala"
	_g_object_unref0 (keys);
#line 2297 "Alteration.c"
}

static gpointer
_alteration_ref0 (gpointer self)
{
#line 293 "../src/core/Alteration.vala"
	return self ? alteration_ref (self) : NULL;
#line 2305 "Alteration.c"
}

Alteration*
alteration_compress (Alteration* self,
                     Alteration* other)
{
	GeeMultiMap* compressed = NULL;
	GeeMultiMap* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
	GeeMultiMap* _tmp20_;
	Alteration* _tmp21_;
	Alteration* result = NULL;
#line 291 "../src/core/Alteration.vala"
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
#line 291 "../src/core/Alteration.vala"
	g_return_val_if_fail (IS_ALTERATION (other), NULL);
#line 292 "../src/core/Alteration.vala"
	if (alteration_equals (self, other)) {
#line 2327 "Alteration.c"
		Alteration* _tmp0_;
#line 293 "../src/core/Alteration.vala"
		_tmp0_ = _alteration_ref0 (self);
#line 293 "../src/core/Alteration.vala"
		result = _tmp0_;
#line 293 "../src/core/Alteration.vala"
		return result;
#line 2335 "Alteration.c"
	}
#line 297 "../src/core/Alteration.vala"
	_tmp1_ = alteration_create_map (self);
#line 297 "../src/core/Alteration.vala"
	compressed = _tmp1_;
#line 299 "../src/core/Alteration.vala"
	_tmp3_ = self->priv->subject;
#line 299 "../src/core/Alteration.vala"
	if (_tmp3_ != NULL) {
#line 2345 "Alteration.c"
		const gchar* _tmp4_;
#line 299 "../src/core/Alteration.vala"
		_tmp4_ = self->priv->detail;
#line 299 "../src/core/Alteration.vala"
		_tmp2_ = _tmp4_ != NULL;
#line 2351 "Alteration.c"
	} else {
#line 299 "../src/core/Alteration.vala"
		_tmp2_ = FALSE;
#line 2355 "Alteration.c"
	}
#line 299 "../src/core/Alteration.vala"
	if (_tmp2_) {
#line 2359 "Alteration.c"
		GeeMultiMap* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 300 "../src/core/Alteration.vala"
		_tmp5_ = compressed;
#line 300 "../src/core/Alteration.vala"
		_tmp6_ = self->priv->subject;
#line 300 "../src/core/Alteration.vala"
		_tmp7_ = self->priv->detail;
#line 300 "../src/core/Alteration.vala"
		gee_multi_map_set (_tmp5_, _tmp6_, _tmp7_);
#line 2371 "Alteration.c"
	} else {
		GeeMultiMap* _tmp8_;
		GeeMultiMap* _tmp9_;
		GeeMultiMap* _tmp10_;
#line 302 "../src/core/Alteration.vala"
		_tmp8_ = self->priv->map;
#line 302 "../src/core/Alteration.vala"
		_vala_assert (_tmp8_ != NULL, "map != null");
#line 303 "../src/core/Alteration.vala"
		_tmp9_ = compressed;
#line 303 "../src/core/Alteration.vala"
		_tmp10_ = self->priv->map;
#line 303 "../src/core/Alteration.vala"
		alteration_multimap_add_all (_tmp9_, _tmp10_);
#line 2386 "Alteration.c"
	}
#line 306 "../src/core/Alteration.vala"
	_tmp12_ = other->priv->subject;
#line 306 "../src/core/Alteration.vala"
	if (_tmp12_ != NULL) {
#line 2392 "Alteration.c"
		const gchar* _tmp13_;
#line 306 "../src/core/Alteration.vala"
		_tmp13_ = other->priv->detail;
#line 306 "../src/core/Alteration.vala"
		_tmp11_ = _tmp13_ != NULL;
#line 2398 "Alteration.c"
	} else {
#line 306 "../src/core/Alteration.vala"
		_tmp11_ = FALSE;
#line 2402 "Alteration.c"
	}
#line 306 "../src/core/Alteration.vala"
	if (_tmp11_) {
#line 2406 "Alteration.c"
		GeeMultiMap* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 307 "../src/core/Alteration.vala"
		_tmp14_ = compressed;
#line 307 "../src/core/Alteration.vala"
		_tmp15_ = other->priv->subject;
#line 307 "../src/core/Alteration.vala"
		_tmp16_ = other->priv->detail;
#line 307 "../src/core/Alteration.vala"
		gee_multi_map_set (_tmp14_, _tmp15_, _tmp16_);
#line 2418 "Alteration.c"
	} else {
		GeeMultiMap* _tmp17_;
		GeeMultiMap* _tmp18_;
		GeeMultiMap* _tmp19_;
#line 309 "../src/core/Alteration.vala"
		_tmp17_ = other->priv->map;
#line 309 "../src/core/Alteration.vala"
		_vala_assert (_tmp17_ != NULL, "other.map != null");
#line 310 "../src/core/Alteration.vala"
		_tmp18_ = compressed;
#line 310 "../src/core/Alteration.vala"
		_tmp19_ = other->priv->map;
#line 310 "../src/core/Alteration.vala"
		alteration_multimap_add_all (_tmp18_, _tmp19_);
#line 2433 "Alteration.c"
	}
#line 313 "../src/core/Alteration.vala"
	_tmp20_ = compressed;
#line 313 "../src/core/Alteration.vala"
	_tmp21_ = alteration_new_from_map (_tmp20_);
#line 313 "../src/core/Alteration.vala"
	result = _tmp21_;
#line 313 "../src/core/Alteration.vala"
	_g_object_unref0 (compressed);
#line 313 "../src/core/Alteration.vala"
	return result;
#line 2445 "Alteration.c"
}

static void
value_alteration_init (GValue* value)
{
#line 27 "../src/core/Alteration.vala"
	value->data[0].v_pointer = NULL;
#line 2453 "Alteration.c"
}

static void
value_alteration_free_value (GValue* value)
{
#line 27 "../src/core/Alteration.vala"
	if (value->data[0].v_pointer) {
#line 27 "../src/core/Alteration.vala"
		alteration_unref (value->data[0].v_pointer);
#line 2463 "Alteration.c"
	}
}

static void
value_alteration_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 27 "../src/core/Alteration.vala"
	if (src_value->data[0].v_pointer) {
#line 27 "../src/core/Alteration.vala"
		dest_value->data[0].v_pointer = alteration_ref (src_value->data[0].v_pointer);
#line 2475 "Alteration.c"
	} else {
#line 27 "../src/core/Alteration.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2479 "Alteration.c"
	}
}

static gpointer
value_alteration_peek_pointer (const GValue* value)
{
#line 27 "../src/core/Alteration.vala"
	return value->data[0].v_pointer;
#line 2488 "Alteration.c"
}

static gchar*
value_alteration_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 27 "../src/core/Alteration.vala"
	if (collect_values[0].v_pointer) {
#line 2499 "Alteration.c"
		Alteration * object;
		object = collect_values[0].v_pointer;
#line 27 "../src/core/Alteration.vala"
		if (object->parent_instance.g_class == NULL) {
#line 27 "../src/core/Alteration.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2506 "Alteration.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 27 "../src/core/Alteration.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2510 "Alteration.c"
		}
#line 27 "../src/core/Alteration.vala"
		value->data[0].v_pointer = alteration_ref (object);
#line 2514 "Alteration.c"
	} else {
#line 27 "../src/core/Alteration.vala"
		value->data[0].v_pointer = NULL;
#line 2518 "Alteration.c"
	}
#line 27 "../src/core/Alteration.vala"
	return NULL;
#line 2522 "Alteration.c"
}

static gchar*
value_alteration_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	Alteration ** object_p;
	object_p = collect_values[0].v_pointer;
#line 27 "../src/core/Alteration.vala"
	if (!object_p) {
#line 27 "../src/core/Alteration.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2537 "Alteration.c"
	}
#line 27 "../src/core/Alteration.vala"
	if (!value->data[0].v_pointer) {
#line 27 "../src/core/Alteration.vala"
		*object_p = NULL;
#line 2543 "Alteration.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 27 "../src/core/Alteration.vala"
		*object_p = value->data[0].v_pointer;
#line 2547 "Alteration.c"
	} else {
#line 27 "../src/core/Alteration.vala"
		*object_p = alteration_ref (value->data[0].v_pointer);
#line 2551 "Alteration.c"
	}
#line 27 "../src/core/Alteration.vala"
	return NULL;
#line 2555 "Alteration.c"
}

GParamSpec*
param_spec_alteration (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecAlteration* spec;
#line 27 "../src/core/Alteration.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ALTERATION), NULL);
#line 27 "../src/core/Alteration.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 27 "../src/core/Alteration.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 27 "../src/core/Alteration.vala"
	return G_PARAM_SPEC (spec);
#line 2574 "Alteration.c"
}

gpointer
value_get_alteration (const GValue* value)
{
#line 27 "../src/core/Alteration.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION), NULL);
#line 27 "../src/core/Alteration.vala"
	return value->data[0].v_pointer;
#line 2584 "Alteration.c"
}

void
value_set_alteration (GValue* value,
                      gpointer v_object)
{
	Alteration * old;
#line 27 "../src/core/Alteration.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
#line 27 "../src/core/Alteration.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/core/Alteration.vala"
	if (v_object) {
#line 27 "../src/core/Alteration.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
#line 27 "../src/core/Alteration.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/core/Alteration.vala"
		value->data[0].v_pointer = v_object;
#line 27 "../src/core/Alteration.vala"
		alteration_ref (value->data[0].v_pointer);
#line 2606 "Alteration.c"
	} else {
#line 27 "../src/core/Alteration.vala"
		value->data[0].v_pointer = NULL;
#line 2610 "Alteration.c"
	}
#line 27 "../src/core/Alteration.vala"
	if (old) {
#line 27 "../src/core/Alteration.vala"
		alteration_unref (old);
#line 2616 "Alteration.c"
	}
}

void
value_take_alteration (GValue* value,
                       gpointer v_object)
{
	Alteration * old;
#line 27 "../src/core/Alteration.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
#line 27 "../src/core/Alteration.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/core/Alteration.vala"
	if (v_object) {
#line 27 "../src/core/Alteration.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
#line 27 "../src/core/Alteration.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/core/Alteration.vala"
		value->data[0].v_pointer = v_object;
#line 2637 "Alteration.c"
	} else {
#line 27 "../src/core/Alteration.vala"
		value->data[0].v_pointer = NULL;
#line 2641 "Alteration.c"
	}
#line 27 "../src/core/Alteration.vala"
	if (old) {
#line 27 "../src/core/Alteration.vala"
		alteration_unref (old);
#line 2647 "Alteration.c"
	}
}

static void
alteration_class_init (AlterationClass * klass,
                       gpointer klass_data)
{
#line 27 "../src/core/Alteration.vala"
	alteration_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/core/Alteration.vala"
	((AlterationClass *) klass)->finalize = alteration_finalize;
#line 27 "../src/core/Alteration.vala"
	g_type_class_adjust_private_offset (klass, &Alteration_private_offset);
#line 2661 "Alteration.c"
}

static void
alteration_instance_init (Alteration * self,
                          gpointer klass)
{
#line 27 "../src/core/Alteration.vala"
	self->priv = alteration_get_instance_private (self);
#line 28 "../src/core/Alteration.vala"
	self->priv->subject = NULL;
#line 29 "../src/core/Alteration.vala"
	self->priv->detail = NULL;
#line 30 "../src/core/Alteration.vala"
	self->priv->map = NULL;
#line 27 "../src/core/Alteration.vala"
	self->ref_count = 1;
#line 2678 "Alteration.c"
}

static void
alteration_finalize (Alteration * obj)
{
	Alteration * self;
#line 27 "../src/core/Alteration.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ALTERATION, Alteration);
#line 27 "../src/core/Alteration.vala"
	g_signal_handlers_destroy (self);
#line 28 "../src/core/Alteration.vala"
	_g_free0 (self->priv->subject);
#line 29 "../src/core/Alteration.vala"
	_g_free0 (self->priv->detail);
#line 30 "../src/core/Alteration.vala"
	_g_object_unref0 (self->priv->map);
#line 2695 "Alteration.c"
}

static GType
alteration_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_alteration_init, value_alteration_free_value, value_alteration_copy_value, value_alteration_peek_pointer, "p", value_alteration_collect_value, "p", value_alteration_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (AlterationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) alteration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Alteration), 0, (GInstanceInitFunc) alteration_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType alteration_type_id;
	alteration_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Alteration", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Alteration_private_offset = g_type_add_instance_private (alteration_type_id, sizeof (AlterationPrivate));
	return alteration_type_id;
}

GType
alteration_get_type (void)
{
	static volatile gsize alteration_type_id__volatile = 0;
	if (g_once_init_enter (&alteration_type_id__volatile)) {
		GType alteration_type_id;
		alteration_type_id = alteration_get_type_once ();
		g_once_init_leave (&alteration_type_id__volatile, alteration_type_id);
	}
	return alteration_type_id__volatile;
}

gpointer
alteration_ref (gpointer instance)
{
	Alteration * self;
	self = instance;
#line 27 "../src/core/Alteration.vala"
	g_atomic_int_inc (&self->ref_count);
#line 27 "../src/core/Alteration.vala"
	return instance;
#line 2731 "Alteration.c"
}

void
alteration_unref (gpointer instance)
{
	Alteration * self;
	self = instance;
#line 27 "../src/core/Alteration.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 27 "../src/core/Alteration.vala"
		ALTERATION_GET_CLASS (self)->finalize (self);
#line 27 "../src/core/Alteration.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2745 "Alteration.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

