/* SourceInterfaces.c generated by valac 0.52.10, the Vala compiler
 * generated from SourceInterfaces.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* See the note in MediaInterfaces.vala for some thoughts on the theory of expanding Shotwell's*/
/* features via interfaces rather than class hierarchies.*/
/* Indexable DataSources provide raw strings that may be searched against (and, in the future,*/
/* indexed) for free-text search queries.  DataSources implementing Indexable must prepare and*/
/* store (i.e. cache) these strings using prepare_indexable_string(s), as preparing the strings*/
/* for each call is expensive.*/
/**/
/* When the indexable string has changed, the object should fire an alteration of*/
/* "indexable:keywords".  The prepare methods will not do this.*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define TYPE_GPS_COORDS (gps_coords_get_type ())
typedef struct _GpsCoords GpsCoords;

#define TYPE_POSITIONABLE (positionable_get_type ())
#define POSITIONABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_POSITIONABLE, Positionable))
#define IS_POSITIONABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_POSITIONABLE))
#define POSITIONABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_POSITIONABLE, PositionableIface))

typedef struct _Positionable Positionable;
typedef struct _PositionableIface PositionableIface;

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _GpsCoords {
	gint has_gps;
	gdouble latitude;
	gdouble longitude;
};

struct _PositionableIface {
	GTypeInterface parent_iface;
	void (*get_gps_coords) (Positionable* self, GpsCoords* result);
	void (*set_gps_coords) (Positionable* self, GpsCoords* gps_coords);
};

GType data_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
GType data_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
GType indexable_get_type (void) G_GNUC_CONST ;
const gchar* indexable_get_indexable_keywords (Indexable* self);
gchar* indexable_prepare_indexable_string (const gchar* str);
gboolean is_string_empty (const gchar* s);
gchar* string_remove_diacritics (const gchar* istring);
gchar* indexable_prepare_indexable_strings (gchar** strs,
                                            gint strs_length1);
static GType indexable_get_type_once (void);
GType gps_coords_get_type (void) G_GNUC_CONST ;
GpsCoords* gps_coords_dup (const GpsCoords* self);
void gps_coords_free (GpsCoords* self);
gboolean gps_coords_equals (GpsCoords *self,
                            GpsCoords* gps);
GType positionable_get_type (void) G_GNUC_CONST ;
void positionable_get_gps_coords (Positionable* self,
                                  GpsCoords* result);
void positionable_set_gps_coords (Positionable* self,
                                  GpsCoords* gps_coords);
static GType positionable_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const gchar*
indexable_get_indexable_keywords (Indexable* self)
{
	IndexableIface* _iface_;
#line 19 "../src/core/SourceInterfaces.vala"
	g_return_val_if_fail (IS_INDEXABLE (self), NULL);
#line 19 "../src/core/SourceInterfaces.vala"
	_iface_ = INDEXABLE_GET_INTERFACE (self);
#line 19 "../src/core/SourceInterfaces.vala"
	if (_iface_->get_indexable_keywords) {
#line 19 "../src/core/SourceInterfaces.vala"
		return _iface_->get_indexable_keywords (self);
#line 123 "SourceInterfaces.c"
	}
#line 19 "../src/core/SourceInterfaces.vala"
	return NULL;
#line 127 "SourceInterfaces.c"
}

gchar*
indexable_prepare_indexable_string (const gchar* str)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 22 "../src/core/SourceInterfaces.vala"
	if (is_string_empty (str)) {
#line 23 "../src/core/SourceInterfaces.vala"
		result = NULL;
#line 23 "../src/core/SourceInterfaces.vala"
		return result;
#line 144 "SourceInterfaces.c"
	}
#line 24 "../src/core/SourceInterfaces.vala"
	_tmp0_ = g_utf8_strdown (str, (gssize) -1);
#line 24 "../src/core/SourceInterfaces.vala"
	_tmp1_ = _tmp0_;
#line 24 "../src/core/SourceInterfaces.vala"
	_tmp2_ = string_remove_diacritics (_tmp1_);
#line 24 "../src/core/SourceInterfaces.vala"
	_tmp3_ = _tmp2_;
#line 24 "../src/core/SourceInterfaces.vala"
	_g_free0 (_tmp1_);
#line 24 "../src/core/SourceInterfaces.vala"
	result = _tmp3_;
#line 24 "../src/core/SourceInterfaces.vala"
	return result;
#line 160 "SourceInterfaces.c"
}

gchar*
indexable_prepare_indexable_strings (gchar** strs,
                                     gint strs_length1)
{
	gboolean _tmp0_ = FALSE;
	GString* builder = NULL;
	GString* _tmp1_;
	gint ctr = 0;
	const gchar* _tmp10_ = NULL;
	GString* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp15_;
	gchar* result = NULL;
#line 28 "../src/core/SourceInterfaces.vala"
	if (strs == NULL) {
#line 28 "../src/core/SourceInterfaces.vala"
		_tmp0_ = TRUE;
#line 180 "SourceInterfaces.c"
	} else {
#line 28 "../src/core/SourceInterfaces.vala"
		_tmp0_ = strs_length1 == 0;
#line 184 "SourceInterfaces.c"
	}
#line 28 "../src/core/SourceInterfaces.vala"
	if (_tmp0_) {
#line 29 "../src/core/SourceInterfaces.vala"
		result = NULL;
#line 29 "../src/core/SourceInterfaces.vala"
		return result;
#line 192 "SourceInterfaces.c"
	}
#line 31 "../src/core/SourceInterfaces.vala"
	_tmp1_ = g_string_new ("");
#line 31 "../src/core/SourceInterfaces.vala"
	builder = _tmp1_;
#line 32 "../src/core/SourceInterfaces.vala"
	ctr = 0;
#line 200 "SourceInterfaces.c"
	{
		gboolean _tmp2_ = FALSE;
#line 33 "../src/core/SourceInterfaces.vala"
		_tmp2_ = TRUE;
#line 33 "../src/core/SourceInterfaces.vala"
		while (TRUE) {
#line 207 "SourceInterfaces.c"
			const gchar* _tmp4_;
#line 33 "../src/core/SourceInterfaces.vala"
			if (!_tmp2_) {
#line 211 "SourceInterfaces.c"
				gint _tmp3_;
#line 39 "../src/core/SourceInterfaces.vala"
				ctr = ctr + 1;
#line 39 "../src/core/SourceInterfaces.vala"
				_tmp3_ = ctr;
#line 39 "../src/core/SourceInterfaces.vala"
				if (!(_tmp3_ < strs_length1)) {
#line 39 "../src/core/SourceInterfaces.vala"
					break;
#line 221 "SourceInterfaces.c"
				}
			}
#line 33 "../src/core/SourceInterfaces.vala"
			_tmp2_ = FALSE;
#line 34 "../src/core/SourceInterfaces.vala"
			_tmp4_ = strs[ctr];
#line 34 "../src/core/SourceInterfaces.vala"
			if (!is_string_empty (_tmp4_)) {
#line 230 "SourceInterfaces.c"
				GString* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 35 "../src/core/SourceInterfaces.vala"
				_tmp5_ = builder;
#line 35 "../src/core/SourceInterfaces.vala"
				_tmp6_ = strs[ctr];
#line 35 "../src/core/SourceInterfaces.vala"
				_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) -1);
#line 35 "../src/core/SourceInterfaces.vala"
				_tmp8_ = _tmp7_;
#line 35 "../src/core/SourceInterfaces.vala"
				g_string_append (_tmp5_, _tmp8_);
#line 35 "../src/core/SourceInterfaces.vala"
				_g_free0 (_tmp8_);
#line 36 "../src/core/SourceInterfaces.vala"
				if (ctr < (strs_length1 - 1)) {
#line 249 "SourceInterfaces.c"
					GString* _tmp9_;
#line 37 "../src/core/SourceInterfaces.vala"
					_tmp9_ = builder;
#line 37 "../src/core/SourceInterfaces.vala"
					g_string_append_c (_tmp9_, ' ');
#line 255 "SourceInterfaces.c"
				}
			}
		}
	}
#line 41 "../src/core/SourceInterfaces.vala"
	_tmp11_ = builder;
#line 41 "../src/core/SourceInterfaces.vala"
	_tmp12_ = _tmp11_->str;
#line 41 "../src/core/SourceInterfaces.vala"
	if (!is_string_empty (_tmp12_)) {
#line 266 "SourceInterfaces.c"
		GString* _tmp13_;
		const gchar* _tmp14_;
#line 41 "../src/core/SourceInterfaces.vala"
		_tmp13_ = builder;
#line 41 "../src/core/SourceInterfaces.vala"
		_tmp14_ = _tmp13_->str;
#line 41 "../src/core/SourceInterfaces.vala"
		_tmp10_ = _tmp14_;
#line 275 "SourceInterfaces.c"
	} else {
#line 41 "../src/core/SourceInterfaces.vala"
		_tmp10_ = NULL;
#line 279 "SourceInterfaces.c"
	}
#line 41 "../src/core/SourceInterfaces.vala"
	_tmp15_ = g_strdup (_tmp10_);
#line 41 "../src/core/SourceInterfaces.vala"
	result = _tmp15_;
#line 41 "../src/core/SourceInterfaces.vala"
	_g_string_free0 (builder);
#line 41 "../src/core/SourceInterfaces.vala"
	return result;
#line 289 "SourceInterfaces.c"
}

static void
indexable_default_init (IndexableIface * iface,
                        gpointer iface_data)
{
}

static GType
indexable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IndexableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indexable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType indexable_type_id;
	indexable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Indexable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (indexable_type_id, TYPE_DATA_SOURCE);
	return indexable_type_id;
}

GType
indexable_get_type (void)
{
	static volatile gsize indexable_type_id__volatile = 0;
	if (g_once_init_enter (&indexable_type_id__volatile)) {
		GType indexable_type_id;
		indexable_type_id = indexable_get_type_once ();
		g_once_init_leave (&indexable_type_id__volatile, indexable_type_id);
	}
	return indexable_type_id__volatile;
}

gboolean
gps_coords_equals (GpsCoords *self,
                   GpsCoords* gps)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result = FALSE;
#line 51 "../src/core/SourceInterfaces.vala"
	g_return_val_if_fail (gps != NULL, FALSE);
#line 52 "../src/core/SourceInterfaces.vala"
	if ((*self).has_gps == 0) {
#line 331 "SourceInterfaces.c"
		GpsCoords _tmp2_;
#line 52 "../src/core/SourceInterfaces.vala"
		_tmp2_ = *gps;
#line 52 "../src/core/SourceInterfaces.vala"
		_tmp1_ = _tmp2_.has_gps == 0;
#line 337 "SourceInterfaces.c"
	} else {
#line 52 "../src/core/SourceInterfaces.vala"
		_tmp1_ = FALSE;
#line 341 "SourceInterfaces.c"
	}
#line 52 "../src/core/SourceInterfaces.vala"
	if (_tmp1_) {
#line 52 "../src/core/SourceInterfaces.vala"
		_tmp0_ = TRUE;
#line 347 "SourceInterfaces.c"
	} else {
		gboolean _tmp3_ = FALSE;
		GpsCoords _tmp4_;
#line 52 "../src/core/SourceInterfaces.vala"
		_tmp4_ = *gps;
#line 52 "../src/core/SourceInterfaces.vala"
		if ((*self).latitude == _tmp4_.latitude) {
#line 355 "SourceInterfaces.c"
			GpsCoords _tmp5_;
#line 52 "../src/core/SourceInterfaces.vala"
			_tmp5_ = *gps;
#line 52 "../src/core/SourceInterfaces.vala"
			_tmp3_ = (*self).longitude == _tmp5_.longitude;
#line 361 "SourceInterfaces.c"
		} else {
#line 52 "../src/core/SourceInterfaces.vala"
			_tmp3_ = FALSE;
#line 365 "SourceInterfaces.c"
		}
#line 52 "../src/core/SourceInterfaces.vala"
		_tmp0_ = _tmp3_;
#line 369 "SourceInterfaces.c"
	}
#line 52 "../src/core/SourceInterfaces.vala"
	result = _tmp0_;
#line 52 "../src/core/SourceInterfaces.vala"
	return result;
#line 375 "SourceInterfaces.c"
}

GpsCoords*
gps_coords_dup (const GpsCoords* self)
{
	GpsCoords* dup;
#line 47 "../src/core/SourceInterfaces.vala"
	dup = g_new0 (GpsCoords, 1);
#line 47 "../src/core/SourceInterfaces.vala"
	memcpy (dup, self, sizeof (GpsCoords));
#line 47 "../src/core/SourceInterfaces.vala"
	return dup;
#line 388 "SourceInterfaces.c"
}

void
gps_coords_free (GpsCoords* self)
{
#line 47 "../src/core/SourceInterfaces.vala"
	g_free (self);
#line 396 "SourceInterfaces.c"
}

static GType
gps_coords_get_type_once (void)
{
	GType gps_coords_type_id;
	gps_coords_type_id = g_boxed_type_register_static ("GpsCoords", (GBoxedCopyFunc) gps_coords_dup, (GBoxedFreeFunc) gps_coords_free);
	return gps_coords_type_id;
}

GType
gps_coords_get_type (void)
{
	static volatile gsize gps_coords_type_id__volatile = 0;
	if (g_once_init_enter (&gps_coords_type_id__volatile)) {
		GType gps_coords_type_id;
		gps_coords_type_id = gps_coords_get_type_once ();
		g_once_init_leave (&gps_coords_type_id__volatile, gps_coords_type_id);
	}
	return gps_coords_type_id__volatile;
}

void
positionable_get_gps_coords (Positionable* self,
                             GpsCoords* result)
{
	PositionableIface* _iface_;
#line 57 "../src/core/SourceInterfaces.vala"
	g_return_if_fail (IS_POSITIONABLE (self));
#line 57 "../src/core/SourceInterfaces.vala"
	_iface_ = POSITIONABLE_GET_INTERFACE (self);
#line 57 "../src/core/SourceInterfaces.vala"
	if (_iface_->get_gps_coords) {
#line 57 "../src/core/SourceInterfaces.vala"
		_iface_->get_gps_coords (self, result);
#line 432 "SourceInterfaces.c"
	}
}

void
positionable_set_gps_coords (Positionable* self,
                             GpsCoords* gps_coords)
{
	PositionableIface* _iface_;
#line 58 "../src/core/SourceInterfaces.vala"
	g_return_if_fail (IS_POSITIONABLE (self));
#line 58 "../src/core/SourceInterfaces.vala"
	_iface_ = POSITIONABLE_GET_INTERFACE (self);
#line 58 "../src/core/SourceInterfaces.vala"
	if (_iface_->set_gps_coords) {
#line 58 "../src/core/SourceInterfaces.vala"
		_iface_->set_gps_coords (self, gps_coords);
#line 449 "SourceInterfaces.c"
	}
}

static void
positionable_default_init (PositionableIface * iface,
                           gpointer iface_data)
{
}

static GType
positionable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PositionableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) positionable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType positionable_type_id;
	positionable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Positionable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (positionable_type_id, TYPE_DATA_SOURCE);
	return positionable_type_id;
}

GType
positionable_get_type (void)
{
	static volatile gsize positionable_type_id__volatile = 0;
	if (g_once_init_enter (&positionable_type_id__volatile)) {
		GType positionable_type_id;
		positionable_type_id = positionable_get_type_once ();
		g_once_init_leave (&positionable_type_id__volatile, positionable_type_id);
	}
	return positionable_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

