/* BackgroundJob.c generated by valac 0.52.10, the Vala compiler
 * generated from BackgroundJob.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/* This callback is executed when an associated BackgroundJob completes.  It is called from within*/
/* the Gtk event loop, *not* the background thread's context.*/

#include <glib-object.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>
#include <gio/gio.h>
#include <gee.h>

#define TYPE_BACKGROUND_JOB (background_job_get_type ())
#define BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_JOB, BackgroundJob))
#define BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_JOB, BackgroundJobClass))
#define IS_BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_JOB))
#define IS_BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_JOB))
#define BACKGROUND_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_JOB, BackgroundJobClass))

typedef struct _BackgroundJob BackgroundJob;
typedef struct _BackgroundJobClass BackgroundJobClass;
typedef void (*CompletionCallback) (BackgroundJob* job, gpointer user_data);
typedef void (*CancellationCallback) (BackgroundJob* job, gpointer user_data);

#define TYPE_NOTIFICATION_OBJECT (notification_object_get_type ())
#define NOTIFICATION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_OBJECT, NotificationObject))
#define NOTIFICATION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_OBJECT, NotificationObjectClass))
#define IS_NOTIFICATION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_OBJECT))
#define IS_NOTIFICATION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_OBJECT))
#define NOTIFICATION_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_OBJECT, NotificationObjectClass))

typedef struct _NotificationObject NotificationObject;
typedef struct _NotificationObjectClass NotificationObjectClass;
typedef struct _NotificationObjectPrivate NotificationObjectPrivate;
typedef struct _ParamSpecNotificationObject ParamSpecNotificationObject;

#define TYPE_INTERLOCKED_NOTIFICATION_OBJECT (interlocked_notification_object_get_type ())
#define INTERLOCKED_NOTIFICATION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INTERLOCKED_NOTIFICATION_OBJECT, InterlockedNotificationObject))
#define INTERLOCKED_NOTIFICATION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INTERLOCKED_NOTIFICATION_OBJECT, InterlockedNotificationObjectClass))
#define IS_INTERLOCKED_NOTIFICATION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INTERLOCKED_NOTIFICATION_OBJECT))
#define IS_INTERLOCKED_NOTIFICATION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INTERLOCKED_NOTIFICATION_OBJECT))
#define INTERLOCKED_NOTIFICATION_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INTERLOCKED_NOTIFICATION_OBJECT, InterlockedNotificationObjectClass))

typedef struct _InterlockedNotificationObject InterlockedNotificationObject;
typedef struct _InterlockedNotificationObjectClass InterlockedNotificationObjectClass;
typedef struct _InterlockedNotificationObjectPrivate InterlockedNotificationObjectPrivate;

#define TYPE_ABSTRACT_SEMAPHORE (abstract_semaphore_get_type ())
#define ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphore))
#define ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))
#define IS_ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ABSTRACT_SEMAPHORE))
#define IS_ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ABSTRACT_SEMAPHORE))
#define ABSTRACT_SEMAPHORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))

typedef struct _AbstractSemaphore AbstractSemaphore;
typedef struct _AbstractSemaphoreClass AbstractSemaphoreClass;

#define TYPE_SEMAPHORE (semaphore_get_type ())
#define SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEMAPHORE, Semaphore))
#define SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEMAPHORE, SemaphoreClass))
#define IS_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEMAPHORE))
#define IS_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEMAPHORE))
#define SEMAPHORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEMAPHORE, SemaphoreClass))

typedef struct _Semaphore Semaphore;
typedef struct _SemaphoreClass SemaphoreClass;
#define _abstract_semaphore_unref0(var) ((var == NULL) ? NULL : (var = (abstract_semaphore_unref (var), NULL)))
typedef void (*NotificationCallback) (BackgroundJob* job, NotificationObject* user, gpointer user_data);
typedef struct _BackgroundJobPrivate BackgroundJobPrivate;
typedef enum  {
	BACKGROUND_JOB_JOB_PRIORITY_HIGHEST = 100,
	BACKGROUND_JOB_JOB_PRIORITY_HIGH = 75,
	BACKGROUND_JOB_JOB_PRIORITY_NORMAL = 50,
	BACKGROUND_JOB_JOB_PRIORITY_LOW = 25,
	BACKGROUND_JOB_JOB_PRIORITY_LOWEST = 0
} BackgroundJobJobPriority;

#define BACKGROUND_JOB_TYPE_JOB_PRIORITY (background_job_job_priority_get_type ())

#define BACKGROUND_JOB_TYPE_NOTIFICATION_JOB (background_job_notification_job_get_type ())
#define BACKGROUND_JOB_NOTIFICATION_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, BackgroundJobNotificationJob))
#define BACKGROUND_JOB_NOTIFICATION_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, BackgroundJobNotificationJobClass))
#define BACKGROUND_JOB_IS_NOTIFICATION_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BACKGROUND_JOB_TYPE_NOTIFICATION_JOB))
#define BACKGROUND_JOB_IS_NOTIFICATION_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BACKGROUND_JOB_TYPE_NOTIFICATION_JOB))
#define BACKGROUND_JOB_NOTIFICATION_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, BackgroundJobNotificationJobClass))

typedef struct _BackgroundJobNotificationJob BackgroundJobNotificationJob;
typedef struct _BackgroundJobNotificationJobClass BackgroundJobNotificationJobClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
#define _background_job_notification_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_notification_job_unref (var), NULL)))
#define _notification_object_unref0(var) ((var == NULL) ? NULL : (var = (notification_object_unref (var), NULL)))
typedef struct _BackgroundJobNotificationJobPrivate BackgroundJobNotificationJobPrivate;
typedef struct _BackgroundJobParamSpecNotificationJob BackgroundJobParamSpecNotificationJob;
typedef struct _ParamSpecBackgroundJob ParamSpecBackgroundJob;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NotificationObject {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NotificationObjectPrivate * priv;
};

struct _NotificationObjectClass {
	GTypeClass parent_class;
	void (*finalize) (NotificationObject *self);
};

struct _ParamSpecNotificationObject {
	GParamSpec parent_instance;
};

struct _InterlockedNotificationObject {
	NotificationObject parent_instance;
	InterlockedNotificationObjectPrivate * priv;
};

struct _InterlockedNotificationObjectClass {
	NotificationObjectClass parent_class;
};

struct _InterlockedNotificationObjectPrivate {
	Semaphore* semaphore;
};

struct _BackgroundJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobPrivate * priv;
};

struct _BackgroundJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJob *self);
	void (*execute) (BackgroundJob* self);
	BackgroundJobJobPriority (*get_priority) (BackgroundJob* self);
};

struct _BackgroundJobPrivate {
	GObject* owner;
	CompletionCallback callback;
	gpointer callback_target;
	GCancellable* cancellable;
	CancellationCallback cancellation;
	gpointer cancellation_target;
	BackgroundJob* self;
	AbstractSemaphore* semaphore;
	gint completion_priority;
	gint notification_priority;
};

struct _BackgroundJobNotificationJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobNotificationJobPrivate * priv;
	NotificationCallback callback;
	gpointer callback_target;
	BackgroundJob* background_job;
	NotificationObject* user;
};

struct _BackgroundJobNotificationJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJobNotificationJob *self);
};

struct _BackgroundJobParamSpecNotificationJob {
	GParamSpec parent_instance;
};

struct _ParamSpecBackgroundJob {
	GParamSpec parent_instance;
};

static gpointer notification_object_parent_class = NULL;
static gint InterlockedNotificationObject_private_offset;
static gpointer interlocked_notification_object_parent_class = NULL;
static gint BackgroundJob_private_offset;
static gpointer background_job_parent_class = NULL;
static GeeArrayList* background_job_notify_queue;
static GRecMutex __lock_background_job_background_job_notify_queue = {0};
static GeeArrayList* background_job_notify_queue = NULL;
static gpointer background_job_notification_job_parent_class = NULL;

gpointer background_job_ref (gpointer instance);
void background_job_unref (gpointer instance);
GParamSpec* param_spec_background_job (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_background_job (GValue* value,
                               gpointer v_object);
void value_take_background_job (GValue* value,
                                gpointer v_object);
gpointer value_get_background_job (const GValue* value);
GType background_job_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackgroundJob, background_job_unref)
gpointer notification_object_ref (gpointer instance);
void notification_object_unref (gpointer instance);
GParamSpec* param_spec_notification_object (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_notification_object (GValue* value,
                                    gpointer v_object);
void value_take_notification_object (GValue* value,
                                     gpointer v_object);
gpointer value_get_notification_object (const GValue* value);
GType notification_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NotificationObject, notification_object_unref)
NotificationObject* notification_object_construct (GType object_type);
static void notification_object_finalize (NotificationObject * obj);
static GType notification_object_get_type_once (void);
GType interlocked_notification_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (InterlockedNotificationObject, notification_object_unref)
gpointer abstract_semaphore_ref (gpointer instance);
void abstract_semaphore_unref (gpointer instance);
GParamSpec* param_spec_abstract_semaphore (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_abstract_semaphore (GValue* value,
                                   gpointer v_object);
void value_take_abstract_semaphore (GValue* value,
                                    gpointer v_object);
gpointer value_get_abstract_semaphore (const GValue* value);
GType abstract_semaphore_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AbstractSemaphore, abstract_semaphore_unref)
GType semaphore_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Semaphore, abstract_semaphore_unref)
Semaphore* semaphore_new (void);
Semaphore* semaphore_construct (GType object_type);
void interlocked_notification_object_internal_wait_for_completion (InterlockedNotificationObject* self);
void abstract_semaphore_wait (AbstractSemaphore* self);
void interlocked_notification_object_internal_completed (InterlockedNotificationObject* self);
void abstract_semaphore_notify (AbstractSemaphore* self);
InterlockedNotificationObject* interlocked_notification_object_construct (GType object_type);
static void interlocked_notification_object_finalize (NotificationObject * obj);
static GType interlocked_notification_object_get_type_once (void);
GType background_job_job_priority_get_type (void) G_GNUC_CONST ;
void background_job_execute (BackgroundJob* self);
BackgroundJobJobPriority background_job_get_priority (BackgroundJob* self);
gint background_job_job_priority_compare (BackgroundJobJobPriority self,
                                          BackgroundJobJobPriority other);
gint background_job_job_priority_compare_func (BackgroundJobJobPriority a,
                                               BackgroundJobJobPriority b);
static gpointer background_job_notification_job_ref (gpointer instance);
static void background_job_notification_job_unref (gpointer instance);
static GParamSpec* background_job_param_spec_notification_job (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags) G_GNUC_UNUSED ;
static void background_job_value_set_notification_job (GValue* value,
                                                gpointer v_object) G_GNUC_UNUSED ;
static void background_job_value_take_notification_job (GValue* value,
                                                 gpointer v_object) G_GNUC_UNUSED ;
static gpointer background_job_value_get_notification_job (const GValue* value) G_GNUC_UNUSED ;
static GType background_job_notification_job_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackgroundJobNotificationJob, background_job_notification_job_unref)
BackgroundJob* background_job_construct (GType object_type,
                                         GObject* owner,
                                         CompletionCallback callback,
                                         gpointer callback_target,
                                         GCancellable* cancellable,
                                         CancellationCallback cancellation,
                                         gpointer cancellation_target,
                                         AbstractSemaphore* completion_semaphore);
static void background_job_real_execute (BackgroundJob* self);
static BackgroundJobJobPriority background_job_real_get_priority (BackgroundJob* self);
gint background_job_priority_compare_func (BackgroundJob* a,
                                           BackgroundJob* b);
gint64 background_job_priority_comparator (void* a,
                                           void* b);
void background_job_set_completion_priority (BackgroundJob* self,
                                             gint priority);
void background_job_set_notification_priority (BackgroundJob* self,
                                               gint priority);
void background_job_wait_for_completion (BackgroundJob* self);
GCancellable* background_job_get_cancellable (BackgroundJob* self);
gboolean background_job_is_cancelled (BackgroundJob* self);
void background_job_cancel (BackgroundJob* self);
void background_job_internal_notify_completion (BackgroundJob* self);
static gboolean background_job_on_notify_completion (BackgroundJob* self);
static gboolean _background_job_on_notify_completion_gsource_func (gpointer self);
void background_job_notify (BackgroundJob* self,
                            NotificationCallback callback,
                            gpointer callback_target,
                            NotificationObject* user);
static BackgroundJobNotificationJob* background_job_notification_job_new (NotificationCallback callback,
                                                                   gpointer callback_target,
                                                                   BackgroundJob* background_job,
                                                                   NotificationObject* user);
static BackgroundJobNotificationJob* background_job_notification_job_construct (GType object_type,
                                                                         NotificationCallback callback,
                                                                         gpointer callback_target,
                                                                         BackgroundJob* background_job,
                                                                         NotificationObject* user);
static gboolean background_job_on_notification_ready (BackgroundJob* self);
static gboolean _background_job_on_notification_ready_gsource_func (gpointer self);
static void background_job_notification_job_finalize (BackgroundJobNotificationJob * obj);
static GType background_job_notification_job_get_type_once (void);
static void background_job_finalize (BackgroundJob * obj);
static GType background_job_get_type_once (void);

NotificationObject*
notification_object_construct (GType object_type)
{
	NotificationObject* self = NULL;
#line 34 "../src/threads/BackgroundJob.vala"
	self = (NotificationObject*) g_type_create_instance (object_type);
#line 34 "../src/threads/BackgroundJob.vala"
	return self;
#line 326 "BackgroundJob.c"
}

static void
value_notification_object_init (GValue* value)
{
#line 34 "../src/threads/BackgroundJob.vala"
	value->data[0].v_pointer = NULL;
#line 334 "BackgroundJob.c"
}

static void
value_notification_object_free_value (GValue* value)
{
#line 34 "../src/threads/BackgroundJob.vala"
	if (value->data[0].v_pointer) {
#line 34 "../src/threads/BackgroundJob.vala"
		notification_object_unref (value->data[0].v_pointer);
#line 344 "BackgroundJob.c"
	}
}

static void
value_notification_object_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 34 "../src/threads/BackgroundJob.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = notification_object_ref (src_value->data[0].v_pointer);
#line 356 "BackgroundJob.c"
	} else {
#line 34 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = NULL;
#line 360 "BackgroundJob.c"
	}
}

static gpointer
value_notification_object_peek_pointer (const GValue* value)
{
#line 34 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 369 "BackgroundJob.c"
}

static gchar*
value_notification_object_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 34 "../src/threads/BackgroundJob.vala"
	if (collect_values[0].v_pointer) {
#line 380 "BackgroundJob.c"
		NotificationObject * object;
		object = collect_values[0].v_pointer;
#line 34 "../src/threads/BackgroundJob.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 387 "BackgroundJob.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 391 "BackgroundJob.c"
		}
#line 34 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = notification_object_ref (object);
#line 395 "BackgroundJob.c"
	} else {
#line 34 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 399 "BackgroundJob.c"
	}
#line 34 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 403 "BackgroundJob.c"
}

static gchar*
value_notification_object_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	NotificationObject ** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "../src/threads/BackgroundJob.vala"
	if (!object_p) {
#line 34 "../src/threads/BackgroundJob.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 418 "BackgroundJob.c"
	}
#line 34 "../src/threads/BackgroundJob.vala"
	if (!value->data[0].v_pointer) {
#line 34 "../src/threads/BackgroundJob.vala"
		*object_p = NULL;
#line 424 "BackgroundJob.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "../src/threads/BackgroundJob.vala"
		*object_p = value->data[0].v_pointer;
#line 428 "BackgroundJob.c"
	} else {
#line 34 "../src/threads/BackgroundJob.vala"
		*object_p = notification_object_ref (value->data[0].v_pointer);
#line 432 "BackgroundJob.c"
	}
#line 34 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 436 "BackgroundJob.c"
}

GParamSpec*
param_spec_notification_object (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecNotificationObject* spec;
#line 34 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_NOTIFICATION_OBJECT), NULL);
#line 34 "../src/threads/BackgroundJob.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "../src/threads/BackgroundJob.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "../src/threads/BackgroundJob.vala"
	return G_PARAM_SPEC (spec);
#line 455 "BackgroundJob.c"
}

gpointer
value_get_notification_object (const GValue* value)
{
#line 34 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NOTIFICATION_OBJECT), NULL);
#line 34 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 465 "BackgroundJob.c"
}

void
value_set_notification_object (GValue* value,
                               gpointer v_object)
{
	NotificationObject * old;
#line 34 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NOTIFICATION_OBJECT));
#line 34 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 34 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NOTIFICATION_OBJECT));
#line 34 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 34 "../src/threads/BackgroundJob.vala"
		notification_object_ref (value->data[0].v_pointer);
#line 487 "BackgroundJob.c"
	} else {
#line 34 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 491 "BackgroundJob.c"
	}
#line 34 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 34 "../src/threads/BackgroundJob.vala"
		notification_object_unref (old);
#line 497 "BackgroundJob.c"
	}
}

void
value_take_notification_object (GValue* value,
                                gpointer v_object)
{
	NotificationObject * old;
#line 34 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NOTIFICATION_OBJECT));
#line 34 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 34 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NOTIFICATION_OBJECT));
#line 34 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 518 "BackgroundJob.c"
	} else {
#line 34 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 522 "BackgroundJob.c"
	}
#line 34 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 34 "../src/threads/BackgroundJob.vala"
		notification_object_unref (old);
#line 528 "BackgroundJob.c"
	}
}

static void
notification_object_class_init (NotificationObjectClass * klass,
                                gpointer klass_data)
{
#line 34 "../src/threads/BackgroundJob.vala"
	notification_object_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/threads/BackgroundJob.vala"
	((NotificationObjectClass *) klass)->finalize = notification_object_finalize;
#line 540 "BackgroundJob.c"
}

static void
notification_object_instance_init (NotificationObject * self,
                                   gpointer klass)
{
#line 34 "../src/threads/BackgroundJob.vala"
	self->ref_count = 1;
#line 549 "BackgroundJob.c"
}

static void
notification_object_finalize (NotificationObject * obj)
{
	NotificationObject * self;
#line 34 "../src/threads/BackgroundJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NOTIFICATION_OBJECT, NotificationObject);
#line 34 "../src/threads/BackgroundJob.vala"
	g_signal_handlers_destroy (self);
#line 560 "BackgroundJob.c"
}

static GType
notification_object_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_notification_object_init, value_notification_object_free_value, value_notification_object_copy_value, value_notification_object_peek_pointer, "p", value_notification_object_collect_value, "p", value_notification_object_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (NotificationObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notification_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationObject), 0, (GInstanceInitFunc) notification_object_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType notification_object_type_id;
	notification_object_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NotificationObject", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return notification_object_type_id;
}

GType
notification_object_get_type (void)
{
	static volatile gsize notification_object_type_id__volatile = 0;
	if (g_once_init_enter (&notification_object_type_id__volatile)) {
		GType notification_object_type_id;
		notification_object_type_id = notification_object_get_type_once ();
		g_once_init_leave (&notification_object_type_id__volatile, notification_object_type_id);
	}
	return notification_object_type_id__volatile;
}

gpointer
notification_object_ref (gpointer instance)
{
	NotificationObject * self;
	self = instance;
#line 34 "../src/threads/BackgroundJob.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "../src/threads/BackgroundJob.vala"
	return instance;
#line 595 "BackgroundJob.c"
}

void
notification_object_unref (gpointer instance)
{
	NotificationObject * self;
	self = instance;
#line 34 "../src/threads/BackgroundJob.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "../src/threads/BackgroundJob.vala"
		NOTIFICATION_OBJECT_GET_CLASS (self)->finalize (self);
#line 34 "../src/threads/BackgroundJob.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 609 "BackgroundJob.c"
	}
}

static inline gpointer
interlocked_notification_object_get_instance_private (InterlockedNotificationObject* self)
{
	return G_STRUCT_MEMBER_P (self, InterlockedNotificationObject_private_offset);
}

void
interlocked_notification_object_internal_wait_for_completion (InterlockedNotificationObject* self)
{
	Semaphore* _tmp0_;
#line 41 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (IS_INTERLOCKED_NOTIFICATION_OBJECT (self));
#line 42 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->semaphore;
#line 42 "../src/threads/BackgroundJob.vala"
	abstract_semaphore_wait (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphore));
#line 629 "BackgroundJob.c"
}

void
interlocked_notification_object_internal_completed (InterlockedNotificationObject* self)
{
	Semaphore* _tmp0_;
#line 46 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (IS_INTERLOCKED_NOTIFICATION_OBJECT (self));
#line 47 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->semaphore;
#line 47 "../src/threads/BackgroundJob.vala"
	abstract_semaphore_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphore));
#line 642 "BackgroundJob.c"
}

InterlockedNotificationObject*
interlocked_notification_object_construct (GType object_type)
{
	InterlockedNotificationObject* self = NULL;
#line 37 "../src/threads/BackgroundJob.vala"
	self = (InterlockedNotificationObject*) notification_object_construct (object_type);
#line 37 "../src/threads/BackgroundJob.vala"
	return self;
#line 653 "BackgroundJob.c"
}

static void
interlocked_notification_object_class_init (InterlockedNotificationObjectClass * klass,
                                            gpointer klass_data)
{
#line 37 "../src/threads/BackgroundJob.vala"
	interlocked_notification_object_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/threads/BackgroundJob.vala"
	((NotificationObjectClass *) klass)->finalize = interlocked_notification_object_finalize;
#line 37 "../src/threads/BackgroundJob.vala"
	g_type_class_adjust_private_offset (klass, &InterlockedNotificationObject_private_offset);
#line 666 "BackgroundJob.c"
}

static void
interlocked_notification_object_instance_init (InterlockedNotificationObject * self,
                                               gpointer klass)
{
	Semaphore* _tmp0_;
#line 37 "../src/threads/BackgroundJob.vala"
	self->priv = interlocked_notification_object_get_instance_private (self);
#line 38 "../src/threads/BackgroundJob.vala"
	_tmp0_ = semaphore_new ();
#line 38 "../src/threads/BackgroundJob.vala"
	self->priv->semaphore = _tmp0_;
#line 680 "BackgroundJob.c"
}

static void
interlocked_notification_object_finalize (NotificationObject * obj)
{
	InterlockedNotificationObject * self;
#line 37 "../src/threads/BackgroundJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INTERLOCKED_NOTIFICATION_OBJECT, InterlockedNotificationObject);
#line 38 "../src/threads/BackgroundJob.vala"
	_abstract_semaphore_unref0 (self->priv->semaphore);
#line 37 "../src/threads/BackgroundJob.vala"
	NOTIFICATION_OBJECT_CLASS (interlocked_notification_object_parent_class)->finalize (obj);
#line 693 "BackgroundJob.c"
}

static GType
interlocked_notification_object_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (InterlockedNotificationObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) interlocked_notification_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (InterlockedNotificationObject), 0, (GInstanceInitFunc) interlocked_notification_object_instance_init, NULL };
	GType interlocked_notification_object_type_id;
	interlocked_notification_object_type_id = g_type_register_static (TYPE_NOTIFICATION_OBJECT, "InterlockedNotificationObject", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	InterlockedNotificationObject_private_offset = g_type_add_instance_private (interlocked_notification_object_type_id, sizeof (InterlockedNotificationObjectPrivate));
	return interlocked_notification_object_type_id;
}

GType
interlocked_notification_object_get_type (void)
{
	static volatile gsize interlocked_notification_object_type_id__volatile = 0;
	if (g_once_init_enter (&interlocked_notification_object_type_id__volatile)) {
		GType interlocked_notification_object_type_id;
		interlocked_notification_object_type_id = interlocked_notification_object_get_type_once ();
		g_once_init_leave (&interlocked_notification_object_type_id__volatile, interlocked_notification_object_type_id);
	}
	return interlocked_notification_object_type_id__volatile;
}

static inline gpointer
background_job_get_instance_private (BackgroundJob* self)
{
	return G_STRUCT_MEMBER_P (self, BackgroundJob_private_offset);
}

gint
background_job_job_priority_compare (BackgroundJobJobPriority self,
                                     BackgroundJobJobPriority other)
{
	gint result = 0;
#line 75 "../src/threads/BackgroundJob.vala"
	result = ((gint) other) - ((gint) self);
#line 75 "../src/threads/BackgroundJob.vala"
	return result;
#line 733 "BackgroundJob.c"
}

gint
background_job_job_priority_compare_func (BackgroundJobJobPriority a,
                                          BackgroundJobJobPriority b)
{
	gint result = 0;
#line 79 "../src/threads/BackgroundJob.vala"
	result = ((gint) b) - ((gint) a);
#line 79 "../src/threads/BackgroundJob.vala"
	return result;
#line 745 "BackgroundJob.c"
}

static GType
background_job_job_priority_get_type_once (void)
{
	static const GEnumValue values[] = {{BACKGROUND_JOB_JOB_PRIORITY_HIGHEST, "BACKGROUND_JOB_JOB_PRIORITY_HIGHEST", "highest"}, {BACKGROUND_JOB_JOB_PRIORITY_HIGH, "BACKGROUND_JOB_JOB_PRIORITY_HIGH", "high"}, {BACKGROUND_JOB_JOB_PRIORITY_NORMAL, "BACKGROUND_JOB_JOB_PRIORITY_NORMAL", "normal"}, {BACKGROUND_JOB_JOB_PRIORITY_LOW, "BACKGROUND_JOB_JOB_PRIORITY_LOW", "low"}, {BACKGROUND_JOB_JOB_PRIORITY_LOWEST, "BACKGROUND_JOB_JOB_PRIORITY_LOWEST", "lowest"}, {0, NULL, NULL}};
	GType background_job_job_priority_type_id;
	background_job_job_priority_type_id = g_enum_register_static ("BackgroundJobJobPriority", values);
	return background_job_job_priority_type_id;
}

GType
background_job_job_priority_get_type (void)
{
	static volatile gsize background_job_job_priority_type_id__volatile = 0;
	if (g_once_init_enter (&background_job_job_priority_type_id__volatile)) {
		GType background_job_job_priority_type_id;
		background_job_job_priority_type_id = background_job_job_priority_get_type_once ();
		g_once_init_leave (&background_job_job_priority_type_id__volatile, background_job_job_priority_type_id);
	}
	return background_job_job_priority_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 116 "../src/threads/BackgroundJob.vala"
	return self ? g_object_ref (self) : NULL;
#line 774 "BackgroundJob.c"
}

static gpointer
_abstract_semaphore_ref0 (gpointer self)
{
#line 120 "../src/threads/BackgroundJob.vala"
	return self ? abstract_semaphore_ref (self) : NULL;
#line 782 "BackgroundJob.c"
}

BackgroundJob*
background_job_construct (GType object_type,
                          GObject* owner,
                          CompletionCallback callback,
                          gpointer callback_target,
                          GCancellable* cancellable,
                          CancellationCallback cancellation,
                          gpointer cancellation_target,
                          AbstractSemaphore* completion_semaphore)
{
	BackgroundJob* self = NULL;
	GObject* _tmp0_;
	GCancellable* _tmp1_;
	AbstractSemaphore* _tmp2_;
#line 113 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail ((owner == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (owner, G_TYPE_OBJECT), NULL);
#line 113 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 113 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail ((completion_semaphore == NULL) || IS_ABSTRACT_SEMAPHORE (completion_semaphore), NULL);
#line 113 "../src/threads/BackgroundJob.vala"
	self = (BackgroundJob*) g_type_create_instance (object_type);
#line 116 "../src/threads/BackgroundJob.vala"
	_tmp0_ = _g_object_ref0 (owner);
#line 116 "../src/threads/BackgroundJob.vala"
	_g_object_unref0 (self->priv->owner);
#line 116 "../src/threads/BackgroundJob.vala"
	self->priv->owner = _tmp0_;
#line 117 "../src/threads/BackgroundJob.vala"
	self->priv->callback = callback;
#line 117 "../src/threads/BackgroundJob.vala"
	self->priv->callback_target = callback_target;
#line 118 "../src/threads/BackgroundJob.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 118 "../src/threads/BackgroundJob.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 118 "../src/threads/BackgroundJob.vala"
	self->priv->cancellable = _tmp1_;
#line 119 "../src/threads/BackgroundJob.vala"
	self->priv->cancellation = cancellation;
#line 119 "../src/threads/BackgroundJob.vala"
	self->priv->cancellation_target = cancellation_target;
#line 120 "../src/threads/BackgroundJob.vala"
	_tmp2_ = _abstract_semaphore_ref0 (completion_semaphore);
#line 120 "../src/threads/BackgroundJob.vala"
	_abstract_semaphore_unref0 (self->priv->semaphore);
#line 120 "../src/threads/BackgroundJob.vala"
	self->priv->semaphore = _tmp2_;
#line 113 "../src/threads/BackgroundJob.vala"
	return self;
#line 835 "BackgroundJob.c"
}

static void
background_job_real_execute (BackgroundJob* self)
{
#line 123 "../src/threads/BackgroundJob.vala"
	g_critical ("Type `%s' does not implement abstract method `background_job_execute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 123 "../src/threads/BackgroundJob.vala"
	return;
#line 845 "BackgroundJob.c"
}

void
background_job_execute (BackgroundJob* self)
{
	BackgroundJobClass* _klass_;
#line 123 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (self));
#line 123 "../src/threads/BackgroundJob.vala"
	_klass_ = BACKGROUND_JOB_GET_CLASS (self);
#line 123 "../src/threads/BackgroundJob.vala"
	if (_klass_->execute) {
#line 123 "../src/threads/BackgroundJob.vala"
		_klass_->execute (self);
#line 860 "BackgroundJob.c"
	}
}

static BackgroundJobJobPriority
background_job_real_get_priority (BackgroundJob* self)
{
	BackgroundJobJobPriority result = 0;
#line 126 "../src/threads/BackgroundJob.vala"
	result = BACKGROUND_JOB_JOB_PRIORITY_NORMAL;
#line 126 "../src/threads/BackgroundJob.vala"
	return result;
#line 872 "BackgroundJob.c"
}

BackgroundJobJobPriority
background_job_get_priority (BackgroundJob* self)
{
	BackgroundJobClass* _klass_;
#line 125 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (IS_BACKGROUND_JOB (self), 0);
#line 125 "../src/threads/BackgroundJob.vala"
	_klass_ = BACKGROUND_JOB_GET_CLASS (self);
#line 125 "../src/threads/BackgroundJob.vala"
	if (_klass_->get_priority) {
#line 125 "../src/threads/BackgroundJob.vala"
		return _klass_->get_priority (self);
#line 887 "BackgroundJob.c"
	}
#line 125 "../src/threads/BackgroundJob.vala"
	return 0;
#line 891 "BackgroundJob.c"
}

gint
background_job_priority_compare_func (BackgroundJob* a,
                                      BackgroundJob* b)
{
	gint result = 0;
#line 130 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (IS_BACKGROUND_JOB (a), 0);
#line 130 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (IS_BACKGROUND_JOB (b), 0);
#line 131 "../src/threads/BackgroundJob.vala"
	result = background_job_job_priority_compare (background_job_get_priority (a), background_job_get_priority (b));
#line 131 "../src/threads/BackgroundJob.vala"
	return result;
#line 907 "BackgroundJob.c"
}

gint64
background_job_priority_comparator (void* a,
                                    void* b)
{
	gint64 result = 0LL;
#line 136 "../src/threads/BackgroundJob.vala"
	result = (gint64) background_job_priority_compare_func (G_TYPE_CHECK_INSTANCE_CAST (a, TYPE_BACKGROUND_JOB, BackgroundJob), G_TYPE_CHECK_INSTANCE_CAST (b, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 136 "../src/threads/BackgroundJob.vala"
	return result;
#line 919 "BackgroundJob.c"
}

void
background_job_set_completion_priority (BackgroundJob* self,
                                        gint priority)
{
#line 140 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (self));
#line 141 "../src/threads/BackgroundJob.vala"
	self->priv->completion_priority = priority;
#line 930 "BackgroundJob.c"
}

void
background_job_set_notification_priority (BackgroundJob* self,
                                          gint priority)
{
#line 145 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (self));
#line 146 "../src/threads/BackgroundJob.vala"
	self->priv->notification_priority = priority;
#line 941 "BackgroundJob.c"
}

void
background_job_wait_for_completion (BackgroundJob* self)
{
	AbstractSemaphore* _tmp0_;
#line 152 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (self));
#line 153 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->semaphore;
#line 153 "../src/threads/BackgroundJob.vala"
	if (_tmp0_ != NULL) {
#line 954 "BackgroundJob.c"
		AbstractSemaphore* _tmp1_;
#line 154 "../src/threads/BackgroundJob.vala"
		_tmp1_ = self->priv->semaphore;
#line 154 "../src/threads/BackgroundJob.vala"
		abstract_semaphore_wait (_tmp1_);
#line 960 "BackgroundJob.c"
	}
}

GCancellable*
background_job_get_cancellable (BackgroundJob* self)
{
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* result = NULL;
#line 157 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (IS_BACKGROUND_JOB (self), NULL);
#line 158 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->cancellable;
#line 158 "../src/threads/BackgroundJob.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 158 "../src/threads/BackgroundJob.vala"
	result = _tmp1_;
#line 158 "../src/threads/BackgroundJob.vala"
	return result;
#line 980 "BackgroundJob.c"
}

gboolean
background_job_is_cancelled (BackgroundJob* self)
{
	gboolean _tmp0_ = FALSE;
	GCancellable* _tmp1_;
	gboolean result = FALSE;
#line 161 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (IS_BACKGROUND_JOB (self), FALSE);
#line 162 "../src/threads/BackgroundJob.vala"
	_tmp1_ = self->priv->cancellable;
#line 162 "../src/threads/BackgroundJob.vala"
	if (_tmp1_ != NULL) {
#line 995 "BackgroundJob.c"
		GCancellable* _tmp2_;
#line 162 "../src/threads/BackgroundJob.vala"
		_tmp2_ = self->priv->cancellable;
#line 162 "../src/threads/BackgroundJob.vala"
		_tmp0_ = g_cancellable_is_cancelled (_tmp2_);
#line 1001 "BackgroundJob.c"
	} else {
#line 162 "../src/threads/BackgroundJob.vala"
		_tmp0_ = FALSE;
#line 1005 "BackgroundJob.c"
	}
#line 162 "../src/threads/BackgroundJob.vala"
	result = _tmp0_;
#line 162 "../src/threads/BackgroundJob.vala"
	return result;
#line 1011 "BackgroundJob.c"
}

void
background_job_cancel (BackgroundJob* self)
{
	GCancellable* _tmp0_;
#line 165 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (self));
#line 166 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->cancellable;
#line 166 "../src/threads/BackgroundJob.vala"
	if (_tmp0_ != NULL) {
#line 1024 "BackgroundJob.c"
		GCancellable* _tmp1_;
#line 167 "../src/threads/BackgroundJob.vala"
		_tmp1_ = self->priv->cancellable;
#line 167 "../src/threads/BackgroundJob.vala"
		g_cancellable_cancel (_tmp1_);
#line 1030 "BackgroundJob.c"
	}
}

static gpointer
_background_job_ref0 (gpointer self)
{
#line 183 "../src/threads/BackgroundJob.vala"
	return self ? background_job_ref (self) : NULL;
#line 1039 "BackgroundJob.c"
}

static gboolean
_background_job_on_notify_completion_gsource_func (gpointer self)
{
	gboolean result;
	result = background_job_on_notify_completion ((BackgroundJob*) self);
#line 185 "../src/threads/BackgroundJob.vala"
	return result;
#line 1049 "BackgroundJob.c"
}

void
background_job_internal_notify_completion (BackgroundJob* self)
{
	AbstractSemaphore* _tmp0_;
	gboolean _tmp2_ = FALSE;
	CompletionCallback _tmp3_;
	gpointer _tmp3__target;
	gboolean _tmp5_ = FALSE;
	BackgroundJob* _tmp7_;
#line 171 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (self));
#line 172 "../src/threads/BackgroundJob.vala"
	_tmp0_ = self->priv->semaphore;
#line 172 "../src/threads/BackgroundJob.vala"
	if (_tmp0_ != NULL) {
#line 1067 "BackgroundJob.c"
		AbstractSemaphore* _tmp1_;
#line 173 "../src/threads/BackgroundJob.vala"
		_tmp1_ = self->priv->semaphore;
#line 173 "../src/threads/BackgroundJob.vala"
		abstract_semaphore_notify (_tmp1_);
#line 1073 "BackgroundJob.c"
	}
#line 175 "../src/threads/BackgroundJob.vala"
	_tmp3_ = self->priv->callback;
#line 175 "../src/threads/BackgroundJob.vala"
	_tmp3__target = self->priv->callback_target;
#line 175 "../src/threads/BackgroundJob.vala"
	if (_tmp3_ == NULL) {
#line 1081 "BackgroundJob.c"
		CancellationCallback _tmp4_;
		gpointer _tmp4__target;
#line 175 "../src/threads/BackgroundJob.vala"
		_tmp4_ = self->priv->cancellation;
#line 175 "../src/threads/BackgroundJob.vala"
		_tmp4__target = self->priv->cancellation_target;
#line 175 "../src/threads/BackgroundJob.vala"
		_tmp2_ = _tmp4_ == NULL;
#line 1090 "BackgroundJob.c"
	} else {
#line 175 "../src/threads/BackgroundJob.vala"
		_tmp2_ = FALSE;
#line 1094 "BackgroundJob.c"
	}
#line 175 "../src/threads/BackgroundJob.vala"
	if (_tmp2_) {
#line 176 "../src/threads/BackgroundJob.vala"
		return;
#line 1100 "BackgroundJob.c"
	}
#line 178 "../src/threads/BackgroundJob.vala"
	if (background_job_is_cancelled (self)) {
#line 1104 "BackgroundJob.c"
		CancellationCallback _tmp6_;
		gpointer _tmp6__target;
#line 178 "../src/threads/BackgroundJob.vala"
		_tmp6_ = self->priv->cancellation;
#line 178 "../src/threads/BackgroundJob.vala"
		_tmp6__target = self->priv->cancellation_target;
#line 178 "../src/threads/BackgroundJob.vala"
		_tmp5_ = _tmp6_ == NULL;
#line 1113 "BackgroundJob.c"
	} else {
#line 178 "../src/threads/BackgroundJob.vala"
		_tmp5_ = FALSE;
#line 1117 "BackgroundJob.c"
	}
#line 178 "../src/threads/BackgroundJob.vala"
	if (_tmp5_) {
#line 179 "../src/threads/BackgroundJob.vala"
		return;
#line 1123 "BackgroundJob.c"
	}
#line 183 "../src/threads/BackgroundJob.vala"
	_tmp7_ = _background_job_ref0 (self);
#line 183 "../src/threads/BackgroundJob.vala"
	_background_job_unref0 (self->priv->self);
#line 183 "../src/threads/BackgroundJob.vala"
	self->priv->self = _tmp7_;
#line 185 "../src/threads/BackgroundJob.vala"
	g_idle_add_full (self->priv->completion_priority, _background_job_on_notify_completion_gsource_func, background_job_ref (self), background_job_unref);
#line 1133 "BackgroundJob.c"
}

static gboolean
background_job_on_notify_completion (BackgroundJob* self)
{
	gboolean result = FALSE;
#line 188 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (IS_BACKGROUND_JOB (self), FALSE);
#line 193 "../src/threads/BackgroundJob.vala"
	if (background_job_is_cancelled (self)) {
#line 1144 "BackgroundJob.c"
		CancellationCallback _tmp0_;
		gpointer _tmp0__target;
#line 194 "../src/threads/BackgroundJob.vala"
		_tmp0_ = self->priv->cancellation;
#line 194 "../src/threads/BackgroundJob.vala"
		_tmp0__target = self->priv->cancellation_target;
#line 194 "../src/threads/BackgroundJob.vala"
		if (_tmp0_ != NULL) {
#line 1153 "BackgroundJob.c"
			CancellationCallback _tmp1_;
			gpointer _tmp1__target;
#line 195 "../src/threads/BackgroundJob.vala"
			_tmp1_ = self->priv->cancellation;
#line 195 "../src/threads/BackgroundJob.vala"
			_tmp1__target = self->priv->cancellation_target;
#line 195 "../src/threads/BackgroundJob.vala"
			_tmp1_ (self, _tmp1__target);
#line 1162 "BackgroundJob.c"
		}
	} else {
		CompletionCallback _tmp2_;
		gpointer _tmp2__target;
#line 197 "../src/threads/BackgroundJob.vala"
		_tmp2_ = self->priv->callback;
#line 197 "../src/threads/BackgroundJob.vala"
		_tmp2__target = self->priv->callback_target;
#line 197 "../src/threads/BackgroundJob.vala"
		if (_tmp2_ != NULL) {
#line 1173 "BackgroundJob.c"
			CompletionCallback _tmp3_;
			gpointer _tmp3__target;
#line 198 "../src/threads/BackgroundJob.vala"
			_tmp3_ = self->priv->callback;
#line 198 "../src/threads/BackgroundJob.vala"
			_tmp3__target = self->priv->callback_target;
#line 198 "../src/threads/BackgroundJob.vala"
			_tmp3_ (self, _tmp3__target);
#line 1182 "BackgroundJob.c"
		}
	}
#line 202 "../src/threads/BackgroundJob.vala"
	_background_job_unref0 (self->priv->self);
#line 202 "../src/threads/BackgroundJob.vala"
	self->priv->self = NULL;
#line 204 "../src/threads/BackgroundJob.vala"
	result = FALSE;
#line 204 "../src/threads/BackgroundJob.vala"
	return result;
#line 1193 "BackgroundJob.c"
}

static gboolean
_background_job_on_notification_ready_gsource_func (gpointer self)
{
	gboolean result;
	result = background_job_on_notification_ready ((BackgroundJob*) self);
#line 214 "../src/threads/BackgroundJob.vala"
	return result;
#line 1203 "BackgroundJob.c"
}

static gpointer
_notification_object_ref0 (gpointer self)
{
#line 218 "../src/threads/BackgroundJob.vala"
	return self ? notification_object_ref (self) : NULL;
#line 1211 "BackgroundJob.c"
}

void
background_job_notify (BackgroundJob* self,
                       NotificationCallback callback,
                       gpointer callback_target,
                       NotificationObject* user)
{
	InterlockedNotificationObject* interlocked = NULL;
	InterlockedNotificationObject* _tmp5_;
	InterlockedNotificationObject* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 209 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (self));
#line 209 "../src/threads/BackgroundJob.vala"
	g_return_if_fail ((user == NULL) || IS_NOTIFICATION_OBJECT (user));
#line 1228 "BackgroundJob.c"
	{
		GeeArrayList* _tmp0_;
#line 210 "../src/threads/BackgroundJob.vala"
		_tmp0_ = background_job_notify_queue;
#line 210 "../src/threads/BackgroundJob.vala"
		g_rec_mutex_lock (&__lock_background_job_background_job_notify_queue);
#line 1235 "BackgroundJob.c"
		{
			GeeArrayList* _tmp1_;
			BackgroundJobNotificationJob* _tmp2_;
			BackgroundJobNotificationJob* _tmp3_;
#line 211 "../src/threads/BackgroundJob.vala"
			_tmp1_ = background_job_notify_queue;
#line 211 "../src/threads/BackgroundJob.vala"
			_tmp2_ = background_job_notification_job_new (callback, callback_target, self, user);
#line 211 "../src/threads/BackgroundJob.vala"
			_tmp3_ = _tmp2_;
#line 211 "../src/threads/BackgroundJob.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp3_);
#line 211 "../src/threads/BackgroundJob.vala"
			_background_job_notification_job_unref0 (_tmp3_);
#line 1250 "BackgroundJob.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp4_;
#line 210 "../src/threads/BackgroundJob.vala"
			_tmp4_ = background_job_notify_queue;
#line 210 "../src/threads/BackgroundJob.vala"
			g_rec_mutex_unlock (&__lock_background_job_background_job_notify_queue);
#line 1259 "BackgroundJob.c"
		}
#line 210 "../src/threads/BackgroundJob.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 210 "../src/threads/BackgroundJob.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 210 "../src/threads/BackgroundJob.vala"
			g_clear_error (&_inner_error0_);
#line 210 "../src/threads/BackgroundJob.vala"
			return;
#line 1269 "BackgroundJob.c"
		}
	}
#line 214 "../src/threads/BackgroundJob.vala"
	g_idle_add_full (self->priv->notification_priority, _background_job_on_notification_ready_gsource_func, background_job_ref (self), background_job_unref);
#line 218 "../src/threads/BackgroundJob.vala"
	_tmp5_ = _notification_object_ref0 (IS_INTERLOCKED_NOTIFICATION_OBJECT (user) ? ((InterlockedNotificationObject*) user) : NULL);
#line 218 "../src/threads/BackgroundJob.vala"
	interlocked = _tmp5_;
#line 219 "../src/threads/BackgroundJob.vala"
	_tmp6_ = interlocked;
#line 219 "../src/threads/BackgroundJob.vala"
	if (_tmp6_ != NULL) {
#line 1282 "BackgroundJob.c"
		InterlockedNotificationObject* _tmp7_;
#line 220 "../src/threads/BackgroundJob.vala"
		_tmp7_ = interlocked;
#line 220 "../src/threads/BackgroundJob.vala"
		interlocked_notification_object_internal_wait_for_completion (_tmp7_);
#line 1288 "BackgroundJob.c"
	}
#line 209 "../src/threads/BackgroundJob.vala"
	_notification_object_unref0 (interlocked);
#line 1292 "BackgroundJob.c"
}

static gboolean
background_job_on_notification_ready (BackgroundJob* self)
{
	BackgroundJobNotificationJob* notification_job = NULL;
	BackgroundJobNotificationJob* _tmp8_;
	BackgroundJobNotificationJob* _tmp9_;
	NotificationCallback _tmp10_;
	gpointer _tmp10__target;
	BackgroundJobNotificationJob* _tmp11_;
	BackgroundJob* _tmp12_;
	BackgroundJobNotificationJob* _tmp13_;
	NotificationObject* _tmp14_;
	InterlockedNotificationObject* interlocked = NULL;
	BackgroundJobNotificationJob* _tmp15_;
	NotificationObject* _tmp16_;
	InterlockedNotificationObject* _tmp17_;
	InterlockedNotificationObject* _tmp18_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 223 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (IS_BACKGROUND_JOB (self), FALSE);
#line 226 "../src/threads/BackgroundJob.vala"
	notification_job = NULL;
#line 1318 "BackgroundJob.c"
	{
		GeeArrayList* _tmp0_;
#line 227 "../src/threads/BackgroundJob.vala"
		_tmp0_ = background_job_notify_queue;
#line 227 "../src/threads/BackgroundJob.vala"
		g_rec_mutex_lock (&__lock_background_job_background_job_notify_queue);
#line 1325 "BackgroundJob.c"
		{
			GeeArrayList* _tmp1_;
			gint _tmp2_;
			gint _tmp3_;
#line 228 "../src/threads/BackgroundJob.vala"
			_tmp1_ = background_job_notify_queue;
#line 228 "../src/threads/BackgroundJob.vala"
			_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 228 "../src/threads/BackgroundJob.vala"
			_tmp3_ = _tmp2_;
#line 228 "../src/threads/BackgroundJob.vala"
			if (_tmp3_ > 0) {
#line 1338 "BackgroundJob.c"
				GeeArrayList* _tmp4_;
				gpointer _tmp5_;
#line 229 "../src/threads/BackgroundJob.vala"
				_tmp4_ = background_job_notify_queue;
#line 229 "../src/threads/BackgroundJob.vala"
				_tmp5_ = gee_abstract_list_remove_at (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0);
#line 229 "../src/threads/BackgroundJob.vala"
				_background_job_notification_job_unref0 (notification_job);
#line 229 "../src/threads/BackgroundJob.vala"
				notification_job = (BackgroundJobNotificationJob*) _tmp5_;
#line 1349 "BackgroundJob.c"
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp6_;
#line 227 "../src/threads/BackgroundJob.vala"
			_tmp6_ = background_job_notify_queue;
#line 227 "../src/threads/BackgroundJob.vala"
			g_rec_mutex_unlock (&__lock_background_job_background_job_notify_queue);
#line 1359 "BackgroundJob.c"
		}
#line 227 "../src/threads/BackgroundJob.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1363 "BackgroundJob.c"
			gboolean _tmp7_ = FALSE;
#line 227 "../src/threads/BackgroundJob.vala"
			_background_job_notification_job_unref0 (notification_job);
#line 227 "../src/threads/BackgroundJob.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 227 "../src/threads/BackgroundJob.vala"
			g_clear_error (&_inner_error0_);
#line 227 "../src/threads/BackgroundJob.vala"
			return _tmp7_;
#line 1373 "BackgroundJob.c"
		}
	}
#line 231 "../src/threads/BackgroundJob.vala"
	_tmp8_ = notification_job;
#line 231 "../src/threads/BackgroundJob.vala"
	_vala_assert (_tmp8_ != NULL, "notification_job != null");
#line 233 "../src/threads/BackgroundJob.vala"
	_tmp9_ = notification_job;
#line 233 "../src/threads/BackgroundJob.vala"
	_tmp10_ = _tmp9_->callback;
#line 233 "../src/threads/BackgroundJob.vala"
	_tmp10__target = _tmp9_->callback_target;
#line 233 "../src/threads/BackgroundJob.vala"
	_tmp11_ = notification_job;
#line 233 "../src/threads/BackgroundJob.vala"
	_tmp12_ = _tmp11_->background_job;
#line 233 "../src/threads/BackgroundJob.vala"
	_tmp13_ = notification_job;
#line 233 "../src/threads/BackgroundJob.vala"
	_tmp14_ = _tmp13_->user;
#line 233 "../src/threads/BackgroundJob.vala"
	_tmp10_ (_tmp12_, _tmp14_, _tmp10__target);
#line 236 "../src/threads/BackgroundJob.vala"
	_tmp15_ = notification_job;
#line 236 "../src/threads/BackgroundJob.vala"
	_tmp16_ = _tmp15_->user;
#line 236 "../src/threads/BackgroundJob.vala"
	_tmp17_ = _notification_object_ref0 (IS_INTERLOCKED_NOTIFICATION_OBJECT (_tmp16_) ? ((InterlockedNotificationObject*) _tmp16_) : NULL);
#line 236 "../src/threads/BackgroundJob.vala"
	interlocked = _tmp17_;
#line 237 "../src/threads/BackgroundJob.vala"
	_tmp18_ = interlocked;
#line 237 "../src/threads/BackgroundJob.vala"
	if (_tmp18_ != NULL) {
#line 1408 "BackgroundJob.c"
		InterlockedNotificationObject* _tmp19_;
#line 238 "../src/threads/BackgroundJob.vala"
		_tmp19_ = interlocked;
#line 238 "../src/threads/BackgroundJob.vala"
		interlocked_notification_object_internal_completed (_tmp19_);
#line 1414 "BackgroundJob.c"
	}
#line 240 "../src/threads/BackgroundJob.vala"
	result = FALSE;
#line 240 "../src/threads/BackgroundJob.vala"
	_notification_object_unref0 (interlocked);
#line 240 "../src/threads/BackgroundJob.vala"
	_background_job_notification_job_unref0 (notification_job);
#line 240 "../src/threads/BackgroundJob.vala"
	return result;
#line 1424 "BackgroundJob.c"
}

static BackgroundJobNotificationJob*
background_job_notification_job_construct (GType object_type,
                                           NotificationCallback callback,
                                           gpointer callback_target,
                                           BackgroundJob* background_job,
                                           NotificationObject* user)
{
	BackgroundJobNotificationJob* self = NULL;
	BackgroundJob* _tmp0_;
	NotificationObject* _tmp1_;
#line 88 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (IS_BACKGROUND_JOB (background_job), NULL);
#line 88 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail ((user == NULL) || IS_NOTIFICATION_OBJECT (user), NULL);
#line 88 "../src/threads/BackgroundJob.vala"
	self = (BackgroundJobNotificationJob*) g_type_create_instance (object_type);
#line 90 "../src/threads/BackgroundJob.vala"
	self->callback = callback;
#line 90 "../src/threads/BackgroundJob.vala"
	self->callback_target = callback_target;
#line 91 "../src/threads/BackgroundJob.vala"
	_tmp0_ = _background_job_ref0 (background_job);
#line 91 "../src/threads/BackgroundJob.vala"
	_background_job_unref0 (self->background_job);
#line 91 "../src/threads/BackgroundJob.vala"
	self->background_job = _tmp0_;
#line 92 "../src/threads/BackgroundJob.vala"
	_tmp1_ = _notification_object_ref0 (user);
#line 92 "../src/threads/BackgroundJob.vala"
	_notification_object_unref0 (self->user);
#line 92 "../src/threads/BackgroundJob.vala"
	self->user = _tmp1_;
#line 88 "../src/threads/BackgroundJob.vala"
	return self;
#line 1461 "BackgroundJob.c"
}

static BackgroundJobNotificationJob*
background_job_notification_job_new (NotificationCallback callback,
                                     gpointer callback_target,
                                     BackgroundJob* background_job,
                                     NotificationObject* user)
{
#line 88 "../src/threads/BackgroundJob.vala"
	return background_job_notification_job_construct (BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, callback, callback_target, background_job, user);
#line 1472 "BackgroundJob.c"
}

static void
background_job_value_notification_job_init (GValue* value)
{
#line 83 "../src/threads/BackgroundJob.vala"
	value->data[0].v_pointer = NULL;
#line 1480 "BackgroundJob.c"
}

static void
background_job_value_notification_job_free_value (GValue* value)
{
#line 83 "../src/threads/BackgroundJob.vala"
	if (value->data[0].v_pointer) {
#line 83 "../src/threads/BackgroundJob.vala"
		background_job_notification_job_unref (value->data[0].v_pointer);
#line 1490 "BackgroundJob.c"
	}
}

static void
background_job_value_notification_job_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
#line 83 "../src/threads/BackgroundJob.vala"
	if (src_value->data[0].v_pointer) {
#line 83 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = background_job_notification_job_ref (src_value->data[0].v_pointer);
#line 1502 "BackgroundJob.c"
	} else {
#line 83 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1506 "BackgroundJob.c"
	}
}

static gpointer
background_job_value_notification_job_peek_pointer (const GValue* value)
{
#line 83 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 1515 "BackgroundJob.c"
}

static gchar*
background_job_value_notification_job_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
#line 83 "../src/threads/BackgroundJob.vala"
	if (collect_values[0].v_pointer) {
#line 1526 "BackgroundJob.c"
		BackgroundJobNotificationJob * object;
		object = collect_values[0].v_pointer;
#line 83 "../src/threads/BackgroundJob.vala"
		if (object->parent_instance.g_class == NULL) {
#line 83 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1533 "BackgroundJob.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 83 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1537 "BackgroundJob.c"
		}
#line 83 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = background_job_notification_job_ref (object);
#line 1541 "BackgroundJob.c"
	} else {
#line 83 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1545 "BackgroundJob.c"
	}
#line 83 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 1549 "BackgroundJob.c"
}

static gchar*
background_job_value_notification_job_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	BackgroundJobNotificationJob ** object_p;
	object_p = collect_values[0].v_pointer;
#line 83 "../src/threads/BackgroundJob.vala"
	if (!object_p) {
#line 83 "../src/threads/BackgroundJob.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1564 "BackgroundJob.c"
	}
#line 83 "../src/threads/BackgroundJob.vala"
	if (!value->data[0].v_pointer) {
#line 83 "../src/threads/BackgroundJob.vala"
		*object_p = NULL;
#line 1570 "BackgroundJob.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 83 "../src/threads/BackgroundJob.vala"
		*object_p = value->data[0].v_pointer;
#line 1574 "BackgroundJob.c"
	} else {
#line 83 "../src/threads/BackgroundJob.vala"
		*object_p = background_job_notification_job_ref (value->data[0].v_pointer);
#line 1578 "BackgroundJob.c"
	}
#line 83 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 1582 "BackgroundJob.c"
}

static GParamSpec*
background_job_param_spec_notification_job (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	BackgroundJobParamSpecNotificationJob* spec;
#line 83 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (g_type_is_a (object_type, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB), NULL);
#line 83 "../src/threads/BackgroundJob.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 83 "../src/threads/BackgroundJob.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 83 "../src/threads/BackgroundJob.vala"
	return G_PARAM_SPEC (spec);
#line 1601 "BackgroundJob.c"
}

static gpointer
background_job_value_get_notification_job (const GValue* value)
{
#line 83 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB), NULL);
#line 83 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 1611 "BackgroundJob.c"
}

static void
background_job_value_set_notification_job (GValue* value,
                                           gpointer v_object)
{
	BackgroundJobNotificationJob * old;
#line 83 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB));
#line 83 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 83 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 83 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB));
#line 83 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 83 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 83 "../src/threads/BackgroundJob.vala"
		background_job_notification_job_ref (value->data[0].v_pointer);
#line 1633 "BackgroundJob.c"
	} else {
#line 83 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1637 "BackgroundJob.c"
	}
#line 83 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 83 "../src/threads/BackgroundJob.vala"
		background_job_notification_job_unref (old);
#line 1643 "BackgroundJob.c"
	}
}

static void
background_job_value_take_notification_job (GValue* value,
                                            gpointer v_object)
{
	BackgroundJobNotificationJob * old;
#line 83 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB));
#line 83 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 83 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 83 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB));
#line 83 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 83 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 1664 "BackgroundJob.c"
	} else {
#line 83 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1668 "BackgroundJob.c"
	}
#line 83 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 83 "../src/threads/BackgroundJob.vala"
		background_job_notification_job_unref (old);
#line 1674 "BackgroundJob.c"
	}
}

static void
background_job_notification_job_class_init (BackgroundJobNotificationJobClass * klass,
                                            gpointer klass_data)
{
#line 83 "../src/threads/BackgroundJob.vala"
	background_job_notification_job_parent_class = g_type_class_peek_parent (klass);
#line 83 "../src/threads/BackgroundJob.vala"
	((BackgroundJobNotificationJobClass *) klass)->finalize = background_job_notification_job_finalize;
#line 1686 "BackgroundJob.c"
}

static void
background_job_notification_job_instance_init (BackgroundJobNotificationJob * self,
                                               gpointer klass)
{
#line 83 "../src/threads/BackgroundJob.vala"
	self->ref_count = 1;
#line 1695 "BackgroundJob.c"
}

static void
background_job_notification_job_finalize (BackgroundJobNotificationJob * obj)
{
	BackgroundJobNotificationJob * self;
#line 83 "../src/threads/BackgroundJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, BackgroundJobNotificationJob);
#line 83 "../src/threads/BackgroundJob.vala"
	g_signal_handlers_destroy (self);
#line 85 "../src/threads/BackgroundJob.vala"
	_background_job_unref0 (self->background_job);
#line 86 "../src/threads/BackgroundJob.vala"
	_notification_object_unref0 (self->user);
#line 1710 "BackgroundJob.c"
}

static GType
background_job_notification_job_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { background_job_value_notification_job_init, background_job_value_notification_job_free_value, background_job_value_notification_job_copy_value, background_job_value_notification_job_peek_pointer, "p", background_job_value_notification_job_collect_value, "p", background_job_value_notification_job_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BackgroundJobNotificationJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_job_notification_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackgroundJobNotificationJob), 0, (GInstanceInitFunc) background_job_notification_job_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType background_job_notification_job_type_id;
	background_job_notification_job_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BackgroundJobNotificationJob", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return background_job_notification_job_type_id;
}

static GType
background_job_notification_job_get_type (void)
{
	static volatile gsize background_job_notification_job_type_id__volatile = 0;
	if (g_once_init_enter (&background_job_notification_job_type_id__volatile)) {
		GType background_job_notification_job_type_id;
		background_job_notification_job_type_id = background_job_notification_job_get_type_once ();
		g_once_init_leave (&background_job_notification_job_type_id__volatile, background_job_notification_job_type_id);
	}
	return background_job_notification_job_type_id__volatile;
}

static gpointer
background_job_notification_job_ref (gpointer instance)
{
	BackgroundJobNotificationJob * self;
	self = instance;
#line 83 "../src/threads/BackgroundJob.vala"
	g_atomic_int_inc (&self->ref_count);
#line 83 "../src/threads/BackgroundJob.vala"
	return instance;
#line 1745 "BackgroundJob.c"
}

static void
background_job_notification_job_unref (gpointer instance)
{
	BackgroundJobNotificationJob * self;
	self = instance;
#line 83 "../src/threads/BackgroundJob.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 83 "../src/threads/BackgroundJob.vala"
		BACKGROUND_JOB_NOTIFICATION_JOB_GET_CLASS (self)->finalize (self);
#line 83 "../src/threads/BackgroundJob.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1759 "BackgroundJob.c"
	}
}

static void
value_background_job_init (GValue* value)
{
#line 65 "../src/threads/BackgroundJob.vala"
	value->data[0].v_pointer = NULL;
#line 1768 "BackgroundJob.c"
}

static void
value_background_job_free_value (GValue* value)
{
#line 65 "../src/threads/BackgroundJob.vala"
	if (value->data[0].v_pointer) {
#line 65 "../src/threads/BackgroundJob.vala"
		background_job_unref (value->data[0].v_pointer);
#line 1778 "BackgroundJob.c"
	}
}

static void
value_background_job_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 65 "../src/threads/BackgroundJob.vala"
	if (src_value->data[0].v_pointer) {
#line 65 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = background_job_ref (src_value->data[0].v_pointer);
#line 1790 "BackgroundJob.c"
	} else {
#line 65 "../src/threads/BackgroundJob.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1794 "BackgroundJob.c"
	}
}

static gpointer
value_background_job_peek_pointer (const GValue* value)
{
#line 65 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 1803 "BackgroundJob.c"
}

static gchar*
value_background_job_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 65 "../src/threads/BackgroundJob.vala"
	if (collect_values[0].v_pointer) {
#line 1814 "BackgroundJob.c"
		BackgroundJob * object;
		object = collect_values[0].v_pointer;
#line 65 "../src/threads/BackgroundJob.vala"
		if (object->parent_instance.g_class == NULL) {
#line 65 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1821 "BackgroundJob.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 65 "../src/threads/BackgroundJob.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1825 "BackgroundJob.c"
		}
#line 65 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = background_job_ref (object);
#line 1829 "BackgroundJob.c"
	} else {
#line 65 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1833 "BackgroundJob.c"
	}
#line 65 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 1837 "BackgroundJob.c"
}

static gchar*
value_background_job_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	BackgroundJob ** object_p;
	object_p = collect_values[0].v_pointer;
#line 65 "../src/threads/BackgroundJob.vala"
	if (!object_p) {
#line 65 "../src/threads/BackgroundJob.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1852 "BackgroundJob.c"
	}
#line 65 "../src/threads/BackgroundJob.vala"
	if (!value->data[0].v_pointer) {
#line 65 "../src/threads/BackgroundJob.vala"
		*object_p = NULL;
#line 1858 "BackgroundJob.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 65 "../src/threads/BackgroundJob.vala"
		*object_p = value->data[0].v_pointer;
#line 1862 "BackgroundJob.c"
	} else {
#line 65 "../src/threads/BackgroundJob.vala"
		*object_p = background_job_ref (value->data[0].v_pointer);
#line 1866 "BackgroundJob.c"
	}
#line 65 "../src/threads/BackgroundJob.vala"
	return NULL;
#line 1870 "BackgroundJob.c"
}

GParamSpec*
param_spec_background_job (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecBackgroundJob* spec;
#line 65 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BACKGROUND_JOB), NULL);
#line 65 "../src/threads/BackgroundJob.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 65 "../src/threads/BackgroundJob.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 65 "../src/threads/BackgroundJob.vala"
	return G_PARAM_SPEC (spec);
#line 1889 "BackgroundJob.c"
}

gpointer
value_get_background_job (const GValue* value)
{
#line 65 "../src/threads/BackgroundJob.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKGROUND_JOB), NULL);
#line 65 "../src/threads/BackgroundJob.vala"
	return value->data[0].v_pointer;
#line 1899 "BackgroundJob.c"
}

void
value_set_background_job (GValue* value,
                          gpointer v_object)
{
	BackgroundJob * old;
#line 65 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKGROUND_JOB));
#line 65 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 65 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 65 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKGROUND_JOB));
#line 65 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 65 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 65 "../src/threads/BackgroundJob.vala"
		background_job_ref (value->data[0].v_pointer);
#line 1921 "BackgroundJob.c"
	} else {
#line 65 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1925 "BackgroundJob.c"
	}
#line 65 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 65 "../src/threads/BackgroundJob.vala"
		background_job_unref (old);
#line 1931 "BackgroundJob.c"
	}
}

void
value_take_background_job (GValue* value,
                           gpointer v_object)
{
	BackgroundJob * old;
#line 65 "../src/threads/BackgroundJob.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKGROUND_JOB));
#line 65 "../src/threads/BackgroundJob.vala"
	old = value->data[0].v_pointer;
#line 65 "../src/threads/BackgroundJob.vala"
	if (v_object) {
#line 65 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKGROUND_JOB));
#line 65 "../src/threads/BackgroundJob.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 65 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = v_object;
#line 1952 "BackgroundJob.c"
	} else {
#line 65 "../src/threads/BackgroundJob.vala"
		value->data[0].v_pointer = NULL;
#line 1956 "BackgroundJob.c"
	}
#line 65 "../src/threads/BackgroundJob.vala"
	if (old) {
#line 65 "../src/threads/BackgroundJob.vala"
		background_job_unref (old);
#line 1962 "BackgroundJob.c"
	}
}

static void
background_job_class_init (BackgroundJobClass * klass,
                           gpointer klass_data)
{
	GeeArrayList* _tmp0_;
#line 65 "../src/threads/BackgroundJob.vala"
	background_job_parent_class = g_type_class_peek_parent (klass);
#line 65 "../src/threads/BackgroundJob.vala"
	((BackgroundJobClass *) klass)->finalize = background_job_finalize;
#line 65 "../src/threads/BackgroundJob.vala"
	g_type_class_adjust_private_offset (klass, &BackgroundJob_private_offset);
#line 65 "../src/threads/BackgroundJob.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) background_job_real_execute;
#line 65 "../src/threads/BackgroundJob.vala"
	((BackgroundJobClass *) klass)->get_priority = (BackgroundJobJobPriority (*) (BackgroundJob*)) background_job_real_get_priority;
#line 96 "../src/threads/BackgroundJob.vala"
	g_rec_mutex_init (&__lock_background_job_background_job_notify_queue);
#line 96 "../src/threads/BackgroundJob.vala"
	_tmp0_ = gee_array_list_new (BACKGROUND_JOB_TYPE_NOTIFICATION_JOB, (GBoxedCopyFunc) background_job_notification_job_ref, (GDestroyNotify) background_job_notification_job_unref, NULL, NULL, NULL);
#line 96 "../src/threads/BackgroundJob.vala"
	background_job_notify_queue = _tmp0_;
#line 1987 "BackgroundJob.c"
}

static void
background_job_instance_init (BackgroundJob * self,
                              gpointer klass)
{
#line 65 "../src/threads/BackgroundJob.vala"
	self->priv = background_job_get_instance_private (self);
#line 102 "../src/threads/BackgroundJob.vala"
	self->priv->self = NULL;
#line 103 "../src/threads/BackgroundJob.vala"
	self->priv->semaphore = NULL;
#line 110 "../src/threads/BackgroundJob.vala"
	self->priv->completion_priority = G_PRIORITY_HIGH;
#line 111 "../src/threads/BackgroundJob.vala"
	self->priv->notification_priority = G_PRIORITY_DEFAULT_IDLE;
#line 65 "../src/threads/BackgroundJob.vala"
	self->ref_count = 1;
#line 2006 "BackgroundJob.c"
}

static void
background_job_finalize (BackgroundJob * obj)
{
	BackgroundJob * self;
#line 65 "../src/threads/BackgroundJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKGROUND_JOB, BackgroundJob);
#line 65 "../src/threads/BackgroundJob.vala"
	g_signal_handlers_destroy (self);
#line 98 "../src/threads/BackgroundJob.vala"
	_g_object_unref0 (self->priv->owner);
#line 100 "../src/threads/BackgroundJob.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 102 "../src/threads/BackgroundJob.vala"
	_background_job_unref0 (self->priv->self);
#line 103 "../src/threads/BackgroundJob.vala"
	_abstract_semaphore_unref0 (self->priv->semaphore);
#line 2025 "BackgroundJob.c"
}

static GType
background_job_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_background_job_init, value_background_job_free_value, value_background_job_copy_value, value_background_job_peek_pointer, "p", value_background_job_collect_value, "p", value_background_job_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BackgroundJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackgroundJob), 0, (GInstanceInitFunc) background_job_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType background_job_type_id;
	background_job_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BackgroundJob", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	BackgroundJob_private_offset = g_type_add_instance_private (background_job_type_id, sizeof (BackgroundJobPrivate));
	return background_job_type_id;
}

GType
background_job_get_type (void)
{
	static volatile gsize background_job_type_id__volatile = 0;
	if (g_once_init_enter (&background_job_type_id__volatile)) {
		GType background_job_type_id;
		background_job_type_id = background_job_get_type_once ();
		g_once_init_leave (&background_job_type_id__volatile, background_job_type_id);
	}
	return background_job_type_id__volatile;
}

gpointer
background_job_ref (gpointer instance)
{
	BackgroundJob * self;
	self = instance;
#line 65 "../src/threads/BackgroundJob.vala"
	g_atomic_int_inc (&self->ref_count);
#line 65 "../src/threads/BackgroundJob.vala"
	return instance;
#line 2061 "BackgroundJob.c"
}

void
background_job_unref (gpointer instance)
{
	BackgroundJob * self;
	self = instance;
#line 65 "../src/threads/BackgroundJob.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 65 "../src/threads/BackgroundJob.vala"
		BACKGROUND_JOB_GET_CLASS (self)->finalize (self);
#line 65 "../src/threads/BackgroundJob.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2075 "BackgroundJob.c"
	}
}

