/* file.c generated by valac 0.52.10, the Vala compiler
 * generated from file.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Returns true if the file is claimed, false if it exists, and throws an Error otherwise.  The file*/
/* will be created when the function exits and should be overwritten.  Note that the file is not*/
/* held open; claiming a file is merely based on its existence.*/
/**/
/* This function is thread-safe.*/

#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include <time.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

gboolean claim_file (GFile* file,
                     GError** error);
GFile* generate_unique_file (GFile* dir,
                             const gchar* basename,
                             gboolean* collision,
                             GError** error);
void disassemble_filename (const gchar* basename,
                           gchar** name,
                           gchar** ext);
glong find_last_offset (const gchar* str,
                        gchar c);
guint64 query_total_file_size (GFile* file_or_dir,
                               GCancellable* cancellable,
                               GError** error);
void delete_all_files (GFile* dir,
                       GeeSet* exceptions,
                       ProgressMonitor monitor,
                       gpointer monitor_target,
                       guint64 file_count,
                       GCancellable* cancellable,
                       GError** error);
time_t query_file_modified (GFile* file,
                            GError** error);
gboolean query_is_directory (GFile* file);
gboolean query_is_directory_empty (GFile* dir,
                                   GError** error);
gchar* get_display_pathname (GFile* file);
gchar* strip_pretty_path (const gchar* path);
gchar* get_file_info_id (GFileInfo* info);
guint64 count_files_in_directory (GFile* dir,
                                  GError** error);
gboolean file_equal (GFile* a,
                     GFile* b);
guint file_hash (GFile* file);

static gpointer
_g_error_copy0 (gpointer self)
{
#line 23 "../src/util/file.vala"
	return self ? g_error_copy (self) : NULL;
#line 69 "file.c"
}

gboolean
claim_file (GFile* file,
            GError** error)
{
	gboolean _tmp9_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 12 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 81 "file.c"
	{
		GFileOutputStream* _tmp0_;
		GFileOutputStream* _tmp1_;
#line 14 "../src/util/file.vala"
		_tmp0_ = g_file_create (file, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 14 "../src/util/file.vala"
		_tmp1_ = _tmp0_;
#line 14 "../src/util/file.vala"
		_g_object_unref0 (_tmp1_);
#line 14 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "file.c"
			goto __catch0_g_error;
		}
#line 17 "../src/util/file.vala"
		result = TRUE;
#line 17 "../src/util/file.vala"
		return result;
#line 100 "file.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
#line 13 "../src/util/file.vala"
		err = _inner_error0_;
#line 13 "../src/util/file.vala"
		_inner_error0_ = NULL;
#line 20 "../src/util/file.vala"
		_tmp2_ = err;
#line 20 "../src/util/file.vala"
		if (!g_error_matches (_tmp2_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 115 "file.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
			GError* _tmp5_;
			const gchar* _tmp6_;
			GError* _tmp7_;
			GError* _tmp8_;
#line 21 "../src/util/file.vala"
			_tmp3_ = g_file_get_path (file);
#line 21 "../src/util/file.vala"
			_tmp4_ = _tmp3_;
#line 21 "../src/util/file.vala"
			_tmp5_ = err;
#line 21 "../src/util/file.vala"
			_tmp6_ = _tmp5_->message;
#line 21 "../src/util/file.vala"
			g_warning ("file.vala:21: claim_file %s: %s", _tmp4_, _tmp6_);
#line 21 "../src/util/file.vala"
			_g_free0 (_tmp4_);
#line 23 "../src/util/file.vala"
			_tmp7_ = err;
#line 23 "../src/util/file.vala"
			_tmp8_ = _g_error_copy0 (_tmp7_);
#line 23 "../src/util/file.vala"
			_inner_error0_ = _tmp8_;
#line 23 "../src/util/file.vala"
			_g_error_free0 (err);
#line 142 "file.c"
			goto __finally0;
		}
#line 26 "../src/util/file.vala"
		result = FALSE;
#line 26 "../src/util/file.vala"
		_g_error_free0 (err);
#line 26 "../src/util/file.vala"
		return result;
#line 151 "file.c"
	}
	__finally0:
#line 13 "../src/util/file.vala"
	g_propagate_error (error, _inner_error0_);
#line 13 "../src/util/file.vala"
	return _tmp9_;
#line 158 "file.c"
}

GFile*
generate_unique_file (GFile* dir,
                      const gchar* basename,
                      gboolean* collision,
                      GError** error)
{
	gboolean _vala_collision = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GFile* _tmp2_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	GFile* result = NULL;
#line 36 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()), NULL);
#line 36 "../src/util/file.vala"
	g_return_val_if_fail (basename != NULL, NULL);
#line 38 "../src/util/file.vala"
	_tmp0_ = g_file_get_child (dir, basename);
#line 38 "../src/util/file.vala"
	file = _tmp0_;
#line 39 "../src/util/file.vala"
	_tmp2_ = file;
#line 39 "../src/util/file.vala"
	_tmp1_ = claim_file (_tmp2_, &_inner_error0_);
#line 39 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 39 "../src/util/file.vala"
		_g_object_unref0 (file);
#line 39 "../src/util/file.vala"
		return NULL;
#line 200 "file.c"
	}
#line 39 "../src/util/file.vala"
	if (_tmp1_) {
#line 40 "../src/util/file.vala"
		_vala_collision = FALSE;
#line 42 "../src/util/file.vala"
		result = file;
#line 42 "../src/util/file.vala"
		if (collision) {
#line 42 "../src/util/file.vala"
			*collision = _vala_collision;
#line 212 "file.c"
		}
#line 42 "../src/util/file.vala"
		return result;
#line 216 "file.c"
	}
#line 46 "../src/util/file.vala"
	_vala_collision = TRUE;
#line 49 "../src/util/file.vala"
	disassemble_filename (basename, &_tmp3_, &_tmp4_);
#line 49 "../src/util/file.vala"
	_g_free0 (name);
#line 49 "../src/util/file.vala"
	name = _tmp3_;
#line 49 "../src/util/file.vala"
	_g_free0 (ext);
#line 49 "../src/util/file.vala"
	ext = _tmp4_;
#line 230 "file.c"
	{
		gint ctr = 0;
#line 52 "../src/util/file.vala"
		ctr = 1;
#line 235 "file.c"
		{
			gboolean _tmp5_ = FALSE;
#line 52 "../src/util/file.vala"
			_tmp5_ = TRUE;
#line 52 "../src/util/file.vala"
			while (TRUE) {
#line 242 "file.c"
				gchar* _tmp7_ = NULL;
				const gchar* _tmp8_;
				gchar* new_name = NULL;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				GFile* _tmp16_;
				gboolean _tmp17_ = FALSE;
				GFile* _tmp18_;
#line 52 "../src/util/file.vala"
				if (!_tmp5_) {
#line 253 "file.c"
					gint _tmp6_;
#line 52 "../src/util/file.vala"
					_tmp6_ = ctr;
#line 52 "../src/util/file.vala"
					ctr = _tmp6_ + 1;
#line 259 "file.c"
				}
#line 52 "../src/util/file.vala"
				_tmp5_ = FALSE;
#line 52 "../src/util/file.vala"
				if (!(ctr < G_MAXINT)) {
#line 52 "../src/util/file.vala"
					break;
#line 267 "file.c"
				}
#line 53 "../src/util/file.vala"
				_tmp8_ = ext;
#line 53 "../src/util/file.vala"
				if (_tmp8_ != NULL) {
#line 273 "file.c"
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 53 "../src/util/file.vala"
					_tmp9_ = name;
#line 53 "../src/util/file.vala"
					_tmp10_ = ext;
#line 53 "../src/util/file.vala"
					_tmp11_ = g_strdup_printf ("%s_%d.%s", _tmp9_, ctr, _tmp10_);
#line 53 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 53 "../src/util/file.vala"
					_tmp7_ = _tmp11_;
#line 287 "file.c"
				} else {
					const gchar* _tmp12_;
					gchar* _tmp13_;
#line 53 "../src/util/file.vala"
					_tmp12_ = name;
#line 53 "../src/util/file.vala"
					_tmp13_ = g_strdup_printf ("%s_%d", _tmp12_, ctr);
#line 53 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 53 "../src/util/file.vala"
					_tmp7_ = _tmp13_;
#line 299 "file.c"
				}
#line 53 "../src/util/file.vala"
				_tmp14_ = g_strdup (_tmp7_);
#line 53 "../src/util/file.vala"
				new_name = _tmp14_;
#line 55 "../src/util/file.vala"
				_tmp15_ = new_name;
#line 55 "../src/util/file.vala"
				_tmp16_ = g_file_get_child (dir, _tmp15_);
#line 55 "../src/util/file.vala"
				_g_object_unref0 (file);
#line 55 "../src/util/file.vala"
				file = _tmp16_;
#line 56 "../src/util/file.vala"
				_tmp18_ = file;
#line 56 "../src/util/file.vala"
				_tmp17_ = claim_file (_tmp18_, &_inner_error0_);
#line 56 "../src/util/file.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/util/file.vala"
					g_propagate_error (error, _inner_error0_);
#line 56 "../src/util/file.vala"
					_g_free0 (new_name);
#line 56 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 56 "../src/util/file.vala"
					_g_free0 (ext);
#line 56 "../src/util/file.vala"
					_g_free0 (name);
#line 56 "../src/util/file.vala"
					_g_object_unref0 (file);
#line 56 "../src/util/file.vala"
					return NULL;
#line 333 "file.c"
				}
#line 56 "../src/util/file.vala"
				if (_tmp17_) {
#line 57 "../src/util/file.vala"
					result = file;
#line 57 "../src/util/file.vala"
					_g_free0 (new_name);
#line 57 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 57 "../src/util/file.vala"
					_g_free0 (ext);
#line 57 "../src/util/file.vala"
					_g_free0 (name);
#line 57 "../src/util/file.vala"
					if (collision) {
#line 57 "../src/util/file.vala"
						*collision = _vala_collision;
#line 351 "file.c"
					}
#line 57 "../src/util/file.vala"
					return result;
#line 355 "file.c"
				}
#line 52 "../src/util/file.vala"
				_g_free0 (new_name);
#line 52 "../src/util/file.vala"
				_g_free0 (_tmp7_);
#line 361 "file.c"
			}
		}
	}
#line 60 "../src/util/file.vala"
	_tmp19_ = g_file_get_path (dir);
#line 60 "../src/util/file.vala"
	_tmp20_ = _tmp19_;
#line 60 "../src/util/file.vala"
	g_warning ("file.vala:60: generate_unique_filename %s for %s: unable to claim file", _tmp20_, basename);
#line 60 "../src/util/file.vala"
	_g_free0 (_tmp20_);
#line 62 "../src/util/file.vala"
	result = NULL;
#line 62 "../src/util/file.vala"
	_g_free0 (ext);
#line 62 "../src/util/file.vala"
	_g_free0 (name);
#line 62 "../src/util/file.vala"
	_g_object_unref0 (file);
#line 62 "../src/util/file.vala"
	if (collision) {
#line 62 "../src/util/file.vala"
		*collision = _vala_collision;
#line 385 "file.c"
	}
#line 62 "../src/util/file.vala"
	return result;
#line 389 "file.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
#line 1447 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1447 "glib-2.0.vapi"
	end = _tmp0_;
#line 1448 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1448 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1449 "glib-2.0.vapi"
		result = maxlen;
#line 1449 "glib-2.0.vapi"
		return result;
#line 412 "file.c"
	} else {
		gchar* _tmp2_;
#line 1451 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1451 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1451 "glib-2.0.vapi"
		return result;
#line 421 "file.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1460 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 440 "file.c"
	} else {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 444 "file.c"
	}
#line 1460 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1462 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 450 "file.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1464 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1464 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1464 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 460 "file.c"
	}
#line 1467 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1469 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 468 "file.c"
	} else {
#line 1471 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 472 "file.c"
	}
#line 1473 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1474 "glib-2.0.vapi"
		len = string_length - offset;
#line 478 "file.c"
	}
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1477 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1477 "glib-2.0.vapi"
	result = _tmp3_;
#line 1477 "glib-2.0.vapi"
	return result;
#line 488 "file.c"
}

void
disassemble_filename (const gchar* basename,
                      gchar** name,
                      gchar** ext)
{
	gchar* _vala_name = NULL;
	gchar* _vala_ext = NULL;
	glong offset = 0L;
#line 65 "../src/util/file.vala"
	g_return_if_fail (basename != NULL);
#line 66 "../src/util/file.vala"
	offset = find_last_offset (basename, '.');
#line 67 "../src/util/file.vala"
	if (offset <= ((glong) 0)) {
#line 505 "file.c"
		gchar* _tmp0_;
#line 68 "../src/util/file.vala"
		_tmp0_ = g_strdup (basename);
#line 68 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 68 "../src/util/file.vala"
		_vala_name = _tmp0_;
#line 69 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 69 "../src/util/file.vala"
		_vala_ext = NULL;
#line 517 "file.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 71 "../src/util/file.vala"
		_tmp1_ = string_substring (basename, (glong) 0, offset);
#line 71 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 71 "../src/util/file.vala"
		_vala_name = _tmp1_;
#line 72 "../src/util/file.vala"
		_tmp2_ = string_substring (basename, offset + 1, (glong) -1);
#line 72 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 72 "../src/util/file.vala"
		_vala_ext = _tmp2_;
#line 533 "file.c"
	}
#line 65 "../src/util/file.vala"
	if (name) {
#line 65 "../src/util/file.vala"
		*name = _vala_name;
#line 539 "file.c"
	} else {
#line 65 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 543 "file.c"
	}
#line 65 "../src/util/file.vala"
	if (ext) {
#line 65 "../src/util/file.vala"
		*ext = _vala_ext;
#line 549 "file.c"
	} else {
#line 65 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 553 "file.c"
	}
}

guint64
query_total_file_size (GFile* file_or_dir,
                       GCancellable* cancellable,
                       GError** error)
{
	GFileType type = 0;
	GFileEnumerator* enumerator = NULL;
	guint64 total_bytes = 0ULL;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
#line 77 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file_or_dir, g_file_get_type ()), 0ULL);
#line 77 "../src/util/file.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), 0ULL);
#line 78 "../src/util/file.vala"
	type = g_file_query_file_type (file_or_dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 79 "../src/util/file.vala"
	if (type == G_FILE_TYPE_REGULAR) {
#line 576 "file.c"
		GFileInfo* info = NULL;
		GFileInfo* _tmp11_;
#line 80 "../src/util/file.vala"
		info = NULL;
#line 581 "file.c"
		{
			GFileInfo* _tmp0_ = NULL;
			GFileInfo* _tmp1_;
			GFileInfo* _tmp2_;
#line 82 "../src/util/file.vala"
			_tmp1_ = g_file_query_info (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 82 "../src/util/file.vala"
			_tmp0_ = _tmp1_;
#line 82 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 592 "file.c"
				goto __catch0_g_error;
			}
#line 82 "../src/util/file.vala"
			_tmp2_ = _tmp0_;
#line 82 "../src/util/file.vala"
			_tmp0_ = NULL;
#line 82 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 82 "../src/util/file.vala"
			info = _tmp2_;
#line 81 "../src/util/file.vala"
			_g_object_unref0 (_tmp0_);
#line 605 "file.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp3_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 81 "../src/util/file.vala"
			err = _inner_error0_;
#line 81 "../src/util/file.vala"
			_inner_error0_ = NULL;
#line 85 "../src/util/file.vala"
			_tmp3_ = err;
#line 85 "../src/util/file.vala"
			if (g_error_matches (_tmp3_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 624 "file.c"
				GError* _tmp4_;
				GError* _tmp5_;
#line 86 "../src/util/file.vala"
				_tmp4_ = err;
#line 86 "../src/util/file.vala"
				_tmp5_ = _g_error_copy0 (_tmp4_);
#line 86 "../src/util/file.vala"
				_inner_error0_ = _tmp5_;
#line 86 "../src/util/file.vala"
				_g_error_free0 (err);
#line 635 "file.c"
				goto __finally0;
			}
#line 88 "../src/util/file.vala"
			_tmp6_ = g_file_get_path (file_or_dir);
#line 88 "../src/util/file.vala"
			_tmp7_ = _tmp6_;
#line 88 "../src/util/file.vala"
			_tmp8_ = err;
#line 88 "../src/util/file.vala"
			_tmp9_ = _tmp8_->message;
#line 88 "../src/util/file.vala"
			g_debug ("file.vala:88: Unable to query filesize for %s: %s", _tmp7_, _tmp9_);
#line 88 "../src/util/file.vala"
			_g_free0 (_tmp7_);
#line 90 "../src/util/file.vala"
			result = (guint64) 0;
#line 90 "../src/util/file.vala"
			_g_error_free0 (err);
#line 90 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 90 "../src/util/file.vala"
			return result;
#line 658 "file.c"
		}
		__finally0:
#line 81 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 663 "file.c"
			guint64 _tmp10_ = 0ULL;
#line 81 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 81 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 81 "../src/util/file.vala"
			return _tmp10_;
#line 671 "file.c"
		}
#line 93 "../src/util/file.vala"
		_tmp11_ = info;
#line 93 "../src/util/file.vala"
		result = (guint64) g_file_info_get_size (_tmp11_);
#line 93 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 93 "../src/util/file.vala"
		return result;
#line 681 "file.c"
	} else {
#line 94 "../src/util/file.vala"
		if (type != G_FILE_TYPE_DIRECTORY) {
#line 95 "../src/util/file.vala"
			result = (guint64) 0;
#line 95 "../src/util/file.vala"
			return result;
#line 689 "file.c"
		}
	}
	{
		GFileEnumerator* _tmp12_ = NULL;
		GFileEnumerator* _tmp13_;
		GFileEnumerator* _tmp14_;
		GFileEnumerator* _tmp15_;
#line 100 "../src/util/file.vala"
		_tmp13_ = g_file_enumerate_children (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 100 "../src/util/file.vala"
		_tmp12_ = _tmp13_;
#line 100 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 703 "file.c"
			goto __catch1_g_error;
		}
#line 100 "../src/util/file.vala"
		_tmp14_ = _tmp12_;
#line 100 "../src/util/file.vala"
		_tmp12_ = NULL;
#line 100 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 100 "../src/util/file.vala"
		enumerator = _tmp14_;
#line 102 "../src/util/file.vala"
		_tmp15_ = enumerator;
#line 102 "../src/util/file.vala"
		if (_tmp15_ == NULL) {
#line 103 "../src/util/file.vala"
			result = (guint64) 0;
#line 103 "../src/util/file.vala"
			_g_object_unref0 (_tmp12_);
#line 103 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 103 "../src/util/file.vala"
			return result;
#line 726 "file.c"
		}
#line 99 "../src/util/file.vala"
		_g_object_unref0 (_tmp12_);
#line 730 "file.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		gboolean _tmp16_ = FALSE;
		GError* _tmp17_;
		GError* _tmp19_;
		GError* _tmp20_;
#line 99 "../src/util/file.vala"
		err = _inner_error0_;
#line 99 "../src/util/file.vala"
		_inner_error0_ = NULL;
#line 106 "../src/util/file.vala"
		_tmp17_ = err;
#line 106 "../src/util/file.vala"
		if (g_error_matches (_tmp17_, G_FILE_ERROR, G_FILE_ERROR_PERM)) {
#line 106 "../src/util/file.vala"
			_tmp16_ = TRUE;
#line 750 "file.c"
		} else {
			GError* _tmp18_;
#line 106 "../src/util/file.vala"
			_tmp18_ = err;
#line 106 "../src/util/file.vala"
			_tmp16_ = g_error_matches (_tmp18_, G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED);
#line 757 "file.c"
		}
#line 106 "../src/util/file.vala"
		if (_tmp16_) {
#line 107 "../src/util/file.vala"
			result = (guint64) 0;
#line 107 "../src/util/file.vala"
			_g_error_free0 (err);
#line 107 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 107 "../src/util/file.vala"
			return result;
#line 769 "file.c"
		}
#line 109 "../src/util/file.vala"
		_tmp19_ = err;
#line 109 "../src/util/file.vala"
		_tmp20_ = _g_error_copy0 (_tmp19_);
#line 109 "../src/util/file.vala"
		_inner_error0_ = _tmp20_;
#line 109 "../src/util/file.vala"
		_g_error_free0 (err);
#line 779 "file.c"
		goto __finally1;
	}
	__finally1:
#line 99 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 785 "file.c"
		guint64 _tmp21_ = 0ULL;
#line 99 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 99 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 99 "../src/util/file.vala"
		return _tmp21_;
#line 793 "file.c"
	}
#line 112 "../src/util/file.vala"
	total_bytes = (guint64) 0;
#line 114 "../src/util/file.vala"
	info = NULL;
#line 115 "../src/util/file.vala"
	while (TRUE) {
#line 801 "file.c"
		GFileInfo* _tmp22_ = NULL;
		GFileEnumerator* _tmp23_;
		GFileInfo* _tmp24_;
		GFileInfo* _tmp26_;
		GFileInfo* _tmp27_;
		guint64 _tmp28_ = 0ULL;
		GFileInfo* _tmp29_;
		const gchar* _tmp30_;
		GFile* _tmp31_;
		GFile* _tmp32_;
		guint64 _tmp33_;
#line 115 "../src/util/file.vala"
		_tmp23_ = enumerator;
#line 115 "../src/util/file.vala"
		_tmp24_ = g_file_enumerator_next_file (_tmp23_, cancellable, &_inner_error0_);
#line 115 "../src/util/file.vala"
		_tmp22_ = _tmp24_;
#line 115 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 821 "file.c"
			guint64 _tmp25_ = 0ULL;
#line 115 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 115 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 115 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 115 "../src/util/file.vala"
			return _tmp25_;
#line 831 "file.c"
		}
#line 115 "../src/util/file.vala"
		_tmp26_ = _tmp22_;
#line 115 "../src/util/file.vala"
		_tmp22_ = NULL;
#line 115 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 115 "../src/util/file.vala"
		info = _tmp26_;
#line 115 "../src/util/file.vala"
		_tmp27_ = info;
#line 115 "../src/util/file.vala"
		if (!(_tmp27_ != NULL)) {
#line 115 "../src/util/file.vala"
			_g_object_unref0 (_tmp22_);
#line 115 "../src/util/file.vala"
			break;
#line 849 "file.c"
		}
#line 116 "../src/util/file.vala"
		_tmp29_ = info;
#line 116 "../src/util/file.vala"
		_tmp30_ = g_file_info_get_name (_tmp29_);
#line 116 "../src/util/file.vala"
		_tmp31_ = g_file_get_child (file_or_dir, _tmp30_);
#line 116 "../src/util/file.vala"
		_tmp32_ = _tmp31_;
#line 116 "../src/util/file.vala"
		_tmp33_ = query_total_file_size (_tmp32_, cancellable, &_inner_error0_);
#line 116 "../src/util/file.vala"
		_g_object_unref0 (_tmp32_);
#line 116 "../src/util/file.vala"
		_tmp28_ = _tmp33_;
#line 116 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 867 "file.c"
			guint64 _tmp34_ = 0ULL;
#line 116 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 116 "../src/util/file.vala"
			_g_object_unref0 (_tmp22_);
#line 116 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 116 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 116 "../src/util/file.vala"
			return _tmp34_;
#line 879 "file.c"
		}
#line 116 "../src/util/file.vala"
		total_bytes += _tmp28_;
#line 115 "../src/util/file.vala"
		_g_object_unref0 (_tmp22_);
#line 885 "file.c"
	}
#line 118 "../src/util/file.vala"
	result = total_bytes;
#line 118 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 118 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 118 "../src/util/file.vala"
	return result;
#line 895 "file.c"
}

void
delete_all_files (GFile* dir,
                  GeeSet* exceptions,
                  ProgressMonitor monitor,
                  gpointer monitor_target,
                  guint64 file_count,
                  GCancellable* cancellable,
                  GError** error)
{
	GFileType type = 0;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp6_;
	GFileInfo* info = NULL;
	guint64 i = 0ULL;
	GError* _inner_error0_ = NULL;
#line 125 "../src/util/file.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 125 "../src/util/file.vala"
	g_return_if_fail ((exceptions == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (exceptions, GEE_TYPE_SET));
#line 125 "../src/util/file.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 127 "../src/util/file.vala"
	type = g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 128 "../src/util/file.vala"
	if (type != G_FILE_TYPE_DIRECTORY) {
#line 923 "file.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
#line 129 "../src/util/file.vala"
		_tmp0_ = g_file_get_path (dir);
#line 129 "../src/util/file.vala"
		_tmp1_ = _tmp0_;
#line 129 "../src/util/file.vala"
		_tmp2_ = g_strdup_printf ("%s is not a directory", _tmp1_);
#line 129 "../src/util/file.vala"
		_tmp3_ = _tmp2_;
#line 129 "../src/util/file.vala"
		_tmp4_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_DIRECTORY, _tmp3_);
#line 129 "../src/util/file.vala"
		_tmp5_ = _tmp4_;
#line 129 "../src/util/file.vala"
		_g_free0 (_tmp3_);
#line 129 "../src/util/file.vala"
		_g_free0 (_tmp1_);
#line 129 "../src/util/file.vala"
		_inner_error0_ = _tmp5_;
#line 129 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 129 "../src/util/file.vala"
		return;
#line 952 "file.c"
	}
#line 131 "../src/util/file.vala"
	_tmp6_ = g_file_enumerate_children (dir, "standard::name,standard::type", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 131 "../src/util/file.vala"
	enumerator = _tmp6_;
#line 131 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 131 "../src/util/file.vala"
		return;
#line 964 "file.c"
	}
#line 133 "../src/util/file.vala"
	info = NULL;
#line 134 "../src/util/file.vala"
	i = (guint64) 0;
#line 135 "../src/util/file.vala"
	while (TRUE) {
#line 972 "file.c"
		GFileInfo* _tmp7_ = NULL;
		GFileEnumerator* _tmp8_;
		GFileInfo* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp12_;
		gboolean _tmp13_ = FALSE;
		GFile* file = NULL;
		GFileInfo* _tmp16_;
		const gchar* _tmp17_;
		GFile* _tmp18_;
		gboolean _tmp25_ = FALSE;
#line 135 "../src/util/file.vala"
		_tmp8_ = enumerator;
#line 135 "../src/util/file.vala"
		_tmp9_ = g_file_enumerator_next_file (_tmp8_, cancellable, &_inner_error0_);
#line 135 "../src/util/file.vala"
		_tmp7_ = _tmp9_;
#line 135 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 135 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 135 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 135 "../src/util/file.vala"
			return;
#line 1001 "file.c"
		}
#line 135 "../src/util/file.vala"
		_tmp10_ = _tmp7_;
#line 135 "../src/util/file.vala"
		_tmp7_ = NULL;
#line 135 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 135 "../src/util/file.vala"
		info = _tmp10_;
#line 135 "../src/util/file.vala"
		_tmp11_ = info;
#line 135 "../src/util/file.vala"
		if (!(_tmp11_ != NULL)) {
#line 135 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 135 "../src/util/file.vala"
			break;
#line 1019 "file.c"
		}
#line 136 "../src/util/file.vala"
		_tmp12_ = info;
#line 136 "../src/util/file.vala"
		if (g_file_info_get_file_type (_tmp12_) != G_FILE_TYPE_REGULAR) {
#line 137 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 137 "../src/util/file.vala"
			continue;
#line 1029 "file.c"
		}
#line 139 "../src/util/file.vala"
		if (exceptions != NULL) {
#line 1033 "file.c"
			GFileInfo* _tmp14_;
			const gchar* _tmp15_;
#line 139 "../src/util/file.vala"
			_tmp14_ = info;
#line 139 "../src/util/file.vala"
			_tmp15_ = g_file_info_get_name (_tmp14_);
#line 139 "../src/util/file.vala"
			_tmp13_ = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (exceptions, GEE_TYPE_COLLECTION, GeeCollection), _tmp15_);
#line 1042 "file.c"
		} else {
#line 139 "../src/util/file.vala"
			_tmp13_ = FALSE;
#line 1046 "file.c"
		}
#line 139 "../src/util/file.vala"
		if (_tmp13_) {
#line 140 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 140 "../src/util/file.vala"
			continue;
#line 1054 "file.c"
		}
#line 142 "../src/util/file.vala"
		_tmp16_ = info;
#line 142 "../src/util/file.vala"
		_tmp17_ = g_file_info_get_name (_tmp16_);
#line 142 "../src/util/file.vala"
		_tmp18_ = g_file_get_child (dir, _tmp17_);
#line 142 "../src/util/file.vala"
		file = _tmp18_;
#line 1064 "file.c"
		{
			GFile* _tmp19_;
#line 144 "../src/util/file.vala"
			_tmp19_ = file;
#line 144 "../src/util/file.vala"
			g_file_delete (_tmp19_, cancellable, &_inner_error0_);
#line 144 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1073 "file.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GFile* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			GError* _tmp23_;
			const gchar* _tmp24_;
#line 143 "../src/util/file.vala"
			err = _inner_error0_;
#line 143 "../src/util/file.vala"
			_inner_error0_ = NULL;
#line 146 "../src/util/file.vala"
			_tmp20_ = file;
#line 146 "../src/util/file.vala"
			_tmp21_ = g_file_get_path (_tmp20_);
#line 146 "../src/util/file.vala"
			_tmp22_ = _tmp21_;
#line 146 "../src/util/file.vala"
			_tmp23_ = err;
#line 146 "../src/util/file.vala"
			_tmp24_ = _tmp23_->message;
#line 146 "../src/util/file.vala"
			g_warning ("file.vala:146: Unable to delete file %s: %s", _tmp22_, _tmp24_);
#line 146 "../src/util/file.vala"
			_g_free0 (_tmp22_);
#line 143 "../src/util/file.vala"
			_g_error_free0 (err);
#line 1106 "file.c"
		}
		__finally0:
#line 143 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 143 "../src/util/file.vala"
			_g_object_unref0 (file);
#line 143 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 143 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 143 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 143 "../src/util/file.vala"
			return;
#line 1123 "file.c"
		}
#line 149 "../src/util/file.vala"
		if (monitor != NULL) {
#line 149 "../src/util/file.vala"
			_tmp25_ = file_count > ((guint64) 0);
#line 1129 "file.c"
		} else {
#line 149 "../src/util/file.vala"
			_tmp25_ = FALSE;
#line 1133 "file.c"
		}
#line 149 "../src/util/file.vala"
		if (_tmp25_) {
#line 1137 "file.c"
			ProgressMonitor _tmp26_;
			gpointer _tmp26__target;
			guint64 _tmp27_;
			guint64 _tmp28_;
#line 150 "../src/util/file.vala"
			_tmp26_ = monitor;
#line 150 "../src/util/file.vala"
			_tmp26__target = monitor_target;
#line 150 "../src/util/file.vala"
			_tmp27_ = file_count;
#line 150 "../src/util/file.vala"
			i = i + 1;
#line 150 "../src/util/file.vala"
			_tmp28_ = i;
#line 150 "../src/util/file.vala"
			_tmp26_ (_tmp27_, _tmp28_, TRUE, _tmp26__target);
#line 1154 "file.c"
		}
#line 135 "../src/util/file.vala"
		_g_object_unref0 (file);
#line 135 "../src/util/file.vala"
		_g_object_unref0 (_tmp7_);
#line 1160 "file.c"
	}
#line 125 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 125 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 1166 "file.c"
}

time_t
query_file_modified (GFile* file,
                     GError** error)
{
	GFileInfo* info = NULL;
	GFileInfo* _tmp0_;
	GTimeVal _tmp2_ = {0};
	GError* _inner_error0_ = NULL;
	time_t result = 0;
#line 154 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), 0);
#line 155 "../src/util/file.vala"
	_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 155 "../src/util/file.vala"
	info = _tmp0_;
#line 155 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1186 "file.c"
		time_t _tmp1_ = 0;
#line 155 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 155 "../src/util/file.vala"
		return _tmp1_;
#line 1192 "file.c"
	}
#line 158 "../src/util/file.vala"
	g_file_info_get_modification_time (info, &_tmp2_);
#line 158 "../src/util/file.vala"
	result = (time_t) _tmp2_.tv_sec;
#line 158 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 158 "../src/util/file.vala"
	return result;
#line 1202 "file.c"
}

gboolean
query_is_directory (GFile* file)
{
	gboolean result = FALSE;
#line 161 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 162 "../src/util/file.vala"
	result = g_file_query_file_type (file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) == G_FILE_TYPE_DIRECTORY;
#line 162 "../src/util/file.vala"
	return result;
#line 1215 "file.c"
}

gboolean
query_is_directory_empty (GFile* dir,
                          GError** error)
{
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileEnumerator* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	GFileEnumerator* _tmp4_;
	GFileInfo* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 165 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()), FALSE);
#line 166 "../src/util/file.vala"
	if (g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) != G_FILE_TYPE_DIRECTORY) {
#line 167 "../src/util/file.vala"
		result = FALSE;
#line 167 "../src/util/file.vala"
		return result;
#line 1238 "file.c"
	}
#line 169 "../src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::name", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 169 "../src/util/file.vala"
	enumerator = _tmp0_;
#line 169 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1246 "file.c"
		gboolean _tmp1_ = FALSE;
#line 169 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 169 "../src/util/file.vala"
		return _tmp1_;
#line 1252 "file.c"
	}
#line 171 "../src/util/file.vala"
	_tmp2_ = enumerator;
#line 171 "../src/util/file.vala"
	if (_tmp2_ == NULL) {
#line 172 "../src/util/file.vala"
		result = FALSE;
#line 172 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 172 "../src/util/file.vala"
		return result;
#line 1264 "file.c"
	}
#line 174 "../src/util/file.vala"
	_tmp4_ = enumerator;
#line 174 "../src/util/file.vala"
	_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
#line 174 "../src/util/file.vala"
	_tmp3_ = _tmp5_;
#line 174 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1274 "file.c"
		gboolean _tmp6_ = FALSE;
#line 174 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 174 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 174 "../src/util/file.vala"
		return _tmp6_;
#line 1282 "file.c"
	}
#line 174 "../src/util/file.vala"
	result = _tmp3_ == NULL;
#line 174 "../src/util/file.vala"
	_g_object_unref0 (_tmp3_);
#line 174 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 174 "../src/util/file.vala"
	return result;
#line 1292 "file.c"
}

gchar*
get_display_pathname (GFile* file)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* home = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* result = NULL;
#line 177 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 179 "../src/util/file.vala"
	_tmp0_ = g_file_get_parse_name (file);
#line 179 "../src/util/file.vala"
	path = _tmp0_;
#line 180 "../src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 180 "../src/util/file.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 180 "../src/util/file.vala"
	home = _tmp2_;
#line 182 "../src/util/file.vala"
	_tmp3_ = path;
#line 182 "../src/util/file.vala"
	_tmp4_ = home;
#line 182 "../src/util/file.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
#line 1326 "file.c"
		gchar* _tmp5_;
#line 183 "../src/util/file.vala"
		_tmp5_ = g_strdup ("~");
#line 183 "../src/util/file.vala"
		result = _tmp5_;
#line 183 "../src/util/file.vala"
		_g_free0 (home);
#line 183 "../src/util/file.vala"
		_g_free0 (path);
#line 183 "../src/util/file.vala"
		return result;
#line 1338 "file.c"
	}
#line 185 "../src/util/file.vala"
	_tmp6_ = path;
#line 185 "../src/util/file.vala"
	_tmp7_ = home;
#line 185 "../src/util/file.vala"
	if (g_str_has_prefix (_tmp6_, _tmp7_)) {
#line 1346 "file.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 186 "../src/util/file.vala"
		_tmp8_ = path;
#line 186 "../src/util/file.vala"
		_tmp9_ = home;
#line 186 "../src/util/file.vala"
		_tmp10_ = strlen (_tmp9_);
#line 186 "../src/util/file.vala"
		_tmp11_ = _tmp10_;
#line 186 "../src/util/file.vala"
		_tmp12_ = string_substring (_tmp8_, (glong) _tmp11_, (glong) -1);
#line 186 "../src/util/file.vala"
		_tmp13_ = _tmp12_;
#line 186 "../src/util/file.vala"
		_tmp14_ = g_strdup_printf ("~%s", _tmp13_);
#line 186 "../src/util/file.vala"
		_tmp15_ = _tmp14_;
#line 186 "../src/util/file.vala"
		_g_free0 (_tmp13_);
#line 186 "../src/util/file.vala"
		result = _tmp15_;
#line 186 "../src/util/file.vala"
		_g_free0 (home);
#line 186 "../src/util/file.vala"
		_g_free0 (path);
#line 186 "../src/util/file.vala"
		return result;
#line 1381 "file.c"
	}
#line 188 "../src/util/file.vala"
	result = path;
#line 188 "../src/util/file.vala"
	_g_free0 (home);
#line 188 "../src/util/file.vala"
	return result;
#line 1389 "file.c"
}

gchar*
strip_pretty_path (const gchar* path)
{
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result = NULL;
#line 191 "../src/util/file.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 192 "../src/util/file.vala"
	if (!g_str_has_prefix (path, "~")) {
#line 1405 "file.c"
		gchar* _tmp0_;
#line 193 "../src/util/file.vala"
		_tmp0_ = g_strdup (path);
#line 193 "../src/util/file.vala"
		result = _tmp0_;
#line 193 "../src/util/file.vala"
		return result;
#line 1413 "file.c"
	}
#line 195 "../src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 195 "../src/util/file.vala"
	_tmp2_ = string_substring (path, (glong) 1, (glong) -1);
#line 195 "../src/util/file.vala"
	_tmp3_ = _tmp2_;
#line 195 "../src/util/file.vala"
	_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
#line 195 "../src/util/file.vala"
	_tmp5_ = _tmp4_;
#line 195 "../src/util/file.vala"
	_g_free0 (_tmp3_);
#line 195 "../src/util/file.vala"
	result = _tmp5_;
#line 195 "../src/util/file.vala"
	return result;
#line 1431 "file.c"
}

gchar*
get_file_info_id (GFileInfo* info)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 198 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), NULL);
#line 199 "../src/util/file.vala"
	_tmp0_ = g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_ID_FILE);
#line 199 "../src/util/file.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 199 "../src/util/file.vala"
	result = _tmp1_;
#line 199 "../src/util/file.vala"
	return result;
#line 1450 "file.c"
}

guint64
count_files_in_directory (GFile* dir,
                          GError** error)
{
	guint64 count = 0ULL;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
#line 203 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()), 0ULL);
#line 204 "../src/util/file.vala"
	if (!query_is_directory (dir)) {
#line 205 "../src/util/file.vala"
		result = (guint64) 0;
#line 205 "../src/util/file.vala"
		return result;
#line 1471 "file.c"
	}
#line 207 "../src/util/file.vala"
	count = (guint64) 0;
#line 208 "../src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 208 "../src/util/file.vala"
	enumerator = _tmp0_;
#line 208 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "file.c"
		guint64 _tmp1_ = 0ULL;
#line 208 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 208 "../src/util/file.vala"
		return _tmp1_;
#line 1487 "file.c"
	}
#line 211 "../src/util/file.vala"
	info = NULL;
#line 212 "../src/util/file.vala"
	while (TRUE) {
#line 1493 "file.c"
		GFileInfo* _tmp2_ = NULL;
		GFileEnumerator* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		guint64 _tmp8_;
#line 212 "../src/util/file.vala"
		_tmp3_ = enumerator;
#line 212 "../src/util/file.vala"
		_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error0_);
#line 212 "../src/util/file.vala"
		_tmp2_ = _tmp4_;
#line 212 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1508 "file.c"
			guint64 _tmp5_ = 0ULL;
#line 212 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 212 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 212 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 212 "../src/util/file.vala"
			return _tmp5_;
#line 1518 "file.c"
		}
#line 212 "../src/util/file.vala"
		_tmp6_ = _tmp2_;
#line 212 "../src/util/file.vala"
		_tmp2_ = NULL;
#line 212 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 212 "../src/util/file.vala"
		info = _tmp6_;
#line 212 "../src/util/file.vala"
		_tmp7_ = info;
#line 212 "../src/util/file.vala"
		if (!(_tmp7_ != NULL)) {
#line 212 "../src/util/file.vala"
			_g_object_unref0 (_tmp2_);
#line 212 "../src/util/file.vala"
			break;
#line 1536 "file.c"
		}
#line 213 "../src/util/file.vala"
		_tmp8_ = count;
#line 213 "../src/util/file.vala"
		count = _tmp8_ + 1;
#line 212 "../src/util/file.vala"
		_g_object_unref0 (_tmp2_);
#line 1544 "file.c"
	}
#line 215 "../src/util/file.vala"
	result = count;
#line 215 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 215 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 215 "../src/util/file.vala"
	return result;
#line 1554 "file.c"
}

gboolean
file_equal (GFile* a,
            GFile* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result = FALSE;
#line 219 "../src/util/file.vala"
	g_return_val_if_fail ((a == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (a, g_file_get_type ()), FALSE);
#line 219 "../src/util/file.vala"
	g_return_val_if_fail ((b == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (b, g_file_get_type ()), FALSE);
#line 220 "../src/util/file.vala"
	if (a != NULL) {
#line 220 "../src/util/file.vala"
		_tmp1_ = b != NULL;
#line 1572 "file.c"
	} else {
#line 220 "../src/util/file.vala"
		_tmp1_ = FALSE;
#line 1576 "file.c"
	}
#line 220 "../src/util/file.vala"
	if (_tmp1_) {
#line 220 "../src/util/file.vala"
		_tmp0_ = g_file_equal (a, b);
#line 1582 "file.c"
	} else {
#line 220 "../src/util/file.vala"
		_tmp0_ = FALSE;
#line 1586 "file.c"
	}
#line 220 "../src/util/file.vala"
	result = _tmp0_;
#line 220 "../src/util/file.vala"
	return result;
#line 1592 "file.c"
}

guint
file_hash (GFile* file)
{
	guint _tmp0_ = 0U;
	guint result = 0U;
#line 224 "../src/util/file.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), 0U);
#line 225 "../src/util/file.vala"
	if (file != NULL) {
#line 225 "../src/util/file.vala"
		_tmp0_ = g_file_hash (file);
#line 1606 "file.c"
	} else {
#line 225 "../src/util/file.vala"
		_tmp0_ = (guint) 0;
#line 1610 "file.c"
	}
#line 225 "../src/util/file.vala"
	result = _tmp0_;
#line 225 "../src/util/file.vala"
	return result;
#line 1616 "file.c"
}

