/* VideoReader.c generated by valac 0.52.10, the Vala compiler
 * generated from VideoReader.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "metadata.h"
#include <locale.h>
#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <gio/gunixinputstream.h>
#include <sys/wait.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>

#define TYPE_VIDEO_READER (video_reader_get_type ())
#define VIDEO_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_READER, VideoReader))
#define VIDEO_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_READER, VideoReaderClass))
#define IS_VIDEO_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_READER))
#define IS_VIDEO_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_READER))
#define VIDEO_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_READER, VideoReaderClass))

typedef struct _VideoReader VideoReader;
typedef struct _VideoReaderClass VideoReaderClass;
typedef struct _VideoReaderPrivate VideoReaderPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_VIDEO_IMPORT_PARAMS (video_import_params_get_type ())
#define VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParams))
#define VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))
#define IS_VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_IMPORT_PARAMS))
#define IS_VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_IMPORT_PARAMS))
#define VIDEO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))

typedef struct _VideoImportParams VideoImportParams;
typedef struct _VideoImportParamsClass VideoImportParamsClass;
typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

#define TYPE_IMPORT_RESULT (import_result_get_type ())
typedef struct _VideoImportParamsPrivate VideoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_VIDEO_ROW (video_row_get_type ())
#define VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_ROW, VideoRow))
#define VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_ROW, VideoRowClass))
#define IS_VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_ROW))
#define IS_VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_ROW))
#define VIDEO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_ROW, VideoRowClass))

typedef struct _VideoRow VideoRow;
typedef struct _VideoRowClass VideoRowClass;
#define _video_reader_unref0(var) ((var == NULL) ? NULL : (var = (video_reader_unref (var), NULL)))

#define TYPE_VIDEO_METADATA (video_metadata_get_type ())
#define VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_METADATA, VideoMetadata))
#define VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_METADATA, VideoMetadataClass))
#define IS_VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_METADATA))
#define IS_VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_METADATA))
#define VIDEO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_METADATA, VideoMetadataClass))

typedef struct _VideoMetadata VideoMetadata;
typedef struct _VideoMetadataClass VideoMetadataClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _VideoRowPrivate VideoRowPrivate;

#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
typedef struct _Block16Data Block16Data;
typedef struct _Block17Data Block17Data;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
typedef struct _ParamSpecVideoReader ParamSpecVideoReader;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	VIDEO_ERROR_FILE,
	VIDEO_ERROR_CONTENTS
} VideoError;
#define VIDEO_ERROR video_error_quark ()
struct _VideoReader {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoReaderPrivate * priv;
};

struct _VideoReaderClass {
	GTypeClass parent_class;
	void (*finalize) (VideoReader *self);
};

struct _VideoReaderPrivate {
	gdouble clip_duration;
	GdkPixbuf* preview_frame;
	GFile* file;
	GPid thumbnailer_pid;
	GDateTime* _timestamp;
};

struct _ImportID {
	gint64 id;
};

struct _VideoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoImportParamsPrivate * priv;
	GFile* file;
	ImportID import_id;
	gchar* md5;
	time_t exposure_time_override;
	Thumbnails* thumbnails;
	VideoRow* row;
};

struct _VideoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (VideoImportParams *self);
};

struct _VideoID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _VideoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoRowPrivate * priv;
	VideoID video_id;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	gint width;
	gint height;
	gdouble clip_duration;
	gboolean is_interpretable;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	gchar* md5;
	time_t time_created;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	time_t time_reimported;
	guint64 flags;
	gchar* comment;
};

struct _VideoRowClass {
	GTypeClass parent_class;
	void (*finalize) (VideoRow *self);
};

struct _Block16Data {
	int _ref_count_;
	VideoReader* self;
	guint id;
};

struct _Block17Data {
	int _ref_count_;
	Block16Data * _data16_;
	GCancellable* cancellable;
};

struct _ParamSpecVideoReader {
	GParamSpec parent_instance;
};

static gint VideoReader_private_offset;
static gpointer video_reader_parent_class = NULL;

GQuark video_error_quark (void);
gpointer video_reader_ref (gpointer instance);
void video_reader_unref (gpointer instance);
GParamSpec* param_spec_video_reader (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
void value_set_video_reader (GValue* value,
                             gpointer v_object);
void value_take_video_reader (GValue* value,
                              gpointer v_object);
gpointer value_get_video_reader (const GValue* value);
GType video_reader_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoReader, video_reader_unref)
#define VIDEO_READER_UNKNOWN_CLIP_DURATION (-1.0)
#define VIDEO_READER_THUMBNAILER_TIMEOUT ((guint) 10000)
VideoReader* video_reader_new (GFile* file);
VideoReader* video_reader_construct (GType object_type,
                                     GFile* file);
gboolean video_reader_is_supported_video_file (GFile* file);
gboolean video_reader_is_supported_video_filename (const gchar* filename);
void disassemble_filename (const gchar* basename,
                           gchar** name,
                           gchar** ext);
gint utf8_ci_compare (void* a,
                      void* b);
gpointer video_import_params_ref (gpointer instance);
void video_import_params_unref (gpointer instance);
GParamSpec* param_spec_video_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_video_import_params (GValue* value,
                                    gpointer v_object);
void value_take_video_import_params (GValue* value,
                                     gpointer v_object);
gpointer value_get_video_import_params (const GValue* value);
GType video_import_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoImportParams, video_import_params_unref)
GType import_result_get_type (void) G_GNUC_CONST ;
ImportResult video_reader_prepare_for_import (VideoImportParams* params);
GType import_id_get_type (void) G_GNUC_CONST ;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_thumbnails (GValue* value,
                           gpointer v_object);
void value_take_thumbnails (GValue* value,
                            gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Thumbnails, thumbnails_unref)
gpointer video_row_ref (gpointer instance);
void video_row_unref (gpointer instance);
GParamSpec* param_spec_video_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_video_row (GValue* value,
                          gpointer v_object);
void value_take_video_row (GValue* value,
                           gpointer v_object);
gpointer value_get_video_row (const GValue* value);
GType video_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoRow, video_row_unref)
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
GdkPixbuf* video_reader_read_preview_frame (VideoReader* self);
gdouble video_reader_read_clip_duration (VideoReader* self,
                                         GError** error);
GType video_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoMetadata, media_metadata_unref)
VideoMetadata* video_reader_read_metadata (VideoReader* self,
                                           GError** error);
GDateTime* video_reader_get_timestamp (VideoReader* self);
GType video_id_get_type (void) G_GNUC_CONST ;
VideoID* video_id_dup (const VideoID* self);
void video_id_free (VideoID* self);
GType event_id_get_type (void) G_GNUC_CONST ;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
GType rating_get_type (void) G_GNUC_CONST ;
#define VIDEO_ID_INVALID ((gint64) -1)
void video_id_init (VideoID *self,
                    gint64 id);
#define EVENT_ID_INVALID ((gint64) -1)
void event_id_init (EventID *self,
                    gint64 id);
Thumbnails* thumbnails_new (void);
Thumbnails* thumbnails_construct (GType object_type);
void thumbnail_cache_generate_for_video_frame (Thumbnails* thumbnails,
                                               GdkPixbuf* preview_frame);
static void video_reader_read_internal (VideoReader* self,
                                 GError** error);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static gboolean video_reader_does_file_exist (VideoReader* self);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static gboolean ___lambda11_ (Block17Data* _data17_);
static gboolean ____lambda11__gsource_func (gpointer self);
GFile* app_dirs_get_metadata_helper (void);
static void video_reader_set_timestamp (VideoReader* self,
                                 GDateTime* value);
static gboolean video_reader_on_thumbnailer_timer (VideoReader* self);
static GdkPixbuf* video_reader_thumbnailer (VideoReader* self,
                                     const gchar* video_file);
GFile* app_dirs_get_thumbnailer_bin (void);
static gboolean _video_reader_on_thumbnailer_timer_gsource_func (gpointer self);
GdkPixbuf* resources_get_noninterpretable_badge_pixbuf (void);
VideoMetadata* video_metadata_new (void);
VideoMetadata* video_metadata_construct (GType object_type);
static void video_reader_finalize (VideoReader * obj);
static GType video_reader_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const gchar* VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS[4] = {"bdm", "bdmv", "cpi", "mpl"};

GQuark
video_error_quark (void)
{
	return g_quark_from_static_string ("video-error-quark");
}

static inline gpointer
video_reader_get_instance_private (VideoReader* self)
{
	return G_STRUCT_MEMBER_P (self, VideoReader_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/video-support/VideoReader.vala"
	return self ? g_object_ref (self) : NULL;
#line 391 "VideoReader.c"
}

VideoReader*
video_reader_construct (GType object_type,
                        GFile* file)
{
	VideoReader* self = NULL;
	GFile* _tmp0_;
#line 28 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 28 "../src/video-support/VideoReader.vala"
	self = (VideoReader*) g_type_create_instance (object_type);
#line 29 "../src/video-support/VideoReader.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 29 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->file);
#line 29 "../src/video-support/VideoReader.vala"
	self->priv->file = _tmp0_;
#line 28 "../src/video-support/VideoReader.vala"
	return self;
#line 412 "VideoReader.c"
}

VideoReader*
video_reader_new (GFile* file)
{
#line 28 "../src/video-support/VideoReader.vala"
	return video_reader_construct (TYPE_VIDEO_READER, file);
#line 420 "VideoReader.c"
}

gboolean
video_reader_is_supported_video_file (GFile* file)
{
	gchar* mime_type = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	guchar* _tmp2_;
	guchar* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 32 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp0_ = g_file_get_basename (file);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_new0 (guchar, 0);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp3_ = _tmp2_;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp3__length1 = 0;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp4_ = g_content_type_guess (_tmp1_, _tmp3_, (gsize) 0, NULL);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp5_ = _tmp4_;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp3_ = (g_free (_tmp3_), NULL);
#line 33 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp1_);
#line 33 "../src/video-support/VideoReader.vala"
	mime_type = _tmp5_;
#line 35 "../src/video-support/VideoReader.vala"
	_tmp7_ = mime_type;
#line 35 "../src/video-support/VideoReader.vala"
	if (g_strcmp0 (_tmp7_, "audio/ogg") == 0) {
#line 35 "../src/video-support/VideoReader.vala"
		_tmp6_ = g_file_has_uri_scheme (file, "file");
#line 469 "VideoReader.c"
	} else {
#line 35 "../src/video-support/VideoReader.vala"
		_tmp6_ = FALSE;
#line 473 "VideoReader.c"
	}
#line 35 "../src/video-support/VideoReader.vala"
	if (_tmp6_) {
#line 477 "VideoReader.c"
		{
			GFileInfo* info = NULL;
			GFileInfo* _tmp8_;
			gchar* content_type = NULL;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_ = FALSE;
			const gchar* _tmp13_;
#line 37 "../src/video-support/VideoReader.vala"
			_tmp8_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 37 "../src/video-support/VideoReader.vala"
			info = _tmp8_;
#line 37 "../src/video-support/VideoReader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 493 "VideoReader.c"
				goto __catch0_g_error;
			}
#line 39 "../src/video-support/VideoReader.vala"
			_tmp9_ = info;
#line 39 "../src/video-support/VideoReader.vala"
			_tmp10_ = g_file_info_get_content_type (_tmp9_);
#line 39 "../src/video-support/VideoReader.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 39 "../src/video-support/VideoReader.vala"
			content_type = _tmp11_;
#line 40 "../src/video-support/VideoReader.vala"
			_tmp13_ = content_type;
#line 40 "../src/video-support/VideoReader.vala"
			if (_tmp13_ != NULL) {
#line 508 "VideoReader.c"
				const gchar* _tmp14_;
#line 40 "../src/video-support/VideoReader.vala"
				_tmp14_ = content_type;
#line 40 "../src/video-support/VideoReader.vala"
				_tmp12_ = g_str_has_prefix (_tmp14_, "video/");
#line 514 "VideoReader.c"
			} else {
#line 40 "../src/video-support/VideoReader.vala"
				_tmp12_ = FALSE;
#line 518 "VideoReader.c"
			}
#line 40 "../src/video-support/VideoReader.vala"
			if (_tmp12_) {
#line 41 "../src/video-support/VideoReader.vala"
				result = TRUE;
#line 41 "../src/video-support/VideoReader.vala"
				_g_free0 (content_type);
#line 41 "../src/video-support/VideoReader.vala"
				_g_object_unref0 (info);
#line 41 "../src/video-support/VideoReader.vala"
				_g_free0 (mime_type);
#line 41 "../src/video-support/VideoReader.vala"
				return result;
#line 532 "VideoReader.c"
			}
#line 36 "../src/video-support/VideoReader.vala"
			_g_free0 (content_type);
#line 36 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (info);
#line 538 "VideoReader.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
#line 36 "../src/video-support/VideoReader.vala"
			_error_ = _inner_error0_;
#line 36 "../src/video-support/VideoReader.vala"
			_inner_error0_ = NULL;
#line 44 "../src/video-support/VideoReader.vala"
			_tmp15_ = _error_;
#line 44 "../src/video-support/VideoReader.vala"
			_tmp16_ = _tmp15_->message;
#line 44 "../src/video-support/VideoReader.vala"
			g_debug ("VideoReader.vala:44: Failed to query content type: %s", _tmp16_);
#line 36 "../src/video-support/VideoReader.vala"
			_g_error_free0 (_error_);
#line 558 "VideoReader.c"
		}
		__finally0:
#line 36 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 563 "VideoReader.c"
			gboolean _tmp17_ = FALSE;
#line 36 "../src/video-support/VideoReader.vala"
			_g_free0 (mime_type);
#line 36 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 36 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 36 "../src/video-support/VideoReader.vala"
			return _tmp17_;
#line 573 "VideoReader.c"
		}
	}
#line 48 "../src/video-support/VideoReader.vala"
	_tmp18_ = g_file_get_basename (file);
#line 48 "../src/video-support/VideoReader.vala"
	_tmp19_ = _tmp18_;
#line 48 "../src/video-support/VideoReader.vala"
	_tmp20_ = video_reader_is_supported_video_filename (_tmp19_);
#line 48 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp19_);
#line 48 "../src/video-support/VideoReader.vala"
	result = _tmp20_;
#line 48 "../src/video-support/VideoReader.vala"
	_g_free0 (mime_type);
#line 48 "../src/video-support/VideoReader.vala"
	return result;
#line 590 "VideoReader.c"
}

gboolean
video_reader_is_supported_video_filename (const gchar* filename)
{
	gchar* mime_type = NULL;
	guchar* _tmp0_;
	guchar* _tmp1_;
	gint _tmp1__length1;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean result = FALSE;
#line 51 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 53 "../src/video-support/VideoReader.vala"
	_tmp0_ = g_new0 (guchar, 0);
#line 53 "../src/video-support/VideoReader.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/video-support/VideoReader.vala"
	_tmp1__length1 = 0;
#line 53 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_content_type_guess (filename, _tmp1_, (gsize) 0, NULL);
#line 53 "../src/video-support/VideoReader.vala"
	_g_free0 (mime_type);
#line 53 "../src/video-support/VideoReader.vala"
	mime_type = _tmp2_;
#line 53 "../src/video-support/VideoReader.vala"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 55 "../src/video-support/VideoReader.vala"
	_tmp4_ = mime_type;
#line 55 "../src/video-support/VideoReader.vala"
	if (g_str_has_prefix (_tmp4_, "video/")) {
#line 55 "../src/video-support/VideoReader.vala"
		_tmp3_ = TRUE;
#line 626 "VideoReader.c"
	} else {
		const gchar* _tmp5_;
#line 55 "../src/video-support/VideoReader.vala"
		_tmp5_ = mime_type;
#line 55 "../src/video-support/VideoReader.vala"
		_tmp3_ = g_str_has_suffix (_tmp5_, "mp4");
#line 633 "VideoReader.c"
	}
#line 55 "../src/video-support/VideoReader.vala"
	if (_tmp3_) {
#line 637 "VideoReader.c"
		gchar* extension = NULL;
		gchar* name = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		const gchar* _tmp8_;
#line 56 "../src/video-support/VideoReader.vala"
		extension = NULL;
#line 57 "../src/video-support/VideoReader.vala"
		name = NULL;
#line 58 "../src/video-support/VideoReader.vala"
		disassemble_filename (filename, &_tmp6_, &_tmp7_);
#line 58 "../src/video-support/VideoReader.vala"
		_g_free0 (name);
#line 58 "../src/video-support/VideoReader.vala"
		name = _tmp6_;
#line 58 "../src/video-support/VideoReader.vala"
		_g_free0 (extension);
#line 58 "../src/video-support/VideoReader.vala"
		extension = _tmp7_;
#line 60 "../src/video-support/VideoReader.vala"
		_tmp8_ = extension;
#line 60 "../src/video-support/VideoReader.vala"
		if (_tmp8_ == NULL) {
#line 61 "../src/video-support/VideoReader.vala"
			result = TRUE;
#line 61 "../src/video-support/VideoReader.vala"
			_g_free0 (name);
#line 61 "../src/video-support/VideoReader.vala"
			_g_free0 (extension);
#line 61 "../src/video-support/VideoReader.vala"
			_g_free0 (mime_type);
#line 61 "../src/video-support/VideoReader.vala"
			return result;
#line 671 "VideoReader.c"
		}
		{
			const gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 63 "../src/video-support/VideoReader.vala"
			s_collection = VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS;
#line 63 "../src/video-support/VideoReader.vala"
			s_collection_length1 = G_N_ELEMENTS (VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS);
#line 63 "../src/video-support/VideoReader.vala"
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 684 "VideoReader.c"
				gchar* _tmp9_;
				gchar* s = NULL;
#line 63 "../src/video-support/VideoReader.vala"
				_tmp9_ = g_strdup (s_collection[s_it]);
#line 63 "../src/video-support/VideoReader.vala"
				s = _tmp9_;
#line 691 "VideoReader.c"
				{
					const gchar* _tmp10_;
					const gchar* _tmp11_;
#line 64 "../src/video-support/VideoReader.vala"
					_tmp10_ = s;
#line 64 "../src/video-support/VideoReader.vala"
					_tmp11_ = extension;
#line 64 "../src/video-support/VideoReader.vala"
					if (utf8_ci_compare (_tmp10_, _tmp11_) == 0) {
#line 65 "../src/video-support/VideoReader.vala"
						result = FALSE;
#line 65 "../src/video-support/VideoReader.vala"
						_g_free0 (s);
#line 65 "../src/video-support/VideoReader.vala"
						_g_free0 (name);
#line 65 "../src/video-support/VideoReader.vala"
						_g_free0 (extension);
#line 65 "../src/video-support/VideoReader.vala"
						_g_free0 (mime_type);
#line 65 "../src/video-support/VideoReader.vala"
						return result;
#line 713 "VideoReader.c"
					}
#line 63 "../src/video-support/VideoReader.vala"
					_g_free0 (s);
#line 717 "VideoReader.c"
				}
			}
		}
#line 68 "../src/video-support/VideoReader.vala"
		result = TRUE;
#line 68 "../src/video-support/VideoReader.vala"
		_g_free0 (name);
#line 68 "../src/video-support/VideoReader.vala"
		_g_free0 (extension);
#line 68 "../src/video-support/VideoReader.vala"
		_g_free0 (mime_type);
#line 68 "../src/video-support/VideoReader.vala"
		return result;
#line 731 "VideoReader.c"
	} else {
		const gchar* _tmp12_;
#line 70 "../src/video-support/VideoReader.vala"
		_tmp12_ = mime_type;
#line 70 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:70: Skipping %s, unsupported mime type %s", filename, _tmp12_);
#line 71 "../src/video-support/VideoReader.vala"
		result = FALSE;
#line 71 "../src/video-support/VideoReader.vala"
		_g_free0 (mime_type);
#line 71 "../src/video-support/VideoReader.vala"
		return result;
#line 744 "VideoReader.c"
	}
}

ImportResult
video_reader_prepare_for_import (VideoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp11_;
	GTimeVal _tmp12_ = {0};
	const gchar* _tmp13_;
	time_t exposure_time = 0;
	gchar* title = NULL;
	gchar* _tmp14_;
	gchar* comment = NULL;
	gchar* _tmp15_;
	VideoReader* reader = NULL;
	GFile* _tmp16_;
	VideoReader* _tmp17_;
	gboolean is_interpretable = FALSE;
	gdouble clip_duration = 0.0;
	GdkPixbuf* preview_frame = NULL;
	VideoReader* _tmp18_;
	GdkPixbuf* _tmp19_;
	VideoRow* _tmp49_;
	VideoRow* _tmp50_;
	GFile* _tmp51_;
	gchar* _tmp52_;
	VideoRow* _tmp53_;
	GFileInfo* _tmp54_;
	VideoRow* _tmp55_;
	GTimeVal _tmp56_;
	VideoRow* _tmp57_;
	GdkPixbuf* _tmp58_;
	gint _tmp59_;
	gint _tmp60_;
	VideoRow* _tmp61_;
	GdkPixbuf* _tmp62_;
	gint _tmp63_;
	gint _tmp64_;
	VideoRow* _tmp65_;
	VideoRow* _tmp66_;
	VideoRow* _tmp67_;
	VideoRow* _tmp68_;
	ImportID _tmp69_;
	VideoRow* _tmp70_;
	VideoRow* _tmp71_;
	const gchar* _tmp72_;
	gchar* _tmp73_;
	VideoRow* _tmp74_;
	VideoRow* _tmp75_;
	const gchar* _tmp76_;
	gchar* _tmp77_;
	VideoRow* _tmp78_;
	const gchar* _tmp79_;
	gchar* _tmp80_;
	VideoRow* _tmp81_;
	gchar* _tmp82_;
	VideoRow* _tmp83_;
	VideoRow* _tmp84_;
	Thumbnails* _tmp85_;
	GError* _inner_error0_ = NULL;
	ImportResult result = 0;
#line 75 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_IMPORT_PARAMS (params), 0);
#line 79 "../src/video-support/VideoReader.vala"
	_tmp0_ = params->file;
#line 79 "../src/video-support/VideoReader.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 79 "../src/video-support/VideoReader.vala"
	file = _tmp1_;
#line 81 "../src/video-support/VideoReader.vala"
	info = NULL;
#line 823 "VideoReader.c"
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 83 "../src/video-support/VideoReader.vala"
		_tmp3_ = file;
#line 83 "../src/video-support/VideoReader.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 83 "../src/video-support/VideoReader.vala"
		_tmp2_ = _tmp4_;
#line 83 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 837 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 83 "../src/video-support/VideoReader.vala"
		_tmp5_ = _tmp2_;
#line 83 "../src/video-support/VideoReader.vala"
		_tmp2_ = NULL;
#line 83 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 83 "../src/video-support/VideoReader.vala"
		info = _tmp5_;
#line 82 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_tmp2_);
#line 850 "VideoReader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 82 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 86 "../src/video-support/VideoReader.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 86 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 86 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 86 "../src/video-support/VideoReader.vala"
		return result;
#line 865 "VideoReader.c"
	}
	__finally0:
#line 82 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 82 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 82 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 82 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 82 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 82 "../src/video-support/VideoReader.vala"
		return 0;
#line 880 "VideoReader.c"
	}
#line 89 "../src/video-support/VideoReader.vala"
	_tmp6_ = info;
#line 89 "../src/video-support/VideoReader.vala"
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
#line 90 "../src/video-support/VideoReader.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 90 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 90 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 90 "../src/video-support/VideoReader.vala"
		return result;
#line 894 "VideoReader.c"
	}
#line 92 "../src/video-support/VideoReader.vala"
	_tmp7_ = file;
#line 92 "../src/video-support/VideoReader.vala"
	if (!video_reader_is_supported_video_file (_tmp7_)) {
#line 900 "VideoReader.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 93 "../src/video-support/VideoReader.vala"
		_tmp8_ = file;
#line 93 "../src/video-support/VideoReader.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 93 "../src/video-support/VideoReader.vala"
		_tmp10_ = _tmp9_;
#line 93 "../src/video-support/VideoReader.vala"
		g_message ("Not importing %s: file is marked as a video file but doesn't have a" "supported extension", _tmp10_);
#line 93 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp10_);
#line 96 "../src/video-support/VideoReader.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 96 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 96 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 96 "../src/video-support/VideoReader.vala"
		return result;
#line 922 "VideoReader.c"
	}
#line 99 "../src/video-support/VideoReader.vala"
	_tmp11_ = info;
#line 99 "../src/video-support/VideoReader.vala"
	g_file_info_get_modification_time (_tmp11_, &_tmp12_);
#line 99 "../src/video-support/VideoReader.vala"
	timestamp = _tmp12_;
#line 102 "../src/video-support/VideoReader.vala"
	_tmp13_ = params->md5;
#line 102 "../src/video-support/VideoReader.vala"
	_vala_assert (_tmp13_ != NULL, "params.md5 != null");
#line 104 "../src/video-support/VideoReader.vala"
	exposure_time = params->exposure_time_override;
#line 105 "../src/video-support/VideoReader.vala"
	_tmp14_ = g_strdup ("");
#line 105 "../src/video-support/VideoReader.vala"
	title = _tmp14_;
#line 106 "../src/video-support/VideoReader.vala"
	_tmp15_ = g_strdup ("");
#line 106 "../src/video-support/VideoReader.vala"
	comment = _tmp15_;
#line 108 "../src/video-support/VideoReader.vala"
	_tmp16_ = file;
#line 108 "../src/video-support/VideoReader.vala"
	_tmp17_ = video_reader_new (_tmp16_);
#line 108 "../src/video-support/VideoReader.vala"
	reader = _tmp17_;
#line 109 "../src/video-support/VideoReader.vala"
	is_interpretable = TRUE;
#line 110 "../src/video-support/VideoReader.vala"
	clip_duration = 0.0;
#line 111 "../src/video-support/VideoReader.vala"
	_tmp18_ = reader;
#line 111 "../src/video-support/VideoReader.vala"
	_tmp19_ = video_reader_read_preview_frame (_tmp18_);
#line 111 "../src/video-support/VideoReader.vala"
	preview_frame = _tmp19_;
#line 960 "VideoReader.c"
	{
		gdouble _tmp20_ = 0.0;
		VideoReader* _tmp21_;
#line 113 "../src/video-support/VideoReader.vala"
		_tmp21_ = reader;
#line 113 "../src/video-support/VideoReader.vala"
		_tmp20_ = video_reader_read_clip_duration (_tmp21_, &_inner_error0_);
#line 113 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../src/video-support/VideoReader.vala"
			if (_inner_error0_->domain == VIDEO_ERROR) {
#line 972 "VideoReader.c"
				goto __catch1_video_error;
			}
#line 113 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (preview_frame);
#line 113 "../src/video-support/VideoReader.vala"
			_video_reader_unref0 (reader);
#line 113 "../src/video-support/VideoReader.vala"
			_g_free0 (comment);
#line 113 "../src/video-support/VideoReader.vala"
			_g_free0 (title);
#line 113 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (info);
#line 113 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (file);
#line 113 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 113 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 113 "../src/video-support/VideoReader.vala"
			return 0;
#line 993 "VideoReader.c"
		}
#line 113 "../src/video-support/VideoReader.vala"
		clip_duration = _tmp20_;
#line 997 "VideoReader.c"
	}
	goto __finally1;
	__catch1_video_error:
	{
		GError* err = NULL;
		GError* _tmp22_;
#line 112 "../src/video-support/VideoReader.vala"
		err = _inner_error0_;
#line 112 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 115 "../src/video-support/VideoReader.vala"
		_tmp22_ = err;
#line 115 "../src/video-support/VideoReader.vala"
		if (g_error_matches (_tmp22_, VIDEO_ERROR, VIDEO_ERROR_FILE)) {
#line 116 "../src/video-support/VideoReader.vala"
			result = IMPORT_RESULT_FILE_ERROR;
#line 116 "../src/video-support/VideoReader.vala"
			_g_error_free0 (err);
#line 116 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (preview_frame);
#line 116 "../src/video-support/VideoReader.vala"
			_video_reader_unref0 (reader);
#line 116 "../src/video-support/VideoReader.vala"
			_g_free0 (comment);
#line 116 "../src/video-support/VideoReader.vala"
			_g_free0 (title);
#line 116 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (info);
#line 116 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (file);
#line 116 "../src/video-support/VideoReader.vala"
			return result;
#line 1030 "VideoReader.c"
		} else {
			GError* _tmp23_;
#line 117 "../src/video-support/VideoReader.vala"
			_tmp23_ = err;
#line 117 "../src/video-support/VideoReader.vala"
			if (g_error_matches (_tmp23_, VIDEO_ERROR, VIDEO_ERROR_CONTENTS)) {
#line 118 "../src/video-support/VideoReader.vala"
				is_interpretable = FALSE;
#line 119 "../src/video-support/VideoReader.vala"
				clip_duration = 0.0;
#line 1041 "VideoReader.c"
			} else {
#line 121 "../src/video-support/VideoReader.vala"
				g_error ("VideoReader.vala:121: can't prepare video for import: an unknown kind " \
"of video error occurred");
#line 1045 "VideoReader.c"
			}
		}
#line 112 "../src/video-support/VideoReader.vala"
		_g_error_free0 (err);
#line 1050 "VideoReader.c"
	}
	__finally1:
#line 112 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 112 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (preview_frame);
#line 112 "../src/video-support/VideoReader.vala"
		_video_reader_unref0 (reader);
#line 112 "../src/video-support/VideoReader.vala"
		_g_free0 (comment);
#line 112 "../src/video-support/VideoReader.vala"
		_g_free0 (title);
#line 112 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 112 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 112 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 112 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 112 "../src/video-support/VideoReader.vala"
		return 0;
#line 1073 "VideoReader.c"
	}
	{
		VideoMetadata* metadata = NULL;
		VideoReader* _tmp24_;
		VideoMetadata* _tmp25_;
		MetadataDateTime* creation_date_time = NULL;
		VideoMetadata* _tmp26_;
		MetadataDateTime* _tmp27_;
		gboolean _tmp28_ = FALSE;
		MetadataDateTime* _tmp29_;
		gchar* video_title = NULL;
		VideoMetadata* _tmp32_;
		gchar* _tmp33_;
		gchar* video_comment = NULL;
		VideoMetadata* _tmp34_;
		gchar* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp39_;
#line 126 "../src/video-support/VideoReader.vala"
		_tmp24_ = reader;
#line 126 "../src/video-support/VideoReader.vala"
		_tmp25_ = video_reader_read_metadata (_tmp24_, &_inner_error0_);
#line 126 "../src/video-support/VideoReader.vala"
		metadata = _tmp25_;
#line 126 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1100 "VideoReader.c"
			goto __catch2_g_error;
		}
#line 127 "../src/video-support/VideoReader.vala"
		_tmp26_ = metadata;
#line 127 "../src/video-support/VideoReader.vala"
		_tmp27_ = media_metadata_get_creation_date_time (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 127 "../src/video-support/VideoReader.vala"
		creation_date_time = _tmp27_;
#line 129 "../src/video-support/VideoReader.vala"
		_tmp29_ = creation_date_time;
#line 129 "../src/video-support/VideoReader.vala"
		if (_tmp29_ != NULL) {
#line 1113 "VideoReader.c"
			MetadataDateTime* _tmp30_;
#line 129 "../src/video-support/VideoReader.vala"
			_tmp30_ = creation_date_time;
#line 129 "../src/video-support/VideoReader.vala"
			_tmp28_ = metadata_date_time_get_timestamp (_tmp30_) != ((time_t) 0);
#line 1119 "VideoReader.c"
		} else {
#line 129 "../src/video-support/VideoReader.vala"
			_tmp28_ = FALSE;
#line 1123 "VideoReader.c"
		}
#line 129 "../src/video-support/VideoReader.vala"
		if (_tmp28_) {
#line 1127 "VideoReader.c"
			MetadataDateTime* _tmp31_;
#line 130 "../src/video-support/VideoReader.vala"
			_tmp31_ = creation_date_time;
#line 130 "../src/video-support/VideoReader.vala"
			exposure_time = metadata_date_time_get_timestamp (_tmp31_);
#line 1133 "VideoReader.c"
		}
#line 132 "../src/video-support/VideoReader.vala"
		_tmp32_ = metadata;
#line 132 "../src/video-support/VideoReader.vala"
		_tmp33_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 132 "../src/video-support/VideoReader.vala"
		video_title = _tmp33_;
#line 133 "../src/video-support/VideoReader.vala"
		_tmp34_ = metadata;
#line 133 "../src/video-support/VideoReader.vala"
		_tmp35_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 133 "../src/video-support/VideoReader.vala"
		video_comment = _tmp35_;
#line 134 "../src/video-support/VideoReader.vala"
		_tmp36_ = video_title;
#line 134 "../src/video-support/VideoReader.vala"
		if (_tmp36_ != NULL) {
#line 1151 "VideoReader.c"
			const gchar* _tmp37_;
			gchar* _tmp38_;
#line 135 "../src/video-support/VideoReader.vala"
			_tmp37_ = video_title;
#line 135 "../src/video-support/VideoReader.vala"
			_tmp38_ = g_strdup (_tmp37_);
#line 135 "../src/video-support/VideoReader.vala"
			_g_free0 (title);
#line 135 "../src/video-support/VideoReader.vala"
			title = _tmp38_;
#line 1162 "VideoReader.c"
		}
#line 136 "../src/video-support/VideoReader.vala"
		_tmp39_ = video_comment;
#line 136 "../src/video-support/VideoReader.vala"
		if (_tmp39_ != NULL) {
#line 1168 "VideoReader.c"
			const gchar* _tmp40_;
			gchar* _tmp41_;
#line 137 "../src/video-support/VideoReader.vala"
			_tmp40_ = video_comment;
#line 137 "../src/video-support/VideoReader.vala"
			_tmp41_ = g_strdup (_tmp40_);
#line 137 "../src/video-support/VideoReader.vala"
			_g_free0 (comment);
#line 137 "../src/video-support/VideoReader.vala"
			comment = _tmp41_;
#line 1179 "VideoReader.c"
		}
#line 125 "../src/video-support/VideoReader.vala"
		_g_free0 (video_comment);
#line 125 "../src/video-support/VideoReader.vala"
		_g_free0 (video_title);
#line 125 "../src/video-support/VideoReader.vala"
		_metadata_date_time_unref0 (creation_date_time);
#line 125 "../src/video-support/VideoReader.vala"
		_media_metadata_unref0 (metadata);
#line 1189 "VideoReader.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* err = NULL;
		GError* _tmp42_;
		const gchar* _tmp43_;
#line 125 "../src/video-support/VideoReader.vala"
		err = _inner_error0_;
#line 125 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 139 "../src/video-support/VideoReader.vala"
		_tmp42_ = err;
#line 139 "../src/video-support/VideoReader.vala"
		_tmp43_ = _tmp42_->message;
#line 139 "../src/video-support/VideoReader.vala"
		g_warning ("VideoReader.vala:139: Unable to read video metadata: %s", _tmp43_);
#line 125 "../src/video-support/VideoReader.vala"
		_g_error_free0 (err);
#line 1209 "VideoReader.c"
	}
	__finally2:
#line 125 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (preview_frame);
#line 125 "../src/video-support/VideoReader.vala"
		_video_reader_unref0 (reader);
#line 125 "../src/video-support/VideoReader.vala"
		_g_free0 (comment);
#line 125 "../src/video-support/VideoReader.vala"
		_g_free0 (title);
#line 125 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 125 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 125 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 125 "../src/video-support/VideoReader.vala"
		return 0;
#line 1232 "VideoReader.c"
	}
#line 142 "../src/video-support/VideoReader.vala"
	if (exposure_time == ((time_t) 0)) {
#line 1236 "VideoReader.c"
		gint64 _tmp44_ = 0LL;
		VideoReader* _tmp45_;
		GDateTime* _tmp46_;
#line 144 "../src/video-support/VideoReader.vala"
		_tmp45_ = reader;
#line 144 "../src/video-support/VideoReader.vala"
		_tmp46_ = _tmp45_->priv->_timestamp;
#line 144 "../src/video-support/VideoReader.vala"
		if (_tmp46_ != NULL) {
#line 1246 "VideoReader.c"
			VideoReader* _tmp47_;
			GDateTime* _tmp48_;
#line 145 "../src/video-support/VideoReader.vala"
			_tmp47_ = reader;
#line 145 "../src/video-support/VideoReader.vala"
			_tmp48_ = _tmp47_->priv->_timestamp;
#line 145 "../src/video-support/VideoReader.vala"
			_tmp44_ = g_date_time_to_unix (_tmp48_);
#line 1255 "VideoReader.c"
		} else {
#line 145 "../src/video-support/VideoReader.vala"
			_tmp44_ = (gint64) 0;
#line 1259 "VideoReader.c"
		}
#line 144 "../src/video-support/VideoReader.vala"
		exposure_time = (time_t) _tmp44_;
#line 1263 "VideoReader.c"
	}
#line 148 "../src/video-support/VideoReader.vala"
	_tmp49_ = params->row;
#line 148 "../src/video-support/VideoReader.vala"
	video_id_init (&_tmp49_->video_id, VIDEO_ID_INVALID);
#line 149 "../src/video-support/VideoReader.vala"
	_tmp50_ = params->row;
#line 149 "../src/video-support/VideoReader.vala"
	_tmp51_ = file;
#line 149 "../src/video-support/VideoReader.vala"
	_tmp52_ = g_file_get_path (_tmp51_);
#line 149 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp50_->filepath);
#line 149 "../src/video-support/VideoReader.vala"
	_tmp50_->filepath = _tmp52_;
#line 150 "../src/video-support/VideoReader.vala"
	_tmp53_ = params->row;
#line 150 "../src/video-support/VideoReader.vala"
	_tmp54_ = info;
#line 150 "../src/video-support/VideoReader.vala"
	_tmp53_->filesize = g_file_info_get_size (_tmp54_);
#line 151 "../src/video-support/VideoReader.vala"
	_tmp55_ = params->row;
#line 151 "../src/video-support/VideoReader.vala"
	_tmp56_ = timestamp;
#line 151 "../src/video-support/VideoReader.vala"
	_tmp55_->timestamp = (time_t) _tmp56_.tv_sec;
#line 152 "../src/video-support/VideoReader.vala"
	_tmp57_ = params->row;
#line 152 "../src/video-support/VideoReader.vala"
	_tmp58_ = preview_frame;
#line 152 "../src/video-support/VideoReader.vala"
	_tmp59_ = gdk_pixbuf_get_width (_tmp58_);
#line 152 "../src/video-support/VideoReader.vala"
	_tmp60_ = _tmp59_;
#line 152 "../src/video-support/VideoReader.vala"
	_tmp57_->width = _tmp60_;
#line 153 "../src/video-support/VideoReader.vala"
	_tmp61_ = params->row;
#line 153 "../src/video-support/VideoReader.vala"
	_tmp62_ = preview_frame;
#line 153 "../src/video-support/VideoReader.vala"
	_tmp63_ = gdk_pixbuf_get_height (_tmp62_);
#line 153 "../src/video-support/VideoReader.vala"
	_tmp64_ = _tmp63_;
#line 153 "../src/video-support/VideoReader.vala"
	_tmp61_->height = _tmp64_;
#line 154 "../src/video-support/VideoReader.vala"
	_tmp65_ = params->row;
#line 154 "../src/video-support/VideoReader.vala"
	_tmp65_->clip_duration = clip_duration;
#line 155 "../src/video-support/VideoReader.vala"
	_tmp66_ = params->row;
#line 155 "../src/video-support/VideoReader.vala"
	_tmp66_->is_interpretable = is_interpretable;
#line 156 "../src/video-support/VideoReader.vala"
	_tmp67_ = params->row;
#line 156 "../src/video-support/VideoReader.vala"
	_tmp67_->exposure_time = exposure_time;
#line 157 "../src/video-support/VideoReader.vala"
	_tmp68_ = params->row;
#line 157 "../src/video-support/VideoReader.vala"
	_tmp69_ = params->import_id;
#line 157 "../src/video-support/VideoReader.vala"
	_tmp68_->import_id = _tmp69_;
#line 158 "../src/video-support/VideoReader.vala"
	_tmp70_ = params->row;
#line 158 "../src/video-support/VideoReader.vala"
	event_id_init (&_tmp70_->event_id, EVENT_ID_INVALID);
#line 159 "../src/video-support/VideoReader.vala"
	_tmp71_ = params->row;
#line 159 "../src/video-support/VideoReader.vala"
	_tmp72_ = params->md5;
#line 159 "../src/video-support/VideoReader.vala"
	_tmp73_ = g_strdup (_tmp72_);
#line 159 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp71_->md5);
#line 159 "../src/video-support/VideoReader.vala"
	_tmp71_->md5 = _tmp73_;
#line 160 "../src/video-support/VideoReader.vala"
	_tmp74_ = params->row;
#line 160 "../src/video-support/VideoReader.vala"
	_tmp74_->time_created = (time_t) 0;
#line 161 "../src/video-support/VideoReader.vala"
	_tmp75_ = params->row;
#line 161 "../src/video-support/VideoReader.vala"
	_tmp76_ = title;
#line 161 "../src/video-support/VideoReader.vala"
	_tmp77_ = g_strdup (_tmp76_);
#line 161 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp75_->title);
#line 161 "../src/video-support/VideoReader.vala"
	_tmp75_->title = _tmp77_;
#line 162 "../src/video-support/VideoReader.vala"
	_tmp78_ = params->row;
#line 162 "../src/video-support/VideoReader.vala"
	_tmp79_ = comment;
#line 162 "../src/video-support/VideoReader.vala"
	_tmp80_ = g_strdup (_tmp79_);
#line 162 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp78_->comment);
#line 162 "../src/video-support/VideoReader.vala"
	_tmp78_->comment = _tmp80_;
#line 163 "../src/video-support/VideoReader.vala"
	_tmp81_ = params->row;
#line 163 "../src/video-support/VideoReader.vala"
	_tmp82_ = g_strdup ("");
#line 163 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp81_->backlinks);
#line 163 "../src/video-support/VideoReader.vala"
	_tmp81_->backlinks = _tmp82_;
#line 164 "../src/video-support/VideoReader.vala"
	_tmp83_ = params->row;
#line 164 "../src/video-support/VideoReader.vala"
	_tmp83_->time_reimported = (time_t) 0;
#line 165 "../src/video-support/VideoReader.vala"
	_tmp84_ = params->row;
#line 165 "../src/video-support/VideoReader.vala"
	_tmp84_->flags = (guint64) 0;
#line 167 "../src/video-support/VideoReader.vala"
	_tmp85_ = params->thumbnails;
#line 167 "../src/video-support/VideoReader.vala"
	if (_tmp85_ != NULL) {
#line 1387 "VideoReader.c"
		Thumbnails* _tmp86_;
		Thumbnails* _tmp87_;
		GdkPixbuf* _tmp88_;
#line 168 "../src/video-support/VideoReader.vala"
		_tmp86_ = thumbnails_new ();
#line 168 "../src/video-support/VideoReader.vala"
		_thumbnails_unref0 (params->thumbnails);
#line 168 "../src/video-support/VideoReader.vala"
		params->thumbnails = _tmp86_;
#line 169 "../src/video-support/VideoReader.vala"
		_tmp87_ = params->thumbnails;
#line 169 "../src/video-support/VideoReader.vala"
		_tmp88_ = preview_frame;
#line 169 "../src/video-support/VideoReader.vala"
		thumbnail_cache_generate_for_video_frame (_tmp87_, _tmp88_);
#line 1403 "VideoReader.c"
	}
#line 175 "../src/video-support/VideoReader.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 175 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (preview_frame);
#line 175 "../src/video-support/VideoReader.vala"
	_video_reader_unref0 (reader);
#line 175 "../src/video-support/VideoReader.vala"
	_g_free0 (comment);
#line 175 "../src/video-support/VideoReader.vala"
	_g_free0 (title);
#line 175 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (info);
#line 175 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (file);
#line 175 "../src/video-support/VideoReader.vala"
	return result;
#line 1421 "VideoReader.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 178 "../src/video-support/VideoReader.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 178 "../src/video-support/VideoReader.vala"
	return _data16_;
#line 1431 "VideoReader.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 178 "../src/video-support/VideoReader.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 1441 "VideoReader.c"
		VideoReader* self;
#line 178 "../src/video-support/VideoReader.vala"
		self = _data16_->self;
#line 178 "../src/video-support/VideoReader.vala"
		_video_reader_unref0 (self);
#line 178 "../src/video-support/VideoReader.vala"
		g_slice_free (Block16Data, _data16_);
#line 1449 "VideoReader.c"
	}
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 184 "../src/video-support/VideoReader.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 184 "../src/video-support/VideoReader.vala"
	return _data17_;
#line 1460 "VideoReader.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 184 "../src/video-support/VideoReader.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 1470 "VideoReader.c"
		VideoReader* self;
#line 184 "../src/video-support/VideoReader.vala"
		self = _data17_->_data16_->self;
#line 184 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_data17_->cancellable);
#line 184 "../src/video-support/VideoReader.vala"
		block16_data_unref (_data17_->_data16_);
#line 184 "../src/video-support/VideoReader.vala"
		_data17_->_data16_ = NULL;
#line 184 "../src/video-support/VideoReader.vala"
		g_slice_free (Block17Data, _data17_);
#line 1482 "VideoReader.c"
	}
}

static gboolean
___lambda11_ (Block17Data* _data17_)
{
	Block16Data* _data16_;
	VideoReader* self;
	GCancellable* _tmp0_;
	gboolean result = FALSE;
#line 187 "../src/video-support/VideoReader.vala"
	_data16_ = _data17_->_data16_;
#line 187 "../src/video-support/VideoReader.vala"
	self = _data16_->self;
#line 188 "../src/video-support/VideoReader.vala"
	_tmp0_ = _data17_->cancellable;
#line 188 "../src/video-support/VideoReader.vala"
	g_cancellable_cancel (_tmp0_);
#line 189 "../src/video-support/VideoReader.vala"
	_data16_->id = (guint) 0;
#line 191 "../src/video-support/VideoReader.vala"
	result = FALSE;
#line 191 "../src/video-support/VideoReader.vala"
	return result;
#line 1507 "VideoReader.c"
}

static gboolean
____lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda11_ (self);
#line 187 "../src/video-support/VideoReader.vala"
	return result;
#line 1517 "VideoReader.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
#line 995 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 996 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 996 "glib-2.0.vapi"
	return result;
#line 1530 "VideoReader.c"
}

static void
video_reader_read_internal (VideoReader* self,
                            GError** error)
{
	Block16Data* _data16_;
	GError* _inner_error0_ = NULL;
#line 178 "../src/video-support/VideoReader.vala"
	g_return_if_fail (IS_VIDEO_READER (self));
#line 178 "../src/video-support/VideoReader.vala"
	_data16_ = g_slice_new0 (Block16Data);
#line 178 "../src/video-support/VideoReader.vala"
	_data16_->_ref_count_ = 1;
#line 178 "../src/video-support/VideoReader.vala"
	_data16_->self = video_reader_ref (self);
#line 179 "../src/video-support/VideoReader.vala"
	if (!video_reader_does_file_exist (self)) {
#line 1549 "VideoReader.c"
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 180 "../src/video-support/VideoReader.vala"
		_tmp0_ = self->priv->file;
#line 180 "../src/video-support/VideoReader.vala"
		_tmp1_ = g_file_get_path (_tmp0_);
#line 180 "../src/video-support/VideoReader.vala"
		_tmp2_ = _tmp1_;
#line 180 "../src/video-support/VideoReader.vala"
		_tmp3_ = g_strdup_printf ("video file '%s' does not exist or is inaccessible", _tmp2_);
#line 180 "../src/video-support/VideoReader.vala"
		_tmp4_ = _tmp3_;
#line 180 "../src/video-support/VideoReader.vala"
		_tmp5_ = g_error_new_literal (VIDEO_ERROR, VIDEO_ERROR_FILE, _tmp4_);
#line 180 "../src/video-support/VideoReader.vala"
		_tmp6_ = _tmp5_;
#line 180 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp4_);
#line 180 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp2_);
#line 180 "../src/video-support/VideoReader.vala"
		_inner_error0_ = _tmp6_;
#line 180 "../src/video-support/VideoReader.vala"
		if (_inner_error0_->domain == VIDEO_ERROR) {
#line 180 "../src/video-support/VideoReader.vala"
			g_propagate_error (error, _inner_error0_);
#line 180 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 180 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 180 "../src/video-support/VideoReader.vala"
			return;
#line 1587 "VideoReader.c"
		} else {
#line 180 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 180 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 180 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 180 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 180 "../src/video-support/VideoReader.vala"
			return;
#line 1599 "VideoReader.c"
		}
	}
#line 183 "../src/video-support/VideoReader.vala"
	_data16_->id = (guint) 0;
#line 1604 "VideoReader.c"
	{
		Block17Data* _data17_;
		GCancellable* _tmp7_;
		GBytes* stdout_buf = NULL;
		GBytes* stderr_buf = NULL;
		GSubprocess* process = NULL;
		GFile* _tmp8_;
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GSubprocess* _tmp15_;
		GSubprocess* _tmp16_;
		gboolean _result_ = FALSE;
		GSubprocess* _tmp17_;
		GCancellable* _tmp18_;
		GBytes* _tmp19_ = NULL;
		GBytes* _tmp20_ = NULL;
		gboolean _tmp21_;
		gboolean _tmp22_ = FALSE;
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
#line 184 "../src/video-support/VideoReader.vala"
		_data17_ = g_slice_new0 (Block17Data);
#line 184 "../src/video-support/VideoReader.vala"
		_data17_->_ref_count_ = 1;
#line 184 "../src/video-support/VideoReader.vala"
		_data17_->_data16_ = block16_data_ref (_data16_);
#line 185 "../src/video-support/VideoReader.vala"
		_tmp7_ = g_cancellable_new ();
#line 185 "../src/video-support/VideoReader.vala"
		_data17_->cancellable = _tmp7_;
#line 187 "../src/video-support/VideoReader.vala"
		_data16_->id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 10, ____lambda11__gsource_func, block17_data_ref (_data17_), block17_data_unref);
#line 194 "../src/video-support/VideoReader.vala"
		stdout_buf = NULL;
#line 195 "../src/video-support/VideoReader.vala"
		stderr_buf = NULL;
#line 197 "../src/video-support/VideoReader.vala"
		_tmp8_ = app_dirs_get_metadata_helper ();
#line 197 "../src/video-support/VideoReader.vala"
		_tmp9_ = _tmp8_;
#line 197 "../src/video-support/VideoReader.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 197 "../src/video-support/VideoReader.vala"
		_tmp11_ = _tmp10_;
#line 197 "../src/video-support/VideoReader.vala"
		_tmp12_ = self->priv->file;
#line 197 "../src/video-support/VideoReader.vala"
		_tmp13_ = g_file_get_uri (_tmp12_);
#line 197 "../src/video-support/VideoReader.vala"
		_tmp14_ = _tmp13_;
#line 197 "../src/video-support/VideoReader.vala"
		_tmp15_ = g_subprocess_new (G_SUBPROCESS_FLAGS_STDOUT_PIPE, &_inner_error0_, _tmp11_, _tmp14_, NULL);
#line 197 "../src/video-support/VideoReader.vala"
		_tmp16_ = _tmp15_;
#line 197 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp14_);
#line 197 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp11_);
#line 197 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_tmp9_);
#line 197 "../src/video-support/VideoReader.vala"
		process = _tmp16_;
#line 197 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stderr_buf);
#line 197 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stdout_buf);
#line 197 "../src/video-support/VideoReader.vala"
			block17_data_unref (_data17_);
#line 197 "../src/video-support/VideoReader.vala"
			_data17_ = NULL;
#line 1681 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 198 "../src/video-support/VideoReader.vala"
		_tmp17_ = process;
#line 198 "../src/video-support/VideoReader.vala"
		_tmp18_ = _data17_->cancellable;
#line 198 "../src/video-support/VideoReader.vala"
		_tmp21_ = g_subprocess_communicate (_tmp17_, NULL, _tmp18_, &_tmp19_, &_tmp20_, &_inner_error0_);
#line 198 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stdout_buf);
#line 198 "../src/video-support/VideoReader.vala"
		stdout_buf = _tmp19_;
#line 198 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stderr_buf);
#line 198 "../src/video-support/VideoReader.vala"
		stderr_buf = _tmp20_;
#line 198 "../src/video-support/VideoReader.vala"
		_result_ = _tmp21_;
#line 198 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (process);
#line 198 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stderr_buf);
#line 198 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stdout_buf);
#line 198 "../src/video-support/VideoReader.vala"
			block17_data_unref (_data17_);
#line 198 "../src/video-support/VideoReader.vala"
			_data17_ = NULL;
#line 1712 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 199 "../src/video-support/VideoReader.vala"
		if (_result_) {
#line 1717 "VideoReader.c"
			GSubprocess* _tmp25_;
#line 199 "../src/video-support/VideoReader.vala"
			_tmp25_ = process;
#line 199 "../src/video-support/VideoReader.vala"
			_tmp24_ = g_subprocess_get_exit_status (_tmp25_) == 0;
#line 1723 "VideoReader.c"
		} else {
#line 199 "../src/video-support/VideoReader.vala"
			_tmp24_ = FALSE;
#line 1727 "VideoReader.c"
		}
#line 199 "../src/video-support/VideoReader.vala"
		if (_tmp24_) {
#line 1731 "VideoReader.c"
			GBytes* _tmp26_;
#line 199 "../src/video-support/VideoReader.vala"
			_tmp26_ = stdout_buf;
#line 199 "../src/video-support/VideoReader.vala"
			_tmp23_ = _tmp26_ != NULL;
#line 1737 "VideoReader.c"
		} else {
#line 199 "../src/video-support/VideoReader.vala"
			_tmp23_ = FALSE;
#line 1741 "VideoReader.c"
		}
#line 199 "../src/video-support/VideoReader.vala"
		if (_tmp23_) {
#line 1745 "VideoReader.c"
			GBytes* _tmp27_;
#line 199 "../src/video-support/VideoReader.vala"
			_tmp27_ = stdout_buf;
#line 199 "../src/video-support/VideoReader.vala"
			_tmp22_ = g_bytes_get_size (_tmp27_) > ((gsize) 0);
#line 1751 "VideoReader.c"
		} else {
#line 199 "../src/video-support/VideoReader.vala"
			_tmp22_ = FALSE;
#line 1755 "VideoReader.c"
		}
#line 199 "../src/video-support/VideoReader.vala"
		if (_tmp22_) {
#line 1759 "VideoReader.c"
			gchar** lines = NULL;
			GBytes* _tmp28_;
			gsize _tmp29_ = 0;
			guint8* _tmp30_;
			gchar** _tmp31_;
			gchar** _tmp32_;
			gint lines_length1;
			gint _lines_size_;
			gchar* old = NULL;
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gchar** _tmp35_;
			gint _tmp35__length1;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar** _tmp38_;
			gint _tmp38__length1;
			const gchar* _tmp39_;
#line 200 "../src/video-support/VideoReader.vala"
			_tmp28_ = stdout_buf;
#line 200 "../src/video-support/VideoReader.vala"
			_tmp30_ = g_bytes_get_data (_tmp28_, &_tmp29_);
#line 200 "../src/video-support/VideoReader.vala"
			_tmp32_ = _tmp31_ = g_strsplit ((const gchar*) _tmp30_, "\n", 0);
#line 200 "../src/video-support/VideoReader.vala"
			lines = _tmp32_;
#line 200 "../src/video-support/VideoReader.vala"
			lines_length1 = _vala_array_length (_tmp31_);
#line 200 "../src/video-support/VideoReader.vala"
			_lines_size_ = lines_length1;
#line 202 "../src/video-support/VideoReader.vala"
			_tmp33_ = setlocale (LC_NUMERIC, "C");
#line 202 "../src/video-support/VideoReader.vala"
			_tmp34_ = g_strdup (_tmp33_);
#line 202 "../src/video-support/VideoReader.vala"
			old = _tmp34_;
#line 203 "../src/video-support/VideoReader.vala"
			_tmp35_ = lines;
#line 203 "../src/video-support/VideoReader.vala"
			_tmp35__length1 = lines_length1;
#line 203 "../src/video-support/VideoReader.vala"
			_tmp36_ = _tmp35_[0];
#line 203 "../src/video-support/VideoReader.vala"
			self->priv->clip_duration = double_parse (_tmp36_);
#line 204 "../src/video-support/VideoReader.vala"
			_tmp37_ = old;
#line 204 "../src/video-support/VideoReader.vala"
			setlocale (LC_NUMERIC, _tmp37_);
#line 205 "../src/video-support/VideoReader.vala"
			_tmp38_ = lines;
#line 205 "../src/video-support/VideoReader.vala"
			_tmp38__length1 = lines_length1;
#line 205 "../src/video-support/VideoReader.vala"
			_tmp39_ = _tmp38_[1];
#line 205 "../src/video-support/VideoReader.vala"
			if (g_strcmp0 (_tmp39_, "none") != 0) {
#line 1816 "VideoReader.c"
				gchar** _tmp40_;
				gint _tmp40__length1;
				const gchar* _tmp41_;
				GDateTime* _tmp42_;
				GDateTime* _tmp43_;
#line 206 "../src/video-support/VideoReader.vala"
				_tmp40_ = lines;
#line 206 "../src/video-support/VideoReader.vala"
				_tmp40__length1 = lines_length1;
#line 206 "../src/video-support/VideoReader.vala"
				_tmp41_ = _tmp40_[1];
#line 206 "../src/video-support/VideoReader.vala"
				_tmp42_ = g_date_time_new_from_iso8601 (_tmp41_, NULL);
#line 206 "../src/video-support/VideoReader.vala"
				_tmp43_ = _tmp42_;
#line 206 "../src/video-support/VideoReader.vala"
				video_reader_set_timestamp (self, _tmp43_);
#line 206 "../src/video-support/VideoReader.vala"
				_g_date_time_unref0 (_tmp43_);
#line 1836 "VideoReader.c"
			}
#line 199 "../src/video-support/VideoReader.vala"
			_g_free0 (old);
#line 199 "../src/video-support/VideoReader.vala"
			lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 1842 "VideoReader.c"
		} else {
			gchar* message = NULL;
			gchar* _tmp44_;
			gboolean _tmp45_ = FALSE;
			FILE* _tmp46_;
#line 208 "../src/video-support/VideoReader.vala"
			_tmp44_ = g_strdup ("");
#line 208 "../src/video-support/VideoReader.vala"
			message = _tmp44_;
#line 209 "../src/video-support/VideoReader.vala"
			_tmp46_ = stderr;
#line 209 "../src/video-support/VideoReader.vala"
			if (_tmp46_ != NULL) {
#line 1856 "VideoReader.c"
				GBytes* _tmp47_;
#line 209 "../src/video-support/VideoReader.vala"
				_tmp47_ = stderr_buf;
#line 209 "../src/video-support/VideoReader.vala"
				_tmp45_ = g_bytes_get_size (_tmp47_) > ((gsize) 0);
#line 1862 "VideoReader.c"
			} else {
#line 209 "../src/video-support/VideoReader.vala"
				_tmp45_ = FALSE;
#line 1866 "VideoReader.c"
			}
#line 209 "../src/video-support/VideoReader.vala"
			if (_tmp45_) {
#line 1870 "VideoReader.c"
				GBytes* _tmp48_;
				gsize _tmp49_ = 0;
				guint8* _tmp50_;
				gchar* _tmp51_;
#line 210 "../src/video-support/VideoReader.vala"
				_tmp48_ = stderr_buf;
#line 210 "../src/video-support/VideoReader.vala"
				_tmp50_ = g_bytes_get_data (_tmp48_, &_tmp49_);
#line 210 "../src/video-support/VideoReader.vala"
				_tmp51_ = g_strdup ((const gchar*) _tmp50_);
#line 210 "../src/video-support/VideoReader.vala"
				_g_free0 (message);
#line 210 "../src/video-support/VideoReader.vala"
				message = _tmp51_;
#line 1885 "VideoReader.c"
			}
#line 212 "../src/video-support/VideoReader.vala"
			g_warning ("VideoReader.vala:212: External Metadata helper failed");
#line 199 "../src/video-support/VideoReader.vala"
			_g_free0 (message);
#line 1891 "VideoReader.c"
		}
#line 184 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (process);
#line 184 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stderr_buf);
#line 184 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stdout_buf);
#line 184 "../src/video-support/VideoReader.vala"
		block17_data_unref (_data17_);
#line 184 "../src/video-support/VideoReader.vala"
		_data17_ = NULL;
#line 1903 "VideoReader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp52_;
		const gchar* _tmp53_;
		GError* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		GError* _tmp58_;
		GError* _tmp59_;
#line 184 "../src/video-support/VideoReader.vala"
		e = _inner_error0_;
#line 184 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 215 "../src/video-support/VideoReader.vala"
		_tmp52_ = e;
#line 215 "../src/video-support/VideoReader.vala"
		_tmp53_ = _tmp52_->message;
#line 215 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:215: Video read error: %s", _tmp53_);
#line 216 "../src/video-support/VideoReader.vala"
		_tmp54_ = e;
#line 216 "../src/video-support/VideoReader.vala"
		_tmp55_ = _tmp54_->message;
#line 216 "../src/video-support/VideoReader.vala"
		_tmp56_ = g_strdup_printf ("GStreamer couldn't extract clip information: %s", _tmp55_);
#line 216 "../src/video-support/VideoReader.vala"
		_tmp57_ = _tmp56_;
#line 216 "../src/video-support/VideoReader.vala"
		_tmp58_ = g_error_new_literal (VIDEO_ERROR, VIDEO_ERROR_CONTENTS, _tmp57_);
#line 216 "../src/video-support/VideoReader.vala"
		_tmp59_ = _tmp58_;
#line 216 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp57_);
#line 216 "../src/video-support/VideoReader.vala"
		_inner_error0_ = _tmp59_;
#line 216 "../src/video-support/VideoReader.vala"
		_g_error_free0 (e);
#line 1945 "VideoReader.c"
		goto __finally0;
	}
	__finally0:
#line 184 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "../src/video-support/VideoReader.vala"
		if (_inner_error0_->domain == VIDEO_ERROR) {
#line 184 "../src/video-support/VideoReader.vala"
			g_propagate_error (error, _inner_error0_);
#line 184 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 184 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 184 "../src/video-support/VideoReader.vala"
			return;
#line 1961 "VideoReader.c"
		} else {
#line 184 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 184 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 184 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 184 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 184 "../src/video-support/VideoReader.vala"
			return;
#line 1973 "VideoReader.c"
		}
	}
#line 220 "../src/video-support/VideoReader.vala"
	if (_data16_->id != ((guint) 0)) {
#line 221 "../src/video-support/VideoReader.vala"
		g_source_remove (_data16_->id);
#line 1980 "VideoReader.c"
	}
#line 178 "../src/video-support/VideoReader.vala"
	block16_data_unref (_data16_);
#line 178 "../src/video-support/VideoReader.vala"
	_data16_ = NULL;
#line 1986 "VideoReader.c"
}

static gboolean
video_reader_on_thumbnailer_timer (VideoReader* self)
{
	gboolean result = FALSE;
#line 226 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), FALSE);
#line 227 "../src/video-support/VideoReader.vala"
	g_debug ("VideoReader.vala:227: Thumbnailer timer called");
#line 228 "../src/video-support/VideoReader.vala"
	if (self->priv->thumbnailer_pid != ((GPid) 0)) {
#line 229 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:229: Killing thumbnailer process: %d", (gint) self->priv->thumbnailer_pid);
#line 231 "../src/video-support/VideoReader.vala"
		kill ((pid_t) self->priv->thumbnailer_pid, (gint) SIGKILL);
#line 2003 "VideoReader.c"
	}
#line 236 "../src/video-support/VideoReader.vala"
	result = FALSE;
#line 236 "../src/video-support/VideoReader.vala"
	return result;
#line 2009 "VideoReader.c"
}

static gboolean
_video_reader_on_thumbnailer_timer_gsource_func (gpointer self)
{
	gboolean result;
	result = video_reader_on_thumbnailer_timer ((VideoReader*) self);
#line 259 "../src/video-support/VideoReader.vala"
	return result;
#line 2019 "VideoReader.c"
}

static GdkPixbuf*
video_reader_thumbnailer (VideoReader* self,
                          const gchar* video_file)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** argv = NULL;
	GFile* _tmp4_;
	GFile* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gint argv_length1;
	gint _argv_size_;
	gint child_stdout = 0;
	GdkPixbuf* buf = NULL;
	gint child_status = 0;
	gint ret_waitpid = 0;
	gint _tmp22_ = 0;
	pid_t _tmp23_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 241 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 241 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (video_file != NULL, NULL);
#line 243 "../src/video-support/VideoReader.vala"
	_tmp0_ = app_dirs_get_thumbnailer_bin ();
#line 243 "../src/video-support/VideoReader.vala"
	_tmp1_ = _tmp0_;
#line 243 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 243 "../src/video-support/VideoReader.vala"
	_tmp3_ = _tmp2_;
#line 243 "../src/video-support/VideoReader.vala"
	g_debug ("VideoReader.vala:243: Launching thumbnailer process: %s", _tmp3_);
#line 243 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp3_);
#line 243 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (_tmp1_);
#line 244 "../src/video-support/VideoReader.vala"
	_tmp4_ = app_dirs_get_thumbnailer_bin ();
#line 244 "../src/video-support/VideoReader.vala"
	_tmp5_ = _tmp4_;
#line 244 "../src/video-support/VideoReader.vala"
	_tmp6_ = g_file_get_path (_tmp5_);
#line 244 "../src/video-support/VideoReader.vala"
	_tmp7_ = g_strdup (video_file);
#line 244 "../src/video-support/VideoReader.vala"
	_tmp8_ = g_new0 (gchar*, 2 + 1);
#line 244 "../src/video-support/VideoReader.vala"
	_tmp8_[0] = _tmp6_;
#line 244 "../src/video-support/VideoReader.vala"
	_tmp8_[1] = _tmp7_;
#line 244 "../src/video-support/VideoReader.vala"
	_tmp9_ = _tmp8_;
#line 244 "../src/video-support/VideoReader.vala"
	_tmp9__length1 = 2;
#line 244 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (_tmp5_);
#line 244 "../src/video-support/VideoReader.vala"
	argv = _tmp9_;
#line 244 "../src/video-support/VideoReader.vala"
	argv_length1 = _tmp9__length1;
#line 244 "../src/video-support/VideoReader.vala"
	_argv_size_ = argv_length1;
#line 2092 "VideoReader.c"
	{
		gchar** _tmp10_;
		gint _tmp10__length1;
		GPid _tmp11_ = 0;
		gint _tmp12_ = 0;
#line 247 "../src/video-support/VideoReader.vala"
		_tmp10_ = argv;
#line 247 "../src/video-support/VideoReader.vala"
		_tmp10__length1 = argv_length1;
#line 247 "../src/video-support/VideoReader.vala"
		g_spawn_async_with_pipes (NULL, _tmp10_, NULL, G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp11_, NULL, &_tmp12_, NULL, &_inner_error0_);
#line 247 "../src/video-support/VideoReader.vala"
		self->priv->thumbnailer_pid = _tmp11_;
#line 247 "../src/video-support/VideoReader.vala"
		child_stdout = _tmp12_;
#line 247 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2110 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 250 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:250: Spawned thumbnailer, child pid: %d", (gint) self->priv->thumbnailer_pid);
#line 2115 "VideoReader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 246 "../src/video-support/VideoReader.vala"
		e = _inner_error0_;
#line 246 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 252 "../src/video-support/VideoReader.vala"
		_tmp13_ = e;
#line 252 "../src/video-support/VideoReader.vala"
		_tmp14_ = _tmp13_->message;
#line 252 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:252: Error spawning process: %s", _tmp14_);
#line 253 "../src/video-support/VideoReader.vala"
		if (self->priv->thumbnailer_pid != ((GPid) 0)) {
#line 254 "../src/video-support/VideoReader.vala"
			g_spawn_close_pid (self->priv->thumbnailer_pid);
#line 2137 "VideoReader.c"
		}
#line 255 "../src/video-support/VideoReader.vala"
		result = NULL;
#line 255 "../src/video-support/VideoReader.vala"
		_g_error_free0 (e);
#line 255 "../src/video-support/VideoReader.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 255 "../src/video-support/VideoReader.vala"
		return result;
#line 2147 "VideoReader.c"
	}
	__finally0:
#line 246 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 246 "../src/video-support/VideoReader.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 246 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 246 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 246 "../src/video-support/VideoReader.vala"
		return NULL;
#line 2160 "VideoReader.c"
	}
#line 259 "../src/video-support/VideoReader.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, VIDEO_READER_THUMBNAILER_TIMEOUT, _video_reader_on_thumbnailer_timer_gsource_func, video_reader_ref (self), video_reader_unref);
#line 262 "../src/video-support/VideoReader.vala"
	buf = NULL;
#line 2166 "VideoReader.c"
	{
		GUnixInputStream* unix_input = NULL;
		GUnixInputStream* _tmp15_;
		GdkPixbuf* _tmp16_ = NULL;
		GUnixInputStream* _tmp17_;
		GdkPixbuf* _tmp18_;
		GdkPixbuf* _tmp19_;
#line 264 "../src/video-support/VideoReader.vala"
		_tmp15_ = (GUnixInputStream*) g_unix_input_stream_new (child_stdout, TRUE);
#line 264 "../src/video-support/VideoReader.vala"
		unix_input = _tmp15_;
#line 265 "../src/video-support/VideoReader.vala"
		_tmp17_ = unix_input;
#line 265 "../src/video-support/VideoReader.vala"
		_tmp18_ = gdk_pixbuf_new_from_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, g_input_stream_get_type (), GInputStream), NULL, &_inner_error0_);
#line 265 "../src/video-support/VideoReader.vala"
		_tmp16_ = _tmp18_;
#line 265 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 265 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (unix_input);
#line 2188 "VideoReader.c"
			goto __catch1_g_error;
		}
#line 265 "../src/video-support/VideoReader.vala"
		_tmp19_ = _tmp16_;
#line 265 "../src/video-support/VideoReader.vala"
		_tmp16_ = NULL;
#line 265 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (buf);
#line 265 "../src/video-support/VideoReader.vala"
		buf = _tmp19_;
#line 263 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_tmp16_);
#line 263 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (unix_input);
#line 2203 "VideoReader.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
#line 263 "../src/video-support/VideoReader.vala"
		e = _inner_error0_;
#line 263 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 267 "../src/video-support/VideoReader.vala"
		_tmp20_ = e;
#line 267 "../src/video-support/VideoReader.vala"
		_tmp21_ = _tmp20_->message;
#line 267 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:267: Error creating pixbuf: %s", _tmp21_);
#line 268 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (buf);
#line 268 "../src/video-support/VideoReader.vala"
		buf = NULL;
#line 263 "../src/video-support/VideoReader.vala"
		_g_error_free0 (e);
#line 2227 "VideoReader.c"
	}
	__finally1:
#line 263 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 263 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (buf);
#line 263 "../src/video-support/VideoReader.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 263 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 263 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 263 "../src/video-support/VideoReader.vala"
		return NULL;
#line 2242 "VideoReader.c"
	}
#line 272 "../src/video-support/VideoReader.vala"
	child_status = 0;
#line 273 "../src/video-support/VideoReader.vala"
	_tmp23_ = waitpid ((pid_t) self->priv->thumbnailer_pid, &_tmp22_, 0);
#line 273 "../src/video-support/VideoReader.vala"
	child_status = _tmp22_;
#line 273 "../src/video-support/VideoReader.vala"
	ret_waitpid = (gint) _tmp23_;
#line 274 "../src/video-support/VideoReader.vala"
	if (ret_waitpid < 0) {
#line 275 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:275: waitpid returned error code: %d", ret_waitpid);
#line 276 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (buf);
#line 276 "../src/video-support/VideoReader.vala"
		buf = NULL;
#line 2260 "VideoReader.c"
	} else {
#line 277 "../src/video-support/VideoReader.vala"
		if (0 != WEXITSTATUS (child_status)) {
#line 278 "../src/video-support/VideoReader.vala"
			g_debug ("VideoReader.vala:278: Thumbnailer exited with error code: %d", WEXITSTATUS (child_status));
#line 280 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (buf);
#line 280 "../src/video-support/VideoReader.vala"
			buf = NULL;
#line 2270 "VideoReader.c"
		}
	}
#line 283 "../src/video-support/VideoReader.vala"
	g_spawn_close_pid (self->priv->thumbnailer_pid);
#line 284 "../src/video-support/VideoReader.vala"
	self->priv->thumbnailer_pid = (GPid) 0;
#line 285 "../src/video-support/VideoReader.vala"
	result = buf;
#line 285 "../src/video-support/VideoReader.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 285 "../src/video-support/VideoReader.vala"
	return result;
#line 2283 "VideoReader.c"
}

static gboolean
video_reader_does_file_exist (VideoReader* self)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean result = FALSE;
#line 288 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), FALSE);
#line 289 "../src/video-support/VideoReader.vala"
	_tmp0_ = self->priv->file;
#line 289 "../src/video-support/VideoReader.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 289 "../src/video-support/VideoReader.vala"
	_tmp2_ = _tmp1_;
#line 289 "../src/video-support/VideoReader.vala"
	_tmp3_ = g_file_test (_tmp2_, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_REGULAR);
#line 289 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp2_);
#line 289 "../src/video-support/VideoReader.vala"
	result = _tmp3_;
#line 289 "../src/video-support/VideoReader.vala"
	return result;
#line 2310 "VideoReader.c"
}

GdkPixbuf*
video_reader_read_preview_frame (VideoReader* self)
{
	GdkPixbuf* _tmp0_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* result = NULL;
#line 292 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 293 "../src/video-support/VideoReader.vala"
	_tmp0_ = self->priv->preview_frame;
#line 293 "../src/video-support/VideoReader.vala"
	if (_tmp0_ != NULL) {
#line 2331 "VideoReader.c"
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 294 "../src/video-support/VideoReader.vala"
		_tmp1_ = self->priv->preview_frame;
#line 294 "../src/video-support/VideoReader.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 294 "../src/video-support/VideoReader.vala"
		result = _tmp2_;
#line 294 "../src/video-support/VideoReader.vala"
		return result;
#line 2342 "VideoReader.c"
	}
#line 296 "../src/video-support/VideoReader.vala"
	if (!video_reader_does_file_exist (self)) {
#line 297 "../src/video-support/VideoReader.vala"
		result = NULL;
#line 297 "../src/video-support/VideoReader.vala"
		return result;
#line 2350 "VideoReader.c"
	}
#line 300 "../src/video-support/VideoReader.vala"
	_tmp3_ = self->priv->file;
#line 300 "../src/video-support/VideoReader.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 300 "../src/video-support/VideoReader.vala"
	_tmp5_ = _tmp4_;
#line 300 "../src/video-support/VideoReader.vala"
	_tmp6_ = video_reader_thumbnailer (self, _tmp5_);
#line 300 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->preview_frame);
#line 300 "../src/video-support/VideoReader.vala"
	self->priv->preview_frame = _tmp6_;
#line 300 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp5_);
#line 301 "../src/video-support/VideoReader.vala"
	_tmp7_ = self->priv->preview_frame;
#line 301 "../src/video-support/VideoReader.vala"
	if (NULL == _tmp7_) {
#line 2370 "VideoReader.c"
		GdkPixbuf* _tmp8_;
#line 302 "../src/video-support/VideoReader.vala"
		_tmp8_ = resources_get_noninterpretable_badge_pixbuf ();
#line 302 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (self->priv->preview_frame);
#line 302 "../src/video-support/VideoReader.vala"
		self->priv->preview_frame = _tmp8_;
#line 2378 "VideoReader.c"
	}
#line 304 "../src/video-support/VideoReader.vala"
	_tmp9_ = self->priv->preview_frame;
#line 304 "../src/video-support/VideoReader.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 304 "../src/video-support/VideoReader.vala"
	result = _tmp10_;
#line 304 "../src/video-support/VideoReader.vala"
	return result;
#line 2388 "VideoReader.c"
}

gdouble
video_reader_read_clip_duration (VideoReader* self,
                                 GError** error)
{
	GError* _inner_error0_ = NULL;
	gdouble result = 0.0;
#line 307 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), 0.0);
#line 308 "../src/video-support/VideoReader.vala"
	if (self->priv->clip_duration == VIDEO_READER_UNKNOWN_CLIP_DURATION) {
#line 309 "../src/video-support/VideoReader.vala"
		video_reader_read_internal (self, &_inner_error0_);
#line 309 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 309 "../src/video-support/VideoReader.vala"
			if (_inner_error0_->domain == VIDEO_ERROR) {
#line 2407 "VideoReader.c"
				gdouble _tmp0_ = -1.0;
#line 309 "../src/video-support/VideoReader.vala"
				g_propagate_error (error, _inner_error0_);
#line 309 "../src/video-support/VideoReader.vala"
				return _tmp0_;
#line 2413 "VideoReader.c"
			} else {
				gdouble _tmp1_ = -1.0;
#line 309 "../src/video-support/VideoReader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 309 "../src/video-support/VideoReader.vala"
				g_clear_error (&_inner_error0_);
#line 309 "../src/video-support/VideoReader.vala"
				return _tmp1_;
#line 2422 "VideoReader.c"
			}
		}
	}
#line 311 "../src/video-support/VideoReader.vala"
	result = self->priv->clip_duration;
#line 311 "../src/video-support/VideoReader.vala"
	return result;
#line 2430 "VideoReader.c"
}

VideoMetadata*
video_reader_read_metadata (VideoReader* self,
                            GError** error)
{
	VideoMetadata* metadata = NULL;
	VideoMetadata* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	VideoMetadata* result = NULL;
#line 314 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 315 "../src/video-support/VideoReader.vala"
	_tmp0_ = video_metadata_new ();
#line 315 "../src/video-support/VideoReader.vala"
	metadata = _tmp0_;
#line 316 "../src/video-support/VideoReader.vala"
	_tmp1_ = self->priv->file;
#line 316 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 316 "../src/video-support/VideoReader.vala"
	_tmp3_ = _tmp2_;
#line 316 "../src/video-support/VideoReader.vala"
	_tmp4_ = g_file_new_for_path (_tmp3_);
#line 316 "../src/video-support/VideoReader.vala"
	_tmp5_ = _tmp4_;
#line 316 "../src/video-support/VideoReader.vala"
	media_metadata_read_from_file (G_TYPE_CHECK_INSTANCE_CAST (metadata, TYPE_MEDIA_METADATA, MediaMetadata), _tmp5_, &_inner_error0_);
#line 316 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (_tmp5_);
#line 316 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp3_);
#line 316 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 316 "../src/video-support/VideoReader.vala"
		g_propagate_error (error, _inner_error0_);
#line 316 "../src/video-support/VideoReader.vala"
		_media_metadata_unref0 (metadata);
#line 316 "../src/video-support/VideoReader.vala"
		return NULL;
#line 2476 "VideoReader.c"
	}
#line 318 "../src/video-support/VideoReader.vala"
	result = metadata;
#line 318 "../src/video-support/VideoReader.vala"
	return result;
#line 2482 "VideoReader.c"
}

GDateTime*
video_reader_get_timestamp (VideoReader* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 26 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 26 "../src/video-support/VideoReader.vala"
	_tmp0_ = self->priv->_timestamp;
#line 26 "../src/video-support/VideoReader.vala"
	result = _tmp0_;
#line 26 "../src/video-support/VideoReader.vala"
	return result;
#line 2498 "VideoReader.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 26 "../src/video-support/VideoReader.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 2506 "VideoReader.c"
}

static void
video_reader_set_timestamp (VideoReader* self,
                            GDateTime* value)
{
	GDateTime* _tmp0_;
#line 26 "../src/video-support/VideoReader.vala"
	g_return_if_fail (IS_VIDEO_READER (self));
#line 26 "../src/video-support/VideoReader.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 26 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (self->priv->_timestamp);
#line 26 "../src/video-support/VideoReader.vala"
	self->priv->_timestamp = _tmp0_;
#line 2522 "VideoReader.c"
}

static void
value_video_reader_init (GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	value->data[0].v_pointer = NULL;
#line 2530 "VideoReader.c"
}

static void
value_video_reader_free_value (GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	if (value->data[0].v_pointer) {
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_unref (value->data[0].v_pointer);
#line 2540 "VideoReader.c"
	}
}

static void
value_video_reader_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 15 "../src/video-support/VideoReader.vala"
	if (src_value->data[0].v_pointer) {
#line 15 "../src/video-support/VideoReader.vala"
		dest_value->data[0].v_pointer = video_reader_ref (src_value->data[0].v_pointer);
#line 2552 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2556 "VideoReader.c"
	}
}

static gpointer
value_video_reader_peek_pointer (const GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	return value->data[0].v_pointer;
#line 2565 "VideoReader.c"
}

static gchar*
value_video_reader_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 15 "../src/video-support/VideoReader.vala"
	if (collect_values[0].v_pointer) {
#line 2576 "VideoReader.c"
		VideoReader * object;
		object = collect_values[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
		if (object->parent_instance.g_class == NULL) {
#line 15 "../src/video-support/VideoReader.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2583 "VideoReader.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 15 "../src/video-support/VideoReader.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2587 "VideoReader.c"
		}
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = video_reader_ref (object);
#line 2591 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = NULL;
#line 2595 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	return NULL;
#line 2599 "VideoReader.c"
}

static gchar*
value_video_reader_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	VideoReader ** object_p;
	object_p = collect_values[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
	if (!object_p) {
#line 15 "../src/video-support/VideoReader.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2614 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	if (!value->data[0].v_pointer) {
#line 15 "../src/video-support/VideoReader.vala"
		*object_p = NULL;
#line 2620 "VideoReader.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 15 "../src/video-support/VideoReader.vala"
		*object_p = value->data[0].v_pointer;
#line 2624 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		*object_p = video_reader_ref (value->data[0].v_pointer);
#line 2628 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	return NULL;
#line 2632 "VideoReader.c"
}

GParamSpec*
param_spec_video_reader (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecVideoReader* spec;
#line 15 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_READER), NULL);
#line 15 "../src/video-support/VideoReader.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 15 "../src/video-support/VideoReader.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 15 "../src/video-support/VideoReader.vala"
	return G_PARAM_SPEC (spec);
#line 2651 "VideoReader.c"
}

gpointer
value_get_video_reader (const GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER), NULL);
#line 15 "../src/video-support/VideoReader.vala"
	return value->data[0].v_pointer;
#line 2661 "VideoReader.c"
}

void
value_set_video_reader (GValue* value,
                        gpointer v_object)
{
	VideoReader * old;
#line 15 "../src/video-support/VideoReader.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
	old = value->data[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
	if (v_object) {
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = v_object;
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_ref (value->data[0].v_pointer);
#line 2683 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = NULL;
#line 2687 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	if (old) {
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_unref (old);
#line 2693 "VideoReader.c"
	}
}

void
value_take_video_reader (GValue* value,
                         gpointer v_object)
{
	VideoReader * old;
#line 15 "../src/video-support/VideoReader.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
	old = value->data[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
	if (v_object) {
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = v_object;
#line 2714 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = NULL;
#line 2718 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	if (old) {
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_unref (old);
#line 2724 "VideoReader.c"
	}
}

static void
video_reader_class_init (VideoReaderClass * klass,
                         gpointer klass_data)
{
#line 15 "../src/video-support/VideoReader.vala"
	video_reader_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/video-support/VideoReader.vala"
	((VideoReaderClass *) klass)->finalize = video_reader_finalize;
#line 15 "../src/video-support/VideoReader.vala"
	g_type_class_adjust_private_offset (klass, &VideoReader_private_offset);
#line 2738 "VideoReader.c"
}

static void
video_reader_instance_init (VideoReader * self,
                            gpointer klass)
{
#line 15 "../src/video-support/VideoReader.vala"
	self->priv = video_reader_get_instance_private (self);
#line 22 "../src/video-support/VideoReader.vala"
	self->priv->clip_duration = VIDEO_READER_UNKNOWN_CLIP_DURATION;
#line 23 "../src/video-support/VideoReader.vala"
	self->priv->preview_frame = NULL;
#line 24 "../src/video-support/VideoReader.vala"
	self->priv->file = NULL;
#line 25 "../src/video-support/VideoReader.vala"
	self->priv->thumbnailer_pid = (GPid) 0;
#line 26 "../src/video-support/VideoReader.vala"
	self->priv->_timestamp = NULL;
#line 15 "../src/video-support/VideoReader.vala"
	self->ref_count = 1;
#line 2759 "VideoReader.c"
}

static void
video_reader_finalize (VideoReader * obj)
{
	VideoReader * self;
#line 15 "../src/video-support/VideoReader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_READER, VideoReader);
#line 15 "../src/video-support/VideoReader.vala"
	g_signal_handlers_destroy (self);
#line 23 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->preview_frame);
#line 24 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->file);
#line 26 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (self->priv->_timestamp);
#line 2776 "VideoReader.c"
}

static GType
video_reader_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_video_reader_init, value_video_reader_free_value, value_video_reader_copy_value, value_video_reader_peek_pointer, "p", value_video_reader_collect_value, "p", value_video_reader_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (VideoReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoReader), 0, (GInstanceInitFunc) video_reader_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType video_reader_type_id;
	video_reader_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoReader", &g_define_type_info, &g_define_type_fundamental_info, 0);
	VideoReader_private_offset = g_type_add_instance_private (video_reader_type_id, sizeof (VideoReaderPrivate));
	return video_reader_type_id;
}

GType
video_reader_get_type (void)
{
	static volatile gsize video_reader_type_id__volatile = 0;
	if (g_once_init_enter (&video_reader_type_id__volatile)) {
		GType video_reader_type_id;
		video_reader_type_id = video_reader_get_type_once ();
		g_once_init_leave (&video_reader_type_id__volatile, video_reader_type_id);
	}
	return video_reader_type_id__volatile;
}

gpointer
video_reader_ref (gpointer instance)
{
	VideoReader * self;
	self = instance;
#line 15 "../src/video-support/VideoReader.vala"
	g_atomic_int_inc (&self->ref_count);
#line 15 "../src/video-support/VideoReader.vala"
	return instance;
#line 2812 "VideoReader.c"
}

void
video_reader_unref (gpointer instance)
{
	VideoReader * self;
	self = instance;
#line 15 "../src/video-support/VideoReader.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 15 "../src/video-support/VideoReader.vala"
		VIDEO_READER_GET_CLASS (self)->finalize (self);
#line 15 "../src/video-support/VideoReader.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2826 "VideoReader.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

