/* AVIMetadataLoader.c generated by valac 0.52.10, the Vala compiler
 * generated from AVIMetadataLoader.vala, do not modify */

#include "shotwell-internal-video-metadata-handling.h"
#include <gio/gio.h>
#include <glib.h>
#include "metadata.h"
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_AVI_CHUNK (avi_chunk_get_type ())
#define AVI_CHUNK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AVI_CHUNK, AVIChunk))
#define AVI_CHUNK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AVI_CHUNK, AVIChunkClass))
#define IS_AVI_CHUNK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AVI_CHUNK))
#define IS_AVI_CHUNK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AVI_CHUNK))
#define AVI_CHUNK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AVI_CHUNK, AVIChunkClass))

typedef struct _AVIChunk AVIChunk;
typedef struct _AVIChunkClass AVIChunkClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _avi_chunk_unref0(var) ((var == NULL) ? NULL : (var = (avi_chunk_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ParamSpecAVIMetadataLoader ParamSpecAVIMetadataLoader;

struct _AVIMetadataLoaderPrivate {
	GFile* file;
};

struct _ParamSpecAVIMetadataLoader {
	GParamSpec parent_instance;
};

static gint AVIMetadataLoader_private_offset;
static gpointer avi_metadata_loader_parent_class = NULL;

#define AVI_METADATA_LOADER_NUMERICAL_DATE_LENGTH 19
#define AVI_METADATA_LOADER_NIKON_NCTG_TIMESTAMP_MARKER ((guint16) 0x13)
#define AVI_METADATA_LOADER_MAX_STRD_LENGTH 100
static gulong avi_metadata_loader_get_creation_date_time_for_avi (AVIMetadataLoader* self);
gpointer avi_chunk_ref (gpointer instance);
void avi_chunk_unref (gpointer instance);
GParamSpec* param_spec_avi_chunk (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_avi_chunk (GValue* value,
                          gpointer v_object);
void value_take_avi_chunk (GValue* value,
                           gpointer v_object);
gpointer value_get_avi_chunk (const GValue* value);
GType avi_chunk_get_type (void) G_GNUC_CONST ;
AVIChunk* avi_chunk_new (GFile* file);
AVIChunk* avi_chunk_construct (GType object_type,
                               GFile* file);
void avi_chunk_open_file (AVIChunk* self,
                          GError** error);
void avi_chunk_read_chunk (AVIChunk* self,
                           GError** error);
gchar* avi_chunk_get_current_chunk_name (AVIChunk* self);
gchar* avi_chunk_read_name (AVIChunk* self,
                            GError** error);
void avi_chunk_close_file (AVIChunk* self,
                           GError** error);
static gchar* avi_metadata_loader_read_nikon_nctg_tag (AVIMetadataLoader* self,
                                                AVIChunk* chunk,
                                                GError** error);
guint64 avi_chunk_section_size_remaining (AVIChunk* self);
guint16 avi_chunk_read_uint16 (AVIChunk* self,
                               GError** error);
void avi_chunk_skip (AVIChunk* self,
                     guint64 skip_amount,
                     GError** error);
guchar avi_chunk_read_byte (AVIChunk* self,
                            GError** error);
static gchar* avi_metadata_loader_read_fuji_strd_tag (AVIMetadataLoader* self,
                                               AVIChunk* chunk,
                                               GError** error);
static gchar* avi_metadata_loader_read_section (AVIMetadataLoader* self,
                                         AVIChunk* chunk,
                                         GError** error);
gchar* avi_chunk_section_to_string (AVIChunk* self,
                                    GError** error);
AVIChunk* avi_chunk_get_first_child_chunk (AVIChunk* self);
gboolean avi_chunk_is_last_chunk (AVIChunk* self);
void avi_chunk_next_chunk (AVIChunk* self,
                           GError** error);
static gulong avi_metadata_loader_parse_date (AVIMetadataLoader* self,
                                       const gchar* sdate);
static GDateMonth avi_metadata_loader_month_from_string (AVIMetadataLoader* self,
                                                  const gchar* s);
void avi_chunk_nonsection_skip (AVIChunk* self,
                                guint64 skip_amount,
                                GError** error);
static void avi_metadata_loader_finalize (AVIMetadataLoader * obj);
static GType avi_metadata_loader_get_type_once (void);

static inline gpointer
avi_metadata_loader_get_instance_private (AVIMetadataLoader* self)
{
	return G_STRUCT_MEMBER_P (self, AVIMetadataLoader_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 15 "../src/video-support/AVIMetadataLoader.vala"
	return self ? g_object_ref (self) : NULL;
#line 117 "AVIMetadataLoader.c"
}

AVIMetadataLoader*
avi_metadata_loader_construct (GType object_type,
                               GFile* file)
{
	AVIMetadataLoader* self = NULL;
	GFile* _tmp0_;
#line 14 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 14 "../src/video-support/AVIMetadataLoader.vala"
	self = (AVIMetadataLoader*) g_type_create_instance (object_type);
#line 15 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 15 "../src/video-support/AVIMetadataLoader.vala"
	_g_object_unref0 (self->priv->file);
#line 15 "../src/video-support/AVIMetadataLoader.vala"
	self->priv->file = _tmp0_;
#line 14 "../src/video-support/AVIMetadataLoader.vala"
	return self;
#line 138 "AVIMetadataLoader.c"
}

AVIMetadataLoader*
avi_metadata_loader_new (GFile* file)
{
#line 14 "../src/video-support/AVIMetadataLoader.vala"
	return avi_metadata_loader_construct (TYPE_AVI_METADATA_LOADER, file);
#line 146 "AVIMetadataLoader.c"
}

MetadataDateTime*
avi_metadata_loader_get_creation_date_time (AVIMetadataLoader* self)
{
	MetadataDateTime* _tmp0_;
	MetadataDateTime* result = NULL;
#line 18 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 19 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = metadata_date_time_new ((time_t) avi_metadata_loader_get_creation_date_time_for_avi (self));
#line 19 "../src/video-support/AVIMetadataLoader.vala"
	result = _tmp0_;
#line 19 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 162 "AVIMetadataLoader.c"
}

gchar*
avi_metadata_loader_get_title (AVIMetadataLoader* self)
{
	gchar* result = NULL;
#line 22 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 24 "../src/video-support/AVIMetadataLoader.vala"
	result = NULL;
#line 24 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 175 "AVIMetadataLoader.c"
}

gboolean
avi_metadata_loader_is_supported (AVIMetadataLoader* self)
{
	AVIChunk* chunk = NULL;
	GFile* _tmp0_;
	AVIChunk* _tmp1_;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 28 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), FALSE);
#line 29 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = self->priv->file;
#line 29 "../src/video-support/AVIMetadataLoader.vala"
	_tmp1_ = avi_chunk_new (_tmp0_);
#line 29 "../src/video-support/AVIMetadataLoader.vala"
	chunk = _tmp1_;
#line 30 "../src/video-support/AVIMetadataLoader.vala"
	ret = FALSE;
#line 197 "AVIMetadataLoader.c"
	{
		AVIChunk* _tmp2_;
		AVIChunk* _tmp3_;
		gboolean _tmp4_ = FALSE;
		AVIChunk* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gboolean _tmp8_;
#line 32 "../src/video-support/AVIMetadataLoader.vala"
		_tmp2_ = chunk;
#line 32 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_open_file (_tmp2_, &_inner_error0_);
#line 32 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "AVIMetadataLoader.c"
			goto __catch0_g_error;
		}
#line 33 "../src/video-support/AVIMetadataLoader.vala"
		_tmp3_ = chunk;
#line 33 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_read_chunk (_tmp3_, &_inner_error0_);
#line 33 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "AVIMetadataLoader.c"
			goto __catch0_g_error;
		}
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		_tmp5_ = chunk;
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		_tmp6_ = avi_chunk_get_current_chunk_name (_tmp5_);
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		_tmp7_ = _tmp6_;
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		_tmp8_ = g_strcmp0 ("RIFF", _tmp7_) == 0;
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		_g_free0 (_tmp7_);
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		if (_tmp8_) {
#line 236 "AVIMetadataLoader.c"
			gchar* _tmp9_ = NULL;
			AVIChunk* _tmp10_;
			gchar* _tmp11_;
#line 36 "../src/video-support/AVIMetadataLoader.vala"
			_tmp10_ = chunk;
#line 36 "../src/video-support/AVIMetadataLoader.vala"
			_tmp11_ = avi_chunk_read_name (_tmp10_, &_inner_error0_);
#line 36 "../src/video-support/AVIMetadataLoader.vala"
			_tmp9_ = _tmp11_;
#line 36 "../src/video-support/AVIMetadataLoader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "AVIMetadataLoader.c"
				goto __catch0_g_error;
			}
#line 36 "../src/video-support/AVIMetadataLoader.vala"
			_tmp4_ = g_strcmp0 ("AVI ", _tmp9_) == 0;
#line 35 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (_tmp9_);
#line 255 "AVIMetadataLoader.c"
		} else {
#line 35 "../src/video-support/AVIMetadataLoader.vala"
			_tmp4_ = FALSE;
#line 259 "AVIMetadataLoader.c"
		}
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		if (_tmp4_) {
#line 37 "../src/video-support/AVIMetadataLoader.vala"
			ret = TRUE;
#line 265 "AVIMetadataLoader.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		e = _inner_error0_;
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		_inner_error0_ = NULL;
#line 40 "../src/video-support/AVIMetadataLoader.vala"
		_tmp12_ = e;
#line 40 "../src/video-support/AVIMetadataLoader.vala"
		_tmp13_ = _tmp12_->message;
#line 40 "../src/video-support/AVIMetadataLoader.vala"
		g_debug ("AVIMetadataLoader.vala:40: Error while testing for AVI file: %s", _tmp13_);
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		_g_error_free0 (e);
#line 286 "AVIMetadataLoader.c"
	}
	__finally0:
#line 31 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 291 "AVIMetadataLoader.c"
		gboolean _tmp14_ = FALSE;
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		_avi_chunk_unref0 (chunk);
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		g_clear_error (&_inner_error0_);
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		return _tmp14_;
#line 301 "AVIMetadataLoader.c"
	}
	{
		AVIChunk* _tmp15_;
#line 44 "../src/video-support/AVIMetadataLoader.vala"
		_tmp15_ = chunk;
#line 44 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_close_file (_tmp15_, &_inner_error0_);
#line 44 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 311 "AVIMetadataLoader.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		e = _inner_error0_;
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		_inner_error0_ = NULL;
#line 46 "../src/video-support/AVIMetadataLoader.vala"
		_tmp16_ = e;
#line 46 "../src/video-support/AVIMetadataLoader.vala"
		_tmp17_ = _tmp16_->message;
#line 46 "../src/video-support/AVIMetadataLoader.vala"
		g_debug ("AVIMetadataLoader.vala:46: Error while closing AVI file: %s", _tmp17_);
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		_g_error_free0 (e);
#line 333 "AVIMetadataLoader.c"
	}
	__finally1:
#line 43 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 338 "AVIMetadataLoader.c"
		gboolean _tmp18_ = FALSE;
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		_avi_chunk_unref0 (chunk);
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		g_clear_error (&_inner_error0_);
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		return _tmp18_;
#line 348 "AVIMetadataLoader.c"
	}
#line 48 "../src/video-support/AVIMetadataLoader.vala"
	result = ret;
#line 48 "../src/video-support/AVIMetadataLoader.vala"
	_avi_chunk_unref0 (chunk);
#line 48 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 356 "AVIMetadataLoader.c"
}

static gchar*
avi_metadata_loader_read_nikon_nctg_tag (AVIMetadataLoader* self,
                                         AVIChunk* chunk,
                                         GError** error)
{
	gboolean found_date = FALSE;
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 52 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 52 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_CHUNK (chunk), NULL);
#line 53 "../src/video-support/AVIMetadataLoader.vala"
	found_date = FALSE;
#line 54 "../src/video-support/AVIMetadataLoader.vala"
	while (TRUE) {
#line 376 "AVIMetadataLoader.c"
		guint16 tag = 0U;
		guint16 size = 0U;
#line 54 "../src/video-support/AVIMetadataLoader.vala"
		if (!(avi_chunk_section_size_remaining (chunk) > ((guint64) (sizeof (guint16) * 2)))) {
#line 54 "../src/video-support/AVIMetadataLoader.vala"
			break;
#line 383 "AVIMetadataLoader.c"
		}
#line 55 "../src/video-support/AVIMetadataLoader.vala"
		tag = avi_chunk_read_uint16 (chunk, &_inner_error0_);
#line 55 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 55 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 393 "AVIMetadataLoader.c"
		}
#line 56 "../src/video-support/AVIMetadataLoader.vala"
		size = avi_chunk_read_uint16 (chunk, &_inner_error0_);
#line 56 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 56 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 403 "AVIMetadataLoader.c"
		}
#line 57 "../src/video-support/AVIMetadataLoader.vala"
		if (AVI_METADATA_LOADER_NIKON_NCTG_TIMESTAMP_MARKER == tag) {
#line 58 "../src/video-support/AVIMetadataLoader.vala"
			found_date = TRUE;
#line 59 "../src/video-support/AVIMetadataLoader.vala"
			break;
#line 411 "AVIMetadataLoader.c"
		}
#line 61 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_skip (chunk, (guint64) size, &_inner_error0_);
#line 61 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 61 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 421 "AVIMetadataLoader.c"
		}
	}
#line 64 "../src/video-support/AVIMetadataLoader.vala"
	if (found_date) {
#line 426 "AVIMetadataLoader.c"
		GString* sb = NULL;
		GString* _tmp0_;
		GString* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 66 "../src/video-support/AVIMetadataLoader.vala"
		_tmp0_ = g_string_new ("");
#line 66 "../src/video-support/AVIMetadataLoader.vala"
		sb = _tmp0_;
#line 436 "AVIMetadataLoader.c"
		{
			gint i = 0;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
			i = 0;
#line 441 "AVIMetadataLoader.c"
			{
				gboolean _tmp1_ = FALSE;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
				_tmp1_ = TRUE;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
				while (TRUE) {
#line 448 "AVIMetadataLoader.c"
					guchar _tmp3_ = '\0';
					GString* _tmp4_;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
					if (!_tmp1_) {
#line 453 "AVIMetadataLoader.c"
						gint _tmp2_;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
						_tmp2_ = i;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
						i = _tmp2_ + 1;
#line 459 "AVIMetadataLoader.c"
					}
#line 67 "../src/video-support/AVIMetadataLoader.vala"
					_tmp1_ = FALSE;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
					if (!(i < AVI_METADATA_LOADER_NUMERICAL_DATE_LENGTH)) {
#line 67 "../src/video-support/AVIMetadataLoader.vala"
						break;
#line 467 "AVIMetadataLoader.c"
					}
#line 68 "../src/video-support/AVIMetadataLoader.vala"
					_tmp3_ = avi_chunk_read_byte (chunk, &_inner_error0_);
#line 68 "../src/video-support/AVIMetadataLoader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/video-support/AVIMetadataLoader.vala"
						g_propagate_error (error, _inner_error0_);
#line 68 "../src/video-support/AVIMetadataLoader.vala"
						_g_string_free0 (sb);
#line 68 "../src/video-support/AVIMetadataLoader.vala"
						return NULL;
#line 479 "AVIMetadataLoader.c"
					}
#line 68 "../src/video-support/AVIMetadataLoader.vala"
					_tmp4_ = sb;
#line 68 "../src/video-support/AVIMetadataLoader.vala"
					g_string_append_c (_tmp4_, (gchar) _tmp3_);
#line 485 "AVIMetadataLoader.c"
				}
			}
		}
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		_tmp5_ = sb;
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		_tmp6_ = _tmp5_->str;
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		result = _tmp7_;
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		_g_string_free0 (sb);
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		return result;
#line 501 "AVIMetadataLoader.c"
	}
#line 72 "../src/video-support/AVIMetadataLoader.vala"
	_tmp8_ = g_strdup ("");
#line 72 "../src/video-support/AVIMetadataLoader.vala"
	result = _tmp8_;
#line 72 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 509 "AVIMetadataLoader.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
#line 1447 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1447 "glib-2.0.vapi"
	end = _tmp0_;
#line 1448 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1448 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1449 "glib-2.0.vapi"
		result = maxlen;
#line 1449 "glib-2.0.vapi"
		return result;
#line 532 "AVIMetadataLoader.c"
	} else {
		gchar* _tmp2_;
#line 1451 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1451 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1451 "glib-2.0.vapi"
		return result;
#line 541 "AVIMetadataLoader.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1460 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 560 "AVIMetadataLoader.c"
	} else {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 564 "AVIMetadataLoader.c"
	}
#line 1460 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1462 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 570 "AVIMetadataLoader.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1464 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1464 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1464 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 580 "AVIMetadataLoader.c"
	}
#line 1467 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1469 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 588 "AVIMetadataLoader.c"
	} else {
#line 1471 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 592 "AVIMetadataLoader.c"
	}
#line 1473 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1474 "glib-2.0.vapi"
		len = string_length - offset;
#line 598 "AVIMetadataLoader.c"
	}
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1477 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1477 "glib-2.0.vapi"
	result = _tmp3_;
#line 1477 "glib-2.0.vapi"
	return result;
#line 608 "AVIMetadataLoader.c"
}

static gchar*
avi_metadata_loader_read_fuji_strd_tag (AVIMetadataLoader* self,
                                        AVIChunk* chunk,
                                        GError** error)
{
	gint colons = 0;
	gint post_colons = 0;
	GString* sb = NULL;
	GString* _tmp0_;
	GString* _tmp8_;
	const gchar* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GString* _tmp13_;
	const gchar* _tmp14_;
	GString* _tmp15_;
	const gchar* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 77 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 77 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_CHUNK (chunk), NULL);
#line 78 "../src/video-support/AVIMetadataLoader.vala"
	avi_chunk_skip (chunk, (guint64) 98, &_inner_error0_);
#line 78 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../src/video-support/AVIMetadataLoader.vala"
		g_propagate_error (error, _inner_error0_);
#line 78 "../src/video-support/AVIMetadataLoader.vala"
		return NULL;
#line 645 "AVIMetadataLoader.c"
	}
#line 79 "../src/video-support/AVIMetadataLoader.vala"
	avi_chunk_skip (chunk, (guint64) 8, &_inner_error0_);
#line 79 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/video-support/AVIMetadataLoader.vala"
		g_propagate_error (error, _inner_error0_);
#line 79 "../src/video-support/AVIMetadataLoader.vala"
		return NULL;
#line 655 "AVIMetadataLoader.c"
	}
#line 81 "../src/video-support/AVIMetadataLoader.vala"
	colons = 0;
#line 82 "../src/video-support/AVIMetadataLoader.vala"
	post_colons = 0;
#line 83 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = g_string_new ("");
#line 83 "../src/video-support/AVIMetadataLoader.vala"
	sb = _tmp0_;
#line 85 "../src/video-support/AVIMetadataLoader.vala"
	while (TRUE) {
#line 667 "AVIMetadataLoader.c"
		gboolean _tmp1_ = FALSE;
		guchar _tmp2_ = '\0';
		gchar c = '\0';
		GString* _tmp6_;
#line 85 "../src/video-support/AVIMetadataLoader.vala"
		if (colons <= 4) {
#line 85 "../src/video-support/AVIMetadataLoader.vala"
			_tmp1_ = post_colons < 2;
#line 676 "AVIMetadataLoader.c"
		} else {
#line 85 "../src/video-support/AVIMetadataLoader.vala"
			_tmp1_ = FALSE;
#line 680 "AVIMetadataLoader.c"
		}
#line 85 "../src/video-support/AVIMetadataLoader.vala"
		if (!_tmp1_) {
#line 85 "../src/video-support/AVIMetadataLoader.vala"
			break;
#line 686 "AVIMetadataLoader.c"
		}
#line 86 "../src/video-support/AVIMetadataLoader.vala"
		_tmp2_ = avi_chunk_read_byte (chunk, &_inner_error0_);
#line 86 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 86 "../src/video-support/AVIMetadataLoader.vala"
			_g_string_free0 (sb);
#line 86 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 698 "AVIMetadataLoader.c"
		}
#line 86 "../src/video-support/AVIMetadataLoader.vala"
		c = (gchar) _tmp2_;
#line 87 "../src/video-support/AVIMetadataLoader.vala"
		if (4 == colons) {
#line 704 "AVIMetadataLoader.c"
			gint _tmp3_;
#line 88 "../src/video-support/AVIMetadataLoader.vala"
			_tmp3_ = post_colons;
#line 88 "../src/video-support/AVIMetadataLoader.vala"
			post_colons = _tmp3_ + 1;
#line 710 "AVIMetadataLoader.c"
		}
#line 90 "../src/video-support/AVIMetadataLoader.vala"
		if (':' == c) {
#line 714 "AVIMetadataLoader.c"
			gint _tmp4_;
#line 91 "../src/video-support/AVIMetadataLoader.vala"
			_tmp4_ = colons;
#line 91 "../src/video-support/AVIMetadataLoader.vala"
			colons = _tmp4_ + 1;
#line 720 "AVIMetadataLoader.c"
		}
#line 93 "../src/video-support/AVIMetadataLoader.vala"
		if (g_ascii_isprint (c)) {
#line 724 "AVIMetadataLoader.c"
			GString* _tmp5_;
#line 94 "../src/video-support/AVIMetadataLoader.vala"
			_tmp5_ = sb;
#line 94 "../src/video-support/AVIMetadataLoader.vala"
			g_string_append_c (_tmp5_, c);
#line 730 "AVIMetadataLoader.c"
		}
#line 96 "../src/video-support/AVIMetadataLoader.vala"
		_tmp6_ = sb;
#line 96 "../src/video-support/AVIMetadataLoader.vala"
		if (_tmp6_->len > ((gssize) AVI_METADATA_LOADER_MAX_STRD_LENGTH)) {
#line 736 "AVIMetadataLoader.c"
			gchar* _tmp7_;
#line 97 "../src/video-support/AVIMetadataLoader.vala"
			_tmp7_ = g_strdup ("");
#line 97 "../src/video-support/AVIMetadataLoader.vala"
			result = _tmp7_;
#line 97 "../src/video-support/AVIMetadataLoader.vala"
			_g_string_free0 (sb);
#line 97 "../src/video-support/AVIMetadataLoader.vala"
			return result;
#line 746 "AVIMetadataLoader.c"
		}
	}
#line 101 "../src/video-support/AVIMetadataLoader.vala"
	_tmp8_ = sb;
#line 101 "../src/video-support/AVIMetadataLoader.vala"
	_tmp9_ = _tmp8_->str;
#line 101 "../src/video-support/AVIMetadataLoader.vala"
	_tmp10_ = strlen (_tmp9_);
#line 101 "../src/video-support/AVIMetadataLoader.vala"
	_tmp11_ = _tmp10_;
#line 101 "../src/video-support/AVIMetadataLoader.vala"
	if (_tmp11_ < AVI_METADATA_LOADER_NUMERICAL_DATE_LENGTH) {
#line 759 "AVIMetadataLoader.c"
		gchar* _tmp12_;
#line 102 "../src/video-support/AVIMetadataLoader.vala"
		_tmp12_ = g_strdup ("");
#line 102 "../src/video-support/AVIMetadataLoader.vala"
		result = _tmp12_;
#line 102 "../src/video-support/AVIMetadataLoader.vala"
		_g_string_free0 (sb);
#line 102 "../src/video-support/AVIMetadataLoader.vala"
		return result;
#line 769 "AVIMetadataLoader.c"
	}
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp13_ = sb;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp14_ = _tmp13_->str;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp15_ = sb;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp16_ = _tmp15_->str;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp17_ = strlen (_tmp16_);
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp18_ = _tmp17_;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp19_ = string_substring (_tmp14_, (glong) (_tmp18_ - AVI_METADATA_LOADER_NUMERICAL_DATE_LENGTH), (glong) -1);
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	result = _tmp19_;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_g_string_free0 (sb);
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 791 "AVIMetadataLoader.c"
}

static gchar*
avi_metadata_loader_read_section (AVIMetadataLoader* self,
                                  AVIChunk* chunk,
                                  GError** error)
{
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 109 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 109 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_CHUNK (chunk), NULL);
#line 110 "../src/video-support/AVIMetadataLoader.vala"
	while (TRUE) {
#line 807 "AVIMetadataLoader.c"
		gchar* name = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp13_;
#line 111 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_read_chunk (chunk, &_inner_error0_);
#line 111 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 111 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 820 "AVIMetadataLoader.c"
		}
#line 112 "../src/video-support/AVIMetadataLoader.vala"
		_tmp0_ = avi_chunk_get_current_chunk_name (chunk);
#line 112 "../src/video-support/AVIMetadataLoader.vala"
		name = _tmp0_;
#line 113 "../src/video-support/AVIMetadataLoader.vala"
		_tmp1_ = name;
#line 113 "../src/video-support/AVIMetadataLoader.vala"
		if (g_strcmp0 ("IDIT", _tmp1_) == 0) {
#line 830 "AVIMetadataLoader.c"
			gchar* _tmp2_ = NULL;
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_tmp3_ = avi_chunk_section_to_string (chunk, &_inner_error0_);
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_tmp2_ = _tmp3_;
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "../src/video-support/AVIMetadataLoader.vala"
				g_propagate_error (error, _inner_error0_);
#line 114 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (name);
#line 114 "../src/video-support/AVIMetadataLoader.vala"
				return NULL;
#line 846 "AVIMetadataLoader.c"
			}
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_tmp4_ = _tmp2_;
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_tmp2_ = NULL;
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			result = _tmp4_;
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (_tmp2_);
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (name);
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			return result;
#line 860 "AVIMetadataLoader.c"
		} else {
			const gchar* _tmp5_;
#line 115 "../src/video-support/AVIMetadataLoader.vala"
			_tmp5_ = name;
#line 115 "../src/video-support/AVIMetadataLoader.vala"
			if (g_strcmp0 ("nctg", _tmp5_) == 0) {
#line 867 "AVIMetadataLoader.c"
				gchar* _tmp6_ = NULL;
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_tmp7_ = avi_metadata_loader_read_nikon_nctg_tag (self, chunk, &_inner_error0_);
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_tmp6_ = _tmp7_;
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/video-support/AVIMetadataLoader.vala"
					g_propagate_error (error, _inner_error0_);
#line 116 "../src/video-support/AVIMetadataLoader.vala"
					_g_free0 (name);
#line 116 "../src/video-support/AVIMetadataLoader.vala"
					return NULL;
#line 883 "AVIMetadataLoader.c"
				}
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_tmp8_ = _tmp6_;
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_tmp6_ = NULL;
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				result = _tmp8_;
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (_tmp6_);
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (name);
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 897 "AVIMetadataLoader.c"
			} else {
				const gchar* _tmp9_;
#line 117 "../src/video-support/AVIMetadataLoader.vala"
				_tmp9_ = name;
#line 117 "../src/video-support/AVIMetadataLoader.vala"
				if (g_strcmp0 ("strd", _tmp9_) == 0) {
#line 904 "AVIMetadataLoader.c"
					gchar* _tmp10_ = NULL;
					gchar* _tmp11_;
					gchar* _tmp12_;
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_tmp11_ = avi_metadata_loader_read_fuji_strd_tag (self, chunk, &_inner_error0_);
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_tmp10_ = _tmp11_;
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../src/video-support/AVIMetadataLoader.vala"
						g_propagate_error (error, _inner_error0_);
#line 118 "../src/video-support/AVIMetadataLoader.vala"
						_g_free0 (name);
#line 118 "../src/video-support/AVIMetadataLoader.vala"
						return NULL;
#line 920 "AVIMetadataLoader.c"
					}
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_tmp12_ = _tmp10_;
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_tmp10_ = NULL;
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					result = _tmp12_;
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_g_free0 (_tmp10_);
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_g_free0 (name);
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					return result;
#line 934 "AVIMetadataLoader.c"
				}
			}
		}
#line 121 "../src/video-support/AVIMetadataLoader.vala"
		_tmp13_ = name;
#line 121 "../src/video-support/AVIMetadataLoader.vala"
		if (g_strcmp0 ("LIST", _tmp13_) == 0) {
#line 942 "AVIMetadataLoader.c"
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _result_ = NULL;
			AVIChunk* _tmp16_;
			AVIChunk* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			const gchar* _tmp20_;
#line 122 "../src/video-support/AVIMetadataLoader.vala"
			_tmp14_ = avi_chunk_read_name (chunk, &_inner_error0_);
#line 122 "../src/video-support/AVIMetadataLoader.vala"
			_tmp15_ = _tmp14_;
#line 122 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (_tmp15_);
#line 122 "../src/video-support/AVIMetadataLoader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "../src/video-support/AVIMetadataLoader.vala"
				g_propagate_error (error, _inner_error0_);
#line 122 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (name);
#line 122 "../src/video-support/AVIMetadataLoader.vala"
				return NULL;
#line 965 "AVIMetadataLoader.c"
			}
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_tmp16_ = avi_chunk_get_first_child_chunk (chunk);
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_tmp17_ = _tmp16_;
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_tmp18_ = avi_metadata_loader_read_section (self, _tmp17_, &_inner_error0_);
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_tmp19_ = _tmp18_;
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_avi_chunk_unref0 (_tmp17_);
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_result_ = _tmp19_;
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/video-support/AVIMetadataLoader.vala"
				g_propagate_error (error, _inner_error0_);
#line 123 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (name);
#line 123 "../src/video-support/AVIMetadataLoader.vala"
				return NULL;
#line 987 "AVIMetadataLoader.c"
			}
#line 124 "../src/video-support/AVIMetadataLoader.vala"
			_tmp20_ = _result_;
#line 124 "../src/video-support/AVIMetadataLoader.vala"
			if (NULL != _tmp20_) {
#line 125 "../src/video-support/AVIMetadataLoader.vala"
				result = _result_;
#line 125 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (name);
#line 125 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 999 "AVIMetadataLoader.c"
			}
#line 121 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (_result_);
#line 1003 "AVIMetadataLoader.c"
		}
#line 129 "../src/video-support/AVIMetadataLoader.vala"
		if (avi_chunk_is_last_chunk (chunk)) {
#line 130 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (name);
#line 130 "../src/video-support/AVIMetadataLoader.vala"
			break;
#line 1011 "AVIMetadataLoader.c"
		}
#line 132 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_next_chunk (chunk, &_inner_error0_);
#line 132 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 132 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 132 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (name);
#line 132 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 1023 "AVIMetadataLoader.c"
		}
#line 110 "../src/video-support/AVIMetadataLoader.vala"
		_g_free0 (name);
#line 1027 "AVIMetadataLoader.c"
	}
#line 134 "../src/video-support/AVIMetadataLoader.vala"
	result = NULL;
#line 134 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 1033 "AVIMetadataLoader.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
#line 1232 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1233 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1233 "glib-2.0.vapi"
	result = _tmp0_;
#line 1233 "glib-2.0.vapi"
	return result;
#line 1050 "AVIMetadataLoader.c"
}

static gulong
avi_metadata_loader_parse_date (AVIMetadataLoader* self,
                                const gchar* sdate)
{
	gint _tmp0_;
	gint _tmp1_;
	GDate date = {0};
	guint seconds = 0U;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint min = 0;
	gint sec = 0;
	gchar weekday[4] = {0};
	gchar monthstr[4] = {0};
	struct tm time = {0};
	struct tm _tmp18_ = {0};
	time_t tm = 0;
	gulong _result_ = 0UL;
	gulong result = 0UL;
#line 141 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), 0UL);
#line 141 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (sdate != NULL, 0UL);
#line 142 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = strlen (sdate);
#line 142 "../src/video-support/AVIMetadataLoader.vala"
	_tmp1_ = _tmp0_;
#line 142 "../src/video-support/AVIMetadataLoader.vala"
	if (_tmp1_ == 0) {
#line 143 "../src/video-support/AVIMetadataLoader.vala"
		result = (gulong) 0;
#line 143 "../src/video-support/AVIMetadataLoader.vala"
		return result;
#line 1088 "AVIMetadataLoader.c"
	}
#line 146 "../src/video-support/AVIMetadataLoader.vala"
	memset (&date, 0, sizeof (GDate));
#line 147 "../src/video-support/AVIMetadataLoader.vala"
	seconds = (guint) 0;
#line 152 "../src/video-support/AVIMetadataLoader.vala"
	if (g_ascii_isdigit (string_get (sdate, (glong) 0))) {
#line 1096 "AVIMetadataLoader.c"
		gchar* tmp = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gint _result_ = 0;
		const gchar* _tmp4_;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		gint _tmp11_;
#line 156 "../src/video-support/AVIMetadataLoader.vala"
		_tmp2_ = g_strdup (sdate);
#line 156 "../src/video-support/AVIMetadataLoader.vala"
		tmp = _tmp2_;
#line 157 "../src/video-support/AVIMetadataLoader.vala"
		_tmp3_ = tmp;
#line 157 "../src/video-support/AVIMetadataLoader.vala"
		g_strcanon (_tmp3_, "0123456789 ", ' ');
#line 158 "../src/video-support/AVIMetadataLoader.vala"
		sec = 0;
#line 159 "../src/video-support/AVIMetadataLoader.vala"
		_tmp4_ = tmp;
#line 159 "../src/video-support/AVIMetadataLoader.vala"
		_tmp11_ = sscanf (_tmp4_, "%d %d %d %d %d %d", &_tmp5_, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
#line 159 "../src/video-support/AVIMetadataLoader.vala"
		year = _tmp5_;
#line 159 "../src/video-support/AVIMetadataLoader.vala"
		month = _tmp6_;
#line 159 "../src/video-support/AVIMetadataLoader.vala"
		day = _tmp7_;
#line 159 "../src/video-support/AVIMetadataLoader.vala"
		hour = _tmp8_;
#line 159 "../src/video-support/AVIMetadataLoader.vala"
		min = _tmp9_;
#line 159 "../src/video-support/AVIMetadataLoader.vala"
		sec = _tmp10_;
#line 159 "../src/video-support/AVIMetadataLoader.vala"
		_result_ = _tmp11_;
#line 160 "../src/video-support/AVIMetadataLoader.vala"
		if (_result_ < 5) {
#line 161 "../src/video-support/AVIMetadataLoader.vala"
			result = (gulong) 0;
#line 161 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (tmp);
#line 161 "../src/video-support/AVIMetadataLoader.vala"
			return result;
#line 1145 "AVIMetadataLoader.c"
		}
#line 163 "../src/video-support/AVIMetadataLoader.vala"
		g_date_set_dmy (&date, (GDateDay) day, (gint) ((GDateMonth) month), (GDateYear) year);
#line 164 "../src/video-support/AVIMetadataLoader.vala"
		seconds = (guint) ((sec + (min * 60)) + (hour * 3600));
#line 152 "../src/video-support/AVIMetadataLoader.vala"
		_g_free0 (tmp);
#line 1153 "AVIMetadataLoader.c"
	} else {
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gint _tmp17_;
#line 167 "../src/video-support/AVIMetadataLoader.vala"
		_tmp17_ = sscanf (sdate, "%3s %3s %d %d:%d:%d %d", weekday, monthstr, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_, &_tmp16_);
#line 167 "../src/video-support/AVIMetadataLoader.vala"
		day = _tmp12_;
#line 167 "../src/video-support/AVIMetadataLoader.vala"
		hour = _tmp13_;
#line 167 "../src/video-support/AVIMetadataLoader.vala"
		min = _tmp14_;
#line 167 "../src/video-support/AVIMetadataLoader.vala"
		sec = _tmp15_;
#line 167 "../src/video-support/AVIMetadataLoader.vala"
		year = _tmp16_;
#line 167 "../src/video-support/AVIMetadataLoader.vala"
		if (7 != _tmp17_) {
#line 169 "../src/video-support/AVIMetadataLoader.vala"
			result = (gulong) 0;
#line 169 "../src/video-support/AVIMetadataLoader.vala"
			return result;
#line 1179 "AVIMetadataLoader.c"
		}
#line 171 "../src/video-support/AVIMetadataLoader.vala"
		g_date_set_dmy (&date, (GDateDay) day, (gint) avi_metadata_loader_month_from_string (self, (const gchar*) monthstr), (GDateYear) year);
#line 172 "../src/video-support/AVIMetadataLoader.vala"
		seconds = (guint) ((sec + (min * 60)) + (hour * 3600));
#line 1185 "AVIMetadataLoader.c"
	}
#line 175 "../src/video-support/AVIMetadataLoader.vala"
	memset (&time, 0, sizeof (struct tm));
#line 176 "../src/video-support/AVIMetadataLoader.vala"
	g_date_to_struct_tm (&date, &_tmp18_);
#line 176 "../src/video-support/AVIMetadataLoader.vala"
	time = _tmp18_;
#line 179 "../src/video-support/AVIMetadataLoader.vala"
	tm = mktime (&time);
#line 180 "../src/video-support/AVIMetadataLoader.vala"
	_result_ = (gulong) (tm + seconds);
#line 181 "../src/video-support/AVIMetadataLoader.vala"
	if (_result_ < ((gulong) tm)) {
#line 1199 "AVIMetadataLoader.c"
		GFile* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 182 "../src/video-support/AVIMetadataLoader.vala"
		_tmp19_ = self->priv->file;
#line 182 "../src/video-support/AVIMetadataLoader.vala"
		_tmp20_ = g_file_get_path (_tmp19_);
#line 182 "../src/video-support/AVIMetadataLoader.vala"
		_tmp21_ = _tmp20_;
#line 182 "../src/video-support/AVIMetadataLoader.vala"
		g_debug ("AVIMetadataLoader.vala:182: Overflow for timestamp in video file %s", _tmp21_);
#line 182 "../src/video-support/AVIMetadataLoader.vala"
		_g_free0 (_tmp21_);
#line 184 "../src/video-support/AVIMetadataLoader.vala"
		result = (gulong) 0;
#line 184 "../src/video-support/AVIMetadataLoader.vala"
		return result;
#line 1217 "AVIMetadataLoader.c"
	}
#line 187 "../src/video-support/AVIMetadataLoader.vala"
	result = _result_;
#line 187 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 1223 "AVIMetadataLoader.c"
}

static GDateMonth
avi_metadata_loader_month_from_string (AVIMetadataLoader* self,
                                       const gchar* s)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label0 = 0;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label1 = 0;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label2 = 0;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label3 = 0;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label4 = 0;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label5 = 0;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label6 = 0;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label7 = 0;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label8 = 0;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label9 = 0;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label10 = 0;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label11 = 0;
#line 1257 "AVIMetadataLoader.c"
	GDateMonth result = 0;
#line 190 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), 0);
#line 190 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (s != NULL, 0);
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = g_utf8_strdown (s, (gssize) -1);
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	_tmp1_ = _tmp0_;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	g_free (_tmp1_);
#line 191 "../src/video-support/AVIMetadataLoader.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("jan")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1275 "AVIMetadataLoader.c"
			default:
			{
#line 193 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_JANUARY;
#line 193 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1282 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("feb")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1288 "AVIMetadataLoader.c"
			default:
			{
#line 195 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_FEBRUARY;
#line 195 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1295 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("mar")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1301 "AVIMetadataLoader.c"
			default:
			{
#line 197 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_MARCH;
#line 197 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1308 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("apr")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1314 "AVIMetadataLoader.c"
			default:
			{
#line 199 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_APRIL;
#line 199 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1321 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("may")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1327 "AVIMetadataLoader.c"
			default:
			{
#line 201 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_MAY;
#line 201 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1334 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("jun")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1340 "AVIMetadataLoader.c"
			default:
			{
#line 203 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_JUNE;
#line 203 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1347 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("jul")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1353 "AVIMetadataLoader.c"
			default:
			{
#line 205 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_JULY;
#line 205 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1360 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("aug")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1366 "AVIMetadataLoader.c"
			default:
			{
#line 207 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_AUGUST;
#line 207 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1373 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("sep")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1379 "AVIMetadataLoader.c"
			default:
			{
#line 209 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_SEPTEMBER;
#line 209 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1386 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("oct")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1392 "AVIMetadataLoader.c"
			default:
			{
#line 211 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_OCTOBER;
#line 211 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1399 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("nov")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1405 "AVIMetadataLoader.c"
			default:
			{
#line 213 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_NOVEMBER;
#line 213 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1412 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("dec")))) {
#line 191 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1418 "AVIMetadataLoader.c"
			default:
			{
#line 215 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_DECEMBER;
#line 215 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1425 "AVIMetadataLoader.c"
			}
		}
	}
#line 217 "../src/video-support/AVIMetadataLoader.vala"
	result = G_DATE_BAD_MONTH;
#line 217 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 1433 "AVIMetadataLoader.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 1454 "AVIMetadataLoader.c"
}

static gulong
avi_metadata_loader_get_creation_date_time_for_avi (AVIMetadataLoader* self)
{
	AVIChunk* chunk = NULL;
	GFile* _tmp0_;
	AVIChunk* _tmp1_;
	gulong timestamp = 0UL;
	GError* _inner_error0_ = NULL;
	gulong result = 0UL;
#line 220 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), 0UL);
#line 221 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = self->priv->file;
#line 221 "../src/video-support/AVIMetadataLoader.vala"
	_tmp1_ = avi_chunk_new (_tmp0_);
#line 221 "../src/video-support/AVIMetadataLoader.vala"
	chunk = _tmp1_;
#line 222 "../src/video-support/AVIMetadataLoader.vala"
	timestamp = (gulong) 0;
#line 1476 "AVIMetadataLoader.c"
	{
		AVIChunk* _tmp2_;
		AVIChunk* _tmp3_;
		gchar* sdate = NULL;
		AVIChunk* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 224 "../src/video-support/AVIMetadataLoader.vala"
		_tmp2_ = chunk;
#line 224 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_open_file (_tmp2_, &_inner_error0_);
#line 224 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1490 "AVIMetadataLoader.c"
			goto __catch0_g_error;
		}
#line 225 "../src/video-support/AVIMetadataLoader.vala"
		_tmp3_ = chunk;
#line 225 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_nonsection_skip (_tmp3_, (guint64) 12, &_inner_error0_);
#line 225 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1499 "AVIMetadataLoader.c"
			goto __catch0_g_error;
		}
#line 226 "../src/video-support/AVIMetadataLoader.vala"
		_tmp4_ = chunk;
#line 226 "../src/video-support/AVIMetadataLoader.vala"
		_tmp5_ = avi_metadata_loader_read_section (self, _tmp4_, &_inner_error0_);
#line 226 "../src/video-support/AVIMetadataLoader.vala"
		sdate = _tmp5_;
#line 226 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1510 "AVIMetadataLoader.c"
			goto __catch0_g_error;
		}
#line 227 "../src/video-support/AVIMetadataLoader.vala"
		_tmp6_ = sdate;
#line 227 "../src/video-support/AVIMetadataLoader.vala"
		if (NULL != _tmp6_) {
#line 1517 "AVIMetadataLoader.c"
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 228 "../src/video-support/AVIMetadataLoader.vala"
			_tmp7_ = sdate;
#line 228 "../src/video-support/AVIMetadataLoader.vala"
			_tmp8_ = string_strip (_tmp7_);
#line 228 "../src/video-support/AVIMetadataLoader.vala"
			_tmp9_ = _tmp8_;
#line 228 "../src/video-support/AVIMetadataLoader.vala"
			timestamp = avi_metadata_loader_parse_date (self, _tmp9_);
#line 228 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (_tmp9_);
#line 1531 "AVIMetadataLoader.c"
		}
#line 223 "../src/video-support/AVIMetadataLoader.vala"
		_g_free0 (sdate);
#line 1535 "AVIMetadataLoader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 223 "../src/video-support/AVIMetadataLoader.vala"
		e = _inner_error0_;
#line 223 "../src/video-support/AVIMetadataLoader.vala"
		_inner_error0_ = NULL;
#line 231 "../src/video-support/AVIMetadataLoader.vala"
		_tmp10_ = e;
#line 231 "../src/video-support/AVIMetadataLoader.vala"
		_tmp11_ = _tmp10_->message;
#line 231 "../src/video-support/AVIMetadataLoader.vala"
		g_debug ("AVIMetadataLoader.vala:231: Error while reading AVI file: %s", _tmp11_);
#line 223 "../src/video-support/AVIMetadataLoader.vala"
		_g_error_free0 (e);
#line 1555 "AVIMetadataLoader.c"
	}
	__finally0:
#line 223 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1560 "AVIMetadataLoader.c"
		gulong _tmp12_ = 0UL;
#line 223 "../src/video-support/AVIMetadataLoader.vala"
		_avi_chunk_unref0 (chunk);
#line 223 "../src/video-support/AVIMetadataLoader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 223 "../src/video-support/AVIMetadataLoader.vala"
		g_clear_error (&_inner_error0_);
#line 223 "../src/video-support/AVIMetadataLoader.vala"
		return _tmp12_;
#line 1570 "AVIMetadataLoader.c"
	}
	{
		AVIChunk* _tmp13_;
#line 235 "../src/video-support/AVIMetadataLoader.vala"
		_tmp13_ = chunk;
#line 235 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_close_file (_tmp13_, &_inner_error0_);
#line 235 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1580 "AVIMetadataLoader.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 234 "../src/video-support/AVIMetadataLoader.vala"
		e = _inner_error0_;
#line 234 "../src/video-support/AVIMetadataLoader.vala"
		_inner_error0_ = NULL;
#line 237 "../src/video-support/AVIMetadataLoader.vala"
		_tmp14_ = e;
#line 237 "../src/video-support/AVIMetadataLoader.vala"
		_tmp15_ = _tmp14_->message;
#line 237 "../src/video-support/AVIMetadataLoader.vala"
		g_debug ("AVIMetadataLoader.vala:237: Error while closing AVI file: %s", _tmp15_);
#line 234 "../src/video-support/AVIMetadataLoader.vala"
		_g_error_free0 (e);
#line 1602 "AVIMetadataLoader.c"
	}
	__finally1:
#line 234 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1607 "AVIMetadataLoader.c"
		gulong _tmp16_ = 0UL;
#line 234 "../src/video-support/AVIMetadataLoader.vala"
		_avi_chunk_unref0 (chunk);
#line 234 "../src/video-support/AVIMetadataLoader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 234 "../src/video-support/AVIMetadataLoader.vala"
		g_clear_error (&_inner_error0_);
#line 234 "../src/video-support/AVIMetadataLoader.vala"
		return _tmp16_;
#line 1617 "AVIMetadataLoader.c"
	}
#line 239 "../src/video-support/AVIMetadataLoader.vala"
	result = timestamp;
#line 239 "../src/video-support/AVIMetadataLoader.vala"
	_avi_chunk_unref0 (chunk);
#line 239 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 1625 "AVIMetadataLoader.c"
}

static void
value_avi_metadata_loader_init (GValue* value)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	value->data[0].v_pointer = NULL;
#line 1633 "AVIMetadataLoader.c"
}

static void
value_avi_metadata_loader_free_value (GValue* value)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (value->data[0].v_pointer) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		avi_metadata_loader_unref (value->data[0].v_pointer);
#line 1643 "AVIMetadataLoader.c"
	}
}

static void
value_avi_metadata_loader_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (src_value->data[0].v_pointer) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		dest_value->data[0].v_pointer = avi_metadata_loader_ref (src_value->data[0].v_pointer);
#line 1655 "AVIMetadataLoader.c"
	} else {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1659 "AVIMetadataLoader.c"
	}
}

static gpointer
value_avi_metadata_loader_peek_pointer (const GValue* value)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return value->data[0].v_pointer;
#line 1668 "AVIMetadataLoader.c"
}

static gchar*
value_avi_metadata_loader_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (collect_values[0].v_pointer) {
#line 1679 "AVIMetadataLoader.c"
		AVIMetadataLoader * object;
		object = collect_values[0].v_pointer;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1686 "AVIMetadataLoader.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1690 "AVIMetadataLoader.c"
		}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = avi_metadata_loader_ref (object);
#line 1694 "AVIMetadataLoader.c"
	} else {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = NULL;
#line 1698 "AVIMetadataLoader.c"
	}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return NULL;
#line 1702 "AVIMetadataLoader.c"
}

static gchar*
value_avi_metadata_loader_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	AVIMetadataLoader ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (!object_p) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1717 "AVIMetadataLoader.c"
	}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (!value->data[0].v_pointer) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		*object_p = NULL;
#line 1723 "AVIMetadataLoader.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		*object_p = value->data[0].v_pointer;
#line 1727 "AVIMetadataLoader.c"
	} else {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		*object_p = avi_metadata_loader_ref (value->data[0].v_pointer);
#line 1731 "AVIMetadataLoader.c"
	}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return NULL;
#line 1735 "AVIMetadataLoader.c"
}

GParamSpec*
param_spec_avi_metadata_loader (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecAVIMetadataLoader* spec;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_AVI_METADATA_LOADER), NULL);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return G_PARAM_SPEC (spec);
#line 1754 "AVIMetadataLoader.c"
}

gpointer
value_get_avi_metadata_loader (const GValue* value)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AVI_METADATA_LOADER), NULL);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return value->data[0].v_pointer;
#line 1764 "AVIMetadataLoader.c"
}

void
value_set_avi_metadata_loader (GValue* value,
                               gpointer v_object)
{
	AVIMetadataLoader * old;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AVI_METADATA_LOADER));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	old = value->data[0].v_pointer;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (v_object) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AVI_METADATA_LOADER));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = v_object;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		avi_metadata_loader_ref (value->data[0].v_pointer);
#line 1786 "AVIMetadataLoader.c"
	} else {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = NULL;
#line 1790 "AVIMetadataLoader.c"
	}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (old) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		avi_metadata_loader_unref (old);
#line 1796 "AVIMetadataLoader.c"
	}
}

void
value_take_avi_metadata_loader (GValue* value,
                                gpointer v_object)
{
	AVIMetadataLoader * old;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AVI_METADATA_LOADER));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	old = value->data[0].v_pointer;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (v_object) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AVI_METADATA_LOADER));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = v_object;
#line 1817 "AVIMetadataLoader.c"
	} else {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = NULL;
#line 1821 "AVIMetadataLoader.c"
	}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (old) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		avi_metadata_loader_unref (old);
#line 1827 "AVIMetadataLoader.c"
	}
}

static void
avi_metadata_loader_class_init (AVIMetadataLoaderClass * klass,
                                gpointer klass_data)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	avi_metadata_loader_parent_class = g_type_class_peek_parent (klass);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	((AVIMetadataLoaderClass *) klass)->finalize = avi_metadata_loader_finalize;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_type_class_adjust_private_offset (klass, &AVIMetadataLoader_private_offset);
#line 1841 "AVIMetadataLoader.c"
}

static void
avi_metadata_loader_instance_init (AVIMetadataLoader * self,
                                   gpointer klass)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	self->priv = avi_metadata_loader_get_instance_private (self);
#line 3 "../src/video-support/AVIMetadataLoader.vala"
	self->priv->file = NULL;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	self->ref_count = 1;
#line 1854 "AVIMetadataLoader.c"
}

static void
avi_metadata_loader_finalize (AVIMetadataLoader * obj)
{
	AVIMetadataLoader * self;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AVI_METADATA_LOADER, AVIMetadataLoader);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_signal_handlers_destroy (self);
#line 3 "../src/video-support/AVIMetadataLoader.vala"
	_g_object_unref0 (self->priv->file);
#line 1867 "AVIMetadataLoader.c"
}

static GType
avi_metadata_loader_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_avi_metadata_loader_init, value_avi_metadata_loader_free_value, value_avi_metadata_loader_copy_value, value_avi_metadata_loader_peek_pointer, "p", value_avi_metadata_loader_collect_value, "p", value_avi_metadata_loader_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (AVIMetadataLoaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) avi_metadata_loader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AVIMetadataLoader), 0, (GInstanceInitFunc) avi_metadata_loader_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType avi_metadata_loader_type_id;
	avi_metadata_loader_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AVIMetadataLoader", &g_define_type_info, &g_define_type_fundamental_info, 0);
	AVIMetadataLoader_private_offset = g_type_add_instance_private (avi_metadata_loader_type_id, sizeof (AVIMetadataLoaderPrivate));
	return avi_metadata_loader_type_id;
}

GType
avi_metadata_loader_get_type (void)
{
	static volatile gsize avi_metadata_loader_type_id__volatile = 0;
	if (g_once_init_enter (&avi_metadata_loader_type_id__volatile)) {
		GType avi_metadata_loader_type_id;
		avi_metadata_loader_type_id = avi_metadata_loader_get_type_once ();
		g_once_init_leave (&avi_metadata_loader_type_id__volatile, avi_metadata_loader_type_id);
	}
	return avi_metadata_loader_type_id__volatile;
}

gpointer
avi_metadata_loader_ref (gpointer instance)
{
	AVIMetadataLoader * self;
	self = instance;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return instance;
#line 1903 "AVIMetadataLoader.c"
}

void
avi_metadata_loader_unref (gpointer instance)
{
	AVIMetadataLoader * self;
	self = instance;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		AVI_METADATA_LOADER_GET_CLASS (self)->finalize (self);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1917 "AVIMetadataLoader.c"
	}
}

