/* Photo.c generated by valac 0.52.10, the Vala compiler
 * generated from Photo.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable.*/
/* UNMODIFIED represents the photo with no edits, i.e. the head of the pipeline.*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <time.h>
#include "metadata.h"
#include <float.h>
#include <math.h>
#include "shotwell-graphics-processor.h"
#include <glib/gstdio.h>
#include <gdk/gdk.h>
#include <config.h>
#include <glib/gi18n-lib.h>
#include <cairo-gobject.h>

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER,
	BACKING_FETCH_MODE_UNMODIFIED
} BackingFetchMode;

#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;
typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;

#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;
enum  {
	PHOTO_TRANSFORMATION_STATE_0_PROPERTY,
	PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES
};
static GParamSpec* photo_transformation_state_properties[PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES];
enum  {
	PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL,
	PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS
};
static guint photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS] = {0};
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;
typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_POSITIONABLE (positionable_get_type ())
#define POSITIONABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_POSITIONABLE, Positionable))
#define IS_POSITIONABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_POSITIONABLE))
#define POSITIONABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_POSITIONABLE, PositionableIface))

typedef struct _Positionable Positionable;
typedef struct _PositionableIface PositionableIface;

#define TYPE_GPS_COORDS (gps_coords_get_type ())
typedef struct _GpsCoords GpsCoords;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;
typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())
#define PHOTO_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders))
#define PHOTO_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))
#define PHOTO_IS_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_IS_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_BACKING_READERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))

typedef struct _PhotoBackingReaders PhotoBackingReaders;
typedef struct _PhotoBackingReadersClass PhotoBackingReadersClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;
typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
enum  {
	PHOTO_0_PROPERTY,
	PHOTO_NUM_PROPERTIES
};
static GParamSpec* photo_properties[PHOTO_NUM_PROPERTIES];

#define PHOTO_TYPE_CACHED_PIXBUF (photo_cached_pixbuf_get_type ())
#define PHOTO_CACHED_PIXBUF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbuf))
#define PHOTO_CACHED_PIXBUF_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbufClass))
#define PHOTO_IS_CACHED_PIXBUF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_CACHED_PIXBUF))
#define PHOTO_IS_CACHED_PIXBUF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_CACHED_PIXBUF))
#define PHOTO_CACHED_PIXBUF_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbufClass))

typedef struct _PhotoCachedPixbuf PhotoCachedPixbuf;
typedef struct _PhotoCachedPixbufClass PhotoCachedPixbufClass;
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _photo_backing_readers_unref0(var) ((var == NULL) ? NULL : (var = (photo_backing_readers_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReadersPrivate PhotoBackingReadersPrivate;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
#define _photo_preview_unref0(var) ((var == NULL) ? NULL : (var = (photo_preview_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;
typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

#define TYPE_IMPORT_RESULT (import_result_get_type ())
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef enum  {
	PHOTO_FILE_READER_ROLE_DEFAULT,
	PHOTO_FILE_READER_ROLE_THUMBNAIL
} PhotoFileReaderRole;

#define PHOTO_FILE_READER_TYPE_ROLE (photo_file_reader_role_get_type ())

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE (photo_reimport_raw_development_state_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))

typedef struct _PhotoReimportRawDevelopmentState PhotoReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateClass PhotoReimportRawDevelopmentStateClass;
#define _photo_reimport_raw_development_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (photo_reimport_raw_development_state_impl_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))

typedef struct _PhotoReimportRawDevelopmentStateImpl PhotoReimportRawDevelopmentStateImpl;
typedef struct _PhotoReimportRawDevelopmentStateImplClass PhotoReimportRawDevelopmentStateImplClass;

#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT (photo_reimport_raw_development_state_impl_dev_to_reimport_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))

typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimport PhotoReimportRawDevelopmentStateImplDevToReimport;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass PhotoReimportRawDevelopmentStateImplDevToReimportClass;
typedef struct _PhotoReimportRawDevelopmentStatePrivate PhotoReimportRawDevelopmentStatePrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplPrivate PhotoReimportRawDevelopmentStateImplPrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportPrivate PhotoReimportRawDevelopmentStateImplDevToReimportPrivate;
#define _photo_reimport_raw_development_state_impl_dev_to_reimport_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_impl_dev_to_reimport_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;
typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;
typedef struct _PhotoCachedPixbufPrivate PhotoCachedPixbufPrivate;
#define _photo_cached_pixbuf_unref0(var) ((var == NULL) ? NULL : (var = (photo_cached_pixbuf_unref (var), NULL)))

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
typedef void (*OneShotCallback) (gpointer user_data);
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_0_PROPERTY,
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES
};
static GParamSpec* photo_photo_transformation_state_impl_properties[PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES];
typedef struct _PhotoParamSpecBackingReaders PhotoParamSpecBackingReaders;
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _PhotoParamSpecCachedPixbuf PhotoParamSpecCachedPixbuf;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _PhotoParamSpecReimportRawDevelopmentState PhotoParamSpecReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport;
enum  {
	PHOTO_EDITABLE_REPLACED_SIGNAL,
	PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL,
	PHOTO_BASELINE_REPLACED_SIGNAL,
	PHOTO_MASTER_REIMPORTED_SIGNAL,
	PHOTO_EDITABLE_REIMPORTED_SIGNAL,
	PHOTO_BASELINE_REIMPORTED_SIGNAL,
	PHOTO_SOURCE_REIMPORTED_SIGNAL,
	PHOTO_NUM_SIGNALS
};
static guint photo_signals[PHOTO_NUM_SIGNALS] = {0};
typedef struct _DataCollectionPrivate DataCollectionPrivate;
typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, gpointer user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;
typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER
} LibraryPhotoSourceCollectionState;

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, gpointer user_data);
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, gpointer user_data);

#define TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (library_photo_source_holding_tank_get_type ())
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))

typedef struct _LibraryPhotoSourceHoldingTank LibraryPhotoSourceHoldingTank;
typedef struct _LibraryPhotoSourceHoldingTankClass LibraryPhotoSourceHoldingTankClass;

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS
};
static guint library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS] = {0};

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;
enum  {
	LIBRARY_PHOTO_0_PROPERTY,
	LIBRARY_PHOTO_NUM_PROPERTIES
};
static GParamSpec* library_photo_properties[LIBRARY_PHOTO_NUM_PROPERTIES];
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;

#define TYPE_FACE (face_get_type ())
#define FACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE, Face))
#define FACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE, FaceClass))
#define IS_FACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE))
#define IS_FACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE))
#define FACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE, FaceClass))

typedef struct _Face Face;
typedef struct _FaceClass FaceClass;

#define TYPE_FACE_SOURCE_COLLECTION (face_source_collection_get_type ())
#define FACE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollection))
#define FACE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollectionClass))
#define IS_FACE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_SOURCE_COLLECTION))
#define IS_FACE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_SOURCE_COLLECTION))
#define FACE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollectionClass))

typedef struct _FaceSourceCollection FaceSourceCollection;
typedef struct _FaceSourceCollectionClass FaceSourceCollectionClass;

#define TYPE_FACE_LOCATION (face_location_get_type ())
#define FACE_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_LOCATION, FaceLocation))
#define FACE_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_LOCATION, FaceLocationClass))
#define IS_FACE_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_LOCATION))
#define IS_FACE_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_LOCATION))
#define FACE_LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_LOCATION, FaceLocationClass))

typedef struct _FaceLocation FaceLocation;
typedef struct _FaceLocationClass FaceLocationClass;

#define TYPE_FACE_ID (face_id_get_type ())
typedef struct _FaceID FaceID;

#define TYPE_FACE_LOCATION_DATA (face_location_data_get_type ())
typedef struct _FaceLocationData FaceLocationData;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;
typedef struct _MediaSourceHoldingTankPrivate MediaSourceHoldingTankPrivate;
typedef struct _LibraryPhotoSourceHoldingTankPrivate LibraryPhotoSourceHoldingTankPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ImportID {
	gint64 id;
};

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	GFile* final_associated_file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow* row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _EventID {
	gint64 id;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, gint* result_length1);
	gchar* (*get_title) (MediaSource* self);
	gchar* (*get_comment) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	gboolean (*set_comment) (MediaSource* self, const gchar* comment);
	Rating (*get_rating) (MediaSource* self);
	void (*set_rating) (MediaSource* self, Rating rating);
	void (*increase_rating) (MediaSource* self);
	void (*decrease_rating) (MediaSource* self);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

struct _GpsCoords {
	gint has_gps;
	gdouble latitude;
	gdouble longitude;
};

struct _PositionableIface {
	GTypeInterface parent_iface;
	void (*get_gps_coords) (Positionable* self, GpsCoords* result);
	void (*set_gps_coords) (Positionable* self, GpsCoords* gps_coords);
};

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
	PhotoRow* row;
	gboolean can_rotate_now;
	BackingPhotoRow* backing_photo_row;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_raw_development_modified) (Photo* self);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*raw_development_modified) (Photo* self);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

struct _PhotoPrivate {
	time_t cached_exposure_time;
	GRecMutex __lock_row;
	BackingPhotoRow* editable;
	PhotoBackingReaders* readers;
	GRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	GeeHashMap* developments;
	GRecMutex __lock_developments;
};

struct _PhotoID {
	gint64 id;
};

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	Rating rating;
	gchar* title;
	GpsCoords gps_coords;
	gchar* comment;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	time_t time_created;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

struct _PhotoBackingReaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoBackingReadersPrivate * priv;
	PhotoFileReader* master;
	PhotoFileReader* developer;
	PhotoFileReader* editable;
};

struct _PhotoBackingReadersClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoBackingReaders *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow* row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoRow* backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStatePrivate * priv;
};

struct _PhotoReimportRawDevelopmentStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentState *self);
};

struct _PhotoReimportRawDevelopmentStateImpl {
	PhotoReimportRawDevelopmentState parent_instance;
	PhotoReimportRawDevelopmentStateImplPrivate * priv;
	GeeCollection* list;
	gboolean metadata_only;
};

struct _PhotoReimportRawDevelopmentStateImplClass {
	PhotoReimportRawDevelopmentStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStateImplDevToReimportPrivate * priv;
	BackingPhotoRow* backing;
	PhotoMetadata* metadata;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentStateImplDevToReimport *self);
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

struct _PhotoCachedPixbuf {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoCachedPixbufPrivate * priv;
	Photo* photo;
	GdkPixbuf* pixbuf;
	GTimer* last_touched;
};

struct _PhotoCachedPixbufClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoCachedPixbuf *self);
};

struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
};

struct _PhotoParamSpecBackingReaders {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecCachedPixbuf {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportRawDevelopmentState {
	GParamSpec parent_instance;
};

struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport {
	GParamSpec parent_instance;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, gpointer comparator_target, ComparatorPredicate predicate, gpointer predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, gpointer monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeHashMap* by_raw_development_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
	GeeMultiMap* photo_to_raw_development_filesize;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

struct _FaceID {
	gint64 id;
};

struct _FaceLocationData {
	gchar* geometry;
	gchar* vec;
};

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _MediaSourceHoldingTank {
	DatabaseSourceHoldingTank parent_instance;
	MediaSourceHoldingTankPrivate * priv;
};

struct _MediaSourceHoldingTankClass {
	DatabaseSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTank {
	MediaSourceHoldingTank parent_instance;
	LibraryPhotoSourceHoldingTankPrivate * priv;
};

struct _LibraryPhotoSourceHoldingTankClass {
	MediaSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTankPrivate {
	GeeHashMap* editable_file_map;
	GeeHashMap* development_file_map;
	GeeMultiMap* reverse_editable_file_map;
	GeeMultiMap* reverse_development_file_map;
};

static gpointer photo_import_params_parent_class = NULL;
static gint PhotoTransformationState_private_offset;
static gpointer photo_transformation_state_parent_class = NULL;
static gint Photo_private_offset;
static gpointer photo_parent_class = NULL;
static GeeLinkedList* photo_source_pixbuf_cache;
static GRecMutex __lock_photo_photo_source_pixbuf_cache = {0};
static GeeLinkedList* photo_source_pixbuf_cache = NULL;
static guint photo_discard_source_id;
static guint photo_discard_source_id = (guint) 0;
static gboolean photo__develop_raw_photos_to_files;
static gboolean photo__develop_raw_photos_to_files = FALSE;
static gint PhotoPhotoTransformationStateImpl_private_offset;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_backing_readers_parent_class = NULL;
static gpointer photo_cached_pixbuf_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = NULL;
static DateableIface * photo_dateable_parent_iface = NULL;
static PositionableIface * photo_positionable_parent_iface = NULL;
static gint LibraryPhotoSourceCollection_private_offset;
static gpointer library_photo_source_collection_parent_class = NULL;
static gint LibraryPhoto_private_offset;
static gpointer library_photo_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
extern TagSourceCollection* tag_global;
extern FaceSourceCollection* face_global;
static FlaggableIface * library_photo_flaggable_parent_iface = NULL;
static MonitorableIface * library_photo_monitorable_parent_iface = NULL;
static gint LibraryPhotoSourceHoldingTank_private_offset;
static gpointer library_photo_source_holding_tank_parent_class = NULL;

GType backing_fetch_mode_get_type (void) G_GNUC_CONST ;
gpointer photo_import_params_ref (gpointer instance);
void photo_import_params_unref (gpointer instance);
GParamSpec* param_spec_photo_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_photo_import_params (GValue* value,
                                    gpointer v_object);
void value_take_photo_import_params (GValue* value,
                                     gpointer v_object);
gpointer value_get_photo_import_params (const GValue* value);
GType photo_import_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoImportParams, photo_import_params_unref)
GType import_id_get_type (void) G_GNUC_CONST ;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST ;
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_thumbnails (GValue* value,
                           gpointer v_object);
void value_take_thumbnails (GValue* value,
                            gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Thumbnails, thumbnails_unref)
gpointer photo_row_ref (gpointer instance);
void photo_row_unref (gpointer instance);
GParamSpec* param_spec_photo_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_photo_row (GValue* value,
                          gpointer v_object);
void value_take_photo_row (GValue* value,
                           gpointer v_object);
gpointer value_get_photo_row (const GValue* value);
GType photo_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoRow, photo_row_unref)
PhotoRow* photo_row_new (void);
PhotoRow* photo_row_construct (GType object_type);
PhotoImportParams* photo_import_params_new (GFile* file,
                                            GFile* final_associated_file,
                                            ImportID* import_id,
                                            PhotoFileSnifferOptions sniffer_options,
                                            const gchar* exif_md5,
                                            const gchar* thumbnail_md5,
                                            const gchar* full_md5,
                                            Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_construct (GType object_type,
                                                  GFile* file,
                                                  GFile* final_associated_file,
                                                  ImportID* import_id,
                                                  PhotoFileSnifferOptions sniffer_options,
                                                  const gchar* exif_md5,
                                                  const gchar* thumbnail_md5,
                                                  const gchar* full_md5,
                                                  Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file,
                                                               ImportID* import_id);
PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type,
                                                                     GFile* file,
                                                                     ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams * obj);
static GType photo_import_params_get_type_once (void);
GType photo_transformation_state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoTransformationState, g_object_unref)
gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
PhotoTransformationState* photo_transformation_state_construct (GType object_type);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject * obj);
static GType photo_transformation_state_get_type_once (void);
GType rating_get_type (void) G_GNUC_CONST ;
gboolean rating_can_increase (Rating self);
gboolean rating_can_decrease (Rating self);
gboolean rating_is_valid (Rating self);
Rating rating_increase (Rating self);
Rating rating_decrease (Rating self);
gint rating_serialize (Rating self);
Rating rating_unserialize (gint value);
GType data_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Alteration, alteration_unref)
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataCollection, data_collection_unref)
GType data_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_source_holding_tank (GValue* value,
                                    gpointer v_object);
void value_take_source_holding_tank (GValue* value,
                                     gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceHoldingTank, source_holding_tank_unref)
GType source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceCollection, data_collection_unref)
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_snapshot (GValue* value,
                                gpointer v_object);
void value_take_source_snapshot (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceSnapshot, source_snapshot_unref)
GType thumbnail_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailSource, g_object_unref)
GType photo_file_format_get_type (void) G_GNUC_CONST ;
GType indexable_get_type (void) G_GNUC_CONST ;
GType media_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSource, g_object_unref)
GType event_id_get_type (void) G_GNUC_CONST ;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_backing_file_state (GValue* value,
                                   gpointer v_object);
void value_take_backing_file_state (GValue* value,
                                    gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingFileState, backing_file_state_unref)
GType photo_exception_get_type (void) G_GNUC_CONST ;
GType dimensions_get_type (void) G_GNUC_CONST ;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST ;
GType scale_constraint_get_type (void) G_GNUC_CONST ;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType photo_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoSource, g_object_unref)
GType photo_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoMetadata, media_metadata_unref)
GType dateable_get_type (void) G_GNUC_CONST ;
GType gps_coords_get_type (void) G_GNUC_CONST ;
GpsCoords* gps_coords_dup (const GpsCoords* self);
void gps_coords_free (GpsCoords* self);
GType positionable_get_type (void) G_GNUC_CONST ;
GType photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Photo, g_object_unref)
GType rotation_get_type (void) G_GNUC_CONST ;
gpointer backing_photo_row_ref (gpointer instance);
void backing_photo_row_unref (gpointer instance);
GParamSpec* param_spec_backing_photo_row (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_backing_photo_row (GValue* value,
                                  gpointer v_object);
void value_take_backing_photo_row (GValue* value,
                                   gpointer v_object);
gpointer value_get_backing_photo_row (const GValue* value);
GType backing_photo_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingPhotoRow, backing_photo_row_unref)
static gpointer photo_backing_readers_ref (gpointer instance);
static void photo_backing_readers_unref (gpointer instance);
static GParamSpec* photo_param_spec_backing_readers (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags) G_GNUC_UNUSED ;
static void photo_value_set_backing_readers (GValue* value,
                                      gpointer v_object) G_GNUC_UNUSED ;
static void photo_value_take_backing_readers (GValue* value,
                                       gpointer v_object) G_GNUC_UNUSED ;
static gpointer photo_value_get_backing_readers (const GValue* value) G_GNUC_UNUSED ;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoBackingReaders, photo_backing_readers_unref)
gpointer one_shot_scheduler_ref (gpointer instance);
void one_shot_scheduler_unref (gpointer instance);
GParamSpec* param_spec_one_shot_scheduler (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_one_shot_scheduler (GValue* value,
                                   gpointer v_object);
void value_take_one_shot_scheduler (GValue* value,
                                    gpointer v_object);
gpointer value_get_one_shot_scheduler (const GValue* value);
GType one_shot_scheduler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OneShotScheduler, one_shot_scheduler_unref)
GType raw_developer_get_type (void) G_GNUC_CONST ;
void photo_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file);
void photo_notify_raw_development_modified (Photo* self);
void photo_notify_baseline_replaced (Photo* self);
void photo_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata);
void photo_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata);
void photo_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata);
void photo_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata);
gboolean data_source_internal_delete_backing (DataSource* self,
                                              GError** error);
BackingFileState** media_source_get_backing_files_state (MediaSource* self,
                                                         gint* result_length1);
void photo_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata);
gchar* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
gchar* data_source_get_source_id (DataSource* self);
PhotoFileFormat thumbnail_source_get_preferred_thumbnail_format (ThumbnailSource* self);
GdkPixbuf* thumbnail_source_create_thumbnail (ThumbnailSource* self,
                                              gint scale,
                                              GError** error);
GFile* media_source_get_file (MediaSource* self);
GFile* media_source_get_master_file (MediaSource* self);
time_t media_source_get_timestamp (MediaSource* self);
void media_source_get_event_id (MediaSource* self,
                                EventID* result);
void media_source_get_import_id (MediaSource* self,
                                 ImportID* result);
gchar* media_source_get_master_md5 (MediaSource* self);
Rating media_source_get_rating (MediaSource* self);
void media_source_set_rating (MediaSource* self,
                              Rating rating);
void media_source_increase_rating (MediaSource* self);
void media_source_decrease_rating (MediaSource* self);
void data_source_commit_backlinks (DataSource* self,
                                   SourceCollection* sources,
                                   const gchar* dehydrated);
gboolean media_source_set_event_id (MediaSource* self,
                                    EventID* id);
gchar* data_object_to_string (DataObject* self);
gboolean data_source_equals (DataSource* self,
                             DataSource* source);
guint64 media_source_get_filesize (MediaSource* self);
guint64 media_source_get_master_filesize (MediaSource* self);
time_t media_source_get_exposure_time (MediaSource* self);
gchar* media_source_get_basename (MediaSource* self);
gchar* media_source_get_title (MediaSource* self);
gchar* media_source_get_comment (MediaSource* self);
void media_source_set_title (MediaSource* self,
                             const gchar* title);
gboolean media_source_set_comment (MediaSource* self,
                                   const gchar* comment);
void media_source_get_dimensions (MediaSource* self,
                                  PhotoException disallowed_steps,
                                  Dimensions* result);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
void photo_rotate (Photo* self,
                   Rotation rotation);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self,
                                    Scaling* scaling,
                                    GError** error);
gboolean photo_has_user_generated_metadata (Photo* self);
void photo_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata);
gboolean photo_exception_prohibits (PhotoException self,
                                    PhotoException exception);
gboolean photo_exception_allows (PhotoException self,
                                 PhotoException exception);
#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 64
#define PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC 10
#define PHOTO_SOURCE_PIXBUF_MIN_LRU_COUNT 1
#define PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT 3
#define PHOTO_MIN_EMBEDDED_SIZE 1024
static gpointer photo_cached_pixbuf_ref (gpointer instance);
static void photo_cached_pixbuf_unref (gpointer instance);
static GParamSpec* photo_param_spec_cached_pixbuf (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags) G_GNUC_UNUSED ;
static void photo_value_set_cached_pixbuf (GValue* value,
                                    gpointer v_object) G_GNUC_UNUSED ;
static void photo_value_take_cached_pixbuf (GValue* value,
                                     gpointer v_object) G_GNUC_UNUSED ;
static gpointer photo_value_get_cached_pixbuf (const GValue* value) G_GNUC_UNUSED ;
static GType photo_cached_pixbuf_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoCachedPixbuf, photo_cached_pixbuf_unref)
BackingPhotoRow* backing_photo_row_new (void);
BackingPhotoRow* backing_photo_row_construct (GType object_type);
static PhotoBackingReaders* photo_backing_readers_new (void);
static PhotoBackingReaders* photo_backing_readers_construct (GType object_type);
Photo* photo_construct (GType object_type,
                        PhotoRow* row);
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) -1)
PhotoSource* photo_source_construct (GType object_type,
                                     gint64 object_id);
gchar* media_source_prep_title (const gchar* title);
GType photo_id_get_type (void) G_GNUC_CONST ;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType orientation_get_type (void) G_GNUC_CONST ;
GType backing_photo_id_get_type (void) G_GNUC_CONST ;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
gchar* media_source_prep_comment (const gchar* comment);
gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_photo_file_adapter (GValue* value,
                                   gpointer v_object);
void value_take_photo_file_adapter (GValue* value,
                                    gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileAdapter, photo_file_adapter_unref)
GType photo_file_reader_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileReader, photo_file_adapter_unref)
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self,
                                                  const gchar* filepath);
gchar* string_sliced_at_last_char (const gchar* haystack,
                                   gunichar ch,
                                   gint start_index);
gchar* string_sliced_at (const gchar* str,
                         gint index);
gboolean is_string_empty (const gchar* s);
#define BACKING_PHOTO_ID_INVALID ((gint64) -1)
static BackingPhotoRow* photo_get_backing_row (Photo* self,
                                        BackingPhotoID* id);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
GType photo_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoTable, database_table_unref)
PhotoTable* photo_table_get_instance (void);
GQuark database_error_quark (void);
void photo_table_detach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  GError** error);
void photo_remove_all_transformations (Photo* self,
                                       gboolean notify);
RawDeveloper* raw_developer_as_array (gint* result_length1);
void photo_init_photo (void);
void photo_terminate_photo (void);
static void photo_real_notify_editable_replaced (Photo* self,
                                          GFile* old_file,
                                          GFile* new_file);
static void photo_real_notify_raw_development_modified (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
static void photo_real_notify_master_reimported (Photo* self,
                                          PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self,
                                            PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self,
                                          PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self,
                                            PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base,
                                             GError** error);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self,
                            gboolean delete_editable,
                            gboolean remove_transformations,
                            gboolean notify);
PhotoFileFormat photo_get_master_file_format (Photo* self);
static gboolean photo_delete_raw_development (Photo* self,
                                       RawDeveloper d);
GType backing_photo_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingPhotoTable, database_table_unref)
BackingPhotoTable* backing_photo_table_get_instance (void);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            GError** error);
void backing_photo_table_remove (BackingPhotoTable* self,
                                 BackingPhotoID* backing_id,
                                 GError** error);
gboolean photo_is_raw_developer_complete (Photo* self,
                                          RawDeveloper d);
gboolean photo_is_raw_developer_available (Photo* self,
                                           RawDeveloper d);
PhotoMetadata* photo_get_master_metadata (Photo* self,
                                          GError** error);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_photo_preview (GValue* value,
                              gpointer v_object);
void value_take_photo_preview (GValue* value,
                               gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoPreview, photo_preview_unref)
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self,
                                          guint number);
void photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                         Dimensions* result);
void photo_add_backing_photo_for_development (Photo* self,
                                              RawDeveloper d,
                                              BackingPhotoRow* bpr,
                                              gboolean notify,
                                              GError** error);
void photo_import_developed_backing_photo (PhotoRow* row,
                                           RawDeveloper d,
                                           BackingPhotoRow* bpr,
                                           GError** error);
void data_object_notify_altered (DataObject* self,
                                 Alteration* alteration);
Alteration* alteration_new (const gchar* subject,
                            const gchar* detail);
Alteration* alteration_construct (GType object_type,
                                  const gchar* subject,
                                  const gchar* detail);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value,
                                        gpointer v_object);
void value_take_photo_file_interrogator (GValue* value,
                                         gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileInterrogator, photo_file_interrogator_unref)
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file,
                                                    PhotoFileSnifferOptions options);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type,
                                                          GFile* file,
                                                          PhotoFileSnifferOptions options);
void photo_file_interrogator_interrogate (PhotoFileInterrogator* self,
                                          GError** error);
gpointer detected_photo_information_ref (gpointer instance);
void detected_photo_information_unref (gpointer instance);
GParamSpec* param_spec_detected_photo_information (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
void value_set_detected_photo_information (GValue* value,
                                           gpointer v_object);
void value_take_detected_photo_information (GValue* value,
                                            gpointer v_object);
gpointer value_get_detected_photo_information (const GValue* value);
GType detected_photo_information_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DetectedPhotoInformation, detected_photo_information_unref)
DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
gboolean photo_file_interrogator_get_is_photo_corrupted (PhotoFileInterrogator* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void backing_photo_table_add (BackingPhotoTable* self,
                              BackingPhotoRow* state,
                              GError** error);
void photo_table_update_raw_development (PhotoTable* self,
                                         PhotoRow* row,
                                         RawDeveloper rd,
                                         BackingPhotoID* backing_photo_id,
                                         GError** error);
static void photo_develop_photo (Photo* self,
                          RawDeveloper d,
                          gboolean notify);
BackingPhotoRow* raw_developer_create_backing_row_for_development (RawDeveloper self,
                                                                   const gchar* raw_filepath,
                                                                   const gchar* camera_development_filename,
                                                                   GError** error);
GdkPixbuf* photo_get_master_pixbuf (Photo* self,
                                    Scaling* scaling,
                                    gboolean rotate,
                                    GError** error);
void scaling_for_original (Scaling* result);
GType photo_file_writer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileWriter, photo_file_adapter_unref)
GQuark photo_format_error_quark (void);
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self,
                                                  const gchar* filepath,
                                                  GError** error);
GType jpeg_quality_get_type (void) G_GNUC_CONST ;
void photo_file_writer_write (PhotoFileWriter* self,
                              GdkPixbuf* pixbuf,
                              JpegQuality quality,
                              GError** error);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileMetadataWriter, photo_file_adapter_unref)
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self,
                                                                   const gchar* filepath,
                                                                   GError** error);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self,
                                                PhotoMetadata* metadata,
                                                GError** error);
GBytes* photo_preview_flatten (PhotoPreview* self,
                               GError** error);
gboolean jpeg_is_jpeg_bytes (GBytes* bytes,
                             GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self,
                                     GError** error);
void photo_set_default_raw_developer (Photo* self,
                                      RawDeveloper d);
void photo_set_raw_developer (Photo* self,
                              RawDeveloper d,
                              gboolean notify);
void photo_revert_to_master (Photo* self,
                             gboolean notify);
GdkPixbuf* photo_get_prefetched_copy (Photo* self,
                                      GError** error);
gboolean photo_set_orientation (Photo* self,
                                Orientation orientation);
void photo_discard_prefetched (Photo* self);
RawDeveloper photo_get_raw_developer (Photo* self);
gchar* raw_developer_to_string (RawDeveloper self);
void photo_table_remove_development (PhotoTable* self,
                                     PhotoRow* row,
                                     RawDeveloper rd,
                                     GError** error);
void photo_redevelop_raw (Photo* self,
                          RawDeveloper d);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base,
                                                       gint* result_length1);
BackingFileState* backing_file_state_new_from_photo_row (BackingPhotoRow* photo_row,
                                                         const gchar* md5);
BackingFileState* backing_file_state_construct_from_photo_row (GType object_type,
                                                               BackingPhotoRow* photo_row,
                                                               const gchar* md5);
static void _vala_array_add84 (BackingFileState** * array,
                        gint* length,
                        gint* size,
                        BackingFileState* value);
gboolean photo_has_editable (Photo* self);
static void _vala_array_add85 (BackingFileState** * array,
                        gint* length,
                        gint* size,
                        BackingFileState* value);
gboolean photo_is_developed (Photo* self);
GeeCollection* photo_get_raw_development_photo_rows (Photo* self);
static void _vala_array_add86 (BackingFileState** * array,
                        gint* length,
                        gint* size,
                        BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self,
                                           BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
static PhotoFileReader* photo_get_raw_developer_reader (Photo* self);
PhotoFileReader* photo_get_editable_reader (Photo* self);
gboolean photo_does_master_exist (Photo* self);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gboolean photo_does_editable_exist (Photo* self);
gboolean photo_is_master_baseline (Photo* self);
gboolean photo_is_master_source (Photo* self);
gboolean photo_is_editable_baseline (Photo* self);
gboolean photo_is_editable_source (Photo* self);
BackingPhotoRow* photo_get_master_photo_row (Photo* self);
BackingPhotoRow* photo_get_editable_photo_row (Photo* self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self,
                                                      RawDeveloper d);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
GType export_format_parameters_get_type (void) G_GNUC_CONST ;
GType export_format_mode_get_type (void) G_GNUC_CONST ;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
PhotoFileFormat photo_get_export_format_for_parameters (Photo* self,
                                                        ExportFormatParameters* params);
PhotoFileFormat photo_file_format_get_system_default_format (void);
PhotoFileFormat photo_get_best_export_file_format (Photo* self);
gchar* photo_get_export_basename_for_parameters (Photo* self,
                                                 ExportFormatParameters* params);
gchar* photo_get_export_basename (Photo* self,
                                  PhotoFileFormat* file_format);
GType import_result_get_type (void) G_GNUC_CONST ;
ImportResult photo_prepare_for_import (PhotoImportParams* params);
gboolean photo_is_file_image (GFile* file);
gboolean photo_file_format_is_file_supported (GFile* file);
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
void photo_metadata_get_gps_coords (PhotoMetadata* self,
                                    GpsCoords* result);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self,
                                     GCompareDataFunc compare_func,
                                     gpointer compare_func_target,
                                     GDestroyNotify compare_func_target_destroy_notify);
Rating photo_metadata_get_rating (PhotoMetadata* self);
#define PHOTO_ID_INVALID ((gint64) -1)
void photo_id_init (PhotoID *self,
                    gint64 id);
#define EVENT_ID_INVALID ((gint64) -1)
void event_id_init (EventID *self,
                    gint64 id);
GType photo_file_reader_role_get_type (void) G_GNUC_CONST ;
void photo_file_reader_set_role (PhotoFileReader* self,
                                 PhotoFileReaderRole role);
void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails,
                                         PhotoFileReader* reader,
                                         Orientation orientation,
                                         Dimensions* original_dim,
                                         GError** error);
ImportResult import_result_convert_error (GError* err,
                                          ImportResult default_result);
void photo_create_pre_import (PhotoImportParams* params);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
BackingPhotoRow* photo_query_backing_photo_row (Photo* self,
                                                GFile* file,
                                                PhotoFileSnifferOptions options,
                                                DetectedPhotoInformation** detected,
                                                GError** error);
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value,
                                            gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value,
                                             gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportMasterState, photo_reimport_master_state_unref)
gboolean photo_prepare_for_reimport_master (Photo* self,
                                            PhotoReimportMasterState** reimport_state,
                                            GError** error);
static void _vala_array_add87 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add88 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add89 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add90 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean _gps_coords_equal (const GpsCoords * s1,
                            const GpsCoords * s2);
static void _vala_array_add91 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add92 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add93 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row,
                                                                    PhotoMetadata* metadata,
                                                                    gchar** alterations,
                                                                    gint alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type,
                                                                          PhotoRow* row,
                                                                          PhotoMetadata* metadata,
                                                                          gchar** alterations,
                                                                          gint alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportMasterStateImpl, photo_reimport_master_state_unref)
static void photo_real_apply_user_metadata_for_reimport (Photo* self,
                                                  PhotoMetadata* metadata);
void photo_finish_reimport_master (Photo* self,
                                   PhotoReimportMasterState* state,
                                   GError** error);
void photo_table_reimport (PhotoTable* self,
                           PhotoRow* row,
                           GError** error);
void backing_photo_row_copy_from (BackingPhotoRow* self,
                                  BackingPhotoRow* from);
static void _vala_array_add94 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add95 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
Alteration* alteration_new_from_array (gchar** array,
                                       gint array_length1);
Alteration* alteration_construct_from_array (GType object_type,
                                             gchar** array,
                                             gint array_length1);
static gboolean photo_verify_file_for_reimport (Photo* self,
                                         GFile* file,
                                         BackingPhotoRow** backing,
                                         DetectedPhotoInformation** detected,
                                         GError** error);
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name,
                                                      const gchar* nick,
                                                      const gchar* blurb,
                                                      GType object_type,
                                                      GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value,
                                              gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value,
                                               gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportEditableState, photo_reimport_editable_state_unref)
gboolean photo_prepare_for_reimport_editable (Photo* self,
                                              PhotoReimportEditableState** state,
                                              GError** error);
GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                                                        PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type,
                                                                              BackingPhotoRow* backing_state,
                                                                              PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportEditableStateImpl, photo_reimport_editable_state_unref)
void photo_finish_reimport_editable (Photo* self,
                                     PhotoReimportEditableState* state,
                                     GError** error);
void photo_get_editable_id (Photo* self,
                            BackingPhotoID* result);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
void backing_photo_table_update (BackingPhotoTable* self,
                                 BackingPhotoRow* row,
                                 GError** error);
void positionable_set_gps_coords (Positionable* self,
                                  GpsCoords* gps_coords);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type,
                                            const gchar* list);
gpointer photo_reimport_raw_development_state_ref (gpointer instance);
void photo_reimport_raw_development_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                             const gchar* nick,
                                                             const gchar* blurb,
                                                             GType object_type,
                                                             GParamFlags flags);
void photo_value_set_reimport_raw_development_state (GValue* value,
                                                     gpointer v_object);
void photo_value_take_reimport_raw_development_state (GValue* value,
                                                      gpointer v_object);
gpointer photo_value_get_reimport_raw_development_state (const GValue* value);
GType photo_reimport_raw_development_state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportRawDevelopmentState, photo_reimport_raw_development_state_unref)
gboolean photo_prepare_for_reimport_raw_development (Photo* self,
                                                     PhotoReimportRawDevelopmentState** state,
                                                     GError** error);
GeeCollection* photo_get_raw_developer_files (Photo* self);
static GType photo_reimport_raw_development_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportRawDevelopmentStateImpl, photo_reimport_raw_development_state_unref)
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type);
static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                                    BackingPhotoRow* backing,
                                                    PhotoMetadata* metadata);
static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self);
void photo_finish_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState* state,
                                            GError** error);
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance);
static GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                                  const gchar* nick,
                                                                                  const gchar* blurb,
                                                                                  GType object_type,
                                                                                  GParamFlags flags) G_GNUC_UNUSED ;
static void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                          gpointer v_object) G_GNUC_UNUSED ;
static void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                           gpointer v_object) G_GNUC_UNUSED ;
static gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) G_GNUC_UNUSED ;
GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportRawDevelopmentStateImplDevToReimport, photo_reimport_raw_development_state_impl_dev_to_reimport_unref)
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
void photo_get_photo_id (Photo* self,
                         PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
void photo_set_master_timestamp (Photo* self,
                                 GFileInfo* info);
void photo_table_update_timestamp (PhotoTable* self,
                                   PhotoID* photo_id,
                                   time_t timestamp,
                                   GError** error);
void app_window_database_error (GError* err);
void photo_update_editable_modification_time (Photo* self,
                                              GFileInfo* info,
                                              GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                           BackingPhotoID* id,
                                           time_t timestamp,
                                           GError** error);
void photo_update_many_editable_timestamps (GeeMap* map,
                                            GError** error);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_get_file_format (Photo* self);
gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base,
                                        gint scale,
                                        GError** error);
void scaling_for_best_fit (gint pixels,
                           gboolean scale_up,
                           Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename,
                                   gchar** extensions,
                                   gint extensions_length1);
void disassemble_filename (const gchar* basename,
                           gchar** name,
                           gchar** ext);
gboolean photo_is_duplicate (GFile* file,
                             const gchar* thumbnail_md5,
                             const gchar* full_md5,
                             PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self,
                                    GFile* file,
                                    const gchar* thumbnail_md5,
                                    const gchar* md5,
                                    PhotoFileFormat file_format);
PhotoID* photo_get_duplicate_ids (GFile* file,
                                  const gchar* thumbnail_md5,
                                  const gchar* full_md5,
                                  PhotoFileFormat file_format,
                                  gint* result_length1);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self,
                                        GFile* file,
                                        const gchar* thumbnail_md5,
                                        const gchar* md5,
                                        PhotoFileFormat file_format,
                                        gint* result_length1);
gint64 photo_get_photo_key (DataSource* source);
GType library_photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryPhoto, g_object_unref)
static GFile* photo_real_get_file (MediaSource* base);
void photo_set_master_file (Photo* self,
                            GFile* file);
void photo_table_set_filepath (PhotoTable* self,
                               PhotoID* photo_id,
                               const gchar* filepath,
                               GError** error);
void media_source_notify_master_replaced (MediaSource* self,
                                          GFile* old_file,
                                          GFile* new_file);
static void _vala_array_add96 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add97 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add98 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add99 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
void photo_set_editable_file (Photo* self,
                              GFile* file);
void backing_photo_table_set_filepath (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       const gchar* filepath,
                                       GError** error);
static void _vala_array_add100 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add101 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add102 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
void photo_set_many_editable_file (GeeMap* map,
                                   GError** error);
GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
GFile* photo_get_source_file (Photo* self);
gboolean photo_file_format_can_write (PhotoFileFormat self);
static time_t photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base,
                              EventID* result);
gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base,
                               ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self,
                                 Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self,
                                 Alteration* other);
guint64 photo_replace_flags (Photo* self,
                             guint64 flags,
                             Alteration* additional_alteration);
gboolean photo_table_replace_flags (PhotoTable* self,
                                    PhotoID* photo_id,
                                    guint64 flags);
gboolean photo_is_flag_set (Photo* self,
                            guint64 mask);
gboolean media_source_internal_is_flag_set (guint64 flags,
                                            guint64 selector);
guint64 photo_add_flags (Photo* self,
                         guint64 mask,
                         Alteration* additional_alteration);
guint64 media_source_internal_add_flags (guint64 flags,
                                         guint64 selector);
guint64 photo_remove_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
guint64 media_source_internal_remove_flags (guint64 flags,
                                            guint64 selector);
guint64 photo_add_remove_flags (Photo* self,
                                guint64 add,
                                guint64 remove,
                                Alteration* additional_alteration);
void photo_add_remove_many_flags (GeeCollection* add,
                                  guint64 add_mask,
                                  Alteration* additional_add_alteration,
                                  GeeCollection* remove,
                                  guint64 remove_mask,
                                  Alteration* additional_remove_alteration,
                                  GError** error);
guint64 photo_toggle_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
gboolean photo_is_master_metadata_dirty (Photo* self);
void photo_set_master_metadata_dirty (Photo* self,
                                      gboolean dirty,
                                      GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self,
                                     PhotoID* photo_id,
                                     gboolean dirty,
                                     GError** error);
static Rating photo_real_get_rating (MediaSource* base);
static void photo_real_set_rating (MediaSource* base,
                            Rating rating);
gboolean photo_table_set_rating (PhotoTable* self,
                                 PhotoID* photo_id,
                                 Rating rating);
static void photo_real_increase_rating (MediaSource* base);
static void photo_real_decrease_rating (MediaSource* base);
static void photo_real_commit_backlinks (DataSource* base,
                                  SourceCollection* sources,
                                  const gchar* backlinks);
void photo_table_update_backlinks (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* backlinks,
                                   GError** error);
static gboolean photo_real_set_event_id (MediaSource* base,
                                  EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self,
                                PhotoID* photo_id,
                                EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base,
                            DataSource* source);
static void photo_file_exif_updated (Photo* self);
gboolean photo_table_master_exif_updated (PhotoTable* self,
                                          PhotoID* photoID,
                                          gint64 filesize,
                                          glong timestamp,
                                          const gchar* md5,
                                          const gchar* exif_md5,
                                          const gchar* thumbnail_md5,
                                          PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
guint64 photo_get_editable_filesize (Photo* self);
static time_t photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static gchar* photo_real_get_comment (MediaSource* base);
static void photo_real_set_title (MediaSource* base,
                           const gchar* title);
gboolean photo_table_set_title (PhotoTable* self,
                                PhotoID* photo_id,
                                const gchar* new_title);
static void photo_real_get_gps_coords (Positionable* base,
                                GpsCoords* result);
static void photo_real_set_gps_coords (Positionable* base,
                                GpsCoords* gps_coords);
void photo_table_set_gps_coords (PhotoTable* self,
                                 PhotoID* photo_id,
                                 GpsCoords* new_gps_coords,
                                 GError** error);
static gboolean photo_real_set_comment (MediaSource* base,
                                 const gchar* comment);
gboolean photo_table_set_comment (PhotoTable* self,
                                  PhotoID* photo_id,
                                  const gchar* new_comment);
void photo_set_import_id (Photo* self,
                          ImportID* import_id);
void photo_table_set_import_id (PhotoTable* self,
                                PhotoID* photo_id,
                                ImportID* import_id,
                                GError** error);
void photo_set_title_persistent (Photo* self,
                                 const gchar* title,
                                 GError** error);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self,
                                                GError** error);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST ;
void photo_metadata_set_title (PhotoMetadata* self,
                               const gchar* title,
                               PhotoMetadataSetOption option);
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self,
                                                                   GError** error);
void library_monitor_blacklist_file (GFile* file,
                                     const gchar* reason);
void library_monitor_unblacklist_file (GFile* file);
void photo_set_comment_persistent (Photo* self,
                                   const gchar* comment,
                                   GError** error);
void photo_metadata_set_comment (PhotoMetadata* self,
                                 const gchar* comment,
                                 PhotoMetadataSetOption option);
static void photo_real_set_exposure_time (Dateable* base,
                                   time_t time);
gboolean photo_table_set_exposure_time (PhotoTable* self,
                                        PhotoID* photo_id,
                                        time_t time);
void photo_set_exposure_time_persistent (Photo* self,
                                         time_t time,
                                         GError** error);
void dateable_set_exposure_time (Dateable* self,
                                 time_t target_time);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                            MetadataDateTime* date_time,
                                            PhotoMetadataSetOption option);
static void photo_real_get_dimensions (MediaSource* base,
                                PhotoException disallowed_steps,
                                Dimensions* result);
void photo_get_raw_dimensions (Photo* self,
                               Dimensions* result);
Orientation photo_get_orientation (Photo* self);
gboolean photo_get_straighten (Photo* self,
                               gdouble* theta);
void compute_arb_rotated_size (gdouble src_width,
                               gdouble src_height,
                               gdouble angle,
                               gdouble* dest_width,
                               gdouble* dest_height);
GType box_get_type (void) G_GNUC_CONST ;
Box* box_dup (const Box* self);
void box_free (Box* self);
gboolean photo_get_crop (Photo* self,
                         Box* crop,
                         PhotoException exceptions);
void box_get_dimensions (Box *self,
                         Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
static KeyValueMap* photo_get_transformation (Photo* self,
                                       const gchar* name);
PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
PixelTransformer* photo_get_pixel_transformer (Photo* self);
gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self,
                                   const gchar* name);
PixelTransformation* photo_get_color_adjustment (Photo* self,
                                                 PixelTransformationType type);
void photo_set_color_adjustments (Photo* self,
                                  PixelTransformationBundle* new_adjustments);
static gboolean photo_remove_transformation (Photo* self,
                                      const gchar* name);
static gboolean photo_set_transformation (Photo* self,
                                   KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
PhotoMetadata* photo_get_editable_metadata (Photo* self,
                                            GError** error);
gboolean photo_persist_master_metadata (Photo* self,
                                        PhotoMetadata* metadata,
                                        PhotoReimportMasterState** state,
                                        GError** error);
void photo_finish_update_master_metadata (Photo* self,
                                          PhotoReimportMasterState* state,
                                          GError** error);
gboolean photo_persist_editable_metadata (Photo* self,
                                          PhotoMetadata* metadata,
                                          PhotoReimportEditableState** state,
                                          GError** error);
void photo_finish_update_editable_metadata (Photo* self,
                                            PhotoReimportEditableState* state,
                                            GError** error);
gboolean photo_has_transformations (Photo* self);
gboolean photo_only_metadata_changed (Photo* self);
gboolean photo_has_alterations (Photo* self);
PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo,
                                                                              Orientation orientation,
                                                                              GeeHashMap* transformations,
                                                                              PixelTransformer* transformer,
                                                                              PixelTransformationBundle* adjustments);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type,
                                                                                    Photo* photo,
                                                                                    Orientation orientation,
                                                                                    GeeHashMap* transformations,
                                                                                    PixelTransformer* transformer,
                                                                                    PixelTransformationBundle* adjustments);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoPhotoTransformationStateImpl, g_object_unref)
gboolean photo_load_transformation_state (Photo* self,
                                          PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
gboolean photo_table_set_transformation_state (PhotoTable* self,
                                               PhotoID* photo_id,
                                               Orientation orientation,
                                               GeeHashMap* transformations);
gboolean photo_table_remove_all_transformations (PhotoTable* self,
                                                 PhotoID* photo_id);
gboolean photo_table_set_orientation (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation);
Orientation photo_get_original_orientation (Photo* self);
gboolean photo_check_can_rotate (Photo* self);
static void photo_real_rotate (Photo* self,
                        Rotation rotation);
Orientation orientation_perform (Orientation self,
                                 Rotation rotation);
gboolean photo_table_set_transformation (PhotoTable* self,
                                         PhotoID* photo_id,
                                         KeyValueMap* map);
gboolean photo_table_remove_transformation (PhotoTable* self,
                                            PhotoID* photo_id,
                                            const gchar* object);
gboolean photo_has_crop (Photo* self);
gboolean photo_get_raw_crop (Photo* self,
                             Box* crop);
void box_init (Box *self,
               gint left,
               gint top,
               gint right,
               gint bottom);
static void photo_set_raw_crop (Photo* self,
                         Box* crop);
static gboolean photo_get_raw_straighten (Photo* self,
                                   gdouble* angle);
static void photo_set_raw_straighten (Photo* self,
                               gdouble theta);
GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST ;
EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self,
                                                            gint* result_length1);
gboolean photo_has_redeye_transformations (Photo* self);
void photo_add_redeye_instance (Photo* self,
                                EditingToolsRedeyeInstance* redeye);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self,
                                            Scaling* scaling,
                                            PhotoException exceptions,
                                            Dimensions* scaled_image,
                                            Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                                   Scaling* scaling,
                                                   PhotoException exceptions,
                                                   Dimensions* scaled_image,
                                                   Dimensions* scaled_to_viewport);
gboolean scaling_is_unscaled (Scaling *self);
void orientation_rotate_box (Orientation self,
                             Dimensions* space,
                             Box* box,
                             Box* result);
void orientation_rotate_dimensions (Orientation self,
                                    Dimensions* dim,
                                    Dimensions* result);
void box_get_scaled (Box *self,
                     Dimensions* scaled,
                     Box* result);
void scaling_get_scaled_dimensions (Scaling *self,
                                    Dimensions* original,
                                    Dimensions* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
void dimensions_get_scaled_similar (Dimensions *self,
                                    Dimensions* original,
                                    Dimensions* scaled,
                                    Dimensions* result);
void orientation_derotate_dimensions (Orientation self,
                                      Dimensions* dim,
                                      Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self,
                                  Scaling* scaling,
                                  PhotoException exceptions,
                                  BackingFetchMode fetch_mode,
                                  GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self,
                                            GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self,
                                          Dimensions* full,
                                          Dimensions* scaled,
                                          GError** error);
gboolean dimensions_approx_equals (Dimensions *self,
                                   Dimensions* dim,
                                   gint fudge);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                            Dimensions* result);
static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self,
                                           Scaling* scaling,
                                           gboolean rotate,
                                           BackingFetchMode fetch_mode,
                                           GError** error);
GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self,
                                        Scaling* scaling,
                                        gboolean rotate,
                                        GError** error);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self,
                                      GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base,
                                  Scaling* scaling,
                                  GError** error);
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          BackingFetchMode fetch_mode,
                                          GError** error);
static GdkPixbuf* photo_run_source_pixbuf_cache (Photo* locate,
                                          gboolean keep,
                                          GError** error);
static PhotoCachedPixbuf* photo_cached_pixbuf_new (Photo* photo,
                                            GdkPixbuf* pixbuf);
static PhotoCachedPixbuf* photo_cached_pixbuf_construct (GType object_type,
                                                  Photo* photo,
                                                  GdkPixbuf* pixbuf);
static gboolean photo_trim_source_pixbuf_cache (void);
static gboolean _photo_trim_source_pixbuf_cache_gsource_func (gpointer self);
gboolean photo_get_develop_raw_photos_to_files (void);
gboolean dimensions_equals (Dimensions *self,
                            Dimensions* dim);
static GdkPixbuf* photo_do_redeye (Photo* self,
                            GdkPixbuf* pixbuf,
                            EditingToolsRedeyeInstance* inst);
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf,
                       gdouble angle);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
static void photo_real_set_user_metadata_for_export (Photo* self,
                                              PhotoMetadata* metadata);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value,
                                             gpointer v_object);
void value_take_photo_file_format_properties (GValue* value,
                                              gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileFormatProperties, photo_file_format_properties_unref)
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self,
                                                            GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self,
                                         GFile* file,
                                         gboolean export_metadata,
                                         GError** error);
PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                          Dimensions* dim,
                                          PhotoMetadataSetOption option);
void photo_metadata_set_orientation (PhotoMetadata* self,
                                     Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self,
                                  const gchar* software,
                                  const gchar* version);
#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_VERSION _VERSION
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_clear (PhotoMetadata* self);
gboolean photo_is_export_required (Photo* self,
                                   Scaling* scaling,
                                   PhotoFileFormat export_format);
void photo_export (Photo* self,
                   GFile* dest_file,
                   Scaling* scaling,
                   JpegQuality quality,
                   PhotoFileFormat export_format,
                   gboolean direct_copy_unmodified,
                   gboolean export_metadata,
                   GError** error);
void photo_metadata_remove_tag (PhotoMetadata* self,
                                const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self,
                                         PhotoFileFormat* file_format,
                                         GError** error);
gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self,
                                                               const gchar* ext);
gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
GFile* generate_unique_file (GFile* dir,
                             const gchar* basename,
                             gboolean* collision,
                             GError** error);
static gboolean photo_launch_editor (GFile* file,
                              PhotoFileFormat file_format,
                              GError** error);
GType configuration_facade_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigurationFacade, g_object_unref)
GType config_facade_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigFacade, g_object_unref)
ConfigFacade* config_facade_get_instance (void);
gchar* configuration_facade_get_external_raw_app (ConfigurationFacade* self);
gchar* configuration_facade_get_external_photo_app (ConfigurationFacade* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void photo_open_with_raw_external_editor (Photo* self,
                                          GError** error);
void photo_open_with_external_editor (Photo* self,
                                      GError** error);
static void photo_halt_monitoring_editable (Photo* self);
static void photo_attach_editable (Photo* self,
                            PhotoFileFormat file_format,
                            GFile* file,
                            GError** error);
static void photo_start_monitoring_editable (Photo* self,
                                      GFile* file,
                                      GError** error);
static void photo_on_editable_file_changed (Photo* self,
                                     GFile* file,
                                     GFile* other_file,
                                     GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                             GFile* file,
                                                             GFile* other_file,
                                                             GFileMonitorEvent event_type,
                                                             gpointer self);
static void photo_update_editable (Photo* self,
                            gboolean only_attributes,
                            PhotoFileReader* new_reader,
                            GError** error);
static void photo_update_editable_attributes (Photo* self,
                                       GError** error);
void photo_reimport_editable (Photo* self,
                              GError** error);
void photo_table_attach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  BackingPhotoID* editable_id,
                                  GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            time_t timestamp,
                                            gint64 filesize,
                                            GError** error);
static void _vala_array_add103 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add104 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add105 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add106 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add107 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add108 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
void backing_photo_id_init (BackingPhotoID *self,
                            gint64 id);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
OneShotScheduler* one_shot_scheduler_new (const gchar* name,
                                          OneShotCallback callback,
                                          gpointer callback_target);
OneShotScheduler* one_shot_scheduler_construct (GType object_type,
                                                const gchar* name,
                                                OneShotCallback callback,
                                                gpointer callback_target);
void one_shot_scheduler_after_timeout (OneShotScheduler* self,
                                       guint msec,
                                       gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
void photo_get_original_dimensions (Photo* self,
                                    Dimensions* result);
void photo_get_master_dimensions (Photo* self,
                                  Dimensions* result);
void photo_set_crop (Photo* self,
                     Box* crop);
void orientation_derotate_box (Orientation self,
                               Dimensions* space,
                               Box* box,
                               Box* result);
void photo_set_straighten (Photo* self,
                           gdouble theta);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self,
                                   GdkPixbuf* pixbuf,
                                   gint x,
                                   gint y);
void photo_unscaled_to_raw_point (Photo* self,
                                  GdkPoint* unscaled_point,
                                  GdkPoint* result);
void orientation_derotate_point (Orientation self,
                                 Dimensions* space,
                                 GdkPoint* point,
                                 GdkPoint* result);
void photo_unscaled_to_raw_rect (Photo* self,
                                 GdkRectangle* unscaled_rect,
                                 GdkRectangle* result);
PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
gboolean photo_enhance (Photo* self);
void photo_set_develop_raw_photos_to_files (gboolean value);
static void photo_real_editable_replaced (Photo* self,
                                   GFile* old_file,
                                   GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void photo_real_raw_development_modified (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                                gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject * obj);
static GType photo_photo_transformation_state_impl_get_type_once (void);
static void photo_backing_readers_finalize (PhotoBackingReaders * obj);
static GType photo_backing_readers_get_type_once (void);
static void photo_cached_pixbuf_finalize (PhotoCachedPixbuf * obj);
static GType photo_cached_pixbuf_get_type_once (void);
PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState * obj);
static GType photo_reimport_master_state_get_type_once (void);
static gchar** _vala_array_dup27 (gchar** self,
                           gint length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj);
static GType photo_reimport_master_state_impl_get_type_once (void);
PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj);
static GType photo_reimport_editable_state_get_type_once (void);
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj);
static GType photo_reimport_editable_state_impl_get_type_once (void);
PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type);
static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj);
static GType photo_reimport_raw_development_state_get_type_once (void);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                                                                                  PhotoMetadata* metadata);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                                                                        BackingPhotoRow* backing,
                                                                                                                        PhotoMetadata* metadata);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj);
static GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type_once (void);
static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj);
static GType photo_reimport_raw_development_state_impl_get_type_once (void);
time_t dateable_get_exposure_time (Dateable* self);
void positionable_get_gps_coords (Positionable* self,
                                  GpsCoords* result);
static void photo_finalize (GObject * obj);
static GType photo_get_type_once (void);
static void _vala_photo_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_photo_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST ;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_backlink (GValue* value,
                                gpointer v_object);
void value_take_source_backlink (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceBacklink, source_backlink_unref)
GType database_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseSourceCollection, data_collection_unref)
GType media_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceCollection, data_collection_unref)
GType database_source_holding_tank_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseSourceHoldingTank, source_holding_tank_unref)
GType media_source_holding_tank_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceHoldingTank, source_holding_tank_unref)
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
void value_set_workers (GValue* value,
                        gpointer v_object);
void value_take_workers (GValue* value,
                         gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Workers, workers_unref)
GType media_monitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaMonitor, g_object_unref)
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_transaction_controller (GValue* value,
                                       gpointer v_object);
void value_take_transaction_controller (GValue* value,
                                        gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TransactionController, transaction_controller_unref)
GType library_photo_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryPhotoSourceCollection, data_collection_unref)
MediaSourceHoldingTank* media_source_collection_create_trashcan (MediaSourceCollection* self);
MediaSourceHoldingTank* media_source_collection_create_offline_bin (MediaSourceCollection* self);
MediaMonitor* media_source_collection_create_media_monitor (MediaSourceCollection* self,
                                                            Workers* workers,
                                                            GCancellable* cancellable);
gboolean source_collection_holds_type_of_source (SourceCollection* self,
                                                 DataSource* source);
gchar* media_source_collection_get_typename (MediaSourceCollection* self);
gboolean media_source_collection_is_file_recognized (MediaSourceCollection* self,
                                                     GFile* file);
void data_collection_notify_contents_altered (DataCollection* self,
                                              GeeIterable* added,
                                              GeeIterable* removed);
void data_collection_items_altered (DataCollection* self,
                                    GeeMap* items);
void media_source_collection_postprocess_imported_media (MediaSourceCollection* self,
                                                         GeeCollection* media);
void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self,
                                                          gint64 numeric_id);
MediaSource* media_source_collection_fetch_by_source_id (MediaSourceCollection* self,
                                                         const gchar* source_id);
GeeCollection* media_source_collection_get_event_source_ids (MediaSourceCollection* self,
                                                             EventID* event_id);
gboolean source_collection_has_backlink (SourceCollection* self,
                                         SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self,
                                        SourceBacklink* backlink);
TransactionController* media_source_collection_get_transaction_controller (MediaSourceCollection* self);
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST ;
guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
gboolean file_equal (GFile* a,
                     GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
gint int64_compare (gint64* a,
                    gint64* b);
static gint _int64_compare_gcompare_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self);
static gint64* _int64_dup (gint64* self);
gboolean int64_equal (gint64* a,
                      gint64* b);
static gboolean _int64_equal_gee_equal_data_func (gconstpointer a,
                                           gconstpointer b,
                                           gpointer self);
LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source,
                                                     gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type,
                                                          const gchar* name,
                                                          GetSourceDatabaseKey source_key_func,
                                                          gpointer source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                                   GeeCollection* added,
                                                                   GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                         GeeCollection* added,
                                                                                                         GeeCollection* removed,
                                                                                                         gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                                  GeeCollection* added,
                                                                  GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                        GeeCollection* added,
                                                                                                        GeeCollection* removed,
                                                                                                        gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                                                      SourceHoldingTankCheckToKeep check_to_keep,
                                                                      gpointer check_to_keep_target,
                                                                      GetSourceDatabaseKey get_key,
                                                                      gpointer get_key_target);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type,
                                                                            LibraryPhotoSourceCollection* sources,
                                                                            SourceHoldingTankCheckToKeep check_to_keep,
                                                                            gpointer check_to_keep_target,
                                                                            GetSourceDatabaseKey get_key,
                                                                            gpointer get_key_target);
GType library_photo_source_holding_tank_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryPhotoSourceHoldingTank, source_holding_tank_unref)
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                                         Workers* workers,
                                                                         GCancellable* cancellable);
PhotoMonitor* photo_monitor_new (Workers* workers,
                                 GCancellable* cancellable);
PhotoMonitor* photo_monitor_construct (GType object_type,
                                       Workers* workers,
                                       GCancellable* cancellable);
GType photo_monitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoMonitor, g_object_unref)
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                                    DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                                  GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                                   GeeIterable* added,
                                                                   GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                           Photo* photo,
                                                           GFile* old_file,
                                                           GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                    GFile* old_file,
                                                                                    GFile* new_file,
                                                                                    gpointer self);
static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                                  Photo* _photo);
static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                  gpointer self);
static void library_photo_source_collection_real_items_altered (DataCollection* base,
                                                         GeeMap* items);
gboolean alteration_has_detail (Alteration* self,
                                const gchar* subject,
                                const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                      GeeCollection* media_sources);
GType tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tag, g_object_unref)
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value,
                                       gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value,
                                        gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HierarchicalTagIndex, hierarchical_tag_index_unref)
HierarchicalTagIndex* hierarchical_tag_index_get_global_index (void);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
HierarchicalTagIndex* hierarchical_tag_utilities_process_hierarchical_import_keywords (GeeCollection* h_keywords);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
gboolean hierarchical_tag_index_is_tag_in_index (HierarchicalTagIndex* self,
                                                 const gchar* tag);
gchar* tag_prep_tag_name (const gchar* name);
gchar* hierarchical_tag_index_get_path_for_name (HierarchicalTagIndex* self,
                                                 const gchar* name);
Tag* tag_for_path (const gchar* name);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
void library_photo_clear_import_keywords (LibraryPhoto* self);
void tag_attach_many (Tag* self,
                      GeeCollection* sources);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                                       gint64 numeric_id);
LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                                     PhotoID* photo_id);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                                      const gchar* source_id);
gint64 parse_int64 (const gchar* str,
                    gint num_base);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                                          EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self,
                                                EventID* event_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self,
                                                     gint64 key);
LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                                      GFile* file);
LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                                             GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                      LibraryPhoto* photo,
                                                      GFileInfo* info,
                                                      GeeCollection* matches_master,
                                                      GeeCollection* matches_editable,
                                                      GeeCollection* matches_development);
gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                              GFileInfo* info);
void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                                GFileInfo* info,
                                                                GeeCollection* matches_master,
                                                                GeeCollection* matches_editable,
                                                                GeeCollection* matched_development);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                      const gchar* basename,
                                                                      gint64 filesize,
                                                                      PhotoID* result);
gint utf8_ci_compare (void* a,
                      void* b);
gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                          const gchar* basename,
                                                                          gint64 filesize);
gboolean photo_id_is_valid (PhotoID *self);
LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self,
                                                             GFile* file);
LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                                       GFile* file);
LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self,
                                                     const gchar* md5);
LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                                 GFile* file,
                                                                 LibraryPhotoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self,
                                                           GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                            SourceBacklink* backlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self,
                                           SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                           SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self,
                                          SourceBacklink* backlink);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type,
                                                                                 MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceTransactionController, transaction_controller_unref)
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                          GValue * return_value,
                                                          guint n_param_values,
                                                          const GValue * param_values,
                                                          gpointer invocation_hint,
                                                          gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection * obj);
static GType library_photo_source_collection_get_type_once (void);
GType flaggable_get_type (void) G_GNUC_CONST ;
GType monitorable_get_type (void) G_GNUC_CONST ;
GdkPixbuf* media_source_get_preview_pixbuf (MediaSource* self,
                                            Scaling* scaling,
                                            GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self,
                                           gint scale,
                                           GError** error);
void media_source_trash (MediaSource* self);
void media_source_untrash (MediaSource* self);
void media_source_mark_offline (MediaSource* self);
void media_source_mark_online (MediaSource* self);
void data_source_destroy (DataSource* self);
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
static LibraryPhoto* library_photo_new (PhotoRow* row);
static LibraryPhoto* library_photo_construct (GType object_type,
                                       PhotoRow* row);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
static void library_photo_import_gps_metadata (LibraryPhoto* self);
static void _library_photo_import_gps_metadata_one_shot_callback (gpointer self);
void one_shot_scheduler_at_priority_idle (OneShotScheduler* self,
                                          gint priority);
void data_source_rehydrate_backlinks (DataSource* self,
                                      SourceCollection* unlinked_from,
                                      const gchar* dehydrated);
static void library_photo_upgrade_rating_flags (LibraryPhoto* self,
                                         guint64 flags);
static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params);
static LibraryPhoto* library_photo_construct_from_import_params (GType object_type,
                                                          PhotoImportParams* import_params);
void library_photo_init (ProgressMonitor monitor,
                         gpointer monitor_target);
GeeArrayList* photo_table_get_all (PhotoTable* self);
GeeCollection* data_collection_add_many (DataCollection* self,
                                         GeeCollection* objects,
                                         ProgressMonitor monitor,
                                         gpointer monitor_target);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self,
                                                GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self,
                                                  GeeCollection* sources);
void library_photo_terminate (void);
ImportResult library_photo_import_create (PhotoImportParams* params,
                                          LibraryPhoto** photo);
void photo_table_add (PhotoTable* self,
                      PhotoRow* photo_row,
                      PhotoID* result);
gboolean photo_id_is_invalid (PhotoID *self);
void library_photo_import_failed (LibraryPhoto* photo);
void photo_table_remove (PhotoTable* self,
                         PhotoID* photo_id,
                         GError** error);
static void library_photo_real_notify_master_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
void thumbnail_cache_import_from_source (ThumbnailSource* source,
                                         gboolean force,
                                         GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base,
                                        Alteration* alteration);
gboolean alteration_has_subject (Alteration* self,
                                 const gchar* subject);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base,
                                                  Scaling* scaling,
                                                  GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST ;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
static void library_photo_real_rotate (Photo* base,
                                Rotation rotation);
void thumbnail_cache_rotate (ThumbnailSource* source,
                             Rotation rotation,
                             GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base,
                                             gint scale,
                                             GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source,
                                  gint scale,
                                  GError** error);
static void library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                            BackingPhotoRow* backing,
                                            BackingPhotoID* result,
                                            GError** error);
GFile* library_files_duplicate (GFile* src,
                                GFileProgressCallback progress_callback,
                                gpointer progress_callback_target,
                                gboolean blacklist,
                                GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self,
                                          gint64 current,
                                          gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                                   gint64 total_num_bytes,
                                                                   gpointer self);
LibraryPhoto* library_photo_duplicate (LibraryPhoto* self,
                                       GError** error);
void photo_table_duplicate (PhotoTable* self,
                            PhotoID* photo_id,
                            const gchar* new_filename,
                            BackingPhotoID* editable_id,
                            BackingPhotoID* develop_shotwell,
                            BackingPhotoID* develop_camera_id,
                            BackingPhotoID* develop_embedded_id,
                            PhotoID* result);
PhotoRow* photo_table_get_row (PhotoTable* self,
                               PhotoID* photo_id);
void thumbnail_cache_duplicate (ThumbnailSource* src_source,
                                ThumbnailSource* dest_source);
gboolean data_collection_add (DataCollection* self,
                              DataObject* object);
GType event_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EventSource, g_object_unref)
GType event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Event, g_object_unref)
Event* media_source_get_event (MediaSource* self);
void event_attach (Event* self,
                   MediaSource* source);
GType container_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContainerSourceCollection, data_collection_unref)
GType tag_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TagSourceCollection, data_collection_unref)
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self,
                                                 MediaSource* source);
void tag_attach (Tag* self,
                 MediaSource* source);
GType face_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Face, g_object_unref)
GType face_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceSourceCollection, data_collection_unref)
GeeList* face_source_collection_fetch_for_source (FaceSourceCollection* self,
                                                  MediaSource* source);
GType face_location_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceLocation, g_object_unref)
GType face_id_get_type (void) G_GNUC_CONST ;
FaceID* face_id_dup (const FaceID* self);
void face_id_free (FaceID* self);
FaceLocation* face_location_get_face_location (FaceID* face_id,
                                               PhotoID* photo_id);
void face_get_face_id (Face* self,
                       FaceID* result);
void face_attach (Face* self,
                  MediaSource* source);
GType face_location_data_get_type (void) G_GNUC_CONST ;
FaceLocationData* face_location_data_dup (const FaceLocationData* self);
void face_location_data_free (FaceLocationData* self);
void face_location_data_copy (const FaceLocationData* self,
                              FaceLocationData* dest);
void face_location_data_destroy (FaceLocationData* self);
FaceLocation* face_location_create (FaceID* face_id,
                                    PhotoID* photo_id,
                                    FaceLocationData* face_data);
void face_location_get_face_data (FaceLocation* self,
                                  FaceLocationData* result);
void spin_event_loop (void);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base,
                                                     GError** error);
gboolean media_source_delete_original_file (MediaSource* self);
static void library_photo_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
gboolean library_photo_has_nontrash_duplicate (GFile* file,
                                               const gchar* thumbnail_md5,
                                               const gchar* full_md5,
                                               PhotoFileFormat file_format);
void library_photo_get_nontrash_duplicate (GFile* file,
                                           const gchar* thumbnail_md5,
                                           const gchar* full_md5,
                                           PhotoFileFormat file_format,
                                           PhotoID* result);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
gboolean gps_coords_equals (GpsCoords *self,
                            GpsCoords* gps);
gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base,
                                                      PhotoMetadata* metadata);
void photo_metadata_set_keywords (PhotoMetadata* self,
                                  GeeCollection* keywords,
                                  PhotoMetadataSetOption option);
void photo_metadata_set_rating (PhotoMetadata* self,
                                Rating rating);
void photo_metadata_set_gps_coords (PhotoMetadata* self,
                                    GpsCoords* gps_coords);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                          PhotoMetadata* metadata);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gchar* hierarchical_tag_utilities_flat_to_hierarchical (const gchar* name);
gboolean tag_source_collection_exists (TagSourceCollection* self,
                                       const gchar* name,
                                       gboolean treat_htags_as_root);
gboolean flaggable_is_flagged (Flaggable* self);
void flaggable_mark_flagged (Flaggable* self);
void flaggable_mark_unflagged (Flaggable* self);
gboolean monitorable_is_offline (Monitorable* self);
void monitorable_mark_offline (Monitorable* self);
void monitorable_mark_online (Monitorable* self);
static void library_photo_finalize (GObject * obj);
static GType library_photo_get_type_once (void);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self,
                                                  GeeCollection* added,
                                                  GeeCollection* removed);
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources,
                                                       SourceHoldingTankCheckToKeep check_to_keep,
                                                       gpointer check_to_keep_target,
                                                       GetSourceDatabaseKey get_key,
                                                       gpointer get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type,
                                                             MediaSourceCollection* sources,
                                                             SourceHoldingTankCheckToKeep check_to_keep,
                                                             gpointer check_to_keep_target,
                                                             GetSourceDatabaseKey get_key,
                                                             gpointer get_key_target);
static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                     GeeCollection* added,
                                                                     GeeCollection* removed);
static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                             Photo* _photo,
                                                             GFile* old_file,
                                                             GFile* new_file);
static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                      GFile* old_file,
                                                                                      GFile* new_file,
                                                                                      gpointer self);
static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                                    Photo* _photo);
static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                    gpointer self);
static void library_photo_source_holding_tank_finalize (SourceHoldingTank * obj);
static GType library_photo_source_holding_tank_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

static GType
backing_fetch_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {BACKING_FETCH_MODE_UNMODIFIED, "BACKING_FETCH_MODE_UNMODIFIED", "unmodified"}, {0, NULL, NULL}};
	GType backing_fetch_mode_type_id;
	backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
	return backing_fetch_mode_type_id;
}

GType
backing_fetch_mode_get_type (void)
{
	static volatile gsize backing_fetch_mode_type_id__volatile = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__volatile)) {
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = backing_fetch_mode_get_type_once ();
		g_once_init_leave (&backing_fetch_mode_type_id__volatile, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 4001 "Photo.c"
}

static gpointer
_thumbnails_ref0 (gpointer self)
{
#line 48 "../src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 4009 "Photo.c"
}

PhotoImportParams*
photo_import_params_construct (GType object_type,
                               GFile* file,
                               GFile* final_associated_file,
                               ImportID* import_id,
                               PhotoFileSnifferOptions sniffer_options,
                               const gchar* exif_md5,
                               const gchar* thumbnail_md5,
                               const gchar* full_md5,
                               Thumbnails* thumbnails)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	ImportID _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	Thumbnails* _tmp6_;
#line 38 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 38 "../src/Photo.vala"
	g_return_val_if_fail ((final_associated_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (final_associated_file, g_file_get_type ()), NULL);
#line 38 "../src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 38 "../src/Photo.vala"
	g_return_val_if_fail ((thumbnails == NULL) || IS_THUMBNAILS (thumbnails), NULL);
#line 38 "../src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 41 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 41 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 41 "../src/Photo.vala"
	self->file = _tmp0_;
#line 42 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (final_associated_file);
#line 42 "../src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 42 "../src/Photo.vala"
	self->final_associated_file = _tmp1_;
#line 43 "../src/Photo.vala"
	_tmp2_ = *import_id;
#line 43 "../src/Photo.vala"
	self->import_id = _tmp2_;
#line 44 "../src/Photo.vala"
	self->sniffer_options = sniffer_options;
#line 45 "../src/Photo.vala"
	_tmp3_ = g_strdup (exif_md5);
#line 45 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 45 "../src/Photo.vala"
	self->exif_md5 = _tmp3_;
#line 46 "../src/Photo.vala"
	_tmp4_ = g_strdup (thumbnail_md5);
#line 46 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 46 "../src/Photo.vala"
	self->thumbnail_md5 = _tmp4_;
#line 47 "../src/Photo.vala"
	_tmp5_ = g_strdup (full_md5);
#line 47 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 47 "../src/Photo.vala"
	self->full_md5 = _tmp5_;
#line 48 "../src/Photo.vala"
	_tmp6_ = _thumbnails_ref0 (thumbnails);
#line 48 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 48 "../src/Photo.vala"
	self->thumbnails = _tmp6_;
#line 38 "../src/Photo.vala"
	return self;
#line 4085 "Photo.c"
}

PhotoImportParams*
photo_import_params_new (GFile* file,
                         GFile* final_associated_file,
                         ImportID* import_id,
                         PhotoFileSnifferOptions sniffer_options,
                         const gchar* exif_md5,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         Thumbnails* thumbnails)
{
#line 38 "../src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, final_associated_file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 4100 "Photo.c"
}

PhotoImportParams*
photo_import_params_construct_create_placeholder (GType object_type,
                                                  GFile* file,
                                                  ImportID* import_id)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	ImportID _tmp1_;
#line 52 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 52 "../src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 52 "../src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 53 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 53 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 53 "../src/Photo.vala"
	self->file = _tmp0_;
#line 54 "../src/Photo.vala"
	_tmp1_ = *import_id;
#line 54 "../src/Photo.vala"
	self->import_id = _tmp1_;
#line 55 "../src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 56 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 56 "../src/Photo.vala"
	self->exif_md5 = NULL;
#line 57 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 57 "../src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 58 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 58 "../src/Photo.vala"
	self->full_md5 = NULL;
#line 59 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 59 "../src/Photo.vala"
	self->thumbnails = NULL;
#line 52 "../src/Photo.vala"
	return self;
#line 4147 "Photo.c"
}

PhotoImportParams*
photo_import_params_new_create_placeholder (GFile* file,
                                            ImportID* import_id)
{
#line 52 "../src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 4156 "Photo.c"
}

static void
value_photo_import_params_init (GValue* value)
{
#line 21 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 4164 "Photo.c"
}

static void
value_photo_import_params_free_value (GValue* value)
{
#line 21 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 21 "../src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 4174 "Photo.c"
	}
}

static void
value_photo_import_params_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 21 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 4186 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4190 "Photo.c"
	}
}

static gpointer
value_photo_import_params_peek_pointer (const GValue* value)
{
#line 21 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 4199 "Photo.c"
}

static gchar*
value_photo_import_params_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 21 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 4210 "Photo.c"
		PhotoImportParams * object;
		object = collect_values[0].v_pointer;
#line 21 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4217 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4221 "Photo.c"
		}
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 4225 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4229 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	return NULL;
#line 4233 "Photo.c"
}

static gchar*
value_photo_import_params_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	PhotoImportParams ** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "../src/Photo.vala"
	if (!object_p) {
#line 21 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4248 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 21 "../src/Photo.vala"
		*object_p = NULL;
#line 4254 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 4258 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 4262 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	return NULL;
#line 4266 "Photo.c"
}

GParamSpec*
param_spec_photo_import_params (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecPhotoImportParams* spec;
#line 21 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 4285 "Photo.c"
}

gpointer
value_get_photo_import_params (const GValue* value)
{
#line 21 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 4295 "Photo.c"
}

void
value_set_photo_import_params (GValue* value,
                               gpointer v_object)
{
	PhotoImportParams * old;
#line 21 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/Photo.vala"
	if (v_object) {
#line 21 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 21 "../src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 4317 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4321 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	if (old) {
#line 21 "../src/Photo.vala"
		photo_import_params_unref (old);
#line 4327 "Photo.c"
	}
}

void
value_take_photo_import_params (GValue* value,
                                gpointer v_object)
{
	PhotoImportParams * old;
#line 21 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/Photo.vala"
	if (v_object) {
#line 21 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 4348 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4352 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	if (old) {
#line 21 "../src/Photo.vala"
		photo_import_params_unref (old);
#line 4358 "Photo.c"
	}
}

static void
photo_import_params_class_init (PhotoImportParamsClass * klass,
                                gpointer klass_data)
{
#line 21 "../src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Photo.vala"
	((PhotoImportParamsClass *) klass)->finalize = photo_import_params_finalize;
#line 4370 "Photo.c"
}

static void
photo_import_params_instance_init (PhotoImportParams * self,
                                   gpointer klass)
{
	PhotoRow* _tmp0_;
#line 24 "../src/Photo.vala"
	self->final_associated_file = NULL;
#line 35 "../src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 35 "../src/Photo.vala"
	self->row = _tmp0_;
#line 36 "../src/Photo.vala"
	self->keywords = NULL;
#line 21 "../src/Photo.vala"
	self->ref_count = 1;
#line 4388 "Photo.c"
}

static void
photo_import_params_finalize (PhotoImportParams * obj)
{
	PhotoImportParams * self;
#line 21 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams);
#line 21 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 23 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 24 "../src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 27 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 28 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 29 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 32 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 35 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 36 "../src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 4415 "Photo.c"
}

static GType
photo_import_params_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_import_params_type_id;
	photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_import_params_type_id;
}

GType
photo_import_params_get_type (void)
{
	static volatile gsize photo_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&photo_import_params_type_id__volatile)) {
		GType photo_import_params_type_id;
		photo_import_params_type_id = photo_import_params_get_type_once ();
		g_once_init_leave (&photo_import_params_type_id__volatile, photo_import_params_type_id);
	}
	return photo_import_params_type_id__volatile;
}

gpointer
photo_import_params_ref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 21 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "../src/Photo.vala"
	return instance;
#line 4450 "Photo.c"
}

void
photo_import_params_unref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 21 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "../src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 21 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4464 "Photo.c"
	}
}

static inline gpointer
photo_transformation_state_get_instance_private (PhotoTransformationState* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoTransformationState_private_offset);
}

gboolean
photo_transformation_state_is_broken (PhotoTransformationState* self)
{
	gboolean result = FALSE;
#line 72 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (self), FALSE);
#line 73 "../src/Photo.vala"
	result = self->priv->is_broke;
#line 73 "../src/Photo.vala"
	return result;
#line 4484 "Photo.c"
}

PhotoTransformationState*
photo_transformation_state_construct (GType object_type)
{
	PhotoTransformationState * self = NULL;
#line 63 "../src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 63 "../src/Photo.vala"
	return self;
#line 4495 "Photo.c"
}

static void
photo_transformation_state_real_broken (PhotoTransformationState* self)
{
#line 69 "../src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 4503 "Photo.c"
}

static void
photo_transformation_state_class_init (PhotoTransformationStateClass * klass,
                                       gpointer klass_data)
{
#line 63 "../src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 63 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &PhotoTransformationState_private_offset);
#line 63 "../src/Photo.vala"
	((PhotoTransformationStateClass *) klass)->broken = photo_transformation_state_real_broken;
#line 63 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 63 "../src/Photo.vala"
	photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL] = g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4520 "Photo.c"
}

static void
photo_transformation_state_instance_init (PhotoTransformationState * self,
                                          gpointer klass)
{
#line 63 "../src/Photo.vala"
	self->priv = photo_transformation_state_get_instance_private (self);
#line 64 "../src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 4531 "Photo.c"
}

static void
photo_transformation_state_finalize (GObject * obj)
{
	PhotoTransformationState * self;
#line 63 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 63 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 4542 "Photo.c"
}

static GType
photo_transformation_state_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
	GType photo_transformation_state_type_id;
	photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	PhotoTransformationState_private_offset = g_type_add_instance_private (photo_transformation_state_type_id, sizeof (PhotoTransformationStatePrivate));
	return photo_transformation_state_type_id;
}

GType
photo_transformation_state_get_type (void)
{
	static volatile gsize photo_transformation_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__volatile)) {
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = photo_transformation_state_get_type_once ();
		g_once_init_leave (&photo_transformation_state_type_id__volatile, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__volatile;
}

gboolean
rating_can_increase (Rating self)
{
	gboolean result = FALSE;
#line 87 "../src/Photo.vala"
	result = self < RATING_FIVE;
#line 87 "../src/Photo.vala"
	return result;
#line 4575 "Photo.c"
}

gboolean
rating_can_decrease (Rating self)
{
	gboolean result = FALSE;
#line 91 "../src/Photo.vala"
	result = self > RATING_REJECTED;
#line 91 "../src/Photo.vala"
	return result;
#line 4586 "Photo.c"
}

gboolean
rating_is_valid (Rating self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
#line 95 "../src/Photo.vala"
	if (self >= RATING_REJECTED) {
#line 95 "../src/Photo.vala"
		_tmp0_ = self <= RATING_FIVE;
#line 4598 "Photo.c"
	} else {
#line 95 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 4602 "Photo.c"
	}
#line 95 "../src/Photo.vala"
	result = _tmp0_;
#line 95 "../src/Photo.vala"
	return result;
#line 4608 "Photo.c"
}

Rating
rating_increase (Rating self)
{
	Rating _tmp0_ = 0;
	Rating result = 0;
#line 99 "../src/Photo.vala"
	if (rating_can_increase (self)) {
#line 99 "../src/Photo.vala"
		_tmp0_ = self + 1;
#line 4620 "Photo.c"
	} else {
#line 99 "../src/Photo.vala"
		_tmp0_ = self;
#line 4624 "Photo.c"
	}
#line 99 "../src/Photo.vala"
	result = _tmp0_;
#line 99 "../src/Photo.vala"
	return result;
#line 4630 "Photo.c"
}

Rating
rating_decrease (Rating self)
{
	Rating _tmp0_ = 0;
	Rating result = 0;
#line 103 "../src/Photo.vala"
	if (rating_can_decrease (self)) {
#line 103 "../src/Photo.vala"
		_tmp0_ = self - 1;
#line 4642 "Photo.c"
	} else {
#line 103 "../src/Photo.vala"
		_tmp0_ = self;
#line 4646 "Photo.c"
	}
#line 103 "../src/Photo.vala"
	result = _tmp0_;
#line 103 "../src/Photo.vala"
	return result;
#line 4652 "Photo.c"
}

gint
rating_serialize (Rating self)
{
	gint result = 0;
#line 107 "../src/Photo.vala"
	switch (self) {
#line 107 "../src/Photo.vala"
		case RATING_REJECTED:
#line 4663 "Photo.c"
		{
#line 109 "../src/Photo.vala"
			result = -1;
#line 109 "../src/Photo.vala"
			return result;
#line 4669 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_UNRATED:
#line 4673 "Photo.c"
		{
#line 111 "../src/Photo.vala"
			result = 0;
#line 111 "../src/Photo.vala"
			return result;
#line 4679 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_ONE:
#line 4683 "Photo.c"
		{
#line 113 "../src/Photo.vala"
			result = 1;
#line 113 "../src/Photo.vala"
			return result;
#line 4689 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_TWO:
#line 4693 "Photo.c"
		{
#line 115 "../src/Photo.vala"
			result = 2;
#line 115 "../src/Photo.vala"
			return result;
#line 4699 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_THREE:
#line 4703 "Photo.c"
		{
#line 117 "../src/Photo.vala"
			result = 3;
#line 117 "../src/Photo.vala"
			return result;
#line 4709 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_FOUR:
#line 4713 "Photo.c"
		{
#line 119 "../src/Photo.vala"
			result = 4;
#line 119 "../src/Photo.vala"
			return result;
#line 4719 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_FIVE:
#line 4723 "Photo.c"
		{
#line 121 "../src/Photo.vala"
			result = 5;
#line 121 "../src/Photo.vala"
			return result;
#line 4729 "Photo.c"
		}
		default:
		{
#line 123 "../src/Photo.vala"
			result = 0;
#line 123 "../src/Photo.vala"
			return result;
#line 4737 "Photo.c"
		}
	}
}

Rating
rating_unserialize (gint value)
{
	Rating result = 0;
#line 128 "../src/Photo.vala"
	if (value > ((gint) RATING_FIVE)) {
#line 129 "../src/Photo.vala"
		result = RATING_FIVE;
#line 129 "../src/Photo.vala"
		return result;
#line 4752 "Photo.c"
	} else {
#line 130 "../src/Photo.vala"
		if (value < ((gint) RATING_REJECTED)) {
#line 131 "../src/Photo.vala"
			result = RATING_REJECTED;
#line 131 "../src/Photo.vala"
			return result;
#line 4760 "Photo.c"
		}
	}
#line 133 "../src/Photo.vala"
	switch (value) {
#line 133 "../src/Photo.vala"
		case -1:
#line 4767 "Photo.c"
		{
#line 135 "../src/Photo.vala"
			result = RATING_REJECTED;
#line 135 "../src/Photo.vala"
			return result;
#line 4773 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 0:
#line 4777 "Photo.c"
		{
#line 137 "../src/Photo.vala"
			result = RATING_UNRATED;
#line 137 "../src/Photo.vala"
			return result;
#line 4783 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 1:
#line 4787 "Photo.c"
		{
#line 139 "../src/Photo.vala"
			result = RATING_ONE;
#line 139 "../src/Photo.vala"
			return result;
#line 4793 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 2:
#line 4797 "Photo.c"
		{
#line 141 "../src/Photo.vala"
			result = RATING_TWO;
#line 141 "../src/Photo.vala"
			return result;
#line 4803 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 3:
#line 4807 "Photo.c"
		{
#line 143 "../src/Photo.vala"
			result = RATING_THREE;
#line 143 "../src/Photo.vala"
			return result;
#line 4813 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 4:
#line 4817 "Photo.c"
		{
#line 145 "../src/Photo.vala"
			result = RATING_FOUR;
#line 145 "../src/Photo.vala"
			return result;
#line 4823 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 5:
#line 4827 "Photo.c"
		{
#line 147 "../src/Photo.vala"
			result = RATING_FIVE;
#line 147 "../src/Photo.vala"
			return result;
#line 4833 "Photo.c"
		}
		default:
		{
#line 149 "../src/Photo.vala"
			result = RATING_UNRATED;
#line 149 "../src/Photo.vala"
			return result;
#line 4841 "Photo.c"
		}
	}
}

static GType
rating_get_type_once (void)
{
	static const GEnumValue values[] = {{RATING_REJECTED, "RATING_REJECTED", "rejected"}, {RATING_UNRATED, "RATING_UNRATED", "unrated"}, {RATING_ONE, "RATING_ONE", "one"}, {RATING_TWO, "RATING_TWO", "two"}, {RATING_THREE, "RATING_THREE", "three"}, {RATING_FOUR, "RATING_FOUR", "four"}, {RATING_FIVE, "RATING_FIVE", "five"}, {0, NULL, NULL}};
	GType rating_type_id;
	rating_type_id = g_enum_register_static ("Rating", values);
	return rating_type_id;
}

GType
rating_get_type (void)
{
	static volatile gsize rating_type_id__volatile = 0;
	if (g_once_init_enter (&rating_type_id__volatile)) {
		GType rating_type_id;
		rating_type_id = rating_get_type_once ();
		g_once_init_leave (&rating_type_id__volatile, rating_type_id);
	}
	return rating_type_id__volatile;
}

static inline gpointer
photo_get_instance_private (Photo* self)
{
	return G_STRUCT_MEMBER_P (self, Photo_private_offset);
}

gboolean
photo_exception_prohibits (PhotoException self,
                           PhotoException exception)
{
	gboolean result = FALSE;
#line 225 "../src/Photo.vala"
	result = (self & exception) != 0;
#line 225 "../src/Photo.vala"
	return result;
#line 4882 "Photo.c"
}

gboolean
photo_exception_allows (PhotoException self,
                        PhotoException exception)
{
	gboolean result = FALSE;
#line 229 "../src/Photo.vala"
	result = (self & exception) == 0;
#line 229 "../src/Photo.vala"
	return result;
#line 4894 "Photo.c"
}

static GType
photo_exception_get_type_once (void)
{
	static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_STRAIGHTEN, "PHOTO_EXCEPTION_STRAIGHTEN", "straighten"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
	GType photo_exception_type_id;
	photo_exception_type_id = g_enum_register_static ("PhotoException", values);
	return photo_exception_type_id;
}

GType
photo_exception_get_type (void)
{
	static volatile gsize photo_exception_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exception_type_id__volatile)) {
		GType photo_exception_type_id;
		photo_exception_type_id = photo_exception_get_type_once ();
		g_once_init_leave (&photo_exception_type_id__volatile, photo_exception_type_id);
	}
	return photo_exception_type_id__volatile;
}

static gpointer
_photo_row_ref0 (gpointer self)
{
#line 397 "../src/Photo.vala"
	return self ? photo_row_ref (self) : NULL;
#line 4923 "Photo.c"
}

static gpointer
_backing_photo_row_ref0 (gpointer self)
{
#line 418 "../src/Photo.vala"
	return self ? backing_photo_row_ref (self) : NULL;
#line 4931 "Photo.c"
}

Photo*
photo_construct (GType object_type,
                 PhotoRow* row)
{
	Photo * self = NULL;
	PhotoRow* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoRow* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	PhotoRow* _tmp5_;
	PhotoRow* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	PhotoBackingReaders* _tmp9_;
	BackingPhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	const gchar* _tmp12_;
	PhotoFileReader* _tmp13_;
	gchar* basename = NULL;
	BackingPhotoRow* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp20_;
	BackingPhotoID _tmp24_;
	BackingPhotoRow* _tmp38_;
	gboolean _tmp50_ = FALSE;
	BackingPhotoRow* _tmp51_;
	PhotoBackingReaders* _tmp60_;
	PhotoFileReader* _tmp61_;
	PhotoRow* _tmp74_;
	GError* _inner_error0_ = NULL;
#line 396 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 396 "../src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 397 "../src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 397 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 397 "../src/Photo.vala"
	self->row = _tmp0_;
#line 400 "../src/Photo.vala"
	_tmp1_ = self->row;
#line 400 "../src/Photo.vala"
	_tmp2_ = self->row;
#line 400 "../src/Photo.vala"
	_tmp3_ = _tmp2_->title;
#line 400 "../src/Photo.vala"
	_tmp4_ = media_source_prep_title (_tmp3_);
#line 400 "../src/Photo.vala"
	_g_free0 (_tmp1_->title);
#line 400 "../src/Photo.vala"
	_tmp1_->title = _tmp4_;
#line 401 "../src/Photo.vala"
	_tmp5_ = self->row;
#line 401 "../src/Photo.vala"
	_tmp6_ = self->row;
#line 401 "../src/Photo.vala"
	_tmp7_ = _tmp6_->comment;
#line 401 "../src/Photo.vala"
	_tmp8_ = media_source_prep_comment (_tmp7_);
#line 401 "../src/Photo.vala"
	_g_free0 (_tmp5_->comment);
#line 401 "../src/Photo.vala"
	_tmp5_->comment = _tmp8_;
#line 405 "../src/Photo.vala"
	_tmp9_ = self->priv->readers;
#line 405 "../src/Photo.vala"
	_tmp10_ = row->master;
#line 405 "../src/Photo.vala"
	_tmp11_ = row->master;
#line 405 "../src/Photo.vala"
	_tmp12_ = _tmp11_->filepath;
#line 405 "../src/Photo.vala"
	_tmp13_ = photo_file_format_create_reader (_tmp10_->file_format, _tmp12_);
#line 405 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp9_->master);
#line 405 "../src/Photo.vala"
	_tmp9_->master = _tmp13_;
#line 408 "../src/Photo.vala"
	_tmp14_ = row->master;
#line 408 "../src/Photo.vala"
	_tmp15_ = _tmp14_->filepath;
#line 408 "../src/Photo.vala"
	_tmp16_ = string_sliced_at_last_char (_tmp15_, (gunichar) G_DIR_SEPARATOR, 0);
#line 408 "../src/Photo.vala"
	basename = _tmp16_;
#line 409 "../src/Photo.vala"
	_tmp17_ = basename;
#line 409 "../src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 5027 "Photo.c"
		const gchar* _tmp18_;
		gchar* _tmp19_;
#line 410 "../src/Photo.vala"
		_tmp18_ = basename;
#line 410 "../src/Photo.vala"
		_tmp19_ = string_sliced_at (_tmp18_, 1);
#line 410 "../src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 410 "../src/Photo.vala"
		self->priv->file_title = _tmp19_;
#line 5038 "Photo.c"
	}
#line 412 "../src/Photo.vala"
	_tmp20_ = self->priv->file_title;
#line 412 "../src/Photo.vala"
	if (is_string_empty (_tmp20_)) {
#line 5044 "Photo.c"
		BackingPhotoRow* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
#line 413 "../src/Photo.vala"
		_tmp21_ = row->master;
#line 413 "../src/Photo.vala"
		_tmp22_ = _tmp21_->filepath;
#line 413 "../src/Photo.vala"
		_tmp23_ = g_strdup (_tmp22_);
#line 413 "../src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 413 "../src/Photo.vala"
		self->priv->file_title = _tmp23_;
#line 5058 "Photo.c"
	}
#line 415 "../src/Photo.vala"
	_tmp24_ = row->editable_id;
#line 415 "../src/Photo.vala"
	if (_tmp24_.id != BACKING_PHOTO_ID_INVALID) {
#line 5064 "Photo.c"
		BackingPhotoRow* e = NULL;
		BackingPhotoID _tmp25_;
		BackingPhotoRow* _tmp26_;
		BackingPhotoRow* _tmp27_;
#line 416 "../src/Photo.vala"
		_tmp25_ = row->editable_id;
#line 416 "../src/Photo.vala"
		_tmp26_ = photo_get_backing_row (self, &_tmp25_);
#line 416 "../src/Photo.vala"
		e = _tmp26_;
#line 417 "../src/Photo.vala"
		_tmp27_ = e;
#line 417 "../src/Photo.vala"
		if (_tmp27_ != NULL) {
#line 5079 "Photo.c"
			BackingPhotoRow* _tmp28_;
			BackingPhotoRow* _tmp29_;
			PhotoBackingReaders* _tmp30_;
			BackingPhotoRow* _tmp31_;
			BackingPhotoRow* _tmp32_;
			const gchar* _tmp33_;
			PhotoFileReader* _tmp34_;
#line 418 "../src/Photo.vala"
			_tmp28_ = e;
#line 418 "../src/Photo.vala"
			_tmp29_ = _backing_photo_row_ref0 (_tmp28_);
#line 418 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->priv->editable);
#line 418 "../src/Photo.vala"
			self->priv->editable = _tmp29_;
#line 419 "../src/Photo.vala"
			_tmp30_ = self->priv->readers;
#line 419 "../src/Photo.vala"
			_tmp31_ = self->priv->editable;
#line 419 "../src/Photo.vala"
			_tmp32_ = self->priv->editable;
#line 419 "../src/Photo.vala"
			_tmp33_ = _tmp32_->filepath;
#line 419 "../src/Photo.vala"
			_tmp34_ = photo_file_format_create_reader (_tmp31_->file_format, _tmp33_);
#line 419 "../src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp30_->editable);
#line 419 "../src/Photo.vala"
			_tmp30_->editable = _tmp34_;
#line 5109 "Photo.c"
		} else {
			{
				PhotoTable* _tmp35_;
				PhotoTable* _tmp36_;
				PhotoRow* _tmp37_;
#line 422 "../src/Photo.vala"
				_tmp35_ = photo_table_get_instance ();
#line 422 "../src/Photo.vala"
				_tmp36_ = _tmp35_;
#line 422 "../src/Photo.vala"
				_tmp37_ = self->row;
#line 422 "../src/Photo.vala"
				photo_table_detach_editable (_tmp36_, _tmp37_, &_inner_error0_);
#line 422 "../src/Photo.vala"
				_database_table_unref0 (_tmp36_);
#line 422 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 422 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5129 "Photo.c"
						goto __catch0_database_error;
					}
#line 422 "../src/Photo.vala"
					_backing_photo_row_unref0 (e);
#line 422 "../src/Photo.vala"
					_g_free0 (basename);
#line 422 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 422 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 422 "../src/Photo.vala"
					return NULL;
#line 5142 "Photo.c"
				}
			}
			goto __finally0;
			__catch0_database_error:
			{
#line 421 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 5150 "Photo.c"
			}
			__finally0:
#line 421 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 421 "../src/Photo.vala"
				_backing_photo_row_unref0 (e);
#line 421 "../src/Photo.vala"
				_g_free0 (basename);
#line 421 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 421 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 421 "../src/Photo.vala"
				return NULL;
#line 5165 "Photo.c"
			}
#line 429 "../src/Photo.vala"
			photo_remove_all_transformations (self, FALSE);
#line 5169 "Photo.c"
		}
#line 415 "../src/Photo.vala"
		_backing_photo_row_unref0 (e);
#line 5173 "Photo.c"
	}
#line 433 "../src/Photo.vala"
	_tmp38_ = row->master;
#line 433 "../src/Photo.vala"
	if (_tmp38_->file_format == PHOTO_FILE_FORMAT_RAW) {
#line 5179 "Photo.c"
		GeeHashMap* _tmp39_;
		gint _tmp40_ = 0;
		RawDeveloper* _tmp41_;
#line 435 "../src/Photo.vala"
		_tmp39_ = gee_hash_map_new (TYPE_RAW_DEVELOPER, NULL, NULL, TYPE_BACKING_PHOTO_ROW, (GBoxedCopyFunc) backing_photo_row_ref, (GDestroyNotify) backing_photo_row_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 435 "../src/Photo.vala"
		_g_object_unref0 (self->priv->developments);
#line 435 "../src/Photo.vala"
		self->priv->developments = _tmp39_;
#line 436 "../src/Photo.vala"
		_tmp41_ = raw_developer_as_array (&_tmp40_);
#line 5191 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 436 "../src/Photo.vala"
			d_collection = _tmp41_;
#line 436 "../src/Photo.vala"
			d_collection_length1 = _tmp40_;
#line 436 "../src/Photo.vala"
			for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 5203 "Photo.c"
				RawDeveloper d = 0;
#line 436 "../src/Photo.vala"
				d = d_collection[d_it];
#line 5207 "Photo.c"
				{
					BackingPhotoID id = {0};
					BackingPhotoID* _tmp42_;
					gint _tmp42__length1;
					BackingPhotoID _tmp43_;
					BackingPhotoID _tmp44_;
#line 437 "../src/Photo.vala"
					_tmp42_ = row->development_ids;
#line 437 "../src/Photo.vala"
					_tmp42__length1 = row->development_ids_length1;
#line 437 "../src/Photo.vala"
					_tmp43_ = _tmp42_[d];
#line 437 "../src/Photo.vala"
					id = _tmp43_;
#line 438 "../src/Photo.vala"
					_tmp44_ = id;
#line 438 "../src/Photo.vala"
					if (_tmp44_.id != BACKING_PHOTO_ID_INVALID) {
#line 5226 "Photo.c"
						BackingPhotoRow* bpr = NULL;
						BackingPhotoID _tmp45_;
						BackingPhotoRow* _tmp46_;
						BackingPhotoRow* _tmp47_;
#line 439 "../src/Photo.vala"
						_tmp45_ = id;
#line 439 "../src/Photo.vala"
						_tmp46_ = photo_get_backing_row (self, &_tmp45_);
#line 439 "../src/Photo.vala"
						bpr = _tmp46_;
#line 440 "../src/Photo.vala"
						_tmp47_ = bpr;
#line 440 "../src/Photo.vala"
						if (_tmp47_ != NULL) {
#line 5241 "Photo.c"
							GeeHashMap* _tmp48_;
							BackingPhotoRow* _tmp49_;
#line 441 "../src/Photo.vala"
							_tmp48_ = self->priv->developments;
#line 441 "../src/Photo.vala"
							_tmp49_ = bpr;
#line 441 "../src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), _tmp49_);
#line 5250 "Photo.c"
						}
#line 438 "../src/Photo.vala"
						_backing_photo_row_unref0 (bpr);
#line 5254 "Photo.c"
					}
				}
			}
#line 436 "../src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 5260 "Photo.c"
		}
	}
#line 447 "../src/Photo.vala"
	_tmp51_ = row->master;
#line 447 "../src/Photo.vala"
	if (_tmp51_->file_format == PHOTO_FILE_FORMAT_RAW) {
#line 5267 "Photo.c"
		GeeHashMap* _tmp52_;
#line 447 "../src/Photo.vala"
		_tmp52_ = self->priv->developments;
#line 447 "../src/Photo.vala"
		_tmp50_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) row->developer));
#line 5273 "Photo.c"
	} else {
#line 447 "../src/Photo.vala"
		_tmp50_ = FALSE;
#line 5277 "Photo.c"
	}
#line 447 "../src/Photo.vala"
	if (_tmp50_) {
#line 5281 "Photo.c"
		BackingPhotoRow* r = NULL;
		GeeHashMap* _tmp53_;
		gpointer _tmp54_;
		PhotoBackingReaders* _tmp55_;
		BackingPhotoRow* _tmp56_;
		BackingPhotoRow* _tmp57_;
		const gchar* _tmp58_;
		PhotoFileReader* _tmp59_;
#line 448 "../src/Photo.vala"
		_tmp53_ = self->priv->developments;
#line 448 "../src/Photo.vala"
		_tmp54_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) row->developer));
#line 448 "../src/Photo.vala"
		r = (BackingPhotoRow*) _tmp54_;
#line 449 "../src/Photo.vala"
		_tmp55_ = self->priv->readers;
#line 449 "../src/Photo.vala"
		_tmp56_ = r;
#line 449 "../src/Photo.vala"
		_tmp57_ = r;
#line 449 "../src/Photo.vala"
		_tmp58_ = _tmp57_->filepath;
#line 449 "../src/Photo.vala"
		_tmp59_ = photo_file_format_create_reader (_tmp56_->file_format, _tmp58_);
#line 449 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp55_->developer);
#line 449 "../src/Photo.vala"
		_tmp55_->developer = _tmp59_;
#line 447 "../src/Photo.vala"
		_backing_photo_row_unref0 (r);
#line 5312 "Photo.c"
	}
#line 453 "../src/Photo.vala"
	_tmp60_ = self->priv->readers;
#line 453 "../src/Photo.vala"
	_tmp61_ = _tmp60_->editable;
#line 453 "../src/Photo.vala"
	if (_tmp61_ != NULL) {
#line 5320 "Photo.c"
		BackingPhotoRow* _tmp62_;
		BackingPhotoRow* _tmp63_;
#line 454 "../src/Photo.vala"
		_tmp62_ = self->priv->editable;
#line 454 "../src/Photo.vala"
		_tmp63_ = _backing_photo_row_ref0 (_tmp62_);
#line 454 "../src/Photo.vala"
		_backing_photo_row_unref0 (self->backing_photo_row);
#line 454 "../src/Photo.vala"
		self->backing_photo_row = _tmp63_;
#line 5331 "Photo.c"
	} else {
		BackingPhotoRow* _tmp64_;
#line 455 "../src/Photo.vala"
		_tmp64_ = row->master;
#line 455 "../src/Photo.vala"
		if (_tmp64_->file_format != PHOTO_FILE_FORMAT_RAW) {
#line 5338 "Photo.c"
			PhotoRow* _tmp65_;
			BackingPhotoRow* _tmp66_;
			BackingPhotoRow* _tmp67_;
#line 456 "../src/Photo.vala"
			_tmp65_ = self->row;
#line 456 "../src/Photo.vala"
			_tmp66_ = _tmp65_->master;
#line 456 "../src/Photo.vala"
			_tmp67_ = _backing_photo_row_ref0 (_tmp66_);
#line 456 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 456 "../src/Photo.vala"
			self->backing_photo_row = _tmp67_;
#line 5352 "Photo.c"
		} else {
			GeeHashMap* _tmp68_;
#line 460 "../src/Photo.vala"
			_tmp68_ = self->priv->developments;
#line 460 "../src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) row->developer))) {
#line 5359 "Photo.c"
				GeeHashMap* _tmp69_;
				gpointer _tmp70_;
#line 461 "../src/Photo.vala"
				_tmp69_ = self->priv->developments;
#line 461 "../src/Photo.vala"
				_tmp70_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) row->developer));
#line 461 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 461 "../src/Photo.vala"
				self->backing_photo_row = (BackingPhotoRow*) _tmp70_;
#line 5370 "Photo.c"
			} else {
				PhotoRow* _tmp71_;
				BackingPhotoRow* _tmp72_;
				BackingPhotoRow* _tmp73_;
#line 464 "../src/Photo.vala"
				_tmp71_ = self->row;
#line 464 "../src/Photo.vala"
				_tmp72_ = _tmp71_->master;
#line 464 "../src/Photo.vala"
				_tmp73_ = _backing_photo_row_ref0 (_tmp72_);
#line 464 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 464 "../src/Photo.vala"
				self->backing_photo_row = _tmp73_;
#line 5385 "Photo.c"
			}
		}
	}
#line 468 "../src/Photo.vala"
	_tmp74_ = self->row;
#line 468 "../src/Photo.vala"
	self->priv->cached_exposure_time = _tmp74_->exposure_time;
#line 396 "../src/Photo.vala"
	_g_free0 (basename);
#line 396 "../src/Photo.vala"
	return self;
#line 5397 "Photo.c"
}

void
photo_init_photo (void)
{
	GeeLinkedList* _tmp0_;
#line 472 "../src/Photo.vala"
	_tmp0_ = gee_linked_list_new (PHOTO_TYPE_CACHED_PIXBUF, (GBoxedCopyFunc) photo_cached_pixbuf_ref, (GDestroyNotify) photo_cached_pixbuf_unref, NULL, NULL, NULL);
#line 472 "../src/Photo.vala"
	_g_object_unref0 (photo_source_pixbuf_cache);
#line 472 "../src/Photo.vala"
	photo_source_pixbuf_cache = _tmp0_;
#line 5410 "Photo.c"
}

void
photo_terminate_photo (void)
{
#line 476 "../src/Photo.vala"
	_g_object_unref0 (photo_source_pixbuf_cache);
#line 476 "../src/Photo.vala"
	photo_source_pixbuf_cache = NULL;
#line 478 "../src/Photo.vala"
	if (photo_discard_source_id != ((guint) 0)) {
#line 479 "../src/Photo.vala"
		g_source_remove (photo_discard_source_id);
#line 480 "../src/Photo.vala"
		photo_discard_source_id = (guint) 0;
#line 5426 "Photo.c"
	}
}

static void
photo_real_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file)
{
#line 484 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 484 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 485 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL], 0, old_file, new_file);
#line 5441 "Photo.c"
}

void
photo_notify_editable_replaced (Photo* self,
                                GFile* old_file,
                                GFile* new_file)
{
	PhotoClass* _klass_;
#line 484 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 484 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 484 "../src/Photo.vala"
	if (_klass_->notify_editable_replaced) {
#line 484 "../src/Photo.vala"
		_klass_->notify_editable_replaced (self, old_file, new_file);
#line 5458 "Photo.c"
	}
}

static void
photo_real_notify_raw_development_modified (Photo* self)
{
#line 489 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL], 0);
#line 5467 "Photo.c"
}

void
photo_notify_raw_development_modified (Photo* self)
{
	PhotoClass* _klass_;
#line 488 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 488 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 488 "../src/Photo.vala"
	if (_klass_->notify_raw_development_modified) {
#line 488 "../src/Photo.vala"
		_klass_->notify_raw_development_modified (self);
#line 5482 "Photo.c"
	}
}

static void
photo_real_notify_baseline_replaced (Photo* self)
{
#line 493 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL], 0);
#line 5491 "Photo.c"
}

void
photo_notify_baseline_replaced (Photo* self)
{
	PhotoClass* _klass_;
#line 492 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 492 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 492 "../src/Photo.vala"
	if (_klass_->notify_baseline_replaced) {
#line 492 "../src/Photo.vala"
		_klass_->notify_baseline_replaced (self);
#line 5506 "Photo.c"
	}
}

static void
photo_real_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 496 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 497 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL], 0, metadata);
#line 5518 "Photo.c"
}

void
photo_notify_master_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 496 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 496 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 496 "../src/Photo.vala"
	if (_klass_->notify_master_reimported) {
#line 496 "../src/Photo.vala"
		_klass_->notify_master_reimported (self, metadata);
#line 5534 "Photo.c"
	}
}

static void
photo_real_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 500 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 501 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL], 0, metadata);
#line 5546 "Photo.c"
}

void
photo_notify_editable_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 500 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 500 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 500 "../src/Photo.vala"
	if (_klass_->notify_editable_reimported) {
#line 500 "../src/Photo.vala"
		_klass_->notify_editable_reimported (self, metadata);
#line 5562 "Photo.c"
	}
}

static void
photo_real_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 504 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 505 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL], 0, metadata);
#line 5574 "Photo.c"
}

void
photo_notify_source_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 504 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 504 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 504 "../src/Photo.vala"
	if (_klass_->notify_source_reimported) {
#line 504 "../src/Photo.vala"
		_klass_->notify_source_reimported (self, metadata);
#line 5590 "Photo.c"
	}
}

static void
photo_real_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 508 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 509 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL], 0, metadata);
#line 5602 "Photo.c"
}

void
photo_notify_baseline_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 508 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 508 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 508 "../src/Photo.vala"
	if (_klass_->notify_baseline_reimported) {
#line 508 "../src/Photo.vala"
		_klass_->notify_baseline_reimported (self, metadata);
#line 5618 "Photo.c"
	}
}

static gboolean
photo_real_internal_delete_backing (DataSource* base,
                                    GError** error)
{
	Photo * self;
	gboolean ret = FALSE;
	GFile* file = NULL;
	GFile* _tmp10_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 512 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 513 "../src/Photo.vala"
	ret = TRUE;
#line 514 "../src/Photo.vala"
	file = NULL;
#line 5640 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 515 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 515 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5647 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 516 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 516 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 516 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 5657 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 517 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 517 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 517 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 517 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 517 "../src/Photo.vala"
				file = _tmp5_;
#line 5671 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp6_;
#line 515 "../src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 515 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5681 "Photo.c"
		}
#line 515 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5685 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 515 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 515 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 515 "../src/Photo.vala"
			return _tmp7_;
#line 5693 "Photo.c"
		}
	}
#line 520 "../src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE, TRUE);
#line 522 "../src/Photo.vala"
	if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 5700 "Photo.c"
		gint _tmp8_ = 0;
		RawDeveloper* _tmp9_;
#line 523 "../src/Photo.vala"
		_tmp9_ = raw_developer_as_array (&_tmp8_);
#line 5705 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 523 "../src/Photo.vala"
			d_collection = _tmp9_;
#line 523 "../src/Photo.vala"
			d_collection_length1 = _tmp8_;
#line 523 "../src/Photo.vala"
			for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 5717 "Photo.c"
				RawDeveloper d = 0;
#line 523 "../src/Photo.vala"
				d = d_collection[d_it];
#line 5721 "Photo.c"
				{
#line 524 "../src/Photo.vala"
					photo_delete_raw_development (self, d);
#line 5725 "Photo.c"
				}
			}
#line 523 "../src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 5730 "Photo.c"
		}
	}
#line 528 "../src/Photo.vala"
	_tmp10_ = file;
#line 528 "../src/Photo.vala"
	if (_tmp10_ != NULL) {
#line 5737 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
			GFile* _tmp12_;
#line 530 "../src/Photo.vala"
			_tmp12_ = file;
#line 530 "../src/Photo.vala"
			_tmp11_ = g_file_trash (_tmp12_, NULL, &_inner_error0_);
#line 530 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5747 "Photo.c"
				goto __catch1_g_error;
			}
#line 530 "../src/Photo.vala"
			ret = _tmp11_;
#line 5752 "Photo.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			GError* _tmp18_;
			const gchar* _tmp19_;
#line 529 "../src/Photo.vala"
			err = _inner_error0_;
#line 529 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 532 "../src/Photo.vala"
			ret = FALSE;
#line 533 "../src/Photo.vala"
			_tmp13_ = file;
#line 533 "../src/Photo.vala"
			_tmp14_ = g_file_get_path (_tmp13_);
#line 533 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 533 "../src/Photo.vala"
			_tmp16_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 533 "../src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 533 "../src/Photo.vala"
			_tmp18_ = err;
#line 533 "../src/Photo.vala"
			_tmp19_ = _tmp18_->message;
#line 533 "../src/Photo.vala"
			g_message ("Photo.vala:533: Unable to move editable %s for %s to trash: %s", _tmp15_, _tmp17_, _tmp19_);
#line 533 "../src/Photo.vala"
			_g_free0 (_tmp17_);
#line 533 "../src/Photo.vala"
			_g_free0 (_tmp15_);
#line 529 "../src/Photo.vala"
			_g_error_free0 (err);
#line 5793 "Photo.c"
		}
		__finally1:
#line 529 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5798 "Photo.c"
			gboolean _tmp20_ = FALSE;
#line 529 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 529 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 529 "../src/Photo.vala"
			return _tmp20_;
#line 5806 "Photo.c"
		}
	}
#line 539 "../src/Photo.vala"
	_tmp22_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), TYPE_DATA_SOURCE, DataSource), &_inner_error0_);
#line 539 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5813 "Photo.c"
		gboolean _tmp23_ = FALSE;
#line 539 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 539 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 539 "../src/Photo.vala"
		return _tmp23_;
#line 5821 "Photo.c"
	}
#line 539 "../src/Photo.vala"
	if (_tmp22_) {
#line 539 "../src/Photo.vala"
		_tmp21_ = ret;
#line 5827 "Photo.c"
	} else {
#line 539 "../src/Photo.vala"
		_tmp21_ = FALSE;
#line 5831 "Photo.c"
	}
#line 539 "../src/Photo.vala"
	result = _tmp21_;
#line 539 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 539 "../src/Photo.vala"
	return result;
#line 5839 "Photo.c"
}

static BackingPhotoRow*
photo_get_backing_row (Photo* self,
                       BackingPhotoID* id)
{
	BackingPhotoID _tmp0_;
	BackingPhotoRow* backing_row = NULL;
	BackingPhotoRow* _tmp12_;
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result = NULL;
#line 544 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 544 "../src/Photo.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 545 "../src/Photo.vala"
	_tmp0_ = *id;
#line 545 "../src/Photo.vala"
	if (_tmp0_.id == BACKING_PHOTO_ID_INVALID) {
#line 546 "../src/Photo.vala"
		result = NULL;
#line 546 "../src/Photo.vala"
		return result;
#line 5863 "Photo.c"
	}
#line 548 "../src/Photo.vala"
	backing_row = NULL;
#line 5867 "Photo.c"
	{
		BackingPhotoRow* _tmp1_ = NULL;
		BackingPhotoTable* _tmp2_;
		BackingPhotoTable* _tmp3_;
		BackingPhotoID _tmp4_;
		BackingPhotoRow* _tmp5_;
		BackingPhotoRow* _tmp6_;
		BackingPhotoRow* _tmp7_;
#line 550 "../src/Photo.vala"
		_tmp2_ = backing_photo_table_get_instance ();
#line 550 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 550 "../src/Photo.vala"
		_tmp4_ = *id;
#line 550 "../src/Photo.vala"
		_tmp5_ = backing_photo_table_fetch (_tmp3_, &_tmp4_, &_inner_error0_);
#line 550 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 550 "../src/Photo.vala"
		_database_table_unref0 (_tmp3_);
#line 550 "../src/Photo.vala"
		_tmp1_ = _tmp6_;
#line 550 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 550 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5894 "Photo.c"
				goto __catch0_database_error;
			}
#line 550 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 550 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 550 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 550 "../src/Photo.vala"
			return NULL;
#line 5905 "Photo.c"
		}
#line 550 "../src/Photo.vala"
		_tmp7_ = _tmp1_;
#line 550 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 550 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 550 "../src/Photo.vala"
		backing_row = _tmp7_;
#line 549 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp1_);
#line 5917 "Photo.c"
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 549 "../src/Photo.vala"
		err = _inner_error0_;
#line 549 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 552 "../src/Photo.vala"
		_tmp8_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 552 "../src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 552 "../src/Photo.vala"
		_tmp10_ = err;
#line 552 "../src/Photo.vala"
		_tmp11_ = _tmp10_->message;
#line 552 "../src/Photo.vala"
		g_warning ("Photo.vala:552: Unable to fetch backing state for %s: %s", _tmp9_, _tmp11_);
#line 552 "../src/Photo.vala"
		_g_free0 (_tmp9_);
#line 549 "../src/Photo.vala"
		_g_error_free0 (err);
#line 5945 "Photo.c"
	}
	__finally0:
#line 549 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 549 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 549 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 549 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 549 "../src/Photo.vala"
		return NULL;
#line 5958 "Photo.c"
	}
#line 555 "../src/Photo.vala"
	_tmp12_ = backing_row;
#line 555 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 5964 "Photo.c"
		{
			BackingPhotoTable* _tmp13_;
			BackingPhotoTable* _tmp14_;
			BackingPhotoID _tmp15_;
#line 557 "../src/Photo.vala"
			_tmp13_ = backing_photo_table_get_instance ();
#line 557 "../src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 557 "../src/Photo.vala"
			_tmp15_ = *id;
#line 557 "../src/Photo.vala"
			backing_photo_table_remove (_tmp14_, &_tmp15_, &_inner_error0_);
#line 557 "../src/Photo.vala"
			_database_table_unref0 (_tmp14_);
#line 557 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 557 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5983 "Photo.c"
					goto __catch1_database_error;
				}
#line 557 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing_row);
#line 557 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 557 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 557 "../src/Photo.vala"
				return NULL;
#line 5994 "Photo.c"
			}
		}
		goto __finally1;
		__catch1_database_error:
		{
#line 556 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 6002 "Photo.c"
		}
		__finally1:
#line 556 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 556 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 556 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 556 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 556 "../src/Photo.vala"
			return NULL;
#line 6015 "Photo.c"
		}
#line 561 "../src/Photo.vala"
		result = NULL;
#line 561 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 561 "../src/Photo.vala"
		return result;
#line 6023 "Photo.c"
	}
#line 564 "../src/Photo.vala"
	result = backing_row;
#line 564 "../src/Photo.vala"
	return result;
#line 6029 "Photo.c"
}

gboolean
photo_is_raw_developer_complete (Photo* self,
                                 RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 569 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 6040 "Photo.c"
	{
		GeeHashMap* _tmp0_;
		gboolean _tmp9_ = FALSE;
#line 570 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 570 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6048 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashMap* _tmp2_;
#line 571 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 571 "../src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 6056 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
				BackingPhotoRow* _tmp5_;
				const gchar* _tmp6_;
#line 572 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 572 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 572 "../src/Photo.vala"
				_tmp5_ = (BackingPhotoRow*) _tmp4_;
#line 572 "../src/Photo.vala"
				_tmp6_ = _tmp5_->filepath;
#line 572 "../src/Photo.vala"
				_tmp1_ = g_file_test (_tmp6_, G_FILE_TEST_EXISTS);
#line 572 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp5_);
#line 6073 "Photo.c"
			} else {
#line 571 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 6077 "Photo.c"
			}
#line 571 "../src/Photo.vala"
			result = _tmp1_;
#line 6081 "Photo.c"
			{
				GeeHashMap* _tmp7_;
#line 570 "../src/Photo.vala"
				_tmp7_ = self->priv->developments;
#line 570 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6088 "Photo.c"
			}
#line 571 "../src/Photo.vala"
			return result;
#line 6092 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp8_;
#line 570 "../src/Photo.vala"
			_tmp8_ = self->priv->developments;
#line 570 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6101 "Photo.c"
		}
#line 570 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 570 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 570 "../src/Photo.vala"
		return _tmp9_;
#line 6109 "Photo.c"
	}
}

gboolean
photo_is_raw_developer_available (Photo* self,
                                  RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 577 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 6121 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 578 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 578 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6128 "Photo.c"
		{
			GeeHashMap* _tmp1_;
#line 579 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 579 "../src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 580 "../src/Photo.vala"
				result = TRUE;
#line 6137 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 578 "../src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 578 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6144 "Photo.c"
				}
#line 580 "../src/Photo.vala"
				return result;
#line 6148 "Photo.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp3_;
#line 578 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 578 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6158 "Photo.c"
		}
#line 578 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6162 "Photo.c"
			gboolean _tmp4_ = FALSE;
#line 578 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 578 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 578 "../src/Photo.vala"
			return _tmp4_;
#line 6170 "Photo.c"
		}
	}
#line 583 "../src/Photo.vala"
	switch (d) {
#line 583 "../src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6177 "Photo.c"
		{
#line 585 "../src/Photo.vala"
			result = TRUE;
#line 585 "../src/Photo.vala"
			return result;
#line 6183 "Photo.c"
		}
#line 583 "../src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 6187 "Photo.c"
		{
#line 588 "../src/Photo.vala"
			result = FALSE;
#line 588 "../src/Photo.vala"
			return result;
#line 6193 "Photo.c"
		}
#line 583 "../src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 6197 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp5_;
				guint num_previews = 0U;
				PhotoMetadata* _tmp6_;
#line 592 "../src/Photo.vala"
				_tmp5_ = photo_get_master_metadata (self, &_inner_error0_);
#line 592 "../src/Photo.vala"
				meta = _tmp5_;
#line 592 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6210 "Photo.c"
					goto __catch1_g_error;
				}
#line 593 "../src/Photo.vala"
				_tmp6_ = meta;
#line 593 "../src/Photo.vala"
				num_previews = photo_metadata_get_preview_count (_tmp6_);
#line 595 "../src/Photo.vala"
				if (num_previews > ((guint) 0)) {
#line 6219 "Photo.c"
					PhotoPreview* prev = NULL;
					PhotoMetadata* _tmp7_;
					PhotoPreview* _tmp8_;
					PhotoPreview* _tmp9_;
					Dimensions dims = {0};
					PhotoPreview* _tmp10_;
					Dimensions _tmp11_ = {0};
					gint _tmp12_ = 0;
					Dimensions _tmp13_;
					Dimensions _tmp14_;
					gint preview_major_axis = 0;
#line 596 "../src/Photo.vala"
					_tmp7_ = meta;
#line 596 "../src/Photo.vala"
					_tmp8_ = photo_metadata_get_preview (_tmp7_, num_previews - 1);
#line 596 "../src/Photo.vala"
					prev = _tmp8_;
#line 599 "../src/Photo.vala"
					_tmp9_ = prev;
#line 599 "../src/Photo.vala"
					if (_tmp9_ == NULL) {
#line 600 "../src/Photo.vala"
						result = FALSE;
#line 600 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 600 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 600 "../src/Photo.vala"
						return result;
#line 6249 "Photo.c"
					}
#line 602 "../src/Photo.vala"
					_tmp10_ = prev;
#line 602 "../src/Photo.vala"
					photo_preview_get_pixel_dimensions (_tmp10_, &_tmp11_);
#line 602 "../src/Photo.vala"
					dims = _tmp11_;
#line 605 "../src/Photo.vala"
					_tmp13_ = dims;
#line 605 "../src/Photo.vala"
					_tmp14_ = dims;
#line 605 "../src/Photo.vala"
					if (_tmp13_.width > _tmp14_.height) {
#line 6263 "Photo.c"
						Dimensions _tmp15_;
#line 605 "../src/Photo.vala"
						_tmp15_ = dims;
#line 605 "../src/Photo.vala"
						_tmp12_ = _tmp15_.width;
#line 6269 "Photo.c"
					} else {
						Dimensions _tmp16_;
#line 605 "../src/Photo.vala"
						_tmp16_ = dims;
#line 605 "../src/Photo.vala"
						_tmp12_ = _tmp16_.height;
#line 6276 "Photo.c"
					}
#line 605 "../src/Photo.vala"
					preview_major_axis = _tmp12_;
#line 606 "../src/Photo.vala"
					if (preview_major_axis < PHOTO_MIN_EMBEDDED_SIZE) {
#line 607 "../src/Photo.vala"
						result = FALSE;
#line 607 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 607 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 607 "../src/Photo.vala"
						return result;
#line 6290 "Photo.c"
					}
#line 610 "../src/Photo.vala"
					result = TRUE;
#line 610 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 610 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 610 "../src/Photo.vala"
					return result;
#line 6300 "Photo.c"
				}
#line 614 "../src/Photo.vala"
				result = FALSE;
#line 614 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 614 "../src/Photo.vala"
				return result;
#line 6308 "Photo.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				GError* _tmp17_;
				const gchar* _tmp18_;
#line 591 "../src/Photo.vala"
				e = _inner_error0_;
#line 591 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 616 "../src/Photo.vala"
				_tmp17_ = e;
#line 616 "../src/Photo.vala"
				_tmp18_ = _tmp17_->message;
#line 616 "../src/Photo.vala"
				g_debug ("Photo.vala:616: Error accessing embedded preview. Message: %s", _tmp18_);
#line 591 "../src/Photo.vala"
				_g_error_free0 (e);
#line 6328 "Photo.c"
			}
			__finally1:
#line 591 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6333 "Photo.c"
				gboolean _tmp19_ = FALSE;
#line 591 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 591 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 591 "../src/Photo.vala"
				return _tmp19_;
#line 6341 "Photo.c"
			}
#line 618 "../src/Photo.vala"
			result = FALSE;
#line 618 "../src/Photo.vala"
			return result;
#line 6347 "Photo.c"
		}
		default:
		{
#line 621 "../src/Photo.vala"
			g_assert_not_reached ();
#line 6353 "Photo.c"
		}
	}
}

void
photo_add_backing_photo_for_development (Photo* self,
                                         RawDeveloper d,
                                         BackingPhotoRow* bpr,
                                         gboolean notify,
                                         GError** error)
{
	PhotoRow* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 628 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 628 "../src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 629 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 629 "../src/Photo.vala"
	photo_import_developed_backing_photo (_tmp0_, d, bpr, &_inner_error0_);
#line 629 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 629 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 629 "../src/Photo.vala"
		return;
#line 6381 "Photo.c"
	}
	{
		GeeHashMap* _tmp1_;
#line 630 "../src/Photo.vala"
		_tmp1_ = self->priv->developments;
#line 630 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6389 "Photo.c"
		{
			GeeHashMap* _tmp2_;
#line 631 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 631 "../src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), bpr);
#line 6396 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp3_;
#line 630 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 630 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6405 "Photo.c"
		}
#line 630 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 630 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 630 "../src/Photo.vala"
			return;
#line 6413 "Photo.c"
		}
	}
#line 634 "../src/Photo.vala"
	if (notify) {
#line 6418 "Photo.c"
		Alteration* _tmp4_;
		Alteration* _tmp5_;
#line 635 "../src/Photo.vala"
		_tmp4_ = alteration_new ("image", "developer");
#line 635 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 635 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp5_);
#line 635 "../src/Photo.vala"
		_alteration_unref0 (_tmp5_);
#line 6429 "Photo.c"
	}
}

void
photo_import_developed_backing_photo (PhotoRow* row,
                                      RawDeveloper d,
                                      BackingPhotoRow* bpr,
                                      GError** error)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp4_;
	GTimeVal _tmp5_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp6_;
	PhotoFileInterrogator* _tmp7_;
	PhotoFileInterrogator* _tmp8_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp9_;
	DetectedPhotoInformation* _tmp10_;
	gboolean _tmp11_ = FALSE;
	DetectedPhotoInformation* _tmp12_;
	DetectedPhotoInformation* _tmp14_;
	Dimensions _tmp15_;
	GFileInfo* _tmp16_;
	GTimeVal _tmp17_;
	Orientation _tmp18_ = 0;
	DetectedPhotoInformation* _tmp19_;
	PhotoMetadata* _tmp20_;
	BackingPhotoTable* _tmp23_;
	BackingPhotoTable* _tmp24_;
	PhotoTable* _tmp25_;
	PhotoTable* _tmp26_;
	BackingPhotoID _tmp27_;
	GError* _inner_error0_ = NULL;
#line 638 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 638 "../src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 640 "../src/Photo.vala"
	_tmp0_ = bpr->filepath;
#line 640 "../src/Photo.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 640 "../src/Photo.vala"
	file = _tmp1_;
#line 641 "../src/Photo.vala"
	_tmp2_ = file;
#line 641 "../src/Photo.vala"
	_tmp3_ = g_file_query_info (_tmp2_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 641 "../src/Photo.vala"
	info = _tmp3_;
#line 641 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 641 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 641 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 641 "../src/Photo.vala"
		return;
#line 6494 "Photo.c"
	}
#line 643 "../src/Photo.vala"
	_tmp4_ = info;
#line 643 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp4_, &_tmp5_);
#line 643 "../src/Photo.vala"
	timestamp = _tmp5_;
#line 645 "../src/Photo.vala"
	_tmp6_ = file;
#line 645 "../src/Photo.vala"
	_tmp7_ = photo_file_interrogator_new (_tmp6_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 645 "../src/Photo.vala"
	interrogator = _tmp7_;
#line 647 "../src/Photo.vala"
	_tmp8_ = interrogator;
#line 647 "../src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp8_, &_inner_error0_);
#line 647 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 647 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 647 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 647 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 647 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 647 "../src/Photo.vala"
		return;
#line 6524 "Photo.c"
	}
#line 649 "../src/Photo.vala"
	_tmp9_ = interrogator;
#line 649 "../src/Photo.vala"
	_tmp10_ = photo_file_interrogator_get_detected_photo_information (_tmp9_);
#line 649 "../src/Photo.vala"
	detected = _tmp10_;
#line 650 "../src/Photo.vala"
	_tmp12_ = detected;
#line 650 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 650 "../src/Photo.vala"
		_tmp11_ = TRUE;
#line 6538 "Photo.c"
	} else {
		PhotoFileInterrogator* _tmp13_;
#line 650 "../src/Photo.vala"
		_tmp13_ = interrogator;
#line 650 "../src/Photo.vala"
		_tmp11_ = photo_file_interrogator_get_is_photo_corrupted (_tmp13_);
#line 6545 "Photo.c"
	}
#line 650 "../src/Photo.vala"
	if (_tmp11_) {
#line 653 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 653 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 653 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 653 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 653 "../src/Photo.vala"
		return;
#line 6559 "Photo.c"
	}
#line 656 "../src/Photo.vala"
	_tmp14_ = detected;
#line 656 "../src/Photo.vala"
	_tmp15_ = _tmp14_->image_dim;
#line 656 "../src/Photo.vala"
	bpr->dim = _tmp15_;
#line 657 "../src/Photo.vala"
	_tmp16_ = info;
#line 657 "../src/Photo.vala"
	bpr->filesize = g_file_info_get_size (_tmp16_);
#line 658 "../src/Photo.vala"
	_tmp17_ = timestamp;
#line 658 "../src/Photo.vala"
	bpr->timestamp = (time_t) _tmp17_.tv_sec;
#line 659 "../src/Photo.vala"
	_tmp19_ = detected;
#line 659 "../src/Photo.vala"
	_tmp20_ = _tmp19_->metadata;
#line 659 "../src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 6581 "Photo.c"
		DetectedPhotoInformation* _tmp21_;
		PhotoMetadata* _tmp22_;
#line 659 "../src/Photo.vala"
		_tmp21_ = detected;
#line 659 "../src/Photo.vala"
		_tmp22_ = _tmp21_->metadata;
#line 659 "../src/Photo.vala"
		_tmp18_ = photo_metadata_get_orientation (_tmp22_);
#line 6590 "Photo.c"
	} else {
#line 660 "../src/Photo.vala"
		_tmp18_ = ORIENTATION_TOP_LEFT;
#line 6594 "Photo.c"
	}
#line 659 "../src/Photo.vala"
	bpr->original_orientation = _tmp18_;
#line 663 "../src/Photo.vala"
	_tmp23_ = backing_photo_table_get_instance ();
#line 663 "../src/Photo.vala"
	_tmp24_ = _tmp23_;
#line 663 "../src/Photo.vala"
	backing_photo_table_add (_tmp24_, bpr, &_inner_error0_);
#line 663 "../src/Photo.vala"
	_database_table_unref0 (_tmp24_);
#line 663 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 663 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 663 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 663 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 663 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 663 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 663 "../src/Photo.vala"
		return;
#line 6620 "Photo.c"
	}
#line 664 "../src/Photo.vala"
	_tmp25_ = photo_table_get_instance ();
#line 664 "../src/Photo.vala"
	_tmp26_ = _tmp25_;
#line 664 "../src/Photo.vala"
	_tmp27_ = bpr->id;
#line 664 "../src/Photo.vala"
	photo_table_update_raw_development (_tmp26_, row, d, &_tmp27_, &_inner_error0_);
#line 664 "../src/Photo.vala"
	_database_table_unref0 (_tmp26_);
#line 664 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 664 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 664 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 664 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 664 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 664 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 664 "../src/Photo.vala"
		return;
#line 6646 "Photo.c"
	}
#line 638 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 638 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 638 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 638 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 6656 "Photo.c"
}

static void
photo_develop_photo (Photo* self,
                     RawDeveloper d,
                     gboolean notify)
{
	gboolean wrote_img_to_disk = FALSE;
	BackingPhotoRow* bps = NULL;
	GError* _inner_error0_ = NULL;
#line 669 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 670 "../src/Photo.vala"
	wrote_img_to_disk = FALSE;
#line 671 "../src/Photo.vala"
	bps = NULL;
#line 673 "../src/Photo.vala"
	switch (d) {
#line 673 "../src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6677 "Photo.c"
		{
			{
				BackingPhotoRow* _tmp0_ = NULL;
				PhotoRow* _tmp1_;
				BackingPhotoRow* _tmp2_;
				const gchar* _tmp3_;
				BackingPhotoRow* _tmp4_;
				BackingPhotoRow* _tmp5_;
				GdkPixbuf* pix = NULL;
				GdkPixbuf* _tmp12_;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp16_;
				const gchar* _tmp17_;
				PhotoFileWriter* _tmp18_;
				PhotoFileWriter* _tmp19_;
				GdkPixbuf* _tmp20_;
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp21_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp22_;
				const gchar* _tmp23_;
				PhotoFileMetadataWriter* _tmp24_;
				PhotoFileMetadataWriter* _tmp25_;
				PhotoMetadata* _tmp26_;
#line 677 "../src/Photo.vala"
				_tmp1_ = self->row;
#line 677 "../src/Photo.vala"
				_tmp2_ = _tmp1_->master;
#line 677 "../src/Photo.vala"
				_tmp3_ = _tmp2_->filepath;
#line 677 "../src/Photo.vala"
				_tmp4_ = raw_developer_create_backing_row_for_development (d, _tmp3_, NULL, &_inner_error0_);
#line 677 "../src/Photo.vala"
				_tmp0_ = _tmp4_;
#line 677 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6714 "Photo.c"
					goto __catch0_g_error;
				}
#line 677 "../src/Photo.vala"
				_tmp5_ = _tmp0_;
#line 677 "../src/Photo.vala"
				_tmp0_ = NULL;
#line 677 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 677 "../src/Photo.vala"
				bps = _tmp5_;
#line 678 "../src/Photo.vala"
				pix = NULL;
#line 6727 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 679 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 679 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 6734 "Photo.c"
					{
						GdkPixbuf* _tmp7_ = NULL;
						Scaling _tmp8_ = {0};
						GdkPixbuf* _tmp9_;
						GdkPixbuf* _tmp10_;
#line 684 "../src/Photo.vala"
						scaling_for_original (&_tmp8_);
#line 684 "../src/Photo.vala"
						_tmp9_ = photo_get_master_pixbuf (self, &_tmp8_, FALSE, &_inner_error0_);
#line 684 "../src/Photo.vala"
						_tmp7_ = _tmp9_;
#line 684 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6748 "Photo.c"
							goto __finally1;
						}
#line 684 "../src/Photo.vala"
						_tmp10_ = _tmp7_;
#line 684 "../src/Photo.vala"
						_tmp7_ = NULL;
#line 684 "../src/Photo.vala"
						_g_object_unref0 (pix);
#line 684 "../src/Photo.vala"
						pix = _tmp10_;
#line 679 "../src/Photo.vala"
						_g_object_unref0 (_tmp7_);
#line 6761 "Photo.c"
					}
					__finally1:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp11_;
#line 679 "../src/Photo.vala"
						_tmp11_ = self->priv->readers;
#line 679 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6771 "Photo.c"
					}
#line 679 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 679 "../src/Photo.vala"
						_g_object_unref0 (pix);
#line 679 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp0_);
#line 6779 "Photo.c"
						goto __catch0_g_error;
					}
				}
#line 687 "../src/Photo.vala"
				_tmp12_ = pix;
#line 687 "../src/Photo.vala"
				if (_tmp12_ == NULL) {
#line 688 "../src/Photo.vala"
					g_debug ("Photo.vala:688: Could not get preview pixbuf");
#line 689 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 689 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6793 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 713 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 6798 "Photo.c"
							{
								BackingPhotoRow* _tmp13_;
#line 716 "../src/Photo.vala"
								_tmp13_ = bps;
#line 716 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp13_, notify, &_inner_error0_);
#line 716 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6807 "Photo.c"
									goto __catch2_g_error;
								}
#line 718 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6812 "Photo.c"
							}
							goto __finally2;
							__catch2_g_error:
							{
								GError* e = NULL;
								GError* _tmp14_;
								const gchar* _tmp15_;
#line 714 "../src/Photo.vala"
								e = _inner_error0_;
#line 714 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 720 "../src/Photo.vala"
								_tmp14_ = e;
#line 720 "../src/Photo.vala"
								_tmp15_ = _tmp14_->message;
#line 720 "../src/Photo.vala"
								g_debug ("Photo.vala:720: Error adding backing photo as development. Message: %s", _tmp15_);
#line 714 "../src/Photo.vala"
								_g_error_free0 (e);
#line 6832 "Photo.c"
							}
							__finally2:
#line 714 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6837 "Photo.c"
								goto __catch0_g_error;
							}
						}
					}
#line 689 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 689 "../src/Photo.vala"
					return;
#line 6846 "Photo.c"
				}
#line 693 "../src/Photo.vala"
				_tmp16_ = bps;
#line 693 "../src/Photo.vala"
				_tmp17_ = _tmp16_->filepath;
#line 693 "../src/Photo.vala"
				_tmp18_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp17_, &_inner_error0_);
#line 693 "../src/Photo.vala"
				writer = _tmp18_;
#line 693 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 693 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 693 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6862 "Photo.c"
					goto __catch0_g_error;
				}
#line 694 "../src/Photo.vala"
				_tmp19_ = writer;
#line 694 "../src/Photo.vala"
				_tmp20_ = pix;
#line 694 "../src/Photo.vala"
				photo_file_writer_write (_tmp19_, _tmp20_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 694 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 694 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 694 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 694 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6879 "Photo.c"
					goto __catch0_g_error;
				}
#line 702 "../src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 707 "../src/Photo.vala"
				_tmp21_ = photo_get_master_metadata (self, &_inner_error0_);
#line 707 "../src/Photo.vala"
				meta = _tmp21_;
#line 707 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 707 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 707 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 707 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6896 "Photo.c"
					goto __catch0_g_error;
				}
#line 708 "../src/Photo.vala"
				_tmp22_ = bps;
#line 708 "../src/Photo.vala"
				_tmp23_ = _tmp22_->filepath;
#line 708 "../src/Photo.vala"
				_tmp24_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp23_, &_inner_error0_);
#line 708 "../src/Photo.vala"
				mwriter = _tmp24_;
#line 708 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 708 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 708 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 708 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 708 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6917 "Photo.c"
					goto __catch0_g_error;
				}
#line 709 "../src/Photo.vala"
				_tmp25_ = mwriter;
#line 709 "../src/Photo.vala"
				_tmp26_ = meta;
#line 709 "../src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp25_, _tmp26_, &_inner_error0_);
#line 709 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 709 "../src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 709 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 709 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 709 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 709 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6938 "Photo.c"
					goto __catch0_g_error;
				}
#line 675 "../src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 675 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 675 "../src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 675 "../src/Photo.vala"
				_g_object_unref0 (pix);
#line 675 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp0_);
#line 6951 "Photo.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				GError* _tmp27_;
				const gchar* _tmp28_;
#line 675 "../src/Photo.vala"
				err = _inner_error0_;
#line 675 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 711 "../src/Photo.vala"
				_tmp27_ = err;
#line 711 "../src/Photo.vala"
				_tmp28_ = _tmp27_->message;
#line 711 "../src/Photo.vala"
				g_debug ("Photo.vala:711: Error developing photo: %s", _tmp28_);
#line 675 "../src/Photo.vala"
				_g_error_free0 (err);
#line 6971 "Photo.c"
			}
			__finally0:
			{
				GError* _inner_error1_ = NULL;
#line 713 "../src/Photo.vala"
				if (wrote_img_to_disk) {
#line 6978 "Photo.c"
					{
						BackingPhotoRow* _tmp29_;
#line 716 "../src/Photo.vala"
						_tmp29_ = bps;
#line 716 "../src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp29_, notify, &_inner_error1_);
#line 716 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 6987 "Photo.c"
							goto __catch3_g_error;
						}
#line 718 "../src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 6992 "Photo.c"
					}
					goto __finally3;
					__catch3_g_error:
					{
						GError* e = NULL;
						GError* _tmp30_;
						const gchar* _tmp31_;
#line 714 "../src/Photo.vala"
						e = _inner_error1_;
#line 714 "../src/Photo.vala"
						_inner_error1_ = NULL;
#line 720 "../src/Photo.vala"
						_tmp30_ = e;
#line 720 "../src/Photo.vala"
						_tmp31_ = _tmp30_->message;
#line 720 "../src/Photo.vala"
						g_debug ("Photo.vala:720: Error adding backing photo as development. Message: %s", _tmp31_);
#line 714 "../src/Photo.vala"
						_g_error_free0 (e);
#line 7012 "Photo.c"
					}
					__finally3:
#line 714 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 714 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 714 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 714 "../src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 714 "../src/Photo.vala"
						return;
#line 7025 "Photo.c"
					}
				}
			}
#line 675 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 675 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 675 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 675 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 675 "../src/Photo.vala"
				return;
#line 7039 "Photo.c"
			}
#line 726 "../src/Photo.vala"
			break;
#line 7043 "Photo.c"
		}
#line 673 "../src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 7047 "Photo.c"
		{
#line 730 "../src/Photo.vala"
			break;
#line 7051 "Photo.c"
		}
#line 673 "../src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 7055 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp32_;
				guint c = 0U;
				PhotoMetadata* _tmp33_;
				PhotoPreview* prev = NULL;
				PhotoMetadata* _tmp37_;
				PhotoPreview* _tmp38_;
				PhotoPreview* _tmp39_;
				GBytes* pix = NULL;
				PhotoPreview* _tmp43_;
				GBytes* _tmp44_;
				GBytes* _tmp45_;
				BackingPhotoRow* _tmp49_ = NULL;
				PhotoRow* _tmp50_;
				BackingPhotoRow* _tmp51_;
				const gchar* _tmp52_;
				BackingPhotoRow* _tmp53_;
				BackingPhotoRow* _tmp54_;
				gboolean _tmp55_ = FALSE;
				GBytes* _tmp56_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp75_;
				const gchar* _tmp76_;
				PhotoFileMetadataWriter* _tmp77_;
				PhotoFileMetadataWriter* _tmp78_;
				PhotoMetadata* _tmp79_;
#line 735 "../src/Photo.vala"
				_tmp32_ = photo_get_master_metadata (self, &_inner_error0_);
#line 735 "../src/Photo.vala"
				meta = _tmp32_;
#line 735 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7090 "Photo.c"
					goto __catch4_g_error;
				}
#line 736 "../src/Photo.vala"
				_tmp33_ = meta;
#line 736 "../src/Photo.vala"
				c = photo_metadata_get_preview_count (_tmp33_);
#line 737 "../src/Photo.vala"
				if (c <= ((guint) 0)) {
#line 738 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7101 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 783 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 7106 "Photo.c"
							{
								BackingPhotoRow* _tmp34_;
#line 786 "../src/Photo.vala"
								_tmp34_ = bps;
#line 786 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp34_, notify, &_inner_error0_);
#line 786 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7115 "Photo.c"
									goto __catch5_g_error;
								}
#line 788 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7120 "Photo.c"
							}
							goto __finally5;
							__catch5_g_error:
							{
								GError* e = NULL;
								GError* _tmp35_;
								const gchar* _tmp36_;
#line 784 "../src/Photo.vala"
								e = _inner_error0_;
#line 784 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 790 "../src/Photo.vala"
								_tmp35_ = e;
#line 790 "../src/Photo.vala"
								_tmp36_ = _tmp35_->message;
#line 790 "../src/Photo.vala"
								g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp36_);
#line 784 "../src/Photo.vala"
								_g_error_free0 (e);
#line 7140 "Photo.c"
							}
							__finally5:
#line 784 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7145 "Photo.c"
								goto __catch4_g_error;
							}
						}
					}
#line 738 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 738 "../src/Photo.vala"
					return;
#line 7154 "Photo.c"
				}
#line 739 "../src/Photo.vala"
				_tmp37_ = meta;
#line 739 "../src/Photo.vala"
				_tmp38_ = photo_metadata_get_preview (_tmp37_, c - 1);
#line 739 "../src/Photo.vala"
				prev = _tmp38_;
#line 740 "../src/Photo.vala"
				_tmp39_ = prev;
#line 740 "../src/Photo.vala"
				if (_tmp39_ == NULL) {
#line 741 "../src/Photo.vala"
					g_debug ("Photo.vala:741: Could not get preview from metadata");
#line 742 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 742 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7172 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 783 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 7177 "Photo.c"
							{
								BackingPhotoRow* _tmp40_;
#line 786 "../src/Photo.vala"
								_tmp40_ = bps;
#line 786 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp40_, notify, &_inner_error0_);
#line 786 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7186 "Photo.c"
									goto __catch6_g_error;
								}
#line 788 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7191 "Photo.c"
							}
							goto __finally6;
							__catch6_g_error:
							{
								GError* e = NULL;
								GError* _tmp41_;
								const gchar* _tmp42_;
#line 784 "../src/Photo.vala"
								e = _inner_error0_;
#line 784 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 790 "../src/Photo.vala"
								_tmp41_ = e;
#line 790 "../src/Photo.vala"
								_tmp42_ = _tmp41_->message;
#line 790 "../src/Photo.vala"
								g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp42_);
#line 784 "../src/Photo.vala"
								_g_error_free0 (e);
#line 7211 "Photo.c"
							}
							__finally6:
#line 784 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7216 "Photo.c"
								goto __catch4_g_error;
							}
						}
					}
#line 742 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 742 "../src/Photo.vala"
					return;
#line 7225 "Photo.c"
				}
#line 745 "../src/Photo.vala"
				_tmp43_ = prev;
#line 745 "../src/Photo.vala"
				_tmp44_ = photo_preview_flatten (_tmp43_, &_inner_error0_);
#line 745 "../src/Photo.vala"
				pix = _tmp44_;
#line 745 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 745 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 745 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7239 "Photo.c"
					goto __catch4_g_error;
				}
#line 746 "../src/Photo.vala"
				_tmp45_ = pix;
#line 746 "../src/Photo.vala"
				if (_tmp45_ == NULL) {
#line 747 "../src/Photo.vala"
					g_debug ("Photo.vala:747: Could not get preview pixbuf");
#line 748 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 748 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 748 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7254 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 783 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 7259 "Photo.c"
							{
								BackingPhotoRow* _tmp46_;
#line 786 "../src/Photo.vala"
								_tmp46_ = bps;
#line 786 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp46_, notify, &_inner_error0_);
#line 786 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7268 "Photo.c"
									goto __catch7_g_error;
								}
#line 788 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7273 "Photo.c"
							}
							goto __finally7;
							__catch7_g_error:
							{
								GError* e = NULL;
								GError* _tmp47_;
								const gchar* _tmp48_;
#line 784 "../src/Photo.vala"
								e = _inner_error0_;
#line 784 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 790 "../src/Photo.vala"
								_tmp47_ = e;
#line 790 "../src/Photo.vala"
								_tmp48_ = _tmp47_->message;
#line 790 "../src/Photo.vala"
								g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp48_);
#line 784 "../src/Photo.vala"
								_g_error_free0 (e);
#line 7293 "Photo.c"
							}
							__finally7:
#line 784 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7298 "Photo.c"
								goto __catch4_g_error;
							}
						}
					}
#line 748 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 748 "../src/Photo.vala"
					return;
#line 7307 "Photo.c"
				}
#line 752 "../src/Photo.vala"
				_tmp50_ = self->row;
#line 752 "../src/Photo.vala"
				_tmp51_ = _tmp50_->master;
#line 752 "../src/Photo.vala"
				_tmp52_ = _tmp51_->filepath;
#line 752 "../src/Photo.vala"
				_tmp53_ = raw_developer_create_backing_row_for_development (d, _tmp52_, NULL, &_inner_error0_);
#line 752 "../src/Photo.vala"
				_tmp49_ = _tmp53_;
#line 752 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 752 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 752 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 752 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7327 "Photo.c"
					goto __catch4_g_error;
				}
#line 752 "../src/Photo.vala"
				_tmp54_ = _tmp49_;
#line 752 "../src/Photo.vala"
				_tmp49_ = NULL;
#line 752 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 752 "../src/Photo.vala"
				bps = _tmp54_;
#line 756 "../src/Photo.vala"
				_tmp56_ = pix;
#line 756 "../src/Photo.vala"
				_tmp55_ = jpeg_is_jpeg_bytes (_tmp56_, &_inner_error0_);
#line 756 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 756 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp49_);
#line 756 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 756 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 756 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7352 "Photo.c"
					goto __catch4_g_error;
				}
#line 756 "../src/Photo.vala"
				if (_tmp55_) {
#line 7357 "Photo.c"
					GFile* outfile = NULL;
					BackingPhotoRow* _tmp57_;
					const gchar* _tmp58_;
					GFile* _tmp59_;
					GFile* _tmp60_;
					GBytes* _tmp61_;
					gsize _tmp62_ = 0;
					guint8* _tmp63_;
#line 757 "../src/Photo.vala"
					_tmp57_ = bps;
#line 757 "../src/Photo.vala"
					_tmp58_ = _tmp57_->filepath;
#line 757 "../src/Photo.vala"
					_tmp59_ = g_file_new_for_path (_tmp58_);
#line 757 "../src/Photo.vala"
					outfile = _tmp59_;
#line 758 "../src/Photo.vala"
					_tmp60_ = outfile;
#line 758 "../src/Photo.vala"
					_tmp61_ = pix;
#line 758 "../src/Photo.vala"
					_tmp63_ = g_bytes_get_data (_tmp61_, &_tmp62_);
#line 758 "../src/Photo.vala"
					g_file_replace_contents (_tmp60_, _tmp63_, (gsize) _tmp62_, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error0_);
#line 758 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 758 "../src/Photo.vala"
						_g_object_unref0 (outfile);
#line 758 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp49_);
#line 758 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 758 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 758 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7394 "Photo.c"
						goto __catch4_g_error;
					}
#line 756 "../src/Photo.vala"
					_g_object_unref0 (outfile);
#line 7399 "Photo.c"
				} else {
					GdkPixbuf* pixbuf = NULL;
					PhotoPreview* _tmp64_;
					GdkPixbuf* _tmp65_;
					GdkPixbuf* _tmp66_;
					PhotoFileWriter* writer = NULL;
					BackingPhotoRow* _tmp70_;
					const gchar* _tmp71_;
					PhotoFileWriter* _tmp72_;
					PhotoFileWriter* _tmp73_;
					GdkPixbuf* _tmp74_;
#line 761 "../src/Photo.vala"
					_tmp64_ = prev;
#line 761 "../src/Photo.vala"
					_tmp65_ = photo_preview_get_pixbuf (_tmp64_, &_inner_error0_);
#line 761 "../src/Photo.vala"
					pixbuf = _tmp65_;
#line 761 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 761 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp49_);
#line 761 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 761 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 761 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7427 "Photo.c"
						goto __catch4_g_error;
					}
#line 762 "../src/Photo.vala"
					_tmp66_ = pixbuf;
#line 762 "../src/Photo.vala"
					if (_tmp66_ == NULL) {
#line 763 "../src/Photo.vala"
						g_debug ("Photo.vala:763: Could not get preview pixbuf");
#line 764 "../src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 764 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp49_);
#line 764 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 764 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 764 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7446 "Photo.c"
						{
							GError* _inner_error0_ = NULL;
#line 783 "../src/Photo.vala"
							if (wrote_img_to_disk) {
#line 7451 "Photo.c"
								{
									BackingPhotoRow* _tmp67_;
#line 786 "../src/Photo.vala"
									_tmp67_ = bps;
#line 786 "../src/Photo.vala"
									photo_add_backing_photo_for_development (self, d, _tmp67_, notify, &_inner_error0_);
#line 786 "../src/Photo.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7460 "Photo.c"
										goto __catch8_g_error;
									}
#line 788 "../src/Photo.vala"
									photo_notify_raw_development_modified (self);
#line 7465 "Photo.c"
								}
								goto __finally8;
								__catch8_g_error:
								{
									GError* e = NULL;
									GError* _tmp68_;
									const gchar* _tmp69_;
#line 784 "../src/Photo.vala"
									e = _inner_error0_;
#line 784 "../src/Photo.vala"
									_inner_error0_ = NULL;
#line 790 "../src/Photo.vala"
									_tmp68_ = e;
#line 790 "../src/Photo.vala"
									_tmp69_ = _tmp68_->message;
#line 790 "../src/Photo.vala"
									g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp69_);
#line 784 "../src/Photo.vala"
									_g_error_free0 (e);
#line 7485 "Photo.c"
								}
								__finally8:
#line 784 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7490 "Photo.c"
									goto __catch4_g_error;
								}
							}
						}
#line 764 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 764 "../src/Photo.vala"
						return;
#line 7499 "Photo.c"
					}
#line 767 "../src/Photo.vala"
					_tmp70_ = bps;
#line 767 "../src/Photo.vala"
					_tmp71_ = _tmp70_->filepath;
#line 767 "../src/Photo.vala"
					_tmp72_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp71_, &_inner_error0_);
#line 767 "../src/Photo.vala"
					writer = _tmp72_;
#line 767 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 767 "../src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 767 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp49_);
#line 767 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 767 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 767 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7521 "Photo.c"
						goto __catch4_g_error;
					}
#line 768 "../src/Photo.vala"
					_tmp73_ = writer;
#line 768 "../src/Photo.vala"
					_tmp74_ = pixbuf;
#line 768 "../src/Photo.vala"
					photo_file_writer_write (_tmp73_, _tmp74_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 768 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 768 "../src/Photo.vala"
						_photo_file_adapter_unref0 (writer);
#line 768 "../src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 768 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp49_);
#line 768 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 768 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 768 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7544 "Photo.c"
						goto __catch4_g_error;
					}
#line 756 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 756 "../src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 7551 "Photo.c"
				}
#line 774 "../src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 777 "../src/Photo.vala"
				_tmp75_ = bps;
#line 777 "../src/Photo.vala"
				_tmp76_ = _tmp75_->filepath;
#line 777 "../src/Photo.vala"
				_tmp77_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp76_, &_inner_error0_);
#line 777 "../src/Photo.vala"
				mwriter = _tmp77_;
#line 777 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 777 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp49_);
#line 777 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 777 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 777 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7573 "Photo.c"
					goto __catch4_g_error;
				}
#line 778 "../src/Photo.vala"
				_tmp78_ = mwriter;
#line 778 "../src/Photo.vala"
				_tmp79_ = meta;
#line 778 "../src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp78_, _tmp79_, &_inner_error0_);
#line 778 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 778 "../src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 778 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp49_);
#line 778 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 778 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 778 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7594 "Photo.c"
					goto __catch4_g_error;
				}
#line 733 "../src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 733 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp49_);
#line 733 "../src/Photo.vala"
				_g_bytes_unref0 (pix);
#line 733 "../src/Photo.vala"
				_photo_preview_unref0 (prev);
#line 733 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 7607 "Photo.c"
			}
			goto __finally4;
			__catch4_g_error:
			{
				GError* e = NULL;
				GError* _tmp80_;
				const gchar* _tmp81_;
#line 733 "../src/Photo.vala"
				e = _inner_error0_;
#line 733 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 780 "../src/Photo.vala"
				_tmp80_ = e;
#line 780 "../src/Photo.vala"
				_tmp81_ = _tmp80_->message;
#line 780 "../src/Photo.vala"
				g_debug ("Photo.vala:780: Error accessing embedded preview. Message: %s", _tmp81_);
#line 781 "../src/Photo.vala"
				_g_error_free0 (e);
#line 7627 "Photo.c"
				{
					GError* _inner_error0_ = NULL;
#line 783 "../src/Photo.vala"
					if (wrote_img_to_disk) {
#line 7632 "Photo.c"
						{
							BackingPhotoRow* _tmp82_;
#line 786 "../src/Photo.vala"
							_tmp82_ = bps;
#line 786 "../src/Photo.vala"
							photo_add_backing_photo_for_development (self, d, _tmp82_, notify, &_inner_error0_);
#line 786 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7641 "Photo.c"
								goto __catch9_g_error;
							}
#line 788 "../src/Photo.vala"
							photo_notify_raw_development_modified (self);
#line 7646 "Photo.c"
						}
						goto __finally9;
						__catch9_g_error:
						{
							GError* e = NULL;
							GError* _tmp83_;
							const gchar* _tmp84_;
#line 784 "../src/Photo.vala"
							e = _inner_error0_;
#line 784 "../src/Photo.vala"
							_inner_error0_ = NULL;
#line 790 "../src/Photo.vala"
							_tmp83_ = e;
#line 790 "../src/Photo.vala"
							_tmp84_ = _tmp83_->message;
#line 790 "../src/Photo.vala"
							g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp84_);
#line 784 "../src/Photo.vala"
							_g_error_free0 (e);
#line 7666 "Photo.c"
						}
						__finally9:
#line 784 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 784 "../src/Photo.vala"
							_backing_photo_row_unref0 (bps);
#line 7673 "Photo.c"
						}
					}
				}
#line 781 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 781 "../src/Photo.vala"
				return;
#line 7681 "Photo.c"
			}
			__finally4:
			{
				GError* _inner_error1_ = NULL;
#line 783 "../src/Photo.vala"
				if (wrote_img_to_disk) {
#line 7688 "Photo.c"
					{
						BackingPhotoRow* _tmp85_;
#line 786 "../src/Photo.vala"
						_tmp85_ = bps;
#line 786 "../src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp85_, notify, &_inner_error1_);
#line 786 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 7697 "Photo.c"
							goto __catch10_g_error;
						}
#line 788 "../src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 7702 "Photo.c"
					}
					goto __finally10;
					__catch10_g_error:
					{
						GError* e = NULL;
						GError* _tmp86_;
						const gchar* _tmp87_;
#line 784 "../src/Photo.vala"
						e = _inner_error1_;
#line 784 "../src/Photo.vala"
						_inner_error1_ = NULL;
#line 790 "../src/Photo.vala"
						_tmp86_ = e;
#line 790 "../src/Photo.vala"
						_tmp87_ = _tmp86_->message;
#line 790 "../src/Photo.vala"
						g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp87_);
#line 784 "../src/Photo.vala"
						_g_error_free0 (e);
#line 7722 "Photo.c"
					}
					__finally10:
#line 784 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 784 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 784 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 784 "../src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 784 "../src/Photo.vala"
						return;
#line 7735 "Photo.c"
					}
				}
			}
#line 733 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 733 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 733 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 733 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 733 "../src/Photo.vala"
				return;
#line 7749 "Photo.c"
			}
#line 795 "../src/Photo.vala"
			break;
#line 7753 "Photo.c"
		}
		default:
		{
#line 798 "../src/Photo.vala"
			g_assert_not_reached ();
#line 7759 "Photo.c"
		}
	}
#line 669 "../src/Photo.vala"
	_backing_photo_row_unref0 (bps);
#line 7764 "Photo.c"
}

void
photo_set_default_raw_developer (Photo* self,
                                 RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 803 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 7774 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 804 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 804 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 7781 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 805 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 805 "../src/Photo.vala"
			_tmp1_->developer = d;
#line 7788 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp2_;
#line 804 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 804 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 7797 "Photo.c"
		}
#line 804 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 804 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 804 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 804 "../src/Photo.vala"
			return;
#line 7807 "Photo.c"
		}
	}
}

void
photo_set_raw_developer (Photo* self,
                         RawDeveloper d,
                         gboolean notify)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 810 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 811 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 812 "../src/Photo.vala"
		return;
#line 7826 "Photo.c"
	}
#line 817 "../src/Photo.vala"
	if (photo_is_raw_developer_available (self, RAW_DEVELOPER_CAMERA)) {
#line 817 "../src/Photo.vala"
		_tmp0_ = d == RAW_DEVELOPER_EMBEDDED;
#line 7832 "Photo.c"
	} else {
#line 817 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 7836 "Photo.c"
	}
#line 817 "../src/Photo.vala"
	if (_tmp0_) {
#line 818 "../src/Photo.vala"
		d = RAW_DEVELOPER_CAMERA;
#line 7842 "Photo.c"
	}
#line 822 "../src/Photo.vala"
	if (!photo_is_raw_developer_available (self, RAW_DEVELOPER_EMBEDDED)) {
#line 822 "../src/Photo.vala"
		_tmp1_ = d != RAW_DEVELOPER_CAMERA;
#line 7848 "Photo.c"
	} else {
#line 822 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 7852 "Photo.c"
	}
#line 822 "../src/Photo.vala"
	if (_tmp1_) {
#line 823 "../src/Photo.vala"
		d = RAW_DEVELOPER_SHOTWELL;
#line 7858 "Photo.c"
	}
	{
		GeeHashMap* _tmp2_;
#line 825 "../src/Photo.vala"
		_tmp2_ = self->priv->developments;
#line 825 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 7866 "Photo.c"
		{
			RawDeveloper stale_raw_developer = 0;
			PhotoRow* _tmp3_;
			GeeHashMap* _tmp4_;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
			gpointer _tmp8_;
			PhotoBackingReaders* _tmp9_;
			BackingPhotoRow* _tmp10_;
			BackingPhotoRow* _tmp11_;
			const gchar* _tmp12_;
			PhotoFileReader* _tmp13_;
			BackingPhotoRow* _tmp17_;
			gboolean _tmp25_ = FALSE;
#line 826 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 826 "../src/Photo.vala"
			stale_raw_developer = _tmp3_->developer;
#line 829 "../src/Photo.vala"
			if (!photo_is_raw_developer_complete (self, d)) {
#line 830 "../src/Photo.vala"
				photo_develop_photo (self, d, notify);
#line 7889 "Photo.c"
			}
#line 832 "../src/Photo.vala"
			_tmp4_ = self->priv->developments;
#line 832 "../src/Photo.vala"
			if (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 7895 "Photo.c"
				{
					GeeHashMap* _tmp5_;
#line 825 "../src/Photo.vala"
					_tmp5_ = self->priv->developments;
#line 825 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7902 "Photo.c"
				}
#line 833 "../src/Photo.vala"
				return;
#line 7906 "Photo.c"
			}
#line 836 "../src/Photo.vala"
			photo_revert_to_master (self, FALSE);
#line 839 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 839 "../src/Photo.vala"
			_tmp6_->developer = d;
#line 840 "../src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 840 "../src/Photo.vala"
			_tmp8_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 840 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 840 "../src/Photo.vala"
			self->backing_photo_row = (BackingPhotoRow*) _tmp8_;
#line 841 "../src/Photo.vala"
			_tmp9_ = self->priv->readers;
#line 841 "../src/Photo.vala"
			_tmp10_ = self->backing_photo_row;
#line 841 "../src/Photo.vala"
			_tmp11_ = self->backing_photo_row;
#line 841 "../src/Photo.vala"
			_tmp12_ = _tmp11_->filepath;
#line 841 "../src/Photo.vala"
			_tmp13_ = photo_file_format_create_reader (_tmp10_->file_format, _tmp12_);
#line 841 "../src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp9_->developer);
#line 841 "../src/Photo.vala"
			_tmp9_->developer = _tmp13_;
#line 7936 "Photo.c"
			{
				GdkPixbuf* _tmp14_;
				GdkPixbuf* _tmp15_;
#line 844 "../src/Photo.vala"
				_tmp14_ = photo_get_prefetched_copy (self, &_inner_error0_);
#line 844 "../src/Photo.vala"
				_tmp15_ = _tmp14_;
#line 844 "../src/Photo.vala"
				_g_object_unref0 (_tmp15_);
#line 844 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7948 "Photo.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
#line 843 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 7957 "Photo.c"
				{
					GeeHashMap* _tmp16_;
#line 825 "../src/Photo.vala"
					_tmp16_ = self->priv->developments;
#line 825 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7964 "Photo.c"
				}
#line 847 "../src/Photo.vala"
				return;
#line 7968 "Photo.c"
			}
			__finally1:
#line 843 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 843 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 843 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 843 "../src/Photo.vala"
				return;
#line 7979 "Photo.c"
			}
#line 850 "../src/Photo.vala"
			_tmp17_ = self->backing_photo_row;
#line 850 "../src/Photo.vala"
			photo_set_orientation (self, _tmp17_->original_orientation);
#line 7985 "Photo.c"
			{
				PhotoTable* _tmp18_;
				PhotoTable* _tmp19_;
				PhotoRow* _tmp20_;
				BackingPhotoRow* _tmp21_;
				BackingPhotoID _tmp22_;
#line 853 "../src/Photo.vala"
				_tmp18_ = photo_table_get_instance ();
#line 853 "../src/Photo.vala"
				_tmp19_ = _tmp18_;
#line 853 "../src/Photo.vala"
				_tmp20_ = self->row;
#line 853 "../src/Photo.vala"
				_tmp21_ = self->backing_photo_row;
#line 853 "../src/Photo.vala"
				_tmp22_ = _tmp21_->id;
#line 853 "../src/Photo.vala"
				photo_table_update_raw_development (_tmp19_, _tmp20_, d, &_tmp22_, &_inner_error0_);
#line 853 "../src/Photo.vala"
				_database_table_unref0 (_tmp19_);
#line 853 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8008 "Photo.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* e = NULL;
				GError* _tmp23_;
				const gchar* _tmp24_;
#line 852 "../src/Photo.vala"
				e = _inner_error0_;
#line 852 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 855 "../src/Photo.vala"
				_tmp23_ = e;
#line 855 "../src/Photo.vala"
				_tmp24_ = _tmp23_->message;
#line 855 "../src/Photo.vala"
				g_warning ("Photo.vala:855: Error updating database: %s", _tmp24_);
#line 852 "../src/Photo.vala"
				_g_error_free0 (e);
#line 8030 "Photo.c"
			}
			__finally2:
#line 852 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 852 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 852 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 852 "../src/Photo.vala"
				return;
#line 8041 "Photo.c"
			}
#line 862 "../src/Photo.vala"
			if (stale_raw_developer != RAW_DEVELOPER_CAMERA) {
#line 8045 "Photo.c"
				PhotoRow* _tmp26_;
#line 863 "../src/Photo.vala"
				_tmp26_ = self->row;
#line 863 "../src/Photo.vala"
				_tmp25_ = stale_raw_developer != _tmp26_->developer;
#line 8051 "Photo.c"
			} else {
#line 862 "../src/Photo.vala"
				_tmp25_ = FALSE;
#line 8055 "Photo.c"
			}
#line 862 "../src/Photo.vala"
			if (_tmp25_) {
#line 866 "../src/Photo.vala"
				photo_delete_raw_development (self, stale_raw_developer);
#line 8061 "Photo.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp27_;
#line 825 "../src/Photo.vala"
			_tmp27_ = self->priv->developments;
#line 825 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8071 "Photo.c"
		}
#line 825 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 825 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 825 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 825 "../src/Photo.vala"
			return;
#line 8081 "Photo.c"
		}
	}
#line 873 "../src/Photo.vala"
	if (notify) {
#line 8086 "Photo.c"
		Alteration* _tmp28_;
		Alteration* _tmp29_;
#line 874 "../src/Photo.vala"
		_tmp28_ = alteration_new ("image", "developer");
#line 874 "../src/Photo.vala"
		_tmp29_ = _tmp28_;
#line 874 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp29_);
#line 874 "../src/Photo.vala"
		_alteration_unref0 (_tmp29_);
#line 8097 "Photo.c"
	}
#line 875 "../src/Photo.vala"
	photo_discard_prefetched (self);
#line 8101 "Photo.c"
}

RawDeveloper
photo_get_raw_developer (Photo* self)
{
	PhotoRow* _tmp0_;
	RawDeveloper result = 0;
#line 878 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 879 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 879 "../src/Photo.vala"
	result = _tmp0_->developer;
#line 879 "../src/Photo.vala"
	return result;
#line 8117 "Photo.c"
}

static gboolean
photo_delete_raw_development (Photo* self,
                              RawDeveloper d)
{
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 884 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 885 "../src/Photo.vala"
	ret = FALSE;
#line 8131 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 887 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 887 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 8138 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			BackingPhotoRow* bpr = NULL;
			GeeHashMap* _tmp7_;
			gpointer _tmp8_;
			BackingPhotoRow* _tmp9_;
			const gchar* _tmp10_;
			GeeHashMap* _tmp31_;
#line 888 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 888 "../src/Photo.vala"
			if (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 889 "../src/Photo.vala"
				result = FALSE;
#line 8157 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 887 "../src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 887 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8164 "Photo.c"
				}
#line 889 "../src/Photo.vala"
				return result;
#line 8168 "Photo.c"
			}
#line 893 "../src/Photo.vala"
			_tmp3_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 893 "../src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 893 "../src/Photo.vala"
			_tmp5_ = raw_developer_to_string (d);
#line 893 "../src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 893 "../src/Photo.vala"
			g_debug ("Photo.vala:893: Delete raw development: %s %s", _tmp4_, _tmp6_);
#line 893 "../src/Photo.vala"
			_g_free0 (_tmp6_);
#line 893 "../src/Photo.vala"
			_g_free0 (_tmp4_);
#line 894 "../src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 894 "../src/Photo.vala"
			_tmp8_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 894 "../src/Photo.vala"
			bpr = (BackingPhotoRow*) _tmp8_;
#line 895 "../src/Photo.vala"
			_tmp9_ = bpr;
#line 895 "../src/Photo.vala"
			_tmp10_ = _tmp9_->filepath;
#line 895 "../src/Photo.vala"
			if (_tmp10_ != NULL) {
#line 8196 "Photo.c"
				GFile* f = NULL;
				BackingPhotoRow* _tmp11_;
				const gchar* _tmp12_;
				GFile* _tmp13_;
#line 896 "../src/Photo.vala"
				_tmp11_ = bpr;
#line 896 "../src/Photo.vala"
				_tmp12_ = _tmp11_->filepath;
#line 896 "../src/Photo.vala"
				_tmp13_ = g_file_new_for_path (_tmp12_);
#line 896 "../src/Photo.vala"
				f = _tmp13_;
#line 8209 "Photo.c"
				{
#line 898 "../src/Photo.vala"
					if (d == RAW_DEVELOPER_CAMERA) {
#line 8213 "Photo.c"
						GFile* _tmp14_;
#line 899 "../src/Photo.vala"
						_tmp14_ = f;
#line 899 "../src/Photo.vala"
						g_file_trash (_tmp14_, NULL, &_inner_error0_);
#line 899 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8221 "Photo.c"
							goto __catch1_g_error;
						}
					} else {
						GFile* _tmp15_;
#line 901 "../src/Photo.vala"
						_tmp15_ = f;
#line 901 "../src/Photo.vala"
						g_file_delete (_tmp15_, NULL, &_inner_error0_);
#line 901 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8232 "Photo.c"
							goto __catch1_g_error;
						}
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp16_;
					const gchar* _tmp17_;
					GError* _tmp18_;
					const gchar* _tmp19_;
#line 897 "../src/Photo.vala"
					e = _inner_error0_;
#line 897 "../src/Photo.vala"
					_inner_error0_ = NULL;
#line 903 "../src/Photo.vala"
					_tmp16_ = bpr;
#line 903 "../src/Photo.vala"
					_tmp17_ = _tmp16_->filepath;
#line 903 "../src/Photo.vala"
					_tmp18_ = e;
#line 903 "../src/Photo.vala"
					_tmp19_ = _tmp18_->message;
#line 903 "../src/Photo.vala"
					g_warning ("Photo.vala:903: Unable to delete RAW development: %s error: %s", _tmp17_, _tmp19_);
#line 897 "../src/Photo.vala"
					_g_error_free0 (e);
#line 8261 "Photo.c"
				}
				__finally1:
#line 897 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8266 "Photo.c"
					gboolean _tmp20_ = FALSE;
#line 897 "../src/Photo.vala"
					_g_object_unref0 (f);
#line 897 "../src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 897 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 897 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 897 "../src/Photo.vala"
					return _tmp20_;
#line 8278 "Photo.c"
				}
#line 895 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 8282 "Photo.c"
			}
			{
				PhotoTable* _tmp21_;
				PhotoTable* _tmp22_;
				PhotoRow* _tmp23_;
				BackingPhotoTable* _tmp24_;
				BackingPhotoTable* _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoID _tmp27_;
#line 909 "../src/Photo.vala"
				_tmp21_ = photo_table_get_instance ();
#line 909 "../src/Photo.vala"
				_tmp22_ = _tmp21_;
#line 909 "../src/Photo.vala"
				_tmp23_ = self->row;
#line 909 "../src/Photo.vala"
				photo_table_remove_development (_tmp22_, _tmp23_, d, &_inner_error0_);
#line 909 "../src/Photo.vala"
				_database_table_unref0 (_tmp22_);
#line 909 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8304 "Photo.c"
					goto __catch2_g_error;
				}
#line 910 "../src/Photo.vala"
				_tmp24_ = backing_photo_table_get_instance ();
#line 910 "../src/Photo.vala"
				_tmp25_ = _tmp24_;
#line 910 "../src/Photo.vala"
				_tmp26_ = bpr;
#line 910 "../src/Photo.vala"
				_tmp27_ = _tmp26_->id;
#line 910 "../src/Photo.vala"
				backing_photo_table_remove (_tmp25_, &_tmp27_, &_inner_error0_);
#line 910 "../src/Photo.vala"
				_database_table_unref0 (_tmp25_);
#line 910 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8321 "Photo.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* e = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 908 "../src/Photo.vala"
				e = _inner_error0_;
#line 908 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 912 "../src/Photo.vala"
				_tmp28_ = e;
#line 912 "../src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 912 "../src/Photo.vala"
				g_warning ("Photo.vala:912: Database error while deleting RAW development: %s", _tmp29_);
#line 908 "../src/Photo.vala"
				_g_error_free0 (e);
#line 8343 "Photo.c"
			}
			__finally2:
#line 908 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8348 "Photo.c"
				gboolean _tmp30_ = FALSE;
#line 908 "../src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 908 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 908 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 908 "../src/Photo.vala"
				return _tmp30_;
#line 8358 "Photo.c"
			}
#line 915 "../src/Photo.vala"
			_tmp31_ = self->priv->developments;
#line 915 "../src/Photo.vala"
			ret = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), NULL);
#line 887 "../src/Photo.vala"
			_backing_photo_row_unref0 (bpr);
#line 8366 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp32_;
#line 887 "../src/Photo.vala"
			_tmp32_ = self->priv->developments;
#line 887 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8375 "Photo.c"
		}
#line 887 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8379 "Photo.c"
			gboolean _tmp33_ = FALSE;
#line 887 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 887 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 887 "../src/Photo.vala"
			return _tmp33_;
#line 8387 "Photo.c"
		}
	}
#line 918 "../src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 919 "../src/Photo.vala"
	result = ret;
#line 919 "../src/Photo.vala"
	return result;
#line 8396 "Photo.c"
}

void
photo_redevelop_raw (Photo* self,
                     RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 923 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 8406 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 924 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 924 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 8413 "Photo.c"
		{
			RawDeveloper dev = 0;
#line 925 "../src/Photo.vala"
			photo_delete_raw_development (self, d);
#line 926 "../src/Photo.vala"
			dev = d;
#line 927 "../src/Photo.vala"
			if (dev == RAW_DEVELOPER_CAMERA) {
#line 928 "../src/Photo.vala"
				dev = RAW_DEVELOPER_EMBEDDED;
#line 8424 "Photo.c"
			}
#line 930 "../src/Photo.vala"
			photo_set_raw_developer (self, dev, TRUE);
#line 8428 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp1_;
#line 924 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 924 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8437 "Photo.c"
		}
#line 924 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 924 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 924 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 924 "../src/Photo.vala"
			return;
#line 8447 "Photo.c"
		}
	}
}

static void
_vala_array_add84 (BackingFileState** * array,
                   gint* length,
                   gint* size,
                   BackingFileState* value)
{
#line 937 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 937 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 937 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8464 "Photo.c"
	}
#line 937 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 937 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8470 "Photo.c"
}

static void
_vala_array_add85 (BackingFileState** * array,
                   gint* length,
                   gint* size,
                   BackingFileState* value)
{
#line 939 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 939 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 939 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8485 "Photo.c"
	}
#line 939 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 939 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8491 "Photo.c"
}

static void
_vala_array_add86 (BackingFileState** * array,
                   gint* length,
                   gint* size,
                   BackingFileState* value)
{
#line 946 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 946 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 946 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8506 "Photo.c"
	}
#line 946 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 946 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8512 "Photo.c"
}

static BackingFileState**
photo_real_get_backing_files_state (MediaSource* base,
                                    gint* result_length1)
{
	Photo * self;
	BackingFileState** backing = NULL;
	BackingFileState** _tmp0_;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp21_;
	gint _tmp21__length1;
	GError* _inner_error0_ = NULL;
	BackingFileState** result = NULL;
#line 934 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 935 "../src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 935 "../src/Photo.vala"
	backing = _tmp0_;
#line 935 "../src/Photo.vala"
	backing_length1 = 0;
#line 935 "../src/Photo.vala"
	_backing_size_ = backing_length1;
#line 8538 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 936 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 936 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8545 "Photo.c"
		{
			PhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
			PhotoRow* _tmp4_;
			const gchar* _tmp5_;
			BackingFileState* _tmp6_;
#line 937 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 937 "../src/Photo.vala"
			_tmp3_ = _tmp2_->master;
#line 937 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 937 "../src/Photo.vala"
			_tmp5_ = _tmp4_->md5;
#line 937 "../src/Photo.vala"
			_tmp6_ = backing_file_state_new_from_photo_row (_tmp3_, _tmp5_);
#line 937 "../src/Photo.vala"
			_vala_array_add84 (&backing, &backing_length1, &_backing_size_, _tmp6_);
#line 938 "../src/Photo.vala"
			if (photo_has_editable (self)) {
#line 8566 "Photo.c"
				BackingPhotoRow* _tmp7_;
				BackingFileState* _tmp8_;
#line 939 "../src/Photo.vala"
				_tmp7_ = self->priv->editable;
#line 939 "../src/Photo.vala"
				_tmp8_ = backing_file_state_new_from_photo_row (_tmp7_, NULL);
#line 939 "../src/Photo.vala"
				_vala_array_add85 (&backing, &backing_length1, &_backing_size_, _tmp8_);
#line 8575 "Photo.c"
			}
#line 941 "../src/Photo.vala"
			if (photo_is_developed (self)) {
#line 8579 "Photo.c"
				GeeCollection* dev_rows = NULL;
				GeeCollection* _tmp9_;
				GeeCollection* _tmp10_;
#line 942 "../src/Photo.vala"
				_tmp9_ = photo_get_raw_development_photo_rows (self);
#line 942 "../src/Photo.vala"
				dev_rows = _tmp9_;
#line 943 "../src/Photo.vala"
				_tmp10_ = dev_rows;
#line 943 "../src/Photo.vala"
				if (_tmp10_ != NULL) {
#line 8591 "Photo.c"
					{
						GeeIterator* _r_it = NULL;
						GeeCollection* _tmp11_;
						GeeIterator* _tmp12_;
#line 944 "../src/Photo.vala"
						_tmp11_ = dev_rows;
#line 944 "../src/Photo.vala"
						_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 944 "../src/Photo.vala"
						_r_it = _tmp12_;
#line 944 "../src/Photo.vala"
						while (TRUE) {
#line 8604 "Photo.c"
							GeeIterator* _tmp13_;
							BackingPhotoRow* r = NULL;
							GeeIterator* _tmp14_;
							gpointer _tmp15_;
							BackingPhotoRow* _tmp16_;
							const gchar* _tmp17_;
							BackingPhotoRow* _tmp18_;
							BackingFileState* _tmp19_;
#line 944 "../src/Photo.vala"
							_tmp13_ = _r_it;
#line 944 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp13_)) {
#line 944 "../src/Photo.vala"
								break;
#line 8619 "Photo.c"
							}
#line 944 "../src/Photo.vala"
							_tmp14_ = _r_it;
#line 944 "../src/Photo.vala"
							_tmp15_ = gee_iterator_get (_tmp14_);
#line 944 "../src/Photo.vala"
							r = (BackingPhotoRow*) _tmp15_;
#line 945 "../src/Photo.vala"
							_tmp16_ = r;
#line 945 "../src/Photo.vala"
							_tmp17_ = _tmp16_->filepath;
#line 945 "../src/Photo.vala"
							g_debug ("Photo.vala:945: adding: %s", _tmp17_);
#line 946 "../src/Photo.vala"
							_tmp18_ = r;
#line 946 "../src/Photo.vala"
							_tmp19_ = backing_file_state_new_from_photo_row (_tmp18_, NULL);
#line 946 "../src/Photo.vala"
							_vala_array_add86 (&backing, &backing_length1, &_backing_size_, _tmp19_);
#line 944 "../src/Photo.vala"
							_backing_photo_row_unref0 (r);
#line 8641 "Photo.c"
						}
#line 944 "../src/Photo.vala"
						_g_object_unref0 (_r_it);
#line 8645 "Photo.c"
					}
				}
#line 941 "../src/Photo.vala"
				_g_object_unref0 (dev_rows);
#line 8650 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp20_;
#line 936 "../src/Photo.vala"
			_tmp20_ = self->row;
#line 936 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8660 "Photo.c"
		}
#line 936 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 936 "../src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 936 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 936 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 936 "../src/Photo.vala"
			return NULL;
#line 8672 "Photo.c"
		}
	}
#line 952 "../src/Photo.vala"
	_tmp21_ = backing;
#line 952 "../src/Photo.vala"
	_tmp21__length1 = backing_length1;
#line 952 "../src/Photo.vala"
	if (result_length1) {
#line 952 "../src/Photo.vala"
		*result_length1 = _tmp21__length1;
#line 8683 "Photo.c"
	}
#line 952 "../src/Photo.vala"
	result = _tmp21_;
#line 952 "../src/Photo.vala"
	return result;
#line 8689 "Photo.c"
}

static PhotoFileReader*
photo_get_backing_reader (Photo* self,
                          BackingFetchMode mode)
{
	PhotoFileReader* result = NULL;
#line 955 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 956 "../src/Photo.vala"
	switch (mode) {
#line 956 "../src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 8703 "Photo.c"
		{
			PhotoFileReader* _tmp0_;
#line 958 "../src/Photo.vala"
			_tmp0_ = photo_get_master_reader (self);
#line 958 "../src/Photo.vala"
			result = _tmp0_;
#line 958 "../src/Photo.vala"
			return result;
#line 8712 "Photo.c"
		}
#line 956 "../src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 8716 "Photo.c"
		{
			PhotoFileReader* _tmp1_;
#line 961 "../src/Photo.vala"
			_tmp1_ = photo_get_baseline_reader (self);
#line 961 "../src/Photo.vala"
			result = _tmp1_;
#line 961 "../src/Photo.vala"
			return result;
#line 8725 "Photo.c"
		}
#line 956 "../src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 8729 "Photo.c"
		{
			PhotoFileReader* _tmp2_;
#line 964 "../src/Photo.vala"
			_tmp2_ = photo_get_source_reader (self);
#line 964 "../src/Photo.vala"
			result = _tmp2_;
#line 964 "../src/Photo.vala"
			return result;
#line 8738 "Photo.c"
		}
#line 956 "../src/Photo.vala"
		case BACKING_FETCH_MODE_UNMODIFIED:
#line 8742 "Photo.c"
		{
#line 967 "../src/Photo.vala"
			if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 8746 "Photo.c"
				PhotoFileReader* _tmp3_;
#line 968 "../src/Photo.vala"
				_tmp3_ = photo_get_raw_developer_reader (self);
#line 968 "../src/Photo.vala"
				result = _tmp3_;
#line 968 "../src/Photo.vala"
				return result;
#line 8754 "Photo.c"
			} else {
				PhotoFileReader* _tmp4_;
#line 970 "../src/Photo.vala"
				_tmp4_ = photo_get_master_reader (self);
#line 970 "../src/Photo.vala"
				result = _tmp4_;
#line 970 "../src/Photo.vala"
				return result;
#line 8763 "Photo.c"
			}
		}
		default:
		{
			GEnumValue* _tmp5_;
#line 973 "../src/Photo.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), mode);
#line 973 "../src/Photo.vala"
			g_error ("Photo.vala:973: Unknown backing fetch mode %s", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 8773 "Photo.c"
		}
	}
}

static gpointer
_photo_file_adapter_ref0 (gpointer self)
{
#line 979 "../src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 8783 "Photo.c"
}

static PhotoFileReader*
photo_get_master_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result = NULL;
#line 977 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8793 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 978 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 978 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8800 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 979 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 979 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 979 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 979 "../src/Photo.vala"
			result = _tmp3_;
#line 8813 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 978 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 978 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8820 "Photo.c"
			}
#line 979 "../src/Photo.vala"
			return result;
#line 8824 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp5_;
#line 978 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 978 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8833 "Photo.c"
		}
#line 978 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 978 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 978 "../src/Photo.vala"
		return NULL;
#line 8841 "Photo.c"
	}
}

PhotoFileReader*
photo_get_editable_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result = NULL;
#line 983 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8852 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 984 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 984 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8859 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 985 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 985 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 985 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 985 "../src/Photo.vala"
			result = _tmp3_;
#line 8872 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 984 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 984 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8879 "Photo.c"
			}
#line 985 "../src/Photo.vala"
			return result;
#line 8883 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp5_;
#line 984 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 984 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8892 "Photo.c"
		}
#line 984 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 984 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 984 "../src/Photo.vala"
		return NULL;
#line 8900 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_baseline_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result = NULL;
#line 990 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8911 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 991 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 991 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8918 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 992 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 992 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 992 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8933 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 993 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 993 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 993 "../src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 993 "../src/Photo.vala"
				result = _tmp5_;
#line 8945 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 991 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 991 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8952 "Photo.c"
				}
#line 993 "../src/Photo.vala"
				return result;
#line 8956 "Photo.c"
			}
#line 995 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 995 "../src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 995 "../src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 8964 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 996 "../src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 996 "../src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 996 "../src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 996 "../src/Photo.vala"
				result = _tmp11_;
#line 8976 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 991 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 991 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8983 "Photo.c"
				}
#line 996 "../src/Photo.vala"
				return result;
#line 8987 "Photo.c"
			}
#line 998 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 998 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 998 "../src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 998 "../src/Photo.vala"
			result = _tmp15_;
#line 8997 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 991 "../src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 991 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9004 "Photo.c"
			}
#line 998 "../src/Photo.vala"
			return result;
#line 9008 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp17_;
#line 991 "../src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 991 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9017 "Photo.c"
		}
#line 991 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 991 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 991 "../src/Photo.vala"
		return NULL;
#line 9025 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_source_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result = NULL;
#line 1003 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9036 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 1004 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1004 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9043 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 1005 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1005 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1005 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9058 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 1006 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1006 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 1006 "../src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 1006 "../src/Photo.vala"
				result = _tmp5_;
#line 9070 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 1004 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 1004 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9077 "Photo.c"
				}
#line 1006 "../src/Photo.vala"
				return result;
#line 9081 "Photo.c"
			}
#line 1008 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 1008 "../src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 1008 "../src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 9089 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 1009 "../src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 1009 "../src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 1009 "../src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 1009 "../src/Photo.vala"
				result = _tmp11_;
#line 9101 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 1004 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 1004 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9108 "Photo.c"
				}
#line 1009 "../src/Photo.vala"
				return result;
#line 9112 "Photo.c"
			}
#line 1011 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 1011 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 1011 "../src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 1011 "../src/Photo.vala"
			result = _tmp15_;
#line 9122 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 1004 "../src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 1004 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9129 "Photo.c"
			}
#line 1011 "../src/Photo.vala"
			return result;
#line 9133 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp17_;
#line 1004 "../src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 1004 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9142 "Photo.c"
		}
#line 1004 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1004 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1004 "../src/Photo.vala"
		return NULL;
#line 9150 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_raw_developer_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result = NULL;
#line 1016 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9161 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 1017 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1017 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9168 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 1018 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1018 "../src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 1018 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 1018 "../src/Photo.vala"
			result = _tmp3_;
#line 9181 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 1017 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 1017 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9188 "Photo.c"
			}
#line 1018 "../src/Photo.vala"
			return result;
#line 9192 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp5_;
#line 1017 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 1017 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9201 "Photo.c"
		}
#line 1017 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1017 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1017 "../src/Photo.vala"
		return NULL;
#line 9209 "Photo.c"
	}
}

gboolean
photo_is_developed (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 1022 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9220 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1023 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1023 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9228 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1024 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1024 "../src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 1024 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9238 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1023 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1023 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9245 "Photo.c"
			}
#line 1024 "../src/Photo.vala"
			return result;
#line 9249 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 1023 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1023 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9258 "Photo.c"
		}
#line 1023 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1023 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1023 "../src/Photo.vala"
		return _tmp5_;
#line 9266 "Photo.c"
	}
}

gboolean
photo_has_editable (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 1028 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9277 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1029 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1029 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9285 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1030 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1030 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1030 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9295 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1029 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1029 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9302 "Photo.c"
			}
#line 1030 "../src/Photo.vala"
			return result;
#line 9306 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 1029 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1029 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9315 "Photo.c"
		}
#line 1029 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1029 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1029 "../src/Photo.vala"
		return _tmp5_;
#line 9323 "Photo.c"
	}
}

gboolean
photo_does_master_exist (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 1034 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9334 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1035 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1035 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9342 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1036 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1036 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1036 "../src/Photo.vala"
			result = photo_file_adapter_file_exists (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 9352 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1035 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1035 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9359 "Photo.c"
			}
#line 1036 "../src/Photo.vala"
			return result;
#line 9363 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 1035 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1035 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9372 "Photo.c"
		}
#line 1035 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1035 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1035 "../src/Photo.vala"
		return _tmp5_;
#line 9380 "Photo.c"
	}
}

gboolean
photo_does_editable_exist (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 1041 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9391 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 1042 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1042 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9399 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 1043 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 1043 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 1043 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 9410 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 1043 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 1043 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 1043 "../src/Photo.vala"
				_tmp1_ = photo_file_adapter_file_exists (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 9419 "Photo.c"
			} else {
#line 1043 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 9423 "Photo.c"
			}
#line 1043 "../src/Photo.vala"
			result = _tmp1_;
#line 9427 "Photo.c"
			{
				PhotoBackingReaders* _tmp6_;
#line 1042 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 1042 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9434 "Photo.c"
			}
#line 1043 "../src/Photo.vala"
			return result;
#line 9438 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp7_;
#line 1042 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 1042 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9447 "Photo.c"
		}
#line 1042 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1042 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1042 "../src/Photo.vala"
		return _tmp8_;
#line 9455 "Photo.c"
	}
}

gboolean
photo_is_master_baseline (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 1047 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9466 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1048 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1048 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9474 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1049 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1049 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1049 "../src/Photo.vala"
			result = _tmp2_ == NULL;
#line 9484 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1048 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1048 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9491 "Photo.c"
			}
#line 1049 "../src/Photo.vala"
			return result;
#line 9495 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 1048 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1048 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9504 "Photo.c"
		}
#line 1048 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1048 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1048 "../src/Photo.vala"
		return _tmp5_;
#line 9512 "Photo.c"
	}
}

gboolean
photo_is_master_source (Photo* self)
{
	gboolean result = FALSE;
#line 1053 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1054 "../src/Photo.vala"
	result = !photo_has_editable (self);
#line 1054 "../src/Photo.vala"
	return result;
#line 9526 "Photo.c"
}

gboolean
photo_is_editable_baseline (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 1057 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9536 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1058 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1058 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9544 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1059 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1059 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1059 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9554 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1058 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1058 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9561 "Photo.c"
			}
#line 1059 "../src/Photo.vala"
			return result;
#line 9565 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 1058 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1058 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9574 "Photo.c"
		}
#line 1058 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1058 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1058 "../src/Photo.vala"
		return _tmp5_;
#line 9582 "Photo.c"
	}
}

gboolean
photo_is_editable_source (Photo* self)
{
	gboolean result = FALSE;
#line 1063 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1064 "../src/Photo.vala"
	result = photo_has_editable (self);
#line 1064 "../src/Photo.vala"
	return result;
#line 9596 "Photo.c"
}

BackingPhotoRow*
photo_get_master_photo_row (Photo* self)
{
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result = NULL;
#line 1067 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9606 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1068 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1068 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9613 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 1069 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1069 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1069 "../src/Photo.vala"
			_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 1069 "../src/Photo.vala"
			result = _tmp3_;
#line 9626 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1068 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 1068 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9633 "Photo.c"
			}
#line 1069 "../src/Photo.vala"
			return result;
#line 9637 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 1068 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 1068 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9646 "Photo.c"
		}
#line 1068 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1068 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1068 "../src/Photo.vala"
		return NULL;
#line 9654 "Photo.c"
	}
}

BackingPhotoRow*
photo_get_editable_photo_row (Photo* self)
{
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result = NULL;
#line 1073 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9665 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1074 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1074 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9672 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 1076 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1076 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp1_->editable_id)) {
#line 9679 "Photo.c"
				BackingPhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
#line 1077 "../src/Photo.vala"
				_tmp2_ = self->priv->editable;
#line 1077 "../src/Photo.vala"
				_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 1077 "../src/Photo.vala"
				result = _tmp3_;
#line 9688 "Photo.c"
				{
					PhotoRow* _tmp4_;
#line 1074 "../src/Photo.vala"
					_tmp4_ = self->row;
#line 1074 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9695 "Photo.c"
				}
#line 1077 "../src/Photo.vala"
				return result;
#line 9699 "Photo.c"
			} else {
#line 1079 "../src/Photo.vala"
				result = NULL;
#line 9703 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 1074 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 1074 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9710 "Photo.c"
				}
#line 1079 "../src/Photo.vala"
				return result;
#line 9714 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 1074 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 1074 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9724 "Photo.c"
		}
#line 1074 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1074 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1074 "../src/Photo.vala"
		return NULL;
#line 9732 "Photo.c"
	}
}

GeeCollection*
photo_get_raw_development_photo_rows (Photo* self)
{
	GError* _inner_error0_ = NULL;
	GeeCollection* result = NULL;
#line 1083 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9743 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1084 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1084 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9750 "Photo.c"
		{
			GeeCollection* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1085 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1085 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9758 "Photo.c"
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
#line 1085 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1085 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1085 "../src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1085 "../src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 1085 "../src/Photo.vala"
				_tmp1_ = _tmp5_;
#line 9772 "Photo.c"
			} else {
#line 1085 "../src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 1085 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 9778 "Photo.c"
			}
#line 1085 "../src/Photo.vala"
			result = _tmp1_;
#line 9782 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 1084 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 1084 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9789 "Photo.c"
			}
#line 1085 "../src/Photo.vala"
			return result;
#line 9793 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 1084 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 1084 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9802 "Photo.c"
		}
#line 1084 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1084 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1084 "../src/Photo.vala"
		return NULL;
#line 9810 "Photo.c"
	}
}

BackingPhotoRow*
photo_get_raw_development_photo_row (Photo* self,
                                     RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result = NULL;
#line 1089 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9822 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1090 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1090 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9829 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1091 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1091 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9837 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
#line 1091 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1091 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 1091 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1091 "../src/Photo.vala"
				_tmp1_ = (BackingPhotoRow*) _tmp4_;
#line 9848 "Photo.c"
			} else {
#line 1091 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1091 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 9854 "Photo.c"
			}
#line 1091 "../src/Photo.vala"
			result = _tmp1_;
#line 9858 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 1090 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 1090 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9865 "Photo.c"
			}
#line 1091 "../src/Photo.vala"
			return result;
#line 9869 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 1090 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 1090 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9878 "Photo.c"
		}
#line 1090 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1090 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1090 "../src/Photo.vala"
		return NULL;
#line 9886 "Photo.c"
	}
}

static PhotoFileFormat*
_photo_file_format_dup (PhotoFileFormat* self)
{
	PhotoFileFormat* dup;
#line 1101 "../src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 1101 "../src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 1101 "../src/Photo.vala"
	return dup;
#line 9900 "Photo.c"
}

static gpointer
__photo_file_format_dup0 (gpointer self)
{
#line 1101 "../src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 9908 "Photo.c"
}

PhotoFileFormat*
photo_get_editable_file_format (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_;
	PhotoFileFormat* _tmp4_;
	PhotoFileFormat* result = NULL;
#line 1095 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1096 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1096 "../src/Photo.vala"
	reader = _tmp0_;
#line 1097 "../src/Photo.vala"
	_tmp1_ = reader;
#line 1097 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1098 "../src/Photo.vala"
		result = NULL;
#line 1098 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 1098 "../src/Photo.vala"
		return result;
#line 9937 "Photo.c"
	}
#line 1101 "../src/Photo.vala"
	_tmp2_ = reader;
#line 1101 "../src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1101 "../src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 1101 "../src/Photo.vala"
	result = _tmp4_;
#line 1101 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1101 "../src/Photo.vala"
	return result;
#line 9951 "Photo.c"
}

PhotoFileFormat
photo_get_export_format_for_parameters (Photo* self,
                                        ExportFormatParameters* params)
{
	PhotoFileFormat _result_ = 0;
	ExportFormatParameters _tmp0_;
	PhotoFileFormat result = 0;
#line 1104 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 1104 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1105 "../src/Photo.vala"
	_result_ = photo_file_format_get_system_default_format ();
#line 1107 "../src/Photo.vala"
	_tmp0_ = *params;
#line 1107 "../src/Photo.vala"
	switch (_tmp0_.mode) {
#line 1107 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 9973 "Photo.c"
		{
#line 1109 "../src/Photo.vala"
			_result_ = photo_get_master_file_format (self);
#line 1110 "../src/Photo.vala"
			break;
#line 9979 "Photo.c"
		}
#line 1107 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 9983 "Photo.c"
		{
#line 1113 "../src/Photo.vala"
			_result_ = photo_get_best_export_file_format (self);
#line 1114 "../src/Photo.vala"
			break;
#line 9989 "Photo.c"
		}
#line 1107 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 9993 "Photo.c"
		{
			ExportFormatParameters _tmp1_;
#line 1117 "../src/Photo.vala"
			_tmp1_ = *params;
#line 1117 "../src/Photo.vala"
			_result_ = _tmp1_.specified_format;
#line 1118 "../src/Photo.vala"
			break;
#line 10002 "Photo.c"
		}
		default:
		{
#line 1121 "../src/Photo.vala"
			g_error ("Photo.vala:1121: get_export_format_for_parameters: unsupported export " \
"format mode");
#line 10008 "Photo.c"
		}
	}
#line 1124 "../src/Photo.vala"
	result = _result_;
#line 1124 "../src/Photo.vala"
	return result;
#line 10015 "Photo.c"
}

gchar*
photo_get_export_basename_for_parameters (Photo* self,
                                          ExportFormatParameters* params)
{
	gchar* _result_ = NULL;
	ExportFormatParameters _tmp0_;
	const gchar* _tmp7_;
	gchar* result = NULL;
#line 1127 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1127 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 1128 "../src/Photo.vala"
	_result_ = NULL;
#line 1130 "../src/Photo.vala"
	_tmp0_ = *params;
#line 1130 "../src/Photo.vala"
	switch (_tmp0_.mode) {
#line 1130 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 10038 "Photo.c"
		{
			GFile* _tmp1_;
			GFile* _tmp2_;
			gchar* _tmp3_;
#line 1132 "../src/Photo.vala"
			_tmp1_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 1132 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 1132 "../src/Photo.vala"
			_tmp3_ = g_file_get_basename (_tmp2_);
#line 1132 "../src/Photo.vala"
			_g_free0 (_result_);
#line 1132 "../src/Photo.vala"
			_result_ = _tmp3_;
#line 1132 "../src/Photo.vala"
			_g_object_unref0 (_tmp2_);
#line 1133 "../src/Photo.vala"
			break;
#line 10057 "Photo.c"
		}
#line 1130 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 1130 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 10063 "Photo.c"
		{
			ExportFormatParameters _tmp4_;
			PhotoFileFormat _tmp5_;
			gchar* _tmp6_;
#line 1137 "../src/Photo.vala"
			_tmp4_ = *params;
#line 1137 "../src/Photo.vala"
			_tmp5_ = photo_get_export_format_for_parameters (self, &_tmp4_);
#line 1137 "../src/Photo.vala"
			_tmp6_ = photo_get_export_basename (self, &_tmp5_);
#line 1137 "../src/Photo.vala"
			result = _tmp6_;
#line 1137 "../src/Photo.vala"
			_g_free0 (_result_);
#line 1137 "../src/Photo.vala"
			return result;
#line 10080 "Photo.c"
		}
		default:
		{
#line 1140 "../src/Photo.vala"
			g_error ("Photo.vala:1140: get_export_basename_for_parameters: unsupported expor" \
"t format mode");
#line 10086 "Photo.c"
		}
	}
#line 1143 "../src/Photo.vala"
	_tmp7_ = _result_;
#line 1143 "../src/Photo.vala"
	_vala_assert (_tmp7_ != NULL, "result != null");
#line 1144 "../src/Photo.vala"
	result = _result_;
#line 1144 "../src/Photo.vala"
	return result;
#line 10097 "Photo.c"
}

ImportResult
photo_prepare_for_import (PhotoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp11_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp15_;
	GTimeVal _tmp16_ = {0};
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	const gchar* _tmp19_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp22_;
	PhotoFileInterrogator* _tmp23_;
	PhotoFileInterrogator* _tmp30_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp31_;
	DetectedPhotoInformation* _tmp32_;
	gboolean _tmp33_ = FALSE;
	DetectedPhotoInformation* _tmp34_;
	Orientation orientation = 0;
	time_t exposure_time = 0;
	gchar* title = NULL;
	gchar* _tmp45_;
	GpsCoords gps_coords = {0};
	gchar* comment = NULL;
	gchar* _tmp46_;
	Rating rating = 0;
	DetectedPhotoInformation* _tmp47_;
	PhotoMetadata* _tmp48_;
	gboolean _tmp70_ = FALSE;
	gboolean _tmp71_ = FALSE;
	DetectedPhotoInformation* _tmp72_;
	PhotoRow* _tmp78_;
	PhotoRow* _tmp79_;
	BackingPhotoRow* _tmp80_;
	GFile* _tmp81_;
	gchar* _tmp82_;
	PhotoRow* _tmp83_;
	BackingPhotoRow* _tmp84_;
	DetectedPhotoInformation* _tmp85_;
	Dimensions _tmp86_;
	PhotoRow* _tmp87_;
	BackingPhotoRow* _tmp88_;
	GFileInfo* _tmp89_;
	PhotoRow* _tmp90_;
	BackingPhotoRow* _tmp91_;
	GTimeVal _tmp92_;
	PhotoRow* _tmp93_;
	PhotoRow* _tmp94_;
	PhotoRow* _tmp95_;
	BackingPhotoRow* _tmp96_;
	PhotoRow* _tmp97_;
	ImportID _tmp98_;
	PhotoRow* _tmp99_;
	PhotoRow* _tmp100_;
	PhotoRow* _tmp101_;
	DetectedPhotoInformation* _tmp102_;
	const gchar* _tmp103_;
	gchar* _tmp104_;
	PhotoRow* _tmp105_;
	DetectedPhotoInformation* _tmp106_;
	const gchar* _tmp107_;
	gchar* _tmp108_;
	PhotoRow* _tmp109_;
	DetectedPhotoInformation* _tmp110_;
	const gchar* _tmp111_;
	gchar* _tmp112_;
	PhotoRow* _tmp113_;
	PhotoRow* _tmp114_;
	PhotoRow* _tmp115_;
	BackingPhotoRow* _tmp116_;
	DetectedPhotoInformation* _tmp117_;
	PhotoRow* _tmp118_;
	const gchar* _tmp119_;
	gchar* _tmp120_;
	PhotoRow* _tmp121_;
	GpsCoords _tmp122_;
	PhotoRow* _tmp123_;
	const gchar* _tmp124_;
	gchar* _tmp125_;
	PhotoRow* _tmp126_;
	Thumbnails* _tmp127_;
	GError* _inner_error0_ = NULL;
	ImportResult result = 0;
#line 1159 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 1163 "../src/Photo.vala"
	_tmp0_ = params->file;
#line 1163 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1163 "../src/Photo.vala"
	file = _tmp1_;
#line 1165 "../src/Photo.vala"
	info = NULL;
#line 10200 "Photo.c"
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 1167 "../src/Photo.vala"
		_tmp3_ = file;
#line 1167 "../src/Photo.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1167 "../src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 1167 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10214 "Photo.c"
			goto __catch0_g_error;
		}
#line 1167 "../src/Photo.vala"
		_tmp5_ = _tmp2_;
#line 1167 "../src/Photo.vala"
		_tmp2_ = NULL;
#line 1167 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1167 "../src/Photo.vala"
		info = _tmp5_;
#line 1166 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 10227 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1166 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1170 "../src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 1170 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1170 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1170 "../src/Photo.vala"
		return result;
#line 10242 "Photo.c"
	}
	__finally0:
#line 1166 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1166 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1166 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1166 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1166 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1166 "../src/Photo.vala"
		return 0;
#line 10257 "Photo.c"
	}
#line 1173 "../src/Photo.vala"
	_tmp6_ = info;
#line 1173 "../src/Photo.vala"
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
#line 1174 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 1174 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1174 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1174 "../src/Photo.vala"
		return result;
#line 10271 "Photo.c"
	}
#line 1176 "../src/Photo.vala"
	_tmp7_ = file;
#line 1176 "../src/Photo.vala"
	if (!photo_is_file_image (_tmp7_)) {
#line 10277 "Photo.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1177 "../src/Photo.vala"
		_tmp8_ = file;
#line 1177 "../src/Photo.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 1177 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 1177 "../src/Photo.vala"
		g_message ("Photo.vala:1177: Not importing %s: Not an image file", _tmp10_);
#line 1177 "../src/Photo.vala"
		_g_free0 (_tmp10_);
#line 1179 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1179 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1179 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1179 "../src/Photo.vala"
		return result;
#line 10299 "Photo.c"
	}
#line 1182 "../src/Photo.vala"
	_tmp11_ = file;
#line 1182 "../src/Photo.vala"
	if (!photo_file_format_is_file_supported (_tmp11_)) {
#line 10305 "Photo.c"
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 1183 "../src/Photo.vala"
		_tmp12_ = file;
#line 1183 "../src/Photo.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 1183 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 1183 "../src/Photo.vala"
		g_message ("Photo.vala:1183: Not importing %s: Unsupported extension", _tmp14_);
#line 1183 "../src/Photo.vala"
		_g_free0 (_tmp14_);
#line 1185 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1185 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1185 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1185 "../src/Photo.vala"
		return result;
#line 10327 "Photo.c"
	}
#line 1188 "../src/Photo.vala"
	_tmp15_ = info;
#line 1188 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp15_, &_tmp16_);
#line 1188 "../src/Photo.vala"
	timestamp = _tmp16_;
#line 1191 "../src/Photo.vala"
	_tmp19_ = params->exif_md5;
#line 1191 "../src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 10339 "Photo.c"
		const gchar* _tmp20_;
#line 1191 "../src/Photo.vala"
		_tmp20_ = params->thumbnail_md5;
#line 1191 "../src/Photo.vala"
		_tmp18_ = _tmp20_ != NULL;
#line 10345 "Photo.c"
	} else {
#line 1191 "../src/Photo.vala"
		_tmp18_ = FALSE;
#line 10349 "Photo.c"
	}
#line 1191 "../src/Photo.vala"
	if (_tmp18_) {
#line 10353 "Photo.c"
		const gchar* _tmp21_;
#line 1191 "../src/Photo.vala"
		_tmp21_ = params->full_md5;
#line 1191 "../src/Photo.vala"
		_tmp17_ = _tmp21_ != NULL;
#line 10359 "Photo.c"
	} else {
#line 1191 "../src/Photo.vala"
		_tmp17_ = FALSE;
#line 10363 "Photo.c"
	}
#line 1191 "../src/Photo.vala"
	if (_tmp17_) {
#line 1192 "../src/Photo.vala"
		params->sniffer_options = params->sniffer_options | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 10369 "Photo.c"
	}
#line 1195 "../src/Photo.vala"
	_tmp22_ = file;
#line 1195 "../src/Photo.vala"
	_tmp23_ = photo_file_interrogator_new (_tmp22_, params->sniffer_options);
#line 1195 "../src/Photo.vala"
	interrogator = _tmp23_;
#line 10377 "Photo.c"
	{
		PhotoFileInterrogator* _tmp24_;
#line 1197 "../src/Photo.vala"
		_tmp24_ = interrogator;
#line 1197 "../src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp24_, &_inner_error0_);
#line 1197 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10386 "Photo.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GFile* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		GError* _tmp28_;
		const gchar* _tmp29_;
#line 1196 "../src/Photo.vala"
		err = _inner_error0_;
#line 1196 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1199 "../src/Photo.vala"
		_tmp25_ = file;
#line 1199 "../src/Photo.vala"
		_tmp26_ = g_file_get_path (_tmp25_);
#line 1199 "../src/Photo.vala"
		_tmp27_ = _tmp26_;
#line 1199 "../src/Photo.vala"
		_tmp28_ = err;
#line 1199 "../src/Photo.vala"
		_tmp29_ = _tmp28_->message;
#line 1199 "../src/Photo.vala"
		g_warning ("Photo.vala:1199: Unable to interrogate photo file %s: %s", _tmp27_, _tmp29_);
#line 1199 "../src/Photo.vala"
		_g_free0 (_tmp27_);
#line 1201 "../src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 1201 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1201 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1201 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1201 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1201 "../src/Photo.vala"
		return result;
#line 10429 "Photo.c"
	}
	__finally1:
#line 1196 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1196 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1196 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1196 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1196 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1196 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1196 "../src/Photo.vala"
		return 0;
#line 10446 "Photo.c"
	}
#line 1204 "../src/Photo.vala"
	_tmp30_ = interrogator;
#line 1204 "../src/Photo.vala"
	if (photo_file_interrogator_get_is_photo_corrupted (_tmp30_)) {
#line 1205 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1205 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1205 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1205 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1205 "../src/Photo.vala"
		return result;
#line 10462 "Photo.c"
	}
#line 1208 "../src/Photo.vala"
	_tmp31_ = interrogator;
#line 1208 "../src/Photo.vala"
	_tmp32_ = photo_file_interrogator_get_detected_photo_information (_tmp31_);
#line 1208 "../src/Photo.vala"
	detected = _tmp32_;
#line 1209 "../src/Photo.vala"
	_tmp34_ = detected;
#line 1209 "../src/Photo.vala"
	if (_tmp34_ == NULL) {
#line 1209 "../src/Photo.vala"
		_tmp33_ = TRUE;
#line 10476 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp35_;
#line 1209 "../src/Photo.vala"
		_tmp35_ = detected;
#line 1209 "../src/Photo.vala"
		_tmp33_ = _tmp35_->file_format == PHOTO_FILE_FORMAT_UNKNOWN;
#line 10483 "Photo.c"
	}
#line 1209 "../src/Photo.vala"
	if (_tmp33_) {
#line 1210 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1210 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1210 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1210 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1210 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1210 "../src/Photo.vala"
		return result;
#line 10499 "Photo.c"
	}
#line 1213 "../src/Photo.vala"
	if ((params->sniffer_options & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 10503 "Photo.c"
		DetectedPhotoInformation* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		DetectedPhotoInformation* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		DetectedPhotoInformation* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
#line 1214 "../src/Photo.vala"
		_tmp36_ = detected;
#line 1214 "../src/Photo.vala"
		_tmp37_ = params->exif_md5;
#line 1214 "../src/Photo.vala"
		_tmp38_ = g_strdup (_tmp37_);
#line 1214 "../src/Photo.vala"
		_g_free0 (_tmp36_->exif_md5);
#line 1214 "../src/Photo.vala"
		_tmp36_->exif_md5 = _tmp38_;
#line 1215 "../src/Photo.vala"
		_tmp39_ = detected;
#line 1215 "../src/Photo.vala"
		_tmp40_ = params->thumbnail_md5;
#line 1215 "../src/Photo.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 1215 "../src/Photo.vala"
		_g_free0 (_tmp39_->thumbnail_md5);
#line 1215 "../src/Photo.vala"
		_tmp39_->thumbnail_md5 = _tmp41_;
#line 1216 "../src/Photo.vala"
		_tmp42_ = detected;
#line 1216 "../src/Photo.vala"
		_tmp43_ = params->full_md5;
#line 1216 "../src/Photo.vala"
		_tmp44_ = g_strdup (_tmp43_);
#line 1216 "../src/Photo.vala"
		_g_free0 (_tmp42_->md5);
#line 1216 "../src/Photo.vala"
		_tmp42_->md5 = _tmp44_;
#line 10543 "Photo.c"
	}
#line 1219 "../src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 1220 "../src/Photo.vala"
	exposure_time = (time_t) 0;
#line 1221 "../src/Photo.vala"
	_tmp45_ = g_strdup ("");
#line 1221 "../src/Photo.vala"
	title = _tmp45_;
#line 1222 "../src/Photo.vala"
	memset (&gps_coords, 0, sizeof (GpsCoords));
#line 1223 "../src/Photo.vala"
	_tmp46_ = g_strdup ("");
#line 1223 "../src/Photo.vala"
	comment = _tmp46_;
#line 1224 "../src/Photo.vala"
	rating = RATING_UNRATED;
#line 1231 "../src/Photo.vala"
	_tmp47_ = detected;
#line 1231 "../src/Photo.vala"
	_tmp48_ = _tmp47_->metadata;
#line 1231 "../src/Photo.vala"
	if (_tmp48_ != NULL) {
#line 10567 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp49_;
		PhotoMetadata* _tmp50_;
		MetadataDateTime* _tmp51_;
		MetadataDateTime* _tmp52_;
		DetectedPhotoInformation* _tmp54_;
		PhotoMetadata* _tmp55_;
		DetectedPhotoInformation* _tmp56_;
		PhotoMetadata* _tmp57_;
		gchar* _tmp58_;
		DetectedPhotoInformation* _tmp59_;
		PhotoMetadata* _tmp60_;
		GpsCoords _tmp61_ = {0};
		DetectedPhotoInformation* _tmp62_;
		PhotoMetadata* _tmp63_;
		gchar* _tmp64_;
		DetectedPhotoInformation* _tmp65_;
		PhotoMetadata* _tmp66_;
		GeeSet* _tmp67_;
		DetectedPhotoInformation* _tmp68_;
		PhotoMetadata* _tmp69_;
#line 1232 "../src/Photo.vala"
		_tmp49_ = detected;
#line 1232 "../src/Photo.vala"
		_tmp50_ = _tmp49_->metadata;
#line 1232 "../src/Photo.vala"
		_tmp51_ = photo_metadata_get_exposure_date_time (_tmp50_);
#line 1232 "../src/Photo.vala"
		date_time = _tmp51_;
#line 1233 "../src/Photo.vala"
		_tmp52_ = date_time;
#line 1233 "../src/Photo.vala"
		if (_tmp52_ != NULL) {
#line 10601 "Photo.c"
			MetadataDateTime* _tmp53_;
#line 1234 "../src/Photo.vala"
			_tmp53_ = date_time;
#line 1234 "../src/Photo.vala"
			exposure_time = metadata_date_time_get_timestamp (_tmp53_);
#line 10607 "Photo.c"
		}
#line 1236 "../src/Photo.vala"
		_tmp54_ = detected;
#line 1236 "../src/Photo.vala"
		_tmp55_ = _tmp54_->metadata;
#line 1236 "../src/Photo.vala"
		orientation = photo_metadata_get_orientation (_tmp55_);
#line 1237 "../src/Photo.vala"
		_tmp56_ = detected;
#line 1237 "../src/Photo.vala"
		_tmp57_ = _tmp56_->metadata;
#line 1237 "../src/Photo.vala"
		_tmp58_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1237 "../src/Photo.vala"
		_g_free0 (title);
#line 1237 "../src/Photo.vala"
		title = _tmp58_;
#line 1238 "../src/Photo.vala"
		_tmp59_ = detected;
#line 1238 "../src/Photo.vala"
		_tmp60_ = _tmp59_->metadata;
#line 1238 "../src/Photo.vala"
		photo_metadata_get_gps_coords (_tmp60_, &_tmp61_);
#line 1238 "../src/Photo.vala"
		gps_coords = _tmp61_;
#line 1239 "../src/Photo.vala"
		_tmp62_ = detected;
#line 1239 "../src/Photo.vala"
		_tmp63_ = _tmp62_->metadata;
#line 1239 "../src/Photo.vala"
		_tmp64_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1239 "../src/Photo.vala"
		_g_free0 (comment);
#line 1239 "../src/Photo.vala"
		comment = _tmp64_;
#line 1240 "../src/Photo.vala"
		_tmp65_ = detected;
#line 1240 "../src/Photo.vala"
		_tmp66_ = _tmp65_->metadata;
#line 1240 "../src/Photo.vala"
		_tmp67_ = photo_metadata_get_keywords (_tmp66_, NULL, NULL, NULL);
#line 1240 "../src/Photo.vala"
		_g_object_unref0 (params->keywords);
#line 1240 "../src/Photo.vala"
		params->keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1241 "../src/Photo.vala"
		_tmp68_ = detected;
#line 1241 "../src/Photo.vala"
		_tmp69_ = _tmp68_->metadata;
#line 1241 "../src/Photo.vala"
		rating = photo_metadata_get_rating (_tmp69_);
#line 1231 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 10661 "Photo.c"
	}
#line 1245 "../src/Photo.vala"
	_tmp72_ = detected;
#line 1245 "../src/Photo.vala"
	if (_tmp72_->colorspace != GDK_COLORSPACE_RGB) {
#line 1245 "../src/Photo.vala"
		_tmp71_ = TRUE;
#line 10669 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp73_;
#line 1246 "../src/Photo.vala"
		_tmp73_ = detected;
#line 1246 "../src/Photo.vala"
		_tmp71_ = _tmp73_->channels < 3;
#line 10676 "Photo.c"
	}
#line 1245 "../src/Photo.vala"
	if (_tmp71_) {
#line 1245 "../src/Photo.vala"
		_tmp70_ = TRUE;
#line 10682 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp74_;
#line 1247 "../src/Photo.vala"
		_tmp74_ = detected;
#line 1247 "../src/Photo.vala"
		_tmp70_ = _tmp74_->bits_per_channel != 8;
#line 10689 "Photo.c"
	}
#line 1245 "../src/Photo.vala"
	if (_tmp70_) {
#line 10693 "Photo.c"
		GFile* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
#line 1248 "../src/Photo.vala"
		_tmp75_ = file;
#line 1248 "../src/Photo.vala"
		_tmp76_ = g_file_get_path (_tmp75_);
#line 1248 "../src/Photo.vala"
		_tmp77_ = _tmp76_;
#line 1248 "../src/Photo.vala"
		g_message ("Photo.vala:1248: Not importing %s: Unsupported color format", _tmp77_);
#line 1248 "../src/Photo.vala"
		_g_free0 (_tmp77_);
#line 1250 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1250 "../src/Photo.vala"
		_g_free0 (comment);
#line 1250 "../src/Photo.vala"
		_g_free0 (title);
#line 1250 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1250 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1250 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1250 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1250 "../src/Photo.vala"
		return result;
#line 10723 "Photo.c"
	}
#line 1256 "../src/Photo.vala"
	_tmp78_ = params->row;
#line 1256 "../src/Photo.vala"
	photo_id_init (&_tmp78_->photo_id, PHOTO_ID_INVALID);
#line 1257 "../src/Photo.vala"
	_tmp79_ = params->row;
#line 1257 "../src/Photo.vala"
	_tmp80_ = _tmp79_->master;
#line 1257 "../src/Photo.vala"
	_tmp81_ = file;
#line 1257 "../src/Photo.vala"
	_tmp82_ = g_file_get_path (_tmp81_);
#line 1257 "../src/Photo.vala"
	_g_free0 (_tmp80_->filepath);
#line 1257 "../src/Photo.vala"
	_tmp80_->filepath = _tmp82_;
#line 1258 "../src/Photo.vala"
	_tmp83_ = params->row;
#line 1258 "../src/Photo.vala"
	_tmp84_ = _tmp83_->master;
#line 1258 "../src/Photo.vala"
	_tmp85_ = detected;
#line 1258 "../src/Photo.vala"
	_tmp86_ = _tmp85_->image_dim;
#line 1258 "../src/Photo.vala"
	_tmp84_->dim = _tmp86_;
#line 1259 "../src/Photo.vala"
	_tmp87_ = params->row;
#line 1259 "../src/Photo.vala"
	_tmp88_ = _tmp87_->master;
#line 1259 "../src/Photo.vala"
	_tmp89_ = info;
#line 1259 "../src/Photo.vala"
	_tmp88_->filesize = g_file_info_get_size (_tmp89_);
#line 1260 "../src/Photo.vala"
	_tmp90_ = params->row;
#line 1260 "../src/Photo.vala"
	_tmp91_ = _tmp90_->master;
#line 1260 "../src/Photo.vala"
	_tmp92_ = timestamp;
#line 1260 "../src/Photo.vala"
	_tmp91_->timestamp = (time_t) _tmp92_.tv_sec;
#line 1261 "../src/Photo.vala"
	_tmp93_ = params->row;
#line 1261 "../src/Photo.vala"
	_tmp93_->exposure_time = exposure_time;
#line 1262 "../src/Photo.vala"
	_tmp94_ = params->row;
#line 1262 "../src/Photo.vala"
	_tmp94_->orientation = orientation;
#line 1263 "../src/Photo.vala"
	_tmp95_ = params->row;
#line 1263 "../src/Photo.vala"
	_tmp96_ = _tmp95_->master;
#line 1263 "../src/Photo.vala"
	_tmp96_->original_orientation = orientation;
#line 1264 "../src/Photo.vala"
	_tmp97_ = params->row;
#line 1264 "../src/Photo.vala"
	_tmp98_ = params->import_id;
#line 1264 "../src/Photo.vala"
	_tmp97_->import_id = _tmp98_;
#line 1265 "../src/Photo.vala"
	_tmp99_ = params->row;
#line 1265 "../src/Photo.vala"
	event_id_init (&_tmp99_->event_id, EVENT_ID_INVALID);
#line 1266 "../src/Photo.vala"
	_tmp100_ = params->row;
#line 1266 "../src/Photo.vala"
	_g_object_unref0 (_tmp100_->transformations);
#line 1266 "../src/Photo.vala"
	_tmp100_->transformations = NULL;
#line 1267 "../src/Photo.vala"
	_tmp101_ = params->row;
#line 1267 "../src/Photo.vala"
	_tmp102_ = detected;
#line 1267 "../src/Photo.vala"
	_tmp103_ = _tmp102_->md5;
#line 1267 "../src/Photo.vala"
	_tmp104_ = g_strdup (_tmp103_);
#line 1267 "../src/Photo.vala"
	_g_free0 (_tmp101_->md5);
#line 1267 "../src/Photo.vala"
	_tmp101_->md5 = _tmp104_;
#line 1268 "../src/Photo.vala"
	_tmp105_ = params->row;
#line 1268 "../src/Photo.vala"
	_tmp106_ = detected;
#line 1268 "../src/Photo.vala"
	_tmp107_ = _tmp106_->thumbnail_md5;
#line 1268 "../src/Photo.vala"
	_tmp108_ = g_strdup (_tmp107_);
#line 1268 "../src/Photo.vala"
	_g_free0 (_tmp105_->thumbnail_md5);
#line 1268 "../src/Photo.vala"
	_tmp105_->thumbnail_md5 = _tmp108_;
#line 1269 "../src/Photo.vala"
	_tmp109_ = params->row;
#line 1269 "../src/Photo.vala"
	_tmp110_ = detected;
#line 1269 "../src/Photo.vala"
	_tmp111_ = _tmp110_->exif_md5;
#line 1269 "../src/Photo.vala"
	_tmp112_ = g_strdup (_tmp111_);
#line 1269 "../src/Photo.vala"
	_g_free0 (_tmp109_->exif_md5);
#line 1269 "../src/Photo.vala"
	_tmp109_->exif_md5 = _tmp112_;
#line 1270 "../src/Photo.vala"
	_tmp113_ = params->row;
#line 1270 "../src/Photo.vala"
	_tmp113_->time_created = (time_t) 0;
#line 1271 "../src/Photo.vala"
	_tmp114_ = params->row;
#line 1271 "../src/Photo.vala"
	_tmp114_->flags = (guint64) 0;
#line 1272 "../src/Photo.vala"
	_tmp115_ = params->row;
#line 1272 "../src/Photo.vala"
	_tmp116_ = _tmp115_->master;
#line 1272 "../src/Photo.vala"
	_tmp117_ = detected;
#line 1272 "../src/Photo.vala"
	_tmp116_->file_format = _tmp117_->file_format;
#line 1273 "../src/Photo.vala"
	_tmp118_ = params->row;
#line 1273 "../src/Photo.vala"
	_tmp119_ = title;
#line 1273 "../src/Photo.vala"
	_tmp120_ = g_strdup (_tmp119_);
#line 1273 "../src/Photo.vala"
	_g_free0 (_tmp118_->title);
#line 1273 "../src/Photo.vala"
	_tmp118_->title = _tmp120_;
#line 1274 "../src/Photo.vala"
	_tmp121_ = params->row;
#line 1274 "../src/Photo.vala"
	_tmp122_ = gps_coords;
#line 1274 "../src/Photo.vala"
	_tmp121_->gps_coords = _tmp122_;
#line 1275 "../src/Photo.vala"
	_tmp123_ = params->row;
#line 1275 "../src/Photo.vala"
	_tmp124_ = comment;
#line 1275 "../src/Photo.vala"
	_tmp125_ = g_strdup (_tmp124_);
#line 1275 "../src/Photo.vala"
	_g_free0 (_tmp123_->comment);
#line 1275 "../src/Photo.vala"
	_tmp123_->comment = _tmp125_;
#line 1276 "../src/Photo.vala"
	_tmp126_ = params->row;
#line 1276 "../src/Photo.vala"
	_tmp126_->rating = rating;
#line 1278 "../src/Photo.vala"
	_tmp127_ = params->thumbnails;
#line 1278 "../src/Photo.vala"
	if (_tmp127_ != NULL) {
#line 10883 "Photo.c"
		PhotoFileReader* reader = NULL;
		PhotoRow* _tmp128_;
		BackingPhotoRow* _tmp129_;
		PhotoRow* _tmp130_;
		BackingPhotoRow* _tmp131_;
		const gchar* _tmp132_;
		PhotoFileReader* _tmp133_;
		PhotoFileReader* _tmp134_;
#line 1279 "../src/Photo.vala"
		_tmp128_ = params->row;
#line 1279 "../src/Photo.vala"
		_tmp129_ = _tmp128_->master;
#line 1279 "../src/Photo.vala"
		_tmp130_ = params->row;
#line 1279 "../src/Photo.vala"
		_tmp131_ = _tmp130_->master;
#line 1279 "../src/Photo.vala"
		_tmp132_ = _tmp131_->filepath;
#line 1279 "../src/Photo.vala"
		_tmp133_ = photo_file_format_create_reader (_tmp129_->file_format, _tmp132_);
#line 1279 "../src/Photo.vala"
		reader = _tmp133_;
#line 1281 "../src/Photo.vala"
		_tmp134_ = reader;
#line 1281 "../src/Photo.vala"
		photo_file_reader_set_role (_tmp134_, PHOTO_FILE_READER_ROLE_THUMBNAIL);
#line 10910 "Photo.c"
		{
			Thumbnails* _tmp135_;
			PhotoFileReader* _tmp136_;
			PhotoRow* _tmp137_;
			PhotoRow* _tmp138_;
			BackingPhotoRow* _tmp139_;
			Dimensions _tmp140_;
#line 1283 "../src/Photo.vala"
			_tmp135_ = params->thumbnails;
#line 1283 "../src/Photo.vala"
			_tmp136_ = reader;
#line 1283 "../src/Photo.vala"
			_tmp137_ = params->row;
#line 1283 "../src/Photo.vala"
			_tmp138_ = params->row;
#line 1283 "../src/Photo.vala"
			_tmp139_ = _tmp138_->master;
#line 1283 "../src/Photo.vala"
			_tmp140_ = _tmp139_->dim;
#line 1283 "../src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp135_, _tmp136_, _tmp137_->orientation, &_tmp140_, &_inner_error0_);
#line 1283 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10934 "Photo.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* err = NULL;
			GError* _tmp141_;
#line 1282 "../src/Photo.vala"
			err = _inner_error0_;
#line 1282 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 1286 "../src/Photo.vala"
			_tmp141_ = err;
#line 1286 "../src/Photo.vala"
			result = import_result_convert_error (_tmp141_, IMPORT_RESULT_FILE_ERROR);
#line 1286 "../src/Photo.vala"
			_g_error_free0 (err);
#line 1286 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1286 "../src/Photo.vala"
			_g_free0 (comment);
#line 1286 "../src/Photo.vala"
			_g_free0 (title);
#line 1286 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1286 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1286 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 1286 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1286 "../src/Photo.vala"
			return result;
#line 10969 "Photo.c"
		}
		__finally2:
#line 1282 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1282 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1282 "../src/Photo.vala"
			_g_free0 (comment);
#line 1282 "../src/Photo.vala"
			_g_free0 (title);
#line 1282 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1282 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1282 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 1282 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1282 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1282 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1282 "../src/Photo.vala"
			return 0;
#line 10994 "Photo.c"
		}
#line 1278 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 10998 "Photo.c"
	}
#line 1293 "../src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1293 "../src/Photo.vala"
	_g_free0 (comment);
#line 1293 "../src/Photo.vala"
	_g_free0 (title);
#line 1293 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1293 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1293 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 1293 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1293 "../src/Photo.vala"
	return result;
#line 11016 "Photo.c"
}

void
photo_create_pre_import (PhotoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoRow* _tmp3_;
	BackingPhotoRow* _tmp4_;
	gchar* _tmp5_;
	PhotoRow* _tmp6_;
	BackingPhotoRow* _tmp7_;
	PhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	PhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	PhotoRow* _tmp12_;
	PhotoRow* _tmp13_;
	PhotoRow* _tmp14_;
	BackingPhotoRow* _tmp15_;
	PhotoRow* _tmp16_;
	ImportID _tmp17_;
	PhotoRow* _tmp18_;
	PhotoRow* _tmp19_;
	PhotoRow* _tmp20_;
	PhotoRow* _tmp21_;
	PhotoRow* _tmp22_;
	PhotoRow* _tmp23_;
	PhotoRow* _tmp24_;
	PhotoRow* _tmp25_;
	BackingPhotoRow* _tmp26_;
	PhotoRow* _tmp27_;
	PhotoRow* _tmp28_;
	PhotoRow* _tmp29_;
	PhotoRow* _tmp30_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp31_;
	PhotoFileInterrogator* _tmp32_;
	GError* _inner_error0_ = NULL;
#line 1296 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_IMPORT_PARAMS (params));
#line 1297 "../src/Photo.vala"
	_tmp0_ = params->file;
#line 1297 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1297 "../src/Photo.vala"
	file = _tmp1_;
#line 1298 "../src/Photo.vala"
	_tmp2_ = params->row;
#line 1298 "../src/Photo.vala"
	photo_id_init (&_tmp2_->photo_id, PHOTO_ID_INVALID);
#line 1299 "../src/Photo.vala"
	_tmp3_ = params->row;
#line 1299 "../src/Photo.vala"
	_tmp4_ = _tmp3_->master;
#line 1299 "../src/Photo.vala"
	_tmp5_ = g_file_get_path (file);
#line 1299 "../src/Photo.vala"
	_g_free0 (_tmp4_->filepath);
#line 1299 "../src/Photo.vala"
	_tmp4_->filepath = _tmp5_;
#line 1300 "../src/Photo.vala"
	_tmp6_ = params->row;
#line 1300 "../src/Photo.vala"
	_tmp7_ = _tmp6_->master;
#line 1300 "../src/Photo.vala"
	dimensions_init (&_tmp7_->dim, 0, 0);
#line 1301 "../src/Photo.vala"
	_tmp8_ = params->row;
#line 1301 "../src/Photo.vala"
	_tmp9_ = _tmp8_->master;
#line 1301 "../src/Photo.vala"
	_tmp9_->filesize = (gint64) 0;
#line 1302 "../src/Photo.vala"
	_tmp10_ = params->row;
#line 1302 "../src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 1302 "../src/Photo.vala"
	_tmp11_->timestamp = (time_t) 0;
#line 1303 "../src/Photo.vala"
	_tmp12_ = params->row;
#line 1303 "../src/Photo.vala"
	_tmp12_->exposure_time = (time_t) 0;
#line 1304 "../src/Photo.vala"
	_tmp13_ = params->row;
#line 1304 "../src/Photo.vala"
	_tmp13_->orientation = ORIENTATION_TOP_LEFT;
#line 1305 "../src/Photo.vala"
	_tmp14_ = params->row;
#line 1305 "../src/Photo.vala"
	_tmp15_ = _tmp14_->master;
#line 1305 "../src/Photo.vala"
	_tmp15_->original_orientation = ORIENTATION_TOP_LEFT;
#line 1306 "../src/Photo.vala"
	_tmp16_ = params->row;
#line 1306 "../src/Photo.vala"
	_tmp17_ = params->import_id;
#line 1306 "../src/Photo.vala"
	_tmp16_->import_id = _tmp17_;
#line 1307 "../src/Photo.vala"
	_tmp18_ = params->row;
#line 1307 "../src/Photo.vala"
	event_id_init (&_tmp18_->event_id, EVENT_ID_INVALID);
#line 1308 "../src/Photo.vala"
	_tmp19_ = params->row;
#line 1308 "../src/Photo.vala"
	_g_object_unref0 (_tmp19_->transformations);
#line 1308 "../src/Photo.vala"
	_tmp19_->transformations = NULL;
#line 1309 "../src/Photo.vala"
	_tmp20_ = params->row;
#line 1309 "../src/Photo.vala"
	_g_free0 (_tmp20_->md5);
#line 1309 "../src/Photo.vala"
	_tmp20_->md5 = NULL;
#line 1310 "../src/Photo.vala"
	_tmp21_ = params->row;
#line 1310 "../src/Photo.vala"
	_g_free0 (_tmp21_->thumbnail_md5);
#line 1310 "../src/Photo.vala"
	_tmp21_->thumbnail_md5 = NULL;
#line 1311 "../src/Photo.vala"
	_tmp22_ = params->row;
#line 1311 "../src/Photo.vala"
	_g_free0 (_tmp22_->exif_md5);
#line 1311 "../src/Photo.vala"
	_tmp22_->exif_md5 = NULL;
#line 1312 "../src/Photo.vala"
	_tmp23_ = params->row;
#line 1312 "../src/Photo.vala"
	_tmp23_->time_created = (time_t) 0;
#line 1313 "../src/Photo.vala"
	_tmp24_ = params->row;
#line 1313 "../src/Photo.vala"
	_tmp24_->flags = (guint64) 0;
#line 1314 "../src/Photo.vala"
	_tmp25_ = params->row;
#line 1314 "../src/Photo.vala"
	_tmp26_ = _tmp25_->master;
#line 1314 "../src/Photo.vala"
	_tmp26_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1315 "../src/Photo.vala"
	_tmp27_ = params->row;
#line 1315 "../src/Photo.vala"
	_g_free0 (_tmp27_->title);
#line 1315 "../src/Photo.vala"
	_tmp27_->title = NULL;
#line 1316 "../src/Photo.vala"
	_tmp28_ = params->row;
#line 1316 "../src/Photo.vala"
	memset (&_tmp28_->gps_coords, 0, sizeof (GpsCoords));
#line 1317 "../src/Photo.vala"
	_tmp29_ = params->row;
#line 1317 "../src/Photo.vala"
	_g_free0 (_tmp29_->comment);
#line 1317 "../src/Photo.vala"
	_tmp29_->comment = NULL;
#line 1318 "../src/Photo.vala"
	_tmp30_ = params->row;
#line 1318 "../src/Photo.vala"
	_tmp30_->rating = RATING_UNRATED;
#line 1320 "../src/Photo.vala"
	_tmp31_ = params->file;
#line 1320 "../src/Photo.vala"
	_tmp32_ = photo_file_interrogator_new (_tmp31_, params->sniffer_options);
#line 1320 "../src/Photo.vala"
	interrogator = _tmp32_;
#line 11186 "Photo.c"
	{
		DetectedPhotoInformation* detected = NULL;
		DetectedPhotoInformation* _tmp33_;
		gboolean _tmp34_ = FALSE;
		gboolean _tmp35_ = FALSE;
		DetectedPhotoInformation* _tmp36_;
#line 1322 "../src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 1322 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11197 "Photo.c"
			goto __catch0_g_error;
		}
#line 1323 "../src/Photo.vala"
		_tmp33_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1323 "../src/Photo.vala"
		detected = _tmp33_;
#line 1324 "../src/Photo.vala"
		_tmp36_ = detected;
#line 1324 "../src/Photo.vala"
		if (_tmp36_ != NULL) {
#line 1324 "../src/Photo.vala"
			_tmp35_ = !photo_file_interrogator_get_is_photo_corrupted (interrogator);
#line 11210 "Photo.c"
		} else {
#line 1324 "../src/Photo.vala"
			_tmp35_ = FALSE;
#line 11214 "Photo.c"
		}
#line 1324 "../src/Photo.vala"
		if (_tmp35_) {
#line 11218 "Photo.c"
			DetectedPhotoInformation* _tmp37_;
#line 1324 "../src/Photo.vala"
			_tmp37_ = detected;
#line 1324 "../src/Photo.vala"
			_tmp34_ = _tmp37_->file_format != PHOTO_FILE_FORMAT_UNKNOWN;
#line 11224 "Photo.c"
		} else {
#line 1324 "../src/Photo.vala"
			_tmp34_ = FALSE;
#line 11228 "Photo.c"
		}
#line 1324 "../src/Photo.vala"
		if (_tmp34_) {
#line 11232 "Photo.c"
			PhotoRow* _tmp38_;
			BackingPhotoRow* _tmp39_;
			DetectedPhotoInformation* _tmp40_;
#line 1325 "../src/Photo.vala"
			_tmp38_ = params->row;
#line 1325 "../src/Photo.vala"
			_tmp39_ = _tmp38_->master;
#line 1325 "../src/Photo.vala"
			_tmp40_ = detected;
#line 1325 "../src/Photo.vala"
			_tmp39_->file_format = _tmp40_->file_format;
#line 11244 "Photo.c"
		}
#line 1321 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 11248 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp41_;
		gchar* _tmp42_;
		GError* _tmp43_;
		const gchar* _tmp44_;
#line 1321 "../src/Photo.vala"
		err = _inner_error0_;
#line 1321 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1327 "../src/Photo.vala"
		_tmp41_ = g_file_get_path (file);
#line 1327 "../src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 1327 "../src/Photo.vala"
		_tmp43_ = err;
#line 1327 "../src/Photo.vala"
		_tmp44_ = _tmp43_->message;
#line 1327 "../src/Photo.vala"
		g_debug ("Photo.vala:1327: Unable to interrogate photo file %s: %s", _tmp42_, _tmp44_);
#line 1327 "../src/Photo.vala"
		_g_free0 (_tmp42_);
#line 1321 "../src/Photo.vala"
		_g_error_free0 (err);
#line 11276 "Photo.c"
	}
	__finally0:
#line 1321 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1321 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1321 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1321 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1321 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1321 "../src/Photo.vala"
		return;
#line 11291 "Photo.c"
	}
#line 1296 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1296 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 11297 "Photo.c"
}

BackingPhotoRow*
photo_query_backing_photo_row (Photo* self,
                               GFile* file,
                               PhotoFileSnifferOptions options,
                               DetectedPhotoInformation** detected,
                               GError** error)
{
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* backing = NULL;
	BackingPhotoRow* _tmp0_;
	GFileInfo* info = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	DetectedPhotoInformation* _tmp11_;
	gboolean _tmp12_ = FALSE;
	DetectedPhotoInformation* _tmp13_;
	GTimeVal modification_time = {0};
	GFileInfo* _tmp17_;
	GTimeVal _tmp18_ = {0};
	BackingPhotoRow* _tmp19_;
	gchar* _tmp20_;
	BackingPhotoRow* _tmp21_;
	GTimeVal _tmp22_;
	BackingPhotoRow* _tmp23_;
	GFileInfo* _tmp24_;
	BackingPhotoRow* _tmp25_;
	DetectedPhotoInformation* _tmp26_;
	BackingPhotoRow* _tmp27_;
	DetectedPhotoInformation* _tmp28_;
	Dimensions _tmp29_;
	Orientation _tmp30_ = 0;
	DetectedPhotoInformation* _tmp31_;
	PhotoMetadata* _tmp32_;
	BackingPhotoRow* _tmp35_;
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result = NULL;
#line 1331 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1331 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1333 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1333 "../src/Photo.vala"
	_vala_detected = NULL;
#line 1335 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1335 "../src/Photo.vala"
	backing = _tmp0_;
#line 1337 "../src/Photo.vala"
	info = NULL;
#line 11352 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 1339 "../src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1339 "../src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 1339 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11363 "Photo.c"
			goto __catch0_g_error;
		}
#line 1339 "../src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 1339 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 1339 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1339 "../src/Photo.vala"
		info = _tmp3_;
#line 1338 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 11376 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 1338 "../src/Photo.vala"
		err = _inner_error0_;
#line 1338 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1342 "../src/Photo.vala"
		_tmp4_ = g_file_get_path (file);
#line 1342 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1342 "../src/Photo.vala"
		_tmp6_ = err;
#line 1342 "../src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 1342 "../src/Photo.vala"
		g_critical ("Photo.vala:1342: Unable to read file information for %s: %s", _tmp5_, _tmp7_);
#line 1342 "../src/Photo.vala"
		_g_free0 (_tmp5_);
#line 1344 "../src/Photo.vala"
		result = NULL;
#line 1344 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1344 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1344 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1344 "../src/Photo.vala"
		if (detected) {
#line 1344 "../src/Photo.vala"
			*detected = _vala_detected;
#line 11414 "Photo.c"
		} else {
#line 1344 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11418 "Photo.c"
		}
#line 1344 "../src/Photo.vala"
		return result;
#line 11422 "Photo.c"
	}
	__finally0:
#line 1338 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1338 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1338 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1338 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1338 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 1338 "../src/Photo.vala"
		return NULL;
#line 11437 "Photo.c"
	}
#line 1348 "../src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (file, options);
#line 1348 "../src/Photo.vala"
	interrogator = _tmp8_;
#line 1349 "../src/Photo.vala"
	_tmp9_ = interrogator;
#line 1349 "../src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp9_, &_inner_error0_);
#line 1349 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1349 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1349 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1349 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1349 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1349 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 1349 "../src/Photo.vala"
		return NULL;
#line 11461 "Photo.c"
	}
#line 1350 "../src/Photo.vala"
	_tmp10_ = interrogator;
#line 1350 "../src/Photo.vala"
	_tmp11_ = photo_file_interrogator_get_detected_photo_information (_tmp10_);
#line 1350 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1350 "../src/Photo.vala"
	_vala_detected = _tmp11_;
#line 1351 "../src/Photo.vala"
	_tmp13_ = _vala_detected;
#line 1351 "../src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 1351 "../src/Photo.vala"
		_tmp12_ = TRUE;
#line 11477 "Photo.c"
	} else {
		PhotoFileInterrogator* _tmp14_;
#line 1351 "../src/Photo.vala"
		_tmp14_ = interrogator;
#line 1351 "../src/Photo.vala"
		_tmp12_ = photo_file_interrogator_get_is_photo_corrupted (_tmp14_);
#line 11484 "Photo.c"
	}
#line 1351 "../src/Photo.vala"
	if (_tmp12_) {
#line 11488 "Photo.c"
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 1352 "../src/Photo.vala"
		_tmp15_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 1352 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 1352 "../src/Photo.vala"
		g_critical ("Photo.vala:1352: Photo update: %s no longer a recognized image", _tmp16_);
#line 1352 "../src/Photo.vala"
		_g_free0 (_tmp16_);
#line 1354 "../src/Photo.vala"
		result = NULL;
#line 1354 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1354 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1354 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1354 "../src/Photo.vala"
		if (detected) {
#line 1354 "../src/Photo.vala"
			*detected = _vala_detected;
#line 11511 "Photo.c"
		} else {
#line 1354 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11515 "Photo.c"
		}
#line 1354 "../src/Photo.vala"
		return result;
#line 11519 "Photo.c"
	}
#line 1357 "../src/Photo.vala"
	_tmp17_ = info;
#line 1357 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp17_, &_tmp18_);
#line 1357 "../src/Photo.vala"
	modification_time = _tmp18_;
#line 1359 "../src/Photo.vala"
	_tmp19_ = backing;
#line 1359 "../src/Photo.vala"
	_tmp20_ = g_file_get_path (file);
#line 1359 "../src/Photo.vala"
	_g_free0 (_tmp19_->filepath);
#line 1359 "../src/Photo.vala"
	_tmp19_->filepath = _tmp20_;
#line 1360 "../src/Photo.vala"
	_tmp21_ = backing;
#line 1360 "../src/Photo.vala"
	_tmp22_ = modification_time;
#line 1360 "../src/Photo.vala"
	_tmp21_->timestamp = (time_t) _tmp22_.tv_sec;
#line 1361 "../src/Photo.vala"
	_tmp23_ = backing;
#line 1361 "../src/Photo.vala"
	_tmp24_ = info;
#line 1361 "../src/Photo.vala"
	_tmp23_->filesize = g_file_info_get_size (_tmp24_);
#line 1362 "../src/Photo.vala"
	_tmp25_ = backing;
#line 1362 "../src/Photo.vala"
	_tmp26_ = _vala_detected;
#line 1362 "../src/Photo.vala"
	_tmp25_->file_format = _tmp26_->file_format;
#line 1363 "../src/Photo.vala"
	_tmp27_ = backing;
#line 1363 "../src/Photo.vala"
	_tmp28_ = _vala_detected;
#line 1363 "../src/Photo.vala"
	_tmp29_ = _tmp28_->image_dim;
#line 1363 "../src/Photo.vala"
	_tmp27_->dim = _tmp29_;
#line 1364 "../src/Photo.vala"
	_tmp31_ = _vala_detected;
#line 1364 "../src/Photo.vala"
	_tmp32_ = _tmp31_->metadata;
#line 1364 "../src/Photo.vala"
	if (_tmp32_ != NULL) {
#line 11567 "Photo.c"
		DetectedPhotoInformation* _tmp33_;
		PhotoMetadata* _tmp34_;
#line 1365 "../src/Photo.vala"
		_tmp33_ = _vala_detected;
#line 1365 "../src/Photo.vala"
		_tmp34_ = _tmp33_->metadata;
#line 1365 "../src/Photo.vala"
		_tmp30_ = photo_metadata_get_orientation (_tmp34_);
#line 11576 "Photo.c"
	} else {
#line 1365 "../src/Photo.vala"
		_tmp30_ = ORIENTATION_TOP_LEFT;
#line 11580 "Photo.c"
	}
#line 1364 "../src/Photo.vala"
	_tmp35_ = backing;
#line 1364 "../src/Photo.vala"
	_tmp35_->original_orientation = _tmp30_;
#line 1367 "../src/Photo.vala"
	result = backing;
#line 1367 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1367 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 1367 "../src/Photo.vala"
	if (detected) {
#line 1367 "../src/Photo.vala"
		*detected = _vala_detected;
#line 11596 "Photo.c"
	} else {
#line 1367 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 11600 "Photo.c"
	}
#line 1367 "../src/Photo.vala"
	return result;
#line 11604 "Photo.c"
}

static void
_vala_array_add87 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1463 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1463 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1463 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11619 "Photo.c"
	}
#line 1463 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1463 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11625 "Photo.c"
}

static void
_vala_array_add88 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1466 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1466 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1466 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11640 "Photo.c"
	}
#line 1466 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1466 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11646 "Photo.c"
}

static void
_vala_array_add89 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1475 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1475 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1475 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11661 "Photo.c"
	}
#line 1475 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1475 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11667 "Photo.c"
}

static void
_vala_array_add90 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1478 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1478 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1478 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11682 "Photo.c"
	}
#line 1478 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1478 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11688 "Photo.c"
}

static gboolean
_gps_coords_equal (const GpsCoords * s1,
                   const GpsCoords * s2)
{
#line 1481 "../src/Photo.vala"
	if (s1 == s2) {
#line 1481 "../src/Photo.vala"
		return TRUE;
#line 11699 "Photo.c"
	}
#line 1481 "../src/Photo.vala"
	if (s1 == NULL) {
#line 1481 "../src/Photo.vala"
		return FALSE;
#line 11705 "Photo.c"
	}
#line 1481 "../src/Photo.vala"
	if (s2 == NULL) {
#line 1481 "../src/Photo.vala"
		return FALSE;
#line 11711 "Photo.c"
	}
#line 1481 "../src/Photo.vala"
	if (s1->has_gps != s2->has_gps) {
#line 1481 "../src/Photo.vala"
		return FALSE;
#line 11717 "Photo.c"
	}
#line 1481 "../src/Photo.vala"
	if (s1->latitude != s2->latitude) {
#line 1481 "../src/Photo.vala"
		return FALSE;
#line 11723 "Photo.c"
	}
#line 1481 "../src/Photo.vala"
	if (s1->longitude != s2->longitude) {
#line 1481 "../src/Photo.vala"
		return FALSE;
#line 11729 "Photo.c"
	}
#line 1481 "../src/Photo.vala"
	return TRUE;
#line 11733 "Photo.c"
}

static void
_vala_array_add91 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1482 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1482 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1482 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11748 "Photo.c"
	}
#line 1482 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1482 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11754 "Photo.c"
}

static void
_vala_array_add92 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1486 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1486 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1486 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11769 "Photo.c"
	}
#line 1486 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1486 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11775 "Photo.c"
}

static void
_vala_array_add93 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1489 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1489 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1489 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11790 "Photo.c"
	}
#line 1489 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1489 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11796 "Photo.c"
}

static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 1499 "../src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 11804 "Photo.c"
}

gboolean
photo_prepare_for_reimport_master (Photo* self,
                                   PhotoReimportMasterState** reimport_state,
                                   GError** error)
{
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	GFile* file = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp4_;
	DetectedPhotoInformation* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_;
	BackingPhotoRow* _tmp8_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	DetectedPhotoInformation* _tmp14_;
	PhotoRow* updated_row = NULL;
	PhotoRow* _tmp20_;
	gchar** list = NULL;
	gchar** _tmp26_;
	gint list_length1;
	gint _list_size_;
	PhotoRow* _tmp27_;
	const gchar* _tmp28_;
	DetectedPhotoInformation* _tmp29_;
	const gchar* _tmp30_;
	PhotoRow* _tmp32_;
	BackingPhotoRow* _tmp33_;
	BackingPhotoRow* _tmp34_;
	GpsCoords gps_coords = {0};
	DetectedPhotoInformation* _tmp39_;
	PhotoMetadata* _tmp40_;
	PhotoRow* _tmp76_;
	BackingPhotoRow* _tmp77_;
	BackingPhotoRow* _tmp78_;
	PhotoRow* _tmp79_;
	DetectedPhotoInformation* _tmp80_;
	const gchar* _tmp81_;
	gchar* _tmp82_;
	PhotoRow* _tmp83_;
	DetectedPhotoInformation* _tmp84_;
	const gchar* _tmp85_;
	gchar* _tmp86_;
	PhotoRow* _tmp87_;
	DetectedPhotoInformation* _tmp88_;
	const gchar* _tmp89_;
	gchar* _tmp90_;
	PhotoMetadata* metadata = NULL;
	DetectedPhotoInformation* _tmp91_;
	PhotoMetadata* _tmp92_;
	PhotoRow* _tmp115_;
	PhotoMetadata* _tmp116_;
	gchar** _tmp117_;
	gint _tmp117__length1;
	PhotoReimportMasterStateImpl* _tmp118_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 1431 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1432 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1432 "../src/Photo.vala"
	_vala_reimport_state = NULL;
#line 1434 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1434 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1434 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1434 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1434 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1434 "../src/Photo.vala"
	file = _tmp3_;
#line 1437 "../src/Photo.vala"
	_tmp4_ = file;
#line 1437 "../src/Photo.vala"
	_tmp6_ = photo_query_backing_photo_row (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_inner_error0_);
#line 1437 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1437 "../src/Photo.vala"
	detected = _tmp5_;
#line 1437 "../src/Photo.vala"
	backing = _tmp6_;
#line 1437 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11898 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1437 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1437 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1437 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1437 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1437 "../src/Photo.vala"
		return _tmp7_;
#line 11910 "Photo.c"
	}
#line 1439 "../src/Photo.vala"
	_tmp8_ = backing;
#line 1439 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 11916 "Photo.c"
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1440 "../src/Photo.vala"
		_tmp9_ = file;
#line 1440 "../src/Photo.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 1440 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 1440 "../src/Photo.vala"
		g_warning ("Photo.vala:1440: Unable to retrieve photo state from %s for reimport", _tmp11_);
#line 1440 "../src/Photo.vala"
		_g_free0 (_tmp11_);
#line 1441 "../src/Photo.vala"
		result = FALSE;
#line 1441 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1441 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1441 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1441 "../src/Photo.vala"
		if (reimport_state) {
#line 1441 "../src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 11942 "Photo.c"
		} else {
#line 1441 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 11946 "Photo.c"
		}
#line 1441 "../src/Photo.vala"
		return result;
#line 11950 "Photo.c"
	}
#line 1445 "../src/Photo.vala"
	_tmp14_ = detected;
#line 1445 "../src/Photo.vala"
	if (_tmp14_->colorspace != GDK_COLORSPACE_RGB) {
#line 1445 "../src/Photo.vala"
		_tmp13_ = TRUE;
#line 11958 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp15_;
#line 1446 "../src/Photo.vala"
		_tmp15_ = detected;
#line 1446 "../src/Photo.vala"
		_tmp13_ = _tmp15_->channels < 3;
#line 11965 "Photo.c"
	}
#line 1445 "../src/Photo.vala"
	if (_tmp13_) {
#line 1445 "../src/Photo.vala"
		_tmp12_ = TRUE;
#line 11971 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp16_;
#line 1447 "../src/Photo.vala"
		_tmp16_ = detected;
#line 1447 "../src/Photo.vala"
		_tmp12_ = _tmp16_->bits_per_channel != 8;
#line 11978 "Photo.c"
	}
#line 1445 "../src/Photo.vala"
	if (_tmp12_) {
#line 11982 "Photo.c"
		GFile* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 1448 "../src/Photo.vala"
		_tmp17_ = file;
#line 1448 "../src/Photo.vala"
		_tmp18_ = g_file_get_path (_tmp17_);
#line 1448 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 1448 "../src/Photo.vala"
		g_warning ("Photo.vala:1448: Not re-importing %s: Unsupported color format", _tmp19_);
#line 1448 "../src/Photo.vala"
		_g_free0 (_tmp19_);
#line 1450 "../src/Photo.vala"
		result = FALSE;
#line 1450 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1450 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1450 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1450 "../src/Photo.vala"
		if (reimport_state) {
#line 1450 "../src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 12008 "Photo.c"
		} else {
#line 1450 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 12012 "Photo.c"
		}
#line 1450 "../src/Photo.vala"
		return result;
#line 12016 "Photo.c"
	}
#line 1454 "../src/Photo.vala"
	_tmp20_ = photo_row_new ();
#line 1454 "../src/Photo.vala"
	updated_row = _tmp20_;
#line 12022 "Photo.c"
	{
		PhotoRow* _tmp21_;
#line 1455 "../src/Photo.vala"
		_tmp21_ = self->row;
#line 1455 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12029 "Photo.c"
		{
			PhotoRow* _tmp22_;
			PhotoRow* _tmp23_;
#line 1456 "../src/Photo.vala"
			_tmp22_ = self->row;
#line 1456 "../src/Photo.vala"
			_tmp23_ = _photo_row_ref0 (_tmp22_);
#line 1456 "../src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1456 "../src/Photo.vala"
			updated_row = _tmp23_;
#line 12041 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp24_;
#line 1455 "../src/Photo.vala"
			_tmp24_ = self->row;
#line 1455 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12050 "Photo.c"
		}
#line 1455 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12054 "Photo.c"
			gboolean _tmp25_ = FALSE;
#line 1455 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1455 "../src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1455 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1455 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1455 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1455 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1455 "../src/Photo.vala"
			return _tmp25_;
#line 12070 "Photo.c"
		}
	}
#line 1460 "../src/Photo.vala"
	_tmp26_ = g_new0 (gchar*, 0 + 1);
#line 1460 "../src/Photo.vala"
	list = _tmp26_;
#line 1460 "../src/Photo.vala"
	list_length1 = 0;
#line 1460 "../src/Photo.vala"
	_list_size_ = list_length1;
#line 1462 "../src/Photo.vala"
	_tmp27_ = updated_row;
#line 1462 "../src/Photo.vala"
	_tmp28_ = _tmp27_->md5;
#line 1462 "../src/Photo.vala"
	_tmp29_ = detected;
#line 1462 "../src/Photo.vala"
	_tmp30_ = _tmp29_->md5;
#line 1462 "../src/Photo.vala"
	if (g_strcmp0 (_tmp28_, _tmp30_) != 0) {
#line 12091 "Photo.c"
		gchar* _tmp31_;
#line 1463 "../src/Photo.vala"
		_tmp31_ = g_strdup ("metadata:md5");
#line 1463 "../src/Photo.vala"
		_vala_array_add87 (&list, &list_length1, &_list_size_, _tmp31_);
#line 12097 "Photo.c"
	}
#line 1465 "../src/Photo.vala"
	_tmp32_ = updated_row;
#line 1465 "../src/Photo.vala"
	_tmp33_ = _tmp32_->master;
#line 1465 "../src/Photo.vala"
	_tmp34_ = backing;
#line 1465 "../src/Photo.vala"
	if (_tmp33_->original_orientation != _tmp34_->original_orientation) {
#line 12107 "Photo.c"
		gchar* _tmp35_;
		PhotoRow* _tmp36_;
		BackingPhotoRow* _tmp37_;
		BackingPhotoRow* _tmp38_;
#line 1466 "../src/Photo.vala"
		_tmp35_ = g_strdup ("image:orientation");
#line 1466 "../src/Photo.vala"
		_vala_array_add88 (&list, &list_length1, &_list_size_, _tmp35_);
#line 1467 "../src/Photo.vala"
		_tmp36_ = updated_row;
#line 1467 "../src/Photo.vala"
		_tmp37_ = _tmp36_->master;
#line 1467 "../src/Photo.vala"
		_tmp38_ = backing;
#line 1467 "../src/Photo.vala"
		_tmp37_->original_orientation = _tmp38_->original_orientation;
#line 12124 "Photo.c"
	}
#line 1470 "../src/Photo.vala"
	memset (&gps_coords, 0, sizeof (GpsCoords));
#line 1472 "../src/Photo.vala"
	_tmp39_ = detected;
#line 1472 "../src/Photo.vala"
	_tmp40_ = _tmp39_->metadata;
#line 1472 "../src/Photo.vala"
	if (_tmp40_ != NULL) {
#line 12134 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp41_;
		PhotoMetadata* _tmp42_;
		MetadataDateTime* _tmp43_;
		gboolean _tmp44_ = FALSE;
		MetadataDateTime* _tmp45_;
		PhotoRow* _tmp49_;
		const gchar* _tmp50_;
		DetectedPhotoInformation* _tmp51_;
		PhotoMetadata* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gboolean _tmp55_;
		DetectedPhotoInformation* _tmp57_;
		PhotoMetadata* _tmp58_;
		GpsCoords _tmp59_ = {0};
		PhotoRow* _tmp60_;
		GpsCoords _tmp61_;
		GpsCoords _tmp62_;
		PhotoRow* _tmp64_;
		const gchar* _tmp65_;
		DetectedPhotoInformation* _tmp66_;
		PhotoMetadata* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
		gboolean _tmp70_;
		PhotoRow* _tmp72_;
		DetectedPhotoInformation* _tmp73_;
		PhotoMetadata* _tmp74_;
#line 1473 "../src/Photo.vala"
		_tmp41_ = detected;
#line 1473 "../src/Photo.vala"
		_tmp42_ = _tmp41_->metadata;
#line 1473 "../src/Photo.vala"
		_tmp43_ = photo_metadata_get_exposure_date_time (_tmp42_);
#line 1473 "../src/Photo.vala"
		date_time = _tmp43_;
#line 1474 "../src/Photo.vala"
		_tmp45_ = date_time;
#line 1474 "../src/Photo.vala"
		if (_tmp45_ != NULL) {
#line 12176 "Photo.c"
			PhotoRow* _tmp46_;
			MetadataDateTime* _tmp47_;
#line 1474 "../src/Photo.vala"
			_tmp46_ = updated_row;
#line 1474 "../src/Photo.vala"
			_tmp47_ = date_time;
#line 1474 "../src/Photo.vala"
			_tmp44_ = _tmp46_->exposure_time != metadata_date_time_get_timestamp (_tmp47_);
#line 12185 "Photo.c"
		} else {
#line 1474 "../src/Photo.vala"
			_tmp44_ = FALSE;
#line 12189 "Photo.c"
		}
#line 1474 "../src/Photo.vala"
		if (_tmp44_) {
#line 12193 "Photo.c"
			gchar* _tmp48_;
#line 1475 "../src/Photo.vala"
			_tmp48_ = g_strdup ("metadata:exposure-time");
#line 1475 "../src/Photo.vala"
			_vala_array_add89 (&list, &list_length1, &_list_size_, _tmp48_);
#line 12199 "Photo.c"
		}
#line 1477 "../src/Photo.vala"
		_tmp49_ = updated_row;
#line 1477 "../src/Photo.vala"
		_tmp50_ = _tmp49_->title;
#line 1477 "../src/Photo.vala"
		_tmp51_ = detected;
#line 1477 "../src/Photo.vala"
		_tmp52_ = _tmp51_->metadata;
#line 1477 "../src/Photo.vala"
		_tmp53_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1477 "../src/Photo.vala"
		_tmp54_ = _tmp53_;
#line 1477 "../src/Photo.vala"
		_tmp55_ = g_strcmp0 (_tmp50_, _tmp54_) != 0;
#line 1477 "../src/Photo.vala"
		_g_free0 (_tmp54_);
#line 1477 "../src/Photo.vala"
		if (_tmp55_) {
#line 12219 "Photo.c"
			gchar* _tmp56_;
#line 1478 "../src/Photo.vala"
			_tmp56_ = g_strdup ("metadata:name");
#line 1478 "../src/Photo.vala"
			_vala_array_add90 (&list, &list_length1, &_list_size_, _tmp56_);
#line 12225 "Photo.c"
		}
#line 1480 "../src/Photo.vala"
		_tmp57_ = detected;
#line 1480 "../src/Photo.vala"
		_tmp58_ = _tmp57_->metadata;
#line 1480 "../src/Photo.vala"
		photo_metadata_get_gps_coords (_tmp58_, &_tmp59_);
#line 1480 "../src/Photo.vala"
		gps_coords = _tmp59_;
#line 1481 "../src/Photo.vala"
		_tmp60_ = updated_row;
#line 1481 "../src/Photo.vala"
		_tmp61_ = _tmp60_->gps_coords;
#line 1481 "../src/Photo.vala"
		_tmp62_ = gps_coords;
#line 1481 "../src/Photo.vala"
		if (_gps_coords_equal (&_tmp61_, &_tmp62_) != TRUE) {
#line 12243 "Photo.c"
			gchar* _tmp63_;
#line 1482 "../src/Photo.vala"
			_tmp63_ = g_strdup ("metadata:gps");
#line 1482 "../src/Photo.vala"
			_vala_array_add91 (&list, &list_length1, &_list_size_, _tmp63_);
#line 12249 "Photo.c"
		}
#line 1485 "../src/Photo.vala"
		_tmp64_ = updated_row;
#line 1485 "../src/Photo.vala"
		_tmp65_ = _tmp64_->comment;
#line 1485 "../src/Photo.vala"
		_tmp66_ = detected;
#line 1485 "../src/Photo.vala"
		_tmp67_ = _tmp66_->metadata;
#line 1485 "../src/Photo.vala"
		_tmp68_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1485 "../src/Photo.vala"
		_tmp69_ = _tmp68_;
#line 1485 "../src/Photo.vala"
		_tmp70_ = g_strcmp0 (_tmp65_, _tmp69_) != 0;
#line 1485 "../src/Photo.vala"
		_g_free0 (_tmp69_);
#line 1485 "../src/Photo.vala"
		if (_tmp70_) {
#line 12269 "Photo.c"
			gchar* _tmp71_;
#line 1486 "../src/Photo.vala"
			_tmp71_ = g_strdup ("metadata:comment");
#line 1486 "../src/Photo.vala"
			_vala_array_add92 (&list, &list_length1, &_list_size_, _tmp71_);
#line 12275 "Photo.c"
		}
#line 1488 "../src/Photo.vala"
		_tmp72_ = updated_row;
#line 1488 "../src/Photo.vala"
		_tmp73_ = detected;
#line 1488 "../src/Photo.vala"
		_tmp74_ = _tmp73_->metadata;
#line 1488 "../src/Photo.vala"
		if (_tmp72_->rating != photo_metadata_get_rating (_tmp74_)) {
#line 12285 "Photo.c"
			gchar* _tmp75_;
#line 1489 "../src/Photo.vala"
			_tmp75_ = g_strdup ("metadata:rating");
#line 1489 "../src/Photo.vala"
			_vala_array_add93 (&list, &list_length1, &_list_size_, _tmp75_);
#line 12291 "Photo.c"
		}
#line 1472 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 12295 "Photo.c"
	}
#line 1492 "../src/Photo.vala"
	_tmp76_ = updated_row;
#line 1492 "../src/Photo.vala"
	_tmp77_ = backing;
#line 1492 "../src/Photo.vala"
	_tmp78_ = _backing_photo_row_ref0 (_tmp77_);
#line 1492 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp76_->master);
#line 1492 "../src/Photo.vala"
	_tmp76_->master = _tmp78_;
#line 1493 "../src/Photo.vala"
	_tmp79_ = updated_row;
#line 1493 "../src/Photo.vala"
	_tmp80_ = detected;
#line 1493 "../src/Photo.vala"
	_tmp81_ = _tmp80_->md5;
#line 1493 "../src/Photo.vala"
	_tmp82_ = g_strdup (_tmp81_);
#line 1493 "../src/Photo.vala"
	_g_free0 (_tmp79_->md5);
#line 1493 "../src/Photo.vala"
	_tmp79_->md5 = _tmp82_;
#line 1494 "../src/Photo.vala"
	_tmp83_ = updated_row;
#line 1494 "../src/Photo.vala"
	_tmp84_ = detected;
#line 1494 "../src/Photo.vala"
	_tmp85_ = _tmp84_->exif_md5;
#line 1494 "../src/Photo.vala"
	_tmp86_ = g_strdup (_tmp85_);
#line 1494 "../src/Photo.vala"
	_g_free0 (_tmp83_->exif_md5);
#line 1494 "../src/Photo.vala"
	_tmp83_->exif_md5 = _tmp86_;
#line 1495 "../src/Photo.vala"
	_tmp87_ = updated_row;
#line 1495 "../src/Photo.vala"
	_tmp88_ = detected;
#line 1495 "../src/Photo.vala"
	_tmp89_ = _tmp88_->thumbnail_md5;
#line 1495 "../src/Photo.vala"
	_tmp90_ = g_strdup (_tmp89_);
#line 1495 "../src/Photo.vala"
	_g_free0 (_tmp87_->thumbnail_md5);
#line 1495 "../src/Photo.vala"
	_tmp87_->thumbnail_md5 = _tmp90_;
#line 1497 "../src/Photo.vala"
	metadata = NULL;
#line 1498 "../src/Photo.vala"
	_tmp91_ = detected;
#line 1498 "../src/Photo.vala"
	_tmp92_ = _tmp91_->metadata;
#line 1498 "../src/Photo.vala"
	if (_tmp92_ != NULL) {
#line 12351 "Photo.c"
		DetectedPhotoInformation* _tmp93_;
		PhotoMetadata* _tmp94_;
		PhotoMetadata* _tmp95_;
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp96_;
		PhotoMetadata* _tmp97_;
		MetadataDateTime* _tmp98_;
		MetadataDateTime* _tmp99_;
		PhotoRow* _tmp102_;
		GpsCoords _tmp103_;
		PhotoRow* _tmp104_;
		DetectedPhotoInformation* _tmp105_;
		PhotoMetadata* _tmp106_;
		gchar* _tmp107_;
		PhotoRow* _tmp108_;
		DetectedPhotoInformation* _tmp109_;
		PhotoMetadata* _tmp110_;
		gchar* _tmp111_;
		PhotoRow* _tmp112_;
		DetectedPhotoInformation* _tmp113_;
		PhotoMetadata* _tmp114_;
#line 1499 "../src/Photo.vala"
		_tmp93_ = detected;
#line 1499 "../src/Photo.vala"
		_tmp94_ = _tmp93_->metadata;
#line 1499 "../src/Photo.vala"
		_tmp95_ = _media_metadata_ref0 (_tmp94_);
#line 1499 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1499 "../src/Photo.vala"
		metadata = _tmp95_;
#line 1501 "../src/Photo.vala"
		_tmp96_ = detected;
#line 1501 "../src/Photo.vala"
		_tmp97_ = _tmp96_->metadata;
#line 1501 "../src/Photo.vala"
		_tmp98_ = photo_metadata_get_exposure_date_time (_tmp97_);
#line 1501 "../src/Photo.vala"
		date_time = _tmp98_;
#line 1502 "../src/Photo.vala"
		_tmp99_ = date_time;
#line 1502 "../src/Photo.vala"
		if (_tmp99_ != NULL) {
#line 12395 "Photo.c"
			PhotoRow* _tmp100_;
			MetadataDateTime* _tmp101_;
#line 1503 "../src/Photo.vala"
			_tmp100_ = updated_row;
#line 1503 "../src/Photo.vala"
			_tmp101_ = date_time;
#line 1503 "../src/Photo.vala"
			_tmp100_->exposure_time = metadata_date_time_get_timestamp (_tmp101_);
#line 12404 "Photo.c"
		}
#line 1505 "../src/Photo.vala"
		_tmp102_ = updated_row;
#line 1505 "../src/Photo.vala"
		_tmp103_ = gps_coords;
#line 1505 "../src/Photo.vala"
		_tmp102_->gps_coords = _tmp103_;
#line 1506 "../src/Photo.vala"
		_tmp104_ = updated_row;
#line 1506 "../src/Photo.vala"
		_tmp105_ = detected;
#line 1506 "../src/Photo.vala"
		_tmp106_ = _tmp105_->metadata;
#line 1506 "../src/Photo.vala"
		_tmp107_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp106_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1506 "../src/Photo.vala"
		_g_free0 (_tmp104_->title);
#line 1506 "../src/Photo.vala"
		_tmp104_->title = _tmp107_;
#line 1507 "../src/Photo.vala"
		_tmp108_ = updated_row;
#line 1507 "../src/Photo.vala"
		_tmp109_ = detected;
#line 1507 "../src/Photo.vala"
		_tmp110_ = _tmp109_->metadata;
#line 1507 "../src/Photo.vala"
		_tmp111_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp110_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1507 "../src/Photo.vala"
		_g_free0 (_tmp108_->comment);
#line 1507 "../src/Photo.vala"
		_tmp108_->comment = _tmp111_;
#line 1508 "../src/Photo.vala"
		_tmp112_ = updated_row;
#line 1508 "../src/Photo.vala"
		_tmp113_ = detected;
#line 1508 "../src/Photo.vala"
		_tmp114_ = _tmp113_->metadata;
#line 1508 "../src/Photo.vala"
		_tmp112_->rating = photo_metadata_get_rating (_tmp114_);
#line 1498 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 12446 "Photo.c"
	}
#line 1511 "../src/Photo.vala"
	_tmp115_ = updated_row;
#line 1511 "../src/Photo.vala"
	_tmp116_ = metadata;
#line 1511 "../src/Photo.vala"
	_tmp117_ = list;
#line 1511 "../src/Photo.vala"
	_tmp117__length1 = list_length1;
#line 1511 "../src/Photo.vala"
	_tmp118_ = photo_reimport_master_state_impl_new (_tmp115_, _tmp116_, _tmp117_, _tmp117__length1);
#line 1511 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1511 "../src/Photo.vala"
	_vala_reimport_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp118_, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1513 "../src/Photo.vala"
	result = TRUE;
#line 1513 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1513 "../src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 1513 "../src/Photo.vala"
	_photo_row_unref0 (updated_row);
#line 1513 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1513 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1513 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1513 "../src/Photo.vala"
	if (reimport_state) {
#line 1513 "../src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 12480 "Photo.c"
	} else {
#line 1513 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 12484 "Photo.c"
	}
#line 1513 "../src/Photo.vala"
	return result;
#line 12488 "Photo.c"
}

static void
photo_real_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata)
{
#line 1516 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1516 "../src/Photo.vala"
	return;
#line 12499 "Photo.c"
}

void
photo_apply_user_metadata_for_reimport (Photo* self,
                                        PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 1516 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1516 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 1516 "../src/Photo.vala"
	if (_klass_->apply_user_metadata_for_reimport) {
#line 1516 "../src/Photo.vala"
		_klass_->apply_user_metadata_for_reimport (self, metadata);
#line 12515 "Photo.c"
	}
}

static gpointer
_photo_reimport_master_state_ref0 (gpointer self)
{
#line 1520 "../src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 12524 "Photo.c"
}

static void
_vala_array_add94 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1538 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1538 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1538 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12539 "Photo.c"
	}
#line 1538 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1538 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 12545 "Photo.c"
}

static void
_vala_array_add95 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1540 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1540 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1540 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12560 "Photo.c"
	}
#line 1540 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1540 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 12566 "Photo.c"
}

void
photo_finish_reimport_master (Photo* self,
                              PhotoReimportMasterState* state,
                              GError** error)
{
	PhotoReimportMasterStateImpl* reimport_state = NULL;
	PhotoReimportMasterStateImpl* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	PhotoRow* _tmp3_;
	PhotoMetadata* _tmp18_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	PhotoMetadata* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 1519 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1519 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 1520 "../src/Photo.vala"
	_tmp0_ = _photo_reimport_master_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl));
#line 1520 "../src/Photo.vala"
	reimport_state = _tmp0_;
#line 1522 "../src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 1522 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1522 "../src/Photo.vala"
	_tmp3_ = reimport_state->row;
#line 1522 "../src/Photo.vala"
	photo_table_reimport (_tmp2_, _tmp3_, &_inner_error0_);
#line 1522 "../src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 1522 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1522 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1522 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1522 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1522 "../src/Photo.vala"
			return;
#line 12612 "Photo.c"
		} else {
#line 1522 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1522 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1522 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1522 "../src/Photo.vala"
			return;
#line 12622 "Photo.c"
		}
	}
	{
		PhotoRow* _tmp4_;
#line 1524 "../src/Photo.vala"
		_tmp4_ = self->row;
#line 1524 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12631 "Photo.c"
		{
			BackingPhotoRow* original_master = NULL;
			PhotoRow* _tmp5_;
			BackingPhotoRow* _tmp6_;
			BackingPhotoRow* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			BackingPhotoRow* _tmp11_;
			BackingPhotoRow* _tmp12_;
			PhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			PhotoRow* _tmp15_;
			BackingPhotoRow* _tmp16_;
#line 1526 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 1526 "../src/Photo.vala"
			_tmp6_ = _tmp5_->master;
#line 1526 "../src/Photo.vala"
			_tmp7_ = _backing_photo_row_ref0 (_tmp6_);
#line 1526 "../src/Photo.vala"
			original_master = _tmp7_;
#line 1527 "../src/Photo.vala"
			_tmp8_ = reimport_state->row;
#line 1527 "../src/Photo.vala"
			_tmp9_ = _photo_row_ref0 (_tmp8_);
#line 1527 "../src/Photo.vala"
			_photo_row_unref0 (self->row);
#line 1527 "../src/Photo.vala"
			self->row = _tmp9_;
#line 1528 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 1528 "../src/Photo.vala"
			_tmp11_ = original_master;
#line 1528 "../src/Photo.vala"
			_tmp12_ = _backing_photo_row_ref0 (_tmp11_);
#line 1528 "../src/Photo.vala"
			_backing_photo_row_unref0 (_tmp10_->master);
#line 1528 "../src/Photo.vala"
			_tmp10_->master = _tmp12_;
#line 1529 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 1529 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 1529 "../src/Photo.vala"
			_tmp15_ = reimport_state->row;
#line 1529 "../src/Photo.vala"
			_tmp16_ = _tmp15_->master;
#line 1529 "../src/Photo.vala"
			backing_photo_row_copy_from (_tmp14_, _tmp16_);
#line 1530 "../src/Photo.vala"
			if (!reimport_state->metadata_only) {
#line 1531 "../src/Photo.vala"
				photo_remove_all_transformations (self, FALSE);
#line 12686 "Photo.c"
			}
#line 1524 "../src/Photo.vala"
			_backing_photo_row_unref0 (original_master);
#line 12690 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp17_;
#line 1524 "../src/Photo.vala"
			_tmp17_ = self->row;
#line 1524 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12699 "Photo.c"
		}
#line 1524 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1524 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1524 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1524 "../src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1524 "../src/Photo.vala"
				return;
#line 12711 "Photo.c"
			} else {
#line 1524 "../src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1524 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1524 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1524 "../src/Photo.vala"
				return;
#line 12721 "Photo.c"
			}
		}
	}
#line 1534 "../src/Photo.vala"
	_tmp18_ = reimport_state->metadata;
#line 1534 "../src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 12729 "Photo.c"
		PhotoMetadata* _tmp19_;
#line 1535 "../src/Photo.vala"
		_tmp19_ = reimport_state->metadata;
#line 1535 "../src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp19_);
#line 12735 "Photo.c"
	}
#line 1537 "../src/Photo.vala"
	if (!reimport_state->metadata_only) {
#line 12739 "Photo.c"
		gchar* _tmp20_;
#line 1538 "../src/Photo.vala"
		_tmp20_ = g_strdup ("image:master");
#line 1538 "../src/Photo.vala"
		_vala_array_add94 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp20_);
#line 1539 "../src/Photo.vala"
		if (photo_is_master_baseline (self)) {
#line 12747 "Photo.c"
			gchar* _tmp21_;
#line 1540 "../src/Photo.vala"
			_tmp21_ = g_strdup ("image:baseline");
#line 1540 "../src/Photo.vala"
			_vala_array_add95 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp21_);
#line 12753 "Photo.c"
		}
	}
#line 1543 "../src/Photo.vala"
	_tmp22_ = reimport_state->alterations;
#line 1543 "../src/Photo.vala"
	_tmp22__length1 = reimport_state->alterations_length1;
#line 1543 "../src/Photo.vala"
	if (_tmp22__length1 > 0) {
#line 12762 "Photo.c"
		gchar** _tmp23_;
		gint _tmp23__length1;
		Alteration* _tmp24_;
		Alteration* _tmp25_;
#line 1544 "../src/Photo.vala"
		_tmp23_ = reimport_state->alterations;
#line 1544 "../src/Photo.vala"
		_tmp23__length1 = reimport_state->alterations_length1;
#line 1544 "../src/Photo.vala"
		_tmp24_ = alteration_new_from_array (_tmp23_, _tmp23__length1);
#line 1544 "../src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 1544 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp25_);
#line 1544 "../src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 12779 "Photo.c"
	}
#line 1546 "../src/Photo.vala"
	_tmp26_ = reimport_state->metadata;
#line 1546 "../src/Photo.vala"
	photo_notify_master_reimported (self, _tmp26_);
#line 1548 "../src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 12787 "Photo.c"
		PhotoMetadata* _tmp27_;
#line 1549 "../src/Photo.vala"
		_tmp27_ = reimport_state->metadata;
#line 1549 "../src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp27_);
#line 12793 "Photo.c"
	}
#line 1551 "../src/Photo.vala"
	if (photo_is_master_source (self)) {
#line 12797 "Photo.c"
		PhotoMetadata* _tmp28_;
#line 1552 "../src/Photo.vala"
		_tmp28_ = reimport_state->metadata;
#line 1552 "../src/Photo.vala"
		photo_notify_source_reimported (self, _tmp28_);
#line 12803 "Photo.c"
	}
#line 1519 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 12807 "Photo.c"
}

static gboolean
photo_verify_file_for_reimport (Photo* self,
                                GFile* file,
                                BackingPhotoRow** backing,
                                DetectedPhotoInformation** detected,
                                GError** error)
{
	BackingPhotoRow* _vala_backing = NULL;
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* _tmp0_ = NULL;
	DetectedPhotoInformation* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_;
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	DetectedPhotoInformation* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 1556 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1556 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1558 "../src/Photo.vala"
	_tmp2_ = photo_query_backing_photo_row (self, file, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp1_, &_inner_error0_);
#line 1558 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1558 "../src/Photo.vala"
	_vala_detected = _tmp1_;
#line 1558 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1558 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12843 "Photo.c"
		gboolean _tmp3_ = FALSE;
#line 1558 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1558 "../src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 1558 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 1558 "../src/Photo.vala"
		return _tmp3_;
#line 12853 "Photo.c"
	}
#line 1558 "../src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 1558 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 1558 "../src/Photo.vala"
	_backing_photo_row_unref0 (_vala_backing);
#line 1558 "../src/Photo.vala"
	_vala_backing = _tmp4_;
#line 1560 "../src/Photo.vala"
	_tmp5_ = _vala_backing;
#line 1560 "../src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 1561 "../src/Photo.vala"
		result = FALSE;
#line 1561 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1561 "../src/Photo.vala"
		if (backing) {
#line 1561 "../src/Photo.vala"
			*backing = _vala_backing;
#line 12875 "Photo.c"
		} else {
#line 1561 "../src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 12879 "Photo.c"
		}
#line 1561 "../src/Photo.vala"
		if (detected) {
#line 1561 "../src/Photo.vala"
			*detected = _vala_detected;
#line 12885 "Photo.c"
		} else {
#line 1561 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 12889 "Photo.c"
		}
#line 1561 "../src/Photo.vala"
		return result;
#line 12893 "Photo.c"
	}
#line 1565 "../src/Photo.vala"
	_tmp8_ = _vala_detected;
#line 1565 "../src/Photo.vala"
	if (_tmp8_->colorspace != GDK_COLORSPACE_RGB) {
#line 1565 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 12901 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp9_;
#line 1566 "../src/Photo.vala"
		_tmp9_ = _vala_detected;
#line 1566 "../src/Photo.vala"
		_tmp7_ = _tmp9_->channels < 3;
#line 12908 "Photo.c"
	}
#line 1565 "../src/Photo.vala"
	if (_tmp7_) {
#line 1565 "../src/Photo.vala"
		_tmp6_ = TRUE;
#line 12914 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp10_;
#line 1567 "../src/Photo.vala"
		_tmp10_ = _vala_detected;
#line 1567 "../src/Photo.vala"
		_tmp6_ = _tmp10_->bits_per_channel != 8;
#line 12921 "Photo.c"
	}
#line 1565 "../src/Photo.vala"
	if (_tmp6_) {
#line 12925 "Photo.c"
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 1568 "../src/Photo.vala"
		_tmp11_ = g_file_get_path (file);
#line 1568 "../src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 1568 "../src/Photo.vala"
		g_warning ("Photo.vala:1568: Not re-importing %s: Unsupported color format", _tmp12_);
#line 1568 "../src/Photo.vala"
		_g_free0 (_tmp12_);
#line 1570 "../src/Photo.vala"
		result = FALSE;
#line 1570 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1570 "../src/Photo.vala"
		if (backing) {
#line 1570 "../src/Photo.vala"
			*backing = _vala_backing;
#line 12944 "Photo.c"
		} else {
#line 1570 "../src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 12948 "Photo.c"
		}
#line 1570 "../src/Photo.vala"
		if (detected) {
#line 1570 "../src/Photo.vala"
			*detected = _vala_detected;
#line 12954 "Photo.c"
		} else {
#line 1570 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 12958 "Photo.c"
		}
#line 1570 "../src/Photo.vala"
		return result;
#line 12962 "Photo.c"
	}
#line 1573 "../src/Photo.vala"
	result = TRUE;
#line 1573 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp0_);
#line 1573 "../src/Photo.vala"
	if (backing) {
#line 1573 "../src/Photo.vala"
		*backing = _vala_backing;
#line 12972 "Photo.c"
	} else {
#line 1573 "../src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 12976 "Photo.c"
	}
#line 1573 "../src/Photo.vala"
	if (detected) {
#line 1573 "../src/Photo.vala"
		*detected = _vala_detected;
#line 12982 "Photo.c"
	} else {
#line 1573 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 12986 "Photo.c"
	}
#line 1573 "../src/Photo.vala"
	return result;
#line 12990 "Photo.c"
}

gboolean
photo_prepare_for_reimport_editable (Photo* self,
                                     PhotoReimportEditableState** state,
                                     GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	BackingPhotoRow* _tmp4_ = NULL;
	DetectedPhotoInformation* _tmp5_ = NULL;
	gboolean _tmp6_;
	BackingPhotoRow* _tmp8_;
	DetectedPhotoInformation* _tmp9_;
	PhotoMetadata* _tmp10_;
	PhotoReimportEditableStateImpl* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 1577 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1578 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1578 "../src/Photo.vala"
	_vala_state = NULL;
#line 1580 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 1580 "../src/Photo.vala"
	file = _tmp0_;
#line 1581 "../src/Photo.vala"
	_tmp1_ = file;
#line 1581 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1582 "../src/Photo.vala"
		result = FALSE;
#line 1582 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1582 "../src/Photo.vala"
		if (state) {
#line 1582 "../src/Photo.vala"
			*state = _vala_state;
#line 13037 "Photo.c"
		} else {
#line 1582 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 13041 "Photo.c"
		}
#line 1582 "../src/Photo.vala"
		return result;
#line 13045 "Photo.c"
	}
#line 1586 "../src/Photo.vala"
	_tmp3_ = file;
#line 1586 "../src/Photo.vala"
	_tmp6_ = photo_verify_file_for_reimport (self, _tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 1586 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1586 "../src/Photo.vala"
	backing = _tmp4_;
#line 1586 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1586 "../src/Photo.vala"
	detected = _tmp5_;
#line 1586 "../src/Photo.vala"
	_tmp2_ = _tmp6_;
#line 1586 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13063 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1586 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1586 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1586 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1586 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1586 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 1586 "../src/Photo.vala"
		return _tmp7_;
#line 13077 "Photo.c"
	}
#line 1586 "../src/Photo.vala"
	if (!_tmp2_) {
#line 1587 "../src/Photo.vala"
		result = FALSE;
#line 1587 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1587 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1587 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1587 "../src/Photo.vala"
		if (state) {
#line 1587 "../src/Photo.vala"
			*state = _vala_state;
#line 13093 "Photo.c"
		} else {
#line 1587 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 13097 "Photo.c"
		}
#line 1587 "../src/Photo.vala"
		return result;
#line 13101 "Photo.c"
	}
#line 1589 "../src/Photo.vala"
	_tmp8_ = backing;
#line 1589 "../src/Photo.vala"
	_tmp9_ = detected;
#line 1589 "../src/Photo.vala"
	_tmp10_ = _tmp9_->metadata;
#line 1589 "../src/Photo.vala"
	_tmp11_ = photo_reimport_editable_state_impl_new (_tmp8_, _tmp10_);
#line 1589 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1589 "../src/Photo.vala"
	_vala_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1591 "../src/Photo.vala"
	result = TRUE;
#line 1591 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1591 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1591 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1591 "../src/Photo.vala"
	if (state) {
#line 1591 "../src/Photo.vala"
		*state = _vala_state;
#line 13127 "Photo.c"
	} else {
#line 1591 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 13131 "Photo.c"
	}
#line 1591 "../src/Photo.vala"
	return result;
#line 13135 "Photo.c"
}

static gpointer
_photo_reimport_editable_state_ref0 (gpointer self)
{
#line 1600 "../src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 13143 "Photo.c"
}

void
photo_finish_reimport_editable (Photo* self,
                                PhotoReimportEditableState* state,
                                GError** error)
{
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp0_ = {0};
	PhotoReimportEditableStateImpl* reimport_state = NULL;
	PhotoReimportEditableStateImpl* _tmp1_;
	PhotoReimportEditableStateImpl* _tmp2_;
	PhotoReimportEditableStateImpl* _tmp16_;
	PhotoMetadata* _tmp17_;
	gchar* list = NULL;
	gchar* _tmp33_;
	PhotoReimportEditableStateImpl* _tmp34_;
	const gchar* _tmp37_;
	Alteration* _tmp38_;
	Alteration* _tmp39_;
	PhotoReimportEditableStateImpl* _tmp40_;
	PhotoMetadata* _tmp41_;
	GError* _inner_error0_ = NULL;
#line 1595 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1595 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 1596 "../src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 1596 "../src/Photo.vala"
	editable_id = _tmp0_;
#line 1597 "../src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 1598 "../src/Photo.vala"
		return;
#line 13179 "Photo.c"
	}
#line 1600 "../src/Photo.vala"
	_tmp1_ = _photo_reimport_editable_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl));
#line 1600 "../src/Photo.vala"
	reimport_state = _tmp1_;
#line 1602 "../src/Photo.vala"
	_tmp2_ = reimport_state;
#line 1602 "../src/Photo.vala"
	if (!_tmp2_->metadata_only) {
#line 13189 "Photo.c"
		BackingPhotoTable* _tmp3_;
		BackingPhotoTable* _tmp4_;
		PhotoReimportEditableStateImpl* _tmp5_;
		BackingPhotoRow* _tmp6_;
#line 1603 "../src/Photo.vala"
		_tmp3_ = backing_photo_table_get_instance ();
#line 1603 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1603 "../src/Photo.vala"
		_tmp5_ = reimport_state;
#line 1603 "../src/Photo.vala"
		_tmp6_ = _tmp5_->backing_state;
#line 1603 "../src/Photo.vala"
		backing_photo_table_update (_tmp4_, _tmp6_, &_inner_error0_);
#line 1603 "../src/Photo.vala"
		_database_table_unref0 (_tmp4_);
#line 1603 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1603 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1603 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1603 "../src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1603 "../src/Photo.vala"
				return;
#line 13216 "Photo.c"
			} else {
#line 1603 "../src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1603 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1603 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1603 "../src/Photo.vala"
				return;
#line 13226 "Photo.c"
			}
		}
		{
			PhotoRow* _tmp7_;
#line 1605 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 1605 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 13235 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp8_;
				BackingPhotoRow* _tmp9_;
				BackingPhotoRow* _tmp10_;
				PhotoReimportEditableStateImpl* _tmp11_;
				BackingPhotoRow* _tmp12_;
#line 1606 "../src/Photo.vala"
				_tmp8_ = reimport_state;
#line 1606 "../src/Photo.vala"
				_tmp9_ = _tmp8_->backing_state;
#line 1606 "../src/Photo.vala"
				_tmp10_ = _backing_photo_row_ref0 (_tmp9_);
#line 1606 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->priv->editable);
#line 1606 "../src/Photo.vala"
				self->priv->editable = _tmp10_;
#line 1607 "../src/Photo.vala"
				_tmp11_ = reimport_state;
#line 1607 "../src/Photo.vala"
				_tmp12_ = _tmp11_->backing_state;
#line 1607 "../src/Photo.vala"
				photo_set_orientation (self, _tmp12_->original_orientation);
#line 1608 "../src/Photo.vala"
				photo_remove_all_transformations (self, FALSE);
#line 13260 "Photo.c"
			}
			__finally0:
			{
				PhotoRow* _tmp13_;
#line 1605 "../src/Photo.vala"
				_tmp13_ = self->row;
#line 1605 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13269 "Photo.c"
			}
#line 1605 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1605 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1605 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1605 "../src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1605 "../src/Photo.vala"
					return;
#line 13281 "Photo.c"
				} else {
#line 1605 "../src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1605 "../src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1605 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1605 "../src/Photo.vala"
					return;
#line 13291 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp14_;
		BackingPhotoRow* _tmp15_;
#line 1611 "../src/Photo.vala"
		_tmp14_ = reimport_state;
#line 1611 "../src/Photo.vala"
		_tmp15_ = _tmp14_->backing_state;
#line 1611 "../src/Photo.vala"
		photo_set_orientation (self, _tmp15_->original_orientation);
#line 13304 "Photo.c"
	}
#line 1614 "../src/Photo.vala"
	_tmp16_ = reimport_state;
#line 1614 "../src/Photo.vala"
	_tmp17_ = _tmp16_->metadata;
#line 1614 "../src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 13312 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp18_;
		PhotoMetadata* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		PhotoReimportEditableStateImpl* _tmp22_;
		PhotoMetadata* _tmp23_;
		GpsCoords _tmp24_ = {0};
		PhotoReimportEditableStateImpl* _tmp25_;
		PhotoMetadata* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		PhotoReimportEditableStateImpl* _tmp29_;
		PhotoMetadata* _tmp30_;
		PhotoReimportEditableStateImpl* _tmp31_;
		PhotoMetadata* _tmp32_;
#line 1615 "../src/Photo.vala"
		_tmp18_ = reimport_state;
#line 1615 "../src/Photo.vala"
		_tmp19_ = _tmp18_->metadata;
#line 1615 "../src/Photo.vala"
		_tmp20_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1615 "../src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 1615 "../src/Photo.vala"
		media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp21_);
#line 1615 "../src/Photo.vala"
		_g_free0 (_tmp21_);
#line 1616 "../src/Photo.vala"
		_tmp22_ = reimport_state;
#line 1616 "../src/Photo.vala"
		_tmp23_ = _tmp22_->metadata;
#line 1616 "../src/Photo.vala"
		photo_metadata_get_gps_coords (_tmp23_, &_tmp24_);
#line 1616 "../src/Photo.vala"
		positionable_set_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp24_);
#line 1617 "../src/Photo.vala"
		_tmp25_ = reimport_state;
#line 1617 "../src/Photo.vala"
		_tmp26_ = _tmp25_->metadata;
#line 1617 "../src/Photo.vala"
		_tmp27_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1617 "../src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 1617 "../src/Photo.vala"
		media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp28_);
#line 1617 "../src/Photo.vala"
		_g_free0 (_tmp28_);
#line 1618 "../src/Photo.vala"
		_tmp29_ = reimport_state;
#line 1618 "../src/Photo.vala"
		_tmp30_ = _tmp29_->metadata;
#line 1618 "../src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), photo_metadata_get_rating (_tmp30_));
#line 1619 "../src/Photo.vala"
		_tmp31_ = reimport_state;
#line 1619 "../src/Photo.vala"
		_tmp32_ = _tmp31_->metadata;
#line 1619 "../src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp32_);
#line 13372 "Photo.c"
	}
#line 1622 "../src/Photo.vala"
	_tmp33_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1622 "../src/Photo.vala"
	list = _tmp33_;
#line 1623 "../src/Photo.vala"
	_tmp34_ = reimport_state;
#line 1623 "../src/Photo.vala"
	if (!_tmp34_->metadata_only) {
#line 13382 "Photo.c"
		const gchar* _tmp35_;
		gchar* _tmp36_;
#line 1624 "../src/Photo.vala"
		_tmp35_ = list;
#line 1624 "../src/Photo.vala"
		_tmp36_ = g_strconcat (_tmp35_, "image:editable,image:baseline", NULL);
#line 1624 "../src/Photo.vala"
		_g_free0 (list);
#line 1624 "../src/Photo.vala"
		list = _tmp36_;
#line 13393 "Photo.c"
	}
#line 1626 "../src/Photo.vala"
	_tmp37_ = list;
#line 1626 "../src/Photo.vala"
	_tmp38_ = alteration_new_from_list (_tmp37_);
#line 1626 "../src/Photo.vala"
	_tmp39_ = _tmp38_;
#line 1626 "../src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp39_);
#line 1626 "../src/Photo.vala"
	_alteration_unref0 (_tmp39_);
#line 1628 "../src/Photo.vala"
	_tmp40_ = reimport_state;
#line 1628 "../src/Photo.vala"
	_tmp41_ = _tmp40_->metadata;
#line 1628 "../src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp41_);
#line 1630 "../src/Photo.vala"
	if (photo_is_editable_baseline (self)) {
#line 13413 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp42_;
		PhotoMetadata* _tmp43_;
#line 1631 "../src/Photo.vala"
		_tmp42_ = reimport_state;
#line 1631 "../src/Photo.vala"
		_tmp43_ = _tmp42_->metadata;
#line 1631 "../src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp43_);
#line 13422 "Photo.c"
	}
#line 1633 "../src/Photo.vala"
	if (photo_is_editable_source (self)) {
#line 13426 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp44_;
		PhotoMetadata* _tmp45_;
#line 1634 "../src/Photo.vala"
		_tmp44_ = reimport_state;
#line 1634 "../src/Photo.vala"
		_tmp45_ = _tmp44_->metadata;
#line 1634 "../src/Photo.vala"
		photo_notify_source_reimported (self, _tmp45_);
#line 13435 "Photo.c"
	}
#line 1595 "../src/Photo.vala"
	_g_free0 (list);
#line 1595 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 13441 "Photo.c"
}

static gpointer
_photo_reimport_raw_development_state_ref0 (gpointer self)
{
#line 1656 "../src/Photo.vala"
	return self ? photo_reimport_raw_development_state_ref (self) : NULL;
#line 13449 "Photo.c"
}

gboolean
photo_prepare_for_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState** state,
                                            GError** error)
{
	PhotoReimportRawDevelopmentState* _vala_state = NULL;
	GeeCollection* files = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_;
	PhotoReimportRawDevelopmentStateImpl* _tmp18_;
	PhotoReimportRawDevelopmentState* _tmp19_;
	PhotoReimportRawDevelopmentStateImpl* _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 1638 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1639 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1639 "../src/Photo.vala"
	_vala_state = NULL;
#line 1641 "../src/Photo.vala"
	_tmp0_ = photo_get_raw_developer_files (self);
#line 1641 "../src/Photo.vala"
	files = _tmp0_;
#line 1642 "../src/Photo.vala"
	_tmp1_ = files;
#line 1642 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1643 "../src/Photo.vala"
		result = FALSE;
#line 1643 "../src/Photo.vala"
		_g_object_unref0 (files);
#line 1643 "../src/Photo.vala"
		if (state) {
#line 1643 "../src/Photo.vala"
			*state = _vala_state;
#line 13490 "Photo.c"
		} else {
#line 1643 "../src/Photo.vala"
			_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 13494 "Photo.c"
		}
#line 1643 "../src/Photo.vala"
		return result;
#line 13498 "Photo.c"
	}
#line 1645 "../src/Photo.vala"
	_tmp2_ = photo_reimport_raw_development_state_impl_new ();
#line 1645 "../src/Photo.vala"
	reimport_state = _tmp2_;
#line 13504 "Photo.c"
	{
		GeeIterator* _file_it = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
#line 1647 "../src/Photo.vala"
		_tmp3_ = files;
#line 1647 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1647 "../src/Photo.vala"
		_file_it = _tmp4_;
#line 1647 "../src/Photo.vala"
		while (TRUE) {
#line 13517 "Photo.c"
			GeeIterator* _tmp5_;
			GFile* file = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DetectedPhotoInformation* detected = NULL;
			BackingPhotoRow* backing = NULL;
			gboolean _tmp8_ = FALSE;
			GFile* _tmp9_;
			BackingPhotoRow* _tmp10_ = NULL;
			DetectedPhotoInformation* _tmp11_ = NULL;
			gboolean _tmp12_;
			PhotoReimportRawDevelopmentStateImpl* _tmp14_;
			BackingPhotoRow* _tmp15_;
			DetectedPhotoInformation* _tmp16_;
			PhotoMetadata* _tmp17_;
#line 1647 "../src/Photo.vala"
			_tmp5_ = _file_it;
#line 1647 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1647 "../src/Photo.vala"
				break;
#line 13539 "Photo.c"
			}
#line 1647 "../src/Photo.vala"
			_tmp6_ = _file_it;
#line 1647 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1647 "../src/Photo.vala"
			file = (GFile*) _tmp7_;
#line 1650 "../src/Photo.vala"
			_tmp9_ = file;
#line 1650 "../src/Photo.vala"
			_tmp12_ = photo_verify_file_for_reimport (self, _tmp9_, &_tmp10_, &_tmp11_, &_inner_error0_);
#line 1650 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1650 "../src/Photo.vala"
			backing = _tmp10_;
#line 1650 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1650 "../src/Photo.vala"
			detected = _tmp11_;
#line 1650 "../src/Photo.vala"
			_tmp8_ = _tmp12_;
#line 1650 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13563 "Photo.c"
				gboolean _tmp13_ = FALSE;
#line 1650 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1650 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1650 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1650 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 1650 "../src/Photo.vala"
				_g_object_unref0 (_file_it);
#line 1650 "../src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1650 "../src/Photo.vala"
				_g_object_unref0 (files);
#line 1650 "../src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1650 "../src/Photo.vala"
				return _tmp13_;
#line 13583 "Photo.c"
			}
#line 1650 "../src/Photo.vala"
			if (!_tmp8_) {
#line 1651 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1651 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1651 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 1651 "../src/Photo.vala"
				continue;
#line 13595 "Photo.c"
			}
#line 1653 "../src/Photo.vala"
			_tmp14_ = reimport_state;
#line 1653 "../src/Photo.vala"
			_tmp15_ = backing;
#line 1653 "../src/Photo.vala"
			_tmp16_ = detected;
#line 1653 "../src/Photo.vala"
			_tmp17_ = _tmp16_->metadata;
#line 1653 "../src/Photo.vala"
			photo_reimport_raw_development_state_impl_add (_tmp14_, _tmp15_, _tmp17_);
#line 1647 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1647 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1647 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 13613 "Photo.c"
		}
#line 1647 "../src/Photo.vala"
		_g_object_unref0 (_file_it);
#line 13617 "Photo.c"
	}
#line 1656 "../src/Photo.vala"
	_tmp18_ = reimport_state;
#line 1656 "../src/Photo.vala"
	_tmp19_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState));
#line 1656 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1656 "../src/Photo.vala"
	_vala_state = _tmp19_;
#line 1657 "../src/Photo.vala"
	_tmp20_ = reimport_state;
#line 1657 "../src/Photo.vala"
	result = photo_reimport_raw_development_state_impl_get_size (_tmp20_) > 0;
#line 1657 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1657 "../src/Photo.vala"
	_g_object_unref0 (files);
#line 1657 "../src/Photo.vala"
	if (state) {
#line 1657 "../src/Photo.vala"
		*state = _vala_state;
#line 13639 "Photo.c"
	} else {
#line 1657 "../src/Photo.vala"
		_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 13643 "Photo.c"
	}
#line 1657 "../src/Photo.vala"
	return result;
#line 13647 "Photo.c"
}

void
photo_finish_reimport_raw_development (Photo* self,
                                       PhotoReimportRawDevelopmentState* state,
                                       GError** error)
{
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp0_;
	gchar* list = NULL;
	gchar* _tmp25_;
	PhotoReimportRawDevelopmentStateImpl* _tmp26_;
	const gchar* _tmp29_;
	Alteration* _tmp30_;
	Alteration* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 1661 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1661 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE (state));
#line 1662 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1663 "../src/Photo.vala"
		return;
#line 13672 "Photo.c"
	}
#line 1665 "../src/Photo.vala"
	_tmp0_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl));
#line 1665 "../src/Photo.vala"
	reimport_state = _tmp0_;
#line 13678 "Photo.c"
	{
		GeeIterator* _dev_it = NULL;
		PhotoReimportRawDevelopmentStateImpl* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
#line 1667 "../src/Photo.vala"
		_tmp1_ = reimport_state;
#line 1667 "../src/Photo.vala"
		_tmp2_ = _tmp1_->list;
#line 1667 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1667 "../src/Photo.vala"
		_dev_it = _tmp3_;
#line 1667 "../src/Photo.vala"
		while (TRUE) {
#line 13694 "Photo.c"
			GeeIterator* _tmp4_;
			PhotoReimportRawDevelopmentStateImplDevToReimport* dev = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			PhotoReimportRawDevelopmentStateImpl* _tmp7_;
#line 1667 "../src/Photo.vala"
			_tmp4_ = _dev_it;
#line 1667 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1667 "../src/Photo.vala"
				break;
#line 13706 "Photo.c"
			}
#line 1667 "../src/Photo.vala"
			_tmp5_ = _dev_it;
#line 1667 "../src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1667 "../src/Photo.vala"
			dev = (PhotoReimportRawDevelopmentStateImplDevToReimport*) _tmp6_;
#line 1668 "../src/Photo.vala"
			_tmp7_ = reimport_state;
#line 1668 "../src/Photo.vala"
			if (!_tmp7_->metadata_only) {
#line 13718 "Photo.c"
				BackingPhotoTable* _tmp8_;
				BackingPhotoTable* _tmp9_;
				PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp10_;
				BackingPhotoRow* _tmp11_;
#line 1669 "../src/Photo.vala"
				_tmp8_ = backing_photo_table_get_instance ();
#line 1669 "../src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1669 "../src/Photo.vala"
				_tmp10_ = dev;
#line 1669 "../src/Photo.vala"
				_tmp11_ = _tmp10_->backing;
#line 1669 "../src/Photo.vala"
				backing_photo_table_update (_tmp9_, _tmp11_, &_inner_error0_);
#line 1669 "../src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1669 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1669 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1669 "../src/Photo.vala"
						g_propagate_error (error, _inner_error0_);
#line 1669 "../src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1669 "../src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1669 "../src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1669 "../src/Photo.vala"
						return;
#line 13749 "Photo.c"
					} else {
#line 1669 "../src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1669 "../src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1669 "../src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1669 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1669 "../src/Photo.vala"
						g_clear_error (&_inner_error0_);
#line 1669 "../src/Photo.vala"
						return;
#line 13763 "Photo.c"
					}
				}
				{
					PhotoRow* _tmp12_;
#line 1671 "../src/Photo.vala"
					_tmp12_ = self->row;
#line 1671 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_row);
#line 13772 "Photo.c"
					{
						gint _tmp13_ = 0;
						RawDeveloper* _tmp14_;
#line 1673 "../src/Photo.vala"
						_tmp14_ = raw_developer_as_array (&_tmp13_);
#line 13778 "Photo.c"
						{
							RawDeveloper* d_collection = NULL;
							gint d_collection_length1 = 0;
							gint _d_collection_size_ = 0;
							gint d_it = 0;
#line 1673 "../src/Photo.vala"
							d_collection = _tmp14_;
#line 1673 "../src/Photo.vala"
							d_collection_length1 = _tmp13_;
#line 1673 "../src/Photo.vala"
							for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 13790 "Photo.c"
								RawDeveloper d = 0;
#line 1673 "../src/Photo.vala"
								d = d_collection[d_it];
#line 13794 "Photo.c"
								{
									BackingPhotoID id = {0};
									PhotoRow* _tmp15_;
									BackingPhotoID* _tmp16_;
									gint _tmp16__length1;
									BackingPhotoID _tmp17_;
									BackingPhotoID _tmp18_;
#line 1674 "../src/Photo.vala"
									_tmp15_ = self->row;
#line 1674 "../src/Photo.vala"
									_tmp16_ = _tmp15_->development_ids;
#line 1674 "../src/Photo.vala"
									_tmp16__length1 = _tmp15_->development_ids_length1;
#line 1674 "../src/Photo.vala"
									_tmp17_ = _tmp16_[d];
#line 1674 "../src/Photo.vala"
									id = _tmp17_;
#line 1675 "../src/Photo.vala"
									_tmp18_ = id;
#line 1675 "../src/Photo.vala"
									if (_tmp18_.id != BACKING_PHOTO_ID_INVALID) {
#line 13816 "Photo.c"
										BackingPhotoRow* bpr = NULL;
										BackingPhotoID _tmp19_;
										BackingPhotoRow* _tmp20_;
										BackingPhotoRow* _tmp21_;
#line 1676 "../src/Photo.vala"
										_tmp19_ = id;
#line 1676 "../src/Photo.vala"
										_tmp20_ = photo_get_backing_row (self, &_tmp19_);
#line 1676 "../src/Photo.vala"
										bpr = _tmp20_;
#line 1677 "../src/Photo.vala"
										_tmp21_ = bpr;
#line 1677 "../src/Photo.vala"
										if (_tmp21_ != NULL) {
#line 13831 "Photo.c"
											GeeHashMap* _tmp22_;
											BackingPhotoRow* _tmp23_;
#line 1678 "../src/Photo.vala"
											_tmp22_ = self->priv->developments;
#line 1678 "../src/Photo.vala"
											_tmp23_ = bpr;
#line 1678 "../src/Photo.vala"
											gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), _tmp23_);
#line 13840 "Photo.c"
										}
#line 1675 "../src/Photo.vala"
										_backing_photo_row_unref0 (bpr);
#line 13844 "Photo.c"
									}
								}
							}
#line 1673 "../src/Photo.vala"
							d_collection = (g_free (d_collection), NULL);
#line 13850 "Photo.c"
						}
					}
					__finally0:
					{
						PhotoRow* _tmp24_;
#line 1671 "../src/Photo.vala"
						_tmp24_ = self->row;
#line 1671 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13860 "Photo.c"
					}
#line 1671 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1671 "../src/Photo.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1671 "../src/Photo.vala"
							g_propagate_error (error, _inner_error0_);
#line 1671 "../src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1671 "../src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1671 "../src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1671 "../src/Photo.vala"
							return;
#line 13876 "Photo.c"
						} else {
#line 1671 "../src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1671 "../src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1671 "../src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1671 "../src/Photo.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1671 "../src/Photo.vala"
							g_clear_error (&_inner_error0_);
#line 1671 "../src/Photo.vala"
							return;
#line 13890 "Photo.c"
						}
					}
				}
			}
#line 1667 "../src/Photo.vala"
			_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 13897 "Photo.c"
		}
#line 1667 "../src/Photo.vala"
		_g_object_unref0 (_dev_it);
#line 13901 "Photo.c"
	}
#line 1685 "../src/Photo.vala"
	_tmp25_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1685 "../src/Photo.vala"
	list = _tmp25_;
#line 1686 "../src/Photo.vala"
	_tmp26_ = reimport_state;
#line 1686 "../src/Photo.vala"
	if (!_tmp26_->metadata_only) {
#line 13911 "Photo.c"
		const gchar* _tmp27_;
		gchar* _tmp28_;
#line 1687 "../src/Photo.vala"
		_tmp27_ = list;
#line 1687 "../src/Photo.vala"
		_tmp28_ = g_strconcat (_tmp27_, "image:editable,image:baseline", NULL);
#line 1687 "../src/Photo.vala"
		_g_free0 (list);
#line 1687 "../src/Photo.vala"
		list = _tmp28_;
#line 13922 "Photo.c"
	}
#line 1689 "../src/Photo.vala"
	_tmp29_ = list;
#line 1689 "../src/Photo.vala"
	_tmp30_ = alteration_new_from_list (_tmp29_);
#line 1689 "../src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 1689 "../src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp31_);
#line 1689 "../src/Photo.vala"
	_alteration_unref0 (_tmp31_);
#line 1691 "../src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 1661 "../src/Photo.vala"
	_g_free0 (list);
#line 1661 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 13940 "Photo.c"
}

static gchar*
photo_real_get_typename (DataSource* base)
{
	Photo * self;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1694 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1695 "../src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1695 "../src/Photo.vala"
	result = _tmp0_;
#line 1695 "../src/Photo.vala"
	return result;
#line 13957 "Photo.c"
}

static gint64
photo_real_get_instance_id (DataSource* base)
{
	Photo * self;
	PhotoID _tmp0_ = {0};
	gint64 result = 0LL;
#line 1698 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1699 "../src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1699 "../src/Photo.vala"
	result = _tmp0_.id;
#line 1699 "../src/Photo.vala"
	return result;
#line 13974 "Photo.c"
}

static gchar*
photo_real_get_source_id (DataSource* base)
{
	Photo * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 1702 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1706 "../src/Photo.vala"
	_tmp0_ = data_source_get_typename (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource));
#line 1706 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1706 "../src/Photo.vala"
	_tmp2_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, data_source_get_instance_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource)));
#line 1706 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1706 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1706 "../src/Photo.vala"
	result = _tmp3_;
#line 1706 "../src/Photo.vala"
	return result;
#line 14002 "Photo.c"
}

void
photo_set_master_timestamp (Photo* self,
                            GFileInfo* info)
{
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 1710 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1710 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 1711 "../src/Photo.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1711 "../src/Photo.vala"
	modification = _tmp0_;
#line 14020 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1714 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1714 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 14028 "Photo.c"
			{
				PhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
				GTimeVal _tmp4_;
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoRow* _tmp8_;
				PhotoID _tmp9_;
				GTimeVal _tmp10_;
				PhotoRow* _tmp11_;
				BackingPhotoRow* _tmp12_;
				GTimeVal _tmp13_;
#line 1715 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 1715 "../src/Photo.vala"
				_tmp3_ = _tmp2_->master;
#line 1715 "../src/Photo.vala"
				_tmp4_ = modification;
#line 1715 "../src/Photo.vala"
				if (_tmp3_->timestamp == ((time_t) _tmp4_.tv_sec)) {
#line 14049 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						PhotoRow* _tmp5_;
#line 1714 "../src/Photo.vala"
						_tmp5_ = self->row;
#line 1714 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14057 "Photo.c"
					}
#line 1716 "../src/Photo.vala"
					return;
#line 14061 "Photo.c"
				}
#line 1718 "../src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 1718 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1718 "../src/Photo.vala"
				_tmp8_ = self->row;
#line 1718 "../src/Photo.vala"
				_tmp9_ = _tmp8_->photo_id;
#line 1718 "../src/Photo.vala"
				_tmp10_ = modification;
#line 1718 "../src/Photo.vala"
				photo_table_update_timestamp (_tmp7_, &_tmp9_, (time_t) _tmp10_.tv_sec, &_inner_error0_);
#line 1718 "../src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 1718 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14079 "Photo.c"
					goto __finally1;
				}
#line 1719 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 1719 "../src/Photo.vala"
				_tmp12_ = _tmp11_->master;
#line 1719 "../src/Photo.vala"
				_tmp13_ = modification;
#line 1719 "../src/Photo.vala"
				_tmp12_->timestamp = (time_t) _tmp13_.tv_sec;
#line 14090 "Photo.c"
			}
			__finally1:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp14_;
#line 1714 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 1714 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14100 "Photo.c"
			}
#line 1714 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1714 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 14106 "Photo.c"
					goto __catch0_database_error;
				}
#line 1714 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1714 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1714 "../src/Photo.vala"
				return;
#line 14115 "Photo.c"
			}
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp15_;
#line 1713 "../src/Photo.vala"
		err = _inner_error0_;
#line 1713 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1722 "../src/Photo.vala"
		_tmp15_ = err;
#line 1722 "../src/Photo.vala"
		app_window_database_error (_tmp15_);
#line 1724 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1724 "../src/Photo.vala"
		return;
#line 14136 "Photo.c"
	}
	__finally0:
#line 1713 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1713 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1713 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1713 "../src/Photo.vala"
		return;
#line 14147 "Photo.c"
	}
#line 1727 "../src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 14151 "Photo.c"
		Alteration* _tmp16_;
		Alteration* _tmp17_;
#line 1728 "../src/Photo.vala"
		_tmp16_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1728 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 1728 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp17_);
#line 1728 "../src/Photo.vala"
		_alteration_unref0 (_tmp17_);
#line 14162 "Photo.c"
	} else {
		Alteration* _tmp18_;
		Alteration* _tmp19_;
#line 1730 "../src/Photo.vala"
		_tmp18_ = alteration_new ("metadata", "master-timestamp");
#line 1730 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 1730 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp19_);
#line 1730 "../src/Photo.vala"
		_alteration_unref0 (_tmp19_);
#line 14174 "Photo.c"
	}
}

void
photo_update_editable_modification_time (Photo* self,
                                         GFileInfo* info,
                                         GError** error)
{
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	gboolean altered = FALSE;
	GError* _inner_error0_ = NULL;
#line 1734 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1734 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 1735 "../src/Photo.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1735 "../src/Photo.vala"
	modification = _tmp0_;
#line 1737 "../src/Photo.vala"
	altered = FALSE;
#line 14197 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1738 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 1738 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14204 "Photo.c"
		{
			gboolean _tmp2_ = FALSE;
			PhotoRow* _tmp3_;
#line 1739 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 1739 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp3_->editable_id)) {
#line 14212 "Photo.c"
				BackingPhotoRow* _tmp4_;
				GTimeVal _tmp5_;
#line 1739 "../src/Photo.vala"
				_tmp4_ = self->priv->editable;
#line 1739 "../src/Photo.vala"
				_tmp5_ = modification;
#line 1739 "../src/Photo.vala"
				_tmp2_ = _tmp4_->timestamp != ((time_t) _tmp5_.tv_sec);
#line 14221 "Photo.c"
			} else {
#line 1739 "../src/Photo.vala"
				_tmp2_ = FALSE;
#line 14225 "Photo.c"
			}
#line 1739 "../src/Photo.vala"
			if (_tmp2_) {
#line 14229 "Photo.c"
				BackingPhotoTable* _tmp6_;
				BackingPhotoTable* _tmp7_;
				PhotoRow* _tmp8_;
				BackingPhotoID _tmp9_;
				GTimeVal _tmp10_;
				BackingPhotoRow* _tmp11_;
				GTimeVal _tmp12_;
#line 1740 "../src/Photo.vala"
				_tmp6_ = backing_photo_table_get_instance ();
#line 1740 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1740 "../src/Photo.vala"
				_tmp8_ = self->row;
#line 1740 "../src/Photo.vala"
				_tmp9_ = _tmp8_->editable_id;
#line 1740 "../src/Photo.vala"
				_tmp10_ = modification;
#line 1740 "../src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp7_, &_tmp9_, (time_t) _tmp10_.tv_sec, &_inner_error0_);
#line 1740 "../src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 1740 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14253 "Photo.c"
					goto __finally0;
				}
#line 1742 "../src/Photo.vala"
				_tmp11_ = self->priv->editable;
#line 1742 "../src/Photo.vala"
				_tmp12_ = modification;
#line 1742 "../src/Photo.vala"
				_tmp11_->timestamp = (time_t) _tmp12_.tv_sec;
#line 1743 "../src/Photo.vala"
				altered = TRUE;
#line 14264 "Photo.c"
			}
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp13_;
#line 1738 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 1738 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14275 "Photo.c"
		}
#line 1738 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1738 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1738 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1738 "../src/Photo.vala"
				return;
#line 14285 "Photo.c"
			} else {
#line 1738 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1738 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1738 "../src/Photo.vala"
				return;
#line 14293 "Photo.c"
			}
		}
	}
#line 1747 "../src/Photo.vala"
	if (altered) {
#line 14299 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 1748 "../src/Photo.vala"
		_tmp14_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1748 "../src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 1748 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp15_);
#line 1748 "../src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 14310 "Photo.c"
	}
}

void
photo_update_many_editable_timestamps (GeeMap* map,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 1752 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 1754 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 14323 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 1755 "../src/Photo.vala"
		_tmp0_ = gee_map_get_keys (map);
#line 1755 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 1755 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1755 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1755 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1755 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 1755 "../src/Photo.vala"
		_photo_it = _tmp4_;
#line 1755 "../src/Photo.vala"
		while (TRUE) {
#line 14347 "Photo.c"
			GeeIterator* _tmp5_;
			Photo* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Photo* _tmp8_;
			Photo* _tmp9_;
			gpointer _tmp10_;
			GFileInfo* _tmp11_;
#line 1755 "../src/Photo.vala"
			_tmp5_ = _photo_it;
#line 1755 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1755 "../src/Photo.vala"
				break;
#line 14362 "Photo.c"
			}
#line 1755 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1755 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1755 "../src/Photo.vala"
			photo = (Photo*) _tmp7_;
#line 1756 "../src/Photo.vala"
			_tmp8_ = photo;
#line 1756 "../src/Photo.vala"
			_tmp9_ = photo;
#line 1756 "../src/Photo.vala"
			_tmp10_ = gee_map_get (map, _tmp9_);
#line 1756 "../src/Photo.vala"
			_tmp11_ = (GFileInfo*) _tmp10_;
#line 1756 "../src/Photo.vala"
			photo_update_editable_modification_time (_tmp8_, _tmp11_, &_inner_error0_);
#line 1756 "../src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 1756 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1756 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1756 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1756 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 1756 "../src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1756 "../src/Photo.vala"
					return;
#line 14394 "Photo.c"
				} else {
#line 1756 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 1756 "../src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1756 "../src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1756 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1756 "../src/Photo.vala"
					return;
#line 14406 "Photo.c"
				}
			}
#line 1755 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 14411 "Photo.c"
		}
#line 1755 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 14415 "Photo.c"
	}
#line 1757 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1757 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1757 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1757 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1757 "../src/Photo.vala"
			return;
#line 14427 "Photo.c"
		} else {
#line 1757 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1757 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1757 "../src/Photo.vala"
			return;
#line 14435 "Photo.c"
		}
	}
}

static PhotoFileFormat
photo_real_get_preferred_thumbnail_format (ThumbnailSource* base)
{
	Photo * self;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat result = 0;
#line 1760 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1761 "../src/Photo.vala"
	if (photo_file_format_can_write_image (photo_get_file_format (self))) {
#line 1761 "../src/Photo.vala"
		_tmp0_ = photo_get_file_format (self);
#line 14452 "Photo.c"
	} else {
#line 1762 "../src/Photo.vala"
		_tmp0_ = photo_file_format_get_system_default_format ();
#line 14456 "Photo.c"
	}
#line 1761 "../src/Photo.vala"
	result = _tmp0_;
#line 1761 "../src/Photo.vala"
	return result;
#line 14462 "Photo.c"
}

static GdkPixbuf*
photo_real_create_thumbnail (ThumbnailSource* base,
                             gint scale,
                             GError** error)
{
	Photo * self;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 1765 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1766 "../src/Photo.vala"
	scaling_for_best_fit (scale, TRUE, &_tmp1_);
#line 1766 "../src/Photo.vala"
	_tmp2_ = photo_source_get_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), &_tmp1_, &_inner_error0_);
#line 1766 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1766 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1766 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1766 "../src/Photo.vala"
		return NULL;
#line 14491 "Photo.c"
	}
#line 1766 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 1766 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 1766 "../src/Photo.vala"
	result = _tmp3_;
#line 1766 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 1766 "../src/Photo.vala"
	return result;
#line 14503 "Photo.c"
}

gboolean
photo_is_file_image (GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
#line 1769 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1773 "../src/Photo.vala"
	if (photo_file_format_is_file_supported (file)) {
#line 1774 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 14517 "Photo.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 1774 "../src/Photo.vala"
		_tmp1_ = g_file_get_basename (file);
#line 1774 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1774 "../src/Photo.vala"
		_tmp0_ = photo_is_extension_found (_tmp2_, PHOTO_IMAGE_EXTENSIONS, (gint) G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1774 "../src/Photo.vala"
		_g_free0 (_tmp2_);
#line 14529 "Photo.c"
	}
#line 1773 "../src/Photo.vala"
	result = _tmp0_;
#line 1773 "../src/Photo.vala"
	return result;
#line 14535 "Photo.c"
}

static gboolean
photo_is_extension_found (const gchar* basename,
                          gchar** extensions,
                          gint extensions_length1)
{
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean result = FALSE;
#line 1777 "../src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1779 "../src/Photo.vala"
	disassemble_filename (basename, &_tmp0_, &_tmp1_);
#line 1779 "../src/Photo.vala"
	_g_free0 (name);
#line 1779 "../src/Photo.vala"
	name = _tmp0_;
#line 1779 "../src/Photo.vala"
	_g_free0 (ext);
#line 1779 "../src/Photo.vala"
	ext = _tmp1_;
#line 1780 "../src/Photo.vala"
	_tmp2_ = ext;
#line 1780 "../src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 1781 "../src/Photo.vala"
		result = FALSE;
#line 1781 "../src/Photo.vala"
		_g_free0 (ext);
#line 1781 "../src/Photo.vala"
		_g_free0 (name);
#line 1781 "../src/Photo.vala"
		return result;
#line 14575 "Photo.c"
	}
#line 1784 "../src/Photo.vala"
	_tmp3_ = ext;
#line 1784 "../src/Photo.vala"
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) -1);
#line 1784 "../src/Photo.vala"
	_g_free0 (ext);
#line 1784 "../src/Photo.vala"
	ext = _tmp4_;
#line 14585 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1787 "../src/Photo.vala"
		extension_collection = extensions;
#line 1787 "../src/Photo.vala"
		extension_collection_length1 = extensions_length1;
#line 1787 "../src/Photo.vala"
		for (extension_it = 0; extension_it < extension_collection_length1; extension_it = extension_it + 1) {
#line 14597 "Photo.c"
			gchar* _tmp5_;
			gchar* extension = NULL;
#line 1787 "../src/Photo.vala"
			_tmp5_ = g_strdup (extension_collection[extension_it]);
#line 1787 "../src/Photo.vala"
			extension = _tmp5_;
#line 14604 "Photo.c"
			{
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1788 "../src/Photo.vala"
				_tmp6_ = ext;
#line 1788 "../src/Photo.vala"
				_tmp7_ = extension;
#line 1788 "../src/Photo.vala"
				if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
#line 1789 "../src/Photo.vala"
					result = TRUE;
#line 1789 "../src/Photo.vala"
					_g_free0 (extension);
#line 1789 "../src/Photo.vala"
					_g_free0 (ext);
#line 1789 "../src/Photo.vala"
					_g_free0 (name);
#line 1789 "../src/Photo.vala"
					return result;
#line 14624 "Photo.c"
				}
#line 1787 "../src/Photo.vala"
				_g_free0 (extension);
#line 14628 "Photo.c"
			}
		}
	}
#line 1792 "../src/Photo.vala"
	result = FALSE;
#line 1792 "../src/Photo.vala"
	_g_free0 (ext);
#line 1792 "../src/Photo.vala"
	_g_free0 (name);
#line 1792 "../src/Photo.vala"
	return result;
#line 14640 "Photo.c"
}

gboolean
photo_is_duplicate (GFile* file,
                    const gchar* thumbnail_md5,
                    const gchar* full_md5,
                    PhotoFileFormat file_format)
{
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gboolean _tmp2_;
	gboolean result = FALSE;
#line 1798 "../src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1801 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1801 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1801 "../src/Photo.vala"
	_tmp2_ = photo_table_has_duplicate (_tmp1_, file, thumbnail_md5, full_md5, file_format);
#line 1801 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1801 "../src/Photo.vala"
	result = _tmp2_;
#line 1801 "../src/Photo.vala"
	return result;
#line 14667 "Photo.c"
}

PhotoID*
photo_get_duplicate_ids (GFile* file,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         PhotoFileFormat file_format,
                         gint* result_length1)
{
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gint _tmp2_ = 0;
	PhotoID* _tmp3_;
	PhotoID* _tmp4_;
	gint _tmp4__length1;
	PhotoID* _tmp5_;
	gint _tmp5__length1;
	PhotoID* result = NULL;
#line 1807 "../src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1810 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1810 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1810 "../src/Photo.vala"
	_tmp3_ = photo_table_get_duplicate_ids (_tmp1_, file, thumbnail_md5, full_md5, file_format, &_tmp2_);
#line 1810 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1810 "../src/Photo.vala"
	_tmp4__length1 = _tmp2_;
#line 1810 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1810 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 1810 "../src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 1810 "../src/Photo.vala"
	if (result_length1) {
#line 1810 "../src/Photo.vala"
		*result_length1 = _tmp5__length1;
#line 14708 "Photo.c"
	}
#line 1810 "../src/Photo.vala"
	result = _tmp5_;
#line 1810 "../src/Photo.vala"
	return result;
#line 14714 "Photo.c"
}

gint64
photo_get_photo_key (DataSource* source)
{
	PhotoID _tmp0_ = {0};
	gint64 result = 0LL;
#line 1817 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0LL);
#line 1818 "../src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_PHOTO, Photo), &_tmp0_);
#line 1818 "../src/Photo.vala"
	result = _tmp0_.id;
#line 1818 "../src/Photo.vala"
	return result;
#line 14730 "Photo.c"
}

static GFile*
photo_real_get_file (MediaSource* base)
{
	Photo * self;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result = NULL;
#line 1836 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1837 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1837 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1837 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1837 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1837 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1837 "../src/Photo.vala"
	result = _tmp3_;
#line 1837 "../src/Photo.vala"
	return result;
#line 14758 "Photo.c"
}

static void
_vala_array_add96 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1880 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1880 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1880 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14773 "Photo.c"
	}
#line 1880 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1880 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14779 "Photo.c"
}

static void
_vala_array_add97 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1885 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1885 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1885 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14794 "Photo.c"
	}
#line 1885 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1885 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14800 "Photo.c"
}

static void
_vala_array_add98 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1888 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1888 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1888 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14815 "Photo.c"
	}
#line 1888 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1888 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14821 "Photo.c"
}

static void
_vala_array_add99 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1891 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1891 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1891 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14836 "Photo.c"
	}
#line 1891 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1891 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14842 "Photo.c"
}

void
photo_set_master_file (Photo* self,
                       GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	gboolean name_changed = FALSE;
	GFile* old_file = NULL;
	GError* _inner_error0_ = NULL;
#line 1842 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1842 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 1843 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1843 "../src/Photo.vala"
	filepath = _tmp0_;
#line 1845 "../src/Photo.vala"
	altered = FALSE;
#line 1846 "../src/Photo.vala"
	is_baseline = FALSE;
#line 1847 "../src/Photo.vala"
	is_source = FALSE;
#line 1848 "../src/Photo.vala"
	name_changed = FALSE;
#line 1849 "../src/Photo.vala"
	old_file = NULL;
#line 14875 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1851 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1851 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 14883 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1852 "../src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1852 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 14891 "Photo.c"
					{
						PhotoBackingReaders* _tmp3_;
						PhotoFileReader* _tmp4_;
						GFile* _tmp5_;
						GFile* _tmp6_;
#line 1853 "../src/Photo.vala"
						_tmp3_ = self->priv->readers;
#line 1853 "../src/Photo.vala"
						_tmp4_ = _tmp3_->master;
#line 1853 "../src/Photo.vala"
						_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1853 "../src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1853 "../src/Photo.vala"
						old_file = _tmp5_;
#line 1854 "../src/Photo.vala"
						_tmp6_ = old_file;
#line 1854 "../src/Photo.vala"
						if (!g_file_equal (file, _tmp6_)) {
#line 14911 "Photo.c"
							PhotoTable* _tmp7_;
							PhotoTable* _tmp8_;
							PhotoID _tmp9_ = {0};
							const gchar* _tmp10_;
							PhotoRow* _tmp11_;
							BackingPhotoRow* _tmp12_;
							const gchar* _tmp13_;
							gchar* _tmp14_;
							gchar* _tmp15_;
							PhotoBackingReaders* _tmp16_;
							PhotoRow* _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							PhotoFileReader* _tmp20_;
							gboolean _tmp21_ = FALSE;
							PhotoRow* _tmp22_;
							const gchar* _tmp23_;
#line 1855 "../src/Photo.vala"
							_tmp7_ = photo_table_get_instance ();
#line 1855 "../src/Photo.vala"
							_tmp8_ = _tmp7_;
#line 1855 "../src/Photo.vala"
							photo_get_photo_id (self, &_tmp9_);
#line 1855 "../src/Photo.vala"
							_tmp10_ = filepath;
#line 1855 "../src/Photo.vala"
							photo_table_set_filepath (_tmp8_, &_tmp9_, _tmp10_, &_inner_error0_);
#line 1855 "../src/Photo.vala"
							_database_table_unref0 (_tmp8_);
#line 1855 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14943 "Photo.c"
								goto __finally2;
							}
#line 1857 "../src/Photo.vala"
							_tmp11_ = self->row;
#line 1857 "../src/Photo.vala"
							_tmp12_ = _tmp11_->master;
#line 1857 "../src/Photo.vala"
							_tmp13_ = filepath;
#line 1857 "../src/Photo.vala"
							_tmp14_ = g_strdup (_tmp13_);
#line 1857 "../src/Photo.vala"
							_g_free0 (_tmp12_->filepath);
#line 1857 "../src/Photo.vala"
							_tmp12_->filepath = _tmp14_;
#line 1858 "../src/Photo.vala"
							_tmp15_ = g_file_get_basename (file);
#line 1858 "../src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1858 "../src/Photo.vala"
							self->priv->file_title = _tmp15_;
#line 1859 "../src/Photo.vala"
							_tmp16_ = self->priv->readers;
#line 1859 "../src/Photo.vala"
							_tmp17_ = self->row;
#line 1859 "../src/Photo.vala"
							_tmp18_ = _tmp17_->master;
#line 1859 "../src/Photo.vala"
							_tmp19_ = filepath;
#line 1859 "../src/Photo.vala"
							_tmp20_ = photo_file_format_create_reader (_tmp18_->file_format, _tmp19_);
#line 1859 "../src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp16_->master);
#line 1859 "../src/Photo.vala"
							_tmp16_->master = _tmp20_;
#line 1861 "../src/Photo.vala"
							altered = TRUE;
#line 1862 "../src/Photo.vala"
							is_baseline = photo_is_master_baseline (self);
#line 1863 "../src/Photo.vala"
							is_source = photo_is_master_source (self);
#line 1864 "../src/Photo.vala"
							_tmp22_ = self->row;
#line 1864 "../src/Photo.vala"
							_tmp23_ = _tmp22_->title;
#line 1864 "../src/Photo.vala"
							if (is_string_empty (_tmp23_)) {
#line 14990 "Photo.c"
								GFile* _tmp24_;
								gchar* _tmp25_;
								gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
#line 1865 "../src/Photo.vala"
								_tmp24_ = old_file;
#line 1865 "../src/Photo.vala"
								_tmp25_ = g_file_get_basename (_tmp24_);
#line 1865 "../src/Photo.vala"
								_tmp26_ = _tmp25_;
#line 1865 "../src/Photo.vala"
								_tmp27_ = g_file_get_basename (file);
#line 1865 "../src/Photo.vala"
								_tmp28_ = _tmp27_;
#line 1865 "../src/Photo.vala"
								_tmp21_ = g_strcmp0 (_tmp26_, _tmp28_) != 0;
#line 1865 "../src/Photo.vala"
								_g_free0 (_tmp28_);
#line 1865 "../src/Photo.vala"
								_g_free0 (_tmp26_);
#line 15012 "Photo.c"
							} else {
#line 1864 "../src/Photo.vala"
								_tmp21_ = FALSE;
#line 15016 "Photo.c"
							}
#line 1864 "../src/Photo.vala"
							name_changed = _tmp21_;
#line 15020 "Photo.c"
						}
					}
					__finally2:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp29_;
#line 1852 "../src/Photo.vala"
						_tmp29_ = self->priv->readers;
#line 1852 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 15031 "Photo.c"
					}
#line 1852 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15035 "Photo.c"
						goto __finally1;
					}
				}
			}
			__finally1:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp30_;
#line 1851 "../src/Photo.vala"
				_tmp30_ = self->row;
#line 1851 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15048 "Photo.c"
			}
#line 1851 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1851 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 15054 "Photo.c"
					goto __catch0_database_error;
				}
#line 1851 "../src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1851 "../src/Photo.vala"
				_g_free0 (filepath);
#line 1851 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1851 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1851 "../src/Photo.vala"
				return;
#line 15067 "Photo.c"
			}
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp31_;
#line 1850 "../src/Photo.vala"
		err = _inner_error0_;
#line 1850 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1870 "../src/Photo.vala"
		_tmp31_ = err;
#line 1870 "../src/Photo.vala"
		app_window_database_error (_tmp31_);
#line 1850 "../src/Photo.vala"
		_g_error_free0 (err);
#line 15086 "Photo.c"
	}
	__finally0:
#line 1850 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1850 "../src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1850 "../src/Photo.vala"
		_g_free0 (filepath);
#line 1850 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1850 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1850 "../src/Photo.vala"
		return;
#line 15101 "Photo.c"
	}
#line 1873 "../src/Photo.vala"
	if (altered) {
#line 15105 "Photo.c"
		GFile* _tmp32_;
		gchar** alteration_list = NULL;
		gchar** _tmp33_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar* _tmp34_;
		gchar** _tmp38_;
		gint _tmp38__length1;
		Alteration* _tmp39_;
		Alteration* _tmp40_;
#line 1874 "../src/Photo.vala"
		_tmp32_ = old_file;
#line 1874 "../src/Photo.vala"
		media_source_notify_master_replaced (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp32_, file);
#line 1876 "../src/Photo.vala"
		if (is_baseline) {
#line 1877 "../src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 15124 "Photo.c"
		}
#line 1879 "../src/Photo.vala"
		_tmp33_ = g_new0 (gchar*, 0 + 1);
#line 1879 "../src/Photo.vala"
		alteration_list = _tmp33_;
#line 1879 "../src/Photo.vala"
		alteration_list_length1 = 0;
#line 1879 "../src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1880 "../src/Photo.vala"
		_tmp34_ = g_strdup ("backing:master");
#line 1880 "../src/Photo.vala"
		_vala_array_add96 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp34_);
#line 1884 "../src/Photo.vala"
		if (name_changed) {
#line 15140 "Photo.c"
			gchar* _tmp35_;
#line 1885 "../src/Photo.vala"
			_tmp35_ = g_strdup ("metadata:name");
#line 1885 "../src/Photo.vala"
			_vala_array_add97 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp35_);
#line 15146 "Photo.c"
		}
#line 1887 "../src/Photo.vala"
		if (is_source) {
#line 15150 "Photo.c"
			gchar* _tmp36_;
#line 1888 "../src/Photo.vala"
			_tmp36_ = g_strdup ("backing:source");
#line 1888 "../src/Photo.vala"
			_vala_array_add98 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp36_);
#line 15156 "Photo.c"
		}
#line 1890 "../src/Photo.vala"
		if (is_baseline) {
#line 15160 "Photo.c"
			gchar* _tmp37_;
#line 1891 "../src/Photo.vala"
			_tmp37_ = g_strdup ("backing:baseline");
#line 1891 "../src/Photo.vala"
			_vala_array_add99 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp37_);
#line 15166 "Photo.c"
		}
#line 1893 "../src/Photo.vala"
		_tmp38_ = alteration_list;
#line 1893 "../src/Photo.vala"
		_tmp38__length1 = alteration_list_length1;
#line 1893 "../src/Photo.vala"
		_tmp39_ = alteration_new_from_array (_tmp38_, _tmp38__length1);
#line 1893 "../src/Photo.vala"
		_tmp40_ = _tmp39_;
#line 1893 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp40_);
#line 1893 "../src/Photo.vala"
		_alteration_unref0 (_tmp40_);
#line 1873 "../src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 15182 "Photo.c"
	}
#line 1842 "../src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1842 "../src/Photo.vala"
	_g_free0 (filepath);
#line 15188 "Photo.c"
}

static void
_vala_array_add100 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 1933 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1933 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1933 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15203 "Photo.c"
	}
#line 1933 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1933 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15209 "Photo.c"
}

static void
_vala_array_add101 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 1936 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1936 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1936 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15224 "Photo.c"
	}
#line 1936 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1936 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15230 "Photo.c"
}

static void
_vala_array_add102 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 1939 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1939 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1939 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15245 "Photo.c"
	}
#line 1939 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1939 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15251 "Photo.c"
}

void
photo_set_editable_file (Photo* self,
                         GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	GFile* old_file = NULL;
	GError* _inner_error0_ = NULL;
#line 1899 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1899 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 1900 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1900 "../src/Photo.vala"
	filepath = _tmp0_;
#line 1902 "../src/Photo.vala"
	altered = FALSE;
#line 1903 "../src/Photo.vala"
	is_baseline = FALSE;
#line 1904 "../src/Photo.vala"
	is_source = FALSE;
#line 1905 "../src/Photo.vala"
	old_file = NULL;
#line 15281 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1907 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1907 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 15289 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1908 "../src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1908 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 15297 "Photo.c"
					{
						GFile* _tmp3_ = NULL;
						PhotoBackingReaders* _tmp4_;
						PhotoFileReader* _tmp5_;
						GFile* _tmp9_;
						gboolean _tmp10_ = FALSE;
						GFile* _tmp11_;
#line 1909 "../src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1909 "../src/Photo.vala"
						_tmp5_ = _tmp4_->editable;
#line 1909 "../src/Photo.vala"
						if (_tmp5_ != NULL) {
#line 15311 "Photo.c"
							PhotoBackingReaders* _tmp6_;
							PhotoFileReader* _tmp7_;
							GFile* _tmp8_;
#line 1909 "../src/Photo.vala"
							_tmp6_ = self->priv->readers;
#line 1909 "../src/Photo.vala"
							_tmp7_ = _tmp6_->editable;
#line 1909 "../src/Photo.vala"
							_tmp8_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1909 "../src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1909 "../src/Photo.vala"
							_tmp3_ = _tmp8_;
#line 15325 "Photo.c"
						} else {
#line 1909 "../src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1909 "../src/Photo.vala"
							_tmp3_ = NULL;
#line 15331 "Photo.c"
						}
#line 1909 "../src/Photo.vala"
						_tmp9_ = _g_object_ref0 (_tmp3_);
#line 1909 "../src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1909 "../src/Photo.vala"
						old_file = _tmp9_;
#line 1910 "../src/Photo.vala"
						_tmp11_ = old_file;
#line 1910 "../src/Photo.vala"
						if (_tmp11_ != NULL) {
#line 15343 "Photo.c"
							GFile* _tmp12_;
#line 1910 "../src/Photo.vala"
							_tmp12_ = old_file;
#line 1910 "../src/Photo.vala"
							_tmp10_ = !g_file_equal (_tmp12_, file);
#line 15349 "Photo.c"
						} else {
#line 1910 "../src/Photo.vala"
							_tmp10_ = FALSE;
#line 15353 "Photo.c"
						}
#line 1910 "../src/Photo.vala"
						if (_tmp10_) {
#line 15357 "Photo.c"
							BackingPhotoTable* _tmp13_;
							BackingPhotoTable* _tmp14_;
							PhotoRow* _tmp15_;
							BackingPhotoID _tmp16_;
							const gchar* _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							gchar* _tmp20_;
							PhotoBackingReaders* _tmp21_;
							BackingPhotoRow* _tmp22_;
							const gchar* _tmp23_;
							PhotoFileReader* _tmp24_;
#line 1911 "../src/Photo.vala"
							_tmp13_ = backing_photo_table_get_instance ();
#line 1911 "../src/Photo.vala"
							_tmp14_ = _tmp13_;
#line 1911 "../src/Photo.vala"
							_tmp15_ = self->row;
#line 1911 "../src/Photo.vala"
							_tmp16_ = _tmp15_->editable_id;
#line 1911 "../src/Photo.vala"
							_tmp17_ = filepath;
#line 1911 "../src/Photo.vala"
							backing_photo_table_set_filepath (_tmp14_, &_tmp16_, _tmp17_, &_inner_error0_);
#line 1911 "../src/Photo.vala"
							_database_table_unref0 (_tmp14_);
#line 1911 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1911 "../src/Photo.vala"
								_g_object_unref0 (_tmp3_);
#line 15388 "Photo.c"
								goto __finally2;
							}
#line 1913 "../src/Photo.vala"
							_tmp18_ = self->priv->editable;
#line 1913 "../src/Photo.vala"
							_tmp19_ = filepath;
#line 1913 "../src/Photo.vala"
							_tmp20_ = g_strdup (_tmp19_);
#line 1913 "../src/Photo.vala"
							_g_free0 (_tmp18_->filepath);
#line 1913 "../src/Photo.vala"
							_tmp18_->filepath = _tmp20_;
#line 1914 "../src/Photo.vala"
							_tmp21_ = self->priv->readers;
#line 1914 "../src/Photo.vala"
							_tmp22_ = self->priv->editable;
#line 1914 "../src/Photo.vala"
							_tmp23_ = filepath;
#line 1914 "../src/Photo.vala"
							_tmp24_ = photo_file_format_create_reader (_tmp22_->file_format, _tmp23_);
#line 1914 "../src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp21_->editable);
#line 1914 "../src/Photo.vala"
							_tmp21_->editable = _tmp24_;
#line 1916 "../src/Photo.vala"
							altered = TRUE;
#line 1917 "../src/Photo.vala"
							is_baseline = photo_is_editable_baseline (self);
#line 1918 "../src/Photo.vala"
							is_source = photo_is_editable_source (self);
#line 15419 "Photo.c"
						}
#line 1908 "../src/Photo.vala"
						_g_object_unref0 (_tmp3_);
#line 15423 "Photo.c"
					}
					__finally2:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp25_;
#line 1908 "../src/Photo.vala"
						_tmp25_ = self->priv->readers;
#line 1908 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 15433 "Photo.c"
					}
#line 1908 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15437 "Photo.c"
						goto __finally1;
					}
				}
			}
			__finally1:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp26_;
#line 1907 "../src/Photo.vala"
				_tmp26_ = self->row;
#line 1907 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15450 "Photo.c"
			}
#line 1907 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1907 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 15456 "Photo.c"
					goto __catch0_database_error;
				}
#line 1907 "../src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1907 "../src/Photo.vala"
				_g_free0 (filepath);
#line 1907 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1907 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1907 "../src/Photo.vala"
				return;
#line 15469 "Photo.c"
			}
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp27_;
#line 1906 "../src/Photo.vala"
		err = _inner_error0_;
#line 1906 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1923 "../src/Photo.vala"
		_tmp27_ = err;
#line 1923 "../src/Photo.vala"
		app_window_database_error (_tmp27_);
#line 1906 "../src/Photo.vala"
		_g_error_free0 (err);
#line 15488 "Photo.c"
	}
	__finally0:
#line 1906 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1906 "../src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1906 "../src/Photo.vala"
		_g_free0 (filepath);
#line 1906 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1906 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1906 "../src/Photo.vala"
		return;
#line 15503 "Photo.c"
	}
#line 1926 "../src/Photo.vala"
	if (altered) {
#line 15507 "Photo.c"
		GFile* _tmp28_;
		gchar** alteration_list = NULL;
		gchar** _tmp29_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar* _tmp30_;
		gchar** _tmp33_;
		gint _tmp33__length1;
		Alteration* _tmp34_;
		Alteration* _tmp35_;
#line 1927 "../src/Photo.vala"
		_tmp28_ = old_file;
#line 1927 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp28_, file);
#line 1929 "../src/Photo.vala"
		if (is_baseline) {
#line 1930 "../src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 15526 "Photo.c"
		}
#line 1932 "../src/Photo.vala"
		_tmp29_ = g_new0 (gchar*, 0 + 1);
#line 1932 "../src/Photo.vala"
		alteration_list = _tmp29_;
#line 1932 "../src/Photo.vala"
		alteration_list_length1 = 0;
#line 1932 "../src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1933 "../src/Photo.vala"
		_tmp30_ = g_strdup ("backing:editable");
#line 1933 "../src/Photo.vala"
		_vala_array_add100 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp30_);
#line 1935 "../src/Photo.vala"
		if (is_baseline) {
#line 15542 "Photo.c"
			gchar* _tmp31_;
#line 1936 "../src/Photo.vala"
			_tmp31_ = g_strdup ("backing:baseline");
#line 1936 "../src/Photo.vala"
			_vala_array_add101 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp31_);
#line 15548 "Photo.c"
		}
#line 1938 "../src/Photo.vala"
		if (is_source) {
#line 15552 "Photo.c"
			gchar* _tmp32_;
#line 1939 "../src/Photo.vala"
			_tmp32_ = g_strdup ("backing:source");
#line 1939 "../src/Photo.vala"
			_vala_array_add102 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp32_);
#line 15558 "Photo.c"
		}
#line 1941 "../src/Photo.vala"
		_tmp33_ = alteration_list;
#line 1941 "../src/Photo.vala"
		_tmp33__length1 = alteration_list_length1;
#line 1941 "../src/Photo.vala"
		_tmp34_ = alteration_new_from_array (_tmp33_, _tmp33__length1);
#line 1941 "../src/Photo.vala"
		_tmp35_ = _tmp34_;
#line 1941 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp35_);
#line 1941 "../src/Photo.vala"
		_alteration_unref0 (_tmp35_);
#line 1926 "../src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 15574 "Photo.c"
	}
#line 1899 "../src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1899 "../src/Photo.vala"
	_g_free0 (filepath);
#line 15580 "Photo.c"
}

void
photo_set_many_editable_file (GeeMap* map,
                              GError** error)
{
	GeeMapIterator* map_iter = NULL;
	GeeMapIterator* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1946 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 1947 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 1949 "../src/Photo.vala"
	_tmp0_ = gee_map_map_iterator (map);
#line 1949 "../src/Photo.vala"
	map_iter = _tmp0_;
#line 1950 "../src/Photo.vala"
	while (TRUE) {
#line 15600 "Photo.c"
		GeeMapIterator* _tmp1_;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		Photo* _tmp4_;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		GFile* _tmp7_;
#line 1950 "../src/Photo.vala"
		_tmp1_ = map_iter;
#line 1950 "../src/Photo.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 1950 "../src/Photo.vala"
			break;
#line 15614 "Photo.c"
		}
#line 1951 "../src/Photo.vala"
		_tmp2_ = map_iter;
#line 1951 "../src/Photo.vala"
		_tmp3_ = gee_map_iterator_get_key (_tmp2_);
#line 1951 "../src/Photo.vala"
		_tmp4_ = (Photo*) _tmp3_;
#line 1951 "../src/Photo.vala"
		_tmp5_ = map_iter;
#line 1951 "../src/Photo.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 1951 "../src/Photo.vala"
		_tmp7_ = (GFile*) _tmp6_;
#line 1951 "../src/Photo.vala"
		photo_set_editable_file (_tmp4_, _tmp7_);
#line 1951 "../src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 1951 "../src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 15634 "Photo.c"
	}
#line 1953 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1953 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1953 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1953 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1953 "../src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1953 "../src/Photo.vala"
			return;
#line 15648 "Photo.c"
		} else {
#line 1953 "../src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1953 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1953 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1953 "../src/Photo.vala"
			return;
#line 15658 "Photo.c"
		}
	}
#line 1946 "../src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 15663 "Photo.c"
}

GFile*
photo_get_actual_file (Photo* self)
{
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result = NULL;
#line 1958 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1959 "../src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1959 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1959 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1959 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1959 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1959 "../src/Photo.vala"
	result = _tmp3_;
#line 1959 "../src/Photo.vala"
	return result;
#line 15690 "Photo.c"
}

static GFile*
photo_real_get_master_file (MediaSource* base)
{
	Photo * self;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result = NULL;
#line 1962 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1963 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1963 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1963 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1963 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1963 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1963 "../src/Photo.vala"
	result = _tmp3_;
#line 1963 "../src/Photo.vala"
	return result;
#line 15718 "Photo.c"
}

GFile*
photo_get_editable_file (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GFile* result = NULL;
#line 1966 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1967 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1967 "../src/Photo.vala"
	reader = _tmp0_;
#line 1969 "../src/Photo.vala"
	_tmp2_ = reader;
#line 1969 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 15739 "Photo.c"
		PhotoFileReader* _tmp3_;
		GFile* _tmp4_;
#line 1969 "../src/Photo.vala"
		_tmp3_ = reader;
#line 1969 "../src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1969 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1969 "../src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 15750 "Photo.c"
	} else {
#line 1969 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1969 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 15756 "Photo.c"
	}
#line 1969 "../src/Photo.vala"
	result = _tmp1_;
#line 1969 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1969 "../src/Photo.vala"
	return result;
#line 15764 "Photo.c"
}

GeeCollection*
photo_get_raw_developer_files (Photo* self)
{
	GeeArrayList* ret = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result = NULL;
#line 1972 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1973 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1974 "../src/Photo.vala"
		result = NULL;
#line 1974 "../src/Photo.vala"
		return result;
#line 15782 "Photo.c"
	}
#line 1976 "../src/Photo.vala"
	_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1976 "../src/Photo.vala"
	ret = _tmp0_;
#line 15788 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1977 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 1977 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15795 "Photo.c"
		{
			{
				GeeIterator* _row_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
#line 1978 "../src/Photo.vala"
				_tmp2_ = self->priv->developments;
#line 1978 "../src/Photo.vala"
				_tmp3_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1978 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 1978 "../src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1978 "../src/Photo.vala"
				_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1978 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1978 "../src/Photo.vala"
				_g_object_unref0 (_tmp5_);
#line 1978 "../src/Photo.vala"
				_row_it = _tmp7_;
#line 1978 "../src/Photo.vala"
				while (TRUE) {
#line 15823 "Photo.c"
					GeeIterator* _tmp8_;
					BackingPhotoRow* row = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					GeeArrayList* _tmp11_;
					BackingPhotoRow* _tmp12_;
					const gchar* _tmp13_;
					GFile* _tmp14_;
					GFile* _tmp15_;
#line 1978 "../src/Photo.vala"
					_tmp8_ = _row_it;
#line 1978 "../src/Photo.vala"
					if (!gee_iterator_next (_tmp8_)) {
#line 1978 "../src/Photo.vala"
						break;
#line 15839 "Photo.c"
					}
#line 1978 "../src/Photo.vala"
					_tmp9_ = _row_it;
#line 1978 "../src/Photo.vala"
					_tmp10_ = gee_iterator_get (_tmp9_);
#line 1978 "../src/Photo.vala"
					row = (BackingPhotoRow*) _tmp10_;
#line 1979 "../src/Photo.vala"
					_tmp11_ = ret;
#line 1979 "../src/Photo.vala"
					_tmp12_ = row;
#line 1979 "../src/Photo.vala"
					_tmp13_ = _tmp12_->filepath;
#line 1979 "../src/Photo.vala"
					_tmp14_ = g_file_new_for_path (_tmp13_);
#line 1979 "../src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 1979 "../src/Photo.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp15_);
#line 1979 "../src/Photo.vala"
					_g_object_unref0 (_tmp15_);
#line 1978 "../src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 15863 "Photo.c"
				}
#line 1978 "../src/Photo.vala"
				_g_object_unref0 (_row_it);
#line 15867 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp16_;
#line 1977 "../src/Photo.vala"
			_tmp16_ = self->row;
#line 1977 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15877 "Photo.c"
		}
#line 1977 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1977 "../src/Photo.vala"
			_g_object_unref0 (ret);
#line 1977 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1977 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1977 "../src/Photo.vala"
			return NULL;
#line 15889 "Photo.c"
		}
	}
#line 1982 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (ret, GEE_TYPE_COLLECTION, GeeCollection);
#line 1982 "../src/Photo.vala"
	return result;
#line 15896 "Photo.c"
}

GFile*
photo_get_source_file (Photo* self)
{
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result = NULL;
#line 1985 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1986 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1986 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1986 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1986 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1986 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1986 "../src/Photo.vala"
	result = _tmp3_;
#line 1986 "../src/Photo.vala"
	return result;
#line 15923 "Photo.c"
}

PhotoFileFormat
photo_get_file_format (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileFormat result = 0;
#line 1989 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 15933 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1990 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1990 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15940 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 1991 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1991 "../src/Photo.vala"
			result = _tmp1_->file_format;
#line 15947 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 1990 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 1990 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15954 "Photo.c"
			}
#line 1991 "../src/Photo.vala"
			return result;
#line 15958 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 1990 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 1990 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15967 "Photo.c"
		}
#line 1990 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1990 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1990 "../src/Photo.vala"
		return 0;
#line 15975 "Photo.c"
	}
}

PhotoFileFormat
photo_get_best_export_file_format (Photo* self)
{
	PhotoFileFormat file_format = 0;
	PhotoFileFormat result = 0;
#line 1995 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 1996 "../src/Photo.vala"
	file_format = photo_get_file_format (self);
#line 1997 "../src/Photo.vala"
	if (!photo_file_format_can_write (file_format)) {
#line 1998 "../src/Photo.vala"
		file_format = photo_file_format_get_system_default_format ();
#line 15992 "Photo.c"
	}
#line 2000 "../src/Photo.vala"
	result = file_format;
#line 2000 "../src/Photo.vala"
	return result;
#line 15998 "Photo.c"
}

PhotoFileFormat
photo_get_master_file_format (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileFormat result = 0;
#line 2003 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 16008 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2004 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2004 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16015 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 2005 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 2005 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2005 "../src/Photo.vala"
			result = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 16025 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2004 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2004 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16032 "Photo.c"
			}
#line 2005 "../src/Photo.vala"
			return result;
#line 16036 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2004 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2004 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16045 "Photo.c"
		}
#line 2004 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2004 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2004 "../src/Photo.vala"
		return 0;
#line 16053 "Photo.c"
	}
}

static time_t
photo_real_get_timestamp (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	time_t result = 0;
#line 2009 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16065 "Photo.c"
	{
		PhotoRow* _tmp0_;
		time_t _tmp4_ = 0;
#line 2010 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2010 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16073 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2011 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2011 "../src/Photo.vala"
			result = _tmp1_->timestamp;
#line 16080 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2010 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2010 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16087 "Photo.c"
			}
#line 2011 "../src/Photo.vala"
			return result;
#line 16091 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2010 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2010 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16100 "Photo.c"
		}
#line 2010 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2010 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2010 "../src/Photo.vala"
		return _tmp4_;
#line 16108 "Photo.c"
	}
}

void
photo_get_photo_id (Photo* self,
                    PhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 2015 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 16119 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2016 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2016 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16126 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoID _tmp2_;
#line 2017 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2017 "../src/Photo.vala"
			_tmp2_ = _tmp1_->photo_id;
#line 2017 "../src/Photo.vala"
			*result = _tmp2_;
#line 16136 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2016 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2016 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16143 "Photo.c"
			}
#line 2017 "../src/Photo.vala"
			return;
#line 16147 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2016 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2016 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16156 "Photo.c"
		}
#line 2016 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2016 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2016 "../src/Photo.vala"
		return;
#line 16164 "Photo.c"
	}
}

static inline void
photo_real_get_event_id (MediaSource* base,
                         EventID* result)
{
	Photo * self;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
#line 2022 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2023 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 2023 "../src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 2023 "../src/Photo.vala"
	*result = _tmp1_;
#line 2023 "../src/Photo.vala"
	return;
#line 16185 "Photo.c"
}

inline gint64
photo_get_raw_event_id (Photo* self)
{
	PhotoRow* _tmp0_;
	EventID _tmp1_;
	gint64 result = 0LL;
#line 2027 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0LL);
#line 2028 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 2028 "../src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 2028 "../src/Photo.vala"
	result = _tmp1_.id;
#line 2028 "../src/Photo.vala"
	return result;
#line 16204 "Photo.c"
}

static void
photo_real_get_import_id (MediaSource* base,
                          ImportID* result)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2031 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16215 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2032 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2032 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16222 "Photo.c"
		{
			PhotoRow* _tmp1_;
			ImportID _tmp2_;
#line 2033 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2033 "../src/Photo.vala"
			_tmp2_ = _tmp1_->import_id;
#line 2033 "../src/Photo.vala"
			*result = _tmp2_;
#line 16232 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2032 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2032 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16239 "Photo.c"
			}
#line 2033 "../src/Photo.vala"
			return;
#line 16243 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2032 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2032 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16252 "Photo.c"
		}
#line 2032 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2032 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2032 "../src/Photo.vala"
		return;
#line 16260 "Photo.c"
	}
}

void
photo_get_editable_id (Photo* self,
                       BackingPhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 2037 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 16271 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2038 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2038 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16278 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoID _tmp2_;
#line 2039 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2039 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable_id;
#line 2039 "../src/Photo.vala"
			*result = _tmp2_;
#line 16288 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2038 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2038 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16295 "Photo.c"
			}
#line 2039 "../src/Photo.vala"
			return;
#line 16299 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2038 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2038 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16308 "Photo.c"
		}
#line 2038 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2038 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2038 "../src/Photo.vala"
		return;
#line 16316 "Photo.c"
	}
}

static gchar*
photo_real_get_master_md5 (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 2043 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16328 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2044 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2044 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16335 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2045 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2045 "../src/Photo.vala"
			_tmp2_ = _tmp1_->md5;
#line 2045 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2045 "../src/Photo.vala"
			result = _tmp3_;
#line 16348 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2044 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2044 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16355 "Photo.c"
			}
#line 2045 "../src/Photo.vala"
			return result;
#line 16359 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2044 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2044 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16368 "Photo.c"
		}
#line 2044 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2044 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2044 "../src/Photo.vala"
		return NULL;
#line 16376 "Photo.c"
	}
}

guint64
photo_get_flags (Photo* self)
{
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
#line 2051 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 16387 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 2052 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2052 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16395 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2053 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2053 "../src/Photo.vala"
			result = _tmp1_->flags;
#line 16402 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2052 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2052 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16409 "Photo.c"
			}
#line 2053 "../src/Photo.vala"
			return result;
#line 16413 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2052 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2052 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16422 "Photo.c"
		}
#line 2052 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2052 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2052 "../src/Photo.vala"
		return _tmp4_;
#line 16430 "Photo.c"
	}
}

static void
photo_notify_flags_altered (Photo* self,
                            Alteration* additional_alteration)
{
	Alteration* alteration = NULL;
	Alteration* _tmp0_;
	Alteration* _tmp3_;
#line 2057 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2057 "../src/Photo.vala"
	g_return_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration));
#line 2058 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 2058 "../src/Photo.vala"
	alteration = _tmp0_;
#line 2059 "../src/Photo.vala"
	if (additional_alteration != NULL) {
#line 16451 "Photo.c"
		Alteration* _tmp1_;
		Alteration* _tmp2_;
#line 2060 "../src/Photo.vala"
		_tmp1_ = alteration;
#line 2060 "../src/Photo.vala"
		_tmp2_ = alteration_compress (_tmp1_, additional_alteration);
#line 2060 "../src/Photo.vala"
		_alteration_unref0 (alteration);
#line 2060 "../src/Photo.vala"
		alteration = _tmp2_;
#line 16462 "Photo.c"
	}
#line 2062 "../src/Photo.vala"
	_tmp3_ = alteration;
#line 2062 "../src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp3_);
#line 2057 "../src/Photo.vala"
	_alteration_unref0 (alteration);
#line 16470 "Photo.c"
}

guint64
photo_replace_flags (Photo* self,
                     guint64 flags,
                     Alteration* additional_alteration)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
#line 2065 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2065 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 16485 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2067 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2067 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16492 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
#line 2068 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2068 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2068 "../src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 2068 "../src/Photo.vala"
			committed = photo_table_replace_flags (_tmp2_, &_tmp3_, flags);
#line 2068 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2069 "../src/Photo.vala"
			if (committed) {
#line 16509 "Photo.c"
				PhotoRow* _tmp4_;
#line 2070 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2070 "../src/Photo.vala"
				_tmp4_->flags = flags;
#line 16515 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2067 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2067 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16525 "Photo.c"
		}
#line 2067 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16529 "Photo.c"
			guint64 _tmp6_ = 0ULL;
#line 2067 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2067 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2067 "../src/Photo.vala"
			return _tmp6_;
#line 16537 "Photo.c"
		}
	}
#line 2073 "../src/Photo.vala"
	if (committed) {
#line 2074 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16544 "Photo.c"
	}
#line 2076 "../src/Photo.vala"
	result = flags;
#line 2076 "../src/Photo.vala"
	return result;
#line 16550 "Photo.c"
}

gboolean
photo_is_flag_set (Photo* self,
                   guint64 mask)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2079 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 16561 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 2080 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2080 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16569 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2081 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2081 "../src/Photo.vala"
			result = media_source_internal_is_flag_set (_tmp1_->flags, mask);
#line 16576 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2080 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2080 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16583 "Photo.c"
			}
#line 2081 "../src/Photo.vala"
			return result;
#line 16587 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2080 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2080 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16596 "Photo.c"
		}
#line 2080 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2080 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2080 "../src/Photo.vala"
		return _tmp4_;
#line 16604 "Photo.c"
	}
}

guint64
photo_add_flags (Photo* self,
                 guint64 mask,
                 Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
#line 2085 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2085 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2086 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2088 "../src/Photo.vala"
	committed = FALSE;
#line 16625 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2089 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2089 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16632 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2090 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2090 "../src/Photo.vala"
			flags = media_source_internal_add_flags (_tmp1_->flags, mask);
#line 2091 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2091 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 16644 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2092 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2092 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2092 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2092 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2092 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2093 "../src/Photo.vala"
				if (committed) {
#line 16660 "Photo.c"
					PhotoRow* _tmp6_;
#line 2094 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2094 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 16666 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2089 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2089 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16677 "Photo.c"
		}
#line 2089 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16681 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2089 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2089 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2089 "../src/Photo.vala"
			return _tmp8_;
#line 16689 "Photo.c"
		}
	}
#line 2098 "../src/Photo.vala"
	if (committed) {
#line 2099 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16696 "Photo.c"
	}
#line 2101 "../src/Photo.vala"
	result = flags;
#line 2101 "../src/Photo.vala"
	return result;
#line 16702 "Photo.c"
}

guint64
photo_remove_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
#line 2104 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2104 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2105 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2107 "../src/Photo.vala"
	committed = FALSE;
#line 16722 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2108 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2108 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16729 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2109 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2109 "../src/Photo.vala"
			flags = media_source_internal_remove_flags (_tmp1_->flags, mask);
#line 2110 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2110 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 16741 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2111 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2111 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2111 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2111 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2111 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2112 "../src/Photo.vala"
				if (committed) {
#line 16757 "Photo.c"
					PhotoRow* _tmp6_;
#line 2113 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2113 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 16763 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2108 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2108 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16774 "Photo.c"
		}
#line 2108 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16778 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2108 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2108 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2108 "../src/Photo.vala"
			return _tmp8_;
#line 16786 "Photo.c"
		}
	}
#line 2117 "../src/Photo.vala"
	if (committed) {
#line 2118 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16793 "Photo.c"
	}
#line 2120 "../src/Photo.vala"
	result = flags;
#line 2120 "../src/Photo.vala"
	return result;
#line 16799 "Photo.c"
}

guint64
photo_add_remove_flags (Photo* self,
                        guint64 add,
                        guint64 remove,
                        Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
#line 2123 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2123 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2124 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2126 "../src/Photo.vala"
	committed = FALSE;
#line 16820 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2127 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2127 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16827 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2128 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2128 "../src/Photo.vala"
			flags = (_tmp1_->flags | add) & (~remove);
#line 2129 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2129 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 16839 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2130 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2130 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2130 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2130 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2130 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2131 "../src/Photo.vala"
				if (committed) {
#line 16855 "Photo.c"
					PhotoRow* _tmp6_;
#line 2132 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2132 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 16861 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2127 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2127 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16872 "Photo.c"
		}
#line 2127 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16876 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2127 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2127 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2127 "../src/Photo.vala"
			return _tmp8_;
#line 16884 "Photo.c"
		}
	}
#line 2136 "../src/Photo.vala"
	if (committed) {
#line 2137 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16891 "Photo.c"
	}
#line 2139 "../src/Photo.vala"
	result = flags;
#line 2139 "../src/Photo.vala"
	return result;
#line 16897 "Photo.c"
}

void
photo_add_remove_many_flags (GeeCollection* add,
                             guint64 add_mask,
                             Alteration* additional_add_alteration,
                             GeeCollection* remove,
                             guint64 remove_mask,
                             Alteration* additional_remove_alteration,
                             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2142 "../src/Photo.vala"
	g_return_if_fail ((add == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (add, GEE_TYPE_COLLECTION));
#line 2142 "../src/Photo.vala"
	g_return_if_fail ((additional_add_alteration == NULL) || IS_ALTERATION (additional_add_alteration));
#line 2142 "../src/Photo.vala"
	g_return_if_fail ((remove == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (remove, GEE_TYPE_COLLECTION));
#line 2142 "../src/Photo.vala"
	g_return_if_fail ((additional_remove_alteration == NULL) || IS_ALTERATION (additional_remove_alteration));
#line 2145 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 2147 "../src/Photo.vala"
	if (add != NULL) {
#line 16922 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp0_;
#line 2148 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (add, GEE_TYPE_ITERABLE, GeeIterable));
#line 2148 "../src/Photo.vala"
			_photo_it = _tmp0_;
#line 2148 "../src/Photo.vala"
			while (TRUE) {
#line 16932 "Photo.c"
				GeeIterator* _tmp1_;
				Photo* photo = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Photo* _tmp4_;
#line 2148 "../src/Photo.vala"
				_tmp1_ = _photo_it;
#line 2148 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 2148 "../src/Photo.vala"
					break;
#line 16944 "Photo.c"
				}
#line 2148 "../src/Photo.vala"
				_tmp2_ = _photo_it;
#line 2148 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 2148 "../src/Photo.vala"
				photo = (Photo*) _tmp3_;
#line 2149 "../src/Photo.vala"
				_tmp4_ = photo;
#line 2149 "../src/Photo.vala"
				photo_add_flags (_tmp4_, add_mask, additional_add_alteration);
#line 2148 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 16958 "Photo.c"
			}
#line 2148 "../src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 16962 "Photo.c"
		}
	}
#line 2152 "../src/Photo.vala"
	if (remove != NULL) {
#line 16967 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp5_;
#line 2153 "../src/Photo.vala"
			_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (remove, GEE_TYPE_ITERABLE, GeeIterable));
#line 2153 "../src/Photo.vala"
			_photo_it = _tmp5_;
#line 2153 "../src/Photo.vala"
			while (TRUE) {
#line 16977 "Photo.c"
				GeeIterator* _tmp6_;
				Photo* photo = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				Photo* _tmp9_;
#line 2153 "../src/Photo.vala"
				_tmp6_ = _photo_it;
#line 2153 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 2153 "../src/Photo.vala"
					break;
#line 16989 "Photo.c"
				}
#line 2153 "../src/Photo.vala"
				_tmp7_ = _photo_it;
#line 2153 "../src/Photo.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 2153 "../src/Photo.vala"
				photo = (Photo*) _tmp8_;
#line 2154 "../src/Photo.vala"
				_tmp9_ = photo;
#line 2154 "../src/Photo.vala"
				photo_remove_flags (_tmp9_, remove_mask, additional_remove_alteration);
#line 2153 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 17003 "Photo.c"
			}
#line 2153 "../src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 17007 "Photo.c"
		}
	}
#line 2157 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 2157 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2157 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2157 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2157 "../src/Photo.vala"
			return;
#line 17020 "Photo.c"
		} else {
#line 2157 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2157 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2157 "../src/Photo.vala"
			return;
#line 17028 "Photo.c"
		}
	}
}

guint64
photo_toggle_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
#line 2160 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2160 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2161 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2163 "../src/Photo.vala"
	committed = FALSE;
#line 17050 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2164 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2164 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17057 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2165 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2165 "../src/Photo.vala"
			flags = _tmp1_->flags ^ mask;
#line 2166 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2166 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 17069 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2167 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2167 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2167 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2167 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2167 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2168 "../src/Photo.vala"
				if (committed) {
#line 17085 "Photo.c"
					PhotoRow* _tmp6_;
#line 2169 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2169 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 17091 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2164 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2164 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17102 "Photo.c"
		}
#line 2164 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17106 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2164 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2164 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2164 "../src/Photo.vala"
			return _tmp8_;
#line 17114 "Photo.c"
		}
	}
#line 2173 "../src/Photo.vala"
	if (committed) {
#line 2174 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17121 "Photo.c"
	}
#line 2176 "../src/Photo.vala"
	result = flags;
#line 2176 "../src/Photo.vala"
	return result;
#line 17127 "Photo.c"
}

gboolean
photo_is_master_metadata_dirty (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2179 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 17137 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 2180 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2180 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17145 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2181 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2181 "../src/Photo.vala"
			result = _tmp1_->metadata_dirty;
#line 17152 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2180 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2180 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17159 "Photo.c"
			}
#line 2181 "../src/Photo.vala"
			return result;
#line 17163 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2180 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2180 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17172 "Photo.c"
		}
#line 2180 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2180 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2180 "../src/Photo.vala"
		return _tmp4_;
#line 17180 "Photo.c"
	}
}

void
photo_set_master_metadata_dirty (Photo* self,
                                 gboolean dirty,
                                 GError** error)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2185 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2186 "../src/Photo.vala"
	committed = FALSE;
#line 17195 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2187 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2187 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17202 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2188 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2188 "../src/Photo.vala"
			if (_tmp1_->metadata_dirty != dirty) {
#line 17209 "Photo.c"
				PhotoTable* _tmp2_;
				PhotoTable* _tmp3_;
				PhotoID _tmp4_ = {0};
				PhotoRow* _tmp5_;
#line 2189 "../src/Photo.vala"
				_tmp2_ = photo_table_get_instance ();
#line 2189 "../src/Photo.vala"
				_tmp3_ = _tmp2_;
#line 2189 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp4_);
#line 2189 "../src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp3_, &_tmp4_, dirty, &_inner_error0_);
#line 2189 "../src/Photo.vala"
				_database_table_unref0 (_tmp3_);
#line 2189 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17226 "Photo.c"
					goto __finally0;
				}
#line 2190 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2190 "../src/Photo.vala"
				_tmp5_->metadata_dirty = dirty;
#line 2191 "../src/Photo.vala"
				committed = TRUE;
#line 17235 "Photo.c"
			}
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp6_;
#line 2187 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2187 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17246 "Photo.c"
		}
#line 2187 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2187 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2187 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 2187 "../src/Photo.vala"
				return;
#line 17256 "Photo.c"
			} else {
#line 2187 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2187 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2187 "../src/Photo.vala"
				return;
#line 17264 "Photo.c"
			}
		}
	}
#line 2195 "../src/Photo.vala"
	if (committed) {
#line 17270 "Photo.c"
		Alteration* _tmp7_;
		Alteration* _tmp8_;
#line 2196 "../src/Photo.vala"
		_tmp7_ = alteration_new ("metadata", "master-dirty");
#line 2196 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2196 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp8_);
#line 2196 "../src/Photo.vala"
		_alteration_unref0 (_tmp8_);
#line 17281 "Photo.c"
	}
}

static Rating
photo_real_get_rating (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	Rating result = 0;
#line 2199 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17293 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2200 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2200 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17300 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2201 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2201 "../src/Photo.vala"
			result = _tmp1_->rating;
#line 17307 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2200 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2200 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17314 "Photo.c"
			}
#line 2201 "../src/Photo.vala"
			return result;
#line 17318 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2200 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2200 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17327 "Photo.c"
		}
#line 2200 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2200 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2200 "../src/Photo.vala"
		return 0;
#line 17335 "Photo.c"
	}
}

static void
photo_real_set_rating (MediaSource* base,
                       Rating rating)
{
	Photo * self;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2205 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2206 "../src/Photo.vala"
	committed = FALSE;
#line 17350 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2208 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2208 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17357 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
#line 2209 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2209 "../src/Photo.vala"
			if (rating != _tmp2_->rating) {
#line 2209 "../src/Photo.vala"
				_tmp1_ = rating_is_valid (rating);
#line 17367 "Photo.c"
			} else {
#line 2209 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 17371 "Photo.c"
			}
#line 2209 "../src/Photo.vala"
			if (_tmp1_) {
#line 17375 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2210 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2210 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2210 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2210 "../src/Photo.vala"
				committed = photo_table_set_rating (_tmp4_, &_tmp5_, rating);
#line 2210 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2211 "../src/Photo.vala"
				if (committed) {
#line 17391 "Photo.c"
					PhotoRow* _tmp6_;
#line 2212 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2212 "../src/Photo.vala"
					_tmp6_->rating = rating;
#line 17397 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2208 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2208 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17408 "Photo.c"
		}
#line 2208 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2208 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2208 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2208 "../src/Photo.vala"
			return;
#line 17418 "Photo.c"
		}
	}
#line 2216 "../src/Photo.vala"
	if (committed) {
#line 17423 "Photo.c"
		Alteration* _tmp8_;
		Alteration* _tmp9_;
#line 2217 "../src/Photo.vala"
		_tmp8_ = alteration_new ("metadata", "rating");
#line 2217 "../src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 2217 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp9_);
#line 2217 "../src/Photo.vala"
		_alteration_unref0 (_tmp9_);
#line 17434 "Photo.c"
	}
}

static void
photo_real_increase_rating (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2220 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17445 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2221 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2221 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17452 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2222 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2222 "../src/Photo.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_increase (_tmp1_->rating));
#line 17459 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp2_;
#line 2221 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2221 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17468 "Photo.c"
		}
#line 2221 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2221 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2221 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2221 "../src/Photo.vala"
			return;
#line 17478 "Photo.c"
		}
	}
}

static void
photo_real_decrease_rating (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2226 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17490 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2227 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2227 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17497 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2228 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2228 "../src/Photo.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_decrease (_tmp1_->rating));
#line 17504 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp2_;
#line 2227 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2227 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17513 "Photo.c"
		}
#line 2227 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2227 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2227 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2227 "../src/Photo.vala"
			return;
#line 17523 "Photo.c"
		}
	}
}

static void
photo_real_commit_backlinks (DataSource* base,
                             SourceCollection* sources,
                             const gchar* backlinks)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2232 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2232 "../src/Photo.vala"
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
#line 17539 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 2237 "../src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 2237 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2237 "../src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2237 "../src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, backlinks, &_inner_error0_);
#line 2237 "../src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 2237 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2237 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 17558 "Photo.c"
				goto __catch0_database_error;
			}
#line 2237 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2237 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2237 "../src/Photo.vala"
			return;
#line 17567 "Photo.c"
		}
		{
			PhotoRow* _tmp3_;
#line 2238 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2238 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 17575 "Photo.c"
			{
				PhotoRow* _tmp4_;
				gchar* _tmp5_;
#line 2239 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2239 "../src/Photo.vala"
				_tmp5_ = g_strdup (backlinks);
#line 2239 "../src/Photo.vala"
				_g_free0 (_tmp4_->backlinks);
#line 2239 "../src/Photo.vala"
				_tmp4_->backlinks = _tmp5_;
#line 17587 "Photo.c"
			}
			__finally1:
			{
				PhotoRow* _tmp6_;
#line 2238 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2238 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17596 "Photo.c"
			}
#line 2238 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2238 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 17602 "Photo.c"
					goto __catch0_database_error;
				}
#line 2238 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2238 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2238 "../src/Photo.vala"
				return;
#line 17611 "Photo.c"
			}
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 2236 "../src/Photo.vala"
		err = _inner_error0_;
#line 2236 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2242 "../src/Photo.vala"
		_tmp7_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2242 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2242 "../src/Photo.vala"
		_tmp9_ = err;
#line 2242 "../src/Photo.vala"
		_tmp10_ = _tmp9_->message;
#line 2242 "../src/Photo.vala"
		g_warning ("Photo.vala:2242: Unable to update link state for %s: %s", _tmp8_, _tmp10_);
#line 2242 "../src/Photo.vala"
		_g_free0 (_tmp8_);
#line 2236 "../src/Photo.vala"
		_g_error_free0 (err);
#line 17641 "Photo.c"
	}
	__finally0:
#line 2236 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2236 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2236 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2236 "../src/Photo.vala"
		return;
#line 17652 "Photo.c"
	}
}

static gboolean
photo_real_set_event_id (MediaSource* base,
                         EventID* event_id)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2250 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2250 "../src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 17667 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp11_ = FALSE;
#line 2251 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2251 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17675 "Photo.c"
		{
			gboolean committed = FALSE;
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_;
#line 2252 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2252 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2252 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2252 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2252 "../src/Photo.vala"
			_tmp5_ = *event_id;
#line 2252 "../src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 2252 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2252 "../src/Photo.vala"
			committed = _tmp6_;
#line 2254 "../src/Photo.vala"
			if (committed) {
#line 17702 "Photo.c"
				PhotoRow* _tmp7_;
				EventID _tmp8_;
#line 2255 "../src/Photo.vala"
				_tmp7_ = self->row;
#line 2255 "../src/Photo.vala"
				_tmp8_ = *event_id;
#line 2255 "../src/Photo.vala"
				_tmp7_->event_id = _tmp8_;
#line 17711 "Photo.c"
			}
#line 2257 "../src/Photo.vala"
			result = committed;
#line 17715 "Photo.c"
			{
				PhotoRow* _tmp9_;
#line 2251 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 2251 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17722 "Photo.c"
			}
#line 2257 "../src/Photo.vala"
			return result;
#line 17726 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp10_;
#line 2251 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 2251 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17735 "Photo.c"
		}
#line 2251 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2251 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2251 "../src/Photo.vala"
		return _tmp11_;
#line 17743 "Photo.c"
	}
}

static gchar*
photo_real_to_string (DataObject* base)
{
	Photo * self;
	gchar* _tmp0_ = NULL;
	PhotoID _tmp9_ = {0};
	gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoFileReader* _tmp12_;
	PhotoFileReader* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* result = NULL;
#line 2261 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2263 "../src/Photo.vala"
	if (!photo_is_master_baseline (self)) {
#line 17766 "Photo.c"
		GFile* _tmp1_;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 2263 "../src/Photo.vala"
		_tmp1_ = photo_get_actual_file (self);
#line 2263 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2263 "../src/Photo.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 2263 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2263 "../src/Photo.vala"
		_tmp5_ = g_strconcat (" (", _tmp4_, NULL);
#line 2263 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2263 "../src/Photo.vala"
		_tmp7_ = g_strconcat (_tmp6_, ")", NULL);
#line 2263 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2263 "../src/Photo.vala"
		_tmp0_ = _tmp7_;
#line 2263 "../src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2263 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2263 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 17798 "Photo.c"
	} else {
		gchar* _tmp8_;
#line 2263 "../src/Photo.vala"
		_tmp8_ = g_strdup ("");
#line 2263 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2263 "../src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 17807 "Photo.c"
	}
#line 2262 "../src/Photo.vala"
	photo_get_photo_id (self, &_tmp9_);
#line 2262 "../src/Photo.vala"
	_tmp10_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp9_.id);
#line 2262 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 2262 "../src/Photo.vala"
	_tmp12_ = photo_get_master_reader (self);
#line 2262 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2262 "../src/Photo.vala"
	_tmp14_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2262 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 2262 "../src/Photo.vala"
	_tmp16_ = g_strdup_printf ("[%s] %s%s", _tmp11_, _tmp15_, _tmp0_);
#line 2262 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 2262 "../src/Photo.vala"
	_g_free0 (_tmp15_);
#line 2262 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp13_);
#line 2262 "../src/Photo.vala"
	_g_free0 (_tmp11_);
#line 2262 "../src/Photo.vala"
	result = _tmp17_;
#line 2262 "../src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2262 "../src/Photo.vala"
	return result;
#line 17839 "Photo.c"
}

static gboolean
photo_real_equals (DataSource* base,
                   DataSource* source)
{
	Photo * self;
	Photo* photo = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
	gboolean result = FALSE;
#line 2266 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2266 "../src/Photo.vala"
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
#line 2268 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_PHOTO (source) ? ((Photo*) source) : NULL);
#line 2268 "../src/Photo.vala"
	photo = _tmp0_;
#line 2269 "../src/Photo.vala"
	_tmp1_ = photo;
#line 2269 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 17863 "Photo.c"
		PhotoID photo_id = {0};
		PhotoID _tmp2_ = {0};
		PhotoID other_photo_id = {0};
		Photo* _tmp3_;
		PhotoID _tmp4_ = {0};
		gboolean _tmp5_ = FALSE;
		Photo* _tmp6_;
#line 2270 "../src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2270 "../src/Photo.vala"
		photo_id = _tmp2_;
#line 2271 "../src/Photo.vala"
		_tmp3_ = photo;
#line 2271 "../src/Photo.vala"
		photo_get_photo_id (_tmp3_, &_tmp4_);
#line 2271 "../src/Photo.vala"
		other_photo_id = _tmp4_;
#line 2273 "../src/Photo.vala"
		_tmp6_ = photo;
#line 2273 "../src/Photo.vala"
		if (self != _tmp6_) {
#line 17885 "Photo.c"
			PhotoID _tmp7_;
#line 2273 "../src/Photo.vala"
			_tmp7_ = photo_id;
#line 2273 "../src/Photo.vala"
			_tmp5_ = _tmp7_.id != PHOTO_ID_INVALID;
#line 17891 "Photo.c"
		} else {
#line 2273 "../src/Photo.vala"
			_tmp5_ = FALSE;
#line 17895 "Photo.c"
		}
#line 2273 "../src/Photo.vala"
		if (_tmp5_) {
#line 17899 "Photo.c"
			PhotoID _tmp8_;
			PhotoID _tmp9_;
#line 2274 "../src/Photo.vala"
			_tmp8_ = photo_id;
#line 2274 "../src/Photo.vala"
			_tmp9_ = other_photo_id;
#line 2274 "../src/Photo.vala"
			_vala_assert (_tmp8_.id != _tmp9_.id, "photo_id.id != other_photo_id.id");
#line 17908 "Photo.c"
		}
	}
#line 2278 "../src/Photo.vala"
	result = DATA_SOURCE_CLASS (photo_parent_class)->equals (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), TYPE_DATA_SOURCE, DataSource), source);
#line 2278 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 2278 "../src/Photo.vala"
	return result;
#line 17917 "Photo.c"
}

static void
photo_file_exif_updated (Photo* self)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFileInfo* info = NULL;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp7_;
	GTimeVal _tmp8_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	DetectedPhotoInformation* _tmp14_;
	gboolean _tmp15_ = FALSE;
	DetectedPhotoInformation* _tmp16_;
	gboolean success = FALSE;
	GError* _inner_error0_ = NULL;
#line 2282 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2283 "../src/Photo.vala"
	_tmp0_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2283 "../src/Photo.vala"
	file = _tmp0_;
#line 2285 "../src/Photo.vala"
	info = NULL;
#line 17945 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 2287 "../src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 2287 "../src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 2287 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17956 "Photo.c"
			goto __catch0_g_error;
		}
#line 2287 "../src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 2287 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 2287 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2287 "../src/Photo.vala"
		info = _tmp3_;
#line 2286 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 17969 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 2286 "../src/Photo.vala"
		err = _inner_error0_;
#line 2286 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2290 "../src/Photo.vala"
		_tmp4_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2290 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2290 "../src/Photo.vala"
		_tmp6_ = err->message;
#line 2290 "../src/Photo.vala"
		g_error ("Photo.vala:2290: Unable to read file information for %s: %s", _tmp5_, _tmp6_);
#line 2290 "../src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2286 "../src/Photo.vala"
		_g_error_free0 (err);
#line 17994 "Photo.c"
	}
	__finally0:
#line 2286 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2286 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2286 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2286 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2286 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2286 "../src/Photo.vala"
		return;
#line 18009 "Photo.c"
	}
#line 2293 "../src/Photo.vala"
	_tmp7_ = info;
#line 2293 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp7_, &_tmp8_);
#line 2293 "../src/Photo.vala"
	timestamp = _tmp8_;
#line 2296 "../src/Photo.vala"
	_tmp9_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 2296 "../src/Photo.vala"
	interrogator = _tmp9_;
#line 18021 "Photo.c"
	{
#line 2298 "../src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 2298 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18027 "Photo.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 2297 "../src/Photo.vala"
		err = _inner_error0_;
#line 2297 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2300 "../src/Photo.vala"
		_tmp10_ = g_file_get_path (file);
#line 2300 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 2300 "../src/Photo.vala"
		_tmp12_ = err;
#line 2300 "../src/Photo.vala"
		_tmp13_ = _tmp12_->message;
#line 2300 "../src/Photo.vala"
		g_warning ("Photo.vala:2300: Unable to interrogate photo file %s: %s", _tmp11_, _tmp13_);
#line 2300 "../src/Photo.vala"
		_g_free0 (_tmp11_);
#line 2297 "../src/Photo.vala"
		_g_error_free0 (err);
#line 18057 "Photo.c"
	}
	__finally1:
#line 2297 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2297 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2297 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2297 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2297 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2297 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2297 "../src/Photo.vala"
		return;
#line 18074 "Photo.c"
	}
#line 2303 "../src/Photo.vala"
	_tmp14_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 2303 "../src/Photo.vala"
	detected = _tmp14_;
#line 2304 "../src/Photo.vala"
	_tmp16_ = detected;
#line 2304 "../src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 2304 "../src/Photo.vala"
		_tmp15_ = TRUE;
#line 18086 "Photo.c"
	} else {
#line 2304 "../src/Photo.vala"
		_tmp15_ = photo_file_interrogator_get_is_photo_corrupted (interrogator);
#line 18090 "Photo.c"
	}
#line 2304 "../src/Photo.vala"
	if (_tmp15_) {
#line 18094 "Photo.c"
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 2305 "../src/Photo.vala"
		_tmp17_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2305 "../src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 2305 "../src/Photo.vala"
		g_critical ("Photo.vala:2305: file_exif_updated: %s no longer an image", _tmp18_);
#line 2305 "../src/Photo.vala"
		_g_free0 (_tmp18_);
#line 2307 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2307 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2307 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2307 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2307 "../src/Photo.vala"
		return;
#line 18115 "Photo.c"
	}
	{
		PhotoRow* _tmp19_;
#line 2311 "../src/Photo.vala"
		_tmp19_ = self->row;
#line 2311 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18123 "Photo.c"
		{
			PhotoTable* _tmp20_;
			PhotoTable* _tmp21_;
			PhotoID _tmp22_ = {0};
			GFileInfo* _tmp23_;
			GTimeVal _tmp24_;
			DetectedPhotoInformation* _tmp25_;
			const gchar* _tmp26_;
			DetectedPhotoInformation* _tmp27_;
			const gchar* _tmp28_;
			DetectedPhotoInformation* _tmp29_;
			const gchar* _tmp30_;
			PhotoRow* _tmp31_;
#line 2312 "../src/Photo.vala"
			_tmp20_ = photo_table_get_instance ();
#line 2312 "../src/Photo.vala"
			_tmp21_ = _tmp20_;
#line 2312 "../src/Photo.vala"
			photo_get_photo_id (self, &_tmp22_);
#line 2312 "../src/Photo.vala"
			_tmp23_ = info;
#line 2312 "../src/Photo.vala"
			_tmp24_ = timestamp;
#line 2312 "../src/Photo.vala"
			_tmp25_ = detected;
#line 2312 "../src/Photo.vala"
			_tmp26_ = _tmp25_->md5;
#line 2312 "../src/Photo.vala"
			_tmp27_ = detected;
#line 2312 "../src/Photo.vala"
			_tmp28_ = _tmp27_->exif_md5;
#line 2312 "../src/Photo.vala"
			_tmp29_ = detected;
#line 2312 "../src/Photo.vala"
			_tmp30_ = _tmp29_->thumbnail_md5;
#line 2312 "../src/Photo.vala"
			_tmp31_ = self->row;
#line 2312 "../src/Photo.vala"
			success = photo_table_master_exif_updated (_tmp21_, &_tmp22_, g_file_info_get_size (_tmp23_), _tmp24_.tv_sec, _tmp26_, _tmp28_, _tmp30_, _tmp31_);
#line 2312 "../src/Photo.vala"
			_database_table_unref0 (_tmp21_);
#line 18165 "Photo.c"
		}
		__finally2:
		{
			PhotoRow* _tmp32_;
#line 2311 "../src/Photo.vala"
			_tmp32_ = self->row;
#line 2311 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18174 "Photo.c"
		}
#line 2311 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2311 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2311 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 2311 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 2311 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 2311 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2311 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2311 "../src/Photo.vala"
			return;
#line 18192 "Photo.c"
		}
	}
#line 2316 "../src/Photo.vala"
	if (success) {
#line 18197 "Photo.c"
		Alteration* _tmp33_;
		Alteration* _tmp34_;
#line 2317 "../src/Photo.vala"
		_tmp33_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 2317 "../src/Photo.vala"
		_tmp34_ = _tmp33_;
#line 2317 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp34_);
#line 2317 "../src/Photo.vala"
		_alteration_unref0 (_tmp34_);
#line 18208 "Photo.c"
	}
#line 2282 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 2282 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 2282 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 2282 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 18218 "Photo.c"
}

static guint64
photo_real_get_filesize (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
#line 2322 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18229 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 2323 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2323 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18237 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2324 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2324 "../src/Photo.vala"
			result = (guint64) _tmp1_->filesize;
#line 18244 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2323 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2323 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18251 "Photo.c"
			}
#line 2324 "../src/Photo.vala"
			return result;
#line 18255 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2323 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2323 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18264 "Photo.c"
		}
#line 2323 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2323 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2323 "../src/Photo.vala"
		return _tmp4_;
#line 18272 "Photo.c"
	}
}

static guint64
photo_real_get_master_filesize (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
#line 2328 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18284 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2329 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2329 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18292 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
#line 2330 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2330 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2330 "../src/Photo.vala"
			result = (guint64) _tmp2_->filesize;
#line 18302 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2329 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2329 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18309 "Photo.c"
			}
#line 2330 "../src/Photo.vala"
			return result;
#line 18313 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2329 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2329 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18322 "Photo.c"
		}
#line 2329 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2329 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2329 "../src/Photo.vala"
		return _tmp5_;
#line 18330 "Photo.c"
	}
}

guint64
photo_get_editable_filesize (Photo* self)
{
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
#line 2334 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 18341 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 2335 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2335 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18349 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2336 "../src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 2336 "../src/Photo.vala"
			result = (guint64) _tmp1_->filesize;
#line 18356 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2335 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2335 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18363 "Photo.c"
			}
#line 2336 "../src/Photo.vala"
			return result;
#line 18367 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2335 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2335 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18376 "Photo.c"
		}
#line 2335 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2335 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2335 "../src/Photo.vala"
		return _tmp4_;
#line 18384 "Photo.c"
	}
}

static time_t
photo_real_get_exposure_time (Dateable* base)
{
	Photo * self;
	time_t result = 0;
#line 2340 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2341 "../src/Photo.vala"
	result = self->priv->cached_exposure_time;
#line 2341 "../src/Photo.vala"
	return result;
#line 18399 "Photo.c"
}

static gchar*
photo_real_get_basename (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 2344 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18410 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2345 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2345 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18417 "Photo.c"
		{
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 2346 "../src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 2346 "../src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 2346 "../src/Photo.vala"
			result = _tmp2_;
#line 18427 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2345 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2345 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18434 "Photo.c"
			}
#line 2346 "../src/Photo.vala"
			return result;
#line 18438 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2345 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2345 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18447 "Photo.c"
		}
#line 2345 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2345 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2345 "../src/Photo.vala"
		return NULL;
#line 18455 "Photo.c"
	}
}

static gchar*
photo_real_get_title (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 2350 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18467 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2351 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2351 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18474 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2352 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2352 "../src/Photo.vala"
			_tmp2_ = _tmp1_->title;
#line 2352 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2352 "../src/Photo.vala"
			result = _tmp3_;
#line 18487 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2351 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2351 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18494 "Photo.c"
			}
#line 2352 "../src/Photo.vala"
			return result;
#line 18498 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2351 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2351 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18507 "Photo.c"
		}
#line 2351 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2351 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2351 "../src/Photo.vala"
		return NULL;
#line 18515 "Photo.c"
	}
}

static gchar*
photo_real_get_comment (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 2356 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18527 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2357 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2357 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18534 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2358 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2358 "../src/Photo.vala"
			_tmp2_ = _tmp1_->comment;
#line 2358 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2358 "../src/Photo.vala"
			result = _tmp3_;
#line 18547 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2357 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2357 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18554 "Photo.c"
			}
#line 2358 "../src/Photo.vala"
			return result;
#line 18558 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2357 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2357 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18567 "Photo.c"
		}
#line 2357 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2357 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2357 "../src/Photo.vala"
		return NULL;
#line 18575 "Photo.c"
	}
}

static void
photo_real_set_title (MediaSource* base,
                      const gchar* title)
{
	Photo * self;
	gchar* new_title = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2362 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2363 "../src/Photo.vala"
	_tmp0_ = media_source_prep_title (title);
#line 2363 "../src/Photo.vala"
	new_title = _tmp0_;
#line 2365 "../src/Photo.vala"
	committed = FALSE;
#line 18596 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2366 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 2366 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18603 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
#line 2367 "../src/Photo.vala"
			_tmp2_ = new_title;
#line 2367 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2367 "../src/Photo.vala"
			_tmp4_ = _tmp3_->title;
#line 2367 "../src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 18621 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2366 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2366 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18628 "Photo.c"
				}
#line 2368 "../src/Photo.vala"
				_g_free0 (new_title);
#line 2368 "../src/Photo.vala"
				return;
#line 18634 "Photo.c"
			}
#line 2370 "../src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2370 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2370 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2370 "../src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2370 "../src/Photo.vala"
			_tmp10_ = new_title;
#line 2370 "../src/Photo.vala"
			committed = photo_table_set_title (_tmp7_, &_tmp9_, _tmp10_);
#line 2370 "../src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2371 "../src/Photo.vala"
			if (committed) {
#line 18652 "Photo.c"
				PhotoRow* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 2372 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2372 "../src/Photo.vala"
				_tmp12_ = new_title;
#line 2372 "../src/Photo.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 2372 "../src/Photo.vala"
				_g_free0 (_tmp11_->title);
#line 2372 "../src/Photo.vala"
				_tmp11_->title = _tmp13_;
#line 18666 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 2366 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2366 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18676 "Photo.c"
		}
#line 2366 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2366 "../src/Photo.vala"
			_g_free0 (new_title);
#line 2366 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2366 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2366 "../src/Photo.vala"
			return;
#line 18688 "Photo.c"
		}
	}
#line 2375 "../src/Photo.vala"
	if (committed) {
#line 18693 "Photo.c"
		Alteration* _tmp15_;
		Alteration* _tmp16_;
#line 2376 "../src/Photo.vala"
		_tmp15_ = alteration_new ("metadata", "name");
#line 2376 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2376 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp16_);
#line 2376 "../src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 18704 "Photo.c"
	}
#line 2362 "../src/Photo.vala"
	_g_free0 (new_title);
#line 18708 "Photo.c"
}

static void
photo_real_get_gps_coords (Positionable* base,
                           GpsCoords* result)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2379 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18719 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2380 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2380 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18726 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GpsCoords _tmp2_;
#line 2381 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2381 "../src/Photo.vala"
			_tmp2_ = _tmp1_->gps_coords;
#line 2381 "../src/Photo.vala"
			*result = _tmp2_;
#line 18736 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2380 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2380 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18743 "Photo.c"
			}
#line 2381 "../src/Photo.vala"
			return;
#line 18747 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2380 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2380 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18756 "Photo.c"
		}
#line 2380 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2380 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2380 "../src/Photo.vala"
		return;
#line 18764 "Photo.c"
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 2392 "../src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 18773 "Photo.c"
}

static void
photo_real_set_gps_coords (Positionable* base,
                           GpsCoords* gps_coords)
{
	Photo * self;
	GError* dberr = NULL;
	GError* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2385 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2385 "../src/Photo.vala"
	g_return_if_fail (gps_coords != NULL);
#line 2386 "../src/Photo.vala"
	dberr = NULL;
#line 18790 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2387 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2387 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18797 "Photo.c"
		{
			{
				PhotoTable* _tmp1_;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				GpsCoords _tmp5_;
				PhotoRow* _tmp7_;
				GpsCoords _tmp8_;
#line 2389 "../src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2389 "../src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2389 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2389 "../src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2389 "../src/Photo.vala"
				_tmp5_ = *gps_coords;
#line 2389 "../src/Photo.vala"
				photo_table_set_gps_coords (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 2389 "../src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2389 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2389 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 18825 "Photo.c"
						goto __catch1_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2387 "../src/Photo.vala"
						_tmp6_ = self->row;
#line 2387 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18834 "Photo.c"
					}
#line 2389 "../src/Photo.vala"
					_g_error_free0 (dberr);
#line 2389 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2389 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 2389 "../src/Photo.vala"
					return;
#line 18844 "Photo.c"
				}
#line 2390 "../src/Photo.vala"
				_tmp7_ = self->row;
#line 2390 "../src/Photo.vala"
				_tmp8_ = *gps_coords;
#line 2390 "../src/Photo.vala"
				_tmp7_->gps_coords = _tmp8_;
#line 18852 "Photo.c"
			}
			goto __finally1;
			__catch1_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2388 "../src/Photo.vala"
				err = _inner_error0_;
#line 2388 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 2392 "../src/Photo.vala"
				_tmp9_ = err;
#line 2392 "../src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2392 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2392 "../src/Photo.vala"
				dberr = _tmp10_;
#line 2388 "../src/Photo.vala"
				_g_error_free0 (err);
#line 18874 "Photo.c"
			}
			__finally1:
#line 2388 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2388 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2388 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2388 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2388 "../src/Photo.vala"
				return;
#line 18887 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp11_;
#line 2387 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2387 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18897 "Photo.c"
		}
#line 2387 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2387 "../src/Photo.vala"
			_g_error_free0 (dberr);
#line 2387 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2387 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2387 "../src/Photo.vala"
			return;
#line 18909 "Photo.c"
		}
	}
#line 2395 "../src/Photo.vala"
	_tmp12_ = dberr;
#line 2395 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 18916 "Photo.c"
		Alteration* _tmp13_;
		Alteration* _tmp14_;
#line 2396 "../src/Photo.vala"
		_tmp13_ = alteration_new ("metadata", "gps");
#line 2396 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2396 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp14_);
#line 2396 "../src/Photo.vala"
		_alteration_unref0 (_tmp14_);
#line 18927 "Photo.c"
	} else {
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 2398 "../src/Photo.vala"
		_tmp15_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2398 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2398 "../src/Photo.vala"
		_tmp17_ = dberr;
#line 2398 "../src/Photo.vala"
		_tmp18_ = _tmp17_->message;
#line 2398 "../src/Photo.vala"
		g_warning ("Photo.vala:2398: Unable to write gps coordinates for %s: %s", _tmp16_, _tmp18_);
#line 2398 "../src/Photo.vala"
		_g_free0 (_tmp16_);
#line 18945 "Photo.c"
	}
#line 2385 "../src/Photo.vala"
	_g_error_free0 (dberr);
#line 18949 "Photo.c"
}

static gboolean
photo_real_set_comment (MediaSource* base,
                        const gchar* comment)
{
	Photo * self;
	gchar* new_comment = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2402 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2403 "../src/Photo.vala"
	_tmp0_ = media_source_prep_comment (comment);
#line 2403 "../src/Photo.vala"
	new_comment = _tmp0_;
#line 2405 "../src/Photo.vala"
	committed = FALSE;
#line 18970 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2406 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 2406 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18977 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
#line 2407 "../src/Photo.vala"
			_tmp2_ = new_comment;
#line 2407 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2407 "../src/Photo.vala"
			_tmp4_ = _tmp3_->comment;
#line 2407 "../src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 2408 "../src/Photo.vala"
				result = TRUE;
#line 18997 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2406 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2406 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19004 "Photo.c"
				}
#line 2408 "../src/Photo.vala"
				_g_free0 (new_comment);
#line 2408 "../src/Photo.vala"
				return result;
#line 19010 "Photo.c"
			}
#line 2410 "../src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2410 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2410 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2410 "../src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2410 "../src/Photo.vala"
			_tmp10_ = new_comment;
#line 2410 "../src/Photo.vala"
			committed = photo_table_set_comment (_tmp7_, &_tmp9_, _tmp10_);
#line 2410 "../src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2411 "../src/Photo.vala"
			if (committed) {
#line 19028 "Photo.c"
				PhotoRow* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 2412 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2412 "../src/Photo.vala"
				_tmp12_ = new_comment;
#line 2412 "../src/Photo.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 2412 "../src/Photo.vala"
				_g_free0 (_tmp11_->comment);
#line 2412 "../src/Photo.vala"
				_tmp11_->comment = _tmp13_;
#line 19042 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 2406 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2406 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19052 "Photo.c"
		}
#line 2406 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19056 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 2406 "../src/Photo.vala"
			_g_free0 (new_comment);
#line 2406 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2406 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2406 "../src/Photo.vala"
			return _tmp15_;
#line 19066 "Photo.c"
		}
	}
#line 2415 "../src/Photo.vala"
	if (committed) {
#line 19071 "Photo.c"
		Alteration* _tmp16_;
		Alteration* _tmp17_;
#line 2416 "../src/Photo.vala"
		_tmp16_ = alteration_new ("metadata", "comment");
#line 2416 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2416 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp17_);
#line 2416 "../src/Photo.vala"
		_alteration_unref0 (_tmp17_);
#line 19082 "Photo.c"
	}
#line 2418 "../src/Photo.vala"
	result = committed;
#line 2418 "../src/Photo.vala"
	_g_free0 (new_comment);
#line 2418 "../src/Photo.vala"
	return result;
#line 19090 "Photo.c"
}

void
photo_set_import_id (Photo* self,
                     ImportID* import_id)
{
	GError* dberr = NULL;
	GError* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2421 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2421 "../src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 2422 "../src/Photo.vala"
	dberr = NULL;
#line 19106 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2423 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2423 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19113 "Photo.c"
		{
			{
				PhotoTable* _tmp1_;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				ImportID _tmp5_;
				PhotoRow* _tmp7_;
				ImportID _tmp8_;
#line 2425 "../src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2425 "../src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2425 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2425 "../src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2425 "../src/Photo.vala"
				_tmp5_ = *import_id;
#line 2425 "../src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 2425 "../src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2425 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2425 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 19141 "Photo.c"
						goto __catch1_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2423 "../src/Photo.vala"
						_tmp6_ = self->row;
#line 2423 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19150 "Photo.c"
					}
#line 2425 "../src/Photo.vala"
					_g_error_free0 (dberr);
#line 2425 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2425 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 2425 "../src/Photo.vala"
					return;
#line 19160 "Photo.c"
				}
#line 2426 "../src/Photo.vala"
				_tmp7_ = self->row;
#line 2426 "../src/Photo.vala"
				_tmp8_ = *import_id;
#line 2426 "../src/Photo.vala"
				_tmp7_->import_id = _tmp8_;
#line 19168 "Photo.c"
			}
			goto __finally1;
			__catch1_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2424 "../src/Photo.vala"
				err = _inner_error0_;
#line 2424 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 2428 "../src/Photo.vala"
				_tmp9_ = err;
#line 2428 "../src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2428 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2428 "../src/Photo.vala"
				dberr = _tmp10_;
#line 2424 "../src/Photo.vala"
				_g_error_free0 (err);
#line 19190 "Photo.c"
			}
			__finally1:
#line 2424 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2424 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2424 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2424 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2424 "../src/Photo.vala"
				return;
#line 19203 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp11_;
#line 2423 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2423 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19213 "Photo.c"
		}
#line 2423 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2423 "../src/Photo.vala"
			_g_error_free0 (dberr);
#line 2423 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2423 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2423 "../src/Photo.vala"
			return;
#line 19225 "Photo.c"
		}
	}
#line 2432 "../src/Photo.vala"
	_tmp12_ = dberr;
#line 2432 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 19232 "Photo.c"
		Alteration* _tmp13_;
		Alteration* _tmp14_;
#line 2433 "../src/Photo.vala"
		_tmp13_ = alteration_new ("metadata", "import-id");
#line 2433 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2433 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp14_);
#line 2433 "../src/Photo.vala"
		_alteration_unref0 (_tmp14_);
#line 19243 "Photo.c"
	} else {
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 2435 "../src/Photo.vala"
		_tmp15_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2435 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2435 "../src/Photo.vala"
		_tmp17_ = dberr;
#line 2435 "../src/Photo.vala"
		_tmp18_ = _tmp17_->message;
#line 2435 "../src/Photo.vala"
		g_warning ("Photo.vala:2435: Unable to write import ID for %s: %s", _tmp16_, _tmp18_);
#line 2435 "../src/Photo.vala"
		_g_free0 (_tmp16_);
#line 19261 "Photo.c"
	}
#line 2421 "../src/Photo.vala"
	_g_error_free0 (dberr);
#line 19265 "Photo.c"
}

void
photo_set_title_persistent (Photo* self,
                            const gchar* title,
                            GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2438 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2439 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2439 "../src/Photo.vala"
	source = _tmp0_;
#line 2442 "../src/Photo.vala"
	_tmp1_ = source;
#line 2442 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 19297 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2443 "../src/Photo.vala"
		_tmp2_ = source;
#line 2443 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2443 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2443 "../src/Photo.vala"
		g_warning ("Photo.vala:2443: No photo file writer available for %s", _tmp4_);
#line 2443 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2445 "../src/Photo.vala"
		media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), title);
#line 2447 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2447 "../src/Photo.vala"
		return;
#line 19317 "Photo.c"
	}
#line 2450 "../src/Photo.vala"
	_tmp5_ = source;
#line 2450 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2450 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2450 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2450 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2450 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2450 "../src/Photo.vala"
		return;
#line 19333 "Photo.c"
	}
#line 2451 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2451 "../src/Photo.vala"
	photo_metadata_set_title (_tmp7_, title, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2453 "../src/Photo.vala"
	_tmp8_ = source;
#line 2453 "../src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2453 "../src/Photo.vala"
	writer = _tmp9_;
#line 2453 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2453 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2453 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2453 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2453 "../src/Photo.vala"
		return;
#line 19355 "Photo.c"
	}
#line 2454 "../src/Photo.vala"
	_tmp10_ = source;
#line 2454 "../src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2454 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2454 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_title");
#line 2454 "../src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 19367 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2456 "../src/Photo.vala"
		_tmp13_ = writer;
#line 2456 "../src/Photo.vala"
		_tmp14_ = metadata;
#line 2456 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2456 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19379 "Photo.c"
			goto __finally0;
		}
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2458 "../src/Photo.vala"
		_tmp15_ = source;
#line 2458 "../src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2458 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2458 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2458 "../src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 19399 "Photo.c"
	}
#line 2455 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2455 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2455 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2455 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2455 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2455 "../src/Photo.vala"
		return;
#line 19413 "Photo.c"
	}
#line 2461 "../src/Photo.vala"
	media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), title);
#line 2463 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2438 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2438 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2438 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 19425 "Photo.c"
}

void
photo_set_comment_persistent (Photo* self,
                              const gchar* comment,
                              GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2466 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2467 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2467 "../src/Photo.vala"
	source = _tmp0_;
#line 2470 "../src/Photo.vala"
	_tmp1_ = source;
#line 2470 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 19457 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2471 "../src/Photo.vala"
		_tmp2_ = source;
#line 2471 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2471 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2471 "../src/Photo.vala"
		g_warning ("Photo.vala:2471: No photo file writer available for %s", _tmp4_);
#line 2471 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2473 "../src/Photo.vala"
		media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), comment);
#line 2475 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2475 "../src/Photo.vala"
		return;
#line 19477 "Photo.c"
	}
#line 2478 "../src/Photo.vala"
	_tmp5_ = source;
#line 2478 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2478 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2478 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2478 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2478 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2478 "../src/Photo.vala"
		return;
#line 19493 "Photo.c"
	}
#line 2479 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2479 "../src/Photo.vala"
	photo_metadata_set_comment (_tmp7_, comment, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2481 "../src/Photo.vala"
	_tmp8_ = source;
#line 2481 "../src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2481 "../src/Photo.vala"
	writer = _tmp9_;
#line 2481 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2481 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2481 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2481 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2481 "../src/Photo.vala"
		return;
#line 19515 "Photo.c"
	}
#line 2482 "../src/Photo.vala"
	_tmp10_ = source;
#line 2482 "../src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2482 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2482 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_comment");
#line 2482 "../src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 19527 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2484 "../src/Photo.vala"
		_tmp13_ = writer;
#line 2484 "../src/Photo.vala"
		_tmp14_ = metadata;
#line 2484 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2484 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19539 "Photo.c"
			goto __finally0;
		}
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2486 "../src/Photo.vala"
		_tmp15_ = source;
#line 2486 "../src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2486 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2486 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2486 "../src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 19559 "Photo.c"
	}
#line 2483 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2483 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2483 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2483 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2483 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2483 "../src/Photo.vala"
		return;
#line 19573 "Photo.c"
	}
#line 2489 "../src/Photo.vala"
	media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), comment);
#line 2491 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2466 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2466 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2466 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 19585 "Photo.c"
}

static void
photo_real_set_exposure_time (Dateable* base,
                              time_t time)
{
	Photo * self;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2494 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 19597 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2496 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2496 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19604 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
#line 2497 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2497 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2497 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2497 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2497 "../src/Photo.vala"
			committed = photo_table_set_exposure_time (_tmp2_, &_tmp4_, time);
#line 2497 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2498 "../src/Photo.vala"
			if (committed) {
#line 19624 "Photo.c"
				PhotoRow* _tmp5_;
#line 2499 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2499 "../src/Photo.vala"
				_tmp5_->exposure_time = time;
#line 2500 "../src/Photo.vala"
				self->priv->cached_exposure_time = time;
#line 19632 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 2496 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2496 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19642 "Photo.c"
		}
#line 2496 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2496 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2496 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2496 "../src/Photo.vala"
			return;
#line 19652 "Photo.c"
		}
	}
#line 2504 "../src/Photo.vala"
	if (committed) {
#line 19657 "Photo.c"
		Alteration* _tmp7_;
		Alteration* _tmp8_;
#line 2505 "../src/Photo.vala"
		_tmp7_ = alteration_new ("metadata", "exposure-time");
#line 2505 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2505 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp8_);
#line 2505 "../src/Photo.vala"
		_alteration_unref0 (_tmp8_);
#line 19668 "Photo.c"
	}
}

void
photo_set_exposure_time_persistent (Photo* self,
                                    time_t time,
                                    GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	MetadataDateTime* _tmp8_;
	MetadataDateTime* _tmp9_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp10_;
	PhotoFileMetadataWriter* _tmp11_;
	PhotoFileReader* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 2508 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2509 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2509 "../src/Photo.vala"
	source = _tmp0_;
#line 2512 "../src/Photo.vala"
	_tmp1_ = source;
#line 2512 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 19703 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2513 "../src/Photo.vala"
		_tmp2_ = source;
#line 2513 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2513 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2513 "../src/Photo.vala"
		g_warning ("Photo.vala:2513: No photo file writer available for %s", _tmp4_);
#line 2513 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2515 "../src/Photo.vala"
		dateable_set_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATEABLE, Dateable), time);
#line 2517 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2517 "../src/Photo.vala"
		return;
#line 19723 "Photo.c"
	}
#line 2520 "../src/Photo.vala"
	_tmp5_ = source;
#line 2520 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2520 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2520 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2520 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2520 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2520 "../src/Photo.vala"
		return;
#line 19739 "Photo.c"
	}
#line 2521 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2521 "../src/Photo.vala"
	_tmp8_ = metadata_date_time_new (time);
#line 2521 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 2521 "../src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp7_, _tmp9_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2521 "../src/Photo.vala"
	_metadata_date_time_unref0 (_tmp9_);
#line 2523 "../src/Photo.vala"
	_tmp10_ = source;
#line 2523 "../src/Photo.vala"
	_tmp11_ = photo_file_reader_create_metadata_writer (_tmp10_, &_inner_error0_);
#line 2523 "../src/Photo.vala"
	writer = _tmp11_;
#line 2523 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2523 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2523 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2523 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2523 "../src/Photo.vala"
		return;
#line 19767 "Photo.c"
	}
#line 2524 "../src/Photo.vala"
	_tmp12_ = source;
#line 2524 "../src/Photo.vala"
	_tmp13_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2524 "../src/Photo.vala"
	_tmp14_ = _tmp13_;
#line 2524 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp14_, "Photo.set_exposure_time_persistent");
#line 2524 "../src/Photo.vala"
	_g_object_unref0 (_tmp14_);
#line 19779 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp15_;
		PhotoMetadata* _tmp16_;
#line 2526 "../src/Photo.vala"
		_tmp15_ = writer;
#line 2526 "../src/Photo.vala"
		_tmp16_ = metadata;
#line 2526 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp15_, _tmp16_, &_inner_error0_);
#line 2526 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19791 "Photo.c"
			goto __finally0;
		}
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
#line 2528 "../src/Photo.vala"
		_tmp17_ = source;
#line 2528 "../src/Photo.vala"
		_tmp18_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2528 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2528 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp19_);
#line 2528 "../src/Photo.vala"
		_g_object_unref0 (_tmp19_);
#line 19811 "Photo.c"
	}
#line 2525 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2525 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2525 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2525 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2525 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2525 "../src/Photo.vala"
		return;
#line 19825 "Photo.c"
	}
#line 2531 "../src/Photo.vala"
	dateable_set_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATEABLE, Dateable), time);
#line 2533 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2508 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2508 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2508 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 19837 "Photo.c"
}

/**
     * @brief Returns the width and height of the Photo after various
     * arbitrary stages of the pipeline have been applied in
     * the same order they're applied in get_pixbuf_with_options.
     * With no argument passed, it works exactly like the
     * previous incarnation did.
     *
     * @param disallowed_steps Which pipeline steps should NOT
     *      be taken into account when computing image dimensions
     *      (matching the convention set by get_pixbuf_with_options()).
     *      Pipeline steps that do not affect the image geometry are
     *      ignored.
     */
static void
photo_real_get_dimensions (MediaSource* base,
                           PhotoException disallowed_steps,
                           Dimensions* result)
{
	Photo * self;
	Dimensions returned_dims = {0};
	Dimensions _tmp0_ = {0};
#line 2549 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2551 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2551 "../src/Photo.vala"
	returned_dims = _tmp0_;
#line 2554 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_ORIENTATION)) {
#line 19869 "Photo.c"
		Orientation ori_tmp = 0;
#line 2555 "../src/Photo.vala"
		ori_tmp = photo_get_orientation (self);
#line 2558 "../src/Photo.vala"
		switch (ori_tmp) {
#line 2558 "../src/Photo.vala"
			case ORIENTATION_LEFT_TOP:
#line 2558 "../src/Photo.vala"
			case ORIENTATION_RIGHT_TOP:
#line 2558 "../src/Photo.vala"
			case ORIENTATION_LEFT_BOTTOM:
#line 2558 "../src/Photo.vala"
			case ORIENTATION_RIGHT_BOTTOM:
#line 19883 "Photo.c"
			{
				gint width_tmp = 0;
				Dimensions _tmp1_;
				Dimensions _tmp2_;
#line 2564 "../src/Photo.vala"
				_tmp1_ = returned_dims;
#line 2564 "../src/Photo.vala"
				width_tmp = _tmp1_.width;
#line 2566 "../src/Photo.vala"
				_tmp2_ = returned_dims;
#line 2566 "../src/Photo.vala"
				returned_dims.width = _tmp2_.height;
#line 2567 "../src/Photo.vala"
				returned_dims.height = width_tmp;
#line 2568 "../src/Photo.vala"
				break;
#line 19900 "Photo.c"
			}
			default:
			{
#line 2572 "../src/Photo.vala"
				break;
#line 19906 "Photo.c"
			}
		}
	}
#line 2577 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 19912 "Photo.c"
		gdouble x_size = 0.0;
		gdouble y_size = 0.0;
		gdouble angle = 0.0;
		gdouble _tmp3_ = 0.0;
		Dimensions _tmp4_;
		Dimensions _tmp5_;
		gdouble _tmp6_ = 0.0;
		gdouble _tmp7_ = 0.0;
#line 2579 "../src/Photo.vala"
		angle = 0.0;
#line 2581 "../src/Photo.vala"
		photo_get_straighten (self, &_tmp3_);
#line 2581 "../src/Photo.vala"
		angle = _tmp3_;
#line 2583 "../src/Photo.vala"
		_tmp4_ = returned_dims;
#line 2583 "../src/Photo.vala"
		_tmp5_ = returned_dims;
#line 2583 "../src/Photo.vala"
		compute_arb_rotated_size ((gdouble) _tmp4_.width, (gdouble) _tmp5_.height, angle, &_tmp6_, &_tmp7_);
#line 2583 "../src/Photo.vala"
		x_size = _tmp6_;
#line 2583 "../src/Photo.vala"
		y_size = _tmp7_;
#line 2585 "../src/Photo.vala"
		returned_dims.width = (gint) x_size;
#line 2586 "../src/Photo.vala"
		returned_dims.height = (gint) y_size;
#line 19941 "Photo.c"
	}
#line 2590 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_CROP)) {
#line 19945 "Photo.c"
		Box crop = {0};
		Box _tmp8_ = {0};
		gboolean _tmp9_;
#line 2592 "../src/Photo.vala"
		_tmp9_ = photo_get_crop (self, &_tmp8_, disallowed_steps);
#line 2592 "../src/Photo.vala"
		crop = _tmp8_;
#line 2592 "../src/Photo.vala"
		if (_tmp9_) {
#line 19955 "Photo.c"
			Dimensions _tmp10_ = {0};
#line 2593 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp10_);
#line 2593 "../src/Photo.vala"
			returned_dims = _tmp10_;
#line 19961 "Photo.c"
		}
	}
#line 2596 "../src/Photo.vala"
	*result = returned_dims;
#line 2596 "../src/Photo.vala"
	return;
#line 19968 "Photo.c"
}

static void
photo_locked_create_adjustments_from_data (Photo* self)
{
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	PixelTransformationBundle* _tmp6_;
	PixelTransformer* _tmp7_;
#line 2600 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2601 "../src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2601 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2601 "../src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 2603 "../src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2603 "../src/Photo.vala"
	map = _tmp1_;
#line 2604 "../src/Photo.vala"
	_tmp2_ = map;
#line 2604 "../src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 19996 "Photo.c"
		PixelTransformationBundle* _tmp3_;
#line 2605 "../src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 2605 "../src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 20002 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_;
		KeyValueMap* _tmp5_;
#line 2607 "../src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 2607 "../src/Photo.vala"
		_tmp5_ = map;
#line 2607 "../src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 20012 "Photo.c"
	}
#line 2609 "../src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 2609 "../src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2609 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2609 "../src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 2600 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 20024 "Photo.c"
}

PixelTransformationBundle*
photo_get_color_adjustments (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PixelTransformationBundle* result = NULL;
#line 2613 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 20034 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2614 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2614 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20041 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_;
			PixelTransformationBundle* _tmp2_;
			PixelTransformationBundle* _tmp3_;
#line 2615 "../src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 2615 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2616 "../src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 20052 "Photo.c"
			}
#line 2618 "../src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 2618 "../src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 2618 "../src/Photo.vala"
			result = _tmp3_;
#line 20060 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2614 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2614 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20067 "Photo.c"
			}
#line 2618 "../src/Photo.vala"
			return result;
#line 20071 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2614 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2614 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20080 "Photo.c"
		}
#line 2614 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2614 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2614 "../src/Photo.vala"
		return NULL;
#line 20088 "Photo.c"
	}
}

PixelTransformer*
photo_get_pixel_transformer (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PixelTransformer* result = NULL;
#line 2622 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 20099 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2623 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2623 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20106 "Photo.c"
		{
			PixelTransformer* _tmp1_;
			PixelTransformer* _tmp2_;
			PixelTransformer* _tmp3_;
#line 2624 "../src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 2624 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2625 "../src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 20117 "Photo.c"
			}
#line 2627 "../src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2627 "../src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 2627 "../src/Photo.vala"
			result = _tmp3_;
#line 20125 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2623 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2623 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20132 "Photo.c"
			}
#line 2627 "../src/Photo.vala"
			return result;
#line 20136 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2623 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2623 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20145 "Photo.c"
		}
#line 2623 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2623 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2623 "../src/Photo.vala"
		return NULL;
#line 20153 "Photo.c"
	}
}

gboolean
photo_has_color_adjustments (Photo* self)
{
	gboolean result = FALSE;
#line 2631 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2632 "../src/Photo.vala"
	result = photo_has_transformation (self, "adjustments");
#line 2632 "../src/Photo.vala"
	return result;
#line 20167 "Photo.c"
}

PixelTransformation*
photo_get_color_adjustment (Photo* self,
                            PixelTransformationType type)
{
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	PixelTransformation* _tmp2_;
	PixelTransformation* _tmp3_;
	PixelTransformation* result = NULL;
#line 2635 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2636 "../src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 2636 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2636 "../src/Photo.vala"
	_tmp2_ = pixel_transformation_bundle_get_transformation (_tmp1_, type);
#line 2636 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2636 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 2636 "../src/Photo.vala"
	result = _tmp3_;
#line 2636 "../src/Photo.vala"
	return result;
#line 20195 "Photo.c"
}

void
photo_set_color_adjustments (Photo* self,
                             PixelTransformationBundle* new_adjustments)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp4_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2639 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2639 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_adjustments, TYPE_PIXEL_TRANSFORMATION_BUNDLE));
#line 2642 "../src/Photo.vala"
	if (pixel_transformation_bundle_is_identity (new_adjustments)) {
#line 20212 "Photo.c"
		gboolean _result_ = FALSE;
		{
			PhotoRow* _tmp0_;
#line 2644 "../src/Photo.vala"
			_tmp0_ = self->row;
#line 2644 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 20220 "Photo.c"
			{
#line 2645 "../src/Photo.vala"
				_result_ = photo_remove_transformation (self, "adjustments");
#line 2646 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2646 "../src/Photo.vala"
				self->priv->adjustments = NULL;
#line 2647 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2647 "../src/Photo.vala"
				self->priv->transformer = NULL;
#line 20232 "Photo.c"
			}
			__finally0:
			{
				PhotoRow* _tmp1_;
#line 2644 "../src/Photo.vala"
				_tmp1_ = self->row;
#line 2644 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20241 "Photo.c"
			}
#line 2644 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2644 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2644 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2644 "../src/Photo.vala"
				return;
#line 20251 "Photo.c"
			}
		}
#line 2650 "../src/Photo.vala"
		if (_result_) {
#line 20256 "Photo.c"
			Alteration* _tmp2_;
			Alteration* _tmp3_;
#line 2651 "../src/Photo.vala"
			_tmp2_ = alteration_new ("image", "color-adjustments");
#line 2651 "../src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 2651 "../src/Photo.vala"
			data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp3_);
#line 2651 "../src/Photo.vala"
			_alteration_unref0 (_tmp3_);
#line 20267 "Photo.c"
		}
#line 2653 "../src/Photo.vala"
		return;
#line 20271 "Photo.c"
	}
#line 2657 "../src/Photo.vala"
	_tmp4_ = pixel_transformation_bundle_save (new_adjustments, "adjustments");
#line 2657 "../src/Photo.vala"
	map = _tmp4_;
#line 20277 "Photo.c"
	{
		PhotoRow* _tmp5_;
#line 2660 "../src/Photo.vala"
		_tmp5_ = self->row;
#line 2660 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20284 "Photo.c"
		{
			gboolean _tmp6_ = FALSE;
			PixelTransformer* _tmp7_;
			KeyValueMap* _tmp25_;
#line 2661 "../src/Photo.vala"
			_tmp7_ = self->priv->transformer;
#line 2661 "../src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 2661 "../src/Photo.vala"
				_tmp6_ = TRUE;
#line 20295 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp8_;
#line 2661 "../src/Photo.vala"
				_tmp8_ = self->priv->adjustments;
#line 2661 "../src/Photo.vala"
				_tmp6_ = _tmp8_ == NULL;
#line 20302 "Photo.c"
			}
#line 2661 "../src/Photo.vala"
			if (_tmp6_) {
#line 20306 "Photo.c"
				PixelTransformationBundle* _tmp9_;
				PixelTransformer* _tmp10_;
#line 2663 "../src/Photo.vala"
				_tmp9_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2663 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2663 "../src/Photo.vala"
				self->priv->adjustments = _tmp9_;
#line 2664 "../src/Photo.vala"
				_tmp10_ = pixel_transformation_bundle_generate_transformer (new_adjustments);
#line 2664 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2664 "../src/Photo.vala"
				self->priv->transformer = _tmp10_;
#line 20321 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp24_;
				{
					GeeIterator* _transformation_it = NULL;
					GeeIterable* _tmp11_;
					GeeIterable* _tmp12_;
					GeeIterator* _tmp13_;
					GeeIterator* _tmp14_;
#line 2667 "../src/Photo.vala"
					_tmp11_ = pixel_transformation_bundle_get_transformations (new_adjustments);
#line 2667 "../src/Photo.vala"
					_tmp12_ = _tmp11_;
#line 2667 "../src/Photo.vala"
					_tmp13_ = gee_iterable_iterator (_tmp12_);
#line 2667 "../src/Photo.vala"
					_tmp14_ = _tmp13_;
#line 2667 "../src/Photo.vala"
					_g_object_unref0 (_tmp12_);
#line 2667 "../src/Photo.vala"
					_transformation_it = _tmp14_;
#line 2667 "../src/Photo.vala"
					while (TRUE) {
#line 20344 "Photo.c"
						GeeIterator* _tmp15_;
						PixelTransformation* transformation = NULL;
						GeeIterator* _tmp16_;
						gpointer _tmp17_;
						PixelTransformer* _tmp18_;
						PixelTransformationBundle* _tmp19_;
						PixelTransformation* _tmp20_;
						PixelTransformation* _tmp21_;
						PixelTransformation* _tmp22_;
						PixelTransformation* _tmp23_;
#line 2667 "../src/Photo.vala"
						_tmp15_ = _transformation_it;
#line 2667 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp15_)) {
#line 2667 "../src/Photo.vala"
							break;
#line 20361 "Photo.c"
						}
#line 2667 "../src/Photo.vala"
						_tmp16_ = _transformation_it;
#line 2667 "../src/Photo.vala"
						_tmp17_ = gee_iterator_get (_tmp16_);
#line 2667 "../src/Photo.vala"
						transformation = (PixelTransformation*) _tmp17_;
#line 2668 "../src/Photo.vala"
						_tmp18_ = self->priv->transformer;
#line 2668 "../src/Photo.vala"
						_tmp19_ = self->priv->adjustments;
#line 2668 "../src/Photo.vala"
						_tmp20_ = transformation;
#line 2668 "../src/Photo.vala"
						_tmp21_ = pixel_transformation_bundle_get_transformation (_tmp19_, pixel_transformation_get_transformation_type (_tmp20_));
#line 2668 "../src/Photo.vala"
						_tmp22_ = _tmp21_;
#line 2668 "../src/Photo.vala"
						_tmp23_ = transformation;
#line 2668 "../src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp18_, _tmp22_, _tmp23_);
#line 2668 "../src/Photo.vala"
						_pixel_transformation_unref0 (_tmp22_);
#line 2667 "../src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 20387 "Photo.c"
					}
#line 2667 "../src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 20391 "Photo.c"
				}
#line 2673 "../src/Photo.vala"
				_tmp24_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2673 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2673 "../src/Photo.vala"
				self->priv->adjustments = _tmp24_;
#line 20399 "Photo.c"
			}
#line 2676 "../src/Photo.vala"
			_tmp25_ = map;
#line 2676 "../src/Photo.vala"
			committed = photo_set_transformation (self, _tmp25_);
#line 20405 "Photo.c"
		}
		__finally1:
		{
			PhotoRow* _tmp26_;
#line 2660 "../src/Photo.vala"
			_tmp26_ = self->row;
#line 2660 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20414 "Photo.c"
		}
#line 2660 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2660 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2660 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2660 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2660 "../src/Photo.vala"
			return;
#line 20426 "Photo.c"
		}
	}
#line 2679 "../src/Photo.vala"
	if (committed) {
#line 20431 "Photo.c"
		Alteration* _tmp27_;
		Alteration* _tmp28_;
#line 2680 "../src/Photo.vala"
		_tmp27_ = alteration_new ("image", "color-adjustments");
#line 2680 "../src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 2680 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp28_);
#line 2680 "../src/Photo.vala"
		_alteration_unref0 (_tmp28_);
#line 20442 "Photo.c"
	}
#line 2639 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 20446 "Photo.c"
}

static PhotoMetadata*
photo_real_get_metadata (PhotoSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	PhotoMetadata* result = NULL;
#line 2684 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 20457 "Photo.c"
	{
		PhotoMetadata* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_;
		PhotoFileReader* _tmp2_;
		PhotoMetadata* _tmp3_;
		PhotoMetadata* _tmp4_;
		PhotoMetadata* _tmp5_;
#line 2686 "../src/Photo.vala"
		_tmp1_ = photo_get_source_reader (self);
#line 2686 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2686 "../src/Photo.vala"
		_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2686 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2686 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2686 "../src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 2686 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20479 "Photo.c"
			goto __catch0_g_error;
		}
#line 2686 "../src/Photo.vala"
		_tmp5_ = _tmp0_;
#line 2686 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 2686 "../src/Photo.vala"
		result = _tmp5_;
#line 2686 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp0_);
#line 2686 "../src/Photo.vala"
		return result;
#line 20492 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 2685 "../src/Photo.vala"
		err = _inner_error0_;
#line 2685 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2688 "../src/Photo.vala"
		_tmp6_ = err;
#line 2688 "../src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 2688 "../src/Photo.vala"
		g_warning ("Photo.vala:2688: Unable to load metadata: %s", _tmp7_);
#line 2690 "../src/Photo.vala"
		result = NULL;
#line 2690 "../src/Photo.vala"
		_g_error_free0 (err);
#line 2690 "../src/Photo.vala"
		return result;
#line 20516 "Photo.c"
	}
	__finally0:
#line 2685 "../src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2685 "../src/Photo.vala"
	g_clear_error (&_inner_error0_);
#line 2685 "../src/Photo.vala"
	return NULL;
#line 20525 "Photo.c"
}

PhotoMetadata*
photo_get_master_metadata (Photo* self,
                           GError** error)
{
	PhotoMetadata* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	PhotoMetadata* _tmp5_;
	GError* _inner_error0_ = NULL;
	PhotoMetadata* result = NULL;
#line 2694 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2695 "../src/Photo.vala"
	_tmp1_ = photo_get_master_reader (self);
#line 2695 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 2695 "../src/Photo.vala"
	_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2695 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2695 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2695 "../src/Photo.vala"
	_tmp0_ = _tmp4_;
#line 2695 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2695 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2695 "../src/Photo.vala"
		return NULL;
#line 20560 "Photo.c"
	}
#line 2695 "../src/Photo.vala"
	_tmp5_ = _tmp0_;
#line 2695 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 2695 "../src/Photo.vala"
	result = _tmp5_;
#line 2695 "../src/Photo.vala"
	_media_metadata_unref0 (_tmp0_);
#line 2695 "../src/Photo.vala"
	return result;
#line 20572 "Photo.c"
}

PhotoMetadata*
photo_get_editable_metadata (Photo* self,
                             GError** error)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GError* _inner_error0_ = NULL;
	PhotoMetadata* result = NULL;
#line 2698 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2699 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2699 "../src/Photo.vala"
	reader = _tmp0_;
#line 2701 "../src/Photo.vala"
	_tmp2_ = reader;
#line 2701 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 20595 "Photo.c"
		PhotoFileReader* _tmp3_;
		PhotoMetadata* _tmp4_;
#line 2701 "../src/Photo.vala"
		_tmp3_ = reader;
#line 2701 "../src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error0_);
#line 2701 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2701 "../src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 2701 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2701 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2701 "../src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 2701 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2701 "../src/Photo.vala"
			return NULL;
#line 20616 "Photo.c"
		}
	} else {
#line 2701 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2701 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 20623 "Photo.c"
	}
#line 2701 "../src/Photo.vala"
	result = _tmp1_;
#line 2701 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2701 "../src/Photo.vala"
	return result;
#line 20631 "Photo.c"
}

gboolean
photo_persist_master_metadata (Photo* self,
                               PhotoMetadata* metadata,
                               PhotoReimportMasterState** state,
                               GError** error)
{
	PhotoReimportMasterState* _vala_state = NULL;
	PhotoFileReader* master_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileMetadataWriter* _tmp2_ = NULL;
	PhotoFileReader* _tmp3_;
	PhotoFileMetadataWriter* _tmp4_;
	gboolean _tmp7_ = FALSE;
	PhotoReimportMasterState* _tmp8_ = NULL;
	gboolean _tmp9_;
	PhotoReimportMasterState* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2707 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2707 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2709 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2709 "../src/Photo.vala"
	_vala_state = NULL;
#line 2711 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2711 "../src/Photo.vala"
	master_reader = _tmp0_;
#line 2713 "../src/Photo.vala"
	_tmp1_ = master_reader;
#line 2713 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 2714 "../src/Photo.vala"
		result = FALSE;
#line 2714 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2714 "../src/Photo.vala"
		if (state) {
#line 2714 "../src/Photo.vala"
			*state = _vala_state;
#line 20677 "Photo.c"
		} else {
#line 2714 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 20681 "Photo.c"
		}
#line 2714 "../src/Photo.vala"
		return result;
#line 20685 "Photo.c"
	}
#line 2716 "../src/Photo.vala"
	_tmp3_ = master_reader;
#line 2716 "../src/Photo.vala"
	_tmp4_ = photo_file_reader_create_metadata_writer (_tmp3_, &_inner_error0_);
#line 2716 "../src/Photo.vala"
	_tmp2_ = _tmp4_;
#line 2716 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20695 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 2716 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2716 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2716 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 2716 "../src/Photo.vala"
		return _tmp5_;
#line 20705 "Photo.c"
	}
#line 2716 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp2_, metadata, &_inner_error0_);
#line 2716 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20711 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2716 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2716 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2716 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2716 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 2716 "../src/Photo.vala"
		return _tmp6_;
#line 20723 "Photo.c"
	}
#line 2718 "../src/Photo.vala"
	_tmp9_ = photo_prepare_for_reimport_master (self, &_tmp8_, &_inner_error0_);
#line 2718 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2718 "../src/Photo.vala"
	_vala_state = _tmp8_;
#line 2718 "../src/Photo.vala"
	_tmp7_ = _tmp9_;
#line 2718 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20735 "Photo.c"
		gboolean _tmp10_ = FALSE;
#line 2718 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2718 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2718 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2718 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 2718 "../src/Photo.vala"
		return _tmp10_;
#line 20747 "Photo.c"
	}
#line 2718 "../src/Photo.vala"
	if (!_tmp7_) {
#line 2719 "../src/Photo.vala"
		result = FALSE;
#line 2719 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2719 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2719 "../src/Photo.vala"
		if (state) {
#line 2719 "../src/Photo.vala"
			*state = _vala_state;
#line 20761 "Photo.c"
		} else {
#line 2719 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 20765 "Photo.c"
		}
#line 2719 "../src/Photo.vala"
		return result;
#line 20769 "Photo.c"
	}
#line 2721 "../src/Photo.vala"
	_tmp11_ = _vala_state;
#line 2721 "../src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl)->metadata_only = TRUE;
#line 2723 "../src/Photo.vala"
	result = TRUE;
#line 2723 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2723 "../src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 2723 "../src/Photo.vala"
	if (state) {
#line 2723 "../src/Photo.vala"
		*state = _vala_state;
#line 20785 "Photo.c"
	} else {
#line 2723 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 20789 "Photo.c"
	}
#line 2723 "../src/Photo.vala"
	return result;
#line 20793 "Photo.c"
}

void
photo_finish_update_master_metadata (Photo* self,
                                     PhotoReimportMasterState* state,
                                     GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2726 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2726 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 2727 "../src/Photo.vala"
	photo_finish_reimport_master (self, state, &_inner_error0_);
#line 2727 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2727 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2727 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2727 "../src/Photo.vala"
			return;
#line 20816 "Photo.c"
		} else {
#line 2727 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2727 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2727 "../src/Photo.vala"
			return;
#line 20824 "Photo.c"
		}
	}
}

gboolean
photo_persist_editable_metadata (Photo* self,
                                 PhotoMetadata* metadata,
                                 PhotoReimportEditableState** state,
                                 GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	PhotoFileReader* editable_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileMetadataWriter* _tmp3_ = NULL;
	PhotoFileReader* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	gboolean _tmp8_ = FALSE;
	PhotoReimportEditableState* _tmp9_ = NULL;
	gboolean _tmp10_;
	PhotoReimportEditableState* _tmp12_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2730 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2730 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2732 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2732 "../src/Photo.vala"
	_vala_state = NULL;
#line 2734 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2734 "../src/Photo.vala"
	editable_reader = _tmp0_;
#line 2735 "../src/Photo.vala"
	_tmp1_ = editable_reader;
#line 2735 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2736 "../src/Photo.vala"
		result = FALSE;
#line 2736 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2736 "../src/Photo.vala"
		if (state) {
#line 2736 "../src/Photo.vala"
			*state = _vala_state;
#line 20873 "Photo.c"
		} else {
#line 2736 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 20877 "Photo.c"
		}
#line 2736 "../src/Photo.vala"
		return result;
#line 20881 "Photo.c"
	}
#line 2738 "../src/Photo.vala"
	_tmp2_ = editable_reader;
#line 2738 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 2739 "../src/Photo.vala"
		result = FALSE;
#line 2739 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2739 "../src/Photo.vala"
		if (state) {
#line 2739 "../src/Photo.vala"
			*state = _vala_state;
#line 20895 "Photo.c"
		} else {
#line 2739 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 20899 "Photo.c"
		}
#line 2739 "../src/Photo.vala"
		return result;
#line 20903 "Photo.c"
	}
#line 2741 "../src/Photo.vala"
	_tmp4_ = editable_reader;
#line 2741 "../src/Photo.vala"
	_tmp5_ = photo_file_reader_create_metadata_writer (_tmp4_, &_inner_error0_);
#line 2741 "../src/Photo.vala"
	_tmp3_ = _tmp5_;
#line 2741 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20913 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2741 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2741 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2741 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 2741 "../src/Photo.vala"
		return _tmp6_;
#line 20923 "Photo.c"
	}
#line 2741 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp3_, metadata, &_inner_error0_);
#line 2741 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20929 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 2741 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2741 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2741 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2741 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 2741 "../src/Photo.vala"
		return _tmp7_;
#line 20941 "Photo.c"
	}
#line 2743 "../src/Photo.vala"
	_tmp10_ = photo_prepare_for_reimport_editable (self, &_tmp9_, &_inner_error0_);
#line 2743 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2743 "../src/Photo.vala"
	_vala_state = _tmp9_;
#line 2743 "../src/Photo.vala"
	_tmp8_ = _tmp10_;
#line 2743 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20953 "Photo.c"
		gboolean _tmp11_ = FALSE;
#line 2743 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2743 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2743 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2743 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 2743 "../src/Photo.vala"
		return _tmp11_;
#line 20965 "Photo.c"
	}
#line 2743 "../src/Photo.vala"
	if (!_tmp8_) {
#line 2744 "../src/Photo.vala"
		result = FALSE;
#line 2744 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2744 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2744 "../src/Photo.vala"
		if (state) {
#line 2744 "../src/Photo.vala"
			*state = _vala_state;
#line 20979 "Photo.c"
		} else {
#line 2744 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 20983 "Photo.c"
		}
#line 2744 "../src/Photo.vala"
		return result;
#line 20987 "Photo.c"
	}
#line 2746 "../src/Photo.vala"
	_tmp12_ = _vala_state;
#line 2746 "../src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl)->metadata_only = TRUE;
#line 2748 "../src/Photo.vala"
	result = TRUE;
#line 2748 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 2748 "../src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 2748 "../src/Photo.vala"
	if (state) {
#line 2748 "../src/Photo.vala"
		*state = _vala_state;
#line 21003 "Photo.c"
	} else {
#line 2748 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 21007 "Photo.c"
	}
#line 2748 "../src/Photo.vala"
	return result;
#line 21011 "Photo.c"
}

void
photo_finish_update_editable_metadata (Photo* self,
                                       PhotoReimportEditableState* state,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2751 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2751 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 2752 "../src/Photo.vala"
	photo_finish_reimport_editable (self, state, &_inner_error0_);
#line 2752 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2752 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2752 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2752 "../src/Photo.vala"
			return;
#line 21034 "Photo.c"
		} else {
#line 2752 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2752 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2752 "../src/Photo.vala"
			return;
#line 21042 "Photo.c"
		}
	}
}

void
photo_get_raw_dimensions (Photo* self,
                          Dimensions* result)
{
	GError* _inner_error0_ = NULL;
#line 2757 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 21054 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2758 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2758 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21061 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Dimensions _tmp2_;
#line 2759 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2759 "../src/Photo.vala"
			_tmp2_ = _tmp1_->dim;
#line 2759 "../src/Photo.vala"
			*result = _tmp2_;
#line 21071 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2758 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2758 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21078 "Photo.c"
			}
#line 2759 "../src/Photo.vala"
			return;
#line 21082 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2758 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2758 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21091 "Photo.c"
		}
#line 2758 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2758 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2758 "../src/Photo.vala"
		return;
#line 21099 "Photo.c"
	}
}

gboolean
photo_has_transformations (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2763 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 21110 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 2764 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2764 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21118 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 2765 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2765 "../src/Photo.vala"
			_tmp3_ = self->backing_photo_row;
#line 2765 "../src/Photo.vala"
			if (_tmp2_->orientation != _tmp3_->original_orientation) {
#line 2766 "../src/Photo.vala"
				_tmp1_ = TRUE;
#line 21131 "Photo.c"
			} else {
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
#line 2767 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2767 "../src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2767 "../src/Photo.vala"
				_tmp1_ = _tmp5_ != NULL;
#line 21141 "Photo.c"
			}
#line 2765 "../src/Photo.vala"
			result = _tmp1_;
#line 21145 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 2764 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2764 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21152 "Photo.c"
			}
#line 2765 "../src/Photo.vala"
			return result;
#line 21156 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2764 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2764 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21165 "Photo.c"
		}
#line 2764 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2764 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2764 "../src/Photo.vala"
		return _tmp8_;
#line 21173 "Photo.c"
	}
}

gboolean
photo_only_metadata_changed (Photo* self)
{
	MetadataDateTime* date_time = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2771 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2772 "../src/Photo.vala"
	date_time = NULL;
#line 2774 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 2774 "../src/Photo.vala"
	metadata = _tmp0_;
#line 2775 "../src/Photo.vala"
	_tmp1_ = metadata;
#line 2775 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 21198 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
#line 2776 "../src/Photo.vala"
		_tmp2_ = metadata;
#line 2776 "../src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2776 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2776 "../src/Photo.vala"
		date_time = _tmp3_;
#line 21209 "Photo.c"
	}
	{
		PhotoRow* _tmp4_;
		gboolean _tmp17_ = FALSE;
#line 2778 "../src/Photo.vala"
		_tmp4_ = self->row;
#line 2778 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21218 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
#line 2779 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2779 "../src/Photo.vala"
			_tmp7_ = _tmp6_->transformations;
#line 2779 "../src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 21229 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow* _tmp9_;
				BackingPhotoRow* _tmp10_;
#line 2780 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 2780 "../src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2780 "../src/Photo.vala"
				if (_tmp9_->orientation != _tmp10_->original_orientation) {
#line 2780 "../src/Photo.vala"
					_tmp8_ = TRUE;
#line 21241 "Photo.c"
				} else {
					gboolean _tmp11_ = FALSE;
					MetadataDateTime* _tmp12_;
#line 2781 "../src/Photo.vala"
					_tmp12_ = date_time;
#line 2781 "../src/Photo.vala"
					if (_tmp12_ != NULL) {
#line 21249 "Photo.c"
						PhotoRow* _tmp13_;
						MetadataDateTime* _tmp14_;
#line 2781 "../src/Photo.vala"
						_tmp13_ = self->row;
#line 2781 "../src/Photo.vala"
						_tmp14_ = date_time;
#line 2781 "../src/Photo.vala"
						_tmp11_ = _tmp13_->exposure_time != metadata_date_time_get_timestamp (_tmp14_);
#line 21258 "Photo.c"
					} else {
#line 2781 "../src/Photo.vala"
						_tmp11_ = FALSE;
#line 21262 "Photo.c"
					}
#line 2781 "../src/Photo.vala"
					_tmp8_ = _tmp11_;
#line 21266 "Photo.c"
				}
#line 2780 "../src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 21270 "Photo.c"
			} else {
#line 2779 "../src/Photo.vala"
				_tmp5_ = FALSE;
#line 21274 "Photo.c"
			}
#line 2779 "../src/Photo.vala"
			result = _tmp5_;
#line 21278 "Photo.c"
			{
				PhotoRow* _tmp15_;
#line 2778 "../src/Photo.vala"
				_tmp15_ = self->row;
#line 2778 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21285 "Photo.c"
			}
#line 2779 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2779 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2779 "../src/Photo.vala"
			return result;
#line 21293 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp16_;
#line 2778 "../src/Photo.vala"
			_tmp16_ = self->row;
#line 2778 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21302 "Photo.c"
		}
#line 2778 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2778 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2778 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2778 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2778 "../src/Photo.vala"
		return _tmp17_;
#line 21314 "Photo.c"
	}
}

gboolean
photo_has_alterations (Photo* self)
{
	MetadataDateTime* date_time = NULL;
	gchar* title = NULL;
	gchar* comment = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	MetadataDateTime* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2785 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2786 "../src/Photo.vala"
	date_time = NULL;
#line 2787 "../src/Photo.vala"
	title = NULL;
#line 2788 "../src/Photo.vala"
	comment = NULL;
#line 2790 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 2790 "../src/Photo.vala"
	metadata = _tmp0_;
#line 2791 "../src/Photo.vala"
	_tmp1_ = metadata;
#line 2791 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 21346 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
		PhotoMetadata* _tmp4_;
		gchar* _tmp5_;
		PhotoMetadata* _tmp6_;
		gchar* _tmp7_;
#line 2792 "../src/Photo.vala"
		_tmp2_ = metadata;
#line 2792 "../src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2792 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2792 "../src/Photo.vala"
		date_time = _tmp3_;
#line 2793 "../src/Photo.vala"
		_tmp4_ = metadata;
#line 2793 "../src/Photo.vala"
		_tmp5_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 2793 "../src/Photo.vala"
		_g_free0 (title);
#line 2793 "../src/Photo.vala"
		title = _tmp5_;
#line 2794 "../src/Photo.vala"
		_tmp6_ = metadata;
#line 2794 "../src/Photo.vala"
		_tmp7_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 2794 "../src/Photo.vala"
		_g_free0 (comment);
#line 2794 "../src/Photo.vala"
		comment = _tmp7_;
#line 21377 "Photo.c"
	}
#line 2798 "../src/Photo.vala"
	_tmp8_ = date_time;
#line 2798 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 21383 "Photo.c"
		{
			PhotoRow* _tmp9_;
#line 2800 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2800 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 21390 "Photo.c"
			{
				BackingPhotoRow* _tmp10_;
				PhotoRow* _tmp11_;
#line 2802 "../src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2802 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2802 "../src/Photo.vala"
				if (_tmp10_->timestamp != _tmp11_->exposure_time) {
#line 2804 "../src/Photo.vala"
					result = TRUE;
#line 21402 "Photo.c"
					{
						PhotoRow* _tmp12_;
#line 2800 "../src/Photo.vala"
						_tmp12_ = self->row;
#line 2800 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21409 "Photo.c"
					}
#line 2804 "../src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 2804 "../src/Photo.vala"
					_g_free0 (comment);
#line 2804 "../src/Photo.vala"
					_g_free0 (title);
#line 2804 "../src/Photo.vala"
					_metadata_date_time_unref0 (date_time);
#line 2804 "../src/Photo.vala"
					return result;
#line 21421 "Photo.c"
				}
			}
			__finally0:
			{
				PhotoRow* _tmp13_;
#line 2800 "../src/Photo.vala"
				_tmp13_ = self->row;
#line 2800 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21431 "Photo.c"
			}
#line 2800 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21435 "Photo.c"
				gboolean _tmp14_ = FALSE;
#line 2800 "../src/Photo.vala"
				_media_metadata_unref0 (metadata);
#line 2800 "../src/Photo.vala"
				_g_free0 (comment);
#line 2800 "../src/Photo.vala"
				_g_free0 (title);
#line 2800 "../src/Photo.vala"
				_metadata_date_time_unref0 (date_time);
#line 2800 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2800 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2800 "../src/Photo.vala"
				return _tmp14_;
#line 21451 "Photo.c"
			}
		}
	}
	{
		PhotoRow* _tmp15_;
		gboolean _tmp36_ = FALSE;
#line 2809 "../src/Photo.vala"
		_tmp15_ = self->row;
#line 2809 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21462 "Photo.c"
		{
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			PhotoRow* _tmp20_;
			GeeHashMap* _tmp21_;
#line 2810 "../src/Photo.vala"
			_tmp20_ = self->row;
#line 2810 "../src/Photo.vala"
			_tmp21_ = _tmp20_->transformations;
#line 2810 "../src/Photo.vala"
			if (_tmp21_ != NULL) {
#line 2810 "../src/Photo.vala"
				_tmp19_ = TRUE;
#line 21478 "Photo.c"
			} else {
				PhotoRow* _tmp22_;
				BackingPhotoRow* _tmp23_;
#line 2811 "../src/Photo.vala"
				_tmp22_ = self->row;
#line 2811 "../src/Photo.vala"
				_tmp23_ = self->backing_photo_row;
#line 2811 "../src/Photo.vala"
				_tmp19_ = _tmp22_->orientation != _tmp23_->original_orientation;
#line 21488 "Photo.c"
			}
#line 2810 "../src/Photo.vala"
			if (_tmp19_) {
#line 2810 "../src/Photo.vala"
				_tmp18_ = TRUE;
#line 21494 "Photo.c"
			} else {
				gboolean _tmp24_ = FALSE;
				MetadataDateTime* _tmp25_;
#line 2812 "../src/Photo.vala"
				_tmp25_ = date_time;
#line 2812 "../src/Photo.vala"
				if (_tmp25_ != NULL) {
#line 21502 "Photo.c"
					PhotoRow* _tmp26_;
					MetadataDateTime* _tmp27_;
#line 2812 "../src/Photo.vala"
					_tmp26_ = self->row;
#line 2812 "../src/Photo.vala"
					_tmp27_ = date_time;
#line 2812 "../src/Photo.vala"
					_tmp24_ = _tmp26_->exposure_time != metadata_date_time_get_timestamp (_tmp27_);
#line 21511 "Photo.c"
				} else {
#line 2812 "../src/Photo.vala"
					_tmp24_ = FALSE;
#line 21515 "Photo.c"
				}
#line 2812 "../src/Photo.vala"
				_tmp18_ = _tmp24_;
#line 21519 "Photo.c"
			}
#line 2810 "../src/Photo.vala"
			if (_tmp18_) {
#line 2810 "../src/Photo.vala"
				_tmp17_ = TRUE;
#line 21525 "Photo.c"
			} else {
				gchar* _tmp28_;
				gchar* _tmp29_;
				const gchar* _tmp30_;
#line 2813 "../src/Photo.vala"
				_tmp28_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2813 "../src/Photo.vala"
				_tmp29_ = _tmp28_;
#line 2813 "../src/Photo.vala"
				_tmp30_ = comment;
#line 2813 "../src/Photo.vala"
				_tmp17_ = g_strcmp0 (_tmp29_, _tmp30_) != 0;
#line 2813 "../src/Photo.vala"
				_g_free0 (_tmp29_);
#line 21540 "Photo.c"
			}
#line 2810 "../src/Photo.vala"
			if (_tmp17_) {
#line 2810 "../src/Photo.vala"
				_tmp16_ = TRUE;
#line 21546 "Photo.c"
			} else {
				gchar* _tmp31_;
				gchar* _tmp32_;
				const gchar* _tmp33_;
#line 2814 "../src/Photo.vala"
				_tmp31_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2814 "../src/Photo.vala"
				_tmp32_ = _tmp31_;
#line 2814 "../src/Photo.vala"
				_tmp33_ = title;
#line 2814 "../src/Photo.vala"
				_tmp16_ = g_strcmp0 (_tmp32_, _tmp33_) != 0;
#line 2814 "../src/Photo.vala"
				_g_free0 (_tmp32_);
#line 21561 "Photo.c"
			}
#line 2810 "../src/Photo.vala"
			result = _tmp16_;
#line 21565 "Photo.c"
			{
				PhotoRow* _tmp34_;
#line 2809 "../src/Photo.vala"
				_tmp34_ = self->row;
#line 2809 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21572 "Photo.c"
			}
#line 2810 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2810 "../src/Photo.vala"
			_g_free0 (comment);
#line 2810 "../src/Photo.vala"
			_g_free0 (title);
#line 2810 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2810 "../src/Photo.vala"
			return result;
#line 21584 "Photo.c"
		}
		__finally1:
		{
			PhotoRow* _tmp35_;
#line 2809 "../src/Photo.vala"
			_tmp35_ = self->row;
#line 2809 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21593 "Photo.c"
		}
#line 2809 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2809 "../src/Photo.vala"
		_g_free0 (comment);
#line 2809 "../src/Photo.vala"
		_g_free0 (title);
#line 2809 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2809 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2809 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2809 "../src/Photo.vala"
		return _tmp36_;
#line 21609 "Photo.c"
	}
}

PhotoTransformationState*
photo_save_transformation_state (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoTransformationState* result = NULL;
#line 2819 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 21620 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2820 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2820 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21627 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			GeeHashMap* _tmp11_;
			PhotoPhotoTransformationStateImpl* _tmp12_;
#line 2823 "../src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2823 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 21641 "Photo.c"
				PixelTransformer* _tmp3_;
				PixelTransformer* _tmp4_;
#line 2823 "../src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2823 "../src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2823 "../src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2823 "../src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 21652 "Photo.c"
			} else {
#line 2823 "../src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2823 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 21658 "Photo.c"
			}
#line 2824 "../src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2824 "../src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 21664 "Photo.c"
				PixelTransformationBundle* _tmp7_;
				PixelTransformationBundle* _tmp8_;
#line 2824 "../src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2824 "../src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2824 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2824 "../src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 21675 "Photo.c"
			} else {
#line 2824 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2824 "../src/Photo.vala"
				_tmp5_ = NULL;
#line 21681 "Photo.c"
			}
#line 2821 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2821 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 2821 "../src/Photo.vala"
			_tmp11_ = _tmp10_->transformations;
#line 2821 "../src/Photo.vala"
			_tmp12_ = photo_photo_transformation_state_impl_new (self, _tmp9_->orientation, _tmp11_, _tmp1_, _tmp5_);
#line 2821 "../src/Photo.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 2821 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2821 "../src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 21697 "Photo.c"
			{
				PhotoRow* _tmp13_;
#line 2820 "../src/Photo.vala"
				_tmp13_ = self->row;
#line 2820 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21704 "Photo.c"
			}
#line 2821 "../src/Photo.vala"
			return result;
#line 21708 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 2820 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2820 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21717 "Photo.c"
		}
#line 2820 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2820 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2820 "../src/Photo.vala"
		return NULL;
#line 21725 "Photo.c"
	}
}

static gpointer
_pixel_transformer_ref0 (gpointer self)
{
#line 2845 "../src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 21734 "Photo.c"
}

static gpointer
_pixel_transformation_bundle_ref0 (gpointer self)
{
#line 2846 "../src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 21742 "Photo.c"
}

gboolean
photo_load_transformation_state (Photo* self,
                                 PhotoTransformationState* state)
{
	PhotoPhotoTransformationStateImpl* state_impl = NULL;
	PhotoPhotoTransformationStateImpl* _tmp0_;
	PhotoPhotoTransformationStateImpl* _tmp1_;
	Orientation saved_orientation = 0;
	PhotoPhotoTransformationStateImpl* _tmp2_;
	GeeHashMap* saved_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp3_;
	GeeHashMap* _tmp4_;
	PixelTransformer* saved_transformer = NULL;
	PhotoPhotoTransformationStateImpl* _tmp5_;
	PixelTransformer* _tmp6_;
	PixelTransformationBundle* saved_adjustments = NULL;
	PhotoPhotoTransformationStateImpl* _tmp7_;
	PixelTransformationBundle* _tmp8_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2828 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2828 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (state), FALSE);
#line 2829 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (state) ? ((PhotoPhotoTransformationStateImpl*) state) : NULL);
#line 2829 "../src/Photo.vala"
	state_impl = _tmp0_;
#line 2830 "../src/Photo.vala"
	_tmp1_ = state_impl;
#line 2830 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2831 "../src/Photo.vala"
		result = FALSE;
#line 2831 "../src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2831 "../src/Photo.vala"
		return result;
#line 21784 "Photo.c"
	}
#line 2833 "../src/Photo.vala"
	_tmp2_ = state_impl;
#line 2833 "../src/Photo.vala"
	saved_orientation = photo_photo_transformation_state_impl_get_orientation (_tmp2_);
#line 2834 "../src/Photo.vala"
	_tmp3_ = state_impl;
#line 2834 "../src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_get_transformations (_tmp3_);
#line 2834 "../src/Photo.vala"
	saved_transformations = _tmp4_;
#line 2835 "../src/Photo.vala"
	_tmp5_ = state_impl;
#line 2835 "../src/Photo.vala"
	_tmp6_ = photo_photo_transformation_state_impl_get_transformer (_tmp5_);
#line 2835 "../src/Photo.vala"
	saved_transformer = _tmp6_;
#line 2836 "../src/Photo.vala"
	_tmp7_ = state_impl;
#line 2836 "../src/Photo.vala"
	_tmp8_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp7_);
#line 2836 "../src/Photo.vala"
	saved_adjustments = _tmp8_;
#line 21808 "Photo.c"
	{
		PhotoRow* _tmp9_;
#line 2839 "../src/Photo.vala"
		_tmp9_ = self->row;
#line 2839 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21815 "Photo.c"
		{
			PhotoTable* _tmp10_;
			PhotoTable* _tmp11_;
			PhotoRow* _tmp12_;
			PhotoID _tmp13_;
			GeeHashMap* _tmp14_;
#line 2840 "../src/Photo.vala"
			_tmp10_ = photo_table_get_instance ();
#line 2840 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 2840 "../src/Photo.vala"
			_tmp12_ = self->row;
#line 2840 "../src/Photo.vala"
			_tmp13_ = _tmp12_->photo_id;
#line 2840 "../src/Photo.vala"
			_tmp14_ = saved_transformations;
#line 2840 "../src/Photo.vala"
			committed = photo_table_set_transformation_state (_tmp11_, &_tmp13_, saved_orientation, _tmp14_);
#line 2840 "../src/Photo.vala"
			_database_table_unref0 (_tmp11_);
#line 2842 "../src/Photo.vala"
			if (committed) {
#line 21838 "Photo.c"
				PhotoRow* _tmp15_;
				PhotoRow* _tmp16_;
				GeeHashMap* _tmp17_;
				GeeHashMap* _tmp18_;
				PixelTransformer* _tmp19_;
				PixelTransformer* _tmp20_;
				PixelTransformationBundle* _tmp21_;
				PixelTransformationBundle* _tmp22_;
#line 2843 "../src/Photo.vala"
				_tmp15_ = self->row;
#line 2843 "../src/Photo.vala"
				_tmp15_->orientation = saved_orientation;
#line 2844 "../src/Photo.vala"
				_tmp16_ = self->row;
#line 2844 "../src/Photo.vala"
				_tmp17_ = saved_transformations;
#line 2844 "../src/Photo.vala"
				_tmp18_ = _g_object_ref0 (_tmp17_);
#line 2844 "../src/Photo.vala"
				_g_object_unref0 (_tmp16_->transformations);
#line 2844 "../src/Photo.vala"
				_tmp16_->transformations = _tmp18_;
#line 2845 "../src/Photo.vala"
				_tmp19_ = saved_transformer;
#line 2845 "../src/Photo.vala"
				_tmp20_ = _pixel_transformer_ref0 (_tmp19_);
#line 2845 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2845 "../src/Photo.vala"
				self->priv->transformer = _tmp20_;
#line 2846 "../src/Photo.vala"
				_tmp21_ = saved_adjustments;
#line 2846 "../src/Photo.vala"
				_tmp22_ = _pixel_transformation_bundle_ref0 (_tmp21_);
#line 2846 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2846 "../src/Photo.vala"
				self->priv->adjustments = _tmp22_;
#line 21877 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp23_;
#line 2839 "../src/Photo.vala"
			_tmp23_ = self->row;
#line 2839 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21887 "Photo.c"
		}
#line 2839 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21891 "Photo.c"
			gboolean _tmp24_ = FALSE;
#line 2839 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2839 "../src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2839 "../src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2839 "../src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2839 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2839 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2839 "../src/Photo.vala"
			return _tmp24_;
#line 21907 "Photo.c"
		}
	}
#line 2850 "../src/Photo.vala"
	if (committed) {
#line 21912 "Photo.c"
		Alteration* _tmp25_;
		Alteration* _tmp26_;
#line 2851 "../src/Photo.vala"
		_tmp25_ = alteration_new ("image", "transformation-state");
#line 2851 "../src/Photo.vala"
		_tmp26_ = _tmp25_;
#line 2851 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp26_);
#line 2851 "../src/Photo.vala"
		_alteration_unref0 (_tmp26_);
#line 21923 "Photo.c"
	}
#line 2853 "../src/Photo.vala"
	result = committed;
#line 2853 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2853 "../src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2853 "../src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2853 "../src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2853 "../src/Photo.vala"
	return result;
#line 21937 "Photo.c"
}

void
photo_remove_all_transformations (Photo* self,
                                  gboolean notify)
{
	gboolean is_altered = FALSE;
	gboolean _tmp16_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 2856 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2857 "../src/Photo.vala"
	is_altered = FALSE;
#line 21951 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2858 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2858 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21958 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			PhotoRow* _tmp5_;
			PhotoRow* _tmp6_;
			BackingPhotoRow* _tmp7_;
#line 2859 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2859 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2859 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2859 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2859 "../src/Photo.vala"
			is_altered = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2859 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2860 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2860 "../src/Photo.vala"
			_g_object_unref0 (_tmp5_->transformations);
#line 2860 "../src/Photo.vala"
			_tmp5_->transformations = NULL;
#line 2862 "../src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2862 "../src/Photo.vala"
			self->priv->transformer = NULL;
#line 2863 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2863 "../src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2865 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2865 "../src/Photo.vala"
			_tmp7_ = self->backing_photo_row;
#line 2865 "../src/Photo.vala"
			if (_tmp6_->orientation != _tmp7_->original_orientation) {
#line 21999 "Photo.c"
				PhotoTable* _tmp8_;
				PhotoTable* _tmp9_;
				PhotoRow* _tmp10_;
				PhotoID _tmp11_;
				BackingPhotoRow* _tmp12_;
				PhotoRow* _tmp13_;
				BackingPhotoRow* _tmp14_;
#line 2866 "../src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 2866 "../src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 2866 "../src/Photo.vala"
				_tmp10_ = self->row;
#line 2866 "../src/Photo.vala"
				_tmp11_ = _tmp10_->photo_id;
#line 2866 "../src/Photo.vala"
				_tmp12_ = self->backing_photo_row;
#line 2866 "../src/Photo.vala"
				photo_table_set_orientation (_tmp9_, &_tmp11_, _tmp12_->original_orientation);
#line 2866 "../src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 2868 "../src/Photo.vala"
				_tmp13_ = self->row;
#line 2868 "../src/Photo.vala"
				_tmp14_ = self->backing_photo_row;
#line 2868 "../src/Photo.vala"
				_tmp13_->orientation = _tmp14_->original_orientation;
#line 2869 "../src/Photo.vala"
				is_altered = TRUE;
#line 22029 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp15_;
#line 2858 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2858 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22039 "Photo.c"
		}
#line 2858 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2858 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2858 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2858 "../src/Photo.vala"
			return;
#line 22049 "Photo.c"
		}
	}
#line 2873 "../src/Photo.vala"
	if (is_altered) {
#line 2873 "../src/Photo.vala"
		_tmp16_ = notify;
#line 22056 "Photo.c"
	} else {
#line 2873 "../src/Photo.vala"
		_tmp16_ = FALSE;
#line 22060 "Photo.c"
	}
#line 2873 "../src/Photo.vala"
	if (_tmp16_) {
#line 22064 "Photo.c"
		Alteration* _tmp17_;
		Alteration* _tmp18_;
#line 2874 "../src/Photo.vala"
		_tmp17_ = alteration_new ("image", "revert");
#line 2874 "../src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 2874 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp18_);
#line 2874 "../src/Photo.vala"
		_alteration_unref0 (_tmp18_);
#line 22075 "Photo.c"
	}
}

Orientation
photo_get_original_orientation (Photo* self)
{
	GError* _inner_error0_ = NULL;
	Orientation result = 0;
#line 2877 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 22086 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2878 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2878 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22093 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2879 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2879 "../src/Photo.vala"
			result = _tmp1_->original_orientation;
#line 22100 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2878 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2878 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22107 "Photo.c"
			}
#line 2879 "../src/Photo.vala"
			return result;
#line 22111 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2878 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2878 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22120 "Photo.c"
		}
#line 2878 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2878 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2878 "../src/Photo.vala"
		return 0;
#line 22128 "Photo.c"
	}
}

Orientation
photo_get_orientation (Photo* self)
{
	GError* _inner_error0_ = NULL;
	Orientation result = 0;
#line 2883 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 22139 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2884 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2884 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22146 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2885 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2885 "../src/Photo.vala"
			result = _tmp1_->orientation;
#line 22153 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2884 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2884 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22160 "Photo.c"
			}
#line 2885 "../src/Photo.vala"
			return result;
#line 22164 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2884 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2884 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22173 "Photo.c"
		}
#line 2884 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2884 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2884 "../src/Photo.vala"
		return 0;
#line 22181 "Photo.c"
	}
}

gboolean
photo_set_orientation (Photo* self,
                       Orientation orientation)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2889 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2890 "../src/Photo.vala"
	committed = FALSE;
#line 22196 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2891 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2891 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22203 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2892 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2892 "../src/Photo.vala"
			if (_tmp1_->orientation != orientation) {
#line 22210 "Photo.c"
				PhotoTable* _tmp2_;
				PhotoTable* _tmp3_;
				PhotoRow* _tmp4_;
				PhotoID _tmp5_;
#line 2893 "../src/Photo.vala"
				_tmp2_ = photo_table_get_instance ();
#line 2893 "../src/Photo.vala"
				_tmp3_ = _tmp2_;
#line 2893 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2893 "../src/Photo.vala"
				_tmp5_ = _tmp4_->photo_id;
#line 2893 "../src/Photo.vala"
				committed = photo_table_set_orientation (_tmp3_, &_tmp5_, orientation);
#line 2893 "../src/Photo.vala"
				_database_table_unref0 (_tmp3_);
#line 2894 "../src/Photo.vala"
				if (committed) {
#line 22229 "Photo.c"
					PhotoRow* _tmp6_;
#line 2895 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2895 "../src/Photo.vala"
					_tmp6_->orientation = orientation;
#line 22235 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2891 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2891 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22246 "Photo.c"
		}
#line 2891 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22250 "Photo.c"
			gboolean _tmp8_ = FALSE;
#line 2891 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2891 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2891 "../src/Photo.vala"
			return _tmp8_;
#line 22258 "Photo.c"
		}
	}
#line 2899 "../src/Photo.vala"
	if (committed) {
#line 22263 "Photo.c"
		Alteration* _tmp9_;
		Alteration* _tmp10_;
#line 2900 "../src/Photo.vala"
		_tmp9_ = alteration_new ("image", "orientation");
#line 2900 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2900 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp10_);
#line 2900 "../src/Photo.vala"
		_alteration_unref0 (_tmp10_);
#line 22274 "Photo.c"
	}
#line 2902 "../src/Photo.vala"
	result = committed;
#line 2902 "../src/Photo.vala"
	return result;
#line 22280 "Photo.c"
}

gboolean
photo_check_can_rotate (Photo* self)
{
	gboolean result = FALSE;
#line 2905 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2906 "../src/Photo.vala"
	result = self->can_rotate_now;
#line 2906 "../src/Photo.vala"
	return result;
#line 22293 "Photo.c"
}

static void
photo_real_rotate (Photo* self,
                   Rotation rotation)
{
	GError* _inner_error0_ = NULL;
	{
		PhotoRow* _tmp0_;
#line 2910 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2910 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22307 "Photo.c"
		{
#line 2911 "../src/Photo.vala"
			photo_set_orientation (self, orientation_perform (photo_get_orientation (self), rotation));
#line 22311 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp1_;
#line 2910 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2910 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22320 "Photo.c"
		}
#line 2910 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2910 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2910 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2910 "../src/Photo.vala"
			return;
#line 22330 "Photo.c"
		}
	}
}

void
photo_rotate (Photo* self,
              Rotation rotation)
{
	PhotoClass* _klass_;
#line 2909 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2909 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 2909 "../src/Photo.vala"
	if (_klass_->rotate) {
#line 2909 "../src/Photo.vala"
		_klass_->rotate (self, rotation);
#line 22348 "Photo.c"
	}
}

static gboolean
photo_has_transformation (Photo* self,
                          const gchar* name)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2915 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2915 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 22362 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 2916 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2916 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22370 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			GeeHashMap* _tmp3_;
#line 2917 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2917 "../src/Photo.vala"
			_tmp3_ = _tmp2_->transformations;
#line 2917 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 22381 "Photo.c"
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
#line 2917 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2917 "../src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2917 "../src/Photo.vala"
				_tmp1_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name);
#line 22390 "Photo.c"
			} else {
#line 2917 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 22394 "Photo.c"
			}
#line 2917 "../src/Photo.vala"
			result = _tmp1_;
#line 22398 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 2916 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2916 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22405 "Photo.c"
			}
#line 2917 "../src/Photo.vala"
			return result;
#line 22409 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2916 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2916 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22418 "Photo.c"
		}
#line 2916 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2916 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2916 "../src/Photo.vala"
		return _tmp8_;
#line 22426 "Photo.c"
	}
}

static KeyValueMap*
photo_get_transformation (Photo* self,
                          const gchar* name)
{
	KeyValueMap* map = NULL;
	GError* _inner_error0_ = NULL;
	KeyValueMap* result = NULL;
#line 2924 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2924 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2925 "../src/Photo.vala"
	map = NULL;
#line 22443 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2926 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2926 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22450 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
#line 2927 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2927 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2927 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22460 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				gpointer _tmp5_;
				KeyValueMap* _tmp6_;
#line 2928 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2928 "../src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2928 "../src/Photo.vala"
				_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name);
#line 2928 "../src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2928 "../src/Photo.vala"
				map = (KeyValueMap*) _tmp5_;
#line 2929 "../src/Photo.vala"
				_tmp6_ = map;
#line 2929 "../src/Photo.vala"
				if (_tmp6_ != NULL) {
#line 22479 "Photo.c"
					KeyValueMap* _tmp7_;
					KeyValueMap* _tmp8_;
#line 2930 "../src/Photo.vala"
					_tmp7_ = map;
#line 2930 "../src/Photo.vala"
					_tmp8_ = key_value_map_copy (_tmp7_);
#line 2930 "../src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2930 "../src/Photo.vala"
					map = _tmp8_;
#line 22490 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp9_;
#line 2926 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2926 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22501 "Photo.c"
		}
#line 2926 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2926 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2926 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2926 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2926 "../src/Photo.vala"
			return NULL;
#line 22513 "Photo.c"
		}
	}
#line 2934 "../src/Photo.vala"
	result = map;
#line 2934 "../src/Photo.vala"
	return result;
#line 22520 "Photo.c"
}

static gboolean
photo_set_transformation (Photo* self,
                          KeyValueMap* trans)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2937 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2937 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (trans, TYPE_KEY_VALUE_MAP), FALSE);
#line 22533 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp16_ = FALSE;
#line 2938 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2938 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22541 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp5_;
			GeeHashMap* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			PhotoTable* _tmp9_;
			PhotoTable* _tmp10_;
			PhotoRow* _tmp11_;
			PhotoID _tmp12_;
			gboolean _tmp13_;
#line 2939 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2939 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2939 "../src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 22560 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2940 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2940 "../src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2940 "../src/Photo.vala"
				_g_object_unref0 (_tmp3_->transformations);
#line 2940 "../src/Photo.vala"
				_tmp3_->transformations = _tmp4_;
#line 22571 "Photo.c"
			}
#line 2942 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2942 "../src/Photo.vala"
			_tmp6_ = _tmp5_->transformations;
#line 2942 "../src/Photo.vala"
			_tmp7_ = key_value_map_get_group (trans);
#line 2942 "../src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2942 "../src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_, trans);
#line 2942 "../src/Photo.vala"
			_g_free0 (_tmp8_);
#line 2944 "../src/Photo.vala"
			_tmp9_ = photo_table_get_instance ();
#line 2944 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2944 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2944 "../src/Photo.vala"
			_tmp12_ = _tmp11_->photo_id;
#line 2944 "../src/Photo.vala"
			_tmp13_ = photo_table_set_transformation (_tmp10_, &_tmp12_, trans);
#line 2944 "../src/Photo.vala"
			_database_table_unref0 (_tmp10_);
#line 2944 "../src/Photo.vala"
			result = _tmp13_;
#line 22599 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2938 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 2938 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22606 "Photo.c"
			}
#line 2944 "../src/Photo.vala"
			return result;
#line 22610 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp15_;
#line 2938 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2938 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22619 "Photo.c"
		}
#line 2938 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2938 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2938 "../src/Photo.vala"
		return _tmp16_;
#line 22627 "Photo.c"
	}
}

static gboolean
photo_remove_transformation (Photo* self,
                             const gchar* name)
{
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp16_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 2948 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2948 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 22644 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2950 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2950 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22651 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp10_;
			PhotoTable* _tmp11_;
			PhotoRow* _tmp12_;
			PhotoID _tmp13_;
#line 2951 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2951 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2951 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22665 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				PhotoRow* _tmp5_;
				GeeHashMap* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 2952 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2952 "../src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2952 "../src/Photo.vala"
				altered_cache = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name, NULL);
#line 2953 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2953 "../src/Photo.vala"
				_tmp6_ = _tmp5_->transformations;
#line 2953 "../src/Photo.vala"
				_tmp7_ = gee_abstract_map_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 2953 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 2953 "../src/Photo.vala"
				if (_tmp8_ == 0) {
#line 22688 "Photo.c"
					PhotoRow* _tmp9_;
#line 2954 "../src/Photo.vala"
					_tmp9_ = self->row;
#line 2954 "../src/Photo.vala"
					_g_object_unref0 (_tmp9_->transformations);
#line 2954 "../src/Photo.vala"
					_tmp9_->transformations = NULL;
#line 22696 "Photo.c"
				}
			} else {
#line 2956 "../src/Photo.vala"
				altered_cache = FALSE;
#line 22701 "Photo.c"
			}
#line 2959 "../src/Photo.vala"
			_tmp10_ = photo_table_get_instance ();
#line 2959 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 2959 "../src/Photo.vala"
			_tmp12_ = self->row;
#line 2959 "../src/Photo.vala"
			_tmp13_ = _tmp12_->photo_id;
#line 2959 "../src/Photo.vala"
			altered_persistent = photo_table_remove_transformation (_tmp11_, &_tmp13_, name);
#line 2959 "../src/Photo.vala"
			_database_table_unref0 (_tmp11_);
#line 22715 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 2950 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2950 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22724 "Photo.c"
		}
#line 2950 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22728 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 2950 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2950 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2950 "../src/Photo.vala"
			return _tmp15_;
#line 22736 "Photo.c"
		}
	}
#line 2963 "../src/Photo.vala"
	if (altered_cache) {
#line 2963 "../src/Photo.vala"
		_tmp16_ = TRUE;
#line 22743 "Photo.c"
	} else {
#line 2963 "../src/Photo.vala"
		_tmp16_ = altered_persistent;
#line 22747 "Photo.c"
	}
#line 2963 "../src/Photo.vala"
	result = _tmp16_;
#line 2963 "../src/Photo.vala"
	return result;
#line 22753 "Photo.c"
}

gboolean
photo_has_crop (Photo* self)
{
	gboolean result = FALSE;
#line 2966 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2967 "../src/Photo.vala"
	result = photo_has_transformation (self, "crop");
#line 2967 "../src/Photo.vala"
	return result;
#line 22766 "Photo.c"
}

gboolean
photo_get_raw_crop (Photo* self,
                    Box* crop)
{
	Box _vala_crop = {0};
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint left = 0;
	KeyValueMap* _tmp2_;
	gint top = 0;
	KeyValueMap* _tmp3_;
	gint right = 0;
	KeyValueMap* _tmp4_;
	gint bottom = 0;
	KeyValueMap* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean result = FALSE;
#line 2971 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2972 "../src/Photo.vala"
	box_init (&_vala_crop, 0, 0, 0, 0);
#line 2974 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2974 "../src/Photo.vala"
	map = _tmp0_;
#line 2975 "../src/Photo.vala"
	_tmp1_ = map;
#line 2975 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2976 "../src/Photo.vala"
		result = FALSE;
#line 2976 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2976 "../src/Photo.vala"
		if (crop) {
#line 2976 "../src/Photo.vala"
			*crop = _vala_crop;
#line 22809 "Photo.c"
		}
#line 2976 "../src/Photo.vala"
		return result;
#line 22813 "Photo.c"
	}
#line 2978 "../src/Photo.vala"
	_tmp2_ = map;
#line 2978 "../src/Photo.vala"
	left = key_value_map_get_int (_tmp2_, "left", -1);
#line 2979 "../src/Photo.vala"
	_tmp3_ = map;
#line 2979 "../src/Photo.vala"
	top = key_value_map_get_int (_tmp3_, "top", -1);
#line 2980 "../src/Photo.vala"
	_tmp4_ = map;
#line 2980 "../src/Photo.vala"
	right = key_value_map_get_int (_tmp4_, "right", -1);
#line 2981 "../src/Photo.vala"
	_tmp5_ = map;
#line 2981 "../src/Photo.vala"
	bottom = key_value_map_get_int (_tmp5_, "bottom", -1);
#line 2983 "../src/Photo.vala"
	if (left == -1) {
#line 2983 "../src/Photo.vala"
		_tmp8_ = TRUE;
#line 22835 "Photo.c"
	} else {
#line 2983 "../src/Photo.vala"
		_tmp8_ = top == -1;
#line 22839 "Photo.c"
	}
#line 2983 "../src/Photo.vala"
	if (_tmp8_) {
#line 2983 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 22845 "Photo.c"
	} else {
#line 2983 "../src/Photo.vala"
		_tmp7_ = right == -1;
#line 22849 "Photo.c"
	}
#line 2983 "../src/Photo.vala"
	if (_tmp7_) {
#line 2983 "../src/Photo.vala"
		_tmp6_ = TRUE;
#line 22855 "Photo.c"
	} else {
#line 2983 "../src/Photo.vala"
		_tmp6_ = bottom == -1;
#line 22859 "Photo.c"
	}
#line 2983 "../src/Photo.vala"
	if (_tmp6_) {
#line 2984 "../src/Photo.vala"
		result = FALSE;
#line 2984 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2984 "../src/Photo.vala"
		if (crop) {
#line 2984 "../src/Photo.vala"
			*crop = _vala_crop;
#line 22871 "Photo.c"
		}
#line 2984 "../src/Photo.vala"
		return result;
#line 22875 "Photo.c"
	}
#line 2986 "../src/Photo.vala"
	box_init (&_vala_crop, left, top, right, bottom);
#line 2988 "../src/Photo.vala"
	result = TRUE;
#line 2988 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2988 "../src/Photo.vala"
	if (crop) {
#line 2988 "../src/Photo.vala"
		*crop = _vala_crop;
#line 22887 "Photo.c"
	}
#line 2988 "../src/Photo.vala"
	return result;
#line 22891 "Photo.c"
}

static void
photo_set_raw_crop (Photo* self,
                    Box* crop)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	Box _tmp2_;
	KeyValueMap* _tmp3_;
	Box _tmp4_;
	KeyValueMap* _tmp5_;
	Box _tmp6_;
	KeyValueMap* _tmp7_;
	Box _tmp8_;
	KeyValueMap* _tmp9_;
#line 2992 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2992 "../src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 2993 "../src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 2993 "../src/Photo.vala"
	map = _tmp0_;
#line 2994 "../src/Photo.vala"
	_tmp1_ = map;
#line 2994 "../src/Photo.vala"
	_tmp2_ = *crop;
#line 2994 "../src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp2_.left);
#line 2995 "../src/Photo.vala"
	_tmp3_ = map;
#line 2995 "../src/Photo.vala"
	_tmp4_ = *crop;
#line 2995 "../src/Photo.vala"
	key_value_map_set_int (_tmp3_, "top", _tmp4_.top);
#line 2996 "../src/Photo.vala"
	_tmp5_ = map;
#line 2996 "../src/Photo.vala"
	_tmp6_ = *crop;
#line 2996 "../src/Photo.vala"
	key_value_map_set_int (_tmp5_, "right", _tmp6_.right);
#line 2997 "../src/Photo.vala"
	_tmp7_ = map;
#line 2997 "../src/Photo.vala"
	_tmp8_ = *crop;
#line 2997 "../src/Photo.vala"
	key_value_map_set_int (_tmp7_, "bottom", _tmp8_.bottom);
#line 2999 "../src/Photo.vala"
	_tmp9_ = map;
#line 2999 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp9_)) {
#line 22945 "Photo.c"
		Alteration* _tmp10_;
		Alteration* _tmp11_;
#line 3000 "../src/Photo.vala"
		_tmp10_ = alteration_new ("image", "crop");
#line 3000 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 3000 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp11_);
#line 3000 "../src/Photo.vala"
		_alteration_unref0 (_tmp11_);
#line 22956 "Photo.c"
	}
#line 2992 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 22960 "Photo.c"
}

static gboolean
photo_get_raw_straighten (Photo* self,
                          gdouble* angle)
{
	gdouble _vala_angle = 0.0;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	gboolean result = FALSE;
#line 3003 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3004 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "straighten");
#line 3004 "../src/Photo.vala"
	map = _tmp0_;
#line 3005 "../src/Photo.vala"
	_tmp1_ = map;
#line 3005 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 3006 "../src/Photo.vala"
		_vala_angle = 0.0;
#line 3008 "../src/Photo.vala"
		result = FALSE;
#line 3008 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3008 "../src/Photo.vala"
		if (angle) {
#line 3008 "../src/Photo.vala"
			*angle = _vala_angle;
#line 22993 "Photo.c"
		}
#line 3008 "../src/Photo.vala"
		return result;
#line 22997 "Photo.c"
	}
#line 3011 "../src/Photo.vala"
	_tmp2_ = map;
#line 3011 "../src/Photo.vala"
	_vala_angle = key_value_map_get_double (_tmp2_, "angle", 0.0);
#line 3013 "../src/Photo.vala"
	result = TRUE;
#line 3013 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3013 "../src/Photo.vala"
	if (angle) {
#line 3013 "../src/Photo.vala"
		*angle = _vala_angle;
#line 23011 "Photo.c"
	}
#line 3013 "../src/Photo.vala"
	return result;
#line 23015 "Photo.c"
}

static void
photo_set_raw_straighten (Photo* self,
                          gdouble theta)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
#line 3016 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3017 "../src/Photo.vala"
	_tmp0_ = key_value_map_new ("straighten");
#line 3017 "../src/Photo.vala"
	map = _tmp0_;
#line 3018 "../src/Photo.vala"
	_tmp1_ = map;
#line 3018 "../src/Photo.vala"
	key_value_map_set_double (_tmp1_, "angle", theta);
#line 3020 "../src/Photo.vala"
	_tmp2_ = map;
#line 3020 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp2_)) {
#line 23040 "Photo.c"
		Alteration* _tmp3_;
		Alteration* _tmp4_;
#line 3021 "../src/Photo.vala"
		_tmp3_ = alteration_new ("image", "straighten");
#line 3021 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 3021 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp4_);
#line 3021 "../src/Photo.vala"
		_alteration_unref0 (_tmp4_);
#line 23051 "Photo.c"
	}
#line 3016 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23055 "Photo.c"
}

static EditingToolsRedeyeInstance*
photo_get_raw_redeye_instances (Photo* self,
                                gint* result_length1)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	EditingToolsRedeyeInstance* res = NULL;
	EditingToolsRedeyeInstance* _tmp5_;
	gint res_length1;
	gint _res_size_;
	GdkPoint default_point = {0};
	GdkPoint _tmp6_ = {0};
	EditingToolsRedeyeInstance* _tmp29_;
	gint _tmp29__length1;
	EditingToolsRedeyeInstance* result = NULL;
#line 3026 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3027 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 3027 "../src/Photo.vala"
	map = _tmp0_;
#line 3028 "../src/Photo.vala"
	_tmp1_ = map;
#line 3028 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 23086 "Photo.c"
		EditingToolsRedeyeInstance* _tmp2_;
		EditingToolsRedeyeInstance* _tmp3_;
		gint _tmp3__length1;
#line 3029 "../src/Photo.vala"
		_tmp2_ = g_new0 (EditingToolsRedeyeInstance, 0);
#line 3029 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3029 "../src/Photo.vala"
		_tmp3__length1 = 0;
#line 3029 "../src/Photo.vala"
		if (result_length1) {
#line 3029 "../src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 23100 "Photo.c"
		}
#line 3029 "../src/Photo.vala"
		result = _tmp3_;
#line 3029 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3029 "../src/Photo.vala"
		return result;
#line 23108 "Photo.c"
	}
#line 3031 "../src/Photo.vala"
	_tmp4_ = map;
#line 3031 "../src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 3032 "../src/Photo.vala"
	_vala_assert (num_points > 0, "num_points > 0");
#line 3034 "../src/Photo.vala"
	_tmp5_ = g_new0 (EditingToolsRedeyeInstance, num_points);
#line 3034 "../src/Photo.vala"
	res = _tmp5_;
#line 3034 "../src/Photo.vala"
	res_length1 = num_points;
#line 3034 "../src/Photo.vala"
	_res_size_ = res_length1;
#line 3036 "../src/Photo.vala"
	_tmp6_.x = 0;
#line 3036 "../src/Photo.vala"
	default_point = _tmp6_;
#line 3037 "../src/Photo.vala"
	default_point.x = -1;
#line 3038 "../src/Photo.vala"
	default_point.y = -1;
#line 23132 "Photo.c"
	{
		gint i = 0;
#line 3040 "../src/Photo.vala"
		i = 0;
#line 23137 "Photo.c"
		{
			gboolean _tmp7_ = FALSE;
#line 3040 "../src/Photo.vala"
			_tmp7_ = TRUE;
#line 3040 "../src/Photo.vala"
			while (TRUE) {
#line 23144 "Photo.c"
				gchar* center_key = NULL;
				gchar* _tmp9_;
				gchar* radius_key = NULL;
				gchar* _tmp10_;
				EditingToolsRedeyeInstance* _tmp11_;
				gint _tmp11__length1;
				KeyValueMap* _tmp12_;
				const gchar* _tmp13_;
				GdkPoint _tmp14_;
				GdkPoint _tmp15_ = {0};
				EditingToolsRedeyeInstance* _tmp16_;
				gint _tmp16__length1;
				EditingToolsRedeyeInstance _tmp17_;
				GdkPoint _tmp18_;
				GdkPoint _tmp19_;
				EditingToolsRedeyeInstance* _tmp20_;
				gint _tmp20__length1;
				EditingToolsRedeyeInstance _tmp21_;
				GdkPoint _tmp22_;
				GdkPoint _tmp23_;
				EditingToolsRedeyeInstance* _tmp24_;
				gint _tmp24__length1;
				KeyValueMap* _tmp25_;
				const gchar* _tmp26_;
				EditingToolsRedeyeInstance* _tmp27_;
				gint _tmp27__length1;
				EditingToolsRedeyeInstance _tmp28_;
#line 3040 "../src/Photo.vala"
				if (!_tmp7_) {
#line 23174 "Photo.c"
					gint _tmp8_;
#line 3040 "../src/Photo.vala"
					_tmp8_ = i;
#line 3040 "../src/Photo.vala"
					i = _tmp8_ + 1;
#line 23180 "Photo.c"
				}
#line 3040 "../src/Photo.vala"
				_tmp7_ = FALSE;
#line 3040 "../src/Photo.vala"
				if (!(i < num_points)) {
#line 3040 "../src/Photo.vala"
					break;
#line 23188 "Photo.c"
				}
#line 3041 "../src/Photo.vala"
				_tmp9_ = g_strdup_printf ("center%d", i);
#line 3041 "../src/Photo.vala"
				center_key = _tmp9_;
#line 3042 "../src/Photo.vala"
				_tmp10_ = g_strdup_printf ("radius%d", i);
#line 3042 "../src/Photo.vala"
				radius_key = _tmp10_;
#line 3044 "../src/Photo.vala"
				_tmp11_ = res;
#line 3044 "../src/Photo.vala"
				_tmp11__length1 = res_length1;
#line 3044 "../src/Photo.vala"
				_tmp12_ = map;
#line 3044 "../src/Photo.vala"
				_tmp13_ = center_key;
#line 3044 "../src/Photo.vala"
				_tmp14_ = default_point;
#line 3044 "../src/Photo.vala"
				key_value_map_get_point (_tmp12_, _tmp13_, &_tmp14_, &_tmp15_);
#line 3044 "../src/Photo.vala"
				_tmp11_[i].center = _tmp15_;
#line 3045 "../src/Photo.vala"
				_tmp16_ = res;
#line 3045 "../src/Photo.vala"
				_tmp16__length1 = res_length1;
#line 3045 "../src/Photo.vala"
				_tmp17_ = _tmp16_[i];
#line 3045 "../src/Photo.vala"
				_tmp18_ = _tmp17_.center;
#line 3045 "../src/Photo.vala"
				_tmp19_ = default_point;
#line 3045 "../src/Photo.vala"
				_vala_assert (_tmp18_.x != _tmp19_.x, "res[i].center.x != default_point.x");
#line 3046 "../src/Photo.vala"
				_tmp20_ = res;
#line 3046 "../src/Photo.vala"
				_tmp20__length1 = res_length1;
#line 3046 "../src/Photo.vala"
				_tmp21_ = _tmp20_[i];
#line 3046 "../src/Photo.vala"
				_tmp22_ = _tmp21_.center;
#line 3046 "../src/Photo.vala"
				_tmp23_ = default_point;
#line 3046 "../src/Photo.vala"
				_vala_assert (_tmp22_.y != _tmp23_.y, "res[i].center.y != default_point.y");
#line 3048 "../src/Photo.vala"
				_tmp24_ = res;
#line 3048 "../src/Photo.vala"
				_tmp24__length1 = res_length1;
#line 3048 "../src/Photo.vala"
				_tmp25_ = map;
#line 3048 "../src/Photo.vala"
				_tmp26_ = radius_key;
#line 3048 "../src/Photo.vala"
				_tmp24_[i].radius = key_value_map_get_int (_tmp25_, _tmp26_, -1);
#line 3049 "../src/Photo.vala"
				_tmp27_ = res;
#line 3049 "../src/Photo.vala"
				_tmp27__length1 = res_length1;
#line 3049 "../src/Photo.vala"
				_tmp28_ = _tmp27_[i];
#line 3049 "../src/Photo.vala"
				_vala_assert (_tmp28_.radius != -1, "res[i].radius != -1");
#line 3040 "../src/Photo.vala"
				_g_free0 (radius_key);
#line 3040 "../src/Photo.vala"
				_g_free0 (center_key);
#line 23258 "Photo.c"
			}
		}
	}
#line 3052 "../src/Photo.vala"
	_tmp29_ = res;
#line 3052 "../src/Photo.vala"
	_tmp29__length1 = res_length1;
#line 3052 "../src/Photo.vala"
	if (result_length1) {
#line 3052 "../src/Photo.vala"
		*result_length1 = _tmp29__length1;
#line 23270 "Photo.c"
	}
#line 3052 "../src/Photo.vala"
	result = _tmp29_;
#line 3052 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3052 "../src/Photo.vala"
	return result;
#line 23278 "Photo.c"
}

gboolean
photo_has_redeye_transformations (Photo* self)
{
	gboolean result = FALSE;
#line 3055 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3056 "../src/Photo.vala"
	result = photo_has_transformation (self, "redeye");
#line 3056 "../src/Photo.vala"
	return result;
#line 23291 "Photo.c"
}

void
photo_add_redeye_instance (Photo* self,
                           EditingToolsRedeyeInstance* redeye)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	gint _tmp5_;
	gchar* radius_key = NULL;
	gchar* _tmp6_;
	gchar* center_key = NULL;
	gchar* _tmp7_;
	KeyValueMap* _tmp8_;
	const gchar* _tmp9_;
	EditingToolsRedeyeInstance _tmp10_;
	KeyValueMap* _tmp11_;
	const gchar* _tmp12_;
	EditingToolsRedeyeInstance _tmp13_;
	GdkPoint _tmp14_;
	KeyValueMap* _tmp15_;
	KeyValueMap* _tmp16_;
#line 3060 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3060 "../src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 3061 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 3061 "../src/Photo.vala"
	map = _tmp0_;
#line 3062 "../src/Photo.vala"
	_tmp1_ = map;
#line 3062 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 23329 "Photo.c"
		KeyValueMap* _tmp2_;
		KeyValueMap* _tmp3_;
#line 3063 "../src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 3063 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3063 "../src/Photo.vala"
		map = _tmp2_;
#line 3064 "../src/Photo.vala"
		_tmp3_ = map;
#line 3064 "../src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 23342 "Photo.c"
	}
#line 3067 "../src/Photo.vala"
	_tmp4_ = map;
#line 3067 "../src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 3068 "../src/Photo.vala"
	_vala_assert (num_points >= 0, "num_points >= 0");
#line 3070 "../src/Photo.vala"
	_tmp5_ = num_points;
#line 3070 "../src/Photo.vala"
	num_points = _tmp5_ + 1;
#line 3072 "../src/Photo.vala"
	_tmp6_ = g_strdup_printf ("radius%d", num_points - 1);
#line 3072 "../src/Photo.vala"
	radius_key = _tmp6_;
#line 3073 "../src/Photo.vala"
	_tmp7_ = g_strdup_printf ("center%d", num_points - 1);
#line 3073 "../src/Photo.vala"
	center_key = _tmp7_;
#line 3075 "../src/Photo.vala"
	_tmp8_ = map;
#line 3075 "../src/Photo.vala"
	_tmp9_ = radius_key;
#line 3075 "../src/Photo.vala"
	_tmp10_ = *redeye;
#line 3075 "../src/Photo.vala"
	key_value_map_set_int (_tmp8_, _tmp9_, _tmp10_.radius);
#line 3076 "../src/Photo.vala"
	_tmp11_ = map;
#line 3076 "../src/Photo.vala"
	_tmp12_ = center_key;
#line 3076 "../src/Photo.vala"
	_tmp13_ = *redeye;
#line 3076 "../src/Photo.vala"
	_tmp14_ = _tmp13_.center;
#line 3076 "../src/Photo.vala"
	key_value_map_set_point (_tmp11_, _tmp12_, &_tmp14_);
#line 3078 "../src/Photo.vala"
	_tmp15_ = map;
#line 3078 "../src/Photo.vala"
	key_value_map_set_int (_tmp15_, "num_points", num_points);
#line 3080 "../src/Photo.vala"
	_tmp16_ = map;
#line 3080 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp16_)) {
#line 23388 "Photo.c"
		Alteration* _tmp17_;
		Alteration* _tmp18_;
#line 3081 "../src/Photo.vala"
		_tmp17_ = alteration_new ("image", "redeye");
#line 3081 "../src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 3081 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp18_);
#line 3081 "../src/Photo.vala"
		_alteration_unref0 (_tmp18_);
#line 23399 "Photo.c"
	}
#line 3060 "../src/Photo.vala"
	_g_free0 (center_key);
#line 3060 "../src/Photo.vala"
	_g_free0 (radius_key);
#line 3060 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23407 "Photo.c"
}

static gboolean
photo_calculate_pixbuf_dimensions (Photo* self,
                                   Scaling* scaling,
                                   PhotoException exceptions,
                                   Dimensions* scaled_image,
                                   Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 3095 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3095 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 23425 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp7_ = FALSE;
#line 3097 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3097 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23433 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			gboolean _tmp4_;
#line 3099 "../src/Photo.vala"
			_tmp1_ = *scaling;
#line 3099 "../src/Photo.vala"
			_tmp4_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, exceptions, &_tmp2_, &_tmp3_);
#line 3099 "../src/Photo.vala"
			_vala_scaled_image = _tmp2_;
#line 3099 "../src/Photo.vala"
			_vala_scaled_to_viewport = _tmp3_;
#line 3099 "../src/Photo.vala"
			result = _tmp4_;
#line 23449 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 3097 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 3097 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23456 "Photo.c"
			}
#line 3099 "../src/Photo.vala"
			if (scaled_image) {
#line 3099 "../src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 23462 "Photo.c"
			}
#line 3099 "../src/Photo.vala"
			if (scaled_to_viewport) {
#line 3099 "../src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23468 "Photo.c"
			}
#line 3099 "../src/Photo.vala"
			return result;
#line 23472 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 3097 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 3097 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23481 "Photo.c"
		}
#line 3097 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3097 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3097 "../src/Photo.vala"
		return _tmp7_;
#line 23489 "Photo.c"
	}
}

static gboolean
photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          Dimensions* scaled_image,
                                          Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	Dimensions raw = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	gboolean _tmp31_ = FALSE;
	Dimensions _tmp32_;
	Dimensions _tmp33_;
	gboolean result = FALSE;
#line 3105 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3105 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3107 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3107 "../src/Photo.vala"
	raw = _tmp0_;
#line 3109 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 23519 "Photo.c"
		Dimensions _tmp1_;
		Dimensions _tmp2_;
#line 3110 "../src/Photo.vala"
		_tmp1_ = raw;
#line 3110 "../src/Photo.vala"
		_vala_scaled_image = _tmp1_;
#line 3111 "../src/Photo.vala"
		_tmp2_ = raw;
#line 3111 "../src/Photo.vala"
		_vala_scaled_to_viewport = _tmp2_;
#line 3113 "../src/Photo.vala"
		result = FALSE;
#line 3113 "../src/Photo.vala"
		if (scaled_image) {
#line 3113 "../src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 23536 "Photo.c"
		}
#line 3113 "../src/Photo.vala"
		if (scaled_to_viewport) {
#line 3113 "../src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23542 "Photo.c"
		}
#line 3113 "../src/Photo.vala"
		return result;
#line 23546 "Photo.c"
	}
#line 3116 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 3121 "../src/Photo.vala"
	dimensions_init (&_vala_scaled_image, 0, 0);
#line 3122 "../src/Photo.vala"
	dimensions_init (&_vala_scaled_to_viewport, 0, 0);
#line 3124 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 23556 "Photo.c"
		Box crop = {0};
		Box _tmp3_ = {0};
		gboolean _tmp4_;
#line 3126 "../src/Photo.vala"
		_tmp4_ = photo_get_raw_crop (self, &_tmp3_);
#line 3126 "../src/Photo.vala"
		crop = _tmp3_;
#line 3126 "../src/Photo.vala"
		if (_tmp4_) {
#line 23566 "Photo.c"
			Dimensions rotated_raw = {0};
			Dimensions _tmp5_;
			Box scaled_crop = {0};
			Dimensions _tmp11_ = {0};
			Dimensions _tmp12_ = {0};
			Box _tmp13_ = {0};
			Dimensions _tmp14_ = {0};
			gboolean _tmp15_ = FALSE;
			Dimensions _tmp18_ = {0};
			Dimensions _tmp19_ = {0};
			Dimensions _tmp20_ = {0};
#line 3129 "../src/Photo.vala"
			_tmp5_ = raw;
#line 3129 "../src/Photo.vala"
			rotated_raw = _tmp5_;
#line 3130 "../src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 23584 "Photo.c"
				Dimensions _tmp6_;
				Box _tmp7_;
				Box _tmp8_ = {0};
				Dimensions _tmp9_;
				Dimensions _tmp10_ = {0};
#line 3131 "../src/Photo.vala"
				_tmp6_ = raw;
#line 3131 "../src/Photo.vala"
				_tmp7_ = crop;
#line 3131 "../src/Photo.vala"
				orientation_rotate_box (orientation, &_tmp6_, &_tmp7_, &_tmp8_);
#line 3131 "../src/Photo.vala"
				crop = _tmp8_;
#line 3132 "../src/Photo.vala"
				_tmp9_ = raw;
#line 3132 "../src/Photo.vala"
				orientation_rotate_dimensions (orientation, &_tmp9_, &_tmp10_);
#line 3132 "../src/Photo.vala"
				rotated_raw = _tmp10_;
#line 23604 "Photo.c"
			}
#line 3136 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp11_);
#line 3136 "../src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp11_, &_tmp12_);
#line 3136 "../src/Photo.vala"
			box_get_scaled (&crop, &_tmp12_, &_tmp13_);
#line 3136 "../src/Photo.vala"
			scaled_crop = _tmp13_;
#line 3139 "../src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp14_);
#line 3139 "../src/Photo.vala"
			_vala_scaled_to_viewport = _tmp14_;
#line 3142 "../src/Photo.vala"
			if (box_get_width (&crop) <= box_get_width (&scaled_crop)) {
#line 3143 "../src/Photo.vala"
				_tmp15_ = box_get_height (&crop) <= box_get_height (&scaled_crop);
#line 23622 "Photo.c"
			} else {
#line 3142 "../src/Photo.vala"
				_tmp15_ = FALSE;
#line 23626 "Photo.c"
			}
#line 3142 "../src/Photo.vala"
			if (_tmp15_) {
#line 23630 "Photo.c"
				Dimensions _tmp16_;
				Dimensions _tmp17_ = {0};
#line 3144 "../src/Photo.vala"
				_tmp16_ = raw;
#line 3144 "../src/Photo.vala"
				_vala_scaled_image = _tmp16_;
#line 3145 "../src/Photo.vala"
				box_get_dimensions (&crop, &_tmp17_);
#line 3145 "../src/Photo.vala"
				_vala_scaled_to_viewport = _tmp17_;
#line 3147 "../src/Photo.vala"
				result = FALSE;
#line 3147 "../src/Photo.vala"
				if (scaled_image) {
#line 3147 "../src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 23647 "Photo.c"
				}
#line 3147 "../src/Photo.vala"
				if (scaled_to_viewport) {
#line 3147 "../src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23653 "Photo.c"
				}
#line 3147 "../src/Photo.vala"
				return result;
#line 23657 "Photo.c"
			}
#line 3152 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp18_);
#line 3152 "../src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp19_);
#line 3152 "../src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp18_, &_tmp19_, &_tmp20_);
#line 3152 "../src/Photo.vala"
			_vala_scaled_image = _tmp20_;
#line 3156 "../src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 23669 "Photo.c"
				Dimensions _tmp21_;
				Dimensions _tmp22_ = {0};
#line 3157 "../src/Photo.vala"
				_tmp21_ = _vala_scaled_image;
#line 3157 "../src/Photo.vala"
				orientation_derotate_dimensions (orientation, &_tmp21_, &_tmp22_);
#line 3157 "../src/Photo.vala"
				_vala_scaled_image = _tmp22_;
#line 23678 "Photo.c"
			}
		}
	}
#line 3162 "../src/Photo.vala"
	if (!dimensions_has_area (&_vala_scaled_image)) {
#line 23684 "Photo.c"
		Dimensions rotated_raw = {0};
		Dimensions _tmp23_;
		Dimensions _tmp26_;
		Dimensions _tmp27_ = {0};
		Dimensions _tmp28_;
#line 3164 "../src/Photo.vala"
		_tmp23_ = raw;
#line 3164 "../src/Photo.vala"
		rotated_raw = _tmp23_;
#line 3165 "../src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 23696 "Photo.c"
			Dimensions _tmp24_;
			Dimensions _tmp25_ = {0};
#line 3166 "../src/Photo.vala"
			_tmp24_ = raw;
#line 3166 "../src/Photo.vala"
			orientation_rotate_dimensions (orientation, &_tmp24_, &_tmp25_);
#line 3166 "../src/Photo.vala"
			rotated_raw = _tmp25_;
#line 23705 "Photo.c"
		}
#line 3168 "../src/Photo.vala"
		_tmp26_ = rotated_raw;
#line 3168 "../src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp26_, &_tmp27_);
#line 3168 "../src/Photo.vala"
		_vala_scaled_image = _tmp27_;
#line 3169 "../src/Photo.vala"
		_tmp28_ = _vala_scaled_image;
#line 3169 "../src/Photo.vala"
		_vala_scaled_to_viewport = _tmp28_;
#line 3172 "../src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 23719 "Photo.c"
			Dimensions _tmp29_;
			Dimensions _tmp30_ = {0};
#line 3173 "../src/Photo.vala"
			_tmp29_ = _vala_scaled_image;
#line 3173 "../src/Photo.vala"
			orientation_derotate_dimensions (orientation, &_tmp29_, &_tmp30_);
#line 3173 "../src/Photo.vala"
			_vala_scaled_image = _tmp30_;
#line 23728 "Photo.c"
		}
	}
#line 3177 "../src/Photo.vala"
	_tmp32_ = _vala_scaled_image;
#line 3177 "../src/Photo.vala"
	_tmp33_ = raw;
#line 3177 "../src/Photo.vala"
	if (_tmp32_.width >= _tmp33_.width) {
#line 23737 "Photo.c"
		Dimensions _tmp34_;
		Dimensions _tmp35_;
#line 3177 "../src/Photo.vala"
		_tmp34_ = _vala_scaled_image;
#line 3177 "../src/Photo.vala"
		_tmp35_ = raw;
#line 3177 "../src/Photo.vala"
		_tmp31_ = _tmp34_.height >= _tmp35_.height;
#line 23746 "Photo.c"
	} else {
#line 3177 "../src/Photo.vala"
		_tmp31_ = FALSE;
#line 23750 "Photo.c"
	}
#line 3177 "../src/Photo.vala"
	if (_tmp31_) {
#line 23754 "Photo.c"
		Dimensions _tmp36_;
#line 3178 "../src/Photo.vala"
		_tmp36_ = raw;
#line 3178 "../src/Photo.vala"
		_vala_scaled_image = _tmp36_;
#line 3180 "../src/Photo.vala"
		result = FALSE;
#line 3180 "../src/Photo.vala"
		if (scaled_image) {
#line 3180 "../src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 23766 "Photo.c"
		}
#line 3180 "../src/Photo.vala"
		if (scaled_to_viewport) {
#line 3180 "../src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23772 "Photo.c"
		}
#line 3180 "../src/Photo.vala"
		return result;
#line 23776 "Photo.c"
	}
#line 3183 "../src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_image), "scaled_image.has_area()");
#line 3184 "../src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_to_viewport), "scaled_to_viewport.has_area()");
#line 3186 "../src/Photo.vala"
	result = TRUE;
#line 3186 "../src/Photo.vala"
	if (scaled_image) {
#line 3186 "../src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 23788 "Photo.c"
	}
#line 3186 "../src/Photo.vala"
	if (scaled_to_viewport) {
#line 3186 "../src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23794 "Photo.c"
	}
#line 3186 "../src/Photo.vala"
	return result;
#line 23798 "Photo.c"
}

static GdkPixbuf*
photo_load_raw_pixbuf (Photo* self,
                       Scaling* scaling,
                       PhotoException exceptions,
                       BackingFetchMode fetch_mode,
                       GError** error)
{
	PhotoFileReader* loader = NULL;
	PhotoFileReader* _tmp0_;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	gboolean is_scaled = FALSE;
	Scaling _tmp5_;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	GdkPixbuf* pixbuf = NULL;
	PhotoFileReader* _tmp13_;
	Dimensions _tmp14_ = {0};
	Dimensions _tmp15_;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* _tmp17_;
	Dimensions _tmp18_ = {0};
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 3192 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3192 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3195 "../src/Photo.vala"
	_tmp0_ = photo_get_backing_reader (self, fetch_mode);
#line 3195 "../src/Photo.vala"
	loader = _tmp0_;
#line 3198 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 23836 "Photo.c"
		GdkPixbuf* _tmp1_ = NULL;
		PhotoFileReader* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 3203 "../src/Photo.vala"
		_tmp2_ = loader;
#line 3203 "../src/Photo.vala"
		_tmp3_ = photo_file_reader_unscaled_read (_tmp2_, &_inner_error0_);
#line 3203 "../src/Photo.vala"
		_tmp1_ = _tmp3_;
#line 3203 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3203 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3203 "../src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3203 "../src/Photo.vala"
			return NULL;
#line 23855 "Photo.c"
		}
#line 3203 "../src/Photo.vala"
		_tmp4_ = _tmp1_;
#line 3203 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 3203 "../src/Photo.vala"
		result = _tmp4_;
#line 3203 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3203 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3203 "../src/Photo.vala"
		return result;
#line 23869 "Photo.c"
	}
#line 3208 "../src/Photo.vala"
	_tmp5_ = *scaling;
#line 3208 "../src/Photo.vala"
	_tmp8_ = photo_calculate_pixbuf_dimensions (self, &_tmp5_, exceptions, &_tmp6_, &_tmp7_);
#line 3208 "../src/Photo.vala"
	scaled_image = _tmp6_;
#line 3208 "../src/Photo.vala"
	scaled_to_viewport = _tmp7_;
#line 3208 "../src/Photo.vala"
	is_scaled = _tmp8_;
#line 3210 "../src/Photo.vala"
	if (!is_scaled) {
#line 23883 "Photo.c"
		GdkPixbuf* _tmp9_ = NULL;
		PhotoFileReader* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkPixbuf* _tmp12_;
#line 3215 "../src/Photo.vala"
		_tmp10_ = loader;
#line 3215 "../src/Photo.vala"
		_tmp11_ = photo_file_reader_unscaled_read (_tmp10_, &_inner_error0_);
#line 3215 "../src/Photo.vala"
		_tmp9_ = _tmp11_;
#line 3215 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3215 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3215 "../src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3215 "../src/Photo.vala"
			return NULL;
#line 23902 "Photo.c"
		}
#line 3215 "../src/Photo.vala"
		_tmp12_ = _tmp9_;
#line 3215 "../src/Photo.vala"
		_tmp9_ = NULL;
#line 3215 "../src/Photo.vala"
		result = _tmp12_;
#line 3215 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 3215 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3215 "../src/Photo.vala"
		return result;
#line 23916 "Photo.c"
	}
#line 3218 "../src/Photo.vala"
	_tmp13_ = loader;
#line 3218 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp14_);
#line 3218 "../src/Photo.vala"
	_tmp15_ = scaled_image;
#line 3218 "../src/Photo.vala"
	_tmp16_ = photo_file_reader_scaled_read (_tmp13_, &_tmp14_, &_tmp15_, &_inner_error0_);
#line 3218 "../src/Photo.vala"
	pixbuf = _tmp16_;
#line 3218 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3218 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3218 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3218 "../src/Photo.vala"
		return NULL;
#line 23936 "Photo.c"
	}
#line 3226 "../src/Photo.vala"
	_tmp17_ = pixbuf;
#line 3226 "../src/Photo.vala"
	dimensions_for_pixbuf (_tmp17_, &_tmp18_);
#line 3226 "../src/Photo.vala"
	_vala_assert (dimensions_approx_equals (&scaled_image, &_tmp18_, PHOTO_SCALING_FUDGE), "scaled_image.approx_equals(Dimensions.for_pixbuf(pixbuf), SCALING_FUDGE)");
#line 3228 "../src/Photo.vala"
	result = pixbuf;
#line 3228 "../src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 3228 "../src/Photo.vala"
	return result;
#line 23950 "Photo.c"
}

GdkPixbuf*
photo_get_master_pixbuf (Photo* self,
                         Scaling* scaling,
                         gboolean rotate,
                         GError** error)
{
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 3233 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3233 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3234 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3234 "../src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_MASTER, &_inner_error0_);
#line 3234 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3234 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3234 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3234 "../src/Photo.vala"
		return NULL;
#line 23981 "Photo.c"
	}
#line 3234 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3234 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3234 "../src/Photo.vala"
	result = _tmp3_;
#line 3234 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3234 "../src/Photo.vala"
	return result;
#line 23993 "Photo.c"
}

GdkPixbuf*
photo_get_unmodified_pixbuf (Photo* self,
                             Scaling* scaling,
                             gboolean rotate,
                             GError** error)
{
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 3238 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3238 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3239 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3239 "../src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_UNMODIFIED, &_inner_error0_);
#line 3239 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3239 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3239 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3239 "../src/Photo.vala"
		return NULL;
#line 24024 "Photo.c"
	}
#line 3239 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3239 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3239 "../src/Photo.vala"
	result = _tmp3_;
#line 3239 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3239 "../src/Photo.vala"
	return result;
#line 24036 "Photo.c"
}

static GdkPixbuf*
photo_get_untransformed_pixbuf (Photo* self,
                                Scaling* scaling,
                                gboolean rotate,
                                BackingFetchMode fetch_mode,
                                GError** error)
{
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	Scaling _tmp5_;
	GdkPixbuf* _tmp6_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 3243 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3243 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 24058 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3258 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3258 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 24065 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
#line 3259 "../src/Photo.vala"
			_tmp1_ = *scaling;
#line 3259 "../src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 3259 "../src/Photo.vala"
			scaled_image = _tmp2_;
#line 3259 "../src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 3261 "../src/Photo.vala"
			original_orientation = photo_get_original_orientation (self);
#line 24080 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 3258 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 3258 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24089 "Photo.c"
		}
#line 3258 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3258 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3258 "../src/Photo.vala"
			return NULL;
#line 24097 "Photo.c"
		}
	}
#line 3265 "../src/Photo.vala"
	_tmp5_ = *scaling;
#line 3265 "../src/Photo.vala"
	_tmp6_ = photo_load_raw_pixbuf (self, &_tmp5_, PHOTO_EXCEPTION_NONE, fetch_mode, &_inner_error0_);
#line 3265 "../src/Photo.vala"
	pixbuf = _tmp6_;
#line 3265 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3265 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3265 "../src/Photo.vala"
		return NULL;
#line 24112 "Photo.c"
	}
#line 3271 "../src/Photo.vala"
	if (rotate) {
#line 24116 "Photo.c"
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp8_;
#line 3272 "../src/Photo.vala"
		_tmp7_ = pixbuf;
#line 3272 "../src/Photo.vala"
		_tmp8_ = orientation_rotate_pixbuf (original_orientation, _tmp7_);
#line 3272 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3272 "../src/Photo.vala"
		pixbuf = _tmp8_;
#line 24127 "Photo.c"
	}
#line 3281 "../src/Photo.vala"
	result = pixbuf;
#line 3281 "../src/Photo.vala"
	return result;
#line 24133 "Photo.c"
}

static GdkPixbuf*
photo_real_get_pixbuf (PhotoSource* base,
                       Scaling* scaling,
                       GError** error)
{
	Photo * self;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 3284 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 3284 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3285 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3285 "../src/Photo.vala"
	_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 3285 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3285 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3285 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3285 "../src/Photo.vala"
		return NULL;
#line 24164 "Photo.c"
	}
#line 3285 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3285 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3285 "../src/Photo.vala"
	result = _tmp3_;
#line 3285 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3285 "../src/Photo.vala"
	return result;
#line 24176 "Photo.c"
}

/**
     * One-stop shopping for the source pixbuf cache.
     *
     * The source pixbuf cache holds untransformed, unscaled (full-sized) pixbufs of Photo objects.
     * These can be rather large and shouldn't be held in memory for too long, nor should many be
     * allowed to stack up.
     *
     * If locate is non-null, a source pixbuf is returned for the Photo.  If keep is true, the
     * pixbuf is stored in the cache.  (Thus, passing a Photo w/ keep == false will drop the cached
     * pixbuf.)  If Photo is non-null but keep is false, null is returned.
     *
     * Whether locate is null or not, the cache is walked in its entirety, dropping expired pixbufs
     * and dropping excessive pixbufs from the LRU.  Locating a Photo "touches" the pixbuf, i.e.
     * it moves to the head of the LRU.
     */
static gpointer
_photo_cached_pixbuf_ref0 (gpointer self)
{
#line 3320 "../src/Photo.vala"
	return self ? photo_cached_pixbuf_ref (self) : NULL;
#line 24199 "Photo.c"
}

static gboolean
_photo_trim_source_pixbuf_cache_gsource_func (gpointer self)
{
	gboolean result;
	result = photo_trim_source_pixbuf_cache ();
#line 3372 "../src/Photo.vala"
	return result;
#line 24209 "Photo.c"
}

static GdkPixbuf*
photo_run_source_pixbuf_cache (Photo* locate,
                               gboolean keep,
                               GError** error)
{
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 3303 "../src/Photo.vala"
	g_return_val_if_fail ((locate == NULL) || IS_PHOTO (locate), NULL);
#line 24221 "Photo.c"
	{
		GeeLinkedList* _tmp0_;
#line 3304 "../src/Photo.vala"
		_tmp0_ = photo_source_pixbuf_cache;
#line 3304 "../src/Photo.vala"
		g_rec_mutex_lock (&__lock_photo_photo_source_pixbuf_cache);
#line 24228 "Photo.c"
		{
			PhotoCachedPixbuf* found = NULL;
			gdouble min_elapsed = 0.0;
			gint count = 0;
			GeeIterator* iter = NULL;
			GeeLinkedList* _tmp1_;
			GeeIterator* _tmp2_;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			PhotoCachedPixbuf* _tmp20_;
			gboolean _tmp28_ = FALSE;
			PhotoCachedPixbuf* _tmp29_;
			GeeLinkedList* _tmp40_;
			gint _tmp41_;
			gint _tmp42_;
			GdkPixbuf* _tmp43_ = NULL;
			PhotoCachedPixbuf* _tmp44_;
			GdkPixbuf* _tmp47_;
#line 3305 "../src/Photo.vala"
			found = NULL;
#line 3309 "../src/Photo.vala"
			min_elapsed = DBL_MAX;
#line 3310 "../src/Photo.vala"
			count = 0;
#line 3311 "../src/Photo.vala"
			_tmp1_ = photo_source_pixbuf_cache;
#line 3311 "../src/Photo.vala"
			_tmp2_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3311 "../src/Photo.vala"
			iter = _tmp2_;
#line 3312 "../src/Photo.vala"
			while (TRUE) {
#line 24261 "Photo.c"
				GeeIterator* _tmp3_;
				PhotoCachedPixbuf* cached_pixbuf = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				gdouble elapsed = 0.0;
				PhotoCachedPixbuf* _tmp6_;
				GTimer* _tmp7_;
				gboolean _tmp8_ = FALSE;
#line 3312 "../src/Photo.vala"
				_tmp3_ = iter;
#line 3312 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 3312 "../src/Photo.vala"
					break;
#line 24276 "Photo.c"
				}
#line 3313 "../src/Photo.vala"
				_tmp4_ = iter;
#line 3313 "../src/Photo.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 3313 "../src/Photo.vala"
				cached_pixbuf = (PhotoCachedPixbuf*) _tmp5_;
#line 3315 "../src/Photo.vala"
				_tmp6_ = cached_pixbuf;
#line 3315 "../src/Photo.vala"
				_tmp7_ = _tmp6_->last_touched;
#line 3315 "../src/Photo.vala"
				elapsed = trunc (g_timer_elapsed (_tmp7_, NULL)) + 1;
#line 3317 "../src/Photo.vala"
				if (locate != NULL) {
#line 24292 "Photo.c"
					PhotoCachedPixbuf* _tmp9_;
					Photo* _tmp10_;
#line 3317 "../src/Photo.vala"
					_tmp9_ = cached_pixbuf;
#line 3317 "../src/Photo.vala"
					_tmp10_ = _tmp9_->photo;
#line 3317 "../src/Photo.vala"
					_tmp8_ = data_source_equals (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (locate, TYPE_DATA_SOURCE, DataSource));
#line 24301 "Photo.c"
				} else {
#line 3317 "../src/Photo.vala"
					_tmp8_ = FALSE;
#line 24305 "Photo.c"
				}
#line 3317 "../src/Photo.vala"
				if (_tmp8_) {
#line 24309 "Photo.c"
					GeeIterator* _tmp11_;
					PhotoCachedPixbuf* _tmp12_;
					PhotoCachedPixbuf* _tmp13_;
					gint _tmp14_;
#line 3319 "../src/Photo.vala"
					_tmp11_ = iter;
#line 3319 "../src/Photo.vala"
					gee_iterator_remove (_tmp11_);
#line 3320 "../src/Photo.vala"
					_tmp12_ = cached_pixbuf;
#line 3320 "../src/Photo.vala"
					_tmp13_ = _photo_cached_pixbuf_ref0 (_tmp12_);
#line 3320 "../src/Photo.vala"
					_photo_cached_pixbuf_unref0 (found);
#line 3320 "../src/Photo.vala"
					found = _tmp13_;
#line 3323 "../src/Photo.vala"
					_tmp14_ = count;
#line 3323 "../src/Photo.vala"
					count = _tmp14_ + 1;
#line 24330 "Photo.c"
				} else {
#line 3324 "../src/Photo.vala"
					if (elapsed >= ((gdouble) PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC)) {
#line 24334 "Photo.c"
						GeeIterator* _tmp15_;
#line 3325 "../src/Photo.vala"
						_tmp15_ = iter;
#line 3325 "../src/Photo.vala"
						gee_iterator_remove (_tmp15_);
#line 24340 "Photo.c"
					} else {
#line 3326 "../src/Photo.vala"
						if (count >= PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT) {
#line 24344 "Photo.c"
							GeeIterator* _tmp16_;
#line 3327 "../src/Photo.vala"
							_tmp16_ = iter;
#line 3327 "../src/Photo.vala"
							gee_iterator_remove (_tmp16_);
#line 24350 "Photo.c"
						} else {
							gint _tmp17_;
#line 3331 "../src/Photo.vala"
							min_elapsed = MIN (elapsed, min_elapsed);
#line 3332 "../src/Photo.vala"
							_tmp17_ = count;
#line 3332 "../src/Photo.vala"
							count = _tmp17_ + 1;
#line 24359 "Photo.c"
						}
					}
				}
#line 3312 "../src/Photo.vala"
				_photo_cached_pixbuf_unref0 (cached_pixbuf);
#line 24365 "Photo.c"
			}
#line 3337 "../src/Photo.vala"
			_tmp20_ = found;
#line 3337 "../src/Photo.vala"
			if (_tmp20_ == NULL) {
#line 3337 "../src/Photo.vala"
				_tmp19_ = locate != NULL;
#line 24373 "Photo.c"
			} else {
#line 3337 "../src/Photo.vala"
				_tmp19_ = FALSE;
#line 24377 "Photo.c"
			}
#line 3337 "../src/Photo.vala"
			if (_tmp19_) {
#line 3337 "../src/Photo.vala"
				_tmp18_ = keep;
#line 24383 "Photo.c"
			} else {
#line 3337 "../src/Photo.vala"
				_tmp18_ = FALSE;
#line 24387 "Photo.c"
			}
#line 3337 "../src/Photo.vala"
			if (_tmp18_) {
#line 24391 "Photo.c"
				GdkPixbuf* _tmp21_ = NULL;
				Scaling _tmp22_ = {0};
				GdkPixbuf* _tmp23_;
				PhotoCachedPixbuf* _tmp24_;
#line 3339 "../src/Photo.vala"
				scaling_for_original (&_tmp22_);
#line 3339 "../src/Photo.vala"
				_tmp23_ = photo_load_raw_pixbuf (locate, &_tmp22_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3339 "../src/Photo.vala"
				_tmp21_ = _tmp23_;
#line 3339 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3339 "../src/Photo.vala"
					_g_object_unref0 (iter);
#line 3339 "../src/Photo.vala"
					_photo_cached_pixbuf_unref0 (found);
#line 24408 "Photo.c"
					goto __finally0;
				}
#line 3338 "../src/Photo.vala"
				_tmp24_ = photo_cached_pixbuf_new (locate, _tmp21_);
#line 3338 "../src/Photo.vala"
				_photo_cached_pixbuf_unref0 (found);
#line 3338 "../src/Photo.vala"
				found = _tmp24_;
#line 3337 "../src/Photo.vala"
				_g_object_unref0 (_tmp21_);
#line 24419 "Photo.c"
			} else {
				PhotoCachedPixbuf* _tmp25_;
#line 3340 "../src/Photo.vala"
				_tmp25_ = found;
#line 3340 "../src/Photo.vala"
				if (_tmp25_ != NULL) {
#line 24426 "Photo.c"
					PhotoCachedPixbuf* _tmp26_;
					GTimer* _tmp27_;
#line 3342 "../src/Photo.vala"
					_tmp26_ = found;
#line 3342 "../src/Photo.vala"
					_tmp27_ = _tmp26_->last_touched;
#line 3342 "../src/Photo.vala"
					g_timer_start (_tmp27_);
#line 24435 "Photo.c"
				}
			}
#line 3346 "../src/Photo.vala"
			_tmp29_ = found;
#line 3346 "../src/Photo.vala"
			if (_tmp29_ != NULL) {
#line 3346 "../src/Photo.vala"
				_tmp28_ = keep;
#line 24444 "Photo.c"
			} else {
#line 3346 "../src/Photo.vala"
				_tmp28_ = FALSE;
#line 24448 "Photo.c"
			}
#line 3346 "../src/Photo.vala"
			if (_tmp28_) {
#line 24452 "Photo.c"
				GeeLinkedList* _tmp30_;
				PhotoCachedPixbuf* _tmp31_;
				PhotoCachedPixbuf* _tmp32_;
				GTimer* _tmp33_;
#line 3347 "../src/Photo.vala"
				_tmp30_ = photo_source_pixbuf_cache;
#line 3347 "../src/Photo.vala"
				_tmp31_ = found;
#line 3347 "../src/Photo.vala"
				gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0, _tmp31_);
#line 3352 "../src/Photo.vala"
				_tmp32_ = found;
#line 3352 "../src/Photo.vala"
				_tmp33_ = _tmp32_->last_touched;
#line 3352 "../src/Photo.vala"
				min_elapsed = MIN (g_timer_elapsed (_tmp33_, NULL), min_elapsed);
#line 3356 "../src/Photo.vala"
				while (TRUE) {
#line 24471 "Photo.c"
					GeeLinkedList* _tmp34_;
					gint _tmp35_;
					gint _tmp36_;
					GeeLinkedList* _tmp37_;
					gpointer _tmp38_;
					PhotoCachedPixbuf* _tmp39_;
#line 3356 "../src/Photo.vala"
					_tmp34_ = photo_source_pixbuf_cache;
#line 3356 "../src/Photo.vala"
					_tmp35_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3356 "../src/Photo.vala"
					_tmp36_ = _tmp35_;
#line 3356 "../src/Photo.vala"
					if (!(_tmp36_ > PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT)) {
#line 3356 "../src/Photo.vala"
						break;
#line 24488 "Photo.c"
					}
#line 3357 "../src/Photo.vala"
					_tmp37_ = photo_source_pixbuf_cache;
#line 3357 "../src/Photo.vala"
					_tmp38_ = gee_deque_poll_tail (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_DEQUE, GeeDeque));
#line 3357 "../src/Photo.vala"
					_tmp39_ = (PhotoCachedPixbuf*) _tmp38_;
#line 3357 "../src/Photo.vala"
					_photo_cached_pixbuf_unref0 (_tmp39_);
#line 24498 "Photo.c"
				}
			}
#line 3361 "../src/Photo.vala"
			if (photo_discard_source_id != ((guint) 0)) {
#line 3362 "../src/Photo.vala"
				g_source_remove (photo_discard_source_id);
#line 3363 "../src/Photo.vala"
				photo_discard_source_id = (guint) 0;
#line 24507 "Photo.c"
			}
#line 3367 "../src/Photo.vala"
			_tmp40_ = photo_source_pixbuf_cache;
#line 3367 "../src/Photo.vala"
			_tmp41_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3367 "../src/Photo.vala"
			_tmp42_ = _tmp41_;
#line 3367 "../src/Photo.vala"
			if (_tmp42_ > PHOTO_SOURCE_PIXBUF_MIN_LRU_COUNT) {
#line 24517 "Photo.c"
				guint retry_sec = 0U;
#line 3368 "../src/Photo.vala"
				_vala_assert (min_elapsed >= 0.0, "min_elapsed >= 0.0");
#line 3371 "../src/Photo.vala"
				retry_sec = PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC - ((guint) trunc (min_elapsed));
#line 3372 "../src/Photo.vala"
				photo_discard_source_id = g_timeout_add_seconds_full (G_PRIORITY_LOW, retry_sec, _photo_trim_source_pixbuf_cache_gsource_func, NULL, NULL);
#line 24525 "Photo.c"
			}
#line 3375 "../src/Photo.vala"
			_tmp44_ = found;
#line 3375 "../src/Photo.vala"
			if (_tmp44_ != NULL) {
#line 24531 "Photo.c"
				PhotoCachedPixbuf* _tmp45_;
				GdkPixbuf* _tmp46_;
#line 3375 "../src/Photo.vala"
				_tmp45_ = found;
#line 3375 "../src/Photo.vala"
				_tmp46_ = _tmp45_->pixbuf;
#line 3375 "../src/Photo.vala"
				_tmp43_ = _tmp46_;
#line 24540 "Photo.c"
			} else {
#line 3375 "../src/Photo.vala"
				_tmp43_ = NULL;
#line 24544 "Photo.c"
			}
#line 3375 "../src/Photo.vala"
			_tmp47_ = _g_object_ref0 (_tmp43_);
#line 3375 "../src/Photo.vala"
			result = _tmp47_;
#line 3375 "../src/Photo.vala"
			_g_object_unref0 (iter);
#line 3375 "../src/Photo.vala"
			_photo_cached_pixbuf_unref0 (found);
#line 24554 "Photo.c"
			{
				GError* _inner_error0_ = NULL;
				GeeLinkedList* _tmp48_;
#line 3304 "../src/Photo.vala"
				_tmp48_ = photo_source_pixbuf_cache;
#line 3304 "../src/Photo.vala"
				g_rec_mutex_unlock (&__lock_photo_photo_source_pixbuf_cache);
#line 24562 "Photo.c"
			}
#line 3375 "../src/Photo.vala"
			return result;
#line 24566 "Photo.c"
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			GeeLinkedList* _tmp49_;
#line 3304 "../src/Photo.vala"
			_tmp49_ = photo_source_pixbuf_cache;
#line 3304 "../src/Photo.vala"
			g_rec_mutex_unlock (&__lock_photo_photo_source_pixbuf_cache);
#line 24576 "Photo.c"
		}
#line 3304 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3304 "../src/Photo.vala"
		return NULL;
#line 24582 "Photo.c"
	}
}

static gboolean
photo_trim_source_pixbuf_cache (void)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	{
		GdkPixbuf* _tmp0_;
		GdkPixbuf* _tmp1_;
#line 3381 "../src/Photo.vala"
		_tmp0_ = photo_run_source_pixbuf_cache (NULL, FALSE, &_inner_error0_);
#line 3381 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3381 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3381 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24602 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 3380 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 24611 "Photo.c"
	}
	__finally0:
#line 3380 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24616 "Photo.c"
		gboolean _tmp2_ = FALSE;
#line 3380 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3380 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3380 "../src/Photo.vala"
		return _tmp2_;
#line 24624 "Photo.c"
	}
#line 3385 "../src/Photo.vala"
	result = FALSE;
#line 3385 "../src/Photo.vala"
	return result;
#line 24630 "Photo.c"
}

/**
     * @brief Get a copy of what's in the cache.
     *
     * @return A copy of the Pixbuf with the image data from unmodified_precached.
     */
GdkPixbuf*
photo_get_prefetched_copy (Photo* self,
                           GError** error)
{
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 3393 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3394 "../src/Photo.vala"
	_tmp1_ = photo_run_source_pixbuf_cache (self, TRUE, &_inner_error0_);
#line 3394 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 3394 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3394 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3394 "../src/Photo.vala"
		return NULL;
#line 24659 "Photo.c"
	}
#line 3394 "../src/Photo.vala"
	_tmp2_ = gdk_pixbuf_copy (_tmp0_);
#line 3394 "../src/Photo.vala"
	result = _tmp2_;
#line 3394 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3394 "../src/Photo.vala"
	return result;
#line 24669 "Photo.c"
}

/**
     * @brief Discards the cached version of the unmodified image.
     */
void
photo_discard_prefetched (Photo* self)
{
	GError* _inner_error0_ = NULL;
#line 3400 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 24681 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
		GdkPixbuf* _tmp1_;
#line 3402 "../src/Photo.vala"
		_tmp0_ = photo_run_source_pixbuf_cache (self, FALSE, &_inner_error0_);
#line 3402 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3402 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3402 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24693 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 3401 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 24702 "Photo.c"
	}
	__finally0:
#line 3401 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3401 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3401 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3401 "../src/Photo.vala"
		return;
#line 24713 "Photo.c"
	}
}

/**
     * @brief Returns a fully transformed and scaled pixbuf.  Transformations may be excluded via
     * the mask. If the image is smaller than the scaling, it will be returned in its actual size.
     * The caller is responsible for scaling thereafter.
     *
     * @param scaling A scaling object that describes the size the output pixbuf should be.
     * @param exceptions The parts of the pipeline that should be skipped; defaults to NONE if
     *      left unset.
     * @param fetch_mode The fetch mode; if left unset, defaults to BASELINE so that
     *      we get the image exactly as it is in the file.
     */
GdkPixbuf*
photo_get_pixbuf_with_options (Photo* self,
                               Scaling* scaling,
                               PhotoException exceptions,
                               BackingFetchMode fetch_mode,
                               GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	gboolean is_straightened = FALSE;
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	EditingToolsRedeyeInstance* redeye_instances = NULL;
	gint redeye_instances_length1;
	gint _redeye_instances_size_;
	Box crop = {0};
	gdouble straightening_angle = 0.0;
	PixelTransformer* transformer = NULL;
	Orientation orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp22_;
	gboolean _tmp60_ = FALSE;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 3418 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3418 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3431 "../src/Photo.vala"
	_tmp3_ = photo_get_develop_raw_photos_to_files ();
#line 3431 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3431 "../src/Photo.vala"
	if (_tmp4_) {
#line 3432 "../src/Photo.vala"
		_tmp2_ = photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 24770 "Photo.c"
	} else {
#line 3431 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 24774 "Photo.c"
	}
#line 3431 "../src/Photo.vala"
	if (_tmp2_) {
#line 24778 "Photo.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 3433 "../src/Photo.vala"
		if (fetch_mode == BACKING_FETCH_MODE_BASELINE) {
#line 3433 "../src/Photo.vala"
			_tmp6_ = TRUE;
#line 24785 "Photo.c"
		} else {
#line 3433 "../src/Photo.vala"
			_tmp6_ = fetch_mode == BACKING_FETCH_MODE_UNMODIFIED;
#line 24789 "Photo.c"
		}
#line 3433 "../src/Photo.vala"
		if (_tmp6_) {
#line 3433 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 24795 "Photo.c"
		} else {
#line 3434 "../src/Photo.vala"
			_tmp5_ = fetch_mode == BACKING_FETCH_MODE_SOURCE;
#line 24799 "Photo.c"
		}
#line 3433 "../src/Photo.vala"
		_tmp1_ = _tmp5_;
#line 24803 "Photo.c"
	} else {
#line 3431 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 24807 "Photo.c"
	}
#line 3431 "../src/Photo.vala"
	if (_tmp1_) {
#line 3435 "../src/Photo.vala"
		_tmp0_ = !photo_is_raw_developer_complete (self, photo_get_raw_developer (self));
#line 24813 "Photo.c"
	} else {
#line 3431 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 24817 "Photo.c"
	}
#line 3431 "../src/Photo.vala"
	if (_tmp0_) {
#line 3436 "../src/Photo.vala"
		photo_set_raw_developer (self, photo_get_raw_developer (self), TRUE);
#line 24823 "Photo.c"
	}
#line 3441 "../src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 3442 "../src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 3443 "../src/Photo.vala"
	redeye_instances = NULL;
#line 3443 "../src/Photo.vala"
	redeye_instances_length1 = 0;
#line 3443 "../src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 3446 "../src/Photo.vala"
	transformer = NULL;
#line 24837 "Photo.c"
	{
		PhotoRow* _tmp7_;
#line 3449 "../src/Photo.vala"
		_tmp7_ = self->row;
#line 3449 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 24844 "Photo.c"
		{
			Dimensions _tmp8_ = {0};
			Dimensions _tmp9_ = {0};
			Dimensions _tmp10_ = {0};
			Dimensions _tmp11_;
			Dimensions _tmp12_ = {0};
			Dimensions _tmp13_;
			gint _tmp14_ = 0;
			EditingToolsRedeyeInstance* _tmp15_;
			Box _tmp16_ = {0};
			gboolean _tmp17_;
			gdouble _tmp18_ = 0.0;
			gboolean _tmp19_;
#line 3450 "../src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_ALL, &_tmp8_);
#line 3450 "../src/Photo.vala"
			original = _tmp8_;
#line 3451 "../src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), exceptions, &_tmp9_);
#line 3451 "../src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp9_, &_tmp10_);
#line 3451 "../src/Photo.vala"
			scaled = _tmp10_;
#line 3452 "../src/Photo.vala"
			_tmp11_ = scaled;
#line 3452 "../src/Photo.vala"
			scaled_to_viewport = _tmp11_;
#line 3454 "../src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp12_);
#line 3454 "../src/Photo.vala"
			_tmp13_ = scaled;
#line 3454 "../src/Photo.vala"
			is_scaled = !dimensions_equals (&_tmp12_, &_tmp13_);
#line 3456 "../src/Photo.vala"
			_tmp15_ = photo_get_raw_redeye_instances (self, &_tmp14_);
#line 3456 "../src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3456 "../src/Photo.vala"
			redeye_instances = _tmp15_;
#line 3456 "../src/Photo.vala"
			redeye_instances_length1 = _tmp14_;
#line 3456 "../src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 3458 "../src/Photo.vala"
			_tmp17_ = photo_get_raw_crop (self, &_tmp16_);
#line 3458 "../src/Photo.vala"
			crop = _tmp16_;
#line 3458 "../src/Photo.vala"
			is_cropped = _tmp17_;
#line 3460 "../src/Photo.vala"
			_tmp19_ = photo_get_raw_straighten (self, &_tmp18_);
#line 3460 "../src/Photo.vala"
			straightening_angle = _tmp18_;
#line 3460 "../src/Photo.vala"
			is_straightened = _tmp19_;
#line 3462 "../src/Photo.vala"
			if (photo_has_color_adjustments (self)) {
#line 24902 "Photo.c"
				PixelTransformer* _tmp20_;
#line 3463 "../src/Photo.vala"
				_tmp20_ = photo_get_pixel_transformer (self);
#line 3463 "../src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 3463 "../src/Photo.vala"
				transformer = _tmp20_;
#line 24910 "Photo.c"
			}
#line 3465 "../src/Photo.vala"
			orientation = photo_get_orientation (self);
#line 24914 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp21_;
#line 3449 "../src/Photo.vala"
			_tmp21_ = self->row;
#line 3449 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24923 "Photo.c"
		}
#line 3449 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3449 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3449 "../src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 3449 "../src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3449 "../src/Photo.vala"
			return NULL;
#line 24935 "Photo.c"
		}
	}
#line 3472 "../src/Photo.vala"
	_tmp22_ = photo_get_prefetched_copy (self, &_inner_error0_);
#line 3472 "../src/Photo.vala"
	pixbuf = _tmp22_;
#line 3472 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3472 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3472 "../src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 3472 "../src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 3472 "../src/Photo.vala"
		return NULL;
#line 24952 "Photo.c"
	}
#line 3479 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_REDEYE)) {
#line 24956 "Photo.c"
		EditingToolsRedeyeInstance* _tmp23_;
		gint _tmp23__length1;
#line 3484 "../src/Photo.vala"
		_tmp23_ = redeye_instances;
#line 3484 "../src/Photo.vala"
		_tmp23__length1 = redeye_instances_length1;
#line 24963 "Photo.c"
		{
			EditingToolsRedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 3484 "../src/Photo.vala"
			instance_collection = _tmp23_;
#line 3484 "../src/Photo.vala"
			instance_collection_length1 = _tmp23__length1;
#line 3484 "../src/Photo.vala"
			for (instance_it = 0; instance_it < instance_collection_length1; instance_it = instance_it + 1) {
#line 24975 "Photo.c"
				EditingToolsRedeyeInstance instance = {0};
#line 3484 "../src/Photo.vala"
				instance = instance_collection[instance_it];
#line 24979 "Photo.c"
				{
					GdkPixbuf* _tmp24_;
					EditingToolsRedeyeInstance _tmp25_;
					GdkPixbuf* _tmp26_;
#line 3485 "../src/Photo.vala"
					_tmp24_ = pixbuf;
#line 3485 "../src/Photo.vala"
					_tmp25_ = instance;
#line 3485 "../src/Photo.vala"
					_tmp26_ = photo_do_redeye (self, _tmp24_, &_tmp25_);
#line 3485 "../src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 3485 "../src/Photo.vala"
					pixbuf = _tmp26_;
#line 24994 "Photo.c"
				}
			}
		}
	}
#line 3493 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 3497 "../src/Photo.vala"
		if (is_straightened) {
#line 25003 "Photo.c"
			GdkPixbuf* _tmp27_;
			GdkPixbuf* _tmp28_;
#line 3498 "../src/Photo.vala"
			_tmp27_ = pixbuf;
#line 3498 "../src/Photo.vala"
			_tmp28_ = rotate_arb (_tmp27_, straightening_angle);
#line 3498 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3498 "../src/Photo.vala"
			pixbuf = _tmp28_;
#line 25014 "Photo.c"
		}
	}
#line 3507 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 3511 "../src/Photo.vala"
		if (is_cropped) {
#line 25021 "Photo.c"
			Box _tmp29_;
			GdkPixbuf* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			Box _tmp33_;
			GdkPixbuf* _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			Box _tmp37_;
			Box _tmp38_;
			GdkPixbuf* _tmp39_;
			gint _tmp40_;
			gint _tmp41_;
			Box _tmp42_;
			Box _tmp43_;
			GdkPixbuf* _tmp44_;
			gint _tmp45_;
			gint _tmp46_;
			GdkPixbuf* _tmp47_;
			Box _tmp48_;
			Box _tmp49_;
			GdkPixbuf* _tmp50_;
#line 3516 "../src/Photo.vala"
			_tmp29_ = crop;
#line 3516 "../src/Photo.vala"
			_tmp30_ = pixbuf;
#line 3516 "../src/Photo.vala"
			_tmp31_ = gdk_pixbuf_get_width (_tmp30_);
#line 3516 "../src/Photo.vala"
			_tmp32_ = _tmp31_;
#line 3516 "../src/Photo.vala"
			crop.left = CLAMP (_tmp29_.left, 0, _tmp32_ - 2);
#line 3517 "../src/Photo.vala"
			_tmp33_ = crop;
#line 3517 "../src/Photo.vala"
			_tmp34_ = pixbuf;
#line 3517 "../src/Photo.vala"
			_tmp35_ = gdk_pixbuf_get_height (_tmp34_);
#line 3517 "../src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 3517 "../src/Photo.vala"
			crop.top = CLAMP (_tmp33_.top, 0, _tmp36_ - 2);
#line 3519 "../src/Photo.vala"
			_tmp37_ = crop;
#line 3519 "../src/Photo.vala"
			_tmp38_ = crop;
#line 3519 "../src/Photo.vala"
			_tmp39_ = pixbuf;
#line 3519 "../src/Photo.vala"
			_tmp40_ = gdk_pixbuf_get_width (_tmp39_);
#line 3519 "../src/Photo.vala"
			_tmp41_ = _tmp40_;
#line 3519 "../src/Photo.vala"
			crop.right = CLAMP (_tmp37_.right, _tmp38_.left + 1, _tmp41_ - 1);
#line 3520 "../src/Photo.vala"
			_tmp42_ = crop;
#line 3520 "../src/Photo.vala"
			_tmp43_ = crop;
#line 3520 "../src/Photo.vala"
			_tmp44_ = pixbuf;
#line 3520 "../src/Photo.vala"
			_tmp45_ = gdk_pixbuf_get_height (_tmp44_);
#line 3520 "../src/Photo.vala"
			_tmp46_ = _tmp45_;
#line 3520 "../src/Photo.vala"
			crop.bottom = CLAMP (_tmp42_.bottom, _tmp43_.top + 1, _tmp46_ - 1);
#line 3522 "../src/Photo.vala"
			_tmp47_ = pixbuf;
#line 3522 "../src/Photo.vala"
			_tmp48_ = crop;
#line 3522 "../src/Photo.vala"
			_tmp49_ = crop;
#line 3522 "../src/Photo.vala"
			_tmp50_ = gdk_pixbuf_new_subpixbuf (_tmp47_, _tmp48_.left, _tmp49_.top, box_get_width (&crop), box_get_height (&crop));
#line 3522 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3522 "../src/Photo.vala"
			pixbuf = _tmp50_;
#line 25100 "Photo.c"
		}
	}
#line 3532 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 25105 "Photo.c"
		GdkPixbuf* _tmp51_;
		GdkPixbuf* _tmp52_;
#line 3536 "../src/Photo.vala"
		_tmp51_ = pixbuf;
#line 3536 "../src/Photo.vala"
		_tmp52_ = orientation_rotate_pixbuf (orientation, _tmp51_);
#line 3536 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3536 "../src/Photo.vala"
		pixbuf = _tmp52_;
#line 25116 "Photo.c"
	}
#line 3543 "../src/Photo.vala"
	if (is_scaled) {
#line 25120 "Photo.c"
		GdkPixbuf* _tmp53_;
		Dimensions _tmp54_;
		Dimensions _tmp55_;
		GdkPixbuf* _tmp56_;
#line 3547 "../src/Photo.vala"
		_tmp53_ = pixbuf;
#line 3547 "../src/Photo.vala"
		_tmp54_ = scaled_to_viewport;
#line 3547 "../src/Photo.vala"
		_tmp55_ = scaled_to_viewport;
#line 3547 "../src/Photo.vala"
		_tmp56_ = gdk_pixbuf_scale_simple (_tmp53_, _tmp54_.width, _tmp55_.height, GDK_INTERP_BILINEAR);
#line 3547 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3547 "../src/Photo.vala"
		pixbuf = _tmp56_;
#line 25137 "Photo.c"
	}
#line 3555 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ADJUST)) {
#line 25141 "Photo.c"
		PixelTransformer* _tmp57_;
#line 3559 "../src/Photo.vala"
		_tmp57_ = transformer;
#line 3559 "../src/Photo.vala"
		if (_tmp57_ != NULL) {
#line 25147 "Photo.c"
			PixelTransformer* _tmp58_;
			GdkPixbuf* _tmp59_;
#line 3560 "../src/Photo.vala"
			_tmp58_ = transformer;
#line 3560 "../src/Photo.vala"
			_tmp59_ = pixbuf;
#line 3560 "../src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp58_, _tmp59_, NULL);
#line 25156 "Photo.c"
		}
	}
#line 3569 "../src/Photo.vala"
	if (is_scaled) {
#line 3569 "../src/Photo.vala"
		_tmp60_ = !is_straightened;
#line 25163 "Photo.c"
	} else {
#line 3569 "../src/Photo.vala"
		_tmp60_ = FALSE;
#line 25167 "Photo.c"
	}
#line 3569 "../src/Photo.vala"
	if (_tmp60_) {
#line 25171 "Photo.c"
		GdkPixbuf* _tmp61_;
		Dimensions _tmp62_ = {0};
#line 3570 "../src/Photo.vala"
		_tmp61_ = pixbuf;
#line 3570 "../src/Photo.vala"
		dimensions_for_pixbuf (_tmp61_, &_tmp62_);
#line 3570 "../src/Photo.vala"
		_vala_assert (dimensions_approx_equals (&scaled_to_viewport, &_tmp62_, PHOTO_SCALING_FUDGE), "scaled_to_viewport.approx_equals(Dimensions.for_pixbuf(pixbuf), SCALING_FUDGE)");
#line 25180 "Photo.c"
	}
#line 3578 "../src/Photo.vala"
	result = pixbuf;
#line 3578 "../src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 3578 "../src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 3578 "../src/Photo.vala"
	return result;
#line 25190 "Photo.c"
}

static gboolean
photo_real_has_user_generated_metadata (Photo* self)
{
	gboolean _tmp0_ = FALSE;
#line 3586 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3586 "../src/Photo.vala"
	return _tmp0_;
#line 25201 "Photo.c"
}

gboolean
photo_has_user_generated_metadata (Photo* self)
{
	PhotoClass* _klass_;
#line 3586 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3586 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 3586 "../src/Photo.vala"
	if (_klass_->has_user_generated_metadata) {
#line 3586 "../src/Photo.vala"
		return _klass_->has_user_generated_metadata (self);
#line 25216 "Photo.c"
	}
#line 3586 "../src/Photo.vala"
	return FALSE;
#line 25220 "Photo.c"
}

static void
photo_real_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata)
{
#line 3590 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3590 "../src/Photo.vala"
	return;
#line 25231 "Photo.c"
}

void
photo_set_user_metadata_for_export (Photo* self,
                                    PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 3590 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3590 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 3590 "../src/Photo.vala"
	if (_klass_->set_user_metadata_for_export) {
#line 3590 "../src/Photo.vala"
		_klass_->set_user_metadata_for_export (self, metadata);
#line 25247 "Photo.c"
	}
}

gchar*
photo_get_export_basename (Photo* self,
                           PhotoFileFormat* file_format)
{
	gchar* result = NULL;
#line 3597 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3598 "../src/Photo.vala"
	if (file_format != NULL) {
#line 25260 "Photo.c"
		PhotoFileFormatProperties* _tmp0_;
		PhotoFileFormatProperties* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 3599 "../src/Photo.vala"
		_tmp0_ = photo_file_format_get_properties (*file_format);
#line 3599 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3599 "../src/Photo.vala"
		_tmp2_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3599 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3599 "../src/Photo.vala"
		_tmp4_ = photo_file_format_properties_convert_file_extension (_tmp1_, _tmp3_);
#line 3599 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3599 "../src/Photo.vala"
		_tmp6_ = g_file_get_basename (_tmp5_);
#line 3599 "../src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3599 "../src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3599 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 3599 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp1_);
#line 3599 "../src/Photo.vala"
		result = _tmp7_;
#line 3599 "../src/Photo.vala"
		return result;
#line 25295 "Photo.c"
	} else {
#line 3601 "../src/Photo.vala"
		if (photo_file_format_can_write (photo_get_file_format (self))) {
#line 25299 "Photo.c"
			PhotoFileFormatProperties* _tmp8_;
			PhotoFileFormatProperties* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 3602 "../src/Photo.vala"
			_tmp8_ = photo_file_format_get_properties (photo_get_file_format (self));
#line 3602 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 3602 "../src/Photo.vala"
			_tmp10_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3602 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 3602 "../src/Photo.vala"
			_tmp12_ = photo_file_format_properties_convert_file_extension (_tmp9_, _tmp11_);
#line 3602 "../src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 3602 "../src/Photo.vala"
			_tmp14_ = g_file_get_basename (_tmp13_);
#line 3602 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3602 "../src/Photo.vala"
			_g_object_unref0 (_tmp13_);
#line 3602 "../src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 3602 "../src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp9_);
#line 3602 "../src/Photo.vala"
			result = _tmp15_;
#line 3602 "../src/Photo.vala"
			return result;
#line 25334 "Photo.c"
		} else {
			PhotoFileFormatProperties* _tmp16_;
			PhotoFileFormatProperties* _tmp17_;
			GFile* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 3605 "../src/Photo.vala"
			_tmp16_ = photo_file_format_get_properties (photo_file_format_get_system_default_format ());
#line 3605 "../src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 3605 "../src/Photo.vala"
			_tmp18_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3605 "../src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 3605 "../src/Photo.vala"
			_tmp20_ = photo_file_format_properties_convert_file_extension (_tmp17_, _tmp19_);
#line 3605 "../src/Photo.vala"
			_tmp21_ = _tmp20_;
#line 3605 "../src/Photo.vala"
			_tmp22_ = g_file_get_basename (_tmp21_);
#line 3605 "../src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3605 "../src/Photo.vala"
			_g_object_unref0 (_tmp21_);
#line 3605 "../src/Photo.vala"
			_g_object_unref0 (_tmp19_);
#line 3605 "../src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp17_);
#line 3605 "../src/Photo.vala"
			result = _tmp23_;
#line 3605 "../src/Photo.vala"
			return result;
#line 25370 "Photo.c"
		}
	}
}

static gboolean
photo_export_fullsized_backing (Photo* self,
                                GFile* file,
                                gboolean export_metadata,
                                GError** error)
{
	PhotoFileReader* export_reader = NULL;
	gboolean is_master = FALSE;
	PhotoFileReader* _tmp24_;
	PhotoFileFormatProperties* format_properties = NULL;
	PhotoFileReader* _tmp25_;
	PhotoFileFormatProperties* _tmp26_;
	GFile* dest_file = NULL;
	PhotoFileFormatProperties* _tmp27_;
	GFile* _tmp28_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	PhotoFileMetadataWriter* _tmp33_;
	PhotoFileMetadataWriter* _tmp34_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	PhotoFileMetadataWriter* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	PhotoFileReader* _tmp41_;
	GFile* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp55_;
	PhotoMetadata* _tmp56_;
	PhotoMetadata* _tmp58_;
	PhotoFileMetadataWriter* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	PhotoFileMetadataWriter* _tmp81_;
	PhotoMetadata* _tmp82_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 3611 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3611 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 3614 "../src/Photo.vala"
	export_reader = NULL;
#line 3615 "../src/Photo.vala"
	is_master = TRUE;
#line 25430 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3616 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3616 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 25437 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 3617 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3617 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3617 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 25448 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 3617 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3617 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3617 "../src/Photo.vala"
				_tmp1_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 25457 "Photo.c"
			} else {
#line 3617 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 25461 "Photo.c"
			}
#line 3617 "../src/Photo.vala"
			if (_tmp1_) {
#line 25465 "Photo.c"
				PhotoBackingReaders* _tmp6_;
				PhotoFileReader* _tmp7_;
				PhotoFileReader* _tmp8_;
#line 3618 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3618 "../src/Photo.vala"
				_tmp7_ = _tmp6_->editable;
#line 3618 "../src/Photo.vala"
				_tmp8_ = _photo_file_adapter_ref0 (_tmp7_);
#line 3618 "../src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 3618 "../src/Photo.vala"
				export_reader = _tmp8_;
#line 3619 "../src/Photo.vala"
				is_master = FALSE;
#line 25481 "Photo.c"
			} else {
				gboolean _tmp9_ = FALSE;
				PhotoBackingReaders* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 3620 "../src/Photo.vala"
				_tmp10_ = self->priv->readers;
#line 3620 "../src/Photo.vala"
				_tmp11_ = _tmp10_->developer;
#line 3620 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 25492 "Photo.c"
					PhotoBackingReaders* _tmp12_;
					PhotoFileReader* _tmp13_;
#line 3620 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 3620 "../src/Photo.vala"
					_tmp13_ = _tmp12_->developer;
#line 3620 "../src/Photo.vala"
					_tmp9_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 25501 "Photo.c"
				} else {
#line 3620 "../src/Photo.vala"
					_tmp9_ = FALSE;
#line 25505 "Photo.c"
				}
#line 3620 "../src/Photo.vala"
				if (_tmp9_) {
#line 25509 "Photo.c"
					PhotoBackingReaders* _tmp14_;
					PhotoFileReader* _tmp15_;
					PhotoFileReader* _tmp16_;
#line 3621 "../src/Photo.vala"
					_tmp14_ = self->priv->readers;
#line 3621 "../src/Photo.vala"
					_tmp15_ = _tmp14_->developer;
#line 3621 "../src/Photo.vala"
					_tmp16_ = _photo_file_adapter_ref0 (_tmp15_);
#line 3621 "../src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 3621 "../src/Photo.vala"
					export_reader = _tmp16_;
#line 3622 "../src/Photo.vala"
					is_master = FALSE;
#line 25525 "Photo.c"
				} else {
					PhotoBackingReaders* _tmp17_;
					PhotoFileReader* _tmp18_;
#line 3623 "../src/Photo.vala"
					_tmp17_ = self->priv->readers;
#line 3623 "../src/Photo.vala"
					_tmp18_ = _tmp17_->master;
#line 3623 "../src/Photo.vala"
					if (photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 25535 "Photo.c"
						PhotoBackingReaders* _tmp19_;
						PhotoFileReader* _tmp20_;
						PhotoFileReader* _tmp21_;
#line 3624 "../src/Photo.vala"
						_tmp19_ = self->priv->readers;
#line 3624 "../src/Photo.vala"
						_tmp20_ = _tmp19_->master;
#line 3624 "../src/Photo.vala"
						_tmp21_ = _photo_file_adapter_ref0 (_tmp20_);
#line 3624 "../src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 3624 "../src/Photo.vala"
						export_reader = _tmp21_;
#line 25549 "Photo.c"
					}
				}
			}
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp22_;
#line 3616 "../src/Photo.vala"
			_tmp22_ = self->priv->readers;
#line 3616 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 25561 "Photo.c"
		}
#line 3616 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25565 "Photo.c"
			gboolean _tmp23_ = FALSE;
#line 3616 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3616 "../src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 3616 "../src/Photo.vala"
			return _tmp23_;
#line 25573 "Photo.c"
		}
	}
#line 3628 "../src/Photo.vala"
	_tmp24_ = export_reader;
#line 3628 "../src/Photo.vala"
	if (_tmp24_ == NULL) {
#line 3629 "../src/Photo.vala"
		result = FALSE;
#line 3629 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3629 "../src/Photo.vala"
		return result;
#line 25586 "Photo.c"
	}
#line 3631 "../src/Photo.vala"
	_tmp25_ = export_reader;
#line 3631 "../src/Photo.vala"
	_tmp26_ = photo_file_format_get_properties (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 3631 "../src/Photo.vala"
	format_properties = _tmp26_;
#line 3634 "../src/Photo.vala"
	_tmp27_ = format_properties;
#line 3634 "../src/Photo.vala"
	_tmp28_ = photo_file_format_properties_convert_file_extension (_tmp27_, file);
#line 3634 "../src/Photo.vala"
	dest_file = _tmp28_;
#line 3637 "../src/Photo.vala"
	_tmp29_ = export_reader;
#line 3637 "../src/Photo.vala"
	_tmp30_ = dest_file;
#line 3637 "../src/Photo.vala"
	_tmp31_ = g_file_get_path (_tmp30_);
#line 3637 "../src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3637 "../src/Photo.vala"
	_tmp33_ = photo_file_format_create_metadata_writer (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)), _tmp32_, &_inner_error0_);
#line 3637 "../src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3637 "../src/Photo.vala"
	_g_free0 (_tmp32_);
#line 3637 "../src/Photo.vala"
	writer = _tmp34_;
#line 3637 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25618 "Photo.c"
		gboolean _tmp35_ = FALSE;
#line 3637 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3637 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3637 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3637 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3637 "../src/Photo.vala"
		return _tmp35_;
#line 25630 "Photo.c"
	}
#line 3640 "../src/Photo.vala"
	_tmp36_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3640 "../src/Photo.vala"
	_tmp37_ = _tmp36_;
#line 3640 "../src/Photo.vala"
	_tmp38_ = writer;
#line 3640 "../src/Photo.vala"
	_tmp39_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3640 "../src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 3640 "../src/Photo.vala"
	g_debug ("Photo.vala:3640: Exporting full-sized copy of %s to %s", _tmp37_, _tmp40_);
#line 3640 "../src/Photo.vala"
	_g_free0 (_tmp40_);
#line 3640 "../src/Photo.vala"
	_g_free0 (_tmp37_);
#line 3642 "../src/Photo.vala"
	_tmp41_ = export_reader;
#line 3642 "../src/Photo.vala"
	_tmp42_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3642 "../src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 3642 "../src/Photo.vala"
	_tmp44_ = dest_file;
#line 3642 "../src/Photo.vala"
	g_file_copy (_tmp43_, _tmp44_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3642 "../src/Photo.vala"
	_g_object_unref0 (_tmp43_);
#line 3642 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25662 "Photo.c"
		gboolean _tmp45_ = FALSE;
#line 3642 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3642 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3642 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3642 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3642 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3642 "../src/Photo.vala"
		return _tmp45_;
#line 25676 "Photo.c"
	}
#line 3647 "../src/Photo.vala"
	if (!photo_has_alterations (self)) {
#line 3647 "../src/Photo.vala"
		_tmp50_ = is_master;
#line 25682 "Photo.c"
	} else {
#line 3647 "../src/Photo.vala"
		_tmp50_ = FALSE;
#line 25686 "Photo.c"
	}
#line 3647 "../src/Photo.vala"
	if (_tmp50_) {
#line 3647 "../src/Photo.vala"
		_tmp49_ = !photo_has_user_generated_metadata (self);
#line 25692 "Photo.c"
	} else {
#line 3647 "../src/Photo.vala"
		_tmp49_ = FALSE;
#line 25696 "Photo.c"
	}
#line 3647 "../src/Photo.vala"
	if (_tmp49_) {
#line 25700 "Photo.c"
		gchar* _tmp51_;
		gchar* _tmp52_;
#line 3648 "../src/Photo.vala"
		_tmp51_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3648 "../src/Photo.vala"
		_tmp52_ = _tmp51_;
#line 3648 "../src/Photo.vala"
		_tmp48_ = _tmp52_ == NULL;
#line 3648 "../src/Photo.vala"
		_g_free0 (_tmp52_);
#line 25711 "Photo.c"
	} else {
#line 3647 "../src/Photo.vala"
		_tmp48_ = FALSE;
#line 25715 "Photo.c"
	}
#line 3647 "../src/Photo.vala"
	if (_tmp48_) {
#line 25719 "Photo.c"
		gchar* _tmp53_;
		gchar* _tmp54_;
#line 3648 "../src/Photo.vala"
		_tmp53_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3648 "../src/Photo.vala"
		_tmp54_ = _tmp53_;
#line 3648 "../src/Photo.vala"
		_tmp47_ = _tmp54_ == NULL;
#line 3648 "../src/Photo.vala"
		_g_free0 (_tmp54_);
#line 25730 "Photo.c"
	} else {
#line 3647 "../src/Photo.vala"
		_tmp47_ = FALSE;
#line 25734 "Photo.c"
	}
#line 3647 "../src/Photo.vala"
	if (_tmp47_) {
#line 3648 "../src/Photo.vala"
		_tmp46_ = export_metadata;
#line 25740 "Photo.c"
	} else {
#line 3647 "../src/Photo.vala"
		_tmp46_ = FALSE;
#line 25744 "Photo.c"
	}
#line 3647 "../src/Photo.vala"
	if (_tmp46_) {
#line 3649 "../src/Photo.vala"
		result = TRUE;
#line 3649 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3649 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3649 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3649 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3649 "../src/Photo.vala"
		return result;
#line 25760 "Photo.c"
	}
#line 3652 "../src/Photo.vala"
	_tmp55_ = export_reader;
#line 3652 "../src/Photo.vala"
	_tmp56_ = photo_file_reader_read_metadata (_tmp55_, &_inner_error0_);
#line 3652 "../src/Photo.vala"
	metadata = _tmp56_;
#line 3652 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25770 "Photo.c"
		gboolean _tmp57_ = FALSE;
#line 3652 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3652 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3652 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3652 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3652 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3652 "../src/Photo.vala"
		return _tmp57_;
#line 25784 "Photo.c"
	}
#line 3653 "../src/Photo.vala"
	_tmp58_ = metadata;
#line 3653 "../src/Photo.vala"
	if (_tmp58_ == NULL) {
#line 25790 "Photo.c"
		PhotoFileReader* _tmp59_;
		PhotoMetadata* _tmp60_;
#line 3654 "../src/Photo.vala"
		_tmp59_ = export_reader;
#line 3654 "../src/Photo.vala"
		_tmp60_ = photo_file_format_create_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 3654 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3654 "../src/Photo.vala"
		metadata = _tmp60_;
#line 25801 "Photo.c"
	}
#line 3656 "../src/Photo.vala"
	_tmp61_ = writer;
#line 3656 "../src/Photo.vala"
	_tmp62_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3656 "../src/Photo.vala"
	_tmp63_ = _tmp62_;
#line 3656 "../src/Photo.vala"
	g_debug ("Photo.vala:3656: Updating metadata of %s", _tmp63_);
#line 3656 "../src/Photo.vala"
	_g_free0 (_tmp63_);
#line 3658 "../src/Photo.vala"
	if (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != ((time_t) 0)) {
#line 25815 "Photo.c"
		PhotoMetadata* _tmp64_;
		MetadataDateTime* _tmp65_;
		MetadataDateTime* _tmp66_;
#line 3659 "../src/Photo.vala"
		_tmp64_ = metadata;
#line 3659 "../src/Photo.vala"
		_tmp65_ = metadata_date_time_new (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)));
#line 3659 "../src/Photo.vala"
		_tmp66_ = _tmp65_;
#line 3659 "../src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp64_, _tmp66_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3659 "../src/Photo.vala"
		_metadata_date_time_unref0 (_tmp66_);
#line 25829 "Photo.c"
	} else {
		PhotoMetadata* _tmp67_;
#line 3661 "../src/Photo.vala"
		_tmp67_ = metadata;
#line 3661 "../src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp67_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 25836 "Photo.c"
	}
#line 3663 "../src/Photo.vala"
	if (export_metadata) {
#line 25840 "Photo.c"
		PhotoMetadata* _tmp68_;
		gchar* _tmp69_;
		gchar* _tmp70_;
		PhotoMetadata* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
		PhotoMetadata* _tmp74_;
		Dimensions _tmp75_ = {0};
		PhotoMetadata* _tmp76_;
		PhotoMetadata* _tmp77_;
		PhotoMetadata* _tmp79_;
#line 3665 "../src/Photo.vala"
		_tmp68_ = metadata;
#line 3665 "../src/Photo.vala"
		_tmp69_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3665 "../src/Photo.vala"
		_tmp70_ = _tmp69_;
#line 3665 "../src/Photo.vala"
		photo_metadata_set_title (_tmp68_, _tmp70_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3665 "../src/Photo.vala"
		_g_free0 (_tmp70_);
#line 3666 "../src/Photo.vala"
		_tmp71_ = metadata;
#line 3666 "../src/Photo.vala"
		_tmp72_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3666 "../src/Photo.vala"
		_tmp73_ = _tmp72_;
#line 3666 "../src/Photo.vala"
		photo_metadata_set_comment (_tmp71_, _tmp73_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3666 "../src/Photo.vala"
		_g_free0 (_tmp73_);
#line 3667 "../src/Photo.vala"
		_tmp74_ = metadata;
#line 3667 "../src/Photo.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp75_);
#line 3667 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp74_, &_tmp75_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3668 "../src/Photo.vala"
		_tmp76_ = metadata;
#line 3668 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp76_, photo_get_orientation (self));
#line 3669 "../src/Photo.vala"
		_tmp77_ = metadata;
#line 3669 "../src/Photo.vala"
		photo_metadata_set_software (_tmp77_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3671 "../src/Photo.vala"
		if (photo_get_orientation (self) != photo_get_original_orientation (self)) {
#line 25888 "Photo.c"
			PhotoMetadata* _tmp78_;
#line 3672 "../src/Photo.vala"
			_tmp78_ = metadata;
#line 3672 "../src/Photo.vala"
			photo_metadata_remove_exif_thumbnail (_tmp78_);
#line 25894 "Photo.c"
		}
#line 3674 "../src/Photo.vala"
		_tmp79_ = metadata;
#line 3674 "../src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp79_);
#line 25900 "Photo.c"
	} else {
		PhotoMetadata* _tmp80_;
#line 3678 "../src/Photo.vala"
		_tmp80_ = metadata;
#line 3678 "../src/Photo.vala"
		photo_metadata_clear (_tmp80_);
#line 25907 "Photo.c"
	}
#line 3680 "../src/Photo.vala"
	_tmp81_ = writer;
#line 3680 "../src/Photo.vala"
	_tmp82_ = metadata;
#line 3680 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp81_, _tmp82_, &_inner_error0_);
#line 3680 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25917 "Photo.c"
		gboolean _tmp83_ = FALSE;
#line 3680 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3680 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3680 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3680 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3680 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3680 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3680 "../src/Photo.vala"
		return _tmp83_;
#line 25933 "Photo.c"
	}
#line 3682 "../src/Photo.vala"
	result = TRUE;
#line 3682 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 3682 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3682 "../src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 3682 "../src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 3682 "../src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 3682 "../src/Photo.vala"
	return result;
#line 25949 "Photo.c"
}

gboolean
photo_is_export_required (Photo* self,
                          Scaling* scaling,
                          PhotoFileFormat export_format)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result = FALSE;
#line 3688 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3688 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3689 "../src/Photo.vala"
	if (!scaling_is_unscaled (scaling)) {
#line 3689 "../src/Photo.vala"
		_tmp2_ = TRUE;
#line 25969 "Photo.c"
	} else {
#line 3689 "../src/Photo.vala"
		_tmp2_ = photo_has_alterations (self);
#line 25973 "Photo.c"
	}
#line 3689 "../src/Photo.vala"
	if (_tmp2_) {
#line 3689 "../src/Photo.vala"
		_tmp1_ = TRUE;
#line 25979 "Photo.c"
	} else {
#line 3689 "../src/Photo.vala"
		_tmp1_ = photo_has_user_generated_metadata (self);
#line 25983 "Photo.c"
	}
#line 3689 "../src/Photo.vala"
	if (_tmp1_) {
#line 3689 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 25989 "Photo.c"
	} else {
#line 3690 "../src/Photo.vala"
		_tmp0_ = export_format != photo_get_file_format (self);
#line 25993 "Photo.c"
	}
#line 3689 "../src/Photo.vala"
	result = _tmp0_;
#line 3689 "../src/Photo.vala"
	return result;
#line 25999 "Photo.c"
}

void
photo_export (Photo* self,
              GFile* dest_file,
              Scaling* scaling,
              JpegQuality quality,
              PhotoFileFormat export_format,
              gboolean direct_copy_unmodified,
              gboolean export_metadata,
              GError** error)
{
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp7_;
	PhotoMetadata* _tmp8_;
	PhotoFileWriter* writer = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoFileWriter* _tmp12_;
	PhotoFileWriter* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	PhotoFileWriter* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GEnumValue* _tmp19_;
	GdkPixbuf* pixbuf = NULL;
	gboolean _tmp20_ = FALSE;
	PhotoFileWriter* _tmp29_;
	GdkPixbuf* _tmp30_;
	PhotoFileWriter* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gboolean _tmp50_ = FALSE;
	PhotoFileMetadataWriter* _tmp58_ = NULL;
	gchar* _tmp59_;
	gchar* _tmp60_;
	PhotoFileMetadataWriter* _tmp61_;
	PhotoFileMetadataWriter* _tmp62_;
	PhotoMetadata* _tmp63_;
	GError* _inner_error0_ = NULL;
#line 3696 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3696 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dest_file, g_file_get_type ()));
#line 3696 "../src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 3698 "../src/Photo.vala"
	if (direct_copy_unmodified) {
#line 26052 "Photo.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 3699 "../src/Photo.vala"
		_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3699 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3699 "../src/Photo.vala"
		g_file_copy (_tmp1_, dest_file, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3699 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3699 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3699 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3699 "../src/Photo.vala"
			return;
#line 26069 "Photo.c"
		}
#line 3701 "../src/Photo.vala"
		return;
#line 26073 "Photo.c"
	}
#line 3708 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 26077 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 3708 "../src/Photo.vala"
		if (!photo_has_alterations (self)) {
#line 3708 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 26083 "Photo.c"
		} else {
#line 3708 "../src/Photo.vala"
			_tmp5_ = photo_only_metadata_changed (self);
#line 26087 "Photo.c"
		}
#line 3708 "../src/Photo.vala"
		_tmp4_ = _tmp5_;
#line 26091 "Photo.c"
	} else {
#line 3708 "../src/Photo.vala"
		_tmp4_ = FALSE;
#line 26095 "Photo.c"
	}
#line 3708 "../src/Photo.vala"
	if (_tmp4_) {
#line 3709 "../src/Photo.vala"
		_tmp3_ = export_format == photo_get_file_format (self);
#line 26101 "Photo.c"
	} else {
#line 3708 "../src/Photo.vala"
		_tmp3_ = FALSE;
#line 26105 "Photo.c"
	}
#line 3708 "../src/Photo.vala"
	if (_tmp3_) {
#line 3709 "../src/Photo.vala"
		_tmp2_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF;
#line 26111 "Photo.c"
	} else {
#line 3708 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 26115 "Photo.c"
	}
#line 3708 "../src/Photo.vala"
	if (_tmp2_) {
#line 26119 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 3710 "../src/Photo.vala"
		_tmp6_ = photo_export_fullsized_backing (self, dest_file, export_metadata, &_inner_error0_);
#line 3710 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3710 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3710 "../src/Photo.vala"
			return;
#line 26129 "Photo.c"
		}
#line 3710 "../src/Photo.vala"
		if (_tmp6_) {
#line 3711 "../src/Photo.vala"
			return;
#line 26135 "Photo.c"
		}
	}
#line 3717 "../src/Photo.vala"
	_tmp7_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 3717 "../src/Photo.vala"
	metadata = _tmp7_;
#line 3718 "../src/Photo.vala"
	_tmp8_ = metadata;
#line 3718 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 26146 "Photo.c"
		PhotoMetadata* _tmp9_;
#line 3719 "../src/Photo.vala"
		_tmp9_ = photo_file_format_create_metadata (export_format);
#line 3719 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3719 "../src/Photo.vala"
		metadata = _tmp9_;
#line 26154 "Photo.c"
	}
#line 3721 "../src/Photo.vala"
	if (!photo_file_format_can_write (export_format)) {
#line 3722 "../src/Photo.vala"
		export_format = photo_file_format_get_system_default_format ();
#line 26160 "Photo.c"
	}
#line 3724 "../src/Photo.vala"
	_tmp10_ = g_file_get_path (dest_file);
#line 3724 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 3724 "../src/Photo.vala"
	_tmp12_ = photo_file_format_create_writer (export_format, _tmp11_, &_inner_error0_);
#line 3724 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 3724 "../src/Photo.vala"
	_g_free0 (_tmp11_);
#line 3724 "../src/Photo.vala"
	writer = _tmp13_;
#line 3724 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3724 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3724 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3724 "../src/Photo.vala"
		return;
#line 26182 "Photo.c"
	}
#line 3726 "../src/Photo.vala"
	_tmp14_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3726 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 3726 "../src/Photo.vala"
	_tmp16_ = writer;
#line 3726 "../src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3726 "../src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 3727 "../src/Photo.vala"
	_tmp19_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), export_format);
#line 3726 "../src/Photo.vala"
	g_debug ("Photo.vala:3726: Saving transformed version of %s to %s in file format" \
" %s", _tmp15_, _tmp18_, (_tmp19_ != NULL) ? _tmp19_->value_name : NULL);
#line 3726 "../src/Photo.vala"
	_g_free0 (_tmp18_);
#line 3726 "../src/Photo.vala"
	_g_free0 (_tmp15_);
#line 3733 "../src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3733 "../src/Photo.vala"
		_tmp20_ = TRUE;
#line 26206 "Photo.c"
	} else {
#line 3734 "../src/Photo.vala"
		_tmp20_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 26210 "Photo.c"
	}
#line 3733 "../src/Photo.vala"
	if (_tmp20_) {
#line 26214 "Photo.c"
		GdkPixbuf* _tmp21_ = NULL;
		Scaling _tmp22_;
		GdkPixbuf* _tmp23_;
		GdkPixbuf* _tmp24_;
#line 3735 "../src/Photo.vala"
		_tmp22_ = *scaling;
#line 3735 "../src/Photo.vala"
		_tmp23_ = photo_get_pixbuf_with_options (self, &_tmp22_, PHOTO_EXCEPTION_ORIENTATION, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3735 "../src/Photo.vala"
		_tmp21_ = _tmp23_;
#line 3735 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3735 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3735 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3735 "../src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3735 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3735 "../src/Photo.vala"
			return;
#line 26237 "Photo.c"
		}
#line 3735 "../src/Photo.vala"
		_tmp24_ = _tmp21_;
#line 3735 "../src/Photo.vala"
		_tmp21_ = NULL;
#line 3735 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3735 "../src/Photo.vala"
		pixbuf = _tmp24_;
#line 3733 "../src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 26249 "Photo.c"
	} else {
		GdkPixbuf* _tmp25_ = NULL;
		Scaling _tmp26_;
		GdkPixbuf* _tmp27_;
		GdkPixbuf* _tmp28_;
#line 3739 "../src/Photo.vala"
		_tmp26_ = *scaling;
#line 3739 "../src/Photo.vala"
		_tmp27_ = photo_get_pixbuf_with_options (self, &_tmp26_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3739 "../src/Photo.vala"
		_tmp25_ = _tmp27_;
#line 3739 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3739 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3739 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3739 "../src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3739 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3739 "../src/Photo.vala"
			return;
#line 26273 "Photo.c"
		}
#line 3739 "../src/Photo.vala"
		_tmp28_ = _tmp25_;
#line 3739 "../src/Photo.vala"
		_tmp25_ = NULL;
#line 3739 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3739 "../src/Photo.vala"
		pixbuf = _tmp28_;
#line 3733 "../src/Photo.vala"
		_g_object_unref0 (_tmp25_);
#line 26285 "Photo.c"
	}
#line 3743 "../src/Photo.vala"
	_tmp29_ = writer;
#line 3743 "../src/Photo.vala"
	_tmp30_ = pixbuf;
#line 3743 "../src/Photo.vala"
	photo_file_writer_write (_tmp29_, _tmp30_, quality, &_inner_error0_);
#line 3743 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3743 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3743 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3743 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3743 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3743 "../src/Photo.vala"
		return;
#line 26305 "Photo.c"
	}
#line 3745 "../src/Photo.vala"
	_tmp31_ = writer;
#line 3745 "../src/Photo.vala"
	_tmp32_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3745 "../src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 3745 "../src/Photo.vala"
	g_debug ("Photo.vala:3745: Setting EXIF for %s", _tmp33_);
#line 3745 "../src/Photo.vala"
	_g_free0 (_tmp33_);
#line 3748 "../src/Photo.vala"
	if (export_metadata) {
#line 26319 "Photo.c"
		PhotoMetadata* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		PhotoMetadata* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		PhotoMetadata* _tmp40_;
		PhotoMetadata* _tmp45_;
		PhotoMetadata* _tmp46_;
		PhotoMetadata* _tmp47_;
#line 3750 "../src/Photo.vala"
		_tmp34_ = metadata;
#line 3750 "../src/Photo.vala"
		_tmp35_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3750 "../src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 3750 "../src/Photo.vala"
		photo_metadata_set_title (_tmp34_, _tmp36_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3750 "../src/Photo.vala"
		_g_free0 (_tmp36_);
#line 3751 "../src/Photo.vala"
		_tmp37_ = metadata;
#line 3751 "../src/Photo.vala"
		_tmp38_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3751 "../src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 3751 "../src/Photo.vala"
		photo_metadata_set_comment (_tmp37_, _tmp39_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3751 "../src/Photo.vala"
		_g_free0 (_tmp39_);
#line 3752 "../src/Photo.vala"
		_tmp40_ = metadata;
#line 3752 "../src/Photo.vala"
		photo_metadata_set_software (_tmp40_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3754 "../src/Photo.vala"
		if (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != ((time_t) 0)) {
#line 26356 "Photo.c"
			PhotoMetadata* _tmp41_;
			MetadataDateTime* _tmp42_;
			MetadataDateTime* _tmp43_;
#line 3755 "../src/Photo.vala"
			_tmp41_ = metadata;
#line 3755 "../src/Photo.vala"
			_tmp42_ = metadata_date_time_new (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)));
#line 3755 "../src/Photo.vala"
			_tmp43_ = _tmp42_;
#line 3755 "../src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp41_, _tmp43_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3755 "../src/Photo.vala"
			_metadata_date_time_unref0 (_tmp43_);
#line 26370 "Photo.c"
		} else {
			PhotoMetadata* _tmp44_;
#line 3757 "../src/Photo.vala"
			_tmp44_ = metadata;
#line 3757 "../src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp44_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 26377 "Photo.c"
		}
#line 3759 "../src/Photo.vala"
		_tmp45_ = metadata;
#line 3759 "../src/Photo.vala"
		photo_metadata_remove_tag (_tmp45_, "Exif.Iop.RelatedImageWidth");
#line 3760 "../src/Photo.vala"
		_tmp46_ = metadata;
#line 3760 "../src/Photo.vala"
		photo_metadata_remove_tag (_tmp46_, "Exif.Iop.RelatedImageHeight");
#line 3761 "../src/Photo.vala"
		_tmp47_ = metadata;
#line 3761 "../src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp47_);
#line 3763 "../src/Photo.vala"
		if (photo_has_user_generated_metadata (self)) {
#line 26393 "Photo.c"
			PhotoMetadata* _tmp48_;
#line 3764 "../src/Photo.vala"
			_tmp48_ = metadata;
#line 3764 "../src/Photo.vala"
			photo_set_user_metadata_for_export (self, _tmp48_);
#line 26399 "Photo.c"
		}
	} else {
		PhotoMetadata* _tmp49_;
#line 3768 "../src/Photo.vala"
		_tmp49_ = metadata;
#line 3768 "../src/Photo.vala"
		photo_metadata_clear (_tmp49_);
#line 26407 "Photo.c"
	}
#line 3775 "../src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3775 "../src/Photo.vala"
		_tmp50_ = TRUE;
#line 26413 "Photo.c"
	} else {
#line 3776 "../src/Photo.vala"
		_tmp50_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 26417 "Photo.c"
	}
#line 3775 "../src/Photo.vala"
	if (_tmp50_) {
#line 26421 "Photo.c"
		PhotoMetadata* _tmp51_;
		Dimensions _tmp52_ = {0};
		PhotoMetadata* _tmp53_;
#line 3777 "../src/Photo.vala"
		_tmp51_ = metadata;
#line 3777 "../src/Photo.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_ORIENTATION, &_tmp52_);
#line 3777 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp51_, &_tmp52_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3778 "../src/Photo.vala"
		_tmp53_ = metadata;
#line 3778 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp53_, photo_get_orientation (self));
#line 26435 "Photo.c"
	} else {
		PhotoMetadata* _tmp54_;
		GdkPixbuf* _tmp55_;
		Dimensions _tmp56_ = {0};
		PhotoMetadata* _tmp57_;
#line 3781 "../src/Photo.vala"
		_tmp54_ = metadata;
#line 3781 "../src/Photo.vala"
		_tmp55_ = pixbuf;
#line 3781 "../src/Photo.vala"
		dimensions_for_pixbuf (_tmp55_, &_tmp56_);
#line 3781 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp54_, &_tmp56_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3782 "../src/Photo.vala"
		_tmp57_ = metadata;
#line 3782 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp57_, ORIENTATION_TOP_LEFT);
#line 26453 "Photo.c"
	}
#line 3785 "../src/Photo.vala"
	_tmp59_ = g_file_get_path (dest_file);
#line 3785 "../src/Photo.vala"
	_tmp60_ = _tmp59_;
#line 3785 "../src/Photo.vala"
	_tmp61_ = photo_file_format_create_metadata_writer (export_format, _tmp60_, &_inner_error0_);
#line 3785 "../src/Photo.vala"
	_tmp62_ = _tmp61_;
#line 3785 "../src/Photo.vala"
	_g_free0 (_tmp60_);
#line 3785 "../src/Photo.vala"
	_tmp58_ = _tmp62_;
#line 3785 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3785 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3785 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3785 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3785 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3785 "../src/Photo.vala"
		return;
#line 26479 "Photo.c"
	}
#line 3785 "../src/Photo.vala"
	_tmp63_ = metadata;
#line 3785 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp58_, _tmp63_, &_inner_error0_);
#line 3785 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3785 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3785 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp58_);
#line 3785 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3785 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3785 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3785 "../src/Photo.vala"
		return;
#line 26499 "Photo.c"
	}
#line 3696 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp58_);
#line 3696 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3696 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3696 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 26509 "Photo.c"
}

static GFile*
photo_generate_new_editable_file (Photo* self,
                                  PhotoFileFormat* file_format,
                                  GError** error)
{
	PhotoFileFormat _vala_file_format = 0;
	GFile* backing = NULL;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	gchar* editable_basename = NULL;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gboolean collision = FALSE;
	GFile* _tmp18_ = NULL;
	GFile* _tmp19_;
	GFile* _tmp20_;
	gboolean _tmp21_ = FALSE;
	GFile* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	GError* _inner_error0_ = NULL;
	GFile* result = NULL;
#line 3788 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 26543 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3790 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3790 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 26550 "Photo.c"
		{
			GFile* _tmp1_;
#line 3791 "../src/Photo.vala"
			_vala_file_format = photo_get_file_format (self);
#line 3792 "../src/Photo.vala"
			_tmp1_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3792 "../src/Photo.vala"
			_g_object_unref0 (backing);
#line 3792 "../src/Photo.vala"
			backing = _tmp1_;
#line 26561 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp2_;
#line 3790 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 3790 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 26570 "Photo.c"
		}
#line 3790 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3790 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3790 "../src/Photo.vala"
			_g_object_unref0 (backing);
#line 3790 "../src/Photo.vala"
			return NULL;
#line 26580 "Photo.c"
		}
	}
#line 3795 "../src/Photo.vala"
	if (!photo_file_format_can_write (_vala_file_format)) {
#line 3796 "../src/Photo.vala"
		_vala_file_format = photo_file_format_get_system_default_format ();
#line 26587 "Photo.c"
	}
#line 3799 "../src/Photo.vala"
	_tmp3_ = g_file_get_basename (backing);
#line 3799 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3799 "../src/Photo.vala"
	disassemble_filename (_tmp4_, &_tmp5_, &_tmp6_);
#line 3799 "../src/Photo.vala"
	_g_free0 (name);
#line 3799 "../src/Photo.vala"
	name = _tmp5_;
#line 3799 "../src/Photo.vala"
	_g_free0 (ext);
#line 3799 "../src/Photo.vala"
	ext = _tmp6_;
#line 3799 "../src/Photo.vala"
	_g_free0 (_tmp4_);
#line 3801 "../src/Photo.vala"
	_tmp8_ = ext;
#line 3801 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 3801 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 26611 "Photo.c"
	} else {
		PhotoFileFormatProperties* _tmp9_;
		PhotoFileFormatProperties* _tmp10_;
		const gchar* _tmp11_;
#line 3801 "../src/Photo.vala"
		_tmp9_ = photo_file_format_get_properties (_vala_file_format);
#line 3801 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 3801 "../src/Photo.vala"
		_tmp11_ = ext;
#line 3801 "../src/Photo.vala"
		_tmp7_ = !photo_file_format_properties_is_recognized_extension (_tmp10_, _tmp11_);
#line 3801 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp10_);
#line 26626 "Photo.c"
	}
#line 3801 "../src/Photo.vala"
	if (_tmp7_) {
#line 26630 "Photo.c"
		PhotoFileFormatProperties* _tmp12_;
		PhotoFileFormatProperties* _tmp13_;
		gchar* _tmp14_;
#line 3802 "../src/Photo.vala"
		_tmp12_ = photo_file_format_get_properties (_vala_file_format);
#line 3802 "../src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 3802 "../src/Photo.vala"
		_tmp14_ = photo_file_format_properties_get_default_extension (_tmp13_);
#line 3802 "../src/Photo.vala"
		_g_free0 (ext);
#line 3802 "../src/Photo.vala"
		ext = _tmp14_;
#line 3802 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp13_);
#line 26646 "Photo.c"
	}
#line 3804 "../src/Photo.vala"
	_tmp15_ = name;
#line 3804 "../src/Photo.vala"
	_tmp16_ = ext;
#line 3804 "../src/Photo.vala"
	_tmp17_ = g_strdup_printf ("%s_%s.%s", _tmp15_, _ ("modified"), _tmp16_);
#line 3804 "../src/Photo.vala"
	editable_basename = _tmp17_;
#line 3807 "../src/Photo.vala"
	_tmp19_ = g_file_get_parent (backing);
#line 3807 "../src/Photo.vala"
	_tmp20_ = _tmp19_;
#line 3807 "../src/Photo.vala"
	_tmp22_ = generate_unique_file (_tmp20_, editable_basename, &_tmp21_, &_inner_error0_);
#line 3807 "../src/Photo.vala"
	collision = _tmp21_;
#line 3807 "../src/Photo.vala"
	_tmp23_ = _tmp22_;
#line 3807 "../src/Photo.vala"
	_g_object_unref0 (_tmp20_);
#line 3807 "../src/Photo.vala"
	_tmp18_ = _tmp23_;
#line 3807 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3807 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3807 "../src/Photo.vala"
		_g_free0 (editable_basename);
#line 3807 "../src/Photo.vala"
		_g_free0 (ext);
#line 3807 "../src/Photo.vala"
		_g_free0 (name);
#line 3807 "../src/Photo.vala"
		_g_object_unref0 (backing);
#line 3807 "../src/Photo.vala"
		return NULL;
#line 26684 "Photo.c"
	}
#line 3807 "../src/Photo.vala"
	_tmp24_ = _tmp18_;
#line 3807 "../src/Photo.vala"
	_tmp18_ = NULL;
#line 3807 "../src/Photo.vala"
	result = _tmp24_;
#line 3807 "../src/Photo.vala"
	_g_object_unref0 (_tmp18_);
#line 3807 "../src/Photo.vala"
	_g_free0 (editable_basename);
#line 3807 "../src/Photo.vala"
	_g_free0 (ext);
#line 3807 "../src/Photo.vala"
	_g_free0 (name);
#line 3807 "../src/Photo.vala"
	_g_object_unref0 (backing);
#line 3807 "../src/Photo.vala"
	if (file_format) {
#line 3807 "../src/Photo.vala"
		*file_format = _vala_file_format;
#line 26706 "Photo.c"
	}
#line 3807 "../src/Photo.vala"
	return result;
#line 26710 "Photo.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 3829 "../src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 26718 "Photo.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 3829 "../src/Photo.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 26726 "Photo.c"
}

static gboolean
photo_launch_editor (GFile* file,
                     PhotoFileFormat file_format,
                     GError** error)
{
	gchar* _tmp0_ = NULL;
	gchar* commandline = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	GAppInfo* app = NULL;
	GList* files = NULL;
	GFile* _tmp14_;
	GAppInfo* _tmp15_;
	gchar** argv = NULL;
	gchar** _tmp20_;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
	GPid child_pid = 0;
	gboolean _tmp26_ = FALSE;
	gchar** _tmp27_;
	gint _tmp27__length1;
	GPid _tmp28_ = 0;
	gboolean _tmp29_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 3810 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 3811 "../src/Photo.vala"
	if (file_format == PHOTO_FILE_FORMAT_RAW) {
#line 26765 "Photo.c"
		ConfigFacade* _tmp1_;
		ConfigFacade* _tmp2_;
		gchar* _tmp3_;
#line 3811 "../src/Photo.vala"
		_tmp1_ = config_facade_get_instance ();
#line 3811 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 3811 "../src/Photo.vala"
		_tmp3_ = configuration_facade_get_external_raw_app (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 3811 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3811 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 3811 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 26781 "Photo.c"
	} else {
		ConfigFacade* _tmp4_;
		ConfigFacade* _tmp5_;
		gchar* _tmp6_;
#line 3812 "../src/Photo.vala"
		_tmp4_ = config_facade_get_instance ();
#line 3812 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3812 "../src/Photo.vala"
		_tmp6_ = configuration_facade_get_external_photo_app (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 3812 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3812 "../src/Photo.vala"
		_tmp0_ = _tmp6_;
#line 3812 "../src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 26798 "Photo.c"
	}
#line 3811 "../src/Photo.vala"
	_tmp7_ = g_strdup (_tmp0_);
#line 3811 "../src/Photo.vala"
	commandline = _tmp7_;
#line 3814 "../src/Photo.vala"
	_tmp8_ = commandline;
#line 3814 "../src/Photo.vala"
	if (is_string_empty (_tmp8_)) {
#line 3815 "../src/Photo.vala"
		result = FALSE;
#line 3815 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3815 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3815 "../src/Photo.vala"
		return result;
#line 26816 "Photo.c"
	}
	{
		GAppInfo* _tmp9_ = NULL;
		const gchar* _tmp10_;
		GAppInfo* _tmp11_;
		GAppInfo* _tmp12_;
#line 3819 "../src/Photo.vala"
		_tmp10_ = commandline;
#line 3819 "../src/Photo.vala"
		_tmp11_ = g_app_info_create_from_commandline (_tmp10_, "", G_APP_INFO_CREATE_NONE, &_inner_error0_);
#line 3819 "../src/Photo.vala"
		_tmp9_ = _tmp11_;
#line 3819 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26831 "Photo.c"
			goto __catch0_g_error;
		}
#line 3819 "../src/Photo.vala"
		_tmp12_ = _tmp9_;
#line 3819 "../src/Photo.vala"
		_tmp9_ = NULL;
#line 3819 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3819 "../src/Photo.vala"
		app = _tmp12_;
#line 3818 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 26844 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 3818 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3822 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3822 "../src/Photo.vala"
		app = NULL;
#line 26855 "Photo.c"
	}
	__finally0:
#line 3818 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26860 "Photo.c"
		gboolean _tmp13_ = FALSE;
#line 3818 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3818 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3818 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3818 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3818 "../src/Photo.vala"
		return _tmp13_;
#line 26872 "Photo.c"
	}
#line 3825 "../src/Photo.vala"
	files = NULL;
#line 3826 "../src/Photo.vala"
	_tmp14_ = _g_object_ref0 (file);
#line 3826 "../src/Photo.vala"
	files = g_list_insert (files, _tmp14_, -1);
#line 3828 "../src/Photo.vala"
	_tmp15_ = app;
#line 3828 "../src/Photo.vala"
	if (_tmp15_ != NULL) {
#line 26884 "Photo.c"
		gboolean _tmp16_ = FALSE;
		GAppInfo* _tmp17_;
		GList* _tmp18_;
#line 3829 "../src/Photo.vala"
		_tmp17_ = app;
#line 3829 "../src/Photo.vala"
		_tmp18_ = files;
#line 3829 "../src/Photo.vala"
		_tmp16_ = g_app_info_launch (_tmp17_, _tmp18_, NULL, &_inner_error0_);
#line 3829 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26896 "Photo.c"
			gboolean _tmp19_ = FALSE;
#line 3829 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3829 "../src/Photo.vala"
			(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3829 "../src/Photo.vala"
			_g_object_unref0 (app);
#line 3829 "../src/Photo.vala"
			_g_free0 (commandline);
#line 3829 "../src/Photo.vala"
			_g_free0 (_tmp0_);
#line 3829 "../src/Photo.vala"
			return _tmp19_;
#line 26910 "Photo.c"
		}
#line 3829 "../src/Photo.vala"
		result = _tmp16_;
#line 3829 "../src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3829 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3829 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3829 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3829 "../src/Photo.vala"
		return result;
#line 26924 "Photo.c"
	}
#line 3831 "../src/Photo.vala"
	_tmp20_ = g_new0 (gchar*, 2 + 1);
#line 3831 "../src/Photo.vala"
	argv = _tmp20_;
#line 3831 "../src/Photo.vala"
	argv_length1 = 2;
#line 3831 "../src/Photo.vala"
	_argv_size_ = argv_length1;
#line 3832 "../src/Photo.vala"
	_tmp21_ = argv;
#line 3832 "../src/Photo.vala"
	_tmp21__length1 = argv_length1;
#line 3832 "../src/Photo.vala"
	_tmp22_ = commandline;
#line 3832 "../src/Photo.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 3832 "../src/Photo.vala"
	_g_free0 (_tmp21_[0]);
#line 3832 "../src/Photo.vala"
	_tmp21_[0] = _tmp23_;
#line 3833 "../src/Photo.vala"
	_tmp24_ = argv;
#line 3833 "../src/Photo.vala"
	_tmp24__length1 = argv_length1;
#line 3833 "../src/Photo.vala"
	_tmp25_ = g_file_get_path (file);
#line 3833 "../src/Photo.vala"
	_g_free0 (_tmp24_[1]);
#line 3833 "../src/Photo.vala"
	_tmp24_[1] = _tmp25_;
#line 3837 "../src/Photo.vala"
	_tmp27_ = argv;
#line 3837 "../src/Photo.vala"
	_tmp27__length1 = argv_length1;
#line 3837 "../src/Photo.vala"
	_tmp29_ = g_spawn_async ("/", _tmp27_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp28_, &_inner_error0_);
#line 3837 "../src/Photo.vala"
	child_pid = _tmp28_;
#line 3837 "../src/Photo.vala"
	_tmp26_ = _tmp29_;
#line 3837 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26968 "Photo.c"
		gboolean _tmp30_ = FALSE;
#line 3837 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3837 "../src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3837 "../src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3837 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3837 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3837 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3837 "../src/Photo.vala"
		return _tmp30_;
#line 26984 "Photo.c"
	}
#line 3837 "../src/Photo.vala"
	result = _tmp26_;
#line 3837 "../src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3837 "../src/Photo.vala"
	(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3837 "../src/Photo.vala"
	_g_object_unref0 (app);
#line 3837 "../src/Photo.vala"
	_g_free0 (commandline);
#line 3837 "../src/Photo.vala"
	_g_free0 (_tmp0_);
#line 3837 "../src/Photo.vala"
	return result;
#line 27000 "Photo.c"
}

void
photo_open_with_raw_external_editor (Photo* self,
                                     GError** error)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 3847 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3848 "../src/Photo.vala"
	_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3848 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3848 "../src/Photo.vala"
	photo_launch_editor (_tmp1_, photo_get_master_file_format (self), &_inner_error0_);
#line 3848 "../src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3848 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3848 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3848 "../src/Photo.vala"
		return;
#line 27026 "Photo.c"
	}
}

void
photo_open_with_external_editor (Photo* self,
                                 GError** error)
{
	GFile* current_editable_file = NULL;
	GFile* create_editable_file = NULL;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GFile* _tmp16_;
	gboolean _tmp22_ = FALSE;
	GFile* _tmp23_;
	GFile* _tmp37_;
	GFileMonitor* _tmp38_;
	GFile* _tmp40_;
	GError* _inner_error0_ = NULL;
#line 3852 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3853 "../src/Photo.vala"
	current_editable_file = NULL;
#line 3854 "../src/Photo.vala"
	create_editable_file = NULL;
#line 27052 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3856 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3856 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 27059 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			GFile* _tmp6_;
#line 3857 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3857 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3857 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 27070 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 3858 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3858 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3858 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3858 "../src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3858 "../src/Photo.vala"
				current_editable_file = _tmp5_;
#line 27084 "Photo.c"
			}
#line 3860 "../src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 3860 "../src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 27090 "Photo.c"
				GFile* _tmp7_ = NULL;
				PhotoFileFormat _tmp8_ = 0;
				GFile* _tmp9_;
				GFile* _tmp10_;
#line 3861 "../src/Photo.vala"
				_tmp9_ = photo_generate_new_editable_file (self, &_tmp8_, &_inner_error0_);
#line 3861 "../src/Photo.vala"
				editable_file_format = _tmp8_;
#line 3861 "../src/Photo.vala"
				_tmp7_ = _tmp9_;
#line 3861 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27103 "Photo.c"
					goto __finally0;
				}
#line 3861 "../src/Photo.vala"
				_tmp10_ = _tmp7_;
#line 3861 "../src/Photo.vala"
				_tmp7_ = NULL;
#line 3861 "../src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3861 "../src/Photo.vala"
				create_editable_file = _tmp10_;
#line 3860 "../src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 27116 "Photo.c"
			} else {
				PhotoBackingReaders* _tmp11_;
				PhotoFileReader* _tmp12_;
#line 3863 "../src/Photo.vala"
				_tmp11_ = self->priv->readers;
#line 3863 "../src/Photo.vala"
				_tmp12_ = _tmp11_->editable;
#line 3863 "../src/Photo.vala"
				editable_file_format = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 27126 "Photo.c"
			}
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			PhotoBackingReaders* _tmp13_;
#line 3856 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 3856 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 27137 "Photo.c"
		}
#line 3856 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3856 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3856 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3856 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3856 "../src/Photo.vala"
			return;
#line 27149 "Photo.c"
		}
	}
#line 3868 "../src/Photo.vala"
	_tmp16_ = create_editable_file;
#line 3868 "../src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 27156 "Photo.c"
		GFile* _tmp17_;
#line 3868 "../src/Photo.vala"
		_tmp17_ = current_editable_file;
#line 3868 "../src/Photo.vala"
		_tmp15_ = _tmp17_ != NULL;
#line 27162 "Photo.c"
	} else {
#line 3868 "../src/Photo.vala"
		_tmp15_ = FALSE;
#line 27166 "Photo.c"
	}
#line 3868 "../src/Photo.vala"
	if (_tmp15_) {
#line 27170 "Photo.c"
		gboolean _tmp18_ = FALSE;
		GFile* _tmp19_;
#line 3869 "../src/Photo.vala"
		_tmp19_ = current_editable_file;
#line 3869 "../src/Photo.vala"
		if (!g_file_query_exists (_tmp19_, NULL)) {
#line 3869 "../src/Photo.vala"
			_tmp18_ = TRUE;
#line 27179 "Photo.c"
		} else {
#line 3869 "../src/Photo.vala"
			_tmp18_ = photo_has_transformations (self);
#line 27183 "Photo.c"
		}
#line 3869 "../src/Photo.vala"
		_tmp14_ = _tmp18_;
#line 27187 "Photo.c"
	} else {
#line 3868 "../src/Photo.vala"
		_tmp14_ = FALSE;
#line 27191 "Photo.c"
	}
#line 3868 "../src/Photo.vala"
	if (_tmp14_) {
#line 27195 "Photo.c"
		GFile* _tmp20_;
		GFile* _tmp21_;
#line 3870 "../src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 3870 "../src/Photo.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 3870 "../src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3870 "../src/Photo.vala"
		create_editable_file = _tmp21_;
#line 27206 "Photo.c"
	}
#line 3873 "../src/Photo.vala"
	_tmp23_ = create_editable_file;
#line 3873 "../src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 3873 "../src/Photo.vala"
		_tmp22_ = photo_file_format_can_write (editable_file_format);
#line 27214 "Photo.c"
	} else {
#line 3873 "../src/Photo.vala"
		_tmp22_ = FALSE;
#line 27218 "Photo.c"
	}
#line 3873 "../src/Photo.vala"
	if (_tmp22_) {
#line 27222 "Photo.c"
		GFile* _tmp34_;
		GFile* _tmp35_;
		GFile* _tmp36_;
#line 3874 "../src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 27228 "Photo.c"
		{
			GFile* _tmp24_;
			Scaling _tmp25_ = {0};
#line 3877 "../src/Photo.vala"
			_tmp24_ = create_editable_file;
#line 3877 "../src/Photo.vala"
			scaling_for_original (&_tmp25_);
#line 3877 "../src/Photo.vala"
			photo_export (self, _tmp24_, &_tmp25_, JPEG_QUALITY_MAXIMUM, editable_file_format, FALSE, TRUE, &_inner_error0_);
#line 3877 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27240 "Photo.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			GError* _tmp32_;
			GError* _tmp33_;
#line 3876 "../src/Photo.vala"
			err = _inner_error0_;
#line 3876 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 27254 "Photo.c"
			{
				GFile* _tmp26_;
#line 3882 "../src/Photo.vala"
				_tmp26_ = create_editable_file;
#line 3882 "../src/Photo.vala"
				g_file_delete (_tmp26_, NULL, &_inner_error0_);
#line 3882 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27263 "Photo.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				GError* _tmp30_;
				const gchar* _tmp31_;
#line 3881 "../src/Photo.vala"
				delete_err = _inner_error0_;
#line 3881 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 3885 "../src/Photo.vala"
				_tmp27_ = create_editable_file;
#line 3885 "../src/Photo.vala"
				_tmp28_ = g_file_get_path (_tmp27_);
#line 3885 "../src/Photo.vala"
				_tmp29_ = _tmp28_;
#line 3885 "../src/Photo.vala"
				_tmp30_ = delete_err;
#line 3885 "../src/Photo.vala"
				_tmp31_ = _tmp30_->message;
#line 3885 "../src/Photo.vala"
				g_warning ("Photo.vala:3885: Unable to delete editable file %s after export error:" \
" %s", _tmp29_, _tmp31_);
#line 3885 "../src/Photo.vala"
				_g_free0 (_tmp29_);
#line 3881 "../src/Photo.vala"
				_g_error_free0 (delete_err);
#line 27296 "Photo.c"
			}
			__finally2:
#line 3881 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3881 "../src/Photo.vala"
				_g_error_free0 (err);
#line 3881 "../src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3881 "../src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3881 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3881 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 3881 "../src/Photo.vala"
				return;
#line 27313 "Photo.c"
			}
#line 3889 "../src/Photo.vala"
			_tmp32_ = err;
#line 3889 "../src/Photo.vala"
			_tmp33_ = _g_error_copy0 (_tmp32_);
#line 3889 "../src/Photo.vala"
			_inner_error0_ = _tmp33_;
#line 3889 "../src/Photo.vala"
			_g_error_free0 (err);
#line 27323 "Photo.c"
			goto __finally1;
		}
		__finally1:
#line 3876 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3876 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3876 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3876 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3876 "../src/Photo.vala"
			return;
#line 27337 "Photo.c"
		}
#line 3893 "../src/Photo.vala"
		_tmp34_ = create_editable_file;
#line 3893 "../src/Photo.vala"
		photo_attach_editable (self, editable_file_format, _tmp34_, &_inner_error0_);
#line 3893 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3893 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3893 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3893 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3893 "../src/Photo.vala"
			return;
#line 27353 "Photo.c"
		}
#line 3895 "../src/Photo.vala"
		_tmp35_ = create_editable_file;
#line 3895 "../src/Photo.vala"
		_tmp36_ = _g_object_ref0 (_tmp35_);
#line 3895 "../src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3895 "../src/Photo.vala"
		current_editable_file = _tmp36_;
#line 27363 "Photo.c"
	}
#line 3898 "../src/Photo.vala"
	_tmp37_ = current_editable_file;
#line 3898 "../src/Photo.vala"
	_vala_assert (_tmp37_ != NULL, "current_editable_file != null");
#line 3901 "../src/Photo.vala"
	_tmp38_ = self->priv->editable_monitor;
#line 3901 "../src/Photo.vala"
	if (_tmp38_ == NULL) {
#line 27373 "Photo.c"
		GFile* _tmp39_;
#line 3902 "../src/Photo.vala"
		_tmp39_ = current_editable_file;
#line 3902 "../src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp39_, &_inner_error0_);
#line 3902 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3902 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3902 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3902 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3902 "../src/Photo.vala"
			return;
#line 27389 "Photo.c"
		}
	}
#line 3904 "../src/Photo.vala"
	_tmp40_ = current_editable_file;
#line 3904 "../src/Photo.vala"
	photo_launch_editor (_tmp40_, photo_get_file_format (self), &_inner_error0_);
#line 3904 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3904 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3904 "../src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3904 "../src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3904 "../src/Photo.vala"
		return;
#line 27406 "Photo.c"
	}
#line 3852 "../src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 3852 "../src/Photo.vala"
	_g_object_unref0 (current_editable_file);
#line 27412 "Photo.c"
}

void
photo_revert_to_master (Photo* self,
                        gboolean notify)
{
#line 3907 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3908 "../src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE, notify);
#line 27423 "Photo.c"
}

static void
_photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                        GFile* file,
                                                        GFile* other_file,
                                                        GFileMonitorEvent event_type,
                                                        gpointer self)
{
#line 3918 "../src/Photo.vala"
	photo_on_editable_file_changed ((Photo*) self, file, other_file, event_type);
#line 27435 "Photo.c"
}

static void
photo_start_monitoring_editable (Photo* self,
                                 GFile* file,
                                 GError** error)
{
	GFileMonitor* _tmp0_ = NULL;
	GFileMonitor* _tmp1_;
	GFileMonitor* _tmp2_;
	GFileMonitor* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3911 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3911 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 3912 "../src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3915 "../src/Photo.vala"
	library_monitor_blacklist_file (file, "Photo.start_monitoring_editable");
#line 3917 "../src/Photo.vala"
	_tmp1_ = g_file_monitor (file, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 3917 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 3917 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3917 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3917 "../src/Photo.vala"
		return;
#line 27466 "Photo.c"
	}
#line 3917 "../src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 3917 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3917 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3917 "../src/Photo.vala"
	self->priv->editable_monitor = _tmp2_;
#line 3918 "../src/Photo.vala"
	_tmp3_ = self->priv->editable_monitor;
#line 3918 "../src/Photo.vala"
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 3911 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 27482 "Photo.c"
}

static void
photo_halt_monitoring_editable (Photo* self)
{
	GFileMonitor* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileMonitor* _tmp4_;
	guint _tmp5_;
	GFileMonitor* _tmp6_;
#line 3921 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3922 "../src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 3922 "../src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 3923 "../src/Photo.vala"
		return;
#line 27503 "Photo.c"
	}
#line 3926 "../src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 3926 "../src/Photo.vala"
	file = _tmp1_;
#line 3927 "../src/Photo.vala"
	_tmp2_ = file;
#line 3927 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 27513 "Photo.c"
		GFile* _tmp3_;
#line 3928 "../src/Photo.vala"
		_tmp3_ = file;
#line 3928 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 27519 "Photo.c"
	}
#line 3930 "../src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3930 "../src/Photo.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 3930 "../src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 3931 "../src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 3931 "../src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 3932 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3932 "../src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 3921 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 27537 "Photo.c"
}

static void
photo_attach_editable (Photo* self,
                       PhotoFileFormat file_format,
                       GFile* file,
                       GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3935 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3935 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 3940 "../src/Photo.vala"
	photo_remove_all_transformations (self, FALSE);
#line 3941 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 3941 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3941 "../src/Photo.vala"
	_tmp2_ = photo_file_format_create_reader (file_format, _tmp1_);
#line 3941 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3941 "../src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp3_, &_inner_error0_);
#line 3941 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 3941 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 3941 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3941 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3941 "../src/Photo.vala"
		return;
#line 27577 "Photo.c"
	}
}

static void
photo_update_editable_attributes (Photo* self,
                                  GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3944 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3945 "../src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error0_);
#line 3945 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3945 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3945 "../src/Photo.vala"
		return;
#line 27596 "Photo.c"
	}
}

void
photo_reimport_editable (Photo* self,
                         GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3948 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3949 "../src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error0_);
#line 3949 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3949 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3949 "../src/Photo.vala"
		return;
#line 27615 "Photo.c"
	}
}

static void
_vala_array_add103 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4056 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4056 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4056 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27631 "Photo.c"
	}
#line 4056 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4056 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 27637 "Photo.c"
}

static void
_vala_array_add104 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4057 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4057 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4057 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27652 "Photo.c"
	}
#line 4057 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4057 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 27658 "Photo.c"
}

static void
_vala_array_add105 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4060 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4060 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4060 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27673 "Photo.c"
	}
#line 4060 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4060 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 27679 "Photo.c"
}

static void
_vala_array_add106 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4064 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4064 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4064 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27694 "Photo.c"
	}
#line 4064 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4064 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 27700 "Photo.c"
}

static void
_vala_array_add107 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4065 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4065 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4065 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27715 "Photo.c"
	}
#line 4065 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4065 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 27721 "Photo.c"
}

static void
_vala_array_add108 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4068 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4068 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4068 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27736 "Photo.c"
	}
#line 4068 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4068 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 27742 "Photo.c"
}

static void
photo_update_editable (Photo* self,
                       gboolean only_attributes,
                       PhotoFileReader* new_reader,
                       GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	PhotoFileReader* old_reader = NULL;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_ = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp5_;
	PhotoFileReader* _tmp6_;
	gboolean timestamp_changed = FALSE;
	gboolean filesize_changed = FALSE;
	gboolean is_new_editable = FALSE;
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp7_ = {0};
	GFile* file = NULL;
	PhotoFileReader* _tmp8_;
	GFile* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp10_;
	DetectedPhotoInformation* _tmp11_ = NULL;
	BackingPhotoRow* _tmp12_;
	gboolean _tmp75_ = FALSE;
	gchar** alteration_list = NULL;
	gchar** _tmp84_;
	gint alteration_list_length1;
	gint _alteration_list_size_;
	gboolean _tmp88_ = FALSE;
	gchar** _tmp92_;
	gint _tmp92__length1;
	GError* _inner_error0_ = NULL;
#line 3954 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3954 "../src/Photo.vala"
	g_return_if_fail ((new_reader == NULL) || IS_PHOTO_FILE_READER (new_reader));
#line 3956 "../src/Photo.vala"
	if (only_attributes) {
#line 3956 "../src/Photo.vala"
		_tmp1_ = new_reader == NULL;
#line 27789 "Photo.c"
	} else {
#line 3956 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 27793 "Photo.c"
	}
#line 3956 "../src/Photo.vala"
	if (_tmp1_) {
#line 3956 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 27799 "Photo.c"
	} else {
#line 3956 "../src/Photo.vala"
		_tmp0_ = !only_attributes;
#line 27803 "Photo.c"
	}
#line 3956 "../src/Photo.vala"
	_vala_assert (_tmp0_, "(only_attributes && new_reader == null) || (!only_attributes)");
#line 3958 "../src/Photo.vala"
	_tmp2_ = photo_get_editable_reader (self);
#line 3958 "../src/Photo.vala"
	old_reader = _tmp2_;
#line 3960 "../src/Photo.vala"
	_tmp3_ = new_reader;
#line 3960 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 27815 "Photo.c"
		PhotoFileReader* _tmp4_;
#line 3960 "../src/Photo.vala"
		_tmp4_ = old_reader;
#line 3960 "../src/Photo.vala"
		_tmp3_ = _tmp4_;
#line 27821 "Photo.c"
	}
#line 3960 "../src/Photo.vala"
	_tmp5_ = _photo_file_adapter_ref0 (_tmp3_);
#line 3960 "../src/Photo.vala"
	reader = _tmp5_;
#line 3961 "../src/Photo.vala"
	_tmp6_ = reader;
#line 3961 "../src/Photo.vala"
	if (_tmp6_ == NULL) {
#line 3962 "../src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3964 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3964 "../src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3964 "../src/Photo.vala"
		return;
#line 27839 "Photo.c"
	}
#line 3967 "../src/Photo.vala"
	timestamp_changed = FALSE;
#line 3968 "../src/Photo.vala"
	filesize_changed = FALSE;
#line 3969 "../src/Photo.vala"
	is_new_editable = FALSE;
#line 3971 "../src/Photo.vala"
	photo_get_editable_id (self, &_tmp7_);
#line 3971 "../src/Photo.vala"
	editable_id = _tmp7_;
#line 3972 "../src/Photo.vala"
	_tmp8_ = reader;
#line 3972 "../src/Photo.vala"
	_tmp9_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3972 "../src/Photo.vala"
	file = _tmp9_;
#line 3975 "../src/Photo.vala"
	_tmp10_ = file;
#line 3975 "../src/Photo.vala"
	_tmp12_ = photo_query_backing_photo_row (self, _tmp10_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp11_, &_inner_error0_);
#line 3975 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3975 "../src/Photo.vala"
	detected = _tmp11_;
#line 3975 "../src/Photo.vala"
	backing = _tmp12_;
#line 3975 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3975 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3975 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3975 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 3975 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3975 "../src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3975 "../src/Photo.vala"
		return;
#line 27881 "Photo.c"
	}
#line 3979 "../src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 27885 "Photo.c"
		BackingPhotoRow* _tmp13_;
#line 3981 "../src/Photo.vala"
		_tmp13_ = backing;
#line 3981 "../src/Photo.vala"
		if (_tmp13_ != NULL) {
#line 27891 "Photo.c"
			BackingPhotoTable* _tmp14_;
			BackingPhotoTable* _tmp15_;
			BackingPhotoRow* _tmp16_;
#line 3982 "../src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 3982 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3982 "../src/Photo.vala"
			_tmp16_ = backing;
#line 3982 "../src/Photo.vala"
			backing_photo_table_add (_tmp15_, _tmp16_, &_inner_error0_);
#line 3982 "../src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 3982 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3982 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 3982 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3982 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3982 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 3982 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3982 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3982 "../src/Photo.vala"
				return;
#line 27921 "Photo.c"
			}
			{
				PhotoRow* _tmp17_;
#line 3983 "../src/Photo.vala"
				_tmp17_ = self->row;
#line 3983 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 27929 "Photo.c"
				{
					PhotoTable* _tmp18_;
					PhotoTable* _tmp19_;
					PhotoRow* _tmp20_;
					BackingPhotoRow* _tmp21_;
					BackingPhotoID _tmp22_;
					BackingPhotoRow* _tmp23_;
					BackingPhotoRow* _tmp24_;
					BackingPhotoRow* _tmp25_;
					BackingPhotoRow* _tmp26_;
					BackingPhotoRow* _tmp27_;
#line 3984 "../src/Photo.vala"
					timestamp_changed = TRUE;
#line 3985 "../src/Photo.vala"
					filesize_changed = TRUE;
#line 3987 "../src/Photo.vala"
					_tmp18_ = photo_table_get_instance ();
#line 3987 "../src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 3987 "../src/Photo.vala"
					_tmp20_ = self->row;
#line 3987 "../src/Photo.vala"
					_tmp21_ = backing;
#line 3987 "../src/Photo.vala"
					_tmp22_ = _tmp21_->id;
#line 3987 "../src/Photo.vala"
					photo_table_attach_editable (_tmp19_, _tmp20_, &_tmp22_, &_inner_error0_);
#line 3987 "../src/Photo.vala"
					_database_table_unref0 (_tmp19_);
#line 3987 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27961 "Photo.c"
						goto __finally0;
					}
#line 3988 "../src/Photo.vala"
					_tmp23_ = backing;
#line 3988 "../src/Photo.vala"
					_tmp24_ = _backing_photo_row_ref0 (_tmp23_);
#line 3988 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3988 "../src/Photo.vala"
					self->priv->editable = _tmp24_;
#line 3989 "../src/Photo.vala"
					_tmp25_ = self->priv->editable;
#line 3989 "../src/Photo.vala"
					_tmp26_ = _backing_photo_row_ref0 (_tmp25_);
#line 3989 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3989 "../src/Photo.vala"
					self->backing_photo_row = _tmp26_;
#line 3990 "../src/Photo.vala"
					_tmp27_ = self->backing_photo_row;
#line 3990 "../src/Photo.vala"
					photo_set_orientation (self, _tmp27_->original_orientation);
#line 27984 "Photo.c"
				}
				__finally0:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp28_;
#line 3983 "../src/Photo.vala"
					_tmp28_ = self->row;
#line 3983 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27994 "Photo.c"
				}
#line 3983 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3983 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 3983 "../src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3983 "../src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3983 "../src/Photo.vala"
					_g_object_unref0 (file);
#line 3983 "../src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3983 "../src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3983 "../src/Photo.vala"
					return;
#line 28012 "Photo.c"
				}
			}
		}
#line 3993 "../src/Photo.vala"
		is_new_editable = TRUE;
#line 28018 "Photo.c"
	}
#line 3996 "../src/Photo.vala"
	if (only_attributes) {
#line 28022 "Photo.c"
		GFileInfo* info = NULL;
		GTimeVal timestamp = {0};
		GFileInfo* _tmp37_;
		GTimeVal _tmp38_ = {0};
		BackingPhotoTable* _tmp39_;
		BackingPhotoTable* _tmp40_;
		BackingPhotoID _tmp41_;
		GTimeVal _tmp42_;
		GFileInfo* _tmp43_;
#line 3998 "../src/Photo.vala"
		_vala_assert (backing_photo_id_is_valid (&editable_id), "editable_id.is_valid()");
#line 28034 "Photo.c"
		{
			GFileInfo* _tmp29_ = NULL;
			GFile* _tmp30_;
			GFileInfo* _tmp31_;
			GFileInfo* _tmp32_;
#line 4002 "../src/Photo.vala"
			_tmp30_ = file;
#line 4002 "../src/Photo.vala"
			_tmp31_ = g_file_query_filesystem_info (_tmp30_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error0_);
#line 4002 "../src/Photo.vala"
			_tmp29_ = _tmp31_;
#line 4002 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28048 "Photo.c"
				goto __catch1_g_error;
			}
#line 4002 "../src/Photo.vala"
			_tmp32_ = _tmp29_;
#line 4002 "../src/Photo.vala"
			_tmp29_ = NULL;
#line 4002 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4002 "../src/Photo.vala"
			info = _tmp32_;
#line 4001 "../src/Photo.vala"
			_g_object_unref0 (_tmp29_);
#line 28061 "Photo.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			gchar* _tmp33_;
			gchar* _tmp34_;
			GError* _tmp35_;
			const gchar* _tmp36_;
#line 4001 "../src/Photo.vala"
			err = _inner_error0_;
#line 4001 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4004 "../src/Photo.vala"
			_tmp33_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4004 "../src/Photo.vala"
			_tmp34_ = _tmp33_;
#line 4004 "../src/Photo.vala"
			_tmp35_ = err;
#line 4004 "../src/Photo.vala"
			_tmp36_ = _tmp35_->message;
#line 4004 "../src/Photo.vala"
			g_warning ("Photo.vala:4004: Unable to read editable filesystem info for %s: %s", _tmp34_, _tmp36_);
#line 4004 "../src/Photo.vala"
			_g_free0 (_tmp34_);
#line 4005 "../src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4007 "../src/Photo.vala"
			_g_error_free0 (err);
#line 4007 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4007 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4007 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4007 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 4007 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4007 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4007 "../src/Photo.vala"
			return;
#line 28105 "Photo.c"
		}
		__finally1:
#line 4001 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4001 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 4001 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4001 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4001 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4001 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 4001 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4001 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4001 "../src/Photo.vala"
			return;
#line 28126 "Photo.c"
		}
#line 4010 "../src/Photo.vala"
		_tmp37_ = info;
#line 4010 "../src/Photo.vala"
		g_file_info_get_modification_time (_tmp37_, &_tmp38_);
#line 4010 "../src/Photo.vala"
		timestamp = _tmp38_;
#line 4012 "../src/Photo.vala"
		_tmp39_ = backing_photo_table_get_instance ();
#line 4012 "../src/Photo.vala"
		_tmp40_ = _tmp39_;
#line 4012 "../src/Photo.vala"
		_tmp41_ = editable_id;
#line 4012 "../src/Photo.vala"
		_tmp42_ = timestamp;
#line 4012 "../src/Photo.vala"
		_tmp43_ = info;
#line 4012 "../src/Photo.vala"
		backing_photo_table_update_attributes (_tmp40_, &_tmp41_, (time_t) _tmp42_.tv_sec, g_file_info_get_size (_tmp43_), &_inner_error0_);
#line 4012 "../src/Photo.vala"
		_database_table_unref0 (_tmp40_);
#line 4012 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4012 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 4012 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4012 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4012 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4012 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 4012 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4012 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4012 "../src/Photo.vala"
			return;
#line 28166 "Photo.c"
		}
		{
			PhotoRow* _tmp44_;
#line 4014 "../src/Photo.vala"
			_tmp44_ = self->row;
#line 4014 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 28174 "Photo.c"
			{
				BackingPhotoRow* _tmp45_;
				GTimeVal _tmp46_;
				BackingPhotoRow* _tmp47_;
				GFileInfo* _tmp48_;
				BackingPhotoRow* _tmp49_;
				GTimeVal _tmp50_;
				BackingPhotoRow* _tmp51_;
				GFileInfo* _tmp52_;
#line 4015 "../src/Photo.vala"
				_tmp45_ = self->priv->editable;
#line 4015 "../src/Photo.vala"
				_tmp46_ = timestamp;
#line 4015 "../src/Photo.vala"
				timestamp_changed = _tmp45_->timestamp != ((time_t) _tmp46_.tv_sec);
#line 4016 "../src/Photo.vala"
				_tmp47_ = self->priv->editable;
#line 4016 "../src/Photo.vala"
				_tmp48_ = info;
#line 4016 "../src/Photo.vala"
				filesize_changed = _tmp47_->filesize != g_file_info_get_size (_tmp48_);
#line 4018 "../src/Photo.vala"
				_tmp49_ = self->priv->editable;
#line 4018 "../src/Photo.vala"
				_tmp50_ = timestamp;
#line 4018 "../src/Photo.vala"
				_tmp49_->timestamp = (time_t) _tmp50_.tv_sec;
#line 4019 "../src/Photo.vala"
				_tmp51_ = self->priv->editable;
#line 4019 "../src/Photo.vala"
				_tmp52_ = info;
#line 4019 "../src/Photo.vala"
				_tmp51_->filesize = g_file_info_get_size (_tmp52_);
#line 28208 "Photo.c"
			}
			__finally2:
			{
				PhotoRow* _tmp53_;
#line 4014 "../src/Photo.vala"
				_tmp53_ = self->row;
#line 4014 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28217 "Photo.c"
			}
#line 4014 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4014 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4014 "../src/Photo.vala"
				_g_object_unref0 (info);
#line 4014 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4014 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4014 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4014 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4014 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4014 "../src/Photo.vala"
				return;
#line 28237 "Photo.c"
			}
		}
#line 3996 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 28242 "Photo.c"
	} else {
		gboolean _tmp54_ = FALSE;
#line 4023 "../src/Photo.vala"
		if (backing_photo_id_is_valid (&editable_id)) {
#line 4023 "../src/Photo.vala"
			_tmp54_ = !is_new_editable;
#line 28249 "Photo.c"
		} else {
#line 4023 "../src/Photo.vala"
			_tmp54_ = FALSE;
#line 28253 "Photo.c"
		}
#line 4023 "../src/Photo.vala"
		if (_tmp54_) {
#line 28257 "Photo.c"
			BackingPhotoRow* _tmp55_;
			BackingPhotoID _tmp56_;
			BackingPhotoTable* _tmp57_;
			BackingPhotoTable* _tmp58_;
			BackingPhotoRow* _tmp59_;
#line 4028 "../src/Photo.vala"
			_tmp55_ = backing;
#line 4028 "../src/Photo.vala"
			_tmp56_ = editable_id;
#line 4028 "../src/Photo.vala"
			_tmp55_->id = _tmp56_;
#line 4029 "../src/Photo.vala"
			_tmp57_ = backing_photo_table_get_instance ();
#line 4029 "../src/Photo.vala"
			_tmp58_ = _tmp57_;
#line 4029 "../src/Photo.vala"
			_tmp59_ = backing;
#line 4029 "../src/Photo.vala"
			backing_photo_table_update (_tmp58_, _tmp59_, &_inner_error0_);
#line 4029 "../src/Photo.vala"
			_database_table_unref0 (_tmp58_);
#line 4029 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4029 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4029 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4029 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4029 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4029 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4029 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4029 "../src/Photo.vala"
				return;
#line 28295 "Photo.c"
			}
			{
				PhotoRow* _tmp60_;
#line 4030 "../src/Photo.vala"
				_tmp60_ = self->row;
#line 4030 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28303 "Photo.c"
				{
					BackingPhotoRow* _tmp61_;
					BackingPhotoRow* _tmp62_;
					BackingPhotoRow* _tmp63_;
					BackingPhotoRow* _tmp64_;
					BackingPhotoRow* _tmp65_;
					BackingPhotoRow* _tmp66_;
					BackingPhotoRow* _tmp67_;
					BackingPhotoRow* _tmp68_;
					BackingPhotoRow* _tmp69_;
#line 4031 "../src/Photo.vala"
					_tmp61_ = self->priv->editable;
#line 4031 "../src/Photo.vala"
					_tmp62_ = backing;
#line 4031 "../src/Photo.vala"
					timestamp_changed = _tmp61_->timestamp != _tmp62_->timestamp;
#line 4032 "../src/Photo.vala"
					_tmp63_ = self->priv->editable;
#line 4032 "../src/Photo.vala"
					_tmp64_ = backing;
#line 4032 "../src/Photo.vala"
					filesize_changed = _tmp63_->filesize != _tmp64_->filesize;
#line 4034 "../src/Photo.vala"
					_tmp65_ = backing;
#line 4034 "../src/Photo.vala"
					_tmp66_ = _backing_photo_row_ref0 (_tmp65_);
#line 4034 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 4034 "../src/Photo.vala"
					self->priv->editable = _tmp66_;
#line 4035 "../src/Photo.vala"
					_tmp67_ = self->priv->editable;
#line 4035 "../src/Photo.vala"
					_tmp68_ = _backing_photo_row_ref0 (_tmp67_);
#line 4035 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 4035 "../src/Photo.vala"
					self->backing_photo_row = _tmp68_;
#line 4036 "../src/Photo.vala"
					_tmp69_ = self->backing_photo_row;
#line 4036 "../src/Photo.vala"
					photo_set_orientation (self, _tmp69_->original_orientation);
#line 28346 "Photo.c"
				}
				__finally3:
				{
					PhotoRow* _tmp70_;
#line 4030 "../src/Photo.vala"
					_tmp70_ = self->row;
#line 4030 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28355 "Photo.c"
				}
#line 4030 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4030 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 4030 "../src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 4030 "../src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 4030 "../src/Photo.vala"
					_g_object_unref0 (file);
#line 4030 "../src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 4030 "../src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 4030 "../src/Photo.vala"
					return;
#line 28373 "Photo.c"
				}
			}
		}
	}
#line 4042 "../src/Photo.vala"
	if (new_reader != NULL) {
#line 28380 "Photo.c"
		{
			PhotoBackingReaders* _tmp71_;
#line 4043 "../src/Photo.vala"
			_tmp71_ = self->priv->readers;
#line 4043 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28387 "Photo.c"
			{
				PhotoBackingReaders* _tmp72_;
				PhotoFileReader* _tmp73_;
#line 4044 "../src/Photo.vala"
				_tmp72_ = self->priv->readers;
#line 4044 "../src/Photo.vala"
				_tmp73_ = _photo_file_adapter_ref0 (new_reader);
#line 4044 "../src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp72_->editable);
#line 4044 "../src/Photo.vala"
				_tmp72_->editable = _tmp73_;
#line 28399 "Photo.c"
			}
			__finally4:
			{
				PhotoBackingReaders* _tmp74_;
#line 4043 "../src/Photo.vala"
				_tmp74_ = self->priv->readers;
#line 4043 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28408 "Photo.c"
			}
#line 4043 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4043 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4043 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4043 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4043 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4043 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4043 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4043 "../src/Photo.vala"
				return;
#line 28426 "Photo.c"
			}
		}
	}
#line 4048 "../src/Photo.vala"
	if (!only_attributes) {
#line 28432 "Photo.c"
		PhotoFileReader* _tmp76_;
		PhotoFileReader* _tmp77_;
#line 4048 "../src/Photo.vala"
		_tmp76_ = reader;
#line 4048 "../src/Photo.vala"
		_tmp77_ = old_reader;
#line 4048 "../src/Photo.vala"
		_tmp75_ = _tmp76_ != _tmp77_;
#line 28441 "Photo.c"
	} else {
#line 4048 "../src/Photo.vala"
		_tmp75_ = FALSE;
#line 28445 "Photo.c"
	}
#line 4048 "../src/Photo.vala"
	if (_tmp75_) {
#line 28449 "Photo.c"
		GFile* _tmp78_ = NULL;
		PhotoFileReader* _tmp79_;
		GFile* _tmp82_ = NULL;
#line 4049 "../src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4050 "../src/Photo.vala"
		_tmp79_ = old_reader;
#line 4050 "../src/Photo.vala"
		if (_tmp79_ != NULL) {
#line 28459 "Photo.c"
			PhotoFileReader* _tmp80_;
			GFile* _tmp81_;
#line 4050 "../src/Photo.vala"
			_tmp80_ = old_reader;
#line 4050 "../src/Photo.vala"
			_tmp81_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4050 "../src/Photo.vala"
			_g_object_unref0 (_tmp78_);
#line 4050 "../src/Photo.vala"
			_tmp78_ = _tmp81_;
#line 28470 "Photo.c"
		} else {
#line 4050 "../src/Photo.vala"
			_g_object_unref0 (_tmp78_);
#line 4050 "../src/Photo.vala"
			_tmp78_ = NULL;
#line 28476 "Photo.c"
		}
#line 4051 "../src/Photo.vala"
		if (new_reader != NULL) {
#line 28480 "Photo.c"
			GFile* _tmp83_;
#line 4051 "../src/Photo.vala"
			_tmp83_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (new_reader, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4051 "../src/Photo.vala"
			_g_object_unref0 (_tmp82_);
#line 4051 "../src/Photo.vala"
			_tmp82_ = _tmp83_;
#line 28488 "Photo.c"
		} else {
#line 4051 "../src/Photo.vala"
			_g_object_unref0 (_tmp82_);
#line 4051 "../src/Photo.vala"
			_tmp82_ = NULL;
#line 28494 "Photo.c"
		}
#line 4050 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp78_, _tmp82_);
#line 4048 "../src/Photo.vala"
		_g_object_unref0 (_tmp82_);
#line 4048 "../src/Photo.vala"
		_g_object_unref0 (_tmp78_);
#line 28502 "Photo.c"
	}
#line 4054 "../src/Photo.vala"
	_tmp84_ = g_new0 (gchar*, 0 + 1);
#line 4054 "../src/Photo.vala"
	alteration_list = _tmp84_;
#line 4054 "../src/Photo.vala"
	alteration_list_length1 = 0;
#line 4054 "../src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 4055 "../src/Photo.vala"
	if (timestamp_changed) {
#line 28514 "Photo.c"
		gchar* _tmp85_;
		gchar* _tmp86_;
#line 4056 "../src/Photo.vala"
		_tmp85_ = g_strdup ("metadata:editable-timestamp");
#line 4056 "../src/Photo.vala"
		_vala_array_add103 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp85_);
#line 4057 "../src/Photo.vala"
		_tmp86_ = g_strdup ("metadata:baseline-timestamp");
#line 4057 "../src/Photo.vala"
		_vala_array_add104 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp86_);
#line 4059 "../src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 28527 "Photo.c"
			gchar* _tmp87_;
#line 4060 "../src/Photo.vala"
			_tmp87_ = g_strdup ("metadata:source-timestamp");
#line 4060 "../src/Photo.vala"
			_vala_array_add105 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp87_);
#line 28533 "Photo.c"
		}
	}
#line 4063 "../src/Photo.vala"
	if (filesize_changed) {
#line 4063 "../src/Photo.vala"
		_tmp88_ = TRUE;
#line 28540 "Photo.c"
	} else {
#line 4063 "../src/Photo.vala"
		_tmp88_ = new_reader != NULL;
#line 28544 "Photo.c"
	}
#line 4063 "../src/Photo.vala"
	if (_tmp88_) {
#line 28548 "Photo.c"
		gchar* _tmp89_;
		gchar* _tmp90_;
#line 4064 "../src/Photo.vala"
		_tmp89_ = g_strdup ("image:editable");
#line 4064 "../src/Photo.vala"
		_vala_array_add106 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp89_);
#line 4065 "../src/Photo.vala"
		_tmp90_ = g_strdup ("image:baseline");
#line 4065 "../src/Photo.vala"
		_vala_array_add107 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp90_);
#line 4067 "../src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 28561 "Photo.c"
			gchar* _tmp91_;
#line 4068 "../src/Photo.vala"
			_tmp91_ = g_strdup ("image:source");
#line 4068 "../src/Photo.vala"
			_vala_array_add108 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp91_);
#line 28567 "Photo.c"
		}
	}
#line 4071 "../src/Photo.vala"
	_tmp92_ = alteration_list;
#line 4071 "../src/Photo.vala"
	_tmp92__length1 = alteration_list_length1;
#line 4071 "../src/Photo.vala"
	if (_tmp92__length1 > 0) {
#line 28576 "Photo.c"
		gchar** _tmp93_;
		gint _tmp93__length1;
		Alteration* _tmp94_;
		Alteration* _tmp95_;
#line 4072 "../src/Photo.vala"
		_tmp93_ = alteration_list;
#line 4072 "../src/Photo.vala"
		_tmp93__length1 = alteration_list_length1;
#line 4072 "../src/Photo.vala"
		_tmp94_ = alteration_new_from_array (_tmp93_, _tmp93__length1);
#line 4072 "../src/Photo.vala"
		_tmp95_ = _tmp94_;
#line 4072 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp95_);
#line 4072 "../src/Photo.vala"
		_alteration_unref0 (_tmp95_);
#line 28593 "Photo.c"
	}
#line 3954 "../src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 3954 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 3954 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3954 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 3954 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 3954 "../src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 28607 "Photo.c"
}

static void
photo_detach_editable (Photo* self,
                       gboolean delete_editable,
                       gboolean remove_transformations,
                       gboolean notify)
{
	gboolean has_editable = FALSE;
	GFile* editable_file = NULL;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp37_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 4075 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4076 "../src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 4078 "../src/Photo.vala"
	has_editable = FALSE;
#line 4079 "../src/Photo.vala"
	editable_file = NULL;
#line 28630 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4080 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4080 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28637 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 4081 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 4081 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 4081 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 28647 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
				PhotoBackingReaders* _tmp6_;
#line 4082 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 4082 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 4082 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4082 "../src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 4082 "../src/Photo.vala"
				editable_file = _tmp5_;
#line 4083 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 4083 "../src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp6_->editable);
#line 4083 "../src/Photo.vala"
				_tmp6_->editable = NULL;
#line 4084 "../src/Photo.vala"
				has_editable = TRUE;
#line 28670 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp7_;
#line 4080 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 4080 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28680 "Photo.c"
		}
#line 4080 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4080 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4080 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4080 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4080 "../src/Photo.vala"
			return;
#line 28692 "Photo.c"
		}
	}
#line 4088 "../src/Photo.vala"
	if (has_editable) {
#line 28697 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 4089 "../src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 28701 "Photo.c"
		{
			{
				PhotoRow* _tmp8_;
#line 4091 "../src/Photo.vala"
				_tmp8_ = self->row;
#line 4091 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28709 "Photo.c"
				{
					PhotoRow* _tmp9_;
					BackingPhotoID _tmp10_;
					PhotoRow* _tmp14_;
					BackingPhotoRow* _tmp15_;
					BackingPhotoRow* _tmp16_;
#line 4092 "../src/Photo.vala"
					_tmp9_ = self->row;
#line 4092 "../src/Photo.vala"
					_tmp10_ = _tmp9_->editable_id;
#line 4092 "../src/Photo.vala"
					editable_id = _tmp10_;
#line 4093 "../src/Photo.vala"
					if (backing_photo_id_is_valid (&editable_id)) {
#line 28724 "Photo.c"
						PhotoTable* _tmp11_;
						PhotoTable* _tmp12_;
						PhotoRow* _tmp13_;
#line 4094 "../src/Photo.vala"
						_tmp11_ = photo_table_get_instance ();
#line 4094 "../src/Photo.vala"
						_tmp12_ = _tmp11_;
#line 4094 "../src/Photo.vala"
						_tmp13_ = self->row;
#line 4094 "../src/Photo.vala"
						photo_table_detach_editable (_tmp12_, _tmp13_, &_inner_error0_);
#line 4094 "../src/Photo.vala"
						_database_table_unref0 (_tmp12_);
#line 4094 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28740 "Photo.c"
							goto __finally2;
						}
					}
#line 4095 "../src/Photo.vala"
					_tmp14_ = self->row;
#line 4095 "../src/Photo.vala"
					_tmp15_ = _tmp14_->master;
#line 4095 "../src/Photo.vala"
					_tmp16_ = _backing_photo_row_ref0 (_tmp15_);
#line 4095 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 4095 "../src/Photo.vala"
					self->backing_photo_row = _tmp16_;
#line 28754 "Photo.c"
				}
				__finally2:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp17_;
#line 4091 "../src/Photo.vala"
					_tmp17_ = self->row;
#line 4091 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28764 "Photo.c"
				}
#line 4091 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4091 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 28770 "Photo.c"
						goto __catch1_database_error;
					}
#line 4091 "../src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 4091 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4091 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 4091 "../src/Photo.vala"
					return;
#line 28781 "Photo.c"
				}
			}
		}
		goto __finally1;
		__catch1_database_error:
		{
			GError* err = NULL;
			GError* _tmp18_;
			const gchar* _tmp19_;
#line 4090 "../src/Photo.vala"
			err = _inner_error0_;
#line 4090 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4098 "../src/Photo.vala"
			_tmp18_ = err;
#line 4098 "../src/Photo.vala"
			_tmp19_ = _tmp18_->message;
#line 4098 "../src/Photo.vala"
			g_warning ("Photo.vala:4098: Unable to remove editable from PhotoTable: %s", _tmp19_);
#line 4090 "../src/Photo.vala"
			_g_error_free0 (err);
#line 28803 "Photo.c"
		}
		__finally1:
#line 4090 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4090 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4090 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4090 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4090 "../src/Photo.vala"
			return;
#line 28816 "Photo.c"
		}
		{
#line 4102 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&editable_id)) {
#line 28821 "Photo.c"
				BackingPhotoTable* _tmp20_;
				BackingPhotoTable* _tmp21_;
				BackingPhotoID _tmp22_;
#line 4103 "../src/Photo.vala"
				_tmp20_ = backing_photo_table_get_instance ();
#line 4103 "../src/Photo.vala"
				_tmp21_ = _tmp20_;
#line 4103 "../src/Photo.vala"
				_tmp22_ = editable_id;
#line 4103 "../src/Photo.vala"
				backing_photo_table_remove (_tmp21_, &_tmp22_, &_inner_error0_);
#line 4103 "../src/Photo.vala"
				_database_table_unref0 (_tmp21_);
#line 4103 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4103 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 28839 "Photo.c"
						goto __catch3_database_error;
					}
#line 4103 "../src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 4103 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4103 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 4103 "../src/Photo.vala"
					return;
#line 28850 "Photo.c"
				}
			}
		}
		goto __finally3;
		__catch3_database_error:
		{
			GError* err = NULL;
			GError* _tmp23_;
			const gchar* _tmp24_;
#line 4101 "../src/Photo.vala"
			err = _inner_error0_;
#line 4101 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4105 "../src/Photo.vala"
			_tmp23_ = err;
#line 4105 "../src/Photo.vala"
			_tmp24_ = _tmp23_->message;
#line 4105 "../src/Photo.vala"
			g_warning ("Photo.vala:4105: Unable to remove editable from BackingPhotoTable: %s", _tmp24_);
#line 4101 "../src/Photo.vala"
			_g_error_free0 (err);
#line 28872 "Photo.c"
		}
		__finally3:
#line 4101 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4101 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4101 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4101 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4101 "../src/Photo.vala"
			return;
#line 28885 "Photo.c"
		}
	}
#line 4109 "../src/Photo.vala"
	if (remove_transformations) {
#line 4110 "../src/Photo.vala"
		photo_remove_all_transformations (self, FALSE);
#line 28892 "Photo.c"
	}
#line 4112 "../src/Photo.vala"
	if (has_editable) {
#line 28896 "Photo.c"
		GFile* _tmp25_;
#line 4113 "../src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4114 "../src/Photo.vala"
		_tmp25_ = editable_file;
#line 4114 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp25_, NULL);
#line 28904 "Photo.c"
	}
#line 4117 "../src/Photo.vala"
	if (delete_editable) {
#line 28908 "Photo.c"
		GFile* _tmp27_;
#line 4117 "../src/Photo.vala"
		_tmp27_ = editable_file;
#line 4117 "../src/Photo.vala"
		_tmp26_ = _tmp27_ != NULL;
#line 28914 "Photo.c"
	} else {
#line 4117 "../src/Photo.vala"
		_tmp26_ = FALSE;
#line 28918 "Photo.c"
	}
#line 4117 "../src/Photo.vala"
	if (_tmp26_) {
#line 28922 "Photo.c"
		{
			GFile* _tmp28_;
#line 4119 "../src/Photo.vala"
			_tmp28_ = editable_file;
#line 4119 "../src/Photo.vala"
			g_file_trash (_tmp28_, NULL, &_inner_error0_);
#line 4119 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28931 "Photo.c"
				goto __catch4_g_error;
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* err = NULL;
			GFile* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			GError* _tmp34_;
			const gchar* _tmp35_;
#line 4118 "../src/Photo.vala"
			err = _inner_error0_;
#line 4118 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4121 "../src/Photo.vala"
			_tmp29_ = editable_file;
#line 4121 "../src/Photo.vala"
			_tmp30_ = g_file_get_path (_tmp29_);
#line 4121 "../src/Photo.vala"
			_tmp31_ = _tmp30_;
#line 4121 "../src/Photo.vala"
			_tmp32_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4121 "../src/Photo.vala"
			_tmp33_ = _tmp32_;
#line 4121 "../src/Photo.vala"
			_tmp34_ = err;
#line 4121 "../src/Photo.vala"
			_tmp35_ = _tmp34_->message;
#line 4121 "../src/Photo.vala"
			g_warning ("Photo.vala:4121: Unable to trash editable %s for %s: %s", _tmp31_, _tmp33_, _tmp35_);
#line 4121 "../src/Photo.vala"
			_g_free0 (_tmp33_);
#line 4121 "../src/Photo.vala"
			_g_free0 (_tmp31_);
#line 4118 "../src/Photo.vala"
			_g_error_free0 (err);
#line 28972 "Photo.c"
		}
		__finally4:
#line 4118 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4118 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4118 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4118 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4118 "../src/Photo.vala"
			return;
#line 28985 "Photo.c"
		}
	}
#line 4126 "../src/Photo.vala"
	if (has_editable) {
#line 4126 "../src/Photo.vala"
		_tmp37_ = TRUE;
#line 28992 "Photo.c"
	} else {
#line 4126 "../src/Photo.vala"
		_tmp37_ = remove_transformations;
#line 28996 "Photo.c"
	}
#line 4126 "../src/Photo.vala"
	if (_tmp37_) {
#line 4126 "../src/Photo.vala"
		_tmp36_ = notify;
#line 29002 "Photo.c"
	} else {
#line 4126 "../src/Photo.vala"
		_tmp36_ = FALSE;
#line 29006 "Photo.c"
	}
#line 4126 "../src/Photo.vala"
	if (_tmp36_) {
#line 29010 "Photo.c"
		Alteration* _tmp38_;
		Alteration* _tmp39_;
#line 4127 "../src/Photo.vala"
		_tmp38_ = alteration_new ("image", "revert");
#line 4127 "../src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 4127 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp39_);
#line 4127 "../src/Photo.vala"
		_alteration_unref0 (_tmp39_);
#line 29021 "Photo.c"
	}
#line 4075 "../src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 29025 "Photo.c"
}

static void
_photo_on_reimport_editable_one_shot_callback (gpointer self)
{
#line 4149 "../src/Photo.vala"
	photo_on_reimport_editable ((Photo*) self);
#line 29033 "Photo.c"
}

static void
_photo_on_update_editable_attributes_one_shot_callback (gpointer self)
{
#line 4158 "../src/Photo.vala"
	photo_on_update_editable_attributes ((Photo*) self);
#line 29041 "Photo.c"
}

static void
_photo_on_remove_editable_one_shot_callback (gpointer self)
{
#line 4167 "../src/Photo.vala"
	photo_on_remove_editable ((Photo*) self);
#line 29049 "Photo.c"
}

static void
photo_on_editable_file_changed (Photo* self,
                                GFile* file,
                                GFile* other_file,
                                GFileMonitorEvent event)
{
	GEnumValue* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 4130 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4130 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 4130 "../src/Photo.vala"
	g_return_if_fail ((other_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (other_file, g_file_get_type ()));
#line 29068 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4132 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4132 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 29075 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp3_;
			PhotoFileReader* _tmp4_;
			GFile* _tmp5_;
			GFile* _tmp6_;
			gboolean _tmp7_;
#line 4133 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 4133 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 4133 "../src/Photo.vala"
			_vala_assert (_tmp2_ != NULL, "readers.editable != null");
#line 4135 "../src/Photo.vala"
			_tmp3_ = self->priv->readers;
#line 4135 "../src/Photo.vala"
			_tmp4_ = _tmp3_->editable;
#line 4135 "../src/Photo.vala"
			_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4135 "../src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 4135 "../src/Photo.vala"
			_tmp7_ = !g_file_equal (file, _tmp6_);
#line 4135 "../src/Photo.vala"
			_g_object_unref0 (_tmp6_);
#line 4135 "../src/Photo.vala"
			if (_tmp7_) {
#line 29104 "Photo.c"
				{
					PhotoBackingReaders* _tmp8_;
#line 4132 "../src/Photo.vala"
					_tmp8_ = self->priv->readers;
#line 4132 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29111 "Photo.c"
				}
#line 4139 "../src/Photo.vala"
				return;
#line 29115 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp9_;
#line 4132 "../src/Photo.vala"
			_tmp9_ = self->priv->readers;
#line 4132 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29125 "Photo.c"
		}
#line 4132 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4132 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4132 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4132 "../src/Photo.vala"
			return;
#line 29135 "Photo.c"
		}
	}
#line 4143 "../src/Photo.vala"
	_tmp10_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 4143 "../src/Photo.vala"
	_tmp11_ = g_file_get_path (file);
#line 4143 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 4143 "../src/Photo.vala"
	g_debug ("Photo.vala:4143: EDITABLE %s: %s", (_tmp10_ != NULL) ? _tmp10_->value_name : NULL, _tmp12_);
#line 4143 "../src/Photo.vala"
	_g_free0 (_tmp12_);
#line 4145 "../src/Photo.vala"
	switch (event) {
#line 4145 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 4145 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 29154 "Photo.c"
		{
			OneShotScheduler* _tmp13_;
			OneShotScheduler* _tmp15_;
#line 4148 "../src/Photo.vala"
			_tmp13_ = self->priv->reimport_editable_scheduler;
#line 4148 "../src/Photo.vala"
			if (_tmp13_ == NULL) {
#line 29162 "Photo.c"
				OneShotScheduler* _tmp14_;
#line 4149 "../src/Photo.vala"
				_tmp14_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 4149 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 4149 "../src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp14_;
#line 29170 "Photo.c"
			}
#line 4153 "../src/Photo.vala"
			_tmp15_ = self->priv->reimport_editable_scheduler;
#line 4153 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp15_, (guint) 1000, TRUE);
#line 4154 "../src/Photo.vala"
			break;
#line 29178 "Photo.c"
		}
#line 4145 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 29182 "Photo.c"
		{
			OneShotScheduler* _tmp16_;
			OneShotScheduler* _tmp18_;
#line 4157 "../src/Photo.vala"
			_tmp16_ = self->priv->update_editable_attributes_scheduler;
#line 4157 "../src/Photo.vala"
			if (_tmp16_ == NULL) {
#line 29190 "Photo.c"
				OneShotScheduler* _tmp17_;
#line 4158 "../src/Photo.vala"
				_tmp17_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 4158 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 4158 "../src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp17_;
#line 29198 "Photo.c"
			}
#line 4162 "../src/Photo.vala"
			_tmp18_ = self->priv->update_editable_attributes_scheduler;
#line 4162 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp18_, (guint) 1000, TRUE);
#line 4163 "../src/Photo.vala"
			break;
#line 29206 "Photo.c"
		}
#line 4145 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 29210 "Photo.c"
		{
			OneShotScheduler* _tmp19_;
			OneShotScheduler* _tmp21_;
#line 4166 "../src/Photo.vala"
			_tmp19_ = self->priv->remove_editable_scheduler;
#line 4166 "../src/Photo.vala"
			if (_tmp19_ == NULL) {
#line 29218 "Photo.c"
				OneShotScheduler* _tmp20_;
#line 4167 "../src/Photo.vala"
				_tmp20_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 4167 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 4167 "../src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp20_;
#line 29226 "Photo.c"
			}
#line 4171 "../src/Photo.vala"
			_tmp21_ = self->priv->remove_editable_scheduler;
#line 4171 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp21_, (guint) 3000, TRUE);
#line 4172 "../src/Photo.vala"
			break;
#line 29234 "Photo.c"
		}
		default:
#line 4145 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 29239 "Photo.c"
		{
#line 4177 "../src/Photo.vala"
			break;
#line 29243 "Photo.c"
		}
	}
#line 4182 "../src/Photo.vala"
	photo_discard_prefetched (self);
#line 29248 "Photo.c"
}

static void
photo_on_reimport_editable (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4185 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4187 "../src/Photo.vala"
	photo_discard_prefetched (self);
#line 4189 "../src/Photo.vala"
	_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4189 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4189 "../src/Photo.vala"
	g_debug ("Photo.vala:4189: Reimporting editable for %s", _tmp1_);
#line 4189 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29269 "Photo.c"
	{
#line 4191 "../src/Photo.vala"
		photo_reimport_editable (self, &_inner_error0_);
#line 4191 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29275 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 4190 "../src/Photo.vala"
		err = _inner_error0_;
#line 4190 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4193 "../src/Photo.vala"
		_tmp2_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4193 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4193 "../src/Photo.vala"
		_tmp4_ = err;
#line 4193 "../src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 4193 "../src/Photo.vala"
		g_warning ("Photo.vala:4193: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 4193 "../src/Photo.vala"
		_g_free0 (_tmp3_);
#line 4190 "../src/Photo.vala"
		_g_error_free0 (err);
#line 29305 "Photo.c"
	}
	__finally0:
#line 4190 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4190 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4190 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4190 "../src/Photo.vala"
		return;
#line 29316 "Photo.c"
	}
}

static void
photo_on_update_editable_attributes (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4198 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4199 "../src/Photo.vala"
	_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4199 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4199 "../src/Photo.vala"
	g_debug ("Photo.vala:4199: Updating editable attributes for %s", _tmp1_);
#line 4199 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29336 "Photo.c"
	{
#line 4201 "../src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error0_);
#line 4201 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29342 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 4200 "../src/Photo.vala"
		err = _inner_error0_;
#line 4200 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4203 "../src/Photo.vala"
		_tmp2_ = err;
#line 4203 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4203 "../src/Photo.vala"
		g_warning ("Photo.vala:4203: Unable to update editable attributes: %s", _tmp3_);
#line 4200 "../src/Photo.vala"
		_g_error_free0 (err);
#line 29364 "Photo.c"
	}
	__finally0:
#line 4200 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4200 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4200 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4200 "../src/Photo.vala"
		return;
#line 29375 "Photo.c"
	}
}

static void
photo_on_remove_editable (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* file = NULL;
	PhotoFileReader* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 4207 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4208 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 4208 "../src/Photo.vala"
	reader = _tmp0_;
#line 4209 "../src/Photo.vala"
	_tmp1_ = reader;
#line 4209 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4210 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4210 "../src/Photo.vala"
		return;
#line 29405 "Photo.c"
	}
#line 4212 "../src/Photo.vala"
	_tmp2_ = reader;
#line 4212 "../src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4212 "../src/Photo.vala"
	file = _tmp3_;
#line 4213 "../src/Photo.vala"
	_tmp4_ = file;
#line 4213 "../src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 29417 "Photo.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 4214 "../src/Photo.vala"
		_tmp5_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4214 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4214 "../src/Photo.vala"
		g_debug ("Photo.vala:4214: Not removing editable for %s: file exists", _tmp6_);
#line 4214 "../src/Photo.vala"
		_g_free0 (_tmp6_);
#line 4216 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 4216 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4216 "../src/Photo.vala"
		return;
#line 29434 "Photo.c"
	}
#line 4219 "../src/Photo.vala"
	_tmp7_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4219 "../src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 4219 "../src/Photo.vala"
	g_debug ("Photo.vala:4219: Removing editable for %s: file no longer exists", _tmp8_);
#line 4219 "../src/Photo.vala"
	_g_free0 (_tmp8_);
#line 4220 "../src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4207 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 4207 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 29450 "Photo.c"
}

void
photo_get_original_dimensions (Photo* self,
                               Dimensions* result)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
#line 4228 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4229 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4229 "../src/Photo.vala"
	dim = _tmp0_;
#line 4230 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4232 "../src/Photo.vala"
	_tmp1_ = dim;
#line 4232 "../src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp1_, &_tmp2_);
#line 4232 "../src/Photo.vala"
	*result = _tmp2_;
#line 4232 "../src/Photo.vala"
	return;
#line 29478 "Photo.c"
}

void
photo_get_master_dimensions (Photo* self,
                             Dimensions* result)
{
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 4236 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4237 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4237 "../src/Photo.vala"
	orientation_rotate_dimensions (photo_get_original_orientation (self), &_tmp0_, &_tmp1_);
#line 4237 "../src/Photo.vala"
	*result = _tmp1_;
#line 4237 "../src/Photo.vala"
	return;
#line 29497 "Photo.c"
}

gboolean
photo_get_crop (Photo* self,
                Box* crop,
                PhotoException exceptions)
{
	Box _vala_crop = {0};
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_;
	Dimensions dim = {0};
	Dimensions _tmp2_ = {0};
	Orientation orientation = 0;
	gboolean result = FALSE;
#line 4241 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4243 "../src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 4243 "../src/Photo.vala"
	raw = _tmp0_;
#line 4243 "../src/Photo.vala"
	if (!_tmp1_) {
#line 4244 "../src/Photo.vala"
		box_init (&_vala_crop, 0, 0, 0, 0);
#line 4246 "../src/Photo.vala"
		result = FALSE;
#line 4246 "../src/Photo.vala"
		if (crop) {
#line 4246 "../src/Photo.vala"
			*crop = _vala_crop;
#line 29529 "Photo.c"
		}
#line 4246 "../src/Photo.vala"
		return result;
#line 29533 "Photo.c"
	}
#line 4249 "../src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp2_);
#line 4249 "../src/Photo.vala"
	dim = _tmp2_;
#line 4250 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4252 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 29543 "Photo.c"
		Dimensions _tmp3_;
		Box _tmp4_;
		Box _tmp5_ = {0};
#line 4253 "../src/Photo.vala"
		_tmp3_ = dim;
#line 4253 "../src/Photo.vala"
		_tmp4_ = raw;
#line 4253 "../src/Photo.vala"
		orientation_rotate_box (orientation, &_tmp3_, &_tmp4_, &_tmp5_);
#line 4253 "../src/Photo.vala"
		_vala_crop = _tmp5_;
#line 29555 "Photo.c"
	} else {
		Box _tmp6_;
#line 4255 "../src/Photo.vala"
		_tmp6_ = raw;
#line 4255 "../src/Photo.vala"
		_vala_crop = _tmp6_;
#line 29562 "Photo.c"
	}
#line 4257 "../src/Photo.vala"
	result = TRUE;
#line 4257 "../src/Photo.vala"
	if (crop) {
#line 4257 "../src/Photo.vala"
		*crop = _vala_crop;
#line 29570 "Photo.c"
	}
#line 4257 "../src/Photo.vala"
	return result;
#line 29574 "Photo.c"
}

void
photo_set_crop (Photo* self,
                Box* crop)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Box derotated = {0};
	Dimensions _tmp1_;
	Box _tmp2_;
	Box _tmp3_ = {0};
	Box _tmp4_;
	Dimensions _tmp5_;
	Box _tmp6_;
	Box _tmp7_;
	Dimensions _tmp8_;
	Box _tmp9_;
	Dimensions _tmp10_;
	Box _tmp11_;
	Box _tmp12_;
	Dimensions _tmp13_;
	Box _tmp14_;
#line 4261 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4261 "../src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 4262 "../src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp0_);
#line 4262 "../src/Photo.vala"
	dim = _tmp0_;
#line 4263 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4265 "../src/Photo.vala"
	_tmp1_ = dim;
#line 4265 "../src/Photo.vala"
	_tmp2_ = *crop;
#line 4265 "../src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp1_, &_tmp2_, &_tmp3_);
#line 4265 "../src/Photo.vala"
	derotated = _tmp3_;
#line 4267 "../src/Photo.vala"
	_tmp4_ = derotated;
#line 4267 "../src/Photo.vala"
	_tmp5_ = dim;
#line 4267 "../src/Photo.vala"
	derotated.left = CLAMP (_tmp4_.left, 0, _tmp5_.width - 2);
#line 4268 "../src/Photo.vala"
	_tmp6_ = derotated;
#line 4268 "../src/Photo.vala"
	_tmp7_ = derotated;
#line 4268 "../src/Photo.vala"
	_tmp8_ = dim;
#line 4268 "../src/Photo.vala"
	derotated.right = CLAMP (_tmp6_.right, _tmp7_.left, _tmp8_.width - 1);
#line 4270 "../src/Photo.vala"
	_tmp9_ = derotated;
#line 4270 "../src/Photo.vala"
	_tmp10_ = dim;
#line 4270 "../src/Photo.vala"
	derotated.top = CLAMP (_tmp9_.top, 0, _tmp10_.height - 2);
#line 4271 "../src/Photo.vala"
	_tmp11_ = derotated;
#line 4271 "../src/Photo.vala"
	_tmp12_ = derotated;
#line 4271 "../src/Photo.vala"
	_tmp13_ = dim;
#line 4271 "../src/Photo.vala"
	derotated.bottom = CLAMP (_tmp11_.bottom, _tmp12_.top, _tmp13_.height - 1);
#line 4273 "../src/Photo.vala"
	_tmp14_ = derotated;
#line 4273 "../src/Photo.vala"
	photo_set_raw_crop (self, &_tmp14_);
#line 29649 "Photo.c"
}

gboolean
photo_get_straighten (Photo* self,
                      gdouble* theta)
{
	gdouble _vala_theta = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	gboolean result = FALSE;
#line 4276 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4277 "../src/Photo.vala"
	_tmp1_ = photo_get_raw_straighten (self, &_tmp0_);
#line 4277 "../src/Photo.vala"
	_vala_theta = _tmp0_;
#line 4277 "../src/Photo.vala"
	if (!_tmp1_) {
#line 4278 "../src/Photo.vala"
		result = FALSE;
#line 4278 "../src/Photo.vala"
		if (theta) {
#line 4278 "../src/Photo.vala"
			*theta = _vala_theta;
#line 29674 "Photo.c"
		}
#line 4278 "../src/Photo.vala"
		return result;
#line 29678 "Photo.c"
	}
#line 4280 "../src/Photo.vala"
	result = TRUE;
#line 4280 "../src/Photo.vala"
	if (theta) {
#line 4280 "../src/Photo.vala"
		*theta = _vala_theta;
#line 29686 "Photo.c"
	}
#line 4280 "../src/Photo.vala"
	return result;
#line 29690 "Photo.c"
}

void
photo_set_straighten (Photo* self,
                      gdouble theta)
{
#line 4283 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4284 "../src/Photo.vala"
	photo_set_raw_straighten (self, theta);
#line 29701 "Photo.c"
}

static GdkPixbuf*
photo_do_redeye (Photo* self,
                 GdkPixbuf* pixbuf,
                 EditingToolsRedeyeInstance* inst)
{
	gdouble r = 0.0;
	EditingToolsRedeyeInstance _tmp0_;
	gint* x_insets_first_quadrant = NULL;
	EditingToolsRedeyeInstance _tmp1_;
	gint* _tmp2_;
	gint x_insets_first_quadrant_length1;
	gint _x_insets_first_quadrant_size_;
	gint i = 0;
	gint x_bounds_min = 0;
	EditingToolsRedeyeInstance _tmp7_;
	GdkPoint _tmp8_;
	EditingToolsRedeyeInstance _tmp9_;
	gint x_bounds_max = 0;
	EditingToolsRedeyeInstance _tmp10_;
	GdkPoint _tmp11_;
	EditingToolsRedeyeInstance _tmp12_;
	gint ymin = 0;
	EditingToolsRedeyeInstance _tmp13_;
	GdkPoint _tmp14_;
	EditingToolsRedeyeInstance _tmp15_;
	gint _tmp16_ = 0;
	gint ymax = 0;
	EditingToolsRedeyeInstance _tmp17_;
	GdkPoint _tmp18_;
	gint _tmp19_ = 0;
	gint _tmp20_;
	gint _tmp21_;
	gint inset_index = 0;
	EditingToolsRedeyeInstance _tmp41_;
	GdkPoint _tmp42_;
	EditingToolsRedeyeInstance _tmp43_;
	GdkPoint _tmp44_;
	EditingToolsRedeyeInstance _tmp45_;
	gint* _tmp46_;
	gint _tmp46__length1;
	GdkPixbuf* _tmp64_;
	GdkPixbuf* result = NULL;
#line 4287 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4287 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()), NULL);
#line 4287 "../src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 4297 "../src/Photo.vala"
	_tmp0_ = *inst;
#line 4297 "../src/Photo.vala"
	r = (gdouble) _tmp0_.radius;
#line 4298 "../src/Photo.vala"
	_tmp1_ = *inst;
#line 4298 "../src/Photo.vala"
	_tmp2_ = g_new0 (gint, _tmp1_.radius + 1);
#line 4298 "../src/Photo.vala"
	x_insets_first_quadrant = _tmp2_;
#line 4298 "../src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp1_.radius + 1;
#line 4298 "../src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 4300 "../src/Photo.vala"
	i = 0;
#line 29768 "Photo.c"
	{
		gdouble y = 0.0;
#line 4301 "../src/Photo.vala"
		y = r;
#line 29773 "Photo.c"
		{
			gboolean _tmp3_ = FALSE;
#line 4301 "../src/Photo.vala"
			_tmp3_ = TRUE;
#line 4301 "../src/Photo.vala"
			while (TRUE) {
#line 29780 "Photo.c"
				gdouble theta = 0.0;
				gint x = 0;
				gint* _tmp4_;
				gint _tmp4__length1;
				EditingToolsRedeyeInstance _tmp5_;
				gint _tmp6_;
#line 4301 "../src/Photo.vala"
				if (!_tmp3_) {
#line 4301 "../src/Photo.vala"
					y -= 1.0;
#line 29791 "Photo.c"
				}
#line 4301 "../src/Photo.vala"
				_tmp3_ = FALSE;
#line 4301 "../src/Photo.vala"
				if (!(y >= 0.0)) {
#line 4301 "../src/Photo.vala"
					break;
#line 29799 "Photo.c"
				}
#line 4302 "../src/Photo.vala"
				theta = asin (y / r);
#line 4303 "../src/Photo.vala"
				x = (gint) ((r * cos (theta)) + 0.5);
#line 4304 "../src/Photo.vala"
				_tmp4_ = x_insets_first_quadrant;
#line 4304 "../src/Photo.vala"
				_tmp4__length1 = x_insets_first_quadrant_length1;
#line 4304 "../src/Photo.vala"
				_tmp5_ = *inst;
#line 4304 "../src/Photo.vala"
				_tmp4_[i] = _tmp5_.radius - x;
#line 4306 "../src/Photo.vala"
				_tmp6_ = i;
#line 4306 "../src/Photo.vala"
				i = _tmp6_ + 1;
#line 29817 "Photo.c"
			}
		}
	}
#line 4309 "../src/Photo.vala"
	_tmp7_ = *inst;
#line 4309 "../src/Photo.vala"
	_tmp8_ = _tmp7_.center;
#line 4309 "../src/Photo.vala"
	_tmp9_ = *inst;
#line 4309 "../src/Photo.vala"
	x_bounds_min = _tmp8_.x - _tmp9_.radius;
#line 4310 "../src/Photo.vala"
	_tmp10_ = *inst;
#line 4310 "../src/Photo.vala"
	_tmp11_ = _tmp10_.center;
#line 4310 "../src/Photo.vala"
	_tmp12_ = *inst;
#line 4310 "../src/Photo.vala"
	x_bounds_max = _tmp11_.x + _tmp12_.radius;
#line 4311 "../src/Photo.vala"
	_tmp13_ = *inst;
#line 4311 "../src/Photo.vala"
	_tmp14_ = _tmp13_.center;
#line 4311 "../src/Photo.vala"
	_tmp15_ = *inst;
#line 4311 "../src/Photo.vala"
	ymin = _tmp14_.y - _tmp15_.radius;
#line 4312 "../src/Photo.vala"
	if (ymin < 0) {
#line 4312 "../src/Photo.vala"
		_tmp16_ = 0;
#line 29849 "Photo.c"
	} else {
#line 4312 "../src/Photo.vala"
		_tmp16_ = ymin;
#line 29853 "Photo.c"
	}
#line 4312 "../src/Photo.vala"
	ymin = _tmp16_;
#line 4313 "../src/Photo.vala"
	_tmp17_ = *inst;
#line 4313 "../src/Photo.vala"
	_tmp18_ = _tmp17_.center;
#line 4313 "../src/Photo.vala"
	ymax = _tmp18_.y;
#line 4314 "../src/Photo.vala"
	_tmp20_ = gdk_pixbuf_get_height (pixbuf);
#line 4314 "../src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 4314 "../src/Photo.vala"
	if (ymax > (_tmp21_ - 1)) {
#line 29869 "Photo.c"
		gint _tmp22_;
		gint _tmp23_;
#line 4314 "../src/Photo.vala"
		_tmp22_ = gdk_pixbuf_get_height (pixbuf);
#line 4314 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 4314 "../src/Photo.vala"
		_tmp19_ = _tmp23_ - 1;
#line 29878 "Photo.c"
	} else {
#line 4314 "../src/Photo.vala"
		_tmp19_ = ymax;
#line 29882 "Photo.c"
	}
#line 4314 "../src/Photo.vala"
	ymax = _tmp19_;
#line 4318 "../src/Photo.vala"
	inset_index = 0;
#line 29888 "Photo.c"
	{
		gint y_it = 0;
#line 4319 "../src/Photo.vala"
		y_it = ymin;
#line 29893 "Photo.c"
		{
			gboolean _tmp24_ = FALSE;
#line 4319 "../src/Photo.vala"
			_tmp24_ = TRUE;
#line 4319 "../src/Photo.vala"
			while (TRUE) {
#line 29900 "Photo.c"
				gint xmin = 0;
				gint* _tmp26_;
				gint _tmp26__length1;
				gint _tmp27_;
				gint _tmp28_ = 0;
				gint xmax = 0;
				gint* _tmp29_;
				gint _tmp29__length1;
				gint _tmp30_;
				gint _tmp31_ = 0;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp40_;
#line 4319 "../src/Photo.vala"
				if (!_tmp24_) {
#line 29916 "Photo.c"
					gint _tmp25_;
#line 4319 "../src/Photo.vala"
					_tmp25_ = y_it;
#line 4319 "../src/Photo.vala"
					y_it = _tmp25_ + 1;
#line 29922 "Photo.c"
				}
#line 4319 "../src/Photo.vala"
				_tmp24_ = FALSE;
#line 4319 "../src/Photo.vala"
				if (!(y_it <= ymax)) {
#line 4319 "../src/Photo.vala"
					break;
#line 29930 "Photo.c"
				}
#line 4320 "../src/Photo.vala"
				_tmp26_ = x_insets_first_quadrant;
#line 4320 "../src/Photo.vala"
				_tmp26__length1 = x_insets_first_quadrant_length1;
#line 4320 "../src/Photo.vala"
				_tmp27_ = _tmp26_[inset_index];
#line 4320 "../src/Photo.vala"
				xmin = x_bounds_min + _tmp27_;
#line 4321 "../src/Photo.vala"
				if (xmin < 0) {
#line 4321 "../src/Photo.vala"
					_tmp28_ = 0;
#line 29944 "Photo.c"
				} else {
#line 4321 "../src/Photo.vala"
					_tmp28_ = xmin;
#line 29948 "Photo.c"
				}
#line 4321 "../src/Photo.vala"
				xmin = _tmp28_;
#line 4322 "../src/Photo.vala"
				_tmp29_ = x_insets_first_quadrant;
#line 4322 "../src/Photo.vala"
				_tmp29__length1 = x_insets_first_quadrant_length1;
#line 4322 "../src/Photo.vala"
				_tmp30_ = _tmp29_[inset_index];
#line 4322 "../src/Photo.vala"
				xmax = x_bounds_max - _tmp30_;
#line 4323 "../src/Photo.vala"
				_tmp32_ = gdk_pixbuf_get_width (pixbuf);
#line 4323 "../src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 4323 "../src/Photo.vala"
				if (xmax > (_tmp33_ - 1)) {
#line 29966 "Photo.c"
					gint _tmp34_;
					gint _tmp35_;
#line 4323 "../src/Photo.vala"
					_tmp34_ = gdk_pixbuf_get_width (pixbuf);
#line 4323 "../src/Photo.vala"
					_tmp35_ = _tmp34_;
#line 4323 "../src/Photo.vala"
					_tmp31_ = _tmp35_ - 1;
#line 29975 "Photo.c"
				} else {
#line 4323 "../src/Photo.vala"
					_tmp31_ = xmax;
#line 29979 "Photo.c"
				}
#line 4323 "../src/Photo.vala"
				xmax = _tmp31_;
#line 29983 "Photo.c"
				{
					gint x_it = 0;
#line 4325 "../src/Photo.vala"
					x_it = xmin;
#line 29988 "Photo.c"
					{
						gboolean _tmp36_ = FALSE;
#line 4325 "../src/Photo.vala"
						_tmp36_ = TRUE;
#line 4325 "../src/Photo.vala"
						while (TRUE) {
#line 29995 "Photo.c"
							GdkPixbuf* _tmp38_;
							GdkPixbuf* _tmp39_;
#line 4325 "../src/Photo.vala"
							if (!_tmp36_) {
#line 30000 "Photo.c"
								gint _tmp37_;
#line 4325 "../src/Photo.vala"
								_tmp37_ = x_it;
#line 4325 "../src/Photo.vala"
								x_it = _tmp37_ + 1;
#line 30006 "Photo.c"
							}
#line 4325 "../src/Photo.vala"
							_tmp36_ = FALSE;
#line 4325 "../src/Photo.vala"
							if (!(x_it <= xmax)) {
#line 4325 "../src/Photo.vala"
								break;
#line 30014 "Photo.c"
							}
#line 4326 "../src/Photo.vala"
							_tmp38_ = photo_red_reduce_pixel (self, pixbuf, x_it, y_it);
#line 4326 "../src/Photo.vala"
							_tmp39_ = _tmp38_;
#line 4326 "../src/Photo.vala"
							_g_object_unref0 (_tmp39_);
#line 30022 "Photo.c"
						}
					}
				}
#line 4328 "../src/Photo.vala"
				_tmp40_ = inset_index;
#line 4328 "../src/Photo.vala"
				inset_index = _tmp40_ + 1;
#line 30030 "Photo.c"
			}
		}
	}
#line 4333 "../src/Photo.vala"
	_tmp41_ = *inst;
#line 4333 "../src/Photo.vala"
	_tmp42_ = _tmp41_.center;
#line 4333 "../src/Photo.vala"
	ymin = _tmp42_.y;
#line 4334 "../src/Photo.vala"
	_tmp43_ = *inst;
#line 4334 "../src/Photo.vala"
	_tmp44_ = _tmp43_.center;
#line 4334 "../src/Photo.vala"
	_tmp45_ = *inst;
#line 4334 "../src/Photo.vala"
	ymax = _tmp44_.y + _tmp45_.radius;
#line 4335 "../src/Photo.vala"
	_tmp46_ = x_insets_first_quadrant;
#line 4335 "../src/Photo.vala"
	_tmp46__length1 = x_insets_first_quadrant_length1;
#line 4335 "../src/Photo.vala"
	inset_index = _tmp46__length1 - 1;
#line 30054 "Photo.c"
	{
		gint y_it = 0;
#line 4336 "../src/Photo.vala"
		y_it = ymin;
#line 30059 "Photo.c"
		{
			gboolean _tmp47_ = FALSE;
#line 4336 "../src/Photo.vala"
			_tmp47_ = TRUE;
#line 4336 "../src/Photo.vala"
			while (TRUE) {
#line 30066 "Photo.c"
				gint xmin = 0;
				gint* _tmp49_;
				gint _tmp49__length1;
				gint _tmp50_;
				gint _tmp51_ = 0;
				gint xmax = 0;
				gint* _tmp52_;
				gint _tmp52__length1;
				gint _tmp53_;
				gint _tmp54_ = 0;
				gint _tmp55_;
				gint _tmp56_;
				gint _tmp63_;
#line 4336 "../src/Photo.vala"
				if (!_tmp47_) {
#line 30082 "Photo.c"
					gint _tmp48_;
#line 4336 "../src/Photo.vala"
					_tmp48_ = y_it;
#line 4336 "../src/Photo.vala"
					y_it = _tmp48_ + 1;
#line 30088 "Photo.c"
				}
#line 4336 "../src/Photo.vala"
				_tmp47_ = FALSE;
#line 4336 "../src/Photo.vala"
				if (!(y_it <= ymax)) {
#line 4336 "../src/Photo.vala"
					break;
#line 30096 "Photo.c"
				}
#line 4337 "../src/Photo.vala"
				_tmp49_ = x_insets_first_quadrant;
#line 4337 "../src/Photo.vala"
				_tmp49__length1 = x_insets_first_quadrant_length1;
#line 4337 "../src/Photo.vala"
				_tmp50_ = _tmp49_[inset_index];
#line 4337 "../src/Photo.vala"
				xmin = x_bounds_min + _tmp50_;
#line 4338 "../src/Photo.vala"
				if (xmin < 0) {
#line 4338 "../src/Photo.vala"
					_tmp51_ = 0;
#line 30110 "Photo.c"
				} else {
#line 4338 "../src/Photo.vala"
					_tmp51_ = xmin;
#line 30114 "Photo.c"
				}
#line 4338 "../src/Photo.vala"
				xmin = _tmp51_;
#line 4339 "../src/Photo.vala"
				_tmp52_ = x_insets_first_quadrant;
#line 4339 "../src/Photo.vala"
				_tmp52__length1 = x_insets_first_quadrant_length1;
#line 4339 "../src/Photo.vala"
				_tmp53_ = _tmp52_[inset_index];
#line 4339 "../src/Photo.vala"
				xmax = x_bounds_max - _tmp53_;
#line 4340 "../src/Photo.vala"
				_tmp55_ = gdk_pixbuf_get_width (pixbuf);
#line 4340 "../src/Photo.vala"
				_tmp56_ = _tmp55_;
#line 4340 "../src/Photo.vala"
				if (xmax > (_tmp56_ - 1)) {
#line 30132 "Photo.c"
					gint _tmp57_;
					gint _tmp58_;
#line 4340 "../src/Photo.vala"
					_tmp57_ = gdk_pixbuf_get_width (pixbuf);
#line 4340 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 4340 "../src/Photo.vala"
					_tmp54_ = _tmp58_ - 1;
#line 30141 "Photo.c"
				} else {
#line 4340 "../src/Photo.vala"
					_tmp54_ = xmax;
#line 30145 "Photo.c"
				}
#line 4340 "../src/Photo.vala"
				xmax = _tmp54_;
#line 30149 "Photo.c"
				{
					gint x_it = 0;
#line 4342 "../src/Photo.vala"
					x_it = xmin;
#line 30154 "Photo.c"
					{
						gboolean _tmp59_ = FALSE;
#line 4342 "../src/Photo.vala"
						_tmp59_ = TRUE;
#line 4342 "../src/Photo.vala"
						while (TRUE) {
#line 30161 "Photo.c"
							GdkPixbuf* _tmp61_;
							GdkPixbuf* _tmp62_;
#line 4342 "../src/Photo.vala"
							if (!_tmp59_) {
#line 30166 "Photo.c"
								gint _tmp60_;
#line 4342 "../src/Photo.vala"
								_tmp60_ = x_it;
#line 4342 "../src/Photo.vala"
								x_it = _tmp60_ + 1;
#line 30172 "Photo.c"
							}
#line 4342 "../src/Photo.vala"
							_tmp59_ = FALSE;
#line 4342 "../src/Photo.vala"
							if (!(x_it <= xmax)) {
#line 4342 "../src/Photo.vala"
								break;
#line 30180 "Photo.c"
							}
#line 4343 "../src/Photo.vala"
							_tmp61_ = photo_red_reduce_pixel (self, pixbuf, x_it, y_it);
#line 4343 "../src/Photo.vala"
							_tmp62_ = _tmp61_;
#line 4343 "../src/Photo.vala"
							_g_object_unref0 (_tmp62_);
#line 30188 "Photo.c"
						}
					}
				}
#line 4345 "../src/Photo.vala"
				_tmp63_ = inset_index;
#line 4345 "../src/Photo.vala"
				inset_index = _tmp63_ - 1;
#line 30196 "Photo.c"
			}
		}
	}
#line 4348 "../src/Photo.vala"
	_tmp64_ = _g_object_ref0 (pixbuf);
#line 4348 "../src/Photo.vala"
	result = _tmp64_;
#line 4348 "../src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 4348 "../src/Photo.vala"
	return result;
#line 30208 "Photo.c"
}

static GdkPixbuf*
photo_red_reduce_pixel (Photo* self,
                        GdkPixbuf* pixbuf,
                        gint x,
                        gint y)
{
	gint px_start_byte_offset = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp13_;
	GdkPixbuf* result = NULL;
#line 4351 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4351 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()), NULL);
#line 4352 "../src/Photo.vala"
	px_start_byte_offset = (y * gdk_pixbuf_get_rowstride (pixbuf)) + (x * gdk_pixbuf_get_n_channels (pixbuf));
#line 4359 "../src/Photo.vala"
	if (x >= 0) {
#line 4359 "../src/Photo.vala"
		_tmp2_ = y >= 0;
#line 30233 "Photo.c"
	} else {
#line 4359 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 30237 "Photo.c"
	}
#line 4359 "../src/Photo.vala"
	if (_tmp2_) {
#line 30241 "Photo.c"
		gint _tmp3_;
		gint _tmp4_;
#line 4359 "../src/Photo.vala"
		_tmp3_ = gdk_pixbuf_get_width (pixbuf);
#line 4359 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4359 "../src/Photo.vala"
		_tmp1_ = x < _tmp4_;
#line 30250 "Photo.c"
	} else {
#line 4359 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 30254 "Photo.c"
	}
#line 4359 "../src/Photo.vala"
	if (_tmp1_) {
#line 30258 "Photo.c"
		gint _tmp5_;
		gint _tmp6_;
#line 4359 "../src/Photo.vala"
		_tmp5_ = gdk_pixbuf_get_height (pixbuf);
#line 4359 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4359 "../src/Photo.vala"
		_tmp0_ = y < _tmp6_;
#line 30267 "Photo.c"
	} else {
#line 4359 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 30271 "Photo.c"
	}
#line 4359 "../src/Photo.vala"
	if (_tmp0_) {
#line 30275 "Photo.c"
		guchar* pixel_data = NULL;
		guint8* _tmp7_;
		gint pixel_data_length1;
		gint _pixel_data_size_;
		guchar g = '\0';
		guchar* _tmp8_;
		gint _tmp8__length1;
		guchar _tmp9_;
		guchar b = '\0';
		guchar* _tmp10_;
		gint _tmp10__length1;
		guchar _tmp11_;
		guchar r = '\0';
		guchar* _tmp12_;
		gint _tmp12__length1;
#line 4360 "../src/Photo.vala"
		_tmp7_ = gdk_pixbuf_get_pixels (pixbuf);
#line 4360 "../src/Photo.vala"
		pixel_data = _tmp7_;
#line 4360 "../src/Photo.vala"
		pixel_data_length1 = -1;
#line 4360 "../src/Photo.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 4370 "../src/Photo.vala"
		_tmp8_ = pixel_data;
#line 4370 "../src/Photo.vala"
		_tmp8__length1 = pixel_data_length1;
#line 4370 "../src/Photo.vala"
		_tmp9_ = _tmp8_[px_start_byte_offset + 1];
#line 4370 "../src/Photo.vala"
		g = _tmp9_;
#line 4371 "../src/Photo.vala"
		_tmp10_ = pixel_data;
#line 4371 "../src/Photo.vala"
		_tmp10__length1 = pixel_data_length1;
#line 4371 "../src/Photo.vala"
		_tmp11_ = _tmp10_[px_start_byte_offset + 2];
#line 4371 "../src/Photo.vala"
		b = _tmp11_;
#line 4373 "../src/Photo.vala"
		r = (guchar) ((g + b) / 2);
#line 4375 "../src/Photo.vala"
		_tmp12_ = pixel_data;
#line 4375 "../src/Photo.vala"
		_tmp12__length1 = pixel_data_length1;
#line 4375 "../src/Photo.vala"
		_tmp12_[px_start_byte_offset] = r;
#line 30323 "Photo.c"
	}
#line 4378 "../src/Photo.vala"
	_tmp13_ = _g_object_ref0 (pixbuf);
#line 4378 "../src/Photo.vala"
	result = _tmp13_;
#line 4378 "../src/Photo.vala"
	return result;
#line 30331 "Photo.c"
}

void
photo_unscaled_to_raw_point (Photo* self,
                             GdkPoint* unscaled_point,
                             GdkPoint* result)
{
	Orientation unscaled_orientation = 0;
	Dimensions unscaled_dims = {0};
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	gint unscaled_x_offset_raw = 0;
	gint unscaled_y_offset_raw = 0;
	Box crop_box = {0};
	Box _tmp2_ = {0};
	gboolean _tmp3_;
	GdkPoint derotated_point = {0};
	Dimensions _tmp6_;
	GdkPoint _tmp7_;
	GdkPoint _tmp8_ = {0};
#line 4381 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4381 "../src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 4382 "../src/Photo.vala"
	unscaled_orientation = photo_get_orientation (self);
#line 4384 "../src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp0_);
#line 4384 "../src/Photo.vala"
	orientation_rotate_dimensions (unscaled_orientation, &_tmp0_, &_tmp1_);
#line 4384 "../src/Photo.vala"
	unscaled_dims = _tmp1_;
#line 4387 "../src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 4388 "../src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 4391 "../src/Photo.vala"
	_tmp3_ = photo_get_raw_crop (self, &_tmp2_);
#line 4391 "../src/Photo.vala"
	crop_box = _tmp2_;
#line 4391 "../src/Photo.vala"
	if (_tmp3_) {
#line 30374 "Photo.c"
		Box _tmp4_;
		Box _tmp5_;
#line 4392 "../src/Photo.vala"
		_tmp4_ = crop_box;
#line 4392 "../src/Photo.vala"
		unscaled_x_offset_raw = _tmp4_.left;
#line 4393 "../src/Photo.vala"
		_tmp5_ = crop_box;
#line 4393 "../src/Photo.vala"
		unscaled_y_offset_raw = _tmp5_.top;
#line 30385 "Photo.c"
	}
#line 4396 "../src/Photo.vala"
	_tmp6_ = unscaled_dims;
#line 4396 "../src/Photo.vala"
	_tmp7_ = *unscaled_point;
#line 4396 "../src/Photo.vala"
	orientation_derotate_point (unscaled_orientation, &_tmp6_, &_tmp7_, &_tmp8_);
#line 4396 "../src/Photo.vala"
	derotated_point = _tmp8_;
#line 4400 "../src/Photo.vala"
	derotated_point.x = derotated_point.x + unscaled_x_offset_raw;
#line 4401 "../src/Photo.vala"
	derotated_point.y = derotated_point.y + unscaled_y_offset_raw;
#line 4403 "../src/Photo.vala"
	*result = derotated_point;
#line 4403 "../src/Photo.vala"
	return;
#line 30403 "Photo.c"
}

void
photo_unscaled_to_raw_rect (Photo* self,
                            GdkRectangle* unscaled_rect,
                            GdkRectangle* result)
{
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkPoint _tmp4_;
	GdkRectangle _tmp5_;
	GdkPoint _tmp6_;
	GdkRectangle _tmp7_;
	GdkPoint _tmp8_;
	GdkPoint _tmp9_ = {0};
	GdkPoint _tmp10_;
	GdkPoint _tmp11_ = {0};
	GdkPoint _tmp12_;
	GdkPoint _tmp13_;
	GdkPoint _tmp16_;
	GdkPoint _tmp17_;
	GdkRectangle raw_rect = {0};
	GdkPoint _tmp20_;
	GdkPoint _tmp21_;
	GdkPoint _tmp22_;
	GdkPoint _tmp23_;
	GdkPoint _tmp24_;
	GdkPoint _tmp25_;
#line 4406 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4406 "../src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 4407 "../src/Photo.vala"
	_tmp0_.x = 0;
#line 4407 "../src/Photo.vala"
	upper_left = _tmp0_;
#line 4408 "../src/Photo.vala"
	_tmp1_.x = 0;
#line 4408 "../src/Photo.vala"
	lower_right = _tmp1_;
#line 4409 "../src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 4409 "../src/Photo.vala"
	upper_left.x = _tmp2_.x;
#line 4410 "../src/Photo.vala"
	_tmp3_ = *unscaled_rect;
#line 4410 "../src/Photo.vala"
	upper_left.y = _tmp3_.y;
#line 4411 "../src/Photo.vala"
	_tmp4_ = upper_left;
#line 4411 "../src/Photo.vala"
	_tmp5_ = *unscaled_rect;
#line 4411 "../src/Photo.vala"
	lower_right.x = _tmp4_.x + _tmp5_.width;
#line 4412 "../src/Photo.vala"
	_tmp6_ = upper_left;
#line 4412 "../src/Photo.vala"
	_tmp7_ = *unscaled_rect;
#line 4412 "../src/Photo.vala"
	lower_right.y = _tmp6_.y + _tmp7_.height;
#line 4414 "../src/Photo.vala"
	_tmp8_ = upper_left;
#line 4414 "../src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp8_, &_tmp9_);
#line 4414 "../src/Photo.vala"
	upper_left = _tmp9_;
#line 4415 "../src/Photo.vala"
	_tmp10_ = lower_right;
#line 4415 "../src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp10_, &_tmp11_);
#line 4415 "../src/Photo.vala"
	lower_right = _tmp11_;
#line 4417 "../src/Photo.vala"
	_tmp12_ = upper_left;
#line 4417 "../src/Photo.vala"
	_tmp13_ = lower_right;
#line 4417 "../src/Photo.vala"
	if (_tmp12_.x > _tmp13_.x) {
#line 30486 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp14_;
		GdkPoint _tmp15_;
#line 4418 "../src/Photo.vala"
		_tmp14_ = upper_left;
#line 4418 "../src/Photo.vala"
		temp = _tmp14_.x;
#line 4419 "../src/Photo.vala"
		_tmp15_ = lower_right;
#line 4419 "../src/Photo.vala"
		upper_left.x = _tmp15_.x;
#line 4420 "../src/Photo.vala"
		lower_right.x = temp;
#line 30500 "Photo.c"
	}
#line 4422 "../src/Photo.vala"
	_tmp16_ = upper_left;
#line 4422 "../src/Photo.vala"
	_tmp17_ = lower_right;
#line 4422 "../src/Photo.vala"
	if (_tmp16_.y > _tmp17_.y) {
#line 30508 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp18_;
		GdkPoint _tmp19_;
#line 4423 "../src/Photo.vala"
		_tmp18_ = upper_left;
#line 4423 "../src/Photo.vala"
		temp = _tmp18_.y;
#line 4424 "../src/Photo.vala"
		_tmp19_ = lower_right;
#line 4424 "../src/Photo.vala"
		upper_left.y = _tmp19_.y;
#line 4425 "../src/Photo.vala"
		lower_right.y = temp;
#line 30522 "Photo.c"
	}
#line 4428 "../src/Photo.vala"
	memset (&raw_rect, 0, sizeof (GdkRectangle));
#line 4429 "../src/Photo.vala"
	_tmp20_ = upper_left;
#line 4429 "../src/Photo.vala"
	raw_rect.x = _tmp20_.x;
#line 4430 "../src/Photo.vala"
	_tmp21_ = upper_left;
#line 4430 "../src/Photo.vala"
	raw_rect.y = _tmp21_.y;
#line 4431 "../src/Photo.vala"
	_tmp22_ = lower_right;
#line 4431 "../src/Photo.vala"
	_tmp23_ = upper_left;
#line 4431 "../src/Photo.vala"
	raw_rect.width = _tmp22_.x - _tmp23_.x;
#line 4432 "../src/Photo.vala"
	_tmp24_ = lower_right;
#line 4432 "../src/Photo.vala"
	_tmp25_ = upper_left;
#line 4432 "../src/Photo.vala"
	raw_rect.height = _tmp24_.y - _tmp25_.y;
#line 4434 "../src/Photo.vala"
	*result = raw_rect;
#line 4434 "../src/Photo.vala"
	return;
#line 30550 "Photo.c"
}

PixelTransformationBundle*
photo_get_enhance_transformations (Photo* self)
{
	GdkPixbuf* pixbuf = NULL;
	PixelTransformationBundle* transformations = NULL;
	GdkPixbuf* _tmp4_;
	PixelTransformationBundle* _tmp5_;
	GError* _inner_error0_ = NULL;
	PixelTransformationBundle* result = NULL;
#line 4437 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4438 "../src/Photo.vala"
	pixbuf = NULL;
#line 30566 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		Scaling _tmp1_ = {0};
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 4445 "../src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp1_);
#line 4445 "../src/Photo.vala"
		_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 4445 "../src/Photo.vala"
		_tmp0_ = _tmp2_;
#line 4445 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 30580 "Photo.c"
			goto __catch0_g_error;
		}
#line 4445 "../src/Photo.vala"
		_tmp3_ = _tmp0_;
#line 4445 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 4445 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4445 "../src/Photo.vala"
		pixbuf = _tmp3_;
#line 4444 "../src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 30593 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 4444 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4452 "../src/Photo.vala"
		g_warning ("Photo.vala:4452: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 4454 "../src/Photo.vala"
		result = NULL;
#line 4454 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4454 "../src/Photo.vala"
		return result;
#line 30608 "Photo.c"
	}
	__finally0:
#line 4444 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4444 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4444 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4444 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4444 "../src/Photo.vala"
		return NULL;
#line 30621 "Photo.c"
	}
#line 4461 "../src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4461 "../src/Photo.vala"
	_tmp5_ = auto_enhance_create_auto_enhance_adjustments (_tmp4_);
#line 4461 "../src/Photo.vala"
	transformations = _tmp5_;
#line 4469 "../src/Photo.vala"
	result = transformations;
#line 4469 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4469 "../src/Photo.vala"
	return result;
#line 30635 "Photo.c"
}

gboolean
photo_enhance (Photo* self)
{
	PixelTransformationBundle* transformations = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 4472 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4473 "../src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 4473 "../src/Photo.vala"
	transformations = _tmp0_;
#line 4475 "../src/Photo.vala"
	_tmp1_ = transformations;
#line 4475 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4476 "../src/Photo.vala"
		result = FALSE;
#line 4476 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 4476 "../src/Photo.vala"
		return result;
#line 30662 "Photo.c"
	}
	{
		PhotoRow* _tmp2_;
#line 4481 "../src/Photo.vala"
		_tmp2_ = self->row;
#line 4481 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 30670 "Photo.c"
		{
			PixelTransformationBundle* _tmp3_;
#line 4482 "../src/Photo.vala"
			_tmp3_ = transformations;
#line 4482 "../src/Photo.vala"
			photo_set_color_adjustments (self, _tmp3_);
#line 30677 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 4481 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 4481 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 30686 "Photo.c"
		}
#line 4481 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 30690 "Photo.c"
			gboolean _tmp5_ = FALSE;
#line 4481 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 4481 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4481 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4481 "../src/Photo.vala"
			return _tmp5_;
#line 30700 "Photo.c"
		}
	}
#line 4489 "../src/Photo.vala"
	result = TRUE;
#line 4489 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 4489 "../src/Photo.vala"
	return result;
#line 30709 "Photo.c"
}

gboolean
photo_get_develop_raw_photos_to_files (void)
{
	gboolean result;
#line 346 "../src/Photo.vala"
	result = photo__develop_raw_photos_to_files;
#line 346 "../src/Photo.vala"
	return result;
#line 30720 "Photo.c"
}

void
photo_set_develop_raw_photos_to_files (gboolean value)
{
#line 346 "../src/Photo.vala"
	photo__develop_raw_photos_to_files = value;
#line 30728 "Photo.c"
}

static void
photo_real_editable_replaced (Photo* self,
                              GFile* old_file,
                              GFile* new_file)
{
#line 355 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 355 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 30740 "Photo.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 158 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 158 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 158 "../src/Photo.vala"
		data1 = closure->data;
#line 158 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 30765 "Photo.c"
	} else {
#line 158 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 158 "../src/Photo.vala"
		data2 = closure->data;
#line 30771 "Photo.c"
	}
#line 158 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 158 "../src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 30777 "Photo.c"
}

static void
photo_real_raw_development_modified (Photo* self)
{
}

static void
photo_real_baseline_replaced (Photo* self)
{
}

static void
photo_real_master_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
#line 373 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 30796 "Photo.c"
}

static void
g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 158 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 158 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 158 "../src/Photo.vala"
		data1 = closure->data;
#line 158 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 30821 "Photo.c"
	} else {
#line 158 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 158 "../src/Photo.vala"
		data2 = closure->data;
#line 30827 "Photo.c"
	}
#line 158 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 158 "../src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 30833 "Photo.c"
}

static void
photo_real_editable_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 377 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 30842 "Photo.c"
}

static void
photo_real_baseline_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 384 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 30851 "Photo.c"
}

static void
photo_real_source_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
#line 391 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 30860 "Photo.c"
}

static inline gpointer
photo_photo_transformation_state_impl_get_instance_private (PhotoPhotoTransformationStateImpl* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoPhotoTransformationStateImpl_private_offset);
}

static void
_photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                           gpointer self)
{
#line 254 "../src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced ((PhotoPhotoTransformationStateImpl*) self);
#line 30875 "Photo.c"
}

static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_construct (GType object_type,
                                                 Photo* photo,
                                                 Orientation orientation,
                                                 GeeHashMap* transformations,
                                                 PixelTransformer* transformer,
                                                 PixelTransformationBundle* adjustments)
{
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_;
	GeeHashMap* _tmp1_;
	PixelTransformer* _tmp2_;
	PixelTransformationBundle* _tmp3_;
#line 241 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 241 "../src/Photo.vala"
	g_return_val_if_fail ((transformations == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformations, GEE_TYPE_HASH_MAP), NULL);
#line 241 "../src/Photo.vala"
	g_return_val_if_fail ((transformer == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformer, TYPE_PIXEL_TRANSFORMER), NULL);
#line 241 "../src/Photo.vala"
	g_return_val_if_fail ((adjustments == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (adjustments, TYPE_PIXEL_TRANSFORMATION_BUNDLE), NULL);
#line 241 "../src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 244 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 244 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 244 "../src/Photo.vala"
	self->priv->photo = _tmp0_;
#line 245 "../src/Photo.vala"
	self->priv->orientation = orientation;
#line 246 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (transformations);
#line 246 "../src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 246 "../src/Photo.vala"
	self->priv->transformations = _tmp1_;
#line 247 "../src/Photo.vala"
	_tmp2_ = _pixel_transformer_ref0 (transformer);
#line 247 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 247 "../src/Photo.vala"
	self->priv->transformer = _tmp2_;
#line 248 "../src/Photo.vala"
	_tmp3_ = _pixel_transformation_bundle_ref0 (adjustments);
#line 248 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 248 "../src/Photo.vala"
	self->priv->adjustments = _tmp3_;
#line 250 "../src/Photo.vala"
	g_signal_connect_object (photo, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 241 "../src/Photo.vala"
	return self;
#line 30931 "Photo.c"
}

static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_new (Photo* photo,
                                           Orientation orientation,
                                           GeeHashMap* transformations,
                                           PixelTransformer* transformer,
                                           PixelTransformationBundle* adjustments)
{
#line 241 "../src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments);
#line 30943 "Photo.c"
}

static Orientation
photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self)
{
	Orientation result = 0;
#line 257 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), 0);
#line 258 "../src/Photo.vala"
	result = self->priv->orientation;
#line 258 "../src/Photo.vala"
	return result;
#line 30956 "Photo.c"
}

static GeeHashMap*
photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* result = NULL;
#line 261 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 262 "../src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 262 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 262 "../src/Photo.vala"
	result = _tmp1_;
#line 262 "../src/Photo.vala"
	return result;
#line 30975 "Photo.c"
}

static PixelTransformer*
photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_;
	PixelTransformer* result = NULL;
#line 265 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 266 "../src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 266 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 30990 "Photo.c"
		PixelTransformer* _tmp2_;
		PixelTransformer* _tmp3_;
#line 266 "../src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 266 "../src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 266 "../src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 266 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31001 "Photo.c"
	} else {
#line 266 "../src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 266 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 31007 "Photo.c"
	}
#line 266 "../src/Photo.vala"
	result = _tmp0_;
#line 266 "../src/Photo.vala"
	return result;
#line 31013 "Photo.c"
}

static PixelTransformationBundle*
photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
	PixelTransformationBundle* result = NULL;
#line 269 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 270 "../src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 270 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 31028 "Photo.c"
		PixelTransformationBundle* _tmp2_;
		PixelTransformationBundle* _tmp3_;
#line 270 "../src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 270 "../src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 270 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 270 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31039 "Photo.c"
	} else {
#line 270 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 270 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 31045 "Photo.c"
	}
#line 270 "../src/Photo.vala"
	result = _tmp0_;
#line 270 "../src/Photo.vala"
	return result;
#line 31051 "Photo.c"
}

static GeeHashMap*
photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original)
{
	GeeHashMap* clone = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* result = NULL;
#line 273 "../src/Photo.vala"
	g_return_val_if_fail ((original == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (original, GEE_TYPE_HASH_MAP), NULL);
#line 275 "../src/Photo.vala"
	if (original == NULL) {
#line 276 "../src/Photo.vala"
		result = NULL;
#line 276 "../src/Photo.vala"
		return result;
#line 31068 "Photo.c"
	}
#line 278 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 278 "../src/Photo.vala"
	clone = _tmp0_;
#line 31074 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 279 "../src/Photo.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (original, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 279 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 279 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 279 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 279 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 279 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 279 "../src/Photo.vala"
		_object_it = _tmp5_;
#line 279 "../src/Photo.vala"
		while (TRUE) {
#line 31098 "Photo.c"
			GeeIterator* _tmp6_;
			gchar* object = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeHashMap* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gpointer _tmp12_;
			KeyValueMap* _tmp13_;
			KeyValueMap* _tmp14_;
			KeyValueMap* _tmp15_;
#line 279 "../src/Photo.vala"
			_tmp6_ = _object_it;
#line 279 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 279 "../src/Photo.vala"
				break;
#line 31116 "Photo.c"
			}
#line 279 "../src/Photo.vala"
			_tmp7_ = _object_it;
#line 279 "../src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 279 "../src/Photo.vala"
			object = (gchar*) _tmp8_;
#line 280 "../src/Photo.vala"
			_tmp9_ = clone;
#line 280 "../src/Photo.vala"
			_tmp10_ = object;
#line 280 "../src/Photo.vala"
			_tmp11_ = object;
#line 280 "../src/Photo.vala"
			_tmp12_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (original, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp11_);
#line 280 "../src/Photo.vala"
			_tmp13_ = (KeyValueMap*) _tmp12_;
#line 280 "../src/Photo.vala"
			_tmp14_ = key_value_map_copy (_tmp13_);
#line 280 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 280 "../src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp10_, _tmp15_);
#line 280 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp15_);
#line 280 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp13_);
#line 279 "../src/Photo.vala"
			_g_free0 (object);
#line 31146 "Photo.c"
		}
#line 279 "../src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 31150 "Photo.c"
	}
#line 282 "../src/Photo.vala"
	result = clone;
#line 282 "../src/Photo.vala"
	return result;
#line 31156 "Photo.c"
}

static void
photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self)
{
#line 285 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self));
#line 286 "../src/Photo.vala"
	if (!photo_transformation_state_is_broken (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))) {
#line 287 "../src/Photo.vala"
		g_signal_emit (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState), photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL], 0);
#line 31168 "Photo.c"
	}
}

static void
photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass,
                                                  gpointer klass_data)
{
#line 234 "../src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 234 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &PhotoPhotoTransformationStateImpl_private_offset);
#line 234 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 31182 "Photo.c"
}

static void
photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self,
                                                     gpointer klass)
{
#line 234 "../src/Photo.vala"
	self->priv = photo_photo_transformation_state_impl_get_instance_private (self);
#line 31191 "Photo.c"
}

static void
photo_photo_transformation_state_impl_finalize (GObject * obj)
{
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_;
	guint _tmp1_;
#line 234 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl);
#line 254 "../src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 254 "../src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 254 "../src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 235 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 237 "../src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 238 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 239 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 234 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 31218 "Photo.c"
}

static GType
photo_photo_transformation_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
	GType photo_photo_transformation_state_impl_type_id;
	photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
	PhotoPhotoTransformationStateImpl_private_offset = g_type_add_instance_private (photo_photo_transformation_state_impl_type_id, sizeof (PhotoPhotoTransformationStateImplPrivate));
	return photo_photo_transformation_state_impl_type_id;
}

static GType
photo_photo_transformation_state_impl_get_type (void)
{
	static volatile gsize photo_photo_transformation_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__volatile)) {
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = photo_photo_transformation_state_impl_get_type_once ();
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__volatile, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__volatile;
}

static PhotoBackingReaders*
photo_backing_readers_construct (GType object_type)
{
	PhotoBackingReaders* self = NULL;
#line 291 "../src/Photo.vala"
	self = (PhotoBackingReaders*) g_type_create_instance (object_type);
#line 291 "../src/Photo.vala"
	return self;
#line 31251 "Photo.c"
}

static PhotoBackingReaders*
photo_backing_readers_new (void)
{
#line 291 "../src/Photo.vala"
	return photo_backing_readers_construct (PHOTO_TYPE_BACKING_READERS);
#line 31259 "Photo.c"
}

static void
photo_value_backing_readers_init (GValue* value)
{
#line 291 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31267 "Photo.c"
}

static void
photo_value_backing_readers_free_value (GValue* value)
{
#line 291 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 291 "../src/Photo.vala"
		photo_backing_readers_unref (value->data[0].v_pointer);
#line 31277 "Photo.c"
	}
}

static void
photo_value_backing_readers_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 291 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 291 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_backing_readers_ref (src_value->data[0].v_pointer);
#line 31289 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31293 "Photo.c"
	}
}

static gpointer
photo_value_backing_readers_peek_pointer (const GValue* value)
{
#line 291 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31302 "Photo.c"
}

static gchar*
photo_value_backing_readers_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 291 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31313 "Photo.c"
		PhotoBackingReaders * object;
		object = collect_values[0].v_pointer;
#line 291 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 291 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31320 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 291 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31324 "Photo.c"
		}
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = photo_backing_readers_ref (object);
#line 31328 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31332 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	return NULL;
#line 31336 "Photo.c"
}

static gchar*
photo_value_backing_readers_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	PhotoBackingReaders ** object_p;
	object_p = collect_values[0].v_pointer;
#line 291 "../src/Photo.vala"
	if (!object_p) {
#line 291 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31351 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 291 "../src/Photo.vala"
		*object_p = NULL;
#line 31357 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 291 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31361 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		*object_p = photo_backing_readers_ref (value->data[0].v_pointer);
#line 31365 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	return NULL;
#line 31369 "Photo.c"
}

static GParamSpec*
photo_param_spec_backing_readers (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	PhotoParamSpecBackingReaders* spec;
#line 291 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_BACKING_READERS), NULL);
#line 291 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 291 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 291 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 31388 "Photo.c"
}

static gpointer
photo_value_get_backing_readers (const GValue* value)
{
#line 291 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS), NULL);
#line 291 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31398 "Photo.c"
}

static void
photo_value_set_backing_readers (GValue* value,
                                 gpointer v_object)
{
	PhotoBackingReaders * old;
#line 291 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 291 "../src/Photo.vala"
	if (v_object) {
#line 291 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 291 "../src/Photo.vala"
		photo_backing_readers_ref (value->data[0].v_pointer);
#line 31420 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31424 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	if (old) {
#line 291 "../src/Photo.vala"
		photo_backing_readers_unref (old);
#line 31430 "Photo.c"
	}
}

static void
photo_value_take_backing_readers (GValue* value,
                                  gpointer v_object)
{
	PhotoBackingReaders * old;
#line 291 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 291 "../src/Photo.vala"
	if (v_object) {
#line 291 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 31451 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31455 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	if (old) {
#line 291 "../src/Photo.vala"
		photo_backing_readers_unref (old);
#line 31461 "Photo.c"
	}
}

static void
photo_backing_readers_class_init (PhotoBackingReadersClass * klass,
                                  gpointer klass_data)
{
#line 291 "../src/Photo.vala"
	photo_backing_readers_parent_class = g_type_class_peek_parent (klass);
#line 291 "../src/Photo.vala"
	((PhotoBackingReadersClass *) klass)->finalize = photo_backing_readers_finalize;
#line 31473 "Photo.c"
}

static void
photo_backing_readers_instance_init (PhotoBackingReaders * self,
                                     gpointer klass)
{
#line 291 "../src/Photo.vala"
	self->ref_count = 1;
#line 31482 "Photo.c"
}

static void
photo_backing_readers_finalize (PhotoBackingReaders * obj)
{
	PhotoBackingReaders * self;
#line 291 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders);
#line 291 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 292 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->master);
#line 293 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->developer);
#line 294 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->editable);
#line 31499 "Photo.c"
}

static GType
photo_backing_readers_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_backing_readers_init, photo_value_backing_readers_free_value, photo_value_backing_readers_copy_value, photo_value_backing_readers_peek_pointer, "p", photo_value_backing_readers_collect_value, "p", photo_value_backing_readers_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoBackingReadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_backing_readers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoBackingReaders), 0, (GInstanceInitFunc) photo_backing_readers_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_backing_readers_type_id;
	photo_backing_readers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoBackingReaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_backing_readers_type_id;
}

static GType
photo_backing_readers_get_type (void)
{
	static volatile gsize photo_backing_readers_type_id__volatile = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__volatile)) {
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = photo_backing_readers_get_type_once ();
		g_once_init_leave (&photo_backing_readers_type_id__volatile, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__volatile;
}

static gpointer
photo_backing_readers_ref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 291 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 291 "../src/Photo.vala"
	return instance;
#line 31534 "Photo.c"
}

static void
photo_backing_readers_unref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 291 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 291 "../src/Photo.vala"
		PHOTO_BACKING_READERS_GET_CLASS (self)->finalize (self);
#line 291 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 31548 "Photo.c"
	}
}

static PhotoCachedPixbuf*
photo_cached_pixbuf_construct (GType object_type,
                               Photo* photo,
                               GdkPixbuf* pixbuf)
{
	PhotoCachedPixbuf* self = NULL;
	Photo* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 302 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 302 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()), NULL);
#line 302 "../src/Photo.vala"
	self = (PhotoCachedPixbuf*) g_type_create_instance (object_type);
#line 303 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 303 "../src/Photo.vala"
	_g_object_unref0 (self->photo);
#line 303 "../src/Photo.vala"
	self->photo = _tmp0_;
#line 304 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (pixbuf);
#line 304 "../src/Photo.vala"
	_g_object_unref0 (self->pixbuf);
#line 304 "../src/Photo.vala"
	self->pixbuf = _tmp1_;
#line 302 "../src/Photo.vala"
	return self;
#line 31580 "Photo.c"
}

static PhotoCachedPixbuf*
photo_cached_pixbuf_new (Photo* photo,
                         GdkPixbuf* pixbuf)
{
#line 302 "../src/Photo.vala"
	return photo_cached_pixbuf_construct (PHOTO_TYPE_CACHED_PIXBUF, photo, pixbuf);
#line 31589 "Photo.c"
}

static void
photo_value_cached_pixbuf_init (GValue* value)
{
#line 297 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31597 "Photo.c"
}

static void
photo_value_cached_pixbuf_free_value (GValue* value)
{
#line 297 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_unref (value->data[0].v_pointer);
#line 31607 "Photo.c"
	}
}

static void
photo_value_cached_pixbuf_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 297 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 297 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_cached_pixbuf_ref (src_value->data[0].v_pointer);
#line 31619 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31623 "Photo.c"
	}
}

static gpointer
photo_value_cached_pixbuf_peek_pointer (const GValue* value)
{
#line 297 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31632 "Photo.c"
}

static gchar*
photo_value_cached_pixbuf_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 297 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31643 "Photo.c"
		PhotoCachedPixbuf * object;
		object = collect_values[0].v_pointer;
#line 297 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 297 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31650 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 297 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31654 "Photo.c"
		}
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = photo_cached_pixbuf_ref (object);
#line 31658 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31662 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	return NULL;
#line 31666 "Photo.c"
}

static gchar*
photo_value_cached_pixbuf_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	PhotoCachedPixbuf ** object_p;
	object_p = collect_values[0].v_pointer;
#line 297 "../src/Photo.vala"
	if (!object_p) {
#line 297 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31681 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 297 "../src/Photo.vala"
		*object_p = NULL;
#line 31687 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 297 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31691 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		*object_p = photo_cached_pixbuf_ref (value->data[0].v_pointer);
#line 31695 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	return NULL;
#line 31699 "Photo.c"
}

static GParamSpec*
photo_param_spec_cached_pixbuf (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	PhotoParamSpecCachedPixbuf* spec;
#line 297 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_CACHED_PIXBUF), NULL);
#line 297 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 297 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 297 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 31718 "Photo.c"
}

static gpointer
photo_value_get_cached_pixbuf (const GValue* value)
{
#line 297 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF), NULL);
#line 297 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31728 "Photo.c"
}

static void
photo_value_set_cached_pixbuf (GValue* value,
                               gpointer v_object)
{
	PhotoCachedPixbuf * old;
#line 297 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 297 "../src/Photo.vala"
	if (v_object) {
#line 297 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_ref (value->data[0].v_pointer);
#line 31750 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31754 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	if (old) {
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_unref (old);
#line 31760 "Photo.c"
	}
}

static void
photo_value_take_cached_pixbuf (GValue* value,
                                gpointer v_object)
{
	PhotoCachedPixbuf * old;
#line 297 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 297 "../src/Photo.vala"
	if (v_object) {
#line 297 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 31781 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31785 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	if (old) {
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_unref (old);
#line 31791 "Photo.c"
	}
}

static void
photo_cached_pixbuf_class_init (PhotoCachedPixbufClass * klass,
                                gpointer klass_data)
{
#line 297 "../src/Photo.vala"
	photo_cached_pixbuf_parent_class = g_type_class_peek_parent (klass);
#line 297 "../src/Photo.vala"
	((PhotoCachedPixbufClass *) klass)->finalize = photo_cached_pixbuf_finalize;
#line 31803 "Photo.c"
}

static void
photo_cached_pixbuf_instance_init (PhotoCachedPixbuf * self,
                                   gpointer klass)
{
	GTimer* _tmp0_;
#line 300 "../src/Photo.vala"
	_tmp0_ = g_timer_new ();
#line 300 "../src/Photo.vala"
	self->last_touched = _tmp0_;
#line 297 "../src/Photo.vala"
	self->ref_count = 1;
#line 31817 "Photo.c"
}

static void
photo_cached_pixbuf_finalize (PhotoCachedPixbuf * obj)
{
	PhotoCachedPixbuf * self;
#line 297 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbuf);
#line 297 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 298 "../src/Photo.vala"
	_g_object_unref0 (self->photo);
#line 299 "../src/Photo.vala"
	_g_object_unref0 (self->pixbuf);
#line 300 "../src/Photo.vala"
	_g_timer_destroy0 (self->last_touched);
#line 31834 "Photo.c"
}

static GType
photo_cached_pixbuf_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_cached_pixbuf_init, photo_value_cached_pixbuf_free_value, photo_value_cached_pixbuf_copy_value, photo_value_cached_pixbuf_peek_pointer, "p", photo_value_cached_pixbuf_collect_value, "p", photo_value_cached_pixbuf_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoCachedPixbufClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_cached_pixbuf_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoCachedPixbuf), 0, (GInstanceInitFunc) photo_cached_pixbuf_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_cached_pixbuf_type_id;
	photo_cached_pixbuf_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoCachedPixbuf", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_cached_pixbuf_type_id;
}

static GType
photo_cached_pixbuf_get_type (void)
{
	static volatile gsize photo_cached_pixbuf_type_id__volatile = 0;
	if (g_once_init_enter (&photo_cached_pixbuf_type_id__volatile)) {
		GType photo_cached_pixbuf_type_id;
		photo_cached_pixbuf_type_id = photo_cached_pixbuf_get_type_once ();
		g_once_init_leave (&photo_cached_pixbuf_type_id__volatile, photo_cached_pixbuf_type_id);
	}
	return photo_cached_pixbuf_type_id__volatile;
}

static gpointer
photo_cached_pixbuf_ref (gpointer instance)
{
	PhotoCachedPixbuf * self;
	self = instance;
#line 297 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 297 "../src/Photo.vala"
	return instance;
#line 31869 "Photo.c"
}

static void
photo_cached_pixbuf_unref (gpointer instance)
{
	PhotoCachedPixbuf * self;
	self = instance;
#line 297 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 297 "../src/Photo.vala"
		PHOTO_CACHED_PIXBUF_GET_CLASS (self)->finalize (self);
#line 297 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 31883 "Photo.c"
	}
}

PhotoReimportMasterState*
photo_reimport_master_state_construct (GType object_type)
{
	PhotoReimportMasterState* self = NULL;
#line 1370 "../src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 1370 "../src/Photo.vala"
	return self;
#line 31895 "Photo.c"
}

static void
photo_value_reimport_master_state_init (GValue* value)
{
#line 1370 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31903 "Photo.c"
}

static void
photo_value_reimport_master_state_free_value (GValue* value)
{
#line 1370 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1370 "../src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 31913 "Photo.c"
	}
}

static void
photo_value_reimport_master_state_copy_value (const GValue* src_value,
                                              GValue* dest_value)
{
#line 1370 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1370 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 31925 "Photo.c"
	} else {
#line 1370 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31929 "Photo.c"
	}
}

static gpointer
photo_value_reimport_master_state_peek_pointer (const GValue* value)
{
#line 1370 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31938 "Photo.c"
}

static gchar*
photo_value_reimport_master_state_collect_value (GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
#line 1370 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31949 "Photo.c"
		PhotoReimportMasterState * object;
		object = collect_values[0].v_pointer;
#line 1370 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1370 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31956 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1370 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31960 "Photo.c"
		}
#line 1370 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 31964 "Photo.c"
	} else {
#line 1370 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31968 "Photo.c"
	}
#line 1370 "../src/Photo.vala"
	return NULL;
#line 31972 "Photo.c"
}

static gchar*
photo_value_reimport_master_state_lcopy_value (const GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	PhotoReimportMasterState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1370 "../src/Photo.vala"
	if (!object_p) {
#line 1370 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31987 "Photo.c"
	}
#line 1370 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1370 "../src/Photo.vala"
		*object_p = NULL;
#line 31993 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1370 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31997 "Photo.c"
	} else {
#line 1370 "../src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32001 "Photo.c"
	}
#line 1370 "../src/Photo.vala"
	return NULL;
#line 32005 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_master_state (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags)
{
	PhotoParamSpecReimportMasterState* spec;
#line 1370 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1370 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1370 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1370 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32024 "Photo.c"
}

gpointer
photo_value_get_reimport_master_state (const GValue* value)
{
#line 1370 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1370 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32034 "Photo.c"
}

void
photo_value_set_reimport_master_state (GValue* value,
                                       gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1370 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1370 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1370 "../src/Photo.vala"
	if (v_object) {
#line 1370 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1370 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1370 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1370 "../src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32056 "Photo.c"
	} else {
#line 1370 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32060 "Photo.c"
	}
#line 1370 "../src/Photo.vala"
	if (old) {
#line 1370 "../src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32066 "Photo.c"
	}
}

void
photo_value_take_reimport_master_state (GValue* value,
                                        gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1370 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1370 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1370 "../src/Photo.vala"
	if (v_object) {
#line 1370 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1370 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1370 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32087 "Photo.c"
	} else {
#line 1370 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32091 "Photo.c"
	}
#line 1370 "../src/Photo.vala"
	if (old) {
#line 1370 "../src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32097 "Photo.c"
	}
}

static void
photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass,
                                        gpointer klass_data)
{
#line 1370 "../src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 1370 "../src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_finalize;
#line 32109 "Photo.c"
}

static void
photo_reimport_master_state_instance_init (PhotoReimportMasterState * self,
                                           gpointer klass)
{
#line 1370 "../src/Photo.vala"
	self->ref_count = 1;
#line 32118 "Photo.c"
}

static void
photo_reimport_master_state_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterState * self;
#line 1370 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1370 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 32129 "Photo.c"
}

static GType
photo_reimport_master_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_master_state_type_id;
	photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return photo_reimport_master_state_type_id;
}

GType
photo_reimport_master_state_get_type (void)
{
	static volatile gsize photo_reimport_master_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__volatile)) {
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = photo_reimport_master_state_get_type_once ();
		g_once_init_leave (&photo_reimport_master_state_type_id__volatile, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__volatile;
}

gpointer
photo_reimport_master_state_ref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1370 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1370 "../src/Photo.vala"
	return instance;
#line 32164 "Photo.c"
}

void
photo_reimport_master_state_unref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1370 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1370 "../src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 1370 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32178 "Photo.c"
	}
}

static gchar**
_vala_array_dup27 (gchar** self,
                   gint length)
{
#line 1382 "../src/Photo.vala"
	if (length >= 0) {
#line 32188 "Photo.c"
		gchar** result;
		gint i;
#line 1382 "../src/Photo.vala"
		result = g_new0 (gchar*, length + 1);
#line 1382 "../src/Photo.vala"
		for (i = 0; i < length; i++) {
#line 32195 "Photo.c"
			gchar* _tmp0_;
#line 1382 "../src/Photo.vala"
			_tmp0_ = g_strdup (self[i]);
#line 1382 "../src/Photo.vala"
			result[i] = _tmp0_;
#line 32201 "Photo.c"
		}
#line 1382 "../src/Photo.vala"
		return result;
#line 32205 "Photo.c"
	}
#line 1382 "../src/Photo.vala"
	return NULL;
#line 32209 "Photo.c"
}

static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_construct (GType object_type,
                                            PhotoRow* row,
                                            PhotoMetadata* metadata,
                                            gchar** alterations,
                                            gint alterations_length1)
{
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 1379 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 1379 "../src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1379 "../src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 1380 "../src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 1380 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1380 "../src/Photo.vala"
	self->row = _tmp0_;
#line 1381 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1381 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1381 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1382 "../src/Photo.vala"
	_tmp2_ = (alterations != NULL) ? _vala_array_dup27 (alterations, alterations_length1) : alterations;
#line 1382 "../src/Photo.vala"
	_tmp2__length1 = alterations_length1;
#line 1382 "../src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1382 "../src/Photo.vala"
	self->alterations = _tmp2_;
#line 1382 "../src/Photo.vala"
	self->alterations_length1 = _tmp2__length1;
#line 1382 "../src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 1379 "../src/Photo.vala"
	return self;
#line 32256 "Photo.c"
}

static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_new (PhotoRow* row,
                                      PhotoMetadata* metadata,
                                      gchar** alterations,
                                      gint alterations_length1)
{
#line 1379 "../src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 32267 "Photo.c"
}

static void
photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass,
                                             gpointer klass_data)
{
#line 1373 "../src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1373 "../src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 32278 "Photo.c"
}

static void
photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self,
                                                gpointer klass)
{
	PhotoRow* _tmp0_;
#line 1374 "../src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 1374 "../src/Photo.vala"
	self->row = _tmp0_;
#line 1377 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 32292 "Photo.c"
}

static void
photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterStateImpl * self;
#line 1373 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl);
#line 1374 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1375 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1376 "../src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 32309 "Photo.c"
}

static GType
photo_reimport_master_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
	GType photo_reimport_master_state_impl_type_id;
	photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
	return photo_reimport_master_state_impl_type_id;
}

static GType
photo_reimport_master_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_master_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__volatile)) {
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = photo_reimport_master_state_impl_get_type_once ();
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__volatile, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__volatile;
}

PhotoReimportEditableState*
photo_reimport_editable_state_construct (GType object_type)
{
	PhotoReimportEditableState* self = NULL;
#line 1386 "../src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 1386 "../src/Photo.vala"
	return self;
#line 32341 "Photo.c"
}

static void
photo_value_reimport_editable_state_init (GValue* value)
{
#line 1386 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32349 "Photo.c"
}

static void
photo_value_reimport_editable_state_free_value (GValue* value)
{
#line 1386 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1386 "../src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 32359 "Photo.c"
	}
}

static void
photo_value_reimport_editable_state_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
#line 1386 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1386 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 32371 "Photo.c"
	} else {
#line 1386 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32375 "Photo.c"
	}
}

static gpointer
photo_value_reimport_editable_state_peek_pointer (const GValue* value)
{
#line 1386 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32384 "Photo.c"
}

static gchar*
photo_value_reimport_editable_state_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
#line 1386 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32395 "Photo.c"
		PhotoReimportEditableState * object;
		object = collect_values[0].v_pointer;
#line 1386 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1386 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32402 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1386 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32406 "Photo.c"
		}
#line 1386 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 32410 "Photo.c"
	} else {
#line 1386 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32414 "Photo.c"
	}
#line 1386 "../src/Photo.vala"
	return NULL;
#line 32418 "Photo.c"
}

static gchar*
photo_value_reimport_editable_state_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	PhotoReimportEditableState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1386 "../src/Photo.vala"
	if (!object_p) {
#line 1386 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32433 "Photo.c"
	}
#line 1386 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1386 "../src/Photo.vala"
		*object_p = NULL;
#line 32439 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1386 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32443 "Photo.c"
	} else {
#line 1386 "../src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 32447 "Photo.c"
	}
#line 1386 "../src/Photo.vala"
	return NULL;
#line 32451 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_editable_state (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	PhotoParamSpecReimportEditableState* spec;
#line 1386 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1386 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1386 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1386 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32470 "Photo.c"
}

gpointer
photo_value_get_reimport_editable_state (const GValue* value)
{
#line 1386 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1386 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32480 "Photo.c"
}

void
photo_value_set_reimport_editable_state (GValue* value,
                                         gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1386 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1386 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1386 "../src/Photo.vala"
	if (v_object) {
#line 1386 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1386 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1386 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1386 "../src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 32502 "Photo.c"
	} else {
#line 1386 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32506 "Photo.c"
	}
#line 1386 "../src/Photo.vala"
	if (old) {
#line 1386 "../src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 32512 "Photo.c"
	}
}

void
photo_value_take_reimport_editable_state (GValue* value,
                                          gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1386 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1386 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1386 "../src/Photo.vala"
	if (v_object) {
#line 1386 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1386 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1386 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32533 "Photo.c"
	} else {
#line 1386 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32537 "Photo.c"
	}
#line 1386 "../src/Photo.vala"
	if (old) {
#line 1386 "../src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 32543 "Photo.c"
	}
}

static void
photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass,
                                          gpointer klass_data)
{
#line 1386 "../src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 1386 "../src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_finalize;
#line 32555 "Photo.c"
}

static void
photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self,
                                             gpointer klass)
{
#line 1386 "../src/Photo.vala"
	self->ref_count = 1;
#line 32564 "Photo.c"
}

static void
photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableState * self;
#line 1386 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1386 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 32575 "Photo.c"
}

static GType
photo_reimport_editable_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_editable_state_type_id;
	photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return photo_reimport_editable_state_type_id;
}

GType
photo_reimport_editable_state_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__volatile)) {
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = photo_reimport_editable_state_get_type_once ();
		g_once_init_leave (&photo_reimport_editable_state_type_id__volatile, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__volatile;
}

gpointer
photo_reimport_editable_state_ref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1386 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1386 "../src/Photo.vala"
	return instance;
#line 32610 "Photo.c"
}

void
photo_reimport_editable_state_unref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1386 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1386 "../src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 1386 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32624 "Photo.c"
	}
}

static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_construct (GType object_type,
                                              BackingPhotoRow* backing_state,
                                              PhotoMetadata* metadata)
{
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1394 "../src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing_state), NULL);
#line 1394 "../src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1394 "../src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 1395 "../src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing_state);
#line 1395 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1395 "../src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1396 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1396 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1396 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1394 "../src/Photo.vala"
	return self;
#line 32656 "Photo.c"
}

static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                        PhotoMetadata* metadata)
{
#line 1394 "../src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 32665 "Photo.c"
}

static void
photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass,
                                               gpointer klass_data)
{
#line 1389 "../src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1389 "../src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 32676 "Photo.c"
}

static void
photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self,
                                                  gpointer klass)
{
	BackingPhotoRow* _tmp0_;
#line 1390 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1390 "../src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1392 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 32690 "Photo.c"
}

static void
photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableStateImpl * self;
#line 1389 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl);
#line 1390 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1391 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1389 "../src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 32705 "Photo.c"
}

static GType
photo_reimport_editable_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
	GType photo_reimport_editable_state_impl_type_id;
	photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
	return photo_reimport_editable_state_impl_type_id;
}

static GType
photo_reimport_editable_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__volatile)) {
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = photo_reimport_editable_state_impl_get_type_once ();
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__volatile, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__volatile;
}

PhotoReimportRawDevelopmentState*
photo_reimport_raw_development_state_construct (GType object_type)
{
	PhotoReimportRawDevelopmentState* self = NULL;
#line 1400 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentState*) g_type_create_instance (object_type);
#line 1400 "../src/Photo.vala"
	return self;
#line 32737 "Photo.c"
}

static void
photo_value_reimport_raw_development_state_init (GValue* value)
{
#line 1400 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32745 "Photo.c"
}

static void
photo_value_reimport_raw_development_state_free_value (GValue* value)
{
#line 1400 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1400 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (value->data[0].v_pointer);
#line 32755 "Photo.c"
	}
}

static void
photo_value_reimport_raw_development_state_copy_value (const GValue* src_value,
                                                       GValue* dest_value)
{
#line 1400 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1400 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_ref (src_value->data[0].v_pointer);
#line 32767 "Photo.c"
	} else {
#line 1400 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32771 "Photo.c"
	}
}

static gpointer
photo_value_reimport_raw_development_state_peek_pointer (const GValue* value)
{
#line 1400 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32780 "Photo.c"
}

static gchar*
photo_value_reimport_raw_development_state_collect_value (GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
#line 1400 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32791 "Photo.c"
		PhotoReimportRawDevelopmentState * object;
		object = collect_values[0].v_pointer;
#line 1400 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1400 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32798 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1400 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32802 "Photo.c"
		}
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_ref (object);
#line 32806 "Photo.c"
	} else {
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32810 "Photo.c"
	}
#line 1400 "../src/Photo.vala"
	return NULL;
#line 32814 "Photo.c"
}

static gchar*
photo_value_reimport_raw_development_state_lcopy_value (const GValue* value,
                                                        guint n_collect_values,
                                                        GTypeCValue* collect_values,
                                                        guint collect_flags)
{
	PhotoReimportRawDevelopmentState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1400 "../src/Photo.vala"
	if (!object_p) {
#line 1400 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32829 "Photo.c"
	}
#line 1400 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1400 "../src/Photo.vala"
		*object_p = NULL;
#line 32835 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1400 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32839 "Photo.c"
	} else {
#line 1400 "../src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 32843 "Photo.c"
	}
#line 1400 "../src/Photo.vala"
	return NULL;
#line 32847 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags)
{
	PhotoParamSpecReimportRawDevelopmentState* spec;
#line 1400 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1400 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1400 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1400 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32866 "Photo.c"
}

gpointer
photo_value_get_reimport_raw_development_state (const GValue* value)
{
#line 1400 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1400 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32876 "Photo.c"
}

void
photo_value_set_reimport_raw_development_state (GValue* value,
                                                gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1400 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1400 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1400 "../src/Photo.vala"
	if (v_object) {
#line 1400 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1400 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1400 "../src/Photo.vala"
		photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 32898 "Photo.c"
	} else {
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32902 "Photo.c"
	}
#line 1400 "../src/Photo.vala"
	if (old) {
#line 1400 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 32908 "Photo.c"
	}
}

void
photo_value_take_reimport_raw_development_state (GValue* value,
                                                 gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1400 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1400 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1400 "../src/Photo.vala"
	if (v_object) {
#line 1400 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1400 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32929 "Photo.c"
	} else {
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32933 "Photo.c"
	}
#line 1400 "../src/Photo.vala"
	if (old) {
#line 1400 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 32939 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_class_init (PhotoReimportRawDevelopmentStateClass * klass,
                                                 gpointer klass_data)
{
#line 1400 "../src/Photo.vala"
	photo_reimport_raw_development_state_parent_class = g_type_class_peek_parent (klass);
#line 1400 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_finalize;
#line 32951 "Photo.c"
}

static void
photo_reimport_raw_development_state_instance_init (PhotoReimportRawDevelopmentState * self,
                                                    gpointer klass)
{
#line 1400 "../src/Photo.vala"
	self->ref_count = 1;
#line 32960 "Photo.c"
}

static void
photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentState * self;
#line 1400 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState);
#line 1400 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 32971 "Photo.c"
}

static GType
photo_reimport_raw_development_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_raw_development_state_init, photo_value_reimport_raw_development_state_free_value, photo_value_reimport_raw_development_state_copy_value, photo_value_reimport_raw_development_state_peek_pointer, "p", photo_value_reimport_raw_development_state_collect_value, "p", photo_value_reimport_raw_development_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentState), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_raw_development_state_type_id;
	photo_reimport_raw_development_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return photo_reimport_raw_development_state_type_id;
}

GType
photo_reimport_raw_development_state_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_type_id__volatile)) {
		GType photo_reimport_raw_development_state_type_id;
		photo_reimport_raw_development_state_type_id = photo_reimport_raw_development_state_get_type_once ();
		g_once_init_leave (&photo_reimport_raw_development_state_type_id__volatile, photo_reimport_raw_development_state_type_id);
	}
	return photo_reimport_raw_development_state_type_id__volatile;
}

gpointer
photo_reimport_raw_development_state_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1400 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1400 "../src/Photo.vala"
	return instance;
#line 33006 "Photo.c"
}

void
photo_reimport_raw_development_state_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1400 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1400 "../src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS (self)->finalize (self);
#line 1400 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33020 "Photo.c"
	}
}

static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_construct (GType object_type)
{
	PhotoReimportRawDevelopmentStateImpl* self = NULL;
#line 1417 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImpl*) photo_reimport_raw_development_state_construct (object_type);
#line 1417 "../src/Photo.vala"
	return self;
#line 33032 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_new (void)
{
#line 1417 "../src/Photo.vala"
	return photo_reimport_raw_development_state_impl_construct (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL);
#line 33040 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                               BackingPhotoRow* backing,
                                               PhotoMetadata* metadata)
{
	GeeCollection* _tmp0_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp1_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp2_;
#line 1420 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self));
#line 1420 "../src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (backing));
#line 1420 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 1421 "../src/Photo.vala"
	_tmp0_ = self->list;
#line 1421 "../src/Photo.vala"
	_tmp1_ = photo_reimport_raw_development_state_impl_dev_to_reimport_new (backing, metadata);
#line 1421 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1421 "../src/Photo.vala"
	gee_collection_add (_tmp0_, _tmp2_);
#line 1421 "../src/Photo.vala"
	_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (_tmp2_);
#line 33067 "Photo.c"
}

static gint
photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self)
{
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result = 0;
#line 1424 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self), 0);
#line 1425 "../src/Photo.vala"
	_tmp0_ = self->list;
#line 1425 "../src/Photo.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 1425 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1425 "../src/Photo.vala"
	result = _tmp2_;
#line 1425 "../src/Photo.vala"
	return result;
#line 33089 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                     BackingPhotoRow* backing,
                                                                     PhotoMetadata* metadata)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1408 "../src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing), NULL);
#line 1408 "../src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1408 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImplDevToReimport*) g_type_create_instance (object_type);
#line 1409 "../src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing);
#line 1409 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1409 "../src/Photo.vala"
	self->backing = _tmp0_;
#line 1410 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1410 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1410 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1408 "../src/Photo.vala"
	return self;
#line 33120 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                               PhotoMetadata* metadata)
{
#line 1408 "../src/Photo.vala"
	return photo_reimport_raw_development_state_impl_dev_to_reimport_construct (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, backing, metadata);
#line 33129 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_init (GValue* value)
{
#line 1404 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33137 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value (GValue* value)
{
#line 1404 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1404 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (value->data[0].v_pointer);
#line 33147 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value (const GValue* src_value,
                                                                            GValue* dest_value)
{
#line 1404 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1404 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (src_value->data[0].v_pointer);
#line 33159 "Photo.c"
	} else {
#line 1404 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33163 "Photo.c"
	}
}

static gpointer
photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer (const GValue* value)
{
#line 1404 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33172 "Photo.c"
}

static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value (GValue* value,
                                                                               guint n_collect_values,
                                                                               GTypeCValue* collect_values,
                                                                               guint collect_flags)
{
#line 1404 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33183 "Photo.c"
		PhotoReimportRawDevelopmentStateImplDevToReimport * object;
		object = collect_values[0].v_pointer;
#line 1404 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1404 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33190 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1404 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33194 "Photo.c"
		}
#line 1404 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (object);
#line 33198 "Photo.c"
	} else {
#line 1404 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33202 "Photo.c"
	}
#line 1404 "../src/Photo.vala"
	return NULL;
#line 33206 "Photo.c"
}

static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value (const GValue* value,
                                                                             guint n_collect_values,
                                                                             GTypeCValue* collect_values,
                                                                             guint collect_flags)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1404 "../src/Photo.vala"
	if (!object_p) {
#line 1404 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33221 "Photo.c"
	}
#line 1404 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1404 "../src/Photo.vala"
		*object_p = NULL;
#line 33227 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1404 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33231 "Photo.c"
	} else {
#line 1404 "../src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33235 "Photo.c"
	}
#line 1404 "../src/Photo.vala"
	return NULL;
#line 33239 "Photo.c"
}

static GParamSpec*
photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                      const gchar* nick,
                                                                      const gchar* blurb,
                                                                      GType object_type,
                                                                      GParamFlags flags)
{
	PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport* spec;
#line 1404 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1404 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1404 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1404 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33258 "Photo.c"
}

static gpointer
photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value)
{
#line 1404 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1404 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33268 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                     gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1404 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1404 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1404 "../src/Photo.vala"
	if (v_object) {
#line 1404 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1404 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1404 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1404 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33290 "Photo.c"
	} else {
#line 1404 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33294 "Photo.c"
	}
#line 1404 "../src/Photo.vala"
	if (old) {
#line 1404 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33300 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                      gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1404 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1404 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1404 "../src/Photo.vala"
	if (v_object) {
#line 1404 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1404 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1404 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33321 "Photo.c"
	} else {
#line 1404 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33325 "Photo.c"
	}
#line 1404 "../src/Photo.vala"
	if (old) {
#line 1404 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33331 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_class_init (PhotoReimportRawDevelopmentStateImplDevToReimportClass * klass,
                                                                      gpointer klass_data)
{
#line 1404 "../src/Photo.vala"
	photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = g_type_class_peek_parent (klass);
#line 1404 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateImplDevToReimportClass *) klass)->finalize = photo_reimport_raw_development_state_impl_dev_to_reimport_finalize;
#line 33343 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init (PhotoReimportRawDevelopmentStateImplDevToReimport * self,
                                                                         gpointer klass)
{
	BackingPhotoRow* _tmp0_;
#line 1405 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1405 "../src/Photo.vala"
	self->backing = _tmp0_;
#line 1404 "../src/Photo.vala"
	self->ref_count = 1;
#line 33357 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
#line 1404 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport);
#line 1404 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 1405 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1406 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 33372 "Photo.c"
}

static GType
photo_reimport_raw_development_state_impl_dev_to_reimport_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_reimport_raw_development_state_impl_value_dev_to_reimport_init, photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplDevToReimportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImplDevToReimport), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
	photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentStateImplDevToReimport", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
}

GType
photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile)) {
		GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
		photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = photo_reimport_raw_development_state_impl_dev_to_reimport_get_type_once ();
		g_once_init_leave (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile, photo_reimport_raw_development_state_impl_dev_to_reimport_type_id);
	}
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile;
}

static gpointer
photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1404 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1404 "../src/Photo.vala"
	return instance;
#line 33407 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1404 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1404 "../src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS (self)->finalize (self);
#line 1404 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33421 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_class_init (PhotoReimportRawDevelopmentStateImplClass * klass,
                                                      gpointer klass_data)
{
#line 1403 "../src/Photo.vala"
	photo_reimport_raw_development_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1403 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_impl_finalize;
#line 33433 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_instance_init (PhotoReimportRawDevelopmentStateImpl * self,
                                                         gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 1414 "../src/Photo.vala"
	_tmp0_ = gee_array_list_new (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, (GBoxedCopyFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_ref, (GDestroyNotify) photo_reimport_raw_development_state_impl_dev_to_reimport_unref, NULL, NULL, NULL);
#line 1414 "../src/Photo.vala"
	self->list = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1415 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 33447 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentStateImpl * self;
#line 1403 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl);
#line 1414 "../src/Photo.vala"
	_g_object_unref0 (self->list);
#line 1403 "../src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (photo_reimport_raw_development_state_impl_parent_class)->finalize (obj);
#line 33460 "Photo.c"
}

static GType
photo_reimport_raw_development_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImpl), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_instance_init, NULL };
	GType photo_reimport_raw_development_state_impl_type_id;
	photo_reimport_raw_development_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, "PhotoReimportRawDevelopmentStateImpl", &g_define_type_info, 0);
	return photo_reimport_raw_development_state_impl_type_id;
}

static GType
photo_reimport_raw_development_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_type_id__volatile)) {
		GType photo_reimport_raw_development_state_impl_type_id;
		photo_reimport_raw_development_state_impl_type_id = photo_reimport_raw_development_state_impl_get_type_once ();
		g_once_init_leave (&photo_reimport_raw_development_state_impl_type_id__volatile, photo_reimport_raw_development_state_impl_type_id);
	}
	return photo_reimport_raw_development_state_impl_type_id__volatile;
}

static void
photo_class_init (PhotoClass * klass,
                  gpointer klass_data)
{
#line 158 "../src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 158 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &Photo_private_offset);
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_replaced = (void (*) (Photo*, GFile*, GFile*)) photo_real_notify_editable_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_raw_development_modified = (void (*) (Photo*)) photo_real_notify_raw_development_modified;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_replaced = (void (*) (Photo*)) photo_real_notify_baseline_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_master_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_editable_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_source_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_baseline_reimported;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) photo_real_internal_delete_backing;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_backing_files_state = (BackingFileState** (*) (MediaSource*, gint*)) photo_real_get_backing_files_state;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) photo_real_apply_user_metadata_for_reimport;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource*)) photo_real_get_typename;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource*)) photo_real_get_instance_id;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_source_id = (gchar* (*) (DataSource*)) photo_real_get_source_id;
#line 158 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource*)) photo_real_get_preferred_thumbnail_format;
#line 158 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) photo_real_create_thumbnail;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_file = (GFile* (*) (MediaSource*)) photo_real_get_file;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_file = (GFile* (*) (MediaSource*)) photo_real_get_master_file;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_timestamp = (time_t (*) (MediaSource*)) photo_real_get_timestamp;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_event_id = (void (*) (MediaSource*, EventID*)) photo_real_get_event_id;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_import_id = (void (*) (MediaSource*, ImportID*)) photo_real_get_import_id;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_md5 = (gchar* (*) (MediaSource*)) photo_real_get_master_md5;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_rating = (Rating (*) (MediaSource*)) photo_real_get_rating;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_rating = (void (*) (MediaSource*, Rating)) photo_real_set_rating;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->increase_rating = (void (*) (MediaSource*)) photo_real_increase_rating;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->decrease_rating = (void (*) (MediaSource*)) photo_real_decrease_rating;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->commit_backlinks = (void (*) (DataSource*, SourceCollection*, const gchar*)) photo_real_commit_backlinks;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_event_id = (gboolean (*) (MediaSource*, EventID*)) photo_real_set_event_id;
#line 158 "../src/Photo.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject*)) photo_real_to_string;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->equals = (gboolean (*) (DataSource*, DataSource*)) photo_real_equals;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_filesize = (guint64 (*) (MediaSource*)) photo_real_get_filesize;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_filesize = (guint64 (*) (MediaSource*)) photo_real_get_master_filesize;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_exposure_time = (time_t (*) (MediaSource*)) photo_real_get_exposure_time;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_basename = (gchar* (*) (MediaSource*)) photo_real_get_basename;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_title = (gchar* (*) (MediaSource*)) photo_real_get_title;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_comment = (gchar* (*) (MediaSource*)) photo_real_get_comment;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_title = (void (*) (MediaSource*, const gchar*)) photo_real_set_title;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_comment = (gboolean (*) (MediaSource*, const gchar*)) photo_real_set_comment;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_dimensions = (void (*) (MediaSource*, PhotoException, Dimensions*)) photo_real_get_dimensions;
#line 158 "../src/Photo.vala"
	((PhotoSourceClass *) klass)->get_metadata = (PhotoMetadata* (*) (PhotoSource*)) photo_real_get_metadata;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) photo_real_rotate;
#line 158 "../src/Photo.vala"
	((PhotoSourceClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoSource*, Scaling*, GError**)) photo_real_get_pixbuf;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) photo_real_has_user_generated_metadata;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) photo_real_set_user_metadata_for_export;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->editable_replaced = photo_real_editable_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->raw_development_modified = photo_real_raw_development_modified;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->baseline_replaced = photo_real_baseline_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->master_reimported = photo_real_master_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->editable_reimported = photo_real_editable_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->baseline_reimported = photo_real_baseline_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->source_reimported = photo_real_source_reimported;
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_photo_get_property;
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_photo_set_property;
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL] = g_signal_new ("editable-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_get_type ());
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL] = g_signal_new ("raw-development-modified", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, raw_development_modified), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL] = g_signal_new ("baseline-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 323 "../src/Photo.vala"
	g_rec_mutex_init (&__lock_photo_photo_source_pixbuf_cache);
#line 33614 "Photo.c"
}

static void
photo_dateable_interface_init (DateableIface * iface,
                               gpointer iface_data)
{
#line 158 "../src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 158 "../src/Photo.vala"
	iface->get_exposure_time = (time_t (*) (Dateable*)) photo_real_get_exposure_time;
#line 158 "../src/Photo.vala"
	iface->set_exposure_time = (void (*) (Dateable*, time_t)) photo_real_set_exposure_time;
#line 33627 "Photo.c"
}

static void
photo_positionable_interface_init (PositionableIface * iface,
                                   gpointer iface_data)
{
#line 158 "../src/Photo.vala"
	photo_positionable_parent_iface = g_type_interface_peek_parent (iface);
#line 158 "../src/Photo.vala"
	iface->get_gps_coords = (void (*) (Positionable*, GpsCoords*)) photo_real_get_gps_coords;
#line 158 "../src/Photo.vala"
	iface->set_gps_coords = (void (*) (Positionable*, GpsCoords*)) photo_real_set_gps_coords;
#line 33640 "Photo.c"
}

static void
photo_instance_init (Photo * self,
                     gpointer klass)
{
	BackingPhotoRow* _tmp0_;
	PhotoBackingReaders* _tmp1_;
#line 158 "../src/Photo.vala"
	self->priv = photo_get_instance_private (self);
#line 328 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_row);
#line 329 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 329 "../src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 330 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_readers);
#line 330 "../src/Photo.vala"
	_tmp1_ = photo_backing_readers_new ();
#line 330 "../src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 331 "../src/Photo.vala"
	self->priv->transformer = NULL;
#line 332 "../src/Photo.vala"
	self->priv->adjustments = NULL;
#line 334 "../src/Photo.vala"
	self->priv->file_title = NULL;
#line 335 "../src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 336 "../src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 337 "../src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 338 "../src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 340 "../src/Photo.vala"
	self->can_rotate_now = TRUE;
#line 343 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_developments);
#line 343 "../src/Photo.vala"
	self->priv->developments = NULL;
#line 350 "../src/Photo.vala"
	self->backing_photo_row = NULL;
#line 33685 "Photo.c"
}

static void
photo_finalize (GObject * obj)
{
	Photo * self;
#line 158 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO, Photo);
#line 328 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_row);
#line 328 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 329 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->priv->editable);
#line 330 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_readers);
#line 330 "../src/Photo.vala"
	_photo_backing_readers_unref0 (self->priv->readers);
#line 331 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 332 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 334 "../src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 335 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 336 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 337 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 338 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 343 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_developments);
#line 343 "../src/Photo.vala"
	_g_object_unref0 (self->priv->developments);
#line 350 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_photo_row);
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 33726 "Photo.c"
}

static GType
photo_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
	static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo positionable_info = { (GInterfaceInitFunc) photo_positionable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType photo_type_id;
	photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
	g_type_add_interface_static (photo_type_id, TYPE_POSITIONABLE, &positionable_info);
	Photo_private_offset = g_type_add_instance_private (photo_type_id, sizeof (PhotoPrivate));
	return photo_type_id;
}

GType
photo_get_type (void)
{
	static volatile gsize photo_type_id__volatile = 0;
	if (g_once_init_enter (&photo_type_id__volatile)) {
		GType photo_type_id;
		photo_type_id = photo_get_type_once ();
		g_once_init_leave (&photo_type_id__volatile, photo_type_id);
	}
	return photo_type_id__volatile;
}

static void
_vala_photo_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 158 "../src/Photo.vala"
	switch (property_id) {
#line 33765 "Photo.c"
		default:
#line 158 "../src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 158 "../src/Photo.vala"
		break;
#line 33771 "Photo.c"
	}
}

static void
_vala_photo_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 158 "../src/Photo.vala"
	switch (property_id) {
#line 33785 "Photo.c"
		default:
#line 158 "../src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 158 "../src/Photo.vala"
		break;
#line 33791 "Photo.c"
	}
}

static inline gpointer
library_photo_source_collection_get_instance_private (LibraryPhotoSourceCollection* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhotoSourceCollection_private_offset);
}

static GType
library_photo_source_collection_state_get_type_once (void)
{
	static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER", "developer"}, {0, NULL, NULL}};
	GType library_photo_source_collection_state_type_id;
	library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
	return library_photo_source_collection_state_type_id;
}

GType
library_photo_source_collection_state_get_type (void)
{
	static volatile gsize library_photo_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__volatile)) {
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = library_photo_source_collection_state_get_type_once ();
		g_once_init_leave (&library_photo_source_collection_state_type_id__volatile, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__volatile;
}

static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 4513 "../src/Photo.vala"
	return result;
#line 33830 "Photo.c"
}

static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 4513 "../src/Photo.vala"
	return result;
#line 33842 "Photo.c"
}

static gint
_int64_compare_gcompare_data_func (gconstpointer a,
                                   gconstpointer b,
                                   gpointer self)
{
	gint result;
	result = int64_compare ((gint64*) a, (gint64*) b);
#line 4517 "../src/Photo.vala"
	return result;
#line 33854 "Photo.c"
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 4517 "../src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 4517 "../src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 4517 "../src/Photo.vala"
	return dup;
#line 33867 "Photo.c"
}

static gboolean
_int64_equal_gee_equal_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gboolean result;
	result = int64_equal ((gint64*) a, (gint64*) b);
#line 4519 "../src/Photo.vala"
	return result;
#line 33879 "Photo.c"
}

static gint64
_photo_get_photo_key_get_source_database_key (DataSource* source,
                                              gpointer self)
{
	gint64 result;
	result = photo_get_photo_key (source);
#line 4539 "../src/Photo.vala"
	return result;
#line 33890 "Photo.c"
}

static void
_library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                    GeeCollection* added,
                                                                                                    GeeCollection* removed,
                                                                                                    gpointer self)
{
#line 4541 "../src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 33901 "Photo.c"
}

static void
_library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                   GeeCollection* added,
                                                                                                   GeeCollection* removed,
                                                                                                   gpointer self)
{
#line 4542 "../src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 33912 "Photo.c"
}

LibraryPhotoSourceCollection*
library_photo_source_collection_construct (GType object_type)
{
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4539 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 4541 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4541 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4541 "../src/Photo.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 4541 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4542 "../src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4542 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4542 "../src/Photo.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 4542 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4538 "../src/Photo.vala"
	return self;
#line 33943 "Photo.c"
}

LibraryPhotoSourceCollection*
library_photo_source_collection_new (void)
{
#line 4538 "../src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 33951 "Photo.c"
}

static gboolean
_library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4546 "../src/Photo.vala"
	return result;
#line 33963 "Photo.c"
}

static MediaSourceHoldingTank*
library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	LibraryPhotoSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* result = NULL;
#line 4545 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4546 "../src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4546 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank);
#line 4546 "../src/Photo.vala"
	return result;
#line 33980 "Photo.c"
}

static gboolean
_library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4550 "../src/Photo.vala"
	return result;
#line 33992 "Photo.c"
}

static MediaSourceHoldingTank*
library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	LibraryPhotoSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* result = NULL;
#line 4549 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4550 "../src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4550 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank);
#line 4550 "../src/Photo.vala"
	return result;
#line 34009 "Photo.c"
}

static MediaMonitor*
library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                           Workers* workers,
                                                           GCancellable* cancellable)
{
	LibraryPhotoSourceCollection * self;
	PhotoMonitor* _tmp0_;
	MediaMonitor* result = NULL;
#line 4553 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4553 "../src/Photo.vala"
	g_return_val_if_fail (IS_WORKERS (workers), NULL);
#line 4553 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 4554 "../src/Photo.vala"
	_tmp0_ = photo_monitor_new (workers, cancellable);
#line 4554 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_MONITOR, MediaMonitor);
#line 4554 "../src/Photo.vala"
	return result;
#line 34032 "Photo.c"
}

static gboolean
library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                           DataSource* source)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
#line 4557 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4557 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4558 "../src/Photo.vala"
	result = IS_LIBRARY_PHOTO (source);
#line 4558 "../src/Photo.vala"
	return result;
#line 34049 "Photo.c"
}

static gchar*
library_photo_source_collection_real_get_typename (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 4561 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4562 "../src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 4562 "../src/Photo.vala"
	result = _tmp0_;
#line 4562 "../src/Photo.vala"
	return result;
#line 34066 "Photo.c"
}

static gboolean
library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                         GFile* file)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
#line 4565 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4565 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 4566 "../src/Photo.vala"
	result = photo_file_format_is_file_supported (file);
#line 4566 "../src/Photo.vala"
	return result;
#line 34083 "Photo.c"
}

static void
_library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                               GFile* old_file,
                                                                               GFile* new_file,
                                                                               gpointer self)
{
#line 4578 "../src/Photo.vala"
	library_photo_source_collection_on_editable_replaced ((LibraryPhotoSourceCollection*) self, _sender, old_file, new_file);
#line 34094 "Photo.c"
}

static void
_library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                             gpointer self)
{
#line 4584 "../src/Photo.vala"
	library_photo_source_collection_on_raw_development_modified ((LibraryPhotoSourceCollection*) self, _sender);
#line 34103 "Photo.c"
}

static void
library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                              GeeIterable* added,
                                                              GeeIterable* removed)
{
	LibraryPhotoSourceCollection * self;
#line 4569 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4569 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_ITERABLE));
#line 4569 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_ITERABLE));
#line 4571 "../src/Photo.vala"
	if (added != NULL) {
#line 34120 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp0_;
#line 4572 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (added);
#line 4572 "../src/Photo.vala"
			_object_it = _tmp0_;
#line 4572 "../src/Photo.vala"
			while (TRUE) {
#line 34130 "Photo.c"
				GeeIterator* _tmp1_;
				DataObject* object = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp4_;
				LibraryPhoto* _tmp5_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				LibraryPhoto* _tmp12_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp13_;
				GeeCollection* _tmp14_;
				GeeCollection* _tmp15_;
				LibraryPhoto* _tmp24_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoRow* _tmp27_;
				gint64 _tmp28_;
				gint64 _tmp29_ = 0LL;
				LibraryPhoto* _tmp30_;
				BackingPhotoRow* _tmp31_;
				BackingPhotoRow* _tmp32_;
				gboolean _tmp33_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp37_;
				LibraryPhoto* _tmp38_;
				GeeHashMap* _tmp39_;
				LibraryPhoto* _tmp40_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp45_;
				GeeCollection* _tmp46_;
				GeeCollection* _tmp47_;
#line 4572 "../src/Photo.vala"
				_tmp1_ = _object_it;
#line 4572 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 4572 "../src/Photo.vala"
					break;
#line 34173 "Photo.c"
				}
#line 4572 "../src/Photo.vala"
				_tmp2_ = _object_it;
#line 4572 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 4572 "../src/Photo.vala"
				object = (DataObject*) _tmp3_;
#line 4573 "../src/Photo.vala"
				_tmp4_ = object;
#line 4573 "../src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4573 "../src/Photo.vala"
				photo = _tmp5_;
#line 4575 "../src/Photo.vala"
				_tmp6_ = photo;
#line 4575 "../src/Photo.vala"
				_tmp7_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PHOTO, Photo));
#line 4575 "../src/Photo.vala"
				editable = _tmp7_;
#line 4576 "../src/Photo.vala"
				_tmp8_ = editable;
#line 4576 "../src/Photo.vala"
				if (_tmp8_ != NULL) {
#line 34197 "Photo.c"
					GeeHashMap* _tmp9_;
					GFile* _tmp10_;
					LibraryPhoto* _tmp11_;
#line 4577 "../src/Photo.vala"
					_tmp9_ = self->priv->by_editable_file;
#line 4577 "../src/Photo.vala"
					_tmp10_ = editable;
#line 4577 "../src/Photo.vala"
					_tmp11_ = photo;
#line 4577 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp10_, _tmp11_);
#line 34209 "Photo.c"
				}
#line 4578 "../src/Photo.vala"
				_tmp12_ = photo;
#line 4578 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO, Photo), "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4580 "../src/Photo.vala"
				_tmp13_ = photo;
#line 4580 "../src/Photo.vala"
				_tmp14_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO, Photo));
#line 4580 "../src/Photo.vala"
				raw_list = _tmp14_;
#line 4581 "../src/Photo.vala"
				_tmp15_ = raw_list;
#line 4581 "../src/Photo.vala"
				if (_tmp15_ != NULL) {
#line 34225 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp16_;
						GeeIterator* _tmp17_;
#line 4582 "../src/Photo.vala"
						_tmp16_ = raw_list;
#line 4582 "../src/Photo.vala"
						_tmp17_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4582 "../src/Photo.vala"
						_f_it = _tmp17_;
#line 4582 "../src/Photo.vala"
						while (TRUE) {
#line 34238 "Photo.c"
							GeeIterator* _tmp18_;
							GFile* f = NULL;
							GeeIterator* _tmp19_;
							gpointer _tmp20_;
							GeeHashMap* _tmp21_;
							GFile* _tmp22_;
							LibraryPhoto* _tmp23_;
#line 4582 "../src/Photo.vala"
							_tmp18_ = _f_it;
#line 4582 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp18_)) {
#line 4582 "../src/Photo.vala"
								break;
#line 34252 "Photo.c"
							}
#line 4582 "../src/Photo.vala"
							_tmp19_ = _f_it;
#line 4582 "../src/Photo.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 4582 "../src/Photo.vala"
							f = (GFile*) _tmp20_;
#line 4583 "../src/Photo.vala"
							_tmp21_ = self->priv->by_raw_development_file;
#line 4583 "../src/Photo.vala"
							_tmp22_ = f;
#line 4583 "../src/Photo.vala"
							_tmp23_ = photo;
#line 4583 "../src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp22_, _tmp23_);
#line 4582 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 34270 "Photo.c"
						}
#line 4582 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 34274 "Photo.c"
					}
				}
#line 4584 "../src/Photo.vala"
				_tmp24_ = photo;
#line 4584 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_PHOTO, Photo), "raw-development-modified", (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4586 "../src/Photo.vala"
				_tmp25_ = photo;
#line 4586 "../src/Photo.vala"
				_tmp26_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_PHOTO, Photo));
#line 4586 "../src/Photo.vala"
				_tmp27_ = _tmp26_;
#line 4586 "../src/Photo.vala"
				_tmp28_ = _tmp27_->filesize;
#line 4586 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp27_);
#line 4586 "../src/Photo.vala"
				master_filesize = _tmp28_;
#line 4587 "../src/Photo.vala"
				_tmp30_ = photo;
#line 4587 "../src/Photo.vala"
				_tmp31_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_PHOTO, Photo));
#line 4587 "../src/Photo.vala"
				_tmp32_ = _tmp31_;
#line 4587 "../src/Photo.vala"
				_tmp33_ = _tmp32_ != NULL;
#line 4587 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp32_);
#line 4587 "../src/Photo.vala"
				if (_tmp33_) {
#line 34305 "Photo.c"
					LibraryPhoto* _tmp34_;
					BackingPhotoRow* _tmp35_;
					BackingPhotoRow* _tmp36_;
#line 4588 "../src/Photo.vala"
					_tmp34_ = photo;
#line 4588 "../src/Photo.vala"
					_tmp35_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, TYPE_PHOTO, Photo));
#line 4588 "../src/Photo.vala"
					_tmp36_ = _tmp35_;
#line 4588 "../src/Photo.vala"
					_tmp29_ = _tmp36_->filesize;
#line 4588 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp36_);
#line 34319 "Photo.c"
				} else {
#line 4589 "../src/Photo.vala"
					_tmp29_ = (gint64) -1;
#line 34323 "Photo.c"
				}
#line 4587 "../src/Photo.vala"
				editable_filesize = _tmp29_;
#line 4590 "../src/Photo.vala"
				_tmp37_ = self->priv->filesize_to_photo;
#line 4590 "../src/Photo.vala"
				_tmp38_ = photo;
#line 4590 "../src/Photo.vala"
				gee_multi_map_set (_tmp37_, &master_filesize, _tmp38_);
#line 4591 "../src/Photo.vala"
				_tmp39_ = self->priv->photo_to_master_filesize;
#line 4591 "../src/Photo.vala"
				_tmp40_ = photo;
#line 4591 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp40_, &master_filesize);
#line 4592 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 34341 "Photo.c"
					GeeMultiMap* _tmp41_;
					LibraryPhoto* _tmp42_;
					GeeHashMap* _tmp43_;
					LibraryPhoto* _tmp44_;
#line 4593 "../src/Photo.vala"
					_tmp41_ = self->priv->filesize_to_photo;
#line 4593 "../src/Photo.vala"
					_tmp42_ = photo;
#line 4593 "../src/Photo.vala"
					gee_multi_map_set (_tmp41_, &editable_filesize, _tmp42_);
#line 4594 "../src/Photo.vala"
					_tmp43_ = self->priv->photo_to_editable_filesize;
#line 4594 "../src/Photo.vala"
					_tmp44_ = photo;
#line 4594 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp44_, &editable_filesize);
#line 34358 "Photo.c"
				}
#line 4597 "../src/Photo.vala"
				_tmp45_ = photo;
#line 4597 "../src/Photo.vala"
				_tmp46_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, TYPE_PHOTO, Photo));
#line 4597 "../src/Photo.vala"
				raw_rows = _tmp46_;
#line 4598 "../src/Photo.vala"
				_tmp47_ = raw_rows;
#line 4598 "../src/Photo.vala"
				if (_tmp47_ != NULL) {
#line 34370 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp48_;
						GeeIterator* _tmp49_;
#line 4599 "../src/Photo.vala"
						_tmp48_ = raw_rows;
#line 4599 "../src/Photo.vala"
						_tmp49_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4599 "../src/Photo.vala"
						_row_it = _tmp49_;
#line 4599 "../src/Photo.vala"
						while (TRUE) {
#line 34383 "Photo.c"
							GeeIterator* _tmp50_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp51_;
							gpointer _tmp52_;
							BackingPhotoRow* _tmp53_;
#line 4599 "../src/Photo.vala"
							_tmp50_ = _row_it;
#line 4599 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp50_)) {
#line 4599 "../src/Photo.vala"
								break;
#line 34395 "Photo.c"
							}
#line 4599 "../src/Photo.vala"
							_tmp51_ = _row_it;
#line 4599 "../src/Photo.vala"
							_tmp52_ = gee_iterator_get (_tmp51_);
#line 4599 "../src/Photo.vala"
							row = (BackingPhotoRow*) _tmp52_;
#line 4600 "../src/Photo.vala"
							_tmp53_ = row;
#line 4600 "../src/Photo.vala"
							if (_tmp53_->filesize >= ((gint64) 0)) {
#line 34407 "Photo.c"
								GeeMultiMap* _tmp54_;
								BackingPhotoRow* _tmp55_;
								LibraryPhoto* _tmp56_;
								GeeMultiMap* _tmp57_;
								LibraryPhoto* _tmp58_;
								BackingPhotoRow* _tmp59_;
#line 4601 "../src/Photo.vala"
								_tmp54_ = self->priv->filesize_to_photo;
#line 4601 "../src/Photo.vala"
								_tmp55_ = row;
#line 4601 "../src/Photo.vala"
								_tmp56_ = photo;
#line 4601 "../src/Photo.vala"
								gee_multi_map_set (_tmp54_, &_tmp55_->filesize, _tmp56_);
#line 4602 "../src/Photo.vala"
								_tmp57_ = self->priv->photo_to_raw_development_filesize;
#line 4602 "../src/Photo.vala"
								_tmp58_ = photo;
#line 4602 "../src/Photo.vala"
								_tmp59_ = row;
#line 4602 "../src/Photo.vala"
								gee_multi_map_set (_tmp57_, _tmp58_, &_tmp59_->filesize);
#line 34430 "Photo.c"
							}
#line 4599 "../src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 34434 "Photo.c"
						}
#line 4599 "../src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 34438 "Photo.c"
					}
				}
#line 4572 "../src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4572 "../src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4572 "../src/Photo.vala"
				_g_object_unref0 (editable);
#line 4572 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4572 "../src/Photo.vala"
				_g_object_unref0 (object);
#line 34451 "Photo.c"
			}
#line 4572 "../src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 34455 "Photo.c"
		}
	}
#line 4609 "../src/Photo.vala"
	if (removed != NULL) {
#line 34460 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp60_;
#line 4610 "../src/Photo.vala"
			_tmp60_ = gee_iterable_iterator (removed);
#line 4610 "../src/Photo.vala"
			_object_it = _tmp60_;
#line 4610 "../src/Photo.vala"
			while (TRUE) {
#line 34470 "Photo.c"
				GeeIterator* _tmp61_;
				DataObject* object = NULL;
				GeeIterator* _tmp62_;
				gpointer _tmp63_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp64_;
				LibraryPhoto* _tmp65_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp66_;
				GFile* _tmp67_;
				GFile* _tmp68_;
				LibraryPhoto* _tmp74_;
				guint _tmp75_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp76_;
				GeeCollection* _tmp77_;
				GeeCollection* _tmp78_;
				LibraryPhoto* _tmp86_;
				guint _tmp87_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp88_;
				BackingPhotoRow* _tmp89_;
				BackingPhotoRow* _tmp90_;
				gint64 _tmp91_;
				gint64 _tmp92_ = 0LL;
				LibraryPhoto* _tmp93_;
				BackingPhotoRow* _tmp94_;
				BackingPhotoRow* _tmp95_;
				gboolean _tmp96_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp100_;
				LibraryPhoto* _tmp101_;
				GeeHashMap* _tmp102_;
				LibraryPhoto* _tmp103_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp108_;
				GeeCollection* _tmp109_;
				GeeCollection* _tmp110_;
#line 4610 "../src/Photo.vala"
				_tmp61_ = _object_it;
#line 4610 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp61_)) {
#line 4610 "../src/Photo.vala"
					break;
#line 34515 "Photo.c"
				}
#line 4610 "../src/Photo.vala"
				_tmp62_ = _object_it;
#line 4610 "../src/Photo.vala"
				_tmp63_ = gee_iterator_get (_tmp62_);
#line 4610 "../src/Photo.vala"
				object = (DataObject*) _tmp63_;
#line 4611 "../src/Photo.vala"
				_tmp64_ = object;
#line 4611 "../src/Photo.vala"
				_tmp65_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4611 "../src/Photo.vala"
				photo = _tmp65_;
#line 4613 "../src/Photo.vala"
				_tmp66_ = photo;
#line 4613 "../src/Photo.vala"
				_tmp67_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, TYPE_PHOTO, Photo));
#line 4613 "../src/Photo.vala"
				editable = _tmp67_;
#line 4614 "../src/Photo.vala"
				_tmp68_ = editable;
#line 4614 "../src/Photo.vala"
				if (_tmp68_ != NULL) {
#line 34539 "Photo.c"
					gboolean is_removed = FALSE;
					GeeHashMap* _tmp69_;
					LibraryPhoto* _tmp70_;
					GFile* _tmp71_;
					GFile* _tmp72_;
					gboolean _tmp73_;
#line 4615 "../src/Photo.vala"
					_tmp69_ = self->priv->by_editable_file;
#line 4615 "../src/Photo.vala"
					_tmp70_ = photo;
#line 4615 "../src/Photo.vala"
					_tmp71_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, TYPE_PHOTO, Photo));
#line 4615 "../src/Photo.vala"
					_tmp72_ = _tmp71_;
#line 4615 "../src/Photo.vala"
					_tmp73_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp72_, NULL);
#line 4615 "../src/Photo.vala"
					_g_object_unref0 (_tmp72_);
#line 4615 "../src/Photo.vala"
					is_removed = _tmp73_;
#line 4616 "../src/Photo.vala"
					_vala_assert (is_removed, "is_removed");
#line 34562 "Photo.c"
				}
#line 4618 "../src/Photo.vala"
				_tmp74_ = photo;
#line 4618 "../src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp75_, NULL, FALSE);
#line 4618 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp75_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4620 "../src/Photo.vala"
				_tmp76_ = photo;
#line 4620 "../src/Photo.vala"
				_tmp77_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, TYPE_PHOTO, Photo));
#line 4620 "../src/Photo.vala"
				raw_list = _tmp77_;
#line 4621 "../src/Photo.vala"
				_tmp78_ = raw_list;
#line 4621 "../src/Photo.vala"
				if (_tmp78_ != NULL) {
#line 34580 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp79_;
						GeeIterator* _tmp80_;
#line 4622 "../src/Photo.vala"
						_tmp79_ = raw_list;
#line 4622 "../src/Photo.vala"
						_tmp80_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4622 "../src/Photo.vala"
						_f_it = _tmp80_;
#line 4622 "../src/Photo.vala"
						while (TRUE) {
#line 34593 "Photo.c"
							GeeIterator* _tmp81_;
							GFile* f = NULL;
							GeeIterator* _tmp82_;
							gpointer _tmp83_;
							GeeHashMap* _tmp84_;
							GFile* _tmp85_;
#line 4622 "../src/Photo.vala"
							_tmp81_ = _f_it;
#line 4622 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp81_)) {
#line 4622 "../src/Photo.vala"
								break;
#line 34606 "Photo.c"
							}
#line 4622 "../src/Photo.vala"
							_tmp82_ = _f_it;
#line 4622 "../src/Photo.vala"
							_tmp83_ = gee_iterator_get (_tmp82_);
#line 4622 "../src/Photo.vala"
							f = (GFile*) _tmp83_;
#line 4623 "../src/Photo.vala"
							_tmp84_ = self->priv->by_raw_development_file;
#line 4623 "../src/Photo.vala"
							_tmp85_ = f;
#line 4623 "../src/Photo.vala"
							gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp84_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp85_, NULL);
#line 4622 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 34622 "Photo.c"
						}
#line 4622 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 34626 "Photo.c"
					}
				}
#line 4624 "../src/Photo.vala"
				_tmp86_ = photo;
#line 4624 "../src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp87_, NULL, FALSE);
#line 4624 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp86_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp87_, 0, NULL, (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4626 "../src/Photo.vala"
				_tmp88_ = photo;
#line 4626 "../src/Photo.vala"
				_tmp89_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp88_, TYPE_PHOTO, Photo));
#line 4626 "../src/Photo.vala"
				_tmp90_ = _tmp89_;
#line 4626 "../src/Photo.vala"
				_tmp91_ = _tmp90_->filesize;
#line 4626 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp90_);
#line 4626 "../src/Photo.vala"
				master_filesize = _tmp91_;
#line 4627 "../src/Photo.vala"
				_tmp93_ = photo;
#line 4627 "../src/Photo.vala"
				_tmp94_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp93_, TYPE_PHOTO, Photo));
#line 4627 "../src/Photo.vala"
				_tmp95_ = _tmp94_;
#line 4627 "../src/Photo.vala"
				_tmp96_ = _tmp95_ != NULL;
#line 4627 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp95_);
#line 4627 "../src/Photo.vala"
				if (_tmp96_) {
#line 34659 "Photo.c"
					LibraryPhoto* _tmp97_;
					BackingPhotoRow* _tmp98_;
					BackingPhotoRow* _tmp99_;
#line 4628 "../src/Photo.vala"
					_tmp97_ = photo;
#line 4628 "../src/Photo.vala"
					_tmp98_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp97_, TYPE_PHOTO, Photo));
#line 4628 "../src/Photo.vala"
					_tmp99_ = _tmp98_;
#line 4628 "../src/Photo.vala"
					_tmp92_ = _tmp99_->filesize;
#line 4628 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp99_);
#line 34673 "Photo.c"
				} else {
#line 4629 "../src/Photo.vala"
					_tmp92_ = (gint64) -1;
#line 34677 "Photo.c"
				}
#line 4627 "../src/Photo.vala"
				editable_filesize = _tmp92_;
#line 4630 "../src/Photo.vala"
				_tmp100_ = self->priv->filesize_to_photo;
#line 4630 "../src/Photo.vala"
				_tmp101_ = photo;
#line 4630 "../src/Photo.vala"
				gee_multi_map_remove (_tmp100_, &master_filesize, _tmp101_);
#line 4631 "../src/Photo.vala"
				_tmp102_ = self->priv->photo_to_master_filesize;
#line 4631 "../src/Photo.vala"
				_tmp103_ = photo;
#line 4631 "../src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp102_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp103_, NULL);
#line 4632 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 34695 "Photo.c"
					GeeMultiMap* _tmp104_;
					LibraryPhoto* _tmp105_;
					GeeHashMap* _tmp106_;
					LibraryPhoto* _tmp107_;
#line 4633 "../src/Photo.vala"
					_tmp104_ = self->priv->filesize_to_photo;
#line 4633 "../src/Photo.vala"
					_tmp105_ = photo;
#line 4633 "../src/Photo.vala"
					gee_multi_map_remove (_tmp104_, &editable_filesize, _tmp105_);
#line 4634 "../src/Photo.vala"
					_tmp106_ = self->priv->photo_to_editable_filesize;
#line 4634 "../src/Photo.vala"
					_tmp107_ = photo;
#line 4634 "../src/Photo.vala"
					gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp106_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp107_, NULL);
#line 34712 "Photo.c"
				}
#line 4637 "../src/Photo.vala"
				_tmp108_ = photo;
#line 4637 "../src/Photo.vala"
				_tmp109_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp108_, TYPE_PHOTO, Photo));
#line 4637 "../src/Photo.vala"
				raw_rows = _tmp109_;
#line 4638 "../src/Photo.vala"
				_tmp110_ = raw_rows;
#line 4638 "../src/Photo.vala"
				if (_tmp110_ != NULL) {
#line 34724 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp111_;
						GeeIterator* _tmp112_;
#line 4639 "../src/Photo.vala"
						_tmp111_ = raw_rows;
#line 4639 "../src/Photo.vala"
						_tmp112_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp111_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4639 "../src/Photo.vala"
						_row_it = _tmp112_;
#line 4639 "../src/Photo.vala"
						while (TRUE) {
#line 34737 "Photo.c"
							GeeIterator* _tmp113_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp114_;
							gpointer _tmp115_;
							BackingPhotoRow* _tmp116_;
#line 4639 "../src/Photo.vala"
							_tmp113_ = _row_it;
#line 4639 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp113_)) {
#line 4639 "../src/Photo.vala"
								break;
#line 34749 "Photo.c"
							}
#line 4639 "../src/Photo.vala"
							_tmp114_ = _row_it;
#line 4639 "../src/Photo.vala"
							_tmp115_ = gee_iterator_get (_tmp114_);
#line 4639 "../src/Photo.vala"
							row = (BackingPhotoRow*) _tmp115_;
#line 4640 "../src/Photo.vala"
							_tmp116_ = row;
#line 4640 "../src/Photo.vala"
							if (_tmp116_->filesize >= ((gint64) 0)) {
#line 34761 "Photo.c"
								GeeMultiMap* _tmp117_;
								BackingPhotoRow* _tmp118_;
								LibraryPhoto* _tmp119_;
								GeeMultiMap* _tmp120_;
								LibraryPhoto* _tmp121_;
								BackingPhotoRow* _tmp122_;
#line 4641 "../src/Photo.vala"
								_tmp117_ = self->priv->filesize_to_photo;
#line 4641 "../src/Photo.vala"
								_tmp118_ = row;
#line 4641 "../src/Photo.vala"
								_tmp119_ = photo;
#line 4641 "../src/Photo.vala"
								gee_multi_map_remove (_tmp117_, &_tmp118_->filesize, _tmp119_);
#line 4642 "../src/Photo.vala"
								_tmp120_ = self->priv->photo_to_raw_development_filesize;
#line 4642 "../src/Photo.vala"
								_tmp121_ = photo;
#line 4642 "../src/Photo.vala"
								_tmp122_ = row;
#line 4642 "../src/Photo.vala"
								gee_multi_map_remove (_tmp120_, _tmp121_, &_tmp122_->filesize);
#line 34784 "Photo.c"
							}
#line 4639 "../src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 34788 "Photo.c"
						}
#line 4639 "../src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 34792 "Photo.c"
					}
				}
#line 4610 "../src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4610 "../src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4610 "../src/Photo.vala"
				_g_object_unref0 (editable);
#line 4610 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4610 "../src/Photo.vala"
				_g_object_unref0 (object);
#line 34805 "Photo.c"
			}
#line 4610 "../src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 34809 "Photo.c"
		}
	}
#line 4649 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), added, removed);
#line 34814 "Photo.c"
}

static void
library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                      Photo* photo,
                                                      GFile* old_file,
                                                      GFile* new_file)
{
#line 4652 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4652 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 4652 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 4652 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 4653 "../src/Photo.vala"
	if (old_file != NULL) {
#line 34833 "Photo.c"
		gboolean is_removed = FALSE;
		GeeHashMap* _tmp0_;
#line 4654 "../src/Photo.vala"
		_tmp0_ = self->priv->by_editable_file;
#line 4654 "../src/Photo.vala"
		is_removed = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), old_file, NULL);
#line 4655 "../src/Photo.vala"
		_vala_assert (is_removed, "is_removed");
#line 34842 "Photo.c"
	}
#line 4658 "../src/Photo.vala"
	if (new_file != NULL) {
#line 34846 "Photo.c"
		GeeHashMap* _tmp1_;
#line 4659 "../src/Photo.vala"
		_tmp1_ = self->priv->by_editable_file;
#line 4659 "../src/Photo.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), new_file, G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 34852 "Photo.c"
	}
}

static void
library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                             Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp19_;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp21_;
	GeeCollection* raw_rows = NULL;
	LibraryPhoto* _tmp30_;
	GeeCollection* _tmp31_;
	GeeCollection* _tmp32_;
#line 4662 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4662 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 4663 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 4663 "../src/Photo.vala"
	photo = _tmp0_;
#line 4664 "../src/Photo.vala"
	_tmp1_ = photo;
#line 4664 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4665 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4665 "../src/Photo.vala"
		return;
#line 34889 "Photo.c"
	}
#line 4668 "../src/Photo.vala"
	_tmp2_ = self->priv->photo_to_raw_development_filesize;
#line 4668 "../src/Photo.vala"
	_tmp3_ = photo;
#line 4668 "../src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 34897 "Photo.c"
		GeeMultiMap* _tmp17_;
		LibraryPhoto* _tmp18_;
		{
			GeeIterator* _s_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 4669 "../src/Photo.vala"
			_tmp4_ = self->priv->photo_to_raw_development_filesize;
#line 4669 "../src/Photo.vala"
			_tmp5_ = photo;
#line 4669 "../src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 4669 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 4669 "../src/Photo.vala"
			_tmp8_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4669 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4669 "../src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 4669 "../src/Photo.vala"
			_s_it = _tmp9_;
#line 4669 "../src/Photo.vala"
			while (TRUE) {
#line 34926 "Photo.c"
				GeeIterator* _tmp10_;
				gint64 s = 0LL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				gint64* _tmp13_;
				gint64 _tmp14_;
				GeeMultiMap* _tmp15_;
				LibraryPhoto* _tmp16_;
#line 4669 "../src/Photo.vala"
				_tmp10_ = _s_it;
#line 4669 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 4669 "../src/Photo.vala"
					break;
#line 34941 "Photo.c"
				}
#line 4669 "../src/Photo.vala"
				_tmp11_ = _s_it;
#line 4669 "../src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 4669 "../src/Photo.vala"
				_tmp13_ = (gint64*) _tmp12_;
#line 4669 "../src/Photo.vala"
				_tmp14_ = *_tmp13_;
#line 4669 "../src/Photo.vala"
				_g_free0 (_tmp13_);
#line 4669 "../src/Photo.vala"
				s = _tmp14_;
#line 4670 "../src/Photo.vala"
				_tmp15_ = self->priv->filesize_to_photo;
#line 4670 "../src/Photo.vala"
				_tmp16_ = photo;
#line 4670 "../src/Photo.vala"
				gee_multi_map_remove (_tmp15_, &s, _tmp16_);
#line 34961 "Photo.c"
			}
#line 4669 "../src/Photo.vala"
			_g_object_unref0 (_s_it);
#line 34965 "Photo.c"
		}
#line 4671 "../src/Photo.vala"
		_tmp17_ = self->priv->photo_to_raw_development_filesize;
#line 4671 "../src/Photo.vala"
		_tmp18_ = photo;
#line 4671 "../src/Photo.vala"
		gee_multi_map_remove_all (_tmp17_, _tmp18_);
#line 34973 "Photo.c"
	}
#line 4675 "../src/Photo.vala"
	_tmp19_ = photo;
#line 4675 "../src/Photo.vala"
	_tmp20_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_PHOTO, Photo));
#line 4675 "../src/Photo.vala"
	raw_list = _tmp20_;
#line 4676 "../src/Photo.vala"
	_tmp21_ = raw_list;
#line 4676 "../src/Photo.vala"
	if (_tmp21_ != NULL) {
#line 34985 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp22_;
			GeeIterator* _tmp23_;
#line 4677 "../src/Photo.vala"
			_tmp22_ = raw_list;
#line 4677 "../src/Photo.vala"
			_tmp23_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4677 "../src/Photo.vala"
			_f_it = _tmp23_;
#line 4677 "../src/Photo.vala"
			while (TRUE) {
#line 34998 "Photo.c"
				GeeIterator* _tmp24_;
				GFile* f = NULL;
				GeeIterator* _tmp25_;
				gpointer _tmp26_;
				GeeHashMap* _tmp27_;
				GFile* _tmp28_;
				LibraryPhoto* _tmp29_;
#line 4677 "../src/Photo.vala"
				_tmp24_ = _f_it;
#line 4677 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp24_)) {
#line 4677 "../src/Photo.vala"
					break;
#line 35012 "Photo.c"
				}
#line 4677 "../src/Photo.vala"
				_tmp25_ = _f_it;
#line 4677 "../src/Photo.vala"
				_tmp26_ = gee_iterator_get (_tmp25_);
#line 4677 "../src/Photo.vala"
				f = (GFile*) _tmp26_;
#line 4678 "../src/Photo.vala"
				_tmp27_ = self->priv->by_raw_development_file;
#line 4678 "../src/Photo.vala"
				_tmp28_ = f;
#line 4678 "../src/Photo.vala"
				_tmp29_ = photo;
#line 4678 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp28_, _tmp29_);
#line 4677 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 35030 "Photo.c"
			}
#line 4677 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 35034 "Photo.c"
		}
	}
#line 4680 "../src/Photo.vala"
	_tmp30_ = photo;
#line 4680 "../src/Photo.vala"
	_tmp31_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_PHOTO, Photo));
#line 4680 "../src/Photo.vala"
	raw_rows = _tmp31_;
#line 4681 "../src/Photo.vala"
	_tmp32_ = raw_rows;
#line 4681 "../src/Photo.vala"
	if (_tmp32_ != NULL) {
#line 35047 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp33_;
			GeeIterator* _tmp34_;
#line 4682 "../src/Photo.vala"
			_tmp33_ = raw_rows;
#line 4682 "../src/Photo.vala"
			_tmp34_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4682 "../src/Photo.vala"
			_row_it = _tmp34_;
#line 4682 "../src/Photo.vala"
			while (TRUE) {
#line 35060 "Photo.c"
				GeeIterator* _tmp35_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp36_;
				gpointer _tmp37_;
				BackingPhotoRow* _tmp38_;
#line 4682 "../src/Photo.vala"
				_tmp35_ = _row_it;
#line 4682 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp35_)) {
#line 4682 "../src/Photo.vala"
					break;
#line 35072 "Photo.c"
				}
#line 4682 "../src/Photo.vala"
				_tmp36_ = _row_it;
#line 4682 "../src/Photo.vala"
				_tmp37_ = gee_iterator_get (_tmp36_);
#line 4682 "../src/Photo.vala"
				row = (BackingPhotoRow*) _tmp37_;
#line 4683 "../src/Photo.vala"
				_tmp38_ = row;
#line 4683 "../src/Photo.vala"
				if (_tmp38_->filesize > ((gint64) 0)) {
#line 35084 "Photo.c"
					GeeMultiMap* _tmp39_;
					BackingPhotoRow* _tmp40_;
					LibraryPhoto* _tmp41_;
					GeeMultiMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					BackingPhotoRow* _tmp44_;
#line 4684 "../src/Photo.vala"
					_tmp39_ = self->priv->filesize_to_photo;
#line 4684 "../src/Photo.vala"
					_tmp40_ = row;
#line 4684 "../src/Photo.vala"
					_tmp41_ = photo;
#line 4684 "../src/Photo.vala"
					gee_multi_map_set (_tmp39_, &_tmp40_->filesize, _tmp41_);
#line 4685 "../src/Photo.vala"
					_tmp42_ = self->priv->photo_to_raw_development_filesize;
#line 4685 "../src/Photo.vala"
					_tmp43_ = photo;
#line 4685 "../src/Photo.vala"
					_tmp44_ = row;
#line 4685 "../src/Photo.vala"
					gee_multi_map_set (_tmp42_, _tmp43_, &_tmp44_->filesize);
#line 35107 "Photo.c"
				}
#line 4682 "../src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 35111 "Photo.c"
			}
#line 4682 "../src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 35115 "Photo.c"
		}
	}
#line 4662 "../src/Photo.vala"
	_g_object_unref0 (raw_rows);
#line 4662 "../src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 4662 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 35124 "Photo.c"
}

static gpointer
__int64_dup0 (gpointer self)
{
#line 4701 "../src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 35132 "Photo.c"
}

static void
library_photo_source_collection_real_items_altered (DataCollection* base,
                                                    GeeMap* items)
{
	LibraryPhotoSourceCollection * self;
#line 4691 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4691 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (items, GEE_TYPE_MAP));
#line 35144 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4692 "../src/Photo.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 4692 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4692 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4692 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4692 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4692 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4692 "../src/Photo.vala"
		_object_it = _tmp4_;
#line 4692 "../src/Photo.vala"
		while (TRUE) {
#line 35168 "Photo.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Alteration* alteration = NULL;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp10_;
			LibraryPhoto* _tmp11_;
			gboolean _tmp12_ = FALSE;
			Alteration* _tmp13_;
#line 4692 "../src/Photo.vala"
			_tmp5_ = _object_it;
#line 4692 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4692 "../src/Photo.vala"
				break;
#line 35187 "Photo.c"
			}
#line 4692 "../src/Photo.vala"
			_tmp6_ = _object_it;
#line 4692 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4692 "../src/Photo.vala"
			object = (DataObject*) _tmp7_;
#line 4693 "../src/Photo.vala"
			_tmp8_ = object;
#line 4693 "../src/Photo.vala"
			_tmp9_ = gee_map_get (items, _tmp8_);
#line 4693 "../src/Photo.vala"
			alteration = (Alteration*) _tmp9_;
#line 4695 "../src/Photo.vala"
			_tmp10_ = object;
#line 4695 "../src/Photo.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4695 "../src/Photo.vala"
			photo = _tmp11_;
#line 4697 "../src/Photo.vala"
			_tmp13_ = alteration;
#line 4697 "../src/Photo.vala"
			if (alteration_has_detail (_tmp13_, "image", "master")) {
#line 4697 "../src/Photo.vala"
				_tmp12_ = TRUE;
#line 35213 "Photo.c"
			} else {
				Alteration* _tmp14_;
#line 4697 "../src/Photo.vala"
				_tmp14_ = alteration;
#line 4697 "../src/Photo.vala"
				_tmp12_ = alteration_has_detail (_tmp14_, "image", "editable");
#line 35220 "Photo.c"
			}
#line 4697 "../src/Photo.vala"
			if (_tmp12_) {
#line 35224 "Photo.c"
				gint64 old_master_filesize = 0LL;
				GeeHashMap* _tmp15_;
				LibraryPhoto* _tmp16_;
				gpointer _tmp17_;
				gint64* _tmp18_;
				gint64 _tmp19_;
				gint64* _tmp20_ = NULL;
				GeeHashMap* _tmp21_;
				LibraryPhoto* _tmp22_;
				gint64 old_editable_filesize = 0LL;
				GeeHashMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GeeMultiMap* _tmp30_;
				LibraryPhoto* _tmp31_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp36_;
				BackingPhotoRow* _tmp37_;
				BackingPhotoRow* _tmp38_;
				gint64 _tmp39_;
				gint64 _tmp40_ = 0LL;
				LibraryPhoto* _tmp41_;
				BackingPhotoRow* _tmp42_;
				BackingPhotoRow* _tmp43_;
				gboolean _tmp44_;
				gint64 editable_filesize = 0LL;
				GeeHashMap* _tmp48_;
				LibraryPhoto* _tmp49_;
				GeeMultiMap* _tmp50_;
				LibraryPhoto* _tmp51_;
#line 4698 "../src/Photo.vala"
				_tmp15_ = self->priv->photo_to_master_filesize;
#line 4698 "../src/Photo.vala"
				_tmp16_ = photo;
#line 4698 "../src/Photo.vala"
				_tmp17_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp16_);
#line 4698 "../src/Photo.vala"
				_tmp18_ = (gint64*) _tmp17_;
#line 4698 "../src/Photo.vala"
				_tmp19_ = *_tmp18_;
#line 4698 "../src/Photo.vala"
				_g_free0 (_tmp18_);
#line 4698 "../src/Photo.vala"
				old_master_filesize = _tmp19_;
#line 4699 "../src/Photo.vala"
				_tmp21_ = self->priv->photo_to_editable_filesize;
#line 4699 "../src/Photo.vala"
				_tmp22_ = photo;
#line 4699 "../src/Photo.vala"
				if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp22_)) {
#line 35274 "Photo.c"
					GeeHashMap* _tmp23_;
					LibraryPhoto* _tmp24_;
					gpointer _tmp25_;
#line 4700 "../src/Photo.vala"
					_tmp23_ = self->priv->photo_to_editable_filesize;
#line 4700 "../src/Photo.vala"
					_tmp24_ = photo;
#line 4700 "../src/Photo.vala"
					_tmp25_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp24_);
#line 4700 "../src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4700 "../src/Photo.vala"
					_tmp20_ = (gint64*) _tmp25_;
#line 35288 "Photo.c"
				} else {
					gint64 _tmp26_;
					gint64* _tmp27_;
#line 4701 "../src/Photo.vala"
					_tmp26_ = (gint64) -1;
#line 4701 "../src/Photo.vala"
					_tmp27_ = __int64_dup0 (&_tmp26_);
#line 4701 "../src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4701 "../src/Photo.vala"
					_tmp20_ = _tmp27_;
#line 35300 "Photo.c"
				}
#line 4699 "../src/Photo.vala"
				old_editable_filesize = *_tmp20_;
#line 4703 "../src/Photo.vala"
				_tmp28_ = self->priv->photo_to_master_filesize;
#line 4703 "../src/Photo.vala"
				_tmp29_ = photo;
#line 4703 "../src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp29_, NULL);
#line 4704 "../src/Photo.vala"
				_tmp30_ = self->priv->filesize_to_photo;
#line 4704 "../src/Photo.vala"
				_tmp31_ = photo;
#line 4704 "../src/Photo.vala"
				gee_multi_map_remove (_tmp30_, &old_master_filesize, _tmp31_);
#line 4705 "../src/Photo.vala"
				if (old_editable_filesize >= ((gint64) 0)) {
#line 35318 "Photo.c"
					GeeHashMap* _tmp32_;
					LibraryPhoto* _tmp33_;
					GeeMultiMap* _tmp34_;
					LibraryPhoto* _tmp35_;
#line 4706 "../src/Photo.vala"
					_tmp32_ = self->priv->photo_to_editable_filesize;
#line 4706 "../src/Photo.vala"
					_tmp33_ = photo;
#line 4706 "../src/Photo.vala"
					gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp33_, NULL);
#line 4707 "../src/Photo.vala"
					_tmp34_ = self->priv->filesize_to_photo;
#line 4707 "../src/Photo.vala"
					_tmp35_ = photo;
#line 4707 "../src/Photo.vala"
					gee_multi_map_remove (_tmp34_, &old_editable_filesize, _tmp35_);
#line 35335 "Photo.c"
				}
#line 4710 "../src/Photo.vala"
				_tmp36_ = photo;
#line 4710 "../src/Photo.vala"
				_tmp37_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, TYPE_PHOTO, Photo));
#line 4710 "../src/Photo.vala"
				_tmp38_ = _tmp37_;
#line 4710 "../src/Photo.vala"
				_tmp39_ = _tmp38_->filesize;
#line 4710 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp38_);
#line 4710 "../src/Photo.vala"
				master_filesize = _tmp39_;
#line 4711 "../src/Photo.vala"
				_tmp41_ = photo;
#line 4711 "../src/Photo.vala"
				_tmp42_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_PHOTO, Photo));
#line 4711 "../src/Photo.vala"
				_tmp43_ = _tmp42_;
#line 4711 "../src/Photo.vala"
				_tmp44_ = _tmp43_ != NULL;
#line 4711 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp43_);
#line 4711 "../src/Photo.vala"
				if (_tmp44_) {
#line 35361 "Photo.c"
					LibraryPhoto* _tmp45_;
					BackingPhotoRow* _tmp46_;
					BackingPhotoRow* _tmp47_;
#line 4712 "../src/Photo.vala"
					_tmp45_ = photo;
#line 4712 "../src/Photo.vala"
					_tmp46_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, TYPE_PHOTO, Photo));
#line 4712 "../src/Photo.vala"
					_tmp47_ = _tmp46_;
#line 4712 "../src/Photo.vala"
					_tmp40_ = _tmp47_->filesize;
#line 4712 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp47_);
#line 35375 "Photo.c"
				} else {
#line 4713 "../src/Photo.vala"
					_tmp40_ = (gint64) -1;
#line 35379 "Photo.c"
				}
#line 4711 "../src/Photo.vala"
				editable_filesize = _tmp40_;
#line 4714 "../src/Photo.vala"
				_tmp48_ = self->priv->photo_to_master_filesize;
#line 4714 "../src/Photo.vala"
				_tmp49_ = photo;
#line 4714 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp49_, &master_filesize);
#line 4715 "../src/Photo.vala"
				_tmp50_ = self->priv->filesize_to_photo;
#line 4715 "../src/Photo.vala"
				_tmp51_ = photo;
#line 4715 "../src/Photo.vala"
				gee_multi_map_set (_tmp50_, &master_filesize, _tmp51_);
#line 4716 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 35397 "Photo.c"
					GeeHashMap* _tmp52_;
					LibraryPhoto* _tmp53_;
					GeeMultiMap* _tmp54_;
					LibraryPhoto* _tmp55_;
#line 4717 "../src/Photo.vala"
					_tmp52_ = self->priv->photo_to_editable_filesize;
#line 4717 "../src/Photo.vala"
					_tmp53_ = photo;
#line 4717 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp53_, &editable_filesize);
#line 4718 "../src/Photo.vala"
					_tmp54_ = self->priv->filesize_to_photo;
#line 4718 "../src/Photo.vala"
					_tmp55_ = photo;
#line 4718 "../src/Photo.vala"
					gee_multi_map_set (_tmp54_, &editable_filesize, _tmp55_);
#line 35414 "Photo.c"
				}
#line 4697 "../src/Photo.vala"
				_g_free0 (_tmp20_);
#line 35418 "Photo.c"
			}
#line 4692 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4692 "../src/Photo.vala"
			_alteration_unref0 (alteration);
#line 4692 "../src/Photo.vala"
			_g_object_unref0 (object);
#line 35426 "Photo.c"
		}
#line 4692 "../src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 35430 "Photo.c"
	}
#line 4723 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), items);
#line 35434 "Photo.c"
}

static void
library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                 GeeCollection* media_sources)
{
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_;
#line 4727 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4727 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (media_sources, GEE_TYPE_COLLECTION));
#line 4728 "../src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4728 "../src/Photo.vala"
	map = _tmp0_;
#line 35452 "Photo.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
#line 4729 "../src/Photo.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 4729 "../src/Photo.vala"
		_media_it = _tmp1_;
#line 4729 "../src/Photo.vala"
		while (TRUE) {
#line 35462 "Photo.c"
			GeeIterator* _tmp2_;
			MediaSource* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp5_;
			LibraryPhoto* _tmp6_;
			PhotoMetadata* metadata = NULL;
			LibraryPhoto* _tmp7_;
			PhotoMetadata* _tmp8_;
			HierarchicalTagIndex* global_index = NULL;
			HierarchicalTagIndex* _tmp9_;
			HierarchicalTagIndex* htag_index = NULL;
			gboolean _tmp10_ = FALSE;
			PhotoMetadata* _tmp11_;
			LibraryPhoto* _tmp17_;
			GeeCollection* _tmp18_;
			GeeCollection* _tmp19_;
			gboolean _tmp20_;
			gboolean _tmp51_ = FALSE;
			PhotoMetadata* _tmp52_;
#line 4729 "../src/Photo.vala"
			_tmp2_ = _media_it;
#line 4729 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 4729 "../src/Photo.vala"
				break;
#line 35490 "Photo.c"
			}
#line 4729 "../src/Photo.vala"
			_tmp3_ = _media_it;
#line 4729 "../src/Photo.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 4729 "../src/Photo.vala"
			media = (MediaSource*) _tmp4_;
#line 4730 "../src/Photo.vala"
			_tmp5_ = media;
#line 4730 "../src/Photo.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4730 "../src/Photo.vala"
			photo = _tmp6_;
#line 4731 "../src/Photo.vala"
			_tmp7_ = photo;
#line 4731 "../src/Photo.vala"
			_tmp8_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PHOTO_SOURCE, PhotoSource));
#line 4731 "../src/Photo.vala"
			metadata = _tmp8_;
#line 4734 "../src/Photo.vala"
			_tmp9_ = hierarchical_tag_index_get_global_index ();
#line 4734 "../src/Photo.vala"
			global_index = _tmp9_;
#line 4741 "../src/Photo.vala"
			htag_index = NULL;
#line 4742 "../src/Photo.vala"
			_tmp11_ = metadata;
#line 4742 "../src/Photo.vala"
			if (_tmp11_ != NULL) {
#line 35520 "Photo.c"
				PhotoMetadata* _tmp12_;
#line 4742 "../src/Photo.vala"
				_tmp12_ = metadata;
#line 4742 "../src/Photo.vala"
				_tmp10_ = photo_metadata_has_hierarchical_keywords (_tmp12_);
#line 35526 "Photo.c"
			} else {
#line 4742 "../src/Photo.vala"
				_tmp10_ = FALSE;
#line 35530 "Photo.c"
			}
#line 4742 "../src/Photo.vala"
			if (_tmp10_) {
#line 35534 "Photo.c"
				PhotoMetadata* _tmp13_;
				GeeSet* _tmp14_;
				GeeSet* _tmp15_;
				HierarchicalTagIndex* _tmp16_;
#line 4743 "../src/Photo.vala"
				_tmp13_ = metadata;
#line 4743 "../src/Photo.vala"
				_tmp14_ = photo_metadata_get_hierarchical_keywords (_tmp13_);
#line 4743 "../src/Photo.vala"
				_tmp15_ = _tmp14_;
#line 4743 "../src/Photo.vala"
				_tmp16_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 4743 "../src/Photo.vala"
				_hierarchical_tag_index_unref0 (htag_index);
#line 4743 "../src/Photo.vala"
				htag_index = _tmp16_;
#line 4743 "../src/Photo.vala"
				_g_object_unref0 (_tmp15_);
#line 35553 "Photo.c"
			}
#line 4747 "../src/Photo.vala"
			_tmp17_ = photo;
#line 4747 "../src/Photo.vala"
			_tmp18_ = library_photo_get_import_keywords (_tmp17_);
#line 4747 "../src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 4747 "../src/Photo.vala"
			_tmp20_ = _tmp19_ != NULL;
#line 4747 "../src/Photo.vala"
			_g_object_unref0 (_tmp19_);
#line 4747 "../src/Photo.vala"
			if (_tmp20_) {
#line 35567 "Photo.c"
				{
					GeeIterator* _keyword_it = NULL;
					LibraryPhoto* _tmp21_;
					GeeCollection* _tmp22_;
					GeeCollection* _tmp23_;
					GeeIterator* _tmp24_;
					GeeIterator* _tmp25_;
#line 4748 "../src/Photo.vala"
					_tmp21_ = photo;
#line 4748 "../src/Photo.vala"
					_tmp22_ = library_photo_get_import_keywords (_tmp21_);
#line 4748 "../src/Photo.vala"
					_tmp23_ = _tmp22_;
#line 4748 "../src/Photo.vala"
					_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4748 "../src/Photo.vala"
					_tmp25_ = _tmp24_;
#line 4748 "../src/Photo.vala"
					_g_object_unref0 (_tmp23_);
#line 4748 "../src/Photo.vala"
					_keyword_it = _tmp25_;
#line 4748 "../src/Photo.vala"
					while (TRUE) {
#line 35591 "Photo.c"
						GeeIterator* _tmp26_;
						gchar* keyword = NULL;
						GeeIterator* _tmp27_;
						gpointer _tmp28_;
						gboolean _tmp29_ = FALSE;
						HierarchicalTagIndex* _tmp30_;
						gchar* name = NULL;
						const gchar* _tmp33_;
						gchar* _tmp34_;
						HierarchicalTagIndex* _tmp35_;
						const gchar* _tmp36_;
						const gchar* _tmp45_;
#line 4748 "../src/Photo.vala"
						_tmp26_ = _keyword_it;
#line 4748 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp26_)) {
#line 4748 "../src/Photo.vala"
							break;
#line 35610 "Photo.c"
						}
#line 4748 "../src/Photo.vala"
						_tmp27_ = _keyword_it;
#line 4748 "../src/Photo.vala"
						_tmp28_ = gee_iterator_get (_tmp27_);
#line 4748 "../src/Photo.vala"
						keyword = (gchar*) _tmp28_;
#line 4749 "../src/Photo.vala"
						_tmp30_ = htag_index;
#line 4749 "../src/Photo.vala"
						if (_tmp30_ != NULL) {
#line 35622 "Photo.c"
							HierarchicalTagIndex* _tmp31_;
							const gchar* _tmp32_;
#line 4749 "../src/Photo.vala"
							_tmp31_ = htag_index;
#line 4749 "../src/Photo.vala"
							_tmp32_ = keyword;
#line 4749 "../src/Photo.vala"
							_tmp29_ = hierarchical_tag_index_is_tag_in_index (_tmp31_, _tmp32_);
#line 35631 "Photo.c"
						} else {
#line 4749 "../src/Photo.vala"
							_tmp29_ = FALSE;
#line 35635 "Photo.c"
						}
#line 4749 "../src/Photo.vala"
						if (_tmp29_) {
#line 4750 "../src/Photo.vala"
							_g_free0 (keyword);
#line 4750 "../src/Photo.vala"
							continue;
#line 35643 "Photo.c"
						}
#line 4752 "../src/Photo.vala"
						_tmp33_ = keyword;
#line 4752 "../src/Photo.vala"
						_tmp34_ = tag_prep_tag_name (_tmp33_);
#line 4752 "../src/Photo.vala"
						name = _tmp34_;
#line 4754 "../src/Photo.vala"
						_tmp35_ = global_index;
#line 4754 "../src/Photo.vala"
						_tmp36_ = name;
#line 4754 "../src/Photo.vala"
						if (hierarchical_tag_index_is_tag_in_index (_tmp35_, _tmp36_)) {
#line 35657 "Photo.c"
							gchar* most_derived_path = NULL;
							HierarchicalTagIndex* _tmp37_;
							const gchar* _tmp38_;
							gchar* _tmp39_;
							GeeHashMultiMap* _tmp40_;
							const gchar* _tmp41_;
							Tag* _tmp42_;
							Tag* _tmp43_;
							LibraryPhoto* _tmp44_;
#line 4755 "../src/Photo.vala"
							_tmp37_ = global_index;
#line 4755 "../src/Photo.vala"
							_tmp38_ = name;
#line 4755 "../src/Photo.vala"
							_tmp39_ = hierarchical_tag_index_get_path_for_name (_tmp37_, _tmp38_);
#line 4755 "../src/Photo.vala"
							most_derived_path = _tmp39_;
#line 4756 "../src/Photo.vala"
							_tmp40_ = map;
#line 4756 "../src/Photo.vala"
							_tmp41_ = most_derived_path;
#line 4756 "../src/Photo.vala"
							_tmp42_ = tag_for_path (_tmp41_);
#line 4756 "../src/Photo.vala"
							_tmp43_ = _tmp42_;
#line 4756 "../src/Photo.vala"
							_tmp44_ = photo;
#line 4756 "../src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp43_, _tmp44_);
#line 4756 "../src/Photo.vala"
							_g_object_unref0 (_tmp43_);
#line 4757 "../src/Photo.vala"
							_g_free0 (most_derived_path);
#line 4757 "../src/Photo.vala"
							_g_free0 (name);
#line 4757 "../src/Photo.vala"
							_g_free0 (keyword);
#line 4757 "../src/Photo.vala"
							continue;
#line 35697 "Photo.c"
						}
#line 4760 "../src/Photo.vala"
						_tmp45_ = name;
#line 4760 "../src/Photo.vala"
						if (_tmp45_ != NULL) {
#line 35703 "Photo.c"
							GeeHashMultiMap* _tmp46_;
							const gchar* _tmp47_;
							Tag* _tmp48_;
							Tag* _tmp49_;
							LibraryPhoto* _tmp50_;
#line 4761 "../src/Photo.vala"
							_tmp46_ = map;
#line 4761 "../src/Photo.vala"
							_tmp47_ = name;
#line 4761 "../src/Photo.vala"
							_tmp48_ = tag_for_path (_tmp47_);
#line 4761 "../src/Photo.vala"
							_tmp49_ = _tmp48_;
#line 4761 "../src/Photo.vala"
							_tmp50_ = photo;
#line 4761 "../src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp49_, _tmp50_);
#line 4761 "../src/Photo.vala"
							_g_object_unref0 (_tmp49_);
#line 35723 "Photo.c"
						}
#line 4748 "../src/Photo.vala"
						_g_free0 (name);
#line 4748 "../src/Photo.vala"
						_g_free0 (keyword);
#line 35729 "Photo.c"
					}
#line 4748 "../src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 35733 "Photo.c"
				}
			}
#line 4765 "../src/Photo.vala"
			_tmp52_ = metadata;
#line 4765 "../src/Photo.vala"
			if (_tmp52_ != NULL) {
#line 35740 "Photo.c"
				PhotoMetadata* _tmp53_;
#line 4765 "../src/Photo.vala"
				_tmp53_ = metadata;
#line 4765 "../src/Photo.vala"
				_tmp51_ = photo_metadata_has_hierarchical_keywords (_tmp53_);
#line 35746 "Photo.c"
			} else {
#line 4765 "../src/Photo.vala"
				_tmp51_ = FALSE;
#line 35750 "Photo.c"
			}
#line 4765 "../src/Photo.vala"
			if (_tmp51_) {
#line 35754 "Photo.c"
				{
					GeeIterator* _path_it = NULL;
					HierarchicalTagIndex* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 4766 "../src/Photo.vala"
					_tmp54_ = htag_index;
#line 4766 "../src/Photo.vala"
					_tmp55_ = hierarchical_tag_index_get_all_paths (_tmp54_);
#line 4766 "../src/Photo.vala"
					_tmp56_ = _tmp55_;
#line 4766 "../src/Photo.vala"
					_tmp57_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4766 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 4766 "../src/Photo.vala"
					_g_object_unref0 (_tmp56_);
#line 4766 "../src/Photo.vala"
					_path_it = _tmp58_;
#line 4766 "../src/Photo.vala"
					while (TRUE) {
#line 35778 "Photo.c"
						GeeIterator* _tmp59_;
						gchar* path = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						gchar* name = NULL;
						const gchar* _tmp62_;
						gchar* _tmp63_;
						const gchar* _tmp64_;
#line 4766 "../src/Photo.vala"
						_tmp59_ = _path_it;
#line 4766 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 4766 "../src/Photo.vala"
							break;
#line 35793 "Photo.c"
						}
#line 4766 "../src/Photo.vala"
						_tmp60_ = _path_it;
#line 4766 "../src/Photo.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 4766 "../src/Photo.vala"
						path = (gchar*) _tmp61_;
#line 4767 "../src/Photo.vala"
						_tmp62_ = path;
#line 4767 "../src/Photo.vala"
						_tmp63_ = tag_prep_tag_name (_tmp62_);
#line 4767 "../src/Photo.vala"
						name = _tmp63_;
#line 4768 "../src/Photo.vala"
						_tmp64_ = name;
#line 4768 "../src/Photo.vala"
						if (_tmp64_ != NULL) {
#line 35811 "Photo.c"
							GeeHashMultiMap* _tmp65_;
							const gchar* _tmp66_;
							Tag* _tmp67_;
							Tag* _tmp68_;
							LibraryPhoto* _tmp69_;
#line 4769 "../src/Photo.vala"
							_tmp65_ = map;
#line 4769 "../src/Photo.vala"
							_tmp66_ = name;
#line 4769 "../src/Photo.vala"
							_tmp67_ = tag_for_path (_tmp66_);
#line 4769 "../src/Photo.vala"
							_tmp68_ = _tmp67_;
#line 4769 "../src/Photo.vala"
							_tmp69_ = photo;
#line 4769 "../src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp68_, _tmp69_);
#line 4769 "../src/Photo.vala"
							_g_object_unref0 (_tmp68_);
#line 35831 "Photo.c"
						}
#line 4766 "../src/Photo.vala"
						_g_free0 (name);
#line 4766 "../src/Photo.vala"
						_g_free0 (path);
#line 35837 "Photo.c"
					}
#line 4766 "../src/Photo.vala"
					_g_object_unref0 (_path_it);
#line 35841 "Photo.c"
				}
			}
#line 4729 "../src/Photo.vala"
			_hierarchical_tag_index_unref0 (htag_index);
#line 4729 "../src/Photo.vala"
			_hierarchical_tag_index_unref0 (global_index);
#line 4729 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 4729 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4729 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 35854 "Photo.c"
		}
#line 4729 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 35858 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp70_;
#line 4774 "../src/Photo.vala"
		_tmp70_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 4774 "../src/Photo.vala"
		_media_it = _tmp70_;
#line 4774 "../src/Photo.vala"
		while (TRUE) {
#line 35869 "Photo.c"
			GeeIterator* _tmp71_;
			MediaSource* media = NULL;
			GeeIterator* _tmp72_;
			gpointer _tmp73_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp74_;
			LibraryPhoto* _tmp75_;
			LibraryPhoto* _tmp76_;
#line 4774 "../src/Photo.vala"
			_tmp71_ = _media_it;
#line 4774 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp71_)) {
#line 4774 "../src/Photo.vala"
				break;
#line 35884 "Photo.c"
			}
#line 4774 "../src/Photo.vala"
			_tmp72_ = _media_it;
#line 4774 "../src/Photo.vala"
			_tmp73_ = gee_iterator_get (_tmp72_);
#line 4774 "../src/Photo.vala"
			media = (MediaSource*) _tmp73_;
#line 4775 "../src/Photo.vala"
			_tmp74_ = media;
#line 4775 "../src/Photo.vala"
			_tmp75_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4775 "../src/Photo.vala"
			photo = _tmp75_;
#line 4776 "../src/Photo.vala"
			_tmp76_ = photo;
#line 4776 "../src/Photo.vala"
			library_photo_clear_import_keywords (_tmp76_);
#line 4774 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4774 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 35906 "Photo.c"
		}
#line 4774 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 35910 "Photo.c"
	}
	{
		GeeIterator* _tag_it = NULL;
		GeeHashMultiMap* _tmp77_;
		GeeSet* _tmp78_;
		GeeSet* _tmp79_;
		GeeIterator* _tmp80_;
		GeeIterator* _tmp81_;
#line 4779 "../src/Photo.vala"
		_tmp77_ = map;
#line 4779 "../src/Photo.vala"
		_tmp78_ = gee_multi_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 4779 "../src/Photo.vala"
		_tmp79_ = _tmp78_;
#line 4779 "../src/Photo.vala"
		_tmp80_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4779 "../src/Photo.vala"
		_tmp81_ = _tmp80_;
#line 4779 "../src/Photo.vala"
		_g_object_unref0 (_tmp79_);
#line 4779 "../src/Photo.vala"
		_tag_it = _tmp81_;
#line 4779 "../src/Photo.vala"
		while (TRUE) {
#line 35935 "Photo.c"
			GeeIterator* _tmp82_;
			Tag* tag = NULL;
			GeeIterator* _tmp83_;
			gpointer _tmp84_;
			Tag* _tmp85_;
			GeeHashMultiMap* _tmp86_;
			Tag* _tmp87_;
			GeeCollection* _tmp88_;
			GeeCollection* _tmp89_;
#line 4779 "../src/Photo.vala"
			_tmp82_ = _tag_it;
#line 4779 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp82_)) {
#line 4779 "../src/Photo.vala"
				break;
#line 35951 "Photo.c"
			}
#line 4779 "../src/Photo.vala"
			_tmp83_ = _tag_it;
#line 4779 "../src/Photo.vala"
			_tmp84_ = gee_iterator_get (_tmp83_);
#line 4779 "../src/Photo.vala"
			tag = (Tag*) _tmp84_;
#line 4780 "../src/Photo.vala"
			_tmp85_ = tag;
#line 4780 "../src/Photo.vala"
			_tmp86_ = map;
#line 4780 "../src/Photo.vala"
			_tmp87_ = tag;
#line 4780 "../src/Photo.vala"
			_tmp88_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp86_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp87_);
#line 4780 "../src/Photo.vala"
			_tmp89_ = _tmp88_;
#line 4780 "../src/Photo.vala"
			tag_attach_many (_tmp85_, _tmp89_);
#line 4780 "../src/Photo.vala"
			_g_object_unref0 (_tmp89_);
#line 4779 "../src/Photo.vala"
			_g_object_unref0 (tag);
#line 35975 "Photo.c"
		}
#line 4779 "../src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 35979 "Photo.c"
	}
#line 4782 "../src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), media_sources);
#line 4727 "../src/Photo.vala"
	_g_object_unref0 (map);
#line 35985 "Photo.c"
}

static void
library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4786 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4786 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4787 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 35999 "Photo.c"
}

void
library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4786 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4786 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4786 "../src/Photo.vala"
	if (_klass_->notify_master_reimported) {
#line 4786 "../src/Photo.vala"
		_klass_->notify_master_reimported (self, photo, metadata);
#line 36016 "Photo.c"
	}
}

static void
library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4791 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4791 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4792 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 36031 "Photo.c"
}

void
library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4791 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4791 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4791 "../src/Photo.vala"
	if (_klass_->notify_editable_reimported) {
#line 4791 "../src/Photo.vala"
		_klass_->notify_editable_reimported (self, photo, metadata);
#line 36048 "Photo.c"
	}
}

static void
library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4796 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4796 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4797 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 36063 "Photo.c"
}

void
library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4796 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4796 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4796 "../src/Photo.vala"
	if (_klass_->notify_source_reimported) {
#line 4796 "../src/Photo.vala"
		_klass_->notify_source_reimported (self, photo, metadata);
#line 36080 "Photo.c"
	}
}

static void
library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4801 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4801 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4802 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 36095 "Photo.c"
}

void
library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4801 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4801 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4801 "../src/Photo.vala"
	if (_klass_->notify_baseline_reimported) {
#line 4801 "../src/Photo.vala"
		_klass_->notify_baseline_reimported (self, photo, metadata);
#line 36112 "Photo.c"
	}
}

static MediaSource*
library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                          gint64 numeric_id)
{
	LibraryPhotoSourceCollection * self;
	PhotoID _tmp0_ = {0};
	LibraryPhoto* _tmp1_;
	MediaSource* result = NULL;
#line 4805 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4806 "../src/Photo.vala"
	photo_id_init (&_tmp0_, numeric_id);
#line 4806 "../src/Photo.vala"
	_tmp1_ = library_photo_source_collection_fetch (self, &_tmp0_);
#line 4806 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_MEDIA_SOURCE, MediaSource);
#line 4806 "../src/Photo.vala"
	return result;
#line 36134 "Photo.c"
}

static void
library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                              GeeCollection* added,
                                                              GeeCollection* removed)
{
#line 4809 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4809 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_COLLECTION));
#line 4809 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
#line 4811 "../src/Photo.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 36150 "Photo.c"
}

static gboolean
library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result = FALSE;
#line 4815 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4815 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4815 "../src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4816 "../src/Photo.vala"
	result = media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_MEDIA_SOURCE, MediaSource));
#line 4816 "../src/Photo.vala"
	return result;
#line 36169 "Photo.c"
}

static void
library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                             GeeCollection* added,
                                                             GeeCollection* removed)
{
#line 4819 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4819 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_COLLECTION));
#line 4819 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
#line 4821 "../src/Photo.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 36185 "Photo.c"
}

static gboolean
library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result = FALSE;
#line 4825 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4825 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4825 "../src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4826 "../src/Photo.vala"
	result = media_source_is_offline (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_MEDIA_SOURCE, MediaSource));
#line 4826 "../src/Photo.vala"
	return result;
#line 36204 "Photo.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
#line 1447 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1447 "glib-2.0.vapi"
	end = _tmp0_;
#line 1448 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1448 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1449 "glib-2.0.vapi"
		result = maxlen;
#line 1449 "glib-2.0.vapi"
		return result;
#line 36227 "Photo.c"
	} else {
		gchar* _tmp2_;
#line 1451 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1451 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1451 "glib-2.0.vapi"
		return result;
#line 36236 "Photo.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1460 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 36255 "Photo.c"
	} else {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 36259 "Photo.c"
	}
#line 1460 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1462 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 36265 "Photo.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1464 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1464 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1464 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 36275 "Photo.c"
	}
#line 1467 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1469 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 36283 "Photo.c"
	} else {
#line 1471 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 36287 "Photo.c"
	}
#line 1473 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1474 "glib-2.0.vapi"
		len = string_length - offset;
#line 36293 "Photo.c"
	}
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1477 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1477 "glib-2.0.vapi"
	result = _tmp3_;
#line 1477 "glib-2.0.vapi"
	return result;
#line 36303 "Photo.c"
}

static MediaSource*
library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                         const gchar* source_id)
{
	LibraryPhotoSourceCollection * self;
	gchar* numeric_only = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	MediaSource* _tmp3_;
	MediaSource* result = NULL;
#line 4829 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4829 "../src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 4830 "../src/Photo.vala"
	_vala_assert (g_str_has_prefix (source_id, PHOTO_TYPENAME), "source_id.has_prefix(Photo.TYPENAME)");
#line 4831 "../src/Photo.vala"
	_tmp0_ = strlen (PHOTO_TYPENAME);
#line 4831 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4831 "../src/Photo.vala"
	_tmp2_ = string_substring (source_id, (glong) _tmp1_, (glong) -1);
#line 4831 "../src/Photo.vala"
	numeric_only = _tmp2_;
#line 4833 "../src/Photo.vala"
	_tmp3_ = media_source_collection_fetch_by_numeric_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), parse_int64 (numeric_only, 16));
#line 4833 "../src/Photo.vala"
	result = _tmp3_;
#line 4833 "../src/Photo.vala"
	_g_free0 (numeric_only);
#line 4833 "../src/Photo.vala"
	return result;
#line 36339 "Photo.c"
}

static GeeCollection*
library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                           EventID* event_id)
{
	LibraryPhotoSourceCollection * self;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* result = NULL;
#line 4836 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4836 "../src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 4837 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4837 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4837 "../src/Photo.vala"
	_tmp2_ = *event_id;
#line 4837 "../src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 4837 "../src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 4837 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4837 "../src/Photo.vala"
	result = _tmp4_;
#line 4837 "../src/Photo.vala"
	return result;
#line 36373 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                       PhotoID* photo_id)
{
	PhotoID _tmp0_;
	DataSource* _tmp1_;
	LibraryPhoto* result = NULL;
#line 4840 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4840 "../src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 4841 "../src/Photo.vala"
	_tmp0_ = *photo_id;
#line 4841 "../src/Photo.vala"
	_tmp1_ = database_source_collection_fetch_by_key (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), _tmp0_.id);
#line 4841 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4841 "../src/Photo.vala"
	return result;
#line 36395 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                        GFile* file)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* result = NULL;
#line 4844 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4844 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4845 "../src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 4845 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 4845 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4845 "../src/Photo.vala"
	return result;
#line 36417 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                               GFile* file)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* result = NULL;
#line 4848 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4848 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4849 "../src/Photo.vala"
	_tmp0_ = self->priv->by_raw_development_file;
#line 4849 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 4849 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4849 "../src/Photo.vala"
	return result;
#line 36439 "Photo.c"
}

static void
library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                 LibraryPhoto* photo,
                                                 GFileInfo* info,
                                                 GeeCollection* matches_master,
                                                 GeeCollection* matches_editable,
                                                 GeeCollection* matches_development)
{
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	gboolean _tmp2_;
	BackingPhotoRow* editable = NULL;
	BackingPhotoRow* _tmp3_;
	gboolean _tmp4_ = FALSE;
	BackingPhotoRow* _tmp5_;
	GeeCollection* development = NULL;
	GeeCollection* _tmp7_;
	GeeCollection* _tmp8_;
#line 4852 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4852 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4852 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 4852 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_master, GEE_TYPE_COLLECTION));
#line 4852 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_editable, GEE_TYPE_COLLECTION));
#line 4852 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_development, GEE_TYPE_COLLECTION));
#line 4855 "../src/Photo.vala"
	_tmp0_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4855 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4855 "../src/Photo.vala"
	_tmp2_ = backing_photo_row_matches_file_info (_tmp1_, info);
#line 4855 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp1_);
#line 4855 "../src/Photo.vala"
	if (_tmp2_) {
#line 4856 "../src/Photo.vala"
		gee_collection_add (matches_master, photo);
#line 36484 "Photo.c"
	}
#line 4858 "../src/Photo.vala"
	_tmp3_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4858 "../src/Photo.vala"
	editable = _tmp3_;
#line 4859 "../src/Photo.vala"
	_tmp5_ = editable;
#line 4859 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 36494 "Photo.c"
		BackingPhotoRow* _tmp6_;
#line 4859 "../src/Photo.vala"
		_tmp6_ = editable;
#line 4859 "../src/Photo.vala"
		_tmp4_ = backing_photo_row_matches_file_info (_tmp6_, info);
#line 36500 "Photo.c"
	} else {
#line 4859 "../src/Photo.vala"
		_tmp4_ = FALSE;
#line 36504 "Photo.c"
	}
#line 4859 "../src/Photo.vala"
	if (_tmp4_) {
#line 4860 "../src/Photo.vala"
		gee_collection_add (matches_editable, photo);
#line 36510 "Photo.c"
	}
#line 4862 "../src/Photo.vala"
	_tmp7_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4862 "../src/Photo.vala"
	development = _tmp7_;
#line 4863 "../src/Photo.vala"
	_tmp8_ = development;
#line 4863 "../src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 36520 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_;
#line 4864 "../src/Photo.vala"
			_tmp9_ = development;
#line 4864 "../src/Photo.vala"
			_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4864 "../src/Photo.vala"
			_row_it = _tmp10_;
#line 4864 "../src/Photo.vala"
			while (TRUE) {
#line 36533 "Photo.c"
				GeeIterator* _tmp11_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				BackingPhotoRow* _tmp14_;
#line 4864 "../src/Photo.vala"
				_tmp11_ = _row_it;
#line 4864 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 4864 "../src/Photo.vala"
					break;
#line 36545 "Photo.c"
				}
#line 4864 "../src/Photo.vala"
				_tmp12_ = _row_it;
#line 4864 "../src/Photo.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 4864 "../src/Photo.vala"
				row = (BackingPhotoRow*) _tmp13_;
#line 4865 "../src/Photo.vala"
				_tmp14_ = row;
#line 4865 "../src/Photo.vala"
				if (backing_photo_row_matches_file_info (_tmp14_, info)) {
#line 4866 "../src/Photo.vala"
					gee_collection_add (matches_development, photo);
#line 4868 "../src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 4868 "../src/Photo.vala"
					break;
#line 36563 "Photo.c"
				}
#line 4864 "../src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 36567 "Photo.c"
			}
#line 4864 "../src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 36571 "Photo.c"
		}
	}
#line 4852 "../src/Photo.vala"
	_g_object_unref0 (development);
#line 4852 "../src/Photo.vala"
	_backing_photo_row_unref0 (editable);
#line 36578 "Photo.c"
}

void
library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                           GFileInfo* info,
                                                           GeeCollection* matches_master,
                                                           GeeCollection* matches_editable,
                                                           GeeCollection* matched_development)
{
#line 4876 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4876 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 4876 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_master, GEE_TYPE_COLLECTION));
#line 4876 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_editable, GEE_TYPE_COLLECTION));
#line 4876 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matched_development, GEE_TYPE_COLLECTION));
#line 36598 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		gint64 _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 4878 "../src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4878 "../src/Photo.vala"
		_tmp1_ = g_file_info_get_size (info);
#line 4878 "../src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 4878 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4878 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4878 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4878 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4878 "../src/Photo.vala"
		_photo_it = _tmp5_;
#line 4878 "../src/Photo.vala"
		while (TRUE) {
#line 36625 "Photo.c"
			GeeIterator* _tmp6_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			LibraryPhoto* _tmp9_;
#line 4878 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4878 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 4878 "../src/Photo.vala"
				break;
#line 36637 "Photo.c"
			}
#line 4878 "../src/Photo.vala"
			_tmp7_ = _photo_it;
#line 4878 "../src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 4878 "../src/Photo.vala"
			photo = (LibraryPhoto*) _tmp8_;
#line 4879 "../src/Photo.vala"
			_tmp9_ = photo;
#line 4879 "../src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp9_, info, matches_master, matches_editable, matched_development);
#line 4878 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 36651 "Photo.c"
		}
#line 4878 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 36655 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp10_;
		GeeCollection* _tmp11_;
		GeeIterator* _tmp12_;
		GeeIterator* _tmp13_;
#line 4881 "../src/Photo.vala"
		_tmp10_ = media_source_collection_get_offline_bin_contents (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4881 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 4881 "../src/Photo.vala"
		_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4881 "../src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 4881 "../src/Photo.vala"
		_g_object_unref0 (_tmp11_);
#line 4881 "../src/Photo.vala"
		_media_it = _tmp13_;
#line 4881 "../src/Photo.vala"
		while (TRUE) {
#line 36677 "Photo.c"
			GeeIterator* _tmp14_;
			MediaSource* media = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			MediaSource* _tmp17_;
#line 4881 "../src/Photo.vala"
			_tmp14_ = _media_it;
#line 4881 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 4881 "../src/Photo.vala"
				break;
#line 36689 "Photo.c"
			}
#line 4881 "../src/Photo.vala"
			_tmp15_ = _media_it;
#line 4881 "../src/Photo.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 4881 "../src/Photo.vala"
			media = (MediaSource*) _tmp16_;
#line 4882 "../src/Photo.vala"
			_tmp17_ = media;
#line 4882 "../src/Photo.vala"
			library_photo_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_LIBRARY_PHOTO, LibraryPhoto), info, matches_master, matches_editable, matched_development);
#line 4881 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 36703 "Photo.c"
		}
#line 4881 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 36707 "Photo.c"
	}
}

void
library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize,
                                                                 PhotoID* result)
{
	PhotoID _tmp15_ = {0};
#line 4885 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4885 "../src/Photo.vala"
	g_return_if_fail (basename != NULL);
#line 36722 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4886 "../src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4886 "../src/Photo.vala"
		_tmp1_ = gee_multi_map_get (_tmp0_, &filesize);
#line 4886 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4886 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4886 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4886 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4886 "../src/Photo.vala"
		_photo_it = _tmp4_;
#line 4886 "../src/Photo.vala"
		while (TRUE) {
#line 36746 "Photo.c"
			GeeIterator* _tmp5_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			LibraryPhoto* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_;
#line 4886 "../src/Photo.vala"
			_tmp5_ = _photo_it;
#line 4886 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4886 "../src/Photo.vala"
				break;
#line 36762 "Photo.c"
			}
#line 4886 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4886 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4886 "../src/Photo.vala"
			photo = (LibraryPhoto*) _tmp7_;
#line 4887 "../src/Photo.vala"
			_tmp8_ = photo;
#line 4887 "../src/Photo.vala"
			_tmp9_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_MEDIA_SOURCE, MediaSource));
#line 4887 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 4887 "../src/Photo.vala"
			_tmp11_ = g_file_get_basename (_tmp10_);
#line 4887 "../src/Photo.vala"
			_tmp12_ = utf8_ci_compare (_tmp11_, basename) == 0;
#line 4887 "../src/Photo.vala"
			_g_object_unref0 (_tmp10_);
#line 4887 "../src/Photo.vala"
			if (_tmp12_) {
#line 36784 "Photo.c"
				LibraryPhoto* _tmp13_;
				PhotoID _tmp14_ = {0};
#line 4888 "../src/Photo.vala"
				_tmp13_ = photo;
#line 4888 "../src/Photo.vala"
				photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO, Photo), &_tmp14_);
#line 4888 "../src/Photo.vala"
				*result = _tmp14_;
#line 4888 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4888 "../src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 4888 "../src/Photo.vala"
				return;
#line 36799 "Photo.c"
			}
#line 4886 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 36803 "Photo.c"
		}
#line 4886 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 36807 "Photo.c"
	}
#line 4891 "../src/Photo.vala"
	photo_id_init (&_tmp15_, PHOTO_ID_INVALID);
#line 4891 "../src/Photo.vala"
	*result = _tmp15_;
#line 4891 "../src/Photo.vala"
	return;
#line 36815 "Photo.c"
}

gboolean
library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize)
{
	PhotoID _tmp0_ = {0};
	gboolean result = FALSE;
#line 4895 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4895 "../src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 4896 "../src/Photo.vala"
	library_photo_source_collection_get_basename_filesize_duplicate (self, basename, filesize, &_tmp0_);
#line 4896 "../src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 4896 "../src/Photo.vala"
	return result;
#line 36835 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* result = NULL;
#line 4899 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4899 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4900 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4900 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4900 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4900 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4900 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4900 "../src/Photo.vala"
	photo = _tmp3_;
#line 4901 "../src/Photo.vala"
	_tmp4_ = photo;
#line 4901 "../src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 36869 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4902 "../src/Photo.vala"
		_tmp5_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4902 "../src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4902 "../src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4902 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4902 "../src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4902 "../src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 36885 "Photo.c"
	}
#line 4905 "../src/Photo.vala"
	result = photo;
#line 4905 "../src/Photo.vala"
	return result;
#line 36891 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* result = NULL;
#line 4908 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4908 "../src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4909 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4909 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4909 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4909 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4909 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4909 "../src/Photo.vala"
	result = _tmp3_;
#line 4909 "../src/Photo.vala"
	return result;
#line 36921 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* result = NULL;
#line 4912 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4912 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4913 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4913 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4913 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4913 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4913 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4913 "../src/Photo.vala"
	photo = _tmp3_;
#line 4914 "../src/Photo.vala"
	_tmp4_ = photo;
#line 4914 "../src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 36955 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4915 "../src/Photo.vala"
		_tmp5_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4915 "../src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4915 "../src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4915 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4915 "../src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4915 "../src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 36971 "Photo.c"
	}
#line 4918 "../src/Photo.vala"
	result = photo;
#line 4918 "../src/Photo.vala"
	return result;
#line 36977 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* result = NULL;
#line 4921 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4921 "../src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4922 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4922 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4922 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4922 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4922 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4922 "../src/Photo.vala"
	result = _tmp3_;
#line 4922 "../src/Photo.vala"
	return result;
#line 37007 "Photo.c"
}

gint
library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_;
	gint result = 0;
#line 4925 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), 0);
#line 4926 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4926 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4926 "../src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank));
#line 4926 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4926 "../src/Photo.vala"
	result = _tmp2_;
#line 4926 "../src/Photo.vala"
	return result;
#line 37031 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                   GFile* file,
                                                   LibraryPhotoSourceCollectionState* state)
{
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* photo = NULL;
	MediaSource* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* _tmp5_;
	LibraryPhoto* _tmp6_;
	LibraryPhoto* _tmp7_;
	LibraryPhoto* _tmp8_;
	LibraryPhoto* _tmp9_;
	LibraryPhoto* _tmp10_;
	LibraryPhoto* _tmp11_;
	LibraryPhoto* result = NULL;
#line 4929 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4929 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4930 "../src/Photo.vala"
	_tmp0_ = media_source_collection_fetch_by_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), file);
#line 4930 "../src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4931 "../src/Photo.vala"
	_tmp1_ = photo;
#line 4931 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 4932 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 4934 "../src/Photo.vala"
		result = photo;
#line 4934 "../src/Photo.vala"
		if (state) {
#line 4934 "../src/Photo.vala"
			*state = _vala_state;
#line 37074 "Photo.c"
		}
#line 4934 "../src/Photo.vala"
		return result;
#line 37078 "Photo.c"
	}
#line 4937 "../src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch_by_editable_file (self, file);
#line 4937 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4937 "../src/Photo.vala"
	photo = _tmp2_;
#line 4938 "../src/Photo.vala"
	_tmp3_ = photo;
#line 4938 "../src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 4939 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 4941 "../src/Photo.vala"
		result = photo;
#line 4941 "../src/Photo.vala"
		if (state) {
#line 4941 "../src/Photo.vala"
			*state = _vala_state;
#line 37098 "Photo.c"
		}
#line 4941 "../src/Photo.vala"
		return result;
#line 37102 "Photo.c"
	}
#line 4944 "../src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_raw_development_file (self, file);
#line 4944 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4944 "../src/Photo.vala"
	photo = _tmp4_;
#line 4945 "../src/Photo.vala"
	_tmp5_ = photo;
#line 4945 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 4946 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER;
#line 4948 "../src/Photo.vala"
		result = photo;
#line 4948 "../src/Photo.vala"
		if (state) {
#line 4948 "../src/Photo.vala"
			*state = _vala_state;
#line 37122 "Photo.c"
		}
#line 4948 "../src/Photo.vala"
		return result;
#line 37126 "Photo.c"
	}
#line 4951 "../src/Photo.vala"
	_tmp6_ = library_photo_source_collection_get_trashed_by_file (self, file);
#line 4951 "../src/Photo.vala"
	_tmp7_ = IS_LIBRARY_PHOTO (_tmp6_) ? ((LibraryPhoto*) _tmp6_) : NULL;
#line 4951 "../src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 4951 "../src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 37136 "Photo.c"
	}
#line 4951 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4951 "../src/Photo.vala"
	photo = _tmp7_;
#line 4952 "../src/Photo.vala"
	_tmp8_ = photo;
#line 4952 "../src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 4953 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 4955 "../src/Photo.vala"
		result = photo;
#line 4955 "../src/Photo.vala"
		if (state) {
#line 4955 "../src/Photo.vala"
			*state = _vala_state;
#line 37154 "Photo.c"
		}
#line 4955 "../src/Photo.vala"
		return result;
#line 37158 "Photo.c"
	}
#line 4958 "../src/Photo.vala"
	_tmp9_ = library_photo_source_collection_get_offline_by_file (self, file);
#line 4958 "../src/Photo.vala"
	_tmp10_ = IS_LIBRARY_PHOTO (_tmp9_) ? ((LibraryPhoto*) _tmp9_) : NULL;
#line 4958 "../src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 4958 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 37168 "Photo.c"
	}
#line 4958 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4958 "../src/Photo.vala"
	photo = _tmp10_;
#line 4959 "../src/Photo.vala"
	_tmp11_ = photo;
#line 4959 "../src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 4960 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 4962 "../src/Photo.vala"
		result = photo;
#line 4962 "../src/Photo.vala"
		if (state) {
#line 4962 "../src/Photo.vala"
			*state = _vala_state;
#line 37186 "Photo.c"
		}
#line 4962 "../src/Photo.vala"
		return result;
#line 37190 "Photo.c"
	}
#line 4965 "../src/Photo.vala"
	_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 4967 "../src/Photo.vala"
	result = NULL;
#line 4967 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4967 "../src/Photo.vala"
	if (state) {
#line 4967 "../src/Photo.vala"
		*state = _vala_state;
#line 37202 "Photo.c"
	}
#line 4967 "../src/Photo.vala"
	return result;
#line 37206 "Photo.c"
}

static gboolean
library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                   SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gboolean _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
	MediaSourceHoldingTank* _tmp4_;
	gboolean _tmp5_;
	gboolean result = FALSE;
#line 4970 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4970 "../src/Photo.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 4971 "../src/Photo.vala"
	if (SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), backlink)) {
#line 4972 "../src/Photo.vala"
		result = TRUE;
#line 4972 "../src/Photo.vala"
		return result;
#line 37231 "Photo.c"
	}
#line 4974 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4974 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4974 "../src/Photo.vala"
	_tmp2_ = source_holding_tank_has_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4974 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4974 "../src/Photo.vala"
	if (_tmp2_) {
#line 4975 "../src/Photo.vala"
		result = TRUE;
#line 4975 "../src/Photo.vala"
		return result;
#line 37247 "Photo.c"
	}
#line 4977 "../src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4977 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4977 "../src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4977 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 4977 "../src/Photo.vala"
	if (_tmp5_) {
#line 4978 "../src/Photo.vala"
		result = TRUE;
#line 4978 "../src/Photo.vala"
		return result;
#line 37263 "Photo.c"
	}
#line 4980 "../src/Photo.vala"
	result = FALSE;
#line 4980 "../src/Photo.vala"
	return result;
#line 37269 "Photo.c"
}

static void
library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                      SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4983 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4983 "../src/Photo.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 4984 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4984 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4984 "../src/Photo.vala"
	source_holding_tank_remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4984 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4985 "../src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4985 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4985 "../src/Photo.vala"
	source_holding_tank_remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4985 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4987 "../src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), backlink);
#line 37303 "Photo.c"
}

static TransactionController*
library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base)
{
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
#line 4504 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4505 "../src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 4505 "../src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 37319 "Photo.c"
		MediaSourceTransactionController* _tmp1_;
#line 4506 "../src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4506 "../src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4506 "../src/Photo.vala"
		self->priv->_transaction_controller = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_TRANSACTION_CONTROLLER, TransactionController);
#line 37327 "Photo.c"
	}
#line 4508 "../src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 4508 "../src/Photo.vala"
	result = _tmp2_;
#line 4508 "../src/Photo.vala"
	return result;
#line 37335 "Photo.c"
}

static void
library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4526 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4526 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 37347 "Photo.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 4493 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 4493 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 4493 "../src/Photo.vala"
		data1 = closure->data;
#line 4493 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 37372 "Photo.c"
	} else {
#line 4493 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 4493 "../src/Photo.vala"
		data2 = closure->data;
#line 37378 "Photo.c"
	}
#line 4493 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 4493 "../src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 37384 "Photo.c"
}

static void
library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4529 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4529 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 37396 "Photo.c"
}

static void
library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4532 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4532 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 37408 "Photo.c"
}

static void
library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4535 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4535 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 37420 "Photo.c"
}

static void
library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass,
                                            gpointer klass_data)
{
#line 4493 "../src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 4493 "../src/Photo.vala"
	((DataCollectionClass *) klass)->finalize = library_photo_source_collection_finalize;
#line 4493 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhotoSourceCollection_private_offset);
#line 4493 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_trashcan = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_trashcan;
#line 4493 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_offline_bin = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_offline_bin;
#line 4493 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_media_monitor = (MediaMonitor* (*) (MediaSourceCollection*, Workers*, GCancellable*)) library_photo_source_collection_real_create_media_monitor;
#line 4493 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->holds_type_of_source = (gboolean (*) (SourceCollection*, DataSource*)) library_photo_source_collection_real_holds_type_of_source;
#line 4493 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_typename = (gchar* (*) (MediaSourceCollection*)) library_photo_source_collection_real_get_typename;
#line 4493 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->is_file_recognized = (gboolean (*) (MediaSourceCollection*, GFile*)) library_photo_source_collection_real_is_file_recognized;
#line 4493 "../src/Photo.vala"
	((DataCollectionClass *) klass)->notify_contents_altered = (void (*) (DataCollection*, GeeIterable*, GeeIterable*)) library_photo_source_collection_real_notify_contents_altered;
#line 4493 "../src/Photo.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*) (DataCollection*, GeeMap*)) library_photo_source_collection_real_items_altered;
#line 4493 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->postprocess_imported_media = (void (*) (MediaSourceCollection*, GeeCollection*)) library_photo_source_collection_real_postprocess_imported_media;
#line 4493 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_master_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_master_reimported;
#line 4493 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_editable_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_editable_reimported;
#line 4493 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_source_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_source_reimported;
#line 4493 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_baseline_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_baseline_reimported;
#line 4493 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = (MediaSource* (*) (MediaSourceCollection*, gint64)) library_photo_source_collection_real_fetch_by_numeric_id;
#line 4493 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_source_id = (MediaSource* (*) (MediaSourceCollection*, const gchar*)) library_photo_source_collection_real_fetch_by_source_id;
#line 4493 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = (GeeCollection* (*) (MediaSourceCollection*, EventID*)) library_photo_source_collection_real_get_event_source_ids;
#line 4493 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->has_backlink = (gboolean (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_has_backlink;
#line 4493 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->remove_backlink = (void (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_remove_backlink;
#line 4493 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 4493 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 4493 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 4493 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 4493 "../src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = library_photo_source_collection_real_get_transaction_controller;
#line 4493 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4493 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4493 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4493 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 37487 "Photo.c"
}

static void
library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self,
                                               gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeTreeMultiMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeTreeMultiMap* _tmp5_;
#line 4493 "../src/Photo.vala"
	self->priv = library_photo_source_collection_get_instance_private (self);
#line 4512 "../src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 4513 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4513 "../src/Photo.vala"
	self->priv->by_editable_file = _tmp0_;
#line 4515 "../src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4515 "../src/Photo.vala"
	self->priv->by_raw_development_file = _tmp1_;
#line 4517 "../src/Photo.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _int64_compare_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4517 "../src/Photo.vala"
	self->priv->filesize_to_photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 4519 "../src/Photo.vala"
	_tmp3_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4519 "../src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp3_;
#line 4521 "../src/Photo.vala"
	_tmp4_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4521 "../src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp4_;
#line 4523 "../src/Photo.vala"
	_tmp5_ = gee_tree_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4523 "../src/Photo.vala"
	self->priv->photo_to_raw_development_filesize = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 37528 "Photo.c"
}

static void
library_photo_source_collection_finalize (DataCollection * obj)
{
	LibraryPhotoSourceCollection * self;
#line 4493 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4512 "../src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4513 "../src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 4515 "../src/Photo.vala"
	_g_object_unref0 (self->priv->by_raw_development_file);
#line 4517 "../src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 4519 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 4521 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 4523 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_raw_development_filesize);
#line 4493 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 37553 "Photo.c"
}

static GType
library_photo_source_collection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
	GType library_photo_source_collection_type_id;
	library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
	LibraryPhotoSourceCollection_private_offset = g_type_add_instance_private (library_photo_source_collection_type_id, sizeof (LibraryPhotoSourceCollectionPrivate));
	return library_photo_source_collection_type_id;
}

GType
library_photo_source_collection_get_type (void)
{
	static volatile gsize library_photo_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__volatile)) {
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = library_photo_source_collection_get_type_once ();
		g_once_init_leave (&library_photo_source_collection_type_id__volatile, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__volatile;
}

static inline gpointer
library_photo_get_instance_private (LibraryPhoto* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhoto_private_offset);
}

static void
_library_photo_generate_thumbnails_one_shot_callback (gpointer self)
{
#line 5015 "../src/Photo.vala"
	library_photo_generate_thumbnails ((LibraryPhoto*) self);
#line 37589 "Photo.c"
}

static void
_library_photo_import_gps_metadata_one_shot_callback (gpointer self)
{
#line 5018 "../src/Photo.vala"
	library_photo_import_gps_metadata ((LibraryPhoto*) self);
#line 37597 "Photo.c"
}

static LibraryPhoto*
library_photo_construct (GType object_type,
                         PhotoRow* row)
{
	LibraryPhoto * self = NULL;
	OneShotScheduler* _tmp0_;
	GpsCoords _tmp1_;
#line 5010 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 5011 "../src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, row);
#line 5013 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5013 "../src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 5015 "../src/Photo.vala"
	_tmp0_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 5015 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5015 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp0_;
#line 5017 "../src/Photo.vala"
	_tmp1_ = row->gps_coords;
#line 5017 "../src/Photo.vala"
	if (_tmp1_.has_gps == -1) {
#line 37625 "Photo.c"
		OneShotScheduler* gps_import_scheduler = NULL;
		OneShotScheduler* _tmp2_;
		OneShotScheduler* _tmp3_;
#line 5018 "../src/Photo.vala"
		_tmp2_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_import_gps_metadata_one_shot_callback, self);
#line 5018 "../src/Photo.vala"
		gps_import_scheduler = _tmp2_;
#line 5019 "../src/Photo.vala"
		_tmp3_ = gps_import_scheduler;
#line 5019 "../src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp3_, G_PRIORITY_LOW);
#line 5017 "../src/Photo.vala"
		_one_shot_scheduler_unref0 (gps_import_scheduler);
#line 37639 "Photo.c"
	}
#line 5023 "../src/Photo.vala"
	if ((row->flags & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 37643 "Photo.c"
		LibraryPhotoSourceCollection* _tmp4_;
		const gchar* _tmp5_;
#line 5024 "../src/Photo.vala"
		_tmp4_ = library_photo_global;
#line 5024 "../src/Photo.vala"
		_tmp5_ = row->backlinks;
#line 5024 "../src/Photo.vala"
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp5_);
#line 37652 "Photo.c"
	}
#line 5026 "../src/Photo.vala"
	if ((row->flags & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 5027 "../src/Photo.vala"
		library_photo_upgrade_rating_flags (self, row->flags);
#line 37658 "Photo.c"
	}
#line 5010 "../src/Photo.vala"
	return self;
#line 37662 "Photo.c"
}

static LibraryPhoto*
library_photo_new (PhotoRow* row)
{
#line 5010 "../src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row);
#line 37670 "Photo.c"
}

static LibraryPhoto*
library_photo_construct_from_import_params (GType object_type,
                                            PhotoImportParams* import_params)
{
	LibraryPhoto * self = NULL;
	PhotoRow* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	OneShotScheduler* _tmp3_;
	PhotoRow* _tmp4_;
	PhotoRow* _tmp8_;
#line 5030 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (import_params), NULL);
#line 5031 "../src/Photo.vala"
	_tmp0_ = import_params->row;
#line 5031 "../src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp0_);
#line 5033 "../src/Photo.vala"
	_tmp1_ = import_params->keywords;
#line 5033 "../src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 5033 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5033 "../src/Photo.vala"
	self->priv->import_keywords = _tmp2_;
#line 5034 "../src/Photo.vala"
	_tmp3_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 5034 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5034 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp3_;
#line 5037 "../src/Photo.vala"
	_tmp4_ = import_params->row;
#line 5037 "../src/Photo.vala"
	if ((_tmp4_->flags & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 37708 "Photo.c"
		LibraryPhotoSourceCollection* _tmp5_;
		PhotoRow* _tmp6_;
		const gchar* _tmp7_;
#line 5038 "../src/Photo.vala"
		_tmp5_ = library_photo_global;
#line 5038 "../src/Photo.vala"
		_tmp6_ = import_params->row;
#line 5038 "../src/Photo.vala"
		_tmp7_ = _tmp6_->backlinks;
#line 5038 "../src/Photo.vala"
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp7_);
#line 37720 "Photo.c"
	}
#line 5040 "../src/Photo.vala"
	_tmp8_ = import_params->row;
#line 5040 "../src/Photo.vala"
	if ((_tmp8_->flags & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 37726 "Photo.c"
		PhotoRow* _tmp9_;
#line 5041 "../src/Photo.vala"
		_tmp9_ = import_params->row;
#line 5041 "../src/Photo.vala"
		library_photo_upgrade_rating_flags (self, _tmp9_->flags);
#line 37732 "Photo.c"
	}
#line 5030 "../src/Photo.vala"
	return self;
#line 37736 "Photo.c"
}

static LibraryPhoto*
library_photo_new_from_import_params (PhotoImportParams* import_params)
{
#line 5030 "../src/Photo.vala"
	return library_photo_construct_from_import_params (TYPE_LIBRARY_PHOTO, import_params);
#line 37744 "Photo.c"
}

void
library_photo_init (ProgressMonitor monitor,
                    gpointer monitor_target)
{
	LibraryPhotoSourceCollection* _tmp0_;
	GeeArrayList* all = NULL;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* all_photos = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* trashed_photos = NULL;
	GeeArrayList* _tmp6_;
	GeeArrayList* offline_photos = NULL;
	GeeArrayList* _tmp7_;
	gint count = 0;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	LibraryPhotoSourceCollection* _tmp24_;
	GeeArrayList* _tmp25_;
	GeeCollection* _tmp26_;
	GeeCollection* _tmp27_;
	LibraryPhotoSourceCollection* _tmp28_;
	GeeArrayList* _tmp29_;
	LibraryPhotoSourceCollection* _tmp30_;
	GeeArrayList* _tmp31_;
#line 5045 "../src/Photo.vala"
	photo_init_photo ();
#line 5047 "../src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 5047 "../src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 5047 "../src/Photo.vala"
	library_photo_global = _tmp0_;
#line 5051 "../src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 5051 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 5051 "../src/Photo.vala"
	_tmp3_ = photo_table_get_all (_tmp2_);
#line 5051 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5051 "../src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 5051 "../src/Photo.vala"
	all = _tmp4_;
#line 5052 "../src/Photo.vala"
	_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5052 "../src/Photo.vala"
	all_photos = _tmp5_;
#line 5053 "../src/Photo.vala"
	_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5053 "../src/Photo.vala"
	trashed_photos = _tmp6_;
#line 5054 "../src/Photo.vala"
	_tmp7_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5054 "../src/Photo.vala"
	offline_photos = _tmp7_;
#line 5055 "../src/Photo.vala"
	_tmp8_ = all;
#line 5055 "../src/Photo.vala"
	_tmp9_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 5055 "../src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 5055 "../src/Photo.vala"
	count = _tmp10_;
#line 37815 "Photo.c"
	{
		gint ctr = 0;
#line 5056 "../src/Photo.vala"
		ctr = 0;
#line 37820 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
#line 5056 "../src/Photo.vala"
			_tmp11_ = TRUE;
#line 5056 "../src/Photo.vala"
			while (TRUE) {
#line 37827 "Photo.c"
				PhotoRow* row = NULL;
				GeeArrayList* _tmp13_;
				gpointer _tmp14_;
				LibraryPhoto* photo = NULL;
				PhotoRow* _tmp15_;
				LibraryPhoto* _tmp16_;
				guint64 flags = 0ULL;
				PhotoRow* _tmp17_;
#line 5056 "../src/Photo.vala"
				if (!_tmp11_) {
#line 37838 "Photo.c"
					gint _tmp12_;
#line 5056 "../src/Photo.vala"
					_tmp12_ = ctr;
#line 5056 "../src/Photo.vala"
					ctr = _tmp12_ + 1;
#line 37844 "Photo.c"
				}
#line 5056 "../src/Photo.vala"
				_tmp11_ = FALSE;
#line 5056 "../src/Photo.vala"
				if (!(ctr < count)) {
#line 5056 "../src/Photo.vala"
					break;
#line 37852 "Photo.c"
				}
#line 5057 "../src/Photo.vala"
				_tmp13_ = all;
#line 5057 "../src/Photo.vala"
				_tmp14_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), ctr);
#line 5057 "../src/Photo.vala"
				row = (PhotoRow*) _tmp14_;
#line 5058 "../src/Photo.vala"
				_tmp15_ = row;
#line 5058 "../src/Photo.vala"
				_tmp16_ = library_photo_new (_tmp15_);
#line 5058 "../src/Photo.vala"
				photo = _tmp16_;
#line 5059 "../src/Photo.vala"
				_tmp17_ = row;
#line 5059 "../src/Photo.vala"
				flags = _tmp17_->flags;
#line 5061 "../src/Photo.vala"
				if ((flags & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 37872 "Photo.c"
					GeeArrayList* _tmp18_;
					LibraryPhoto* _tmp19_;
#line 5062 "../src/Photo.vala"
					_tmp18_ = trashed_photos;
#line 5062 "../src/Photo.vala"
					_tmp19_ = photo;
#line 5062 "../src/Photo.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp19_);
#line 37881 "Photo.c"
				} else {
#line 5063 "../src/Photo.vala"
					if ((flags & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 37885 "Photo.c"
						GeeArrayList* _tmp20_;
						LibraryPhoto* _tmp21_;
#line 5064 "../src/Photo.vala"
						_tmp20_ = offline_photos;
#line 5064 "../src/Photo.vala"
						_tmp21_ = photo;
#line 5064 "../src/Photo.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp21_);
#line 37894 "Photo.c"
					} else {
						GeeArrayList* _tmp22_;
						LibraryPhoto* _tmp23_;
#line 5066 "../src/Photo.vala"
						_tmp22_ = all_photos;
#line 5066 "../src/Photo.vala"
						_tmp23_ = photo;
#line 5066 "../src/Photo.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp23_);
#line 37904 "Photo.c"
					}
				}
#line 5068 "../src/Photo.vala"
				if (monitor != NULL) {
#line 5069 "../src/Photo.vala"
					monitor ((guint64) ctr, (guint64) count, TRUE, monitor_target);
#line 37911 "Photo.c"
				}
#line 5056 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5056 "../src/Photo.vala"
				_photo_row_unref0 (row);
#line 37917 "Photo.c"
			}
		}
	}
#line 5072 "../src/Photo.vala"
	_tmp24_ = library_photo_global;
#line 5072 "../src/Photo.vala"
	_tmp25_ = all_photos;
#line 5072 "../src/Photo.vala"
	_tmp26_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 5072 "../src/Photo.vala"
	_tmp27_ = _tmp26_;
#line 5072 "../src/Photo.vala"
	_g_object_unref0 (_tmp27_);
#line 5073 "../src/Photo.vala"
	_tmp28_ = library_photo_global;
#line 5073 "../src/Photo.vala"
	_tmp29_ = trashed_photos;
#line 5073 "../src/Photo.vala"
	media_source_collection_add_many_to_trash (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5074 "../src/Photo.vala"
	_tmp30_ = library_photo_global;
#line 5074 "../src/Photo.vala"
	_tmp31_ = offline_photos;
#line 5074 "../src/Photo.vala"
	media_source_collection_add_many_to_offline (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5044 "../src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 5044 "../src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 5044 "../src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 5044 "../src/Photo.vala"
	_g_object_unref0 (all);
#line 37951 "Photo.c"
}

void
library_photo_terminate (void)
{
#line 5078 "../src/Photo.vala"
	photo_terminate_photo ();
#line 37959 "Photo.c"
}

ImportResult
library_photo_import_create (PhotoImportParams* params,
                             LibraryPhoto** photo)
{
	LibraryPhoto* _vala_photo = NULL;
	PhotoID photo_id = {0};
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoID _tmp3_ = {0};
	PhotoID _tmp4_;
	LibraryPhoto* _tmp5_;
	ImportResult result = 0;
#line 5085 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 5087 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 5087 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5087 "../src/Photo.vala"
	_tmp2_ = params->row;
#line 5087 "../src/Photo.vala"
	photo_table_add (_tmp1_, _tmp2_, &_tmp3_);
#line 5087 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5087 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 5087 "../src/Photo.vala"
	photo_id = _tmp4_;
#line 5088 "../src/Photo.vala"
	if (photo_id_is_invalid (&photo_id)) {
#line 5089 "../src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 5089 "../src/Photo.vala"
		_vala_photo = NULL;
#line 5091 "../src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 5091 "../src/Photo.vala"
		if (photo) {
#line 5091 "../src/Photo.vala"
			*photo = _vala_photo;
#line 38003 "Photo.c"
		} else {
#line 5091 "../src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 38007 "Photo.c"
		}
#line 5091 "../src/Photo.vala"
		return result;
#line 38011 "Photo.c"
	}
#line 5095 "../src/Photo.vala"
	_tmp5_ = library_photo_new_from_import_params (params);
#line 5095 "../src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 5095 "../src/Photo.vala"
	_vala_photo = _tmp5_;
#line 5097 "../src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 5097 "../src/Photo.vala"
	if (photo) {
#line 5097 "../src/Photo.vala"
		*photo = _vala_photo;
#line 38025 "Photo.c"
	} else {
#line 5097 "../src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 38029 "Photo.c"
	}
#line 5097 "../src/Photo.vala"
	return result;
#line 38033 "Photo.c"
}

void
library_photo_import_failed (LibraryPhoto* photo)
{
	GError* _inner_error0_ = NULL;
#line 5100 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 38042 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 5102 "../src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 5102 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5102 "../src/Photo.vala"
		photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo), &_tmp2_);
#line 5102 "../src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp2_, &_inner_error0_);
#line 5102 "../src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 5102 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5102 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 38061 "Photo.c"
				goto __catch0_database_error;
			}
#line 5102 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5102 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5102 "../src/Photo.vala"
			return;
#line 38070 "Photo.c"
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
#line 5101 "../src/Photo.vala"
		err = _inner_error0_;
#line 5101 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5104 "../src/Photo.vala"
		_tmp3_ = err;
#line 5104 "../src/Photo.vala"
		app_window_database_error (_tmp3_);
#line 5101 "../src/Photo.vala"
		_g_error_free0 (err);
#line 38088 "Photo.c"
	}
	__finally0:
#line 5101 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5101 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5101 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5101 "../src/Photo.vala"
		return;
#line 38099 "Photo.c"
	}
}

static void
library_photo_real_notify_master_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5108 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5108 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5109 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5111 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5111 "../src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp0_, self, metadata);
#line 38119 "Photo.c"
}

static void
library_photo_real_notify_editable_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5114 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5114 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5115 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5117 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5117 "../src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp0_, self, metadata);
#line 38138 "Photo.c"
}

static void
library_photo_real_notify_source_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5120 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5120 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5121 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5123 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5123 "../src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp0_, self, metadata);
#line 38157 "Photo.c"
}

static void
library_photo_real_notify_baseline_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5126 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5126 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5127 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5129 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5129 "../src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp0_, self, metadata);
#line 38176 "Photo.c"
}

static void
library_photo_generate_thumbnails (LibraryPhoto* self)
{
	GError* _inner_error0_ = NULL;
#line 5132 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 38185 "Photo.c"
	{
#line 5134 "../src/Photo.vala"
		thumbnail_cache_import_from_source (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), TRUE, &_inner_error0_);
#line 5134 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38191 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5133 "../src/Photo.vala"
		err = _inner_error0_;
#line 5133 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5136 "../src/Photo.vala"
		_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 5136 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5136 "../src/Photo.vala"
		_tmp2_ = err;
#line 5136 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5136 "../src/Photo.vala"
		g_warning ("Photo.vala:5136: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5136 "../src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5133 "../src/Photo.vala"
		_g_error_free0 (err);
#line 38221 "Photo.c"
	}
	__finally0:
#line 5133 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5133 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5133 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5133 "../src/Photo.vala"
		return;
#line 38232 "Photo.c"
	}
#line 5140 "../src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 38236 "Photo.c"
}

static void
library_photo_import_gps_metadata (LibraryPhoto* self)
{
	GpsCoords gps_coords = {0};
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	GpsCoords _tmp2_ = {0};
	GpsCoords _tmp3_;
	GpsCoords _tmp4_;
#line 5143 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5144 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 5144 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5144 "../src/Photo.vala"
	photo_metadata_get_gps_coords (_tmp1_, &_tmp2_);
#line 5144 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5144 "../src/Photo.vala"
	_media_metadata_unref0 (_tmp1_);
#line 5144 "../src/Photo.vala"
	gps_coords = _tmp3_;
#line 5145 "../src/Photo.vala"
	_tmp4_ = gps_coords;
#line 5145 "../src/Photo.vala"
	positionable_set_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp4_);
#line 38266 "Photo.c"
}

GeeCollection*
library_photo_get_import_keywords (LibraryPhoto* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result = NULL;
#line 5149 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 5150 "../src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 5150 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 5150 "../src/Photo.vala"
	result = _tmp1_;
#line 5150 "../src/Photo.vala"
	return result;
#line 38285 "Photo.c"
}

void
library_photo_clear_import_keywords (LibraryPhoto* self)
{
#line 5153 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5154 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5154 "../src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 38297 "Photo.c"
}

static void
library_photo_real_notify_altered (DataObject* base,
                                   Alteration* alteration)
{
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
#line 5157 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5157 "../src/Photo.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 5159 "../src/Photo.vala"
	if (!self->priv->block_thumbnail_generation) {
#line 5159 "../src/Photo.vala"
		_tmp0_ = alteration_has_subject (alteration, "image");
#line 38314 "Photo.c"
	} else {
#line 5159 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 38318 "Photo.c"
	}
#line 5159 "../src/Photo.vala"
	if (_tmp0_) {
#line 38322 "Photo.c"
		OneShotScheduler* _tmp1_;
#line 5160 "../src/Photo.vala"
		_tmp1_ = self->priv->thumbnail_scheduler;
#line 5160 "../src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp1_, G_PRIORITY_LOW);
#line 38328 "Photo.c"
	}
#line 5162 "../src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_OBJECT, DataObject), alteration);
#line 38332 "Photo.c"
}

static GdkPixbuf*
library_photo_real_get_preview_pixbuf (MediaSource* base,
                                       Scaling* scaling,
                                       GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 5165 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5165 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 5166 "../src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error0_);
#line 5166 "../src/Photo.vala"
	pixbuf = _tmp0_;
#line 5166 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5166 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5166 "../src/Photo.vala"
		return NULL;
#line 38360 "Photo.c"
	}
#line 5168 "../src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 5168 "../src/Photo.vala"
	result = _tmp1_;
#line 5168 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 5168 "../src/Photo.vala"
	return result;
#line 38370 "Photo.c"
}

static void
library_photo_real_rotate (Photo* base,
                           Rotation rotation)
{
	LibraryPhoto * self;
	GError* _inner_error0_ = NULL;
#line 5171 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5173 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 5174 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), rotation);
#line 5175 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 38387 "Photo.c"
	{
#line 5183 "../src/Photo.vala"
		thumbnail_cache_rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), rotation, &_inner_error0_);
#line 5183 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38393 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5182 "../src/Photo.vala"
		err = _inner_error0_;
#line 5182 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5186 "../src/Photo.vala"
		_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 5186 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5186 "../src/Photo.vala"
		_tmp2_ = err;
#line 5186 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5186 "../src/Photo.vala"
		g_warning ("Photo.vala:5186: Unable to update thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5186 "../src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5182 "../src/Photo.vala"
		_g_error_free0 (err);
#line 38423 "Photo.c"
	}
	__finally0:
#line 5182 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5182 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5182 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5182 "../src/Photo.vala"
		return;
#line 38434 "Photo.c"
	}
#line 5189 "../src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 38438 "Photo.c"
}

static GdkPixbuf*
library_photo_real_get_thumbnail (ThumbnailSource* base,
                                  gint scale,
                                  GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 5193 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5194 "../src/Photo.vala"
	_tmp1_ = thumbnail_cache_fetch (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), scale, &_inner_error0_);
#line 5194 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 5194 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5194 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5194 "../src/Photo.vala"
		return NULL;
#line 38464 "Photo.c"
	}
#line 5194 "../src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 5194 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 5194 "../src/Photo.vala"
	result = _tmp2_;
#line 5194 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 5194 "../src/Photo.vala"
	return result;
#line 38476 "Photo.c"
}

static void
_library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                              gint64 total_num_bytes,
                                                              gpointer self)
{
#line 5206 "../src/Photo.vala"
	library_photo_on_duplicate_progress ((LibraryPhoto*) self, current_num_bytes, total_num_bytes);
#line 38486 "Photo.c"
}

static void
library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                       BackingPhotoRow* backing,
                                       BackingPhotoID* result,
                                       GError** error)
{
	BackingPhotoID backing_id = {0};
	gboolean _tmp0_ = FALSE;
	GFile* file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 5199 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5199 "../src/Photo.vala"
	g_return_if_fail ((backing == NULL) || IS_BACKING_PHOTO_ROW (backing));
#line 5200 "../src/Photo.vala"
	backing_photo_id_init (&backing_id, BACKING_PHOTO_ID_INVALID);
#line 5201 "../src/Photo.vala"
	if (backing == NULL) {
#line 5201 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 38512 "Photo.c"
	} else {
		const gchar* _tmp1_;
#line 5201 "../src/Photo.vala"
		_tmp1_ = backing->filepath;
#line 5201 "../src/Photo.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 38519 "Photo.c"
	}
#line 5201 "../src/Photo.vala"
	if (_tmp0_) {
#line 5202 "../src/Photo.vala"
		*result = backing_id;
#line 5202 "../src/Photo.vala"
		return;
#line 38527 "Photo.c"
	}
#line 5204 "../src/Photo.vala"
	_tmp2_ = backing->filepath;
#line 5204 "../src/Photo.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 5204 "../src/Photo.vala"
	file = _tmp3_;
#line 5205 "../src/Photo.vala"
	_tmp4_ = file;
#line 5205 "../src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 38539 "Photo.c"
		GFile* dupe_file = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_;
		DetectedPhotoInformation* detected = NULL;
		BackingPhotoRow* state = NULL;
		GFile* _tmp7_;
		DetectedPhotoInformation* _tmp8_ = NULL;
		BackingPhotoRow* _tmp9_;
		BackingPhotoRow* _tmp10_;
#line 5206 "../src/Photo.vala"
		_tmp5_ = file;
#line 5206 "../src/Photo.vala"
		_tmp6_ = library_files_duplicate (_tmp5_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5206 "../src/Photo.vala"
		dupe_file = _tmp6_;
#line 5206 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5206 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5206 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 5206 "../src/Photo.vala"
			return;
#line 38563 "Photo.c"
		}
#line 5209 "../src/Photo.vala"
		_tmp7_ = dupe_file;
#line 5209 "../src/Photo.vala"
		_tmp9_ = photo_query_backing_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp7_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp8_, &_inner_error0_);
#line 5209 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5209 "../src/Photo.vala"
		detected = _tmp8_;
#line 5209 "../src/Photo.vala"
		state = _tmp9_;
#line 5209 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5209 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5209 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 5209 "../src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 5209 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 5209 "../src/Photo.vala"
			return;
#line 38587 "Photo.c"
		}
#line 5211 "../src/Photo.vala"
		_tmp10_ = state;
#line 5211 "../src/Photo.vala"
		if (_tmp10_ != NULL) {
#line 38593 "Photo.c"
			BackingPhotoTable* _tmp11_;
			BackingPhotoTable* _tmp12_;
			BackingPhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			BackingPhotoID _tmp15_;
#line 5212 "../src/Photo.vala"
			_tmp11_ = backing_photo_table_get_instance ();
#line 5212 "../src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 5212 "../src/Photo.vala"
			_tmp13_ = state;
#line 5212 "../src/Photo.vala"
			backing_photo_table_add (_tmp12_, _tmp13_, &_inner_error0_);
#line 5212 "../src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 5212 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5212 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 5212 "../src/Photo.vala"
				_backing_photo_row_unref0 (state);
#line 5212 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 5212 "../src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 5212 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 5212 "../src/Photo.vala"
				return;
#line 38623 "Photo.c"
			}
#line 5213 "../src/Photo.vala"
			_tmp14_ = state;
#line 5213 "../src/Photo.vala"
			_tmp15_ = _tmp14_->id;
#line 5213 "../src/Photo.vala"
			backing_id = _tmp15_;
#line 38631 "Photo.c"
		}
#line 5205 "../src/Photo.vala"
		_backing_photo_row_unref0 (state);
#line 5205 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5205 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 38639 "Photo.c"
	}
#line 5217 "../src/Photo.vala"
	*result = backing_id;
#line 5217 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 5217 "../src/Photo.vala"
	return;
#line 38647 "Photo.c"
}

LibraryPhoto*
library_photo_duplicate (LibraryPhoto* self,
                         GError** error)
{
	GFile* dupe_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	BackingPhotoID dupe_editable_id = {0};
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	BackingPhotoID _tmp6_ = {0};
	BackingPhotoID _tmp7_;
	BackingPhotoID dupe_raw_shotwell_id = {0};
	BackingPhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	BackingPhotoID _tmp10_ = {0};
	BackingPhotoID _tmp11_;
	BackingPhotoID dupe_raw_camera_id = {0};
	BackingPhotoRow* _tmp12_;
	BackingPhotoRow* _tmp13_;
	BackingPhotoID _tmp14_ = {0};
	BackingPhotoID _tmp15_;
	BackingPhotoID dupe_raw_embedded_id = {0};
	BackingPhotoRow* _tmp16_;
	BackingPhotoRow* _tmp17_;
	BackingPhotoID _tmp18_ = {0};
	BackingPhotoID _tmp19_;
	PhotoID dupe_id = {0};
	PhotoTable* _tmp20_;
	PhotoTable* _tmp21_;
	PhotoID _tmp22_ = {0};
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	BackingPhotoID _tmp26_;
	BackingPhotoID _tmp27_;
	BackingPhotoID _tmp28_;
	BackingPhotoID _tmp29_;
	PhotoID _tmp30_ = {0};
	PhotoID _tmp31_;
	PhotoRow* dupe_row = NULL;
	PhotoTable* _tmp32_;
	PhotoTable* _tmp33_;
	PhotoID _tmp34_;
	PhotoRow* _tmp35_;
	PhotoRow* _tmp36_;
	LibraryPhoto* dupe = NULL;
	PhotoRow* _tmp37_;
	LibraryPhoto* _tmp38_;
	LibraryPhoto* _tmp39_;
	LibraryPhotoSourceCollection* _tmp40_;
	LibraryPhoto* _tmp41_;
	LibraryPhoto* _tmp42_;
	Event* _tmp43_;
	Event* _tmp44_;
	gboolean _tmp45_;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp50_;
	GeeList* _tmp51_;
	GeeCollection* _tmp52_;
	GeeCollection* faces = NULL;
	FaceSourceCollection* _tmp60_;
	GeeList* _tmp61_;
	GeeCollection* _tmp62_;
	GError* _inner_error0_ = NULL;
	LibraryPhoto* result = NULL;
#line 5220 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 5222 "../src/Photo.vala"
	_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5222 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5222 "../src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5222 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5222 "../src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 5222 "../src/Photo.vala"
	dupe_file = _tmp3_;
#line 5222 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5222 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5222 "../src/Photo.vala"
		return NULL;
#line 38738 "Photo.c"
	}
#line 5225 "../src/Photo.vala"
	_tmp4_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo));
#line 5225 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 5225 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp5_, &_tmp6_, &_inner_error0_);
#line 5225 "../src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 5225 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp5_);
#line 5225 "../src/Photo.vala"
	dupe_editable_id = _tmp7_;
#line 5225 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5225 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5225 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5225 "../src/Photo.vala"
		return NULL;
#line 38760 "Photo.c"
	}
#line 5226 "../src/Photo.vala"
	_tmp8_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_SHOTWELL);
#line 5226 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 5226 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp9_, &_tmp10_, &_inner_error0_);
#line 5226 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 5226 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp9_);
#line 5226 "../src/Photo.vala"
	dupe_raw_shotwell_id = _tmp11_;
#line 5226 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5226 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5226 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5226 "../src/Photo.vala"
		return NULL;
#line 38782 "Photo.c"
	}
#line 5228 "../src/Photo.vala"
	_tmp12_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_CAMERA);
#line 5228 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 5228 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp13_, &_tmp14_, &_inner_error0_);
#line 5228 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 5228 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp13_);
#line 5228 "../src/Photo.vala"
	dupe_raw_camera_id = _tmp15_;
#line 5228 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5228 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5228 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5228 "../src/Photo.vala"
		return NULL;
#line 38804 "Photo.c"
	}
#line 5230 "../src/Photo.vala"
	_tmp16_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_EMBEDDED);
#line 5230 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 5230 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp17_, &_tmp18_, &_inner_error0_);
#line 5230 "../src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 5230 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp17_);
#line 5230 "../src/Photo.vala"
	dupe_raw_embedded_id = _tmp19_;
#line 5230 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5230 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5230 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5230 "../src/Photo.vala"
		return NULL;
#line 38826 "Photo.c"
	}
#line 5234 "../src/Photo.vala"
	_tmp20_ = photo_table_get_instance ();
#line 5234 "../src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 5234 "../src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp22_);
#line 5234 "../src/Photo.vala"
	_tmp23_ = dupe_file;
#line 5234 "../src/Photo.vala"
	_tmp24_ = g_file_get_path (_tmp23_);
#line 5234 "../src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 5234 "../src/Photo.vala"
	_tmp26_ = dupe_editable_id;
#line 5234 "../src/Photo.vala"
	_tmp27_ = dupe_raw_shotwell_id;
#line 5234 "../src/Photo.vala"
	_tmp28_ = dupe_raw_camera_id;
#line 5234 "../src/Photo.vala"
	_tmp29_ = dupe_raw_embedded_id;
#line 5234 "../src/Photo.vala"
	photo_table_duplicate (_tmp21_, &_tmp22_, _tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_, &_tmp30_);
#line 5234 "../src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 5234 "../src/Photo.vala"
	_g_free0 (_tmp25_);
#line 5234 "../src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 5234 "../src/Photo.vala"
	dupe_id = _tmp31_;
#line 5236 "../src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 5236 "../src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 5236 "../src/Photo.vala"
	_tmp34_ = dupe_id;
#line 5236 "../src/Photo.vala"
	_tmp35_ = photo_table_get_row (_tmp33_, &_tmp34_);
#line 5236 "../src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 5236 "../src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 5236 "../src/Photo.vala"
	dupe_row = _tmp36_;
#line 5239 "../src/Photo.vala"
	_tmp37_ = dupe_row;
#line 5239 "../src/Photo.vala"
	_tmp38_ = library_photo_new (_tmp37_);
#line 5239 "../src/Photo.vala"
	dupe = _tmp38_;
#line 5242 "../src/Photo.vala"
	_tmp39_ = dupe;
#line 5242 "../src/Photo.vala"
	thumbnail_cache_duplicate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 5245 "../src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 5245 "../src/Photo.vala"
	_tmp41_ = dupe;
#line 5245 "../src/Photo.vala"
	data_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_DATA_OBJECT, DataObject));
#line 5248 "../src/Photo.vala"
	_tmp42_ = dupe;
#line 5248 "../src/Photo.vala"
	_tmp43_ = media_source_get_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5248 "../src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 5248 "../src/Photo.vala"
	_tmp45_ = _tmp44_ != NULL;
#line 5248 "../src/Photo.vala"
	_g_object_unref0 (_tmp44_);
#line 5248 "../src/Photo.vala"
	if (_tmp45_) {
#line 38900 "Photo.c"
		LibraryPhoto* _tmp46_;
		Event* _tmp47_;
		Event* _tmp48_;
		LibraryPhoto* _tmp49_;
#line 5249 "../src/Photo.vala"
		_tmp46_ = dupe;
#line 5249 "../src/Photo.vala"
		_tmp47_ = media_source_get_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5249 "../src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 5249 "../src/Photo.vala"
		_tmp49_ = dupe;
#line 5249 "../src/Photo.vala"
		event_attach (_tmp48_, G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5249 "../src/Photo.vala"
		_g_object_unref0 (_tmp48_);
#line 38917 "Photo.c"
	}
#line 5252 "../src/Photo.vala"
	_tmp50_ = tag_global;
#line 5252 "../src/Photo.vala"
	_tmp51_ = tag_source_collection_fetch_for_source (_tmp50_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5252 "../src/Photo.vala"
	tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5253 "../src/Photo.vala"
	_tmp52_ = tags;
#line 5253 "../src/Photo.vala"
	if (_tmp52_ != NULL) {
#line 38929 "Photo.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp53_;
			GeeIterator* _tmp54_;
#line 5254 "../src/Photo.vala"
			_tmp53_ = tags;
#line 5254 "../src/Photo.vala"
			_tmp54_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5254 "../src/Photo.vala"
			_tag_it = _tmp54_;
#line 5254 "../src/Photo.vala"
			while (TRUE) {
#line 38942 "Photo.c"
				GeeIterator* _tmp55_;
				Tag* tag = NULL;
				GeeIterator* _tmp56_;
				gpointer _tmp57_;
				Tag* _tmp58_;
				LibraryPhoto* _tmp59_;
#line 5254 "../src/Photo.vala"
				_tmp55_ = _tag_it;
#line 5254 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp55_)) {
#line 5254 "../src/Photo.vala"
					break;
#line 38955 "Photo.c"
				}
#line 5254 "../src/Photo.vala"
				_tmp56_ = _tag_it;
#line 5254 "../src/Photo.vala"
				_tmp57_ = gee_iterator_get (_tmp56_);
#line 5254 "../src/Photo.vala"
				tag = (Tag*) _tmp57_;
#line 5255 "../src/Photo.vala"
				_tmp58_ = tag;
#line 5255 "../src/Photo.vala"
				_tmp59_ = dupe;
#line 5255 "../src/Photo.vala"
				tag_attach (_tmp58_, G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5254 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 38971 "Photo.c"
			}
#line 5254 "../src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 38975 "Photo.c"
		}
	}
#line 5261 "../src/Photo.vala"
	_tmp60_ = face_global;
#line 5261 "../src/Photo.vala"
	_tmp61_ = face_source_collection_fetch_for_source (_tmp60_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5261 "../src/Photo.vala"
	faces = G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5262 "../src/Photo.vala"
	_tmp62_ = faces;
#line 5262 "../src/Photo.vala"
	if (_tmp62_ != NULL) {
#line 38988 "Photo.c"
		{
			GeeIterator* _face_it = NULL;
			GeeCollection* _tmp63_;
			GeeIterator* _tmp64_;
#line 5263 "../src/Photo.vala"
			_tmp63_ = faces;
#line 5263 "../src/Photo.vala"
			_tmp64_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5263 "../src/Photo.vala"
			_face_it = _tmp64_;
#line 5263 "../src/Photo.vala"
			while (TRUE) {
#line 39001 "Photo.c"
				GeeIterator* _tmp65_;
				Face* face = NULL;
				GeeIterator* _tmp66_;
				gpointer _tmp67_;
				FaceLocation* location = NULL;
				Face* _tmp68_;
				FaceID _tmp69_ = {0};
				PhotoID _tmp70_ = {0};
				FaceLocation* _tmp71_;
				FaceLocation* _tmp72_;
#line 5263 "../src/Photo.vala"
				_tmp65_ = _face_it;
#line 5263 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp65_)) {
#line 5263 "../src/Photo.vala"
					break;
#line 39018 "Photo.c"
				}
#line 5263 "../src/Photo.vala"
				_tmp66_ = _face_it;
#line 5263 "../src/Photo.vala"
				_tmp67_ = gee_iterator_get (_tmp66_);
#line 5263 "../src/Photo.vala"
				face = (Face*) _tmp67_;
#line 5264 "../src/Photo.vala"
				_tmp68_ = face;
#line 5264 "../src/Photo.vala"
				face_get_face_id (_tmp68_, &_tmp69_);
#line 5264 "../src/Photo.vala"
				photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp70_);
#line 5264 "../src/Photo.vala"
				_tmp71_ = face_location_get_face_location (&_tmp69_, &_tmp70_);
#line 5264 "../src/Photo.vala"
				location = _tmp71_;
#line 5266 "../src/Photo.vala"
				_tmp72_ = location;
#line 5266 "../src/Photo.vala"
				if (_tmp72_ != NULL) {
#line 39040 "Photo.c"
					Face* _tmp73_;
					LibraryPhoto* _tmp74_;
					Face* _tmp75_;
					FaceID _tmp76_ = {0};
					LibraryPhoto* _tmp77_;
					PhotoID _tmp78_ = {0};
					FaceLocation* _tmp79_;
					FaceLocationData _tmp80_ = {0};
					FaceLocationData _tmp81_;
					FaceLocation* _tmp82_;
					FaceLocation* _tmp83_;
#line 5267 "../src/Photo.vala"
					_tmp73_ = face;
#line 5267 "../src/Photo.vala"
					_tmp74_ = dupe;
#line 5267 "../src/Photo.vala"
					face_attach (_tmp73_, G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5268 "../src/Photo.vala"
					_tmp75_ = face;
#line 5268 "../src/Photo.vala"
					face_get_face_id (_tmp75_, &_tmp76_);
#line 5268 "../src/Photo.vala"
					_tmp77_ = dupe;
#line 5268 "../src/Photo.vala"
					photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, TYPE_PHOTO, Photo), &_tmp78_);
#line 5268 "../src/Photo.vala"
					_tmp79_ = location;
#line 5268 "../src/Photo.vala"
					face_location_get_face_data (_tmp79_, &_tmp80_);
#line 5268 "../src/Photo.vala"
					_tmp81_ = _tmp80_;
#line 5268 "../src/Photo.vala"
					_tmp82_ = face_location_create (&_tmp76_, &_tmp78_, &_tmp81_);
#line 5268 "../src/Photo.vala"
					_tmp83_ = _tmp82_;
#line 5268 "../src/Photo.vala"
					_g_object_unref0 (_tmp83_);
#line 5268 "../src/Photo.vala"
					face_location_data_destroy (&_tmp81_);
#line 39080 "Photo.c"
				}
#line 5263 "../src/Photo.vala"
				_g_object_unref0 (location);
#line 5263 "../src/Photo.vala"
				_g_object_unref0 (face);
#line 39086 "Photo.c"
			}
#line 5263 "../src/Photo.vala"
			_g_object_unref0 (_face_it);
#line 39090 "Photo.c"
		}
	}
#line 5275 "../src/Photo.vala"
	result = dupe;
#line 5275 "../src/Photo.vala"
	_g_object_unref0 (faces);
#line 5275 "../src/Photo.vala"
	_g_object_unref0 (tags);
#line 5275 "../src/Photo.vala"
	_photo_row_unref0 (dupe_row);
#line 5275 "../src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 5275 "../src/Photo.vala"
	return result;
#line 39105 "Photo.c"
}

static void
library_photo_on_duplicate_progress (LibraryPhoto* self,
                                     gint64 current,
                                     gint64 total)
{
#line 5278 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5279 "../src/Photo.vala"
	spin_event_loop ();
#line 39117 "Photo.c"
}

static void
library_photo_upgrade_rating_flags (LibraryPhoto* self,
                                    guint64 flags)
{
#line 5282 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5283 "../src/Photo.vala"
	if ((flags & LIBRARY_PHOTO_FLAG_HIDDEN) != ((guint64) 0)) {
#line 5284 "../src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), RATING_REJECTED);
#line 5285 "../src/Photo.vala"
		photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_HIDDEN, NULL);
#line 39132 "Photo.c"
	}
#line 5288 "../src/Photo.vala"
	if ((flags & LIBRARY_PHOTO_FLAG_FAVORITE) != ((guint64) 0)) {
#line 5289 "../src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), RATING_FIVE);
#line 5290 "../src/Photo.vala"
		photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FAVORITE, NULL);
#line 39140 "Photo.c"
	}
}

static gboolean
library_photo_real_is_trashed (MediaSource* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5295 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5296 "../src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH);
#line 5296 "../src/Photo.vala"
	return result;
#line 39155 "Photo.c"
}

static void
library_photo_real_trash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5299 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5300 "../src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39166 "Photo.c"
}

static void
library_photo_real_untrash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5303 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5304 "../src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39177 "Photo.c"
}

static gboolean
library_photo_real_is_offline (Monitorable* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5307 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5308 "../src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE);
#line 5308 "../src/Photo.vala"
	return result;
#line 39191 "Photo.c"
}

static void
library_photo_real_mark_offline (Monitorable* base)
{
	LibraryPhoto * self;
#line 5311 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5312 "../src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39202 "Photo.c"
}

static void
library_photo_real_mark_online (Monitorable* base)
{
	LibraryPhoto * self;
#line 5315 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5316 "../src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39213 "Photo.c"
}

static gboolean
library_photo_real_is_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5319 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5320 "../src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED);
#line 5320 "../src/Photo.vala"
	return result;
#line 39227 "Photo.c"
}

static void
library_photo_real_mark_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5323 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5324 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5324 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5324 "../src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5324 "../src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39246 "Photo.c"
}

static void
library_photo_real_mark_unflagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5327 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5328 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5328 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5328 "../src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5328 "../src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39265 "Photo.c"
}

static gboolean
library_photo_real_internal_delete_backing (DataSource* base,
                                            GError** error)
{
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 5331 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5334 "../src/Photo.vala"
	_tmp0_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_SOURCE, DataSource), &_inner_error0_);
#line 5334 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39282 "Photo.c"
		gboolean _tmp1_ = FALSE;
#line 5334 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5334 "../src/Photo.vala"
		return _tmp1_;
#line 39288 "Photo.c"
	}
#line 5334 "../src/Photo.vala"
	if (!_tmp0_) {
#line 5335 "../src/Photo.vala"
		result = FALSE;
#line 5335 "../src/Photo.vala"
		return result;
#line 39296 "Photo.c"
	}
#line 5337 "../src/Photo.vala"
	result = media_source_delete_original_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5337 "../src/Photo.vala"
	return result;
#line 39302 "Photo.c"
}

static void
library_photo_real_destroy (DataSource* base)
{
	LibraryPhoto * self;
	PhotoID photo_id = {0};
	PhotoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 5340 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5341 "../src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp0_);
#line 5341 "../src/Photo.vala"
	photo_id = _tmp0_;
#line 5344 "../src/Photo.vala"
	thumbnail_cache_remove (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 39320 "Photo.c"
	{
		PhotoTable* _tmp1_;
		PhotoTable* _tmp2_;
		PhotoID _tmp3_;
#line 5350 "../src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 5350 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 5350 "../src/Photo.vala"
		_tmp3_ = photo_id;
#line 5350 "../src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error0_);
#line 5350 "../src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 5350 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5350 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 39339 "Photo.c"
				goto __catch0_database_error;
			}
#line 5350 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5350 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5350 "../src/Photo.vala"
			return;
#line 39348 "Photo.c"
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 5349 "../src/Photo.vala"
		err = _inner_error0_;
#line 5349 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5352 "../src/Photo.vala"
		_tmp4_ = err;
#line 5352 "../src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 5349 "../src/Photo.vala"
		_g_error_free0 (err);
#line 39366 "Photo.c"
	}
	__finally0:
#line 5349 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5349 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5349 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5349 "../src/Photo.vala"
		return;
#line 39377 "Photo.c"
	}
#line 5355 "../src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_SOURCE, DataSource));
#line 39381 "Photo.c"
}

gboolean
library_photo_has_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format)
{
	PhotoID _tmp0_ = {0};
	gboolean result = FALSE;
#line 5358 "../src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 5360 "../src/Photo.vala"
	library_photo_get_nontrash_duplicate (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5360 "../src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 5360 "../src/Photo.vala"
	return result;
#line 39400 "Photo.c"
}

void
library_photo_get_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format,
                                      PhotoID* result)
{
	PhotoID* ids = NULL;
	gint _tmp0_ = 0;
	PhotoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gboolean _tmp2_ = FALSE;
	PhotoID* _tmp3_;
	gint _tmp3__length1;
	PhotoID* _tmp6_;
	gint _tmp6__length1;
	PhotoID _tmp13_ = {0};
#line 5363 "../src/Photo.vala"
	g_return_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 5365 "../src/Photo.vala"
	_tmp1_ = photo_get_duplicate_ids (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5365 "../src/Photo.vala"
	ids = _tmp1_;
#line 5365 "../src/Photo.vala"
	ids_length1 = _tmp0_;
#line 5365 "../src/Photo.vala"
	_ids_size_ = ids_length1;
#line 5367 "../src/Photo.vala"
	_tmp3_ = ids;
#line 5367 "../src/Photo.vala"
	_tmp3__length1 = ids_length1;
#line 5367 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 5367 "../src/Photo.vala"
		_tmp2_ = TRUE;
#line 39439 "Photo.c"
	} else {
		PhotoID* _tmp4_;
		gint _tmp4__length1;
#line 5367 "../src/Photo.vala"
		_tmp4_ = ids;
#line 5367 "../src/Photo.vala"
		_tmp4__length1 = ids_length1;
#line 5367 "../src/Photo.vala"
		_tmp2_ = _tmp4__length1 == 0;
#line 39449 "Photo.c"
	}
#line 5367 "../src/Photo.vala"
	if (_tmp2_) {
#line 39453 "Photo.c"
		PhotoID _tmp5_ = {0};
#line 5368 "../src/Photo.vala"
		photo_id_init (&_tmp5_, PHOTO_ID_INVALID);
#line 5368 "../src/Photo.vala"
		*result = _tmp5_;
#line 5368 "../src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 5368 "../src/Photo.vala"
		return;
#line 39463 "Photo.c"
	}
#line 5370 "../src/Photo.vala"
	_tmp6_ = ids;
#line 5370 "../src/Photo.vala"
	_tmp6__length1 = ids_length1;
#line 39469 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 5370 "../src/Photo.vala"
		id_collection = _tmp6_;
#line 5370 "../src/Photo.vala"
		id_collection_length1 = _tmp6__length1;
#line 5370 "../src/Photo.vala"
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
#line 39481 "Photo.c"
			PhotoID id = {0};
#line 5370 "../src/Photo.vala"
			id = id_collection[id_it];
#line 39485 "Photo.c"
			{
				LibraryPhoto* photo = NULL;
				LibraryPhotoSourceCollection* _tmp7_;
				PhotoID _tmp8_;
				LibraryPhoto* _tmp9_;
				gboolean _tmp10_ = FALSE;
				LibraryPhoto* _tmp11_;
#line 5371 "../src/Photo.vala"
				_tmp7_ = library_photo_global;
#line 5371 "../src/Photo.vala"
				_tmp8_ = id;
#line 5371 "../src/Photo.vala"
				_tmp9_ = library_photo_source_collection_fetch (_tmp7_, &_tmp8_);
#line 5371 "../src/Photo.vala"
				photo = _tmp9_;
#line 5372 "../src/Photo.vala"
				_tmp11_ = photo;
#line 5372 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 39505 "Photo.c"
					LibraryPhoto* _tmp12_;
#line 5372 "../src/Photo.vala"
					_tmp12_ = photo;
#line 5372 "../src/Photo.vala"
					_tmp10_ = !media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_MEDIA_SOURCE, MediaSource));
#line 39511 "Photo.c"
				} else {
#line 5372 "../src/Photo.vala"
					_tmp10_ = FALSE;
#line 39515 "Photo.c"
				}
#line 5372 "../src/Photo.vala"
				if (_tmp10_) {
#line 5373 "../src/Photo.vala"
					*result = id;
#line 5373 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 5373 "../src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 5373 "../src/Photo.vala"
					return;
#line 39527 "Photo.c"
				}
#line 5370 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 39531 "Photo.c"
			}
		}
	}
#line 5376 "../src/Photo.vala"
	photo_id_init (&_tmp13_, PHOTO_ID_INVALID);
#line 5376 "../src/Photo.vala"
	*result = _tmp13_;
#line 5376 "../src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 5376 "../src/Photo.vala"
	return;
#line 39543 "Photo.c"
}

static gboolean
library_photo_real_has_user_generated_metadata (Photo* base)
{
	LibraryPhoto * self;
	GeeList* tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp12_;
	GpsCoords old_coords = {0};
	PhotoMetadata* _tmp13_;
	GpsCoords _tmp14_ = {0};
	GpsCoords _tmp15_ = {0};
	gboolean _tmp16_;
	GeeSet* keywords = NULL;
	PhotoMetadata* _tmp17_;
	GeeSet* _tmp18_;
	gint _tmp19_ = 0;
	GeeList* _tmp20_;
	gint tags_count = 0;
	gint _tmp24_ = 0;
	GeeSet* _tmp25_;
	gint keywords_count = 0;
	gboolean _tmp29_ = FALSE;
	GeeList* _tmp30_;
	gboolean result = FALSE;
#line 5379 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5380 "../src/Photo.vala"
	_tmp0_ = tag_global;
#line 5380 "../src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5380 "../src/Photo.vala"
	tags = _tmp1_;
#line 5382 "../src/Photo.vala"
	_tmp2_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 5382 "../src/Photo.vala"
	metadata = _tmp2_;
#line 5383 "../src/Photo.vala"
	_tmp3_ = metadata;
#line 5383 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 39590 "Photo.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		GeeList* _tmp7_;
#line 5384 "../src/Photo.vala"
		_tmp7_ = tags;
#line 5384 "../src/Photo.vala"
		if (_tmp7_ != NULL) {
#line 5384 "../src/Photo.vala"
			_tmp6_ = TRUE;
#line 39601 "Photo.c"
		} else {
			GeeList* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
#line 5384 "../src/Photo.vala"
			_tmp8_ = tags;
#line 5384 "../src/Photo.vala"
			_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5384 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 5384 "../src/Photo.vala"
			_tmp6_ = _tmp10_ > 0;
#line 39614 "Photo.c"
		}
#line 5384 "../src/Photo.vala"
		if (_tmp6_) {
#line 5384 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 39620 "Photo.c"
		} else {
#line 5384 "../src/Photo.vala"
			_tmp5_ = media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != RATING_UNRATED;
#line 39624 "Photo.c"
		}
#line 5384 "../src/Photo.vala"
		if (_tmp5_) {
#line 5384 "../src/Photo.vala"
			_tmp4_ = TRUE;
#line 39630 "Photo.c"
		} else {
			GpsCoords _tmp11_ = {0};
#line 5384 "../src/Photo.vala"
			positionable_get_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp11_);
#line 5384 "../src/Photo.vala"
			_tmp4_ = _tmp11_.has_gps != 0;
#line 39637 "Photo.c"
		}
#line 5384 "../src/Photo.vala"
		result = _tmp4_;
#line 5384 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5384 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5384 "../src/Photo.vala"
		return result;
#line 39647 "Photo.c"
	}
#line 5386 "../src/Photo.vala"
	_tmp12_ = metadata;
#line 5386 "../src/Photo.vala"
	if (media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != photo_metadata_get_rating (_tmp12_)) {
#line 5387 "../src/Photo.vala"
		result = TRUE;
#line 5387 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5387 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5387 "../src/Photo.vala"
		return result;
#line 39661 "Photo.c"
	}
#line 5389 "../src/Photo.vala"
	_tmp13_ = metadata;
#line 5389 "../src/Photo.vala"
	photo_metadata_get_gps_coords (_tmp13_, &_tmp14_);
#line 5389 "../src/Photo.vala"
	old_coords = _tmp14_;
#line 5390 "../src/Photo.vala"
	positionable_get_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp15_);
#line 5390 "../src/Photo.vala"
	_tmp16_ = gps_coords_equals (&_tmp15_, &old_coords);
#line 5390 "../src/Photo.vala"
	if (!_tmp16_) {
#line 5391 "../src/Photo.vala"
		result = TRUE;
#line 5391 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5391 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5391 "../src/Photo.vala"
		return result;
#line 39683 "Photo.c"
	}
#line 5393 "../src/Photo.vala"
	_tmp17_ = metadata;
#line 5393 "../src/Photo.vala"
	_tmp18_ = photo_metadata_get_keywords (_tmp17_, NULL, NULL, NULL);
#line 5393 "../src/Photo.vala"
	keywords = _tmp18_;
#line 5394 "../src/Photo.vala"
	_tmp20_ = tags;
#line 5394 "../src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 39695 "Photo.c"
		GeeList* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
#line 5394 "../src/Photo.vala"
		_tmp21_ = tags;
#line 5394 "../src/Photo.vala"
		_tmp22_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5394 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 5394 "../src/Photo.vala"
		_tmp19_ = _tmp23_;
#line 39707 "Photo.c"
	} else {
#line 5394 "../src/Photo.vala"
		_tmp19_ = 0;
#line 39711 "Photo.c"
	}
#line 5394 "../src/Photo.vala"
	tags_count = _tmp19_;
#line 5395 "../src/Photo.vala"
	_tmp25_ = keywords;
#line 5395 "../src/Photo.vala"
	if (_tmp25_ != NULL) {
#line 39719 "Photo.c"
		GeeSet* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
#line 5395 "../src/Photo.vala"
		_tmp26_ = keywords;
#line 5395 "../src/Photo.vala"
		_tmp27_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5395 "../src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 5395 "../src/Photo.vala"
		_tmp24_ = _tmp28_;
#line 39731 "Photo.c"
	} else {
#line 5395 "../src/Photo.vala"
		_tmp24_ = 0;
#line 39735 "Photo.c"
	}
#line 5395 "../src/Photo.vala"
	keywords_count = _tmp24_;
#line 5397 "../src/Photo.vala"
	if (tags_count != keywords_count) {
#line 5398 "../src/Photo.vala"
		result = TRUE;
#line 5398 "../src/Photo.vala"
		_g_object_unref0 (keywords);
#line 5398 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5398 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5398 "../src/Photo.vala"
		return result;
#line 39751 "Photo.c"
	}
#line 5400 "../src/Photo.vala"
	_tmp30_ = tags;
#line 5400 "../src/Photo.vala"
	if (_tmp30_ != NULL) {
#line 39757 "Photo.c"
		GeeSet* _tmp31_;
#line 5400 "../src/Photo.vala"
		_tmp31_ = keywords;
#line 5400 "../src/Photo.vala"
		_tmp29_ = _tmp31_ != NULL;
#line 39763 "Photo.c"
	} else {
#line 5400 "../src/Photo.vala"
		_tmp29_ = FALSE;
#line 39767 "Photo.c"
	}
#line 5400 "../src/Photo.vala"
	if (_tmp29_) {
#line 39771 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp32_;
			gint _tag_size = 0;
			GeeList* _tmp33_;
			gint _tmp34_;
			gint _tmp35_;
			gint _tag_index = 0;
#line 5401 "../src/Photo.vala"
			_tmp32_ = tags;
#line 5401 "../src/Photo.vala"
			_tag_list = _tmp32_;
#line 5401 "../src/Photo.vala"
			_tmp33_ = _tag_list;
#line 5401 "../src/Photo.vala"
			_tmp34_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5401 "../src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 5401 "../src/Photo.vala"
			_tag_size = _tmp35_;
#line 5401 "../src/Photo.vala"
			_tag_index = -1;
#line 5401 "../src/Photo.vala"
			while (TRUE) {
#line 39796 "Photo.c"
				gint _tmp36_;
				gint _tmp37_;
				Tag* tag = NULL;
				GeeList* _tmp38_;
				gpointer _tmp39_;
				GeeSet* _tmp40_;
				Tag* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
				gboolean _tmp46_;
#line 5401 "../src/Photo.vala"
				_tag_index = _tag_index + 1;
#line 5401 "../src/Photo.vala"
				_tmp36_ = _tag_index;
#line 5401 "../src/Photo.vala"
				_tmp37_ = _tag_size;
#line 5401 "../src/Photo.vala"
				if (!(_tmp36_ < _tmp37_)) {
#line 5401 "../src/Photo.vala"
					break;
#line 39819 "Photo.c"
				}
#line 5401 "../src/Photo.vala"
				_tmp38_ = _tag_list;
#line 5401 "../src/Photo.vala"
				_tmp39_ = gee_list_get (_tmp38_, _tag_index);
#line 5401 "../src/Photo.vala"
				tag = (Tag*) _tmp39_;
#line 5402 "../src/Photo.vala"
				_tmp40_ = keywords;
#line 5402 "../src/Photo.vala"
				_tmp41_ = tag;
#line 5402 "../src/Photo.vala"
				_tmp42_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_DATA_OBJECT, DataObject));
#line 5402 "../src/Photo.vala"
				_tmp43_ = _tmp42_;
#line 5402 "../src/Photo.vala"
				_tmp44_ = g_utf8_normalize (_tmp43_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 5402 "../src/Photo.vala"
				_tmp45_ = _tmp44_;
#line 5402 "../src/Photo.vala"
				_tmp46_ = !gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_COLLECTION, GeeCollection), _tmp45_);
#line 5402 "../src/Photo.vala"
				_g_free0 (_tmp45_);
#line 5402 "../src/Photo.vala"
				_g_free0 (_tmp43_);
#line 5402 "../src/Photo.vala"
				if (_tmp46_) {
#line 5403 "../src/Photo.vala"
					result = TRUE;
#line 5403 "../src/Photo.vala"
					_g_object_unref0 (tag);
#line 5403 "../src/Photo.vala"
					_g_object_unref0 (keywords);
#line 5403 "../src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 5403 "../src/Photo.vala"
					_g_object_unref0 (tags);
#line 5403 "../src/Photo.vala"
					return result;
#line 39859 "Photo.c"
				}
#line 5401 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 39863 "Photo.c"
			}
		}
	}
#line 5407 "../src/Photo.vala"
	result = FALSE;
#line 5407 "../src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5407 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 5407 "../src/Photo.vala"
	_g_object_unref0 (tags);
#line 5407 "../src/Photo.vala"
	return result;
#line 39877 "Photo.c"
}

static void
library_photo_real_set_user_metadata_for_export (Photo* base,
                                                 PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	GeeList* photo_tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	GpsCoords _tmp17_ = {0};
#line 5410 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5410 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5411 "../src/Photo.vala"
	_tmp0_ = tag_global;
#line 5411 "../src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5411 "../src/Photo.vala"
	photo_tags = _tmp1_;
#line 5412 "../src/Photo.vala"
	_tmp2_ = photo_tags;
#line 5412 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 39904 "Photo.c"
		GeeCollection* string_tags = NULL;
		GeeArrayList* _tmp3_;
		GeeCollection* _tmp16_;
#line 5413 "../src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 5413 "../src/Photo.vala"
		string_tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 39912 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp4_;
			gint _tag_size = 0;
			GeeList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _tag_index = 0;
#line 5414 "../src/Photo.vala"
			_tmp4_ = photo_tags;
#line 5414 "../src/Photo.vala"
			_tag_list = _tmp4_;
#line 5414 "../src/Photo.vala"
			_tmp5_ = _tag_list;
#line 5414 "../src/Photo.vala"
			_tmp6_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5414 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 5414 "../src/Photo.vala"
			_tag_size = _tmp7_;
#line 5414 "../src/Photo.vala"
			_tag_index = -1;
#line 5414 "../src/Photo.vala"
			while (TRUE) {
#line 39937 "Photo.c"
				gint _tmp8_;
				gint _tmp9_;
				Tag* tag = NULL;
				GeeList* _tmp10_;
				gpointer _tmp11_;
				GeeCollection* _tmp12_;
				Tag* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 5414 "../src/Photo.vala"
				_tag_index = _tag_index + 1;
#line 5414 "../src/Photo.vala"
				_tmp8_ = _tag_index;
#line 5414 "../src/Photo.vala"
				_tmp9_ = _tag_size;
#line 5414 "../src/Photo.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 5414 "../src/Photo.vala"
					break;
#line 39957 "Photo.c"
				}
#line 5414 "../src/Photo.vala"
				_tmp10_ = _tag_list;
#line 5414 "../src/Photo.vala"
				_tmp11_ = gee_list_get (_tmp10_, _tag_index);
#line 5414 "../src/Photo.vala"
				tag = (Tag*) _tmp11_;
#line 5415 "../src/Photo.vala"
				_tmp12_ = string_tags;
#line 5415 "../src/Photo.vala"
				_tmp13_ = tag;
#line 5415 "../src/Photo.vala"
				_tmp14_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_DATA_OBJECT, DataObject));
#line 5415 "../src/Photo.vala"
				_tmp15_ = _tmp14_;
#line 5415 "../src/Photo.vala"
				gee_collection_add (_tmp12_, _tmp15_);
#line 5415 "../src/Photo.vala"
				_g_free0 (_tmp15_);
#line 5414 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 39979 "Photo.c"
			}
		}
#line 5417 "../src/Photo.vala"
		_tmp16_ = string_tags;
#line 5417 "../src/Photo.vala"
		photo_metadata_set_keywords (metadata, _tmp16_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 5412 "../src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 39988 "Photo.c"
	} else {
#line 5419 "../src/Photo.vala"
		photo_metadata_set_keywords (metadata, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 39992 "Photo.c"
	}
#line 5421 "../src/Photo.vala"
	photo_metadata_set_rating (metadata, media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)));
#line 5422 "../src/Photo.vala"
	positionable_get_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp17_);
#line 5422 "../src/Photo.vala"
	photo_metadata_set_gps_coords (metadata, &_tmp17_);
#line 5410 "../src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 40002 "Photo.c"
}

static void
library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                     PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	HierarchicalTagIndex* new_htag_index = NULL;
	GeeCollection* keywords = NULL;
	GeeSet* _tmp3_;
	GeeCollection* _tmp4_;
	HierarchicalTagIndex* _tmp31_;
#line 5425 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5425 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5426 "../src/Photo.vala"
	new_htag_index = NULL;
#line 5428 "../src/Photo.vala"
	if (photo_metadata_has_hierarchical_keywords (metadata)) {
#line 40023 "Photo.c"
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		HierarchicalTagIndex* _tmp2_;
#line 5429 "../src/Photo.vala"
		_tmp0_ = photo_metadata_get_hierarchical_keywords (metadata);
#line 5429 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5429 "../src/Photo.vala"
		_tmp2_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5429 "../src/Photo.vala"
		_hierarchical_tag_index_unref0 (new_htag_index);
#line 5429 "../src/Photo.vala"
		new_htag_index = _tmp2_;
#line 5429 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 40039 "Photo.c"
	}
#line 5433 "../src/Photo.vala"
	_tmp3_ = photo_metadata_get_keywords (metadata, NULL, NULL, NULL);
#line 5433 "../src/Photo.vala"
	keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5434 "../src/Photo.vala"
	_tmp4_ = keywords;
#line 5434 "../src/Photo.vala"
	if (_tmp4_ != NULL) {
#line 40049 "Photo.c"
		{
			GeeIterator* _keyword_it = NULL;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_;
#line 5435 "../src/Photo.vala"
			_tmp5_ = keywords;
#line 5435 "../src/Photo.vala"
			_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5435 "../src/Photo.vala"
			_keyword_it = _tmp6_;
#line 5435 "../src/Photo.vala"
			while (TRUE) {
#line 40062 "Photo.c"
				GeeIterator* _tmp7_;
				gchar* keyword = NULL;
				GeeIterator* _tmp8_;
				gpointer _tmp9_;
				gboolean _tmp10_ = FALSE;
				HierarchicalTagIndex* _tmp11_;
				gchar* safe_keyword = NULL;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* promoted_keyword = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				TagSourceCollection* _tmp18_;
				const gchar* _tmp19_;
				TagSourceCollection* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp28_;
				Tag* _tmp29_;
				Tag* _tmp30_;
#line 5435 "../src/Photo.vala"
				_tmp7_ = _keyword_it;
#line 5435 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp7_)) {
#line 5435 "../src/Photo.vala"
					break;
#line 40088 "Photo.c"
				}
#line 5435 "../src/Photo.vala"
				_tmp8_ = _keyword_it;
#line 5435 "../src/Photo.vala"
				_tmp9_ = gee_iterator_get (_tmp8_);
#line 5435 "../src/Photo.vala"
				keyword = (gchar*) _tmp9_;
#line 5436 "../src/Photo.vala"
				_tmp11_ = new_htag_index;
#line 5436 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 40100 "Photo.c"
					HierarchicalTagIndex* _tmp12_;
					const gchar* _tmp13_;
#line 5436 "../src/Photo.vala"
					_tmp12_ = new_htag_index;
#line 5436 "../src/Photo.vala"
					_tmp13_ = keyword;
#line 5436 "../src/Photo.vala"
					_tmp10_ = hierarchical_tag_index_is_tag_in_index (_tmp12_, _tmp13_);
#line 40109 "Photo.c"
				} else {
#line 5436 "../src/Photo.vala"
					_tmp10_ = FALSE;
#line 40113 "Photo.c"
				}
#line 5436 "../src/Photo.vala"
				if (_tmp10_) {
#line 5437 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5437 "../src/Photo.vala"
					continue;
#line 40121 "Photo.c"
				}
#line 5439 "../src/Photo.vala"
				_tmp14_ = keyword;
#line 5439 "../src/Photo.vala"
				_tmp15_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp14_);
#line 5439 "../src/Photo.vala"
				safe_keyword = _tmp15_;
#line 5440 "../src/Photo.vala"
				_tmp16_ = safe_keyword;
#line 5440 "../src/Photo.vala"
				_tmp17_ = hierarchical_tag_utilities_flat_to_hierarchical (_tmp16_);
#line 5440 "../src/Photo.vala"
				promoted_keyword = _tmp17_;
#line 5443 "../src/Photo.vala"
				_tmp18_ = tag_global;
#line 5443 "../src/Photo.vala"
				_tmp19_ = safe_keyword;
#line 5443 "../src/Photo.vala"
				if (tag_source_collection_exists (_tmp18_, _tmp19_, FALSE)) {
#line 40141 "Photo.c"
					const gchar* _tmp20_;
					Tag* _tmp21_;
					Tag* _tmp22_;
#line 5444 "../src/Photo.vala"
					_tmp20_ = safe_keyword;
#line 5444 "../src/Photo.vala"
					_tmp21_ = tag_for_path (_tmp20_);
#line 5444 "../src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 5444 "../src/Photo.vala"
					tag_attach (_tmp22_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5444 "../src/Photo.vala"
					_g_object_unref0 (_tmp22_);
#line 5445 "../src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5445 "../src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5445 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5445 "../src/Photo.vala"
					continue;
#line 40163 "Photo.c"
				}
#line 5448 "../src/Photo.vala"
				_tmp23_ = tag_global;
#line 5448 "../src/Photo.vala"
				_tmp24_ = promoted_keyword;
#line 5448 "../src/Photo.vala"
				if (tag_source_collection_exists (_tmp23_, _tmp24_, FALSE)) {
#line 40171 "Photo.c"
					const gchar* _tmp25_;
					Tag* _tmp26_;
					Tag* _tmp27_;
#line 5449 "../src/Photo.vala"
					_tmp25_ = promoted_keyword;
#line 5449 "../src/Photo.vala"
					_tmp26_ = tag_for_path (_tmp25_);
#line 5449 "../src/Photo.vala"
					_tmp27_ = _tmp26_;
#line 5449 "../src/Photo.vala"
					tag_attach (_tmp27_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5449 "../src/Photo.vala"
					_g_object_unref0 (_tmp27_);
#line 5450 "../src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5450 "../src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5450 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5450 "../src/Photo.vala"
					continue;
#line 40193 "Photo.c"
				}
#line 5453 "../src/Photo.vala"
				_tmp28_ = keyword;
#line 5453 "../src/Photo.vala"
				_tmp29_ = tag_for_path (_tmp28_);
#line 5453 "../src/Photo.vala"
				_tmp30_ = _tmp29_;
#line 5453 "../src/Photo.vala"
				tag_attach (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5453 "../src/Photo.vala"
				_g_object_unref0 (_tmp30_);
#line 5435 "../src/Photo.vala"
				_g_free0 (promoted_keyword);
#line 5435 "../src/Photo.vala"
				_g_free0 (safe_keyword);
#line 5435 "../src/Photo.vala"
				_g_free0 (keyword);
#line 40211 "Photo.c"
			}
#line 5435 "../src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 40215 "Photo.c"
		}
	}
#line 5457 "../src/Photo.vala"
	_tmp31_ = new_htag_index;
#line 5457 "../src/Photo.vala"
	if (_tmp31_ != NULL) {
#line 40222 "Photo.c"
		{
			GeeIterator* _path_it = NULL;
			HierarchicalTagIndex* _tmp32_;
			GeeCollection* _tmp33_;
			GeeCollection* _tmp34_;
			GeeIterator* _tmp35_;
			GeeIterator* _tmp36_;
#line 5458 "../src/Photo.vala"
			_tmp32_ = new_htag_index;
#line 5458 "../src/Photo.vala"
			_tmp33_ = hierarchical_tag_index_get_all_paths (_tmp32_);
#line 5458 "../src/Photo.vala"
			_tmp34_ = _tmp33_;
#line 5458 "../src/Photo.vala"
			_tmp35_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5458 "../src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 5458 "../src/Photo.vala"
			_g_object_unref0 (_tmp34_);
#line 5458 "../src/Photo.vala"
			_path_it = _tmp36_;
#line 5458 "../src/Photo.vala"
			while (TRUE) {
#line 40246 "Photo.c"
				GeeIterator* _tmp37_;
				gchar* path = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				const gchar* _tmp40_;
				Tag* _tmp41_;
				Tag* _tmp42_;
#line 5458 "../src/Photo.vala"
				_tmp37_ = _path_it;
#line 5458 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5458 "../src/Photo.vala"
					break;
#line 40260 "Photo.c"
				}
#line 5458 "../src/Photo.vala"
				_tmp38_ = _path_it;
#line 5458 "../src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5458 "../src/Photo.vala"
				path = (gchar*) _tmp39_;
#line 5459 "../src/Photo.vala"
				_tmp40_ = path;
#line 5459 "../src/Photo.vala"
				_tmp41_ = tag_for_path (_tmp40_);
#line 5459 "../src/Photo.vala"
				_tmp42_ = _tmp41_;
#line 5459 "../src/Photo.vala"
				tag_attach (_tmp42_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5459 "../src/Photo.vala"
				_g_object_unref0 (_tmp42_);
#line 5458 "../src/Photo.vala"
				_g_free0 (path);
#line 40280 "Photo.c"
			}
#line 5458 "../src/Photo.vala"
			_g_object_unref0 (_path_it);
#line 40284 "Photo.c"
		}
	}
#line 5425 "../src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5425 "../src/Photo.vala"
	_hierarchical_tag_index_unref0 (new_htag_index);
#line 40291 "Photo.c"
}

static void
library_photo_class_init (LibraryPhotoClass * klass,
                          gpointer klass_data)
{
#line 4995 "../src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 4995 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhoto_private_offset);
#line 4995 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_master_reimported;
#line 4995 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_editable_reimported;
#line 4995 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_source_reimported;
#line 4995 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_baseline_reimported;
#line 4995 "../src/Photo.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject*, Alteration*)) library_photo_real_notify_altered;
#line 4995 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_preview_pixbuf = (GdkPixbuf* (*) (MediaSource*, Scaling*, GError**)) library_photo_real_get_preview_pixbuf;
#line 4995 "../src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) library_photo_real_rotate;
#line 4995 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) library_photo_real_get_thumbnail;
#line 4995 "../src/Photo.vala"
	((MediaSourceClass *) klass)->is_trashed = (gboolean (*) (MediaSource*)) library_photo_real_is_trashed;
#line 4995 "../src/Photo.vala"
	((MediaSourceClass *) klass)->trash = (void (*) (MediaSource*)) library_photo_real_trash;
#line 4995 "../src/Photo.vala"
	((MediaSourceClass *) klass)->untrash = (void (*) (MediaSource*)) library_photo_real_untrash;
#line 4995 "../src/Photo.vala"
	((MediaSourceClass *) klass)->is_offline = (gboolean (*) (MediaSource*)) library_photo_real_is_offline;
#line 4995 "../src/Photo.vala"
	((MediaSourceClass *) klass)->mark_offline = (void (*) (MediaSource*)) library_photo_real_mark_offline;
#line 4995 "../src/Photo.vala"
	((MediaSourceClass *) klass)->mark_online = (void (*) (MediaSource*)) library_photo_real_mark_online;
#line 4995 "../src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) library_photo_real_internal_delete_backing;
#line 4995 "../src/Photo.vala"
	((DataSourceClass *) klass)->destroy = (void (*) (DataSource*)) library_photo_real_destroy;
#line 4995 "../src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) library_photo_real_has_user_generated_metadata;
#line 4995 "../src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_set_user_metadata_for_export;
#line 4995 "../src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_apply_user_metadata_for_reimport;
#line 4995 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 40342 "Photo.c"
}

static void
library_photo_flaggable_interface_init (FlaggableIface * iface,
                                        gpointer iface_data)
{
#line 4995 "../src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 4995 "../src/Photo.vala"
	iface->is_flagged = (gboolean (*) (Flaggable*)) library_photo_real_is_flagged;
#line 4995 "../src/Photo.vala"
	iface->mark_flagged = (void (*) (Flaggable*)) library_photo_real_mark_flagged;
#line 4995 "../src/Photo.vala"
	iface->mark_unflagged = (void (*) (Flaggable*)) library_photo_real_mark_unflagged;
#line 40357 "Photo.c"
}

static void
library_photo_monitorable_interface_init (MonitorableIface * iface,
                                          gpointer iface_data)
{
#line 4995 "../src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 4995 "../src/Photo.vala"
	iface->is_offline = (gboolean (*) (Monitorable*)) library_photo_real_is_offline;
#line 4995 "../src/Photo.vala"
	iface->mark_offline = (void (*) (Monitorable*)) library_photo_real_mark_offline;
#line 4995 "../src/Photo.vala"
	iface->mark_online = (void (*) (Monitorable*)) library_photo_real_mark_online;
#line 4995 "../src/Photo.vala"
	iface->set_master_file = (void (*) (Monitorable*, GFile*)) photo_set_master_file;
#line 4995 "../src/Photo.vala"
	iface->set_master_timestamp = (void (*) (Monitorable*, GFileInfo*)) photo_set_master_timestamp;
#line 40376 "Photo.c"
}

static void
library_photo_instance_init (LibraryPhoto * self,
                             gpointer klass)
{
#line 4995 "../src/Photo.vala"
	self->priv = library_photo_get_instance_private (self);
#line 5006 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 5007 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 40389 "Photo.c"
}

static void
library_photo_finalize (GObject * obj)
{
	LibraryPhoto * self;
#line 4995 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5007 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5008 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4995 "../src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 40404 "Photo.c"
}

static GType
library_photo_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
	static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType library_photo_type_id;
	library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
	g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
	g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
	LibraryPhoto_private_offset = g_type_add_instance_private (library_photo_type_id, sizeof (LibraryPhotoPrivate));
	return library_photo_type_id;
}

GType
library_photo_get_type (void)
{
	static volatile gsize library_photo_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_type_id__volatile)) {
		GType library_photo_type_id;
		library_photo_type_id = library_photo_get_type_once ();
		g_once_init_leave (&library_photo_type_id__volatile, library_photo_type_id);
	}
	return library_photo_type_id__volatile;
}

static inline gpointer
library_photo_source_holding_tank_get_instance_private (LibraryPhotoSourceHoldingTank* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhotoSourceHoldingTank_private_offset);
}

LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_construct (GType object_type,
                                             LibraryPhotoSourceCollection* sources,
                                             SourceHoldingTankCheckToKeep check_to_keep,
                                             gpointer check_to_keep_target,
                                             GetSourceDatabaseKey get_key,
                                             gpointer get_key_target)
{
	LibraryPhotoSourceHoldingTank* self = NULL;
#line 5475 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (sources), NULL);
#line 5477 "../src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) media_source_holding_tank_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (sources, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 5475 "../src/Photo.vala"
	return self;
#line 40454 "Photo.c"
}

LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                       SourceHoldingTankCheckToKeep check_to_keep,
                                       gpointer check_to_keep_target,
                                       GetSourceDatabaseKey get_key,
                                       gpointer get_key_target)
{
#line 5475 "../src/Photo.vala"
	return library_photo_source_holding_tank_construct (TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 40466 "Photo.c"
}

LibraryPhoto*
library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                         GFile* file)
{
	LibraryPhoto* ret = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
	LibraryPhoto* result = NULL;
#line 5480 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self), NULL);
#line 5480 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 5481 "../src/Photo.vala"
	ret = NULL;
#line 5482 "../src/Photo.vala"
	_tmp0_ = self->priv->editable_file_map;
#line 5482 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 5482 "../src/Photo.vala"
	_g_object_unref0 (ret);
#line 5482 "../src/Photo.vala"
	ret = (LibraryPhoto*) _tmp1_;
#line 5483 "../src/Photo.vala"
	_tmp2_ = ret;
#line 5483 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 5484 "../src/Photo.vala"
		result = ret;
#line 5484 "../src/Photo.vala"
		return result;
#line 40502 "Photo.c"
	}
#line 5486 "../src/Photo.vala"
	_tmp3_ = self->priv->development_file_map;
#line 5486 "../src/Photo.vala"
	_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 5486 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp4_;
#line 5486 "../src/Photo.vala"
	_g_object_unref0 (ret);
#line 5486 "../src/Photo.vala"
	return result;
#line 40514 "Photo.c"
}

static void
_library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                 GFile* old_file,
                                                                                 GFile* new_file,
                                                                                 gpointer self)
{
#line 5510 "../src/Photo.vala"
	library_photo_source_holding_tank_on_editable_replaced ((LibraryPhotoSourceHoldingTank*) self, _sender, old_file, new_file);
#line 40525 "Photo.c"
}

static void
_library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                               gpointer self)
{
#line 5511 "../src/Photo.vala"
	library_photo_source_holding_tank_on_raw_development_modified ((LibraryPhotoSourceHoldingTank*) self, _sender);
#line 40534 "Photo.c"
}

static void
library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                GeeCollection* added,
                                                                GeeCollection* removed)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5489 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5489 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_COLLECTION));
#line 5489 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
#line 5491 "../src/Photo.vala"
	if (added != NULL) {
#line 40551 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp0_;
#line 5492 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_ITERABLE, GeeIterable));
#line 5492 "../src/Photo.vala"
			_source_it = _tmp0_;
#line 5492 "../src/Photo.vala"
			while (TRUE) {
#line 40561 "Photo.c"
				GeeIterator* _tmp1_;
				DataSource* source = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp4_;
				LibraryPhoto* _tmp5_;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				gboolean _tmp9_;
				GeeCollection* raw_files = NULL;
				LibraryPhoto* _tmp20_;
				GeeCollection* _tmp21_;
				GeeCollection* _tmp22_;
				LibraryPhoto* _tmp34_;
				LibraryPhoto* _tmp35_;
#line 5492 "../src/Photo.vala"
				_tmp1_ = _source_it;
#line 5492 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 5492 "../src/Photo.vala"
					break;
#line 40585 "Photo.c"
				}
#line 5492 "../src/Photo.vala"
				_tmp2_ = _source_it;
#line 5492 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 5492 "../src/Photo.vala"
				source = (DataSource*) _tmp3_;
#line 5493 "../src/Photo.vala"
				_tmp4_ = source;
#line 5493 "../src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5493 "../src/Photo.vala"
				photo = _tmp5_;
#line 5496 "../src/Photo.vala"
				_tmp6_ = photo;
#line 5496 "../src/Photo.vala"
				_tmp7_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PHOTO, Photo));
#line 5496 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 5496 "../src/Photo.vala"
				_tmp9_ = _tmp8_ != NULL;
#line 5496 "../src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 5496 "../src/Photo.vala"
				if (_tmp9_) {
#line 40611 "Photo.c"
					GeeHashMap* _tmp10_;
					LibraryPhoto* _tmp11_;
					GFile* _tmp12_;
					GFile* _tmp13_;
					LibraryPhoto* _tmp14_;
					GeeMultiMap* _tmp15_;
					LibraryPhoto* _tmp16_;
					LibraryPhoto* _tmp17_;
					GFile* _tmp18_;
					GFile* _tmp19_;
#line 5497 "../src/Photo.vala"
					_tmp10_ = self->priv->editable_file_map;
#line 5497 "../src/Photo.vala"
					_tmp11_ = photo;
#line 5497 "../src/Photo.vala"
					_tmp12_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_PHOTO, Photo));
#line 5497 "../src/Photo.vala"
					_tmp13_ = _tmp12_;
#line 5497 "../src/Photo.vala"
					_tmp14_ = photo;
#line 5497 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp13_, _tmp14_);
#line 5497 "../src/Photo.vala"
					_g_object_unref0 (_tmp13_);
#line 5498 "../src/Photo.vala"
					_tmp15_ = self->priv->reverse_editable_file_map;
#line 5498 "../src/Photo.vala"
					_tmp16_ = photo;
#line 5498 "../src/Photo.vala"
					_tmp17_ = photo;
#line 5498 "../src/Photo.vala"
					_tmp18_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO, Photo));
#line 5498 "../src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 5498 "../src/Photo.vala"
					gee_multi_map_set (_tmp15_, _tmp16_, _tmp19_);
#line 5498 "../src/Photo.vala"
					_g_object_unref0 (_tmp19_);
#line 40650 "Photo.c"
				}
#line 5502 "../src/Photo.vala"
				_tmp20_ = photo;
#line 5502 "../src/Photo.vala"
				_tmp21_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_PHOTO, Photo));
#line 5502 "../src/Photo.vala"
				raw_files = _tmp21_;
#line 5503 "../src/Photo.vala"
				_tmp22_ = raw_files;
#line 5503 "../src/Photo.vala"
				if (_tmp22_ != NULL) {
#line 40662 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp23_;
						GeeIterator* _tmp24_;
#line 5504 "../src/Photo.vala"
						_tmp23_ = raw_files;
#line 5504 "../src/Photo.vala"
						_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5504 "../src/Photo.vala"
						_f_it = _tmp24_;
#line 5504 "../src/Photo.vala"
						while (TRUE) {
#line 40675 "Photo.c"
							GeeIterator* _tmp25_;
							GFile* f = NULL;
							GeeIterator* _tmp26_;
							gpointer _tmp27_;
							GeeHashMap* _tmp28_;
							GFile* _tmp29_;
							LibraryPhoto* _tmp30_;
							GeeMultiMap* _tmp31_;
							LibraryPhoto* _tmp32_;
							GFile* _tmp33_;
#line 5504 "../src/Photo.vala"
							_tmp25_ = _f_it;
#line 5504 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp25_)) {
#line 5504 "../src/Photo.vala"
								break;
#line 40692 "Photo.c"
							}
#line 5504 "../src/Photo.vala"
							_tmp26_ = _f_it;
#line 5504 "../src/Photo.vala"
							_tmp27_ = gee_iterator_get (_tmp26_);
#line 5504 "../src/Photo.vala"
							f = (GFile*) _tmp27_;
#line 5505 "../src/Photo.vala"
							_tmp28_ = self->priv->development_file_map;
#line 5505 "../src/Photo.vala"
							_tmp29_ = f;
#line 5505 "../src/Photo.vala"
							_tmp30_ = photo;
#line 5505 "../src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp29_, _tmp30_);
#line 5506 "../src/Photo.vala"
							_tmp31_ = self->priv->reverse_development_file_map;
#line 5506 "../src/Photo.vala"
							_tmp32_ = photo;
#line 5506 "../src/Photo.vala"
							_tmp33_ = f;
#line 5506 "../src/Photo.vala"
							gee_multi_map_set (_tmp31_, _tmp32_, _tmp33_);
#line 5504 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 40718 "Photo.c"
						}
#line 5504 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 40722 "Photo.c"
					}
				}
#line 5510 "../src/Photo.vala"
				_tmp34_ = photo;
#line 5510 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, TYPE_PHOTO, Photo), "editable-replaced", (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5511 "../src/Photo.vala"
				_tmp35_ = photo;
#line 5511 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_PHOTO, Photo), "raw-development-modified", (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5492 "../src/Photo.vala"
				_g_object_unref0 (raw_files);
#line 5492 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5492 "../src/Photo.vala"
				_g_object_unref0 (source);
#line 40739 "Photo.c"
			}
#line 5492 "../src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 40743 "Photo.c"
		}
	}
#line 5515 "../src/Photo.vala"
	if (removed != NULL) {
#line 40748 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp36_;
#line 5516 "../src/Photo.vala"
			_tmp36_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_ITERABLE, GeeIterable));
#line 5516 "../src/Photo.vala"
			_source_it = _tmp36_;
#line 5516 "../src/Photo.vala"
			while (TRUE) {
#line 40758 "Photo.c"
				GeeIterator* _tmp37_;
				DataSource* source = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp40_;
				LibraryPhoto* _tmp41_;
				GeeMultiMap* _tmp64_;
				LibraryPhoto* _tmp65_;
				GeeMultiMap* _tmp66_;
				LibraryPhoto* _tmp67_;
				LibraryPhoto* _tmp68_;
				guint _tmp69_;
				LibraryPhoto* _tmp70_;
				guint _tmp71_;
#line 5516 "../src/Photo.vala"
				_tmp37_ = _source_it;
#line 5516 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5516 "../src/Photo.vala"
					break;
#line 40780 "Photo.c"
				}
#line 5516 "../src/Photo.vala"
				_tmp38_ = _source_it;
#line 5516 "../src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5516 "../src/Photo.vala"
				source = (DataSource*) _tmp39_;
#line 5517 "../src/Photo.vala"
				_tmp40_ = source;
#line 5517 "../src/Photo.vala"
				_tmp41_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5517 "../src/Photo.vala"
				photo = _tmp41_;
#line 40794 "Photo.c"
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					GeeCollection* _tmp44_;
					GeeCollection* _tmp45_;
					GeeIterator* _tmp46_;
					GeeIterator* _tmp47_;
#line 5518 "../src/Photo.vala"
					_tmp42_ = self->priv->reverse_editable_file_map;
#line 5518 "../src/Photo.vala"
					_tmp43_ = photo;
#line 5518 "../src/Photo.vala"
					_tmp44_ = gee_multi_map_get (_tmp42_, _tmp43_);
#line 5518 "../src/Photo.vala"
					_tmp45_ = _tmp44_;
#line 5518 "../src/Photo.vala"
					_tmp46_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5518 "../src/Photo.vala"
					_tmp47_ = _tmp46_;
#line 5518 "../src/Photo.vala"
					_g_object_unref0 (_tmp45_);
#line 5518 "../src/Photo.vala"
					_f_it = _tmp47_;
#line 5518 "../src/Photo.vala"
					while (TRUE) {
#line 40821 "Photo.c"
						GeeIterator* _tmp48_;
						GFile* f = NULL;
						GeeIterator* _tmp49_;
						gpointer _tmp50_;
						GeeHashMap* _tmp51_;
						GFile* _tmp52_;
#line 5518 "../src/Photo.vala"
						_tmp48_ = _f_it;
#line 5518 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp48_)) {
#line 5518 "../src/Photo.vala"
							break;
#line 40834 "Photo.c"
						}
#line 5518 "../src/Photo.vala"
						_tmp49_ = _f_it;
#line 5518 "../src/Photo.vala"
						_tmp50_ = gee_iterator_get (_tmp49_);
#line 5518 "../src/Photo.vala"
						f = (GFile*) _tmp50_;
#line 5519 "../src/Photo.vala"
						_tmp51_ = self->priv->editable_file_map;
#line 5519 "../src/Photo.vala"
						_tmp52_ = f;
#line 5519 "../src/Photo.vala"
						gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp52_, NULL);
#line 5518 "../src/Photo.vala"
						_g_object_unref0 (f);
#line 40850 "Photo.c"
					}
#line 5518 "../src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 40854 "Photo.c"
				}
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp53_;
					LibraryPhoto* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 5521 "../src/Photo.vala"
					_tmp53_ = self->priv->reverse_development_file_map;
#line 5521 "../src/Photo.vala"
					_tmp54_ = photo;
#line 5521 "../src/Photo.vala"
					_tmp55_ = gee_multi_map_get (_tmp53_, _tmp54_);
#line 5521 "../src/Photo.vala"
					_tmp56_ = _tmp55_;
#line 5521 "../src/Photo.vala"
					_tmp57_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5521 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 5521 "../src/Photo.vala"
					_g_object_unref0 (_tmp56_);
#line 5521 "../src/Photo.vala"
					_f_it = _tmp58_;
#line 5521 "../src/Photo.vala"
					while (TRUE) {
#line 40882 "Photo.c"
						GeeIterator* _tmp59_;
						GFile* f = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						GeeHashMap* _tmp62_;
						GFile* _tmp63_;
#line 5521 "../src/Photo.vala"
						_tmp59_ = _f_it;
#line 5521 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 5521 "../src/Photo.vala"
							break;
#line 40895 "Photo.c"
						}
#line 5521 "../src/Photo.vala"
						_tmp60_ = _f_it;
#line 5521 "../src/Photo.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 5521 "../src/Photo.vala"
						f = (GFile*) _tmp61_;
#line 5522 "../src/Photo.vala"
						_tmp62_ = self->priv->development_file_map;
#line 5522 "../src/Photo.vala"
						_tmp63_ = f;
#line 5522 "../src/Photo.vala"
						gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp63_, NULL);
#line 5521 "../src/Photo.vala"
						_g_object_unref0 (f);
#line 40911 "Photo.c"
					}
#line 5521 "../src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 40915 "Photo.c"
				}
#line 5524 "../src/Photo.vala"
				_tmp64_ = self->priv->reverse_editable_file_map;
#line 5524 "../src/Photo.vala"
				_tmp65_ = photo;
#line 5524 "../src/Photo.vala"
				gee_multi_map_remove_all (_tmp64_, _tmp65_);
#line 5525 "../src/Photo.vala"
				_tmp66_ = self->priv->reverse_development_file_map;
#line 5525 "../src/Photo.vala"
				_tmp67_ = photo;
#line 5525 "../src/Photo.vala"
				gee_multi_map_remove_all (_tmp66_, _tmp67_);
#line 5527 "../src/Photo.vala"
				_tmp68_ = photo;
#line 5527 "../src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp69_, NULL, FALSE);
#line 5527 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp69_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5528 "../src/Photo.vala"
				_tmp70_ = photo;
#line 5528 "../src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp71_, NULL, FALSE);
#line 5528 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp71_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5516 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5516 "../src/Photo.vala"
				_g_object_unref0 (source);
#line 40945 "Photo.c"
			}
#line 5516 "../src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 40949 "Photo.c"
		}
	}
#line 5532 "../src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), added, removed);
#line 40954 "Photo.c"
}

static void
library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                        Photo* _photo,
                                                        GFile* old_file,
                                                        GFile* new_file)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp7_;
	LibraryPhoto* _tmp8_;
#line 5535 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5535 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5535 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 5535 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 5536 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 5536 "../src/Photo.vala"
	photo = _tmp0_;
#line 5537 "../src/Photo.vala"
	_tmp1_ = photo;
#line 5537 "../src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5539 "../src/Photo.vala"
	if (old_file != NULL) {
#line 40986 "Photo.c"
		GeeHashMap* _tmp2_;
		GeeMultiMap* _tmp3_;
		LibraryPhoto* _tmp4_;
#line 5540 "../src/Photo.vala"
		_tmp2_ = self->priv->editable_file_map;
#line 5540 "../src/Photo.vala"
		gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), old_file, NULL);
#line 5541 "../src/Photo.vala"
		_tmp3_ = self->priv->reverse_editable_file_map;
#line 5541 "../src/Photo.vala"
		_tmp4_ = photo;
#line 5541 "../src/Photo.vala"
		gee_multi_map_remove (_tmp3_, _tmp4_, old_file);
#line 41000 "Photo.c"
	}
#line 5544 "../src/Photo.vala"
	if (new_file != NULL) {
#line 41004 "Photo.c"
		GeeHashMap* _tmp5_;
		LibraryPhoto* _tmp6_;
#line 5545 "../src/Photo.vala"
		_tmp5_ = self->priv->editable_file_map;
#line 5545 "../src/Photo.vala"
		_tmp6_ = photo;
#line 5545 "../src/Photo.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), new_file, _tmp6_);
#line 41013 "Photo.c"
	}
#line 5546 "../src/Photo.vala"
	_tmp7_ = self->priv->reverse_editable_file_map;
#line 5546 "../src/Photo.vala"
	_tmp8_ = photo;
#line 5546 "../src/Photo.vala"
	gee_multi_map_set (_tmp7_, _tmp8_, new_file);
#line 5535 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 41023 "Photo.c"
}

static void
library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                               Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp17_;
	GeeCollection* _tmp18_;
	GeeCollection* _tmp19_;
#line 5549 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5549 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5550 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 5550 "../src/Photo.vala"
	photo = _tmp0_;
#line 5551 "../src/Photo.vala"
	_tmp1_ = photo;
#line 5551 "../src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5554 "../src/Photo.vala"
	_tmp2_ = self->priv->reverse_development_file_map;
#line 5554 "../src/Photo.vala"
	_tmp3_ = photo;
#line 5554 "../src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 41057 "Photo.c"
		GeeMultiMap* _tmp15_;
		LibraryPhoto* _tmp16_;
		{
			GeeIterator* _f_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 5555 "../src/Photo.vala"
			_tmp4_ = self->priv->reverse_development_file_map;
#line 5555 "../src/Photo.vala"
			_tmp5_ = photo;
#line 5555 "../src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 5555 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 5555 "../src/Photo.vala"
			_tmp8_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5555 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5555 "../src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 5555 "../src/Photo.vala"
			_f_it = _tmp9_;
#line 5555 "../src/Photo.vala"
			while (TRUE) {
#line 41086 "Photo.c"
				GeeIterator* _tmp10_;
				GFile* f = NULL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				GeeHashMap* _tmp13_;
				GFile* _tmp14_;
#line 5555 "../src/Photo.vala"
				_tmp10_ = _f_it;
#line 5555 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 5555 "../src/Photo.vala"
					break;
#line 41099 "Photo.c"
				}
#line 5555 "../src/Photo.vala"
				_tmp11_ = _f_it;
#line 5555 "../src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 5555 "../src/Photo.vala"
				f = (GFile*) _tmp12_;
#line 5556 "../src/Photo.vala"
				_tmp13_ = self->priv->development_file_map;
#line 5556 "../src/Photo.vala"
				_tmp14_ = f;
#line 5556 "../src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp14_, NULL);
#line 5555 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 41115 "Photo.c"
			}
#line 5555 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41119 "Photo.c"
		}
#line 5557 "../src/Photo.vala"
		_tmp15_ = self->priv->reverse_development_file_map;
#line 5557 "../src/Photo.vala"
		_tmp16_ = photo;
#line 5557 "../src/Photo.vala"
		gee_multi_map_remove_all (_tmp15_, _tmp16_);
#line 41127 "Photo.c"
	}
#line 5561 "../src/Photo.vala"
	_tmp17_ = photo;
#line 5561 "../src/Photo.vala"
	_tmp18_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO, Photo));
#line 5561 "../src/Photo.vala"
	raw_list = _tmp18_;
#line 5562 "../src/Photo.vala"
	_tmp19_ = raw_list;
#line 5562 "../src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 41139 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp20_;
			GeeIterator* _tmp21_;
#line 5563 "../src/Photo.vala"
			_tmp20_ = raw_list;
#line 5563 "../src/Photo.vala"
			_tmp21_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5563 "../src/Photo.vala"
			_f_it = _tmp21_;
#line 5563 "../src/Photo.vala"
			while (TRUE) {
#line 41152 "Photo.c"
				GeeIterator* _tmp22_;
				GFile* f = NULL;
				GeeIterator* _tmp23_;
				gpointer _tmp24_;
				GeeHashMap* _tmp25_;
				GFile* _tmp26_;
				LibraryPhoto* _tmp27_;
				GeeMultiMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GFile* _tmp30_;
#line 5563 "../src/Photo.vala"
				_tmp22_ = _f_it;
#line 5563 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp22_)) {
#line 5563 "../src/Photo.vala"
					break;
#line 41169 "Photo.c"
				}
#line 5563 "../src/Photo.vala"
				_tmp23_ = _f_it;
#line 5563 "../src/Photo.vala"
				_tmp24_ = gee_iterator_get (_tmp23_);
#line 5563 "../src/Photo.vala"
				f = (GFile*) _tmp24_;
#line 5564 "../src/Photo.vala"
				_tmp25_ = self->priv->development_file_map;
#line 5564 "../src/Photo.vala"
				_tmp26_ = f;
#line 5564 "../src/Photo.vala"
				_tmp27_ = photo;
#line 5564 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp26_, _tmp27_);
#line 5565 "../src/Photo.vala"
				_tmp28_ = self->priv->reverse_development_file_map;
#line 5565 "../src/Photo.vala"
				_tmp29_ = photo;
#line 5565 "../src/Photo.vala"
				_tmp30_ = f;
#line 5565 "../src/Photo.vala"
				gee_multi_map_set (_tmp28_, _tmp29_, _tmp30_);
#line 5563 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 41195 "Photo.c"
			}
#line 5563 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41199 "Photo.c"
		}
	}
#line 5549 "../src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 5549 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 41206 "Photo.c"
}

static void
library_photo_source_holding_tank_class_init (LibraryPhotoSourceHoldingTankClass * klass,
                                              gpointer klass_data)
{
#line 5465 "../src/Photo.vala"
	library_photo_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 5465 "../src/Photo.vala"
	((SourceHoldingTankClass *) klass)->finalize = library_photo_source_holding_tank_finalize;
#line 5465 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhotoSourceHoldingTank_private_offset);
#line 5465 "../src/Photo.vala"
	((SourceHoldingTankClass *) klass)->notify_contents_altered = (void (*) (SourceHoldingTank*, GeeCollection*, GeeCollection*)) library_photo_source_holding_tank_real_notify_contents_altered;
#line 41221 "Photo.c"
}

static void
library_photo_source_holding_tank_instance_init (LibraryPhotoSourceHoldingTank * self,
                                                 gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMultiMap* _tmp2_;
	GeeHashMultiMap* _tmp3_;
#line 5465 "../src/Photo.vala"
	self->priv = library_photo_source_holding_tank_get_instance_private (self);
#line 5466 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5466 "../src/Photo.vala"
	self->priv->editable_file_map = _tmp0_;
#line 5468 "../src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5468 "../src/Photo.vala"
	self->priv->development_file_map = _tmp1_;
#line 5470 "../src/Photo.vala"
	_tmp2_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5470 "../src/Photo.vala"
	self->priv->reverse_editable_file_map = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 5472 "../src/Photo.vala"
	_tmp3_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5472 "../src/Photo.vala"
	self->priv->reverse_development_file_map = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 41250 "Photo.c"
}

static void
library_photo_source_holding_tank_finalize (SourceHoldingTank * obj)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5465 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5466 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_file_map);
#line 5468 "../src/Photo.vala"
	_g_object_unref0 (self->priv->development_file_map);
#line 5470 "../src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_editable_file_map);
#line 5472 "../src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_development_file_map);
#line 5465 "../src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->finalize (obj);
#line 41269 "Photo.c"
}

static GType
library_photo_source_holding_tank_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceHoldingTank), 0, (GInstanceInitFunc) library_photo_source_holding_tank_instance_init, NULL };
	GType library_photo_source_holding_tank_type_id;
	library_photo_source_holding_tank_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_HOLDING_TANK, "LibraryPhotoSourceHoldingTank", &g_define_type_info, 0);
	LibraryPhotoSourceHoldingTank_private_offset = g_type_add_instance_private (library_photo_source_holding_tank_type_id, sizeof (LibraryPhotoSourceHoldingTankPrivate));
	return library_photo_source_holding_tank_type_id;
}

GType
library_photo_source_holding_tank_get_type (void)
{
	static volatile gsize library_photo_source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_holding_tank_type_id__volatile)) {
		GType library_photo_source_holding_tank_type_id;
		library_photo_source_holding_tank_type_id = library_photo_source_holding_tank_get_type_once ();
		g_once_init_leave (&library_photo_source_holding_tank_type_id__volatile, library_photo_source_holding_tank_type_id);
	}
	return library_photo_source_holding_tank_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

