/* SearchFilter.c generated by valac 0.52.10, the Vala compiler
 * generated from SearchFilter.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/* Bitfield values used to specify which search bar features we want.*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

typedef enum  {
	SEARCH_FILTER_CRITERIA_NONE = 0,
	SEARCH_FILTER_CRITERIA_RECURSIVE = 1 << 0,
	SEARCH_FILTER_CRITERIA_TEXT = 1 << 1,
	SEARCH_FILTER_CRITERIA_FLAG = 1 << 2,
	SEARCH_FILTER_CRITERIA_MEDIA = 1 << 3,
	SEARCH_FILTER_CRITERIA_RATING = 1 << 4,
	SEARCH_FILTER_CRITERIA_SAVEDSEARCH = 1 << 5,
	SEARCH_FILTER_CRITERIA_ALL = 0xFFFFFFFFLL
} SearchFilterCriteria;

#define TYPE_SEARCH_FILTER_CRITERIA (search_filter_criteria_get_type ())
typedef enum  {
	RATING_FILTER_NO_FILTER = 0,
	RATING_FILTER_REJECTED_OR_HIGHER = 1,
	RATING_FILTER_UNRATED_OR_HIGHER = 2,
	RATING_FILTER_ONE_OR_HIGHER = 3,
	RATING_FILTER_TWO_OR_HIGHER = 4,
	RATING_FILTER_THREE_OR_HIGHER = 5,
	RATING_FILTER_FOUR_OR_HIGHER = 6,
	RATING_FILTER_FIVE_OR_HIGHER = 7,
	RATING_FILTER_REJECTED_ONLY = 8,
	RATING_FILTER_UNRATED_ONLY = 9,
	RATING_FILTER_ONE_ONLY = 10,
	RATING_FILTER_TWO_ONLY = 11,
	RATING_FILTER_THREE_ONLY = 12,
	RATING_FILTER_FOUR_ONLY = 13,
	RATING_FILTER_FIVE_ONLY = 14
} RatingFilter;

#define TYPE_RATING_FILTER (rating_filter_get_type ())

#define TYPE_VIEW_FILTER (view_filter_get_type ())
#define VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_FILTER, ViewFilter))
#define VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_FILTER, ViewFilterClass))
#define IS_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_FILTER))
#define IS_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_FILTER))
#define VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_FILTER, ViewFilterClass))

typedef struct _ViewFilter ViewFilter;
typedef struct _ViewFilterClass ViewFilterClass;
typedef struct _ViewFilterPrivate ViewFilterPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;

#define TYPE_SEARCH_VIEW_FILTER (search_view_filter_get_type ())
#define SEARCH_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_VIEW_FILTER, SearchViewFilter))
#define SEARCH_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_VIEW_FILTER, SearchViewFilterClass))
#define IS_SEARCH_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_VIEW_FILTER))
#define IS_SEARCH_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_VIEW_FILTER))
#define SEARCH_VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_VIEW_FILTER, SearchViewFilterClass))

typedef struct _SearchViewFilter SearchViewFilter;
typedef struct _SearchViewFilterClass SearchViewFilterClass;
typedef struct _SearchViewFilterPrivate SearchViewFilterPrivate;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_SAVED_SEARCH (saved_search_get_type ())
#define SAVED_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SAVED_SEARCH, SavedSearch))
#define SAVED_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SAVED_SEARCH, SavedSearchClass))
#define IS_SAVED_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SAVED_SEARCH))
#define IS_SAVED_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SAVED_SEARCH))
#define SAVED_SEARCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SAVED_SEARCH, SavedSearchClass))

typedef struct _SavedSearch SavedSearch;
typedef struct _SavedSearchClass SavedSearchClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DEFAULT_SEARCH_VIEW_FILTER (default_search_view_filter_get_type ())
#define DEFAULT_SEARCH_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEFAULT_SEARCH_VIEW_FILTER, DefaultSearchViewFilter))
#define DEFAULT_SEARCH_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEFAULT_SEARCH_VIEW_FILTER, DefaultSearchViewFilterClass))
#define IS_DEFAULT_SEARCH_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEFAULT_SEARCH_VIEW_FILTER))
#define IS_DEFAULT_SEARCH_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEFAULT_SEARCH_VIEW_FILTER))
#define DEFAULT_SEARCH_VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEFAULT_SEARCH_VIEW_FILTER, DefaultSearchViewFilterClass))

typedef struct _DefaultSearchViewFilter DefaultSearchViewFilter;
typedef struct _DefaultSearchViewFilterClass DefaultSearchViewFilterClass;
typedef struct _DefaultSearchViewFilterPrivate DefaultSearchViewFilterPrivate;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_THUMBNAIL_VIEW (thumbnail_view_get_type ())
#define THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailView))
#define THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))
#define IS_THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_VIEW))
#define IS_THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_VIEW))
#define THUMBNAIL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))

typedef struct _ThumbnailView ThumbnailView;
typedef struct _ThumbnailViewClass ThumbnailViewClass;

#define TYPE_CHECKERBOARD_ITEM (checkerboard_item_get_type ())
#define CHECKERBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHECKERBOARD_ITEM, CheckerboardItem))
#define CHECKERBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHECKERBOARD_ITEM, CheckerboardItemClass))
#define IS_CHECKERBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHECKERBOARD_ITEM))
#define IS_CHECKERBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHECKERBOARD_ITEM))
#define CHECKERBOARD_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHECKERBOARD_ITEM, CheckerboardItemClass))

typedef struct _CheckerboardItem CheckerboardItem;
typedef struct _CheckerboardItemClass CheckerboardItemClass;

#define TYPE_MEDIA_SOURCE_ITEM (media_source_item_get_type ())
#define MEDIA_SOURCE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_ITEM, MediaSourceItem))
#define MEDIA_SOURCE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_ITEM, MediaSourceItemClass))
#define IS_MEDIA_SOURCE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_ITEM))
#define IS_MEDIA_SOURCE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_ITEM))
#define MEDIA_SOURCE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_ITEM, MediaSourceItemClass))

typedef struct _MediaSourceItem MediaSourceItem;
typedef struct _MediaSourceItemClass MediaSourceItemClass;

#define TYPE_THUMBNAIL (thumbnail_get_type ())
#define THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL, Thumbnail))
#define THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL, ThumbnailClass))
#define IS_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL))
#define IS_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL))
#define THUMBNAIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL, ThumbnailClass))

typedef struct _Thumbnail Thumbnail;
typedef struct _ThumbnailClass ThumbnailClass;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_VIDEO_SOURCE (video_source_get_type ())
#define VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_SOURCE, VideoSource))
#define VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_SOURCE, VideoSourceClass))
#define IS_VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_SOURCE))
#define IS_VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_SOURCE))
#define VIDEO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_SOURCE, VideoSourceClass))

typedef struct _VideoSource VideoSource;
typedef struct _VideoSourceClass VideoSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;

#define TYPE_FACE (face_get_type ())
#define FACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE, Face))
#define FACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE, FaceClass))
#define IS_FACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE))
#define IS_FACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE))
#define FACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE, FaceClass))

typedef struct _Face Face;
typedef struct _FaceClass FaceClass;

#define TYPE_FACE_SOURCE_COLLECTION (face_source_collection_get_type ())
#define FACE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollection))
#define FACE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollectionClass))
#define IS_FACE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_SOURCE_COLLECTION))
#define IS_FACE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_SOURCE_COLLECTION))
#define FACE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollectionClass))

typedef struct _FaceSourceCollection FaceSourceCollection;
typedef struct _FaceSourceCollectionClass FaceSourceCollectionClass;

#define TYPE_DISABLED_VIEW_FILTER (disabled_view_filter_get_type ())
#define DISABLED_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DISABLED_VIEW_FILTER, DisabledViewFilter))
#define DISABLED_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DISABLED_VIEW_FILTER, DisabledViewFilterClass))
#define IS_DISABLED_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DISABLED_VIEW_FILTER))
#define IS_DISABLED_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DISABLED_VIEW_FILTER))
#define DISABLED_VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DISABLED_VIEW_FILTER, DisabledViewFilterClass))

typedef struct _DisabledViewFilter DisabledViewFilter;
typedef struct _DisabledViewFilterClass DisabledViewFilterClass;
typedef struct _DisabledViewFilterPrivate DisabledViewFilterPrivate;

#define TYPE_TEXT_ACTION (text_action_get_type ())
#define TEXT_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEXT_ACTION, TextAction))
#define TEXT_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEXT_ACTION, TextActionClass))
#define IS_TEXT_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEXT_ACTION))
#define IS_TEXT_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEXT_ACTION))
#define TEXT_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEXT_ACTION, TextActionClass))

typedef struct _TextAction TextAction;
typedef struct _TextActionClass TextActionClass;
typedef struct _TextActionPrivate TextActionPrivate;
typedef struct _ParamSpecTextAction ParamSpecTextAction;
enum  {
	TEXT_ACTION_TEXT_CHANGED_SIGNAL,
	TEXT_ACTION_SENSITIVITY_CHANGED_SIGNAL,
	TEXT_ACTION_VISIBILITY_CHANGED_SIGNAL,
	TEXT_ACTION_NUM_SIGNALS
};
static guint text_action_signals[TEXT_ACTION_NUM_SIGNALS] = {0};

#define TYPE_SEARCH_FILTER_ACTIONS (search_filter_actions_get_type ())
#define SEARCH_FILTER_ACTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_FILTER_ACTIONS, SearchFilterActions))
#define SEARCH_FILTER_ACTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_FILTER_ACTIONS, SearchFilterActionsClass))
#define IS_SEARCH_FILTER_ACTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_FILTER_ACTIONS))
#define IS_SEARCH_FILTER_ACTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_FILTER_ACTIONS))
#define SEARCH_FILTER_ACTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_FILTER_ACTIONS, SearchFilterActionsClass))

typedef struct _SearchFilterActions SearchFilterActions;
typedef struct _SearchFilterActionsClass SearchFilterActionsClass;
typedef struct _SearchFilterActionsPrivate SearchFilterActionsPrivate;
#define _text_action_unref0(var) ((var == NULL) ? NULL : (var = (text_action_unref (var), NULL)))

#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;

#define TYPE_APP_WINDOW (app_window_get_type ())
#define APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_WINDOW, AppWindow))
#define APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_WINDOW, AppWindowClass))
#define IS_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_WINDOW))
#define IS_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_WINDOW))
#define APP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_WINDOW, AppWindowClass))

typedef struct _AppWindow AppWindow;
typedef struct _AppWindowClass AppWindowClass;

#define TYPE_LIBRARY_WINDOW (library_window_get_type ())
#define LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_WINDOW, LibraryWindow))
#define LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_WINDOW, LibraryWindowClass))
#define IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_WINDOW))
#define IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_WINDOW))
#define LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_WINDOW, LibraryWindowClass))

typedef struct _LibraryWindow LibraryWindow;
typedef struct _LibraryWindowClass LibraryWindowClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_CHECKERBOARD_PAGE (checkerboard_page_get_type ())
#define CHECKERBOARD_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHECKERBOARD_PAGE, CheckerboardPage))
#define CHECKERBOARD_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHECKERBOARD_PAGE, CheckerboardPageClass))
#define IS_CHECKERBOARD_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHECKERBOARD_PAGE))
#define IS_CHECKERBOARD_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHECKERBOARD_PAGE))
#define CHECKERBOARD_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHECKERBOARD_PAGE, CheckerboardPageClass))

typedef struct _CheckerboardPage CheckerboardPage;
typedef struct _CheckerboardPageClass CheckerboardPageClass;

#define CORE_TYPE_TRACKER (core_tracker_get_type ())
#define CORE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CORE_TYPE_TRACKER, CoreTracker))
#define CORE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CORE_TYPE_TRACKER, CoreTrackerClass))
#define CORE_IS_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CORE_TYPE_TRACKER))
#define CORE_IS_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CORE_TYPE_TRACKER))
#define CORE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CORE_TYPE_TRACKER, CoreTrackerClass))

typedef struct _CoreTracker CoreTracker;
typedef struct _CoreTrackerClass CoreTrackerClass;

#define CORE_TYPE_VIEW_TRACKER (core_view_tracker_get_type ())
#define CORE_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CORE_TYPE_VIEW_TRACKER, CoreViewTracker))
#define CORE_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CORE_TYPE_VIEW_TRACKER, CoreViewTrackerClass))
#define CORE_IS_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CORE_TYPE_VIEW_TRACKER))
#define CORE_IS_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CORE_TYPE_VIEW_TRACKER))
#define CORE_VIEW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CORE_TYPE_VIEW_TRACKER, CoreViewTrackerClass))

typedef struct _CoreViewTracker CoreViewTracker;
typedef struct _CoreViewTrackerClass CoreViewTrackerClass;

#define TYPE_MEDIA_VIEW_TRACKER (media_view_tracker_get_type ())
#define MEDIA_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_VIEW_TRACKER, MediaViewTracker))
#define MEDIA_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_VIEW_TRACKER, MediaViewTrackerClass))
#define IS_MEDIA_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_VIEW_TRACKER))
#define IS_MEDIA_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_VIEW_TRACKER))
#define MEDIA_VIEW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_VIEW_TRACKER, MediaViewTrackerClass))

typedef struct _MediaViewTracker MediaViewTracker;
typedef struct _MediaViewTrackerClass MediaViewTrackerClass;

#define TYPE_CAMERA_VIEW_TRACKER (camera_view_tracker_get_type ())
#define CAMERA_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CAMERA_VIEW_TRACKER, CameraViewTracker))
#define CAMERA_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CAMERA_VIEW_TRACKER, CameraViewTrackerClass))
#define IS_CAMERA_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CAMERA_VIEW_TRACKER))
#define IS_CAMERA_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CAMERA_VIEW_TRACKER))
#define CAMERA_VIEW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CAMERA_VIEW_TRACKER, CameraViewTrackerClass))

typedef struct _CameraViewTracker CameraViewTracker;
typedef struct _CameraViewTrackerClass CameraViewTrackerClass;
#define _core_tracker_unref0(var) ((var == NULL) ? NULL : (var = (core_tracker_unref (var), NULL)))
typedef struct _CoreTrackerPrivate CoreTrackerPrivate;
typedef struct _CoreViewTrackerPrivate CoreViewTrackerPrivate;
typedef struct _MediaViewTrackerPrivate MediaViewTrackerPrivate;

#define TYPE_MEDIA_ACCUMULATOR (media_accumulator_get_type ())
#define MEDIA_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_ACCUMULATOR, MediaAccumulator))
#define MEDIA_ACCUMULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_ACCUMULATOR, MediaAccumulatorClass))
#define IS_MEDIA_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_ACCUMULATOR))
#define IS_MEDIA_ACCUMULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_ACCUMULATOR))
#define MEDIA_ACCUMULATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_ACCUMULATOR, MediaAccumulatorClass))

typedef struct _MediaAccumulator MediaAccumulator;
typedef struct _MediaAccumulatorClass MediaAccumulatorClass;

#define CORE_TYPE_TRACKER_ACCUMULATOR (core_tracker_accumulator_get_type ())
#define CORE_TRACKER_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CORE_TYPE_TRACKER_ACCUMULATOR, CoreTrackerAccumulator))
#define CORE_IS_TRACKER_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CORE_TYPE_TRACKER_ACCUMULATOR))
#define CORE_TRACKER_ACCUMULATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), CORE_TYPE_TRACKER_ACCUMULATOR, CoreTrackerAccumulatorIface))

typedef struct _CoreTrackerAccumulator CoreTrackerAccumulator;
typedef struct _CoreTrackerAccumulatorIface CoreTrackerAccumulatorIface;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;
typedef struct _MediaAccumulatorPrivate MediaAccumulatorPrivate;
typedef struct _CameraViewTrackerPrivate CameraViewTrackerPrivate;

#define TYPE_CAMERA_ACCUMULATOR (camera_accumulator_get_type ())
#define CAMERA_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CAMERA_ACCUMULATOR, CameraAccumulator))
#define CAMERA_ACCUMULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CAMERA_ACCUMULATOR, CameraAccumulatorClass))
#define IS_CAMERA_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CAMERA_ACCUMULATOR))
#define IS_CAMERA_ACCUMULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CAMERA_ACCUMULATOR))
#define CAMERA_ACCUMULATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CAMERA_ACCUMULATOR, CameraAccumulatorClass))

typedef struct _CameraAccumulator CameraAccumulator;
typedef struct _CameraAccumulatorClass CameraAccumulatorClass;
typedef struct _ParamSpecSearchFilterActions ParamSpecSearchFilterActions;
enum  {
	SEARCH_FILTER_ACTIONS_FLAGGED_TOGGLED_SIGNAL,
	SEARCH_FILTER_ACTIONS_PHOTOS_TOGGLED_SIGNAL,
	SEARCH_FILTER_ACTIONS_VIDEOS_TOGGLED_SIGNAL,
	SEARCH_FILTER_ACTIONS_RAW_TOGGLED_SIGNAL,
	SEARCH_FILTER_ACTIONS_RATING_CHANGED_SIGNAL,
	SEARCH_FILTER_ACTIONS_TEXT_CHANGED_SIGNAL,
	SEARCH_FILTER_ACTIONS_MEDIA_CONTEXT_CHANGED_SIGNAL,
	SEARCH_FILTER_ACTIONS_CRITERIA_CHANGED_SIGNAL,
	SEARCH_FILTER_ACTIONS_NUM_SIGNALS
};
static guint search_filter_actions_signals[SEARCH_FILTER_ACTIONS_NUM_SIGNALS] = {0};

#define TYPE_SEARCH_FILTER_TOOLBAR (search_filter_toolbar_get_type ())
#define SEARCH_FILTER_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_FILTER_TOOLBAR, SearchFilterToolbar))
#define SEARCH_FILTER_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_FILTER_TOOLBAR, SearchFilterToolbarClass))
#define IS_SEARCH_FILTER_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_FILTER_TOOLBAR))
#define IS_SEARCH_FILTER_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_FILTER_TOOLBAR))
#define SEARCH_FILTER_TOOLBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_FILTER_TOOLBAR, SearchFilterToolbarClass))

typedef struct _SearchFilterToolbar SearchFilterToolbar;
typedef struct _SearchFilterToolbarClass SearchFilterToolbarClass;
typedef struct _SearchFilterToolbarPrivate SearchFilterToolbarPrivate;

#define SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX (search_filter_toolbar_search_box_get_type ())
#define SEARCH_FILTER_TOOLBAR_SEARCH_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX, SearchFilterToolbarSearchBox))
#define SEARCH_FILTER_TOOLBAR_SEARCH_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX, SearchFilterToolbarSearchBoxClass))
#define SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX))
#define SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX))
#define SEARCH_FILTER_TOOLBAR_SEARCH_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX, SearchFilterToolbarSearchBoxClass))

typedef struct _SearchFilterToolbarSearchBox SearchFilterToolbarSearchBox;
typedef struct _SearchFilterToolbarSearchBoxClass SearchFilterToolbarSearchBoxClass;

#define SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON (search_filter_toolbar_rating_filter_button_get_type ())
#define SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON, SearchFilterToolbarRatingFilterButton))
#define SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON, SearchFilterToolbarRatingFilterButtonClass))
#define SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON))
#define SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON))
#define SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON, SearchFilterToolbarRatingFilterButtonClass))

typedef struct _SearchFilterToolbarRatingFilterButton SearchFilterToolbarRatingFilterButton;
typedef struct _SearchFilterToolbarRatingFilterButtonClass SearchFilterToolbarRatingFilterButtonClass;

#define SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON (search_filter_toolbar_saved_search_filter_button_get_type ())
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON, SearchFilterToolbarSavedSearchFilterButton))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON, SearchFilterToolbarSavedSearchFilterButtonClass))
#define SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON))
#define SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON, SearchFilterToolbarSavedSearchFilterButtonClass))

typedef struct _SearchFilterToolbarSavedSearchFilterButton SearchFilterToolbarSavedSearchFilterButton;
typedef struct _SearchFilterToolbarSavedSearchFilterButtonClass SearchFilterToolbarSavedSearchFilterButtonClass;

#define SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM (search_filter_toolbar_label_tool_item_get_type ())
#define SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM, SearchFilterToolbarLabelToolItem))
#define SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM, SearchFilterToolbarLabelToolItemClass))
#define SEARCH_FILTER_TOOLBAR_IS_LABEL_TOOL_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM))
#define SEARCH_FILTER_TOOLBAR_IS_LABEL_TOOL_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM))
#define SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM, SearchFilterToolbarLabelToolItemClass))

typedef struct _SearchFilterToolbarLabelToolItem SearchFilterToolbarLabelToolItem;
typedef struct _SearchFilterToolbarLabelToolItemClass SearchFilterToolbarLabelToolItemClass;

#define SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON (search_filter_toolbar_toggle_action_tool_button_get_type ())
#define SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON, SearchFilterToolbarToggleActionToolButton))
#define SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON, SearchFilterToolbarToggleActionToolButtonClass))
#define SEARCH_FILTER_TOOLBAR_IS_TOGGLE_ACTION_TOOL_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON))
#define SEARCH_FILTER_TOOLBAR_IS_TOGGLE_ACTION_TOOL_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON))
#define SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON, SearchFilterToolbarToggleActionToolButtonClass))

typedef struct _SearchFilterToolbarToggleActionToolButton SearchFilterToolbarToggleActionToolButton;
typedef struct _SearchFilterToolbarToggleActionToolButtonClass SearchFilterToolbarToggleActionToolButtonClass;
enum  {
	SEARCH_FILTER_TOOLBAR_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_properties[SEARCH_FILTER_TOOLBAR_NUM_PROPERTIES];
#define _search_filter_actions_unref0(var) ((var == NULL) ? NULL : (var = (search_filter_actions_unref (var), NULL)))
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SearchFilterToolbarSavedSearchFilterButtonPrivate SearchFilterToolbarSavedSearchFilterButtonPrivate;

#define SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER (search_filter_toolbar_saved_search_popover_get_type ())
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, SearchFilterToolbarSavedSearchPopover))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, SearchFilterToolbarSavedSearchPopoverClass))
#define SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER))
#define SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, SearchFilterToolbarSavedSearchPopoverClass))

typedef struct _SearchFilterToolbarSavedSearchPopover SearchFilterToolbarSavedSearchPopover;
typedef struct _SearchFilterToolbarSavedSearchPopoverClass SearchFilterToolbarSavedSearchPopoverClass;

#define TYPE_SAVED_SEARCH_DIALOG (saved_search_dialog_get_type ())
#define SAVED_SEARCH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SAVED_SEARCH_DIALOG, SavedSearchDialog))
#define SAVED_SEARCH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SAVED_SEARCH_DIALOG, SavedSearchDialogClass))
#define IS_SAVED_SEARCH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SAVED_SEARCH_DIALOG))
#define IS_SAVED_SEARCH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SAVED_SEARCH_DIALOG))
#define SAVED_SEARCH_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SAVED_SEARCH_DIALOG, SavedSearchDialogClass))

typedef struct _SavedSearchDialog SavedSearchDialog;
typedef struct _SavedSearchDialogClass SavedSearchDialogClass;

#define TYPE_COMMAND_MANAGER (command_manager_get_type ())
#define COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_MANAGER, CommandManager))
#define COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND_MANAGER, CommandManagerClass))
#define IS_COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_MANAGER))
#define IS_COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND_MANAGER))
#define COMMAND_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND_MANAGER, CommandManagerClass))

typedef struct _CommandManager CommandManager;
typedef struct _CommandManagerClass CommandManagerClass;

#define TYPE_COMMAND (command_get_type ())
#define COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND, Command))
#define COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND, CommandClass))
#define IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND))
#define IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND))
#define COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND, CommandClass))

typedef struct _Command Command;
typedef struct _CommandClass CommandClass;

#define TYPE_PAGE_COMMAND (page_command_get_type ())
#define PAGE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_COMMAND, PageCommand))
#define PAGE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_COMMAND, PageCommandClass))
#define IS_PAGE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_COMMAND))
#define IS_PAGE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_COMMAND))
#define PAGE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_COMMAND, PageCommandClass))

typedef struct _PageCommand PageCommand;
typedef struct _PageCommandClass PageCommandClass;

#define TYPE_SINGLE_DATA_SOURCE_COMMAND (single_data_source_command_get_type ())
#define SINGLE_DATA_SOURCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand))
#define SINGLE_DATA_SOURCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommandClass))
#define IS_SINGLE_DATA_SOURCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND))
#define IS_SINGLE_DATA_SOURCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SINGLE_DATA_SOURCE_COMMAND))
#define SINGLE_DATA_SOURCE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommandClass))

typedef struct _SingleDataSourceCommand SingleDataSourceCommand;
typedef struct _SingleDataSourceCommandClass SingleDataSourceCommandClass;

#define TYPE_DELETE_SAVED_SEARCH_COMMAND (delete_saved_search_command_get_type ())
#define DELETE_SAVED_SEARCH_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommand))
#define DELETE_SAVED_SEARCH_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommandClass))
#define IS_DELETE_SAVED_SEARCH_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DELETE_SAVED_SEARCH_COMMAND))
#define IS_DELETE_SAVED_SEARCH_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DELETE_SAVED_SEARCH_COMMAND))
#define DELETE_SAVED_SEARCH_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommandClass))

typedef struct _DeleteSavedSearchCommand DeleteSavedSearchCommand;
typedef struct _DeleteSavedSearchCommandClass DeleteSavedSearchCommandClass;
#define _command_manager_unref0(var) ((var == NULL) ? NULL : (var = (command_manager_unref (var), NULL)))
#define _search_filter_toolbar_saved_search_popover_unref0(var) ((var == NULL) ? NULL : (var = (search_filter_toolbar_saved_search_popover_unref (var), NULL)))
typedef struct _SearchFilterToolbarLabelToolItemPrivate SearchFilterToolbarLabelToolItemPrivate;
enum  {
	SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_label_tool_item_properties[SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM_NUM_PROPERTIES];
typedef struct _SearchFilterToolbarToggleActionToolButtonPrivate SearchFilterToolbarToggleActionToolButtonPrivate;
enum  {
	SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_toggle_action_tool_button_properties[SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON_NUM_PROPERTIES];
typedef struct _SearchFilterToolbarSearchBoxPrivate SearchFilterToolbarSearchBoxPrivate;
enum  {
	SEARCH_FILTER_TOOLBAR_SEARCH_BOX_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_SEARCH_BOX_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_search_box_properties[SEARCH_FILTER_TOOLBAR_SEARCH_BOX_NUM_PROPERTIES];
typedef struct _SearchFilterToolbarRatingFilterButtonPrivate SearchFilterToolbarRatingFilterButtonPrivate;
enum  {
	SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_rating_filter_button_properties[SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON_NUM_PROPERTIES];
enum  {
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_saved_search_filter_button_properties[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_NUM_PROPERTIES];
enum  {
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_CLICKED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_NUM_SIGNALS
};
static guint search_filter_toolbar_saved_search_filter_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_NUM_SIGNALS] = {0};
typedef struct _SearchFilterToolbarSavedSearchPopoverPrivate SearchFilterToolbarSavedSearchPopoverPrivate;

#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON (search_filter_toolbar_saved_search_popover_data_button_get_type ())
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButton))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButtonClass))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButtonClass))

typedef struct _SearchFilterToolbarSavedSearchPopoverDataButton SearchFilterToolbarSavedSearchPopoverDataButton;
typedef struct _SearchFilterToolbarSavedSearchPopoverDataButtonClass SearchFilterToolbarSavedSearchPopoverDataButtonClass;

#define TYPE_SAVED_SEARCH_TABLE (saved_search_table_get_type ())
#define SAVED_SEARCH_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SAVED_SEARCH_TABLE, SavedSearchTable))
#define SAVED_SEARCH_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SAVED_SEARCH_TABLE, SavedSearchTableClass))
#define IS_SAVED_SEARCH_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SAVED_SEARCH_TABLE))
#define IS_SAVED_SEARCH_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SAVED_SEARCH_TABLE))
#define SAVED_SEARCH_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SAVED_SEARCH_TABLE, SavedSearchTableClass))

typedef struct _SavedSearchTable SavedSearchTable;
typedef struct _SavedSearchTableClass SavedSearchTableClass;
#define _saved_search_table_unref0(var) ((var == NULL) ? NULL : (var = (saved_search_table_unref (var), NULL)))
typedef struct _SearchFilterToolbarSavedSearchPopoverDataButtonPrivate SearchFilterToolbarSavedSearchPopoverDataButtonPrivate;
enum  {
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_saved_search_popover_data_button_properties[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_NUM_PROPERTIES];
enum  {
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_CLICKED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_NUM_SIGNALS
};
static guint search_filter_toolbar_saved_search_popover_data_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_NUM_SIGNALS] = {0};
typedef struct _SearchFilterToolbarParamSpecSavedSearchPopover SearchFilterToolbarParamSpecSavedSearchPopover;
enum  {
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_SEARCH_ACTIVATED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_EDIT_CLICKED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DELETE_CLICKED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_ADD_CLICKED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_CLOSED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_NUM_SIGNALS
};
static guint search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ViewFilter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewFilterPrivate * priv;
};

struct _ViewFilterClass {
	GTypeClass parent_class;
	void (*finalize) (ViewFilter *self);
	gboolean (*predicate) (ViewFilter* self, DataView* view);
	void (*refresh) (ViewFilter* self);
};

struct _SearchViewFilter {
	ViewFilter parent_instance;
	SearchViewFilterPrivate * priv;
};

struct _SearchViewFilterClass {
	ViewFilterClass parent_class;
	guint (*get_criteria) (SearchViewFilter* self);
};

struct _SearchViewFilterPrivate {
	gboolean rating_allow_higher;
	Rating rating;
	RatingFilter rating_filter;
	gboolean _flagged;
	gboolean _show_media_video;
	gboolean _show_media_photos;
	gboolean _show_media_raw;
	gchar* search_filter;
	gchar** search_filter_words;
	gint search_filter_words_length1;
	gint _search_filter_words_size_;
	SavedSearch* _saved_search;
};

struct _DefaultSearchViewFilter {
	SearchViewFilter parent_instance;
	DefaultSearchViewFilterPrivate * priv;
};

struct _DefaultSearchViewFilterClass {
	SearchViewFilterClass parent_class;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _DisabledViewFilter {
	SearchViewFilter parent_instance;
	DisabledViewFilterPrivate * priv;
};

struct _DisabledViewFilterClass {
	SearchViewFilterClass parent_class;
};

struct _TextAction {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TextActionPrivate * priv;
};

struct _TextActionClass {
	GTypeClass parent_class;
	void (*finalize) (TextAction *self);
};

struct _TextActionPrivate {
	gchar* text;
	gboolean sensitive;
	gboolean visible;
};

struct _ParamSpecTextAction {
	GParamSpec parent_instance;
};

struct _SearchFilterActions {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SearchFilterActionsPrivate * priv;
};

struct _SearchFilterActionsClass {
	GTypeClass parent_class;
	void (*finalize) (SearchFilterActions *self);
};

struct _SearchFilterActionsPrivate {
	SearchFilterCriteria criteria;
	TextAction* _text;
	gboolean has_flagged;
	gboolean has_photos;
	gboolean has_videos;
	gboolean has_raw;
	gboolean can_filter_by_stars;
};

struct _CoreTracker {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CoreTrackerPrivate * priv;
};

struct _CoreTrackerClass {
	GTypeClass parent_class;
	void (*finalize) (CoreTracker *self);
	void (*updated) (CoreTracker* self);
};

struct _CoreViewTracker {
	CoreTracker parent_instance;
	CoreViewTrackerPrivate * priv;
};

struct _CoreViewTrackerClass {
	CoreTrackerClass parent_class;
};

struct _MediaViewTracker {
	CoreViewTracker parent_instance;
	MediaViewTrackerPrivate * priv;
	MediaAccumulator* all;
	MediaAccumulator* visible;
	MediaAccumulator* selected;
};

struct _MediaViewTrackerClass {
	CoreViewTrackerClass parent_class;
};

struct _CoreTrackerAccumulatorIface {
	GTypeInterface parent_iface;
	gboolean (*include) (CoreTrackerAccumulator* self, DataObject* object);
	gboolean (*uninclude) (CoreTrackerAccumulator* self, DataObject* object);
	gboolean (*altered) (CoreTrackerAccumulator* self, DataObject* object, Alteration* alteration);
};

struct _MediaAccumulator {
	GObject parent_instance;
	MediaAccumulatorPrivate * priv;
	gint total;
	gint photos;
	gint videos;
	gint raw;
	gint flagged;
};

struct _MediaAccumulatorClass {
	GObjectClass parent_class;
};

struct _CameraViewTracker {
	CoreViewTracker parent_instance;
	CameraViewTrackerPrivate * priv;
	CameraAccumulator* all;
	CameraAccumulator* visible;
	CameraAccumulator* selected;
};

struct _CameraViewTrackerClass {
	CoreViewTrackerClass parent_class;
};

struct _ParamSpecSearchFilterActions {
	GParamSpec parent_instance;
};

struct _SearchFilterToolbar {
	GtkRevealer parent_instance;
	SearchFilterToolbarPrivate * priv;
	GtkBuilder* builder;
};

struct _SearchFilterToolbarClass {
	GtkRevealerClass parent_class;
};

struct _SearchFilterToolbarPrivate {
	GtkToolbar* toolbar;
	GtkMenu* close_menu;
	GtkMenuItem* close_item;
	SearchFilterActions* actions;
	SavedSearch* saved_search;
	SearchFilterToolbarSearchBox* search_box;
	SearchFilterToolbarRatingFilterButton* rating_button;
	SearchFilterToolbarSavedSearchFilterButton* saved_search_button;
	gboolean elide_showing_again;
	SearchViewFilter* search_filter;
	SearchFilterToolbarLabelToolItem* label_type;
	SearchFilterToolbarToggleActionToolButton* toolbtn_photos;
	SearchFilterToolbarToggleActionToolButton* toolbtn_videos;
	SearchFilterToolbarToggleActionToolButton* toolbtn_raw;
	SearchFilterToolbarToggleActionToolButton* toolbtn_flag;
	GtkSeparatorToolItem* sepr_mediatype_flagged;
	GtkSeparatorToolItem* sepr_flagged_rating;
	GtkSeparatorToolItem* sepr_rating_saved;
};

struct _SearchFilterToolbarSavedSearchFilterButton {
	GtkToolItem parent_instance;
	SearchFilterToolbarSavedSearchFilterButtonPrivate * priv;
	SearchFilterToolbarSavedSearchPopover* filter_popup;
	GtkToggleButton* button;
};

struct _SearchFilterToolbarSavedSearchFilterButtonClass {
	GtkToolItemClass parent_class;
};

struct _SearchFilterToolbarLabelToolItem {
	GtkToolItem parent_instance;
	SearchFilterToolbarLabelToolItemPrivate * priv;
};

struct _SearchFilterToolbarLabelToolItemClass {
	GtkToolItemClass parent_class;
};

struct _SearchFilterToolbarLabelToolItemPrivate {
	GtkLabel* label;
};

struct _SearchFilterToolbarToggleActionToolButton {
	GtkToolItem parent_instance;
	SearchFilterToolbarToggleActionToolButtonPrivate * priv;
};

struct _SearchFilterToolbarToggleActionToolButtonClass {
	GtkToolItemClass parent_class;
};

struct _SearchFilterToolbarToggleActionToolButtonPrivate {
	GtkToggleButton* button;
};

struct _SearchFilterToolbarSearchBox {
	GtkToolItem parent_instance;
	SearchFilterToolbarSearchBoxPrivate * priv;
};

struct _SearchFilterToolbarSearchBoxClass {
	GtkToolItemClass parent_class;
};

struct _SearchFilterToolbarSearchBoxPrivate {
	GtkSearchEntry* search_entry;
	TextAction* action;
};

struct _SearchFilterToolbarRatingFilterButton {
	GtkToolItem parent_instance;
	SearchFilterToolbarRatingFilterButtonPrivate * priv;
	GtkMenuButton* button;
};

struct _SearchFilterToolbarRatingFilterButtonClass {
	GtkToolItemClass parent_class;
};

struct _SearchFilterToolbarSavedSearchPopover {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SearchFilterToolbarSavedSearchPopoverPrivate * priv;
};

struct _SearchFilterToolbarSavedSearchPopoverClass {
	GTypeClass parent_class;
	void (*finalize) (SearchFilterToolbarSavedSearchPopover *self);
};

struct _SearchFilterToolbarSavedSearchPopoverPrivate {
	GtkPopover* popover;
	GtkListBox* list_box;
	SearchFilterToolbarSavedSearchPopoverDataButton** edit_buttons;
	gint edit_buttons_length1;
	gint _edit_buttons_size_;
	SearchFilterToolbarSavedSearchPopoverDataButton** delete_buttons;
	gint delete_buttons_length1;
	gint _delete_buttons_size_;
	GtkButton* add;
};

struct _SearchFilterToolbarSavedSearchPopoverDataButton {
	GtkBin parent_instance;
	SearchFilterToolbarSavedSearchPopoverDataButtonPrivate * priv;
};

struct _SearchFilterToolbarSavedSearchPopoverDataButtonClass {
	GtkBinClass parent_class;
};

struct _SearchFilterToolbarSavedSearchPopoverDataButtonPrivate {
	GtkButton* button;
	SavedSearch* _search;
};

struct _SearchFilterToolbarParamSpecSavedSearchPopover {
	GParamSpec parent_instance;
};

static gint SearchViewFilter_private_offset;
static gpointer search_view_filter_parent_class = NULL;
static gpointer default_search_view_filter_parent_class = NULL;
extern TagSourceCollection* tag_global;
extern FaceSourceCollection* face_global;
static gpointer disabled_view_filter_parent_class = NULL;
static gint TextAction_private_offset;
static gpointer text_action_parent_class = NULL;
static gint SearchFilterActions_private_offset;
static gpointer search_filter_actions_parent_class = NULL;
static gint SearchFilterToolbar_private_offset;
static gpointer search_filter_toolbar_parent_class = NULL;
static gint SearchFilterToolbarLabelToolItem_private_offset;
static gpointer search_filter_toolbar_label_tool_item_parent_class = NULL;
static gint SearchFilterToolbarToggleActionToolButton_private_offset;
static gpointer search_filter_toolbar_toggle_action_tool_button_parent_class = NULL;
static gint SearchFilterToolbarSearchBox_private_offset;
static gpointer search_filter_toolbar_search_box_parent_class = NULL;
static gpointer search_filter_toolbar_rating_filter_button_parent_class = NULL;
static gpointer search_filter_toolbar_saved_search_filter_button_parent_class = NULL;
static gint SearchFilterToolbarSavedSearchPopover_private_offset;
static gpointer search_filter_toolbar_saved_search_popover_parent_class = NULL;
static gint SearchFilterToolbarSavedSearchPopoverDataButton_private_offset;
static gpointer search_filter_toolbar_saved_search_popover_data_button_parent_class = NULL;

GType search_filter_criteria_get_type (void) G_GNUC_CONST ;
GType rating_filter_get_type (void) G_GNUC_CONST ;
gpointer view_filter_ref (gpointer instance);
void view_filter_unref (gpointer instance);
GParamSpec* param_spec_view_filter (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_view_filter (GValue* value,
                            gpointer v_object);
void value_take_view_filter (GValue* value,
                             gpointer v_object);
gpointer value_get_view_filter (const GValue* value);
GType view_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ViewFilter, view_filter_unref)
GType data_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
GType data_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataView, g_object_unref)
GType search_view_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchViewFilter, view_filter_unref)
GType rating_get_type (void) G_GNUC_CONST ;
GType data_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
GType saved_search_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SavedSearch, g_object_unref)
guint search_view_filter_get_criteria (SearchViewFilter* self);
static guint search_view_filter_real_get_criteria (SearchViewFilter* self);
void search_view_filter_set_rating_filter (SearchViewFilter* self,
                                           RatingFilter rf);
gboolean search_view_filter_has_search_filter (SearchViewFilter* self);
gboolean is_string_empty (const gchar* s);
const gchar* search_view_filter_get_search_filter (SearchViewFilter* self);
gchar** search_view_filter_get_search_filter_words (SearchViewFilter* self,
                                                    gint* result_length1);
void search_view_filter_set_search_filter (SearchViewFilter* self,
                                           const gchar* text);
gchar* string_remove_diacritics (const gchar* istring);
static gchar** _vala_array_dup30 (gchar** self,
                           gint length);
void search_view_filter_clear_search_filter (SearchViewFilter* self);
gboolean search_view_filter_has_saved_search (SearchViewFilter* self);
SavedSearch* search_view_filter_get_saved_search (SearchViewFilter* self);
gboolean search_view_filter_get_rating_allow_higher (SearchViewFilter* self);
Rating search_view_filter_get_rating (SearchViewFilter* self);
gboolean search_view_filter_filter_by_media_type (SearchViewFilter* self);
gboolean search_view_filter_get_show_media_video (SearchViewFilter* self);
gboolean search_view_filter_get_show_media_photos (SearchViewFilter* self);
gboolean search_view_filter_get_show_media_raw (SearchViewFilter* self);
SearchViewFilter* search_view_filter_construct (GType object_type);
ViewFilter* view_filter_construct (GType object_type);
gboolean search_view_filter_get_flagged (SearchViewFilter* self);
void search_view_filter_set_flagged (SearchViewFilter* self,
                                     gboolean value);
void search_view_filter_set_show_media_video (SearchViewFilter* self,
                                              gboolean value);
void search_view_filter_set_show_media_photos (SearchViewFilter* self,
                                               gboolean value);
void search_view_filter_set_show_media_raw (SearchViewFilter* self,
                                            gboolean value);
void search_view_filter_set_saved_search (SearchViewFilter* self,
                                          SavedSearch* value);
static void search_view_filter_finalize (ViewFilter * obj);
static GType search_view_filter_get_type_once (void);
GType default_search_view_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DefaultSearchViewFilter, view_filter_unref)
gboolean view_filter_predicate (ViewFilter* self,
                                DataView* view);
static gboolean default_search_view_filter_real_predicate (ViewFilter* base,
                                                    DataView* view);
GType thumbnail_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailSource, g_object_unref)
GType media_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSource, g_object_unref)
GType thumbnail_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailView, g_object_unref)
GType checkerboard_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CheckerboardItem, g_object_unref)
GType media_source_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceItem, g_object_unref)
GType thumbnail_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Thumbnail, g_object_unref)
MediaSource* thumbnail_get_media_source (Thumbnail* self);
Rating media_source_get_rating (MediaSource* self);
GType flaggable_get_type (void) G_GNUC_CONST ;
gboolean flaggable_is_flagged (Flaggable* self);
GType video_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoSource, g_object_unref)
GType photo_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoSource, g_object_unref)
GType photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Photo, g_object_unref)
GType photo_file_format_get_type (void) G_GNUC_CONST ;
PhotoFileFormat photo_get_master_file_format (Photo* self);
GType indexable_get_type (void) G_GNUC_CONST ;
const gchar* indexable_get_indexable_keywords (Indexable* self);
GType event_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EventSource, g_object_unref)
GType event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Event, g_object_unref)
Event* media_source_get_event (MediaSource* self);
GType tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tag, g_object_unref)
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataCollection, data_collection_unref)
GType source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceCollection, data_collection_unref)
GType database_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseSourceCollection, data_collection_unref)
GType container_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContainerSourceCollection, data_collection_unref)
GType tag_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TagSourceCollection, data_collection_unref)
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self,
                                                 MediaSource* source);
GType face_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Face, g_object_unref)
GType face_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceSourceCollection, data_collection_unref)
GeeList* face_source_collection_fetch_for_source (FaceSourceCollection* self,
                                                  MediaSource* source);
gboolean saved_search_predicate (SavedSearch* self,
                                 MediaSource* source);
DefaultSearchViewFilter* default_search_view_filter_construct (GType object_type);
static GType default_search_view_filter_get_type_once (void);
GType disabled_view_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisabledViewFilter, view_filter_unref)
static gboolean disabled_view_filter_real_predicate (ViewFilter* base,
                                              DataView* view);
static guint disabled_view_filter_real_get_criteria (SearchViewFilter* base);
DisabledViewFilter* disabled_view_filter_new (void);
DisabledViewFilter* disabled_view_filter_construct (GType object_type);
static GType disabled_view_filter_get_type_once (void);
gpointer text_action_ref (gpointer instance);
void text_action_unref (gpointer instance);
GParamSpec* param_spec_text_action (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_text_action (GValue* value,
                            gpointer v_object);
void value_take_text_action (GValue* value,
                             gpointer v_object);
gpointer value_get_text_action (const GValue* value);
GType text_action_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TextAction, text_action_unref)
TextAction* text_action_new (const gchar* init);
TextAction* text_action_construct (GType object_type,
                                   const gchar* init);
void text_action_set_text (TextAction* self,
                           const gchar* text);
void text_action_clear (TextAction* self);
gboolean text_action_is_sensitive (TextAction* self);
void text_action_set_sensitive (TextAction* self,
                                gboolean sensitive);
gboolean text_action_is_visible (TextAction* self);
void text_action_set_visible (TextAction* self,
                              gboolean visible);
const gchar* text_action_get_value (TextAction* self);
static void text_action_finalize (TextAction * obj);
static GType text_action_get_type_once (void);
gpointer search_filter_actions_ref (gpointer instance);
void search_filter_actions_unref (gpointer instance);
GParamSpec* param_spec_search_filter_actions (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
void value_set_search_filter_actions (GValue* value,
                                      gpointer v_object);
void value_take_search_filter_actions (GValue* value,
                                       gpointer v_object);
gpointer value_get_search_filter_actions (const GValue* value);
GType search_filter_actions_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterActions, search_filter_actions_unref)
static void search_filter_actions_on_action_radio (SearchFilterActions* self,
                                            GSimpleAction* action,
                                            GVariant* parameter);
static void _search_filter_actions_on_action_radio_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void search_filter_actions_on_rating_changed (SearchFilterActions* self,
                                              GSimpleAction* action,
                                              GVariant* value);
static void _search_filter_actions_on_rating_changed_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                    GVariant* value,
                                                                                    gpointer self);
static void search_filter_actions_on_action_toggle (SearchFilterActions* self,
                                             GSimpleAction* action,
                                             GVariant* parameter);
static void _search_filter_actions_on_action_toggle_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void search_filter_actions_on_flagged_toggled (SearchFilterActions* self,
                                               GSimpleAction* action,
                                               GVariant* value);
static void _search_filter_actions_on_flagged_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                     GVariant* value,
                                                                                     gpointer self);
static void search_filter_actions_on_photos_toggled (SearchFilterActions* self,
                                              GSimpleAction* action,
                                              GVariant* value);
static void _search_filter_actions_on_photos_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                    GVariant* value,
                                                                                    gpointer self);
static void search_filter_actions_on_videos_toggled (SearchFilterActions* self,
                                              GSimpleAction* action,
                                              GVariant* value);
static void _search_filter_actions_on_videos_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                    GVariant* value,
                                                                                    gpointer self);
static void search_filter_actions_on_raw_toggled (SearchFilterActions* self,
                                           GSimpleAction* action,
                                           GVariant* value);
static void _search_filter_actions_on_raw_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                 GVariant* value,
                                                                                 gpointer self);
SearchFilterActions* search_filter_actions_new (void);
SearchFilterActions* search_filter_actions_construct (GType object_type);
static void search_filter_actions_register (SearchFilterActions* self);
TextAction* search_filter_actions_get_text (SearchFilterActions* self);
static void search_filter_actions_on_text_changed (SearchFilterActions* self,
                                            TextAction* action,
                                            const gchar* text);
static void _search_filter_actions_on_text_changed_text_action_text_changed (TextAction* _sender,
                                                                      const gchar* text,
                                                                      gpointer self);
SearchFilterCriteria search_filter_actions_get_criteria (SearchFilterActions* self);
GActionEntry* search_filter_actions_get_actions (SearchFilterActions* self,
                                                 gint* result_length1);
GSimpleAction* search_filter_actions_get_action (SearchFilterActions* self,
                                                 const gchar* name);
GType page_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageWindow, g_object_unref)
GType app_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppWindow, g_object_unref)
GType library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryWindow, g_object_unref)
AppWindow* app_window_get_instance (void);
void search_filter_actions_set_action_sensitive (SearchFilterActions* self,
                                                 const gchar* name,
                                                 gboolean sensitive);
void search_filter_actions_reset (SearchFilterActions* self);
GSimpleAction* search_filter_actions_get_flagged (SearchFilterActions* self);
static GVariant* _variant_new30 (gboolean value);
GSimpleAction* search_filter_actions_get_photos (SearchFilterActions* self);
static GVariant* _variant_new31 (gboolean value);
GSimpleAction* search_filter_actions_get_raw (SearchFilterActions* self);
static GVariant* _variant_new32 (gboolean value);
GSimpleAction* search_filter_actions_get_videos (SearchFilterActions* self);
static GVariant* _variant_new33 (gboolean value);
static GVariant* _variant_new34 (gchar* value);
GSimpleAction* search_filter_actions_get_rating (SearchFilterActions* self);
void search_filter_actions_set_sensitive_for_search_criteria (SearchFilterActions* self,
                                                              SearchFilterCriteria criteria);
static void search_filter_actions_update_sensitivities (SearchFilterActions* self);
GType page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Page, g_object_unref)
void search_filter_actions_monitor_page_contents (SearchFilterActions* self,
                                                  Page* old_page,
                                                  Page* new_page);
GType checkerboard_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CheckerboardPage, g_object_unref)
gpointer core_tracker_ref (gpointer instance);
void core_tracker_unref (gpointer instance);
GParamSpec* core_param_spec_tracker (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
void core_value_set_tracker (GValue* value,
                             gpointer v_object);
void core_value_take_tracker (GValue* value,
                              gpointer v_object);
gpointer core_value_get_tracker (const GValue* value);
GType core_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CoreTracker, core_tracker_unref)
GType core_view_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CoreViewTracker, core_tracker_unref)
CoreViewTracker* checkerboard_page_get_view_tracker (CheckerboardPage* self);
GType media_view_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaViewTracker, core_tracker_unref)
static void search_filter_actions_on_media_tracker_updated (SearchFilterActions* self,
                                                     CoreTracker* t);
static void _search_filter_actions_on_media_tracker_updated_core_tracker_updated (CoreTracker* _sender,
                                                                           gpointer self);
GType camera_view_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraViewTracker, core_tracker_unref)
static void search_filter_actions_on_camera_tracker_updated (SearchFilterActions* self,
                                                      CoreTracker* t);
static void _search_filter_actions_on_camera_tracker_updated_core_tracker_updated (CoreTracker* _sender,
                                                                            gpointer self);
GType media_accumulator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaAccumulator, g_object_unref)
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Alteration, alteration_unref)
GType core_tracker_accumulator_get_type (void) G_GNUC_CONST ;
GType camera_accumulator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraAccumulator, g_object_unref)
gint camera_accumulator_get_photos (CameraAccumulator* self);
gint camera_accumulator_get_videos (CameraAccumulator* self);
gint camera_accumulator_get_raw (CameraAccumulator* self);
static gboolean _variant_get3 (GVariant* value);
static GVariant* _variant_new35 (gboolean value);
gboolean search_filter_actions_get_has_photos (SearchFilterActions* self);
gboolean search_filter_actions_get_has_videos (SearchFilterActions* self);
gboolean search_filter_actions_get_has_raw (SearchFilterActions* self);
gboolean search_filter_actions_get_has_flagged (SearchFilterActions* self);
static void g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN (GClosure * closure,
                                                                    GValue * return_value,
                                                                    guint n_param_values,
                                                                    const GValue * param_values,
                                                                    gpointer invocation_hint,
                                                                    gpointer marshal_data);
static void search_filter_actions_finalize (SearchFilterActions * obj);
static GType search_filter_actions_get_type_once (void);
GType search_filter_toolbar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbar, g_object_unref)
GType search_filter_toolbar_search_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarSearchBox, g_object_unref)
GType search_filter_toolbar_rating_filter_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarRatingFilterButton, g_object_unref)
GType search_filter_toolbar_saved_search_filter_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarSavedSearchFilterButton, g_object_unref)
static GType search_filter_toolbar_label_tool_item_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarLabelToolItem, g_object_unref)
static GType search_filter_toolbar_toggle_action_tool_button_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarToggleActionToolButton, g_object_unref)
static void search_filter_toolbar_on_media_context_changed (SearchFilterToolbar* self,
                                                     gboolean has_photos,
                                                     gboolean has_videos,
                                                     gboolean has_raw,
                                                     gboolean has_flagged);
static void _search_filter_toolbar_on_media_context_changed_search_filter_actions_media_context_changed (SearchFilterActions* _sender,
                                                                                                  gboolean has_photos,
                                                                                                  gboolean has_videos,
                                                                                                  gboolean has_raw,
                                                                                                  gboolean has_flagged,
                                                                                                  gpointer self);
static void search_filter_toolbar_on_flagged_toggled (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_flagged_toggled_search_filter_actions_flagged_toggled (SearchFilterActions* _sender,
                                                                                      gboolean on,
                                                                                      gpointer self);
static void search_filter_toolbar_on_photos_toggled (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_photos_toggled_search_filter_actions_photos_toggled (SearchFilterActions* _sender,
                                                                                    gboolean on,
                                                                                    gpointer self);
static void search_filter_toolbar_on_videos_toggled (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_videos_toggled_search_filter_actions_videos_toggled (SearchFilterActions* _sender,
                                                                                    gboolean on,
                                                                                    gpointer self);
static void search_filter_toolbar_on_raw_toggled (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_raw_toggled_search_filter_actions_raw_toggled (SearchFilterActions* _sender,
                                                                              gboolean on,
                                                                              gpointer self);
static void search_filter_toolbar_on_rating_changed (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_rating_changed_search_filter_actions_rating_changed (SearchFilterActions* _sender,
                                                                                    RatingFilter filter,
                                                                                    gpointer self);
static void search_filter_toolbar_on_search_text_changed (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_search_text_changed_search_filter_actions_text_changed (SearchFilterActions* _sender,
                                                                                       const gchar* text,
                                                                                       gpointer self);
static void search_filter_toolbar_on_criteria_changed (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_criteria_changed_search_filter_actions_criteria_changed (SearchFilterActions* _sender,
                                                                                        gpointer self);
static gboolean search_filter_toolbar_on_context_menu_requested (SearchFilterToolbar* self,
                                                          gint x,
                                                          gint y,
                                                          gint button);
static gboolean _search_filter_toolbar_on_context_menu_requested_gtk_toolbar_popup_context_menu (GtkToolbar* _sender,
                                                                                          gint x,
                                                                                          gint y,
                                                                                          gint button_number,
                                                                                          gpointer self);
#define SEARCH_FILTER_TOOLBAR_FILTER_BUTTON_MARGIN 12
#define SEARCH_FILTER_TOOLBAR_FILTER_ICON_STAR_SCALE 0.65f
#define SEARCH_FILTER_TOOLBAR_FILTER_ICON_SCALE 0.75f
#define SEARCH_FILTER_TOOLBAR_FILTER_ICON_BASE_WIDTH 30
#define SEARCH_FILTER_TOOLBAR_FILTER_ICON_PLUS_WIDTH 20
SearchFilterToolbarSavedSearchFilterButton* search_filter_toolbar_saved_search_filter_button_new (void);
SearchFilterToolbarSavedSearchFilterButton* search_filter_toolbar_saved_search_filter_button_construct (GType object_type);
SearchFilterToolbar* search_filter_toolbar_new (SearchFilterActions* actions);
SearchFilterToolbar* search_filter_toolbar_construct (GType object_type,
                                                      SearchFilterActions* actions);
SearchFilterToolbarSearchBox* search_filter_toolbar_search_box_new (TextAction* action);
SearchFilterToolbarSearchBox* search_filter_toolbar_search_box_construct (GType object_type,
                                                                          TextAction* action);
gchar* resources_get_ui (const gchar* filename);
void app_window_panic (const gchar* msg);
static void search_filter_toolbar_on_context_menu_close_chosen (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_context_menu_close_chosen_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                                 gpointer self);
static SearchFilterToolbarLabelToolItem* search_filter_toolbar_label_tool_item_new (const gchar* s,
                                                                             gint left_padding,
                                                                             gint right_padding);
static SearchFilterToolbarLabelToolItem* search_filter_toolbar_label_tool_item_construct (GType object_type,
                                                                                   const gchar* s,
                                                                                   gint left_padding,
                                                                                   gint right_padding);
static SearchFilterToolbarToggleActionToolButton* search_filter_toolbar_toggle_action_tool_button_new (const gchar* action);
static SearchFilterToolbarToggleActionToolButton* search_filter_toolbar_toggle_action_tool_button_construct (GType object_type,
                                                                                                      const gchar* action);
static void search_filter_toolbar_toggle_action_tool_button_set_label (SearchFilterToolbarToggleActionToolButton* self,
                                                                const gchar* label);
SearchFilterToolbarRatingFilterButton* search_filter_toolbar_rating_filter_button_new (GMenuModel* model);
SearchFilterToolbarRatingFilterButton* search_filter_toolbar_rating_filter_button_construct (GType object_type,
                                                                                             GMenuModel* model);
void search_filter_toolbar_rating_filter_button_set_label (SearchFilterToolbarRatingFilterButton* self,
                                                           const gchar* label);
void search_filter_toolbar_saved_search_filter_button_set_label (SearchFilterToolbarSavedSearchFilterButton* self,
                                                                 const gchar* label);
static void search_filter_toolbar_on_saved_search_button_clicked (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_saved_search_button_clicked_search_filter_toolbar_saved_search_filter_button_clicked (SearchFilterToolbarSavedSearchFilterButton* _sender,
                                                                                                                     gpointer self);
static void search_filter_toolbar_toggle_action_tool_button_set_icon_name (SearchFilterToolbarToggleActionToolButton* self,
                                                                    const gchar* icon_name);
LibraryWindow* library_window_get_app (void);
static GVariant* _variant_new36 (gboolean value);
void search_filter_toolbar_update (SearchFilterToolbar* self);
static GVariant* _variant_new37 (gboolean value);
void search_filter_toolbar_set_view_filter (SearchFilterToolbar* self,
                                            SearchViewFilter* search_filter);
void search_filter_toolbar_unset_view_filter (SearchFilterToolbar* self);
void library_window_show_search_bar (LibraryWindow* self,
                                     gboolean display);
void search_filter_toolbar_rating_filter_button_set_filter_icon (SearchFilterToolbarRatingFilterButton* self,
                                                                 RatingFilter filter);
static void search_filter_toolbar_on_savedsearch_selected (SearchFilterToolbar* self,
                                                    SavedSearch* saved_search);
static void search_filter_toolbar_disable_savedsearch (SearchFilterToolbar* self);
static void search_filter_toolbar_edit_dialog (SearchFilterToolbar* self,
                                        SavedSearch* search);
gpointer search_filter_toolbar_saved_search_popover_ref (gpointer instance);
void search_filter_toolbar_saved_search_popover_unref (gpointer instance);
GParamSpec* search_filter_toolbar_param_spec_saved_search_popover (const gchar* name,
                                                                   const gchar* nick,
                                                                   const gchar* blurb,
                                                                   GType object_type,
                                                                   GParamFlags flags);
void search_filter_toolbar_value_set_saved_search_popover (GValue* value,
                                                           gpointer v_object);
void search_filter_toolbar_value_take_saved_search_popover (GValue* value,
                                                            gpointer v_object);
gpointer search_filter_toolbar_value_get_saved_search_popover (const GValue* value);
GType search_filter_toolbar_saved_search_popover_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarSavedSearchPopover, search_filter_toolbar_saved_search_popover_unref)
void search_filter_toolbar_saved_search_popover_hide (SearchFilterToolbarSavedSearchPopover* self);
GType saved_search_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SavedSearchDialog, g_object_unref)
SavedSearchDialog* saved_search_dialog_new_edit_existing (SavedSearch* saved_search);
SavedSearchDialog* saved_search_dialog_construct_edit_existing (GType object_type,
                                                                SavedSearch* saved_search);
void saved_search_dialog_show (SavedSearchDialog* self);
static void search_filter_toolbar_delete_dialog (SearchFilterToolbar* self,
                                          SavedSearch* search);
gboolean dialogs_confirm_delete_saved_search (SavedSearch* search);
gpointer command_manager_ref (gpointer instance);
void command_manager_unref (gpointer instance);
GParamSpec* param_spec_command_manager (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_command_manager (GValue* value,
                                gpointer v_object);
void value_take_command_manager (GValue* value,
                                 gpointer v_object);
gpointer value_get_command_manager (const GValue* value);
GType command_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CommandManager, command_manager_unref)
CommandManager* app_window_get_command_manager (void);
GType command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Command, g_object_unref)
void command_manager_execute (CommandManager* self,
                              Command* command);
DeleteSavedSearchCommand* delete_saved_search_command_new (SavedSearch* search);
DeleteSavedSearchCommand* delete_saved_search_command_construct (GType object_type,
                                                                 SavedSearch* search);
GType page_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageCommand, g_object_unref)
GType single_data_source_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SingleDataSourceCommand, g_object_unref)
GType delete_saved_search_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DeleteSavedSearchCommand, g_object_unref)
static void search_filter_toolbar_add_dialog (SearchFilterToolbar* self);
SavedSearchDialog* saved_search_dialog_new (void);
SavedSearchDialog* saved_search_dialog_construct (GType object_type);
static void search_filter_toolbar_on_popover_closed (SearchFilterToolbar* self);
void search_filter_toolbar_saved_search_filter_button_set_active (SearchFilterToolbarSavedSearchFilterButton* self,
                                                                  gboolean active);
static void _search_filter_toolbar_edit_dialog_search_filter_toolbar_saved_search_popover_edit_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                 SavedSearch* search,
                                                                                                 gpointer self);
static void _search_filter_toolbar_on_savedsearch_selected_search_filter_toolbar_saved_search_popover_search_activated (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                                 SavedSearch* search,
                                                                                                                 gpointer self);
static void _search_filter_toolbar_delete_dialog_search_filter_toolbar_saved_search_popover_delete_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                     SavedSearch* search,
                                                                                                     gpointer self);
static void _search_filter_toolbar_add_dialog_search_filter_toolbar_saved_search_popover_add_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                               gpointer self);
static void _search_filter_toolbar_on_popover_closed_search_filter_toolbar_saved_search_popover_closed (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                 gpointer self);
SearchFilterToolbarSavedSearchPopover* search_filter_toolbar_saved_search_popover_new (GtkWidget* relative_to);
SearchFilterToolbarSavedSearchPopover* search_filter_toolbar_saved_search_popover_construct (GType object_type,
                                                                                             GtkWidget* relative_to);
void search_filter_toolbar_saved_search_popover_show_all (SearchFilterToolbarSavedSearchPopover* self);
void search_filter_toolbar_take_focus (SearchFilterToolbar* self);
void search_filter_toolbar_search_box_get_focus (SearchFilterToolbarSearchBox* self);
static void search_filter_toolbar_label_tool_item_finalize (GObject * obj);
static GType search_filter_toolbar_label_tool_item_get_type_once (void);
static void search_filter_toolbar_toggle_action_tool_button_finalize (GObject * obj);
static GType search_filter_toolbar_toggle_action_tool_button_get_type_once (void);
static void search_filter_toolbar_search_box_on_action_text_changed (SearchFilterToolbarSearchBox* self,
                                                              const gchar* text);
static void _search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed (TextAction* _sender,
                                                                                        const gchar* text,
                                                                                        gpointer self);
static void search_filter_toolbar_search_box_on_sensitivity_changed (SearchFilterToolbarSearchBox* self,
                                                              gboolean sensitive);
static void _search_filter_toolbar_search_box_on_sensitivity_changed_text_action_sensitivity_changed (TextAction* _sender,
                                                                                               gboolean sensitive,
                                                                                               gpointer self);
static void search_filter_toolbar_search_box_on_visibility_changed (SearchFilterToolbarSearchBox* self,
                                                             gboolean visible);
static void _search_filter_toolbar_search_box_on_visibility_changed_text_action_visibility_changed (TextAction* _sender,
                                                                                             gboolean visible,
                                                                                             gpointer self);
static void search_filter_toolbar_search_box_on_entry_changed (SearchFilterToolbarSearchBox* self);
static void _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text (GtkEntryBuffer* _sender,
                                                                                       guint position,
                                                                                       guint n_chars,
                                                                                       gpointer self);
static void _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text (GtkEntryBuffer* _sender,
                                                                                        guint position,
                                                                                        const gchar* chars,
                                                                                        guint n_chars,
                                                                                        gpointer self);
static gboolean search_filter_toolbar_search_box_on_escape_key (SearchFilterToolbarSearchBox* self,
                                                         GdkEventKey* e);
static gboolean _search_filter_toolbar_search_box_on_escape_key_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                     GdkEventKey* event,
                                                                                     gpointer self);
static void search_filter_toolbar_search_box_set_nullable_text (SearchFilterToolbarSearchBox* self,
                                                         const gchar* text);
static void search_filter_toolbar_search_box_finalize (GObject * obj);
static GType search_filter_toolbar_search_box_get_type_once (void);
static GtkWidget* search_filter_toolbar_rating_filter_button_get_filter_icon (SearchFilterToolbarRatingFilterButton* self,
                                                                       RatingFilter filter);
static gint search_filter_toolbar_rating_filter_button_get_filter_icon_size (SearchFilterToolbarRatingFilterButton* self,
                                                                      RatingFilter filter);
#define RESOURCES_ICON_FILTER_REJECTED_OR_BETTER_FIXED_SIZE 32
#define RESOURCES_ICON_FILTER_UNRATED_OR_BETTER_FIXED_SIZE 16
static gint search_filter_toolbar_rating_filter_button_get_filter_button_size (SearchFilterToolbarRatingFilterButton* self,
                                                                        RatingFilter filter);
gchar* resources_get_rating_filter_tooltip (RatingFilter filter);
static void search_filter_toolbar_rating_filter_button_finalize (GObject * obj);
static GType search_filter_toolbar_rating_filter_button_get_type_once (void);
static void search_filter_toolbar_saved_search_filter_button_on_clicked (SearchFilterToolbarSavedSearchFilterButton* self);
static void _search_filter_toolbar_saved_search_filter_button_on_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                      gpointer self);
void search_filter_toolbar_saved_search_filter_button_restyle (SearchFilterToolbarSavedSearchFilterButton* self);
static void search_filter_toolbar_saved_search_filter_button_finalize (GObject * obj);
static GType search_filter_toolbar_saved_search_filter_button_get_type_once (void);
static GType search_filter_toolbar_saved_search_popover_data_button_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarSavedSearchPopoverDataButton, g_object_unref)
static void search_filter_toolbar_saved_search_popover_on_edit_click (SearchFilterToolbarSavedSearchPopover* self,
                                                               SavedSearch* search);
static void _search_filter_toolbar_saved_search_popover_on_edit_click_search_filter_toolbar_saved_search_popover_data_button_clicked (SearchFilterToolbarSavedSearchPopoverDataButton* _sender,
                                                                                                                               SavedSearch* search,
                                                                                                                               gpointer self);
static void search_filter_toolbar_saved_search_popover_on_delete_click (SearchFilterToolbarSavedSearchPopover* self,
                                                                 SavedSearch* search);
static void _search_filter_toolbar_saved_search_popover_on_delete_click_search_filter_toolbar_saved_search_popover_data_button_clicked (SearchFilterToolbarSavedSearchPopoverDataButton* _sender,
                                                                                                                                 SavedSearch* search,
                                                                                                                                 gpointer self);
static void search_filter_toolbar_saved_search_popover_on_add_click (SearchFilterToolbarSavedSearchPopover* self);
static void _search_filter_toolbar_saved_search_popover_on_add_click_gtk_button_clicked (GtkButton* _sender,
                                                                                  gpointer self);
static void search_filter_toolbar_saved_search_popover_on_activate_row (SearchFilterToolbarSavedSearchPopover* self,
                                                                 GtkListBoxRow* row);
static void _search_filter_toolbar_saved_search_popover_on_activate_row_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                                             GtkListBoxRow* row,
                                                                                             gpointer self);
static void search_filter_toolbar_saved_search_popover_on_popover_closed (SearchFilterToolbarSavedSearchPopover* self);
static void _search_filter_toolbar_saved_search_popover_on_popover_closed_gtk_popover_closed (GtkPopover* _sender,
                                                                                       gpointer self);
gpointer saved_search_table_ref (gpointer instance);
void saved_search_table_unref (gpointer instance);
GParamSpec* param_spec_saved_search_table (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_saved_search_table (GValue* value,
                                   gpointer v_object);
void value_take_saved_search_table (GValue* value,
                                    gpointer v_object);
gpointer value_get_saved_search_table (const GValue* value);
GType saved_search_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SavedSearchTable, saved_search_table_unref)
SavedSearchTable* saved_search_table_get_instance (void);
GeeCollection* saved_search_table_get_all (SavedSearchTable* self);
gchar* data_object_get_name (DataObject* self);
static SearchFilterToolbarSavedSearchPopoverDataButton* search_filter_toolbar_saved_search_popover_data_button_new (SavedSearch* search,
                                                                                                             const gchar* name);
static SearchFilterToolbarSavedSearchPopoverDataButton* search_filter_toolbar_saved_search_popover_data_button_construct (GType object_type,
                                                                                                                   SavedSearch* search,
                                                                                                                   const gchar* name);
static void _vala_array_add130 (SearchFilterToolbarSavedSearchPopoverDataButton** * array,
                         gint* length,
                         gint* size,
                         SearchFilterToolbarSavedSearchPopoverDataButton* value);
static void _vala_array_add131 (SearchFilterToolbarSavedSearchPopoverDataButton** * array,
                         gint* length,
                         gint* size,
                         SearchFilterToolbarSavedSearchPopoverDataButton* value);
void search_filter_toolbar_saved_search_popover_restyle (SearchFilterToolbarSavedSearchPopover* self);
static void search_filter_toolbar_saved_search_popover_data_button_restyle (SearchFilterToolbarSavedSearchPopoverDataButton* self);
static gboolean search_filter_toolbar_saved_search_popover_is_search_row (SearchFilterToolbarSavedSearchPopover* self,
                                                                   GtkListBoxRow* row);
static SavedSearch* search_filter_toolbar_saved_search_popover_get_search (SearchFilterToolbarSavedSearchPopover* self,
                                                                    GtkListBoxRow* row);
static SavedSearch* search_filter_toolbar_saved_search_popover_data_button_get_search (SearchFilterToolbarSavedSearchPopoverDataButton* self);
static void search_filter_toolbar_saved_search_popover_data_button_on_click (SearchFilterToolbarSavedSearchPopoverDataButton* self);
static void _search_filter_toolbar_saved_search_popover_data_button_on_click_gtk_button_clicked (GtkButton* _sender,
                                                                                          gpointer self);
static void search_filter_toolbar_saved_search_popover_data_button_set_search (SearchFilterToolbarSavedSearchPopoverDataButton* self,
                                                                        SavedSearch* value);
static void search_filter_toolbar_saved_search_popover_data_button_finalize (GObject * obj);
static GType search_filter_toolbar_saved_search_popover_data_button_get_type_once (void);
static void _vala_search_filter_toolbar_saved_search_popover_data_button_get_property (GObject * object,
                                                                                guint property_id,
                                                                                GValue * value,
                                                                                GParamSpec * pspec);
static void _vala_search_filter_toolbar_saved_search_popover_data_button_set_property (GObject * object,
                                                                                guint property_id,
                                                                                const GValue * value,
                                                                                GParamSpec * pspec);
static void search_filter_toolbar_saved_search_popover_finalize (SearchFilterToolbarSavedSearchPopover * obj);
static GType search_filter_toolbar_saved_search_popover_get_type_once (void);
static void search_filter_toolbar_finalize (GObject * obj);
static GType search_filter_toolbar_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry SEARCH_FILTER_ACTIONS_entries[5] = {{"display.rating", _search_filter_actions_on_action_radio_gsimple_action_activate_callback, "s", "'2'", _search_filter_actions_on_rating_changed_gsimple_action_change_state_callback}, {"display.flagged", _search_filter_actions_on_action_toggle_gsimple_action_activate_callback, NULL, "false", _search_filter_actions_on_flagged_toggled_gsimple_action_change_state_callback}, {"display.photos", _search_filter_actions_on_action_toggle_gsimple_action_activate_callback, NULL, "false", _search_filter_actions_on_photos_toggled_gsimple_action_change_state_callback}, {"display.videos", _search_filter_actions_on_action_toggle_gsimple_action_activate_callback, NULL, "false", _search_filter_actions_on_videos_toggled_gsimple_action_change_state_callback}, {"display.raw", _search_filter_actions_on_action_toggle_gsimple_action_activate_callback, NULL, "false", _search_filter_actions_on_raw_toggled_gsimple_action_change_state_callback}};

static GType
search_filter_criteria_get_type_once (void)
{
	static const GFlagsValue values[] = {{SEARCH_FILTER_CRITERIA_NONE, "SEARCH_FILTER_CRITERIA_NONE", "none"}, {SEARCH_FILTER_CRITERIA_RECURSIVE, "SEARCH_FILTER_CRITERIA_RECURSIVE", "recursive"}, {SEARCH_FILTER_CRITERIA_TEXT, "SEARCH_FILTER_CRITERIA_TEXT", "text"}, {SEARCH_FILTER_CRITERIA_FLAG, "SEARCH_FILTER_CRITERIA_FLAG", "flag"}, {SEARCH_FILTER_CRITERIA_MEDIA, "SEARCH_FILTER_CRITERIA_MEDIA", "media"}, {SEARCH_FILTER_CRITERIA_RATING, "SEARCH_FILTER_CRITERIA_RATING", "rating"}, {SEARCH_FILTER_CRITERIA_SAVEDSEARCH, "SEARCH_FILTER_CRITERIA_SAVEDSEARCH", "savedsearch"}, {SEARCH_FILTER_CRITERIA_ALL, "SEARCH_FILTER_CRITERIA_ALL", "all"}, {0, NULL, NULL}};
	GType search_filter_criteria_type_id;
	search_filter_criteria_type_id = g_flags_register_static ("SearchFilterCriteria", values);
	return search_filter_criteria_type_id;
}

GType
search_filter_criteria_get_type (void)
{
	static volatile gsize search_filter_criteria_type_id__volatile = 0;
	if (g_once_init_enter (&search_filter_criteria_type_id__volatile)) {
		GType search_filter_criteria_type_id;
		search_filter_criteria_type_id = search_filter_criteria_get_type_once ();
		g_once_init_leave (&search_filter_criteria_type_id__volatile, search_filter_criteria_type_id);
	}
	return search_filter_criteria_type_id__volatile;
}

static GType
rating_filter_get_type_once (void)
{
	static const GEnumValue values[] = {{RATING_FILTER_NO_FILTER, "RATING_FILTER_NO_FILTER", "no-filter"}, {RATING_FILTER_REJECTED_OR_HIGHER, "RATING_FILTER_REJECTED_OR_HIGHER", "rejected-or-higher"}, {RATING_FILTER_UNRATED_OR_HIGHER, "RATING_FILTER_UNRATED_OR_HIGHER", "unrated-or-higher"}, {RATING_FILTER_ONE_OR_HIGHER, "RATING_FILTER_ONE_OR_HIGHER", "one-or-higher"}, {RATING_FILTER_TWO_OR_HIGHER, "RATING_FILTER_TWO_OR_HIGHER", "two-or-higher"}, {RATING_FILTER_THREE_OR_HIGHER, "RATING_FILTER_THREE_OR_HIGHER", "three-or-higher"}, {RATING_FILTER_FOUR_OR_HIGHER, "RATING_FILTER_FOUR_OR_HIGHER", "four-or-higher"}, {RATING_FILTER_FIVE_OR_HIGHER, "RATING_FILTER_FIVE_OR_HIGHER", "five-or-higher"}, {RATING_FILTER_REJECTED_ONLY, "RATING_FILTER_REJECTED_ONLY", "rejected-only"}, {RATING_FILTER_UNRATED_ONLY, "RATING_FILTER_UNRATED_ONLY", "unrated-only"}, {RATING_FILTER_ONE_ONLY, "RATING_FILTER_ONE_ONLY", "one-only"}, {RATING_FILTER_TWO_ONLY, "RATING_FILTER_TWO_ONLY", "two-only"}, {RATING_FILTER_THREE_ONLY, "RATING_FILTER_THREE_ONLY", "three-only"}, {RATING_FILTER_FOUR_ONLY, "RATING_FILTER_FOUR_ONLY", "four-only"}, {RATING_FILTER_FIVE_ONLY, "RATING_FILTER_FIVE_ONLY", "five-only"}, {0, NULL, NULL}};
	GType rating_filter_type_id;
	rating_filter_type_id = g_enum_register_static ("RatingFilter", values);
	return rating_filter_type_id;
}

GType
rating_filter_get_type (void)
{
	static volatile gsize rating_filter_type_id__volatile = 0;
	if (g_once_init_enter (&rating_filter_type_id__volatile)) {
		GType rating_filter_type_id;
		rating_filter_type_id = rating_filter_get_type_once ();
		g_once_init_leave (&rating_filter_type_id__volatile, rating_filter_type_id);
	}
	return rating_filter_type_id__volatile;
}

static inline gpointer
search_view_filter_get_instance_private (SearchViewFilter* self)
{
	return G_STRUCT_MEMBER_P (self, SearchViewFilter_private_offset);
}

static guint
search_view_filter_real_get_criteria (SearchViewFilter* self)
{
	guint _tmp0_ = 0U;
#line 65 "../src/SearchFilter.vala"
	g_critical ("Type `%s' does not implement abstract method `search_view_filter_get_criteria'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 65 "../src/SearchFilter.vala"
	return _tmp0_;
#line 1851 "SearchFilter.c"
}

guint
search_view_filter_get_criteria (SearchViewFilter* self)
{
	SearchViewFilterClass* _klass_;
#line 65 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), 0U);
#line 65 "../src/SearchFilter.vala"
	_klass_ = SEARCH_VIEW_FILTER_GET_CLASS (self);
#line 65 "../src/SearchFilter.vala"
	if (_klass_->get_criteria) {
#line 65 "../src/SearchFilter.vala"
		return _klass_->get_criteria (self);
#line 1866 "SearchFilter.c"
	}
#line 65 "../src/SearchFilter.vala"
	return 0U;
#line 1870 "SearchFilter.c"
}

void
search_view_filter_set_rating_filter (SearchViewFilter* self,
                                      RatingFilter rf)
{
#line 67 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
#line 68 "../src/SearchFilter.vala"
	self->priv->rating_filter = rf;
#line 69 "../src/SearchFilter.vala"
	switch (self->priv->rating_filter) {
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_REJECTED_ONLY:
#line 1885 "SearchFilter.c"
		{
#line 71 "../src/SearchFilter.vala"
			self->priv->rating = RATING_REJECTED;
#line 72 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = FALSE;
#line 73 "../src/SearchFilter.vala"
			break;
#line 1893 "SearchFilter.c"
		}
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_REJECTED_OR_HIGHER:
#line 1897 "SearchFilter.c"
		{
#line 76 "../src/SearchFilter.vala"
			self->priv->rating = RATING_REJECTED;
#line 77 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = TRUE;
#line 78 "../src/SearchFilter.vala"
			break;
#line 1905 "SearchFilter.c"
		}
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_ONE_OR_HIGHER:
#line 1909 "SearchFilter.c"
		{
#line 81 "../src/SearchFilter.vala"
			self->priv->rating = RATING_ONE;
#line 82 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = TRUE;
#line 83 "../src/SearchFilter.vala"
			break;
#line 1917 "SearchFilter.c"
		}
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_ONE_ONLY:
#line 1921 "SearchFilter.c"
		{
#line 86 "../src/SearchFilter.vala"
			self->priv->rating = RATING_ONE;
#line 87 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = FALSE;
#line 88 "../src/SearchFilter.vala"
			break;
#line 1929 "SearchFilter.c"
		}
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_TWO_OR_HIGHER:
#line 1933 "SearchFilter.c"
		{
#line 91 "../src/SearchFilter.vala"
			self->priv->rating = RATING_TWO;
#line 92 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = TRUE;
#line 93 "../src/SearchFilter.vala"
			break;
#line 1941 "SearchFilter.c"
		}
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_TWO_ONLY:
#line 1945 "SearchFilter.c"
		{
#line 96 "../src/SearchFilter.vala"
			self->priv->rating = RATING_TWO;
#line 97 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = FALSE;
#line 98 "../src/SearchFilter.vala"
			break;
#line 1953 "SearchFilter.c"
		}
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_THREE_OR_HIGHER:
#line 1957 "SearchFilter.c"
		{
#line 101 "../src/SearchFilter.vala"
			self->priv->rating = RATING_THREE;
#line 102 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = TRUE;
#line 103 "../src/SearchFilter.vala"
			break;
#line 1965 "SearchFilter.c"
		}
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_THREE_ONLY:
#line 1969 "SearchFilter.c"
		{
#line 106 "../src/SearchFilter.vala"
			self->priv->rating = RATING_THREE;
#line 107 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = FALSE;
#line 108 "../src/SearchFilter.vala"
			break;
#line 1977 "SearchFilter.c"
		}
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_FOUR_OR_HIGHER:
#line 1981 "SearchFilter.c"
		{
#line 111 "../src/SearchFilter.vala"
			self->priv->rating = RATING_FOUR;
#line 112 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = TRUE;
#line 113 "../src/SearchFilter.vala"
			break;
#line 1989 "SearchFilter.c"
		}
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_FOUR_ONLY:
#line 1993 "SearchFilter.c"
		{
#line 116 "../src/SearchFilter.vala"
			self->priv->rating = RATING_FOUR;
#line 117 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = FALSE;
#line 118 "../src/SearchFilter.vala"
			break;
#line 2001 "SearchFilter.c"
		}
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_FIVE_OR_HIGHER:
#line 2005 "SearchFilter.c"
		{
#line 121 "../src/SearchFilter.vala"
			self->priv->rating = RATING_FIVE;
#line 122 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = TRUE;
#line 123 "../src/SearchFilter.vala"
			break;
#line 2013 "SearchFilter.c"
		}
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_FIVE_ONLY:
#line 2017 "SearchFilter.c"
		{
#line 126 "../src/SearchFilter.vala"
			self->priv->rating = RATING_FIVE;
#line 127 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = FALSE;
#line 128 "../src/SearchFilter.vala"
			break;
#line 2025 "SearchFilter.c"
		}
		default:
#line 69 "../src/SearchFilter.vala"
		case RATING_FILTER_UNRATED_OR_HIGHER:
#line 2030 "SearchFilter.c"
		{
#line 132 "../src/SearchFilter.vala"
			self->priv->rating = RATING_UNRATED;
#line 133 "../src/SearchFilter.vala"
			self->priv->rating_allow_higher = TRUE;
#line 134 "../src/SearchFilter.vala"
			break;
#line 2038 "SearchFilter.c"
		}
	}
}

gboolean
search_view_filter_has_search_filter (SearchViewFilter* self)
{
	const gchar* _tmp0_;
	gboolean result = FALSE;
#line 138 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
#line 139 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_filter;
#line 139 "../src/SearchFilter.vala"
	result = !is_string_empty (_tmp0_);
#line 139 "../src/SearchFilter.vala"
	return result;
#line 2056 "SearchFilter.c"
}

const gchar*
search_view_filter_get_search_filter (SearchViewFilter* self)
{
	const gchar* _tmp0_;
	const gchar* result = NULL;
#line 142 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), NULL);
#line 143 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_filter;
#line 143 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 143 "../src/SearchFilter.vala"
	return result;
#line 2072 "SearchFilter.c"
}

gchar**
search_view_filter_get_search_filter_words (SearchViewFilter* self,
                                            gint* result_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** result = NULL;
#line 146 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), NULL);
#line 147 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_filter_words;
#line 147 "../src/SearchFilter.vala"
	_tmp0__length1 = self->priv->search_filter_words_length1;
#line 147 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_;
#line 147 "../src/SearchFilter.vala"
	_tmp1__length1 = _tmp0__length1;
#line 147 "../src/SearchFilter.vala"
	if (result_length1) {
#line 147 "../src/SearchFilter.vala"
		*result_length1 = _tmp1__length1;
#line 2098 "SearchFilter.c"
	}
#line 147 "../src/SearchFilter.vala"
	result = _tmp1_;
#line 147 "../src/SearchFilter.vala"
	return result;
#line 2104 "SearchFilter.c"
}

static gchar**
_vala_array_dup30 (gchar** self,
                   gint length)
{
#line 152 "../src/SearchFilter.vala"
	if (length >= 0) {
#line 2113 "SearchFilter.c"
		gchar** result;
		gint i;
#line 152 "../src/SearchFilter.vala"
		result = g_new0 (gchar*, length + 1);
#line 152 "../src/SearchFilter.vala"
		for (i = 0; i < length; i++) {
#line 2120 "SearchFilter.c"
			gchar* _tmp0_;
#line 152 "../src/SearchFilter.vala"
			_tmp0_ = g_strdup (self[i]);
#line 152 "../src/SearchFilter.vala"
			result[i] = _tmp0_;
#line 2126 "SearchFilter.c"
		}
#line 152 "../src/SearchFilter.vala"
		return result;
#line 2130 "SearchFilter.c"
	}
#line 152 "../src/SearchFilter.vala"
	return NULL;
#line 2134 "SearchFilter.c"
}

void
search_view_filter_set_search_filter (SearchViewFilter* self,
                                      const gchar* text)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp4_;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint __tmp5__size_ = 0;
	const gchar* _tmp6_;
	gchar** _tmp10_;
	gint _tmp10__length1;
#line 150 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
#line 151 "../src/SearchFilter.vala"
	if (!is_string_empty (text)) {
#line 2153 "SearchFilter.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 151 "../src/SearchFilter.vala"
		_tmp1_ = g_utf8_strdown (text, (gssize) -1);
#line 151 "../src/SearchFilter.vala"
		_tmp2_ = _tmp1_;
#line 151 "../src/SearchFilter.vala"
		_tmp3_ = string_remove_diacritics (_tmp2_);
#line 151 "../src/SearchFilter.vala"
		_g_free0 (_tmp0_);
#line 151 "../src/SearchFilter.vala"
		_tmp0_ = _tmp3_;
#line 151 "../src/SearchFilter.vala"
		_g_free0 (_tmp2_);
#line 2169 "SearchFilter.c"
	} else {
#line 151 "../src/SearchFilter.vala"
		_g_free0 (_tmp0_);
#line 151 "../src/SearchFilter.vala"
		_tmp0_ = NULL;
#line 2175 "SearchFilter.c"
	}
#line 151 "../src/SearchFilter.vala"
	_tmp4_ = g_strdup (_tmp0_);
#line 151 "../src/SearchFilter.vala"
	_g_free0 (self->priv->search_filter);
#line 151 "../src/SearchFilter.vala"
	self->priv->search_filter = _tmp4_;
#line 152 "../src/SearchFilter.vala"
	_tmp6_ = self->priv->search_filter;
#line 152 "../src/SearchFilter.vala"
	if (_tmp6_ != NULL) {
#line 2187 "SearchFilter.c"
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
#line 152 "../src/SearchFilter.vala"
		_tmp7_ = self->priv->search_filter;
#line 152 "../src/SearchFilter.vala"
		_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, " ", 0);
#line 152 "../src/SearchFilter.vala"
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 152 "../src/SearchFilter.vala"
		_tmp5_ = _tmp9_;
#line 152 "../src/SearchFilter.vala"
		_tmp5__length1 = _vala_array_length (_tmp8_);
#line 152 "../src/SearchFilter.vala"
		__tmp5__size_ = _tmp5__length1;
#line 2203 "SearchFilter.c"
	} else {
#line 152 "../src/SearchFilter.vala"
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 152 "../src/SearchFilter.vala"
		_tmp5_ = NULL;
#line 152 "../src/SearchFilter.vala"
		_tmp5__length1 = 0;
#line 152 "../src/SearchFilter.vala"
		__tmp5__size_ = _tmp5__length1;
#line 2213 "SearchFilter.c"
	}
#line 152 "../src/SearchFilter.vala"
	_tmp10_ = (_tmp5_ != NULL) ? _vala_array_dup30 (_tmp5_, _tmp5__length1) : _tmp5_;
#line 152 "../src/SearchFilter.vala"
	_tmp10__length1 = _tmp5__length1;
#line 152 "../src/SearchFilter.vala"
	self->priv->search_filter_words = (_vala_array_free (self->priv->search_filter_words, self->priv->search_filter_words_length1, (GDestroyNotify) g_free), NULL);
#line 152 "../src/SearchFilter.vala"
	self->priv->search_filter_words = _tmp10_;
#line 152 "../src/SearchFilter.vala"
	self->priv->search_filter_words_length1 = _tmp10__length1;
#line 152 "../src/SearchFilter.vala"
	self->priv->_search_filter_words_size_ = self->priv->search_filter_words_length1;
#line 150 "../src/SearchFilter.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 150 "../src/SearchFilter.vala"
	_g_free0 (_tmp0_);
#line 2231 "SearchFilter.c"
}

void
search_view_filter_clear_search_filter (SearchViewFilter* self)
{
#line 155 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
#line 156 "../src/SearchFilter.vala"
	_g_free0 (self->priv->search_filter);
#line 156 "../src/SearchFilter.vala"
	self->priv->search_filter = NULL;
#line 157 "../src/SearchFilter.vala"
	self->priv->search_filter_words = (_vala_array_free (self->priv->search_filter_words, self->priv->search_filter_words_length1, (GDestroyNotify) g_free), NULL);
#line 157 "../src/SearchFilter.vala"
	self->priv->search_filter_words = NULL;
#line 157 "../src/SearchFilter.vala"
	self->priv->search_filter_words_length1 = 0;
#line 157 "../src/SearchFilter.vala"
	self->priv->_search_filter_words_size_ = self->priv->search_filter_words_length1;
#line 2251 "SearchFilter.c"
}

gboolean
search_view_filter_has_saved_search (SearchViewFilter* self)
{
	SavedSearch* _tmp0_;
	gboolean result = FALSE;
#line 160 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
#line 161 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->_saved_search;
#line 161 "../src/SearchFilter.vala"
	result = _tmp0_ != NULL;
#line 161 "../src/SearchFilter.vala"
	return result;
#line 2267 "SearchFilter.c"
}

gboolean
search_view_filter_get_rating_allow_higher (SearchViewFilter* self)
{
	gboolean result = FALSE;
#line 164 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
#line 165 "../src/SearchFilter.vala"
	result = self->priv->rating_allow_higher;
#line 165 "../src/SearchFilter.vala"
	return result;
#line 2280 "SearchFilter.c"
}

Rating
search_view_filter_get_rating (SearchViewFilter* self)
{
	Rating result = 0;
#line 168 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), 0);
#line 169 "../src/SearchFilter.vala"
	result = self->priv->rating;
#line 169 "../src/SearchFilter.vala"
	return result;
#line 2293 "SearchFilter.c"
}

gboolean
search_view_filter_filter_by_media_type (SearchViewFilter* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean result = FALSE;
#line 172 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
#line 173 "../src/SearchFilter.vala"
	_tmp3_ = self->priv->_show_media_video;
#line 173 "../src/SearchFilter.vala"
	if (_tmp3_) {
#line 173 "../src/SearchFilter.vala"
		_tmp2_ = TRUE;
#line 2312 "SearchFilter.c"
	} else {
		gboolean _tmp4_;
#line 173 "../src/SearchFilter.vala"
		_tmp4_ = self->priv->_show_media_photos;
#line 173 "../src/SearchFilter.vala"
		_tmp2_ = _tmp4_;
#line 2319 "SearchFilter.c"
	}
#line 173 "../src/SearchFilter.vala"
	if (_tmp2_) {
#line 173 "../src/SearchFilter.vala"
		_tmp1_ = TRUE;
#line 2325 "SearchFilter.c"
	} else {
		gboolean _tmp5_;
#line 173 "../src/SearchFilter.vala"
		_tmp5_ = self->priv->_show_media_raw;
#line 173 "../src/SearchFilter.vala"
		_tmp1_ = _tmp5_;
#line 2332 "SearchFilter.c"
	}
#line 173 "../src/SearchFilter.vala"
	if (_tmp1_) {
#line 2336 "SearchFilter.c"
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_;
#line 174 "../src/SearchFilter.vala"
		_tmp8_ = self->priv->_show_media_video;
#line 174 "../src/SearchFilter.vala"
		if (_tmp8_) {
#line 2344 "SearchFilter.c"
			gboolean _tmp9_;
#line 174 "../src/SearchFilter.vala"
			_tmp9_ = self->priv->_show_media_photos;
#line 174 "../src/SearchFilter.vala"
			_tmp7_ = _tmp9_;
#line 2350 "SearchFilter.c"
		} else {
#line 174 "../src/SearchFilter.vala"
			_tmp7_ = FALSE;
#line 2354 "SearchFilter.c"
		}
#line 174 "../src/SearchFilter.vala"
		if (_tmp7_) {
#line 2358 "SearchFilter.c"
			gboolean _tmp10_;
#line 174 "../src/SearchFilter.vala"
			_tmp10_ = self->priv->_show_media_raw;
#line 174 "../src/SearchFilter.vala"
			_tmp6_ = _tmp10_;
#line 2364 "SearchFilter.c"
		} else {
#line 174 "../src/SearchFilter.vala"
			_tmp6_ = FALSE;
#line 2368 "SearchFilter.c"
		}
#line 174 "../src/SearchFilter.vala"
		_tmp0_ = !_tmp6_;
#line 2372 "SearchFilter.c"
	} else {
#line 173 "../src/SearchFilter.vala"
		_tmp0_ = FALSE;
#line 2376 "SearchFilter.c"
	}
#line 173 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 173 "../src/SearchFilter.vala"
	return result;
#line 2382 "SearchFilter.c"
}

SearchViewFilter*
search_view_filter_construct (GType object_type)
{
	SearchViewFilter* self = NULL;
#line 39 "../src/SearchFilter.vala"
	self = (SearchViewFilter*) view_filter_construct (object_type);
#line 39 "../src/SearchFilter.vala"
	return self;
#line 2393 "SearchFilter.c"
}

gboolean
search_view_filter_get_flagged (SearchViewFilter* self)
{
	gboolean result;
#line 48 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
#line 48 "../src/SearchFilter.vala"
	result = self->priv->_flagged;
#line 48 "../src/SearchFilter.vala"
	return result;
#line 2406 "SearchFilter.c"
}

void
search_view_filter_set_flagged (SearchViewFilter* self,
                                gboolean value)
{
#line 48 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
#line 48 "../src/SearchFilter.vala"
	self->priv->_flagged = value;
#line 2417 "SearchFilter.c"
}

gboolean
search_view_filter_get_show_media_video (SearchViewFilter* self)
{
	gboolean result;
#line 51 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
#line 51 "../src/SearchFilter.vala"
	result = self->priv->_show_media_video;
#line 51 "../src/SearchFilter.vala"
	return result;
#line 2430 "SearchFilter.c"
}

void
search_view_filter_set_show_media_video (SearchViewFilter* self,
                                         gboolean value)
{
#line 51 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
#line 51 "../src/SearchFilter.vala"
	self->priv->_show_media_video = value;
#line 2441 "SearchFilter.c"
}

gboolean
search_view_filter_get_show_media_photos (SearchViewFilter* self)
{
	gboolean result;
#line 52 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
#line 52 "../src/SearchFilter.vala"
	result = self->priv->_show_media_photos;
#line 52 "../src/SearchFilter.vala"
	return result;
#line 2454 "SearchFilter.c"
}

void
search_view_filter_set_show_media_photos (SearchViewFilter* self,
                                          gboolean value)
{
#line 52 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
#line 52 "../src/SearchFilter.vala"
	self->priv->_show_media_photos = value;
#line 2465 "SearchFilter.c"
}

gboolean
search_view_filter_get_show_media_raw (SearchViewFilter* self)
{
	gboolean result;
#line 53 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
#line 53 "../src/SearchFilter.vala"
	result = self->priv->_show_media_raw;
#line 53 "../src/SearchFilter.vala"
	return result;
#line 2478 "SearchFilter.c"
}

void
search_view_filter_set_show_media_raw (SearchViewFilter* self,
                                       gboolean value)
{
#line 53 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
#line 53 "../src/SearchFilter.vala"
	self->priv->_show_media_raw = value;
#line 2489 "SearchFilter.c"
}

SavedSearch*
search_view_filter_get_saved_search (SearchViewFilter* self)
{
	SavedSearch* result;
	SavedSearch* _tmp0_;
#line 60 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), NULL);
#line 60 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->_saved_search;
#line 60 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 60 "../src/SearchFilter.vala"
	return result;
#line 2505 "SearchFilter.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 60 "../src/SearchFilter.vala"
	return self ? g_object_ref (self) : NULL;
#line 2513 "SearchFilter.c"
}

void
search_view_filter_set_saved_search (SearchViewFilter* self,
                                     SavedSearch* value)
{
	SavedSearch* _tmp0_;
#line 60 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
#line 60 "../src/SearchFilter.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 60 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->_saved_search);
#line 60 "../src/SearchFilter.vala"
	self->priv->_saved_search = _tmp0_;
#line 2529 "SearchFilter.c"
}

static void
search_view_filter_class_init (SearchViewFilterClass * klass,
                               gpointer klass_data)
{
#line 39 "../src/SearchFilter.vala"
	search_view_filter_parent_class = g_type_class_peek_parent (klass);
#line 39 "../src/SearchFilter.vala"
	((ViewFilterClass *) klass)->finalize = search_view_filter_finalize;
#line 39 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &SearchViewFilter_private_offset);
#line 39 "../src/SearchFilter.vala"
	((SearchViewFilterClass *) klass)->get_criteria = (guint (*) (SearchViewFilter*)) search_view_filter_real_get_criteria;
#line 2544 "SearchFilter.c"
}

static void
search_view_filter_instance_init (SearchViewFilter * self,
                                  gpointer klass)
{
#line 39 "../src/SearchFilter.vala"
	self->priv = search_view_filter_get_instance_private (self);
#line 41 "../src/SearchFilter.vala"
	self->priv->rating_allow_higher = TRUE;
#line 44 "../src/SearchFilter.vala"
	self->priv->rating = RATING_UNRATED;
#line 45 "../src/SearchFilter.vala"
	self->priv->rating_filter = RATING_FILTER_UNRATED_OR_HIGHER;
#line 48 "../src/SearchFilter.vala"
	self->priv->_flagged = FALSE;
#line 51 "../src/SearchFilter.vala"
	self->priv->_show_media_video = TRUE;
#line 52 "../src/SearchFilter.vala"
	self->priv->_show_media_photos = TRUE;
#line 53 "../src/SearchFilter.vala"
	self->priv->_show_media_raw = TRUE;
#line 56 "../src/SearchFilter.vala"
	self->priv->search_filter = NULL;
#line 57 "../src/SearchFilter.vala"
	self->priv->search_filter_words = NULL;
#line 57 "../src/SearchFilter.vala"
	self->priv->search_filter_words_length1 = 0;
#line 57 "../src/SearchFilter.vala"
	self->priv->_search_filter_words_size_ = self->priv->search_filter_words_length1;
#line 60 "../src/SearchFilter.vala"
	self->priv->_saved_search = NULL;
#line 2577 "SearchFilter.c"
}

static void
search_view_filter_finalize (ViewFilter * obj)
{
	SearchViewFilter * self;
#line 39 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter);
#line 56 "../src/SearchFilter.vala"
	_g_free0 (self->priv->search_filter);
#line 57 "../src/SearchFilter.vala"
	self->priv->search_filter_words = (_vala_array_free (self->priv->search_filter_words, self->priv->search_filter_words_length1, (GDestroyNotify) g_free), NULL);
#line 60 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->_saved_search);
#line 39 "../src/SearchFilter.vala"
	VIEW_FILTER_CLASS (search_view_filter_parent_class)->finalize (obj);
#line 2594 "SearchFilter.c"
}

static GType
search_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchViewFilter), 0, (GInstanceInitFunc) search_view_filter_instance_init, NULL };
	GType search_view_filter_type_id;
	search_view_filter_type_id = g_type_register_static (TYPE_VIEW_FILTER, "SearchViewFilter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	SearchViewFilter_private_offset = g_type_add_instance_private (search_view_filter_type_id, sizeof (SearchViewFilterPrivate));
	return search_view_filter_type_id;
}

GType
search_view_filter_get_type (void)
{
	static volatile gsize search_view_filter_type_id__volatile = 0;
	if (g_once_init_enter (&search_view_filter_type_id__volatile)) {
		GType search_view_filter_type_id;
		search_view_filter_type_id = search_view_filter_get_type_once ();
		g_once_init_leave (&search_view_filter_type_id__volatile, search_view_filter_type_id);
	}
	return search_view_filter_type_id__volatile;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 2635 "SearchFilter.c"
}

static gboolean
default_search_view_filter_real_predicate (ViewFilter* base,
                                           DataView* view)
{
	DefaultSearchViewFilter * self;
	MediaSource* source = NULL;
	MediaSource* _tmp0_;
	guint criteria = 0U;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp81_ = FALSE;
	gboolean result = FALSE;
#line 181 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DEFAULT_SEARCH_VIEW_FILTER, DefaultSearchViewFilter);
#line 181 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 182 "../src/SearchFilter.vala"
	_tmp0_ = thumbnail_get_media_source (G_TYPE_CHECK_INSTANCE_CAST (view, TYPE_THUMBNAIL, Thumbnail));
#line 182 "../src/SearchFilter.vala"
	source = _tmp0_;
#line 183 "../src/SearchFilter.vala"
	criteria = search_view_filter_get_criteria (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 186 "../src/SearchFilter.vala"
	if ((SEARCH_FILTER_CRITERIA_RATING & criteria) != 0) {
#line 2662 "SearchFilter.c"
		gboolean _tmp1_ = FALSE;
#line 187 "../src/SearchFilter.vala"
		if (search_view_filter_get_rating_allow_higher (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter))) {
#line 2666 "SearchFilter.c"
			MediaSource* _tmp2_;
#line 187 "../src/SearchFilter.vala"
			_tmp2_ = source;
#line 187 "../src/SearchFilter.vala"
			_tmp1_ = media_source_get_rating (_tmp2_) < search_view_filter_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 2672 "SearchFilter.c"
		} else {
#line 187 "../src/SearchFilter.vala"
			_tmp1_ = FALSE;
#line 2676 "SearchFilter.c"
		}
#line 187 "../src/SearchFilter.vala"
		if (_tmp1_) {
#line 188 "../src/SearchFilter.vala"
			result = FALSE;
#line 188 "../src/SearchFilter.vala"
			_g_object_unref0 (source);
#line 188 "../src/SearchFilter.vala"
			return result;
#line 2686 "SearchFilter.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 189 "../src/SearchFilter.vala"
			if (!search_view_filter_get_rating_allow_higher (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter))) {
#line 2691 "SearchFilter.c"
				MediaSource* _tmp4_;
#line 189 "../src/SearchFilter.vala"
				_tmp4_ = source;
#line 189 "../src/SearchFilter.vala"
				_tmp3_ = media_source_get_rating (_tmp4_) != search_view_filter_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 2697 "SearchFilter.c"
			} else {
#line 189 "../src/SearchFilter.vala"
				_tmp3_ = FALSE;
#line 2701 "SearchFilter.c"
			}
#line 189 "../src/SearchFilter.vala"
			if (_tmp3_) {
#line 190 "../src/SearchFilter.vala"
				result = FALSE;
#line 190 "../src/SearchFilter.vala"
				_g_object_unref0 (source);
#line 190 "../src/SearchFilter.vala"
				return result;
#line 2711 "SearchFilter.c"
			}
		}
	}
#line 194 "../src/SearchFilter.vala"
	if ((SEARCH_FILTER_CRITERIA_FLAG & criteria) != 0) {
#line 2717 "SearchFilter.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 195 "../src/SearchFilter.vala"
		_tmp7_ = search_view_filter_get_flagged (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 195 "../src/SearchFilter.vala"
		_tmp8_ = _tmp7_;
#line 195 "../src/SearchFilter.vala"
		if (_tmp8_) {
#line 2728 "SearchFilter.c"
			MediaSource* _tmp9_;
#line 195 "../src/SearchFilter.vala"
			_tmp9_ = source;
#line 195 "../src/SearchFilter.vala"
			_tmp6_ = IS_FLAGGABLE (_tmp9_);
#line 2734 "SearchFilter.c"
		} else {
#line 195 "../src/SearchFilter.vala"
			_tmp6_ = FALSE;
#line 2738 "SearchFilter.c"
		}
#line 195 "../src/SearchFilter.vala"
		if (_tmp6_) {
#line 2742 "SearchFilter.c"
			MediaSource* _tmp10_;
#line 195 "../src/SearchFilter.vala"
			_tmp10_ = source;
#line 195 "../src/SearchFilter.vala"
			_tmp5_ = !flaggable_is_flagged (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_FLAGGABLE, Flaggable));
#line 2748 "SearchFilter.c"
		} else {
#line 195 "../src/SearchFilter.vala"
			_tmp5_ = FALSE;
#line 2752 "SearchFilter.c"
		}
#line 195 "../src/SearchFilter.vala"
		if (_tmp5_) {
#line 196 "../src/SearchFilter.vala"
			result = FALSE;
#line 196 "../src/SearchFilter.vala"
			_g_object_unref0 (source);
#line 196 "../src/SearchFilter.vala"
			return result;
#line 2762 "SearchFilter.c"
		}
	}
#line 200 "../src/SearchFilter.vala"
	if ((SEARCH_FILTER_CRITERIA_MEDIA & criteria) != 0) {
#line 200 "../src/SearchFilter.vala"
		_tmp11_ = search_view_filter_filter_by_media_type (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 2769 "SearchFilter.c"
	} else {
#line 200 "../src/SearchFilter.vala"
		_tmp11_ = FALSE;
#line 2773 "SearchFilter.c"
	}
#line 200 "../src/SearchFilter.vala"
	if (_tmp11_) {
#line 2777 "SearchFilter.c"
		MediaSource* _tmp12_;
#line 201 "../src/SearchFilter.vala"
		_tmp12_ = source;
#line 201 "../src/SearchFilter.vala"
		if (IS_VIDEO_SOURCE (_tmp12_)) {
#line 2783 "SearchFilter.c"
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 202 "../src/SearchFilter.vala"
			_tmp13_ = search_view_filter_get_show_media_video (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 202 "../src/SearchFilter.vala"
			_tmp14_ = _tmp13_;
#line 202 "../src/SearchFilter.vala"
			if (!_tmp14_) {
#line 203 "../src/SearchFilter.vala"
				result = FALSE;
#line 203 "../src/SearchFilter.vala"
				_g_object_unref0 (source);
#line 203 "../src/SearchFilter.vala"
				return result;
#line 2798 "SearchFilter.c"
			}
		} else {
			MediaSource* _tmp15_;
#line 204 "../src/SearchFilter.vala"
			_tmp15_ = source;
#line 204 "../src/SearchFilter.vala"
			if (IS_PHOTO (_tmp15_)) {
#line 2806 "SearchFilter.c"
				Photo* photo = NULL;
				MediaSource* _tmp16_;
				Photo* _tmp17_;
				Photo* _tmp18_;
#line 205 "../src/SearchFilter.vala"
				_tmp16_ = source;
#line 205 "../src/SearchFilter.vala"
				_tmp17_ = _g_object_ref0 (IS_PHOTO (_tmp16_) ? ((Photo*) _tmp16_) : NULL);
#line 205 "../src/SearchFilter.vala"
				photo = _tmp17_;
#line 206 "../src/SearchFilter.vala"
				_tmp18_ = photo;
#line 206 "../src/SearchFilter.vala"
				if (photo_get_master_file_format (_tmp18_) == PHOTO_FILE_FORMAT_RAW) {
#line 2821 "SearchFilter.c"
					gboolean _tmp19_ = FALSE;
					gboolean _tmp20_;
					gboolean _tmp21_;
#line 207 "../src/SearchFilter.vala"
					_tmp20_ = search_view_filter_get_show_media_photos (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 207 "../src/SearchFilter.vala"
					_tmp21_ = _tmp20_;
#line 207 "../src/SearchFilter.vala"
					if (!_tmp21_) {
#line 2831 "SearchFilter.c"
						gboolean _tmp22_;
						gboolean _tmp23_;
#line 207 "../src/SearchFilter.vala"
						_tmp22_ = search_view_filter_get_show_media_raw (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 207 "../src/SearchFilter.vala"
						_tmp23_ = _tmp22_;
#line 207 "../src/SearchFilter.vala"
						_tmp19_ = !_tmp23_;
#line 2840 "SearchFilter.c"
					} else {
#line 207 "../src/SearchFilter.vala"
						_tmp19_ = FALSE;
#line 2844 "SearchFilter.c"
					}
#line 207 "../src/SearchFilter.vala"
					if (_tmp19_) {
#line 208 "../src/SearchFilter.vala"
						result = FALSE;
#line 208 "../src/SearchFilter.vala"
						_g_object_unref0 (photo);
#line 208 "../src/SearchFilter.vala"
						_g_object_unref0 (source);
#line 208 "../src/SearchFilter.vala"
						return result;
#line 2856 "SearchFilter.c"
					}
				} else {
					gboolean _tmp24_;
					gboolean _tmp25_;
#line 209 "../src/SearchFilter.vala"
					_tmp24_ = search_view_filter_get_show_media_photos (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 209 "../src/SearchFilter.vala"
					_tmp25_ = _tmp24_;
#line 209 "../src/SearchFilter.vala"
					if (!_tmp25_) {
#line 210 "../src/SearchFilter.vala"
						result = FALSE;
#line 210 "../src/SearchFilter.vala"
						_g_object_unref0 (photo);
#line 210 "../src/SearchFilter.vala"
						_g_object_unref0 (source);
#line 210 "../src/SearchFilter.vala"
						return result;
#line 2875 "SearchFilter.c"
					}
				}
#line 204 "../src/SearchFilter.vala"
				_g_object_unref0 (photo);
#line 2880 "SearchFilter.c"
			}
		}
	}
#line 215 "../src/SearchFilter.vala"
	if ((SEARCH_FILTER_CRITERIA_TEXT & criteria) != 0) {
#line 215 "../src/SearchFilter.vala"
		_tmp26_ = search_view_filter_has_search_filter (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 2888 "SearchFilter.c"
	} else {
#line 215 "../src/SearchFilter.vala"
		_tmp26_ = FALSE;
#line 2892 "SearchFilter.c"
	}
#line 215 "../src/SearchFilter.vala"
	if (_tmp26_) {
#line 2896 "SearchFilter.c"
		const gchar* media_keywords = NULL;
		MediaSource* _tmp27_;
		const gchar* _tmp28_;
		const gchar* event_keywords = NULL;
		Event* event = NULL;
		MediaSource* _tmp29_;
		Event* _tmp30_;
		Event* _tmp31_;
		GeeList* tags = NULL;
		TagSourceCollection* _tmp34_;
		MediaSource* _tmp35_;
		GeeList* _tmp36_;
		gint _tmp37_ = 0;
		GeeList* _tmp38_;
		gint tags_size = 0;
		GeeList* faces = NULL;
		FaceSourceCollection* _tmp42_;
		MediaSource* _tmp43_;
		GeeList* _tmp44_;
		gint _tmp45_ = 0;
		gchar** _tmp46_;
#line 216 "../src/SearchFilter.vala"
		_tmp27_ = source;
#line 216 "../src/SearchFilter.vala"
		_tmp28_ = indexable_get_indexable_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, TYPE_INDEXABLE, Indexable));
#line 216 "../src/SearchFilter.vala"
		media_keywords = _tmp28_;
#line 218 "../src/SearchFilter.vala"
		event_keywords = NULL;
#line 219 "../src/SearchFilter.vala"
		_tmp29_ = source;
#line 219 "../src/SearchFilter.vala"
		_tmp30_ = media_source_get_event (_tmp29_);
#line 219 "../src/SearchFilter.vala"
		event = _tmp30_;
#line 220 "../src/SearchFilter.vala"
		_tmp31_ = event;
#line 220 "../src/SearchFilter.vala"
		if (_tmp31_ != NULL) {
#line 2936 "SearchFilter.c"
			Event* _tmp32_;
			const gchar* _tmp33_;
#line 221 "../src/SearchFilter.vala"
			_tmp32_ = event;
#line 221 "../src/SearchFilter.vala"
			_tmp33_ = indexable_get_indexable_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_INDEXABLE, Indexable));
#line 221 "../src/SearchFilter.vala"
			event_keywords = _tmp33_;
#line 2945 "SearchFilter.c"
		}
#line 223 "../src/SearchFilter.vala"
		_tmp34_ = tag_global;
#line 223 "../src/SearchFilter.vala"
		_tmp35_ = source;
#line 223 "../src/SearchFilter.vala"
		_tmp36_ = tag_source_collection_fetch_for_source (_tmp34_, _tmp35_);
#line 223 "../src/SearchFilter.vala"
		tags = _tmp36_;
#line 224 "../src/SearchFilter.vala"
		_tmp38_ = tags;
#line 224 "../src/SearchFilter.vala"
		if (_tmp38_ != NULL) {
#line 2959 "SearchFilter.c"
			GeeList* _tmp39_;
			gint _tmp40_;
			gint _tmp41_;
#line 224 "../src/SearchFilter.vala"
			_tmp39_ = tags;
#line 224 "../src/SearchFilter.vala"
			_tmp40_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_COLLECTION, GeeCollection));
#line 224 "../src/SearchFilter.vala"
			_tmp41_ = _tmp40_;
#line 224 "../src/SearchFilter.vala"
			_tmp37_ = _tmp41_;
#line 2971 "SearchFilter.c"
		} else {
#line 224 "../src/SearchFilter.vala"
			_tmp37_ = 0;
#line 2975 "SearchFilter.c"
		}
#line 224 "../src/SearchFilter.vala"
		tags_size = _tmp37_;
#line 227 "../src/SearchFilter.vala"
		_tmp42_ = face_global;
#line 227 "../src/SearchFilter.vala"
		_tmp43_ = source;
#line 227 "../src/SearchFilter.vala"
		_tmp44_ = face_source_collection_fetch_for_source (_tmp42_, _tmp43_);
#line 227 "../src/SearchFilter.vala"
		faces = _tmp44_;
#line 230 "../src/SearchFilter.vala"
		_tmp46_ = search_view_filter_get_search_filter_words (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter), &_tmp45_);
#line 2989 "SearchFilter.c"
		{
			gchar** word_collection = NULL;
			gint word_collection_length1 = 0;
			gint _word_collection_size_ = 0;
			gint word_it = 0;
#line 230 "../src/SearchFilter.vala"
			word_collection = _tmp46_;
#line 230 "../src/SearchFilter.vala"
			word_collection_length1 = _tmp45_;
#line 230 "../src/SearchFilter.vala"
			for (word_it = 0; word_it < word_collection_length1; word_it = word_it + 1) {
#line 3001 "SearchFilter.c"
				const gchar* word = NULL;
#line 230 "../src/SearchFilter.vala"
				word = word_collection[word_it];
#line 3005 "SearchFilter.c"
				{
					gboolean _tmp47_ = FALSE;
					const gchar* _tmp48_;
					gboolean _tmp51_ = FALSE;
					const gchar* _tmp52_;
					GeeList* _tmp66_;
#line 231 "../src/SearchFilter.vala"
					_tmp48_ = media_keywords;
#line 231 "../src/SearchFilter.vala"
					if (_tmp48_ != NULL) {
#line 3016 "SearchFilter.c"
						const gchar* _tmp49_;
						const gchar* _tmp50_;
#line 231 "../src/SearchFilter.vala"
						_tmp49_ = media_keywords;
#line 231 "../src/SearchFilter.vala"
						_tmp50_ = word;
#line 231 "../src/SearchFilter.vala"
						_tmp47_ = string_contains (_tmp49_, _tmp50_);
#line 3025 "SearchFilter.c"
					} else {
#line 231 "../src/SearchFilter.vala"
						_tmp47_ = FALSE;
#line 3029 "SearchFilter.c"
					}
#line 231 "../src/SearchFilter.vala"
					if (_tmp47_) {
#line 232 "../src/SearchFilter.vala"
						continue;
#line 3035 "SearchFilter.c"
					}
#line 234 "../src/SearchFilter.vala"
					_tmp52_ = event_keywords;
#line 234 "../src/SearchFilter.vala"
					if (_tmp52_ != NULL) {
#line 3041 "SearchFilter.c"
						const gchar* _tmp53_;
						const gchar* _tmp54_;
#line 234 "../src/SearchFilter.vala"
						_tmp53_ = event_keywords;
#line 234 "../src/SearchFilter.vala"
						_tmp54_ = word;
#line 234 "../src/SearchFilter.vala"
						_tmp51_ = string_contains (_tmp53_, _tmp54_);
#line 3050 "SearchFilter.c"
					} else {
#line 234 "../src/SearchFilter.vala"
						_tmp51_ = FALSE;
#line 3054 "SearchFilter.c"
					}
#line 234 "../src/SearchFilter.vala"
					if (_tmp51_) {
#line 235 "../src/SearchFilter.vala"
						continue;
#line 3060 "SearchFilter.c"
					}
#line 237 "../src/SearchFilter.vala"
					if (tags_size > 0) {
#line 3064 "SearchFilter.c"
						gboolean found = FALSE;
#line 238 "../src/SearchFilter.vala"
						found = FALSE;
#line 3068 "SearchFilter.c"
						{
							gint ctr = 0;
#line 239 "../src/SearchFilter.vala"
							ctr = 0;
#line 3073 "SearchFilter.c"
							{
								gboolean _tmp55_ = FALSE;
#line 239 "../src/SearchFilter.vala"
								_tmp55_ = TRUE;
#line 239 "../src/SearchFilter.vala"
								while (TRUE) {
#line 3080 "SearchFilter.c"
									const gchar* tag_keywords = NULL;
									GeeList* _tmp57_;
									gpointer _tmp58_;
									Tag* _tmp59_;
									const gchar* _tmp60_;
									const gchar* _tmp61_;
									gboolean _tmp62_ = FALSE;
									const gchar* _tmp63_;
#line 239 "../src/SearchFilter.vala"
									if (!_tmp55_) {
#line 3091 "SearchFilter.c"
										gint _tmp56_;
#line 239 "../src/SearchFilter.vala"
										_tmp56_ = ctr;
#line 239 "../src/SearchFilter.vala"
										ctr = _tmp56_ + 1;
#line 3097 "SearchFilter.c"
									}
#line 239 "../src/SearchFilter.vala"
									_tmp55_ = FALSE;
#line 239 "../src/SearchFilter.vala"
									if (!(ctr < tags_size)) {
#line 239 "../src/SearchFilter.vala"
										break;
#line 3105 "SearchFilter.c"
									}
#line 240 "../src/SearchFilter.vala"
									_tmp57_ = tags;
#line 240 "../src/SearchFilter.vala"
									_tmp58_ = gee_list_get (_tmp57_, ctr);
#line 240 "../src/SearchFilter.vala"
									_tmp59_ = (Tag*) _tmp58_;
#line 240 "../src/SearchFilter.vala"
									_tmp60_ = indexable_get_indexable_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, TYPE_INDEXABLE, Indexable));
#line 240 "../src/SearchFilter.vala"
									_tmp61_ = _tmp60_;
#line 240 "../src/SearchFilter.vala"
									_g_object_unref0 (_tmp59_);
#line 240 "../src/SearchFilter.vala"
									tag_keywords = _tmp61_;
#line 241 "../src/SearchFilter.vala"
									_tmp63_ = tag_keywords;
#line 241 "../src/SearchFilter.vala"
									if (_tmp63_ != NULL) {
#line 3125 "SearchFilter.c"
										const gchar* _tmp64_;
										const gchar* _tmp65_;
#line 241 "../src/SearchFilter.vala"
										_tmp64_ = tag_keywords;
#line 241 "../src/SearchFilter.vala"
										_tmp65_ = word;
#line 241 "../src/SearchFilter.vala"
										_tmp62_ = string_contains (_tmp64_, _tmp65_);
#line 3134 "SearchFilter.c"
									} else {
#line 241 "../src/SearchFilter.vala"
										_tmp62_ = FALSE;
#line 3138 "SearchFilter.c"
									}
#line 241 "../src/SearchFilter.vala"
									if (_tmp62_) {
#line 242 "../src/SearchFilter.vala"
										found = TRUE;
#line 244 "../src/SearchFilter.vala"
										break;
#line 3146 "SearchFilter.c"
									}
								}
							}
						}
#line 248 "../src/SearchFilter.vala"
						if (found) {
#line 249 "../src/SearchFilter.vala"
							continue;
#line 3155 "SearchFilter.c"
						}
					}
#line 253 "../src/SearchFilter.vala"
					_tmp66_ = faces;
#line 253 "../src/SearchFilter.vala"
					if (_tmp66_ != NULL) {
#line 3162 "SearchFilter.c"
						gboolean found = FALSE;
#line 254 "../src/SearchFilter.vala"
						found = FALSE;
#line 3166 "SearchFilter.c"
						{
							GeeList* _f_list = NULL;
							GeeList* _tmp67_;
							gint _f_size = 0;
							GeeList* _tmp68_;
							gint _tmp69_;
							gint _tmp70_;
							gint _f_index = 0;
#line 255 "../src/SearchFilter.vala"
							_tmp67_ = faces;
#line 255 "../src/SearchFilter.vala"
							_f_list = _tmp67_;
#line 255 "../src/SearchFilter.vala"
							_tmp68_ = _f_list;
#line 255 "../src/SearchFilter.vala"
							_tmp69_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, GEE_TYPE_COLLECTION, GeeCollection));
#line 255 "../src/SearchFilter.vala"
							_tmp70_ = _tmp69_;
#line 255 "../src/SearchFilter.vala"
							_f_size = _tmp70_;
#line 255 "../src/SearchFilter.vala"
							_f_index = -1;
#line 255 "../src/SearchFilter.vala"
							while (TRUE) {
#line 3191 "SearchFilter.c"
								gint _tmp71_;
								gint _tmp72_;
								Face* f = NULL;
								GeeList* _tmp73_;
								gpointer _tmp74_;
								const gchar* face_keywords = NULL;
								Face* _tmp75_;
								const gchar* _tmp76_;
								gboolean _tmp77_ = FALSE;
								const gchar* _tmp78_;
#line 255 "../src/SearchFilter.vala"
								_f_index = _f_index + 1;
#line 255 "../src/SearchFilter.vala"
								_tmp71_ = _f_index;
#line 255 "../src/SearchFilter.vala"
								_tmp72_ = _f_size;
#line 255 "../src/SearchFilter.vala"
								if (!(_tmp71_ < _tmp72_)) {
#line 255 "../src/SearchFilter.vala"
									break;
#line 3212 "SearchFilter.c"
								}
#line 255 "../src/SearchFilter.vala"
								_tmp73_ = _f_list;
#line 255 "../src/SearchFilter.vala"
								_tmp74_ = gee_list_get (_tmp73_, _f_index);
#line 255 "../src/SearchFilter.vala"
								f = (Face*) _tmp74_;
#line 256 "../src/SearchFilter.vala"
								_tmp75_ = f;
#line 256 "../src/SearchFilter.vala"
								_tmp76_ = indexable_get_indexable_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp75_, TYPE_INDEXABLE, Indexable));
#line 256 "../src/SearchFilter.vala"
								face_keywords = _tmp76_;
#line 257 "../src/SearchFilter.vala"
								_tmp78_ = face_keywords;
#line 257 "../src/SearchFilter.vala"
								if (_tmp78_ != NULL) {
#line 3230 "SearchFilter.c"
									const gchar* _tmp79_;
									const gchar* _tmp80_;
#line 257 "../src/SearchFilter.vala"
									_tmp79_ = face_keywords;
#line 257 "../src/SearchFilter.vala"
									_tmp80_ = word;
#line 257 "../src/SearchFilter.vala"
									_tmp77_ = string_contains (_tmp79_, _tmp80_);
#line 3239 "SearchFilter.c"
								} else {
#line 257 "../src/SearchFilter.vala"
									_tmp77_ = FALSE;
#line 3243 "SearchFilter.c"
								}
#line 257 "../src/SearchFilter.vala"
								if (_tmp77_) {
#line 258 "../src/SearchFilter.vala"
									found = TRUE;
#line 260 "../src/SearchFilter.vala"
									_g_object_unref0 (f);
#line 260 "../src/SearchFilter.vala"
									break;
#line 3253 "SearchFilter.c"
								}
#line 255 "../src/SearchFilter.vala"
								_g_object_unref0 (f);
#line 3257 "SearchFilter.c"
							}
						}
#line 264 "../src/SearchFilter.vala"
						if (found) {
#line 265 "../src/SearchFilter.vala"
							continue;
#line 3264 "SearchFilter.c"
						}
					}
#line 270 "../src/SearchFilter.vala"
					result = FALSE;
#line 270 "../src/SearchFilter.vala"
					_g_object_unref0 (faces);
#line 270 "../src/SearchFilter.vala"
					_g_object_unref0 (tags);
#line 270 "../src/SearchFilter.vala"
					_g_object_unref0 (event);
#line 270 "../src/SearchFilter.vala"
					_g_object_unref0 (source);
#line 270 "../src/SearchFilter.vala"
					return result;
#line 3279 "SearchFilter.c"
				}
			}
		}
#line 215 "../src/SearchFilter.vala"
		_g_object_unref0 (faces);
#line 215 "../src/SearchFilter.vala"
		_g_object_unref0 (tags);
#line 215 "../src/SearchFilter.vala"
		_g_object_unref0 (event);
#line 3289 "SearchFilter.c"
	}
#line 275 "../src/SearchFilter.vala"
	if ((SEARCH_FILTER_CRITERIA_SAVEDSEARCH & criteria) != 0) {
#line 275 "../src/SearchFilter.vala"
		_tmp81_ = search_view_filter_has_saved_search (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 3295 "SearchFilter.c"
	} else {
#line 275 "../src/SearchFilter.vala"
		_tmp81_ = FALSE;
#line 3299 "SearchFilter.c"
	}
#line 275 "../src/SearchFilter.vala"
	if (_tmp81_) {
#line 3303 "SearchFilter.c"
		SavedSearch* _tmp82_;
		SavedSearch* _tmp83_;
		MediaSource* _tmp84_;
#line 276 "../src/SearchFilter.vala"
		_tmp82_ = search_view_filter_get_saved_search (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 276 "../src/SearchFilter.vala"
		_tmp83_ = _tmp82_;
#line 276 "../src/SearchFilter.vala"
		_tmp84_ = source;
#line 276 "../src/SearchFilter.vala"
		result = saved_search_predicate (_tmp83_, _tmp84_);
#line 276 "../src/SearchFilter.vala"
		_g_object_unref0 (source);
#line 276 "../src/SearchFilter.vala"
		return result;
#line 3319 "SearchFilter.c"
	}
#line 279 "../src/SearchFilter.vala"
	result = TRUE;
#line 279 "../src/SearchFilter.vala"
	_g_object_unref0 (source);
#line 279 "../src/SearchFilter.vala"
	return result;
#line 3327 "SearchFilter.c"
}

DefaultSearchViewFilter*
default_search_view_filter_construct (GType object_type)
{
	DefaultSearchViewFilter* self = NULL;
#line 180 "../src/SearchFilter.vala"
	self = (DefaultSearchViewFilter*) search_view_filter_construct (object_type);
#line 180 "../src/SearchFilter.vala"
	return self;
#line 3338 "SearchFilter.c"
}

static void
default_search_view_filter_class_init (DefaultSearchViewFilterClass * klass,
                                       gpointer klass_data)
{
#line 180 "../src/SearchFilter.vala"
	default_search_view_filter_parent_class = g_type_class_peek_parent (klass);
#line 180 "../src/SearchFilter.vala"
	((ViewFilterClass *) klass)->predicate = (gboolean (*) (ViewFilter*, DataView*)) default_search_view_filter_real_predicate;
#line 3349 "SearchFilter.c"
}

static void
default_search_view_filter_instance_init (DefaultSearchViewFilter * self,
                                          gpointer klass)
{
}

static GType
default_search_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DefaultSearchViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) default_search_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DefaultSearchViewFilter), 0, (GInstanceInitFunc) default_search_view_filter_instance_init, NULL };
	GType default_search_view_filter_type_id;
	default_search_view_filter_type_id = g_type_register_static (TYPE_SEARCH_VIEW_FILTER, "DefaultSearchViewFilter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return default_search_view_filter_type_id;
}

GType
default_search_view_filter_get_type (void)
{
	static volatile gsize default_search_view_filter_type_id__volatile = 0;
	if (g_once_init_enter (&default_search_view_filter_type_id__volatile)) {
		GType default_search_view_filter_type_id;
		default_search_view_filter_type_id = default_search_view_filter_get_type_once ();
		g_once_init_leave (&default_search_view_filter_type_id__volatile, default_search_view_filter_type_id);
	}
	return default_search_view_filter_type_id__volatile;
}

static gboolean
disabled_view_filter_real_predicate (ViewFilter* base,
                                     DataView* view)
{
	DisabledViewFilter * self;
	gboolean result = FALSE;
#line 284 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DISABLED_VIEW_FILTER, DisabledViewFilter);
#line 284 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 285 "../src/SearchFilter.vala"
	result = TRUE;
#line 285 "../src/SearchFilter.vala"
	return result;
#line 3393 "SearchFilter.c"
}

static guint
disabled_view_filter_real_get_criteria (SearchViewFilter* base)
{
	DisabledViewFilter * self;
	guint result = 0U;
#line 288 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DISABLED_VIEW_FILTER, DisabledViewFilter);
#line 289 "../src/SearchFilter.vala"
	result = (guint) SEARCH_FILTER_CRITERIA_RATING;
#line 289 "../src/SearchFilter.vala"
	return result;
#line 3407 "SearchFilter.c"
}

DisabledViewFilter*
disabled_view_filter_construct (GType object_type)
{
	DisabledViewFilter* self = NULL;
#line 283 "../src/SearchFilter.vala"
	self = (DisabledViewFilter*) search_view_filter_construct (object_type);
#line 283 "../src/SearchFilter.vala"
	return self;
#line 3418 "SearchFilter.c"
}

DisabledViewFilter*
disabled_view_filter_new (void)
{
#line 283 "../src/SearchFilter.vala"
	return disabled_view_filter_construct (TYPE_DISABLED_VIEW_FILTER);
#line 3426 "SearchFilter.c"
}

static void
disabled_view_filter_class_init (DisabledViewFilterClass * klass,
                                 gpointer klass_data)
{
#line 283 "../src/SearchFilter.vala"
	disabled_view_filter_parent_class = g_type_class_peek_parent (klass);
#line 283 "../src/SearchFilter.vala"
	((ViewFilterClass *) klass)->predicate = (gboolean (*) (ViewFilter*, DataView*)) disabled_view_filter_real_predicate;
#line 283 "../src/SearchFilter.vala"
	((SearchViewFilterClass *) klass)->get_criteria = (guint (*) (SearchViewFilter*)) disabled_view_filter_real_get_criteria;
#line 3439 "SearchFilter.c"
}

static void
disabled_view_filter_instance_init (DisabledViewFilter * self,
                                    gpointer klass)
{
}

static GType
disabled_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisabledViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) disabled_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisabledViewFilter), 0, (GInstanceInitFunc) disabled_view_filter_instance_init, NULL };
	GType disabled_view_filter_type_id;
	disabled_view_filter_type_id = g_type_register_static (TYPE_SEARCH_VIEW_FILTER, "DisabledViewFilter", &g_define_type_info, 0);
	return disabled_view_filter_type_id;
}

GType
disabled_view_filter_get_type (void)
{
	static volatile gsize disabled_view_filter_type_id__volatile = 0;
	if (g_once_init_enter (&disabled_view_filter_type_id__volatile)) {
		GType disabled_view_filter_type_id;
		disabled_view_filter_type_id = disabled_view_filter_get_type_once ();
		g_once_init_leave (&disabled_view_filter_type_id__volatile, disabled_view_filter_type_id);
	}
	return disabled_view_filter_type_id__volatile;
}

static inline gpointer
text_action_get_instance_private (TextAction* self)
{
	return G_STRUCT_MEMBER_P (self, TextAction_private_offset);
}

TextAction*
text_action_construct (GType object_type,
                       const gchar* init)
{
	TextAction* self = NULL;
	gchar* _tmp0_;
#line 310 "../src/SearchFilter.vala"
	self = (TextAction*) g_type_create_instance (object_type);
#line 311 "../src/SearchFilter.vala"
	_tmp0_ = g_strdup (init);
#line 311 "../src/SearchFilter.vala"
	_g_free0 (self->priv->text);
#line 311 "../src/SearchFilter.vala"
	self->priv->text = _tmp0_;
#line 310 "../src/SearchFilter.vala"
	return self;
#line 3491 "SearchFilter.c"
}

TextAction*
text_action_new (const gchar* init)
{
#line 310 "../src/SearchFilter.vala"
	return text_action_construct (TYPE_TEXT_ACTION, init);
#line 3499 "SearchFilter.c"
}

void
text_action_set_text (TextAction* self,
                      const gchar* text)
{
	const gchar* _tmp0_;
#line 314 "../src/SearchFilter.vala"
	g_return_if_fail (IS_TEXT_ACTION (self));
#line 315 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->text;
#line 315 "../src/SearchFilter.vala"
	if (g_strcmp0 (_tmp0_, text) != 0) {
#line 3513 "SearchFilter.c"
		gchar* _tmp1_;
#line 316 "../src/SearchFilter.vala"
		_tmp1_ = g_strdup (text);
#line 316 "../src/SearchFilter.vala"
		_g_free0 (self->priv->text);
#line 316 "../src/SearchFilter.vala"
		self->priv->text = _tmp1_;
#line 317 "../src/SearchFilter.vala"
		g_signal_emit (self, text_action_signals[TEXT_ACTION_TEXT_CHANGED_SIGNAL], 0, text);
#line 3523 "SearchFilter.c"
	}
}

void
text_action_clear (TextAction* self)
{
#line 321 "../src/SearchFilter.vala"
	g_return_if_fail (IS_TEXT_ACTION (self));
#line 322 "../src/SearchFilter.vala"
	text_action_set_text (self, NULL);
#line 3534 "SearchFilter.c"
}

gboolean
text_action_is_sensitive (TextAction* self)
{
	gboolean result = FALSE;
#line 325 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_TEXT_ACTION (self), FALSE);
#line 326 "../src/SearchFilter.vala"
	result = self->priv->sensitive;
#line 326 "../src/SearchFilter.vala"
	return result;
#line 3547 "SearchFilter.c"
}

void
text_action_set_sensitive (TextAction* self,
                           gboolean sensitive)
{
#line 329 "../src/SearchFilter.vala"
	g_return_if_fail (IS_TEXT_ACTION (self));
#line 330 "../src/SearchFilter.vala"
	if (self->priv->sensitive != sensitive) {
#line 331 "../src/SearchFilter.vala"
		self->priv->sensitive = sensitive;
#line 332 "../src/SearchFilter.vala"
		g_signal_emit (self, text_action_signals[TEXT_ACTION_SENSITIVITY_CHANGED_SIGNAL], 0, sensitive);
#line 3562 "SearchFilter.c"
	}
}

gboolean
text_action_is_visible (TextAction* self)
{
	gboolean result = FALSE;
#line 336 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_TEXT_ACTION (self), FALSE);
#line 337 "../src/SearchFilter.vala"
	result = self->priv->visible;
#line 337 "../src/SearchFilter.vala"
	return result;
#line 3576 "SearchFilter.c"
}

void
text_action_set_visible (TextAction* self,
                         gboolean visible)
{
#line 340 "../src/SearchFilter.vala"
	g_return_if_fail (IS_TEXT_ACTION (self));
#line 341 "../src/SearchFilter.vala"
	if (self->priv->visible != visible) {
#line 342 "../src/SearchFilter.vala"
		self->priv->visible = visible;
#line 343 "../src/SearchFilter.vala"
		g_signal_emit (self, text_action_signals[TEXT_ACTION_VISIBILITY_CHANGED_SIGNAL], 0, visible);
#line 3591 "SearchFilter.c"
	}
}

const gchar*
text_action_get_value (TextAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 295 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_TEXT_ACTION (self), NULL);
#line 296 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->text;
#line 296 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 296 "../src/SearchFilter.vala"
	return result;
#line 3608 "SearchFilter.c"
}

static void
value_text_action_init (GValue* value)
{
#line 293 "../src/SearchFilter.vala"
	value->data[0].v_pointer = NULL;
#line 3616 "SearchFilter.c"
}

static void
value_text_action_free_value (GValue* value)
{
#line 293 "../src/SearchFilter.vala"
	if (value->data[0].v_pointer) {
#line 293 "../src/SearchFilter.vala"
		text_action_unref (value->data[0].v_pointer);
#line 3626 "SearchFilter.c"
	}
}

static void
value_text_action_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
#line 293 "../src/SearchFilter.vala"
	if (src_value->data[0].v_pointer) {
#line 293 "../src/SearchFilter.vala"
		dest_value->data[0].v_pointer = text_action_ref (src_value->data[0].v_pointer);
#line 3638 "SearchFilter.c"
	} else {
#line 293 "../src/SearchFilter.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3642 "SearchFilter.c"
	}
}

static gpointer
value_text_action_peek_pointer (const GValue* value)
{
#line 293 "../src/SearchFilter.vala"
	return value->data[0].v_pointer;
#line 3651 "SearchFilter.c"
}

static gchar*
value_text_action_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
#line 293 "../src/SearchFilter.vala"
	if (collect_values[0].v_pointer) {
#line 3662 "SearchFilter.c"
		TextAction * object;
		object = collect_values[0].v_pointer;
#line 293 "../src/SearchFilter.vala"
		if (object->parent_instance.g_class == NULL) {
#line 293 "../src/SearchFilter.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3669 "SearchFilter.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 293 "../src/SearchFilter.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3673 "SearchFilter.c"
		}
#line 293 "../src/SearchFilter.vala"
		value->data[0].v_pointer = text_action_ref (object);
#line 3677 "SearchFilter.c"
	} else {
#line 293 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 3681 "SearchFilter.c"
	}
#line 293 "../src/SearchFilter.vala"
	return NULL;
#line 3685 "SearchFilter.c"
}

static gchar*
value_text_action_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	TextAction ** object_p;
	object_p = collect_values[0].v_pointer;
#line 293 "../src/SearchFilter.vala"
	if (!object_p) {
#line 293 "../src/SearchFilter.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3700 "SearchFilter.c"
	}
#line 293 "../src/SearchFilter.vala"
	if (!value->data[0].v_pointer) {
#line 293 "../src/SearchFilter.vala"
		*object_p = NULL;
#line 3706 "SearchFilter.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 293 "../src/SearchFilter.vala"
		*object_p = value->data[0].v_pointer;
#line 3710 "SearchFilter.c"
	} else {
#line 293 "../src/SearchFilter.vala"
		*object_p = text_action_ref (value->data[0].v_pointer);
#line 3714 "SearchFilter.c"
	}
#line 293 "../src/SearchFilter.vala"
	return NULL;
#line 3718 "SearchFilter.c"
}

GParamSpec*
param_spec_text_action (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecTextAction* spec;
#line 293 "../src/SearchFilter.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TEXT_ACTION), NULL);
#line 293 "../src/SearchFilter.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 293 "../src/SearchFilter.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 293 "../src/SearchFilter.vala"
	return G_PARAM_SPEC (spec);
#line 3737 "SearchFilter.c"
}

gpointer
value_get_text_action (const GValue* value)
{
#line 293 "../src/SearchFilter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEXT_ACTION), NULL);
#line 293 "../src/SearchFilter.vala"
	return value->data[0].v_pointer;
#line 3747 "SearchFilter.c"
}

void
value_set_text_action (GValue* value,
                       gpointer v_object)
{
	TextAction * old;
#line 293 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEXT_ACTION));
#line 293 "../src/SearchFilter.vala"
	old = value->data[0].v_pointer;
#line 293 "../src/SearchFilter.vala"
	if (v_object) {
#line 293 "../src/SearchFilter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEXT_ACTION));
#line 293 "../src/SearchFilter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 293 "../src/SearchFilter.vala"
		value->data[0].v_pointer = v_object;
#line 293 "../src/SearchFilter.vala"
		text_action_ref (value->data[0].v_pointer);
#line 3769 "SearchFilter.c"
	} else {
#line 293 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 3773 "SearchFilter.c"
	}
#line 293 "../src/SearchFilter.vala"
	if (old) {
#line 293 "../src/SearchFilter.vala"
		text_action_unref (old);
#line 3779 "SearchFilter.c"
	}
}

void
value_take_text_action (GValue* value,
                        gpointer v_object)
{
	TextAction * old;
#line 293 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEXT_ACTION));
#line 293 "../src/SearchFilter.vala"
	old = value->data[0].v_pointer;
#line 293 "../src/SearchFilter.vala"
	if (v_object) {
#line 293 "../src/SearchFilter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEXT_ACTION));
#line 293 "../src/SearchFilter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 293 "../src/SearchFilter.vala"
		value->data[0].v_pointer = v_object;
#line 3800 "SearchFilter.c"
	} else {
#line 293 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 3804 "SearchFilter.c"
	}
#line 293 "../src/SearchFilter.vala"
	if (old) {
#line 293 "../src/SearchFilter.vala"
		text_action_unref (old);
#line 3810 "SearchFilter.c"
	}
}

static void
text_action_class_init (TextActionClass * klass,
                        gpointer klass_data)
{
#line 293 "../src/SearchFilter.vala"
	text_action_parent_class = g_type_class_peek_parent (klass);
#line 293 "../src/SearchFilter.vala"
	((TextActionClass *) klass)->finalize = text_action_finalize;
#line 293 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &TextAction_private_offset);
#line 293 "../src/SearchFilter.vala"
	text_action_signals[TEXT_ACTION_TEXT_CHANGED_SIGNAL] = g_signal_new ("text-changed", TYPE_TEXT_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 293 "../src/SearchFilter.vala"
	text_action_signals[TEXT_ACTION_SENSITIVITY_CHANGED_SIGNAL] = g_signal_new ("sensitivity-changed", TYPE_TEXT_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 293 "../src/SearchFilter.vala"
	text_action_signals[TEXT_ACTION_VISIBILITY_CHANGED_SIGNAL] = g_signal_new ("visibility-changed", TYPE_TEXT_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 3830 "SearchFilter.c"
}

static void
text_action_instance_init (TextAction * self,
                           gpointer klass)
{
#line 293 "../src/SearchFilter.vala"
	self->priv = text_action_get_instance_private (self);
#line 300 "../src/SearchFilter.vala"
	self->priv->text = NULL;
#line 301 "../src/SearchFilter.vala"
	self->priv->sensitive = TRUE;
#line 302 "../src/SearchFilter.vala"
	self->priv->visible = TRUE;
#line 293 "../src/SearchFilter.vala"
	self->ref_count = 1;
#line 3847 "SearchFilter.c"
}

static void
text_action_finalize (TextAction * obj)
{
	TextAction * self;
#line 293 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TEXT_ACTION, TextAction);
#line 293 "../src/SearchFilter.vala"
	g_signal_handlers_destroy (self);
#line 300 "../src/SearchFilter.vala"
	_g_free0 (self->priv->text);
#line 3860 "SearchFilter.c"
}

static GType
text_action_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_text_action_init, value_text_action_free_value, value_text_action_copy_value, value_text_action_peek_pointer, "p", value_text_action_collect_value, "p", value_text_action_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TextActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) text_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TextAction), 0, (GInstanceInitFunc) text_action_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType text_action_type_id;
	text_action_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TextAction", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TextAction_private_offset = g_type_add_instance_private (text_action_type_id, sizeof (TextActionPrivate));
	return text_action_type_id;
}

GType
text_action_get_type (void)
{
	static volatile gsize text_action_type_id__volatile = 0;
	if (g_once_init_enter (&text_action_type_id__volatile)) {
		GType text_action_type_id;
		text_action_type_id = text_action_get_type_once ();
		g_once_init_leave (&text_action_type_id__volatile, text_action_type_id);
	}
	return text_action_type_id__volatile;
}

gpointer
text_action_ref (gpointer instance)
{
	TextAction * self;
	self = instance;
#line 293 "../src/SearchFilter.vala"
	g_atomic_int_inc (&self->ref_count);
#line 293 "../src/SearchFilter.vala"
	return instance;
#line 3896 "SearchFilter.c"
}

void
text_action_unref (gpointer instance)
{
	TextAction * self;
	self = instance;
#line 293 "../src/SearchFilter.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 293 "../src/SearchFilter.vala"
		TEXT_ACTION_GET_CLASS (self)->finalize (self);
#line 293 "../src/SearchFilter.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3910 "SearchFilter.c"
	}
}

static inline gpointer
search_filter_actions_get_instance_private (SearchFilterActions* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterActions_private_offset);
}

static void
_search_filter_actions_on_action_radio_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 548 "../src/SearchFilter.vala"
	search_filter_actions_on_action_radio ((SearchFilterActions*) self, action, parameter);
#line 3927 "SearchFilter.c"
}

static void
_search_filter_actions_on_rating_changed_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                               GVariant* value,
                                                                               gpointer self)
{
#line 548 "../src/SearchFilter.vala"
	search_filter_actions_on_rating_changed ((SearchFilterActions*) self, action, value);
#line 3937 "SearchFilter.c"
}

static void
_search_filter_actions_on_action_toggle_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 548 "../src/SearchFilter.vala"
	search_filter_actions_on_action_toggle ((SearchFilterActions*) self, action, parameter);
#line 3947 "SearchFilter.c"
}

static void
_search_filter_actions_on_flagged_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                GVariant* value,
                                                                                gpointer self)
{
#line 548 "../src/SearchFilter.vala"
	search_filter_actions_on_flagged_toggled ((SearchFilterActions*) self, action, value);
#line 3957 "SearchFilter.c"
}

static void
_search_filter_actions_on_photos_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                               GVariant* value,
                                                                               gpointer self)
{
#line 548 "../src/SearchFilter.vala"
	search_filter_actions_on_photos_toggled ((SearchFilterActions*) self, action, value);
#line 3967 "SearchFilter.c"
}

static void
_search_filter_actions_on_videos_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                               GVariant* value,
                                                                               gpointer self)
{
#line 548 "../src/SearchFilter.vala"
	search_filter_actions_on_videos_toggled ((SearchFilterActions*) self, action, value);
#line 3977 "SearchFilter.c"
}

static void
_search_filter_actions_on_raw_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                            GVariant* value,
                                                                            gpointer self)
{
#line 548 "../src/SearchFilter.vala"
	search_filter_actions_on_raw_toggled ((SearchFilterActions*) self, action, value);
#line 3987 "SearchFilter.c"
}

static void
_search_filter_actions_on_text_changed_text_action_text_changed (TextAction* _sender,
                                                                 const gchar* text,
                                                                 gpointer self)
{
#line 426 "../src/SearchFilter.vala"
	search_filter_actions_on_text_changed ((SearchFilterActions*) self, _sender, text);
#line 3997 "SearchFilter.c"
}

SearchFilterActions*
search_filter_actions_construct (GType object_type)
{
	SearchFilterActions* self = NULL;
	TextAction* _tmp0_;
	TextAction* _tmp1_;
#line 422 "../src/SearchFilter.vala"
	self = (SearchFilterActions*) g_type_create_instance (object_type);
#line 424 "../src/SearchFilter.vala"
	search_filter_actions_register (self);
#line 426 "../src/SearchFilter.vala"
	_tmp0_ = search_filter_actions_get_text (self);
#line 426 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_;
#line 426 "../src/SearchFilter.vala"
	g_signal_connect (_tmp1_, "text-changed", (GCallback) _search_filter_actions_on_text_changed_text_action_text_changed, self);
#line 422 "../src/SearchFilter.vala"
	return self;
#line 4018 "SearchFilter.c"
}

SearchFilterActions*
search_filter_actions_new (void)
{
#line 422 "../src/SearchFilter.vala"
	return search_filter_actions_construct (TYPE_SEARCH_FILTER_ACTIONS);
#line 4026 "SearchFilter.c"
}

SearchFilterCriteria
search_filter_actions_get_criteria (SearchFilterActions* self)
{
	SearchFilterCriteria result = 0U;
#line 429 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), 0U);
#line 430 "../src/SearchFilter.vala"
	result = self->priv->criteria;
#line 430 "../src/SearchFilter.vala"
	return result;
#line 4039 "SearchFilter.c"
}

GActionEntry*
search_filter_actions_get_actions (SearchFilterActions* self,
                                   gint* result_length1)
{
	GActionEntry* _tmp0_;
	gint _tmp0__length1;
	GActionEntry* result = NULL;
#line 433 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
#line 434 "../src/SearchFilter.vala"
	_tmp0_ = SEARCH_FILTER_ACTIONS_entries;
#line 434 "../src/SearchFilter.vala"
	_tmp0__length1 = G_N_ELEMENTS (SEARCH_FILTER_ACTIONS_entries);
#line 434 "../src/SearchFilter.vala"
	if (result_length1) {
#line 434 "../src/SearchFilter.vala"
		*result_length1 = _tmp0__length1;
#line 4059 "SearchFilter.c"
	}
#line 434 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 434 "../src/SearchFilter.vala"
	return result;
#line 4065 "SearchFilter.c"
}

GSimpleAction*
search_filter_actions_get_action (SearchFilterActions* self,
                                  const gchar* name)
{
	LibraryWindow* lw = NULL;
	AppWindow* _tmp0_;
	LibraryWindow* _tmp1_;
	LibraryWindow* _tmp2_;
	GSimpleAction* result = NULL;
#line 437 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
#line 437 "../src/SearchFilter.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 438 "../src/SearchFilter.vala"
	_tmp0_ = app_window_get_instance ();
#line 438 "../src/SearchFilter.vala"
	_tmp1_ = IS_LIBRARY_WINDOW (_tmp0_) ? ((LibraryWindow*) _tmp0_) : NULL;
#line 438 "../src/SearchFilter.vala"
	if (_tmp1_ == NULL) {
#line 438 "../src/SearchFilter.vala"
		_g_object_unref0 (_tmp0_);
#line 4089 "SearchFilter.c"
	}
#line 438 "../src/SearchFilter.vala"
	lw = _tmp1_;
#line 439 "../src/SearchFilter.vala"
	_tmp2_ = lw;
#line 439 "../src/SearchFilter.vala"
	if (_tmp2_ != NULL) {
#line 4097 "SearchFilter.c"
		LibraryWindow* _tmp3_;
		GAction* _tmp4_;
#line 440 "../src/SearchFilter.vala"
		_tmp3_ = lw;
#line 440 "../src/SearchFilter.vala"
		_tmp4_ = g_action_map_lookup_action (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_action_map_get_type (), GActionMap), name);
#line 440 "../src/SearchFilter.vala"
		result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp4_) : NULL;
#line 440 "../src/SearchFilter.vala"
		_g_object_unref0 (lw);
#line 440 "../src/SearchFilter.vala"
		return result;
#line 4110 "SearchFilter.c"
	}
#line 443 "../src/SearchFilter.vala"
	result = NULL;
#line 443 "../src/SearchFilter.vala"
	_g_object_unref0 (lw);
#line 443 "../src/SearchFilter.vala"
	return result;
#line 4118 "SearchFilter.c"
}

void
search_filter_actions_set_action_sensitive (SearchFilterActions* self,
                                            const gchar* name,
                                            gboolean sensitive)
{
	GSimpleAction* action = NULL;
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
#line 447 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 447 "../src/SearchFilter.vala"
	g_return_if_fail (name != NULL);
#line 448 "../src/SearchFilter.vala"
	_tmp0_ = search_filter_actions_get_action (self, name);
#line 448 "../src/SearchFilter.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 448 "../src/SearchFilter.vala"
	action = _tmp1_;
#line 449 "../src/SearchFilter.vala"
	_tmp2_ = action;
#line 449 "../src/SearchFilter.vala"
	if (_tmp2_ != NULL) {
#line 4144 "SearchFilter.c"
		GSimpleAction* _tmp3_;
#line 450 "../src/SearchFilter.vala"
		_tmp3_ = action;
#line 450 "../src/SearchFilter.vala"
		g_simple_action_set_enabled (_tmp3_, sensitive);
#line 4150 "SearchFilter.c"
	}
#line 447 "../src/SearchFilter.vala"
	_g_object_unref0 (action);
#line 4154 "SearchFilter.c"
}

static GVariant*
_variant_new30 (gboolean value)
{
#line 455 "../src/SearchFilter.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4162 "SearchFilter.c"
}

static GVariant*
_variant_new31 (gboolean value)
{
#line 456 "../src/SearchFilter.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4170 "SearchFilter.c"
}

static GVariant*
_variant_new32 (gboolean value)
{
#line 457 "../src/SearchFilter.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4178 "SearchFilter.c"
}

static GVariant*
_variant_new33 (gboolean value)
{
#line 458 "../src/SearchFilter.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4186 "SearchFilter.c"
}

static GVariant*
_variant_new34 (gchar* value)
{
#line 459 "../src/SearchFilter.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 4194 "SearchFilter.c"
}

void
search_filter_actions_reset (SearchFilterActions* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GVariant* _tmp2_;
	GSimpleAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GVariant* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GVariant* _tmp8_;
	GSimpleAction* _tmp9_;
	GSimpleAction* _tmp10_;
	GVariant* _tmp11_;
	GVariant* v = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	GSimpleAction* _tmp16_;
	GSimpleAction* _tmp17_;
	TextAction* _tmp18_;
	TextAction* _tmp19_;
#line 454 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 455 "../src/SearchFilter.vala"
	_tmp0_ = search_filter_actions_get_flagged (self);
#line 455 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_;
#line 455 "../src/SearchFilter.vala"
	_tmp2_ = _variant_new30 (FALSE);
#line 455 "../src/SearchFilter.vala"
	g_signal_emit_by_name (_tmp1_, "change-state", _tmp2_);
#line 455 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp2_);
#line 456 "../src/SearchFilter.vala"
	_tmp3_ = search_filter_actions_get_photos (self);
#line 456 "../src/SearchFilter.vala"
	_tmp4_ = _tmp3_;
#line 456 "../src/SearchFilter.vala"
	_tmp5_ = _variant_new31 (FALSE);
#line 456 "../src/SearchFilter.vala"
	g_signal_emit_by_name (_tmp4_, "change-state", _tmp5_);
#line 456 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp5_);
#line 457 "../src/SearchFilter.vala"
	_tmp6_ = search_filter_actions_get_raw (self);
#line 457 "../src/SearchFilter.vala"
	_tmp7_ = _tmp6_;
#line 457 "../src/SearchFilter.vala"
	_tmp8_ = _variant_new32 (FALSE);
#line 457 "../src/SearchFilter.vala"
	g_signal_emit_by_name (_tmp7_, "change-state", _tmp8_);
#line 457 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp8_);
#line 458 "../src/SearchFilter.vala"
	_tmp9_ = search_filter_actions_get_videos (self);
#line 458 "../src/SearchFilter.vala"
	_tmp10_ = _tmp9_;
#line 458 "../src/SearchFilter.vala"
	_tmp11_ = _variant_new33 (FALSE);
#line 458 "../src/SearchFilter.vala"
	g_signal_emit_by_name (_tmp10_, "change-state", _tmp11_);
#line 458 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp11_);
#line 459 "../src/SearchFilter.vala"
	_tmp12_ = g_strdup_printf ("%d", (gint) RATING_FILTER_UNRATED_OR_HIGHER);
#line 459 "../src/SearchFilter.vala"
	_tmp13_ = _tmp12_;
#line 459 "../src/SearchFilter.vala"
	_tmp14_ = _variant_new34 (_tmp13_);
#line 459 "../src/SearchFilter.vala"
	_tmp15_ = _tmp14_;
#line 459 "../src/SearchFilter.vala"
	_g_free0 (_tmp13_);
#line 459 "../src/SearchFilter.vala"
	v = _tmp15_;
#line 460 "../src/SearchFilter.vala"
	_tmp16_ = search_filter_actions_get_rating (self);
#line 460 "../src/SearchFilter.vala"
	_tmp17_ = _tmp16_;
#line 460 "../src/SearchFilter.vala"
	g_signal_emit_by_name (_tmp17_, "change-state", v);
#line 462 "../src/SearchFilter.vala"
	_tmp18_ = search_filter_actions_get_text (self);
#line 462 "../src/SearchFilter.vala"
	_tmp19_ = _tmp18_;
#line 462 "../src/SearchFilter.vala"
	text_action_set_text (_tmp19_, NULL);
#line 454 "../src/SearchFilter.vala"
	_g_variant_unref0 (v);
#line 4289 "SearchFilter.c"
}

void
search_filter_actions_set_sensitive_for_search_criteria (SearchFilterActions* self,
                                                         SearchFilterCriteria criteria)
{
#line 465 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 466 "../src/SearchFilter.vala"
	self->priv->criteria = criteria;
#line 467 "../src/SearchFilter.vala"
	search_filter_actions_update_sensitivities (self);
#line 470 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_CRITERIA_CHANGED_SIGNAL], 0);
#line 4304 "SearchFilter.c"
}

static void
_search_filter_actions_on_media_tracker_updated_core_tracker_updated (CoreTracker* _sender,
                                                                      gpointer self)
{
#line 478 "../src/SearchFilter.vala"
	search_filter_actions_on_media_tracker_updated ((SearchFilterActions*) self, _sender);
#line 4313 "SearchFilter.c"
}

static void
_search_filter_actions_on_camera_tracker_updated_core_tracker_updated (CoreTracker* _sender,
                                                                       gpointer self)
{
#line 480 "../src/SearchFilter.vala"
	search_filter_actions_on_camera_tracker_updated ((SearchFilterActions*) self, _sender);
#line 4322 "SearchFilter.c"
}

void
search_filter_actions_monitor_page_contents (SearchFilterActions* self,
                                             Page* old_page,
                                             Page* new_page)
{
	CheckerboardPage* old_tracked_page = NULL;
	CheckerboardPage* _tmp0_;
	CheckerboardPage* _tmp1_;
	CheckerboardPage* new_tracked_page = NULL;
	CheckerboardPage* _tmp10_;
	CheckerboardPage* _tmp11_;
#line 473 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 473 "../src/SearchFilter.vala"
	g_return_if_fail ((old_page == NULL) || IS_PAGE (old_page));
#line 473 "../src/SearchFilter.vala"
	g_return_if_fail ((new_page == NULL) || IS_PAGE (new_page));
#line 474 "../src/SearchFilter.vala"
	_tmp0_ = _g_object_ref0 (IS_CHECKERBOARD_PAGE (old_page) ? ((CheckerboardPage*) old_page) : NULL);
#line 474 "../src/SearchFilter.vala"
	old_tracked_page = _tmp0_;
#line 475 "../src/SearchFilter.vala"
	_tmp1_ = old_tracked_page;
#line 475 "../src/SearchFilter.vala"
	if (_tmp1_ != NULL) {
#line 4350 "SearchFilter.c"
		CoreViewTracker* tracker = NULL;
		CheckerboardPage* _tmp2_;
		CoreViewTracker* _tmp3_;
		CoreViewTracker* _tmp4_;
#line 476 "../src/SearchFilter.vala"
		_tmp2_ = old_tracked_page;
#line 476 "../src/SearchFilter.vala"
		_tmp3_ = checkerboard_page_get_view_tracker (_tmp2_);
#line 476 "../src/SearchFilter.vala"
		tracker = _tmp3_;
#line 477 "../src/SearchFilter.vala"
		_tmp4_ = tracker;
#line 477 "../src/SearchFilter.vala"
		if (IS_MEDIA_VIEW_TRACKER (_tmp4_)) {
#line 4365 "SearchFilter.c"
			CoreViewTracker* _tmp5_;
			guint _tmp6_;
#line 478 "../src/SearchFilter.vala"
			_tmp5_ = tracker;
#line 478 "../src/SearchFilter.vala"
			g_signal_parse_name ("updated", CORE_TYPE_TRACKER, &_tmp6_, NULL, FALSE);
#line 478 "../src/SearchFilter.vala"
			g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, CORE_TYPE_TRACKER, CoreTracker), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _search_filter_actions_on_media_tracker_updated_core_tracker_updated, self);
#line 4374 "SearchFilter.c"
		} else {
			CoreViewTracker* _tmp7_;
#line 479 "../src/SearchFilter.vala"
			_tmp7_ = tracker;
#line 479 "../src/SearchFilter.vala"
			if (IS_CAMERA_VIEW_TRACKER (_tmp7_)) {
#line 4381 "SearchFilter.c"
				CoreViewTracker* _tmp8_;
				guint _tmp9_;
#line 480 "../src/SearchFilter.vala"
				_tmp8_ = tracker;
#line 480 "../src/SearchFilter.vala"
				g_signal_parse_name ("updated", CORE_TYPE_TRACKER, &_tmp9_, NULL, FALSE);
#line 480 "../src/SearchFilter.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, CORE_TYPE_TRACKER, CoreTracker), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _search_filter_actions_on_camera_tracker_updated_core_tracker_updated, self);
#line 4390 "SearchFilter.c"
			}
		}
#line 475 "../src/SearchFilter.vala"
		_core_tracker_unref0 (tracker);
#line 4395 "SearchFilter.c"
	}
#line 483 "../src/SearchFilter.vala"
	_tmp10_ = _g_object_ref0 (IS_CHECKERBOARD_PAGE (new_page) ? ((CheckerboardPage*) new_page) : NULL);
#line 483 "../src/SearchFilter.vala"
	new_tracked_page = _tmp10_;
#line 484 "../src/SearchFilter.vala"
	_tmp11_ = new_tracked_page;
#line 484 "../src/SearchFilter.vala"
	if (_tmp11_ != NULL) {
#line 4405 "SearchFilter.c"
		CoreViewTracker* tracker = NULL;
		CheckerboardPage* _tmp12_;
		CoreViewTracker* _tmp13_;
		CoreViewTracker* _tmp14_;
#line 485 "../src/SearchFilter.vala"
		self->priv->can_filter_by_stars = TRUE;
#line 487 "../src/SearchFilter.vala"
		_tmp12_ = new_tracked_page;
#line 487 "../src/SearchFilter.vala"
		_tmp13_ = checkerboard_page_get_view_tracker (_tmp12_);
#line 487 "../src/SearchFilter.vala"
		tracker = _tmp13_;
#line 488 "../src/SearchFilter.vala"
		_tmp14_ = tracker;
#line 488 "../src/SearchFilter.vala"
		if (IS_MEDIA_VIEW_TRACKER (_tmp14_)) {
#line 4422 "SearchFilter.c"
			CoreViewTracker* _tmp15_;
			CoreViewTracker* _tmp16_;
#line 489 "../src/SearchFilter.vala"
			_tmp15_ = tracker;
#line 489 "../src/SearchFilter.vala"
			g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, CORE_TYPE_TRACKER, CoreTracker), "updated", (GCallback) _search_filter_actions_on_media_tracker_updated_core_tracker_updated, self);
#line 490 "../src/SearchFilter.vala"
			_tmp16_ = tracker;
#line 490 "../src/SearchFilter.vala"
			search_filter_actions_on_media_tracker_updated (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, CORE_TYPE_TRACKER, CoreTracker));
#line 492 "../src/SearchFilter.vala"
			_core_tracker_unref0 (tracker);
#line 492 "../src/SearchFilter.vala"
			_g_object_unref0 (new_tracked_page);
#line 492 "../src/SearchFilter.vala"
			_g_object_unref0 (old_tracked_page);
#line 492 "../src/SearchFilter.vala"
			return;
#line 4441 "SearchFilter.c"
		} else {
			CoreViewTracker* _tmp17_;
#line 493 "../src/SearchFilter.vala"
			_tmp17_ = tracker;
#line 493 "../src/SearchFilter.vala"
			if (IS_CAMERA_VIEW_TRACKER (_tmp17_)) {
#line 4448 "SearchFilter.c"
				CoreViewTracker* _tmp18_;
				CoreViewTracker* _tmp19_;
#line 494 "../src/SearchFilter.vala"
				_tmp18_ = tracker;
#line 494 "../src/SearchFilter.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, CORE_TYPE_TRACKER, CoreTracker), "updated", (GCallback) _search_filter_actions_on_camera_tracker_updated_core_tracker_updated, self);
#line 495 "../src/SearchFilter.vala"
				_tmp19_ = tracker;
#line 495 "../src/SearchFilter.vala"
				search_filter_actions_on_camera_tracker_updated (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, CORE_TYPE_TRACKER, CoreTracker));
#line 497 "../src/SearchFilter.vala"
				_core_tracker_unref0 (tracker);
#line 497 "../src/SearchFilter.vala"
				_g_object_unref0 (new_tracked_page);
#line 497 "../src/SearchFilter.vala"
				_g_object_unref0 (old_tracked_page);
#line 497 "../src/SearchFilter.vala"
				return;
#line 4467 "SearchFilter.c"
			}
		}
#line 484 "../src/SearchFilter.vala"
		_core_tracker_unref0 (tracker);
#line 4472 "SearchFilter.c"
	}
#line 502 "../src/SearchFilter.vala"
	self->priv->has_flagged = FALSE;
#line 503 "../src/SearchFilter.vala"
	self->priv->has_photos = FALSE;
#line 504 "../src/SearchFilter.vala"
	self->priv->has_videos = FALSE;
#line 505 "../src/SearchFilter.vala"
	self->priv->has_raw = FALSE;
#line 506 "../src/SearchFilter.vala"
	self->priv->can_filter_by_stars = FALSE;
#line 508 "../src/SearchFilter.vala"
	search_filter_actions_update_sensitivities (self);
#line 473 "../src/SearchFilter.vala"
	_g_object_unref0 (new_tracked_page);
#line 473 "../src/SearchFilter.vala"
	_g_object_unref0 (old_tracked_page);
#line 4490 "SearchFilter.c"
}

static gpointer
_core_tracker_ref0 (gpointer self)
{
#line 512 "../src/SearchFilter.vala"
	return self ? core_tracker_ref (self) : NULL;
#line 4498 "SearchFilter.c"
}

static void
search_filter_actions_on_media_tracker_updated (SearchFilterActions* self,
                                                CoreTracker* t)
{
	MediaViewTracker* tracker = NULL;
	MediaViewTracker* _tmp0_;
	MediaAccumulator* _tmp1_;
	MediaAccumulator* _tmp2_;
	MediaAccumulator* _tmp3_;
	MediaAccumulator* _tmp4_;
#line 511 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 511 "../src/SearchFilter.vala"
	g_return_if_fail (CORE_IS_TRACKER (t));
#line 512 "../src/SearchFilter.vala"
	_tmp0_ = _core_tracker_ref0 (G_TYPE_CHECK_INSTANCE_CAST (t, TYPE_MEDIA_VIEW_TRACKER, MediaViewTracker));
#line 512 "../src/SearchFilter.vala"
	tracker = _tmp0_;
#line 514 "../src/SearchFilter.vala"
	_tmp1_ = tracker->all;
#line 514 "../src/SearchFilter.vala"
	self->priv->has_flagged = _tmp1_->flagged > 0;
#line 515 "../src/SearchFilter.vala"
	_tmp2_ = tracker->all;
#line 515 "../src/SearchFilter.vala"
	self->priv->has_photos = _tmp2_->photos > 0;
#line 516 "../src/SearchFilter.vala"
	_tmp3_ = tracker->all;
#line 516 "../src/SearchFilter.vala"
	self->priv->has_videos = _tmp3_->videos > 0;
#line 517 "../src/SearchFilter.vala"
	_tmp4_ = tracker->all;
#line 517 "../src/SearchFilter.vala"
	self->priv->has_raw = _tmp4_->raw > 0;
#line 519 "../src/SearchFilter.vala"
	search_filter_actions_update_sensitivities (self);
#line 511 "../src/SearchFilter.vala"
	_core_tracker_unref0 (tracker);
#line 4539 "SearchFilter.c"
}

static void
search_filter_actions_on_camera_tracker_updated (SearchFilterActions* self,
                                                 CoreTracker* t)
{
	CameraViewTracker* tracker = NULL;
	CameraViewTracker* _tmp0_;
	CameraAccumulator* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	CameraAccumulator* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	CameraAccumulator* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 522 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 522 "../src/SearchFilter.vala"
	g_return_if_fail (CORE_IS_TRACKER (t));
#line 523 "../src/SearchFilter.vala"
	_tmp0_ = _core_tracker_ref0 (G_TYPE_CHECK_INSTANCE_CAST (t, TYPE_CAMERA_VIEW_TRACKER, CameraViewTracker));
#line 523 "../src/SearchFilter.vala"
	tracker = _tmp0_;
#line 525 "../src/SearchFilter.vala"
	self->priv->has_flagged = FALSE;
#line 526 "../src/SearchFilter.vala"
	_tmp1_ = tracker->all;
#line 526 "../src/SearchFilter.vala"
	_tmp2_ = camera_accumulator_get_photos (_tmp1_);
#line 526 "../src/SearchFilter.vala"
	_tmp3_ = _tmp2_;
#line 526 "../src/SearchFilter.vala"
	self->priv->has_photos = _tmp3_ > 0;
#line 527 "../src/SearchFilter.vala"
	_tmp4_ = tracker->all;
#line 527 "../src/SearchFilter.vala"
	_tmp5_ = camera_accumulator_get_videos (_tmp4_);
#line 527 "../src/SearchFilter.vala"
	_tmp6_ = _tmp5_;
#line 527 "../src/SearchFilter.vala"
	self->priv->has_videos = _tmp6_ > 0;
#line 528 "../src/SearchFilter.vala"
	_tmp7_ = tracker->all;
#line 528 "../src/SearchFilter.vala"
	_tmp8_ = camera_accumulator_get_raw (_tmp7_);
#line 528 "../src/SearchFilter.vala"
	_tmp9_ = _tmp8_;
#line 528 "../src/SearchFilter.vala"
	self->priv->has_raw = _tmp9_ > 0;
#line 530 "../src/SearchFilter.vala"
	search_filter_actions_update_sensitivities (self);
#line 522 "../src/SearchFilter.vala"
	_core_tracker_unref0 (tracker);
#line 4595 "SearchFilter.c"
}

static void
search_filter_actions_update_sensitivities (SearchFilterActions* self)
{
	gboolean allow_ratings = FALSE;
	TextAction* _tmp0_;
	TextAction* _tmp1_;
#line 533 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 534 "../src/SearchFilter.vala"
	allow_ratings = (SEARCH_FILTER_CRITERIA_RATING & self->priv->criteria) != 0;
#line 535 "../src/SearchFilter.vala"
	search_filter_actions_set_action_sensitive (self, "display.rating", allow_ratings & self->priv->can_filter_by_stars);
#line 539 "../src/SearchFilter.vala"
	_tmp0_ = search_filter_actions_get_text (self);
#line 539 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_;
#line 539 "../src/SearchFilter.vala"
	text_action_set_sensitive (_tmp1_, TRUE);
#line 541 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_MEDIA_CONTEXT_CHANGED_SIGNAL], 0, self->priv->has_photos, self->priv->has_videos, self->priv->has_raw, self->priv->has_flagged);
#line 4618 "SearchFilter.c"
}

static void
search_filter_actions_on_text_changed (SearchFilterActions* self,
                                       TextAction* action,
                                       const gchar* text)
{
#line 544 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 544 "../src/SearchFilter.vala"
	g_return_if_fail (IS_TEXT_ACTION (action));
#line 545 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_TEXT_CHANGED_SIGNAL], 0, text);
#line 4632 "SearchFilter.c"
}

static void
search_filter_actions_on_action_radio (SearchFilterActions* self,
                                       GSimpleAction* action,
                                       GVariant* parameter)
{
#line 556 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 556 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 558 "../src/SearchFilter.vala"
	g_signal_emit_by_name (action, "change-state", parameter);
#line 4646 "SearchFilter.c"
}

static gboolean
_variant_get3 (GVariant* value)
{
#line 563 "../src/SearchFilter.vala"
	return g_variant_get_boolean (value);
#line 4654 "SearchFilter.c"
}

static GVariant*
_variant_new35 (gboolean value)
{
#line 564 "../src/SearchFilter.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4662 "SearchFilter.c"
}

static void
search_filter_actions_on_action_toggle (SearchFilterActions* self,
                                        GSimpleAction* action,
                                        GVariant* parameter)
{
	gboolean state = FALSE;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GVariant* _tmp4_;
#line 561 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 561 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 563 "../src/SearchFilter.vala"
	_tmp0_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (action, g_action_get_type (), GAction));
#line 563 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_;
#line 563 "../src/SearchFilter.vala"
	_tmp2_ = _variant_get3 (_tmp1_);
#line 563 "../src/SearchFilter.vala"
	_tmp3_ = _tmp2_;
#line 563 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp1_);
#line 563 "../src/SearchFilter.vala"
	state = _tmp3_;
#line 564 "../src/SearchFilter.vala"
	_tmp4_ = _variant_new35 (!state);
#line 564 "../src/SearchFilter.vala"
	g_signal_emit_by_name (action, "change-state", _tmp4_);
#line 564 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp4_);
#line 4698 "SearchFilter.c"
}

static void
search_filter_actions_register (SearchFilterActions* self)
{
	TextAction* _tmp0_;
#line 567 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 568 "../src/SearchFilter.vala"
	_tmp0_ = text_action_new (NULL);
#line 568 "../src/SearchFilter.vala"
	_text_action_unref0 (self->priv->_text);
#line 568 "../src/SearchFilter.vala"
	self->priv->_text = _tmp0_;
#line 4713 "SearchFilter.c"
}

static void
search_filter_actions_on_rating_changed (SearchFilterActions* self,
                                         GSimpleAction* action,
                                         GVariant* value)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	RatingFilter filter = 0;
	const gchar* _tmp5_;
#line 571 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 571 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 571 "../src/SearchFilter.vala"
	g_return_if_fail (value != NULL);
#line 573 "../src/SearchFilter.vala"
	_tmp0_ = g_variant_get_string (value, NULL);
#line 573 "../src/SearchFilter.vala"
	_tmp1_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (action, g_action_get_type (), GAction));
#line 573 "../src/SearchFilter.vala"
	_tmp2_ = _tmp1_;
#line 573 "../src/SearchFilter.vala"
	_tmp3_ = g_variant_get_string (_tmp2_, NULL);
#line 573 "../src/SearchFilter.vala"
	_tmp4_ = g_strcmp0 (_tmp0_, _tmp3_) == 0;
#line 573 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp2_);
#line 573 "../src/SearchFilter.vala"
	if (_tmp4_) {
#line 574 "../src/SearchFilter.vala"
		return;
#line 4750 "SearchFilter.c"
	}
#line 576 "../src/SearchFilter.vala"
	_tmp5_ = g_variant_get_string (value, NULL);
#line 576 "../src/SearchFilter.vala"
	filter = (RatingFilter) atoi (_tmp5_);
#line 577 "../src/SearchFilter.vala"
	g_simple_action_set_state (action, value);
#line 578 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_RATING_CHANGED_SIGNAL], 0, filter);
#line 4760 "SearchFilter.c"
}

static void
search_filter_actions_on_flagged_toggled (SearchFilterActions* self,
                                          GSimpleAction* action,
                                          GVariant* value)
{
#line 581 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 581 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 581 "../src/SearchFilter.vala"
	g_return_if_fail (value != NULL);
#line 583 "../src/SearchFilter.vala"
	g_simple_action_set_state (action, value);
#line 584 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_FLAGGED_TOGGLED_SIGNAL], 0, g_variant_get_boolean (value));
#line 4778 "SearchFilter.c"
}

static void
search_filter_actions_on_photos_toggled (SearchFilterActions* self,
                                         GSimpleAction* action,
                                         GVariant* value)
{
#line 587 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 587 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 587 "../src/SearchFilter.vala"
	g_return_if_fail (value != NULL);
#line 589 "../src/SearchFilter.vala"
	g_simple_action_set_state (action, value);
#line 590 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_PHOTOS_TOGGLED_SIGNAL], 0, g_variant_get_boolean (value));
#line 4796 "SearchFilter.c"
}

static void
search_filter_actions_on_videos_toggled (SearchFilterActions* self,
                                         GSimpleAction* action,
                                         GVariant* value)
{
#line 593 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 593 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 593 "../src/SearchFilter.vala"
	g_return_if_fail (value != NULL);
#line 595 "../src/SearchFilter.vala"
	g_simple_action_set_state (action, value);
#line 596 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_VIDEOS_TOGGLED_SIGNAL], 0, g_variant_get_boolean (value));
#line 4814 "SearchFilter.c"
}

static void
search_filter_actions_on_raw_toggled (SearchFilterActions* self,
                                      GSimpleAction* action,
                                      GVariant* value)
{
#line 599 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
#line 599 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 599 "../src/SearchFilter.vala"
	g_return_if_fail (value != NULL);
#line 601 "../src/SearchFilter.vala"
	g_simple_action_set_state (action, value);
#line 602 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_RAW_TOGGLED_SIGNAL], 0, g_variant_get_boolean (value));
#line 4832 "SearchFilter.c"
}

gboolean
search_filter_actions_get_has_photos (SearchFilterActions* self)
{
	gboolean result = FALSE;
#line 605 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), FALSE);
#line 606 "../src/SearchFilter.vala"
	result = self->priv->has_photos;
#line 606 "../src/SearchFilter.vala"
	return result;
#line 4845 "SearchFilter.c"
}

gboolean
search_filter_actions_get_has_videos (SearchFilterActions* self)
{
	gboolean result = FALSE;
#line 609 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), FALSE);
#line 610 "../src/SearchFilter.vala"
	result = self->priv->has_videos;
#line 610 "../src/SearchFilter.vala"
	return result;
#line 4858 "SearchFilter.c"
}

gboolean
search_filter_actions_get_has_raw (SearchFilterActions* self)
{
	gboolean result = FALSE;
#line 613 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), FALSE);
#line 614 "../src/SearchFilter.vala"
	result = self->priv->has_raw;
#line 614 "../src/SearchFilter.vala"
	return result;
#line 4871 "SearchFilter.c"
}

gboolean
search_filter_actions_get_has_flagged (SearchFilterActions* self)
{
	gboolean result = FALSE;
#line 617 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), FALSE);
#line 618 "../src/SearchFilter.vala"
	result = self->priv->has_flagged;
#line 618 "../src/SearchFilter.vala"
	return result;
#line 4884 "SearchFilter.c"
}

GSimpleAction*
search_filter_actions_get_flagged (SearchFilterActions* self)
{
	GSimpleAction* result;
	GSimpleAction* _tmp0_;
#line 351 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
#line 352 "../src/SearchFilter.vala"
	_tmp0_ = search_filter_actions_get_action (self, "display.flagged");
#line 352 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 352 "../src/SearchFilter.vala"
	return result;
#line 4900 "SearchFilter.c"
}

GSimpleAction*
search_filter_actions_get_photos (SearchFilterActions* self)
{
	GSimpleAction* result;
	GSimpleAction* _tmp0_;
#line 357 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
#line 358 "../src/SearchFilter.vala"
	_tmp0_ = search_filter_actions_get_action (self, "display.photos");
#line 358 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 358 "../src/SearchFilter.vala"
	return result;
#line 4916 "SearchFilter.c"
}

GSimpleAction*
search_filter_actions_get_videos (SearchFilterActions* self)
{
	GSimpleAction* result;
	GSimpleAction* _tmp0_;
#line 363 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
#line 364 "../src/SearchFilter.vala"
	_tmp0_ = search_filter_actions_get_action (self, "display.videos");
#line 364 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 364 "../src/SearchFilter.vala"
	return result;
#line 4932 "SearchFilter.c"
}

GSimpleAction*
search_filter_actions_get_raw (SearchFilterActions* self)
{
	GSimpleAction* result;
	GSimpleAction* _tmp0_;
#line 369 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
#line 370 "../src/SearchFilter.vala"
	_tmp0_ = search_filter_actions_get_action (self, "display.raw");
#line 370 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 370 "../src/SearchFilter.vala"
	return result;
#line 4948 "SearchFilter.c"
}

GSimpleAction*
search_filter_actions_get_rating (SearchFilterActions* self)
{
	GSimpleAction* result;
	GSimpleAction* _tmp0_;
#line 375 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
#line 376 "../src/SearchFilter.vala"
	_tmp0_ = search_filter_actions_get_action (self, "display.rating");
#line 376 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 376 "../src/SearchFilter.vala"
	return result;
#line 4964 "SearchFilter.c"
}

TextAction*
search_filter_actions_get_text (SearchFilterActions* self)
{
	TextAction* result;
	TextAction* _tmp0_;
	TextAction* _tmp1_;
#line 381 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
#line 382 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->_text;
#line 382 "../src/SearchFilter.vala"
	_vala_assert (_tmp0_ != NULL, "_text != null");
#line 383 "../src/SearchFilter.vala"
	_tmp1_ = self->priv->_text;
#line 383 "../src/SearchFilter.vala"
	result = _tmp1_;
#line 383 "../src/SearchFilter.vala"
	return result;
#line 4985 "SearchFilter.c"
}

static void
g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN (GClosure * closure,
                                                               GValue * return_value,
                                                               guint n_param_values,
                                                               const GValue * param_values,
                                                               gpointer invocation_hint,
                                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN) (gpointer data1, gboolean arg_1, gboolean arg_2, gboolean arg_3, gboolean arg_4, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 349 "../src/SearchFilter.vala"
	g_return_if_fail (n_param_values == 5);
#line 349 "../src/SearchFilter.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 349 "../src/SearchFilter.vala"
		data1 = closure->data;
#line 349 "../src/SearchFilter.vala"
		data2 = param_values->data[0].v_pointer;
#line 5010 "SearchFilter.c"
	} else {
#line 349 "../src/SearchFilter.vala"
		data1 = param_values->data[0].v_pointer;
#line 349 "../src/SearchFilter.vala"
		data2 = closure->data;
#line 5016 "SearchFilter.c"
	}
#line 349 "../src/SearchFilter.vala"
	callback = (GMarshalFunc_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 349 "../src/SearchFilter.vala"
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_boolean (param_values + 2), g_value_get_boolean (param_values + 3), g_value_get_boolean (param_values + 4), data2);
#line 5022 "SearchFilter.c"
}

static void
value_search_filter_actions_init (GValue* value)
{
#line 349 "../src/SearchFilter.vala"
	value->data[0].v_pointer = NULL;
#line 5030 "SearchFilter.c"
}

static void
value_search_filter_actions_free_value (GValue* value)
{
#line 349 "../src/SearchFilter.vala"
	if (value->data[0].v_pointer) {
#line 349 "../src/SearchFilter.vala"
		search_filter_actions_unref (value->data[0].v_pointer);
#line 5040 "SearchFilter.c"
	}
}

static void
value_search_filter_actions_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 349 "../src/SearchFilter.vala"
	if (src_value->data[0].v_pointer) {
#line 349 "../src/SearchFilter.vala"
		dest_value->data[0].v_pointer = search_filter_actions_ref (src_value->data[0].v_pointer);
#line 5052 "SearchFilter.c"
	} else {
#line 349 "../src/SearchFilter.vala"
		dest_value->data[0].v_pointer = NULL;
#line 5056 "SearchFilter.c"
	}
}

static gpointer
value_search_filter_actions_peek_pointer (const GValue* value)
{
#line 349 "../src/SearchFilter.vala"
	return value->data[0].v_pointer;
#line 5065 "SearchFilter.c"
}

static gchar*
value_search_filter_actions_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 349 "../src/SearchFilter.vala"
	if (collect_values[0].v_pointer) {
#line 5076 "SearchFilter.c"
		SearchFilterActions * object;
		object = collect_values[0].v_pointer;
#line 349 "../src/SearchFilter.vala"
		if (object->parent_instance.g_class == NULL) {
#line 349 "../src/SearchFilter.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5083 "SearchFilter.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 349 "../src/SearchFilter.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5087 "SearchFilter.c"
		}
#line 349 "../src/SearchFilter.vala"
		value->data[0].v_pointer = search_filter_actions_ref (object);
#line 5091 "SearchFilter.c"
	} else {
#line 349 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 5095 "SearchFilter.c"
	}
#line 349 "../src/SearchFilter.vala"
	return NULL;
#line 5099 "SearchFilter.c"
}

static gchar*
value_search_filter_actions_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	SearchFilterActions ** object_p;
	object_p = collect_values[0].v_pointer;
#line 349 "../src/SearchFilter.vala"
	if (!object_p) {
#line 349 "../src/SearchFilter.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 5114 "SearchFilter.c"
	}
#line 349 "../src/SearchFilter.vala"
	if (!value->data[0].v_pointer) {
#line 349 "../src/SearchFilter.vala"
		*object_p = NULL;
#line 5120 "SearchFilter.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 349 "../src/SearchFilter.vala"
		*object_p = value->data[0].v_pointer;
#line 5124 "SearchFilter.c"
	} else {
#line 349 "../src/SearchFilter.vala"
		*object_p = search_filter_actions_ref (value->data[0].v_pointer);
#line 5128 "SearchFilter.c"
	}
#line 349 "../src/SearchFilter.vala"
	return NULL;
#line 5132 "SearchFilter.c"
}

GParamSpec*
param_spec_search_filter_actions (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	ParamSpecSearchFilterActions* spec;
#line 349 "../src/SearchFilter.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SEARCH_FILTER_ACTIONS), NULL);
#line 349 "../src/SearchFilter.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 349 "../src/SearchFilter.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 349 "../src/SearchFilter.vala"
	return G_PARAM_SPEC (spec);
#line 5151 "SearchFilter.c"
}

gpointer
value_get_search_filter_actions (const GValue* value)
{
#line 349 "../src/SearchFilter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEARCH_FILTER_ACTIONS), NULL);
#line 349 "../src/SearchFilter.vala"
	return value->data[0].v_pointer;
#line 5161 "SearchFilter.c"
}

void
value_set_search_filter_actions (GValue* value,
                                 gpointer v_object)
{
	SearchFilterActions * old;
#line 349 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEARCH_FILTER_ACTIONS));
#line 349 "../src/SearchFilter.vala"
	old = value->data[0].v_pointer;
#line 349 "../src/SearchFilter.vala"
	if (v_object) {
#line 349 "../src/SearchFilter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SEARCH_FILTER_ACTIONS));
#line 349 "../src/SearchFilter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 349 "../src/SearchFilter.vala"
		value->data[0].v_pointer = v_object;
#line 349 "../src/SearchFilter.vala"
		search_filter_actions_ref (value->data[0].v_pointer);
#line 5183 "SearchFilter.c"
	} else {
#line 349 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 5187 "SearchFilter.c"
	}
#line 349 "../src/SearchFilter.vala"
	if (old) {
#line 349 "../src/SearchFilter.vala"
		search_filter_actions_unref (old);
#line 5193 "SearchFilter.c"
	}
}

void
value_take_search_filter_actions (GValue* value,
                                  gpointer v_object)
{
	SearchFilterActions * old;
#line 349 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEARCH_FILTER_ACTIONS));
#line 349 "../src/SearchFilter.vala"
	old = value->data[0].v_pointer;
#line 349 "../src/SearchFilter.vala"
	if (v_object) {
#line 349 "../src/SearchFilter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SEARCH_FILTER_ACTIONS));
#line 349 "../src/SearchFilter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 349 "../src/SearchFilter.vala"
		value->data[0].v_pointer = v_object;
#line 5214 "SearchFilter.c"
	} else {
#line 349 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 5218 "SearchFilter.c"
	}
#line 349 "../src/SearchFilter.vala"
	if (old) {
#line 349 "../src/SearchFilter.vala"
		search_filter_actions_unref (old);
#line 5224 "SearchFilter.c"
	}
}

static void
search_filter_actions_class_init (SearchFilterActionsClass * klass,
                                  gpointer klass_data)
{
#line 349 "../src/SearchFilter.vala"
	search_filter_actions_parent_class = g_type_class_peek_parent (klass);
#line 349 "../src/SearchFilter.vala"
	((SearchFilterActionsClass *) klass)->finalize = search_filter_actions_finalize;
#line 349 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &SearchFilterActions_private_offset);
#line 349 "../src/SearchFilter.vala"
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_FLAGGED_TOGGLED_SIGNAL] = g_signal_new ("flagged-toggled", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 349 "../src/SearchFilter.vala"
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_PHOTOS_TOGGLED_SIGNAL] = g_signal_new ("photos-toggled", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 349 "../src/SearchFilter.vala"
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_VIDEOS_TOGGLED_SIGNAL] = g_signal_new ("videos-toggled", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 349 "../src/SearchFilter.vala"
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_RAW_TOGGLED_SIGNAL] = g_signal_new ("raw-toggled", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 349 "../src/SearchFilter.vala"
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_RATING_CHANGED_SIGNAL] = g_signal_new ("rating-changed", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, TYPE_RATING_FILTER);
#line 349 "../src/SearchFilter.vala"
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_TEXT_CHANGED_SIGNAL] = g_signal_new ("text-changed", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 5250 "SearchFilter.c"
	/**
	     * fired when the kinds of media present in the current view change (e.g., a video becomes
	     * available in the view through a new import operation or no raw photos are available in
	     * the view anymore because the last one was moved to the trash)
	     */
#line 349 "../src/SearchFilter.vala"
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_MEDIA_CONTEXT_CHANGED_SIGNAL] = g_signal_new ("media-context-changed", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN, G_TYPE_NONE, 4, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN);
#line 349 "../src/SearchFilter.vala"
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_CRITERIA_CHANGED_SIGNAL] = g_signal_new ("criteria-changed", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5260 "SearchFilter.c"
}

static void
search_filter_actions_instance_init (SearchFilterActions * self,
                                     gpointer klass)
{
#line 349 "../src/SearchFilter.vala"
	self->priv = search_filter_actions_get_instance_private (self);
#line 387 "../src/SearchFilter.vala"
	self->priv->criteria = SEARCH_FILTER_CRITERIA_ALL;
#line 388 "../src/SearchFilter.vala"
	self->priv->_text = NULL;
#line 389 "../src/SearchFilter.vala"
	self->priv->has_flagged = TRUE;
#line 390 "../src/SearchFilter.vala"
	self->priv->has_photos = TRUE;
#line 391 "../src/SearchFilter.vala"
	self->priv->has_videos = TRUE;
#line 392 "../src/SearchFilter.vala"
	self->priv->has_raw = TRUE;
#line 393 "../src/SearchFilter.vala"
	self->priv->can_filter_by_stars = TRUE;
#line 349 "../src/SearchFilter.vala"
	self->ref_count = 1;
#line 5285 "SearchFilter.c"
}

static void
search_filter_actions_finalize (SearchFilterActions * obj)
{
	SearchFilterActions * self;
#line 349 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_FILTER_ACTIONS, SearchFilterActions);
#line 349 "../src/SearchFilter.vala"
	g_signal_handlers_destroy (self);
#line 388 "../src/SearchFilter.vala"
	_text_action_unref0 (self->priv->_text);
#line 5298 "SearchFilter.c"
}

static GType
search_filter_actions_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_search_filter_actions_init, value_search_filter_actions_free_value, value_search_filter_actions_copy_value, value_search_filter_actions_peek_pointer, "p", value_search_filter_actions_collect_value, "p", value_search_filter_actions_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterActionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_actions_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterActions), 0, (GInstanceInitFunc) search_filter_actions_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType search_filter_actions_type_id;
	search_filter_actions_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SearchFilterActions", &g_define_type_info, &g_define_type_fundamental_info, 0);
	SearchFilterActions_private_offset = g_type_add_instance_private (search_filter_actions_type_id, sizeof (SearchFilterActionsPrivate));
	return search_filter_actions_type_id;
}

GType
search_filter_actions_get_type (void)
{
	static volatile gsize search_filter_actions_type_id__volatile = 0;
	if (g_once_init_enter (&search_filter_actions_type_id__volatile)) {
		GType search_filter_actions_type_id;
		search_filter_actions_type_id = search_filter_actions_get_type_once ();
		g_once_init_leave (&search_filter_actions_type_id__volatile, search_filter_actions_type_id);
	}
	return search_filter_actions_type_id__volatile;
}

gpointer
search_filter_actions_ref (gpointer instance)
{
	SearchFilterActions * self;
	self = instance;
#line 349 "../src/SearchFilter.vala"
	g_atomic_int_inc (&self->ref_count);
#line 349 "../src/SearchFilter.vala"
	return instance;
#line 5334 "SearchFilter.c"
}

void
search_filter_actions_unref (gpointer instance)
{
	SearchFilterActions * self;
	self = instance;
#line 349 "../src/SearchFilter.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 349 "../src/SearchFilter.vala"
		SEARCH_FILTER_ACTIONS_GET_CLASS (self)->finalize (self);
#line 349 "../src/SearchFilter.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 5348 "SearchFilter.c"
	}
}

static inline gpointer
search_filter_toolbar_get_instance_private (SearchFilterToolbar* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbar_private_offset);
}

static void
_search_filter_toolbar_on_media_context_changed_search_filter_actions_media_context_changed (SearchFilterActions* _sender,
                                                                                             gboolean has_photos,
                                                                                             gboolean has_videos,
                                                                                             gboolean has_raw,
                                                                                             gboolean has_flagged,
                                                                                             gpointer self)
{
#line 1182 "../src/SearchFilter.vala"
	search_filter_toolbar_on_media_context_changed ((SearchFilterToolbar*) self, has_photos, has_videos, has_raw, has_flagged);
#line 5368 "SearchFilter.c"
}

static void
_search_filter_toolbar_on_flagged_toggled_search_filter_actions_flagged_toggled (SearchFilterActions* _sender,
                                                                                 gboolean on,
                                                                                 gpointer self)
{
#line 1184 "../src/SearchFilter.vala"
	search_filter_toolbar_on_flagged_toggled ((SearchFilterToolbar*) self);
#line 5378 "SearchFilter.c"
}

static void
_search_filter_toolbar_on_photos_toggled_search_filter_actions_photos_toggled (SearchFilterActions* _sender,
                                                                               gboolean on,
                                                                               gpointer self)
{
#line 1185 "../src/SearchFilter.vala"
	search_filter_toolbar_on_photos_toggled ((SearchFilterToolbar*) self);
#line 5388 "SearchFilter.c"
}

static void
_search_filter_toolbar_on_videos_toggled_search_filter_actions_videos_toggled (SearchFilterActions* _sender,
                                                                               gboolean on,
                                                                               gpointer self)
{
#line 1186 "../src/SearchFilter.vala"
	search_filter_toolbar_on_videos_toggled ((SearchFilterToolbar*) self);
#line 5398 "SearchFilter.c"
}

static void
_search_filter_toolbar_on_raw_toggled_search_filter_actions_raw_toggled (SearchFilterActions* _sender,
                                                                         gboolean on,
                                                                         gpointer self)
{
#line 1187 "../src/SearchFilter.vala"
	search_filter_toolbar_on_raw_toggled ((SearchFilterToolbar*) self);
#line 5408 "SearchFilter.c"
}

static void
_search_filter_toolbar_on_rating_changed_search_filter_actions_rating_changed (SearchFilterActions* _sender,
                                                                               RatingFilter filter,
                                                                               gpointer self)
{
#line 1188 "../src/SearchFilter.vala"
	search_filter_toolbar_on_rating_changed ((SearchFilterToolbar*) self);
#line 5418 "SearchFilter.c"
}

static void
_search_filter_toolbar_on_search_text_changed_search_filter_actions_text_changed (SearchFilterActions* _sender,
                                                                                  const gchar* text,
                                                                                  gpointer self)
{
#line 1189 "../src/SearchFilter.vala"
	search_filter_toolbar_on_search_text_changed ((SearchFilterToolbar*) self);
#line 5428 "SearchFilter.c"
}

static void
_search_filter_toolbar_on_criteria_changed_search_filter_actions_criteria_changed (SearchFilterActions* _sender,
                                                                                   gpointer self)
{
#line 1190 "../src/SearchFilter.vala"
	search_filter_toolbar_on_criteria_changed ((SearchFilterToolbar*) self);
#line 5437 "SearchFilter.c"
}

static gboolean
_search_filter_toolbar_on_context_menu_requested_gtk_toolbar_popup_context_menu (GtkToolbar* _sender,
                                                                                 gint x,
                                                                                 gint y,
                                                                                 gint button_number,
                                                                                 gpointer self)
{
	gboolean result;
	result = search_filter_toolbar_on_context_menu_requested ((SearchFilterToolbar*) self, x, y, button_number);
#line 1192 "../src/SearchFilter.vala"
	return result;
#line 5451 "SearchFilter.c"
}

static gpointer
_search_filter_actions_ref0 (gpointer self)
{
#line 1077 "../src/SearchFilter.vala"
	return self ? search_filter_actions_ref (self) : NULL;
#line 5459 "SearchFilter.c"
}

static void
_search_filter_toolbar_on_context_menu_close_chosen_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                            gpointer self)
{
#line 1099 "../src/SearchFilter.vala"
	search_filter_toolbar_on_context_menu_close_chosen ((SearchFilterToolbar*) self);
#line 5468 "SearchFilter.c"
}

static void
_search_filter_toolbar_on_saved_search_button_clicked_search_filter_toolbar_saved_search_filter_button_clicked (SearchFilterToolbarSavedSearchFilterButton* _sender,
                                                                                                                gpointer self)
{
#line 1150 "../src/SearchFilter.vala"
	search_filter_toolbar_on_saved_search_button_clicked ((SearchFilterToolbar*) self);
#line 5477 "SearchFilter.c"
}

SearchFilterToolbar*
search_filter_toolbar_construct (GType object_type,
                                 SearchFilterActions* actions)
{
	SearchFilterToolbar * self = NULL;
	SearchFilterActions* _tmp0_;
	GtkToolbar* _tmp1_;
	TextAction* _tmp2_;
	TextAction* _tmp3_;
	SearchFilterToolbarSearchBox* _tmp4_;
	GtkToolbar* _tmp5_;
	GtkToolbar* _tmp6_;
	GtkMenuItem* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenu* _tmp17_;
	GtkMenuItem* _tmp18_;
	SearchFilterToolbarLabelToolItem* _tmp19_;
	GtkToolbar* _tmp20_;
	SearchFilterToolbarLabelToolItem* _tmp21_;
	SearchFilterToolbarToggleActionToolButton* _tmp22_;
	SearchFilterToolbarToggleActionToolButton* _tmp23_;
	SearchFilterToolbarToggleActionToolButton* _tmp24_;
	SearchFilterToolbarToggleActionToolButton* _tmp25_;
	SearchFilterToolbarToggleActionToolButton* _tmp26_;
	SearchFilterToolbarToggleActionToolButton* _tmp27_;
	GtkToolbar* _tmp28_;
	SearchFilterToolbarToggleActionToolButton* _tmp29_;
	GtkToolbar* _tmp30_;
	SearchFilterToolbarToggleActionToolButton* _tmp31_;
	GtkToolbar* _tmp32_;
	SearchFilterToolbarToggleActionToolButton* _tmp33_;
	GtkSeparatorToolItem* _tmp34_;
	GtkToolbar* _tmp35_;
	GtkSeparatorToolItem* _tmp36_;
	SearchFilterToolbarToggleActionToolButton* _tmp37_;
	SearchFilterToolbarToggleActionToolButton* _tmp38_;
	SearchFilterToolbarToggleActionToolButton* _tmp39_;
	GtkToolbar* _tmp40_;
	SearchFilterToolbarToggleActionToolButton* _tmp41_;
	GtkSeparatorToolItem* _tmp42_;
	GtkToolbar* _tmp43_;
	GtkSeparatorToolItem* _tmp44_;
	GMenuModel* model = NULL;
	GtkBuilder* _tmp45_;
	GObject* _tmp46_;
	GMenuModel* _tmp47_;
	SearchFilterToolbarRatingFilterButton* _tmp48_;
	SearchFilterToolbarRatingFilterButton* _tmp49_;
	SearchFilterToolbarRatingFilterButton* _tmp50_;
	GtkToolbar* _tmp51_;
	SearchFilterToolbarRatingFilterButton* _tmp52_;
	GtkSeparatorToolItem* _tmp53_;
	GtkToolbar* _tmp54_;
	GtkSeparatorToolItem* _tmp55_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp56_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp57_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp58_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp59_;
	GtkToolbar* _tmp60_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp61_;
	GtkSeparatorToolItem* separator_align = NULL;
	GtkSeparatorToolItem* _tmp62_;
	GtkToolbar* _tmp63_;
	GtkToolbar* _tmp64_;
	SearchFilterToolbarSearchBox* _tmp65_;
	GtkToolbar* _tmp66_;
	GtkToolbar* _tmp67_;
	GError* _inner_error0_ = NULL;
#line 1076 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (actions), NULL);
#line 1076 "../src/SearchFilter.vala"
	self = (SearchFilterToolbar*) g_object_new (object_type, NULL);
#line 1077 "../src/SearchFilter.vala"
	_tmp0_ = _search_filter_actions_ref0 (actions);
#line 1077 "../src/SearchFilter.vala"
	_search_filter_actions_unref0 (self->priv->actions);
#line 1077 "../src/SearchFilter.vala"
	self->priv->actions = _tmp0_;
#line 1078 "../src/SearchFilter.vala"
	_tmp1_ = (GtkToolbar*) gtk_toolbar_new ();
#line 1078 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp1_);
#line 1078 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->toolbar);
#line 1078 "../src/SearchFilter.vala"
	self->priv->toolbar = _tmp1_;
#line 1079 "../src/SearchFilter.vala"
	g_signal_connect_object (actions, "media-context-changed", (GCallback) _search_filter_toolbar_on_media_context_changed_search_filter_actions_media_context_changed, self, 0);
#line 1080 "../src/SearchFilter.vala"
	_tmp2_ = search_filter_actions_get_text (actions);
#line 1080 "../src/SearchFilter.vala"
	_tmp3_ = _tmp2_;
#line 1080 "../src/SearchFilter.vala"
	_tmp4_ = search_filter_toolbar_search_box_new (_tmp3_);
#line 1080 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp4_);
#line 1080 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->search_box);
#line 1080 "../src/SearchFilter.vala"
	self->priv->search_box = _tmp4_;
#line 1082 "../src/SearchFilter.vala"
	_tmp5_ = self->priv->toolbar;
#line 1082 "../src/SearchFilter.vala"
	gtk_buildable_set_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_buildable_get_type (), GtkBuildable), "search-filter-toolbar");
#line 1083 "../src/SearchFilter.vala"
	_tmp6_ = self->priv->toolbar;
#line 1083 "../src/SearchFilter.vala"
	gtk_toolbar_set_icon_size (_tmp6_, GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 5589 "SearchFilter.c"
	{
		GtkBuilder* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1086 "../src/SearchFilter.vala"
		_tmp7_ = self->builder;
#line 1086 "../src/SearchFilter.vala"
		_tmp8_ = resources_get_ui ("search_bar.ui");
#line 1086 "../src/SearchFilter.vala"
		_tmp9_ = _tmp8_;
#line 1086 "../src/SearchFilter.vala"
		gtk_builder_add_from_resource (_tmp7_, _tmp9_, &_inner_error0_);
#line 1086 "../src/SearchFilter.vala"
		_g_free0 (_tmp9_);
#line 1086 "../src/SearchFilter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5606 "SearchFilter.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 1085 "../src/SearchFilter.vala"
		err = _inner_error0_;
#line 1085 "../src/SearchFilter.vala"
		_inner_error0_ = NULL;
#line 1088 "../src/SearchFilter.vala"
		_tmp10_ = err;
#line 1088 "../src/SearchFilter.vala"
		_tmp11_ = _tmp10_->message;
#line 1088 "../src/SearchFilter.vala"
		_tmp12_ = g_strdup_printf (_ ("Error loading search bar UI: %s"), _tmp11_);
#line 1088 "../src/SearchFilter.vala"
		_tmp13_ = _tmp12_;
#line 1088 "../src/SearchFilter.vala"
		app_window_panic (_tmp13_);
#line 1088 "../src/SearchFilter.vala"
		_g_free0 (_tmp13_);
#line 1085 "../src/SearchFilter.vala"
		_g_error_free0 (err);
#line 5636 "SearchFilter.c"
	}
	__finally0:
#line 1085 "../src/SearchFilter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1085 "../src/SearchFilter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1085 "../src/SearchFilter.vala"
		g_clear_error (&_inner_error0_);
#line 1085 "../src/SearchFilter.vala"
		return NULL;
#line 5647 "SearchFilter.c"
	}
#line 1097 "../src/SearchFilter.vala"
	_tmp14_ = self->priv->close_item;
#line 1097 "../src/SearchFilter.vala"
	gtk_menu_item_set_label (_tmp14_, _ ("Close"));
#line 1098 "../src/SearchFilter.vala"
	_tmp15_ = self->priv->close_item;
#line 1098 "../src/SearchFilter.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget));
#line 1099 "../src/SearchFilter.vala"
	_tmp16_ = self->priv->close_item;
#line 1099 "../src/SearchFilter.vala"
	g_signal_connect_object (_tmp16_, "activate", (GCallback) _search_filter_toolbar_on_context_menu_close_chosen_gtk_menu_item_activate, self, 0);
#line 1100 "../src/SearchFilter.vala"
	_tmp17_ = self->priv->close_menu;
#line 1100 "../src/SearchFilter.vala"
	_tmp18_ = self->priv->close_item;
#line 1100 "../src/SearchFilter.vala"
	gtk_menu_shell_append (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_menu_shell_get_type (), GtkMenuShell), _tmp18_);
#line 1103 "../src/SearchFilter.vala"
	_tmp19_ = search_filter_toolbar_label_tool_item_new (_ ("Type"), 10, 5);
#line 1103 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp19_);
#line 1103 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->label_type);
#line 1103 "../src/SearchFilter.vala"
	self->priv->label_type = _tmp19_;
#line 1104 "../src/SearchFilter.vala"
	_tmp20_ = self->priv->toolbar;
#line 1104 "../src/SearchFilter.vala"
	_tmp21_ = self->priv->label_type;
#line 1104 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp20_, G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1106 "../src/SearchFilter.vala"
	_tmp22_ = search_filter_toolbar_toggle_action_tool_button_new ("win.display.photos");
#line 1106 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp22_);
#line 1106 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->toolbtn_photos);
#line 1106 "../src/SearchFilter.vala"
	self->priv->toolbtn_photos = _tmp22_;
#line 1107 "../src/SearchFilter.vala"
	_tmp23_ = self->priv->toolbtn_photos;
#line 1107 "../src/SearchFilter.vala"
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_tool_item_get_type (), GtkToolItem), _ ("Photos"));
#line 1109 "../src/SearchFilter.vala"
	_tmp24_ = search_filter_toolbar_toggle_action_tool_button_new ("win.display.videos");
#line 1109 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp24_);
#line 1109 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->toolbtn_videos);
#line 1109 "../src/SearchFilter.vala"
	self->priv->toolbtn_videos = _tmp24_;
#line 1110 "../src/SearchFilter.vala"
	_tmp25_ = self->priv->toolbtn_videos;
#line 1110 "../src/SearchFilter.vala"
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_tool_item_get_type (), GtkToolItem), _ ("Videos"));
#line 1112 "../src/SearchFilter.vala"
	_tmp26_ = search_filter_toolbar_toggle_action_tool_button_new ("win.display.raw");
#line 1112 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp26_);
#line 1112 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->toolbtn_raw);
#line 1112 "../src/SearchFilter.vala"
	self->priv->toolbtn_raw = _tmp26_;
#line 1113 "../src/SearchFilter.vala"
	_tmp27_ = self->priv->toolbtn_raw;
#line 1113 "../src/SearchFilter.vala"
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_tool_item_get_type (), GtkToolItem), _ ("RAW Photos"));
#line 1115 "../src/SearchFilter.vala"
	_tmp28_ = self->priv->toolbar;
#line 1115 "../src/SearchFilter.vala"
	_tmp29_ = self->priv->toolbtn_photos;
#line 1115 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp28_, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1116 "../src/SearchFilter.vala"
	_tmp30_ = self->priv->toolbar;
#line 1116 "../src/SearchFilter.vala"
	_tmp31_ = self->priv->toolbtn_videos;
#line 1116 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1117 "../src/SearchFilter.vala"
	_tmp32_ = self->priv->toolbar;
#line 1117 "../src/SearchFilter.vala"
	_tmp33_ = self->priv->toolbtn_raw;
#line 1117 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp32_, G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1120 "../src/SearchFilter.vala"
	_tmp34_ = (GtkSeparatorToolItem*) gtk_separator_tool_item_new ();
#line 1120 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp34_);
#line 1120 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->sepr_mediatype_flagged);
#line 1120 "../src/SearchFilter.vala"
	self->priv->sepr_mediatype_flagged = _tmp34_;
#line 1121 "../src/SearchFilter.vala"
	_tmp35_ = self->priv->toolbar;
#line 1121 "../src/SearchFilter.vala"
	_tmp36_ = self->priv->sepr_mediatype_flagged;
#line 1121 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp35_, G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1125 "../src/SearchFilter.vala"
	_tmp37_ = search_filter_toolbar_toggle_action_tool_button_new ("win.display.flagged");
#line 1125 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp37_);
#line 1125 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->toolbtn_flag);
#line 1125 "../src/SearchFilter.vala"
	self->priv->toolbtn_flag = _tmp37_;
#line 1126 "../src/SearchFilter.vala"
	_tmp38_ = self->priv->toolbtn_flag;
#line 1126 "../src/SearchFilter.vala"
	search_filter_toolbar_toggle_action_tool_button_set_label (_tmp38_, _ ("Flagged"));
#line 1127 "../src/SearchFilter.vala"
	_tmp39_ = self->priv->toolbtn_flag;
#line 1127 "../src/SearchFilter.vala"
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_tool_item_get_type (), GtkToolItem), _ ("Flagged"));
#line 1129 "../src/SearchFilter.vala"
	_tmp40_ = self->priv->toolbar;
#line 1129 "../src/SearchFilter.vala"
	_tmp41_ = self->priv->toolbtn_flag;
#line 1129 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp40_, G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1132 "../src/SearchFilter.vala"
	_tmp42_ = (GtkSeparatorToolItem*) gtk_separator_tool_item_new ();
#line 1132 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp42_);
#line 1132 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->sepr_flagged_rating);
#line 1132 "../src/SearchFilter.vala"
	self->priv->sepr_flagged_rating = _tmp42_;
#line 1133 "../src/SearchFilter.vala"
	_tmp43_ = self->priv->toolbar;
#line 1133 "../src/SearchFilter.vala"
	_tmp44_ = self->priv->sepr_flagged_rating;
#line 1133 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp43_, G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1136 "../src/SearchFilter.vala"
	_tmp45_ = self->builder;
#line 1136 "../src/SearchFilter.vala"
	_tmp46_ = gtk_builder_get_object (_tmp45_, "popup-menu");
#line 1136 "../src/SearchFilter.vala"
	_tmp47_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp46_, g_menu_model_get_type ()) ? ((GMenuModel*) _tmp46_) : NULL);
#line 1136 "../src/SearchFilter.vala"
	model = _tmp47_;
#line 1137 "../src/SearchFilter.vala"
	_tmp48_ = search_filter_toolbar_rating_filter_button_new (model);
#line 1137 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp48_);
#line 1137 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->rating_button);
#line 1137 "../src/SearchFilter.vala"
	self->priv->rating_button = _tmp48_;
#line 1138 "../src/SearchFilter.vala"
	_tmp49_ = self->priv->rating_button;
#line 1138 "../src/SearchFilter.vala"
	search_filter_toolbar_rating_filter_button_set_label (_tmp49_, _ ("Rating"));
#line 1139 "../src/SearchFilter.vala"
	_tmp50_ = self->priv->rating_button;
#line 1139 "../src/SearchFilter.vala"
	gtk_tool_item_set_expand (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_tool_item_get_type (), GtkToolItem), FALSE);
#line 1140 "../src/SearchFilter.vala"
	_tmp51_ = self->priv->toolbar;
#line 1140 "../src/SearchFilter.vala"
	_tmp52_ = self->priv->rating_button;
#line 1140 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp51_, G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1143 "../src/SearchFilter.vala"
	_tmp53_ = (GtkSeparatorToolItem*) gtk_separator_tool_item_new ();
#line 1143 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp53_);
#line 1143 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->sepr_rating_saved);
#line 1143 "../src/SearchFilter.vala"
	self->priv->sepr_rating_saved = _tmp53_;
#line 1144 "../src/SearchFilter.vala"
	_tmp54_ = self->priv->toolbar;
#line 1144 "../src/SearchFilter.vala"
	_tmp55_ = self->priv->sepr_rating_saved;
#line 1144 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp54_, G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1147 "../src/SearchFilter.vala"
	_tmp56_ = self->priv->saved_search_button;
#line 1147 "../src/SearchFilter.vala"
	gtk_tool_item_set_expand (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, gtk_tool_item_get_type (), GtkToolItem), FALSE);
#line 1148 "../src/SearchFilter.vala"
	_tmp57_ = self->priv->saved_search_button;
#line 1148 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_filter_button_set_label (_tmp57_, _ ("Saved Search"));
#line 1149 "../src/SearchFilter.vala"
	_tmp58_ = self->priv->saved_search_button;
#line 1149 "../src/SearchFilter.vala"
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, gtk_tool_item_get_type (), GtkToolItem), _ ("Use a saved search to filter items in the current view"));
#line 1150 "../src/SearchFilter.vala"
	_tmp59_ = self->priv->saved_search_button;
#line 1150 "../src/SearchFilter.vala"
	g_signal_connect_object (_tmp59_, "clicked", (GCallback) _search_filter_toolbar_on_saved_search_button_clicked_search_filter_toolbar_saved_search_filter_button_clicked, self, 0);
#line 1151 "../src/SearchFilter.vala"
	_tmp60_ = self->priv->toolbar;
#line 1151 "../src/SearchFilter.vala"
	_tmp61_ = self->priv->saved_search_button;
#line 1151 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp60_, G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1154 "../src/SearchFilter.vala"
	_tmp62_ = (GtkSeparatorToolItem*) gtk_separator_tool_item_new ();
#line 1154 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp62_);
#line 1154 "../src/SearchFilter.vala"
	separator_align = _tmp62_;
#line 1155 "../src/SearchFilter.vala"
	gtk_tool_item_set_expand (G_TYPE_CHECK_INSTANCE_CAST (separator_align, gtk_tool_item_get_type (), GtkToolItem), TRUE);
#line 1156 "../src/SearchFilter.vala"
	gtk_separator_tool_item_set_draw (separator_align, FALSE);
#line 1157 "../src/SearchFilter.vala"
	_tmp63_ = self->priv->toolbar;
#line 1157 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp63_, G_TYPE_CHECK_INSTANCE_CAST (separator_align, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1160 "../src/SearchFilter.vala"
	_tmp64_ = self->priv->toolbar;
#line 1160 "../src/SearchFilter.vala"
	_tmp65_ = self->priv->search_box;
#line 1160 "../src/SearchFilter.vala"
	gtk_toolbar_insert (_tmp64_, G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, gtk_tool_item_get_type (), GtkToolItem), -1);
#line 1162 "../src/SearchFilter.vala"
	_tmp66_ = self->priv->toolbar;
#line 1162 "../src/SearchFilter.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, gtk_widget_get_type (), GtkWidget));
#line 1165 "../src/SearchFilter.vala"
	g_signal_connect_object (actions, "flagged-toggled", (GCallback) _search_filter_toolbar_on_flagged_toggled_search_filter_actions_flagged_toggled, self, 0);
#line 1166 "../src/SearchFilter.vala"
	g_signal_connect_object (actions, "photos-toggled", (GCallback) _search_filter_toolbar_on_photos_toggled_search_filter_actions_photos_toggled, self, 0);
#line 1167 "../src/SearchFilter.vala"
	g_signal_connect_object (actions, "videos-toggled", (GCallback) _search_filter_toolbar_on_videos_toggled_search_filter_actions_videos_toggled, self, 0);
#line 1168 "../src/SearchFilter.vala"
	g_signal_connect_object (actions, "raw-toggled", (GCallback) _search_filter_toolbar_on_raw_toggled_search_filter_actions_raw_toggled, self, 0);
#line 1169 "../src/SearchFilter.vala"
	g_signal_connect_object (actions, "rating-changed", (GCallback) _search_filter_toolbar_on_rating_changed_search_filter_actions_rating_changed, self, 0);
#line 1170 "../src/SearchFilter.vala"
	g_signal_connect_object (actions, "text-changed", (GCallback) _search_filter_toolbar_on_search_text_changed_search_filter_actions_text_changed, self, 0);
#line 1171 "../src/SearchFilter.vala"
	g_signal_connect_object (actions, "criteria-changed", (GCallback) _search_filter_toolbar_on_criteria_changed_search_filter_actions_criteria_changed, self, 0);
#line 1174 "../src/SearchFilter.vala"
	_tmp67_ = self->priv->toolbar;
#line 1174 "../src/SearchFilter.vala"
	g_signal_connect_object (_tmp67_, "popup-context-menu", (GCallback) _search_filter_toolbar_on_context_menu_requested_gtk_toolbar_popup_context_menu, self, 0);
#line 1176 "../src/SearchFilter.vala"
	search_filter_toolbar_on_media_context_changed (self, search_filter_actions_get_has_photos (actions), search_filter_actions_get_has_videos (actions), search_filter_actions_get_has_raw (actions), search_filter_actions_get_has_flagged (actions));
#line 1076 "../src/SearchFilter.vala"
	_g_object_unref0 (separator_align);
#line 1076 "../src/SearchFilter.vala"
	_g_object_unref0 (model);
#line 1076 "../src/SearchFilter.vala"
	return self;
#line 5901 "SearchFilter.c"
}

SearchFilterToolbar*
search_filter_toolbar_new (SearchFilterActions* actions)
{
#line 1076 "../src/SearchFilter.vala"
	return search_filter_toolbar_construct (TYPE_SEARCH_FILTER_TOOLBAR, actions);
#line 5909 "SearchFilter.c"
}

static void
search_filter_toolbar_on_media_context_changed (SearchFilterToolbar* self,
                                                gboolean has_photos,
                                                gboolean has_videos,
                                                gboolean has_raw,
                                                gboolean has_flagged)
{
	gboolean _tmp0_ = FALSE;
#line 1195 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1197 "../src/SearchFilter.vala"
	if (has_photos) {
#line 1197 "../src/SearchFilter.vala"
		_tmp0_ = TRUE;
#line 5926 "SearchFilter.c"
	} else {
#line 1197 "../src/SearchFilter.vala"
		_tmp0_ = has_raw;
#line 5930 "SearchFilter.c"
	}
#line 1197 "../src/SearchFilter.vala"
	if (_tmp0_) {
#line 5934 "SearchFilter.c"
		SearchFilterToolbarToggleActionToolButton* _tmp1_;
#line 1200 "../src/SearchFilter.vala"
		_tmp1_ = self->priv->toolbtn_photos;
#line 1200 "../src/SearchFilter.vala"
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp1_, "filter-photos-symbolic");
#line 5940 "SearchFilter.c"
	} else {
		SearchFilterToolbarToggleActionToolButton* _tmp2_;
#line 1202 "../src/SearchFilter.vala"
		_tmp2_ = self->priv->toolbtn_photos;
#line 1202 "../src/SearchFilter.vala"
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp2_, "filter-photos-disabled-symbolic");
#line 5947 "SearchFilter.c"
	}
#line 1204 "../src/SearchFilter.vala"
	if (has_videos) {
#line 5951 "SearchFilter.c"
		SearchFilterToolbarToggleActionToolButton* _tmp3_;
#line 1205 "../src/SearchFilter.vala"
		_tmp3_ = self->priv->toolbtn_videos;
#line 1205 "../src/SearchFilter.vala"
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp3_, "filter-videos-symbolic");
#line 5957 "SearchFilter.c"
	} else {
		SearchFilterToolbarToggleActionToolButton* _tmp4_;
#line 1207 "../src/SearchFilter.vala"
		_tmp4_ = self->priv->toolbtn_videos;
#line 1207 "../src/SearchFilter.vala"
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp4_, "filter-videos-disabled-symbolic");
#line 5964 "SearchFilter.c"
	}
#line 1209 "../src/SearchFilter.vala"
	if (has_raw) {
#line 5968 "SearchFilter.c"
		SearchFilterToolbarToggleActionToolButton* _tmp5_;
#line 1210 "../src/SearchFilter.vala"
		_tmp5_ = self->priv->toolbtn_raw;
#line 1210 "../src/SearchFilter.vala"
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp5_, "filter-raw-symbolic");
#line 5974 "SearchFilter.c"
	} else {
		SearchFilterToolbarToggleActionToolButton* _tmp6_;
#line 1212 "../src/SearchFilter.vala"
		_tmp6_ = self->priv->toolbtn_raw;
#line 1212 "../src/SearchFilter.vala"
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp6_, "filter-raw-disabled-symbolic");
#line 5981 "SearchFilter.c"
	}
#line 1214 "../src/SearchFilter.vala"
	if (has_flagged) {
#line 5985 "SearchFilter.c"
		SearchFilterToolbarToggleActionToolButton* _tmp7_;
#line 1215 "../src/SearchFilter.vala"
		_tmp7_ = self->priv->toolbtn_flag;
#line 1215 "../src/SearchFilter.vala"
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp7_, "filter-flagged-symbolic");
#line 5991 "SearchFilter.c"
	} else {
		SearchFilterToolbarToggleActionToolButton* _tmp8_;
#line 1217 "../src/SearchFilter.vala"
		_tmp8_ = self->priv->toolbtn_flag;
#line 1217 "../src/SearchFilter.vala"
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp8_, "filter-flagged-disabled-symbolic");
#line 5998 "SearchFilter.c"
	}
}

static gboolean
search_filter_toolbar_on_context_menu_requested (SearchFilterToolbar* self,
                                                 gint x,
                                                 gint y,
                                                 gint button)
{
	GtkMenu* _tmp0_;
	gboolean result = FALSE;
#line 1221 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SEARCH_FILTER_TOOLBAR (self), FALSE);
#line 1222 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->close_menu;
#line 1222 "../src/SearchFilter.vala"
	gtk_menu_popup_at_pointer (_tmp0_, NULL);
#line 1223 "../src/SearchFilter.vala"
	result = FALSE;
#line 1223 "../src/SearchFilter.vala"
	return result;
#line 6020 "SearchFilter.c"
}

static GVariant*
_variant_new36 (gboolean value)
{
#line 1240 "../src/SearchFilter.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 6028 "SearchFilter.c"
}

static void
search_filter_toolbar_on_context_menu_close_chosen (SearchFilterToolbar* self)
{
	AppWindow* aw = NULL;
	LibraryWindow* _tmp0_;
	GSimpleAction* action = NULL;
	AppWindow* _tmp1_;
	GAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GSimpleAction* _tmp4_;
#line 1228 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1229 "../src/SearchFilter.vala"
	_tmp0_ = library_window_get_app ();
#line 1229 "../src/SearchFilter.vala"
	aw = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_APP_WINDOW, AppWindow);
#line 1234 "../src/SearchFilter.vala"
	_tmp1_ = aw;
#line 1234 "../src/SearchFilter.vala"
	_tmp2_ = g_action_map_lookup_action (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_map_get_type (), GActionMap), "CommonDisplaySearchbar");
#line 1234 "../src/SearchFilter.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL);
#line 1234 "../src/SearchFilter.vala"
	action = _tmp3_;
#line 1238 "../src/SearchFilter.vala"
	_tmp4_ = action;
#line 1238 "../src/SearchFilter.vala"
	if (_tmp4_ != NULL) {
#line 6059 "SearchFilter.c"
		GSimpleAction* _tmp5_;
		GVariant* _tmp6_;
#line 1240 "../src/SearchFilter.vala"
		_tmp5_ = action;
#line 1240 "../src/SearchFilter.vala"
		_tmp6_ = _variant_new36 (FALSE);
#line 1240 "../src/SearchFilter.vala"
		g_signal_emit_by_name (_tmp5_, "change-state", _tmp6_);
#line 1240 "../src/SearchFilter.vala"
		_g_variant_unref0 (_tmp6_);
#line 6070 "SearchFilter.c"
	}
#line 1228 "../src/SearchFilter.vala"
	_g_object_unref0 (action);
#line 1228 "../src/SearchFilter.vala"
	_g_object_unref0 (aw);
#line 6076 "SearchFilter.c"
}

static void
search_filter_toolbar_on_flagged_toggled (SearchFilterToolbar* self)
{
#line 1244 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1245 "../src/SearchFilter.vala"
	search_filter_toolbar_update (self);
#line 6086 "SearchFilter.c"
}

static void
search_filter_toolbar_on_videos_toggled (SearchFilterToolbar* self)
{
#line 1248 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1249 "../src/SearchFilter.vala"
	search_filter_toolbar_update (self);
#line 6096 "SearchFilter.c"
}

static void
search_filter_toolbar_on_photos_toggled (SearchFilterToolbar* self)
{
#line 1252 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1253 "../src/SearchFilter.vala"
	search_filter_toolbar_update (self);
#line 6106 "SearchFilter.c"
}

static void
search_filter_toolbar_on_raw_toggled (SearchFilterToolbar* self)
{
#line 1256 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1257 "../src/SearchFilter.vala"
	search_filter_toolbar_update (self);
#line 6116 "SearchFilter.c"
}

static void
search_filter_toolbar_on_search_text_changed (SearchFilterToolbar* self)
{
#line 1260 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1261 "../src/SearchFilter.vala"
	search_filter_toolbar_update (self);
#line 6126 "SearchFilter.c"
}

static GVariant*
_variant_new37 (gboolean value)
{
#line 1275 "../src/SearchFilter.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 6134 "SearchFilter.c"
}

static void
search_filter_toolbar_on_rating_changed (SearchFilterToolbar* self)
{
	AppWindow* aw = NULL;
	LibraryWindow* _tmp0_;
	AppWindow* _tmp1_;
	GSimpleAction* action = NULL;
	AppWindow* _tmp2_;
	GAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
#line 1264 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1265 "../src/SearchFilter.vala"
	_tmp0_ = library_window_get_app ();
#line 1265 "../src/SearchFilter.vala"
	aw = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_APP_WINDOW, AppWindow);
#line 1267 "../src/SearchFilter.vala"
	_tmp1_ = aw;
#line 1267 "../src/SearchFilter.vala"
	if (_tmp1_ == NULL) {
#line 1268 "../src/SearchFilter.vala"
		_g_object_unref0 (aw);
#line 1268 "../src/SearchFilter.vala"
		return;
#line 6162 "SearchFilter.c"
	}
#line 1270 "../src/SearchFilter.vala"
	_tmp2_ = aw;
#line 1270 "../src/SearchFilter.vala"
	_tmp3_ = g_action_map_lookup_action (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, g_action_map_get_type (), GActionMap), "CommonDisplaySearchbar");
#line 1270 "../src/SearchFilter.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp3_) : NULL);
#line 1270 "../src/SearchFilter.vala"
	action = _tmp4_;
#line 1274 "../src/SearchFilter.vala"
	_tmp5_ = action;
#line 1274 "../src/SearchFilter.vala"
	if (_tmp5_ != NULL) {
#line 6176 "SearchFilter.c"
		GSimpleAction* _tmp6_;
		GVariant* _tmp7_;
#line 1275 "../src/SearchFilter.vala"
		_tmp6_ = action;
#line 1275 "../src/SearchFilter.vala"
		_tmp7_ = _variant_new37 (TRUE);
#line 1275 "../src/SearchFilter.vala"
		g_signal_emit_by_name (_tmp6_, "change-state", _tmp7_);
#line 1275 "../src/SearchFilter.vala"
		_g_variant_unref0 (_tmp7_);
#line 6187 "SearchFilter.c"
	}
#line 1278 "../src/SearchFilter.vala"
	search_filter_toolbar_update (self);
#line 1264 "../src/SearchFilter.vala"
	_g_object_unref0 (action);
#line 1264 "../src/SearchFilter.vala"
	_g_object_unref0 (aw);
#line 6195 "SearchFilter.c"
}

static void
search_filter_toolbar_on_criteria_changed (SearchFilterToolbar* self)
{
#line 1284 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1285 "../src/SearchFilter.vala"
	search_filter_toolbar_update (self);
#line 6205 "SearchFilter.c"
}

static gpointer
_view_filter_ref0 (gpointer self)
{
#line 1292 "../src/SearchFilter.vala"
	return self ? view_filter_ref (self) : NULL;
#line 6213 "SearchFilter.c"
}

void
search_filter_toolbar_set_view_filter (SearchFilterToolbar* self,
                                       SearchViewFilter* search_filter)
{
	SearchViewFilter* _tmp0_;
	SearchViewFilter* _tmp1_;
	SearchFilterActions* _tmp2_;
	SearchFilterToolbarRatingFilterButton* _tmp3_;
#line 1288 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1288 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (search_filter));
#line 1289 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_filter;
#line 1289 "../src/SearchFilter.vala"
	if (search_filter == _tmp0_) {
#line 1290 "../src/SearchFilter.vala"
		return;
#line 6234 "SearchFilter.c"
	}
#line 1292 "../src/SearchFilter.vala"
	_tmp1_ = _view_filter_ref0 (search_filter);
#line 1292 "../src/SearchFilter.vala"
	_view_filter_unref0 (self->priv->search_filter);
#line 1292 "../src/SearchFilter.vala"
	self->priv->search_filter = _tmp1_;
#line 1295 "../src/SearchFilter.vala"
	_tmp2_ = self->priv->actions;
#line 1295 "../src/SearchFilter.vala"
	search_filter_actions_set_sensitive_for_search_criteria (_tmp2_, (SearchFilterCriteria) search_view_filter_get_criteria (search_filter));
#line 1296 "../src/SearchFilter.vala"
	_tmp3_ = self->priv->rating_button;
#line 1296 "../src/SearchFilter.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), (SEARCH_FILTER_CRITERIA_RATING & search_view_filter_get_criteria (search_filter)) != 0);
#line 1298 "../src/SearchFilter.vala"
	search_filter_toolbar_update (self);
#line 6252 "SearchFilter.c"
}

void
search_filter_toolbar_unset_view_filter (SearchFilterToolbar* self)
{
	DisabledViewFilter* _tmp0_;
	DisabledViewFilter* _tmp1_;
#line 1301 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1302 "../src/SearchFilter.vala"
	_tmp0_ = disabled_view_filter_new ();
#line 1302 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_;
#line 1302 "../src/SearchFilter.vala"
	search_filter_toolbar_set_view_filter (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
#line 1302 "../src/SearchFilter.vala"
	_view_filter_unref0 (_tmp1_);
#line 6270 "SearchFilter.c"
}

void
search_filter_toolbar_update (SearchFilterToolbar* self)
{
	SearchViewFilter* _tmp0_;
	SearchViewFilter* _tmp3_;
	SearchViewFilter* _tmp4_;
	SearchFilterActions* _tmp5_;
	TextAction* _tmp6_;
	TextAction* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	SearchViewFilter* _tmp10_;
	SearchFilterActions* _tmp11_;
	GSimpleAction* _tmp12_;
	GSimpleAction* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	SearchViewFilter* _tmp16_;
	SearchFilterActions* _tmp17_;
	GSimpleAction* _tmp18_;
	GSimpleAction* _tmp19_;
	GVariant* _tmp20_;
	GVariant* _tmp21_;
	SearchViewFilter* _tmp22_;
	SearchFilterActions* _tmp23_;
	GSimpleAction* _tmp24_;
	GSimpleAction* _tmp25_;
	GVariant* _tmp26_;
	GVariant* _tmp27_;
	SearchViewFilter* _tmp28_;
	SearchFilterActions* _tmp29_;
	GSimpleAction* _tmp30_;
	GSimpleAction* _tmp31_;
	GVariant* _tmp32_;
	GVariant* _tmp33_;
	RatingFilter filter = 0;
	SearchFilterActions* _tmp34_;
	GSimpleAction* _tmp35_;
	GSimpleAction* _tmp36_;
	GVariant* _tmp37_;
	GVariant* _tmp38_;
	const gchar* _tmp39_;
	RatingFilter _tmp40_;
	SearchViewFilter* _tmp41_;
	SearchFilterToolbarRatingFilterButton* _tmp42_;
	SearchViewFilter* _tmp43_;
	SavedSearch* _tmp44_;
	SearchFilterCriteria criteria = 0U;
	SearchFilterActions* _tmp45_;
	SearchFilterToolbarSearchBox* _tmp46_;
	SearchFilterToolbarRatingFilterButton* _tmp47_;
	SearchFilterToolbarToggleActionToolButton* _tmp48_;
	SearchFilterToolbarLabelToolItem* _tmp49_;
	SearchFilterToolbarToggleActionToolButton* _tmp50_;
	SearchFilterToolbarToggleActionToolButton* _tmp51_;
	SearchFilterToolbarToggleActionToolButton* _tmp52_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp53_;
	gboolean _tmp54_ = FALSE;
	SearchFilterToolbarLabelToolItem* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp57_;
	GtkSeparatorToolItem* _tmp61_;
	gboolean _tmp62_ = FALSE;
	gboolean _tmp63_ = FALSE;
	SearchFilterToolbarLabelToolItem* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	GtkSeparatorToolItem* _tmp77_;
	SearchViewFilter* _tmp78_;
#line 1306 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1307 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_filter;
#line 1307 "../src/SearchFilter.vala"
	if (NULL == _tmp0_) {
#line 6348 "SearchFilter.c"
		LibraryWindow* _tmp1_;
		LibraryWindow* _tmp2_;
#line 1309 "../src/SearchFilter.vala"
		_tmp1_ = library_window_get_app ();
#line 1309 "../src/SearchFilter.vala"
		_tmp2_ = _tmp1_;
#line 1309 "../src/SearchFilter.vala"
		library_window_show_search_bar (_tmp2_, TRUE);
#line 1309 "../src/SearchFilter.vala"
		_g_object_unref0 (_tmp2_);
#line 6359 "SearchFilter.c"
	}
#line 1312 "../src/SearchFilter.vala"
	_tmp3_ = self->priv->search_filter;
#line 1312 "../src/SearchFilter.vala"
	_vala_assert (NULL != _tmp3_, "null != search_filter");
#line 1314 "../src/SearchFilter.vala"
	_tmp4_ = self->priv->search_filter;
#line 1314 "../src/SearchFilter.vala"
	_tmp5_ = self->priv->actions;
#line 1314 "../src/SearchFilter.vala"
	_tmp6_ = search_filter_actions_get_text (_tmp5_);
#line 1314 "../src/SearchFilter.vala"
	_tmp7_ = _tmp6_;
#line 1314 "../src/SearchFilter.vala"
	_tmp8_ = text_action_get_value (_tmp7_);
#line 1314 "../src/SearchFilter.vala"
	_tmp9_ = _tmp8_;
#line 1314 "../src/SearchFilter.vala"
	search_view_filter_set_search_filter (_tmp4_, _tmp9_);
#line 1315 "../src/SearchFilter.vala"
	_tmp10_ = self->priv->search_filter;
#line 1315 "../src/SearchFilter.vala"
	_tmp11_ = self->priv->actions;
#line 1315 "../src/SearchFilter.vala"
	_tmp12_ = search_filter_actions_get_flagged (_tmp11_);
#line 1315 "../src/SearchFilter.vala"
	_tmp13_ = _tmp12_;
#line 1315 "../src/SearchFilter.vala"
	_tmp14_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, g_action_get_type (), GAction));
#line 1315 "../src/SearchFilter.vala"
	_tmp15_ = _tmp14_;
#line 1315 "../src/SearchFilter.vala"
	search_view_filter_set_flagged (_tmp10_, g_variant_get_boolean (_tmp15_));
#line 1315 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp15_);
#line 1316 "../src/SearchFilter.vala"
	_tmp16_ = self->priv->search_filter;
#line 1316 "../src/SearchFilter.vala"
	_tmp17_ = self->priv->actions;
#line 1316 "../src/SearchFilter.vala"
	_tmp18_ = search_filter_actions_get_videos (_tmp17_);
#line 1316 "../src/SearchFilter.vala"
	_tmp19_ = _tmp18_;
#line 1316 "../src/SearchFilter.vala"
	_tmp20_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, g_action_get_type (), GAction));
#line 1316 "../src/SearchFilter.vala"
	_tmp21_ = _tmp20_;
#line 1316 "../src/SearchFilter.vala"
	search_view_filter_set_show_media_video (_tmp16_, g_variant_get_boolean (_tmp21_));
#line 1316 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp21_);
#line 1318 "../src/SearchFilter.vala"
	_tmp22_ = self->priv->search_filter;
#line 1318 "../src/SearchFilter.vala"
	_tmp23_ = self->priv->actions;
#line 1318 "../src/SearchFilter.vala"
	_tmp24_ = search_filter_actions_get_photos (_tmp23_);
#line 1318 "../src/SearchFilter.vala"
	_tmp25_ = _tmp24_;
#line 1318 "../src/SearchFilter.vala"
	_tmp26_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, g_action_get_type (), GAction));
#line 1318 "../src/SearchFilter.vala"
	_tmp27_ = _tmp26_;
#line 1318 "../src/SearchFilter.vala"
	search_view_filter_set_show_media_photos (_tmp22_, g_variant_get_boolean (_tmp27_));
#line 1318 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp27_);
#line 1320 "../src/SearchFilter.vala"
	_tmp28_ = self->priv->search_filter;
#line 1320 "../src/SearchFilter.vala"
	_tmp29_ = self->priv->actions;
#line 1320 "../src/SearchFilter.vala"
	_tmp30_ = search_filter_actions_get_raw (_tmp29_);
#line 1320 "../src/SearchFilter.vala"
	_tmp31_ = _tmp30_;
#line 1320 "../src/SearchFilter.vala"
	_tmp32_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, g_action_get_type (), GAction));
#line 1320 "../src/SearchFilter.vala"
	_tmp33_ = _tmp32_;
#line 1320 "../src/SearchFilter.vala"
	search_view_filter_set_show_media_raw (_tmp28_, g_variant_get_boolean (_tmp33_));
#line 1320 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp33_);
#line 1322 "../src/SearchFilter.vala"
	_tmp34_ = self->priv->actions;
#line 1322 "../src/SearchFilter.vala"
	_tmp35_ = search_filter_actions_get_rating (_tmp34_);
#line 1322 "../src/SearchFilter.vala"
	_tmp36_ = _tmp35_;
#line 1322 "../src/SearchFilter.vala"
	_tmp37_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, g_action_get_type (), GAction));
#line 1322 "../src/SearchFilter.vala"
	_tmp38_ = _tmp37_;
#line 1322 "../src/SearchFilter.vala"
	_tmp39_ = g_variant_get_string (_tmp38_, NULL);
#line 1322 "../src/SearchFilter.vala"
	_tmp40_ = (RatingFilter) atoi (_tmp39_);
#line 1322 "../src/SearchFilter.vala"
	_g_variant_unref0 (_tmp38_);
#line 1322 "../src/SearchFilter.vala"
	filter = _tmp40_;
#line 1323 "../src/SearchFilter.vala"
	_tmp41_ = self->priv->search_filter;
#line 1323 "../src/SearchFilter.vala"
	search_view_filter_set_rating_filter (_tmp41_, filter);
#line 1324 "../src/SearchFilter.vala"
	_tmp42_ = self->priv->rating_button;
#line 1324 "../src/SearchFilter.vala"
	search_filter_toolbar_rating_filter_button_set_filter_icon (_tmp42_, filter);
#line 1326 "../src/SearchFilter.vala"
	_tmp43_ = self->priv->search_filter;
#line 1326 "../src/SearchFilter.vala"
	_tmp44_ = self->priv->saved_search;
#line 1326 "../src/SearchFilter.vala"
	search_view_filter_set_saved_search (_tmp43_, _tmp44_);
#line 1330 "../src/SearchFilter.vala"
	_tmp45_ = self->priv->actions;
#line 1330 "../src/SearchFilter.vala"
	criteria = search_filter_actions_get_criteria (_tmp45_);
#line 1332 "../src/SearchFilter.vala"
	_tmp46_ = self->priv->search_box;
#line 1332 "../src/SearchFilter.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_TEXT) != 0);
#line 1334 "../src/SearchFilter.vala"
	_tmp47_ = self->priv->rating_button;
#line 1334 "../src/SearchFilter.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_RATING) != 0);
#line 1336 "../src/SearchFilter.vala"
	_tmp48_ = self->priv->toolbtn_flag;
#line 1336 "../src/SearchFilter.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_FLAG) != 0);
#line 1338 "../src/SearchFilter.vala"
	_tmp49_ = self->priv->label_type;
#line 1338 "../src/SearchFilter.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_MEDIA) != 0);
#line 1339 "../src/SearchFilter.vala"
	_tmp50_ = self->priv->toolbtn_photos;
#line 1339 "../src/SearchFilter.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_MEDIA) != 0);
#line 1340 "../src/SearchFilter.vala"
	_tmp51_ = self->priv->toolbtn_videos;
#line 1340 "../src/SearchFilter.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_MEDIA) != 0);
#line 1341 "../src/SearchFilter.vala"
	_tmp52_ = self->priv->toolbtn_raw;
#line 1341 "../src/SearchFilter.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_MEDIA) != 0);
#line 1343 "../src/SearchFilter.vala"
	_tmp53_ = self->priv->saved_search_button;
#line 1343 "../src/SearchFilter.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_SAVEDSEARCH) != 0);
#line 1347 "../src/SearchFilter.vala"
	_tmp55_ = self->priv->label_type;
#line 1347 "../src/SearchFilter.vala"
	_tmp56_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, gtk_widget_get_type (), GtkWidget));
#line 1347 "../src/SearchFilter.vala"
	_tmp57_ = _tmp56_;
#line 1347 "../src/SearchFilter.vala"
	if (_tmp57_) {
#line 6519 "SearchFilter.c"
		SearchFilterToolbarToggleActionToolButton* _tmp58_;
		gboolean _tmp59_;
		gboolean _tmp60_;
#line 1347 "../src/SearchFilter.vala"
		_tmp58_ = self->priv->toolbtn_flag;
#line 1347 "../src/SearchFilter.vala"
		_tmp59_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, gtk_widget_get_type (), GtkWidget));
#line 1347 "../src/SearchFilter.vala"
		_tmp60_ = _tmp59_;
#line 1347 "../src/SearchFilter.vala"
		_tmp54_ = _tmp60_;
#line 6531 "SearchFilter.c"
	} else {
#line 1347 "../src/SearchFilter.vala"
		_tmp54_ = FALSE;
#line 6535 "SearchFilter.c"
	}
#line 1347 "../src/SearchFilter.vala"
	_tmp61_ = self->priv->sepr_mediatype_flagged;
#line 1347 "../src/SearchFilter.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, gtk_widget_get_type (), GtkWidget), _tmp54_);
#line 1349 "../src/SearchFilter.vala"
	_tmp64_ = self->priv->label_type;
#line 1349 "../src/SearchFilter.vala"
	_tmp65_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, gtk_widget_get_type (), GtkWidget));
#line 1349 "../src/SearchFilter.vala"
	_tmp66_ = _tmp65_;
#line 1349 "../src/SearchFilter.vala"
	if (_tmp66_) {
#line 6549 "SearchFilter.c"
		SearchFilterToolbarRatingFilterButton* _tmp67_;
		gboolean _tmp68_;
		gboolean _tmp69_;
#line 1349 "../src/SearchFilter.vala"
		_tmp67_ = self->priv->rating_button;
#line 1349 "../src/SearchFilter.vala"
		_tmp68_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, gtk_widget_get_type (), GtkWidget));
#line 1349 "../src/SearchFilter.vala"
		_tmp69_ = _tmp68_;
#line 1349 "../src/SearchFilter.vala"
		_tmp63_ = _tmp69_;
#line 6561 "SearchFilter.c"
	} else {
#line 1349 "../src/SearchFilter.vala"
		_tmp63_ = FALSE;
#line 6565 "SearchFilter.c"
	}
#line 1349 "../src/SearchFilter.vala"
	if (_tmp63_) {
#line 1349 "../src/SearchFilter.vala"
		_tmp62_ = TRUE;
#line 6571 "SearchFilter.c"
	} else {
		gboolean _tmp70_ = FALSE;
		SearchFilterToolbarToggleActionToolButton* _tmp71_;
		gboolean _tmp72_;
		gboolean _tmp73_;
#line 1350 "../src/SearchFilter.vala"
		_tmp71_ = self->priv->toolbtn_flag;
#line 1350 "../src/SearchFilter.vala"
		_tmp72_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, gtk_widget_get_type (), GtkWidget));
#line 1350 "../src/SearchFilter.vala"
		_tmp73_ = _tmp72_;
#line 1350 "../src/SearchFilter.vala"
		if (_tmp73_) {
#line 6585 "SearchFilter.c"
			SearchFilterToolbarRatingFilterButton* _tmp74_;
			gboolean _tmp75_;
			gboolean _tmp76_;
#line 1350 "../src/SearchFilter.vala"
			_tmp74_ = self->priv->rating_button;
#line 1350 "../src/SearchFilter.vala"
			_tmp75_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, gtk_widget_get_type (), GtkWidget));
#line 1350 "../src/SearchFilter.vala"
			_tmp76_ = _tmp75_;
#line 1350 "../src/SearchFilter.vala"
			_tmp70_ = _tmp76_;
#line 6597 "SearchFilter.c"
		} else {
#line 1350 "../src/SearchFilter.vala"
			_tmp70_ = FALSE;
#line 6601 "SearchFilter.c"
		}
#line 1350 "../src/SearchFilter.vala"
		_tmp62_ = _tmp70_;
#line 6605 "SearchFilter.c"
	}
#line 1349 "../src/SearchFilter.vala"
	_tmp77_ = self->priv->sepr_flagged_rating;
#line 1349 "../src/SearchFilter.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, gtk_widget_get_type (), GtkWidget), _tmp62_);
#line 1353 "../src/SearchFilter.vala"
	_tmp78_ = self->priv->search_filter;
#line 1353 "../src/SearchFilter.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, TYPE_VIEW_FILTER, ViewFilter), "refresh");
#line 6615 "SearchFilter.c"
}

static void
search_filter_toolbar_on_savedsearch_selected (SearchFilterToolbar* self,
                                               SavedSearch* saved_search)
{
	SavedSearch* _tmp0_;
#line 1356 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1356 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SAVED_SEARCH (saved_search));
#line 1357 "../src/SearchFilter.vala"
	_tmp0_ = _g_object_ref0 (saved_search);
#line 1357 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->saved_search);
#line 1357 "../src/SearchFilter.vala"
	self->priv->saved_search = _tmp0_;
#line 1358 "../src/SearchFilter.vala"
	search_filter_toolbar_update (self);
#line 6635 "SearchFilter.c"
}

static void
search_filter_toolbar_disable_savedsearch (SearchFilterToolbar* self)
{
#line 1361 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1362 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->saved_search);
#line 1362 "../src/SearchFilter.vala"
	self->priv->saved_search = NULL;
#line 1363 "../src/SearchFilter.vala"
	search_filter_toolbar_update (self);
#line 6649 "SearchFilter.c"
}

static void
search_filter_toolbar_edit_dialog (SearchFilterToolbar* self,
                                   SavedSearch* search)
{
	SearchFilterToolbarSavedSearchFilterButton* _tmp0_;
	SearchFilterToolbarSavedSearchPopover* _tmp1_;
	SavedSearchDialog* ssd = NULL;
	SavedSearchDialog* _tmp2_;
#line 1366 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1366 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SAVED_SEARCH (search));
#line 1367 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->saved_search_button;
#line 1367 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_->filter_popup;
#line 1367 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_hide (_tmp1_);
#line 1368 "../src/SearchFilter.vala"
	_tmp2_ = saved_search_dialog_new_edit_existing (search);
#line 1368 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp2_);
#line 1368 "../src/SearchFilter.vala"
	ssd = _tmp2_;
#line 1369 "../src/SearchFilter.vala"
	saved_search_dialog_show (ssd);
#line 1366 "../src/SearchFilter.vala"
	_g_object_unref0 (ssd);
#line 6680 "SearchFilter.c"
}

static void
search_filter_toolbar_delete_dialog (SearchFilterToolbar* self,
                                     SavedSearch* search)
{
	SearchFilterToolbarSavedSearchFilterButton* _tmp0_;
	SearchFilterToolbarSavedSearchPopover* _tmp1_;
#line 1372 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1372 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SAVED_SEARCH (search));
#line 1373 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->saved_search_button;
#line 1373 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_->filter_popup;
#line 1373 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_hide (_tmp1_);
#line 1374 "../src/SearchFilter.vala"
	if (dialogs_confirm_delete_saved_search (search)) {
#line 6701 "SearchFilter.c"
		CommandManager* _tmp2_;
		CommandManager* _tmp3_;
		DeleteSavedSearchCommand* _tmp4_;
		DeleteSavedSearchCommand* _tmp5_;
#line 1375 "../src/SearchFilter.vala"
		_tmp2_ = app_window_get_command_manager ();
#line 1375 "../src/SearchFilter.vala"
		_tmp3_ = _tmp2_;
#line 1375 "../src/SearchFilter.vala"
		_tmp4_ = delete_saved_search_command_new (search);
#line 1375 "../src/SearchFilter.vala"
		_tmp5_ = _tmp4_;
#line 1375 "../src/SearchFilter.vala"
		command_manager_execute (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_COMMAND, Command));
#line 1375 "../src/SearchFilter.vala"
		_g_object_unref0 (_tmp5_);
#line 1375 "../src/SearchFilter.vala"
		_command_manager_unref0 (_tmp3_);
#line 6720 "SearchFilter.c"
	}
}

static void
search_filter_toolbar_add_dialog (SearchFilterToolbar* self)
{
	SearchFilterToolbarSavedSearchFilterButton* _tmp0_;
	SearchFilterToolbarSavedSearchPopover* _tmp1_;
	SavedSearchDialog* _tmp2_;
	SavedSearchDialog* _tmp3_;
#line 1378 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1379 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->saved_search_button;
#line 1379 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_->filter_popup;
#line 1379 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_hide (_tmp1_);
#line 1380 "../src/SearchFilter.vala"
	_tmp2_ = saved_search_dialog_new ();
#line 1380 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp2_);
#line 1380 "../src/SearchFilter.vala"
	_tmp3_ = _tmp2_;
#line 1380 "../src/SearchFilter.vala"
	saved_search_dialog_show (_tmp3_);
#line 1380 "../src/SearchFilter.vala"
	_g_object_unref0 (_tmp3_);
#line 6749 "SearchFilter.c"
}

static void
search_filter_toolbar_on_popover_closed (SearchFilterToolbar* self)
{
	SearchFilterToolbarSavedSearchFilterButton* _tmp0_;
	SavedSearch* _tmp1_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp2_;
	SearchFilterToolbarSavedSearchPopover* _tmp3_;
#line 1383 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1385 "../src/SearchFilter.vala"
	self->priv->elide_showing_again = TRUE;
#line 1386 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->saved_search_button;
#line 1386 "../src/SearchFilter.vala"
	_tmp1_ = self->priv->saved_search;
#line 1386 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_filter_button_set_active (_tmp0_, _tmp1_ != NULL);
#line 1387 "../src/SearchFilter.vala"
	_tmp2_ = self->priv->saved_search_button;
#line 1387 "../src/SearchFilter.vala"
	_tmp3_ = _tmp2_->filter_popup;
#line 1387 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_hide (_tmp3_);
#line 6775 "SearchFilter.c"
}

static void
_search_filter_toolbar_edit_dialog_search_filter_toolbar_saved_search_popover_edit_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                            SavedSearch* search,
                                                                                            gpointer self)
{
#line 1398 "../src/SearchFilter.vala"
	search_filter_toolbar_edit_dialog ((SearchFilterToolbar*) self, search);
#line 6785 "SearchFilter.c"
}

static void
_search_filter_toolbar_on_savedsearch_selected_search_filter_toolbar_saved_search_popover_search_activated (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                            SavedSearch* search,
                                                                                                            gpointer self)
{
#line 1399 "../src/SearchFilter.vala"
	search_filter_toolbar_on_savedsearch_selected ((SearchFilterToolbar*) self, search);
#line 6795 "SearchFilter.c"
}

static void
_search_filter_toolbar_delete_dialog_search_filter_toolbar_saved_search_popover_delete_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                SavedSearch* search,
                                                                                                gpointer self)
{
#line 1400 "../src/SearchFilter.vala"
	search_filter_toolbar_delete_dialog ((SearchFilterToolbar*) self, search);
#line 6805 "SearchFilter.c"
}

static void
_search_filter_toolbar_add_dialog_search_filter_toolbar_saved_search_popover_add_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                          gpointer self)
{
#line 1401 "../src/SearchFilter.vala"
	search_filter_toolbar_add_dialog ((SearchFilterToolbar*) self);
#line 6814 "SearchFilter.c"
}

static void
_search_filter_toolbar_on_popover_closed_search_filter_toolbar_saved_search_popover_closed (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                            gpointer self)
{
#line 1402 "../src/SearchFilter.vala"
	search_filter_toolbar_on_popover_closed ((SearchFilterToolbar*) self);
#line 6823 "SearchFilter.c"
}

static void
search_filter_toolbar_on_saved_search_button_clicked (SearchFilterToolbar* self)
{
	gboolean _tmp0_ = FALSE;
#line 1390 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1391 "../src/SearchFilter.vala"
	if (self->priv->elide_showing_again) {
#line 6834 "SearchFilter.c"
		SavedSearch* _tmp1_;
#line 1391 "../src/SearchFilter.vala"
		_tmp1_ = self->priv->saved_search;
#line 1391 "../src/SearchFilter.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 6840 "SearchFilter.c"
	} else {
#line 1391 "../src/SearchFilter.vala"
		_tmp0_ = FALSE;
#line 6844 "SearchFilter.c"
	}
#line 1391 "../src/SearchFilter.vala"
	if (_tmp0_) {
#line 6848 "SearchFilter.c"
	} else {
		SavedSearch* _tmp2_;
#line 1392 "../src/SearchFilter.vala"
		_tmp2_ = self->priv->saved_search;
#line 1392 "../src/SearchFilter.vala"
		if (_tmp2_ != NULL) {
#line 6855 "SearchFilter.c"
			SearchFilterToolbarSavedSearchFilterButton* _tmp3_;
#line 1393 "../src/SearchFilter.vala"
			_g_object_unref0 (self->priv->saved_search);
#line 1393 "../src/SearchFilter.vala"
			self->priv->saved_search = NULL;
#line 1394 "../src/SearchFilter.vala"
			_tmp3_ = self->priv->saved_search_button;
#line 1394 "../src/SearchFilter.vala"
			search_filter_toolbar_saved_search_filter_button_set_active (_tmp3_, FALSE);
#line 1395 "../src/SearchFilter.vala"
			search_filter_toolbar_disable_savedsearch (self);
#line 6867 "SearchFilter.c"
		} else {
			SearchFilterToolbarSavedSearchFilterButton* _tmp4_;
			SearchFilterToolbarSavedSearchPopover* _tmp5_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp21_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp22_;
			SearchFilterToolbarSavedSearchPopover* _tmp23_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp24_;
			SearchFilterToolbarSavedSearchPopover* _tmp25_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp26_;
			SearchFilterToolbarSavedSearchPopover* _tmp27_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp28_;
			SearchFilterToolbarSavedSearchPopover* _tmp29_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp30_;
			SearchFilterToolbarSavedSearchPopover* _tmp31_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp32_;
			SearchFilterToolbarSavedSearchPopover* _tmp33_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp34_;
			SearchFilterToolbarSavedSearchPopover* _tmp35_;
#line 1397 "../src/SearchFilter.vala"
			_tmp4_ = self->priv->saved_search_button;
#line 1397 "../src/SearchFilter.vala"
			_tmp5_ = _tmp4_->filter_popup;
#line 1397 "../src/SearchFilter.vala"
			if (_tmp5_ != NULL) {
#line 6892 "SearchFilter.c"
				SearchFilterToolbarSavedSearchFilterButton* _tmp6_;
				SearchFilterToolbarSavedSearchPopover* _tmp7_;
				guint _tmp8_;
				SearchFilterToolbarSavedSearchFilterButton* _tmp9_;
				SearchFilterToolbarSavedSearchPopover* _tmp10_;
				guint _tmp11_;
				SearchFilterToolbarSavedSearchFilterButton* _tmp12_;
				SearchFilterToolbarSavedSearchPopover* _tmp13_;
				guint _tmp14_;
				SearchFilterToolbarSavedSearchFilterButton* _tmp15_;
				SearchFilterToolbarSavedSearchPopover* _tmp16_;
				guint _tmp17_;
				SearchFilterToolbarSavedSearchFilterButton* _tmp18_;
				SearchFilterToolbarSavedSearchPopover* _tmp19_;
				guint _tmp20_;
#line 1398 "../src/SearchFilter.vala"
				_tmp6_ = self->priv->saved_search_button;
#line 1398 "../src/SearchFilter.vala"
				_tmp7_ = _tmp6_->filter_popup;
#line 1398 "../src/SearchFilter.vala"
				g_signal_parse_name ("edit-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, &_tmp8_, NULL, FALSE);
#line 1398 "../src/SearchFilter.vala"
				g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _search_filter_toolbar_edit_dialog_search_filter_toolbar_saved_search_popover_edit_clicked, self);
#line 1399 "../src/SearchFilter.vala"
				_tmp9_ = self->priv->saved_search_button;
#line 1399 "../src/SearchFilter.vala"
				_tmp10_ = _tmp9_->filter_popup;
#line 1399 "../src/SearchFilter.vala"
				g_signal_parse_name ("search-activated", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, &_tmp11_, NULL, FALSE);
#line 1399 "../src/SearchFilter.vala"
				g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _search_filter_toolbar_on_savedsearch_selected_search_filter_toolbar_saved_search_popover_search_activated, self);
#line 1400 "../src/SearchFilter.vala"
				_tmp12_ = self->priv->saved_search_button;
#line 1400 "../src/SearchFilter.vala"
				_tmp13_ = _tmp12_->filter_popup;
#line 1400 "../src/SearchFilter.vala"
				g_signal_parse_name ("delete-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, &_tmp14_, NULL, FALSE);
#line 1400 "../src/SearchFilter.vala"
				g_signal_handlers_disconnect_matched (_tmp13_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _search_filter_toolbar_delete_dialog_search_filter_toolbar_saved_search_popover_delete_clicked, self);
#line 1401 "../src/SearchFilter.vala"
				_tmp15_ = self->priv->saved_search_button;
#line 1401 "../src/SearchFilter.vala"
				_tmp16_ = _tmp15_->filter_popup;
#line 1401 "../src/SearchFilter.vala"
				g_signal_parse_name ("add-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, &_tmp17_, NULL, FALSE);
#line 1401 "../src/SearchFilter.vala"
				g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _search_filter_toolbar_add_dialog_search_filter_toolbar_saved_search_popover_add_clicked, self);
#line 1402 "../src/SearchFilter.vala"
				_tmp18_ = self->priv->saved_search_button;
#line 1402 "../src/SearchFilter.vala"
				_tmp19_ = _tmp18_->filter_popup;
#line 1402 "../src/SearchFilter.vala"
				g_signal_parse_name ("closed", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, &_tmp20_, NULL, FALSE);
#line 1402 "../src/SearchFilter.vala"
				g_signal_handlers_disconnect_matched (_tmp19_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _search_filter_toolbar_on_popover_closed_search_filter_toolbar_saved_search_popover_closed, self);
#line 6948 "SearchFilter.c"
			}
#line 1404 "../src/SearchFilter.vala"
			_tmp21_ = self->priv->saved_search_button;
#line 1404 "../src/SearchFilter.vala"
			_tmp22_ = self->priv->saved_search_button;
#line 1404 "../src/SearchFilter.vala"
			_tmp23_ = search_filter_toolbar_saved_search_popover_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_widget_get_type (), GtkWidget));
#line 1404 "../src/SearchFilter.vala"
			_search_filter_toolbar_saved_search_popover_unref0 (_tmp21_->filter_popup);
#line 1404 "../src/SearchFilter.vala"
			_tmp21_->filter_popup = _tmp23_;
#line 1405 "../src/SearchFilter.vala"
			_tmp24_ = self->priv->saved_search_button;
#line 1405 "../src/SearchFilter.vala"
			_tmp25_ = _tmp24_->filter_popup;
#line 1405 "../src/SearchFilter.vala"
			g_signal_connect_object (_tmp25_, "edit-clicked", (GCallback) _search_filter_toolbar_edit_dialog_search_filter_toolbar_saved_search_popover_edit_clicked, self, 0);
#line 1406 "../src/SearchFilter.vala"
			_tmp26_ = self->priv->saved_search_button;
#line 1406 "../src/SearchFilter.vala"
			_tmp27_ = _tmp26_->filter_popup;
#line 1406 "../src/SearchFilter.vala"
			g_signal_connect_object (_tmp27_, "search-activated", (GCallback) _search_filter_toolbar_on_savedsearch_selected_search_filter_toolbar_saved_search_popover_search_activated, self, 0);
#line 1407 "../src/SearchFilter.vala"
			_tmp28_ = self->priv->saved_search_button;
#line 1407 "../src/SearchFilter.vala"
			_tmp29_ = _tmp28_->filter_popup;
#line 1407 "../src/SearchFilter.vala"
			g_signal_connect_object (_tmp29_, "delete-clicked", (GCallback) _search_filter_toolbar_delete_dialog_search_filter_toolbar_saved_search_popover_delete_clicked, self, 0);
#line 1408 "../src/SearchFilter.vala"
			_tmp30_ = self->priv->saved_search_button;
#line 1408 "../src/SearchFilter.vala"
			_tmp31_ = _tmp30_->filter_popup;
#line 1408 "../src/SearchFilter.vala"
			g_signal_connect_object (_tmp31_, "add-clicked", (GCallback) _search_filter_toolbar_add_dialog_search_filter_toolbar_saved_search_popover_add_clicked, self, 0);
#line 1409 "../src/SearchFilter.vala"
			_tmp32_ = self->priv->saved_search_button;
#line 1409 "../src/SearchFilter.vala"
			_tmp33_ = _tmp32_->filter_popup;
#line 1409 "../src/SearchFilter.vala"
			g_signal_connect_object (_tmp33_, "closed", (GCallback) _search_filter_toolbar_on_popover_closed_search_filter_toolbar_saved_search_popover_closed, self, 0);
#line 1411 "../src/SearchFilter.vala"
			_tmp34_ = self->priv->saved_search_button;
#line 1411 "../src/SearchFilter.vala"
			_tmp35_ = _tmp34_->filter_popup;
#line 1411 "../src/SearchFilter.vala"
			search_filter_toolbar_saved_search_popover_show_all (_tmp35_);
#line 6996 "SearchFilter.c"
		}
	}
#line 1413 "../src/SearchFilter.vala"
	self->priv->elide_showing_again = FALSE;
#line 7001 "SearchFilter.c"
}

void
search_filter_toolbar_take_focus (SearchFilterToolbar* self)
{
	SearchFilterToolbarSearchBox* _tmp0_;
#line 1416 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
#line 1417 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_box;
#line 1417 "../src/SearchFilter.vala"
	search_filter_toolbar_search_box_get_focus (_tmp0_);
#line 7014 "SearchFilter.c"
}

static inline gpointer
search_filter_toolbar_label_tool_item_get_instance_private (SearchFilterToolbarLabelToolItem* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbarLabelToolItem_private_offset);
}

static SearchFilterToolbarLabelToolItem*
search_filter_toolbar_label_tool_item_construct (GType object_type,
                                                 const gchar* s,
                                                 gint left_padding,
                                                 gint right_padding)
{
	SearchFilterToolbarLabelToolItem * self = NULL;
	GtkLabel* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GtkLabel* _tmp6_;
#line 636 "../src/SearchFilter.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 636 "../src/SearchFilter.vala"
	self = (SearchFilterToolbarLabelToolItem*) g_object_new (object_type, NULL);
#line 637 "../src/SearchFilter.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (s);
#line 637 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp0_);
#line 637 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->label);
#line 637 "../src/SearchFilter.vala"
	self->priv->label = _tmp0_;
#line 638 "../src/SearchFilter.vala"
	if (left_padding != 0) {
#line 638 "../src/SearchFilter.vala"
		_tmp1_ = TRUE;
#line 7049 "SearchFilter.c"
	} else {
#line 638 "../src/SearchFilter.vala"
		_tmp1_ = right_padding != 0;
#line 7053 "SearchFilter.c"
	}
#line 638 "../src/SearchFilter.vala"
	if (_tmp1_) {
#line 7057 "SearchFilter.c"
		GtkLabel* _tmp2_;
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
		GtkLabel* _tmp5_;
#line 639 "../src/SearchFilter.vala"
		_tmp2_ = self->priv->label;
#line 639 "../src/SearchFilter.vala"
		gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
#line 640 "../src/SearchFilter.vala"
		_tmp3_ = self->priv->label;
#line 640 "../src/SearchFilter.vala"
		gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_CENTER);
#line 641 "../src/SearchFilter.vala"
		_tmp4_ = self->priv->label;
#line 641 "../src/SearchFilter.vala"
		gtk_widget_set_margin_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), left_padding);
#line 642 "../src/SearchFilter.vala"
		_tmp5_ = self->priv->label;
#line 642 "../src/SearchFilter.vala"
		gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget), right_padding);
#line 7078 "SearchFilter.c"
	}
#line 644 "../src/SearchFilter.vala"
	_tmp6_ = self->priv->label;
#line 644 "../src/SearchFilter.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget));
#line 636 "../src/SearchFilter.vala"
	return self;
#line 7086 "SearchFilter.c"
}

static SearchFilterToolbarLabelToolItem*
search_filter_toolbar_label_tool_item_new (const gchar* s,
                                           gint left_padding,
                                           gint right_padding)
{
#line 636 "../src/SearchFilter.vala"
	return search_filter_toolbar_label_tool_item_construct (SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM, s, left_padding, right_padding);
#line 7096 "SearchFilter.c"
}

static void
search_filter_toolbar_label_tool_item_class_init (SearchFilterToolbarLabelToolItemClass * klass,
                                                  gpointer klass_data)
{
#line 633 "../src/SearchFilter.vala"
	search_filter_toolbar_label_tool_item_parent_class = g_type_class_peek_parent (klass);
#line 633 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbarLabelToolItem_private_offset);
#line 633 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_label_tool_item_finalize;
#line 7109 "SearchFilter.c"
}

static void
search_filter_toolbar_label_tool_item_instance_init (SearchFilterToolbarLabelToolItem * self,
                                                     gpointer klass)
{
#line 633 "../src/SearchFilter.vala"
	self->priv = search_filter_toolbar_label_tool_item_get_instance_private (self);
#line 7118 "SearchFilter.c"
}

static void
search_filter_toolbar_label_tool_item_finalize (GObject * obj)
{
	SearchFilterToolbarLabelToolItem * self;
#line 633 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM, SearchFilterToolbarLabelToolItem);
#line 634 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->label);
#line 633 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (search_filter_toolbar_label_tool_item_parent_class)->finalize (obj);
#line 7131 "SearchFilter.c"
}

static GType
search_filter_toolbar_label_tool_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarLabelToolItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_label_tool_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarLabelToolItem), 0, (GInstanceInitFunc) search_filter_toolbar_label_tool_item_instance_init, NULL };
	GType search_filter_toolbar_label_tool_item_type_id;
	search_filter_toolbar_label_tool_item_type_id = g_type_register_static (gtk_tool_item_get_type (), "SearchFilterToolbarLabelToolItem", &g_define_type_info, 0);
	SearchFilterToolbarLabelToolItem_private_offset = g_type_add_instance_private (search_filter_toolbar_label_tool_item_type_id, sizeof (SearchFilterToolbarLabelToolItemPrivate));
	return search_filter_toolbar_label_tool_item_type_id;
}

static GType
search_filter_toolbar_label_tool_item_get_type (void)
{
	static volatile gsize search_filter_toolbar_label_tool_item_type_id__volatile = 0;
	if (g_once_init_enter (&search_filter_toolbar_label_tool_item_type_id__volatile)) {
		GType search_filter_toolbar_label_tool_item_type_id;
		search_filter_toolbar_label_tool_item_type_id = search_filter_toolbar_label_tool_item_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_label_tool_item_type_id__volatile, search_filter_toolbar_label_tool_item_type_id);
	}
	return search_filter_toolbar_label_tool_item_type_id__volatile;
}

static inline gpointer
search_filter_toolbar_toggle_action_tool_button_get_instance_private (SearchFilterToolbarToggleActionToolButton* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbarToggleActionToolButton_private_offset);
}

static SearchFilterToolbarToggleActionToolButton*
search_filter_toolbar_toggle_action_tool_button_construct (GType object_type,
                                                           const gchar* action)
{
	SearchFilterToolbarToggleActionToolButton * self = NULL;
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
	GtkToggleButton* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkToggleButton* _tmp4_;
	GtkToggleButton* _tmp5_;
	GtkToggleButton* _tmp6_;
#line 651 "../src/SearchFilter.vala"
	g_return_val_if_fail (action != NULL, NULL);
#line 651 "../src/SearchFilter.vala"
	self = (SearchFilterToolbarToggleActionToolButton*) g_object_new (object_type, NULL);
#line 652 "../src/SearchFilter.vala"
	_tmp0_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 652 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp0_);
#line 652 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->button);
#line 652 "../src/SearchFilter.vala"
	self->priv->button = _tmp0_;
#line 653 "../src/SearchFilter.vala"
	_tmp1_ = self->priv->button;
#line 653 "../src/SearchFilter.vala"
	gtk_widget_set_can_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 654 "../src/SearchFilter.vala"
	_tmp2_ = self->priv->button;
#line 654 "../src/SearchFilter.vala"
	gtk_actionable_set_action_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_actionable_get_type (), GtkActionable), action);
#line 655 "../src/SearchFilter.vala"
	_tmp3_ = self->priv->button;
#line 655 "../src/SearchFilter.vala"
	gtk_widget_set_has_tooltip (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 656 "../src/SearchFilter.vala"
	_tmp4_ = self->priv->button;
#line 656 "../src/SearchFilter.vala"
	gtk_button_set_relief (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_button_get_type (), GtkButton), GTK_RELIEF_NONE);
#line 657 "../src/SearchFilter.vala"
	_tmp5_ = self->priv->button;
#line 657 "../src/SearchFilter.vala"
	gtk_widget_set_margin_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget), 2);
#line 659 "../src/SearchFilter.vala"
	_tmp6_ = self->priv->button;
#line 659 "../src/SearchFilter.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget));
#line 651 "../src/SearchFilter.vala"
	return self;
#line 7212 "SearchFilter.c"
}

static SearchFilterToolbarToggleActionToolButton*
search_filter_toolbar_toggle_action_tool_button_new (const gchar* action)
{
#line 651 "../src/SearchFilter.vala"
	return search_filter_toolbar_toggle_action_tool_button_construct (SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON, action);
#line 7220 "SearchFilter.c"
}

static void
search_filter_toolbar_toggle_action_tool_button_set_icon_name (SearchFilterToolbarToggleActionToolButton* self,
                                                               const gchar* icon_name)
{
	GtkImage* image = NULL;
	GtkToggleButton* _tmp0_;
	GtkImage* _tmp1_;
	GtkToggleButton* _tmp2_;
	GtkImage* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GtkToggleButton* _tmp5_;
	const gchar* _tmp6_;
#line 662 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_TOGGLE_ACTION_TOOL_BUTTON (self));
#line 662 "../src/SearchFilter.vala"
	g_return_if_fail (icon_name != NULL);
#line 663 "../src/SearchFilter.vala"
	image = NULL;
#line 664 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->button;
#line 664 "../src/SearchFilter.vala"
	gtk_button_set_always_show_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), TRUE);
#line 665 "../src/SearchFilter.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 665 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp1_);
#line 665 "../src/SearchFilter.vala"
	_g_object_unref0 (image);
#line 665 "../src/SearchFilter.vala"
	image = _tmp1_;
#line 666 "../src/SearchFilter.vala"
	_tmp2_ = self->priv->button;
#line 666 "../src/SearchFilter.vala"
	_tmp3_ = image;
#line 666 "../src/SearchFilter.vala"
	gtk_button_set_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_button_get_type (), GtkButton), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget));
#line 667 "../src/SearchFilter.vala"
	_tmp5_ = self->priv->button;
#line 667 "../src/SearchFilter.vala"
	_tmp6_ = gtk_button_get_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_button_get_type (), GtkButton));
#line 667 "../src/SearchFilter.vala"
	if (g_strcmp0 (_tmp6_, "") != 0) {
#line 7265 "SearchFilter.c"
		GtkToggleButton* _tmp7_;
		const gchar* _tmp8_;
#line 667 "../src/SearchFilter.vala"
		_tmp7_ = self->priv->button;
#line 667 "../src/SearchFilter.vala"
		_tmp8_ = gtk_button_get_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_button_get_type (), GtkButton));
#line 667 "../src/SearchFilter.vala"
		_tmp4_ = _tmp8_ != NULL;
#line 7274 "SearchFilter.c"
	} else {
#line 667 "../src/SearchFilter.vala"
		_tmp4_ = FALSE;
#line 7278 "SearchFilter.c"
	}
#line 667 "../src/SearchFilter.vala"
	if (_tmp4_) {
#line 7282 "SearchFilter.c"
		GtkImage* _tmp9_;
#line 668 "../src/SearchFilter.vala"
		_tmp9_ = image;
#line 668 "../src/SearchFilter.vala"
		gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget), 6);
#line 7288 "SearchFilter.c"
	}
#line 662 "../src/SearchFilter.vala"
	_g_object_unref0 (image);
#line 7292 "SearchFilter.c"
}

static void
search_filter_toolbar_toggle_action_tool_button_set_label (SearchFilterToolbarToggleActionToolButton* self,
                                                           const gchar* label)
{
	GtkToggleButton* _tmp0_;
#line 672 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_TOGGLE_ACTION_TOOL_BUTTON (self));
#line 672 "../src/SearchFilter.vala"
	g_return_if_fail (label != NULL);
#line 673 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->button;
#line 673 "../src/SearchFilter.vala"
	gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), label);
#line 7308 "SearchFilter.c"
}

static void
search_filter_toolbar_toggle_action_tool_button_class_init (SearchFilterToolbarToggleActionToolButtonClass * klass,
                                                            gpointer klass_data)
{
#line 648 "../src/SearchFilter.vala"
	search_filter_toolbar_toggle_action_tool_button_parent_class = g_type_class_peek_parent (klass);
#line 648 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbarToggleActionToolButton_private_offset);
#line 648 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_toggle_action_tool_button_finalize;
#line 7321 "SearchFilter.c"
}

static void
search_filter_toolbar_toggle_action_tool_button_instance_init (SearchFilterToolbarToggleActionToolButton * self,
                                                               gpointer klass)
{
#line 648 "../src/SearchFilter.vala"
	self->priv = search_filter_toolbar_toggle_action_tool_button_get_instance_private (self);
#line 7330 "SearchFilter.c"
}

static void
search_filter_toolbar_toggle_action_tool_button_finalize (GObject * obj)
{
	SearchFilterToolbarToggleActionToolButton * self;
#line 648 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON, SearchFilterToolbarToggleActionToolButton);
#line 649 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->button);
#line 648 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (search_filter_toolbar_toggle_action_tool_button_parent_class)->finalize (obj);
#line 7343 "SearchFilter.c"
}

static GType
search_filter_toolbar_toggle_action_tool_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarToggleActionToolButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_toggle_action_tool_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarToggleActionToolButton), 0, (GInstanceInitFunc) search_filter_toolbar_toggle_action_tool_button_instance_init, NULL };
	GType search_filter_toolbar_toggle_action_tool_button_type_id;
	search_filter_toolbar_toggle_action_tool_button_type_id = g_type_register_static (gtk_tool_item_get_type (), "SearchFilterToolbarToggleActionToolButton", &g_define_type_info, 0);
	SearchFilterToolbarToggleActionToolButton_private_offset = g_type_add_instance_private (search_filter_toolbar_toggle_action_tool_button_type_id, sizeof (SearchFilterToolbarToggleActionToolButtonPrivate));
	return search_filter_toolbar_toggle_action_tool_button_type_id;
}

static GType
search_filter_toolbar_toggle_action_tool_button_get_type (void)
{
	static volatile gsize search_filter_toolbar_toggle_action_tool_button_type_id__volatile = 0;
	if (g_once_init_enter (&search_filter_toolbar_toggle_action_tool_button_type_id__volatile)) {
		GType search_filter_toolbar_toggle_action_tool_button_type_id;
		search_filter_toolbar_toggle_action_tool_button_type_id = search_filter_toolbar_toggle_action_tool_button_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_toggle_action_tool_button_type_id__volatile, search_filter_toolbar_toggle_action_tool_button_type_id);
	}
	return search_filter_toolbar_toggle_action_tool_button_type_id__volatile;
}

static inline gpointer
search_filter_toolbar_search_box_get_instance_private (SearchFilterToolbarSearchBox* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbarSearchBox_private_offset);
}

static void
_search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed (TextAction* _sender,
                                                                                   const gchar* text,
                                                                                   gpointer self)
{
#line 708 "../src/SearchFilter.vala"
	search_filter_toolbar_search_box_on_action_text_changed ((SearchFilterToolbarSearchBox*) self, text);
#line 7381 "SearchFilter.c"
}

static void
_search_filter_toolbar_search_box_on_sensitivity_changed_text_action_sensitivity_changed (TextAction* _sender,
                                                                                          gboolean sensitive,
                                                                                          gpointer self)
{
#line 709 "../src/SearchFilter.vala"
	search_filter_toolbar_search_box_on_sensitivity_changed ((SearchFilterToolbarSearchBox*) self, sensitive);
#line 7391 "SearchFilter.c"
}

static void
_search_filter_toolbar_search_box_on_visibility_changed_text_action_visibility_changed (TextAction* _sender,
                                                                                        gboolean visible,
                                                                                        gpointer self)
{
#line 710 "../src/SearchFilter.vala"
	search_filter_toolbar_search_box_on_visibility_changed ((SearchFilterToolbarSearchBox*) self, visible);
#line 7401 "SearchFilter.c"
}

static void
_search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text (GtkEntryBuffer* _sender,
                                                                                  guint position,
                                                                                  guint n_chars,
                                                                                  gpointer self)
{
#line 712 "../src/SearchFilter.vala"
	search_filter_toolbar_search_box_on_entry_changed ((SearchFilterToolbarSearchBox*) self);
#line 7412 "SearchFilter.c"
}

static void
_search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text (GtkEntryBuffer* _sender,
                                                                                   guint position,
                                                                                   const gchar* chars,
                                                                                   guint n_chars,
                                                                                   gpointer self)
{
#line 713 "../src/SearchFilter.vala"
	search_filter_toolbar_search_box_on_entry_changed ((SearchFilterToolbarSearchBox*) self);
#line 7424 "SearchFilter.c"
}

static gpointer
_text_action_ref0 (gpointer self)
{
#line 690 "../src/SearchFilter.vala"
	return self ? text_action_ref (self) : NULL;
#line 7432 "SearchFilter.c"
}

static gboolean
_search_filter_toolbar_search_box_on_escape_key_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                            GdkEventKey* event,
                                                                            gpointer self)
{
	gboolean result;
	result = search_filter_toolbar_search_box_on_escape_key ((SearchFilterToolbarSearchBox*) self, event);
#line 694 "../src/SearchFilter.vala"
	return result;
#line 7444 "SearchFilter.c"
}

SearchFilterToolbarSearchBox*
search_filter_toolbar_search_box_construct (GType object_type,
                                            TextAction* action)
{
	SearchFilterToolbarSearchBox * self = NULL;
	TextAction* _tmp0_;
	GtkSearchEntry* _tmp1_;
	GtkSearchEntry* _tmp2_;
	GtkSearchEntry* _tmp3_;
	GtkSearchEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkSearchEntry* _tmp7_;
	GtkEntryBuffer* _tmp8_;
	GtkEntryBuffer* _tmp9_;
	GtkSearchEntry* _tmp10_;
	GtkEntryBuffer* _tmp11_;
	GtkEntryBuffer* _tmp12_;
#line 689 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_TEXT_ACTION (action), NULL);
#line 689 "../src/SearchFilter.vala"
	self = (SearchFilterToolbarSearchBox*) g_object_new (object_type, NULL);
#line 690 "../src/SearchFilter.vala"
	_tmp0_ = _text_action_ref0 (action);
#line 690 "../src/SearchFilter.vala"
	_text_action_unref0 (self->priv->action);
#line 690 "../src/SearchFilter.vala"
	self->priv->action = _tmp0_;
#line 691 "../src/SearchFilter.vala"
	_tmp1_ = (GtkSearchEntry*) gtk_search_entry_new ();
#line 691 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp1_);
#line 691 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->search_entry);
#line 691 "../src/SearchFilter.vala"
	self->priv->search_entry = _tmp1_;
#line 693 "../src/SearchFilter.vala"
	_tmp2_ = self->priv->search_entry;
#line 693 "../src/SearchFilter.vala"
	gtk_entry_set_width_chars (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_entry_get_type (), GtkEntry), 23);
#line 694 "../src/SearchFilter.vala"
	_tmp3_ = self->priv->search_entry;
#line 694 "../src/SearchFilter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), "key-press-event", (GCallback) _search_filter_toolbar_search_box_on_escape_key_gtk_widget_key_press_event, self, 0);
#line 695 "../src/SearchFilter.vala"
	_tmp4_ = self->priv->search_entry;
#line 695 "../src/SearchFilter.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
#line 697 "../src/SearchFilter.vala"
	_tmp5_ = text_action_get_value (action);
#line 697 "../src/SearchFilter.vala"
	_tmp6_ = _tmp5_;
#line 697 "../src/SearchFilter.vala"
	search_filter_toolbar_search_box_set_nullable_text (self, _tmp6_);
#line 699 "../src/SearchFilter.vala"
	g_signal_connect_object (action, "text-changed", (GCallback) _search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed, self, 0);
#line 700 "../src/SearchFilter.vala"
	g_signal_connect_object (action, "sensitivity-changed", (GCallback) _search_filter_toolbar_search_box_on_sensitivity_changed_text_action_sensitivity_changed, self, 0);
#line 701 "../src/SearchFilter.vala"
	g_signal_connect_object (action, "visibility-changed", (GCallback) _search_filter_toolbar_search_box_on_visibility_changed_text_action_visibility_changed, self, 0);
#line 703 "../src/SearchFilter.vala"
	_tmp7_ = self->priv->search_entry;
#line 703 "../src/SearchFilter.vala"
	_tmp8_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_entry_get_type (), GtkEntry));
#line 703 "../src/SearchFilter.vala"
	_tmp9_ = _tmp8_;
#line 703 "../src/SearchFilter.vala"
	g_signal_connect_object (_tmp9_, "deleted-text", (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text, self, 0);
#line 704 "../src/SearchFilter.vala"
	_tmp10_ = self->priv->search_entry;
#line 704 "../src/SearchFilter.vala"
	_tmp11_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_entry_get_type (), GtkEntry));
#line 704 "../src/SearchFilter.vala"
	_tmp12_ = _tmp11_;
#line 704 "../src/SearchFilter.vala"
	g_signal_connect_object (_tmp12_, "inserted-text", (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text, self, 0);
#line 689 "../src/SearchFilter.vala"
	return self;
#line 7525 "SearchFilter.c"
}

SearchFilterToolbarSearchBox*
search_filter_toolbar_search_box_new (TextAction* action)
{
#line 689 "../src/SearchFilter.vala"
	return search_filter_toolbar_search_box_construct (SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX, action);
#line 7533 "SearchFilter.c"
}

void
search_filter_toolbar_search_box_get_focus (SearchFilterToolbarSearchBox* self)
{
	GtkSearchEntry* _tmp0_;
#line 716 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
#line 717 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_entry;
#line 717 "../src/SearchFilter.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), "has-focus", TRUE, NULL);
#line 7546 "SearchFilter.c"
}

static gboolean
search_filter_toolbar_search_box_on_escape_key (SearchFilterToolbarSearchBox* self,
                                                GdkEventKey* e)
{
	const gchar* _tmp0_;
	gboolean result = FALSE;
#line 722 "../src/SearchFilter.vala"
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self), FALSE);
#line 722 "../src/SearchFilter.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 723 "../src/SearchFilter.vala"
	_tmp0_ = gdk_keyval_name (e->keyval);
#line 723 "../src/SearchFilter.vala"
	if (g_strcmp0 (_tmp0_, "Escape") == 0) {
#line 7563 "SearchFilter.c"
		TextAction* _tmp1_;
#line 724 "../src/SearchFilter.vala"
		_tmp1_ = self->priv->action;
#line 724 "../src/SearchFilter.vala"
		text_action_clear (_tmp1_);
#line 7569 "SearchFilter.c"
	}
#line 728 "../src/SearchFilter.vala"
	result = FALSE;
#line 728 "../src/SearchFilter.vala"
	return result;
#line 7575 "SearchFilter.c"
}

static void
search_filter_toolbar_search_box_on_action_text_changed (SearchFilterToolbarSearchBox* self,
                                                         const gchar* text)
{
	GtkSearchEntry* _tmp0_;
	GtkEntryBuffer* _tmp1_;
	GtkEntryBuffer* _tmp2_;
	guint _tmp3_;
	GtkSearchEntry* _tmp4_;
	GtkEntryBuffer* _tmp5_;
	GtkEntryBuffer* _tmp6_;
	guint _tmp7_;
	GtkSearchEntry* _tmp8_;
	GtkEntryBuffer* _tmp9_;
	GtkEntryBuffer* _tmp10_;
	GtkSearchEntry* _tmp11_;
	GtkEntryBuffer* _tmp12_;
	GtkEntryBuffer* _tmp13_;
#line 731 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
#line 732 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_entry;
#line 732 "../src/SearchFilter.vala"
	_tmp1_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_entry_get_type (), GtkEntry));
#line 732 "../src/SearchFilter.vala"
	_tmp2_ = _tmp1_;
#line 732 "../src/SearchFilter.vala"
	g_signal_parse_name ("deleted-text", gtk_entry_buffer_get_type (), &_tmp3_, NULL, FALSE);
#line 732 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text, self);
#line 733 "../src/SearchFilter.vala"
	_tmp4_ = self->priv->search_entry;
#line 733 "../src/SearchFilter.vala"
	_tmp5_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_entry_get_type (), GtkEntry));
#line 733 "../src/SearchFilter.vala"
	_tmp6_ = _tmp5_;
#line 733 "../src/SearchFilter.vala"
	g_signal_parse_name ("inserted-text", gtk_entry_buffer_get_type (), &_tmp7_, NULL, FALSE);
#line 733 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text, self);
#line 734 "../src/SearchFilter.vala"
	search_filter_toolbar_search_box_set_nullable_text (self, text);
#line 735 "../src/SearchFilter.vala"
	_tmp8_ = self->priv->search_entry;
#line 735 "../src/SearchFilter.vala"
	_tmp9_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_entry_get_type (), GtkEntry));
#line 735 "../src/SearchFilter.vala"
	_tmp10_ = _tmp9_;
#line 735 "../src/SearchFilter.vala"
	g_signal_connect_object (_tmp10_, "deleted-text", (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text, self, 0);
#line 736 "../src/SearchFilter.vala"
	_tmp11_ = self->priv->search_entry;
#line 736 "../src/SearchFilter.vala"
	_tmp12_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_entry_get_type (), GtkEntry));
#line 736 "../src/SearchFilter.vala"
	_tmp13_ = _tmp12_;
#line 736 "../src/SearchFilter.vala"
	g_signal_connect_object (_tmp13_, "inserted-text", (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text, self, 0);
#line 7636 "SearchFilter.c"
}

static void
search_filter_toolbar_search_box_on_entry_changed (SearchFilterToolbarSearchBox* self)
{
	TextAction* _tmp0_;
	guint _tmp1_;
	TextAction* _tmp2_;
	GtkSearchEntry* _tmp3_;
	const gchar* _tmp4_;
	TextAction* _tmp5_;
#line 739 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
#line 740 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->action;
#line 740 "../src/SearchFilter.vala"
	g_signal_parse_name ("text-changed", TYPE_TEXT_ACTION, &_tmp1_, NULL, FALSE);
#line 740 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed, self);
#line 741 "../src/SearchFilter.vala"
	_tmp2_ = self->priv->action;
#line 741 "../src/SearchFilter.vala"
	_tmp3_ = self->priv->search_entry;
#line 741 "../src/SearchFilter.vala"
	_tmp4_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_entry_get_type (), GtkEntry));
#line 741 "../src/SearchFilter.vala"
	text_action_set_text (_tmp2_, _tmp4_);
#line 742 "../src/SearchFilter.vala"
	_tmp5_ = self->priv->action;
#line 742 "../src/SearchFilter.vala"
	g_signal_connect_object (_tmp5_, "text-changed", (GCallback) _search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed, self, 0);
#line 7668 "SearchFilter.c"
}

static void
search_filter_toolbar_search_box_on_sensitivity_changed (SearchFilterToolbarSearchBox* self,
                                                         gboolean sensitive)
{
#line 745 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
#line 746 "../src/SearchFilter.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), sensitive);
#line 7679 "SearchFilter.c"
}

static void
search_filter_toolbar_search_box_on_visibility_changed (SearchFilterToolbarSearchBox* self,
                                                        gboolean visible)
{
#line 749 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
#line 750 "../src/SearchFilter.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), visible);
#line 7690 "SearchFilter.c"
}

static void
search_filter_toolbar_search_box_set_nullable_text (SearchFilterToolbarSearchBox* self,
                                                    const gchar* text)
{
	const gchar* _tmp0_ = NULL;
	GtkSearchEntry* _tmp1_;
#line 753 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
#line 754 "../src/SearchFilter.vala"
	if (text != NULL) {
#line 754 "../src/SearchFilter.vala"
		_tmp0_ = text;
#line 7705 "SearchFilter.c"
	} else {
#line 754 "../src/SearchFilter.vala"
		_tmp0_ = "";
#line 7709 "SearchFilter.c"
	}
#line 754 "../src/SearchFilter.vala"
	_tmp1_ = self->priv->search_entry;
#line 754 "../src/SearchFilter.vala"
	gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_entry_get_type (), GtkEntry), _tmp0_);
#line 7715 "SearchFilter.c"
}

static void
search_filter_toolbar_search_box_class_init (SearchFilterToolbarSearchBoxClass * klass,
                                             gpointer klass_data)
{
#line 685 "../src/SearchFilter.vala"
	search_filter_toolbar_search_box_parent_class = g_type_class_peek_parent (klass);
#line 685 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbarSearchBox_private_offset);
#line 685 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_search_box_finalize;
#line 7728 "SearchFilter.c"
}

static void
search_filter_toolbar_search_box_instance_init (SearchFilterToolbarSearchBox * self,
                                                gpointer klass)
{
#line 685 "../src/SearchFilter.vala"
	self->priv = search_filter_toolbar_search_box_get_instance_private (self);
#line 7737 "SearchFilter.c"
}

static void
search_filter_toolbar_search_box_finalize (GObject * obj)
{
	SearchFilterToolbarSearchBox * self;
	TextAction* _tmp0_;
	guint _tmp1_;
	TextAction* _tmp2_;
	guint _tmp3_;
	TextAction* _tmp4_;
	guint _tmp5_;
	GtkSearchEntry* _tmp6_;
	GtkEntryBuffer* _tmp7_;
	GtkEntryBuffer* _tmp8_;
	guint _tmp9_;
	GtkSearchEntry* _tmp10_;
	GtkEntryBuffer* _tmp11_;
	GtkEntryBuffer* _tmp12_;
	guint _tmp13_;
#line 685 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX, SearchFilterToolbarSearchBox);
#line 708 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->action;
#line 708 "../src/SearchFilter.vala"
	g_signal_parse_name ("text-changed", TYPE_TEXT_ACTION, &_tmp1_, NULL, FALSE);
#line 708 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed, self);
#line 709 "../src/SearchFilter.vala"
	_tmp2_ = self->priv->action;
#line 709 "../src/SearchFilter.vala"
	g_signal_parse_name ("sensitivity-changed", TYPE_TEXT_ACTION, &_tmp3_, NULL, FALSE);
#line 709 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_sensitivity_changed_text_action_sensitivity_changed, self);
#line 710 "../src/SearchFilter.vala"
	_tmp4_ = self->priv->action;
#line 710 "../src/SearchFilter.vala"
	g_signal_parse_name ("visibility-changed", TYPE_TEXT_ACTION, &_tmp5_, NULL, FALSE);
#line 710 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_visibility_changed_text_action_visibility_changed, self);
#line 712 "../src/SearchFilter.vala"
	_tmp6_ = self->priv->search_entry;
#line 712 "../src/SearchFilter.vala"
	_tmp7_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_entry_get_type (), GtkEntry));
#line 712 "../src/SearchFilter.vala"
	_tmp8_ = _tmp7_;
#line 712 "../src/SearchFilter.vala"
	g_signal_parse_name ("deleted-text", gtk_entry_buffer_get_type (), &_tmp9_, NULL, FALSE);
#line 712 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text, self);
#line 713 "../src/SearchFilter.vala"
	_tmp10_ = self->priv->search_entry;
#line 713 "../src/SearchFilter.vala"
	_tmp11_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_entry_get_type (), GtkEntry));
#line 713 "../src/SearchFilter.vala"
	_tmp12_ = _tmp11_;
#line 713 "../src/SearchFilter.vala"
	g_signal_parse_name ("inserted-text", gtk_entry_buffer_get_type (), &_tmp13_, NULL, FALSE);
#line 713 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text, self);
#line 686 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->search_entry);
#line 687 "../src/SearchFilter.vala"
	_text_action_unref0 (self->priv->action);
#line 685 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (search_filter_toolbar_search_box_parent_class)->finalize (obj);
#line 7804 "SearchFilter.c"
}

static GType
search_filter_toolbar_search_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarSearchBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_search_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarSearchBox), 0, (GInstanceInitFunc) search_filter_toolbar_search_box_instance_init, NULL };
	GType search_filter_toolbar_search_box_type_id;
	search_filter_toolbar_search_box_type_id = g_type_register_static (gtk_tool_item_get_type (), "SearchFilterToolbarSearchBox", &g_define_type_info, 0);
	SearchFilterToolbarSearchBox_private_offset = g_type_add_instance_private (search_filter_toolbar_search_box_type_id, sizeof (SearchFilterToolbarSearchBoxPrivate));
	return search_filter_toolbar_search_box_type_id;
}

GType
search_filter_toolbar_search_box_get_type (void)
{
	static volatile gsize search_filter_toolbar_search_box_type_id__volatile = 0;
	if (g_once_init_enter (&search_filter_toolbar_search_box_type_id__volatile)) {
		GType search_filter_toolbar_search_box_type_id;
		search_filter_toolbar_search_box_type_id = search_filter_toolbar_search_box_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_search_box_type_id__volatile, search_filter_toolbar_search_box_type_id);
	}
	return search_filter_toolbar_search_box_type_id__volatile;
}

SearchFilterToolbarRatingFilterButton*
search_filter_toolbar_rating_filter_button_construct (GType object_type,
                                                      GMenuModel* model)
{
	SearchFilterToolbarRatingFilterButton * self = NULL;
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkMenuButton* _tmp4_;
	GtkMenuButton* _tmp5_;
	GtkMenuButton* _tmp6_;
	GtkMenuButton* _tmp7_;
	GtkMenuButton* _tmp8_;
#line 762 "../src/SearchFilter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (model, g_menu_model_get_type ()), NULL);
#line 762 "../src/SearchFilter.vala"
	self = (SearchFilterToolbarRatingFilterButton*) g_object_new (object_type, NULL);
#line 763 "../src/SearchFilter.vala"
	_tmp0_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 763 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp0_);
#line 763 "../src/SearchFilter.vala"
	_g_object_unref0 (self->button);
#line 763 "../src/SearchFilter.vala"
	self->button = _tmp0_;
#line 765 "../src/SearchFilter.vala"
	_tmp1_ = self->button;
#line 765 "../src/SearchFilter.vala"
	_tmp2_ = search_filter_toolbar_rating_filter_button_get_filter_icon (self, RATING_FILTER_UNRATED_OR_HIGHER);
#line 765 "../src/SearchFilter.vala"
	_tmp3_ = _tmp2_;
#line 765 "../src/SearchFilter.vala"
	gtk_button_set_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_button_get_type (), GtkButton), _tmp3_);
#line 765 "../src/SearchFilter.vala"
	_g_object_unref0 (_tmp3_);
#line 766 "../src/SearchFilter.vala"
	_tmp4_ = self->button;
#line 766 "../src/SearchFilter.vala"
	gtk_widget_set_can_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 767 "../src/SearchFilter.vala"
	_tmp5_ = self->button;
#line 767 "../src/SearchFilter.vala"
	gtk_button_set_relief (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_button_get_type (), GtkButton), GTK_RELIEF_NONE);
#line 768 "../src/SearchFilter.vala"
	_tmp6_ = self->button;
#line 768 "../src/SearchFilter.vala"
	gtk_widget_set_margin_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), 2);
#line 769 "../src/SearchFilter.vala"
	_tmp7_ = self->button;
#line 769 "../src/SearchFilter.vala"
	gtk_menu_button_set_menu_model (_tmp7_, model);
#line 771 "../src/SearchFilter.vala"
	gtk_tool_item_set_homogeneous (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tool_item_get_type (), GtkToolItem), FALSE);
#line 773 "../src/SearchFilter.vala"
	_tmp8_ = self->button;
#line 773 "../src/SearchFilter.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 762 "../src/SearchFilter.vala"
	return self;
#line 7889 "SearchFilter.c"
}

SearchFilterToolbarRatingFilterButton*
search_filter_toolbar_rating_filter_button_new (GMenuModel* model)
{
#line 762 "../src/SearchFilter.vala"
	return search_filter_toolbar_rating_filter_button_construct (SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON, model);
#line 7897 "SearchFilter.c"
}

static GtkWidget*
search_filter_toolbar_rating_filter_button_get_filter_icon (SearchFilterToolbarRatingFilterButton* self,
                                                            RatingFilter filter)
{
	GtkWidget* icon = NULL;
	GtkWidget* _tmp13_;
	GtkWidget* result = NULL;
#line 776 "../src/SearchFilter.vala"
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON (self), NULL);
#line 777 "../src/SearchFilter.vala"
	icon = NULL;
#line 779 "../src/SearchFilter.vala"
	switch (filter) {
#line 779 "../src/SearchFilter.vala"
		case RATING_FILTER_REJECTED_OR_HIGHER:
#line 7915 "SearchFilter.c"
		{
			GtkBox* box = NULL;
			GtkBox* _tmp0_;
			GtkImage* image = NULL;
			GtkImage* _tmp1_;
			GtkImage* _tmp2_;
			GtkBox* _tmp3_;
			GtkImage* _tmp4_;
			GtkImage* _tmp5_;
			GtkBox* _tmp6_;
			GtkImage* _tmp7_;
			GtkBox* _tmp8_;
			GtkWidget* _tmp9_;
			GtkWidget* _tmp10_;
#line 781 "../src/SearchFilter.vala"
			_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 781 "../src/SearchFilter.vala"
			g_object_ref_sink (_tmp0_);
#line 781 "../src/SearchFilter.vala"
			box = _tmp0_;
#line 782 "../src/SearchFilter.vala"
			_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("emblem-photos-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 782 "../src/SearchFilter.vala"
			g_object_ref_sink (_tmp1_);
#line 782 "../src/SearchFilter.vala"
			image = _tmp1_;
#line 783 "../src/SearchFilter.vala"
			_tmp2_ = image;
#line 783 "../src/SearchFilter.vala"
			gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), 2);
#line 784 "../src/SearchFilter.vala"
			_tmp3_ = box;
#line 784 "../src/SearchFilter.vala"
			_tmp4_ = image;
#line 784 "../src/SearchFilter.vala"
			gtk_box_pack_start (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 0);
#line 785 "../src/SearchFilter.vala"
			_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 785 "../src/SearchFilter.vala"
			g_object_ref_sink (_tmp5_);
#line 785 "../src/SearchFilter.vala"
			_g_object_unref0 (image);
#line 785 "../src/SearchFilter.vala"
			image = _tmp5_;
#line 786 "../src/SearchFilter.vala"
			_tmp6_ = box;
#line 786 "../src/SearchFilter.vala"
			_tmp7_ = image;
#line 786 "../src/SearchFilter.vala"
			gtk_box_pack_start (_tmp6_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 0);
#line 787 "../src/SearchFilter.vala"
			_tmp8_ = box;
#line 787 "../src/SearchFilter.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 787 "../src/SearchFilter.vala"
			_g_object_unref0 (icon);
#line 787 "../src/SearchFilter.vala"
			icon = _tmp9_;
#line 788 "../src/SearchFilter.vala"
			_tmp10_ = icon;
#line 788 "../src/SearchFilter.vala"
			gtk_widget_show_all (_tmp10_);
#line 789 "../src/SearchFilter.vala"
			_g_object_unref0 (image);
#line 789 "../src/SearchFilter.vala"
			_g_object_unref0 (box);
#line 789 "../src/SearchFilter.vala"
			break;
#line 7984 "SearchFilter.c"
		}
#line 779 "../src/SearchFilter.vala"
		case RATING_FILTER_REJECTED_ONLY:
#line 7988 "SearchFilter.c"
		{
			GtkImage* _tmp11_;
#line 792 "../src/SearchFilter.vala"
			_tmp11_ = (GtkImage*) gtk_image_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 792 "../src/SearchFilter.vala"
			g_object_ref_sink (_tmp11_);
#line 792 "../src/SearchFilter.vala"
			_g_object_unref0 (icon);
#line 792 "../src/SearchFilter.vala"
			icon = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget);
#line 793 "../src/SearchFilter.vala"
			break;
#line 8001 "SearchFilter.c"
		}
		default:
#line 779 "../src/SearchFilter.vala"
		case RATING_FILTER_UNRATED_OR_HIGHER:
#line 8006 "SearchFilter.c"
		{
			GtkImage* _tmp12_;
#line 797 "../src/SearchFilter.vala"
			_tmp12_ = (GtkImage*) gtk_image_new_from_icon_name ("emblem-photos-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 797 "../src/SearchFilter.vala"
			g_object_ref_sink (_tmp12_);
#line 797 "../src/SearchFilter.vala"
			_g_object_unref0 (icon);
#line 797 "../src/SearchFilter.vala"
			icon = G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget);
#line 798 "../src/SearchFilter.vala"
			break;
#line 8019 "SearchFilter.c"
		}
	}
#line 801 "../src/SearchFilter.vala"
	_tmp13_ = icon;
#line 801 "../src/SearchFilter.vala"
	gtk_widget_set_margin_end (_tmp13_, 6);
#line 803 "../src/SearchFilter.vala"
	result = icon;
#line 803 "../src/SearchFilter.vala"
	return result;
#line 8030 "SearchFilter.c"
}

static gint
search_filter_toolbar_rating_filter_button_get_filter_icon_size (SearchFilterToolbarRatingFilterButton* self,
                                                                 RatingFilter filter)
{
	gint icon_base = 0;
	gint icon_star_base = 0;
	gint icon_plus = 0;
	gint result = 0;
#line 806 "../src/SearchFilter.vala"
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON (self), 0);
#line 807 "../src/SearchFilter.vala"
	icon_base = (gint) (SEARCH_FILTER_TOOLBAR_FILTER_ICON_BASE_WIDTH * SEARCH_FILTER_TOOLBAR_FILTER_ICON_SCALE);
#line 808 "../src/SearchFilter.vala"
	icon_star_base = (gint) (SEARCH_FILTER_TOOLBAR_FILTER_ICON_BASE_WIDTH * SEARCH_FILTER_TOOLBAR_FILTER_ICON_STAR_SCALE);
#line 809 "../src/SearchFilter.vala"
	icon_plus = (gint) (SEARCH_FILTER_TOOLBAR_FILTER_ICON_PLUS_WIDTH * SEARCH_FILTER_TOOLBAR_FILTER_ICON_STAR_SCALE);
#line 811 "../src/SearchFilter.vala"
	switch (filter) {
#line 811 "../src/SearchFilter.vala"
		case RATING_FILTER_ONE_OR_HIGHER:
#line 8053 "SearchFilter.c"
		{
#line 813 "../src/SearchFilter.vala"
			result = icon_star_base + icon_plus;
#line 813 "../src/SearchFilter.vala"
			return result;
#line 8059 "SearchFilter.c"
		}
#line 811 "../src/SearchFilter.vala"
		case RATING_FILTER_TWO_OR_HIGHER:
#line 8063 "SearchFilter.c"
		{
#line 815 "../src/SearchFilter.vala"
			result = (icon_star_base * 2) + icon_plus;
#line 815 "../src/SearchFilter.vala"
			return result;
#line 8069 "SearchFilter.c"
		}
#line 811 "../src/SearchFilter.vala"
		case RATING_FILTER_THREE_OR_HIGHER:
#line 8073 "SearchFilter.c"
		{
#line 817 "../src/SearchFilter.vala"
			result = (icon_star_base * 3) + icon_plus;
#line 817 "../src/SearchFilter.vala"
			return result;
#line 8079 "SearchFilter.c"
		}
#line 811 "../src/SearchFilter.vala"
		case RATING_FILTER_FOUR_OR_HIGHER:
#line 8083 "SearchFilter.c"
		{
#line 819 "../src/SearchFilter.vala"
			result = (icon_star_base * 4) + icon_plus;
#line 819 "../src/SearchFilter.vala"
			return result;
#line 8089 "SearchFilter.c"
		}
#line 811 "../src/SearchFilter.vala"
		case RATING_FILTER_FIVE_OR_HIGHER:
#line 811 "../src/SearchFilter.vala"
		case RATING_FILTER_FIVE_ONLY:
#line 8095 "SearchFilter.c"
		{
#line 822 "../src/SearchFilter.vala"
			result = icon_star_base * 5;
#line 822 "../src/SearchFilter.vala"
			return result;
#line 8101 "SearchFilter.c"
		}
#line 811 "../src/SearchFilter.vala"
		case RATING_FILTER_REJECTED_OR_HIGHER:
#line 8105 "SearchFilter.c"
		{
#line 824 "../src/SearchFilter.vala"
			result = RESOURCES_ICON_FILTER_REJECTED_OR_BETTER_FIXED_SIZE;
#line 824 "../src/SearchFilter.vala"
			return result;
#line 8111 "SearchFilter.c"
		}
#line 811 "../src/SearchFilter.vala"
		case RATING_FILTER_UNRATED_OR_HIGHER:
#line 8115 "SearchFilter.c"
		{
#line 826 "../src/SearchFilter.vala"
			result = RESOURCES_ICON_FILTER_UNRATED_OR_BETTER_FIXED_SIZE;
#line 826 "../src/SearchFilter.vala"
			return result;
#line 8121 "SearchFilter.c"
		}
#line 811 "../src/SearchFilter.vala"
		case RATING_FILTER_REJECTED_ONLY:
#line 8125 "SearchFilter.c"
		{
#line 828 "../src/SearchFilter.vala"
			result = icon_plus;
#line 828 "../src/SearchFilter.vala"
			return result;
#line 8131 "SearchFilter.c"
		}
		default:
		{
#line 830 "../src/SearchFilter.vala"
			result = icon_base;
#line 830 "../src/SearchFilter.vala"
			return result;
#line 8139 "SearchFilter.c"
		}
	}
}

void
search_filter_toolbar_rating_filter_button_set_filter_icon (SearchFilterToolbarRatingFilterButton* self,
                                                            RatingFilter filter)
{
	GtkMenuButton* _tmp0_;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 834 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON (self));
#line 835 "../src/SearchFilter.vala"
	_tmp0_ = self->button;
#line 835 "../src/SearchFilter.vala"
	gtk_button_set_always_show_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), TRUE);
#line 836 "../src/SearchFilter.vala"
	switch (filter) {
#line 836 "../src/SearchFilter.vala"
		case RATING_FILTER_ONE_OR_HIGHER:
#line 8161 "SearchFilter.c"
		{
			GtkMenuButton* _tmp1_;
#line 838 "../src/SearchFilter.vala"
			_tmp1_ = self->button;
#line 838 "../src/SearchFilter.vala"
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_button_get_type (), GtkButton), _ ("★+ Rating"));
#line 839 "../src/SearchFilter.vala"
			break;
#line 8170 "SearchFilter.c"
		}
#line 836 "../src/SearchFilter.vala"
		case RATING_FILTER_TWO_OR_HIGHER:
#line 8174 "SearchFilter.c"
		{
			GtkMenuButton* _tmp2_;
#line 841 "../src/SearchFilter.vala"
			_tmp2_ = self->button;
#line 841 "../src/SearchFilter.vala"
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_button_get_type (), GtkButton), _ ("★★+ Rating"));
#line 842 "../src/SearchFilter.vala"
			break;
#line 8183 "SearchFilter.c"
		}
#line 836 "../src/SearchFilter.vala"
		case RATING_FILTER_THREE_OR_HIGHER:
#line 8187 "SearchFilter.c"
		{
			GtkMenuButton* _tmp3_;
#line 844 "../src/SearchFilter.vala"
			_tmp3_ = self->button;
#line 844 "../src/SearchFilter.vala"
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_button_get_type (), GtkButton), _ ("★★★+ Rating"));
#line 845 "../src/SearchFilter.vala"
			break;
#line 8196 "SearchFilter.c"
		}
#line 836 "../src/SearchFilter.vala"
		case RATING_FILTER_FOUR_OR_HIGHER:
#line 8200 "SearchFilter.c"
		{
			GtkMenuButton* _tmp4_;
#line 847 "../src/SearchFilter.vala"
			_tmp4_ = self->button;
#line 847 "../src/SearchFilter.vala"
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_button_get_type (), GtkButton), _ ("★★★★+ Rating"));
#line 848 "../src/SearchFilter.vala"
			break;
#line 8209 "SearchFilter.c"
		}
#line 836 "../src/SearchFilter.vala"
		case RATING_FILTER_FIVE_ONLY:
#line 836 "../src/SearchFilter.vala"
		case RATING_FILTER_FIVE_OR_HIGHER:
#line 8215 "SearchFilter.c"
		{
			GtkMenuButton* _tmp5_;
#line 851 "../src/SearchFilter.vala"
			_tmp5_ = self->button;
#line 851 "../src/SearchFilter.vala"
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_button_get_type (), GtkButton), _ ("★★★★★+ Rating"));
#line 852 "../src/SearchFilter.vala"
			break;
#line 8224 "SearchFilter.c"
		}
		default:
		{
			GtkMenuButton* _tmp6_;
			GtkMenuButton* _tmp7_;
			GtkWidget* _tmp8_;
			GtkWidget* _tmp9_;
#line 854 "../src/SearchFilter.vala"
			_tmp6_ = self->button;
#line 854 "../src/SearchFilter.vala"
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_button_get_type (), GtkButton), _ ("Rating"));
#line 855 "../src/SearchFilter.vala"
			_tmp7_ = self->button;
#line 855 "../src/SearchFilter.vala"
			_tmp8_ = search_filter_toolbar_rating_filter_button_get_filter_icon (self, filter);
#line 855 "../src/SearchFilter.vala"
			_tmp9_ = _tmp8_;
#line 855 "../src/SearchFilter.vala"
			gtk_button_set_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_button_get_type (), GtkButton), _tmp9_);
#line 855 "../src/SearchFilter.vala"
			_g_object_unref0 (_tmp9_);
#line 856 "../src/SearchFilter.vala"
			break;
#line 8248 "SearchFilter.c"
		}
	}
#line 859 "../src/SearchFilter.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), search_filter_toolbar_rating_filter_button_get_filter_button_size (self, filter), -1);
#line 860 "../src/SearchFilter.vala"
	_tmp10_ = resources_get_rating_filter_tooltip (filter);
#line 860 "../src/SearchFilter.vala"
	_tmp11_ = _tmp10_;
#line 860 "../src/SearchFilter.vala"
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tool_item_get_type (), GtkToolItem), _tmp11_);
#line 860 "../src/SearchFilter.vala"
	_g_free0 (_tmp11_);
#line 861 "../src/SearchFilter.vala"
	gtk_widget_set_has_tooltip (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), TRUE);
#line 862 "../src/SearchFilter.vala"
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 8265 "SearchFilter.c"
}

static gint
search_filter_toolbar_rating_filter_button_get_filter_button_size (SearchFilterToolbarRatingFilterButton* self,
                                                                   RatingFilter filter)
{
	gint result = 0;
#line 865 "../src/SearchFilter.vala"
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON (self), 0);
#line 866 "../src/SearchFilter.vala"
	result = search_filter_toolbar_rating_filter_button_get_filter_icon_size (self, filter) + (2 * SEARCH_FILTER_TOOLBAR_FILTER_BUTTON_MARGIN);
#line 866 "../src/SearchFilter.vala"
	return result;
#line 8279 "SearchFilter.c"
}

void
search_filter_toolbar_rating_filter_button_set_label (SearchFilterToolbarRatingFilterButton* self,
                                                      const gchar* label)
{
	GtkMenuButton* _tmp0_;
#line 869 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON (self));
#line 869 "../src/SearchFilter.vala"
	g_return_if_fail (label != NULL);
#line 870 "../src/SearchFilter.vala"
	_tmp0_ = self->button;
#line 870 "../src/SearchFilter.vala"
	gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), label);
#line 8295 "SearchFilter.c"
}

static void
search_filter_toolbar_rating_filter_button_class_init (SearchFilterToolbarRatingFilterButtonClass * klass,
                                                       gpointer klass_data)
{
#line 759 "../src/SearchFilter.vala"
	search_filter_toolbar_rating_filter_button_parent_class = g_type_class_peek_parent (klass);
#line 759 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_rating_filter_button_finalize;
#line 8306 "SearchFilter.c"
}

static void
search_filter_toolbar_rating_filter_button_instance_init (SearchFilterToolbarRatingFilterButton * self,
                                                          gpointer klass)
{
}

static void
search_filter_toolbar_rating_filter_button_finalize (GObject * obj)
{
	SearchFilterToolbarRatingFilterButton * self;
#line 759 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON, SearchFilterToolbarRatingFilterButton);
#line 760 "../src/SearchFilter.vala"
	_g_object_unref0 (self->button);
#line 759 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (search_filter_toolbar_rating_filter_button_parent_class)->finalize (obj);
#line 8325 "SearchFilter.c"
}

static GType
search_filter_toolbar_rating_filter_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarRatingFilterButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_rating_filter_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarRatingFilterButton), 0, (GInstanceInitFunc) search_filter_toolbar_rating_filter_button_instance_init, NULL };
	GType search_filter_toolbar_rating_filter_button_type_id;
	search_filter_toolbar_rating_filter_button_type_id = g_type_register_static (gtk_tool_item_get_type (), "SearchFilterToolbarRatingFilterButton", &g_define_type_info, 0);
	return search_filter_toolbar_rating_filter_button_type_id;
}

GType
search_filter_toolbar_rating_filter_button_get_type (void)
{
	static volatile gsize search_filter_toolbar_rating_filter_button_type_id__volatile = 0;
	if (g_once_init_enter (&search_filter_toolbar_rating_filter_button_type_id__volatile)) {
		GType search_filter_toolbar_rating_filter_button_type_id;
		search_filter_toolbar_rating_filter_button_type_id = search_filter_toolbar_rating_filter_button_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_rating_filter_button_type_id__volatile, search_filter_toolbar_rating_filter_button_type_id);
	}
	return search_filter_toolbar_rating_filter_button_type_id__volatile;
}

static void
_search_filter_toolbar_saved_search_filter_button_on_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                 gpointer self)
{
#line 900 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_filter_button_on_clicked ((SearchFilterToolbarSavedSearchFilterButton*) self);
#line 8355 "SearchFilter.c"
}

SearchFilterToolbarSavedSearchFilterButton*
search_filter_toolbar_saved_search_filter_button_construct (GType object_type)
{
	SearchFilterToolbarSavedSearchFilterButton * self = NULL;
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
	GtkImage* image = NULL;
	GtkImage* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkToggleButton* _tmp4_;
	GtkToggleButton* _tmp5_;
	GtkToggleButton* _tmp6_;
#line 881 "../src/SearchFilter.vala"
	self = (SearchFilterToolbarSavedSearchFilterButton*) g_object_new (object_type, NULL);
#line 882 "../src/SearchFilter.vala"
	_tmp0_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 882 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp0_);
#line 882 "../src/SearchFilter.vala"
	_g_object_unref0 (self->button);
#line 882 "../src/SearchFilter.vala"
	self->button = _tmp0_;
#line 883 "../src/SearchFilter.vala"
	_tmp1_ = self->button;
#line 883 "../src/SearchFilter.vala"
	gtk_button_set_always_show_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_button_get_type (), GtkButton), TRUE);
#line 885 "../src/SearchFilter.vala"
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-find-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 885 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp2_);
#line 885 "../src/SearchFilter.vala"
	image = _tmp2_;
#line 886 "../src/SearchFilter.vala"
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (image, gtk_widget_get_type (), GtkWidget), 6);
#line 887 "../src/SearchFilter.vala"
	_tmp3_ = self->button;
#line 887 "../src/SearchFilter.vala"
	gtk_button_set_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_button_get_type (), GtkButton), G_TYPE_CHECK_INSTANCE_CAST (image, gtk_widget_get_type (), GtkWidget));
#line 888 "../src/SearchFilter.vala"
	_tmp4_ = self->button;
#line 888 "../src/SearchFilter.vala"
	gtk_widget_set_can_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 890 "../src/SearchFilter.vala"
	_tmp5_ = self->button;
#line 890 "../src/SearchFilter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_button_get_type (), GtkButton), "clicked", (GCallback) _search_filter_toolbar_saved_search_filter_button_on_clicked_gtk_button_clicked, self, 0);
#line 892 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_filter_button_restyle (self);
#line 894 "../src/SearchFilter.vala"
	gtk_tool_item_set_homogeneous (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tool_item_get_type (), GtkToolItem), FALSE);
#line 896 "../src/SearchFilter.vala"
	_tmp6_ = self->button;
#line 896 "../src/SearchFilter.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget));
#line 881 "../src/SearchFilter.vala"
	_g_object_unref0 (image);
#line 881 "../src/SearchFilter.vala"
	return self;
#line 8416 "SearchFilter.c"
}

SearchFilterToolbarSavedSearchFilterButton*
search_filter_toolbar_saved_search_filter_button_new (void)
{
#line 881 "../src/SearchFilter.vala"
	return search_filter_toolbar_saved_search_filter_button_construct (SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON);
#line 8424 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_filter_button_on_clicked (SearchFilterToolbarSavedSearchFilterButton* self)
{
#line 903 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON (self));
#line 904 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_toolbar_saved_search_filter_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_CLICKED_SIGNAL], 0);
#line 8434 "SearchFilter.c"
}

void
search_filter_toolbar_saved_search_filter_button_set_active (SearchFilterToolbarSavedSearchFilterButton* self,
                                                             gboolean active)
{
	GtkToggleButton* _tmp0_;
#line 907 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON (self));
#line 908 "../src/SearchFilter.vala"
	_tmp0_ = self->button;
#line 908 "../src/SearchFilter.vala"
	gtk_toggle_button_set_active (_tmp0_, active);
#line 8448 "SearchFilter.c"
}

void
search_filter_toolbar_saved_search_filter_button_set_label (SearchFilterToolbarSavedSearchFilterButton* self,
                                                            const gchar* label)
{
	GtkToggleButton* _tmp0_;
#line 911 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON (self));
#line 911 "../src/SearchFilter.vala"
	g_return_if_fail (label != NULL);
#line 912 "../src/SearchFilter.vala"
	_tmp0_ = self->button;
#line 912 "../src/SearchFilter.vala"
	gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), label);
#line 8464 "SearchFilter.c"
}

void
search_filter_toolbar_saved_search_filter_button_restyle (SearchFilterToolbarSavedSearchFilterButton* self)
{
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
#line 915 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON (self));
#line 916 "../src/SearchFilter.vala"
	_tmp0_ = self->button;
#line 916 "../src/SearchFilter.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), 24, 24);
#line 917 "../src/SearchFilter.vala"
	_tmp1_ = self->button;
#line 917 "../src/SearchFilter.vala"
	gtk_button_set_relief (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_button_get_type (), GtkButton), GTK_RELIEF_NONE);
#line 8482 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_filter_button_class_init (SearchFilterToolbarSavedSearchFilterButtonClass * klass,
                                                             gpointer klass_data)
{
#line 875 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_filter_button_parent_class = g_type_class_peek_parent (klass);
#line 875 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_saved_search_filter_button_finalize;
#line 875 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_filter_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_CLICKED_SIGNAL] = g_signal_new ("clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 8495 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_filter_button_instance_init (SearchFilterToolbarSavedSearchFilterButton * self,
                                                                gpointer klass)
{
#line 876 "../src/SearchFilter.vala"
	self->filter_popup = NULL;
#line 8504 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_filter_button_finalize (GObject * obj)
{
	SearchFilterToolbarSavedSearchFilterButton * self;
	GtkToggleButton* _tmp0_;
	guint _tmp1_;
#line 875 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON, SearchFilterToolbarSavedSearchFilterButton);
#line 900 "../src/SearchFilter.vala"
	_tmp0_ = self->button;
#line 900 "../src/SearchFilter.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp1_, NULL, FALSE);
#line 900 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_filter_button_on_clicked_gtk_button_clicked, self);
#line 876 "../src/SearchFilter.vala"
	_search_filter_toolbar_saved_search_popover_unref0 (self->filter_popup);
#line 877 "../src/SearchFilter.vala"
	_g_object_unref0 (self->button);
#line 875 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (search_filter_toolbar_saved_search_filter_button_parent_class)->finalize (obj);
#line 8527 "SearchFilter.c"
}

static GType
search_filter_toolbar_saved_search_filter_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarSavedSearchFilterButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_saved_search_filter_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarSavedSearchFilterButton), 0, (GInstanceInitFunc) search_filter_toolbar_saved_search_filter_button_instance_init, NULL };
	GType search_filter_toolbar_saved_search_filter_button_type_id;
	search_filter_toolbar_saved_search_filter_button_type_id = g_type_register_static (gtk_tool_item_get_type (), "SearchFilterToolbarSavedSearchFilterButton", &g_define_type_info, 0);
	return search_filter_toolbar_saved_search_filter_button_type_id;
}

GType
search_filter_toolbar_saved_search_filter_button_get_type (void)
{
	static volatile gsize search_filter_toolbar_saved_search_filter_button_type_id__volatile = 0;
	if (g_once_init_enter (&search_filter_toolbar_saved_search_filter_button_type_id__volatile)) {
		GType search_filter_toolbar_saved_search_filter_button_type_id;
		search_filter_toolbar_saved_search_filter_button_type_id = search_filter_toolbar_saved_search_filter_button_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_saved_search_filter_button_type_id__volatile, search_filter_toolbar_saved_search_filter_button_type_id);
	}
	return search_filter_toolbar_saved_search_filter_button_type_id__volatile;
}

static inline gpointer
search_filter_toolbar_saved_search_popover_get_instance_private (SearchFilterToolbarSavedSearchPopover* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbarSavedSearchPopover_private_offset);
}

static void
_search_filter_toolbar_saved_search_popover_on_edit_click_search_filter_toolbar_saved_search_popover_data_button_clicked (SearchFilterToolbarSavedSearchPopoverDataButton* _sender,
                                                                                                                          SavedSearch* search,
                                                                                                                          gpointer self)
{
#line 1002 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_on_edit_click ((SearchFilterToolbarSavedSearchPopover*) self, search);
#line 8564 "SearchFilter.c"
}

static void
_search_filter_toolbar_saved_search_popover_on_delete_click_search_filter_toolbar_saved_search_popover_data_button_clicked (SearchFilterToolbarSavedSearchPopoverDataButton* _sender,
                                                                                                                            SavedSearch* search,
                                                                                                                            gpointer self)
{
#line 1003 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_on_delete_click ((SearchFilterToolbarSavedSearchPopover*) self, search);
#line 8574 "SearchFilter.c"
}

static void
_search_filter_toolbar_saved_search_popover_on_add_click_gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self)
{
#line 1004 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_on_add_click ((SearchFilterToolbarSavedSearchPopover*) self);
#line 8583 "SearchFilter.c"
}

static void
_search_filter_toolbar_saved_search_popover_on_activate_row_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                                        GtkListBoxRow* row,
                                                                                        gpointer self)
{
#line 1005 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_on_activate_row ((SearchFilterToolbarSavedSearchPopover*) self, row);
#line 8593 "SearchFilter.c"
}

static void
_search_filter_toolbar_saved_search_popover_on_popover_closed_gtk_popover_closed (GtkPopover* _sender,
                                                                                  gpointer self)
{
#line 1006 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_on_popover_closed ((SearchFilterToolbarSavedSearchPopover*) self);
#line 8602 "SearchFilter.c"
}

static void
_vala_array_add130 (SearchFilterToolbarSavedSearchPopoverDataButton** * array,
                    gint* length,
                    gint* size,
                    SearchFilterToolbarSavedSearchPopoverDataButton* value)
{
#line 982 "../src/SearchFilter.vala"
	if ((*length) == (*size)) {
#line 982 "../src/SearchFilter.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 982 "../src/SearchFilter.vala"
		*array = g_renew (SearchFilterToolbarSavedSearchPopoverDataButton*, *array, (*size) + 1);
#line 8617 "SearchFilter.c"
	}
#line 982 "../src/SearchFilter.vala"
	(*array)[(*length)++] = value;
#line 982 "../src/SearchFilter.vala"
	(*array)[*length] = NULL;
#line 8623 "SearchFilter.c"
}

static void
_vala_array_add131 (SearchFilterToolbarSavedSearchPopoverDataButton** * array,
                    gint* length,
                    gint* size,
                    SearchFilterToolbarSavedSearchPopoverDataButton* value)
{
#line 987 "../src/SearchFilter.vala"
	if ((*length) == (*size)) {
#line 987 "../src/SearchFilter.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 987 "../src/SearchFilter.vala"
		*array = g_renew (SearchFilterToolbarSavedSearchPopoverDataButton*, *array, (*size) + 1);
#line 8638 "SearchFilter.c"
	}
#line 987 "../src/SearchFilter.vala"
	(*array)[(*length)++] = value;
#line 987 "../src/SearchFilter.vala"
	(*array)[*length] = NULL;
#line 8644 "SearchFilter.c"
}

SearchFilterToolbarSavedSearchPopover*
search_filter_toolbar_saved_search_popover_construct (GType object_type,
                                                      GtkWidget* relative_to)
{
	SearchFilterToolbarSavedSearchPopover* self = NULL;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	GtkListBox* _tmp2_;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp3_;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp4_;
	GtkButton* _tmp40_;
	GtkButton* _tmp41_;
	GtkListBox* _tmp42_;
	GtkButton* _tmp43_;
	GtkListBox* _tmp44_;
	GtkListBox* _tmp45_;
	GtkPopover* _tmp46_;
	GtkListBox* _tmp47_;
#line 965 "../src/SearchFilter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (relative_to, gtk_widget_get_type ()), NULL);
#line 965 "../src/SearchFilter.vala"
	self = (SearchFilterToolbarSavedSearchPopover*) g_type_create_instance (object_type);
#line 966 "../src/SearchFilter.vala"
	_tmp0_ = (GtkPopover*) gtk_popover_new (relative_to);
#line 966 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp0_);
#line 966 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->popover);
#line 966 "../src/SearchFilter.vala"
	self->priv->popover = _tmp0_;
#line 967 "../src/SearchFilter.vala"
	_tmp1_ = self->priv->popover;
#line 967 "../src/SearchFilter.vala"
	g_signal_connect (_tmp1_, "closed", (GCallback) _search_filter_toolbar_saved_search_popover_on_popover_closed_gtk_popover_closed, self);
#line 968 "../src/SearchFilter.vala"
	_tmp2_ = (GtkListBox*) gtk_list_box_new ();
#line 968 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp2_);
#line 968 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->list_box);
#line 968 "../src/SearchFilter.vala"
	self->priv->list_box = _tmp2_;
#line 969 "../src/SearchFilter.vala"
	_tmp3_ = g_new0 (SearchFilterToolbarSavedSearchPopoverDataButton*, 0 + 1);
#line 969 "../src/SearchFilter.vala"
	self->priv->edit_buttons = (_vala_array_free (self->priv->edit_buttons, self->priv->edit_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
#line 969 "../src/SearchFilter.vala"
	self->priv->edit_buttons = _tmp3_;
#line 969 "../src/SearchFilter.vala"
	self->priv->edit_buttons_length1 = 0;
#line 969 "../src/SearchFilter.vala"
	self->priv->_edit_buttons_size_ = self->priv->edit_buttons_length1;
#line 970 "../src/SearchFilter.vala"
	_tmp4_ = g_new0 (SearchFilterToolbarSavedSearchPopoverDataButton*, 0 + 1);
#line 970 "../src/SearchFilter.vala"
	self->priv->delete_buttons = (_vala_array_free (self->priv->delete_buttons, self->priv->delete_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
#line 970 "../src/SearchFilter.vala"
	self->priv->delete_buttons = _tmp4_;
#line 970 "../src/SearchFilter.vala"
	self->priv->delete_buttons_length1 = 0;
#line 970 "../src/SearchFilter.vala"
	self->priv->_delete_buttons_size_ = self->priv->delete_buttons_length1;
#line 8709 "SearchFilter.c"
	{
		GeeIterator* _search_it = NULL;
		SavedSearchTable* _tmp5_;
		SavedSearchTable* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
		GeeIterator* _tmp9_;
		GeeIterator* _tmp10_;
#line 972 "../src/SearchFilter.vala"
		_tmp5_ = saved_search_table_get_instance ();
#line 972 "../src/SearchFilter.vala"
		_tmp6_ = _tmp5_;
#line 972 "../src/SearchFilter.vala"
		_tmp7_ = saved_search_table_get_all (_tmp6_);
#line 972 "../src/SearchFilter.vala"
		_tmp8_ = _tmp7_;
#line 972 "../src/SearchFilter.vala"
		_tmp9_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ITERABLE, GeeIterable));
#line 972 "../src/SearchFilter.vala"
		_tmp10_ = _tmp9_;
#line 972 "../src/SearchFilter.vala"
		_g_object_unref0 (_tmp8_);
#line 972 "../src/SearchFilter.vala"
		_saved_search_table_unref0 (_tmp6_);
#line 972 "../src/SearchFilter.vala"
		_search_it = _tmp10_;
#line 972 "../src/SearchFilter.vala"
		while (TRUE) {
#line 8738 "SearchFilter.c"
			GeeIterator* _tmp11_;
			SavedSearch* search = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			GtkBox* row = NULL;
			GtkBox* _tmp14_;
			GtkBox* _tmp15_;
			GtkLabel* label = NULL;
			SavedSearch* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GtkLabel* _tmp19_;
			GtkLabel* _tmp20_;
			GtkLabel* _tmp21_;
			GtkBox* _tmp22_;
			GtkLabel* _tmp23_;
			SearchFilterToolbarSavedSearchPopoverDataButton* delete_button = NULL;
			SavedSearch* _tmp24_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp25_;
			GtkBox* _tmp26_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp27_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp28_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp29_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp30_;
			SearchFilterToolbarSavedSearchPopoverDataButton* edit_button = NULL;
			SavedSearch* _tmp31_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp32_;
			GtkBox* _tmp33_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp34_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp35_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp36_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp37_;
			GtkListBox* _tmp38_;
			GtkBox* _tmp39_;
#line 972 "../src/SearchFilter.vala"
			_tmp11_ = _search_it;
#line 972 "../src/SearchFilter.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 972 "../src/SearchFilter.vala"
				break;
#line 8779 "SearchFilter.c"
			}
#line 972 "../src/SearchFilter.vala"
			_tmp12_ = _search_it;
#line 972 "../src/SearchFilter.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 972 "../src/SearchFilter.vala"
			search = (SavedSearch*) _tmp13_;
#line 973 "../src/SearchFilter.vala"
			_tmp14_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 1);
#line 973 "../src/SearchFilter.vala"
			g_object_ref_sink (_tmp14_);
#line 973 "../src/SearchFilter.vala"
			row = _tmp14_;
#line 974 "../src/SearchFilter.vala"
			_tmp15_ = row;
#line 974 "../src/SearchFilter.vala"
			gtk_box_set_homogeneous (_tmp15_, FALSE);
#line 975 "../src/SearchFilter.vala"
			_tmp16_ = search;
#line 975 "../src/SearchFilter.vala"
			_tmp17_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_DATA_OBJECT, DataObject));
#line 975 "../src/SearchFilter.vala"
			_tmp18_ = _tmp17_;
#line 975 "../src/SearchFilter.vala"
			_tmp19_ = (GtkLabel*) gtk_label_new (_tmp18_);
#line 975 "../src/SearchFilter.vala"
			g_object_ref_sink (_tmp19_);
#line 975 "../src/SearchFilter.vala"
			_tmp20_ = _tmp19_;
#line 975 "../src/SearchFilter.vala"
			_g_free0 (_tmp18_);
#line 975 "../src/SearchFilter.vala"
			label = _tmp20_;
#line 976 "../src/SearchFilter.vala"
			_tmp21_ = label;
#line 976 "../src/SearchFilter.vala"
			gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
#line 977 "../src/SearchFilter.vala"
			_tmp22_ = row;
#line 977 "../src/SearchFilter.vala"
			_tmp23_ = label;
#line 977 "../src/SearchFilter.vala"
			gtk_box_pack_start (_tmp22_, G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 3);
#line 979 "../src/SearchFilter.vala"
			_tmp24_ = search;
#line 979 "../src/SearchFilter.vala"
			_tmp25_ = search_filter_toolbar_saved_search_popover_data_button_new (_tmp24_, "edit-delete-symbolic");
#line 979 "../src/SearchFilter.vala"
			g_object_ref_sink (_tmp25_);
#line 979 "../src/SearchFilter.vala"
			delete_button = _tmp25_;
#line 980 "../src/SearchFilter.vala"
			_tmp26_ = row;
#line 980 "../src/SearchFilter.vala"
			_tmp27_ = delete_button;
#line 980 "../src/SearchFilter.vala"
			gtk_box_pack_end (_tmp26_, G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_widget_get_type (), GtkWidget), FALSE, FALSE, (guint) 0);
#line 981 "../src/SearchFilter.vala"
			_tmp28_ = delete_button;
#line 981 "../src/SearchFilter.vala"
			g_signal_connect (_tmp28_, "clicked", (GCallback) _search_filter_toolbar_saved_search_popover_on_delete_click_search_filter_toolbar_saved_search_popover_data_button_clicked, self);
#line 982 "../src/SearchFilter.vala"
			_tmp29_ = delete_button;
#line 982 "../src/SearchFilter.vala"
			_tmp30_ = _g_object_ref0 (_tmp29_);
#line 982 "../src/SearchFilter.vala"
			_vala_array_add130 (&self->priv->delete_buttons, &self->priv->delete_buttons_length1, &self->priv->_delete_buttons_size_, _tmp30_);
#line 984 "../src/SearchFilter.vala"
			_tmp31_ = search;
#line 984 "../src/SearchFilter.vala"
			_tmp32_ = search_filter_toolbar_saved_search_popover_data_button_new (_tmp31_, "text-editor-symbolic");
#line 984 "../src/SearchFilter.vala"
			g_object_ref_sink (_tmp32_);
#line 984 "../src/SearchFilter.vala"
			edit_button = _tmp32_;
#line 985 "../src/SearchFilter.vala"
			_tmp33_ = row;
#line 985 "../src/SearchFilter.vala"
			_tmp34_ = edit_button;
#line 985 "../src/SearchFilter.vala"
			gtk_box_pack_end (_tmp33_, G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_widget_get_type (), GtkWidget), FALSE, FALSE, (guint) 0);
#line 986 "../src/SearchFilter.vala"
			_tmp35_ = edit_button;
#line 986 "../src/SearchFilter.vala"
			g_signal_connect (_tmp35_, "clicked", (GCallback) _search_filter_toolbar_saved_search_popover_on_edit_click_search_filter_toolbar_saved_search_popover_data_button_clicked, self);
#line 987 "../src/SearchFilter.vala"
			_tmp36_ = edit_button;
#line 987 "../src/SearchFilter.vala"
			_tmp37_ = _g_object_ref0 (_tmp36_);
#line 987 "../src/SearchFilter.vala"
			_vala_array_add131 (&self->priv->edit_buttons, &self->priv->edit_buttons_length1, &self->priv->_edit_buttons_size_, _tmp37_);
#line 989 "../src/SearchFilter.vala"
			_tmp38_ = self->priv->list_box;
#line 989 "../src/SearchFilter.vala"
			_tmp39_ = row;
#line 989 "../src/SearchFilter.vala"
			gtk_list_box_insert (_tmp38_, G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_widget_get_type (), GtkWidget), -1);
#line 972 "../src/SearchFilter.vala"
			_g_object_unref0 (edit_button);
#line 972 "../src/SearchFilter.vala"
			_g_object_unref0 (delete_button);
#line 972 "../src/SearchFilter.vala"
			_g_object_unref0 (label);
#line 972 "../src/SearchFilter.vala"
			_g_object_unref0 (row);
#line 972 "../src/SearchFilter.vala"
			_g_object_unref0 (search);
#line 8887 "SearchFilter.c"
		}
#line 972 "../src/SearchFilter.vala"
		_g_object_unref0 (_search_it);
#line 8891 "SearchFilter.c"
	}
#line 991 "../src/SearchFilter.vala"
	_tmp40_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 991 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp40_);
#line 991 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->add);
#line 991 "../src/SearchFilter.vala"
	self->priv->add = _tmp40_;
#line 992 "../src/SearchFilter.vala"
	_tmp41_ = self->priv->add;
#line 992 "../src/SearchFilter.vala"
	g_signal_connect (_tmp41_, "clicked", (GCallback) _search_filter_toolbar_saved_search_popover_on_add_click_gtk_button_clicked, self);
#line 993 "../src/SearchFilter.vala"
	_tmp42_ = self->priv->list_box;
#line 993 "../src/SearchFilter.vala"
	_tmp43_ = self->priv->add;
#line 993 "../src/SearchFilter.vala"
	gtk_list_box_insert (_tmp42_, G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_widget_get_type (), GtkWidget), -1);
#line 994 "../src/SearchFilter.vala"
	_tmp44_ = self->priv->list_box;
#line 994 "../src/SearchFilter.vala"
	g_signal_connect (_tmp44_, "row-activated", (GCallback) _search_filter_toolbar_saved_search_popover_on_activate_row_gtk_list_box_row_activated, self);
#line 995 "../src/SearchFilter.vala"
	_tmp45_ = self->priv->list_box;
#line 995 "../src/SearchFilter.vala"
	gtk_list_box_set_selection_mode (_tmp45_, GTK_SELECTION_NONE);
#line 996 "../src/SearchFilter.vala"
	_tmp46_ = self->priv->popover;
#line 996 "../src/SearchFilter.vala"
	_tmp47_ = self->priv->list_box;
#line 996 "../src/SearchFilter.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, gtk_widget_get_type (), GtkWidget));
#line 998 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_restyle (self);
#line 965 "../src/SearchFilter.vala"
	return self;
#line 8929 "SearchFilter.c"
}

SearchFilterToolbarSavedSearchPopover*
search_filter_toolbar_saved_search_popover_new (GtkWidget* relative_to)
{
#line 965 "../src/SearchFilter.vala"
	return search_filter_toolbar_saved_search_popover_construct (SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, relative_to);
#line 8937 "SearchFilter.c"
}

void
search_filter_toolbar_saved_search_popover_restyle (SearchFilterToolbarSavedSearchPopover* self)
{
	GtkButton* _tmp0_;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp1_;
	gint _tmp1__length1;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp4_;
	gint _tmp4__length1;
#line 1009 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
#line 1010 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->add;
#line 1010 "../src/SearchFilter.vala"
	gtk_button_set_relief (_tmp0_, GTK_RELIEF_NONE);
#line 1011 "../src/SearchFilter.vala"
	_tmp1_ = self->priv->edit_buttons;
#line 1011 "../src/SearchFilter.vala"
	_tmp1__length1 = self->priv->edit_buttons_length1;
#line 8958 "SearchFilter.c"
	{
		SearchFilterToolbarSavedSearchPopoverDataButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
#line 1011 "../src/SearchFilter.vala"
		button_collection = _tmp1_;
#line 1011 "../src/SearchFilter.vala"
		button_collection_length1 = _tmp1__length1;
#line 1011 "../src/SearchFilter.vala"
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
#line 8970 "SearchFilter.c"
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp2_;
			SearchFilterToolbarSavedSearchPopoverDataButton* button = NULL;
#line 1011 "../src/SearchFilter.vala"
			_tmp2_ = _g_object_ref0 (button_collection[button_it]);
#line 1011 "../src/SearchFilter.vala"
			button = _tmp2_;
#line 8977 "SearchFilter.c"
			{
				SearchFilterToolbarSavedSearchPopoverDataButton* _tmp3_;
#line 1011 "../src/SearchFilter.vala"
				_tmp3_ = button;
#line 1011 "../src/SearchFilter.vala"
				search_filter_toolbar_saved_search_popover_data_button_restyle (_tmp3_);
#line 1011 "../src/SearchFilter.vala"
				_g_object_unref0 (button);
#line 8986 "SearchFilter.c"
			}
		}
	}
#line 1012 "../src/SearchFilter.vala"
	_tmp4_ = self->priv->delete_buttons;
#line 1012 "../src/SearchFilter.vala"
	_tmp4__length1 = self->priv->delete_buttons_length1;
#line 8994 "SearchFilter.c"
	{
		SearchFilterToolbarSavedSearchPopoverDataButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
#line 1012 "../src/SearchFilter.vala"
		button_collection = _tmp4_;
#line 1012 "../src/SearchFilter.vala"
		button_collection_length1 = _tmp4__length1;
#line 1012 "../src/SearchFilter.vala"
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
#line 9006 "SearchFilter.c"
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp5_;
			SearchFilterToolbarSavedSearchPopoverDataButton* button = NULL;
#line 1012 "../src/SearchFilter.vala"
			_tmp5_ = _g_object_ref0 (button_collection[button_it]);
#line 1012 "../src/SearchFilter.vala"
			button = _tmp5_;
#line 9013 "SearchFilter.c"
			{
				SearchFilterToolbarSavedSearchPopoverDataButton* _tmp6_;
#line 1012 "../src/SearchFilter.vala"
				_tmp6_ = button;
#line 1012 "../src/SearchFilter.vala"
				search_filter_toolbar_saved_search_popover_data_button_restyle (_tmp6_);
#line 1012 "../src/SearchFilter.vala"
				_g_object_unref0 (button);
#line 9022 "SearchFilter.c"
			}
		}
	}
}

static gboolean
search_filter_toolbar_saved_search_popover_is_search_row (SearchFilterToolbarSavedSearchPopover* self,
                                                          GtkListBoxRow* row)
{
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	gboolean _tmp4_;
	gboolean result = FALSE;
#line 1015 "../src/SearchFilter.vala"
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self), FALSE);
#line 1015 "../src/SearchFilter.vala"
	g_return_val_if_fail ((row == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (row, gtk_list_box_row_get_type ()), FALSE);
#line 1016 "../src/SearchFilter.vala"
	if (row == NULL) {
#line 1016 "../src/SearchFilter.vala"
		result = FALSE;
#line 1016 "../src/SearchFilter.vala"
		return result;
#line 9048 "SearchFilter.c"
	}
#line 1017 "../src/SearchFilter.vala"
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (row, gtk_container_get_type (), GtkContainer));
#line 1017 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_;
#line 1017 "../src/SearchFilter.vala"
	_tmp2_ = g_list_last (_tmp1_);
#line 1017 "../src/SearchFilter.vala"
	_tmp3_ = _tmp2_->data;
#line 1017 "../src/SearchFilter.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE ((GtkWidget*) _tmp3_, gtk_button_get_type ());
#line 1017 "../src/SearchFilter.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 1017 "../src/SearchFilter.vala"
	if (_tmp4_) {
#line 1017 "../src/SearchFilter.vala"
		result = FALSE;
#line 1017 "../src/SearchFilter.vala"
		return result;
#line 9068 "SearchFilter.c"
	}
#line 1018 "../src/SearchFilter.vala"
	result = TRUE;
#line 1018 "../src/SearchFilter.vala"
	return result;
#line 9074 "SearchFilter.c"
}

static SavedSearch*
search_filter_toolbar_saved_search_popover_get_search (SearchFilterToolbarSavedSearchPopover* self,
                                                       GtkListBoxRow* row)
{
	GtkBox* box = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	SearchFilterToolbarSavedSearchPopoverDataButton* button = NULL;
	GList* _tmp6_;
	GList* _tmp7_;
	GList* _tmp8_;
	gconstpointer _tmp9_;
	GtkWidget* _tmp10_;
	SearchFilterToolbarSavedSearchPopoverDataButton* _tmp11_;
	SearchFilterToolbarSavedSearchPopoverDataButton* _tmp12_;
	SavedSearch* _tmp13_;
	SavedSearch* _tmp14_;
	SavedSearch* _tmp15_;
	SavedSearch* result = NULL;
#line 1021 "../src/SearchFilter.vala"
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self), NULL);
#line 1021 "../src/SearchFilter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (row, gtk_list_box_row_get_type ()), NULL);
#line 1022 "../src/SearchFilter.vala"
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (row, gtk_container_get_type (), GtkContainer));
#line 1022 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_;
#line 1022 "../src/SearchFilter.vala"
	_tmp2_ = g_list_first (_tmp1_);
#line 1022 "../src/SearchFilter.vala"
	_tmp3_ = _tmp2_->data;
#line 1022 "../src/SearchFilter.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((GtkWidget*) _tmp3_, gtk_box_get_type (), GtkBox));
#line 1022 "../src/SearchFilter.vala"
	_tmp5_ = _tmp4_;
#line 1022 "../src/SearchFilter.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 1022 "../src/SearchFilter.vala"
	box = _tmp5_;
#line 1023 "../src/SearchFilter.vala"
	_tmp6_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (box, gtk_container_get_type (), GtkContainer));
#line 1023 "../src/SearchFilter.vala"
	_tmp7_ = _tmp6_;
#line 1023 "../src/SearchFilter.vala"
	_tmp8_ = g_list_last (_tmp7_);
#line 1023 "../src/SearchFilter.vala"
	_tmp9_ = _tmp8_->data;
#line 1023 "../src/SearchFilter.vala"
	_tmp10_ = (GtkWidget*) _tmp9_;
#line 1023 "../src/SearchFilter.vala"
	_tmp11_ = _g_object_ref0 (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON (_tmp10_) ? ((SearchFilterToolbarSavedSearchPopoverDataButton*) _tmp10_) : NULL);
#line 1023 "../src/SearchFilter.vala"
	_tmp12_ = _tmp11_;
#line 1023 "../src/SearchFilter.vala"
	(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_list_free (_tmp7_), NULL));
#line 1023 "../src/SearchFilter.vala"
	button = _tmp12_;
#line 1024 "../src/SearchFilter.vala"
	_tmp13_ = search_filter_toolbar_saved_search_popover_data_button_get_search (button);
#line 1024 "../src/SearchFilter.vala"
	_tmp14_ = _tmp13_;
#line 1024 "../src/SearchFilter.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 1024 "../src/SearchFilter.vala"
	result = _tmp15_;
#line 1024 "../src/SearchFilter.vala"
	_g_object_unref0 (button);
#line 1024 "../src/SearchFilter.vala"
	_g_object_unref0 (box);
#line 1024 "../src/SearchFilter.vala"
	return result;
#line 9152 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_on_activate_row (SearchFilterToolbarSavedSearchPopover* self,
                                                            GtkListBoxRow* row)
{
	GtkPopover* _tmp2_;
#line 1027 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
#line 1027 "../src/SearchFilter.vala"
	g_return_if_fail ((row == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (row, gtk_list_box_row_get_type ()));
#line 1028 "../src/SearchFilter.vala"
	if (search_filter_toolbar_saved_search_popover_is_search_row (self, row)) {
#line 9166 "SearchFilter.c"
		SavedSearch* _tmp0_;
		SavedSearch* _tmp1_;
#line 1029 "../src/SearchFilter.vala"
		_tmp0_ = search_filter_toolbar_saved_search_popover_get_search (self, row);
#line 1029 "../src/SearchFilter.vala"
		_tmp1_ = _tmp0_;
#line 1029 "../src/SearchFilter.vala"
		g_signal_emit (self, search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_SEARCH_ACTIVATED_SIGNAL], 0, _tmp1_);
#line 1029 "../src/SearchFilter.vala"
		_g_object_unref0 (_tmp1_);
#line 9177 "SearchFilter.c"
	}
#line 1030 "../src/SearchFilter.vala"
	_tmp2_ = self->priv->popover;
#line 1030 "../src/SearchFilter.vala"
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget));
#line 9183 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_on_edit_click (SearchFilterToolbarSavedSearchPopover* self,
                                                          SavedSearch* search)
{
#line 1033 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
#line 1033 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SAVED_SEARCH (search));
#line 1034 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_EDIT_CLICKED_SIGNAL], 0, search);
#line 9196 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_on_delete_click (SearchFilterToolbarSavedSearchPopover* self,
                                                            SavedSearch* search)
{
#line 1037 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
#line 1037 "../src/SearchFilter.vala"
	g_return_if_fail (IS_SAVED_SEARCH (search));
#line 1038 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DELETE_CLICKED_SIGNAL], 0, search);
#line 9209 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_on_add_click (SearchFilterToolbarSavedSearchPopover* self)
{
#line 1041 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
#line 1042 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_ADD_CLICKED_SIGNAL], 0);
#line 9219 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_on_popover_closed (SearchFilterToolbarSavedSearchPopover* self)
{
#line 1045 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
#line 1046 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_CLOSED_SIGNAL], 0);
#line 9229 "SearchFilter.c"
}

void
search_filter_toolbar_saved_search_popover_show_all (SearchFilterToolbarSavedSearchPopover* self)
{
	GtkPopover* _tmp0_;
#line 1049 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
#line 1050 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->popover;
#line 1050 "../src/SearchFilter.vala"
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 9242 "SearchFilter.c"
}

void
search_filter_toolbar_saved_search_popover_hide (SearchFilterToolbarSavedSearchPopover* self)
{
	GtkPopover* _tmp0_;
#line 1053 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
#line 1054 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->popover;
#line 1054 "../src/SearchFilter.vala"
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 9255 "SearchFilter.c"
}

static inline gpointer
search_filter_toolbar_saved_search_popover_data_button_get_instance_private (SearchFilterToolbarSavedSearchPopoverDataButton* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbarSavedSearchPopoverDataButton_private_offset);
}

static void
_search_filter_toolbar_saved_search_popover_data_button_on_click_gtk_button_clicked (GtkButton* _sender,
                                                                                     gpointer self)
{
#line 952 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_data_button_on_click ((SearchFilterToolbarSavedSearchPopoverDataButton*) self);
#line 9270 "SearchFilter.c"
}

static SearchFilterToolbarSavedSearchPopoverDataButton*
search_filter_toolbar_saved_search_popover_data_button_construct (GType object_type,
                                                                  SavedSearch* search,
                                                                  const gchar* name)
{
	SearchFilterToolbarSavedSearchPopoverDataButton * self = NULL;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
#line 941 "../src/SearchFilter.vala"
	g_return_val_if_fail (IS_SAVED_SEARCH (search), NULL);
#line 941 "../src/SearchFilter.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 941 "../src/SearchFilter.vala"
	self = (SearchFilterToolbarSavedSearchPopoverDataButton*) g_object_new (object_type, NULL);
#line 942 "../src/SearchFilter.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_from_icon_name (name, (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 942 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp0_);
#line 942 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->button);
#line 942 "../src/SearchFilter.vala"
	self->priv->button = _tmp0_;
#line 943 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_data_button_set_search (self, search);
#line 944 "../src/SearchFilter.vala"
	_tmp1_ = self->priv->button;
#line 944 "../src/SearchFilter.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 946 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_data_button_restyle (self);
#line 948 "../src/SearchFilter.vala"
	_tmp2_ = self->priv->button;
#line 948 "../src/SearchFilter.vala"
	g_signal_connect_object (_tmp2_, "clicked", (GCallback) _search_filter_toolbar_saved_search_popover_data_button_on_click_gtk_button_clicked, self, 0);
#line 941 "../src/SearchFilter.vala"
	return self;
#line 9310 "SearchFilter.c"
}

static SearchFilterToolbarSavedSearchPopoverDataButton*
search_filter_toolbar_saved_search_popover_data_button_new (SavedSearch* search,
                                                            const gchar* name)
{
#line 941 "../src/SearchFilter.vala"
	return search_filter_toolbar_saved_search_popover_data_button_construct (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, search, name);
#line 9319 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_data_button_restyle (SearchFilterToolbarSavedSearchPopoverDataButton* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
#line 955 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON (self));
#line 956 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->button;
#line 956 "../src/SearchFilter.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), 24, 24);
#line 957 "../src/SearchFilter.vala"
	_tmp1_ = self->priv->button;
#line 957 "../src/SearchFilter.vala"
	gtk_button_set_relief (_tmp1_, GTK_RELIEF_NONE);
#line 9337 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_data_button_on_click (SearchFilterToolbarSavedSearchPopoverDataButton* self)
{
	SavedSearch* _tmp0_;
#line 960 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON (self));
#line 961 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->_search;
#line 961 "../src/SearchFilter.vala"
	g_signal_emit (self, search_filter_toolbar_saved_search_popover_data_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_CLICKED_SIGNAL], 0, _tmp0_);
#line 9350 "SearchFilter.c"
}

static SavedSearch*
search_filter_toolbar_saved_search_popover_data_button_get_search (SearchFilterToolbarSavedSearchPopoverDataButton* self)
{
	SavedSearch* result;
	SavedSearch* _tmp0_;
#line 937 "../src/SearchFilter.vala"
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON (self), NULL);
#line 937 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->_search;
#line 937 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 937 "../src/SearchFilter.vala"
	return result;
#line 9366 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_data_button_set_search (SearchFilterToolbarSavedSearchPopoverDataButton* self,
                                                                   SavedSearch* value)
{
	SavedSearch* old_value;
#line 937 "../src/SearchFilter.vala"
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON (self));
#line 937 "../src/SearchFilter.vala"
	old_value = search_filter_toolbar_saved_search_popover_data_button_get_search (self);
#line 937 "../src/SearchFilter.vala"
	if (old_value != value) {
#line 9380 "SearchFilter.c"
		SavedSearch* _tmp0_;
#line 937 "../src/SearchFilter.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 937 "../src/SearchFilter.vala"
		_g_object_unref0 (self->priv->_search);
#line 937 "../src/SearchFilter.vala"
		self->priv->_search = _tmp0_;
#line 937 "../src/SearchFilter.vala"
		g_object_notify_by_pspec ((GObject *) self, search_filter_toolbar_saved_search_popover_data_button_properties[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY]);
#line 9390 "SearchFilter.c"
	}
}

static void
search_filter_toolbar_saved_search_popover_data_button_class_init (SearchFilterToolbarSavedSearchPopoverDataButtonClass * klass,
                                                                   gpointer klass_data)
{
#line 935 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_data_button_parent_class = g_type_class_peek_parent (klass);
#line 935 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbarSavedSearchPopoverDataButton_private_offset);
#line 935 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_search_filter_toolbar_saved_search_popover_data_button_get_property;
#line 935 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_search_filter_toolbar_saved_search_popover_data_button_set_property;
#line 935 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_saved_search_popover_data_button_finalize;
#line 935 "../src/SearchFilter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY, search_filter_toolbar_saved_search_popover_data_button_properties[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY] = g_param_spec_object ("search", "search", "search", TYPE_SAVED_SEARCH, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 935 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_data_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_CLICKED_SIGNAL] = g_signal_new ("clicked", SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_SAVED_SEARCH);
#line 9412 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_data_button_instance_init (SearchFilterToolbarSavedSearchPopoverDataButton * self,
                                                                      gpointer klass)
{
#line 935 "../src/SearchFilter.vala"
	self->priv = search_filter_toolbar_saved_search_popover_data_button_get_instance_private (self);
#line 936 "../src/SearchFilter.vala"
	self->priv->button = NULL;
#line 9423 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_data_button_finalize (GObject * obj)
{
	SearchFilterToolbarSavedSearchPopoverDataButton * self;
	GtkButton* _tmp0_;
	guint _tmp1_;
#line 935 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButton);
#line 952 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->button;
#line 952 "../src/SearchFilter.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp1_, NULL, FALSE);
#line 952 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_data_button_on_click_gtk_button_clicked, self);
#line 936 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->button);
#line 937 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->_search);
#line 935 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (search_filter_toolbar_saved_search_popover_data_button_parent_class)->finalize (obj);
#line 9446 "SearchFilter.c"
}

static GType
search_filter_toolbar_saved_search_popover_data_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarSavedSearchPopoverDataButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_saved_search_popover_data_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarSavedSearchPopoverDataButton), 0, (GInstanceInitFunc) search_filter_toolbar_saved_search_popover_data_button_instance_init, NULL };
	GType search_filter_toolbar_saved_search_popover_data_button_type_id;
	search_filter_toolbar_saved_search_popover_data_button_type_id = g_type_register_static (gtk_bin_get_type (), "SearchFilterToolbarSavedSearchPopoverDataButton", &g_define_type_info, 0);
	SearchFilterToolbarSavedSearchPopoverDataButton_private_offset = g_type_add_instance_private (search_filter_toolbar_saved_search_popover_data_button_type_id, sizeof (SearchFilterToolbarSavedSearchPopoverDataButtonPrivate));
	return search_filter_toolbar_saved_search_popover_data_button_type_id;
}

static GType
search_filter_toolbar_saved_search_popover_data_button_get_type (void)
{
	static volatile gsize search_filter_toolbar_saved_search_popover_data_button_type_id__volatile = 0;
	if (g_once_init_enter (&search_filter_toolbar_saved_search_popover_data_button_type_id__volatile)) {
		GType search_filter_toolbar_saved_search_popover_data_button_type_id;
		search_filter_toolbar_saved_search_popover_data_button_type_id = search_filter_toolbar_saved_search_popover_data_button_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_saved_search_popover_data_button_type_id__volatile, search_filter_toolbar_saved_search_popover_data_button_type_id);
	}
	return search_filter_toolbar_saved_search_popover_data_button_type_id__volatile;
}

static void
_vala_search_filter_toolbar_saved_search_popover_data_button_get_property (GObject * object,
                                                                           guint property_id,
                                                                           GValue * value,
                                                                           GParamSpec * pspec)
{
	SearchFilterToolbarSavedSearchPopoverDataButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButton);
#line 935 "../src/SearchFilter.vala"
	switch (property_id) {
#line 935 "../src/SearchFilter.vala"
		case SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY:
#line 935 "../src/SearchFilter.vala"
		g_value_set_object (value, search_filter_toolbar_saved_search_popover_data_button_get_search (self));
#line 935 "../src/SearchFilter.vala"
		break;
#line 9487 "SearchFilter.c"
		default:
#line 935 "../src/SearchFilter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 935 "../src/SearchFilter.vala"
		break;
#line 9493 "SearchFilter.c"
	}
}

static void
_vala_search_filter_toolbar_saved_search_popover_data_button_set_property (GObject * object,
                                                                           guint property_id,
                                                                           const GValue * value,
                                                                           GParamSpec * pspec)
{
	SearchFilterToolbarSavedSearchPopoverDataButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButton);
#line 935 "../src/SearchFilter.vala"
	switch (property_id) {
#line 935 "../src/SearchFilter.vala"
		case SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY:
#line 935 "../src/SearchFilter.vala"
		search_filter_toolbar_saved_search_popover_data_button_set_search (self, g_value_get_object (value));
#line 935 "../src/SearchFilter.vala"
		break;
#line 9513 "SearchFilter.c"
		default:
#line 935 "../src/SearchFilter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 935 "../src/SearchFilter.vala"
		break;
#line 9519 "SearchFilter.c"
	}
}

static void
search_filter_toolbar_value_saved_search_popover_init (GValue* value)
{
#line 921 "../src/SearchFilter.vala"
	value->data[0].v_pointer = NULL;
#line 9528 "SearchFilter.c"
}

static void
search_filter_toolbar_value_saved_search_popover_free_value (GValue* value)
{
#line 921 "../src/SearchFilter.vala"
	if (value->data[0].v_pointer) {
#line 921 "../src/SearchFilter.vala"
		search_filter_toolbar_saved_search_popover_unref (value->data[0].v_pointer);
#line 9538 "SearchFilter.c"
	}
}

static void
search_filter_toolbar_value_saved_search_popover_copy_value (const GValue* src_value,
                                                             GValue* dest_value)
{
#line 921 "../src/SearchFilter.vala"
	if (src_value->data[0].v_pointer) {
#line 921 "../src/SearchFilter.vala"
		dest_value->data[0].v_pointer = search_filter_toolbar_saved_search_popover_ref (src_value->data[0].v_pointer);
#line 9550 "SearchFilter.c"
	} else {
#line 921 "../src/SearchFilter.vala"
		dest_value->data[0].v_pointer = NULL;
#line 9554 "SearchFilter.c"
	}
}

static gpointer
search_filter_toolbar_value_saved_search_popover_peek_pointer (const GValue* value)
{
#line 921 "../src/SearchFilter.vala"
	return value->data[0].v_pointer;
#line 9563 "SearchFilter.c"
}

static gchar*
search_filter_toolbar_value_saved_search_popover_collect_value (GValue* value,
                                                                guint n_collect_values,
                                                                GTypeCValue* collect_values,
                                                                guint collect_flags)
{
#line 921 "../src/SearchFilter.vala"
	if (collect_values[0].v_pointer) {
#line 9574 "SearchFilter.c"
		SearchFilterToolbarSavedSearchPopover * object;
		object = collect_values[0].v_pointer;
#line 921 "../src/SearchFilter.vala"
		if (object->parent_instance.g_class == NULL) {
#line 921 "../src/SearchFilter.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9581 "SearchFilter.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 921 "../src/SearchFilter.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9585 "SearchFilter.c"
		}
#line 921 "../src/SearchFilter.vala"
		value->data[0].v_pointer = search_filter_toolbar_saved_search_popover_ref (object);
#line 9589 "SearchFilter.c"
	} else {
#line 921 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 9593 "SearchFilter.c"
	}
#line 921 "../src/SearchFilter.vala"
	return NULL;
#line 9597 "SearchFilter.c"
}

static gchar*
search_filter_toolbar_value_saved_search_popover_lcopy_value (const GValue* value,
                                                              guint n_collect_values,
                                                              GTypeCValue* collect_values,
                                                              guint collect_flags)
{
	SearchFilterToolbarSavedSearchPopover ** object_p;
	object_p = collect_values[0].v_pointer;
#line 921 "../src/SearchFilter.vala"
	if (!object_p) {
#line 921 "../src/SearchFilter.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 9612 "SearchFilter.c"
	}
#line 921 "../src/SearchFilter.vala"
	if (!value->data[0].v_pointer) {
#line 921 "../src/SearchFilter.vala"
		*object_p = NULL;
#line 9618 "SearchFilter.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 921 "../src/SearchFilter.vala"
		*object_p = value->data[0].v_pointer;
#line 9622 "SearchFilter.c"
	} else {
#line 921 "../src/SearchFilter.vala"
		*object_p = search_filter_toolbar_saved_search_popover_ref (value->data[0].v_pointer);
#line 9626 "SearchFilter.c"
	}
#line 921 "../src/SearchFilter.vala"
	return NULL;
#line 9630 "SearchFilter.c"
}

GParamSpec*
search_filter_toolbar_param_spec_saved_search_popover (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags)
{
	SearchFilterToolbarParamSpecSavedSearchPopover* spec;
#line 921 "../src/SearchFilter.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER), NULL);
#line 921 "../src/SearchFilter.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 921 "../src/SearchFilter.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 921 "../src/SearchFilter.vala"
	return G_PARAM_SPEC (spec);
#line 9649 "SearchFilter.c"
}

gpointer
search_filter_toolbar_value_get_saved_search_popover (const GValue* value)
{
#line 921 "../src/SearchFilter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER), NULL);
#line 921 "../src/SearchFilter.vala"
	return value->data[0].v_pointer;
#line 9659 "SearchFilter.c"
}

void
search_filter_toolbar_value_set_saved_search_popover (GValue* value,
                                                      gpointer v_object)
{
	SearchFilterToolbarSavedSearchPopover * old;
#line 921 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER));
#line 921 "../src/SearchFilter.vala"
	old = value->data[0].v_pointer;
#line 921 "../src/SearchFilter.vala"
	if (v_object) {
#line 921 "../src/SearchFilter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER));
#line 921 "../src/SearchFilter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 921 "../src/SearchFilter.vala"
		value->data[0].v_pointer = v_object;
#line 921 "../src/SearchFilter.vala"
		search_filter_toolbar_saved_search_popover_ref (value->data[0].v_pointer);
#line 9681 "SearchFilter.c"
	} else {
#line 921 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 9685 "SearchFilter.c"
	}
#line 921 "../src/SearchFilter.vala"
	if (old) {
#line 921 "../src/SearchFilter.vala"
		search_filter_toolbar_saved_search_popover_unref (old);
#line 9691 "SearchFilter.c"
	}
}

void
search_filter_toolbar_value_take_saved_search_popover (GValue* value,
                                                       gpointer v_object)
{
	SearchFilterToolbarSavedSearchPopover * old;
#line 921 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER));
#line 921 "../src/SearchFilter.vala"
	old = value->data[0].v_pointer;
#line 921 "../src/SearchFilter.vala"
	if (v_object) {
#line 921 "../src/SearchFilter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER));
#line 921 "../src/SearchFilter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 921 "../src/SearchFilter.vala"
		value->data[0].v_pointer = v_object;
#line 9712 "SearchFilter.c"
	} else {
#line 921 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 9716 "SearchFilter.c"
	}
#line 921 "../src/SearchFilter.vala"
	if (old) {
#line 921 "../src/SearchFilter.vala"
		search_filter_toolbar_saved_search_popover_unref (old);
#line 9722 "SearchFilter.c"
	}
}

static void
search_filter_toolbar_saved_search_popover_class_init (SearchFilterToolbarSavedSearchPopoverClass * klass,
                                                       gpointer klass_data)
{
#line 921 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_parent_class = g_type_class_peek_parent (klass);
#line 921 "../src/SearchFilter.vala"
	((SearchFilterToolbarSavedSearchPopoverClass *) klass)->finalize = search_filter_toolbar_saved_search_popover_finalize;
#line 921 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbarSavedSearchPopover_private_offset);
#line 921 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_SEARCH_ACTIVATED_SIGNAL] = g_signal_new ("search-activated", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_SAVED_SEARCH);
#line 921 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_EDIT_CLICKED_SIGNAL] = g_signal_new ("edit-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_SAVED_SEARCH);
#line 921 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DELETE_CLICKED_SIGNAL] = g_signal_new ("delete-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_SAVED_SEARCH);
#line 921 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_ADD_CLICKED_SIGNAL] = g_signal_new ("add-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 921 "../src/SearchFilter.vala"
	search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_CLOSED_SIGNAL] = g_signal_new ("closed", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 9746 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_instance_init (SearchFilterToolbarSavedSearchPopover * self,
                                                          gpointer klass)
{
#line 921 "../src/SearchFilter.vala"
	self->priv = search_filter_toolbar_saved_search_popover_get_instance_private (self);
#line 922 "../src/SearchFilter.vala"
	self->priv->popover = NULL;
#line 923 "../src/SearchFilter.vala"
	self->priv->list_box = NULL;
#line 924 "../src/SearchFilter.vala"
	self->priv->edit_buttons = NULL;
#line 924 "../src/SearchFilter.vala"
	self->priv->edit_buttons_length1 = 0;
#line 924 "../src/SearchFilter.vala"
	self->priv->_edit_buttons_size_ = self->priv->edit_buttons_length1;
#line 925 "../src/SearchFilter.vala"
	self->priv->delete_buttons = NULL;
#line 925 "../src/SearchFilter.vala"
	self->priv->delete_buttons_length1 = 0;
#line 925 "../src/SearchFilter.vala"
	self->priv->_delete_buttons_size_ = self->priv->delete_buttons_length1;
#line 926 "../src/SearchFilter.vala"
	self->priv->add = NULL;
#line 921 "../src/SearchFilter.vala"
	self->ref_count = 1;
#line 9775 "SearchFilter.c"
}

static void
search_filter_toolbar_saved_search_popover_finalize (SearchFilterToolbarSavedSearchPopover * obj)
{
	SearchFilterToolbarSavedSearchPopover * self;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp0_;
	gint _tmp0__length1;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp4_;
	gint _tmp4__length1;
	GtkButton* _tmp8_;
	guint _tmp9_;
	GtkListBox* _tmp10_;
	guint _tmp11_;
	GtkPopover* _tmp12_;
	guint _tmp13_;
#line 921 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, SearchFilterToolbarSavedSearchPopover);
#line 921 "../src/SearchFilter.vala"
	g_signal_handlers_destroy (self);
#line 1002 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->edit_buttons;
#line 1002 "../src/SearchFilter.vala"
	_tmp0__length1 = self->priv->edit_buttons_length1;
#line 9800 "SearchFilter.c"
	{
		SearchFilterToolbarSavedSearchPopoverDataButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
#line 1002 "../src/SearchFilter.vala"
		button_collection = _tmp0_;
#line 1002 "../src/SearchFilter.vala"
		button_collection_length1 = _tmp0__length1;
#line 1002 "../src/SearchFilter.vala"
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
#line 9812 "SearchFilter.c"
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp1_;
			SearchFilterToolbarSavedSearchPopoverDataButton* button = NULL;
#line 1002 "../src/SearchFilter.vala"
			_tmp1_ = _g_object_ref0 (button_collection[button_it]);
#line 1002 "../src/SearchFilter.vala"
			button = _tmp1_;
#line 9819 "SearchFilter.c"
			{
				SearchFilterToolbarSavedSearchPopoverDataButton* _tmp2_;
				guint _tmp3_;
#line 1002 "../src/SearchFilter.vala"
				_tmp2_ = button;
#line 1002 "../src/SearchFilter.vala"
				g_signal_parse_name ("clicked", SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, &_tmp3_, NULL, FALSE);
#line 1002 "../src/SearchFilter.vala"
				g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_on_edit_click_search_filter_toolbar_saved_search_popover_data_button_clicked, self);
#line 1002 "../src/SearchFilter.vala"
				_g_object_unref0 (button);
#line 9831 "SearchFilter.c"
			}
		}
	}
#line 1003 "../src/SearchFilter.vala"
	_tmp4_ = self->priv->delete_buttons;
#line 1003 "../src/SearchFilter.vala"
	_tmp4__length1 = self->priv->delete_buttons_length1;
#line 9839 "SearchFilter.c"
	{
		SearchFilterToolbarSavedSearchPopoverDataButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
#line 1003 "../src/SearchFilter.vala"
		button_collection = _tmp4_;
#line 1003 "../src/SearchFilter.vala"
		button_collection_length1 = _tmp4__length1;
#line 1003 "../src/SearchFilter.vala"
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
#line 9851 "SearchFilter.c"
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp5_;
			SearchFilterToolbarSavedSearchPopoverDataButton* button = NULL;
#line 1003 "../src/SearchFilter.vala"
			_tmp5_ = _g_object_ref0 (button_collection[button_it]);
#line 1003 "../src/SearchFilter.vala"
			button = _tmp5_;
#line 9858 "SearchFilter.c"
			{
				SearchFilterToolbarSavedSearchPopoverDataButton* _tmp6_;
				guint _tmp7_;
#line 1003 "../src/SearchFilter.vala"
				_tmp6_ = button;
#line 1003 "../src/SearchFilter.vala"
				g_signal_parse_name ("clicked", SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, &_tmp7_, NULL, FALSE);
#line 1003 "../src/SearchFilter.vala"
				g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_on_delete_click_search_filter_toolbar_saved_search_popover_data_button_clicked, self);
#line 1003 "../src/SearchFilter.vala"
				_g_object_unref0 (button);
#line 9870 "SearchFilter.c"
			}
		}
	}
#line 1004 "../src/SearchFilter.vala"
	_tmp8_ = self->priv->add;
#line 1004 "../src/SearchFilter.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp9_, NULL, FALSE);
#line 1004 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_on_add_click_gtk_button_clicked, self);
#line 1005 "../src/SearchFilter.vala"
	_tmp10_ = self->priv->list_box;
#line 1005 "../src/SearchFilter.vala"
	g_signal_parse_name ("row-activated", gtk_list_box_get_type (), &_tmp11_, NULL, FALSE);
#line 1005 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_on_activate_row_gtk_list_box_row_activated, self);
#line 1006 "../src/SearchFilter.vala"
	_tmp12_ = self->priv->popover;
#line 1006 "../src/SearchFilter.vala"
	g_signal_parse_name ("closed", gtk_popover_get_type (), &_tmp13_, NULL, FALSE);
#line 1006 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_on_popover_closed_gtk_popover_closed, self);
#line 922 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->popover);
#line 923 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->list_box);
#line 924 "../src/SearchFilter.vala"
	self->priv->edit_buttons = (_vala_array_free (self->priv->edit_buttons, self->priv->edit_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
#line 925 "../src/SearchFilter.vala"
	self->priv->delete_buttons = (_vala_array_free (self->priv->delete_buttons, self->priv->delete_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
#line 926 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->add);
#line 9902 "SearchFilter.c"
}

static GType
search_filter_toolbar_saved_search_popover_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { search_filter_toolbar_value_saved_search_popover_init, search_filter_toolbar_value_saved_search_popover_free_value, search_filter_toolbar_value_saved_search_popover_copy_value, search_filter_toolbar_value_saved_search_popover_peek_pointer, "p", search_filter_toolbar_value_saved_search_popover_collect_value, "p", search_filter_toolbar_value_saved_search_popover_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarSavedSearchPopoverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_saved_search_popover_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarSavedSearchPopover), 0, (GInstanceInitFunc) search_filter_toolbar_saved_search_popover_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType search_filter_toolbar_saved_search_popover_type_id;
	search_filter_toolbar_saved_search_popover_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SearchFilterToolbarSavedSearchPopover", &g_define_type_info, &g_define_type_fundamental_info, 0);
	SearchFilterToolbarSavedSearchPopover_private_offset = g_type_add_instance_private (search_filter_toolbar_saved_search_popover_type_id, sizeof (SearchFilterToolbarSavedSearchPopoverPrivate));
	return search_filter_toolbar_saved_search_popover_type_id;
}

GType
search_filter_toolbar_saved_search_popover_get_type (void)
{
	static volatile gsize search_filter_toolbar_saved_search_popover_type_id__volatile = 0;
	if (g_once_init_enter (&search_filter_toolbar_saved_search_popover_type_id__volatile)) {
		GType search_filter_toolbar_saved_search_popover_type_id;
		search_filter_toolbar_saved_search_popover_type_id = search_filter_toolbar_saved_search_popover_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_saved_search_popover_type_id__volatile, search_filter_toolbar_saved_search_popover_type_id);
	}
	return search_filter_toolbar_saved_search_popover_type_id__volatile;
}

gpointer
search_filter_toolbar_saved_search_popover_ref (gpointer instance)
{
	SearchFilterToolbarSavedSearchPopover * self;
	self = instance;
#line 921 "../src/SearchFilter.vala"
	g_atomic_int_inc (&self->ref_count);
#line 921 "../src/SearchFilter.vala"
	return instance;
#line 9938 "SearchFilter.c"
}

void
search_filter_toolbar_saved_search_popover_unref (gpointer instance)
{
	SearchFilterToolbarSavedSearchPopover * self;
	self = instance;
#line 921 "../src/SearchFilter.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 921 "../src/SearchFilter.vala"
		SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_GET_CLASS (self)->finalize (self);
#line 921 "../src/SearchFilter.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 9952 "SearchFilter.c"
	}
}

static void
search_filter_toolbar_class_init (SearchFilterToolbarClass * klass,
                                  gpointer klass_data)
{
#line 622 "../src/SearchFilter.vala"
	search_filter_toolbar_parent_class = g_type_class_peek_parent (klass);
#line 622 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbar_private_offset);
#line 622 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_finalize;
#line 9966 "SearchFilter.c"
}

static void
search_filter_toolbar_instance_init (SearchFilterToolbar * self,
                                     gpointer klass)
{
	GtkMenu* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkBuilder* _tmp2_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp3_;
#line 622 "../src/SearchFilter.vala"
	self->priv = search_filter_toolbar_get_instance_private (self);
#line 681 "../src/SearchFilter.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 681 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp0_);
#line 681 "../src/SearchFilter.vala"
	self->priv->close_menu = _tmp0_;
#line 682 "../src/SearchFilter.vala"
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 682 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp1_);
#line 682 "../src/SearchFilter.vala"
	self->priv->close_item = _tmp1_;
#line 1058 "../src/SearchFilter.vala"
	_tmp2_ = gtk_builder_new ();
#line 1058 "../src/SearchFilter.vala"
	self->builder = _tmp2_;
#line 1061 "../src/SearchFilter.vala"
	self->priv->saved_search = NULL;
#line 1064 "../src/SearchFilter.vala"
	_tmp3_ = search_filter_toolbar_saved_search_filter_button_new ();
#line 1064 "../src/SearchFilter.vala"
	g_object_ref_sink (_tmp3_);
#line 1064 "../src/SearchFilter.vala"
	self->priv->saved_search_button = _tmp3_;
#line 1065 "../src/SearchFilter.vala"
	self->priv->elide_showing_again = FALSE;
#line 1066 "../src/SearchFilter.vala"
	self->priv->search_filter = NULL;
#line 10007 "SearchFilter.c"
}

static void
search_filter_toolbar_finalize (GObject * obj)
{
	SearchFilterToolbar * self;
	SearchFilterActions* _tmp0_;
	guint _tmp1_;
	SearchFilterActions* _tmp2_;
	guint _tmp3_;
	SearchFilterActions* _tmp4_;
	guint _tmp5_;
	SearchFilterActions* _tmp6_;
	guint _tmp7_;
	SearchFilterActions* _tmp8_;
	guint _tmp9_;
	SearchFilterActions* _tmp10_;
	guint _tmp11_;
	SearchFilterActions* _tmp12_;
	guint _tmp13_;
	SearchFilterActions* _tmp14_;
	guint _tmp15_;
	GtkToolbar* _tmp16_;
	guint _tmp17_;
#line 622 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_FILTER_TOOLBAR, SearchFilterToolbar);
#line 1182 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->actions;
#line 1182 "../src/SearchFilter.vala"
	g_signal_parse_name ("media-context-changed", TYPE_SEARCH_FILTER_ACTIONS, &_tmp1_, NULL, FALSE);
#line 1182 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _search_filter_toolbar_on_media_context_changed_search_filter_actions_media_context_changed, self);
#line 1184 "../src/SearchFilter.vala"
	_tmp2_ = self->priv->actions;
#line 1184 "../src/SearchFilter.vala"
	g_signal_parse_name ("flagged-toggled", TYPE_SEARCH_FILTER_ACTIONS, &_tmp3_, NULL, FALSE);
#line 1184 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _search_filter_toolbar_on_flagged_toggled_search_filter_actions_flagged_toggled, self);
#line 1185 "../src/SearchFilter.vala"
	_tmp4_ = self->priv->actions;
#line 1185 "../src/SearchFilter.vala"
	g_signal_parse_name ("photos-toggled", TYPE_SEARCH_FILTER_ACTIONS, &_tmp5_, NULL, FALSE);
#line 1185 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _search_filter_toolbar_on_photos_toggled_search_filter_actions_photos_toggled, self);
#line 1186 "../src/SearchFilter.vala"
	_tmp6_ = self->priv->actions;
#line 1186 "../src/SearchFilter.vala"
	g_signal_parse_name ("videos-toggled", TYPE_SEARCH_FILTER_ACTIONS, &_tmp7_, NULL, FALSE);
#line 1186 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _search_filter_toolbar_on_videos_toggled_search_filter_actions_videos_toggled, self);
#line 1187 "../src/SearchFilter.vala"
	_tmp8_ = self->priv->actions;
#line 1187 "../src/SearchFilter.vala"
	g_signal_parse_name ("raw-toggled", TYPE_SEARCH_FILTER_ACTIONS, &_tmp9_, NULL, FALSE);
#line 1187 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _search_filter_toolbar_on_raw_toggled_search_filter_actions_raw_toggled, self);
#line 1188 "../src/SearchFilter.vala"
	_tmp10_ = self->priv->actions;
#line 1188 "../src/SearchFilter.vala"
	g_signal_parse_name ("rating-changed", TYPE_SEARCH_FILTER_ACTIONS, &_tmp11_, NULL, FALSE);
#line 1188 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _search_filter_toolbar_on_rating_changed_search_filter_actions_rating_changed, self);
#line 1189 "../src/SearchFilter.vala"
	_tmp12_ = self->priv->actions;
#line 1189 "../src/SearchFilter.vala"
	g_signal_parse_name ("text-changed", TYPE_SEARCH_FILTER_ACTIONS, &_tmp13_, NULL, FALSE);
#line 1189 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _search_filter_toolbar_on_search_text_changed_search_filter_actions_text_changed, self);
#line 1190 "../src/SearchFilter.vala"
	_tmp14_ = self->priv->actions;
#line 1190 "../src/SearchFilter.vala"
	g_signal_parse_name ("criteria-changed", TYPE_SEARCH_FILTER_ACTIONS, &_tmp15_, NULL, FALSE);
#line 1190 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _search_filter_toolbar_on_criteria_changed_search_filter_actions_criteria_changed, self);
#line 1192 "../src/SearchFilter.vala"
	_tmp16_ = self->priv->toolbar;
#line 1192 "../src/SearchFilter.vala"
	g_signal_parse_name ("popup-context-menu", gtk_toolbar_get_type (), &_tmp17_, NULL, FALSE);
#line 1192 "../src/SearchFilter.vala"
	g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _search_filter_toolbar_on_context_menu_requested_gtk_toolbar_popup_context_menu, self);
#line 623 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->toolbar);
#line 681 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->close_menu);
#line 682 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->close_item);
#line 1058 "../src/SearchFilter.vala"
	_g_object_unref0 (self->builder);
#line 1060 "../src/SearchFilter.vala"
	_search_filter_actions_unref0 (self->priv->actions);
#line 1061 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->saved_search);
#line 1062 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->search_box);
#line 1063 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->rating_button);
#line 1064 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->saved_search_button);
#line 1066 "../src/SearchFilter.vala"
	_view_filter_unref0 (self->priv->search_filter);
#line 1067 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->label_type);
#line 1068 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->toolbtn_photos);
#line 1069 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->toolbtn_videos);
#line 1070 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->toolbtn_raw);
#line 1071 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->toolbtn_flag);
#line 1072 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->sepr_mediatype_flagged);
#line 1073 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->sepr_flagged_rating);
#line 1074 "../src/SearchFilter.vala"
	_g_object_unref0 (self->priv->sepr_rating_saved);
#line 622 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (search_filter_toolbar_parent_class)->finalize (obj);
#line 10126 "SearchFilter.c"
}

static GType
search_filter_toolbar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbar), 0, (GInstanceInitFunc) search_filter_toolbar_instance_init, NULL };
	GType search_filter_toolbar_type_id;
	search_filter_toolbar_type_id = g_type_register_static (gtk_revealer_get_type (), "SearchFilterToolbar", &g_define_type_info, 0);
	SearchFilterToolbar_private_offset = g_type_add_instance_private (search_filter_toolbar_type_id, sizeof (SearchFilterToolbarPrivate));
	return search_filter_toolbar_type_id;
}

GType
search_filter_toolbar_get_type (void)
{
	static volatile gsize search_filter_toolbar_type_id__volatile = 0;
	if (g_once_init_enter (&search_filter_toolbar_type_id__volatile)) {
		GType search_filter_toolbar_type_id;
		search_filter_toolbar_type_id = search_filter_toolbar_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_type_id__volatile, search_filter_toolbar_type_id);
	}
	return search_filter_toolbar_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

