/* PhotoTable.c generated by valac 0.52.10, the Vala compiler
 * generated from PhotoTable.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <gee.h>
#include "shotwell-graphics-processor.h"
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>
#include <gio/gio.h>

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

#define TYPE_ORIENTATION (orientation_get_type ())
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())

#define TYPE_GPS_COORDS (gps_coords_get_type ())
typedef struct _GpsCoords GpsCoords;

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecPhotoRow ParamSpecPhotoRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
typedef struct _PhotoTablePrivate PhotoTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecBackingPhotoRow ParamSpecBackingPhotoRow;

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;
typedef struct _BackingPhotoTablePrivate BackingPhotoTablePrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PhotoID {
	gint64 id;
};

struct _ImportID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _GpsCoords {
	gint has_gps;
	gdouble latitude;
	gdouble longitude;
};

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	Rating rating;
	gchar* title;
	GpsCoords gps_coords;
	gchar* comment;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _ParamSpecPhotoRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _PhotoTable {
	DatabaseTable parent_instance;
	PhotoTablePrivate * priv;
};

struct _PhotoTableClass {
	DatabaseTableClass parent_class;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	time_t time_created;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _ParamSpecBackingPhotoRow {
	GParamSpec parent_instance;
};

struct _BackingPhotoTable {
	DatabaseTable parent_instance;
	BackingPhotoTablePrivate * priv;
};

struct _BackingPhotoTableClass {
	DatabaseTableClass parent_class;
};

static gpointer photo_row_parent_class = NULL;
static gpointer photo_table_parent_class = NULL;
static PhotoTable* photo_table_instance;
static PhotoTable* photo_table_instance = NULL;
extern sqlite3* database_table_db;
static gpointer backing_photo_row_parent_class = NULL;
static gpointer backing_photo_table_parent_class = NULL;
static BackingPhotoTable* backing_photo_table_instance;
static BackingPhotoTable* backing_photo_table_instance = NULL;

GType photo_id_get_type (void) G_GNUC_CONST ;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
#define PHOTO_ID_INVALID ((gint64) -1)
void photo_id_init (PhotoID *self,
                    gint64 id);
gboolean photo_id_is_invalid (PhotoID *self);
gboolean photo_id_is_valid (PhotoID *self);
guint photo_id_hash (PhotoID *self);
guint int64_hash (gint64* n);
gboolean photo_id_equal (void* a,
                         void* b);
gchar* photo_id_upgrade_photo_id_to_source_id (PhotoID* photo_id);
#define PHOTO_TYPENAME "thumb"
GType import_id_get_type (void) G_GNUC_CONST ;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
#define IMPORT_ID_INVALID ((gint64) 0)
void import_id_init (ImportID *self,
                     gint64 id);
void import_id_generate (ImportID* result);
#define UTIL_USEC_PER_SEC ((gint64) 1000000)
gboolean import_id_is_invalid (ImportID *self);
gboolean import_id_is_valid (ImportID *self);
gint import_id_compare_func (ImportID* a,
                             ImportID* b);
gint64 import_id_comparator (void* a,
                             void* b);
gpointer photo_row_ref (gpointer instance);
void photo_row_unref (gpointer instance);
GParamSpec* param_spec_photo_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_photo_row (GValue* value,
                          gpointer v_object);
void value_take_photo_row (GValue* value,
                           gpointer v_object);
gpointer value_get_photo_row (const GValue* value);
GType photo_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoRow, photo_row_unref)
gpointer backing_photo_row_ref (gpointer instance);
void backing_photo_row_unref (gpointer instance);
GParamSpec* param_spec_backing_photo_row (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_backing_photo_row (GValue* value,
                                  gpointer v_object);
void value_take_backing_photo_row (GValue* value,
                                   gpointer v_object);
gpointer value_get_backing_photo_row (const GValue* value);
GType backing_photo_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingPhotoRow, backing_photo_row_unref)
GType event_id_get_type (void) G_GNUC_CONST ;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
GType orientation_get_type (void) G_GNUC_CONST ;
GType rating_get_type (void) G_GNUC_CONST ;
GType gps_coords_get_type (void) G_GNUC_CONST ;
GpsCoords* gps_coords_dup (const GpsCoords* self);
void gps_coords_free (GpsCoords* self);
GType backing_photo_id_get_type (void) G_GNUC_CONST ;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
GType raw_developer_get_type (void) G_GNUC_CONST ;
PhotoRow* photo_row_new (void);
PhotoRow* photo_row_construct (GType object_type);
BackingPhotoRow* backing_photo_row_new (void);
BackingPhotoRow* backing_photo_row_construct (GType object_type);
#define BACKING_PHOTO_ID_INVALID ((gint64) -1)
void backing_photo_id_init (BackingPhotoID *self,
                            gint64 id);
RawDeveloper* raw_developer_as_array (gint* result_length1);
static void photo_row_finalize (PhotoRow * obj);
static GType photo_row_get_type_once (void);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
GType photo_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoTable, database_table_unref)
static PhotoTable* photo_table_new (void);
static PhotoTable* photo_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_fatal (const gchar* op,
                           gint res);
void database_table_warning (const gchar* op,
                             gint res);
void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
PhotoTable* photo_table_get_instance (void);
void photo_table_add (PhotoTable* self,
                      PhotoRow* photo_row,
                      PhotoID* result);
gulong now_sec (void);
GType photo_file_format_get_type (void) G_GNUC_CONST ;
GType dimensions_get_type (void) G_GNUC_CONST ;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
#define EVENT_ID_INVALID ((gint64) -1)
gint photo_file_format_serialize (PhotoFileFormat self);
gint rating_serialize (Rating self);
gchar* raw_developer_to_string (RawDeveloper self);
void event_id_init (EventID *self,
                    gint64 id);
GQuark database_error_quark (void);
void photo_table_reimport (PhotoTable* self,
                           PhotoRow* row,
                           GError** error);
void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
gboolean photo_table_master_exif_updated (PhotoTable* self,
                                          PhotoID* photoID,
                                          gint64 filesize,
                                          glong timestamp,
                                          const gchar* md5,
                                          const gchar* exif_md5,
                                          const gchar* thumbnail_md5,
                                          PhotoRow* row);
static void photo_table_validate_orientation (PhotoTable* self,
                                       PhotoRow* row);
gboolean photo_table_set_orientation (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation);
PhotoRow* photo_table_get_row (PhotoTable* self,
                               PhotoID* photo_id);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
GeeHashMap* photo_table_marshall_all_transformations (const gchar* trans);
Rating rating_unserialize (gint value);
PhotoFileFormat photo_file_format_unserialize (gint value);
RawDeveloper raw_developer_from_string (const gchar* value);
GeeArrayList* photo_table_get_all (PhotoTable* self);
void photo_table_duplicate (PhotoTable* self,
                            PhotoID* photo_id,
                            const gchar* new_filename,
                            BackingPhotoID* editable_id,
                            BackingPhotoID* develop_shotwell,
                            BackingPhotoID* develop_camera_id,
                            BackingPhotoID* develop_embedded_id,
                            PhotoID* result);
gchar* photo_table_unmarshall_all_transformations (GeeHashMap* transformations);
gboolean photo_table_set_title (PhotoTable* self,
                                PhotoID* photo_id,
                                const gchar* new_title);
gboolean database_table_update_text_by_id (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           const gchar* text);
void photo_table_set_gps_coords (PhotoTable* self,
                                 PhotoID* photo_id,
                                 GpsCoords* new_gps_coords,
                                 GError** error);
void database_table_update_int_by_id_2 (DatabaseTable* self,
                                        gint64 id,
                                        const gchar* column,
                                        gint value,
                                        GError** error);
void database_table_update_double_by_id_2 (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           gdouble value,
                                           GError** error);
gboolean photo_table_set_comment (PhotoTable* self,
                                  PhotoID* photo_id,
                                  const gchar* new_comment);
void photo_table_set_filepath (PhotoTable* self,
                               PhotoID* photo_id,
                               const gchar* filepath,
                               GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
void photo_table_update_timestamp (PhotoTable* self,
                                   PhotoID* photo_id,
                                   time_t timestamp,
                                   GError** error);
void database_table_update_int64_by_id_2 (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint64 value,
                                          GError** error);
gboolean photo_table_set_exposure_time (PhotoTable* self,
                                        PhotoID* photo_id,
                                        time_t time);
gboolean database_table_update_int64_by_id (DatabaseTable* self,
                                            gint64 id,
                                            const gchar* column,
                                            gint64 value);
void photo_table_set_import_id (PhotoTable* self,
                                PhotoID* photo_id,
                                ImportID* import_id,
                                GError** error);
gboolean photo_table_remove_by_file (PhotoTable* self,
                                     GFile* file);
void photo_table_remove (PhotoTable* self,
                         PhotoID* photo_id,
                         GError** error);
void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
GeeArrayList* photo_table_get_photos (PhotoTable* self);
gboolean database_table_update_int_by_id (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint value);
gboolean photo_table_replace_flags (PhotoTable* self,
                                    PhotoID* photo_id,
                                    guint64 flags);
gboolean photo_table_set_rating (PhotoTable* self,
                                 PhotoID* photo_id,
                                 Rating rating);
gint photo_table_get_event_photo_count (PhotoTable* self,
                                        EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self,
                                                EventID* event_id);
gboolean photo_table_event_has_photos (PhotoTable* self,
                                       EventID* event_id);
gboolean photo_table_drop_event (PhotoTable* self,
                                 EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self,
                                PhotoID* photo_id,
                                EventID* event_id);
static gchar* photo_table_get_raw_transformations (PhotoTable* self,
                                            PhotoID* photo_id);
gboolean database_table_select_by_id (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* columns,
                                      sqlite3_stmt** stmt);
static gboolean photo_table_set_raw_transformations (PhotoTable* self,
                                              PhotoID* photo_id,
                                              const gchar* trans);
gboolean photo_table_set_transformation_state (PhotoTable* self,
                                               PhotoID* photo_id,
                                               Orientation orientation,
                                               GeeHashMap* transformations);
gboolean photo_table_set_transformation (PhotoTable* self,
                                         PhotoID* photo_id,
                                         KeyValueMap* map);
gboolean photo_table_remove_transformation (PhotoTable* self,
                                            PhotoID* photo_id,
                                            const gchar* object);
gboolean photo_table_remove_all_transformations (PhotoTable* self,
                                                 PhotoID* photo_id);
static sqlite3_stmt* photo_table_get_duplicate_stmt (PhotoTable* self,
                                              GFile* file,
                                              const gchar* thumbnail_md5,
                                              const gchar* md5,
                                              PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self,
                                    GFile* file,
                                    const gchar* thumbnail_md5,
                                    const gchar* md5,
                                    PhotoFileFormat file_format);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self,
                                        GFile* file,
                                        const gchar* thumbnail_md5,
                                        const gchar* md5,
                                        PhotoFileFormat file_format,
                                        gint* result_length1);
static void _vala_array_add2 (PhotoID* * array,
                       gint* length,
                       gint* size,
                       const PhotoID* value);
void photo_table_update_backlinks (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* backlinks,
                                   GError** error);
void photo_table_attach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  BackingPhotoID* editable_id,
                                  GError** error);
void photo_table_detach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self,
                                     PhotoID* photo_id,
                                     gboolean dirty,
                                     GError** error);
void photo_table_update_raw_development (PhotoTable* self,
                                         PhotoRow* row,
                                         RawDeveloper rd,
                                         BackingPhotoID* backing_photo_id,
                                         GError** error);
void photo_table_remove_development (PhotoTable* self,
                                     PhotoRow* row,
                                     RawDeveloper rd,
                                     GError** error);
static void photo_table_finalize (DatabaseTable * obj);
static GType photo_table_get_type_once (void);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                              GFileInfo* info);
gboolean backing_photo_row_is_touched (BackingPhotoRow* self,
                                       GFileInfo* info);
void backing_photo_row_copy_from (BackingPhotoRow* self,
                                  BackingPhotoRow* from);
static void backing_photo_row_finalize (BackingPhotoRow * obj);
static GType backing_photo_row_get_type_once (void);
GType backing_photo_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingPhotoTable, database_table_unref)
static BackingPhotoTable* backing_photo_table_new (void);
static BackingPhotoTable* backing_photo_table_construct (GType object_type);
BackingPhotoTable* backing_photo_table_get_instance (void);
void backing_photo_table_add (BackingPhotoTable* self,
                              BackingPhotoRow* state,
                              GError** error);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            GError** error);
void backing_photo_table_update (BackingPhotoTable* self,
                                 BackingPhotoRow* row,
                                 GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            time_t timestamp,
                                            gint64 filesize,
                                            GError** error);
void backing_photo_table_remove (BackingPhotoTable* self,
                                 BackingPhotoID* backing_id,
                                 GError** error);
void backing_photo_table_set_filepath (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       const gchar* filepath,
                                       GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                           BackingPhotoID* id,
                                           time_t timestamp,
                                           GError** error);
static void backing_photo_table_finalize (DatabaseTable * obj);
static GType backing_photo_table_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

void
photo_id_init (PhotoID *self,
               gint64 id)
{
#line 12 "../src/db/PhotoTable.vala"
	memset (self, 0, sizeof (PhotoID));
#line 13 "../src/db/PhotoTable.vala"
	(*self).id = id;
#line 657 "PhotoTable.c"
}

gboolean
photo_id_is_invalid (PhotoID *self)
{
	gboolean result = FALSE;
#line 17 "../src/db/PhotoTable.vala"
	result = (*self).id == PHOTO_ID_INVALID;
#line 17 "../src/db/PhotoTable.vala"
	return result;
#line 668 "PhotoTable.c"
}

gboolean
photo_id_is_valid (PhotoID *self)
{
	gboolean result = FALSE;
#line 21 "../src/db/PhotoTable.vala"
	result = (*self).id != PHOTO_ID_INVALID;
#line 21 "../src/db/PhotoTable.vala"
	return result;
#line 679 "PhotoTable.c"
}

guint
photo_id_hash (PhotoID *self)
{
	guint result = 0U;
#line 25 "../src/db/PhotoTable.vala"
	result = int64_hash (&(*self).id);
#line 25 "../src/db/PhotoTable.vala"
	return result;
#line 690 "PhotoTable.c"
}

gboolean
photo_id_equal (void* a,
                void* b)
{
	gboolean result = FALSE;
#line 29 "../src/db/PhotoTable.vala"
	result = (*((PhotoID*) a)).id == (*((PhotoID*) b)).id;
#line 29 "../src/db/PhotoTable.vala"
	return result;
#line 702 "PhotoTable.c"
}

gchar*
photo_id_upgrade_photo_id_to_source_id (PhotoID* photo_id)
{
	PhotoID _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 32 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 33 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 33 "../src/db/PhotoTable.vala"
	_tmp1_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", PHOTO_TYPENAME, _tmp0_.id);
#line 33 "../src/db/PhotoTable.vala"
	result = _tmp1_;
#line 33 "../src/db/PhotoTable.vala"
	return result;
#line 721 "PhotoTable.c"
}

PhotoID*
photo_id_dup (const PhotoID* self)
{
	PhotoID* dup;
#line 7 "../src/db/PhotoTable.vala"
	dup = g_new0 (PhotoID, 1);
#line 7 "../src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (PhotoID));
#line 7 "../src/db/PhotoTable.vala"
	return dup;
#line 734 "PhotoTable.c"
}

void
photo_id_free (PhotoID* self)
{
#line 7 "../src/db/PhotoTable.vala"
	g_free (self);
#line 742 "PhotoTable.c"
}

static GType
photo_id_get_type_once (void)
{
	GType photo_id_type_id;
	photo_id_type_id = g_boxed_type_register_static ("PhotoID", (GBoxedCopyFunc) photo_id_dup, (GBoxedFreeFunc) photo_id_free);
	return photo_id_type_id;
}

GType
photo_id_get_type (void)
{
	static volatile gsize photo_id_type_id__volatile = 0;
	if (g_once_init_enter (&photo_id_type_id__volatile)) {
		GType photo_id_type_id;
		photo_id_type_id = photo_id_get_type_once ();
		g_once_init_leave (&photo_id_type_id__volatile, photo_id_type_id);
	}
	return photo_id_type_id__volatile;
}

void
import_id_init (ImportID *self,
                gint64 id)
{
#line 42 "../src/db/PhotoTable.vala"
	memset (self, 0, sizeof (ImportID));
#line 43 "../src/db/PhotoTable.vala"
	(*self).id = id;
#line 773 "PhotoTable.c"
}

void
import_id_generate (ImportID* result)
{
	gint64 id = 0LL;
	ImportID _tmp0_ = {0};
#line 47 "../src/db/PhotoTable.vala"
	id = g_get_real_time () / UTIL_USEC_PER_SEC;
#line 49 "../src/db/PhotoTable.vala"
	import_id_init (&_tmp0_, id);
#line 49 "../src/db/PhotoTable.vala"
	*result = _tmp0_;
#line 49 "../src/db/PhotoTable.vala"
	return;
#line 789 "PhotoTable.c"
}

gboolean
import_id_is_invalid (ImportID *self)
{
	gboolean result = FALSE;
#line 53 "../src/db/PhotoTable.vala"
	result = (*self).id == IMPORT_ID_INVALID;
#line 53 "../src/db/PhotoTable.vala"
	return result;
#line 800 "PhotoTable.c"
}

gboolean
import_id_is_valid (ImportID *self)
{
	gboolean result = FALSE;
#line 57 "../src/db/PhotoTable.vala"
	result = (*self).id != IMPORT_ID_INVALID;
#line 57 "../src/db/PhotoTable.vala"
	return result;
#line 811 "PhotoTable.c"
}

gint
import_id_compare_func (ImportID* a,
                        ImportID* b)
{
	gboolean _tmp0_ = FALSE;
	gint result = 0;
#line 61 "../src/db/PhotoTable.vala"
	if (a != NULL) {
#line 61 "../src/db/PhotoTable.vala"
		_tmp0_ = b != NULL;
#line 824 "PhotoTable.c"
	} else {
#line 61 "../src/db/PhotoTable.vala"
		_tmp0_ = FALSE;
#line 828 "PhotoTable.c"
	}
#line 61 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp0_, "a != null && b != null");
#line 62 "../src/db/PhotoTable.vala"
	result = (gint) ((*a).id - (*b).id);
#line 62 "../src/db/PhotoTable.vala"
	return result;
#line 836 "PhotoTable.c"
}

gint64
import_id_comparator (void* a,
                      void* b)
{
	gint64 result = 0LL;
#line 66 "../src/db/PhotoTable.vala"
	result = (*((ImportID*) a)).id - (*((ImportID*) b)).id;
#line 66 "../src/db/PhotoTable.vala"
	return result;
#line 848 "PhotoTable.c"
}

ImportID*
import_id_dup (const ImportID* self)
{
	ImportID* dup;
#line 37 "../src/db/PhotoTable.vala"
	dup = g_new0 (ImportID, 1);
#line 37 "../src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (ImportID));
#line 37 "../src/db/PhotoTable.vala"
	return dup;
#line 861 "PhotoTable.c"
}

void
import_id_free (ImportID* self)
{
#line 37 "../src/db/PhotoTable.vala"
	g_free (self);
#line 869 "PhotoTable.c"
}

static GType
import_id_get_type_once (void)
{
	GType import_id_type_id;
	import_id_type_id = g_boxed_type_register_static ("ImportID", (GBoxedCopyFunc) import_id_dup, (GBoxedFreeFunc) import_id_free);
	return import_id_type_id;
}

GType
import_id_get_type (void)
{
	static volatile gsize import_id_type_id__volatile = 0;
	if (g_once_init_enter (&import_id_type_id__volatile)) {
		GType import_id_type_id;
		import_id_type_id = import_id_get_type_once ();
		g_once_init_leave (&import_id_type_id__volatile, import_id_type_id);
	}
	return import_id_type_id__volatile;
}

PhotoRow*
photo_row_construct (GType object_type)
{
	PhotoRow* self = NULL;
	BackingPhotoRow* _tmp0_;
	gint _tmp1_ = 0;
	RawDeveloper* _tmp2_;
	RawDeveloper* _tmp3_;
	gint _tmp3__length1;
	BackingPhotoID* _tmp4_;
	gint _tmp5_ = 0;
	RawDeveloper* _tmp6_;
	gint _tmp9_ = 0;
	RawDeveloper* _tmp10_;
	RawDeveloper* _tmp11_;
	gint _tmp11__length1;
	BackingPhotoID* _tmp12_;
	gint _tmp13_ = 0;
	RawDeveloper* _tmp14_;
#line 99 "../src/db/PhotoTable.vala"
	self = (PhotoRow*) g_type_create_instance (object_type);
#line 100 "../src/db/PhotoTable.vala"
	_tmp0_ = backing_photo_row_new ();
#line 100 "../src/db/PhotoTable.vala"
	_backing_photo_row_unref0 (self->master);
#line 100 "../src/db/PhotoTable.vala"
	self->master = _tmp0_;
#line 101 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&self->editable_id, BACKING_PHOTO_ID_INVALID);
#line 102 "../src/db/PhotoTable.vala"
	_tmp2_ = raw_developer_as_array (&_tmp1_);
#line 102 "../src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_;
#line 102 "../src/db/PhotoTable.vala"
	_tmp3__length1 = _tmp1_;
#line 102 "../src/db/PhotoTable.vala"
	_tmp4_ = g_new0 (BackingPhotoID, _tmp1_);
#line 102 "../src/db/PhotoTable.vala"
	self->development_ids = (g_free (self->development_ids), NULL);
#line 102 "../src/db/PhotoTable.vala"
	self->development_ids = _tmp4_;
#line 102 "../src/db/PhotoTable.vala"
	self->development_ids_length1 = _tmp1_;
#line 102 "../src/db/PhotoTable.vala"
	_tmp3_ = (g_free (_tmp3_), NULL);
#line 103 "../src/db/PhotoTable.vala"
	_tmp6_ = raw_developer_as_array (&_tmp5_);
#line 939 "PhotoTable.c"
	{
		RawDeveloper* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
#line 103 "../src/db/PhotoTable.vala"
		d_collection = _tmp6_;
#line 103 "../src/db/PhotoTable.vala"
		d_collection_length1 = _tmp5_;
#line 103 "../src/db/PhotoTable.vala"
		for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 951 "PhotoTable.c"
			RawDeveloper d = 0;
#line 103 "../src/db/PhotoTable.vala"
			d = d_collection[d_it];
#line 955 "PhotoTable.c"
			{
				BackingPhotoID* _tmp7_;
				gint _tmp7__length1;
				BackingPhotoID _tmp8_ = {0};
#line 104 "../src/db/PhotoTable.vala"
				_tmp7_ = self->development_ids;
#line 104 "../src/db/PhotoTable.vala"
				_tmp7__length1 = self->development_ids_length1;
#line 104 "../src/db/PhotoTable.vala"
				backing_photo_id_init (&_tmp8_, BACKING_PHOTO_ID_INVALID);
#line 104 "../src/db/PhotoTable.vala"
				_tmp7_[d] = _tmp8_;
#line 968 "PhotoTable.c"
			}
		}
#line 103 "../src/db/PhotoTable.vala"
		d_collection = (g_free (d_collection), NULL);
#line 973 "PhotoTable.c"
	}
#line 105 "../src/db/PhotoTable.vala"
	memset (&self->gps_coords, 0, sizeof (GpsCoords));
#line 106 "../src/db/PhotoTable.vala"
	_tmp10_ = raw_developer_as_array (&_tmp9_);
#line 106 "../src/db/PhotoTable.vala"
	_tmp11_ = _tmp10_;
#line 106 "../src/db/PhotoTable.vala"
	_tmp11__length1 = _tmp9_;
#line 106 "../src/db/PhotoTable.vala"
	_tmp12_ = g_new0 (BackingPhotoID, _tmp9_);
#line 106 "../src/db/PhotoTable.vala"
	self->development_ids = (g_free (self->development_ids), NULL);
#line 106 "../src/db/PhotoTable.vala"
	self->development_ids = _tmp12_;
#line 106 "../src/db/PhotoTable.vala"
	self->development_ids_length1 = _tmp9_;
#line 106 "../src/db/PhotoTable.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 107 "../src/db/PhotoTable.vala"
	_tmp14_ = raw_developer_as_array (&_tmp13_);
#line 995 "PhotoTable.c"
	{
		RawDeveloper* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
#line 107 "../src/db/PhotoTable.vala"
		d_collection = _tmp14_;
#line 107 "../src/db/PhotoTable.vala"
		d_collection_length1 = _tmp13_;
#line 107 "../src/db/PhotoTable.vala"
		for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 1007 "PhotoTable.c"
			RawDeveloper d = 0;
#line 107 "../src/db/PhotoTable.vala"
			d = d_collection[d_it];
#line 1011 "PhotoTable.c"
			{
				BackingPhotoID* _tmp15_;
				gint _tmp15__length1;
				BackingPhotoID _tmp16_ = {0};
#line 108 "../src/db/PhotoTable.vala"
				_tmp15_ = self->development_ids;
#line 108 "../src/db/PhotoTable.vala"
				_tmp15__length1 = self->development_ids_length1;
#line 108 "../src/db/PhotoTable.vala"
				backing_photo_id_init (&_tmp16_, BACKING_PHOTO_ID_INVALID);
#line 108 "../src/db/PhotoTable.vala"
				_tmp15_[d] = _tmp16_;
#line 1024 "PhotoTable.c"
			}
		}
#line 107 "../src/db/PhotoTable.vala"
		d_collection = (g_free (d_collection), NULL);
#line 1029 "PhotoTable.c"
	}
#line 99 "../src/db/PhotoTable.vala"
	return self;
#line 1033 "PhotoTable.c"
}

PhotoRow*
photo_row_new (void)
{
#line 99 "../src/db/PhotoTable.vala"
	return photo_row_construct (TYPE_PHOTO_ROW);
#line 1041 "PhotoTable.c"
}

static void
value_photo_row_init (GValue* value)
{
#line 70 "../src/db/PhotoTable.vala"
	value->data[0].v_pointer = NULL;
#line 1049 "PhotoTable.c"
}

static void
value_photo_row_free_value (GValue* value)
{
#line 70 "../src/db/PhotoTable.vala"
	if (value->data[0].v_pointer) {
#line 70 "../src/db/PhotoTable.vala"
		photo_row_unref (value->data[0].v_pointer);
#line 1059 "PhotoTable.c"
	}
}

static void
value_photo_row_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 70 "../src/db/PhotoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 70 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = photo_row_ref (src_value->data[0].v_pointer);
#line 1071 "PhotoTable.c"
	} else {
#line 70 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1075 "PhotoTable.c"
	}
}

static gpointer
value_photo_row_peek_pointer (const GValue* value)
{
#line 70 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 1084 "PhotoTable.c"
}

static gchar*
value_photo_row_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 70 "../src/db/PhotoTable.vala"
	if (collect_values[0].v_pointer) {
#line 1095 "PhotoTable.c"
		PhotoRow * object;
		object = collect_values[0].v_pointer;
#line 70 "../src/db/PhotoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 70 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1102 "PhotoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 70 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1106 "PhotoTable.c"
		}
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = photo_row_ref (object);
#line 1110 "PhotoTable.c"
	} else {
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 1114 "PhotoTable.c"
	}
#line 70 "../src/db/PhotoTable.vala"
	return NULL;
#line 1118 "PhotoTable.c"
}

static gchar*
value_photo_row_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	PhotoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 70 "../src/db/PhotoTable.vala"
	if (!object_p) {
#line 70 "../src/db/PhotoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1133 "PhotoTable.c"
	}
#line 70 "../src/db/PhotoTable.vala"
	if (!value->data[0].v_pointer) {
#line 70 "../src/db/PhotoTable.vala"
		*object_p = NULL;
#line 1139 "PhotoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 70 "../src/db/PhotoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 1143 "PhotoTable.c"
	} else {
#line 70 "../src/db/PhotoTable.vala"
		*object_p = photo_row_ref (value->data[0].v_pointer);
#line 1147 "PhotoTable.c"
	}
#line 70 "../src/db/PhotoTable.vala"
	return NULL;
#line 1151 "PhotoTable.c"
}

GParamSpec*
param_spec_photo_row (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	ParamSpecPhotoRow* spec;
#line 70 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_ROW), NULL);
#line 70 "../src/db/PhotoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 70 "../src/db/PhotoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 70 "../src/db/PhotoTable.vala"
	return G_PARAM_SPEC (spec);
#line 1170 "PhotoTable.c"
}

gpointer
value_get_photo_row (const GValue* value)
{
#line 70 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW), NULL);
#line 70 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 1180 "PhotoTable.c"
}

void
value_set_photo_row (GValue* value,
                     gpointer v_object)
{
	PhotoRow * old;
#line 70 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW));
#line 70 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 70 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 70 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_ROW));
#line 70 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 70 "../src/db/PhotoTable.vala"
		photo_row_ref (value->data[0].v_pointer);
#line 1202 "PhotoTable.c"
	} else {
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 1206 "PhotoTable.c"
	}
#line 70 "../src/db/PhotoTable.vala"
	if (old) {
#line 70 "../src/db/PhotoTable.vala"
		photo_row_unref (old);
#line 1212 "PhotoTable.c"
	}
}

void
value_take_photo_row (GValue* value,
                      gpointer v_object)
{
	PhotoRow * old;
#line 70 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW));
#line 70 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 70 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 70 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_ROW));
#line 70 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 1233 "PhotoTable.c"
	} else {
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 1237 "PhotoTable.c"
	}
#line 70 "../src/db/PhotoTable.vala"
	if (old) {
#line 70 "../src/db/PhotoTable.vala"
		photo_row_unref (old);
#line 1243 "PhotoTable.c"
	}
}

static void
photo_row_class_init (PhotoRowClass * klass,
                      gpointer klass_data)
{
#line 70 "../src/db/PhotoTable.vala"
	photo_row_parent_class = g_type_class_peek_parent (klass);
#line 70 "../src/db/PhotoTable.vala"
	((PhotoRowClass *) klass)->finalize = photo_row_finalize;
#line 1255 "PhotoTable.c"
}

static void
photo_row_instance_init (PhotoRow * self,
                         gpointer klass)
{
#line 70 "../src/db/PhotoTable.vala"
	self->ref_count = 1;
#line 1264 "PhotoTable.c"
}

static void
photo_row_finalize (PhotoRow * obj)
{
	PhotoRow * self;
#line 70 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_ROW, PhotoRow);
#line 70 "../src/db/PhotoTable.vala"
	g_signal_handlers_destroy (self);
#line 72 "../src/db/PhotoTable.vala"
	_backing_photo_row_unref0 (self->master);
#line 77 "../src/db/PhotoTable.vala"
	_g_object_unref0 (self->transformations);
#line 78 "../src/db/PhotoTable.vala"
	_g_free0 (self->md5);
#line 79 "../src/db/PhotoTable.vala"
	_g_free0 (self->thumbnail_md5);
#line 80 "../src/db/PhotoTable.vala"
	_g_free0 (self->exif_md5);
#line 84 "../src/db/PhotoTable.vala"
	_g_free0 (self->title);
#line 86 "../src/db/PhotoTable.vala"
	_g_free0 (self->comment);
#line 87 "../src/db/PhotoTable.vala"
	_g_free0 (self->backlinks);
#line 96 "../src/db/PhotoTable.vala"
	self->development_ids = (g_free (self->development_ids), NULL);
#line 1293 "PhotoTable.c"
}

static GType
photo_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_photo_row_init, value_photo_row_free_value, value_photo_row_copy_value, value_photo_row_peek_pointer, "p", value_photo_row_collect_value, "p", value_photo_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoRow), 0, (GInstanceInitFunc) photo_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_row_type_id;
	photo_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_row_type_id;
}

GType
photo_row_get_type (void)
{
	static volatile gsize photo_row_type_id__volatile = 0;
	if (g_once_init_enter (&photo_row_type_id__volatile)) {
		GType photo_row_type_id;
		photo_row_type_id = photo_row_get_type_once ();
		g_once_init_leave (&photo_row_type_id__volatile, photo_row_type_id);
	}
	return photo_row_type_id__volatile;
}

gpointer
photo_row_ref (gpointer instance)
{
	PhotoRow * self;
	self = instance;
#line 70 "../src/db/PhotoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 70 "../src/db/PhotoTable.vala"
	return instance;
#line 1328 "PhotoTable.c"
}

void
photo_row_unref (gpointer instance)
{
	PhotoRow * self;
	self = instance;
#line 70 "../src/db/PhotoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 70 "../src/db/PhotoTable.vala"
		PHOTO_ROW_GET_CLASS (self)->finalize (self);
#line 70 "../src/db/PhotoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1342 "PhotoTable.c"
	}
}

static PhotoTable*
photo_table_construct (GType object_type)
{
	PhotoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* stmt2 = NULL;
	gint res2 = 0;
	sqlite3* _tmp4_;
	sqlite3_stmt* _tmp5_ = NULL;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3* _tmp8_;
	sqlite3_stmt* _tmp9_ = NULL;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_;
	sqlite3* _tmp12_;
	sqlite3_stmt* _tmp13_ = NULL;
	gint _tmp14_;
	sqlite3_stmt* _tmp15_;
	sqlite3* _tmp16_;
	sqlite3_stmt* _tmp17_ = NULL;
	gint _tmp18_;
	sqlite3_stmt* _tmp19_;
	sqlite3* _tmp20_;
	sqlite3_stmt* _tmp21_ = NULL;
	gint _tmp22_;
	sqlite3_stmt* _tmp23_;
#line 115 "../src/db/PhotoTable.vala"
	self = (PhotoTable*) database_table_construct (object_type);
#line 117 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 117 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS PhotoTable (" "id INTEGER PRIMARY KEY, " "filename TEXT UNIQUE NOT NULL, " "width INTEGER, " "height INTEGER, " "filesize INTEGER, " "timestamp INTEGER, " "exposure_time INTEGER, " "orientation INTEGER, " "original_orientation INTEGER, " "import_id INTEGER, " "event_id INTEGER, " "transformations TEXT, " "md5 TEXT, " "thumbnail_md5 TEXT, " "exif_md5 TEXT, " "time_created INTEGER, " "flags INTEGER DEFAULT 0, " "rating INTEGER DEFAULT 0, " "file_format INTEGER DEFAULT 0, " "title TEXT, " "backlinks TEXT, " "time_reimported INTEGER, " "editable_id INTEGER DEFAULT -1, " "metadata_dirty INTEGER DEFAULT 0, " "developer TEXT, " "develop_shotwell_id INTEGER DEFAULT -1, " "develop_camera_id INTEGER DEFAULT -1, " "develop_embedded_id INTEGER DEFAULT -1, " "has_gps INTEGER DEFAULT -1, " "gps_lat REAL, " "gps_lon REAL, " "comment TEXT" ")", -1, &_tmp1_, NULL);
#line 117 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 117 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 117 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 151 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 153 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 153 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 154 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 155 "../src/db/PhotoTable.vala"
		database_table_fatal ("create photo table", res);
#line 1400 "PhotoTable.c"
	}
#line 159 "../src/db/PhotoTable.vala"
	_tmp4_ = database_table_db;
#line 159 "../src/db/PhotoTable.vala"
	_tmp6_ = sqlite3_prepare_v2 (_tmp4_, "CREATE INDEX IF NOT EXISTS PhotoEventIDIndex ON PhotoTable (event_id)", -1, &_tmp5_, NULL);
#line 159 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 159 "../src/db/PhotoTable.vala"
	stmt2 = _tmp5_;
#line 159 "../src/db/PhotoTable.vala"
	res2 = _tmp6_;
#line 161 "../src/db/PhotoTable.vala"
	_vala_assert (res2 == SQLITE_OK, "res2 == Sqlite.OK");
#line 163 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt2;
#line 163 "../src/db/PhotoTable.vala"
	res2 = sqlite3_step (_tmp7_);
#line 164 "../src/db/PhotoTable.vala"
	if (res2 != SQLITE_DONE) {
#line 165 "../src/db/PhotoTable.vala"
		database_table_fatal ("create photo table", res2);
#line 1422 "PhotoTable.c"
	}
#line 171 "../src/db/PhotoTable.vala"
	_tmp8_ = database_table_db;
#line 171 "../src/db/PhotoTable.vala"
	_tmp10_ = sqlite3_prepare_v2 (_tmp8_, "DROP INDEX IF EXISTS PhotoTableMD5Format", -1, &_tmp9_, NULL);
#line 171 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 171 "../src/db/PhotoTable.vala"
	stmt = _tmp9_;
#line 171 "../src/db/PhotoTable.vala"
	res = _tmp10_;
#line 172 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 173 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 173 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp11_);
#line 174 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 175 "../src/db/PhotoTable.vala"
		database_table_warning ("Failed to drop old PhotoTable index", res);
#line 1444 "PhotoTable.c"
	}
#line 178 "../src/db/PhotoTable.vala"
	_tmp12_ = database_table_db;
#line 178 "../src/db/PhotoTable.vala"
	_tmp14_ = sqlite3_prepare_v2 (_tmp12_, "CREATE INDEX IF NOT EXISTS PhotoTableMD5FormatV2 on PhotoTable(md5, fi" \
"le_format)", -1, &_tmp13_, NULL);
#line 178 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 178 "../src/db/PhotoTable.vala"
	stmt = _tmp13_;
#line 178 "../src/db/PhotoTable.vala"
	res = _tmp14_;
#line 179 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 180 "../src/db/PhotoTable.vala"
	_tmp15_ = stmt;
#line 180 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp15_);
#line 181 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 182 "../src/db/PhotoTable.vala"
		database_table_warning ("Failed to create index on md5 and file_format", res);
#line 1466 "PhotoTable.c"
	}
#line 186 "../src/db/PhotoTable.vala"
	_tmp16_ = database_table_db;
#line 186 "../src/db/PhotoTable.vala"
	_tmp18_ = sqlite3_prepare_v2 (_tmp16_, "CREATE INDEX IF NOT EXISTS PhotoTableThumbnailMD5Format on PhotoTable(" \
"thumbnail_md5, file_format)", -1, &_tmp17_, NULL);
#line 186 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 186 "../src/db/PhotoTable.vala"
	stmt = _tmp17_;
#line 186 "../src/db/PhotoTable.vala"
	res = _tmp18_;
#line 187 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 188 "../src/db/PhotoTable.vala"
	_tmp19_ = stmt;
#line 188 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp19_);
#line 189 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 190 "../src/db/PhotoTable.vala"
		database_table_warning ("Failed to create index on md5 and file_format", res);
#line 1488 "PhotoTable.c"
	}
#line 194 "../src/db/PhotoTable.vala"
	_tmp20_ = database_table_db;
#line 194 "../src/db/PhotoTable.vala"
	_tmp22_ = sqlite3_prepare_v2 (_tmp20_, "CREATE INDEX IF NOT EXISTS PhotoTableThumbnailMD5MD5 on PhotoTable(thu" \
"mbnail_md5, md5)", -1, &_tmp21_, NULL);
#line 194 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 194 "../src/db/PhotoTable.vala"
	stmt = _tmp21_;
#line 194 "../src/db/PhotoTable.vala"
	res = _tmp22_;
#line 195 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 196 "../src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 196 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp23_);
#line 197 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 198 "../src/db/PhotoTable.vala"
		database_table_warning ("Failed to create index on thumbnail_md5 and md5", res);
#line 1510 "PhotoTable.c"
	}
#line 201 "../src/db/PhotoTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "PhotoTable");
#line 115 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 115 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 115 "../src/db/PhotoTable.vala"
	return self;
#line 1520 "PhotoTable.c"
}

static PhotoTable*
photo_table_new (void)
{
#line 115 "../src/db/PhotoTable.vala"
	return photo_table_construct (TYPE_PHOTO_TABLE);
#line 1528 "PhotoTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 208 "../src/db/PhotoTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 1536 "PhotoTable.c"
}

PhotoTable*
photo_table_get_instance (void)
{
	PhotoTable* _tmp0_;
	PhotoTable* _tmp2_;
	PhotoTable* _tmp3_;
	PhotoTable* result = NULL;
#line 205 "../src/db/PhotoTable.vala"
	_tmp0_ = photo_table_instance;
#line 205 "../src/db/PhotoTable.vala"
	if (_tmp0_ == NULL) {
#line 1550 "PhotoTable.c"
		PhotoTable* _tmp1_;
#line 206 "../src/db/PhotoTable.vala"
		_tmp1_ = photo_table_new ();
#line 206 "../src/db/PhotoTable.vala"
		_database_table_unref0 (photo_table_instance);
#line 206 "../src/db/PhotoTable.vala"
		photo_table_instance = _tmp1_;
#line 1558 "PhotoTable.c"
	}
#line 208 "../src/db/PhotoTable.vala"
	_tmp2_ = photo_table_instance;
#line 208 "../src/db/PhotoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 208 "../src/db/PhotoTable.vala"
	result = _tmp3_;
#line 208 "../src/db/PhotoTable.vala"
	return result;
#line 1568 "PhotoTable.c"
}

void
photo_table_add (PhotoTable* self,
                 PhotoRow* photo_row,
                 PhotoID* result)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gulong time_created = 0UL;
	sqlite3_stmt* _tmp3_;
	BackingPhotoRow* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GDestroyNotify _tmp7_;
	sqlite3_stmt* _tmp8_;
	BackingPhotoRow* _tmp9_;
	Dimensions _tmp10_;
	sqlite3_stmt* _tmp11_;
	BackingPhotoRow* _tmp12_;
	Dimensions _tmp13_;
	sqlite3_stmt* _tmp14_;
	BackingPhotoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	BackingPhotoRow* _tmp17_;
	sqlite3_stmt* _tmp18_;
	sqlite3_stmt* _tmp19_;
	BackingPhotoRow* _tmp20_;
	sqlite3_stmt* _tmp21_;
	BackingPhotoRow* _tmp22_;
	sqlite3_stmt* _tmp23_;
	ImportID _tmp24_;
	sqlite3_stmt* _tmp25_;
	sqlite3_stmt* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	GDestroyNotify _tmp29_;
	sqlite3_stmt* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	GDestroyNotify _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	GDestroyNotify _tmp37_;
	sqlite3_stmt* _tmp38_;
	sqlite3_stmt* _tmp39_;
	BackingPhotoRow* _tmp40_;
	sqlite3_stmt* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	GDestroyNotify _tmp44_;
	sqlite3_stmt* _tmp45_;
	sqlite3_stmt* _tmp46_;
	sqlite3_stmt* _tmp47_;
	gchar* _tmp48_;
	GDestroyNotify _tmp49_;
	sqlite3_stmt* _tmp50_;
	GpsCoords _tmp51_;
	sqlite3_stmt* _tmp52_;
	GpsCoords _tmp53_;
	sqlite3_stmt* _tmp54_;
	GpsCoords _tmp55_;
	sqlite3_stmt* _tmp56_;
	const gchar* _tmp57_;
	gchar* _tmp58_;
	GDestroyNotify _tmp59_;
	sqlite3_stmt* _tmp60_;
	sqlite3* _tmp62_;
	BackingPhotoRow* _tmp63_;
	PhotoID _tmp64_;
#line 213 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 213 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (photo_row));
#line 215 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 215 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO PhotoTable (filename, width, height, filesize, timestamp, " \
"exposure_time, " "orientation, original_orientation, import_id, event_id, md5, thumbnail" \
"_md5, " "exif_md5, time_created, file_format, title, rating, editable_id, devel" \
"oper, has_gps, gps_lat, gps_lon, comment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?," \
" ?, ?)", -1, &_tmp1_, NULL);
#line 215 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 215 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 215 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 221 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 223 "../src/db/PhotoTable.vala"
	time_created = now_sec ();
#line 225 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 225 "../src/db/PhotoTable.vala"
	_tmp4_ = photo_row->master;
#line 225 "../src/db/PhotoTable.vala"
	_tmp5_ = _tmp4_->filepath;
#line 225 "../src/db/PhotoTable.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 225 "../src/db/PhotoTable.vala"
	_tmp7_ = g_free;
#line 225 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp6_, -1, _tmp7_);
#line 226 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 227 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 227 "../src/db/PhotoTable.vala"
	_tmp9_ = photo_row->master;
#line 227 "../src/db/PhotoTable.vala"
	_tmp10_ = _tmp9_->dim;
#line 227 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp8_, 2, _tmp10_.width);
#line 228 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 229 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 229 "../src/db/PhotoTable.vala"
	_tmp12_ = photo_row->master;
#line 229 "../src/db/PhotoTable.vala"
	_tmp13_ = _tmp12_->dim;
#line 229 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp11_, 3, _tmp13_.height);
#line 230 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 231 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 231 "../src/db/PhotoTable.vala"
	_tmp15_ = photo_row->master;
#line 231 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp14_, 4, _tmp15_->filesize);
#line 232 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 233 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 233 "../src/db/PhotoTable.vala"
	_tmp17_ = photo_row->master;
#line 233 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp16_, 5, (gint64) _tmp17_->timestamp);
#line 234 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 235 "../src/db/PhotoTable.vala"
	_tmp18_ = stmt;
#line 235 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp18_, 6, (gint64) photo_row->exposure_time);
#line 236 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 237 "../src/db/PhotoTable.vala"
	_tmp19_ = stmt;
#line 237 "../src/db/PhotoTable.vala"
	_tmp20_ = photo_row->master;
#line 237 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp19_, 7, (gint) _tmp20_->original_orientation);
#line 238 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 239 "../src/db/PhotoTable.vala"
	_tmp21_ = stmt;
#line 239 "../src/db/PhotoTable.vala"
	_tmp22_ = photo_row->master;
#line 239 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp21_, 8, (gint) _tmp22_->original_orientation);
#line 240 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 241 "../src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 241 "../src/db/PhotoTable.vala"
	_tmp24_ = photo_row->import_id;
#line 241 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp23_, 9, _tmp24_.id);
#line 242 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 243 "../src/db/PhotoTable.vala"
	_tmp25_ = stmt;
#line 243 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp25_, 10, EVENT_ID_INVALID);
#line 244 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 245 "../src/db/PhotoTable.vala"
	_tmp26_ = stmt;
#line 245 "../src/db/PhotoTable.vala"
	_tmp27_ = photo_row->md5;
#line 245 "../src/db/PhotoTable.vala"
	_tmp28_ = g_strdup (_tmp27_);
#line 245 "../src/db/PhotoTable.vala"
	_tmp29_ = g_free;
#line 245 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp26_, 11, _tmp28_, -1, _tmp29_);
#line 246 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 247 "../src/db/PhotoTable.vala"
	_tmp30_ = stmt;
#line 247 "../src/db/PhotoTable.vala"
	_tmp31_ = photo_row->thumbnail_md5;
#line 247 "../src/db/PhotoTable.vala"
	_tmp32_ = g_strdup (_tmp31_);
#line 247 "../src/db/PhotoTable.vala"
	_tmp33_ = g_free;
#line 247 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp30_, 12, _tmp32_, -1, _tmp33_);
#line 248 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 249 "../src/db/PhotoTable.vala"
	_tmp34_ = stmt;
#line 249 "../src/db/PhotoTable.vala"
	_tmp35_ = photo_row->exif_md5;
#line 249 "../src/db/PhotoTable.vala"
	_tmp36_ = g_strdup (_tmp35_);
#line 249 "../src/db/PhotoTable.vala"
	_tmp37_ = g_free;
#line 249 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp34_, 13, _tmp36_, -1, _tmp37_);
#line 250 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 251 "../src/db/PhotoTable.vala"
	_tmp38_ = stmt;
#line 251 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp38_, 14, (gint64) time_created);
#line 252 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 253 "../src/db/PhotoTable.vala"
	_tmp39_ = stmt;
#line 253 "../src/db/PhotoTable.vala"
	_tmp40_ = photo_row->master;
#line 253 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp39_, 15, photo_file_format_serialize (_tmp40_->file_format));
#line 254 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 255 "../src/db/PhotoTable.vala"
	_tmp41_ = stmt;
#line 255 "../src/db/PhotoTable.vala"
	_tmp42_ = photo_row->title;
#line 255 "../src/db/PhotoTable.vala"
	_tmp43_ = g_strdup (_tmp42_);
#line 255 "../src/db/PhotoTable.vala"
	_tmp44_ = g_free;
#line 255 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp41_, 16, _tmp43_, -1, _tmp44_);
#line 256 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 257 "../src/db/PhotoTable.vala"
	_tmp45_ = stmt;
#line 257 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp45_, 17, (gint64) rating_serialize (photo_row->rating));
#line 258 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 259 "../src/db/PhotoTable.vala"
	_tmp46_ = stmt;
#line 259 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp46_, 18, BACKING_PHOTO_ID_INVALID);
#line 260 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 261 "../src/db/PhotoTable.vala"
	_tmp47_ = stmt;
#line 261 "../src/db/PhotoTable.vala"
	_tmp48_ = raw_developer_to_string (photo_row->developer);
#line 261 "../src/db/PhotoTable.vala"
	_tmp49_ = g_free;
#line 261 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp47_, 19, _tmp48_, -1, _tmp49_);
#line 262 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 263 "../src/db/PhotoTable.vala"
	_tmp50_ = stmt;
#line 263 "../src/db/PhotoTable.vala"
	_tmp51_ = photo_row->gps_coords;
#line 263 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp50_, 20, _tmp51_.has_gps);
#line 264 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 265 "../src/db/PhotoTable.vala"
	_tmp52_ = stmt;
#line 265 "../src/db/PhotoTable.vala"
	_tmp53_ = photo_row->gps_coords;
#line 265 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp52_, 21, _tmp53_.latitude);
#line 266 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 267 "../src/db/PhotoTable.vala"
	_tmp54_ = stmt;
#line 267 "../src/db/PhotoTable.vala"
	_tmp55_ = photo_row->gps_coords;
#line 267 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp54_, 22, _tmp55_.longitude);
#line 268 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 269 "../src/db/PhotoTable.vala"
	_tmp56_ = stmt;
#line 269 "../src/db/PhotoTable.vala"
	_tmp57_ = photo_row->comment;
#line 269 "../src/db/PhotoTable.vala"
	_tmp58_ = g_strdup (_tmp57_);
#line 269 "../src/db/PhotoTable.vala"
	_tmp59_ = g_free;
#line 269 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp56_, 23, _tmp58_, -1, _tmp59_);
#line 270 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 272 "../src/db/PhotoTable.vala"
	_tmp60_ = stmt;
#line 272 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp60_);
#line 273 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1873 "PhotoTable.c"
		PhotoID _tmp61_ = {0};
#line 274 "../src/db/PhotoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 275 "../src/db/PhotoTable.vala"
			database_table_fatal ("add_photo", res);
#line 1879 "PhotoTable.c"
		}
#line 277 "../src/db/PhotoTable.vala"
		photo_id_init (&_tmp61_, PHOTO_ID_INVALID);
#line 277 "../src/db/PhotoTable.vala"
		*result = _tmp61_;
#line 277 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 277 "../src/db/PhotoTable.vala"
		return;
#line 1889 "PhotoTable.c"
	}
#line 281 "../src/db/PhotoTable.vala"
	_tmp62_ = database_table_db;
#line 281 "../src/db/PhotoTable.vala"
	photo_id_init (&photo_row->photo_id, sqlite3_last_insert_rowid (_tmp62_));
#line 282 "../src/db/PhotoTable.vala"
	_tmp63_ = photo_row->master;
#line 282 "../src/db/PhotoTable.vala"
	photo_row->orientation = _tmp63_->original_orientation;
#line 283 "../src/db/PhotoTable.vala"
	event_id_init (&photo_row->event_id, EVENT_ID_INVALID);
#line 284 "../src/db/PhotoTable.vala"
	photo_row->time_created = (time_t) time_created;
#line 285 "../src/db/PhotoTable.vala"
	photo_row->flags = (guint64) 0;
#line 287 "../src/db/PhotoTable.vala"
	_tmp64_ = photo_row->photo_id;
#line 287 "../src/db/PhotoTable.vala"
	*result = _tmp64_;
#line 287 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 287 "../src/db/PhotoTable.vala"
	return;
#line 1913 "PhotoTable.c"
}

void
photo_table_reimport (PhotoTable* self,
                      PhotoRow* row,
                      GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	time_t time_reimported = 0;
	sqlite3_stmt* _tmp3_;
	BackingPhotoRow* _tmp4_;
	Dimensions _tmp5_;
	sqlite3_stmt* _tmp6_;
	BackingPhotoRow* _tmp7_;
	Dimensions _tmp8_;
	sqlite3_stmt* _tmp9_;
	BackingPhotoRow* _tmp10_;
	sqlite3_stmt* _tmp11_;
	BackingPhotoRow* _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp14_;
	BackingPhotoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	BackingPhotoRow* _tmp17_;
	sqlite3_stmt* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	GDestroyNotify _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	GDestroyNotify _tmp25_;
	sqlite3_stmt* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	GDestroyNotify _tmp29_;
	sqlite3_stmt* _tmp30_;
	BackingPhotoRow* _tmp31_;
	sqlite3_stmt* _tmp32_;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	GDestroyNotify _tmp35_;
	sqlite3_stmt* _tmp36_;
	GpsCoords _tmp37_;
	sqlite3_stmt* _tmp38_;
	GpsCoords _tmp39_;
	sqlite3_stmt* _tmp40_;
	GpsCoords _tmp41_;
	sqlite3_stmt* _tmp42_;
	sqlite3_stmt* _tmp43_;
	PhotoID _tmp44_;
	sqlite3_stmt* _tmp45_;
	BackingPhotoRow* _tmp46_;
	GError* _inner_error0_ = NULL;
#line 295 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 295 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 297 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 297 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET width = ?, height = ?, filesize = ?, timestamp =" \
" ?, " "exposure_time = ?, orientation = ?, original_orientation = ?, md5 = ?," \
" " "exif_md5 = ?, thumbnail_md5 = ?, file_format = ?, title = ?, " "has_gps = ?, gps_lat = ?, gps_lon = ?, time_reimported = ? " "WHERE id = ?", -1, &_tmp1_, NULL);
#line 297 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 297 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 297 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 303 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 305 "../src/db/PhotoTable.vala"
	time_reimported = (time_t) now_sec ();
#line 307 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 307 "../src/db/PhotoTable.vala"
	_tmp4_ = row->master;
#line 307 "../src/db/PhotoTable.vala"
	_tmp5_ = _tmp4_->dim;
#line 307 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp3_, 1, _tmp5_.width);
#line 308 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 309 "../src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 309 "../src/db/PhotoTable.vala"
	_tmp7_ = row->master;
#line 309 "../src/db/PhotoTable.vala"
	_tmp8_ = _tmp7_->dim;
#line 309 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp6_, 2, _tmp8_.height);
#line 310 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 311 "../src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 311 "../src/db/PhotoTable.vala"
	_tmp10_ = row->master;
#line 311 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp9_, 3, _tmp10_->filesize);
#line 312 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 313 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 313 "../src/db/PhotoTable.vala"
	_tmp12_ = row->master;
#line 313 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp11_, 4, (gint64) _tmp12_->timestamp);
#line 314 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 315 "../src/db/PhotoTable.vala"
	_tmp13_ = stmt;
#line 315 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp13_, 5, (gint64) row->exposure_time);
#line 316 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 317 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 317 "../src/db/PhotoTable.vala"
	_tmp15_ = row->master;
#line 317 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp14_, 6, (gint) _tmp15_->original_orientation);
#line 318 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 319 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 319 "../src/db/PhotoTable.vala"
	_tmp17_ = row->master;
#line 319 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp16_, 7, (gint) _tmp17_->original_orientation);
#line 320 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 321 "../src/db/PhotoTable.vala"
	_tmp18_ = stmt;
#line 321 "../src/db/PhotoTable.vala"
	_tmp19_ = row->md5;
#line 321 "../src/db/PhotoTable.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 321 "../src/db/PhotoTable.vala"
	_tmp21_ = g_free;
#line 321 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp18_, 8, _tmp20_, -1, _tmp21_);
#line 322 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 323 "../src/db/PhotoTable.vala"
	_tmp22_ = stmt;
#line 323 "../src/db/PhotoTable.vala"
	_tmp23_ = row->exif_md5;
#line 323 "../src/db/PhotoTable.vala"
	_tmp24_ = g_strdup (_tmp23_);
#line 323 "../src/db/PhotoTable.vala"
	_tmp25_ = g_free;
#line 323 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp22_, 9, _tmp24_, -1, _tmp25_);
#line 324 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 325 "../src/db/PhotoTable.vala"
	_tmp26_ = stmt;
#line 325 "../src/db/PhotoTable.vala"
	_tmp27_ = row->thumbnail_md5;
#line 325 "../src/db/PhotoTable.vala"
	_tmp28_ = g_strdup (_tmp27_);
#line 325 "../src/db/PhotoTable.vala"
	_tmp29_ = g_free;
#line 325 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp26_, 10, _tmp28_, -1, _tmp29_);
#line 326 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 327 "../src/db/PhotoTable.vala"
	_tmp30_ = stmt;
#line 327 "../src/db/PhotoTable.vala"
	_tmp31_ = row->master;
#line 327 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp30_, 11, photo_file_format_serialize (_tmp31_->file_format));
#line 328 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 329 "../src/db/PhotoTable.vala"
	_tmp32_ = stmt;
#line 329 "../src/db/PhotoTable.vala"
	_tmp33_ = row->title;
#line 329 "../src/db/PhotoTable.vala"
	_tmp34_ = g_strdup (_tmp33_);
#line 329 "../src/db/PhotoTable.vala"
	_tmp35_ = g_free;
#line 329 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp32_, 12, _tmp34_, -1, _tmp35_);
#line 330 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 331 "../src/db/PhotoTable.vala"
	_tmp36_ = stmt;
#line 331 "../src/db/PhotoTable.vala"
	_tmp37_ = row->gps_coords;
#line 331 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp36_, 13, _tmp37_.has_gps);
#line 332 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 333 "../src/db/PhotoTable.vala"
	_tmp38_ = stmt;
#line 333 "../src/db/PhotoTable.vala"
	_tmp39_ = row->gps_coords;
#line 333 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp38_, 14, _tmp39_.latitude);
#line 334 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 335 "../src/db/PhotoTable.vala"
	_tmp40_ = stmt;
#line 335 "../src/db/PhotoTable.vala"
	_tmp41_ = row->gps_coords;
#line 335 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp40_, 15, _tmp41_.longitude);
#line 336 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 337 "../src/db/PhotoTable.vala"
	_tmp42_ = stmt;
#line 337 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp42_, 16, (gint64) time_reimported);
#line 338 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 339 "../src/db/PhotoTable.vala"
	_tmp43_ = stmt;
#line 339 "../src/db/PhotoTable.vala"
	_tmp44_ = row->photo_id;
#line 339 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp43_, 17, _tmp44_.id);
#line 340 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 342 "../src/db/PhotoTable.vala"
	_tmp45_ = stmt;
#line 342 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp45_);
#line 343 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 344 "../src/db/PhotoTable.vala"
		database_table_throw_error ("PhotoTable.reimport_master", res, &_inner_error0_);
#line 344 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 344 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 344 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 344 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 344 "../src/db/PhotoTable.vala"
				return;
#line 2160 "PhotoTable.c"
			} else {
#line 344 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 344 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 344 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 344 "../src/db/PhotoTable.vala"
				return;
#line 2170 "PhotoTable.c"
			}
		}
	}
#line 346 "../src/db/PhotoTable.vala"
	row->time_reimported = time_reimported;
#line 347 "../src/db/PhotoTable.vala"
	_tmp46_ = row->master;
#line 347 "../src/db/PhotoTable.vala"
	row->orientation = _tmp46_->original_orientation;
#line 295 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2182 "PhotoTable.c"
}

gboolean
photo_table_master_exif_updated (PhotoTable* self,
                                 PhotoID* photoID,
                                 gint64 filesize,
                                 glong timestamp,
                                 const gchar* md5,
                                 const gchar* exif_md5,
                                 const gchar* thumbnail_md5,
                                 PhotoRow* row)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	gchar* _tmp6_;
	GDestroyNotify _tmp7_;
	sqlite3_stmt* _tmp8_;
	gchar* _tmp9_;
	GDestroyNotify _tmp10_;
	sqlite3_stmt* _tmp11_;
	gchar* _tmp12_;
	GDestroyNotify _tmp13_;
	sqlite3_stmt* _tmp14_;
	PhotoID _tmp15_;
	sqlite3_stmt* _tmp16_;
	BackingPhotoRow* _tmp17_;
	BackingPhotoRow* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gboolean result = FALSE;
#line 350 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 350 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photoID != NULL, FALSE);
#line 350 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (md5 != NULL, FALSE);
#line 350 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), FALSE);
#line 353 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 353 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET filesize = ?, timestamp = ?, md5 = ?, exif_md5 =" \
" ?," "thumbnail_md5 =? WHERE id = ?", -1, &_tmp1_, NULL);
#line 353 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 353 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 353 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 356 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 358 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 358 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, filesize);
#line 359 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 360 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 360 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 2, (gint64) timestamp);
#line 361 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 362 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 362 "../src/db/PhotoTable.vala"
	_tmp6_ = g_strdup (md5);
#line 362 "../src/db/PhotoTable.vala"
	_tmp7_ = g_free;
#line 362 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp5_, 3, _tmp6_, -1, _tmp7_);
#line 363 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 364 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 364 "../src/db/PhotoTable.vala"
	_tmp9_ = g_strdup (exif_md5);
#line 364 "../src/db/PhotoTable.vala"
	_tmp10_ = g_free;
#line 364 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp8_, 4, _tmp9_, -1, _tmp10_);
#line 365 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 366 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 366 "../src/db/PhotoTable.vala"
	_tmp12_ = g_strdup (thumbnail_md5);
#line 366 "../src/db/PhotoTable.vala"
	_tmp13_ = g_free;
#line 366 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp11_, 5, _tmp12_, -1, _tmp13_);
#line 367 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 368 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 368 "../src/db/PhotoTable.vala"
	_tmp15_ = *photoID;
#line 368 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp14_, 6, _tmp15_.id);
#line 369 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 371 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 371 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp16_);
#line 372 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 373 "../src/db/PhotoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 374 "../src/db/PhotoTable.vala"
			database_table_fatal ("write_update_photo", res);
#line 2300 "PhotoTable.c"
		}
#line 376 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 376 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 376 "../src/db/PhotoTable.vala"
		return result;
#line 2308 "PhotoTable.c"
	}
#line 379 "../src/db/PhotoTable.vala"
	_tmp17_ = row->master;
#line 379 "../src/db/PhotoTable.vala"
	_tmp17_->filesize = filesize;
#line 380 "../src/db/PhotoTable.vala"
	_tmp18_ = row->master;
#line 380 "../src/db/PhotoTable.vala"
	_tmp18_->timestamp = (time_t) timestamp;
#line 381 "../src/db/PhotoTable.vala"
	_tmp19_ = g_strdup (md5);
#line 381 "../src/db/PhotoTable.vala"
	_g_free0 (row->md5);
#line 381 "../src/db/PhotoTable.vala"
	row->md5 = _tmp19_;
#line 382 "../src/db/PhotoTable.vala"
	_tmp20_ = g_strdup (exif_md5);
#line 382 "../src/db/PhotoTable.vala"
	_g_free0 (row->exif_md5);
#line 382 "../src/db/PhotoTable.vala"
	row->exif_md5 = _tmp20_;
#line 383 "../src/db/PhotoTable.vala"
	_tmp21_ = g_strdup (thumbnail_md5);
#line 383 "../src/db/PhotoTable.vala"
	_g_free0 (row->thumbnail_md5);
#line 383 "../src/db/PhotoTable.vala"
	row->thumbnail_md5 = _tmp21_;
#line 385 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 385 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 385 "../src/db/PhotoTable.vala"
	return result;
#line 2342 "PhotoTable.c"
}

static void
photo_table_validate_orientation (PhotoTable* self,
                                  PhotoRow* row)
{
	gboolean _tmp0_ = FALSE;
#line 396 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 396 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 397 "../src/db/PhotoTable.vala"
	if (row->orientation < ORIENTATION_MIN) {
#line 397 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 2358 "PhotoTable.c"
	} else {
#line 398 "../src/db/PhotoTable.vala"
		_tmp0_ = row->orientation > ORIENTATION_MAX;
#line 2362 "PhotoTable.c"
	}
#line 397 "../src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 2366 "PhotoTable.c"
		PhotoID _tmp1_;
#line 400 "../src/db/PhotoTable.vala"
		_tmp1_ = row->photo_id;
#line 400 "../src/db/PhotoTable.vala"
		photo_table_set_orientation (self, &_tmp1_, ORIENTATION_MIN);
#line 401 "../src/db/PhotoTable.vala"
		row->orientation = ORIENTATION_MIN;
#line 2374 "PhotoTable.c"
	}
}

PhotoRow*
photo_table_get_row (PhotoTable* self,
                     PhotoID* photo_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	PhotoID _tmp4_;
	sqlite3_stmt* _tmp5_;
	PhotoRow* row = NULL;
	PhotoRow* _tmp6_;
	PhotoRow* _tmp7_;
	PhotoID _tmp8_;
	PhotoRow* _tmp9_;
	BackingPhotoRow* _tmp10_;
	sqlite3_stmt* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	PhotoRow* _tmp14_;
	BackingPhotoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	sqlite3_stmt* _tmp17_;
	PhotoRow* _tmp18_;
	BackingPhotoRow* _tmp19_;
	sqlite3_stmt* _tmp20_;
	PhotoRow* _tmp21_;
	BackingPhotoRow* _tmp22_;
	sqlite3_stmt* _tmp23_;
	PhotoRow* _tmp24_;
	sqlite3_stmt* _tmp25_;
	PhotoRow* _tmp26_;
	sqlite3_stmt* _tmp27_;
	PhotoRow* _tmp28_;
	BackingPhotoRow* _tmp29_;
	sqlite3_stmt* _tmp30_;
	PhotoRow* _tmp31_;
	sqlite3_stmt* _tmp32_;
	PhotoRow* _tmp33_;
	sqlite3_stmt* _tmp34_;
	PhotoRow* _tmp35_;
	sqlite3_stmt* _tmp36_;
	const gchar* _tmp37_;
	GeeHashMap* _tmp38_;
	PhotoRow* _tmp39_;
	sqlite3_stmt* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	PhotoRow* _tmp43_;
	sqlite3_stmt* _tmp44_;
	const gchar* _tmp45_;
	gchar* _tmp46_;
	PhotoRow* _tmp47_;
	sqlite3_stmt* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	PhotoRow* _tmp51_;
	sqlite3_stmt* _tmp52_;
	PhotoRow* _tmp53_;
	sqlite3_stmt* _tmp54_;
	PhotoRow* _tmp55_;
	sqlite3_stmt* _tmp56_;
	PhotoRow* _tmp57_;
	BackingPhotoRow* _tmp58_;
	sqlite3_stmt* _tmp59_;
	PhotoRow* _tmp60_;
	sqlite3_stmt* _tmp61_;
	const gchar* _tmp62_;
	gchar* _tmp63_;
	PhotoRow* _tmp64_;
	sqlite3_stmt* _tmp65_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
	PhotoRow* _tmp68_;
	sqlite3_stmt* _tmp69_;
	PhotoRow* _tmp70_;
	sqlite3_stmt* _tmp71_;
	PhotoRow* _tmp72_;
	sqlite3_stmt* _tmp73_;
	RawDeveloper _tmp74_ = 0;
	sqlite3_stmt* _tmp75_;
	const gchar* _tmp76_;
	PhotoRow* _tmp79_;
	PhotoRow* _tmp80_;
	BackingPhotoID* _tmp81_;
	gint _tmp81__length1;
	sqlite3_stmt* _tmp82_;
	BackingPhotoID _tmp83_ = {0};
	PhotoRow* _tmp84_;
	BackingPhotoID* _tmp85_;
	gint _tmp85__length1;
	sqlite3_stmt* _tmp86_;
	BackingPhotoID _tmp87_ = {0};
	PhotoRow* _tmp88_;
	BackingPhotoID* _tmp89_;
	gint _tmp89__length1;
	sqlite3_stmt* _tmp90_;
	BackingPhotoID _tmp91_ = {0};
	PhotoRow* _tmp92_;
	sqlite3_stmt* _tmp93_;
	PhotoRow* _tmp94_;
	sqlite3_stmt* _tmp95_;
	PhotoRow* _tmp96_;
	sqlite3_stmt* _tmp97_;
	PhotoRow* _tmp98_;
	sqlite3_stmt* _tmp99_;
	const gchar* _tmp100_;
	gchar* _tmp101_;
	PhotoRow* result = NULL;
#line 405 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 405 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 407 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 407 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT filename, width, height, filesize, timestamp, exposure_time, or" \
"ientation, " "original_orientation, import_id, event_id, transformations, md5, thumb" \
"nail_md5, " "exif_md5, time_created, flags, rating, file_format, title, backlinks, " "time_reimported, editable_id, metadata_dirty, developer, develop_shotw" \
"ell_id, " "develop_camera_id, develop_embedded_id, has_gps, gps_lat, gps_lon, com" \
"ment " "FROM PhotoTable WHERE id=?", -1, &_tmp1_, NULL);
#line 407 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 407 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 407 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 415 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 417 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 417 "../src/db/PhotoTable.vala"
	_tmp4_ = *photo_id;
#line 417 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 418 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 420 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 420 "../src/db/PhotoTable.vala"
	if (sqlite3_step (_tmp5_) != SQLITE_ROW) {
#line 421 "../src/db/PhotoTable.vala"
		result = NULL;
#line 421 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 421 "../src/db/PhotoTable.vala"
		return result;
#line 2523 "PhotoTable.c"
	}
#line 423 "../src/db/PhotoTable.vala"
	_tmp6_ = photo_row_new ();
#line 423 "../src/db/PhotoTable.vala"
	row = _tmp6_;
#line 424 "../src/db/PhotoTable.vala"
	_tmp7_ = row;
#line 424 "../src/db/PhotoTable.vala"
	_tmp8_ = *photo_id;
#line 424 "../src/db/PhotoTable.vala"
	_tmp7_->photo_id = _tmp8_;
#line 425 "../src/db/PhotoTable.vala"
	_tmp9_ = row;
#line 425 "../src/db/PhotoTable.vala"
	_tmp10_ = _tmp9_->master;
#line 425 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 425 "../src/db/PhotoTable.vala"
	_tmp12_ = (const gchar*) sqlite3_column_text (_tmp11_, 0);
#line 425 "../src/db/PhotoTable.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 425 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp10_->filepath);
#line 425 "../src/db/PhotoTable.vala"
	_tmp10_->filepath = _tmp13_;
#line 426 "../src/db/PhotoTable.vala"
	_tmp14_ = row;
#line 426 "../src/db/PhotoTable.vala"
	_tmp15_ = _tmp14_->master;
#line 426 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 426 "../src/db/PhotoTable.vala"
	_tmp17_ = stmt;
#line 426 "../src/db/PhotoTable.vala"
	dimensions_init (&_tmp15_->dim, sqlite3_column_int (_tmp16_, 1), sqlite3_column_int (_tmp17_, 2));
#line 427 "../src/db/PhotoTable.vala"
	_tmp18_ = row;
#line 427 "../src/db/PhotoTable.vala"
	_tmp19_ = _tmp18_->master;
#line 427 "../src/db/PhotoTable.vala"
	_tmp20_ = stmt;
#line 427 "../src/db/PhotoTable.vala"
	_tmp19_->filesize = sqlite3_column_int64 (_tmp20_, 3);
#line 428 "../src/db/PhotoTable.vala"
	_tmp21_ = row;
#line 428 "../src/db/PhotoTable.vala"
	_tmp22_ = _tmp21_->master;
#line 428 "../src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 428 "../src/db/PhotoTable.vala"
	_tmp22_->timestamp = (time_t) sqlite3_column_int64 (_tmp23_, 4);
#line 429 "../src/db/PhotoTable.vala"
	_tmp24_ = row;
#line 429 "../src/db/PhotoTable.vala"
	_tmp25_ = stmt;
#line 429 "../src/db/PhotoTable.vala"
	_tmp24_->exposure_time = (time_t) sqlite3_column_int64 (_tmp25_, 5);
#line 430 "../src/db/PhotoTable.vala"
	_tmp26_ = row;
#line 430 "../src/db/PhotoTable.vala"
	_tmp27_ = stmt;
#line 430 "../src/db/PhotoTable.vala"
	_tmp26_->orientation = (Orientation) sqlite3_column_int (_tmp27_, 6);
#line 431 "../src/db/PhotoTable.vala"
	_tmp28_ = row;
#line 431 "../src/db/PhotoTable.vala"
	_tmp29_ = _tmp28_->master;
#line 431 "../src/db/PhotoTable.vala"
	_tmp30_ = stmt;
#line 431 "../src/db/PhotoTable.vala"
	_tmp29_->original_orientation = (Orientation) sqlite3_column_int (_tmp30_, 7);
#line 432 "../src/db/PhotoTable.vala"
	_tmp31_ = row;
#line 432 "../src/db/PhotoTable.vala"
	_tmp32_ = stmt;
#line 432 "../src/db/PhotoTable.vala"
	_tmp31_->import_id.id = sqlite3_column_int64 (_tmp32_, 8);
#line 433 "../src/db/PhotoTable.vala"
	_tmp33_ = row;
#line 433 "../src/db/PhotoTable.vala"
	_tmp34_ = stmt;
#line 433 "../src/db/PhotoTable.vala"
	_tmp33_->event_id.id = sqlite3_column_int64 (_tmp34_, 9);
#line 434 "../src/db/PhotoTable.vala"
	_tmp35_ = row;
#line 434 "../src/db/PhotoTable.vala"
	_tmp36_ = stmt;
#line 434 "../src/db/PhotoTable.vala"
	_tmp37_ = (const gchar*) sqlite3_column_text (_tmp36_, 10);
#line 434 "../src/db/PhotoTable.vala"
	_tmp38_ = photo_table_marshall_all_transformations (_tmp37_);
#line 434 "../src/db/PhotoTable.vala"
	_g_object_unref0 (_tmp35_->transformations);
#line 434 "../src/db/PhotoTable.vala"
	_tmp35_->transformations = _tmp38_;
#line 435 "../src/db/PhotoTable.vala"
	_tmp39_ = row;
#line 435 "../src/db/PhotoTable.vala"
	_tmp40_ = stmt;
#line 435 "../src/db/PhotoTable.vala"
	_tmp41_ = (const gchar*) sqlite3_column_text (_tmp40_, 11);
#line 435 "../src/db/PhotoTable.vala"
	_tmp42_ = g_strdup (_tmp41_);
#line 435 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp39_->md5);
#line 435 "../src/db/PhotoTable.vala"
	_tmp39_->md5 = _tmp42_;
#line 436 "../src/db/PhotoTable.vala"
	_tmp43_ = row;
#line 436 "../src/db/PhotoTable.vala"
	_tmp44_ = stmt;
#line 436 "../src/db/PhotoTable.vala"
	_tmp45_ = (const gchar*) sqlite3_column_text (_tmp44_, 12);
#line 436 "../src/db/PhotoTable.vala"
	_tmp46_ = g_strdup (_tmp45_);
#line 436 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp43_->thumbnail_md5);
#line 436 "../src/db/PhotoTable.vala"
	_tmp43_->thumbnail_md5 = _tmp46_;
#line 437 "../src/db/PhotoTable.vala"
	_tmp47_ = row;
#line 437 "../src/db/PhotoTable.vala"
	_tmp48_ = stmt;
#line 437 "../src/db/PhotoTable.vala"
	_tmp49_ = (const gchar*) sqlite3_column_text (_tmp48_, 13);
#line 437 "../src/db/PhotoTable.vala"
	_tmp50_ = g_strdup (_tmp49_);
#line 437 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp47_->exif_md5);
#line 437 "../src/db/PhotoTable.vala"
	_tmp47_->exif_md5 = _tmp50_;
#line 438 "../src/db/PhotoTable.vala"
	_tmp51_ = row;
#line 438 "../src/db/PhotoTable.vala"
	_tmp52_ = stmt;
#line 438 "../src/db/PhotoTable.vala"
	_tmp51_->time_created = (time_t) sqlite3_column_int64 (_tmp52_, 14);
#line 439 "../src/db/PhotoTable.vala"
	_tmp53_ = row;
#line 439 "../src/db/PhotoTable.vala"
	_tmp54_ = stmt;
#line 439 "../src/db/PhotoTable.vala"
	_tmp53_->flags = (guint64) sqlite3_column_int64 (_tmp54_, 15);
#line 440 "../src/db/PhotoTable.vala"
	_tmp55_ = row;
#line 440 "../src/db/PhotoTable.vala"
	_tmp56_ = stmt;
#line 440 "../src/db/PhotoTable.vala"
	_tmp55_->rating = rating_unserialize (sqlite3_column_int (_tmp56_, 16));
#line 441 "../src/db/PhotoTable.vala"
	_tmp57_ = row;
#line 441 "../src/db/PhotoTable.vala"
	_tmp58_ = _tmp57_->master;
#line 441 "../src/db/PhotoTable.vala"
	_tmp59_ = stmt;
#line 441 "../src/db/PhotoTable.vala"
	_tmp58_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp59_, 17));
#line 442 "../src/db/PhotoTable.vala"
	_tmp60_ = row;
#line 442 "../src/db/PhotoTable.vala"
	_tmp61_ = stmt;
#line 442 "../src/db/PhotoTable.vala"
	_tmp62_ = (const gchar*) sqlite3_column_text (_tmp61_, 18);
#line 442 "../src/db/PhotoTable.vala"
	_tmp63_ = g_strdup (_tmp62_);
#line 442 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp60_->title);
#line 442 "../src/db/PhotoTable.vala"
	_tmp60_->title = _tmp63_;
#line 443 "../src/db/PhotoTable.vala"
	_tmp64_ = row;
#line 443 "../src/db/PhotoTable.vala"
	_tmp65_ = stmt;
#line 443 "../src/db/PhotoTable.vala"
	_tmp66_ = (const gchar*) sqlite3_column_text (_tmp65_, 19);
#line 443 "../src/db/PhotoTable.vala"
	_tmp67_ = g_strdup (_tmp66_);
#line 443 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp64_->backlinks);
#line 443 "../src/db/PhotoTable.vala"
	_tmp64_->backlinks = _tmp67_;
#line 444 "../src/db/PhotoTable.vala"
	_tmp68_ = row;
#line 444 "../src/db/PhotoTable.vala"
	_tmp69_ = stmt;
#line 444 "../src/db/PhotoTable.vala"
	_tmp68_->time_reimported = (time_t) sqlite3_column_int64 (_tmp69_, 20);
#line 445 "../src/db/PhotoTable.vala"
	_tmp70_ = row;
#line 445 "../src/db/PhotoTable.vala"
	_tmp71_ = stmt;
#line 445 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp70_->editable_id, sqlite3_column_int64 (_tmp71_, 21));
#line 446 "../src/db/PhotoTable.vala"
	_tmp72_ = row;
#line 446 "../src/db/PhotoTable.vala"
	_tmp73_ = stmt;
#line 446 "../src/db/PhotoTable.vala"
	_tmp72_->metadata_dirty = sqlite3_column_int (_tmp73_, 22) != 0;
#line 447 "../src/db/PhotoTable.vala"
	_tmp75_ = stmt;
#line 447 "../src/db/PhotoTable.vala"
	_tmp76_ = (const gchar*) sqlite3_column_text (_tmp75_, 23);
#line 447 "../src/db/PhotoTable.vala"
	if (_tmp76_ != NULL) {
#line 2729 "PhotoTable.c"
		sqlite3_stmt* _tmp77_;
		const gchar* _tmp78_;
#line 447 "../src/db/PhotoTable.vala"
		_tmp77_ = stmt;
#line 447 "../src/db/PhotoTable.vala"
		_tmp78_ = (const gchar*) sqlite3_column_text (_tmp77_, 23);
#line 447 "../src/db/PhotoTable.vala"
		_tmp74_ = raw_developer_from_string (_tmp78_);
#line 2738 "PhotoTable.c"
	} else {
#line 448 "../src/db/PhotoTable.vala"
		_tmp74_ = RAW_DEVELOPER_CAMERA;
#line 2742 "PhotoTable.c"
	}
#line 447 "../src/db/PhotoTable.vala"
	_tmp79_ = row;
#line 447 "../src/db/PhotoTable.vala"
	_tmp79_->developer = _tmp74_;
#line 449 "../src/db/PhotoTable.vala"
	_tmp80_ = row;
#line 449 "../src/db/PhotoTable.vala"
	_tmp81_ = _tmp80_->development_ids;
#line 449 "../src/db/PhotoTable.vala"
	_tmp81__length1 = _tmp80_->development_ids_length1;
#line 449 "../src/db/PhotoTable.vala"
	_tmp82_ = stmt;
#line 449 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp83_, sqlite3_column_int64 (_tmp82_, 24));
#line 449 "../src/db/PhotoTable.vala"
	_tmp81_[RAW_DEVELOPER_SHOTWELL] = _tmp83_;
#line 450 "../src/db/PhotoTable.vala"
	_tmp84_ = row;
#line 450 "../src/db/PhotoTable.vala"
	_tmp85_ = _tmp84_->development_ids;
#line 450 "../src/db/PhotoTable.vala"
	_tmp85__length1 = _tmp84_->development_ids_length1;
#line 450 "../src/db/PhotoTable.vala"
	_tmp86_ = stmt;
#line 450 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp87_, sqlite3_column_int64 (_tmp86_, 25));
#line 450 "../src/db/PhotoTable.vala"
	_tmp85_[RAW_DEVELOPER_CAMERA] = _tmp87_;
#line 451 "../src/db/PhotoTable.vala"
	_tmp88_ = row;
#line 451 "../src/db/PhotoTable.vala"
	_tmp89_ = _tmp88_->development_ids;
#line 451 "../src/db/PhotoTable.vala"
	_tmp89__length1 = _tmp88_->development_ids_length1;
#line 451 "../src/db/PhotoTable.vala"
	_tmp90_ = stmt;
#line 451 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp91_, sqlite3_column_int64 (_tmp90_, 26));
#line 451 "../src/db/PhotoTable.vala"
	_tmp89_[RAW_DEVELOPER_EMBEDDED] = _tmp91_;
#line 452 "../src/db/PhotoTable.vala"
	_tmp92_ = row;
#line 452 "../src/db/PhotoTable.vala"
	_tmp93_ = stmt;
#line 452 "../src/db/PhotoTable.vala"
	_tmp92_->gps_coords.has_gps = sqlite3_column_int (_tmp93_, 27);
#line 453 "../src/db/PhotoTable.vala"
	_tmp94_ = row;
#line 453 "../src/db/PhotoTable.vala"
	_tmp95_ = stmt;
#line 453 "../src/db/PhotoTable.vala"
	_tmp94_->gps_coords.latitude = sqlite3_column_double (_tmp95_, 28);
#line 454 "../src/db/PhotoTable.vala"
	_tmp96_ = row;
#line 454 "../src/db/PhotoTable.vala"
	_tmp97_ = stmt;
#line 454 "../src/db/PhotoTable.vala"
	_tmp96_->gps_coords.longitude = sqlite3_column_double (_tmp97_, 29);
#line 455 "../src/db/PhotoTable.vala"
	_tmp98_ = row;
#line 455 "../src/db/PhotoTable.vala"
	_tmp99_ = stmt;
#line 455 "../src/db/PhotoTable.vala"
	_tmp100_ = (const gchar*) sqlite3_column_text (_tmp99_, 30);
#line 455 "../src/db/PhotoTable.vala"
	_tmp101_ = g_strdup (_tmp100_);
#line 455 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp98_->comment);
#line 455 "../src/db/PhotoTable.vala"
	_tmp98_->comment = _tmp101_;
#line 457 "../src/db/PhotoTable.vala"
	result = row;
#line 457 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 457 "../src/db/PhotoTable.vala"
	return result;
#line 2820 "PhotoTable.c"
}

GeeArrayList*
photo_table_get_all (PhotoTable* self)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeArrayList* all = NULL;
	GeeArrayList* _tmp3_;
	GeeArrayList* result = NULL;
#line 460 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 462 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 462 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, filename, width, height, filesize, timestamp, exposure_time" \
", orientation, " "original_orientation, import_id, event_id, transformations, md5, thumb" \
"nail_md5, " "exif_md5, time_created, flags, rating, file_format, title, backlinks, " \
"time_reimported, " "editable_id, metadata_dirty, developer, develop_shotwell_id, develop_c" \
"amera_id, " "develop_embedded_id, has_gps, gps_lat, gps_lon, comment FROM PhotoTabl" \
"e", -1, &_tmp1_, NULL);
#line 462 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 462 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 462 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 469 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 471 "../src/db/PhotoTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_PHOTO_ROW, (GBoxedCopyFunc) photo_row_ref, (GDestroyNotify) photo_row_unref, NULL, NULL, NULL);
#line 471 "../src/db/PhotoTable.vala"
	all = _tmp3_;
#line 473 "../src/db/PhotoTable.vala"
	while (TRUE) {
#line 2854 "PhotoTable.c"
		sqlite3_stmt* _tmp4_;
		PhotoRow* row = NULL;
		PhotoRow* _tmp5_;
		PhotoRow* _tmp6_;
		sqlite3_stmt* _tmp7_;
		PhotoRow* _tmp8_;
		BackingPhotoRow* _tmp9_;
		sqlite3_stmt* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		PhotoRow* _tmp13_;
		BackingPhotoRow* _tmp14_;
		sqlite3_stmt* _tmp15_;
		sqlite3_stmt* _tmp16_;
		PhotoRow* _tmp17_;
		BackingPhotoRow* _tmp18_;
		sqlite3_stmt* _tmp19_;
		PhotoRow* _tmp20_;
		BackingPhotoRow* _tmp21_;
		sqlite3_stmt* _tmp22_;
		PhotoRow* _tmp23_;
		sqlite3_stmt* _tmp24_;
		PhotoRow* _tmp25_;
		sqlite3_stmt* _tmp26_;
		PhotoRow* _tmp27_;
		BackingPhotoRow* _tmp28_;
		sqlite3_stmt* _tmp29_;
		PhotoRow* _tmp30_;
		sqlite3_stmt* _tmp31_;
		PhotoRow* _tmp32_;
		sqlite3_stmt* _tmp33_;
		PhotoRow* _tmp34_;
		sqlite3_stmt* _tmp35_;
		const gchar* _tmp36_;
		GeeHashMap* _tmp37_;
		PhotoRow* _tmp38_;
		sqlite3_stmt* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		PhotoRow* _tmp42_;
		sqlite3_stmt* _tmp43_;
		const gchar* _tmp44_;
		gchar* _tmp45_;
		PhotoRow* _tmp46_;
		sqlite3_stmt* _tmp47_;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		PhotoRow* _tmp50_;
		sqlite3_stmt* _tmp51_;
		PhotoRow* _tmp52_;
		sqlite3_stmt* _tmp53_;
		PhotoRow* _tmp54_;
		sqlite3_stmt* _tmp55_;
		PhotoRow* _tmp56_;
		BackingPhotoRow* _tmp57_;
		sqlite3_stmt* _tmp58_;
		PhotoRow* _tmp59_;
		sqlite3_stmt* _tmp60_;
		const gchar* _tmp61_;
		gchar* _tmp62_;
		PhotoRow* _tmp63_;
		sqlite3_stmt* _tmp64_;
		const gchar* _tmp65_;
		gchar* _tmp66_;
		PhotoRow* _tmp67_;
		sqlite3_stmt* _tmp68_;
		PhotoRow* _tmp69_;
		sqlite3_stmt* _tmp70_;
		PhotoRow* _tmp71_;
		sqlite3_stmt* _tmp72_;
		RawDeveloper _tmp73_ = 0;
		sqlite3_stmt* _tmp74_;
		const gchar* _tmp75_;
		PhotoRow* _tmp78_;
		PhotoRow* _tmp79_;
		BackingPhotoID* _tmp80_;
		gint _tmp80__length1;
		sqlite3_stmt* _tmp81_;
		BackingPhotoID _tmp82_ = {0};
		PhotoRow* _tmp83_;
		BackingPhotoID* _tmp84_;
		gint _tmp84__length1;
		sqlite3_stmt* _tmp85_;
		BackingPhotoID _tmp86_ = {0};
		PhotoRow* _tmp87_;
		BackingPhotoID* _tmp88_;
		gint _tmp88__length1;
		sqlite3_stmt* _tmp89_;
		BackingPhotoID _tmp90_ = {0};
		PhotoRow* _tmp91_;
		sqlite3_stmt* _tmp92_;
		PhotoRow* _tmp93_;
		sqlite3_stmt* _tmp94_;
		PhotoRow* _tmp95_;
		sqlite3_stmt* _tmp96_;
		PhotoRow* _tmp97_;
		sqlite3_stmt* _tmp98_;
		const gchar* _tmp99_;
		gchar* _tmp100_;
		PhotoRow* _tmp101_;
		GeeArrayList* _tmp102_;
		PhotoRow* _tmp103_;
#line 473 "../src/db/PhotoTable.vala"
		_tmp4_ = stmt;
#line 473 "../src/db/PhotoTable.vala"
		res = sqlite3_step (_tmp4_);
#line 473 "../src/db/PhotoTable.vala"
		if (!(res == SQLITE_ROW)) {
#line 473 "../src/db/PhotoTable.vala"
			break;
#line 2965 "PhotoTable.c"
		}
#line 474 "../src/db/PhotoTable.vala"
		_tmp5_ = photo_row_new ();
#line 474 "../src/db/PhotoTable.vala"
		row = _tmp5_;
#line 475 "../src/db/PhotoTable.vala"
		_tmp6_ = row;
#line 475 "../src/db/PhotoTable.vala"
		_tmp7_ = stmt;
#line 475 "../src/db/PhotoTable.vala"
		_tmp6_->photo_id.id = sqlite3_column_int64 (_tmp7_, 0);
#line 476 "../src/db/PhotoTable.vala"
		_tmp8_ = row;
#line 476 "../src/db/PhotoTable.vala"
		_tmp9_ = _tmp8_->master;
#line 476 "../src/db/PhotoTable.vala"
		_tmp10_ = stmt;
#line 476 "../src/db/PhotoTable.vala"
		_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 1);
#line 476 "../src/db/PhotoTable.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 476 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp9_->filepath);
#line 476 "../src/db/PhotoTable.vala"
		_tmp9_->filepath = _tmp12_;
#line 477 "../src/db/PhotoTable.vala"
		_tmp13_ = row;
#line 477 "../src/db/PhotoTable.vala"
		_tmp14_ = _tmp13_->master;
#line 477 "../src/db/PhotoTable.vala"
		_tmp15_ = stmt;
#line 477 "../src/db/PhotoTable.vala"
		_tmp16_ = stmt;
#line 477 "../src/db/PhotoTable.vala"
		dimensions_init (&_tmp14_->dim, sqlite3_column_int (_tmp15_, 2), sqlite3_column_int (_tmp16_, 3));
#line 478 "../src/db/PhotoTable.vala"
		_tmp17_ = row;
#line 478 "../src/db/PhotoTable.vala"
		_tmp18_ = _tmp17_->master;
#line 478 "../src/db/PhotoTable.vala"
		_tmp19_ = stmt;
#line 478 "../src/db/PhotoTable.vala"
		_tmp18_->filesize = sqlite3_column_int64 (_tmp19_, 4);
#line 479 "../src/db/PhotoTable.vala"
		_tmp20_ = row;
#line 479 "../src/db/PhotoTable.vala"
		_tmp21_ = _tmp20_->master;
#line 479 "../src/db/PhotoTable.vala"
		_tmp22_ = stmt;
#line 479 "../src/db/PhotoTable.vala"
		_tmp21_->timestamp = (time_t) sqlite3_column_int64 (_tmp22_, 5);
#line 480 "../src/db/PhotoTable.vala"
		_tmp23_ = row;
#line 480 "../src/db/PhotoTable.vala"
		_tmp24_ = stmt;
#line 480 "../src/db/PhotoTable.vala"
		_tmp23_->exposure_time = (time_t) sqlite3_column_int64 (_tmp24_, 6);
#line 481 "../src/db/PhotoTable.vala"
		_tmp25_ = row;
#line 481 "../src/db/PhotoTable.vala"
		_tmp26_ = stmt;
#line 481 "../src/db/PhotoTable.vala"
		_tmp25_->orientation = (Orientation) sqlite3_column_int (_tmp26_, 7);
#line 482 "../src/db/PhotoTable.vala"
		_tmp27_ = row;
#line 482 "../src/db/PhotoTable.vala"
		_tmp28_ = _tmp27_->master;
#line 482 "../src/db/PhotoTable.vala"
		_tmp29_ = stmt;
#line 482 "../src/db/PhotoTable.vala"
		_tmp28_->original_orientation = (Orientation) sqlite3_column_int (_tmp29_, 8);
#line 483 "../src/db/PhotoTable.vala"
		_tmp30_ = row;
#line 483 "../src/db/PhotoTable.vala"
		_tmp31_ = stmt;
#line 483 "../src/db/PhotoTable.vala"
		_tmp30_->import_id.id = sqlite3_column_int64 (_tmp31_, 9);
#line 484 "../src/db/PhotoTable.vala"
		_tmp32_ = row;
#line 484 "../src/db/PhotoTable.vala"
		_tmp33_ = stmt;
#line 484 "../src/db/PhotoTable.vala"
		_tmp32_->event_id.id = sqlite3_column_int64 (_tmp33_, 10);
#line 485 "../src/db/PhotoTable.vala"
		_tmp34_ = row;
#line 485 "../src/db/PhotoTable.vala"
		_tmp35_ = stmt;
#line 485 "../src/db/PhotoTable.vala"
		_tmp36_ = (const gchar*) sqlite3_column_text (_tmp35_, 11);
#line 485 "../src/db/PhotoTable.vala"
		_tmp37_ = photo_table_marshall_all_transformations (_tmp36_);
#line 485 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp34_->transformations);
#line 485 "../src/db/PhotoTable.vala"
		_tmp34_->transformations = _tmp37_;
#line 486 "../src/db/PhotoTable.vala"
		_tmp38_ = row;
#line 486 "../src/db/PhotoTable.vala"
		_tmp39_ = stmt;
#line 486 "../src/db/PhotoTable.vala"
		_tmp40_ = (const gchar*) sqlite3_column_text (_tmp39_, 12);
#line 486 "../src/db/PhotoTable.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 486 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp38_->md5);
#line 486 "../src/db/PhotoTable.vala"
		_tmp38_->md5 = _tmp41_;
#line 487 "../src/db/PhotoTable.vala"
		_tmp42_ = row;
#line 487 "../src/db/PhotoTable.vala"
		_tmp43_ = stmt;
#line 487 "../src/db/PhotoTable.vala"
		_tmp44_ = (const gchar*) sqlite3_column_text (_tmp43_, 13);
#line 487 "../src/db/PhotoTable.vala"
		_tmp45_ = g_strdup (_tmp44_);
#line 487 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp42_->thumbnail_md5);
#line 487 "../src/db/PhotoTable.vala"
		_tmp42_->thumbnail_md5 = _tmp45_;
#line 488 "../src/db/PhotoTable.vala"
		_tmp46_ = row;
#line 488 "../src/db/PhotoTable.vala"
		_tmp47_ = stmt;
#line 488 "../src/db/PhotoTable.vala"
		_tmp48_ = (const gchar*) sqlite3_column_text (_tmp47_, 14);
#line 488 "../src/db/PhotoTable.vala"
		_tmp49_ = g_strdup (_tmp48_);
#line 488 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp46_->exif_md5);
#line 488 "../src/db/PhotoTable.vala"
		_tmp46_->exif_md5 = _tmp49_;
#line 489 "../src/db/PhotoTable.vala"
		_tmp50_ = row;
#line 489 "../src/db/PhotoTable.vala"
		_tmp51_ = stmt;
#line 489 "../src/db/PhotoTable.vala"
		_tmp50_->time_created = (time_t) sqlite3_column_int64 (_tmp51_, 15);
#line 490 "../src/db/PhotoTable.vala"
		_tmp52_ = row;
#line 490 "../src/db/PhotoTable.vala"
		_tmp53_ = stmt;
#line 490 "../src/db/PhotoTable.vala"
		_tmp52_->flags = (guint64) sqlite3_column_int64 (_tmp53_, 16);
#line 491 "../src/db/PhotoTable.vala"
		_tmp54_ = row;
#line 491 "../src/db/PhotoTable.vala"
		_tmp55_ = stmt;
#line 491 "../src/db/PhotoTable.vala"
		_tmp54_->rating = rating_unserialize (sqlite3_column_int (_tmp55_, 17));
#line 492 "../src/db/PhotoTable.vala"
		_tmp56_ = row;
#line 492 "../src/db/PhotoTable.vala"
		_tmp57_ = _tmp56_->master;
#line 492 "../src/db/PhotoTable.vala"
		_tmp58_ = stmt;
#line 492 "../src/db/PhotoTable.vala"
		_tmp57_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp58_, 18));
#line 493 "../src/db/PhotoTable.vala"
		_tmp59_ = row;
#line 493 "../src/db/PhotoTable.vala"
		_tmp60_ = stmt;
#line 493 "../src/db/PhotoTable.vala"
		_tmp61_ = (const gchar*) sqlite3_column_text (_tmp60_, 19);
#line 493 "../src/db/PhotoTable.vala"
		_tmp62_ = g_strdup (_tmp61_);
#line 493 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp59_->title);
#line 493 "../src/db/PhotoTable.vala"
		_tmp59_->title = _tmp62_;
#line 494 "../src/db/PhotoTable.vala"
		_tmp63_ = row;
#line 494 "../src/db/PhotoTable.vala"
		_tmp64_ = stmt;
#line 494 "../src/db/PhotoTable.vala"
		_tmp65_ = (const gchar*) sqlite3_column_text (_tmp64_, 20);
#line 494 "../src/db/PhotoTable.vala"
		_tmp66_ = g_strdup (_tmp65_);
#line 494 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp63_->backlinks);
#line 494 "../src/db/PhotoTable.vala"
		_tmp63_->backlinks = _tmp66_;
#line 495 "../src/db/PhotoTable.vala"
		_tmp67_ = row;
#line 495 "../src/db/PhotoTable.vala"
		_tmp68_ = stmt;
#line 495 "../src/db/PhotoTable.vala"
		_tmp67_->time_reimported = (time_t) sqlite3_column_int64 (_tmp68_, 21);
#line 496 "../src/db/PhotoTable.vala"
		_tmp69_ = row;
#line 496 "../src/db/PhotoTable.vala"
		_tmp70_ = stmt;
#line 496 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp69_->editable_id, sqlite3_column_int64 (_tmp70_, 22));
#line 497 "../src/db/PhotoTable.vala"
		_tmp71_ = row;
#line 497 "../src/db/PhotoTable.vala"
		_tmp72_ = stmt;
#line 497 "../src/db/PhotoTable.vala"
		_tmp71_->metadata_dirty = sqlite3_column_int (_tmp72_, 23) != 0;
#line 498 "../src/db/PhotoTable.vala"
		_tmp74_ = stmt;
#line 498 "../src/db/PhotoTable.vala"
		_tmp75_ = (const gchar*) sqlite3_column_text (_tmp74_, 24);
#line 498 "../src/db/PhotoTable.vala"
		if (_tmp75_ != NULL) {
#line 3171 "PhotoTable.c"
			sqlite3_stmt* _tmp76_;
			const gchar* _tmp77_;
#line 498 "../src/db/PhotoTable.vala"
			_tmp76_ = stmt;
#line 498 "../src/db/PhotoTable.vala"
			_tmp77_ = (const gchar*) sqlite3_column_text (_tmp76_, 24);
#line 498 "../src/db/PhotoTable.vala"
			_tmp73_ = raw_developer_from_string (_tmp77_);
#line 3180 "PhotoTable.c"
		} else {
#line 499 "../src/db/PhotoTable.vala"
			_tmp73_ = RAW_DEVELOPER_CAMERA;
#line 3184 "PhotoTable.c"
		}
#line 498 "../src/db/PhotoTable.vala"
		_tmp78_ = row;
#line 498 "../src/db/PhotoTable.vala"
		_tmp78_->developer = _tmp73_;
#line 500 "../src/db/PhotoTable.vala"
		_tmp79_ = row;
#line 500 "../src/db/PhotoTable.vala"
		_tmp80_ = _tmp79_->development_ids;
#line 500 "../src/db/PhotoTable.vala"
		_tmp80__length1 = _tmp79_->development_ids_length1;
#line 500 "../src/db/PhotoTable.vala"
		_tmp81_ = stmt;
#line 500 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp82_, sqlite3_column_int64 (_tmp81_, 25));
#line 500 "../src/db/PhotoTable.vala"
		_tmp80_[RAW_DEVELOPER_SHOTWELL] = _tmp82_;
#line 501 "../src/db/PhotoTable.vala"
		_tmp83_ = row;
#line 501 "../src/db/PhotoTable.vala"
		_tmp84_ = _tmp83_->development_ids;
#line 501 "../src/db/PhotoTable.vala"
		_tmp84__length1 = _tmp83_->development_ids_length1;
#line 501 "../src/db/PhotoTable.vala"
		_tmp85_ = stmt;
#line 501 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp86_, sqlite3_column_int64 (_tmp85_, 26));
#line 501 "../src/db/PhotoTable.vala"
		_tmp84_[RAW_DEVELOPER_CAMERA] = _tmp86_;
#line 502 "../src/db/PhotoTable.vala"
		_tmp87_ = row;
#line 502 "../src/db/PhotoTable.vala"
		_tmp88_ = _tmp87_->development_ids;
#line 502 "../src/db/PhotoTable.vala"
		_tmp88__length1 = _tmp87_->development_ids_length1;
#line 502 "../src/db/PhotoTable.vala"
		_tmp89_ = stmt;
#line 502 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp90_, sqlite3_column_int64 (_tmp89_, 27));
#line 502 "../src/db/PhotoTable.vala"
		_tmp88_[RAW_DEVELOPER_EMBEDDED] = _tmp90_;
#line 503 "../src/db/PhotoTable.vala"
		_tmp91_ = row;
#line 503 "../src/db/PhotoTable.vala"
		_tmp92_ = stmt;
#line 503 "../src/db/PhotoTable.vala"
		_tmp91_->gps_coords.has_gps = sqlite3_column_int (_tmp92_, 28);
#line 504 "../src/db/PhotoTable.vala"
		_tmp93_ = row;
#line 504 "../src/db/PhotoTable.vala"
		_tmp94_ = stmt;
#line 504 "../src/db/PhotoTable.vala"
		_tmp93_->gps_coords.latitude = sqlite3_column_double (_tmp94_, 29);
#line 505 "../src/db/PhotoTable.vala"
		_tmp95_ = row;
#line 505 "../src/db/PhotoTable.vala"
		_tmp96_ = stmt;
#line 505 "../src/db/PhotoTable.vala"
		_tmp95_->gps_coords.longitude = sqlite3_column_double (_tmp96_, 30);
#line 506 "../src/db/PhotoTable.vala"
		_tmp97_ = row;
#line 506 "../src/db/PhotoTable.vala"
		_tmp98_ = stmt;
#line 506 "../src/db/PhotoTable.vala"
		_tmp99_ = (const gchar*) sqlite3_column_text (_tmp98_, 31);
#line 506 "../src/db/PhotoTable.vala"
		_tmp100_ = g_strdup (_tmp99_);
#line 506 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp97_->comment);
#line 506 "../src/db/PhotoTable.vala"
		_tmp97_->comment = _tmp100_;
#line 508 "../src/db/PhotoTable.vala"
		_tmp101_ = row;
#line 508 "../src/db/PhotoTable.vala"
		photo_table_validate_orientation (self, _tmp101_);
#line 510 "../src/db/PhotoTable.vala"
		_tmp102_ = all;
#line 510 "../src/db/PhotoTable.vala"
		_tmp103_ = row;
#line 510 "../src/db/PhotoTable.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp102_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp103_);
#line 473 "../src/db/PhotoTable.vala"
		_photo_row_unref0 (row);
#line 3268 "PhotoTable.c"
	}
#line 513 "../src/db/PhotoTable.vala"
	result = all;
#line 513 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 513 "../src/db/PhotoTable.vala"
	return result;
#line 3276 "PhotoTable.c"
}

void
photo_table_duplicate (PhotoTable* self,
                       PhotoID* photo_id,
                       const gchar* new_filename,
                       BackingPhotoID* editable_id,
                       BackingPhotoID* develop_shotwell,
                       BackingPhotoID* develop_camera_id,
                       BackingPhotoID* develop_embedded_id,
                       PhotoID* result)
{
	PhotoRow* original = NULL;
	PhotoID _tmp0_;
	PhotoRow* _tmp1_;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	sqlite3_stmt* _tmp5_;
	gchar* _tmp6_;
	GDestroyNotify _tmp7_;
	sqlite3_stmt* _tmp8_;
	PhotoRow* _tmp9_;
	BackingPhotoRow* _tmp10_;
	Dimensions _tmp11_;
	sqlite3_stmt* _tmp12_;
	PhotoRow* _tmp13_;
	BackingPhotoRow* _tmp14_;
	Dimensions _tmp15_;
	sqlite3_stmt* _tmp16_;
	PhotoRow* _tmp17_;
	BackingPhotoRow* _tmp18_;
	sqlite3_stmt* _tmp19_;
	PhotoRow* _tmp20_;
	BackingPhotoRow* _tmp21_;
	sqlite3_stmt* _tmp22_;
	PhotoRow* _tmp23_;
	sqlite3_stmt* _tmp24_;
	PhotoRow* _tmp25_;
	sqlite3_stmt* _tmp26_;
	PhotoRow* _tmp27_;
	BackingPhotoRow* _tmp28_;
	sqlite3_stmt* _tmp29_;
	PhotoRow* _tmp30_;
	ImportID _tmp31_;
	sqlite3_stmt* _tmp32_;
	PhotoRow* _tmp33_;
	EventID _tmp34_;
	sqlite3_stmt* _tmp35_;
	PhotoRow* _tmp36_;
	GeeHashMap* _tmp37_;
	gchar* _tmp38_;
	GDestroyNotify _tmp39_;
	sqlite3_stmt* _tmp40_;
	PhotoRow* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	GDestroyNotify _tmp44_;
	sqlite3_stmt* _tmp45_;
	PhotoRow* _tmp46_;
	const gchar* _tmp47_;
	gchar* _tmp48_;
	GDestroyNotify _tmp49_;
	sqlite3_stmt* _tmp50_;
	PhotoRow* _tmp51_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	GDestroyNotify _tmp54_;
	sqlite3_stmt* _tmp55_;
	sqlite3_stmt* _tmp56_;
	PhotoRow* _tmp57_;
	sqlite3_stmt* _tmp58_;
	PhotoRow* _tmp59_;
	sqlite3_stmt* _tmp60_;
	PhotoRow* _tmp61_;
	BackingPhotoRow* _tmp62_;
	sqlite3_stmt* _tmp63_;
	PhotoRow* _tmp64_;
	const gchar* _tmp65_;
	gchar* _tmp66_;
	GDestroyNotify _tmp67_;
	sqlite3_stmt* _tmp68_;
	PhotoRow* _tmp69_;
	GpsCoords _tmp70_;
	sqlite3_stmt* _tmp71_;
	PhotoRow* _tmp72_;
	GpsCoords _tmp73_;
	sqlite3_stmt* _tmp74_;
	PhotoRow* _tmp75_;
	GpsCoords _tmp76_;
	sqlite3_stmt* _tmp77_;
	BackingPhotoID _tmp78_;
	sqlite3_stmt* _tmp79_;
	PhotoRow* _tmp80_;
	gchar* _tmp81_;
	GDestroyNotify _tmp82_;
	sqlite3_stmt* _tmp83_;
	BackingPhotoID _tmp84_;
	sqlite3_stmt* _tmp85_;
	BackingPhotoID _tmp86_;
	sqlite3_stmt* _tmp87_;
	BackingPhotoID _tmp88_;
	sqlite3_stmt* _tmp89_;
	PhotoRow* _tmp90_;
	const gchar* _tmp91_;
	gchar* _tmp92_;
	GDestroyNotify _tmp93_;
	sqlite3_stmt* _tmp94_;
	sqlite3* _tmp96_;
	PhotoID _tmp97_ = {0};
#line 518 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 518 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 518 "../src/db/PhotoTable.vala"
	g_return_if_fail (new_filename != NULL);
#line 518 "../src/db/PhotoTable.vala"
	g_return_if_fail (editable_id != NULL);
#line 518 "../src/db/PhotoTable.vala"
	g_return_if_fail (develop_shotwell != NULL);
#line 518 "../src/db/PhotoTable.vala"
	g_return_if_fail (develop_camera_id != NULL);
#line 518 "../src/db/PhotoTable.vala"
	g_return_if_fail (develop_embedded_id != NULL);
#line 522 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 522 "../src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_row (self, &_tmp0_);
#line 522 "../src/db/PhotoTable.vala"
	original = _tmp1_;
#line 525 "../src/db/PhotoTable.vala"
	_tmp2_ = database_table_db;
#line 525 "../src/db/PhotoTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp2_, "INSERT INTO PhotoTable (filename, width, height, filesize, " "timestamp, exposure_time, orientation, original_orientation, import_id" \
", event_id, " "transformations, md5, thumbnail_md5, exif_md5, time_created, flags, ra" \
"ting, " "file_format, title, has_gps, gps_lat, gps_lon, editable_id, developer," \
" " "develop_shotwell_id, develop_camera_id, develop_embedded_id, comment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?," \
" ?, ?, ?, ?, ?, ?, ?)", -1, &_tmp3_, NULL);
#line 525 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 525 "../src/db/PhotoTable.vala"
	stmt = _tmp3_;
#line 525 "../src/db/PhotoTable.vala"
	res = _tmp4_;
#line 532 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 534 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 534 "../src/db/PhotoTable.vala"
	_tmp6_ = g_strdup (new_filename);
#line 534 "../src/db/PhotoTable.vala"
	_tmp7_ = g_free;
#line 534 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp5_, 1, _tmp6_, -1, _tmp7_);
#line 535 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 536 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 536 "../src/db/PhotoTable.vala"
	_tmp9_ = original;
#line 536 "../src/db/PhotoTable.vala"
	_tmp10_ = _tmp9_->master;
#line 536 "../src/db/PhotoTable.vala"
	_tmp11_ = _tmp10_->dim;
#line 536 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp8_, 2, _tmp11_.width);
#line 537 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 538 "../src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 538 "../src/db/PhotoTable.vala"
	_tmp13_ = original;
#line 538 "../src/db/PhotoTable.vala"
	_tmp14_ = _tmp13_->master;
#line 538 "../src/db/PhotoTable.vala"
	_tmp15_ = _tmp14_->dim;
#line 538 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp12_, 3, _tmp15_.height);
#line 539 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 540 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 540 "../src/db/PhotoTable.vala"
	_tmp17_ = original;
#line 540 "../src/db/PhotoTable.vala"
	_tmp18_ = _tmp17_->master;
#line 540 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp16_, 4, _tmp18_->filesize);
#line 541 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 542 "../src/db/PhotoTable.vala"
	_tmp19_ = stmt;
#line 542 "../src/db/PhotoTable.vala"
	_tmp20_ = original;
#line 542 "../src/db/PhotoTable.vala"
	_tmp21_ = _tmp20_->master;
#line 542 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp19_, 5, (gint64) _tmp21_->timestamp);
#line 543 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 544 "../src/db/PhotoTable.vala"
	_tmp22_ = stmt;
#line 544 "../src/db/PhotoTable.vala"
	_tmp23_ = original;
#line 544 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp22_, 6, (gint64) _tmp23_->exposure_time);
#line 545 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 546 "../src/db/PhotoTable.vala"
	_tmp24_ = stmt;
#line 546 "../src/db/PhotoTable.vala"
	_tmp25_ = original;
#line 546 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp24_, 7, (gint) _tmp25_->orientation);
#line 547 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 548 "../src/db/PhotoTable.vala"
	_tmp26_ = stmt;
#line 548 "../src/db/PhotoTable.vala"
	_tmp27_ = original;
#line 548 "../src/db/PhotoTable.vala"
	_tmp28_ = _tmp27_->master;
#line 548 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp26_, 8, (gint) _tmp28_->original_orientation);
#line 549 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 550 "../src/db/PhotoTable.vala"
	_tmp29_ = stmt;
#line 550 "../src/db/PhotoTable.vala"
	_tmp30_ = original;
#line 550 "../src/db/PhotoTable.vala"
	_tmp31_ = _tmp30_->import_id;
#line 550 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp29_, 9, _tmp31_.id);
#line 551 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 552 "../src/db/PhotoTable.vala"
	_tmp32_ = stmt;
#line 552 "../src/db/PhotoTable.vala"
	_tmp33_ = original;
#line 552 "../src/db/PhotoTable.vala"
	_tmp34_ = _tmp33_->event_id;
#line 552 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp32_, 10, _tmp34_.id);
#line 553 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 554 "../src/db/PhotoTable.vala"
	_tmp35_ = stmt;
#line 554 "../src/db/PhotoTable.vala"
	_tmp36_ = original;
#line 554 "../src/db/PhotoTable.vala"
	_tmp37_ = _tmp36_->transformations;
#line 554 "../src/db/PhotoTable.vala"
	_tmp38_ = photo_table_unmarshall_all_transformations (_tmp37_);
#line 554 "../src/db/PhotoTable.vala"
	_tmp39_ = g_free;
#line 554 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp35_, 11, _tmp38_, -1, _tmp39_);
#line 555 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 556 "../src/db/PhotoTable.vala"
	_tmp40_ = stmt;
#line 556 "../src/db/PhotoTable.vala"
	_tmp41_ = original;
#line 556 "../src/db/PhotoTable.vala"
	_tmp42_ = _tmp41_->md5;
#line 556 "../src/db/PhotoTable.vala"
	_tmp43_ = g_strdup (_tmp42_);
#line 556 "../src/db/PhotoTable.vala"
	_tmp44_ = g_free;
#line 556 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp40_, 12, _tmp43_, -1, _tmp44_);
#line 557 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 558 "../src/db/PhotoTable.vala"
	_tmp45_ = stmt;
#line 558 "../src/db/PhotoTable.vala"
	_tmp46_ = original;
#line 558 "../src/db/PhotoTable.vala"
	_tmp47_ = _tmp46_->thumbnail_md5;
#line 558 "../src/db/PhotoTable.vala"
	_tmp48_ = g_strdup (_tmp47_);
#line 558 "../src/db/PhotoTable.vala"
	_tmp49_ = g_free;
#line 558 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp45_, 13, _tmp48_, -1, _tmp49_);
#line 559 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 560 "../src/db/PhotoTable.vala"
	_tmp50_ = stmt;
#line 560 "../src/db/PhotoTable.vala"
	_tmp51_ = original;
#line 560 "../src/db/PhotoTable.vala"
	_tmp52_ = _tmp51_->exif_md5;
#line 560 "../src/db/PhotoTable.vala"
	_tmp53_ = g_strdup (_tmp52_);
#line 560 "../src/db/PhotoTable.vala"
	_tmp54_ = g_free;
#line 560 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp50_, 14, _tmp53_, -1, _tmp54_);
#line 561 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 562 "../src/db/PhotoTable.vala"
	_tmp55_ = stmt;
#line 562 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp55_, 15, (gint64) now_sec ());
#line 563 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 564 "../src/db/PhotoTable.vala"
	_tmp56_ = stmt;
#line 564 "../src/db/PhotoTable.vala"
	_tmp57_ = original;
#line 564 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp56_, 16, (gint64) _tmp57_->flags);
#line 565 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 566 "../src/db/PhotoTable.vala"
	_tmp58_ = stmt;
#line 566 "../src/db/PhotoTable.vala"
	_tmp59_ = original;
#line 566 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp58_, 17, (gint64) rating_serialize (_tmp59_->rating));
#line 567 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 568 "../src/db/PhotoTable.vala"
	_tmp60_ = stmt;
#line 568 "../src/db/PhotoTable.vala"
	_tmp61_ = original;
#line 568 "../src/db/PhotoTable.vala"
	_tmp62_ = _tmp61_->master;
#line 568 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp60_, 18, photo_file_format_serialize (_tmp62_->file_format));
#line 569 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 570 "../src/db/PhotoTable.vala"
	_tmp63_ = stmt;
#line 570 "../src/db/PhotoTable.vala"
	_tmp64_ = original;
#line 570 "../src/db/PhotoTable.vala"
	_tmp65_ = _tmp64_->title;
#line 570 "../src/db/PhotoTable.vala"
	_tmp66_ = g_strdup (_tmp65_);
#line 570 "../src/db/PhotoTable.vala"
	_tmp67_ = g_free;
#line 570 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp63_, 19, _tmp66_, -1, _tmp67_);
#line 571 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 572 "../src/db/PhotoTable.vala"
	_tmp68_ = stmt;
#line 572 "../src/db/PhotoTable.vala"
	_tmp69_ = original;
#line 572 "../src/db/PhotoTable.vala"
	_tmp70_ = _tmp69_->gps_coords;
#line 572 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp68_, 20, _tmp70_.has_gps);
#line 573 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 574 "../src/db/PhotoTable.vala"
	_tmp71_ = stmt;
#line 574 "../src/db/PhotoTable.vala"
	_tmp72_ = original;
#line 574 "../src/db/PhotoTable.vala"
	_tmp73_ = _tmp72_->gps_coords;
#line 574 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp71_, 21, _tmp73_.latitude);
#line 575 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 576 "../src/db/PhotoTable.vala"
	_tmp74_ = stmt;
#line 576 "../src/db/PhotoTable.vala"
	_tmp75_ = original;
#line 576 "../src/db/PhotoTable.vala"
	_tmp76_ = _tmp75_->gps_coords;
#line 576 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp74_, 22, _tmp76_.longitude);
#line 577 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 578 "../src/db/PhotoTable.vala"
	_tmp77_ = stmt;
#line 578 "../src/db/PhotoTable.vala"
	_tmp78_ = *editable_id;
#line 578 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp77_, 23, _tmp78_.id);
#line 579 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 580 "../src/db/PhotoTable.vala"
	_tmp79_ = stmt;
#line 580 "../src/db/PhotoTable.vala"
	_tmp80_ = original;
#line 580 "../src/db/PhotoTable.vala"
	_tmp81_ = raw_developer_to_string (_tmp80_->developer);
#line 580 "../src/db/PhotoTable.vala"
	_tmp82_ = g_free;
#line 580 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp79_, 24, _tmp81_, -1, _tmp82_);
#line 581 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 582 "../src/db/PhotoTable.vala"
	_tmp83_ = stmt;
#line 582 "../src/db/PhotoTable.vala"
	_tmp84_ = *develop_shotwell;
#line 582 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp83_, 25, _tmp84_.id);
#line 583 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 584 "../src/db/PhotoTable.vala"
	_tmp85_ = stmt;
#line 584 "../src/db/PhotoTable.vala"
	_tmp86_ = *develop_camera_id;
#line 584 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp85_, 26, _tmp86_.id);
#line 585 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 586 "../src/db/PhotoTable.vala"
	_tmp87_ = stmt;
#line 586 "../src/db/PhotoTable.vala"
	_tmp88_ = *develop_embedded_id;
#line 586 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp87_, 27, _tmp88_.id);
#line 587 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 588 "../src/db/PhotoTable.vala"
	_tmp89_ = stmt;
#line 588 "../src/db/PhotoTable.vala"
	_tmp90_ = original;
#line 588 "../src/db/PhotoTable.vala"
	_tmp91_ = _tmp90_->comment;
#line 588 "../src/db/PhotoTable.vala"
	_tmp92_ = g_strdup (_tmp91_);
#line 588 "../src/db/PhotoTable.vala"
	_tmp93_ = g_free;
#line 588 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp89_, 28, _tmp92_, -1, _tmp93_);
#line 589 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 591 "../src/db/PhotoTable.vala"
	_tmp94_ = stmt;
#line 591 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp94_);
#line 592 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 3717 "PhotoTable.c"
		PhotoID _tmp95_ = {0};
#line 593 "../src/db/PhotoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 594 "../src/db/PhotoTable.vala"
			database_table_fatal ("duplicate", res);
#line 3723 "PhotoTable.c"
		}
#line 596 "../src/db/PhotoTable.vala"
		photo_id_init (&_tmp95_, PHOTO_ID_INVALID);
#line 596 "../src/db/PhotoTable.vala"
		*result = _tmp95_;
#line 596 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 596 "../src/db/PhotoTable.vala"
		_photo_row_unref0 (original);
#line 596 "../src/db/PhotoTable.vala"
		return;
#line 3735 "PhotoTable.c"
	}
#line 599 "../src/db/PhotoTable.vala"
	_tmp96_ = database_table_db;
#line 599 "../src/db/PhotoTable.vala"
	photo_id_init (&_tmp97_, sqlite3_last_insert_rowid (_tmp96_));
#line 599 "../src/db/PhotoTable.vala"
	*result = _tmp97_;
#line 599 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 599 "../src/db/PhotoTable.vala"
	_photo_row_unref0 (original);
#line 599 "../src/db/PhotoTable.vala"
	return;
#line 3749 "PhotoTable.c"
}

gboolean
photo_table_set_title (PhotoTable* self,
                       PhotoID* photo_id,
                       const gchar* new_title)
{
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	gboolean result = FALSE;
#line 602 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 602 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 603 "../src/db/PhotoTable.vala"
	if (new_title != NULL) {
#line 603 "../src/db/PhotoTable.vala"
		_tmp0_ = new_title;
#line 3768 "PhotoTable.c"
	} else {
#line 603 "../src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 3772 "PhotoTable.c"
	}
#line 603 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 603 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "title", _tmp0_);
#line 603 "../src/db/PhotoTable.vala"
	return result;
#line 3780 "PhotoTable.c"
}

void
photo_table_set_gps_coords (PhotoTable* self,
                            PhotoID* photo_id,
                            GpsCoords* new_gps_coords,
                            GError** error)
{
	PhotoID _tmp0_;
	GpsCoords _tmp1_;
	GpsCoords _tmp2_;
	GError* _inner_error0_ = NULL;
#line 606 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 606 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 606 "../src/db/PhotoTable.vala"
	g_return_if_fail (new_gps_coords != NULL);
#line 607 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 607 "../src/db/PhotoTable.vala"
	_tmp1_ = *new_gps_coords;
#line 607 "../src/db/PhotoTable.vala"
	database_table_update_int_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "has_gps", _tmp1_.has_gps, &_inner_error0_);
#line 607 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 607 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 607 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 607 "../src/db/PhotoTable.vala"
			return;
#line 3813 "PhotoTable.c"
		} else {
#line 607 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 607 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 607 "../src/db/PhotoTable.vala"
			return;
#line 3821 "PhotoTable.c"
		}
	}
#line 608 "../src/db/PhotoTable.vala"
	_tmp2_ = *new_gps_coords;
#line 608 "../src/db/PhotoTable.vala"
	if (_tmp2_.has_gps > 0) {
#line 3828 "PhotoTable.c"
		PhotoID _tmp3_;
		GpsCoords _tmp4_;
		PhotoID _tmp5_;
		GpsCoords _tmp6_;
#line 609 "../src/db/PhotoTable.vala"
		_tmp3_ = *photo_id;
#line 609 "../src/db/PhotoTable.vala"
		_tmp4_ = *new_gps_coords;
#line 609 "../src/db/PhotoTable.vala"
		database_table_update_double_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp3_.id, "gps_lat", _tmp4_.latitude, &_inner_error0_);
#line 609 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 609 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 609 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 609 "../src/db/PhotoTable.vala"
				return;
#line 3847 "PhotoTable.c"
			} else {
#line 609 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 609 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 609 "../src/db/PhotoTable.vala"
				return;
#line 3855 "PhotoTable.c"
			}
		}
#line 610 "../src/db/PhotoTable.vala"
		_tmp5_ = *photo_id;
#line 610 "../src/db/PhotoTable.vala"
		_tmp6_ = *new_gps_coords;
#line 610 "../src/db/PhotoTable.vala"
		database_table_update_double_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp5_.id, "gps_lon", _tmp6_.longitude, &_inner_error0_);
#line 610 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 610 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 610 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 610 "../src/db/PhotoTable.vala"
				return;
#line 3872 "PhotoTable.c"
			} else {
#line 610 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 610 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 610 "../src/db/PhotoTable.vala"
				return;
#line 3880 "PhotoTable.c"
			}
		}
	}
}

gboolean
photo_table_set_comment (PhotoTable* self,
                         PhotoID* photo_id,
                         const gchar* new_comment)
{
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	gboolean result = FALSE;
#line 614 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 614 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 615 "../src/db/PhotoTable.vala"
	if (new_comment != NULL) {
#line 615 "../src/db/PhotoTable.vala"
		_tmp0_ = new_comment;
#line 3902 "PhotoTable.c"
	} else {
#line 615 "../src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 3906 "PhotoTable.c"
	}
#line 615 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 615 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "comment", _tmp0_);
#line 615 "../src/db/PhotoTable.vala"
	return result;
#line 3914 "PhotoTable.c"
}

void
photo_table_set_filepath (PhotoTable* self,
                          PhotoID* photo_id,
                          const gchar* filepath,
                          GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 618 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 618 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 618 "../src/db/PhotoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 619 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 619 "../src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "filename", filepath, &_inner_error0_);
#line 619 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 619 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 619 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 619 "../src/db/PhotoTable.vala"
			return;
#line 3943 "PhotoTable.c"
		} else {
#line 619 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 619 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 619 "../src/db/PhotoTable.vala"
			return;
#line 3951 "PhotoTable.c"
		}
	}
}

void
photo_table_update_timestamp (PhotoTable* self,
                              PhotoID* photo_id,
                              time_t timestamp,
                              GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 622 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 622 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 623 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 623 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "timestamp", (gint64) timestamp, &_inner_error0_);
#line 623 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 623 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 623 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 623 "../src/db/PhotoTable.vala"
			return;
#line 3980 "PhotoTable.c"
		} else {
#line 623 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 623 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 623 "../src/db/PhotoTable.vala"
			return;
#line 3988 "PhotoTable.c"
		}
	}
}

gboolean
photo_table_set_exposure_time (PhotoTable* self,
                               PhotoID* photo_id,
                               time_t time)
{
	PhotoID _tmp0_;
	gboolean result = FALSE;
#line 626 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 626 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 627 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 627 "../src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "exposure_time", (gint64) time);
#line 627 "../src/db/PhotoTable.vala"
	return result;
#line 4010 "PhotoTable.c"
}

void
photo_table_set_import_id (PhotoTable* self,
                           PhotoID* photo_id,
                           ImportID* import_id,
                           GError** error)
{
	PhotoID _tmp0_;
	ImportID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 630 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 630 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 630 "../src/db/PhotoTable.vala"
	g_return_if_fail (import_id != NULL);
#line 631 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 631 "../src/db/PhotoTable.vala"
	_tmp1_ = *import_id;
#line 631 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "import_id", _tmp1_.id, &_inner_error0_);
#line 631 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 631 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 631 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 631 "../src/db/PhotoTable.vala"
			return;
#line 4042 "PhotoTable.c"
		} else {
#line 631 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 631 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 631 "../src/db/PhotoTable.vala"
			return;
#line 4050 "PhotoTable.c"
		}
	}
}

gboolean
photo_table_remove_by_file (PhotoTable* self,
                            GFile* file)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	GDestroyNotify _tmp5_;
	sqlite3_stmt* _tmp6_;
	gboolean result = FALSE;
#line 634 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 634 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 636 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 636 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "DELETE FROM PhotoTable WHERE filename=?", -1, &_tmp1_, NULL);
#line 636 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 636 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 636 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 637 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 639 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 639 "../src/db/PhotoTable.vala"
	_tmp4_ = g_file_get_path (file);
#line 639 "../src/db/PhotoTable.vala"
	_tmp5_ = g_free;
#line 639 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp4_, -1, _tmp5_);
#line 640 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 642 "../src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 642 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp6_);
#line 643 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 644 "../src/db/PhotoTable.vala"
		database_table_warning ("remove", res);
#line 646 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 646 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 646 "../src/db/PhotoTable.vala"
		return result;
#line 4109 "PhotoTable.c"
	}
#line 649 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 649 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 649 "../src/db/PhotoTable.vala"
	return result;
#line 4117 "PhotoTable.c"
}

void
photo_table_remove (PhotoTable* self,
                    PhotoID* photo_id,
                    GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 652 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 652 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 653 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 653 "../src/db/PhotoTable.vala"
	database_table_delete_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, &_inner_error0_);
#line 653 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 653 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 653 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 653 "../src/db/PhotoTable.vala"
			return;
#line 4143 "PhotoTable.c"
		} else {
#line 653 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 653 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 653 "../src/db/PhotoTable.vala"
			return;
#line 4151 "PhotoTable.c"
		}
	}
}

GeeArrayList*
photo_table_get_photos (PhotoTable* self)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeArrayList* photo_ids = NULL;
	GeeArrayList* _tmp3_;
	GeeArrayList* result = NULL;
#line 656 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 658 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 658 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable", -1, &_tmp1_, NULL);
#line 658 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 658 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 658 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 659 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 661 "../src/db/PhotoTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_PHOTO_ID, (GBoxedCopyFunc) photo_id_dup, (GDestroyNotify) photo_id_free, NULL, NULL, NULL);
#line 661 "../src/db/PhotoTable.vala"
	photo_ids = _tmp3_;
#line 4185 "PhotoTable.c"
	{
		gboolean _tmp4_ = FALSE;
#line 662 "../src/db/PhotoTable.vala"
		_tmp4_ = TRUE;
#line 662 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 4192 "PhotoTable.c"
			sqlite3_stmt* _tmp5_;
			GeeArrayList* _tmp6_;
			sqlite3_stmt* _tmp7_;
			PhotoID _tmp8_ = {0};
#line 662 "../src/db/PhotoTable.vala"
			if (!_tmp4_) {
#line 4199 "PhotoTable.c"
			}
#line 662 "../src/db/PhotoTable.vala"
			_tmp4_ = FALSE;
#line 663 "../src/db/PhotoTable.vala"
			_tmp5_ = stmt;
#line 663 "../src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp5_);
#line 664 "../src/db/PhotoTable.vala"
			if (res == SQLITE_DONE) {
#line 665 "../src/db/PhotoTable.vala"
				break;
#line 4211 "PhotoTable.c"
			} else {
#line 666 "../src/db/PhotoTable.vala"
				if (res != SQLITE_ROW) {
#line 667 "../src/db/PhotoTable.vala"
					database_table_fatal ("get_photos", res);
#line 669 "../src/db/PhotoTable.vala"
					break;
#line 4219 "PhotoTable.c"
				}
			}
#line 672 "../src/db/PhotoTable.vala"
			_tmp6_ = photo_ids;
#line 672 "../src/db/PhotoTable.vala"
			_tmp7_ = stmt;
#line 672 "../src/db/PhotoTable.vala"
			photo_id_init (&_tmp8_, sqlite3_column_int64 (_tmp7_, 0));
#line 672 "../src/db/PhotoTable.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp8_);
#line 4230 "PhotoTable.c"
		}
	}
#line 675 "../src/db/PhotoTable.vala"
	result = photo_ids;
#line 675 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 675 "../src/db/PhotoTable.vala"
	return result;
#line 4239 "PhotoTable.c"
}

gboolean
photo_table_set_orientation (PhotoTable* self,
                             PhotoID* photo_id,
                             Orientation orientation)
{
	PhotoID _tmp0_;
	gboolean result = FALSE;
#line 678 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 678 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 679 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 679 "../src/db/PhotoTable.vala"
	result = database_table_update_int_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "orientation", (gint) orientation);
#line 679 "../src/db/PhotoTable.vala"
	return result;
#line 4259 "PhotoTable.c"
}

gboolean
photo_table_replace_flags (PhotoTable* self,
                           PhotoID* photo_id,
                           guint64 flags)
{
	PhotoID _tmp0_;
	gboolean result = FALSE;
#line 682 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 682 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 683 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 683 "../src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "flags", (gint64) flags);
#line 683 "../src/db/PhotoTable.vala"
	return result;
#line 4279 "PhotoTable.c"
}

gboolean
photo_table_set_rating (PhotoTable* self,
                        PhotoID* photo_id,
                        Rating rating)
{
	PhotoID _tmp0_;
	gboolean result = FALSE;
#line 686 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 686 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 687 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 687 "../src/db/PhotoTable.vala"
	result = database_table_update_int_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "rating", rating_serialize (rating));
#line 687 "../src/db/PhotoTable.vala"
	return result;
#line 4299 "PhotoTable.c"
}

gint
photo_table_get_event_photo_count (PhotoTable* self,
                                   EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	EventID _tmp4_;
	gint count = 0;
	gint result = 0;
#line 690 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), 0);
#line 690 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, 0);
#line 692 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 692 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 692 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 692 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 692 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 693 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 695 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 695 "../src/db/PhotoTable.vala"
	_tmp4_ = *event_id;
#line 695 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 696 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 698 "../src/db/PhotoTable.vala"
	count = 0;
#line 4341 "PhotoTable.c"
	{
		gboolean _tmp5_ = FALSE;
#line 699 "../src/db/PhotoTable.vala"
		_tmp5_ = TRUE;
#line 699 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 4348 "PhotoTable.c"
			sqlite3_stmt* _tmp6_;
			gint _tmp7_;
#line 699 "../src/db/PhotoTable.vala"
			if (!_tmp5_) {
#line 4353 "PhotoTable.c"
			}
#line 699 "../src/db/PhotoTable.vala"
			_tmp5_ = FALSE;
#line 700 "../src/db/PhotoTable.vala"
			_tmp6_ = stmt;
#line 700 "../src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp6_);
#line 701 "../src/db/PhotoTable.vala"
			if (res == SQLITE_DONE) {
#line 702 "../src/db/PhotoTable.vala"
				break;
#line 4365 "PhotoTable.c"
			} else {
#line 703 "../src/db/PhotoTable.vala"
				if (res != SQLITE_ROW) {
#line 704 "../src/db/PhotoTable.vala"
					database_table_fatal ("get_event_photo_count", res);
#line 706 "../src/db/PhotoTable.vala"
					break;
#line 4373 "PhotoTable.c"
				}
			}
#line 709 "../src/db/PhotoTable.vala"
			_tmp7_ = count;
#line 709 "../src/db/PhotoTable.vala"
			count = _tmp7_ + 1;
#line 4380 "PhotoTable.c"
		}
	}
#line 712 "../src/db/PhotoTable.vala"
	result = count;
#line 712 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 712 "../src/db/PhotoTable.vala"
	return result;
#line 4389 "PhotoTable.c"
}

GeeArrayList*
photo_table_get_event_source_ids (PhotoTable* self,
                                  EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	EventID _tmp4_;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* result = NULL;
#line 715 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 715 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 717 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 717 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 717 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 717 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 717 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 718 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 720 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 720 "../src/db/PhotoTable.vala"
	_tmp4_ = *event_id;
#line 720 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 721 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 723 "../src/db/PhotoTable.vala"
	_tmp5_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 723 "../src/db/PhotoTable.vala"
	_result_ = _tmp5_;
#line 4434 "PhotoTable.c"
	{
		gboolean _tmp6_ = FALSE;
#line 724 "../src/db/PhotoTable.vala"
		_tmp6_ = TRUE;
#line 724 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 4441 "PhotoTable.c"
			sqlite3_stmt* _tmp7_;
			GeeArrayList* _tmp8_;
			sqlite3_stmt* _tmp9_;
			PhotoID _tmp10_ = {0};
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 724 "../src/db/PhotoTable.vala"
			if (!_tmp6_) {
#line 4450 "PhotoTable.c"
			}
#line 724 "../src/db/PhotoTable.vala"
			_tmp6_ = FALSE;
#line 725 "../src/db/PhotoTable.vala"
			_tmp7_ = stmt;
#line 725 "../src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp7_);
#line 726 "../src/db/PhotoTable.vala"
			if (res == SQLITE_DONE) {
#line 727 "../src/db/PhotoTable.vala"
				break;
#line 4462 "PhotoTable.c"
			} else {
#line 728 "../src/db/PhotoTable.vala"
				if (res != SQLITE_ROW) {
#line 729 "../src/db/PhotoTable.vala"
					database_table_fatal ("get_event_source_ids", res);
#line 731 "../src/db/PhotoTable.vala"
					break;
#line 4470 "PhotoTable.c"
				}
			}
#line 734 "../src/db/PhotoTable.vala"
			_tmp8_ = _result_;
#line 734 "../src/db/PhotoTable.vala"
			_tmp9_ = stmt;
#line 734 "../src/db/PhotoTable.vala"
			photo_id_init (&_tmp10_, sqlite3_column_int64 (_tmp9_, 0));
#line 734 "../src/db/PhotoTable.vala"
			_tmp11_ = photo_id_upgrade_photo_id_to_source_id (&_tmp10_);
#line 734 "../src/db/PhotoTable.vala"
			_tmp12_ = _tmp11_;
#line 734 "../src/db/PhotoTable.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp12_);
#line 734 "../src/db/PhotoTable.vala"
			_g_free0 (_tmp12_);
#line 4487 "PhotoTable.c"
		}
	}
#line 737 "../src/db/PhotoTable.vala"
	result = _result_;
#line 737 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 737 "../src/db/PhotoTable.vala"
	return result;
#line 4496 "PhotoTable.c"
}

gboolean
photo_table_event_has_photos (PhotoTable* self,
                              EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	EventID _tmp4_;
	sqlite3_stmt* _tmp5_;
	gboolean result = FALSE;
#line 740 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 740 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 742 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 742 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable WHERE event_id = ? LIMIT 1", -1, &_tmp1_, NULL);
#line 742 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 742 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 742 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 743 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 745 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 745 "../src/db/PhotoTable.vala"
	_tmp4_ = *event_id;
#line 745 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 746 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 748 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 748 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp5_);
#line 749 "../src/db/PhotoTable.vala"
	if (res == SQLITE_DONE) {
#line 750 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 750 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 750 "../src/db/PhotoTable.vala"
		return result;
#line 4548 "PhotoTable.c"
	} else {
#line 751 "../src/db/PhotoTable.vala"
		if (res != SQLITE_ROW) {
#line 752 "../src/db/PhotoTable.vala"
			database_table_fatal ("event_has_photos", res);
#line 754 "../src/db/PhotoTable.vala"
			result = FALSE;
#line 754 "../src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 754 "../src/db/PhotoTable.vala"
			return result;
#line 4560 "PhotoTable.c"
		}
	}
#line 757 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 757 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 757 "../src/db/PhotoTable.vala"
	return result;
#line 4569 "PhotoTable.c"
}

gboolean
photo_table_drop_event (PhotoTable* self,
                        EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	EventID _tmp5_;
	sqlite3_stmt* _tmp6_;
	gboolean result = FALSE;
#line 760 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 760 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 762 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 762 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET event_id = ? WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 762 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 762 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 762 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 763 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 765 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 765 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, EVENT_ID_INVALID);
#line 766 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 767 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 767 "../src/db/PhotoTable.vala"
	_tmp5_ = *event_id;
#line 767 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 2, _tmp5_.id);
#line 768 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 770 "../src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 770 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp6_);
#line 771 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 772 "../src/db/PhotoTable.vala"
		database_table_fatal ("drop_event", res);
#line 774 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 774 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 774 "../src/db/PhotoTable.vala"
		return result;
#line 4630 "PhotoTable.c"
	}
#line 777 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 777 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 777 "../src/db/PhotoTable.vala"
	return result;
#line 4638 "PhotoTable.c"
}

gboolean
photo_table_set_event (PhotoTable* self,
                       PhotoID* photo_id,
                       EventID* event_id)
{
	PhotoID _tmp0_;
	EventID _tmp1_;
	gboolean result = FALSE;
#line 780 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 780 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 780 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 781 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 781 "../src/db/PhotoTable.vala"
	_tmp1_ = *event_id;
#line 781 "../src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "event_id", _tmp1_.id);
#line 781 "../src/db/PhotoTable.vala"
	return result;
#line 4663 "PhotoTable.c"
}

static gchar*
photo_table_get_raw_transformations (PhotoTable* self,
                                     PhotoID* photo_id)
{
	sqlite3_stmt* stmt = NULL;
	PhotoID _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gboolean _tmp2_;
	gchar* trans = NULL;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gchar* result = NULL;
#line 784 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 784 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 786 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 786 "../src/db/PhotoTable.vala"
	_tmp2_ = database_table_select_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "transformations", &_tmp1_);
#line 786 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 786 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 786 "../src/db/PhotoTable.vala"
	if (!_tmp2_) {
#line 787 "../src/db/PhotoTable.vala"
		result = NULL;
#line 787 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 787 "../src/db/PhotoTable.vala"
		return result;
#line 4701 "PhotoTable.c"
	}
#line 789 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 789 "../src/db/PhotoTable.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (_tmp3_, 0);
#line 789 "../src/db/PhotoTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 789 "../src/db/PhotoTable.vala"
	trans = _tmp5_;
#line 790 "../src/db/PhotoTable.vala"
	_tmp7_ = trans;
#line 790 "../src/db/PhotoTable.vala"
	if (_tmp7_ == NULL) {
#line 790 "../src/db/PhotoTable.vala"
		_tmp6_ = TRUE;
#line 4717 "PhotoTable.c"
	} else {
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 790 "../src/db/PhotoTable.vala"
		_tmp8_ = trans;
#line 790 "../src/db/PhotoTable.vala"
		_tmp9_ = strlen (_tmp8_);
#line 790 "../src/db/PhotoTable.vala"
		_tmp10_ = _tmp9_;
#line 790 "../src/db/PhotoTable.vala"
		_tmp6_ = _tmp10_ == 0;
#line 4730 "PhotoTable.c"
	}
#line 790 "../src/db/PhotoTable.vala"
	if (_tmp6_) {
#line 791 "../src/db/PhotoTable.vala"
		result = NULL;
#line 791 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 791 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 791 "../src/db/PhotoTable.vala"
		return result;
#line 4742 "PhotoTable.c"
	}
#line 793 "../src/db/PhotoTable.vala"
	result = trans;
#line 793 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 793 "../src/db/PhotoTable.vala"
	return result;
#line 4750 "PhotoTable.c"
}

static gboolean
photo_table_set_raw_transformations (PhotoTable* self,
                                     PhotoID* photo_id,
                                     const gchar* trans)
{
	PhotoID _tmp0_;
	gboolean result = FALSE;
#line 796 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 796 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 796 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 797 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 797 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "transformations", trans);
#line 797 "../src/db/PhotoTable.vala"
	return result;
#line 4772 "PhotoTable.c"
}

gboolean
photo_table_set_transformation_state (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation,
                                      GeeHashMap* transformations)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	gchar* _tmp5_;
	GDestroyNotify _tmp6_;
	sqlite3_stmt* _tmp7_;
	PhotoID _tmp8_;
	sqlite3_stmt* _tmp9_;
	gboolean result = FALSE;
#line 800 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 800 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 800 "../src/db/PhotoTable.vala"
	g_return_val_if_fail ((transformations == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformations, GEE_TYPE_HASH_MAP), FALSE);
#line 803 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 803 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET orientation = ?, transformations = ? WHERE id = " \
"?", -1, &_tmp1_, NULL);
#line 803 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 803 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 803 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 805 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 807 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 807 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp3_, 1, (gint) orientation);
#line 808 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 809 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 809 "../src/db/PhotoTable.vala"
	_tmp5_ = photo_table_unmarshall_all_transformations (transformations);
#line 809 "../src/db/PhotoTable.vala"
	_tmp6_ = g_free;
#line 809 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp4_, 2, _tmp5_, -1, _tmp6_);
#line 810 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 811 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 811 "../src/db/PhotoTable.vala"
	_tmp8_ = *photo_id;
#line 811 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 3, _tmp8_.id);
#line 812 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 814 "../src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 814 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp9_);
#line 815 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 816 "../src/db/PhotoTable.vala"
		database_table_fatal ("set_transformation_state", res);
#line 818 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 818 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 818 "../src/db/PhotoTable.vala"
		return result;
#line 4850 "PhotoTable.c"
	}
#line 821 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 821 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 821 "../src/db/PhotoTable.vala"
	return result;
#line 4858 "PhotoTable.c"
}

GeeHashMap*
photo_table_marshall_all_transformations (const gchar* trans)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	GeeHashMap* result = NULL;
#line 825 "../src/db/PhotoTable.vala"
	if (trans == NULL) {
#line 825 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 4871 "PhotoTable.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 825 "../src/db/PhotoTable.vala"
		_tmp1_ = strlen (trans);
#line 825 "../src/db/PhotoTable.vala"
		_tmp2_ = _tmp1_;
#line 825 "../src/db/PhotoTable.vala"
		_tmp0_ = _tmp2_ == 0;
#line 4881 "PhotoTable.c"
	}
#line 825 "../src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 826 "../src/db/PhotoTable.vala"
		result = NULL;
#line 826 "../src/db/PhotoTable.vala"
		return result;
#line 4889 "PhotoTable.c"
	}
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GKeyFile* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		GeeHashMap* map = NULL;
		GeeHashMap* _tmp8_;
		gchar** objects = NULL;
		GKeyFile* _tmp9_;
		gsize _tmp10_ = 0;
		gchar** _tmp11_;
		gint objects_length1;
		gint _objects_size_;
		gchar** _tmp12_;
		gint _tmp12__length1;
#line 829 "../src/db/PhotoTable.vala"
		_tmp3_ = g_key_file_new ();
#line 829 "../src/db/PhotoTable.vala"
		keyfile = _tmp3_;
#line 830 "../src/db/PhotoTable.vala"
		_tmp5_ = keyfile;
#line 830 "../src/db/PhotoTable.vala"
		_tmp6_ = strlen (trans);
#line 830 "../src/db/PhotoTable.vala"
		_tmp7_ = _tmp6_;
#line 830 "../src/db/PhotoTable.vala"
		_tmp4_ = g_key_file_load_from_data (_tmp5_, trans, (gsize) _tmp7_, G_KEY_FILE_NONE, &_inner_error0_);
#line 830 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 830 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 4924 "PhotoTable.c"
			goto __catch0_g_error;
		}
#line 830 "../src/db/PhotoTable.vala"
		if (!_tmp4_) {
#line 831 "../src/db/PhotoTable.vala"
			result = NULL;
#line 831 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 831 "../src/db/PhotoTable.vala"
			return result;
#line 4935 "PhotoTable.c"
		}
#line 833 "../src/db/PhotoTable.vala"
		_tmp8_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 833 "../src/db/PhotoTable.vala"
		map = _tmp8_;
#line 835 "../src/db/PhotoTable.vala"
		_tmp9_ = keyfile;
#line 835 "../src/db/PhotoTable.vala"
		_tmp11_ = g_key_file_get_groups (_tmp9_, &_tmp10_);
#line 835 "../src/db/PhotoTable.vala"
		objects = _tmp11_;
#line 835 "../src/db/PhotoTable.vala"
		objects_length1 = _tmp10_;
#line 835 "../src/db/PhotoTable.vala"
		_objects_size_ = objects_length1;
#line 836 "../src/db/PhotoTable.vala"
		_tmp12_ = objects;
#line 836 "../src/db/PhotoTable.vala"
		_tmp12__length1 = objects_length1;
#line 4955 "PhotoTable.c"
		{
			gchar** object_collection = NULL;
			gint object_collection_length1 = 0;
			gint _object_collection_size_ = 0;
			gint object_it = 0;
#line 836 "../src/db/PhotoTable.vala"
			object_collection = _tmp12_;
#line 836 "../src/db/PhotoTable.vala"
			object_collection_length1 = _tmp12__length1;
#line 836 "../src/db/PhotoTable.vala"
			for (object_it = 0; object_it < object_collection_length1; object_it = object_it + 1) {
#line 4967 "PhotoTable.c"
				gchar* _tmp13_;
				gchar* object = NULL;
#line 836 "../src/db/PhotoTable.vala"
				_tmp13_ = g_strdup (object_collection[object_it]);
#line 836 "../src/db/PhotoTable.vala"
				object = _tmp13_;
#line 4974 "PhotoTable.c"
				{
					gchar** keys = NULL;
					GKeyFile* _tmp14_;
					const gchar* _tmp15_;
					gsize _tmp16_ = 0;
					gchar** _tmp17_;
					gint keys_length1;
					gint _keys_size_;
					gboolean _tmp18_ = FALSE;
					gchar** _tmp19_;
					gint _tmp19__length1;
					KeyValueMap* key_map = NULL;
					const gchar* _tmp21_;
					KeyValueMap* _tmp22_;
					GeeHashMap* _tmp35_;
					const gchar* _tmp36_;
					KeyValueMap* _tmp37_;
#line 837 "../src/db/PhotoTable.vala"
					_tmp14_ = keyfile;
#line 837 "../src/db/PhotoTable.vala"
					_tmp15_ = object;
#line 837 "../src/db/PhotoTable.vala"
					_tmp17_ = g_key_file_get_keys (_tmp14_, _tmp15_, &_tmp16_, &_inner_error0_);
#line 837 "../src/db/PhotoTable.vala"
					keys = _tmp17_;
#line 837 "../src/db/PhotoTable.vala"
					keys_length1 = _tmp16_;
#line 837 "../src/db/PhotoTable.vala"
					_keys_size_ = keys_length1;
#line 837 "../src/db/PhotoTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 837 "../src/db/PhotoTable.vala"
						_g_free0 (object);
#line 837 "../src/db/PhotoTable.vala"
						objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 837 "../src/db/PhotoTable.vala"
						_g_object_unref0 (map);
#line 837 "../src/db/PhotoTable.vala"
						_g_key_file_unref0 (keyfile);
#line 5014 "PhotoTable.c"
						goto __catch0_g_error;
					}
#line 838 "../src/db/PhotoTable.vala"
					_tmp19_ = keys;
#line 838 "../src/db/PhotoTable.vala"
					_tmp19__length1 = keys_length1;
#line 838 "../src/db/PhotoTable.vala"
					if (_tmp19_ == NULL) {
#line 838 "../src/db/PhotoTable.vala"
						_tmp18_ = TRUE;
#line 5025 "PhotoTable.c"
					} else {
						gchar** _tmp20_;
						gint _tmp20__length1;
#line 838 "../src/db/PhotoTable.vala"
						_tmp20_ = keys;
#line 838 "../src/db/PhotoTable.vala"
						_tmp20__length1 = keys_length1;
#line 838 "../src/db/PhotoTable.vala"
						_tmp18_ = _tmp20__length1 == 0;
#line 5035 "PhotoTable.c"
					}
#line 838 "../src/db/PhotoTable.vala"
					if (_tmp18_) {
#line 839 "../src/db/PhotoTable.vala"
						keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 839 "../src/db/PhotoTable.vala"
						_g_free0 (object);
#line 839 "../src/db/PhotoTable.vala"
						continue;
#line 5045 "PhotoTable.c"
					}
#line 841 "../src/db/PhotoTable.vala"
					_tmp21_ = object;
#line 841 "../src/db/PhotoTable.vala"
					_tmp22_ = key_value_map_new (_tmp21_);
#line 841 "../src/db/PhotoTable.vala"
					key_map = _tmp22_;
#line 5053 "PhotoTable.c"
					{
						gint ctr = 0;
#line 842 "../src/db/PhotoTable.vala"
						ctr = 0;
#line 5058 "PhotoTable.c"
						{
							gboolean _tmp23_ = FALSE;
#line 842 "../src/db/PhotoTable.vala"
							_tmp23_ = TRUE;
#line 842 "../src/db/PhotoTable.vala"
							while (TRUE) {
#line 5065 "PhotoTable.c"
								gchar** _tmp25_;
								gint _tmp25__length1;
								gchar* _tmp26_ = NULL;
								GKeyFile* _tmp27_;
								const gchar* _tmp28_;
								gchar** _tmp29_;
								gint _tmp29__length1;
								const gchar* _tmp30_;
								gchar* _tmp31_;
								KeyValueMap* _tmp32_;
								gchar** _tmp33_;
								gint _tmp33__length1;
								const gchar* _tmp34_;
#line 842 "../src/db/PhotoTable.vala"
								if (!_tmp23_) {
#line 5081 "PhotoTable.c"
									gint _tmp24_;
#line 842 "../src/db/PhotoTable.vala"
									_tmp24_ = ctr;
#line 842 "../src/db/PhotoTable.vala"
									ctr = _tmp24_ + 1;
#line 5087 "PhotoTable.c"
								}
#line 842 "../src/db/PhotoTable.vala"
								_tmp23_ = FALSE;
#line 842 "../src/db/PhotoTable.vala"
								_tmp25_ = keys;
#line 842 "../src/db/PhotoTable.vala"
								_tmp25__length1 = keys_length1;
#line 842 "../src/db/PhotoTable.vala"
								if (!(ctr < _tmp25__length1)) {
#line 842 "../src/db/PhotoTable.vala"
									break;
#line 5099 "PhotoTable.c"
								}
#line 843 "../src/db/PhotoTable.vala"
								_tmp27_ = keyfile;
#line 843 "../src/db/PhotoTable.vala"
								_tmp28_ = object;
#line 843 "../src/db/PhotoTable.vala"
								_tmp29_ = keys;
#line 843 "../src/db/PhotoTable.vala"
								_tmp29__length1 = keys_length1;
#line 843 "../src/db/PhotoTable.vala"
								_tmp30_ = _tmp29_[ctr];
#line 843 "../src/db/PhotoTable.vala"
								_tmp31_ = g_key_file_get_string (_tmp27_, _tmp28_, _tmp30_, &_inner_error0_);
#line 843 "../src/db/PhotoTable.vala"
								_tmp26_ = _tmp31_;
#line 843 "../src/db/PhotoTable.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 843 "../src/db/PhotoTable.vala"
									_key_value_map_unref0 (key_map);
#line 843 "../src/db/PhotoTable.vala"
									keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 843 "../src/db/PhotoTable.vala"
									_g_free0 (object);
#line 843 "../src/db/PhotoTable.vala"
									objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 843 "../src/db/PhotoTable.vala"
									_g_object_unref0 (map);
#line 843 "../src/db/PhotoTable.vala"
									_g_key_file_unref0 (keyfile);
#line 5129 "PhotoTable.c"
									goto __catch0_g_error;
								}
#line 843 "../src/db/PhotoTable.vala"
								_tmp32_ = key_map;
#line 843 "../src/db/PhotoTable.vala"
								_tmp33_ = keys;
#line 843 "../src/db/PhotoTable.vala"
								_tmp33__length1 = keys_length1;
#line 843 "../src/db/PhotoTable.vala"
								_tmp34_ = _tmp33_[ctr];
#line 843 "../src/db/PhotoTable.vala"
								key_value_map_set_string (_tmp32_, _tmp34_, _tmp26_);
#line 842 "../src/db/PhotoTable.vala"
								_g_free0 (_tmp26_);
#line 5144 "PhotoTable.c"
							}
						}
					}
#line 845 "../src/db/PhotoTable.vala"
					_tmp35_ = map;
#line 845 "../src/db/PhotoTable.vala"
					_tmp36_ = object;
#line 845 "../src/db/PhotoTable.vala"
					_tmp37_ = key_map;
#line 845 "../src/db/PhotoTable.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp36_, _tmp37_);
#line 836 "../src/db/PhotoTable.vala"
					_key_value_map_unref0 (key_map);
#line 836 "../src/db/PhotoTable.vala"
					keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 836 "../src/db/PhotoTable.vala"
					_g_free0 (object);
#line 5162 "PhotoTable.c"
				}
			}
		}
#line 848 "../src/db/PhotoTable.vala"
		result = map;
#line 848 "../src/db/PhotoTable.vala"
		objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 848 "../src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 848 "../src/db/PhotoTable.vala"
		return result;
#line 5174 "PhotoTable.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp38_;
#line 828 "../src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 828 "../src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 850 "../src/db/PhotoTable.vala"
		_tmp38_ = err->message;
#line 850 "../src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:850: %s", _tmp38_);
#line 828 "../src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 5191 "PhotoTable.c"
	}
	__finally0:
#line 828 "../src/db/PhotoTable.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 828 "../src/db/PhotoTable.vala"
	g_clear_error (&_inner_error0_);
#line 828 "../src/db/PhotoTable.vala"
	return NULL;
#line 5200 "PhotoTable.c"
}

gchar*
photo_table_unmarshall_all_transformations (GeeHashMap* transformations)
{
	gboolean _tmp0_ = FALSE;
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp6_;
	gsize length = 0UL;
	gchar* unmarshalled = NULL;
	GKeyFile* _tmp33_;
	gsize _tmp34_ = 0UL;
	gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	gchar* result = NULL;
#line 854 "../src/db/PhotoTable.vala"
	g_return_val_if_fail ((transformations == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformations, GEE_TYPE_HASH_MAP), NULL);
#line 855 "../src/db/PhotoTable.vala"
	if (transformations == NULL) {
#line 855 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 5225 "PhotoTable.c"
	} else {
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 855 "../src/db/PhotoTable.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (transformations, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 855 "../src/db/PhotoTable.vala"
		_tmp2_ = _tmp1_;
#line 855 "../src/db/PhotoTable.vala"
		_tmp3_ = _tmp2_;
#line 855 "../src/db/PhotoTable.vala"
		_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 855 "../src/db/PhotoTable.vala"
		_tmp5_ = _tmp4_;
#line 855 "../src/db/PhotoTable.vala"
		_tmp0_ = _tmp5_ == 0;
#line 855 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp3_);
#line 5246 "PhotoTable.c"
	}
#line 855 "../src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 856 "../src/db/PhotoTable.vala"
		result = NULL;
#line 856 "../src/db/PhotoTable.vala"
		return result;
#line 5254 "PhotoTable.c"
	}
#line 858 "../src/db/PhotoTable.vala"
	_tmp6_ = g_key_file_new ();
#line 858 "../src/db/PhotoTable.vala"
	keyfile = _tmp6_;
#line 5260 "PhotoTable.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 860 "../src/db/PhotoTable.vala"
		_tmp7_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (transformations, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 860 "../src/db/PhotoTable.vala"
		_tmp8_ = _tmp7_;
#line 860 "../src/db/PhotoTable.vala"
		_tmp9_ = _tmp8_;
#line 860 "../src/db/PhotoTable.vala"
		_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 860 "../src/db/PhotoTable.vala"
		_tmp11_ = _tmp10_;
#line 860 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp9_);
#line 860 "../src/db/PhotoTable.vala"
		_object_it = _tmp11_;
#line 860 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 5284 "PhotoTable.c"
			GeeIterator* _tmp12_;
			gchar* object = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			KeyValueMap* map = NULL;
			const gchar* _tmp15_;
			gpointer _tmp16_;
#line 860 "../src/db/PhotoTable.vala"
			_tmp12_ = _object_it;
#line 860 "../src/db/PhotoTable.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 860 "../src/db/PhotoTable.vala"
				break;
#line 5298 "PhotoTable.c"
			}
#line 860 "../src/db/PhotoTable.vala"
			_tmp13_ = _object_it;
#line 860 "../src/db/PhotoTable.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 860 "../src/db/PhotoTable.vala"
			object = (gchar*) _tmp14_;
#line 861 "../src/db/PhotoTable.vala"
			_tmp15_ = object;
#line 861 "../src/db/PhotoTable.vala"
			_tmp16_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (transformations, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp15_);
#line 861 "../src/db/PhotoTable.vala"
			map = (KeyValueMap*) _tmp16_;
#line 5312 "PhotoTable.c"
			{
				GeeIterator* _key_it = NULL;
				KeyValueMap* _tmp17_;
				GeeSet* _tmp18_;
				GeeSet* _tmp19_;
				GeeIterator* _tmp20_;
				GeeIterator* _tmp21_;
#line 863 "../src/db/PhotoTable.vala"
				_tmp17_ = map;
#line 863 "../src/db/PhotoTable.vala"
				_tmp18_ = key_value_map_get_keys (_tmp17_);
#line 863 "../src/db/PhotoTable.vala"
				_tmp19_ = _tmp18_;
#line 863 "../src/db/PhotoTable.vala"
				_tmp20_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_ITERABLE, GeeIterable));
#line 863 "../src/db/PhotoTable.vala"
				_tmp21_ = _tmp20_;
#line 863 "../src/db/PhotoTable.vala"
				_g_object_unref0 (_tmp19_);
#line 863 "../src/db/PhotoTable.vala"
				_key_it = _tmp21_;
#line 863 "../src/db/PhotoTable.vala"
				while (TRUE) {
#line 5336 "PhotoTable.c"
					GeeIterator* _tmp22_;
					gchar* key = NULL;
					GeeIterator* _tmp23_;
					gpointer _tmp24_;
					gchar* value = NULL;
					KeyValueMap* _tmp25_;
					const gchar* _tmp26_;
					gchar* _tmp27_;
					const gchar* _tmp28_;
					GKeyFile* _tmp29_;
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
#line 863 "../src/db/PhotoTable.vala"
					_tmp22_ = _key_it;
#line 863 "../src/db/PhotoTable.vala"
					if (!gee_iterator_next (_tmp22_)) {
#line 863 "../src/db/PhotoTable.vala"
						break;
#line 5356 "PhotoTable.c"
					}
#line 863 "../src/db/PhotoTable.vala"
					_tmp23_ = _key_it;
#line 863 "../src/db/PhotoTable.vala"
					_tmp24_ = gee_iterator_get (_tmp23_);
#line 863 "../src/db/PhotoTable.vala"
					key = (gchar*) _tmp24_;
#line 864 "../src/db/PhotoTable.vala"
					_tmp25_ = map;
#line 864 "../src/db/PhotoTable.vala"
					_tmp26_ = key;
#line 864 "../src/db/PhotoTable.vala"
					_tmp27_ = key_value_map_get_string (_tmp25_, _tmp26_, NULL);
#line 864 "../src/db/PhotoTable.vala"
					value = _tmp27_;
#line 865 "../src/db/PhotoTable.vala"
					_tmp28_ = value;
#line 865 "../src/db/PhotoTable.vala"
					_vala_assert (_tmp28_ != NULL, "value != null");
#line 867 "../src/db/PhotoTable.vala"
					_tmp29_ = keyfile;
#line 867 "../src/db/PhotoTable.vala"
					_tmp30_ = object;
#line 867 "../src/db/PhotoTable.vala"
					_tmp31_ = key;
#line 867 "../src/db/PhotoTable.vala"
					_tmp32_ = value;
#line 867 "../src/db/PhotoTable.vala"
					g_key_file_set_string (_tmp29_, _tmp30_, _tmp31_, _tmp32_);
#line 863 "../src/db/PhotoTable.vala"
					_g_free0 (value);
#line 863 "../src/db/PhotoTable.vala"
					_g_free0 (key);
#line 5390 "PhotoTable.c"
				}
#line 863 "../src/db/PhotoTable.vala"
				_g_object_unref0 (_key_it);
#line 5394 "PhotoTable.c"
			}
#line 860 "../src/db/PhotoTable.vala"
			_key_value_map_unref0 (map);
#line 860 "../src/db/PhotoTable.vala"
			_g_free0 (object);
#line 5400 "PhotoTable.c"
		}
#line 860 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_object_it);
#line 5404 "PhotoTable.c"
	}
#line 872 "../src/db/PhotoTable.vala"
	_tmp33_ = keyfile;
#line 872 "../src/db/PhotoTable.vala"
	_tmp35_ = g_key_file_to_data (_tmp33_, &_tmp34_, NULL);
#line 872 "../src/db/PhotoTable.vala"
	length = _tmp34_;
#line 872 "../src/db/PhotoTable.vala"
	unmarshalled = _tmp35_;
#line 873 "../src/db/PhotoTable.vala"
	_tmp36_ = unmarshalled;
#line 873 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp36_ != NULL, "unmarshalled != null");
#line 874 "../src/db/PhotoTable.vala"
	_tmp37_ = unmarshalled;
#line 874 "../src/db/PhotoTable.vala"
	_tmp38_ = strlen (_tmp37_);
#line 874 "../src/db/PhotoTable.vala"
	_tmp39_ = _tmp38_;
#line 874 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp39_ > 0, "unmarshalled.length > 0");
#line 876 "../src/db/PhotoTable.vala"
	result = unmarshalled;
#line 876 "../src/db/PhotoTable.vala"
	_g_key_file_unref0 (keyfile);
#line 876 "../src/db/PhotoTable.vala"
	return result;
#line 5432 "PhotoTable.c"
}

gboolean
photo_table_set_transformation (PhotoTable* self,
                                PhotoID* photo_id,
                                KeyValueMap* map)
{
	gchar* trans = NULL;
	PhotoID _tmp0_;
	gchar* _tmp1_;
	PhotoID _tmp33_;
	const gchar* _tmp34_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 879 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 879 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 879 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, TYPE_KEY_VALUE_MAP), FALSE);
#line 880 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 880 "../src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_raw_transformations (self, &_tmp0_);
#line 880 "../src/db/PhotoTable.vala"
	trans = _tmp1_;
#line 5459 "PhotoTable.c"
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp2_;
		const gchar* _tmp3_;
		GeeSet* keys = NULL;
		GeeSet* _tmp10_;
		gsize length = 0UL;
		GKeyFile* _tmp24_;
		gsize _tmp25_ = 0UL;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
#line 883 "../src/db/PhotoTable.vala"
		_tmp2_ = g_key_file_new ();
#line 883 "../src/db/PhotoTable.vala"
		keyfile = _tmp2_;
#line 884 "../src/db/PhotoTable.vala"
		_tmp3_ = trans;
#line 884 "../src/db/PhotoTable.vala"
		if (_tmp3_ != NULL) {
#line 5482 "PhotoTable.c"
			gboolean _tmp4_ = FALSE;
			GKeyFile* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 885 "../src/db/PhotoTable.vala"
			_tmp5_ = keyfile;
#line 885 "../src/db/PhotoTable.vala"
			_tmp6_ = trans;
#line 885 "../src/db/PhotoTable.vala"
			_tmp7_ = trans;
#line 885 "../src/db/PhotoTable.vala"
			_tmp8_ = strlen (_tmp7_);
#line 885 "../src/db/PhotoTable.vala"
			_tmp9_ = _tmp8_;
#line 885 "../src/db/PhotoTable.vala"
			_tmp4_ = g_key_file_load_from_data (_tmp5_, _tmp6_, (gsize) _tmp9_, G_KEY_FILE_NONE, &_inner_error0_);
#line 885 "../src/db/PhotoTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 885 "../src/db/PhotoTable.vala"
				_g_key_file_unref0 (keyfile);
#line 5505 "PhotoTable.c"
				goto __catch0_g_error;
			}
#line 885 "../src/db/PhotoTable.vala"
			if (!_tmp4_) {
#line 886 "../src/db/PhotoTable.vala"
				result = FALSE;
#line 886 "../src/db/PhotoTable.vala"
				_g_key_file_unref0 (keyfile);
#line 886 "../src/db/PhotoTable.vala"
				_g_free0 (trans);
#line 886 "../src/db/PhotoTable.vala"
				return result;
#line 5518 "PhotoTable.c"
			}
		}
#line 889 "../src/db/PhotoTable.vala"
		_tmp10_ = key_value_map_get_keys (map);
#line 889 "../src/db/PhotoTable.vala"
		keys = _tmp10_;
#line 5525 "PhotoTable.c"
		{
			GeeIterator* _key_it = NULL;
			GeeSet* _tmp11_;
			GeeIterator* _tmp12_;
#line 890 "../src/db/PhotoTable.vala"
			_tmp11_ = keys;
#line 890 "../src/db/PhotoTable.vala"
			_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 890 "../src/db/PhotoTable.vala"
			_key_it = _tmp12_;
#line 890 "../src/db/PhotoTable.vala"
			while (TRUE) {
#line 5538 "PhotoTable.c"
				GeeIterator* _tmp13_;
				gchar* key = NULL;
				GeeIterator* _tmp14_;
				gpointer _tmp15_;
				gchar* value = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				const gchar* _tmp18_;
				GKeyFile* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
#line 890 "../src/db/PhotoTable.vala"
				_tmp13_ = _key_it;
#line 890 "../src/db/PhotoTable.vala"
				if (!gee_iterator_next (_tmp13_)) {
#line 890 "../src/db/PhotoTable.vala"
					break;
#line 5558 "PhotoTable.c"
				}
#line 890 "../src/db/PhotoTable.vala"
				_tmp14_ = _key_it;
#line 890 "../src/db/PhotoTable.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 890 "../src/db/PhotoTable.vala"
				key = (gchar*) _tmp15_;
#line 891 "../src/db/PhotoTable.vala"
				_tmp16_ = key;
#line 891 "../src/db/PhotoTable.vala"
				_tmp17_ = key_value_map_get_string (map, _tmp16_, NULL);
#line 891 "../src/db/PhotoTable.vala"
				value = _tmp17_;
#line 892 "../src/db/PhotoTable.vala"
				_tmp18_ = value;
#line 892 "../src/db/PhotoTable.vala"
				_vala_assert (_tmp18_ != NULL, "value != null");
#line 894 "../src/db/PhotoTable.vala"
				_tmp19_ = keyfile;
#line 894 "../src/db/PhotoTable.vala"
				_tmp20_ = key_value_map_get_group (map);
#line 894 "../src/db/PhotoTable.vala"
				_tmp21_ = _tmp20_;
#line 894 "../src/db/PhotoTable.vala"
				_tmp22_ = key;
#line 894 "../src/db/PhotoTable.vala"
				_tmp23_ = value;
#line 894 "../src/db/PhotoTable.vala"
				g_key_file_set_string (_tmp19_, _tmp21_, _tmp22_, _tmp23_);
#line 894 "../src/db/PhotoTable.vala"
				_g_free0 (_tmp21_);
#line 890 "../src/db/PhotoTable.vala"
				_g_free0 (value);
#line 890 "../src/db/PhotoTable.vala"
				_g_free0 (key);
#line 5594 "PhotoTable.c"
			}
#line 890 "../src/db/PhotoTable.vala"
			_g_object_unref0 (_key_it);
#line 5598 "PhotoTable.c"
		}
#line 898 "../src/db/PhotoTable.vala"
		_tmp24_ = keyfile;
#line 898 "../src/db/PhotoTable.vala"
		_tmp26_ = g_key_file_to_data (_tmp24_, &_tmp25_, NULL);
#line 898 "../src/db/PhotoTable.vala"
		length = _tmp25_;
#line 898 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 898 "../src/db/PhotoTable.vala"
		trans = _tmp26_;
#line 899 "../src/db/PhotoTable.vala"
		_tmp27_ = trans;
#line 899 "../src/db/PhotoTable.vala"
		_vala_assert (_tmp27_ != NULL, "trans != null");
#line 900 "../src/db/PhotoTable.vala"
		_tmp28_ = trans;
#line 900 "../src/db/PhotoTable.vala"
		_tmp29_ = strlen (_tmp28_);
#line 900 "../src/db/PhotoTable.vala"
		_tmp30_ = _tmp29_;
#line 900 "../src/db/PhotoTable.vala"
		_vala_assert (_tmp30_ > 0, "trans.length > 0");
#line 882 "../src/db/PhotoTable.vala"
		_g_object_unref0 (keys);
#line 882 "../src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 5626 "PhotoTable.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp31_;
#line 882 "../src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 882 "../src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 902 "../src/db/PhotoTable.vala"
		_tmp31_ = err->message;
#line 902 "../src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:902: %s", _tmp31_);
#line 882 "../src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 5643 "PhotoTable.c"
	}
	__finally0:
#line 882 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5648 "PhotoTable.c"
		gboolean _tmp32_ = FALSE;
#line 882 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 882 "../src/db/PhotoTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 882 "../src/db/PhotoTable.vala"
		g_clear_error (&_inner_error0_);
#line 882 "../src/db/PhotoTable.vala"
		return _tmp32_;
#line 5658 "PhotoTable.c"
	}
#line 905 "../src/db/PhotoTable.vala"
	_tmp33_ = *photo_id;
#line 905 "../src/db/PhotoTable.vala"
	_tmp34_ = trans;
#line 905 "../src/db/PhotoTable.vala"
	result = photo_table_set_raw_transformations (self, &_tmp33_, _tmp34_);
#line 905 "../src/db/PhotoTable.vala"
	_g_free0 (trans);
#line 905 "../src/db/PhotoTable.vala"
	return result;
#line 5670 "PhotoTable.c"
}

gboolean
photo_table_remove_transformation (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* object)
{
	gchar* trans = NULL;
	PhotoID _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoID _tmp18_;
	const gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 908 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 908 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 908 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 909 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 909 "../src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_raw_transformations (self, &_tmp0_);
#line 909 "../src/db/PhotoTable.vala"
	trans = _tmp1_;
#line 910 "../src/db/PhotoTable.vala"
	_tmp2_ = trans;
#line 910 "../src/db/PhotoTable.vala"
	if (_tmp2_ == NULL) {
#line 911 "../src/db/PhotoTable.vala"
		result = TRUE;
#line 911 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 911 "../src/db/PhotoTable.vala"
		return result;
#line 5708 "PhotoTable.c"
	}
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GKeyFile* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		GKeyFile* _tmp10_;
		GKeyFile* _tmp11_;
		gsize length = 0UL;
		GKeyFile* _tmp12_;
		gsize _tmp13_ = 0UL;
		gchar* _tmp14_;
		const gchar* _tmp15_;
#line 914 "../src/db/PhotoTable.vala"
		_tmp3_ = g_key_file_new ();
#line 914 "../src/db/PhotoTable.vala"
		keyfile = _tmp3_;
#line 915 "../src/db/PhotoTable.vala"
		_tmp5_ = keyfile;
#line 915 "../src/db/PhotoTable.vala"
		_tmp6_ = trans;
#line 915 "../src/db/PhotoTable.vala"
		_tmp7_ = trans;
#line 915 "../src/db/PhotoTable.vala"
		_tmp8_ = strlen (_tmp7_);
#line 915 "../src/db/PhotoTable.vala"
		_tmp9_ = _tmp8_;
#line 915 "../src/db/PhotoTable.vala"
		_tmp4_ = g_key_file_load_from_data (_tmp5_, _tmp6_, (gsize) _tmp9_, G_KEY_FILE_NONE, &_inner_error0_);
#line 915 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 915 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 5746 "PhotoTable.c"
			goto __catch0_g_error;
		}
#line 915 "../src/db/PhotoTable.vala"
		if (!_tmp4_) {
#line 916 "../src/db/PhotoTable.vala"
			result = FALSE;
#line 916 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 916 "../src/db/PhotoTable.vala"
			_g_free0 (trans);
#line 916 "../src/db/PhotoTable.vala"
			return result;
#line 5759 "PhotoTable.c"
		}
#line 918 "../src/db/PhotoTable.vala"
		_tmp10_ = keyfile;
#line 918 "../src/db/PhotoTable.vala"
		if (!g_key_file_has_group (_tmp10_, object)) {
#line 919 "../src/db/PhotoTable.vala"
			result = TRUE;
#line 919 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 919 "../src/db/PhotoTable.vala"
			_g_free0 (trans);
#line 919 "../src/db/PhotoTable.vala"
			return result;
#line 5773 "PhotoTable.c"
		}
#line 921 "../src/db/PhotoTable.vala"
		_tmp11_ = keyfile;
#line 921 "../src/db/PhotoTable.vala"
		g_key_file_remove_group (_tmp11_, object, &_inner_error0_);
#line 921 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 921 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 5783 "PhotoTable.c"
			goto __catch0_g_error;
		}
#line 924 "../src/db/PhotoTable.vala"
		_tmp12_ = keyfile;
#line 924 "../src/db/PhotoTable.vala"
		_tmp14_ = g_key_file_to_data (_tmp12_, &_tmp13_, NULL);
#line 924 "../src/db/PhotoTable.vala"
		length = _tmp13_;
#line 924 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 924 "../src/db/PhotoTable.vala"
		trans = _tmp14_;
#line 925 "../src/db/PhotoTable.vala"
		_tmp15_ = trans;
#line 925 "../src/db/PhotoTable.vala"
		_vala_assert (_tmp15_ != NULL, "trans != null");
#line 913 "../src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 5802 "PhotoTable.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp16_;
#line 913 "../src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 913 "../src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 927 "../src/db/PhotoTable.vala"
		_tmp16_ = err->message;
#line 927 "../src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:927: %s", _tmp16_);
#line 913 "../src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 5819 "PhotoTable.c"
	}
	__finally0:
#line 913 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5824 "PhotoTable.c"
		gboolean _tmp17_ = FALSE;
#line 913 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 913 "../src/db/PhotoTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 913 "../src/db/PhotoTable.vala"
		g_clear_error (&_inner_error0_);
#line 913 "../src/db/PhotoTable.vala"
		return _tmp17_;
#line 5834 "PhotoTable.c"
	}
#line 930 "../src/db/PhotoTable.vala"
	_tmp18_ = *photo_id;
#line 930 "../src/db/PhotoTable.vala"
	_tmp19_ = trans;
#line 930 "../src/db/PhotoTable.vala"
	result = photo_table_set_raw_transformations (self, &_tmp18_, _tmp19_);
#line 930 "../src/db/PhotoTable.vala"
	_g_free0 (trans);
#line 930 "../src/db/PhotoTable.vala"
	return result;
#line 5846 "PhotoTable.c"
}

gboolean
photo_table_remove_all_transformations (PhotoTable* self,
                                        PhotoID* photo_id)
{
	PhotoID _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	PhotoID _tmp4_;
	gboolean result = FALSE;
#line 933 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 933 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 934 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 934 "../src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_raw_transformations (self, &_tmp0_);
#line 934 "../src/db/PhotoTable.vala"
	_tmp2_ = _tmp1_;
#line 934 "../src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_ == NULL;
#line 934 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp2_);
#line 934 "../src/db/PhotoTable.vala"
	if (_tmp3_) {
#line 935 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 935 "../src/db/PhotoTable.vala"
		return result;
#line 5879 "PhotoTable.c"
	}
#line 937 "../src/db/PhotoTable.vala"
	_tmp4_ = *photo_id;
#line 937 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp4_.id, "transformations", "");
#line 937 "../src/db/PhotoTable.vala"
	return result;
#line 5887 "PhotoTable.c"
}

static sqlite3_stmt*
photo_table_get_duplicate_stmt (PhotoTable* self,
                                GFile* file,
                                const gchar* thumbnail_md5,
                                const gchar* md5,
                                PhotoFileFormat file_format)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* sql = NULL;
	gchar* _tmp2_;
	gboolean first = FALSE;
	gboolean _tmp5_ = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp22_;
	const gchar* _tmp23_;
	sqlite3_stmt* _tmp24_ = NULL;
	gint _tmp25_;
	gint col = 0;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp41_ = FALSE;
	sqlite3_stmt* result = NULL;
#line 942 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 942 "../src/db/PhotoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 944 "../src/db/PhotoTable.vala"
	if (file != NULL) {
#line 944 "../src/db/PhotoTable.vala"
		_tmp1_ = TRUE;
#line 5921 "PhotoTable.c"
	} else {
#line 944 "../src/db/PhotoTable.vala"
		_tmp1_ = thumbnail_md5 != NULL;
#line 5925 "PhotoTable.c"
	}
#line 944 "../src/db/PhotoTable.vala"
	if (_tmp1_) {
#line 944 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 5931 "PhotoTable.c"
	} else {
#line 944 "../src/db/PhotoTable.vala"
		_tmp0_ = md5 != NULL;
#line 5935 "PhotoTable.c"
	}
#line 944 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp0_, "file != null || thumbnail_md5 != null || md5 != null");
#line 946 "../src/db/PhotoTable.vala"
	_tmp2_ = g_strdup ("SELECT id FROM PhotoTable WHERE");
#line 946 "../src/db/PhotoTable.vala"
	sql = _tmp2_;
#line 947 "../src/db/PhotoTable.vala"
	first = TRUE;
#line 949 "../src/db/PhotoTable.vala"
	if (file != NULL) {
#line 5947 "PhotoTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 950 "../src/db/PhotoTable.vala"
		_tmp3_ = sql;
#line 950 "../src/db/PhotoTable.vala"
		_tmp4_ = g_strconcat (_tmp3_, " filename=?", NULL);
#line 950 "../src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 950 "../src/db/PhotoTable.vala"
		sql = _tmp4_;
#line 951 "../src/db/PhotoTable.vala"
		first = FALSE;
#line 5960 "PhotoTable.c"
	}
#line 954 "../src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 954 "../src/db/PhotoTable.vala"
		_tmp5_ = TRUE;
#line 5966 "PhotoTable.c"
	} else {
#line 954 "../src/db/PhotoTable.vala"
		_tmp5_ = md5 != NULL;
#line 5970 "PhotoTable.c"
	}
#line 954 "../src/db/PhotoTable.vala"
	if (_tmp5_) {
#line 5974 "PhotoTable.c"
		const gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
#line 955 "../src/db/PhotoTable.vala"
		if (first) {
#line 5981 "PhotoTable.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 956 "../src/db/PhotoTable.vala"
			_tmp6_ = sql;
#line 956 "../src/db/PhotoTable.vala"
			_tmp7_ = g_strconcat (_tmp6_, " ((", NULL);
#line 956 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 956 "../src/db/PhotoTable.vala"
			sql = _tmp7_;
#line 5992 "PhotoTable.c"
		} else {
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 958 "../src/db/PhotoTable.vala"
			_tmp8_ = sql;
#line 958 "../src/db/PhotoTable.vala"
			_tmp9_ = g_strconcat (_tmp8_, " OR ((", NULL);
#line 958 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 958 "../src/db/PhotoTable.vala"
			sql = _tmp9_;
#line 6004 "PhotoTable.c"
		}
#line 959 "../src/db/PhotoTable.vala"
		first = FALSE;
#line 961 "../src/db/PhotoTable.vala"
		if (md5 != NULL) {
#line 6010 "PhotoTable.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 962 "../src/db/PhotoTable.vala"
			_tmp10_ = sql;
#line 962 "../src/db/PhotoTable.vala"
			_tmp11_ = g_strconcat (_tmp10_, " md5=?", NULL);
#line 962 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 962 "../src/db/PhotoTable.vala"
			sql = _tmp11_;
#line 6021 "PhotoTable.c"
		}
#line 965 "../src/db/PhotoTable.vala"
		if (thumbnail_md5 != NULL) {
#line 966 "../src/db/PhotoTable.vala"
			if (md5 == NULL) {
#line 6027 "PhotoTable.c"
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 967 "../src/db/PhotoTable.vala"
				_tmp12_ = sql;
#line 967 "../src/db/PhotoTable.vala"
				_tmp13_ = g_strconcat (_tmp12_, " thumbnail_md5=?", NULL);
#line 967 "../src/db/PhotoTable.vala"
				_g_free0 (sql);
#line 967 "../src/db/PhotoTable.vala"
				sql = _tmp13_;
#line 6038 "PhotoTable.c"
			} else {
				const gchar* _tmp14_;
				gchar* _tmp15_;
#line 969 "../src/db/PhotoTable.vala"
				_tmp14_ = sql;
#line 969 "../src/db/PhotoTable.vala"
				_tmp15_ = g_strconcat (_tmp14_, " OR (md5 IS NULL AND thumbnail_md5=?)", NULL);
#line 969 "../src/db/PhotoTable.vala"
				_g_free0 (sql);
#line 969 "../src/db/PhotoTable.vala"
				sql = _tmp15_;
#line 6050 "PhotoTable.c"
			}
		}
#line 972 "../src/db/PhotoTable.vala"
		_tmp16_ = sql;
#line 972 "../src/db/PhotoTable.vala"
		_tmp17_ = g_strconcat (_tmp16_, ")", NULL);
#line 972 "../src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 972 "../src/db/PhotoTable.vala"
		sql = _tmp17_;
#line 974 "../src/db/PhotoTable.vala"
		if (file_format != PHOTO_FILE_FORMAT_UNKNOWN) {
#line 6063 "PhotoTable.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 975 "../src/db/PhotoTable.vala"
			_tmp18_ = sql;
#line 975 "../src/db/PhotoTable.vala"
			_tmp19_ = g_strconcat (_tmp18_, " AND file_format=?", NULL);
#line 975 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 975 "../src/db/PhotoTable.vala"
			sql = _tmp19_;
#line 6074 "PhotoTable.c"
		}
#line 977 "../src/db/PhotoTable.vala"
		_tmp20_ = sql;
#line 977 "../src/db/PhotoTable.vala"
		_tmp21_ = g_strconcat (_tmp20_, ")", NULL);
#line 977 "../src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 977 "../src/db/PhotoTable.vala"
		sql = _tmp21_;
#line 6084 "PhotoTable.c"
	}
#line 981 "../src/db/PhotoTable.vala"
	_tmp22_ = database_table_db;
#line 981 "../src/db/PhotoTable.vala"
	_tmp23_ = sql;
#line 981 "../src/db/PhotoTable.vala"
	_tmp25_ = sqlite3_prepare_v2 (_tmp22_, _tmp23_, -1, &_tmp24_, NULL);
#line 981 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 981 "../src/db/PhotoTable.vala"
	stmt = _tmp24_;
#line 981 "../src/db/PhotoTable.vala"
	res = _tmp25_;
#line 982 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 984 "../src/db/PhotoTable.vala"
	col = 1;
#line 986 "../src/db/PhotoTable.vala"
	if (file != NULL) {
#line 6104 "PhotoTable.c"
		sqlite3_stmt* _tmp26_;
		gint _tmp27_;
		gchar* _tmp28_;
		GDestroyNotify _tmp29_;
#line 987 "../src/db/PhotoTable.vala"
		_tmp26_ = stmt;
#line 987 "../src/db/PhotoTable.vala"
		_tmp27_ = col;
#line 987 "../src/db/PhotoTable.vala"
		col = _tmp27_ + 1;
#line 987 "../src/db/PhotoTable.vala"
		_tmp28_ = g_file_get_path (file);
#line 987 "../src/db/PhotoTable.vala"
		_tmp29_ = g_free;
#line 987 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_text (_tmp26_, _tmp27_, _tmp28_, -1, _tmp29_);
#line 988 "../src/db/PhotoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 6123 "PhotoTable.c"
	}
#line 991 "../src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 6127 "PhotoTable.c"
		sqlite3_stmt* _tmp30_;
		gint _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
		GDestroyNotify _tmp34_;
#line 992 "../src/db/PhotoTable.vala"
		_tmp30_ = stmt;
#line 992 "../src/db/PhotoTable.vala"
		_tmp31_ = col;
#line 992 "../src/db/PhotoTable.vala"
		col = _tmp31_ + 1;
#line 992 "../src/db/PhotoTable.vala"
		_tmp32_ = thumbnail_md5;
#line 992 "../src/db/PhotoTable.vala"
		_tmp33_ = g_strdup (_tmp32_);
#line 992 "../src/db/PhotoTable.vala"
		_tmp34_ = g_free;
#line 992 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_text (_tmp30_, _tmp31_, _tmp33_, -1, _tmp34_);
#line 993 "../src/db/PhotoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 6149 "PhotoTable.c"
	}
#line 996 "../src/db/PhotoTable.vala"
	if (md5 != NULL) {
#line 6153 "PhotoTable.c"
		sqlite3_stmt* _tmp35_;
		gint _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		GDestroyNotify _tmp39_;
#line 997 "../src/db/PhotoTable.vala"
		_tmp35_ = stmt;
#line 997 "../src/db/PhotoTable.vala"
		_tmp36_ = col;
#line 997 "../src/db/PhotoTable.vala"
		col = _tmp36_ + 1;
#line 997 "../src/db/PhotoTable.vala"
		_tmp37_ = md5;
#line 997 "../src/db/PhotoTable.vala"
		_tmp38_ = g_strdup (_tmp37_);
#line 997 "../src/db/PhotoTable.vala"
		_tmp39_ = g_free;
#line 997 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_text (_tmp35_, _tmp36_, _tmp38_, -1, _tmp39_);
#line 998 "../src/db/PhotoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 6175 "PhotoTable.c"
	}
#line 1001 "../src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 1001 "../src/db/PhotoTable.vala"
		_tmp41_ = TRUE;
#line 6181 "PhotoTable.c"
	} else {
#line 1001 "../src/db/PhotoTable.vala"
		_tmp41_ = md5 != NULL;
#line 6185 "PhotoTable.c"
	}
#line 1001 "../src/db/PhotoTable.vala"
	if (_tmp41_) {
#line 1001 "../src/db/PhotoTable.vala"
		_tmp40_ = file_format != PHOTO_FILE_FORMAT_UNKNOWN;
#line 6191 "PhotoTable.c"
	} else {
#line 1001 "../src/db/PhotoTable.vala"
		_tmp40_ = FALSE;
#line 6195 "PhotoTable.c"
	}
#line 1001 "../src/db/PhotoTable.vala"
	if (_tmp40_) {
#line 6199 "PhotoTable.c"
		sqlite3_stmt* _tmp42_;
		gint _tmp43_;
#line 1002 "../src/db/PhotoTable.vala"
		_tmp42_ = stmt;
#line 1002 "../src/db/PhotoTable.vala"
		_tmp43_ = col;
#line 1002 "../src/db/PhotoTable.vala"
		col = _tmp43_ + 1;
#line 1002 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_int (_tmp42_, _tmp43_, photo_file_format_serialize (file_format));
#line 1003 "../src/db/PhotoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 6212 "PhotoTable.c"
	}
#line 1006 "../src/db/PhotoTable.vala"
	result = stmt;
#line 1006 "../src/db/PhotoTable.vala"
	_g_free0 (sql);
#line 1006 "../src/db/PhotoTable.vala"
	return result;
#line 6220 "PhotoTable.c"
}

gboolean
photo_table_has_duplicate (PhotoTable* self,
                           GFile* file,
                           const gchar* thumbnail_md5,
                           const gchar* md5,
                           PhotoFileFormat file_format)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gboolean result = FALSE;
#line 1009 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 1009 "../src/db/PhotoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1010 "../src/db/PhotoTable.vala"
	_tmp0_ = photo_table_get_duplicate_stmt (self, file, thumbnail_md5, md5, file_format);
#line 1010 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 1011 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 1011 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 1013 "../src/db/PhotoTable.vala"
	if (res == SQLITE_DONE) {
#line 1015 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 1015 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 1015 "../src/db/PhotoTable.vala"
		return result;
#line 6255 "PhotoTable.c"
	} else {
#line 1016 "../src/db/PhotoTable.vala"
		if (res == SQLITE_ROW) {
#line 1018 "../src/db/PhotoTable.vala"
			result = TRUE;
#line 1018 "../src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 1018 "../src/db/PhotoTable.vala"
			return result;
#line 6265 "PhotoTable.c"
		} else {
#line 1020 "../src/db/PhotoTable.vala"
			database_table_fatal ("has_duplicate", res);
#line 1022 "../src/db/PhotoTable.vala"
			result = FALSE;
#line 1022 "../src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 1022 "../src/db/PhotoTable.vala"
			return result;
#line 6275 "PhotoTable.c"
		}
	}
}

static void
_vala_array_add2 (PhotoID* * array,
                  gint* length,
                  gint* size,
                  const PhotoID* value)
{
#line 1034 "../src/db/PhotoTable.vala"
	if ((*length) == (*size)) {
#line 1034 "../src/db/PhotoTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1034 "../src/db/PhotoTable.vala"
		*array = g_renew (PhotoID, *array, *size);
#line 6292 "PhotoTable.c"
	}
#line 1034 "../src/db/PhotoTable.vala"
	(*array)[(*length)++] = *value;
#line 6296 "PhotoTable.c"
}

PhotoID*
photo_table_get_duplicate_ids (PhotoTable* self,
                               GFile* file,
                               const gchar* thumbnail_md5,
                               const gchar* md5,
                               PhotoFileFormat file_format,
                               gint* result_length1)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	PhotoID* ids = NULL;
	PhotoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gint res = 0;
	sqlite3_stmt* _tmp2_;
	PhotoID* _tmp6_;
	gint _tmp6__length1;
	PhotoID* result = NULL;
#line 1026 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 1026 "../src/db/PhotoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1028 "../src/db/PhotoTable.vala"
	_tmp0_ = photo_table_get_duplicate_stmt (self, file, thumbnail_md5, md5, file_format);
#line 1028 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 1030 "../src/db/PhotoTable.vala"
	_tmp1_ = g_new0 (PhotoID, 0);
#line 1030 "../src/db/PhotoTable.vala"
	ids = _tmp1_;
#line 1030 "../src/db/PhotoTable.vala"
	ids_length1 = 0;
#line 1030 "../src/db/PhotoTable.vala"
	_ids_size_ = ids_length1;
#line 1032 "../src/db/PhotoTable.vala"
	_tmp2_ = stmt;
#line 1032 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp2_);
#line 1033 "../src/db/PhotoTable.vala"
	while (TRUE) {
#line 6340 "PhotoTable.c"
		sqlite3_stmt* _tmp3_;
		PhotoID _tmp4_ = {0};
		sqlite3_stmt* _tmp5_;
#line 1033 "../src/db/PhotoTable.vala"
		if (!(res == SQLITE_ROW)) {
#line 1033 "../src/db/PhotoTable.vala"
			break;
#line 6348 "PhotoTable.c"
		}
#line 1034 "../src/db/PhotoTable.vala"
		_tmp3_ = stmt;
#line 1034 "../src/db/PhotoTable.vala"
		photo_id_init (&_tmp4_, sqlite3_column_int64 (_tmp3_, 0));
#line 1034 "../src/db/PhotoTable.vala"
		_vala_array_add2 (&ids, &ids_length1, &_ids_size_, &_tmp4_);
#line 1035 "../src/db/PhotoTable.vala"
		_tmp5_ = stmt;
#line 1035 "../src/db/PhotoTable.vala"
		res = sqlite3_step (_tmp5_);
#line 6360 "PhotoTable.c"
	}
#line 1038 "../src/db/PhotoTable.vala"
	_tmp6_ = ids;
#line 1038 "../src/db/PhotoTable.vala"
	_tmp6__length1 = ids_length1;
#line 1038 "../src/db/PhotoTable.vala"
	if (result_length1) {
#line 1038 "../src/db/PhotoTable.vala"
		*result_length1 = _tmp6__length1;
#line 6370 "PhotoTable.c"
	}
#line 1038 "../src/db/PhotoTable.vala"
	result = _tmp6_;
#line 1038 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1038 "../src/db/PhotoTable.vala"
	return result;
#line 6378 "PhotoTable.c"
}

void
photo_table_update_backlinks (PhotoTable* self,
                              PhotoID* photo_id,
                              const gchar* backlinks,
                              GError** error)
{
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1041 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1041 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 1042 "../src/db/PhotoTable.vala"
	if (backlinks != NULL) {
#line 1042 "../src/db/PhotoTable.vala"
		_tmp0_ = backlinks;
#line 6398 "PhotoTable.c"
	} else {
#line 1042 "../src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 6402 "PhotoTable.c"
	}
#line 1042 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 1042 "../src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "backlinks", _tmp0_, &_inner_error0_);
#line 1042 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1042 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1042 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1042 "../src/db/PhotoTable.vala"
			return;
#line 6416 "PhotoTable.c"
		} else {
#line 1042 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1042 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1042 "../src/db/PhotoTable.vala"
			return;
#line 6424 "PhotoTable.c"
		}
	}
}

void
photo_table_attach_editable (PhotoTable* self,
                             PhotoRow* row,
                             BackingPhotoID* editable_id,
                             GError** error)
{
	PhotoID _tmp0_;
	BackingPhotoID _tmp1_;
	BackingPhotoID _tmp2_;
	GError* _inner_error0_ = NULL;
#line 1045 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1045 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1045 "../src/db/PhotoTable.vala"
	g_return_if_fail (editable_id != NULL);
#line 1046 "../src/db/PhotoTable.vala"
	_tmp0_ = row->photo_id;
#line 1046 "../src/db/PhotoTable.vala"
	_tmp1_ = *editable_id;
#line 1046 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "editable_id", _tmp1_.id, &_inner_error0_);
#line 1046 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1046 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1046 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1046 "../src/db/PhotoTable.vala"
			return;
#line 6459 "PhotoTable.c"
		} else {
#line 1046 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1046 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1046 "../src/db/PhotoTable.vala"
			return;
#line 6467 "PhotoTable.c"
		}
	}
#line 1048 "../src/db/PhotoTable.vala"
	_tmp2_ = *editable_id;
#line 1048 "../src/db/PhotoTable.vala"
	row->editable_id = _tmp2_;
#line 6474 "PhotoTable.c"
}

void
photo_table_detach_editable (PhotoTable* self,
                             PhotoRow* row,
                             GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1051 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1051 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1052 "../src/db/PhotoTable.vala"
	_tmp0_ = row->photo_id;
#line 1052 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "editable_id", BACKING_PHOTO_ID_INVALID, &_inner_error0_);
#line 1052 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1052 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1052 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1052 "../src/db/PhotoTable.vala"
			return;
#line 6500 "PhotoTable.c"
		} else {
#line 1052 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1052 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1052 "../src/db/PhotoTable.vala"
			return;
#line 6508 "PhotoTable.c"
		}
	}
#line 1054 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&row->editable_id, BACKING_PHOTO_ID_INVALID);
#line 6513 "PhotoTable.c"
}

void
photo_table_set_metadata_dirty (PhotoTable* self,
                                PhotoID* photo_id,
                                gboolean dirty,
                                GError** error)
{
	gint _tmp0_ = 0;
	PhotoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1057 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1057 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 1058 "../src/db/PhotoTable.vala"
	if (dirty) {
#line 1058 "../src/db/PhotoTable.vala"
		_tmp0_ = 1;
#line 6533 "PhotoTable.c"
	} else {
#line 1058 "../src/db/PhotoTable.vala"
		_tmp0_ = 0;
#line 6537 "PhotoTable.c"
	}
#line 1058 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 1058 "../src/db/PhotoTable.vala"
	database_table_update_int_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "metadata_dirty", _tmp0_, &_inner_error0_);
#line 1058 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1058 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1058 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1058 "../src/db/PhotoTable.vala"
			return;
#line 6551 "PhotoTable.c"
		} else {
#line 1058 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1058 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1058 "../src/db/PhotoTable.vala"
			return;
#line 6559 "PhotoTable.c"
		}
	}
}

void
photo_table_update_raw_development (PhotoTable* self,
                                    PhotoRow* row,
                                    RawDeveloper rd,
                                    BackingPhotoID* backing_photo_id,
                                    GError** error)
{
	gchar* col = NULL;
	BackingPhotoID* _tmp3_;
	gint _tmp3__length1;
	BackingPhotoID _tmp4_;
	PhotoID _tmp5_;
	const gchar* _tmp6_;
	BackingPhotoID _tmp7_;
	BackingPhotoID _tmp8_;
	GError* _inner_error0_ = NULL;
#line 1061 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1061 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1061 "../src/db/PhotoTable.vala"
	g_return_if_fail (backing_photo_id != NULL);
#line 1065 "../src/db/PhotoTable.vala"
	switch (rd) {
#line 1065 "../src/db/PhotoTable.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6590 "PhotoTable.c"
		{
			gchar* _tmp0_;
#line 1067 "../src/db/PhotoTable.vala"
			_tmp0_ = g_strdup ("develop_shotwell_id");
#line 1067 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1067 "../src/db/PhotoTable.vala"
			col = _tmp0_;
#line 1068 "../src/db/PhotoTable.vala"
			break;
#line 6601 "PhotoTable.c"
		}
#line 1065 "../src/db/PhotoTable.vala"
		case RAW_DEVELOPER_CAMERA:
#line 6605 "PhotoTable.c"
		{
			gchar* _tmp1_;
#line 1071 "../src/db/PhotoTable.vala"
			_tmp1_ = g_strdup ("develop_camera_id");
#line 1071 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1071 "../src/db/PhotoTable.vala"
			col = _tmp1_;
#line 1072 "../src/db/PhotoTable.vala"
			break;
#line 6616 "PhotoTable.c"
		}
#line 1065 "../src/db/PhotoTable.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 6620 "PhotoTable.c"
		{
			gchar* _tmp2_;
#line 1075 "../src/db/PhotoTable.vala"
			_tmp2_ = g_strdup ("develop_embedded_id");
#line 1075 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1075 "../src/db/PhotoTable.vala"
			col = _tmp2_;
#line 1076 "../src/db/PhotoTable.vala"
			break;
#line 6631 "PhotoTable.c"
		}
		default:
		{
#line 1079 "../src/db/PhotoTable.vala"
			g_assert_not_reached ();
#line 6637 "PhotoTable.c"
		}
	}
#line 1082 "../src/db/PhotoTable.vala"
	_tmp3_ = row->development_ids;
#line 1082 "../src/db/PhotoTable.vala"
	_tmp3__length1 = row->development_ids_length1;
#line 1082 "../src/db/PhotoTable.vala"
	_tmp4_ = *backing_photo_id;
#line 1082 "../src/db/PhotoTable.vala"
	_tmp3_[rd] = _tmp4_;
#line 1083 "../src/db/PhotoTable.vala"
	_tmp5_ = row->photo_id;
#line 1083 "../src/db/PhotoTable.vala"
	_tmp6_ = col;
#line 1083 "../src/db/PhotoTable.vala"
	_tmp7_ = *backing_photo_id;
#line 1083 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp5_.id, _tmp6_, _tmp7_.id, &_inner_error0_);
#line 1083 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1083 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1083 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1083 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1083 "../src/db/PhotoTable.vala"
			return;
#line 6666 "PhotoTable.c"
		} else {
#line 1083 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1083 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1083 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1083 "../src/db/PhotoTable.vala"
			return;
#line 6676 "PhotoTable.c"
		}
	}
#line 1085 "../src/db/PhotoTable.vala"
	_tmp8_ = *backing_photo_id;
#line 1085 "../src/db/PhotoTable.vala"
	if (_tmp8_.id != BACKING_PHOTO_ID_INVALID) {
#line 6683 "PhotoTable.c"
		PhotoID _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1086 "../src/db/PhotoTable.vala"
		_tmp9_ = row->photo_id;
#line 1086 "../src/db/PhotoTable.vala"
		_tmp10_ = raw_developer_to_string (rd);
#line 1086 "../src/db/PhotoTable.vala"
		_tmp11_ = _tmp10_;
#line 1086 "../src/db/PhotoTable.vala"
		database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp9_.id, "developer", _tmp11_, &_inner_error0_);
#line 1086 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp11_);
#line 1086 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1086 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1086 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1086 "../src/db/PhotoTable.vala"
				_g_free0 (col);
#line 1086 "../src/db/PhotoTable.vala"
				return;
#line 6707 "PhotoTable.c"
			} else {
#line 1086 "../src/db/PhotoTable.vala"
				_g_free0 (col);
#line 1086 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1086 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1086 "../src/db/PhotoTable.vala"
				return;
#line 6717 "PhotoTable.c"
			}
		}
	}
#line 1061 "../src/db/PhotoTable.vala"
	_g_free0 (col);
#line 6723 "PhotoTable.c"
}

void
photo_table_remove_development (PhotoTable* self,
                                PhotoRow* row,
                                RawDeveloper rd,
                                GError** error)
{
	BackingPhotoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 1089 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1089 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1090 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp0_, BACKING_PHOTO_ID_INVALID);
#line 1090 "../src/db/PhotoTable.vala"
	photo_table_update_raw_development (self, row, rd, &_tmp0_, &_inner_error0_);
#line 1090 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1090 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1090 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1090 "../src/db/PhotoTable.vala"
			return;
#line 6750 "PhotoTable.c"
		} else {
#line 1090 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1090 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1090 "../src/db/PhotoTable.vala"
			return;
#line 6758 "PhotoTable.c"
		}
	}
}

static void
photo_table_class_init (PhotoTableClass * klass,
                        gpointer klass_data)
{
#line 112 "../src/db/PhotoTable.vala"
	photo_table_parent_class = g_type_class_peek_parent (klass);
#line 112 "../src/db/PhotoTable.vala"
	((DatabaseTableClass *) klass)->finalize = photo_table_finalize;
#line 6771 "PhotoTable.c"
}

static void
photo_table_instance_init (PhotoTable * self,
                           gpointer klass)
{
}

static void
photo_table_finalize (DatabaseTable * obj)
{
	PhotoTable * self;
#line 112 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TABLE, PhotoTable);
#line 112 "../src/db/PhotoTable.vala"
	DATABASE_TABLE_CLASS (photo_table_parent_class)->finalize (obj);
#line 6788 "PhotoTable.c"
}

static GType
photo_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTable), 0, (GInstanceInitFunc) photo_table_instance_init, NULL };
	GType photo_table_type_id;
	photo_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "PhotoTable", &g_define_type_info, 0);
	return photo_table_type_id;
}

GType
photo_table_get_type (void)
{
	static volatile gsize photo_table_type_id__volatile = 0;
	if (g_once_init_enter (&photo_table_type_id__volatile)) {
		GType photo_table_type_id;
		photo_table_type_id = photo_table_get_type_once ();
		g_once_init_leave (&photo_table_type_id__volatile, photo_table_type_id);
	}
	return photo_table_type_id__volatile;
}

void
backing_photo_id_init (BackingPhotoID *self,
                       gint64 id)
{
#line 1110 "../src/db/PhotoTable.vala"
	memset (self, 0, sizeof (BackingPhotoID));
#line 1111 "../src/db/PhotoTable.vala"
	(*self).id = id;
#line 6820 "PhotoTable.c"
}

gboolean
backing_photo_id_is_invalid (BackingPhotoID *self)
{
	gboolean result = FALSE;
#line 1115 "../src/db/PhotoTable.vala"
	result = (*self).id == BACKING_PHOTO_ID_INVALID;
#line 1115 "../src/db/PhotoTable.vala"
	return result;
#line 6831 "PhotoTable.c"
}

gboolean
backing_photo_id_is_valid (BackingPhotoID *self)
{
	gboolean result = FALSE;
#line 1119 "../src/db/PhotoTable.vala"
	result = (*self).id != BACKING_PHOTO_ID_INVALID;
#line 1119 "../src/db/PhotoTable.vala"
	return result;
#line 6842 "PhotoTable.c"
}

BackingPhotoID*
backing_photo_id_dup (const BackingPhotoID* self)
{
	BackingPhotoID* dup;
#line 1105 "../src/db/PhotoTable.vala"
	dup = g_new0 (BackingPhotoID, 1);
#line 1105 "../src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (BackingPhotoID));
#line 1105 "../src/db/PhotoTable.vala"
	return dup;
#line 6855 "PhotoTable.c"
}

void
backing_photo_id_free (BackingPhotoID* self)
{
#line 1105 "../src/db/PhotoTable.vala"
	g_free (self);
#line 6863 "PhotoTable.c"
}

static GType
backing_photo_id_get_type_once (void)
{
	GType backing_photo_id_type_id;
	backing_photo_id_type_id = g_boxed_type_register_static ("BackingPhotoID", (GBoxedCopyFunc) backing_photo_id_dup, (GBoxedFreeFunc) backing_photo_id_free);
	return backing_photo_id_type_id;
}

GType
backing_photo_id_get_type (void)
{
	static volatile gsize backing_photo_id_type_id__volatile = 0;
	if (g_once_init_enter (&backing_photo_id_type_id__volatile)) {
		GType backing_photo_id_type_id;
		backing_photo_id_type_id = backing_photo_id_get_type_once ();
		g_once_init_leave (&backing_photo_id_type_id__volatile, backing_photo_id_type_id);
	}
	return backing_photo_id_type_id__volatile;
}

gboolean
backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                     GFileInfo* info)
{
	GTimeVal _tmp0_ = {0};
	gboolean result = FALSE;
#line 1133 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (self), FALSE);
#line 1133 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 1134 "../src/db/PhotoTable.vala"
	if (self->filesize != g_file_info_get_size (info)) {
#line 1135 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 1135 "../src/db/PhotoTable.vala"
		return result;
#line 6902 "PhotoTable.c"
	}
#line 1137 "../src/db/PhotoTable.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1137 "../src/db/PhotoTable.vala"
	result = self->timestamp == ((time_t) _tmp0_.tv_sec);
#line 1137 "../src/db/PhotoTable.vala"
	return result;
#line 6910 "PhotoTable.c"
}

gboolean
backing_photo_row_is_touched (BackingPhotoRow* self,
                              GFileInfo* info)
{
	GTimeVal _tmp0_ = {0};
	gboolean result = FALSE;
#line 1140 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (self), FALSE);
#line 1140 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 1141 "../src/db/PhotoTable.vala"
	if (self->filesize != g_file_info_get_size (info)) {
#line 1142 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 1142 "../src/db/PhotoTable.vala"
		return result;
#line 6929 "PhotoTable.c"
	}
#line 1144 "../src/db/PhotoTable.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1144 "../src/db/PhotoTable.vala"
	result = self->timestamp != ((time_t) _tmp0_.tv_sec);
#line 1144 "../src/db/PhotoTable.vala"
	return result;
#line 6937 "PhotoTable.c"
}

void
backing_photo_row_copy_from (BackingPhotoRow* self,
                             BackingPhotoRow* from)
{
	BackingPhotoID _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	Dimensions _tmp3_;
#line 1148 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (self));
#line 1148 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (from));
#line 1149 "../src/db/PhotoTable.vala"
	_tmp0_ = from->id;
#line 1149 "../src/db/PhotoTable.vala"
	self->id = _tmp0_;
#line 1150 "../src/db/PhotoTable.vala"
	self->time_created = from->time_created;
#line 1151 "../src/db/PhotoTable.vala"
	_tmp1_ = from->filepath;
#line 1151 "../src/db/PhotoTable.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 1151 "../src/db/PhotoTable.vala"
	_g_free0 (self->filepath);
#line 1151 "../src/db/PhotoTable.vala"
	self->filepath = _tmp2_;
#line 1152 "../src/db/PhotoTable.vala"
	self->filesize = from->filesize;
#line 1153 "../src/db/PhotoTable.vala"
	self->timestamp = from->timestamp;
#line 1154 "../src/db/PhotoTable.vala"
	self->file_format = from->file_format;
#line 1155 "../src/db/PhotoTable.vala"
	_tmp3_ = from->dim;
#line 1155 "../src/db/PhotoTable.vala"
	self->dim = _tmp3_;
#line 1156 "../src/db/PhotoTable.vala"
	self->original_orientation = from->original_orientation;
#line 6978 "PhotoTable.c"
}

BackingPhotoRow*
backing_photo_row_construct (GType object_type)
{
	BackingPhotoRow* self = NULL;
#line 1123 "../src/db/PhotoTable.vala"
	self = (BackingPhotoRow*) g_type_create_instance (object_type);
#line 1123 "../src/db/PhotoTable.vala"
	return self;
#line 6989 "PhotoTable.c"
}

BackingPhotoRow*
backing_photo_row_new (void)
{
#line 1123 "../src/db/PhotoTable.vala"
	return backing_photo_row_construct (TYPE_BACKING_PHOTO_ROW);
#line 6997 "PhotoTable.c"
}

static void
value_backing_photo_row_init (GValue* value)
{
#line 1123 "../src/db/PhotoTable.vala"
	value->data[0].v_pointer = NULL;
#line 7005 "PhotoTable.c"
}

static void
value_backing_photo_row_free_value (GValue* value)
{
#line 1123 "../src/db/PhotoTable.vala"
	if (value->data[0].v_pointer) {
#line 1123 "../src/db/PhotoTable.vala"
		backing_photo_row_unref (value->data[0].v_pointer);
#line 7015 "PhotoTable.c"
	}
}

static void
value_backing_photo_row_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 1123 "../src/db/PhotoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 1123 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = backing_photo_row_ref (src_value->data[0].v_pointer);
#line 7027 "PhotoTable.c"
	} else {
#line 1123 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7031 "PhotoTable.c"
	}
}

static gpointer
value_backing_photo_row_peek_pointer (const GValue* value)
{
#line 1123 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 7040 "PhotoTable.c"
}

static gchar*
value_backing_photo_row_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 1123 "../src/db/PhotoTable.vala"
	if (collect_values[0].v_pointer) {
#line 7051 "PhotoTable.c"
		BackingPhotoRow * object;
		object = collect_values[0].v_pointer;
#line 1123 "../src/db/PhotoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1123 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7058 "PhotoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1123 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7062 "PhotoTable.c"
		}
#line 1123 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = backing_photo_row_ref (object);
#line 7066 "PhotoTable.c"
	} else {
#line 1123 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 7070 "PhotoTable.c"
	}
#line 1123 "../src/db/PhotoTable.vala"
	return NULL;
#line 7074 "PhotoTable.c"
}

static gchar*
value_backing_photo_row_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	BackingPhotoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1123 "../src/db/PhotoTable.vala"
	if (!object_p) {
#line 1123 "../src/db/PhotoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7089 "PhotoTable.c"
	}
#line 1123 "../src/db/PhotoTable.vala"
	if (!value->data[0].v_pointer) {
#line 1123 "../src/db/PhotoTable.vala"
		*object_p = NULL;
#line 7095 "PhotoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1123 "../src/db/PhotoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 7099 "PhotoTable.c"
	} else {
#line 1123 "../src/db/PhotoTable.vala"
		*object_p = backing_photo_row_ref (value->data[0].v_pointer);
#line 7103 "PhotoTable.c"
	}
#line 1123 "../src/db/PhotoTable.vala"
	return NULL;
#line 7107 "PhotoTable.c"
}

GParamSpec*
param_spec_backing_photo_row (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	ParamSpecBackingPhotoRow* spec;
#line 1123 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BACKING_PHOTO_ROW), NULL);
#line 1123 "../src/db/PhotoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1123 "../src/db/PhotoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1123 "../src/db/PhotoTable.vala"
	return G_PARAM_SPEC (spec);
#line 7126 "PhotoTable.c"
}

gpointer
value_get_backing_photo_row (const GValue* value)
{
#line 1123 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW), NULL);
#line 1123 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 7136 "PhotoTable.c"
}

void
value_set_backing_photo_row (GValue* value,
                             gpointer v_object)
{
	BackingPhotoRow * old;
#line 1123 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW));
#line 1123 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 1123 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 1123 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKING_PHOTO_ROW));
#line 1123 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1123 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 1123 "../src/db/PhotoTable.vala"
		backing_photo_row_ref (value->data[0].v_pointer);
#line 7158 "PhotoTable.c"
	} else {
#line 1123 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 7162 "PhotoTable.c"
	}
#line 1123 "../src/db/PhotoTable.vala"
	if (old) {
#line 1123 "../src/db/PhotoTable.vala"
		backing_photo_row_unref (old);
#line 7168 "PhotoTable.c"
	}
}

void
value_take_backing_photo_row (GValue* value,
                              gpointer v_object)
{
	BackingPhotoRow * old;
#line 1123 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW));
#line 1123 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 1123 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 1123 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKING_PHOTO_ROW));
#line 1123 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1123 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 7189 "PhotoTable.c"
	} else {
#line 1123 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 7193 "PhotoTable.c"
	}
#line 1123 "../src/db/PhotoTable.vala"
	if (old) {
#line 1123 "../src/db/PhotoTable.vala"
		backing_photo_row_unref (old);
#line 7199 "PhotoTable.c"
	}
}

static void
backing_photo_row_class_init (BackingPhotoRowClass * klass,
                              gpointer klass_data)
{
#line 1123 "../src/db/PhotoTable.vala"
	backing_photo_row_parent_class = g_type_class_peek_parent (klass);
#line 1123 "../src/db/PhotoTable.vala"
	((BackingPhotoRowClass *) klass)->finalize = backing_photo_row_finalize;
#line 7211 "PhotoTable.c"
}

static void
backing_photo_row_instance_init (BackingPhotoRow * self,
                                 gpointer klass)
{
#line 1126 "../src/db/PhotoTable.vala"
	self->filepath = NULL;
#line 1123 "../src/db/PhotoTable.vala"
	self->ref_count = 1;
#line 7222 "PhotoTable.c"
}

static void
backing_photo_row_finalize (BackingPhotoRow * obj)
{
	BackingPhotoRow * self;
#line 1123 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKING_PHOTO_ROW, BackingPhotoRow);
#line 1123 "../src/db/PhotoTable.vala"
	g_signal_handlers_destroy (self);
#line 1126 "../src/db/PhotoTable.vala"
	_g_free0 (self->filepath);
#line 7235 "PhotoTable.c"
}

static GType
backing_photo_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_backing_photo_row_init, value_backing_photo_row_free_value, value_backing_photo_row_copy_value, value_backing_photo_row_peek_pointer, "p", value_backing_photo_row_collect_value, "p", value_backing_photo_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BackingPhotoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) backing_photo_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackingPhotoRow), 0, (GInstanceInitFunc) backing_photo_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType backing_photo_row_type_id;
	backing_photo_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BackingPhotoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return backing_photo_row_type_id;
}

GType
backing_photo_row_get_type (void)
{
	static volatile gsize backing_photo_row_type_id__volatile = 0;
	if (g_once_init_enter (&backing_photo_row_type_id__volatile)) {
		GType backing_photo_row_type_id;
		backing_photo_row_type_id = backing_photo_row_get_type_once ();
		g_once_init_leave (&backing_photo_row_type_id__volatile, backing_photo_row_type_id);
	}
	return backing_photo_row_type_id__volatile;
}

gpointer
backing_photo_row_ref (gpointer instance)
{
	BackingPhotoRow * self;
	self = instance;
#line 1123 "../src/db/PhotoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1123 "../src/db/PhotoTable.vala"
	return instance;
#line 7270 "PhotoTable.c"
}

void
backing_photo_row_unref (gpointer instance)
{
	BackingPhotoRow * self;
	self = instance;
#line 1123 "../src/db/PhotoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1123 "../src/db/PhotoTable.vala"
		BACKING_PHOTO_ROW_GET_CLASS (self)->finalize (self);
#line 1123 "../src/db/PhotoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7284 "PhotoTable.c"
	}
}

static BackingPhotoTable*
backing_photo_table_construct (GType object_type)
{
	BackingPhotoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
#line 1163 "../src/db/PhotoTable.vala"
	self = (BackingPhotoTable*) database_table_construct (object_type);
#line 1164 "../src/db/PhotoTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "BackingPhotoTable");
#line 1167 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1167 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS " "BackingPhotoTable " "(" "id INTEGER PRIMARY KEY, " "filepath TEXT UNIQUE NOT NULL, " "timestamp INTEGER, " "filesize INTEGER, " "width INTEGER, " "height INTEGER, " "original_orientation INTEGER, " "file_format INTEGER, " "time_created INTEGER " ")", -1, &_tmp1_, NULL);
#line 1167 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1167 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1167 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1180 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1182 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1182 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 1183 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1184 "../src/db/PhotoTable.vala"
		database_table_fatal ("create PhotoBackingTable", res);
#line 7322 "PhotoTable.c"
	}
#line 1163 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1163 "../src/db/PhotoTable.vala"
	return self;
#line 7328 "PhotoTable.c"
}

static BackingPhotoTable*
backing_photo_table_new (void)
{
#line 1163 "../src/db/PhotoTable.vala"
	return backing_photo_table_construct (TYPE_BACKING_PHOTO_TABLE);
#line 7336 "PhotoTable.c"
}

BackingPhotoTable*
backing_photo_table_get_instance (void)
{
	BackingPhotoTable* _tmp0_;
	BackingPhotoTable* _tmp2_;
	BackingPhotoTable* _tmp3_;
	BackingPhotoTable* result = NULL;
#line 1188 "../src/db/PhotoTable.vala"
	_tmp0_ = backing_photo_table_instance;
#line 1188 "../src/db/PhotoTable.vala"
	if (_tmp0_ == NULL) {
#line 7350 "PhotoTable.c"
		BackingPhotoTable* _tmp1_;
#line 1189 "../src/db/PhotoTable.vala"
		_tmp1_ = backing_photo_table_new ();
#line 1189 "../src/db/PhotoTable.vala"
		_database_table_unref0 (backing_photo_table_instance);
#line 1189 "../src/db/PhotoTable.vala"
		backing_photo_table_instance = _tmp1_;
#line 7358 "PhotoTable.c"
	}
#line 1191 "../src/db/PhotoTable.vala"
	_tmp2_ = backing_photo_table_instance;
#line 1191 "../src/db/PhotoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 1191 "../src/db/PhotoTable.vala"
	result = _tmp3_;
#line 1191 "../src/db/PhotoTable.vala"
	return result;
#line 7368 "PhotoTable.c"
}

void
backing_photo_table_add (BackingPhotoTable* self,
                         BackingPhotoRow* state,
                         GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	time_t time_created = 0;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GDestroyNotify _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	Dimensions _tmp10_;
	sqlite3_stmt* _tmp11_;
	Dimensions _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp14_;
	sqlite3_stmt* _tmp15_;
	sqlite3_stmt* _tmp16_;
	sqlite3* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 1194 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1194 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (state));
#line 1196 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1196 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO BackingPhotoTable " "(filepath, timestamp, filesize, width, height, original_orientation, " "file_format, time_created) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?)", -1, &_tmp1_, NULL);
#line 1196 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1196 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1196 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1201 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1203 "../src/db/PhotoTable.vala"
	time_created = (time_t) now_sec ();
#line 1205 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1205 "../src/db/PhotoTable.vala"
	_tmp4_ = state->filepath;
#line 1205 "../src/db/PhotoTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 1205 "../src/db/PhotoTable.vala"
	_tmp6_ = g_free;
#line 1205 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp5_, -1, _tmp6_);
#line 1206 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1207 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 1207 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 2, (gint64) state->timestamp);
#line 1208 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1209 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 1209 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp8_, 3, state->filesize);
#line 1210 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1211 "../src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 1211 "../src/db/PhotoTable.vala"
	_tmp10_ = state->dim;
#line 1211 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp9_, 4, _tmp10_.width);
#line 1212 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1213 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 1213 "../src/db/PhotoTable.vala"
	_tmp12_ = state->dim;
#line 1213 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp11_, 5, _tmp12_.height);
#line 1214 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1215 "../src/db/PhotoTable.vala"
	_tmp13_ = stmt;
#line 1215 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp13_, 6, (gint) state->original_orientation);
#line 1216 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1217 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 1217 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp14_, 7, photo_file_format_serialize (state->file_format));
#line 1218 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1219 "../src/db/PhotoTable.vala"
	_tmp15_ = stmt;
#line 1219 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp15_, 8, (gint64) time_created);
#line 1220 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1222 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 1222 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp16_);
#line 1223 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1224 "../src/db/PhotoTable.vala"
		database_table_throw_error ("PhotoBackingTable.add", res, &_inner_error0_);
#line 1224 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1224 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1224 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1224 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1224 "../src/db/PhotoTable.vala"
				return;
#line 7492 "PhotoTable.c"
			} else {
#line 1224 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1224 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1224 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1224 "../src/db/PhotoTable.vala"
				return;
#line 7502 "PhotoTable.c"
			}
		}
	}
#line 1226 "../src/db/PhotoTable.vala"
	_tmp17_ = database_table_db;
#line 1226 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&state->id, sqlite3_last_insert_rowid (_tmp17_));
#line 1227 "../src/db/PhotoTable.vala"
	state->time_created = time_created;
#line 1194 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 7514 "PhotoTable.c"
}

BackingPhotoRow*
backing_photo_table_fetch (BackingPhotoTable* self,
                           BackingPhotoID* id,
                           GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	BackingPhotoID _tmp4_;
	sqlite3_stmt* _tmp5_;
	BackingPhotoRow* row = NULL;
	BackingPhotoRow* _tmp6_;
	BackingPhotoRow* _tmp7_;
	BackingPhotoID _tmp8_;
	BackingPhotoRow* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	BackingPhotoRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	BackingPhotoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	BackingPhotoRow* _tmp17_;
	sqlite3_stmt* _tmp18_;
	sqlite3_stmt* _tmp19_;
	BackingPhotoRow* _tmp20_;
	sqlite3_stmt* _tmp21_;
	BackingPhotoRow* _tmp22_;
	sqlite3_stmt* _tmp23_;
	BackingPhotoRow* _tmp24_;
	sqlite3_stmt* _tmp25_;
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result = NULL;
#line 1230 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_TABLE (self), NULL);
#line 1230 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1232 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1232 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT filepath, timestamp, filesize, width, height, " "original_orientation, file_format, time_created FROM BackingPhotoTable" \
" WHERE id=?", -1, &_tmp1_, NULL);
#line 1232 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1232 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1232 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1235 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1237 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1237 "../src/db/PhotoTable.vala"
	_tmp4_ = *id;
#line 1237 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 1238 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1240 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 1240 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp5_);
#line 1241 "../src/db/PhotoTable.vala"
	if (res == SQLITE_DONE) {
#line 1242 "../src/db/PhotoTable.vala"
		result = NULL;
#line 1242 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 1242 "../src/db/PhotoTable.vala"
		return result;
#line 7589 "PhotoTable.c"
	} else {
#line 1243 "../src/db/PhotoTable.vala"
		if (res != SQLITE_ROW) {
#line 1244 "../src/db/PhotoTable.vala"
			database_table_throw_error ("BackingPhotoTable.fetch_for_photo", res, &_inner_error0_);
#line 1244 "../src/db/PhotoTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1244 "../src/db/PhotoTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1244 "../src/db/PhotoTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 1244 "../src/db/PhotoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 1244 "../src/db/PhotoTable.vala"
					return NULL;
#line 7605 "PhotoTable.c"
				} else {
#line 1244 "../src/db/PhotoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 1244 "../src/db/PhotoTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1244 "../src/db/PhotoTable.vala"
					g_clear_error (&_inner_error0_);
#line 1244 "../src/db/PhotoTable.vala"
					return NULL;
#line 7615 "PhotoTable.c"
				}
			}
		}
	}
#line 1246 "../src/db/PhotoTable.vala"
	_tmp6_ = backing_photo_row_new ();
#line 1246 "../src/db/PhotoTable.vala"
	row = _tmp6_;
#line 1247 "../src/db/PhotoTable.vala"
	_tmp7_ = row;
#line 1247 "../src/db/PhotoTable.vala"
	_tmp8_ = *id;
#line 1247 "../src/db/PhotoTable.vala"
	_tmp7_->id = _tmp8_;
#line 1248 "../src/db/PhotoTable.vala"
	_tmp9_ = row;
#line 1248 "../src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 1248 "../src/db/PhotoTable.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 0);
#line 1248 "../src/db/PhotoTable.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 1248 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp9_->filepath);
#line 1248 "../src/db/PhotoTable.vala"
	_tmp9_->filepath = _tmp12_;
#line 1249 "../src/db/PhotoTable.vala"
	_tmp13_ = row;
#line 1249 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 1249 "../src/db/PhotoTable.vala"
	_tmp13_->timestamp = (time_t) sqlite3_column_int64 (_tmp14_, 1);
#line 1250 "../src/db/PhotoTable.vala"
	_tmp15_ = row;
#line 1250 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 1250 "../src/db/PhotoTable.vala"
	_tmp15_->filesize = sqlite3_column_int64 (_tmp16_, 2);
#line 1251 "../src/db/PhotoTable.vala"
	_tmp17_ = row;
#line 1251 "../src/db/PhotoTable.vala"
	_tmp18_ = stmt;
#line 1251 "../src/db/PhotoTable.vala"
	_tmp19_ = stmt;
#line 1251 "../src/db/PhotoTable.vala"
	dimensions_init (&_tmp17_->dim, sqlite3_column_int (_tmp18_, 3), sqlite3_column_int (_tmp19_, 4));
#line 1252 "../src/db/PhotoTable.vala"
	_tmp20_ = row;
#line 1252 "../src/db/PhotoTable.vala"
	_tmp21_ = stmt;
#line 1252 "../src/db/PhotoTable.vala"
	_tmp20_->original_orientation = (Orientation) sqlite3_column_int (_tmp21_, 5);
#line 1253 "../src/db/PhotoTable.vala"
	_tmp22_ = row;
#line 1253 "../src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 1253 "../src/db/PhotoTable.vala"
	_tmp22_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp23_, 6));
#line 1254 "../src/db/PhotoTable.vala"
	_tmp24_ = row;
#line 1254 "../src/db/PhotoTable.vala"
	_tmp25_ = stmt;
#line 1254 "../src/db/PhotoTable.vala"
	_tmp24_->time_created = (time_t) sqlite3_column_int64 (_tmp25_, 7);
#line 1256 "../src/db/PhotoTable.vala"
	result = row;
#line 1256 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1256 "../src/db/PhotoTable.vala"
	return result;
#line 7686 "PhotoTable.c"
}

void
backing_photo_table_update (BackingPhotoTable* self,
                            BackingPhotoRow* row,
                            GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	Dimensions _tmp6_;
	sqlite3_stmt* _tmp7_;
	Dimensions _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp11_;
	BackingPhotoID _tmp12_;
	sqlite3_stmt* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 1260 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1260 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (row));
#line 1262 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1262 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE BackingPhotoTable SET timestamp=?, filesize=?, " "width=?, height=?, original_orientation=?, file_format=? " "WHERE id=?", -1, &_tmp1_, NULL);
#line 1262 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1262 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1262 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1266 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1268 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1268 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, (gint64) row->timestamp);
#line 1269 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1270 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 1270 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 2, row->filesize);
#line 1271 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1272 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 1272 "../src/db/PhotoTable.vala"
	_tmp6_ = row->dim;
#line 1272 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp5_, 3, _tmp6_.width);
#line 1273 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1274 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 1274 "../src/db/PhotoTable.vala"
	_tmp8_ = row->dim;
#line 1274 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp7_, 4, _tmp8_.height);
#line 1275 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1276 "../src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 1276 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp9_, 5, (gint) row->original_orientation);
#line 1277 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1278 "../src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 1278 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp10_, 6, photo_file_format_serialize (row->file_format));
#line 1279 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1280 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 1280 "../src/db/PhotoTable.vala"
	_tmp12_ = row->id;
#line 1280 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp11_, 7, _tmp12_.id);
#line 1281 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1283 "../src/db/PhotoTable.vala"
	_tmp13_ = stmt;
#line 1283 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp13_);
#line 1284 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1285 "../src/db/PhotoTable.vala"
		database_table_throw_error ("BackingPhotoTable.update", res, &_inner_error0_);
#line 1285 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1285 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1285 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1285 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1285 "../src/db/PhotoTable.vala"
				return;
#line 7793 "PhotoTable.c"
			} else {
#line 1285 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1285 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1285 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1285 "../src/db/PhotoTable.vala"
				return;
#line 7803 "PhotoTable.c"
			}
		}
	}
#line 1260 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 7809 "PhotoTable.c"
}

void
backing_photo_table_update_attributes (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       time_t timestamp,
                                       gint64 filesize,
                                       GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	BackingPhotoID _tmp6_;
	sqlite3_stmt* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 1288 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1288 "../src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1290 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1290 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE BackingPhotoTable SET timestamp=?, filesize=? WHERE id=?", -1, &_tmp1_, NULL);
#line 1290 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1290 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1290 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1292 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1294 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1294 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, (gint64) timestamp);
#line 1295 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1296 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 1296 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 2, filesize);
#line 1297 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1298 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 1298 "../src/db/PhotoTable.vala"
	_tmp6_ = *id;
#line 1298 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp5_, 3, _tmp6_.id);
#line 1299 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1301 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 1301 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp7_);
#line 1302 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1303 "../src/db/PhotoTable.vala"
		database_table_throw_error ("BackingPhotoTable.update_attributes", res, &_inner_error0_);
#line 1303 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1303 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1303 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1303 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1303 "../src/db/PhotoTable.vala"
				return;
#line 7884 "PhotoTable.c"
			} else {
#line 1303 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1303 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1303 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1303 "../src/db/PhotoTable.vala"
				return;
#line 7894 "PhotoTable.c"
			}
		}
	}
#line 1288 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 7900 "PhotoTable.c"
}

void
backing_photo_table_remove (BackingPhotoTable* self,
                            BackingPhotoID* backing_id,
                            GError** error)
{
	BackingPhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1306 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1306 "../src/db/PhotoTable.vala"
	g_return_if_fail (backing_id != NULL);
#line 1307 "../src/db/PhotoTable.vala"
	_tmp0_ = *backing_id;
#line 1307 "../src/db/PhotoTable.vala"
	database_table_delete_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, &_inner_error0_);
#line 1307 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1307 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1307 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1307 "../src/db/PhotoTable.vala"
			return;
#line 7926 "PhotoTable.c"
		} else {
#line 1307 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1307 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1307 "../src/db/PhotoTable.vala"
			return;
#line 7934 "PhotoTable.c"
		}
	}
}

void
backing_photo_table_set_filepath (BackingPhotoTable* self,
                                  BackingPhotoID* id,
                                  const gchar* filepath,
                                  GError** error)
{
	BackingPhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1310 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1310 "../src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1310 "../src/db/PhotoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 1311 "../src/db/PhotoTable.vala"
	_tmp0_ = *id;
#line 1311 "../src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "filepath", filepath, &_inner_error0_);
#line 1311 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1311 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1311 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1311 "../src/db/PhotoTable.vala"
			return;
#line 7965 "PhotoTable.c"
		} else {
#line 1311 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1311 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1311 "../src/db/PhotoTable.vala"
			return;
#line 7973 "PhotoTable.c"
		}
	}
}

void
backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                      BackingPhotoID* id,
                                      time_t timestamp,
                                      GError** error)
{
	BackingPhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1314 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1314 "../src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1315 "../src/db/PhotoTable.vala"
	_tmp0_ = *id;
#line 1315 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "timestamp", (gint64) timestamp, &_inner_error0_);
#line 1315 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1315 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1315 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1315 "../src/db/PhotoTable.vala"
			return;
#line 8002 "PhotoTable.c"
		} else {
#line 1315 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1315 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1315 "../src/db/PhotoTable.vala"
			return;
#line 8010 "PhotoTable.c"
		}
	}
}

static void
backing_photo_table_class_init (BackingPhotoTableClass * klass,
                                gpointer klass_data)
{
#line 1160 "../src/db/PhotoTable.vala"
	backing_photo_table_parent_class = g_type_class_peek_parent (klass);
#line 1160 "../src/db/PhotoTable.vala"
	((DatabaseTableClass *) klass)->finalize = backing_photo_table_finalize;
#line 8023 "PhotoTable.c"
}

static void
backing_photo_table_instance_init (BackingPhotoTable * self,
                                   gpointer klass)
{
}

static void
backing_photo_table_finalize (DatabaseTable * obj)
{
	BackingPhotoTable * self;
#line 1160 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable);
#line 1160 "../src/db/PhotoTable.vala"
	DATABASE_TABLE_CLASS (backing_photo_table_parent_class)->finalize (obj);
#line 8040 "PhotoTable.c"
}

static GType
backing_photo_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BackingPhotoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) backing_photo_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackingPhotoTable), 0, (GInstanceInitFunc) backing_photo_table_instance_init, NULL };
	GType backing_photo_table_type_id;
	backing_photo_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "BackingPhotoTable", &g_define_type_info, 0);
	return backing_photo_table_type_id;
}

GType
backing_photo_table_get_type (void)
{
	static volatile gsize backing_photo_table_type_id__volatile = 0;
	if (g_once_init_enter (&backing_photo_table_type_id__volatile)) {
		GType backing_photo_table_type_id;
		backing_photo_table_type_id = backing_photo_table_get_type_once ();
		g_once_init_leave (&backing_photo_table_type_id__volatile, backing_photo_table_type_id);
	}
	return backing_photo_table_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

