/* PhotoMetadata.c generated by valac 0.52.10, the Vala compiler
 * generated from PhotoMetadata.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/**/
/* PhotoMetadata*/
/**/
/* PhotoMetadata is a wrapper class around gexiv2.  The reasoning for this is (a) to facilitate*/
/* interface changes to meet Shotwell's requirements without needing modifications of the library*/
/* itself, and (b) some requirements for this class (i.e. obtaining raw metadata) is not available*/
/* in gexiv2, and so must be done by hand.*/
/**/
/* Although it's perceived that Exiv2 will remain Shotwell's metadata library of choice, this*/
/* may change in the future, and so this wrapper helps with that as well.*/
/**/
/* There is no expectation of thread-safety in this class (yet).*/
/**/
/* Tags come from Exiv2's naming scheme:*/
/* http://www.exiv2.org/metadata.html*/
/**/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include "metadata.h"
#include <gexiv2/gexiv2.h>
#include <libexif/exif-data.h>
#include <libexif/exif-mem.h>
#include <float.h>
#include <math.h>

typedef enum  {
	METADATA_DOMAIN_UNKNOWN,
	METADATA_DOMAIN_EXIF,
	METADATA_DOMAIN_XMP,
	METADATA_DOMAIN_IPTC
} MetadataDomain;

#define TYPE_METADATA_DOMAIN (metadata_domain_get_type ())

#define TYPE_KEYWORD_TRANSFORMER (keyword_transformer_get_type ())
#define KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEYWORD_TRANSFORMER, KeywordTransformer))
#define KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEYWORD_TRANSFORMER, KeywordTransformerClass))
#define IS_KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEYWORD_TRANSFORMER))
#define IS_KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEYWORD_TRANSFORMER))
#define KEYWORD_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEYWORD_TRANSFORMER, KeywordTransformerClass))

typedef struct _KeywordTransformer KeywordTransformer;
typedef struct _KeywordTransformerClass KeywordTransformerClass;
typedef struct _KeywordTransformerPrivate KeywordTransformerPrivate;
typedef struct _ParamSpecKeywordTransformer ParamSpecKeywordTransformer;

#define TYPE_NULL_KEYWORD_TRANSFORMER (null_keyword_transformer_get_type ())
#define NULL_KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NULL_KEYWORD_TRANSFORMER, NullKeywordTransformer))
#define NULL_KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NULL_KEYWORD_TRANSFORMER, NullKeywordTransformerClass))
#define IS_NULL_KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NULL_KEYWORD_TRANSFORMER))
#define IS_NULL_KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NULL_KEYWORD_TRANSFORMER))
#define NULL_KEYWORD_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NULL_KEYWORD_TRANSFORMER, NullKeywordTransformerClass))

typedef struct _NullKeywordTransformer NullKeywordTransformer;
typedef struct _NullKeywordTransformerClass NullKeywordTransformerClass;
typedef struct _NullKeywordTransformerPrivate NullKeywordTransformerPrivate;

#define TYPE_ACD_SEE_KEYWORD_TRANSFORMER (acd_see_keyword_transformer_get_type ())
#define ACD_SEE_KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACD_SEE_KEYWORD_TRANSFORMER, ACDSeeKeywordTransformer))
#define ACD_SEE_KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACD_SEE_KEYWORD_TRANSFORMER, ACDSeeKeywordTransformerClass))
#define IS_ACD_SEE_KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACD_SEE_KEYWORD_TRANSFORMER))
#define IS_ACD_SEE_KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACD_SEE_KEYWORD_TRANSFORMER))
#define ACD_SEE_KEYWORD_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACD_SEE_KEYWORD_TRANSFORMER, ACDSeeKeywordTransformerClass))

typedef struct _ACDSeeKeywordTransformer ACDSeeKeywordTransformer;
typedef struct _ACDSeeKeywordTransformerClass ACDSeeKeywordTransformerClass;
typedef struct _ACDSeeKeywordTransformerPrivate ACDSeeKeywordTransformerPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_markup_parse_context_unref0(var) ((var == NULL) ? NULL : (var = (g_markup_parse_context_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define TYPE_HIERARCHICAL_KEYWORD_FIELD (hierarchical_keyword_field_get_type ())
#define HIERARCHICAL_KEYWORD_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordField))
#define HIERARCHICAL_KEYWORD_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordFieldClass))
#define IS_HIERARCHICAL_KEYWORD_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD))
#define IS_HIERARCHICAL_KEYWORD_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_KEYWORD_FIELD))
#define HIERARCHICAL_KEYWORD_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordFieldClass))

typedef struct _HierarchicalKeywordField HierarchicalKeywordField;
typedef struct _HierarchicalKeywordFieldClass HierarchicalKeywordFieldClass;
typedef struct _HierarchicalKeywordFieldPrivate HierarchicalKeywordFieldPrivate;
#define _keyword_transformer_unref0(var) ((var == NULL) ? NULL : (var = (keyword_transformer_unref (var), NULL)))
typedef struct _ParamSpecHierarchicalKeywordField ParamSpecHierarchicalKeywordField;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
typedef struct _PhotoPreviewPrivate PhotoPreviewPrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
typedef struct _ParamSpecPhotoPreview ParamSpecPhotoPreview;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
typedef struct _PhotoMetadataPrivate PhotoMetadataPrivate;
typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())
typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))
typedef void (*PhotoMetadataSetGenericValue) (const gchar* tag, gpointer user_data);
typedef struct _Block1Data Block1Data;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _exif_mem_unref0(var) ((var == NULL) ? NULL : (var = (exif_mem_unref (var), NULL)))
#define _g_checksum_free0(var) ((var == NULL) ? NULL : (var = (g_checksum_free (var), NULL)))

#define PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW (photo_metadata_internal_photo_preview_get_type ())
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))

typedef struct _PhotoMetadataInternalPhotoPreview PhotoMetadataInternalPhotoPreview;
typedef struct _PhotoMetadataInternalPhotoPreviewClass PhotoMetadataInternalPhotoPreviewClass;
typedef struct _Block6Data Block6Data;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_keyword_field_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_keyword_field_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_GPS_COORDS (gps_coords_get_type ())
typedef struct _GpsCoords GpsCoords;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())
typedef struct _PhotoMetadataInternalPhotoPreviewPrivate PhotoMetadataInternalPhotoPreviewPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KeywordTransformer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	KeywordTransformerPrivate * priv;
};

struct _KeywordTransformerClass {
	GTypeClass parent_class;
	void (*finalize) (KeywordTransformer *self);
	GeeList* (*transform) (KeywordTransformer* self, const gchar* input, GError** error);
};

struct _ParamSpecKeywordTransformer {
	GParamSpec parent_instance;
};

struct _NullKeywordTransformer {
	KeywordTransformer parent_instance;
	NullKeywordTransformerPrivate * priv;
};

struct _NullKeywordTransformerClass {
	KeywordTransformerClass parent_class;
};

struct _ACDSeeKeywordTransformer {
	KeywordTransformer parent_instance;
	ACDSeeKeywordTransformerPrivate * priv;
};

struct _ACDSeeKeywordTransformerClass {
	KeywordTransformerClass parent_class;
};

struct _ACDSeeKeywordTransformerPrivate {
	GMarkupParser parser;
	GError* error;
	GeeArrayQueue* stack;
	GeeArrayList* result;
	gboolean assigned;
};

struct _HierarchicalKeywordField {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HierarchicalKeywordFieldPrivate * priv;
	gchar* field_name;
	gchar* path_separator;
	gboolean wants_leading_separator;
	gboolean is_writeable;
	KeywordTransformer* transformer;
};

struct _HierarchicalKeywordFieldClass {
	GTypeClass parent_class;
	void (*finalize) (HierarchicalKeywordField *self);
};

struct _ParamSpecHierarchicalKeywordField {
	GParamSpec parent_instance;
};

struct _PhotoPreview {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoPreviewPrivate * priv;
};

struct _PhotoPreviewClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoPreview *self);
	GBytes* (*flatten) (PhotoPreview* self, GError** error);
	GdkPixbuf* (*get_pixbuf) (PhotoPreview* self, GError** error);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _PhotoPreviewPrivate {
	gchar* name;
	Dimensions dimensions;
	guint32 size;
	gchar* mime_type;
	gchar* extension;
};

struct _ParamSpecPhotoPreview {
	GParamSpec parent_instance;
};

struct _PhotoMetadata {
	MediaMetadata parent_instance;
	PhotoMetadataPrivate * priv;
};

struct _PhotoMetadataClass {
	MediaMetadataClass parent_class;
};

struct _PhotoMetadataPrivate {
	GExiv2Metadata* exiv2;
	ExifData* exif;
	gchar* source_name;
	gchar* metadata_hash;
	gchar* thumbnail_md5;
};

struct _Block1Data {
	int _ref_count_;
	PhotoMetadata* self;
	gchar* value;
};

struct _Block2Data {
	int _ref_count_;
	PhotoMetadata* self;
	GeeCollection* values;
};

struct _Block3Data {
	int _ref_count_;
	PhotoMetadata* self;
	glong value;
};

struct _Block4Data {
	int _ref_count_;
	PhotoMetadata* self;
	MetadataRational rational;
};

struct _Block5Data {
	int _ref_count_;
	PhotoMetadata* self;
	MetadataDateTime* date_time;
};

struct _Block6Data {
	int _ref_count_;
	PhotoMetadata* self;
	gchar* comment;
};

struct _GpsCoords {
	gint has_gps;
	gdouble latitude;
	gdouble longitude;
};

struct _PhotoMetadataInternalPhotoPreview {
	PhotoPreview parent_instance;
	PhotoMetadataInternalPhotoPreviewPrivate * priv;
	PhotoMetadata* owner;
	guint number;
};

struct _PhotoMetadataInternalPhotoPreviewClass {
	PhotoPreviewClass parent_class;
};

static gpointer keyword_transformer_parent_class = NULL;
static gpointer null_keyword_transformer_parent_class = NULL;
static gint ACDSeeKeywordTransformer_private_offset;
static gpointer acd_see_keyword_transformer_parent_class = NULL;
static gpointer hierarchical_keyword_field_parent_class = NULL;
static gint PhotoPreview_private_offset;
static gpointer photo_preview_parent_class = NULL;
static gint PhotoMetadata_private_offset;
static gpointer photo_metadata_parent_class = NULL;
static gchar** photo_metadata_DATE_TIME_TAGS;
static gint photo_metadata_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS = NULL;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_EXPOSURE_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DIGITIZED_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_WIDTH_TAGS;
static gint photo_metadata_WIDTH_TAGS_length1;
static gchar** photo_metadata_WIDTH_TAGS = NULL;
static gint photo_metadata_WIDTH_TAGS_length1 = 0;
static gint _photo_metadata_WIDTH_TAGS_size_ = 0;
extern gchar** photo_metadata_HEIGHT_TAGS;
extern gint photo_metadata_HEIGHT_TAGS_length1;
gchar** photo_metadata_HEIGHT_TAGS = NULL;
gint photo_metadata_HEIGHT_TAGS_length1 = 0;
static gchar** photo_metadata_STANDARD_TITLE_TAGS;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1;
static gchar** photo_metadata_STANDARD_TITLE_TAGS = NULL;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1 = 0;
static gint _photo_metadata_STANDARD_TITLE_TAGS_size_ = 0;
static gchar** photo_metadata_COMMENT_TAGS;
static gint photo_metadata_COMMENT_TAGS_length1;
static gchar** photo_metadata_COMMENT_TAGS = NULL;
static gint photo_metadata_COMMENT_TAGS_length1 = 0;
static gint _photo_metadata_COMMENT_TAGS_size_ = 0;
static gchar** photo_metadata_KEYWORD_TAGS;
static gint photo_metadata_KEYWORD_TAGS_length1;
static gchar** photo_metadata_KEYWORD_TAGS = NULL;
static gint photo_metadata_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_KEYWORD_TAGS_size_ = 0;
static HierarchicalKeywordField** photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
static HierarchicalKeywordField** photo_metadata_HIERARCHICAL_KEYWORD_TAGS = NULL;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_HIERARCHICAL_KEYWORD_TAGS_size_ = 0;
static gchar** photo_metadata_ARTIST_TAGS;
static gint photo_metadata_ARTIST_TAGS_length1;
static gchar** photo_metadata_ARTIST_TAGS = NULL;
static gint photo_metadata_ARTIST_TAGS_length1 = 0;
static gint _photo_metadata_ARTIST_TAGS_size_ = 0;
static gchar** photo_metadata_RATING_TAGS;
static gint photo_metadata_RATING_TAGS_length1;
static gchar** photo_metadata_RATING_TAGS = NULL;
static gint photo_metadata_RATING_TAGS_length1 = 0;
static gint _photo_metadata_RATING_TAGS_size_ = 0;
static gpointer photo_metadata_internal_photo_preview_parent_class = NULL;

GType metadata_domain_get_type (void) G_GNUC_CONST ;
gpointer keyword_transformer_ref (gpointer instance);
void keyword_transformer_unref (gpointer instance);
GParamSpec* param_spec_keyword_transformer (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_keyword_transformer (GValue* value,
                                    gpointer v_object);
void value_take_keyword_transformer (GValue* value,
                                     gpointer v_object);
gpointer value_get_keyword_transformer (const GValue* value);
GType keyword_transformer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KeywordTransformer, keyword_transformer_unref)
GeeList* keyword_transformer_transform (KeywordTransformer* self,
                                        const gchar* input,
                                        GError** error);
static GeeList* keyword_transformer_real_transform (KeywordTransformer* self,
                                             const gchar* input,
                                             GError** error);
KeywordTransformer* keyword_transformer_construct (GType object_type);
static void keyword_transformer_finalize (KeywordTransformer * obj);
static GType keyword_transformer_get_type_once (void);
GType null_keyword_transformer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NullKeywordTransformer, keyword_transformer_unref)
static GeeList* null_keyword_transformer_real_transform (KeywordTransformer* base,
                                                  const gchar* input,
                                                  GError** error);
NullKeywordTransformer* null_keyword_transformer_new (void);
NullKeywordTransformer* null_keyword_transformer_construct (GType object_type);
static GType null_keyword_transformer_get_type_once (void);
GType acd_see_keyword_transformer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ACDSeeKeywordTransformer, keyword_transformer_unref)
ACDSeeKeywordTransformer* acd_see_keyword_transformer_new (void);
ACDSeeKeywordTransformer* acd_see_keyword_transformer_construct (GType object_type);
static void acd_see_keyword_transformer_on_start (ACDSeeKeywordTransformer* self,
                                           GMarkupParseContext* ctx,
                                           const gchar* name,
                                           gchar** attribute_names,
                                           gchar** attribute_values,
                                           GError** error);
static void _acd_see_keyword_transformer_on_start_gmarkup_parser_start_element_func (GMarkupParseContext* context,
                                                                              const gchar* element_name,
                                                                              gchar** attribute_names,
                                                                              gchar** attribute_values,
                                                                              gpointer self,
                                                                              GError** error);
static void acd_see_keyword_transformer_on_end (ACDSeeKeywordTransformer* self,
                                         GMarkupParseContext* ctx,
                                         const gchar* name,
                                         GError** error);
static void _acd_see_keyword_transformer_on_end_gmarkup_parser_end_element_func (GMarkupParseContext* context,
                                                                          const gchar* element_name,
                                                                          gpointer self,
                                                                          GError** error);
static void acd_see_keyword_transformer_on_text (ACDSeeKeywordTransformer* self,
                                          GMarkupParseContext* ctx,
                                          const gchar* text,
                                          GError** error);
static void _acd_see_keyword_transformer_on_text_gmarkup_parser_text_func (GMarkupParseContext* context,
                                                                    const gchar* text,
                                                                    gsize text_len,
                                                                    gpointer self,
                                                                    GError** error);
static void acd_see_keyword_transformer_on_error (ACDSeeKeywordTransformer* self,
                                           GMarkupParseContext* ctx,
                                           GError* _error_);
static void _acd_see_keyword_transformer_on_error_gmarkup_parser_error_func (GMarkupParseContext* context,
                                                                      GError* _error_,
                                                                      gpointer self);
static GeeList* acd_see_keyword_transformer_real_transform (KeywordTransformer* base,
                                                     const gchar* input,
                                                     GError** error);
static void acd_see_keyword_transformer_finalize (KeywordTransformer * obj);
static GType acd_see_keyword_transformer_get_type_once (void);
gpointer hierarchical_keyword_field_ref (gpointer instance);
void hierarchical_keyword_field_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_keyword_field (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
void value_set_hierarchical_keyword_field (GValue* value,
                                           gpointer v_object);
void value_take_hierarchical_keyword_field (GValue* value,
                                            gpointer v_object);
gpointer value_get_hierarchical_keyword_field (const GValue* value);
GType hierarchical_keyword_field_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HierarchicalKeywordField, hierarchical_keyword_field_unref)
HierarchicalKeywordField* hierarchical_keyword_field_new (const gchar* field_name,
                                                          const gchar* path_separator,
                                                          gboolean wants_leading_separator,
                                                          gboolean is_writeable,
                                                          KeywordTransformer* transformer);
HierarchicalKeywordField* hierarchical_keyword_field_construct (GType object_type,
                                                                const gchar* field_name,
                                                                const gchar* path_separator,
                                                                gboolean wants_leading_separator,
                                                                gboolean is_writeable,
                                                                KeywordTransformer* transformer);
static void hierarchical_keyword_field_finalize (HierarchicalKeywordField * obj);
static GType hierarchical_keyword_field_get_type_once (void);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_photo_preview (GValue* value,
                              gpointer v_object);
void value_take_photo_preview (GValue* value,
                               gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoPreview, photo_preview_unref)
GType dimensions_get_type (void) G_GNUC_CONST ;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GBytes* photo_preview_flatten (PhotoPreview* self,
                               GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self,
                                     GError** error);
PhotoPreview* photo_preview_construct (GType object_type,
                                       const gchar* name,
                                       Dimensions* dimensions,
                                       guint32 size,
                                       const gchar* mime_type,
                                       const gchar* extension);
gchar* photo_preview_get_name (PhotoPreview* self);
void photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                         Dimensions* result);
guint32 photo_preview_get_size (PhotoPreview* self);
gchar* photo_preview_get_mime_type (PhotoPreview* self);
gchar* photo_preview_get_extension (PhotoPreview* self);
static GBytes* photo_preview_real_flatten (PhotoPreview* self,
                                    GError** error);
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self,
                                          GError** error);
static void photo_preview_finalize (PhotoPreview * obj);
static GType photo_preview_get_type_once (void);
GType photo_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoMetadata, media_metadata_unref)
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST ;
GType prepare_input_text_options_get_type (void) G_GNUC_CONST ;
#define PHOTO_METADATA_PREPARE_STRING_OPTIONS (((((PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE)
#define PHOTO_METADATA_IPHOTO_TITLE_TAG "Iptc.Application2.ObjectName"
PhotoMetadata* photo_metadata_new (void);
PhotoMetadata* photo_metadata_construct (GType object_type);
static void photo_metadata_real_read_from_file (MediaMetadata* base,
                                         GFile* file,
                                         GError** error);
void photo_metadata_write_to_file (PhotoMetadata* self,
                                   GFile* file,
                                   GError** error);
void photo_metadata_read_from_buffer (PhotoMetadata* self,
                                      guint8* buffer,
                                      gint buffer_length1,
                                      gint length,
                                      GError** error);
void photo_metadata_read_from_app1_segment (PhotoMetadata* self,
                                            GBytes* buffer,
                                            GError** error);
MetadataDomain photo_metadata_get_tag_domain (const gchar* tag);
gboolean photo_metadata_has_domain (PhotoMetadata* self,
                                    MetadataDomain domain);
gboolean photo_metadata_has_exif (PhotoMetadata* self);
gboolean photo_metadata_has_xmp (PhotoMetadata* self);
gboolean photo_metadata_has_iptc (PhotoMetadata* self);
gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self,
                                             MetadataDomain domain);
gboolean photo_metadata_can_write_exif (PhotoMetadata* self);
gboolean photo_metadata_can_write_xmp (PhotoMetadata* self);
gboolean photo_metadata_can_write_iptc (PhotoMetadata* self);
gboolean photo_metadata_has_tag (PhotoMetadata* self,
                                 const gchar* tag);
static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self,
                                          GCompareDataFunc compare_func,
                                          gpointer compare_func_target,
                                          GDestroyNotify compare_func_target_destroy_notify);
GeeCollection* photo_metadata_get_tags (PhotoMetadata* self,
                                        MetadataDomain domain,
                                        GCompareDataFunc compare_func,
                                        gpointer compare_func_target,
                                        GDestroyNotify compare_func_target_destroy_notify);
GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self,
                                            GCompareDataFunc compare_func,
                                            gpointer compare_func_target,
                                            GDestroyNotify compare_func_target_destroy_notify);
gchar* photo_metadata_get_tag_label (PhotoMetadata* self,
                                     const gchar* tag);
gchar* photo_metadata_get_tag_description (PhotoMetadata* self,
                                           const gchar* tag);
gchar* photo_metadata_get_string (PhotoMetadata* self,
                                  const gchar* tag,
                                  PrepareInputTextOptions options);
gchar* prepare_input_text (const gchar* text,
                           PrepareInputTextOptions options,
                           gint dest_length);
#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
gchar* photo_metadata_get_string_interpreted (PhotoMetadata* self,
                                              const gchar* tag,
                                              PrepareInputTextOptions options);
gchar* photo_metadata_get_first_string (PhotoMetadata* self,
                                        gchar** tags,
                                        gint tags_length1);
gchar* photo_metadata_get_first_string_interpreted (PhotoMetadata* self,
                                                    gchar** tags,
                                                    gint tags_length1);
GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self,
                                             const gchar* tag);
GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self,
                                                   gchar** tags,
                                                   gint tags_length1);
void photo_metadata_set_string (PhotoMetadata* self,
                                const gchar* tag,
                                const gchar* value,
                                PrepareInputTextOptions options,
                                gint length);
static void photo_metadata_set_all_generic (PhotoMetadata* self,
                                     gchar** tags,
                                     gint tags_length1,
                                     PhotoMetadataSetOption option,
                                     PhotoMetadataSetGenericValue setter,
                                     gpointer setter_target);
void photo_metadata_set_all_string (PhotoMetadata* self,
                                    gchar** tags,
                                    gint tags_length1,
                                    const gchar* value,
                                    PhotoMetadataSetOption option);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda5_ (Block1Data* _data1_,
                 const gchar* tag);
static void ___lambda5__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
void photo_metadata_set_string_multiple (PhotoMetadata* self,
                                         const gchar* tag,
                                         GeeCollection* collection);
static void _vala_array_add46 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add47 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
void photo_metadata_set_all_string_multiple (PhotoMetadata* self,
                                             gchar** tags,
                                             gint tags_length1,
                                             GeeCollection* values,
                                             PhotoMetadataSetOption option);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda6_ (Block2Data* _data2_,
                 const gchar* tag);
static void ___lambda6__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
gboolean photo_metadata_get_long (PhotoMetadata* self,
                                  const gchar* tag,
                                  glong* value);
gboolean photo_metadata_get_first_long (PhotoMetadata* self,
                                        gchar** tags,
                                        gint tags_length1,
                                        glong* value);
void photo_metadata_set_long (PhotoMetadata* self,
                              const gchar* tag,
                              glong value);
void photo_metadata_set_all_long (PhotoMetadata* self,
                                  gchar** tags,
                                  gint tags_length1,
                                  glong value,
                                  PhotoMetadataSetOption option);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda7_ (Block3Data* _data3_,
                 const gchar* tag);
static void ___lambda7__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
gboolean photo_metadata_get_rational (PhotoMetadata* self,
                                      const gchar* tag,
                                      MetadataRational* rational);
gboolean photo_metadata_get_first_rational (PhotoMetadata* self,
                                            gchar** tags,
                                            gint tags_length1,
                                            MetadataRational* rational);
void photo_metadata_set_rational (PhotoMetadata* self,
                                  const gchar* tag,
                                  MetadataRational* rational);
void photo_metadata_set_all_rational (PhotoMetadata* self,
                                      gchar** tags,
                                      gint tags_length1,
                                      MetadataRational* rational,
                                      PhotoMetadataSetOption option);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda8_ (Block4Data* _data4_,
                 const gchar* tag);
static void ___lambda8__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self,
                                                const gchar* tag);
MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self,
                                                      gchar** tags,
                                                      gint tags_length1);
void photo_metadata_set_date_time (PhotoMetadata* self,
                                   const gchar* tag,
                                   MetadataDateTime* date_time);
void photo_metadata_set_all_date_time (PhotoMetadata* self,
                                       gchar** tags,
                                       gint tags_length1,
                                       MetadataDateTime* date_time,
                                       PhotoMetadataSetOption option);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda9_ (Block5Data* _data5_,
                 const gchar* tag);
static void ___lambda9__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
gchar* photo_metadata_exif_hash (PhotoMetadata* self);
gchar* photo_metadata_thumbnail_hash (PhotoMetadata* self);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self,
                                          guint number);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner,
                                                                              const gchar* name,
                                                                              guint number,
                                                                              GExiv2PreviewProperties* props);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type,
                                                                                    PhotoMetadata* owner,
                                                                                    const gchar* name,
                                                                                    guint number,
                                                                                    GExiv2PreviewProperties* props);
static GType photo_metadata_internal_photo_preview_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoMetadataInternalPhotoPreview, photo_preview_unref)
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_remove_tag (PhotoMetadata* self,
                                const gchar* tag);
void photo_metadata_remove_tags (PhotoMetadata* self,
                                 gchar** tags,
                                 gint tags_length1);
void photo_metadata_clear_domain (PhotoMetadata* self,
                                  MetadataDomain domain);
void photo_metadata_clear (PhotoMetadata* self);
MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self);
void photo_metadata_set_modification_date_time (PhotoMetadata* self,
                                                MetadataDateTime* date_time,
                                                PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                            MetadataDateTime* date_time,
                                            PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self);
void photo_metadata_set_digitized_date_time (PhotoMetadata* self,
                                             MetadataDateTime* date_time,
                                             PhotoMetadataSetOption option);
static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base);
Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                          Dimensions* dim,
                                          PhotoMetadataSetOption option);
static gchar* photo_metadata_real_get_title (MediaMetadata* base);
gboolean is_string_empty (const gchar* s);
void photo_metadata_set_title (PhotoMetadata* self,
                               const gchar* title,
                               PhotoMetadataSetOption option);
static gchar* photo_metadata_real_get_comment (MediaMetadata* base);
void photo_metadata_set_comment (PhotoMetadata* self,
                                 const gchar* comment,
                                 PhotoMetadataSetOption option);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void ___lambda10_ (Block6Data* _data6_,
                   const gchar* tag);
static void ____lambda10__photo_metadata_set_generic_value (const gchar* tag,
                                                     gpointer self);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self,
                                     GCompareDataFunc compare_func,
                                     gpointer compare_func_target,
                                     GDestroyNotify compare_func_target_destroy_notify);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value,
                                       gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value,
                                        gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HierarchicalTagIndex, hierarchical_tag_index_unref)
static void photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self,
                                                        HierarchicalTagIndex* index);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
#define TAG_PATH_SEPARATOR_STRING "/"
void photo_metadata_set_keywords (PhotoMetadata* self,
                                  GeeCollection* keywords,
                                  PhotoMetadataSetOption option);
HierarchicalTagIndex* hierarchical_tag_index_new (void);
HierarchicalTagIndex* hierarchical_tag_index_construct (GType object_type);
GeeList* hierarchical_tag_utilities_enumerate_path_components (const gchar* in_path);
void hierarchical_tag_index_add_path (HierarchicalTagIndex* self,
                                      const gchar* tag,
                                      const gchar* path);
GeeCollection* hierarchical_tag_index_get_all_tags (HierarchicalTagIndex* self);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
gchar* hierarchical_tag_utilities_canonicalize (const gchar* in_tag,
                                                const gchar* foreign_separator);
gboolean photo_metadata_has_orientation (PhotoMetadata* self);
GType orientation_get_type (void) G_GNUC_CONST ;
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self,
                                     Orientation orientation);
gboolean photo_metadata_get_gps (PhotoMetadata* self,
                                 gdouble* longitude,
                                 gchar** long_ref,
                                 gdouble* latitude,
                                 gchar** lat_ref,
                                 gdouble* altitude);
GType gps_coords_get_type (void) G_GNUC_CONST ;
GpsCoords* gps_coords_dup (const GpsCoords* self);
void gps_coords_free (GpsCoords* self);
void photo_metadata_get_gps_coords (PhotoMetadata* self,
                                    GpsCoords* result);
void photo_metadata_set_gps_coords (PhotoMetadata* self,
                                    GpsCoords* gps_coords);
gboolean photo_metadata_get_exposure (PhotoMetadata* self,
                                      MetadataRational* exposure);
gchar* photo_metadata_get_exposure_string (PhotoMetadata* self);
gboolean photo_metadata_get_iso (PhotoMetadata* self,
                                 glong* iso);
gchar* photo_metadata_get_iso_string (PhotoMetadata* self);
gboolean photo_metadata_get_aperture (PhotoMetadata* self,
                                      MetadataRational* aperture);
gchar* photo_metadata_get_aperture_string (PhotoMetadata* self,
                                           gboolean pango_formatted);
gchar* photo_metadata_get_camera_make (PhotoMetadata* self);
gchar* photo_metadata_get_camera_model (PhotoMetadata* self);
gboolean photo_metadata_get_flash (PhotoMetadata* self,
                                   glong* flash);
gchar* photo_metadata_get_flash_string (PhotoMetadata* self);
gboolean photo_metadata_get_focal_length (PhotoMetadata* self,
                                          MetadataRational* focal_length);
gchar* photo_metadata_get_focal_length_string (PhotoMetadata* self);
gchar* photo_metadata_get_artist (PhotoMetadata* self);
gchar* photo_metadata_get_copyright (PhotoMetadata* self);
gchar* photo_metadata_get_software (PhotoMetadata* self);
void photo_metadata_set_software (PhotoMetadata* self,
                                  const gchar* software,
                                  const gchar* version);
void photo_metadata_remove_software (PhotoMetadata* self);
gchar* photo_metadata_get_exposure_bias (PhotoMetadata* self);
GType rating_get_type (void) G_GNUC_CONST ;
Rating photo_metadata_get_rating (PhotoMetadata* self);
Rating rating_unserialize (gint value);
void photo_metadata_set_rating (PhotoMetadata* self,
                                Rating rating);
gint rating_serialize (Rating self);
static GBytes* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base,
                                                            GError** error);
static void photo_metadata_internal_photo_preview_finalize (PhotoPreview * obj);
static GType photo_metadata_internal_photo_preview_get_type_once (void);
static void photo_metadata_finalize (MediaMetadata * obj);
static GType photo_metadata_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

extern const gint RESOURCES_rating_thresholds[6];

static GType
metadata_domain_get_type_once (void)
{
	static const GEnumValue values[] = {{METADATA_DOMAIN_UNKNOWN, "METADATA_DOMAIN_UNKNOWN", "unknown"}, {METADATA_DOMAIN_EXIF, "METADATA_DOMAIN_EXIF", "exif"}, {METADATA_DOMAIN_XMP, "METADATA_DOMAIN_XMP", "xmp"}, {METADATA_DOMAIN_IPTC, "METADATA_DOMAIN_IPTC", "iptc"}, {0, NULL, NULL}};
	GType metadata_domain_type_id;
	metadata_domain_type_id = g_enum_register_static ("MetadataDomain", values);
	return metadata_domain_type_id;
}

GType
metadata_domain_get_type (void)
{
	static volatile gsize metadata_domain_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_domain_type_id__volatile)) {
		GType metadata_domain_type_id;
		metadata_domain_type_id = metadata_domain_get_type_once ();
		g_once_init_leave (&metadata_domain_type_id__volatile, metadata_domain_type_id);
	}
	return metadata_domain_type_id__volatile;
}

static GeeList*
keyword_transformer_real_transform (KeywordTransformer* self,
                                    const gchar* input,
                                    GError** error)
{
#line 32 "../src/photos/PhotoMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `keyword_transformer_transform'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 32 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 958 "PhotoMetadata.c"
}

GeeList*
keyword_transformer_transform (KeywordTransformer* self,
                               const gchar* input,
                               GError** error)
{
	KeywordTransformerClass* _klass_;
#line 32 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_KEYWORD_TRANSFORMER (self), NULL);
#line 32 "../src/photos/PhotoMetadata.vala"
	_klass_ = KEYWORD_TRANSFORMER_GET_CLASS (self);
#line 32 "../src/photos/PhotoMetadata.vala"
	if (_klass_->transform) {
#line 32 "../src/photos/PhotoMetadata.vala"
		return _klass_->transform (self, input, error);
#line 975 "PhotoMetadata.c"
	}
#line 32 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 979 "PhotoMetadata.c"
}

KeywordTransformer*
keyword_transformer_construct (GType object_type)
{
	KeywordTransformer* self = NULL;
#line 31 "../src/photos/PhotoMetadata.vala"
	self = (KeywordTransformer*) g_type_create_instance (object_type);
#line 31 "../src/photos/PhotoMetadata.vala"
	return self;
#line 990 "PhotoMetadata.c"
}

static void
value_keyword_transformer_init (GValue* value)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 998 "PhotoMetadata.c"
}

static void
value_keyword_transformer_free_value (GValue* value)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 31 "../src/photos/PhotoMetadata.vala"
		keyword_transformer_unref (value->data[0].v_pointer);
#line 1008 "PhotoMetadata.c"
	}
}

static void
value_keyword_transformer_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 31 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = keyword_transformer_ref (src_value->data[0].v_pointer);
#line 1020 "PhotoMetadata.c"
	} else {
#line 31 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1024 "PhotoMetadata.c"
	}
}

static gpointer
value_keyword_transformer_peek_pointer (const GValue* value)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1033 "PhotoMetadata.c"
}

static gchar*
value_keyword_transformer_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 1044 "PhotoMetadata.c"
		KeywordTransformer * object;
		object = collect_values[0].v_pointer;
#line 31 "../src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 31 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1051 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 31 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1055 "PhotoMetadata.c"
		}
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = keyword_transformer_ref (object);
#line 1059 "PhotoMetadata.c"
	} else {
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1063 "PhotoMetadata.c"
	}
#line 31 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1067 "PhotoMetadata.c"
}

static gchar*
value_keyword_transformer_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	KeywordTransformer ** object_p;
	object_p = collect_values[0].v_pointer;
#line 31 "../src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 31 "../src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1082 "PhotoMetadata.c"
	}
#line 31 "../src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 31 "../src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 1088 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 31 "../src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 1092 "PhotoMetadata.c"
	} else {
#line 31 "../src/photos/PhotoMetadata.vala"
		*object_p = keyword_transformer_ref (value->data[0].v_pointer);
#line 1096 "PhotoMetadata.c"
	}
#line 31 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1100 "PhotoMetadata.c"
}

GParamSpec*
param_spec_keyword_transformer (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecKeywordTransformer* spec;
#line 31 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_KEYWORD_TRANSFORMER), NULL);
#line 31 "../src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 31 "../src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 31 "../src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 1119 "PhotoMetadata.c"
}

gpointer
value_get_keyword_transformer (const GValue* value)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KEYWORD_TRANSFORMER), NULL);
#line 31 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1129 "PhotoMetadata.c"
}

void
value_set_keyword_transformer (GValue* value,
                               gpointer v_object)
{
	KeywordTransformer * old;
#line 31 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KEYWORD_TRANSFORMER));
#line 31 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 31 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 31 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_KEYWORD_TRANSFORMER));
#line 31 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 31 "../src/photos/PhotoMetadata.vala"
		keyword_transformer_ref (value->data[0].v_pointer);
#line 1151 "PhotoMetadata.c"
	} else {
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1155 "PhotoMetadata.c"
	}
#line 31 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 31 "../src/photos/PhotoMetadata.vala"
		keyword_transformer_unref (old);
#line 1161 "PhotoMetadata.c"
	}
}

void
value_take_keyword_transformer (GValue* value,
                                gpointer v_object)
{
	KeywordTransformer * old;
#line 31 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KEYWORD_TRANSFORMER));
#line 31 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 31 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 31 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_KEYWORD_TRANSFORMER));
#line 31 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 1182 "PhotoMetadata.c"
	} else {
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1186 "PhotoMetadata.c"
	}
#line 31 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 31 "../src/photos/PhotoMetadata.vala"
		keyword_transformer_unref (old);
#line 1192 "PhotoMetadata.c"
	}
}

static void
keyword_transformer_class_init (KeywordTransformerClass * klass,
                                gpointer klass_data)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	keyword_transformer_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/photos/PhotoMetadata.vala"
	((KeywordTransformerClass *) klass)->finalize = keyword_transformer_finalize;
#line 31 "../src/photos/PhotoMetadata.vala"
	((KeywordTransformerClass *) klass)->transform = (GeeList* (*) (KeywordTransformer*, const gchar*, GError**)) keyword_transformer_real_transform;
#line 1206 "PhotoMetadata.c"
}

static void
keyword_transformer_instance_init (KeywordTransformer * self,
                                   gpointer klass)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 1215 "PhotoMetadata.c"
}

static void
keyword_transformer_finalize (KeywordTransformer * obj)
{
	KeywordTransformer * self;
#line 31 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer);
#line 31 "../src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 1226 "PhotoMetadata.c"
}

static GType
keyword_transformer_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_keyword_transformer_init, value_keyword_transformer_free_value, value_keyword_transformer_copy_value, value_keyword_transformer_peek_pointer, "p", value_keyword_transformer_collect_value, "p", value_keyword_transformer_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (KeywordTransformerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyword_transformer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeywordTransformer), 0, (GInstanceInitFunc) keyword_transformer_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType keyword_transformer_type_id;
	keyword_transformer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "KeywordTransformer", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return keyword_transformer_type_id;
}

GType
keyword_transformer_get_type (void)
{
	static volatile gsize keyword_transformer_type_id__volatile = 0;
	if (g_once_init_enter (&keyword_transformer_type_id__volatile)) {
		GType keyword_transformer_type_id;
		keyword_transformer_type_id = keyword_transformer_get_type_once ();
		g_once_init_leave (&keyword_transformer_type_id__volatile, keyword_transformer_type_id);
	}
	return keyword_transformer_type_id__volatile;
}

gpointer
keyword_transformer_ref (gpointer instance)
{
	KeywordTransformer * self;
	self = instance;
#line 31 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 31 "../src/photos/PhotoMetadata.vala"
	return instance;
#line 1261 "PhotoMetadata.c"
}

void
keyword_transformer_unref (gpointer instance)
{
	KeywordTransformer * self;
	self = instance;
#line 31 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 31 "../src/photos/PhotoMetadata.vala"
		KEYWORD_TRANSFORMER_GET_CLASS (self)->finalize (self);
#line 31 "../src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1275 "PhotoMetadata.c"
	}
}

static GeeList*
null_keyword_transformer_real_transform (KeywordTransformer* base,
                                         const gchar* input,
                                         GError** error)
{
	NullKeywordTransformer * self;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp0_;
	GeeList* result = NULL;
#line 36 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_NULL_KEYWORD_TRANSFORMER, NullKeywordTransformer);
#line 36 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 37 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 37 "../src/photos/PhotoMetadata.vala"
	_result_ = _tmp0_;
#line 38 "../src/photos/PhotoMetadata.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_result_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), input);
#line 40 "../src/photos/PhotoMetadata.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_result_, GEE_TYPE_LIST, GeeList);
#line 40 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1302 "PhotoMetadata.c"
}

NullKeywordTransformer*
null_keyword_transformer_construct (GType object_type)
{
	NullKeywordTransformer* self = NULL;
#line 35 "../src/photos/PhotoMetadata.vala"
	self = (NullKeywordTransformer*) keyword_transformer_construct (object_type);
#line 35 "../src/photos/PhotoMetadata.vala"
	return self;
#line 1313 "PhotoMetadata.c"
}

NullKeywordTransformer*
null_keyword_transformer_new (void)
{
#line 35 "../src/photos/PhotoMetadata.vala"
	return null_keyword_transformer_construct (TYPE_NULL_KEYWORD_TRANSFORMER);
#line 1321 "PhotoMetadata.c"
}

static void
null_keyword_transformer_class_init (NullKeywordTransformerClass * klass,
                                     gpointer klass_data)
{
#line 35 "../src/photos/PhotoMetadata.vala"
	null_keyword_transformer_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/photos/PhotoMetadata.vala"
	((KeywordTransformerClass *) klass)->transform = (GeeList* (*) (KeywordTransformer*, const gchar*, GError**)) null_keyword_transformer_real_transform;
#line 1332 "PhotoMetadata.c"
}

static void
null_keyword_transformer_instance_init (NullKeywordTransformer * self,
                                        gpointer klass)
{
}

static GType
null_keyword_transformer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NullKeywordTransformerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) null_keyword_transformer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NullKeywordTransformer), 0, (GInstanceInitFunc) null_keyword_transformer_instance_init, NULL };
	GType null_keyword_transformer_type_id;
	null_keyword_transformer_type_id = g_type_register_static (TYPE_KEYWORD_TRANSFORMER, "NullKeywordTransformer", &g_define_type_info, 0);
	return null_keyword_transformer_type_id;
}

GType
null_keyword_transformer_get_type (void)
{
	static volatile gsize null_keyword_transformer_type_id__volatile = 0;
	if (g_once_init_enter (&null_keyword_transformer_type_id__volatile)) {
		GType null_keyword_transformer_type_id;
		null_keyword_transformer_type_id = null_keyword_transformer_get_type_once ();
		g_once_init_leave (&null_keyword_transformer_type_id__volatile, null_keyword_transformer_type_id);
	}
	return null_keyword_transformer_type_id__volatile;
}

static inline gpointer
acd_see_keyword_transformer_get_instance_private (ACDSeeKeywordTransformer* self)
{
	return G_STRUCT_MEMBER_P (self, ACDSeeKeywordTransformer_private_offset);
}

static void
_acd_see_keyword_transformer_on_start_gmarkup_parser_start_element_func (GMarkupParseContext* context,
                                                                         const gchar* element_name,
                                                                         gchar** attribute_names,
                                                                         gchar** attribute_values,
                                                                         gpointer self,
                                                                         GError** error)
{
#line 64 "../src/photos/PhotoMetadata.vala"
	acd_see_keyword_transformer_on_start ((ACDSeeKeywordTransformer*) self, context, element_name, attribute_names, attribute_values, error);
#line 1378 "PhotoMetadata.c"
}

static void
_acd_see_keyword_transformer_on_end_gmarkup_parser_end_element_func (GMarkupParseContext* context,
                                                                     const gchar* element_name,
                                                                     gpointer self,
                                                                     GError** error)
{
#line 65 "../src/photos/PhotoMetadata.vala"
	acd_see_keyword_transformer_on_end ((ACDSeeKeywordTransformer*) self, context, element_name, error);
#line 1389 "PhotoMetadata.c"
}

static void
_acd_see_keyword_transformer_on_text_gmarkup_parser_text_func (GMarkupParseContext* context,
                                                               const gchar* text,
                                                               gsize text_len,
                                                               gpointer self,
                                                               GError** error)
{
#line 66 "../src/photos/PhotoMetadata.vala"
	acd_see_keyword_transformer_on_text ((ACDSeeKeywordTransformer*) self, context, text, error);
#line 1401 "PhotoMetadata.c"
}

static void
_acd_see_keyword_transformer_on_error_gmarkup_parser_error_func (GMarkupParseContext* context,
                                                                 GError* _error_,
                                                                 gpointer self)
{
#line 67 "../src/photos/PhotoMetadata.vala"
	acd_see_keyword_transformer_on_error ((ACDSeeKeywordTransformer*) self, context, _error_);
#line 1411 "PhotoMetadata.c"
}

ACDSeeKeywordTransformer*
acd_see_keyword_transformer_construct (GType object_type)
{
	ACDSeeKeywordTransformer* self = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayQueue* _tmp1_;
#line 62 "../src/photos/PhotoMetadata.vala"
	self = (ACDSeeKeywordTransformer*) keyword_transformer_construct (object_type);
#line 63 "../src/photos/PhotoMetadata.vala"
	memset (&self->priv->parser, 0, sizeof (GMarkupParser));
#line 64 "../src/photos/PhotoMetadata.vala"
	self->priv->parser.start_element = _acd_see_keyword_transformer_on_start_gmarkup_parser_start_element_func;
#line 65 "../src/photos/PhotoMetadata.vala"
	self->priv->parser.end_element = _acd_see_keyword_transformer_on_end_gmarkup_parser_end_element_func;
#line 66 "../src/photos/PhotoMetadata.vala"
	self->priv->parser.text = _acd_see_keyword_transformer_on_text_gmarkup_parser_text_func;
#line 67 "../src/photos/PhotoMetadata.vala"
	self->priv->parser.error = _acd_see_keyword_transformer_on_error_gmarkup_parser_error_func;
#line 68 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 68 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->result);
#line 68 "../src/photos/PhotoMetadata.vala"
	self->priv->result = _tmp0_;
#line 69 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gee_array_queue_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 69 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->stack);
#line 69 "../src/photos/PhotoMetadata.vala"
	self->priv->stack = _tmp1_;
#line 62 "../src/photos/PhotoMetadata.vala"
	return self;
#line 1446 "PhotoMetadata.c"
}

ACDSeeKeywordTransformer*
acd_see_keyword_transformer_new (void)
{
#line 62 "../src/photos/PhotoMetadata.vala"
	return acd_see_keyword_transformer_construct (TYPE_ACD_SEE_KEYWORD_TRANSFORMER);
#line 1454 "PhotoMetadata.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 79 "../src/photos/PhotoMetadata.vala"
	return self ? g_object_ref (self) : NULL;
#line 1462 "PhotoMetadata.c"
}

static GeeList*
acd_see_keyword_transformer_real_transform (KeywordTransformer* base,
                                            const gchar* input,
                                            GError** error)
{
	ACDSeeKeywordTransformer * self;
	GeeArrayQueue* _tmp0_;
	GeeArrayList* _tmp1_;
	GMarkupParseContext* ctx = NULL;
	GMarkupParser _tmp2_;
	GMarkupParseContext* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeArrayList* _tmp6_;
	GeeList* _tmp7_;
	GError* _inner_error0_ = NULL;
	GeeList* result = NULL;
#line 72 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ACD_SEE_KEYWORD_TRANSFORMER, ACDSeeKeywordTransformer);
#line 72 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 73 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->stack;
#line 73 "../src/photos/PhotoMetadata.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 74 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->result;
#line 74 "../src/photos/PhotoMetadata.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 75 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->parser;
#line 75 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_markup_parse_context_new (&_tmp2_, 0, self, NULL);
#line 75 "../src/photos/PhotoMetadata.vala"
	ctx = _tmp3_;
#line 77 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = strlen (input);
#line 77 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_;
#line 77 "../src/photos/PhotoMetadata.vala"
	g_markup_parse_context_parse (ctx, input, (gssize) _tmp5_, &_inner_error0_);
#line 77 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 77 "../src/photos/PhotoMetadata.vala"
		_g_markup_parse_context_unref0 (ctx);
#line 77 "../src/photos/PhotoMetadata.vala"
		return NULL;
#line 1514 "PhotoMetadata.c"
	}
#line 79 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = self->priv->result;
#line 79 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_LIST, GeeList));
#line 79 "../src/photos/PhotoMetadata.vala"
	result = _tmp7_;
#line 79 "../src/photos/PhotoMetadata.vala"
	_g_markup_parse_context_unref0 (ctx);
#line 79 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1526 "PhotoMetadata.c"
}

static void
acd_see_keyword_transformer_on_start (ACDSeeKeywordTransformer* self,
                                      GMarkupParseContext* ctx,
                                      const gchar* name,
                                      gchar** attribute_names,
                                      gchar** attribute_values,
                                      GError** error)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 82 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_ACD_SEE_KEYWORD_TRANSFORMER (self));
#line 82 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (ctx != NULL);
#line 82 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (name != NULL);
#line 90 "../src/photos/PhotoMetadata.vala"
	self->priv->assigned = FALSE;
#line 91 "../src/photos/PhotoMetadata.vala"
	if (g_strcmp0 (name, "Categories") == 0) {
#line 92 "../src/photos/PhotoMetadata.vala"
		return;
#line 1551 "PhotoMetadata.c"
	}
#line 95 "../src/photos/PhotoMetadata.vala"
	if (g_strcmp0 (name, "Category") != 0) {
#line 96 "../src/photos/PhotoMetadata.vala"
		return;
#line 1557 "PhotoMetadata.c"
	}
#line 99 "../src/photos/PhotoMetadata.vala"
	g_markup_collect_attributes (name, attribute_names, attribute_values, &_inner_error0_, G_MARKUP_COLLECT_BOOLEAN, "Assigned", &_tmp0_, G_MARKUP_COLLECT_INVALID);
#line 99 "../src/photos/PhotoMetadata.vala"
	self->priv->assigned = _tmp0_;
#line 99 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/photos/PhotoMetadata.vala"
		if (_inner_error0_->domain == G_MARKUP_ERROR) {
#line 99 "../src/photos/PhotoMetadata.vala"
			g_propagate_error (error, _inner_error0_);
#line 99 "../src/photos/PhotoMetadata.vala"
			return;
#line 1571 "PhotoMetadata.c"
		} else {
#line 99 "../src/photos/PhotoMetadata.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/photos/PhotoMetadata.vala"
			g_clear_error (&_inner_error0_);
#line 99 "../src/photos/PhotoMetadata.vala"
			return;
#line 1579 "PhotoMetadata.c"
		}
	}
}

static void
acd_see_keyword_transformer_on_end (ACDSeeKeywordTransformer* self,
                                    GMarkupParseContext* ctx,
                                    const gchar* name,
                                    GError** error)
{
#line 106 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_ACD_SEE_KEYWORD_TRANSFORMER (self));
#line 106 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (ctx != NULL);
#line 106 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (name != NULL);
#line 108 "../src/photos/PhotoMetadata.vala"
	if (g_strcmp0 (name, "Category") == 0) {
#line 1598 "PhotoMetadata.c"
		GeeArrayQueue* _tmp0_;
		gpointer _tmp1_;
		gchar* _tmp2_;
#line 109 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = self->priv->stack;
#line 109 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = gee_deque_poll_tail (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_DEQUE, GeeDeque));
#line 109 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = (gchar*) _tmp1_;
#line 109 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp2_);
#line 1610 "PhotoMetadata.c"
	}
}

static void
acd_see_keyword_transformer_on_text (ACDSeeKeywordTransformer* self,
                                     GMarkupParseContext* ctx,
                                     const gchar* text,
                                     GError** error)
{
	GeeArrayQueue* _tmp0_;
#line 113 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_ACD_SEE_KEYWORD_TRANSFORMER (self));
#line 113 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (ctx != NULL);
#line 113 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (text != NULL);
#line 115 "../src/photos/PhotoMetadata.vala"
	if (g_strcmp0 (text, "") == 0) {
#line 116 "../src/photos/PhotoMetadata.vala"
		return;
#line 1631 "PhotoMetadata.c"
	}
#line 119 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->stack;
#line 119 "../src/photos/PhotoMetadata.vala"
	gee_deque_offer_tail (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_DEQUE, GeeDeque), text);
#line 120 "../src/photos/PhotoMetadata.vala"
	if (self->priv->assigned) {
#line 1639 "PhotoMetadata.c"
		GString* builder = NULL;
		GString* _tmp1_;
		GString* _tmp9_;
		GeeArrayList* _tmp12_;
		GString* _tmp13_;
		const gchar* _tmp14_;
#line 121 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = g_string_new ("");
#line 121 "../src/photos/PhotoMetadata.vala"
		builder = _tmp1_;
#line 1650 "PhotoMetadata.c"
		{
			GeeIterator* _f_it = NULL;
			GeeArrayQueue* _tmp2_;
			GeeIterator* _tmp3_;
#line 122 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->stack;
#line 122 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 122 "../src/photos/PhotoMetadata.vala"
			_f_it = _tmp3_;
#line 122 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 1663 "PhotoMetadata.c"
				GeeIterator* _tmp4_;
				gchar* f = NULL;
				GeeIterator* _tmp5_;
				gpointer _tmp6_;
				GString* _tmp7_;
				const gchar* _tmp8_;
#line 122 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = _f_it;
#line 122 "../src/photos/PhotoMetadata.vala"
				if (!gee_iterator_next (_tmp4_)) {
#line 122 "../src/photos/PhotoMetadata.vala"
					break;
#line 1676 "PhotoMetadata.c"
				}
#line 122 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = _f_it;
#line 122 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 122 "../src/photos/PhotoMetadata.vala"
				f = (gchar*) _tmp6_;
#line 123 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = builder;
#line 123 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = f;
#line 123 "../src/photos/PhotoMetadata.vala"
				g_string_append_printf (_tmp7_, "%s|", _tmp8_);
#line 122 "../src/photos/PhotoMetadata.vala"
				_g_free0 (f);
#line 1692 "PhotoMetadata.c"
			}
#line 122 "../src/photos/PhotoMetadata.vala"
			_g_object_unref0 (_f_it);
#line 1696 "PhotoMetadata.c"
		}
#line 125 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = builder;
#line 125 "../src/photos/PhotoMetadata.vala"
		if (_tmp9_->len > ((gssize) 0)) {
#line 1702 "PhotoMetadata.c"
			GString* _tmp10_;
			GString* _tmp11_;
#line 126 "../src/photos/PhotoMetadata.vala"
			_tmp10_ = builder;
#line 126 "../src/photos/PhotoMetadata.vala"
			_tmp11_ = builder;
#line 126 "../src/photos/PhotoMetadata.vala"
			g_string_truncate (_tmp10_, (gsize) (_tmp11_->len - 1));
#line 1711 "PhotoMetadata.c"
		}
#line 128 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = self->priv->result;
#line 128 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = builder;
#line 128 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = _tmp13_->str;
#line 128 "../src/photos/PhotoMetadata.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp14_);
#line 120 "../src/photos/PhotoMetadata.vala"
		_g_string_free0 (builder);
#line 1723 "PhotoMetadata.c"
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 133 "../src/photos/PhotoMetadata.vala"
	return self ? g_error_copy (self) : NULL;
#line 1732 "PhotoMetadata.c"
}

static void
acd_see_keyword_transformer_on_error (ACDSeeKeywordTransformer* self,
                                      GMarkupParseContext* ctx,
                                      GError* _error_)
{
	GError* _tmp0_;
#line 132 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_ACD_SEE_KEYWORD_TRANSFORMER (self));
#line 132 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (ctx != NULL);
#line 132 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (_error_ != NULL);
#line 133 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _g_error_copy0 (_error_);
#line 133 "../src/photos/PhotoMetadata.vala"
	_g_error_free0 (self->priv->error);
#line 133 "../src/photos/PhotoMetadata.vala"
	self->priv->error = _tmp0_;
#line 1753 "PhotoMetadata.c"
}

static void
acd_see_keyword_transformer_class_init (ACDSeeKeywordTransformerClass * klass,
                                        gpointer klass_data)
{
#line 55 "../src/photos/PhotoMetadata.vala"
	acd_see_keyword_transformer_parent_class = g_type_class_peek_parent (klass);
#line 55 "../src/photos/PhotoMetadata.vala"
	((KeywordTransformerClass *) klass)->finalize = acd_see_keyword_transformer_finalize;
#line 55 "../src/photos/PhotoMetadata.vala"
	g_type_class_adjust_private_offset (klass, &ACDSeeKeywordTransformer_private_offset);
#line 55 "../src/photos/PhotoMetadata.vala"
	((KeywordTransformerClass *) klass)->transform = (GeeList* (*) (KeywordTransformer*, const gchar*, GError**)) acd_see_keyword_transformer_real_transform;
#line 1768 "PhotoMetadata.c"
}

static void
acd_see_keyword_transformer_instance_init (ACDSeeKeywordTransformer * self,
                                           gpointer klass)
{
#line 55 "../src/photos/PhotoMetadata.vala"
	self->priv = acd_see_keyword_transformer_get_instance_private (self);
#line 1777 "PhotoMetadata.c"
}

static void
acd_see_keyword_transformer_finalize (KeywordTransformer * obj)
{
	ACDSeeKeywordTransformer * self;
#line 55 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ACD_SEE_KEYWORD_TRANSFORMER, ACDSeeKeywordTransformer);
#line 57 "../src/photos/PhotoMetadata.vala"
	_g_error_free0 (self->priv->error);
#line 58 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->stack);
#line 59 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->result);
#line 55 "../src/photos/PhotoMetadata.vala"
	KEYWORD_TRANSFORMER_CLASS (acd_see_keyword_transformer_parent_class)->finalize (obj);
#line 1794 "PhotoMetadata.c"
}

static GType
acd_see_keyword_transformer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ACDSeeKeywordTransformerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) acd_see_keyword_transformer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ACDSeeKeywordTransformer), 0, (GInstanceInitFunc) acd_see_keyword_transformer_instance_init, NULL };
	GType acd_see_keyword_transformer_type_id;
	acd_see_keyword_transformer_type_id = g_type_register_static (TYPE_KEYWORD_TRANSFORMER, "ACDSeeKeywordTransformer", &g_define_type_info, 0);
	ACDSeeKeywordTransformer_private_offset = g_type_add_instance_private (acd_see_keyword_transformer_type_id, sizeof (ACDSeeKeywordTransformerPrivate));
	return acd_see_keyword_transformer_type_id;
}

GType
acd_see_keyword_transformer_get_type (void)
{
	static volatile gsize acd_see_keyword_transformer_type_id__volatile = 0;
	if (g_once_init_enter (&acd_see_keyword_transformer_type_id__volatile)) {
		GType acd_see_keyword_transformer_type_id;
		acd_see_keyword_transformer_type_id = acd_see_keyword_transformer_get_type_once ();
		g_once_init_leave (&acd_see_keyword_transformer_type_id__volatile, acd_see_keyword_transformer_type_id);
	}
	return acd_see_keyword_transformer_type_id__volatile;
}

static gpointer
_keyword_transformer_ref0 (gpointer self)
{
#line 156 "../src/photos/PhotoMetadata.vala"
	return self ? keyword_transformer_ref (self) : NULL;
#line 1824 "PhotoMetadata.c"
}

HierarchicalKeywordField*
hierarchical_keyword_field_construct (GType object_type,
                                      const gchar* field_name,
                                      const gchar* path_separator,
                                      gboolean wants_leading_separator,
                                      gboolean is_writeable,
                                      KeywordTransformer* transformer)
{
	HierarchicalKeywordField* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	KeywordTransformer* _tmp2_;
#line 146 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (field_name != NULL, NULL);
#line 146 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (path_separator != NULL, NULL);
#line 146 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_KEYWORD_TRANSFORMER (transformer), NULL);
#line 146 "../src/photos/PhotoMetadata.vala"
	self = (HierarchicalKeywordField*) g_type_create_instance (object_type);
#line 152 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (field_name);
#line 152 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 152 "../src/photos/PhotoMetadata.vala"
	self->field_name = _tmp0_;
#line 153 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (path_separator);
#line 153 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 153 "../src/photos/PhotoMetadata.vala"
	self->path_separator = _tmp1_;
#line 154 "../src/photos/PhotoMetadata.vala"
	self->wants_leading_separator = wants_leading_separator;
#line 155 "../src/photos/PhotoMetadata.vala"
	self->is_writeable = is_writeable;
#line 156 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _keyword_transformer_ref0 (transformer);
#line 156 "../src/photos/PhotoMetadata.vala"
	_keyword_transformer_unref0 (self->transformer);
#line 156 "../src/photos/PhotoMetadata.vala"
	self->transformer = _tmp2_;
#line 146 "../src/photos/PhotoMetadata.vala"
	return self;
#line 1871 "PhotoMetadata.c"
}

HierarchicalKeywordField*
hierarchical_keyword_field_new (const gchar* field_name,
                                const gchar* path_separator,
                                gboolean wants_leading_separator,
                                gboolean is_writeable,
                                KeywordTransformer* transformer)
{
#line 146 "../src/photos/PhotoMetadata.vala"
	return hierarchical_keyword_field_construct (TYPE_HIERARCHICAL_KEYWORD_FIELD, field_name, path_separator, wants_leading_separator, is_writeable, transformer);
#line 1883 "PhotoMetadata.c"
}

static void
value_hierarchical_keyword_field_init (GValue* value)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 1891 "PhotoMetadata.c"
}

static void
value_hierarchical_keyword_field_free_value (GValue* value)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 139 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (value->data[0].v_pointer);
#line 1901 "PhotoMetadata.c"
	}
}

static void
value_hierarchical_keyword_field_copy_value (const GValue* src_value,
                                             GValue* dest_value)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 139 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = hierarchical_keyword_field_ref (src_value->data[0].v_pointer);
#line 1913 "PhotoMetadata.c"
	} else {
#line 139 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1917 "PhotoMetadata.c"
	}
}

static gpointer
value_hierarchical_keyword_field_peek_pointer (const GValue* value)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1926 "PhotoMetadata.c"
}

static gchar*
value_hierarchical_keyword_field_collect_value (GValue* value,
                                                guint n_collect_values,
                                                GTypeCValue* collect_values,
                                                guint collect_flags)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 1937 "PhotoMetadata.c"
		HierarchicalKeywordField * object;
		object = collect_values[0].v_pointer;
#line 139 "../src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 139 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1944 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 139 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1948 "PhotoMetadata.c"
		}
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = hierarchical_keyword_field_ref (object);
#line 1952 "PhotoMetadata.c"
	} else {
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1956 "PhotoMetadata.c"
	}
#line 139 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1960 "PhotoMetadata.c"
}

static gchar*
value_hierarchical_keyword_field_lcopy_value (const GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	HierarchicalKeywordField ** object_p;
	object_p = collect_values[0].v_pointer;
#line 139 "../src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 139 "../src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1975 "PhotoMetadata.c"
	}
#line 139 "../src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 139 "../src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 1981 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 139 "../src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 1985 "PhotoMetadata.c"
	} else {
#line 139 "../src/photos/PhotoMetadata.vala"
		*object_p = hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 1989 "PhotoMetadata.c"
	}
#line 139 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1993 "PhotoMetadata.c"
}

GParamSpec*
param_spec_hierarchical_keyword_field (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags)
{
	ParamSpecHierarchicalKeywordField* spec;
#line 139 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 139 "../src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 139 "../src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 139 "../src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 2012 "PhotoMetadata.c"
}

gpointer
value_get_hierarchical_keyword_field (const GValue* value)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 139 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 2022 "PhotoMetadata.c"
}

void
value_set_hierarchical_keyword_field (GValue* value,
                                      gpointer v_object)
{
	HierarchicalKeywordField * old;
#line 139 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 139 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 139 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 139 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 139 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 139 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 2044 "PhotoMetadata.c"
	} else {
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 2048 "PhotoMetadata.c"
	}
#line 139 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 139 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 2054 "PhotoMetadata.c"
	}
}

void
value_take_hierarchical_keyword_field (GValue* value,
                                       gpointer v_object)
{
	HierarchicalKeywordField * old;
#line 139 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 139 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 139 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 139 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 139 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 2075 "PhotoMetadata.c"
	} else {
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 2079 "PhotoMetadata.c"
	}
#line 139 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 139 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 2085 "PhotoMetadata.c"
	}
}

static void
hierarchical_keyword_field_class_init (HierarchicalKeywordFieldClass * klass,
                                       gpointer klass_data)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	hierarchical_keyword_field_parent_class = g_type_class_peek_parent (klass);
#line 139 "../src/photos/PhotoMetadata.vala"
	((HierarchicalKeywordFieldClass *) klass)->finalize = hierarchical_keyword_field_finalize;
#line 2097 "PhotoMetadata.c"
}

static void
hierarchical_keyword_field_instance_init (HierarchicalKeywordField * self,
                                          gpointer klass)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 2106 "PhotoMetadata.c"
}

static void
hierarchical_keyword_field_finalize (HierarchicalKeywordField * obj)
{
	HierarchicalKeywordField * self;
#line 139 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordField);
#line 139 "../src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 140 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 141 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 144 "../src/photos/PhotoMetadata.vala"
	_keyword_transformer_unref0 (self->transformer);
#line 2123 "PhotoMetadata.c"
}

static GType
hierarchical_keyword_field_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_hierarchical_keyword_field_init, value_hierarchical_keyword_field_free_value, value_hierarchical_keyword_field_copy_value, value_hierarchical_keyword_field_peek_pointer, "p", value_hierarchical_keyword_field_collect_value, "p", value_hierarchical_keyword_field_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HierarchicalKeywordFieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hierarchical_keyword_field_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HierarchicalKeywordField), 0, (GInstanceInitFunc) hierarchical_keyword_field_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType hierarchical_keyword_field_type_id;
	hierarchical_keyword_field_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HierarchicalKeywordField", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return hierarchical_keyword_field_type_id;
}

GType
hierarchical_keyword_field_get_type (void)
{
	static volatile gsize hierarchical_keyword_field_type_id__volatile = 0;
	if (g_once_init_enter (&hierarchical_keyword_field_type_id__volatile)) {
		GType hierarchical_keyword_field_type_id;
		hierarchical_keyword_field_type_id = hierarchical_keyword_field_get_type_once ();
		g_once_init_leave (&hierarchical_keyword_field_type_id__volatile, hierarchical_keyword_field_type_id);
	}
	return hierarchical_keyword_field_type_id__volatile;
}

gpointer
hierarchical_keyword_field_ref (gpointer instance)
{
	HierarchicalKeywordField * self;
	self = instance;
#line 139 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 139 "../src/photos/PhotoMetadata.vala"
	return instance;
#line 2158 "PhotoMetadata.c"
}

void
hierarchical_keyword_field_unref (gpointer instance)
{
	HierarchicalKeywordField * self;
	self = instance;
#line 139 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 139 "../src/photos/PhotoMetadata.vala"
		HIERARCHICAL_KEYWORD_FIELD_GET_CLASS (self)->finalize (self);
#line 139 "../src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2172 "PhotoMetadata.c"
	}
}

static inline gpointer
photo_preview_get_instance_private (PhotoPreview* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoPreview_private_offset);
}

PhotoPreview*
photo_preview_construct (GType object_type,
                         const gchar* name,
                         Dimensions* dimensions,
                         guint32 size,
                         const gchar* mime_type,
                         const gchar* extension)
{
	PhotoPreview* self = NULL;
	gchar* _tmp0_;
	Dimensions _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 167 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 167 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (dimensions != NULL, NULL);
#line 167 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 167 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 167 "../src/photos/PhotoMetadata.vala"
	self = (PhotoPreview*) g_type_create_instance (object_type);
#line 168 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (name);
#line 168 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 168 "../src/photos/PhotoMetadata.vala"
	self->priv->name = _tmp0_;
#line 169 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = *dimensions;
#line 169 "../src/photos/PhotoMetadata.vala"
	self->priv->dimensions = _tmp1_;
#line 170 "../src/photos/PhotoMetadata.vala"
	self->priv->size = size;
#line 171 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup (mime_type);
#line 171 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 171 "../src/photos/PhotoMetadata.vala"
	self->priv->mime_type = _tmp2_;
#line 172 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup (extension);
#line 172 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 172 "../src/photos/PhotoMetadata.vala"
	self->priv->extension = _tmp3_;
#line 167 "../src/photos/PhotoMetadata.vala"
	return self;
#line 2231 "PhotoMetadata.c"
}

gchar*
photo_preview_get_name (PhotoPreview* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 175 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 176 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->name;
#line 176 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 176 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 176 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2250 "PhotoMetadata.c"
}

void
photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                    Dimensions* result)
{
	Dimensions _tmp0_;
#line 179 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_PREVIEW (self));
#line 180 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->dimensions;
#line 180 "../src/photos/PhotoMetadata.vala"
	*result = _tmp0_;
#line 180 "../src/photos/PhotoMetadata.vala"
	return;
#line 2266 "PhotoMetadata.c"
}

guint32
photo_preview_get_size (PhotoPreview* self)
{
	guint32 result = 0U;
#line 183 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), 0U);
#line 184 "../src/photos/PhotoMetadata.vala"
	result = self->priv->size;
#line 184 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2279 "PhotoMetadata.c"
}

gchar*
photo_preview_get_mime_type (PhotoPreview* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 187 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 188 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->mime_type;
#line 188 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 188 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 188 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2298 "PhotoMetadata.c"
}

gchar*
photo_preview_get_extension (PhotoPreview* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 191 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 192 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->extension;
#line 192 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 192 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 192 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2317 "PhotoMetadata.c"
}

static GBytes*
photo_preview_real_flatten (PhotoPreview* self,
                            GError** error)
{
#line 195 "../src/photos/PhotoMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_preview_flatten'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 195 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2328 "PhotoMetadata.c"
}

GBytes*
photo_preview_flatten (PhotoPreview* self,
                       GError** error)
{
	PhotoPreviewClass* _klass_;
#line 195 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 195 "../src/photos/PhotoMetadata.vala"
	_klass_ = PHOTO_PREVIEW_GET_CLASS (self);
#line 195 "../src/photos/PhotoMetadata.vala"
	if (_klass_->flatten) {
#line 195 "../src/photos/PhotoMetadata.vala"
		return _klass_->flatten (self, error);
#line 2344 "PhotoMetadata.c"
	}
#line 195 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2348 "PhotoMetadata.c"
}

static GdkPixbuf*
photo_preview_real_get_pixbuf (PhotoPreview* self,
                               GError** error)
{
	GBytes* flattened = NULL;
	GBytes* _tmp0_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 198 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_preview_flatten (self, &_inner_error0_);
#line 198 "../src/photos/PhotoMetadata.vala"
	flattened = _tmp0_;
#line 198 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 198 "../src/photos/PhotoMetadata.vala"
		return NULL;
#line 2369 "PhotoMetadata.c"
	}
	{
		GdkPixbuf* _tmp1_ = NULL;
		GMemoryInputStream* _tmp2_;
		GMemoryInputStream* _tmp3_;
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = (GMemoryInputStream*) g_memory_input_stream_new_from_bytes (flattened);
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_;
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = gdk_pixbuf_new_from_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_input_stream_get_type (), GInputStream), NULL, &_inner_error0_);
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_;
#line 203 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp3_);
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = _tmp5_;
#line 203 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2392 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp1_;
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = NULL;
#line 203 "../src/photos/PhotoMetadata.vala"
		result = _tmp6_;
#line 203 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp1_);
#line 203 "../src/photos/PhotoMetadata.vala"
		_g_bytes_unref0 (flattened);
#line 203 "../src/photos/PhotoMetadata.vala"
		return result;
#line 2407 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 202 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 202 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 206 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->name;
#line 206 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = err;
#line 206 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp8_->message;
#line 206 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:206: Unable to decode thumbnail for %s: %s", _tmp7_, _tmp9_);
#line 208 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 208 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 208 "../src/photos/PhotoMetadata.vala"
		_g_bytes_unref0 (flattened);
#line 208 "../src/photos/PhotoMetadata.vala"
		return result;
#line 2436 "PhotoMetadata.c"
	}
	__finally0:
#line 202 "../src/photos/PhotoMetadata.vala"
	g_propagate_error (error, _inner_error0_);
#line 202 "../src/photos/PhotoMetadata.vala"
	_g_bytes_unref0 (flattened);
#line 202 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2445 "PhotoMetadata.c"
}

GdkPixbuf*
photo_preview_get_pixbuf (PhotoPreview* self,
                          GError** error)
{
	PhotoPreviewClass* _klass_;
#line 197 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 197 "../src/photos/PhotoMetadata.vala"
	_klass_ = PHOTO_PREVIEW_GET_CLASS (self);
#line 197 "../src/photos/PhotoMetadata.vala"
	if (_klass_->get_pixbuf) {
#line 197 "../src/photos/PhotoMetadata.vala"
		return _klass_->get_pixbuf (self, error);
#line 2461 "PhotoMetadata.c"
	}
#line 197 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2465 "PhotoMetadata.c"
}

static void
value_photo_preview_init (GValue* value)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 2473 "PhotoMetadata.c"
}

static void
value_photo_preview_free_value (GValue* value)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 160 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (value->data[0].v_pointer);
#line 2483 "PhotoMetadata.c"
	}
}

static void
value_photo_preview_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 160 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = photo_preview_ref (src_value->data[0].v_pointer);
#line 2495 "PhotoMetadata.c"
	} else {
#line 160 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2499 "PhotoMetadata.c"
	}
}

static gpointer
value_photo_preview_peek_pointer (const GValue* value)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 2508 "PhotoMetadata.c"
}

static gchar*
value_photo_preview_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 2519 "PhotoMetadata.c"
		PhotoPreview * object;
		object = collect_values[0].v_pointer;
#line 160 "../src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 160 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2526 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 160 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2530 "PhotoMetadata.c"
		}
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = photo_preview_ref (object);
#line 2534 "PhotoMetadata.c"
	} else {
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 2538 "PhotoMetadata.c"
	}
#line 160 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2542 "PhotoMetadata.c"
}

static gchar*
value_photo_preview_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	PhotoPreview ** object_p;
	object_p = collect_values[0].v_pointer;
#line 160 "../src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 160 "../src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2557 "PhotoMetadata.c"
	}
#line 160 "../src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 160 "../src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 2563 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 160 "../src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 2567 "PhotoMetadata.c"
	} else {
#line 160 "../src/photos/PhotoMetadata.vala"
		*object_p = photo_preview_ref (value->data[0].v_pointer);
#line 2571 "PhotoMetadata.c"
	}
#line 160 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2575 "PhotoMetadata.c"
}

GParamSpec*
param_spec_photo_preview (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecPhotoPreview* spec;
#line 160 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_PREVIEW), NULL);
#line 160 "../src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 160 "../src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 160 "../src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 2594 "PhotoMetadata.c"
}

gpointer
value_get_photo_preview (const GValue* value)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW), NULL);
#line 160 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 2604 "PhotoMetadata.c"
}

void
value_set_photo_preview (GValue* value,
                         gpointer v_object)
{
	PhotoPreview * old;
#line 160 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 160 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 160 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 160 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 160 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 160 "../src/photos/PhotoMetadata.vala"
		photo_preview_ref (value->data[0].v_pointer);
#line 2626 "PhotoMetadata.c"
	} else {
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 2630 "PhotoMetadata.c"
	}
#line 160 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 160 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 2636 "PhotoMetadata.c"
	}
}

void
value_take_photo_preview (GValue* value,
                          gpointer v_object)
{
	PhotoPreview * old;
#line 160 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 160 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 160 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 160 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 160 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 2657 "PhotoMetadata.c"
	} else {
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 2661 "PhotoMetadata.c"
	}
#line 160 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 160 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 2667 "PhotoMetadata.c"
	}
}

static void
photo_preview_class_init (PhotoPreviewClass * klass,
                          gpointer klass_data)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 160 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->finalize = photo_preview_finalize;
#line 160 "../src/photos/PhotoMetadata.vala"
	g_type_class_adjust_private_offset (klass, &PhotoPreview_private_offset);
#line 160 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->flatten = (GBytes* (*) (PhotoPreview*, GError**)) photo_preview_real_flatten;
#line 160 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoPreview*, GError**)) photo_preview_real_get_pixbuf;
#line 2685 "PhotoMetadata.c"
}

static void
photo_preview_instance_init (PhotoPreview * self,
                             gpointer klass)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	self->priv = photo_preview_get_instance_private (self);
#line 160 "../src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 2696 "PhotoMetadata.c"
}

static void
photo_preview_finalize (PhotoPreview * obj)
{
	PhotoPreview * self;
#line 160 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_PREVIEW, PhotoPreview);
#line 160 "../src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 161 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 164 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 165 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 2713 "PhotoMetadata.c"
}

static GType
photo_preview_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_photo_preview_init, value_photo_preview_free_value, value_photo_preview_copy_value, value_photo_preview_peek_pointer, "p", value_photo_preview_collect_value, "p", value_photo_preview_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPreview), 0, (GInstanceInitFunc) photo_preview_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_preview_type_id;
	photo_preview_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoPreview", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	PhotoPreview_private_offset = g_type_add_instance_private (photo_preview_type_id, sizeof (PhotoPreviewPrivate));
	return photo_preview_type_id;
}

GType
photo_preview_get_type (void)
{
	static volatile gsize photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_preview_type_id__volatile)) {
		GType photo_preview_type_id;
		photo_preview_type_id = photo_preview_get_type_once ();
		g_once_init_leave (&photo_preview_type_id__volatile, photo_preview_type_id);
	}
	return photo_preview_type_id__volatile;
}

gpointer
photo_preview_ref (gpointer instance)
{
	PhotoPreview * self;
	self = instance;
#line 160 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 160 "../src/photos/PhotoMetadata.vala"
	return instance;
#line 2749 "PhotoMetadata.c"
}

void
photo_preview_unref (gpointer instance)
{
	PhotoPreview * self;
	self = instance;
#line 160 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 160 "../src/photos/PhotoMetadata.vala"
		PHOTO_PREVIEW_GET_CLASS (self)->finalize (self);
#line 160 "../src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2763 "PhotoMetadata.c"
	}
}

static inline gpointer
photo_metadata_get_instance_private (PhotoMetadata* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoMetadata_private_offset);
}

static GType
photo_metadata_set_option_get_type_once (void)
{
	static const GEnumValue values[] = {{PHOTO_METADATA_SET_OPTION_ALL_DOMAINS, "PHOTO_METADATA_SET_OPTION_ALL_DOMAINS", "all-domains"}, {PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT, "PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT", "only-if-domain-present"}, {PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN, "PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN", "at-least-default-domain"}, {0, NULL, NULL}};
	GType photo_metadata_set_option_type_id;
	photo_metadata_set_option_type_id = g_enum_register_static ("PhotoMetadataSetOption", values);
	return photo_metadata_set_option_type_id;
}

GType
photo_metadata_set_option_get_type (void)
{
	static volatile gsize photo_metadata_set_option_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_set_option_type_id__volatile)) {
		GType photo_metadata_set_option_type_id;
		photo_metadata_set_option_type_id = photo_metadata_set_option_get_type_once ();
		g_once_init_leave (&photo_metadata_set_option_type_id__volatile, photo_metadata_set_option_type_id);
	}
	return photo_metadata_set_option_type_id__volatile;
}

PhotoMetadata*
photo_metadata_construct (GType object_type)
{
	PhotoMetadata* self = NULL;
#line 256 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) media_metadata_construct (object_type);
#line 256 "../src/photos/PhotoMetadata.vala"
	return self;
#line 2802 "PhotoMetadata.c"
}

PhotoMetadata*
photo_metadata_new (void)
{
#line 256 "../src/photos/PhotoMetadata.vala"
	return photo_metadata_construct (TYPE_PHOTO_METADATA);
#line 2810 "PhotoMetadata.c"
}

static void
photo_metadata_real_read_from_file (MediaMetadata* base,
                                    GFile* file,
                                    GError** error)
{
	PhotoMetadata * self;
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	ExifData* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 259 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 259 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 260 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 260 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 260 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 261 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 261 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 263 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 263 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_file_get_path (file);
#line 263 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 263 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_path (_tmp1_, _tmp3_, &_inner_error0_);
#line 263 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 263 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 263 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 263 "../src/photos/PhotoMetadata.vala"
		return;
#line 2858 "PhotoMetadata.c"
	}
#line 264 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = g_file_get_path (file);
#line 264 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_;
#line 264 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = exif_data_new_from_file (_tmp5_);
#line 264 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 264 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp6_;
#line 264 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp5_);
#line 265 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = g_file_get_basename (file);
#line 265 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 265 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp7_;
#line 2878 "PhotoMetadata.c"
}

void
photo_metadata_write_to_file (PhotoMetadata* self,
                              GFile* file,
                              GError** error)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 268 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 268 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 269 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 269 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_file_get_path (file);
#line 269 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_;
#line 269 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_save_file (_tmp0_, _tmp2_, &_inner_error0_);
#line 269 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp2_);
#line 269 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 269 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 269 "../src/photos/PhotoMetadata.vala"
		return;
#line 2910 "PhotoMetadata.c"
	}
}

void
photo_metadata_read_from_buffer (PhotoMetadata* self,
                                 guint8* buffer,
                                 gint buffer_length1,
                                 gint length,
                                 GError** error)
{
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	ExifData* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 272 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 273 "../src/photos/PhotoMetadata.vala"
	if (length <= 0) {
#line 274 "../src/photos/PhotoMetadata.vala"
		length = buffer_length1;
#line 2932 "PhotoMetadata.c"
	}
#line 276 "../src/photos/PhotoMetadata.vala"
	_vala_assert (buffer_length1 >= length, "buffer.length >= length");
#line 278 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 278 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 278 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 279 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 279 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 281 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 281 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_buf (_tmp1_, buffer + 0, (glong) (length - 0), &_inner_error0_);
#line 281 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 281 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 281 "../src/photos/PhotoMetadata.vala"
		return;
#line 2956 "PhotoMetadata.c"
	}
#line 282 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = exif_data_new_from_data (buffer + 0, (gint) (length - 0));
#line 282 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 282 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp2_;
#line 283 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup_printf ("<memory buffer %d bytes>", length);
#line 283 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 283 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp3_;
#line 2970 "PhotoMetadata.c"
}

void
photo_metadata_read_from_app1_segment (PhotoMetadata* self,
                                       GBytes* buffer,
                                       GError** error)
{
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	gsize _tmp2_ = 0;
	guint8* _tmp3_;
	gsize _tmp4_ = 0;
	guint8* _tmp5_;
	ExifData* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 286 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 286 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (buffer != NULL);
#line 287 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 287 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 287 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 288 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 288 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 290 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 290 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_bytes_get_data (buffer, &_tmp2_);
#line 290 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_from_app1_segment (_tmp1_, _tmp3_, (glong) _tmp2_, &_inner_error0_);
#line 290 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 290 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 290 "../src/photos/PhotoMetadata.vala"
		return;
#line 3013 "PhotoMetadata.c"
	}
#line 291 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = g_bytes_get_data (buffer, &_tmp4_);
#line 291 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = exif_data_new_from_data (_tmp5_, (gint) _tmp4_);
#line 291 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 291 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp6_;
#line 292 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup_printf ("<app1 segment %zu bytes>", g_bytes_get_size (buffer));
#line 292 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 292 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp7_;
#line 3029 "PhotoMetadata.c"
}

MetadataDomain
photo_metadata_get_tag_domain (const gchar* tag)
{
	MetadataDomain result = 0;
#line 295 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, 0);
#line 296 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_exif_tag (tag)) {
#line 297 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_EXIF;
#line 297 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3044 "PhotoMetadata.c"
	}
#line 299 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_xmp_tag (tag)) {
#line 300 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_XMP;
#line 300 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3052 "PhotoMetadata.c"
	}
#line 302 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_iptc_tag (tag)) {
#line 303 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_IPTC;
#line 303 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3060 "PhotoMetadata.c"
	}
#line 305 "../src/photos/PhotoMetadata.vala"
	result = METADATA_DOMAIN_UNKNOWN;
#line 305 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3066 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_domain (PhotoMetadata* self,
                           MetadataDomain domain)
{
	gboolean result = FALSE;
#line 308 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 309 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 309 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 3080 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 311 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 311 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_exif (_tmp0_);
#line 311 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3089 "PhotoMetadata.c"
		}
#line 309 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 3093 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 314 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 314 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_xmp (_tmp1_);
#line 314 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3102 "PhotoMetadata.c"
		}
#line 309 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 3106 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 317 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 317 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_iptc (_tmp2_);
#line 317 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3115 "PhotoMetadata.c"
		}
		default:
#line 309 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 3120 "PhotoMetadata.c"
		{
#line 321 "../src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 321 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3126 "PhotoMetadata.c"
		}
	}
}

gboolean
photo_metadata_has_exif (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 325 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 326 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_EXIF);
#line 326 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3141 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_xmp (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 329 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 330 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_XMP);
#line 330 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3154 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_iptc (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 333 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 334 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_IPTC);
#line 334 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3167 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_to_domain (PhotoMetadata* self,
                                    MetadataDomain domain)
{
	gboolean result = FALSE;
#line 337 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 338 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 338 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 3181 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 340 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 340 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_exif (_tmp0_);
#line 340 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3190 "PhotoMetadata.c"
		}
#line 338 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 3194 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 343 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 343 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_xmp (_tmp1_);
#line 343 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3203 "PhotoMetadata.c"
		}
#line 338 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 3207 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 346 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 346 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_iptc (_tmp2_);
#line 346 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3216 "PhotoMetadata.c"
		}
		default:
#line 338 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 3221 "PhotoMetadata.c"
		{
#line 350 "../src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 350 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3227 "PhotoMetadata.c"
		}
	}
}

gboolean
photo_metadata_can_write_exif (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 354 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 355 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_EXIF);
#line 355 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3242 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_xmp (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 358 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 359 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_XMP);
#line 359 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3255 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_iptc (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 362 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 363 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_IPTC);
#line 363 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3268 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_tag (PhotoMetadata* self,
                        const gchar* tag)
{
	GExiv2Metadata* _tmp0_;
	gboolean result = FALSE;
#line 366 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 366 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 367 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 367 "../src/photos/PhotoMetadata.vala"
	result = gexiv2_metadata_has_tag (_tmp0_, tag);
#line 367 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3287 "PhotoMetadata.c"
}

static GeeSet*
photo_metadata_create_string_set (PhotoMetadata* self,
                                  GCompareDataFunc compare_func,
                                  gpointer compare_func_target,
                                  GDestroyNotify compare_func_target_destroy_notify)
{
	GeeSet* result = NULL;
#line 370 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 372 "../src/photos/PhotoMetadata.vala"
	if (compare_func == NULL) {
#line 3301 "PhotoMetadata.c"
		GeeHashSet* _tmp0_;
#line 373 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 373 "../src/photos/PhotoMetadata.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_SET, GeeSet);
#line 373 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 373 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 373 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 373 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 373 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3317 "PhotoMetadata.c"
	} else {
		GCompareDataFunc _tmp1_;
		gpointer _tmp1__target;
		GDestroyNotify _tmp1__target_destroy_notify;
		GeeTreeSet* _tmp2_;
#line 375 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = compare_func;
#line 375 "../src/photos/PhotoMetadata.vala"
		_tmp1__target = compare_func_target;
#line 375 "../src/photos/PhotoMetadata.vala"
		_tmp1__target_destroy_notify = compare_func_target_destroy_notify;
#line 375 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 375 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 375 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 375 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify);
#line 375 "../src/photos/PhotoMetadata.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_SET, GeeSet);
#line 375 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 375 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 375 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 375 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 375 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3349 "PhotoMetadata.c"
	}
}

GeeCollection*
photo_metadata_get_tags (PhotoMetadata* self,
                         MetadataDomain domain,
                         GCompareDataFunc compare_func,
                         gpointer compare_func_target,
                         GDestroyNotify compare_func_target_destroy_notify)
{
	gchar** tags = NULL;
	gint tags_length1;
	gint _tags_size_;
	gboolean _tmp9_ = FALSE;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GeeCollection* collection = NULL;
	GCompareDataFunc _tmp12_;
	gpointer _tmp12__target;
	GDestroyNotify _tmp12__target_destroy_notify;
	GeeSet* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	GeeCollection* result = NULL;
#line 378 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 380 "../src/photos/PhotoMetadata.vala"
	tags = NULL;
#line 380 "../src/photos/PhotoMetadata.vala"
	tags_length1 = 0;
#line 380 "../src/photos/PhotoMetadata.vala"
	_tags_size_ = tags_length1;
#line 381 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 381 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 3386 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
			gchar** _tmp1_;
			gchar** _tmp2_;
#line 383 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 383 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _tmp1_ = gexiv2_metadata_get_exif_tags (_tmp0_);
#line 383 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 383 "../src/photos/PhotoMetadata.vala"
			tags = _tmp2_;
#line 383 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp1_);
#line 383 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 384 "../src/photos/PhotoMetadata.vala"
			break;
#line 3405 "PhotoMetadata.c"
		}
#line 381 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 3409 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_;
			gchar** _tmp4_;
			gchar** _tmp5_;
#line 387 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 387 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = _tmp4_ = gexiv2_metadata_get_xmp_tags (_tmp3_);
#line 387 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 387 "../src/photos/PhotoMetadata.vala"
			tags = _tmp5_;
#line 387 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp4_);
#line 387 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 388 "../src/photos/PhotoMetadata.vala"
			break;
#line 3428 "PhotoMetadata.c"
		}
#line 381 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 3432 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp6_;
			gchar** _tmp7_;
			gchar** _tmp8_;
#line 391 "../src/photos/PhotoMetadata.vala"
			_tmp6_ = self->priv->exiv2;
#line 391 "../src/photos/PhotoMetadata.vala"
			_tmp8_ = _tmp7_ = gexiv2_metadata_get_iptc_tags (_tmp6_);
#line 391 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 391 "../src/photos/PhotoMetadata.vala"
			tags = _tmp8_;
#line 391 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp7_);
#line 391 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 392 "../src/photos/PhotoMetadata.vala"
			break;
#line 3451 "PhotoMetadata.c"
		}
		default:
		{
#line 395 "../src/photos/PhotoMetadata.vala"
			break;
#line 3457 "PhotoMetadata.c"
		}
	}
#line 398 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = tags;
#line 398 "../src/photos/PhotoMetadata.vala"
	_tmp10__length1 = tags_length1;
#line 398 "../src/photos/PhotoMetadata.vala"
	if (_tmp10_ == NULL) {
#line 398 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = TRUE;
#line 3468 "PhotoMetadata.c"
	} else {
		gchar** _tmp11_;
		gint _tmp11__length1;
#line 398 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = tags;
#line 398 "../src/photos/PhotoMetadata.vala"
		_tmp11__length1 = tags_length1;
#line 398 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp11__length1 == 0;
#line 3478 "PhotoMetadata.c"
	}
#line 398 "../src/photos/PhotoMetadata.vala"
	if (_tmp9_) {
#line 399 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 399 "../src/photos/PhotoMetadata.vala"
		tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 399 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 399 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 399 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 399 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 399 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3496 "PhotoMetadata.c"
	}
#line 401 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = compare_func;
#line 401 "../src/photos/PhotoMetadata.vala"
	_tmp12__target = compare_func_target;
#line 401 "../src/photos/PhotoMetadata.vala"
	_tmp12__target_destroy_notify = compare_func_target_destroy_notify;
#line 401 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 401 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 401 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 401 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = photo_metadata_create_string_set (self, _tmp12_, _tmp12__target, _tmp12__target_destroy_notify);
#line 401 "../src/photos/PhotoMetadata.vala"
	collection = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection);
#line 402 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = tags;
#line 402 "../src/photos/PhotoMetadata.vala"
	_tmp14__length1 = tags_length1;
#line 3518 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 402 "../src/photos/PhotoMetadata.vala"
		tag_collection = _tmp14_;
#line 402 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp14__length1;
#line 402 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 3530 "PhotoMetadata.c"
			gchar* _tmp15_;
			gchar* tag = NULL;
#line 402 "../src/photos/PhotoMetadata.vala"
			_tmp15_ = g_strdup (tag_collection[tag_it]);
#line 402 "../src/photos/PhotoMetadata.vala"
			tag = _tmp15_;
#line 3537 "PhotoMetadata.c"
			{
				GeeCollection* _tmp16_;
				const gchar* _tmp17_;
#line 403 "../src/photos/PhotoMetadata.vala"
				_tmp16_ = collection;
#line 403 "../src/photos/PhotoMetadata.vala"
				_tmp17_ = tag;
#line 403 "../src/photos/PhotoMetadata.vala"
				gee_collection_add (_tmp16_, _tmp17_);
#line 402 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3549 "PhotoMetadata.c"
			}
		}
	}
#line 405 "../src/photos/PhotoMetadata.vala"
	result = collection;
#line 405 "../src/photos/PhotoMetadata.vala"
	tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 405 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 405 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 405 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 405 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 405 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3567 "PhotoMetadata.c"
}

GeeCollection*
photo_metadata_get_all_tags (PhotoMetadata* self,
                             GCompareDataFunc compare_func,
                             gpointer compare_func_target,
                             GDestroyNotify compare_func_target_destroy_notify)
{
	GeeCollection* all_tags = NULL;
	GCompareDataFunc _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	GeeSet* _tmp1_;
	GeeCollection* exif_tags = NULL;
	GeeCollection* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GeeCollection* _tmp4_;
	GeeCollection* xmp_tags = NULL;
	GeeCollection* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GeeCollection* _tmp12_;
	GeeCollection* iptc_tags = NULL;
	GeeCollection* _tmp18_;
	gboolean _tmp19_ = FALSE;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp26_ = NULL;
	GeeCollection* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	GeeCollection* _tmp31_;
	GeeCollection* result = NULL;
#line 408 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 410 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = compare_func;
#line 410 "../src/photos/PhotoMetadata.vala"
	_tmp0__target = compare_func_target;
#line 410 "../src/photos/PhotoMetadata.vala"
	_tmp0__target_destroy_notify = compare_func_target_destroy_notify;
#line 410 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 410 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 410 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 410 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_create_string_set (self, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify);
#line 410 "../src/photos/PhotoMetadata.vala"
	all_tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection);
#line 412 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_tags (self, METADATA_DOMAIN_EXIF, NULL, NULL, NULL);
#line 412 "../src/photos/PhotoMetadata.vala"
	exif_tags = _tmp2_;
#line 413 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = exif_tags;
#line 413 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 3625 "PhotoMetadata.c"
		GeeCollection* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 413 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = exif_tags;
#line 413 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = gee_collection_get_size (_tmp5_);
#line 413 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_;
#line 413 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp7_ > 0;
#line 3637 "PhotoMetadata.c"
	} else {
#line 413 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = FALSE;
#line 3641 "PhotoMetadata.c"
	}
#line 413 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 3645 "PhotoMetadata.c"
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
#line 414 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = all_tags;
#line 414 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = exif_tags;
#line 414 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp8_, _tmp9_);
#line 3654 "PhotoMetadata.c"
	}
#line 416 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = photo_metadata_get_tags (self, METADATA_DOMAIN_XMP, NULL, NULL, NULL);
#line 416 "../src/photos/PhotoMetadata.vala"
	xmp_tags = _tmp10_;
#line 417 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = xmp_tags;
#line 417 "../src/photos/PhotoMetadata.vala"
	if (_tmp12_ != NULL) {
#line 3664 "PhotoMetadata.c"
		GeeCollection* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 417 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = xmp_tags;
#line 417 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = gee_collection_get_size (_tmp13_);
#line 417 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = _tmp14_;
#line 417 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = _tmp15_ > 0;
#line 3676 "PhotoMetadata.c"
	} else {
#line 417 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = FALSE;
#line 3680 "PhotoMetadata.c"
	}
#line 417 "../src/photos/PhotoMetadata.vala"
	if (_tmp11_) {
#line 3684 "PhotoMetadata.c"
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
#line 418 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = all_tags;
#line 418 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = xmp_tags;
#line 418 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp16_, _tmp17_);
#line 3693 "PhotoMetadata.c"
	}
#line 420 "../src/photos/PhotoMetadata.vala"
	_tmp18_ = photo_metadata_get_tags (self, METADATA_DOMAIN_IPTC, NULL, NULL, NULL);
#line 420 "../src/photos/PhotoMetadata.vala"
	iptc_tags = _tmp18_;
#line 421 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = iptc_tags;
#line 421 "../src/photos/PhotoMetadata.vala"
	if (_tmp20_ != NULL) {
#line 3703 "PhotoMetadata.c"
		GeeCollection* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = iptc_tags;
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = gee_collection_get_size (_tmp21_);
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = _tmp22_;
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = _tmp23_ > 0;
#line 3715 "PhotoMetadata.c"
	} else {
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = FALSE;
#line 3719 "PhotoMetadata.c"
	}
#line 421 "../src/photos/PhotoMetadata.vala"
	if (_tmp19_) {
#line 3723 "PhotoMetadata.c"
		GeeCollection* _tmp24_;
		GeeCollection* _tmp25_;
#line 422 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = all_tags;
#line 422 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = iptc_tags;
#line 422 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp24_, _tmp25_);
#line 3732 "PhotoMetadata.c"
	}
#line 424 "../src/photos/PhotoMetadata.vala"
	_tmp27_ = all_tags;
#line 424 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = gee_collection_get_size (_tmp27_);
#line 424 "../src/photos/PhotoMetadata.vala"
	_tmp29_ = _tmp28_;
#line 424 "../src/photos/PhotoMetadata.vala"
	if (_tmp29_ > 0) {
#line 3742 "PhotoMetadata.c"
		GeeCollection* _tmp30_;
#line 424 "../src/photos/PhotoMetadata.vala"
		_tmp30_ = all_tags;
#line 424 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = _tmp30_;
#line 3748 "PhotoMetadata.c"
	} else {
#line 424 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = NULL;
#line 3752 "PhotoMetadata.c"
	}
#line 424 "../src/photos/PhotoMetadata.vala"
	_tmp31_ = _g_object_ref0 (_tmp26_);
#line 424 "../src/photos/PhotoMetadata.vala"
	result = _tmp31_;
#line 424 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (iptc_tags);
#line 424 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (xmp_tags);
#line 424 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (exif_tags);
#line 424 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (all_tags);
#line 424 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 424 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 424 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 424 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 424 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3776 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_tag_label (PhotoMetadata* self,
                              const gchar* tag)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 427 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 427 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 428 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_get_tag_label (tag);
#line 428 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 428 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 428 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3798 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_tag_description (PhotoMetadata* self,
                                    const gchar* tag)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 431 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 431 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 432 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_get_tag_description (tag);
#line 432 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 432 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 432 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3820 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_string (PhotoMetadata* self,
                           const gchar* tag,
                           PrepareInputTextOptions options)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 435 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 435 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 436 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 436 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_string (_tmp0_, tag);
#line 436 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_;
#line 436 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = prepare_input_text (_tmp2_, options, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 436 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = _tmp3_;
#line 436 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp2_);
#line 436 "../src/photos/PhotoMetadata.vala"
	result = _tmp4_;
#line 436 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3854 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_string_interpreted (PhotoMetadata* self,
                                       const gchar* tag,
                                       PrepareInputTextOptions options)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 439 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 439 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 440 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 440 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_interpreted_string (_tmp0_, tag);
#line 440 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_;
#line 440 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = prepare_input_text (_tmp2_, options, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 440 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = _tmp3_;
#line 440 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp2_);
#line 440 "../src/photos/PhotoMetadata.vala"
	result = _tmp4_;
#line 440 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3888 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_first_string (PhotoMetadata* self,
                                 gchar** tags,
                                 gint tags_length1)
{
	gchar* result = NULL;
#line 443 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3899 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 444 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 444 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 444 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 3911 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 444 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 444 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 3918 "PhotoMetadata.c"
			{
				gchar* value = NULL;
				const gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp3_;
#line 445 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 445 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string (self, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 445 "../src/photos/PhotoMetadata.vala"
				value = _tmp2_;
#line 446 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 446 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 447 "../src/photos/PhotoMetadata.vala"
					result = value;
#line 447 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 447 "../src/photos/PhotoMetadata.vala"
					return result;
#line 3940 "PhotoMetadata.c"
				}
#line 444 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 444 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3946 "PhotoMetadata.c"
			}
		}
	}
#line 450 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 450 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3954 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_first_string_interpreted (PhotoMetadata* self,
                                             gchar** tags,
                                             gint tags_length1)
{
	gchar* result = NULL;
#line 453 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3965 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 454 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 454 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 454 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 3977 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 454 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 454 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 3984 "PhotoMetadata.c"
			{
				gchar* value = NULL;
				const gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp3_;
#line 455 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 455 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string_interpreted (self, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 455 "../src/photos/PhotoMetadata.vala"
				value = _tmp2_;
#line 456 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 456 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 457 "../src/photos/PhotoMetadata.vala"
					result = value;
#line 457 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 457 "../src/photos/PhotoMetadata.vala"
					return result;
#line 4006 "PhotoMetadata.c"
				}
#line 454 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 454 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4012 "PhotoMetadata.c"
			}
		}
	}
#line 460 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 460 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4020 "PhotoMetadata.c"
}

GeeList*
photo_metadata_get_string_multiple (PhotoMetadata* self,
                                    const gchar* tag)
{
	gchar** values = NULL;
	GExiv2Metadata* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint values_length1;
	gint _values_size_;
	gboolean _tmp3_ = FALSE;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GeeList* list = NULL;
	GeeArrayList* _tmp6_;
	GeeHashSet* collection = NULL;
	GeeHashSet* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GeeList* _tmp20_ = NULL;
	GeeList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	GeeList* _tmp25_;
	GeeList* result = NULL;
#line 469 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 469 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 470 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 470 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_tag_multiple (_tmp0_, tag);
#line 470 "../src/photos/PhotoMetadata.vala"
	values = _tmp2_;
#line 470 "../src/photos/PhotoMetadata.vala"
	values_length1 = _vala_array_length (_tmp1_);
#line 470 "../src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 471 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = values;
#line 471 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = values_length1;
#line 471 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 471 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 4070 "PhotoMetadata.c"
	} else {
		gchar** _tmp5_;
		gint _tmp5__length1;
#line 471 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = values;
#line 471 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = values_length1;
#line 471 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5__length1 == 0;
#line 4080 "PhotoMetadata.c"
	}
#line 471 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 472 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 472 "../src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 472 "../src/photos/PhotoMetadata.vala"
		return result;
#line 4090 "PhotoMetadata.c"
	}
#line 474 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 474 "../src/photos/PhotoMetadata.vala"
	list = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_LIST, GeeList);
#line 476 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 476 "../src/photos/PhotoMetadata.vala"
	collection = _tmp7_;
#line 477 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = values;
#line 477 "../src/photos/PhotoMetadata.vala"
	_tmp8__length1 = values_length1;
#line 4104 "PhotoMetadata.c"
	{
		gchar** value_collection = NULL;
		gint value_collection_length1 = 0;
		gint _value_collection_size_ = 0;
		gint value_it = 0;
#line 477 "../src/photos/PhotoMetadata.vala"
		value_collection = _tmp8_;
#line 477 "../src/photos/PhotoMetadata.vala"
		value_collection_length1 = _tmp8__length1;
#line 477 "../src/photos/PhotoMetadata.vala"
		for (value_it = 0; value_it < value_collection_length1; value_it = value_it + 1) {
#line 4116 "PhotoMetadata.c"
			gchar* _tmp9_;
			gchar* value = NULL;
#line 477 "../src/photos/PhotoMetadata.vala"
			_tmp9_ = g_strdup (value_collection[value_it]);
#line 477 "../src/photos/PhotoMetadata.vala"
			value = _tmp9_;
#line 4123 "PhotoMetadata.c"
			{
				gchar* prepped = NULL;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gboolean _tmp12_ = FALSE;
				const gchar* _tmp13_;
#line 478 "../src/photos/PhotoMetadata.vala"
				_tmp10_ = value;
#line 478 "../src/photos/PhotoMetadata.vala"
				_tmp11_ = prepare_input_text (_tmp10_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 478 "../src/photos/PhotoMetadata.vala"
				prepped = _tmp11_;
#line 481 "../src/photos/PhotoMetadata.vala"
				_tmp13_ = prepped;
#line 481 "../src/photos/PhotoMetadata.vala"
				if (_tmp13_ != NULL) {
#line 4140 "PhotoMetadata.c"
					GeeHashSet* _tmp14_;
					const gchar* _tmp15_;
#line 481 "../src/photos/PhotoMetadata.vala"
					_tmp14_ = collection;
#line 481 "../src/photos/PhotoMetadata.vala"
					_tmp15_ = prepped;
#line 481 "../src/photos/PhotoMetadata.vala"
					_tmp12_ = !gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp15_);
#line 4149 "PhotoMetadata.c"
				} else {
#line 481 "../src/photos/PhotoMetadata.vala"
					_tmp12_ = FALSE;
#line 4153 "PhotoMetadata.c"
				}
#line 481 "../src/photos/PhotoMetadata.vala"
				if (_tmp12_) {
#line 4157 "PhotoMetadata.c"
					GeeList* _tmp16_;
					const gchar* _tmp17_;
					GeeHashSet* _tmp18_;
					const gchar* _tmp19_;
#line 482 "../src/photos/PhotoMetadata.vala"
					_tmp16_ = list;
#line 482 "../src/photos/PhotoMetadata.vala"
					_tmp17_ = prepped;
#line 482 "../src/photos/PhotoMetadata.vala"
					gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_COLLECTION, GeeCollection), _tmp17_);
#line 483 "../src/photos/PhotoMetadata.vala"
					_tmp18_ = collection;
#line 483 "../src/photos/PhotoMetadata.vala"
					_tmp19_ = prepped;
#line 483 "../src/photos/PhotoMetadata.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp19_);
#line 4174 "PhotoMetadata.c"
				}
#line 477 "../src/photos/PhotoMetadata.vala"
				_g_free0 (prepped);
#line 477 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 4180 "PhotoMetadata.c"
			}
		}
	}
#line 487 "../src/photos/PhotoMetadata.vala"
	_tmp21_ = list;
#line 487 "../src/photos/PhotoMetadata.vala"
	_tmp22_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection));
#line 487 "../src/photos/PhotoMetadata.vala"
	_tmp23_ = _tmp22_;
#line 487 "../src/photos/PhotoMetadata.vala"
	if (_tmp23_ > 0) {
#line 4192 "PhotoMetadata.c"
		GeeList* _tmp24_;
#line 487 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = list;
#line 487 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = _tmp24_;
#line 4198 "PhotoMetadata.c"
	} else {
#line 487 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = NULL;
#line 4202 "PhotoMetadata.c"
	}
#line 487 "../src/photos/PhotoMetadata.vala"
	_tmp25_ = _g_object_ref0 (_tmp20_);
#line 487 "../src/photos/PhotoMetadata.vala"
	result = _tmp25_;
#line 487 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (collection);
#line 487 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (list);
#line 487 "../src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 487 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4216 "PhotoMetadata.c"
}

GeeList*
photo_metadata_get_first_string_multiple (PhotoMetadata* self,
                                          gchar** tags,
                                          gint tags_length1)
{
	GeeList* result = NULL;
#line 496 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 4227 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 497 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 497 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 497 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 4239 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 497 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 497 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 4246 "PhotoMetadata.c"
			{
				GeeList* values = NULL;
				const gchar* _tmp1_;
				GeeList* _tmp2_;
				gboolean _tmp3_ = FALSE;
				GeeList* _tmp4_;
#line 498 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 498 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string_multiple (self, _tmp1_);
#line 498 "../src/photos/PhotoMetadata.vala"
				values = _tmp2_;
#line 499 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = values;
#line 499 "../src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 4263 "PhotoMetadata.c"
					GeeList* _tmp5_;
					gint _tmp6_;
					gint _tmp7_;
#line 499 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = values;
#line 499 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 499 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = _tmp6_;
#line 499 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = _tmp7_ > 0;
#line 4275 "PhotoMetadata.c"
				} else {
#line 499 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = FALSE;
#line 4279 "PhotoMetadata.c"
				}
#line 499 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 500 "../src/photos/PhotoMetadata.vala"
					result = values;
#line 500 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 500 "../src/photos/PhotoMetadata.vala"
					return result;
#line 4289 "PhotoMetadata.c"
				}
#line 497 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 497 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4295 "PhotoMetadata.c"
			}
		}
	}
#line 503 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 503 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4303 "PhotoMetadata.c"
}

void
photo_metadata_set_string (PhotoMetadata* self,
                           const gchar* tag,
                           const gchar* value,
                           PrepareInputTextOptions options,
                           gint length)
{
	gchar* prepped = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GExiv2Metadata* _tmp2_;
	const gchar* _tmp3_;
#line 506 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 506 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 506 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 508 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = prepare_input_text (value, options, length);
#line 508 "../src/photos/PhotoMetadata.vala"
	prepped = _tmp0_;
#line 509 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = prepped;
#line 509 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 510 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:510: Not setting tag %s to string %s: invalid UTF-8", tag, value);
#line 512 "../src/photos/PhotoMetadata.vala"
		_g_free0 (prepped);
#line 512 "../src/photos/PhotoMetadata.vala"
		return;
#line 4338 "PhotoMetadata.c"
	}
#line 515 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->exiv2;
#line 515 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = prepped;
#line 515 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_string (_tmp2_, tag, _tmp3_)) {
#line 4346 "PhotoMetadata.c"
		const gchar* _tmp4_;
#line 516 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = self->priv->source_name;
#line 516 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:516: Unable to set tag %s to string %s from source " \
"%s", tag, value, _tmp4_);
#line 4352 "PhotoMetadata.c"
	}
#line 506 "../src/photos/PhotoMetadata.vala"
	_g_free0 (prepped);
#line 4356 "PhotoMetadata.c"
}

static void
photo_metadata_set_all_generic (PhotoMetadata* self,
                                gchar** tags,
                                gint tags_length1,
                                PhotoMetadataSetOption option,
                                PhotoMetadataSetGenericValue setter,
                                gpointer setter_target)
{
	gboolean written = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 521 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 522 "../src/photos/PhotoMetadata.vala"
	written = FALSE;
#line 4374 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 523 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 523 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 523 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 4386 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 523 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 523 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 4393 "PhotoMetadata.c"
			{
				gboolean _tmp1_ = FALSE;
#line 524 "../src/photos/PhotoMetadata.vala"
				if (option == PHOTO_METADATA_SET_OPTION_ALL_DOMAINS) {
#line 524 "../src/photos/PhotoMetadata.vala"
					_tmp1_ = TRUE;
#line 4400 "PhotoMetadata.c"
				} else {
					const gchar* _tmp2_;
#line 524 "../src/photos/PhotoMetadata.vala"
					_tmp2_ = tag;
#line 524 "../src/photos/PhotoMetadata.vala"
					_tmp1_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (_tmp2_));
#line 4407 "PhotoMetadata.c"
				}
#line 524 "../src/photos/PhotoMetadata.vala"
				if (_tmp1_) {
#line 4411 "PhotoMetadata.c"
					const gchar* _tmp3_;
#line 525 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = tag;
#line 525 "../src/photos/PhotoMetadata.vala"
					setter (_tmp3_, setter_target);
#line 526 "../src/photos/PhotoMetadata.vala"
					written = TRUE;
#line 4419 "PhotoMetadata.c"
				}
#line 523 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4423 "PhotoMetadata.c"
			}
		}
	}
#line 530 "../src/photos/PhotoMetadata.vala"
	if (option == PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN) {
#line 530 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = !written;
#line 4431 "PhotoMetadata.c"
	} else {
#line 530 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = FALSE;
#line 4435 "PhotoMetadata.c"
	}
#line 530 "../src/photos/PhotoMetadata.vala"
	if (_tmp5_) {
#line 530 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = tags_length1 > 0;
#line 4441 "PhotoMetadata.c"
	} else {
#line 530 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 4445 "PhotoMetadata.c"
	}
#line 530 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 4449 "PhotoMetadata.c"
		MetadataDomain default_domain = 0;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 531 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = tags[0];
#line 531 "../src/photos/PhotoMetadata.vala"
		default_domain = photo_metadata_get_tag_domain (_tmp6_);
#line 534 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = tags[0];
#line 534 "../src/photos/PhotoMetadata.vala"
		setter (_tmp7_, setter_target);
#line 4461 "PhotoMetadata.c"
		{
			gint ctr = 0;
#line 537 "../src/photos/PhotoMetadata.vala"
			ctr = 1;
#line 4466 "PhotoMetadata.c"
			{
				gboolean _tmp8_ = FALSE;
#line 537 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = TRUE;
#line 537 "../src/photos/PhotoMetadata.vala"
				while (TRUE) {
#line 4473 "PhotoMetadata.c"
					const gchar* _tmp10_;
#line 537 "../src/photos/PhotoMetadata.vala"
					if (!_tmp8_) {
#line 4477 "PhotoMetadata.c"
						gint _tmp9_;
#line 537 "../src/photos/PhotoMetadata.vala"
						_tmp9_ = ctr;
#line 537 "../src/photos/PhotoMetadata.vala"
						ctr = _tmp9_ + 1;
#line 4483 "PhotoMetadata.c"
					}
#line 537 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = FALSE;
#line 537 "../src/photos/PhotoMetadata.vala"
					if (!(ctr < tags_length1)) {
#line 537 "../src/photos/PhotoMetadata.vala"
						break;
#line 4491 "PhotoMetadata.c"
					}
#line 538 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = tags[ctr];
#line 538 "../src/photos/PhotoMetadata.vala"
					if (photo_metadata_get_tag_domain (_tmp10_) == default_domain) {
#line 4497 "PhotoMetadata.c"
						const gchar* _tmp11_;
#line 539 "../src/photos/PhotoMetadata.vala"
						_tmp11_ = tags[ctr];
#line 539 "../src/photos/PhotoMetadata.vala"
						setter (_tmp11_, setter_target);
#line 4503 "PhotoMetadata.c"
					}
				}
			}
		}
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 544 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 544 "../src/photos/PhotoMetadata.vala"
	return _data1_;
#line 4518 "PhotoMetadata.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 544 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 4528 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 544 "../src/photos/PhotoMetadata.vala"
		self = _data1_->self;
#line 544 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_data1_->value);
#line 544 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 544 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block1Data, _data1_);
#line 4538 "PhotoMetadata.c"
	}
}

static void
__lambda5_ (Block1Data* _data1_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 545 "../src/photos/PhotoMetadata.vala"
	self = _data1_->self;
#line 545 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 545 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, tag, _data1_->value, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 4553 "PhotoMetadata.c"
}

static void
___lambda5__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 545 "../src/photos/PhotoMetadata.vala"
	__lambda5_ (self, tag);
#line 4562 "PhotoMetadata.c"
}

void
photo_metadata_set_all_string (PhotoMetadata* self,
                               gchar** tags,
                               gint tags_length1,
                               const gchar* value,
                               PhotoMetadataSetOption option)
{
	Block1Data* _data1_;
	gchar* _tmp0_;
#line 544 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 544 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 544 "../src/photos/PhotoMetadata.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 544 "../src/photos/PhotoMetadata.vala"
	_data1_->_ref_count_ = 1;
#line 544 "../src/photos/PhotoMetadata.vala"
	_data1_->self = media_metadata_ref (self);
#line 544 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (value);
#line 544 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_data1_->value);
#line 544 "../src/photos/PhotoMetadata.vala"
	_data1_->value = _tmp0_;
#line 545 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda5__photo_metadata_set_generic_value, _data1_);
#line 544 "../src/photos/PhotoMetadata.vala"
	block1_data_unref (_data1_);
#line 544 "../src/photos/PhotoMetadata.vala"
	_data1_ = NULL;
#line 4596 "PhotoMetadata.c"
}

static void
_vala_array_add46 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 553 "../src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 553 "../src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 553 "../src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4611 "PhotoMetadata.c"
	}
#line 553 "../src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 553 "../src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 4617 "PhotoMetadata.c"
}

static void
_vala_array_add47 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 565 "../src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 565 "../src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 565 "../src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4632 "PhotoMetadata.c"
	}
#line 565 "../src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 565 "../src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 4638 "PhotoMetadata.c"
}

void
photo_metadata_set_string_multiple (PhotoMetadata* self,
                                    const gchar* tag,
                                    GeeCollection* collection)
{
	gchar** values = NULL;
	gchar** _tmp0_;
	gint values_length1;
	gint _values_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	GExiv2Metadata* _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
#line 548 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 548 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 548 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (collection, GEE_TYPE_COLLECTION));
#line 549 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 549 "../src/photos/PhotoMetadata.vala"
	values = _tmp0_;
#line 549 "../src/photos/PhotoMetadata.vala"
	values_length1 = 0;
#line 549 "../src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 4669 "PhotoMetadata.c"
	{
		GeeIterator* _value_it = NULL;
		GeeIterator* _tmp1_;
#line 550 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (collection, GEE_TYPE_ITERABLE, GeeIterable));
#line 550 "../src/photos/PhotoMetadata.vala"
		_value_it = _tmp1_;
#line 550 "../src/photos/PhotoMetadata.vala"
		while (TRUE) {
#line 4679 "PhotoMetadata.c"
			GeeIterator* _tmp2_;
			gchar* value = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gchar* prepped = NULL;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			const gchar* _tmp7_;
#line 550 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _value_it;
#line 550 "../src/photos/PhotoMetadata.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 550 "../src/photos/PhotoMetadata.vala"
				break;
#line 4694 "PhotoMetadata.c"
			}
#line 550 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = _value_it;
#line 550 "../src/photos/PhotoMetadata.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 550 "../src/photos/PhotoMetadata.vala"
			value = (gchar*) _tmp4_;
#line 551 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = value;
#line 551 "../src/photos/PhotoMetadata.vala"
			_tmp6_ = prepare_input_text (_tmp5_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, -1);
#line 551 "../src/photos/PhotoMetadata.vala"
			prepped = _tmp6_;
#line 552 "../src/photos/PhotoMetadata.vala"
			_tmp7_ = prepped;
#line 552 "../src/photos/PhotoMetadata.vala"
			if (_tmp7_ != NULL) {
#line 4712 "PhotoMetadata.c"
				const gchar* _tmp8_;
				gchar* _tmp9_;
#line 553 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = prepped;
#line 553 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 553 "../src/photos/PhotoMetadata.vala"
				_vala_array_add46 (&values, &values_length1, &_values_size_, _tmp9_);
#line 4721 "PhotoMetadata.c"
			} else {
				const gchar* _tmp10_;
#line 555 "../src/photos/PhotoMetadata.vala"
				_tmp10_ = value;
#line 555 "../src/photos/PhotoMetadata.vala"
				g_warning ("PhotoMetadata.vala:555: Unable to set string %s to %s: invalid UTF-8", _tmp10_, tag);
#line 4728 "PhotoMetadata.c"
			}
#line 550 "../src/photos/PhotoMetadata.vala"
			_g_free0 (prepped);
#line 550 "../src/photos/PhotoMetadata.vala"
			_g_free0 (value);
#line 4734 "PhotoMetadata.c"
		}
#line 550 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_value_it);
#line 4738 "PhotoMetadata.c"
	}
#line 558 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = values;
#line 558 "../src/photos/PhotoMetadata.vala"
	_tmp11__length1 = values_length1;
#line 558 "../src/photos/PhotoMetadata.vala"
	if (_tmp11__length1 == 0) {
#line 559 "../src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 559 "../src/photos/PhotoMetadata.vala"
		return;
#line 4750 "PhotoMetadata.c"
	}
#line 565 "../src/photos/PhotoMetadata.vala"
	_vala_array_add47 (&values, &values_length1, &_values_size_, NULL);
#line 567 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = self->priv->exiv2;
#line 567 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = values;
#line 567 "../src/photos/PhotoMetadata.vala"
	_tmp13__length1 = values_length1;
#line 567 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_multiple (_tmp12_, tag, _tmp13_)) {
#line 4762 "PhotoMetadata.c"
		gchar** _tmp14_;
		gint _tmp14__length1;
		const gchar* _tmp15_;
#line 568 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = values;
#line 568 "../src/photos/PhotoMetadata.vala"
		_tmp14__length1 = values_length1;
#line 568 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = self->priv->source_name;
#line 568 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:568: Unable to set %d strings to tag %s from source" \
" %s", _tmp14__length1, tag, _tmp15_);
#line 4774 "PhotoMetadata.c"
	}
#line 548 "../src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 4778 "PhotoMetadata.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 571 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 571 "../src/photos/PhotoMetadata.vala"
	return _data2_;
#line 4788 "PhotoMetadata.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 571 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 4798 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 571 "../src/photos/PhotoMetadata.vala"
		self = _data2_->self;
#line 571 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_data2_->values);
#line 571 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 571 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block2Data, _data2_);
#line 4808 "PhotoMetadata.c"
	}
}

static void
__lambda6_ (Block2Data* _data2_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 572 "../src/photos/PhotoMetadata.vala"
	self = _data2_->self;
#line 572 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 572 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string_multiple (self, tag, _data2_->values);
#line 4823 "PhotoMetadata.c"
}

static void
___lambda6__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 572 "../src/photos/PhotoMetadata.vala"
	__lambda6_ (self, tag);
#line 4832 "PhotoMetadata.c"
}

void
photo_metadata_set_all_string_multiple (PhotoMetadata* self,
                                        gchar** tags,
                                        gint tags_length1,
                                        GeeCollection* values,
                                        PhotoMetadataSetOption option)
{
	Block2Data* _data2_;
	GeeCollection* _tmp0_;
#line 571 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 571 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (values, GEE_TYPE_COLLECTION));
#line 571 "../src/photos/PhotoMetadata.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 571 "../src/photos/PhotoMetadata.vala"
	_data2_->_ref_count_ = 1;
#line 571 "../src/photos/PhotoMetadata.vala"
	_data2_->self = media_metadata_ref (self);
#line 571 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _g_object_ref0 (values);
#line 571 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_data2_->values);
#line 571 "../src/photos/PhotoMetadata.vala"
	_data2_->values = _tmp0_;
#line 572 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda6__photo_metadata_set_generic_value, _data2_);
#line 571 "../src/photos/PhotoMetadata.vala"
	block2_data_unref (_data2_);
#line 571 "../src/photos/PhotoMetadata.vala"
	_data2_ = NULL;
#line 4866 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_long (PhotoMetadata* self,
                         const gchar* tag,
                         glong* value)
{
	glong _vala_value = 0L;
	GExiv2Metadata* _tmp0_;
	gboolean result = FALSE;
#line 575 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 575 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 576 "../src/photos/PhotoMetadata.vala"
	if (!photo_metadata_has_tag (self, tag)) {
#line 577 "../src/photos/PhotoMetadata.vala"
		_vala_value = (glong) 0;
#line 579 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 579 "../src/photos/PhotoMetadata.vala"
		if (value) {
#line 579 "../src/photos/PhotoMetadata.vala"
			*value = _vala_value;
#line 4891 "PhotoMetadata.c"
		}
#line 579 "../src/photos/PhotoMetadata.vala"
		return result;
#line 4895 "PhotoMetadata.c"
	}
#line 582 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 582 "../src/photos/PhotoMetadata.vala"
	_vala_value = gexiv2_metadata_get_tag_long (_tmp0_, tag);
#line 584 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 584 "../src/photos/PhotoMetadata.vala"
	if (value) {
#line 584 "../src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 4907 "PhotoMetadata.c"
	}
#line 584 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4911 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_first_long (PhotoMetadata* self,
                               gchar** tags,
                               gint tags_length1,
                               glong* value)
{
	glong _vala_value = 0L;
	gboolean result = FALSE;
#line 587 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 4924 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 588 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 588 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 588 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 4936 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 588 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 588 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 4943 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
				glong _tmp2_ = 0L;
				gboolean _tmp3_;
#line 589 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 589 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_long (self, _tmp1_, &_tmp2_);
#line 589 "../src/photos/PhotoMetadata.vala"
				_vala_value = _tmp2_;
#line 589 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 590 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 590 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 590 "../src/photos/PhotoMetadata.vala"
					if (value) {
#line 590 "../src/photos/PhotoMetadata.vala"
						*value = _vala_value;
#line 4964 "PhotoMetadata.c"
					}
#line 590 "../src/photos/PhotoMetadata.vala"
					return result;
#line 4968 "PhotoMetadata.c"
				}
#line 588 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4972 "PhotoMetadata.c"
			}
		}
	}
#line 593 "../src/photos/PhotoMetadata.vala"
	_vala_value = (glong) 0;
#line 595 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 595 "../src/photos/PhotoMetadata.vala"
	if (value) {
#line 595 "../src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 4984 "PhotoMetadata.c"
	}
#line 595 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4988 "PhotoMetadata.c"
}

void
photo_metadata_set_long (PhotoMetadata* self,
                         const gchar* tag,
                         glong value)
{
	GExiv2Metadata* _tmp0_;
#line 598 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 598 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 599 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 599 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_long (_tmp0_, tag, value)) {
#line 5005 "PhotoMetadata.c"
		const gchar* _tmp1_;
#line 600 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->source_name;
#line 600 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:600: Unable to set tag %s to long %ld from source %" \
"s", tag, value, _tmp1_);
#line 5011 "PhotoMetadata.c"
	}
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 603 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 603 "../src/photos/PhotoMetadata.vala"
	return _data3_;
#line 5022 "PhotoMetadata.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 603 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 5032 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 603 "../src/photos/PhotoMetadata.vala"
		self = _data3_->self;
#line 603 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 603 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block3Data, _data3_);
#line 5040 "PhotoMetadata.c"
	}
}

static void
__lambda7_ (Block3Data* _data3_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 604 "../src/photos/PhotoMetadata.vala"
	self = _data3_->self;
#line 604 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 604 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_long (self, tag, _data3_->value);
#line 5055 "PhotoMetadata.c"
}

static void
___lambda7__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 604 "../src/photos/PhotoMetadata.vala"
	__lambda7_ (self, tag);
#line 5064 "PhotoMetadata.c"
}

void
photo_metadata_set_all_long (PhotoMetadata* self,
                             gchar** tags,
                             gint tags_length1,
                             glong value,
                             PhotoMetadataSetOption option)
{
	Block3Data* _data3_;
#line 603 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 603 "../src/photos/PhotoMetadata.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 603 "../src/photos/PhotoMetadata.vala"
	_data3_->_ref_count_ = 1;
#line 603 "../src/photos/PhotoMetadata.vala"
	_data3_->self = media_metadata_ref (self);
#line 603 "../src/photos/PhotoMetadata.vala"
	_data3_->value = value;
#line 604 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda7__photo_metadata_set_generic_value, _data3_);
#line 603 "../src/photos/PhotoMetadata.vala"
	block3_data_unref (_data3_);
#line 603 "../src/photos/PhotoMetadata.vala"
	_data3_ = NULL;
#line 5091 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_rational (PhotoMetadata* self,
                             const gchar* tag,
                             MetadataRational* rational)
{
	MetadataRational _vala_rational = {0};
	gint numerator = 0;
	gint denominator = 0;
	gboolean _result_ = FALSE;
	GExiv2Metadata* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
	gboolean result = FALSE;
#line 607 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 607 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 609 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 609 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = gexiv2_metadata_get_exif_tag_rational (_tmp0_, tag, &_tmp1_, &_tmp2_);
#line 609 "../src/photos/PhotoMetadata.vala"
	numerator = _tmp1_;
#line 609 "../src/photos/PhotoMetadata.vala"
	denominator = _tmp2_;
#line 609 "../src/photos/PhotoMetadata.vala"
	_result_ = _tmp3_;
#line 611 "../src/photos/PhotoMetadata.vala"
	metadata_rational_init (&_vala_rational, numerator, denominator);
#line 613 "../src/photos/PhotoMetadata.vala"
	result = _result_;
#line 613 "../src/photos/PhotoMetadata.vala"
	if (rational) {
#line 613 "../src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 5130 "PhotoMetadata.c"
	}
#line 613 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5134 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_first_rational (PhotoMetadata* self,
                                   gchar** tags,
                                   gint tags_length1,
                                   MetadataRational* rational)
{
	MetadataRational _vala_rational = {0};
	gboolean result = FALSE;
#line 616 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 5147 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 617 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 617 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 617 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 5159 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 617 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 617 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 5166 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
				MetadataRational _tmp2_ = {0};
				gboolean _tmp3_;
#line 618 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 618 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_rational (self, _tmp1_, &_tmp2_);
#line 618 "../src/photos/PhotoMetadata.vala"
				_vala_rational = _tmp2_;
#line 618 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 619 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 619 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 619 "../src/photos/PhotoMetadata.vala"
					if (rational) {
#line 619 "../src/photos/PhotoMetadata.vala"
						*rational = _vala_rational;
#line 5187 "PhotoMetadata.c"
					}
#line 619 "../src/photos/PhotoMetadata.vala"
					return result;
#line 5191 "PhotoMetadata.c"
				}
#line 617 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 5195 "PhotoMetadata.c"
			}
		}
	}
#line 622 "../src/photos/PhotoMetadata.vala"
	metadata_rational_init (&_vala_rational, 0, 0);
#line 624 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 624 "../src/photos/PhotoMetadata.vala"
	if (rational) {
#line 624 "../src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 5207 "PhotoMetadata.c"
	}
#line 624 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5211 "PhotoMetadata.c"
}

void
photo_metadata_set_rational (PhotoMetadata* self,
                             const gchar* tag,
                             MetadataRational* rational)
{
	GExiv2Metadata* _tmp0_;
	MetadataRational _tmp1_;
	MetadataRational _tmp2_;
#line 627 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 627 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 627 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 628 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 628 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = *rational;
#line 628 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = *rational;
#line 628 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_exif_tag_rational (_tmp0_, tag, _tmp1_.numerator, _tmp2_.denominator)) {
#line 5236 "PhotoMetadata.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 629 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = metadata_rational_to_string (rational);
#line 629 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = _tmp3_;
#line 629 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = self->priv->source_name;
#line 629 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:629: Unable to set tag %s to rational %s from sourc" \
"e %s", tag, _tmp4_, _tmp5_);
#line 629 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp4_);
#line 5250 "PhotoMetadata.c"
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 634 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 634 "../src/photos/PhotoMetadata.vala"
	return _data4_;
#line 5261 "PhotoMetadata.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 634 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 5271 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 634 "../src/photos/PhotoMetadata.vala"
		self = _data4_->self;
#line 634 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 634 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block4Data, _data4_);
#line 5279 "PhotoMetadata.c"
	}
}

static void
__lambda8_ (Block4Data* _data4_,
            const gchar* tag)
{
	PhotoMetadata* self;
	MetadataRational _tmp0_;
#line 635 "../src/photos/PhotoMetadata.vala"
	self = _data4_->self;
#line 635 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 635 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _data4_->rational;
#line 635 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_rational (self, tag, &_tmp0_);
#line 5297 "PhotoMetadata.c"
}

static void
___lambda8__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 635 "../src/photos/PhotoMetadata.vala"
	__lambda8_ (self, tag);
#line 5306 "PhotoMetadata.c"
}

void
photo_metadata_set_all_rational (PhotoMetadata* self,
                                 gchar** tags,
                                 gint tags_length1,
                                 MetadataRational* rational,
                                 PhotoMetadataSetOption option)
{
	Block4Data* _data4_;
	MetadataRational _tmp0_;
#line 634 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 634 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 634 "../src/photos/PhotoMetadata.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 634 "../src/photos/PhotoMetadata.vala"
	_data4_->_ref_count_ = 1;
#line 634 "../src/photos/PhotoMetadata.vala"
	_data4_->self = media_metadata_ref (self);
#line 634 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = *rational;
#line 634 "../src/photos/PhotoMetadata.vala"
	_data4_->rational = _tmp0_;
#line 635 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda8__photo_metadata_set_generic_value, _data4_);
#line 634 "../src/photos/PhotoMetadata.vala"
	block4_data_unref (_data4_);
#line 634 "../src/photos/PhotoMetadata.vala"
	_data4_ = NULL;
#line 5338 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_date_time (PhotoMetadata* self,
                              const gchar* tag)
{
	gchar* value = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	MetadataDateTime* result = NULL;
#line 638 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 638 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 639 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string (self, tag, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 639 "../src/photos/PhotoMetadata.vala"
	value = _tmp0_;
#line 640 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = value;
#line 640 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 641 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 641 "../src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 641 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5368 "PhotoMetadata.c"
	}
	{
#line 644 "../src/photos/PhotoMetadata.vala"
		switch (photo_metadata_get_tag_domain (tag)) {
#line 644 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_XMP:
#line 5375 "PhotoMetadata.c"
			{
				MetadataDateTime* _tmp2_ = NULL;
				const gchar* _tmp3_;
				MetadataDateTime* _tmp4_;
				MetadataDateTime* _tmp5_;
#line 646 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 646 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = metadata_date_time_new_from_xmp (_tmp3_, &_inner_error0_);
#line 646 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = _tmp4_;
#line 646 "../src/photos/PhotoMetadata.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5389 "PhotoMetadata.c"
					goto __catch0_g_error;
				}
#line 646 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = _tmp2_;
#line 646 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = NULL;
#line 646 "../src/photos/PhotoMetadata.vala"
				result = _tmp5_;
#line 646 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (_tmp2_);
#line 646 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 646 "../src/photos/PhotoMetadata.vala"
				return result;
#line 5404 "PhotoMetadata.c"
			}
#line 644 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_IPTC:
#line 5408 "PhotoMetadata.c"
			{
#line 651 "../src/photos/PhotoMetadata.vala"
				result = NULL;
#line 651 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 651 "../src/photos/PhotoMetadata.vala"
				return result;
#line 5416 "PhotoMetadata.c"
			}
			default:
#line 644 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_EXIF:
#line 5421 "PhotoMetadata.c"
			{
				MetadataDateTime* _tmp6_ = NULL;
				const gchar* _tmp7_;
				MetadataDateTime* _tmp8_;
				MetadataDateTime* _tmp9_;
#line 655 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = value;
#line 655 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = metadata_date_time_new_from_exif (_tmp7_, &_inner_error0_);
#line 655 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = _tmp8_;
#line 655 "../src/photos/PhotoMetadata.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5435 "PhotoMetadata.c"
					goto __catch0_g_error;
				}
#line 655 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = _tmp6_;
#line 655 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = NULL;
#line 655 "../src/photos/PhotoMetadata.vala"
				result = _tmp9_;
#line 655 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (_tmp6_);
#line 655 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 655 "../src/photos/PhotoMetadata.vala"
				return result;
#line 5450 "PhotoMetadata.c"
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 643 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 643 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 658 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = self->priv->source_name;
#line 658 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = err;
#line 658 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = _tmp11_->message;
#line 658 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:658: Unable to read date/time %s from source %s: %s", tag, _tmp10_, _tmp12_);
#line 660 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 660 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 660 "../src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 660 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5481 "PhotoMetadata.c"
	}
	__finally0:
#line 643 "../src/photos/PhotoMetadata.vala"
	_g_free0 (value);
#line 643 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 643 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 643 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 5492 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_first_date_time (PhotoMetadata* self,
                                    gchar** tags,
                                    gint tags_length1)
{
	MetadataDateTime* result = NULL;
#line 664 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 5503 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 665 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 665 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 665 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 5515 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 665 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 665 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 5522 "PhotoMetadata.c"
			{
				MetadataDateTime* date_time = NULL;
				const gchar* _tmp1_;
				MetadataDateTime* _tmp2_;
				MetadataDateTime* _tmp3_;
#line 666 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 666 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_date_time (self, _tmp1_);
#line 666 "../src/photos/PhotoMetadata.vala"
				date_time = _tmp2_;
#line 667 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = date_time;
#line 667 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 668 "../src/photos/PhotoMetadata.vala"
					result = date_time;
#line 668 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 668 "../src/photos/PhotoMetadata.vala"
					return result;
#line 5544 "PhotoMetadata.c"
				}
#line 665 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (date_time);
#line 665 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 5550 "PhotoMetadata.c"
			}
		}
	}
#line 671 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 671 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5558 "PhotoMetadata.c"
}

void
photo_metadata_set_date_time (PhotoMetadata* self,
                              const gchar* tag,
                              MetadataDateTime* date_time)
{
#line 674 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 674 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 674 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (date_time, TYPE_METADATA_DATE_TIME));
#line 675 "../src/photos/PhotoMetadata.vala"
	switch (photo_metadata_get_tag_domain (tag)) {
#line 675 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 5576 "PhotoMetadata.c"
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
#line 677 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = metadata_date_time_get_exif_label (date_time);
#line 677 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _tmp0_;
#line 677 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 677 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp1_);
#line 678 "../src/photos/PhotoMetadata.vala"
			break;
#line 5590 "PhotoMetadata.c"
		}
#line 675 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 5594 "PhotoMetadata.c"
		{
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 681 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = metadata_date_time_get_xmp_label (date_time);
#line 681 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = _tmp2_;
#line 681 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 681 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp3_);
#line 682 "../src/photos/PhotoMetadata.vala"
			break;
#line 5608 "PhotoMetadata.c"
		}
		default:
#line 675 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 5613 "PhotoMetadata.c"
		{
			const gchar* _tmp4_;
			GEnumValue* _tmp5_;
#line 687 "../src/photos/PhotoMetadata.vala"
			_tmp4_ = self->priv->source_name;
#line 688 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_METADATA_DOMAIN), photo_metadata_get_tag_domain (tag));
#line 687 "../src/photos/PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:687: Cannot set date/time for %s from source %s: un" \
"supported metadata domain %s", tag, _tmp4_, (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 689 "../src/photos/PhotoMetadata.vala"
			break;
#line 5625 "PhotoMetadata.c"
		}
	}
}

static gpointer
_metadata_date_time_ref0 (gpointer self)
{
#line 693 "../src/photos/PhotoMetadata.vala"
	return self ? metadata_date_time_ref (self) : NULL;
#line 5635 "PhotoMetadata.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 693 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 693 "../src/photos/PhotoMetadata.vala"
	return _data5_;
#line 5645 "PhotoMetadata.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 693 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 5655 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 693 "../src/photos/PhotoMetadata.vala"
		self = _data5_->self;
#line 693 "../src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (_data5_->date_time);
#line 693 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 693 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block5Data, _data5_);
#line 5665 "PhotoMetadata.c"
	}
}

static void
__lambda9_ (Block5Data* _data5_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 694 "../src/photos/PhotoMetadata.vala"
	self = _data5_->self;
#line 694 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 694 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_date_time (self, tag, _data5_->date_time);
#line 5680 "PhotoMetadata.c"
}

static void
___lambda9__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 694 "../src/photos/PhotoMetadata.vala"
	__lambda9_ (self, tag);
#line 5689 "PhotoMetadata.c"
}

void
photo_metadata_set_all_date_time (PhotoMetadata* self,
                                  gchar** tags,
                                  gint tags_length1,
                                  MetadataDateTime* date_time,
                                  PhotoMetadataSetOption option)
{
	Block5Data* _data5_;
	MetadataDateTime* _tmp0_;
#line 693 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 693 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (date_time, TYPE_METADATA_DATE_TIME));
#line 693 "../src/photos/PhotoMetadata.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 693 "../src/photos/PhotoMetadata.vala"
	_data5_->_ref_count_ = 1;
#line 693 "../src/photos/PhotoMetadata.vala"
	_data5_->self = media_metadata_ref (self);
#line 693 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _metadata_date_time_ref0 (date_time);
#line 693 "../src/photos/PhotoMetadata.vala"
	_metadata_date_time_unref0 (_data5_->date_time);
#line 693 "../src/photos/PhotoMetadata.vala"
	_data5_->date_time = _tmp0_;
#line 694 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda9__photo_metadata_set_generic_value, _data5_);
#line 693 "../src/photos/PhotoMetadata.vala"
	block5_data_unref (_data5_);
#line 693 "../src/photos/PhotoMetadata.vala"
	_data5_ = NULL;
#line 5723 "PhotoMetadata.c"
}

gchar*
photo_metadata_exif_hash (PhotoMetadata* self)
{
	ExifData* _tmp0_;
	const gchar* _tmp1_;
	gchar* hash = NULL;
	guchar* thumb = NULL;
	ExifData* _tmp4_;
	guchar* _tmp5_;
	guint thumb_size = 0U;
	ExifData* _tmp6_;
	ExifData* _tmp7_;
	ExifData* _tmp8_;
	guchar* saved_data = NULL;
	guint saved_size = 0U;
	ExifData* _tmp9_;
	ExifData* _tmp10_;
	guchar* _tmp11_;
	ExifData* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gchar* result = NULL;
#line 698 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 699 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exif;
#line 699 "../src/photos/PhotoMetadata.vala"
	if (_tmp0_ == NULL) {
#line 700 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 700 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5757 "PhotoMetadata.c"
	}
#line 702 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->metadata_hash;
#line 702 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ != NULL) {
#line 5763 "PhotoMetadata.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 703 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = self->priv->metadata_hash;
#line 703 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 703 "../src/photos/PhotoMetadata.vala"
		result = _tmp3_;
#line 703 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5774 "PhotoMetadata.c"
	}
#line 706 "../src/photos/PhotoMetadata.vala"
	hash = NULL;
#line 708 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = self->priv->exif;
#line 708 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_->data;
#line 708 "../src/photos/PhotoMetadata.vala"
	thumb = _tmp5_;
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = self->priv->exif;
#line 709 "../src/photos/PhotoMetadata.vala"
	thumb_size = _tmp6_->size;
#line 712 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = self->priv->exif;
#line 712 "../src/photos/PhotoMetadata.vala"
	_tmp7_->data = NULL;
#line 713 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = self->priv->exif;
#line 713 "../src/photos/PhotoMetadata.vala"
	_tmp8_->size = (guint) 0;
#line 715 "../src/photos/PhotoMetadata.vala"
	saved_data = NULL;
#line 716 "../src/photos/PhotoMetadata.vala"
	saved_size = (guint) 0;
#line 718 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = self->priv->exif;
#line 718 "../src/photos/PhotoMetadata.vala"
	exif_data_save_data (_tmp9_, &saved_data, &saved_size);
#line 720 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = self->priv->exif;
#line 720 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = thumb;
#line 720 "../src/photos/PhotoMetadata.vala"
	_tmp10_->data = _tmp11_;
#line 721 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = self->priv->exif;
#line 721 "../src/photos/PhotoMetadata.vala"
	_tmp12_->size = thumb_size;
#line 723 "../src/photos/PhotoMetadata.vala"
	if (saved_size > ((guint) 0)) {
#line 5816 "PhotoMetadata.c"
		guchar* _tmp14_;
#line 723 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = saved_data;
#line 723 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = _tmp14_ != NULL;
#line 5822 "PhotoMetadata.c"
	} else {
#line 723 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = FALSE;
#line 5826 "PhotoMetadata.c"
	}
#line 723 "../src/photos/PhotoMetadata.vala"
	if (_tmp13_) {
#line 5830 "PhotoMetadata.c"
		GChecksum* md5 = NULL;
		GChecksum* _tmp15_;
		GChecksum* _tmp16_;
		guchar* _tmp17_;
		ExifMem* _tmp18_;
		ExifMem* _tmp19_;
		guchar* _tmp20_;
		GChecksum* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
#line 724 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = g_checksum_new (G_CHECKSUM_MD5);
#line 724 "../src/photos/PhotoMetadata.vala"
		md5 = _tmp15_;
#line 725 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = md5;
#line 725 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = saved_data;
#line 725 "../src/photos/PhotoMetadata.vala"
		g_checksum_update (_tmp16_, (guchar*) _tmp17_, (gsize) saved_size);
#line 726 "../src/photos/PhotoMetadata.vala"
		_tmp18_ = exif_mem_new_default ();
#line 726 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = _tmp18_;
#line 726 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = saved_data;
#line 726 "../src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp19_, _tmp20_);
#line 726 "../src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp19_);
#line 728 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = md5;
#line 728 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = g_checksum_get_string (_tmp21_);
#line 728 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = g_strdup (_tmp22_);
#line 728 "../src/photos/PhotoMetadata.vala"
		_g_free0 (self->priv->metadata_hash);
#line 728 "../src/photos/PhotoMetadata.vala"
		self->priv->metadata_hash = _tmp23_;
#line 723 "../src/photos/PhotoMetadata.vala"
		_g_checksum_free0 (md5);
#line 5873 "PhotoMetadata.c"
	}
#line 731 "../src/photos/PhotoMetadata.vala"
	result = hash;
#line 731 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5879 "PhotoMetadata.c"
}

gchar*
photo_metadata_thumbnail_hash (PhotoMetadata* self)
{
	const gchar* _tmp0_;
	guchar* buffer = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	GExiv2Metadata* _tmp3_;
	guint8* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gboolean _tmp6_;
	gchar* result = NULL;
#line 735 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 736 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->thumbnail_md5;
#line 736 "../src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5900 "PhotoMetadata.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 737 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->thumbnail_md5;
#line 737 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 737 "../src/photos/PhotoMetadata.vala"
		result = _tmp2_;
#line 737 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5911 "PhotoMetadata.c"
	}
#line 741 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = self->priv->exiv2;
#line 741 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = gexiv2_metadata_get_exif_thumbnail (_tmp3_, &_tmp4_, &_tmp5_);
#line 741 "../src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 741 "../src/photos/PhotoMetadata.vala"
	buffer = _tmp4_;
#line 741 "../src/photos/PhotoMetadata.vala"
	buffer_length1 = _tmp5_;
#line 741 "../src/photos/PhotoMetadata.vala"
	_buffer_size_ = buffer_length1;
#line 741 "../src/photos/PhotoMetadata.vala"
	if (_tmp6_) {
#line 5927 "PhotoMetadata.c"
		GChecksum* md5 = NULL;
		GChecksum* _tmp7_;
		GChecksum* _tmp8_;
		guchar* _tmp9_;
		gint _tmp9__length1;
		guchar* _tmp10_;
		gint _tmp10__length1;
		GChecksum* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 742 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = g_checksum_new (G_CHECKSUM_MD5);
#line 742 "../src/photos/PhotoMetadata.vala"
		md5 = _tmp7_;
#line 743 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = md5;
#line 743 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = buffer;
#line 743 "../src/photos/PhotoMetadata.vala"
		_tmp9__length1 = buffer_length1;
#line 743 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = buffer;
#line 743 "../src/photos/PhotoMetadata.vala"
		_tmp10__length1 = buffer_length1;
#line 743 "../src/photos/PhotoMetadata.vala"
		g_checksum_update (_tmp8_, _tmp9_, (gsize) _tmp10__length1);
#line 745 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = md5;
#line 745 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = g_checksum_get_string (_tmp11_);
#line 745 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 745 "../src/photos/PhotoMetadata.vala"
		_g_free0 (self->priv->thumbnail_md5);
#line 745 "../src/photos/PhotoMetadata.vala"
		self->priv->thumbnail_md5 = _tmp13_;
#line 747 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = self->priv->thumbnail_md5;
#line 747 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 747 "../src/photos/PhotoMetadata.vala"
		result = _tmp15_;
#line 747 "../src/photos/PhotoMetadata.vala"
		_g_checksum_free0 (md5);
#line 747 "../src/photos/PhotoMetadata.vala"
		buffer = (g_free (buffer), NULL);
#line 747 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5978 "PhotoMetadata.c"
	}
#line 750 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 750 "../src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 750 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5986 "PhotoMetadata.c"
}

guint
photo_metadata_get_preview_count (PhotoMetadata* self)
{
	GExiv2PreviewProperties** props = NULL;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	gint props_length1;
	gint _props_size_;
	gint _tmp3_ = 0;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
	guint result = 0U;
#line 753 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0U);
#line 754 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 754 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 754 "../src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 754 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 754 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 756 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 756 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 756 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 6020 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
#line 756 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 756 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 756 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5__length1;
#line 6029 "PhotoMetadata.c"
	} else {
#line 756 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = 0;
#line 6033 "PhotoMetadata.c"
	}
#line 756 "../src/photos/PhotoMetadata.vala"
	result = (guint) _tmp3_;
#line 756 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6039 "PhotoMetadata.c"
}

PhotoPreview*
photo_metadata_get_preview (PhotoMetadata* self,
                            guint number)
{
	GExiv2PreviewProperties** props = NULL;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp3_ = FALSE;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp6_;
	GExiv2PreviewProperties** _tmp7_;
	gint _tmp7__length1;
	GExiv2PreviewProperties* _tmp8_;
	PhotoMetadataInternalPhotoPreview* _tmp9_;
	PhotoPreview* result = NULL;
#line 760 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 761 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 761 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 761 "../src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 761 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 761 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 762 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 762 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 6081 "PhotoMetadata.c"
	} else {
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
#line 762 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 762 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 762 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = ((guint) _tmp5__length1) <= number;
#line 6091 "PhotoMetadata.c"
	}
#line 762 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 763 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 763 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6099 "PhotoMetadata.c"
	}
#line 765 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = self->priv->source_name;
#line 765 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = props;
#line 765 "../src/photos/PhotoMetadata.vala"
	_tmp7__length1 = props_length1;
#line 765 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp7_[number];
#line 765 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = photo_metadata_internal_photo_preview_new (self, _tmp6_, number, _tmp8_);
#line 765 "../src/photos/PhotoMetadata.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_PHOTO_PREVIEW, PhotoPreview);
#line 765 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6115 "PhotoMetadata.c"
}

void
photo_metadata_remove_exif_thumbnail (PhotoMetadata* self)
{
	GExiv2Metadata* _tmp0_;
	ExifData* _tmp1_;
#line 768 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 769 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 769 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_erase_exif_thumbnail (_tmp0_);
#line 770 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exif;
#line 770 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ != NULL) {
#line 6133 "PhotoMetadata.c"
		ExifMem* _tmp2_;
		ExifMem* _tmp3_;
		ExifData* _tmp4_;
		guchar* _tmp5_;
		ExifData* _tmp6_;
		ExifData* _tmp7_;
#line 771 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = exif_mem_new_default ();
#line 771 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_;
#line 771 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = self->priv->exif;
#line 771 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_->data;
#line 771 "../src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp3_, _tmp5_);
#line 771 "../src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp3_);
#line 772 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->exif;
#line 772 "../src/photos/PhotoMetadata.vala"
		_tmp6_->data = NULL;
#line 773 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->exif;
#line 773 "../src/photos/PhotoMetadata.vala"
		_tmp7_->size = (guint) 0;
#line 6160 "PhotoMetadata.c"
	}
}

void
photo_metadata_remove_tag (PhotoMetadata* self,
                           const gchar* tag)
{
	GExiv2Metadata* _tmp0_;
#line 777 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 777 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 778 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 778 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear_tag (_tmp0_, tag);
#line 6177 "PhotoMetadata.c"
}

void
photo_metadata_remove_tags (PhotoMetadata* self,
                            gchar** tags,
                            gint tags_length1)
{
#line 781 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 6187 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 782 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 782 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 782 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 6199 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 782 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 782 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 6206 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
#line 783 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 783 "../src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp1_);
#line 782 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 6215 "PhotoMetadata.c"
			}
		}
	}
}

void
photo_metadata_clear_domain (PhotoMetadata* self,
                             MetadataDomain domain)
{
#line 786 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 787 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 787 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 6231 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 789 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 789 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_exif (_tmp0_);
#line 790 "../src/photos/PhotoMetadata.vala"
			break;
#line 6240 "PhotoMetadata.c"
		}
#line 787 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 6244 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 793 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 793 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_xmp (_tmp1_);
#line 794 "../src/photos/PhotoMetadata.vala"
			break;
#line 6253 "PhotoMetadata.c"
		}
#line 787 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 6257 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 797 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 797 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_iptc (_tmp2_);
#line 798 "../src/photos/PhotoMetadata.vala"
			break;
#line 6266 "PhotoMetadata.c"
		}
		default:
		{
#line 801 "../src/photos/PhotoMetadata.vala"
			break;
#line 6272 "PhotoMetadata.c"
		}
	}
}

void
photo_metadata_clear (PhotoMetadata* self)
{
	GExiv2Metadata* _tmp0_;
#line 805 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 806 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 806 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear (_tmp0_);
#line 6287 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_modification_date_time (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result = NULL;
#line 816 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 817 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DATE_TIME_TAGS;
#line 817 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 817 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 817 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 817 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6309 "PhotoMetadata.c"
}

void
photo_metadata_set_modification_date_time (PhotoMetadata* self,
                                           MetadataDateTime* date_time,
                                           PhotoMetadataSetOption option)
{
#line 820 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 820 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (date_time, TYPE_METADATA_DATE_TIME));
#line 822 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 6323 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 823 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_DATE_TIME_TAGS;
#line 823 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 823 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 6332 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 825 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DATE_TIME_TAGS;
#line 825 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 825 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 6342 "PhotoMetadata.c"
	}
}

MetadataDateTime*
photo_metadata_get_exposure_date_time (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result = NULL;
#line 837 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 838 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 838 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 838 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 838 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 838 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6365 "PhotoMetadata.c"
}

void
photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                       MetadataDateTime* date_time,
                                       PhotoMetadataSetOption option)
{
#line 841 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 841 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (date_time, TYPE_METADATA_DATE_TIME));
#line 843 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 6379 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 844 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 844 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 844 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 6388 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 846 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 846 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 846 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 6398 "PhotoMetadata.c"
	}
}

MetadataDateTime*
photo_metadata_get_digitized_date_time (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result = NULL;
#line 854 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 855 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 855 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 855 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 855 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 855 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6421 "PhotoMetadata.c"
}

void
photo_metadata_set_digitized_date_time (PhotoMetadata* self,
                                        MetadataDateTime* date_time,
                                        PhotoMetadataSetOption option)
{
#line 858 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 858 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (date_time, TYPE_METADATA_DATE_TIME));
#line 860 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 6435 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 861 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 861 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 861 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 6444 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 863 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 863 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 863 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 6454 "PhotoMetadata.c"
	}
}

static MetadataDateTime*
photo_metadata_real_get_creation_date_time (MediaMetadata* base)
{
	PhotoMetadata * self;
	MetadataDateTime* creation = NULL;
	MetadataDateTime* _tmp0_;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result = NULL;
#line 866 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 867 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_exposure_date_time (self);
#line 867 "../src/photos/PhotoMetadata.vala"
	creation = _tmp0_;
#line 868 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = creation;
#line 868 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 6476 "PhotoMetadata.c"
		MetadataDateTime* _tmp2_;
#line 869 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_get_digitized_date_time (self);
#line 869 "../src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (creation);
#line 869 "../src/photos/PhotoMetadata.vala"
		creation = _tmp2_;
#line 6484 "PhotoMetadata.c"
	}
#line 871 "../src/photos/PhotoMetadata.vala"
	result = creation;
#line 871 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6490 "PhotoMetadata.c"
}

static gpointer
_dimensions_dup0 (gpointer self)
{
#line 902 "../src/photos/PhotoMetadata.vala"
	return self ? dimensions_dup (self) : NULL;
#line 6498 "PhotoMetadata.c"
}

Dimensions*
photo_metadata_get_pixel_dimensions (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	Dimensions* result = NULL;
#line 888 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 890 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_WIDTH_TAGS;
#line 890 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 890 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_HEIGHT_TAGS;
#line 890 "../src/photos/PhotoMetadata.vala"
	_tmp1__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 890 "../src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp0__length1 == _tmp1__length1, "WIDTH_TAGS.length == HEIGHT_TAGS.length");
#line 6521 "PhotoMetadata.c"
	{
		gint ctr = 0;
#line 891 "../src/photos/PhotoMetadata.vala"
		ctr = 0;
#line 6526 "PhotoMetadata.c"
		{
			gboolean _tmp2_ = FALSE;
#line 891 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = TRUE;
#line 891 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 6533 "PhotoMetadata.c"
				gchar** _tmp4_;
				gint _tmp4__length1;
				glong width = 0L;
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp6_;
				glong _tmp7_ = 0L;
				gboolean _tmp8_;
				glong height = 0L;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
				glong _tmp11_ = 0L;
				gboolean _tmp12_;
				Dimensions _tmp13_ = {0};
				Dimensions* _tmp14_;
#line 891 "../src/photos/PhotoMetadata.vala"
				if (!_tmp2_) {
#line 6552 "PhotoMetadata.c"
					gint _tmp3_;
#line 891 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = ctr;
#line 891 "../src/photos/PhotoMetadata.vala"
					ctr = _tmp3_ + 1;
#line 6558 "PhotoMetadata.c"
				}
#line 891 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = FALSE;
#line 891 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_WIDTH_TAGS;
#line 891 "../src/photos/PhotoMetadata.vala"
				_tmp4__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 891 "../src/photos/PhotoMetadata.vala"
				if (!(ctr < _tmp4__length1)) {
#line 891 "../src/photos/PhotoMetadata.vala"
					break;
#line 6570 "PhotoMetadata.c"
				}
#line 895 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = photo_metadata_WIDTH_TAGS;
#line 895 "../src/photos/PhotoMetadata.vala"
				_tmp5__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 895 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = _tmp5_[ctr];
#line 895 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = photo_metadata_get_long (self, _tmp6_, &_tmp7_);
#line 895 "../src/photos/PhotoMetadata.vala"
				width = _tmp7_;
#line 895 "../src/photos/PhotoMetadata.vala"
				if (!_tmp8_) {
#line 896 "../src/photos/PhotoMetadata.vala"
					continue;
#line 6586 "PhotoMetadata.c"
				}
#line 899 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = photo_metadata_HEIGHT_TAGS;
#line 899 "../src/photos/PhotoMetadata.vala"
				_tmp9__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 899 "../src/photos/PhotoMetadata.vala"
				_tmp10_ = _tmp9_[ctr];
#line 899 "../src/photos/PhotoMetadata.vala"
				_tmp12_ = photo_metadata_get_long (self, _tmp10_, &_tmp11_);
#line 899 "../src/photos/PhotoMetadata.vala"
				height = _tmp11_;
#line 899 "../src/photos/PhotoMetadata.vala"
				if (!_tmp12_) {
#line 900 "../src/photos/PhotoMetadata.vala"
					continue;
#line 6602 "PhotoMetadata.c"
				}
#line 902 "../src/photos/PhotoMetadata.vala"
				dimensions_init (&_tmp13_, (gint) width, (gint) height);
#line 902 "../src/photos/PhotoMetadata.vala"
				_tmp14_ = _dimensions_dup0 (&_tmp13_);
#line 902 "../src/photos/PhotoMetadata.vala"
				result = _tmp14_;
#line 902 "../src/photos/PhotoMetadata.vala"
				return result;
#line 6612 "PhotoMetadata.c"
			}
		}
	}
#line 905 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 905 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6620 "PhotoMetadata.c"
}

void
photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                     Dimensions* dim,
                                     PhotoMetadataSetOption option)
{
#line 908 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 909 "../src/photos/PhotoMetadata.vala"
	if (dim != NULL) {
#line 6632 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 910 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_WIDTH_TAGS;
#line 910 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 910 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp0_, (gint) _tmp0__length1, (glong) (*dim).width, option);
#line 911 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_HEIGHT_TAGS;
#line 911 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 911 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp1_, (gint) _tmp1__length1, (glong) (*dim).height, option);
#line 6649 "PhotoMetadata.c"
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 913 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_WIDTH_TAGS;
#line 913 "../src/photos/PhotoMetadata.vala"
		_tmp2__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 913 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp2_, (gint) _tmp2__length1);
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = photo_metadata_HEIGHT_TAGS;
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp3__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 914 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp3_, (gint) _tmp3__length1);
#line 6667 "PhotoMetadata.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 6689 "PhotoMetadata.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 6708 "PhotoMetadata.c"
}

static gchar*
photo_metadata_real_get_title (MediaMetadata* base)
{
	PhotoMetadata * self;
	GeeList* _tmp0_ = NULL;
	GeeList* titles = NULL;
	GeeList* _tmp4_;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GeeList* _tmp7_;
	gchar* title = NULL;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	const gchar* _tmp20_;
	gchar* _tmp24_;
	gchar* result = NULL;
#line 948 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 956 "../src/photos/PhotoMetadata.vala"
	if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 6734 "PhotoMetadata.c"
		GeeList* _tmp1_;
#line 957 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_get_string_multiple (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 957 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 957 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp1_;
#line 6742 "PhotoMetadata.c"
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
		GeeList* _tmp3_;
#line 958 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 958 "../src/photos/PhotoMetadata.vala"
		_tmp2__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 958 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = photo_metadata_get_first_string_multiple (self, _tmp2_, (gint) _tmp2__length1);
#line 958 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 958 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp3_;
#line 6757 "PhotoMetadata.c"
	}
#line 956 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = _g_object_ref0 (_tmp0_);
#line 956 "../src/photos/PhotoMetadata.vala"
	titles = _tmp4_;
#line 963 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = titles;
#line 963 "../src/photos/PhotoMetadata.vala"
	if (_tmp7_ != NULL) {
#line 6767 "PhotoMetadata.c"
		GeeList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = titles;
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp9_;
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp10_ > 0;
#line 6779 "PhotoMetadata.c"
	} else {
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = FALSE;
#line 6783 "PhotoMetadata.c"
	}
#line 963 "../src/photos/PhotoMetadata.vala"
	if (_tmp6_) {
#line 6787 "PhotoMetadata.c"
		GeeList* _tmp11_;
		gpointer _tmp12_;
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = titles;
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = gee_list_get (_tmp11_, 0);
#line 963 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp5_);
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = (gchar*) _tmp12_;
#line 6798 "PhotoMetadata.c"
	} else {
#line 963 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp5_);
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = NULL;
#line 6804 "PhotoMetadata.c"
	}
#line 963 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = g_strdup (_tmp5_);
#line 963 "../src/photos/PhotoMetadata.vala"
	title = _tmp13_;
#line 966 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = title;
#line 966 "../src/photos/PhotoMetadata.vala"
	if (_tmp14_ != NULL) {
#line 6814 "PhotoMetadata.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 967 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = title;
#line 967 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = string_strip (_tmp15_);
#line 967 "../src/photos/PhotoMetadata.vala"
		_g_free0 (title);
#line 967 "../src/photos/PhotoMetadata.vala"
		title = _tmp16_;
#line 6825 "PhotoMetadata.c"
	}
#line 970 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = title;
#line 970 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (_tmp20_)) {
#line 6831 "PhotoMetadata.c"
		const gchar* _tmp21_;
#line 970 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = title;
#line 970 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = !string_contains (_tmp21_, "\n");
#line 6837 "PhotoMetadata.c"
	} else {
#line 970 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = FALSE;
#line 6841 "PhotoMetadata.c"
	}
#line 970 "../src/photos/PhotoMetadata.vala"
	if (_tmp19_) {
#line 6845 "PhotoMetadata.c"
		const gchar* _tmp22_;
#line 970 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = title;
#line 970 "../src/photos/PhotoMetadata.vala"
		_tmp18_ = !string_contains (_tmp22_, "\r");
#line 6851 "PhotoMetadata.c"
	} else {
#line 970 "../src/photos/PhotoMetadata.vala"
		_tmp18_ = FALSE;
#line 6855 "PhotoMetadata.c"
	}
#line 970 "../src/photos/PhotoMetadata.vala"
	if (_tmp18_) {
#line 6859 "PhotoMetadata.c"
		const gchar* _tmp23_;
#line 971 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = title;
#line 971 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = _tmp23_;
#line 6865 "PhotoMetadata.c"
	} else {
#line 971 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = NULL;
#line 6869 "PhotoMetadata.c"
	}
#line 970 "../src/photos/PhotoMetadata.vala"
	_tmp24_ = g_strdup (_tmp17_);
#line 970 "../src/photos/PhotoMetadata.vala"
	result = _tmp24_;
#line 970 "../src/photos/PhotoMetadata.vala"
	_g_free0 (title);
#line 970 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp5_);
#line 970 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (titles);
#line 970 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_tmp0_);
#line 970 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6885 "PhotoMetadata.c"
}

void
photo_metadata_set_title (PhotoMetadata* self,
                          const gchar* title,
                          PhotoMetadataSetOption option)
{
#line 974 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 975 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (title)) {
#line 976 "../src/photos/PhotoMetadata.vala"
		if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 977 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_TITLE_TAG, title, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 6901 "PhotoMetadata.c"
		} else {
			gchar** _tmp0_;
			gint _tmp0__length1;
#line 979 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 979 "../src/photos/PhotoMetadata.vala"
			_tmp0__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 979 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_all_string (self, _tmp0_, (gint) _tmp0__length1, title, option);
#line 6911 "PhotoMetadata.c"
		}
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 981 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 981 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 981 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 6922 "PhotoMetadata.c"
	}
}

static gchar*
photo_metadata_real_get_comment (MediaMetadata* base)
{
	PhotoMetadata * self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 990 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_COMMENT_TAGS;
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_COMMENT_TAGS_length1;
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string_interpreted (self, _tmp0_, (gint) _tmp0__length1);
#line 991 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 991 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6946 "PhotoMetadata.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 994 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 994 "../src/photos/PhotoMetadata.vala"
	return _data6_;
#line 6956 "PhotoMetadata.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 994 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 6966 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 994 "../src/photos/PhotoMetadata.vala"
		self = _data6_->self;
#line 994 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_data6_->comment);
#line 994 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 994 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block6Data, _data6_);
#line 6976 "PhotoMetadata.c"
	}
}

static void
___lambda10_ (Block6Data* _data6_,
              const gchar* tag)
{
	PhotoMetadata* self;
#line 999 "../src/photos/PhotoMetadata.vala"
	self = _data6_->self;
#line 999 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 1001 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, tag, _data6_->comment, PHOTO_METADATA_PREPARE_STRING_OPTIONS & (~PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF), 4095);
#line 6991 "PhotoMetadata.c"
}

static void
____lambda10__photo_metadata_set_generic_value (const gchar* tag,
                                                gpointer self)
{
#line 999 "../src/photos/PhotoMetadata.vala"
	___lambda10_ (self, tag);
#line 7000 "PhotoMetadata.c"
}

void
photo_metadata_set_comment (PhotoMetadata* self,
                            const gchar* comment,
                            PhotoMetadataSetOption option)
{
	Block6Data* _data6_;
	gchar* _tmp0_;
#line 994 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 994 "../src/photos/PhotoMetadata.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 994 "../src/photos/PhotoMetadata.vala"
	_data6_->_ref_count_ = 1;
#line 994 "../src/photos/PhotoMetadata.vala"
	_data6_->self = media_metadata_ref (self);
#line 994 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (comment);
#line 994 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_data6_->comment);
#line 994 "../src/photos/PhotoMetadata.vala"
	_data6_->comment = _tmp0_;
#line 998 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (_data6_->comment)) {
#line 7026 "PhotoMetadata.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 999 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_COMMENT_TAGS;
#line 999 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_COMMENT_TAGS_length1;
#line 999 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_generic (self, _tmp1_, (gint) _tmp1__length1, option, ____lambda10__photo_metadata_set_generic_value, _data6_);
#line 7035 "PhotoMetadata.c"
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
#line 1005 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_COMMENT_TAGS;
#line 1005 "../src/photos/PhotoMetadata.vala"
		_tmp2__length1 = photo_metadata_COMMENT_TAGS_length1;
#line 1005 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp2_, (gint) _tmp2__length1);
#line 7045 "PhotoMetadata.c"
	}
#line 994 "../src/photos/PhotoMetadata.vala"
	block6_data_unref (_data6_);
#line 994 "../src/photos/PhotoMetadata.vala"
	_data6_ = NULL;
#line 7051 "PhotoMetadata.c"
}

GeeSet*
photo_metadata_get_keywords (PhotoMetadata* self,
                             GCompareDataFunc compare_func,
                             gpointer compare_func_target,
                             GDestroyNotify compare_func_target_destroy_notify)
{
	GeeSet* keywords = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GeeSet* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
	GeeSet* _tmp23_;
	GeeSet* _tmp28_;
	GeeSet* result = NULL;
#line 1025 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1026 "../src/photos/PhotoMetadata.vala"
	keywords = NULL;
#line 1027 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_KEYWORD_TAGS;
#line 1027 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 7076 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 1027 "../src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 1027 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 1027 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 7088 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 1027 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 1027 "../src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 7095 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				const gchar* _tmp2_;
				GeeList* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeCollection* _tmp5_;
#line 1028 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 1028 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_multiple (self, _tmp2_);
#line 1028 "../src/photos/PhotoMetadata.vala"
				values = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1029 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = values;
#line 1029 "../src/photos/PhotoMetadata.vala"
				if (_tmp5_ != NULL) {
#line 7112 "PhotoMetadata.c"
					GeeCollection* _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
#line 1029 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = values;
#line 1029 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = gee_collection_get_size (_tmp6_);
#line 1029 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = _tmp7_;
#line 1029 "../src/photos/PhotoMetadata.vala"
					_tmp4_ = _tmp8_ > 0;
#line 7124 "PhotoMetadata.c"
				} else {
#line 1029 "../src/photos/PhotoMetadata.vala"
					_tmp4_ = FALSE;
#line 7128 "PhotoMetadata.c"
				}
#line 1029 "../src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 7132 "PhotoMetadata.c"
					GeeSet* _tmp9_;
#line 1030 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = keywords;
#line 1030 "../src/photos/PhotoMetadata.vala"
					if (_tmp9_ == NULL) {
#line 7138 "PhotoMetadata.c"
						GCompareDataFunc _tmp10_;
						gpointer _tmp10__target;
						GDestroyNotify _tmp10__target_destroy_notify;
						GeeSet* _tmp11_;
#line 1031 "../src/photos/PhotoMetadata.vala"
						_tmp10_ = compare_func;
#line 1031 "../src/photos/PhotoMetadata.vala"
						_tmp10__target = compare_func_target;
#line 1031 "../src/photos/PhotoMetadata.vala"
						_tmp10__target_destroy_notify = compare_func_target_destroy_notify;
#line 1031 "../src/photos/PhotoMetadata.vala"
						compare_func = NULL;
#line 1031 "../src/photos/PhotoMetadata.vala"
						compare_func_target = NULL;
#line 1031 "../src/photos/PhotoMetadata.vala"
						compare_func_target_destroy_notify = NULL;
#line 1031 "../src/photos/PhotoMetadata.vala"
						_tmp11_ = photo_metadata_create_string_set (self, _tmp10_, _tmp10__target, _tmp10__target_destroy_notify);
#line 1031 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (keywords);
#line 1031 "../src/photos/PhotoMetadata.vala"
						keywords = _tmp11_;
#line 7161 "PhotoMetadata.c"
					}
					{
						GeeIterator* _current_value_it = NULL;
						GeeCollection* _tmp12_;
						GeeIterator* _tmp13_;
#line 1033 "../src/photos/PhotoMetadata.vala"
						_tmp12_ = values;
#line 1033 "../src/photos/PhotoMetadata.vala"
						_tmp13_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1033 "../src/photos/PhotoMetadata.vala"
						_current_value_it = _tmp13_;
#line 1033 "../src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 7175 "PhotoMetadata.c"
							GeeIterator* _tmp14_;
							gchar* current_value = NULL;
							GeeIterator* _tmp15_;
							gpointer _tmp16_;
							GeeSet* _tmp17_;
							const gchar* _tmp18_;
							gchar* _tmp19_;
							gchar* _tmp20_;
#line 1033 "../src/photos/PhotoMetadata.vala"
							_tmp14_ = _current_value_it;
#line 1033 "../src/photos/PhotoMetadata.vala"
							if (!gee_iterator_next (_tmp14_)) {
#line 1033 "../src/photos/PhotoMetadata.vala"
								break;
#line 7190 "PhotoMetadata.c"
							}
#line 1033 "../src/photos/PhotoMetadata.vala"
							_tmp15_ = _current_value_it;
#line 1033 "../src/photos/PhotoMetadata.vala"
							_tmp16_ = gee_iterator_get (_tmp15_);
#line 1033 "../src/photos/PhotoMetadata.vala"
							current_value = (gchar*) _tmp16_;
#line 1034 "../src/photos/PhotoMetadata.vala"
							_tmp17_ = keywords;
#line 1034 "../src/photos/PhotoMetadata.vala"
							_tmp18_ = current_value;
#line 1034 "../src/photos/PhotoMetadata.vala"
							_tmp19_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp18_);
#line 1034 "../src/photos/PhotoMetadata.vala"
							_tmp20_ = _tmp19_;
#line 1034 "../src/photos/PhotoMetadata.vala"
							gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection), _tmp20_);
#line 1034 "../src/photos/PhotoMetadata.vala"
							_g_free0 (_tmp20_);
#line 1033 "../src/photos/PhotoMetadata.vala"
							_g_free0 (current_value);
#line 7212 "PhotoMetadata.c"
						}
#line 1033 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_current_value_it);
#line 7216 "PhotoMetadata.c"
					}
				}
#line 1027 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 1027 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 7223 "PhotoMetadata.c"
			}
		}
	}
#line 1038 "../src/photos/PhotoMetadata.vala"
	_tmp23_ = keywords;
#line 1038 "../src/photos/PhotoMetadata.vala"
	if (_tmp23_ != NULL) {
#line 7231 "PhotoMetadata.c"
		GeeSet* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 1038 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = keywords;
#line 1038 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1038 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = _tmp25_;
#line 1038 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp26_ > 0;
#line 7243 "PhotoMetadata.c"
	} else {
#line 1038 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = FALSE;
#line 7247 "PhotoMetadata.c"
	}
#line 1038 "../src/photos/PhotoMetadata.vala"
	if (_tmp22_) {
#line 7251 "PhotoMetadata.c"
		GeeSet* _tmp27_;
#line 1038 "../src/photos/PhotoMetadata.vala"
		_tmp27_ = keywords;
#line 1038 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = _tmp27_;
#line 7257 "PhotoMetadata.c"
	} else {
#line 1038 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = NULL;
#line 7261 "PhotoMetadata.c"
	}
#line 1038 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = _g_object_ref0 (_tmp21_);
#line 1038 "../src/photos/PhotoMetadata.vala"
	result = _tmp28_;
#line 1038 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (keywords);
#line 1038 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 1038 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 1038 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 1038 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 1038 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7279 "PhotoMetadata.c"
}

static gpointer
_hierarchical_keyword_field_ref0 (gpointer self)
{
#line 1042 "../src/photos/PhotoMetadata.vala"
	return self ? hierarchical_keyword_field_ref (self) : NULL;
#line 7287 "PhotoMetadata.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 7309 "PhotoMetadata.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 7313 "PhotoMetadata.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 7319 "PhotoMetadata.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 7323 "PhotoMetadata.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 7327 "PhotoMetadata.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 7335 "PhotoMetadata.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 7363 "PhotoMetadata.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 7372 "PhotoMetadata.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 7386 "PhotoMetadata.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 7395 "PhotoMetadata.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 7409 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 7418 "PhotoMetadata.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 7427 "PhotoMetadata.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
#line 1447 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1447 "glib-2.0.vapi"
	end = _tmp0_;
#line 1448 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1448 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1449 "glib-2.0.vapi"
		result = maxlen;
#line 1449 "glib-2.0.vapi"
		return result;
#line 7450 "PhotoMetadata.c"
	} else {
		gchar* _tmp2_;
#line 1451 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1451 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1451 "glib-2.0.vapi"
		return result;
#line 7459 "PhotoMetadata.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1460 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 7478 "PhotoMetadata.c"
	} else {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 7482 "PhotoMetadata.c"
	}
#line 1460 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1462 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 7488 "PhotoMetadata.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1464 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1464 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1464 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 7498 "PhotoMetadata.c"
	}
#line 1467 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1469 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 7506 "PhotoMetadata.c"
	} else {
#line 1471 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 7510 "PhotoMetadata.c"
	}
#line 1473 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1474 "glib-2.0.vapi"
		len = string_length - offset;
#line 7516 "PhotoMetadata.c"
	}
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1477 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1477 "glib-2.0.vapi"
	result = _tmp3_;
#line 1477 "glib-2.0.vapi"
	return result;
#line 7526 "PhotoMetadata.c"
}

static void
photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self,
                                                   HierarchicalTagIndex* index)
{
	HierarchicalKeywordField** _tmp0_;
	gint _tmp0__length1;
	HierarchicalKeywordField** _tmp4_;
	gint _tmp4__length1;
#line 1041 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1041 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail ((index == NULL) || IS_HIERARCHICAL_TAG_INDEX (index));
#line 1042 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 1042 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 7545 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 1042 "../src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp0_;
#line 1042 "../src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp0__length1;
#line 1042 "../src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < current_field_collection_length1; current_field_it = current_field_it + 1) {
#line 7557 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_;
			HierarchicalKeywordField* current_field = NULL;
#line 1042 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 1042 "../src/photos/PhotoMetadata.vala"
			current_field = _tmp1_;
#line 7564 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp2_;
				const gchar* _tmp3_;
#line 1043 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = current_field;
#line 1043 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 1043 "../src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp3_);
#line 1042 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 7576 "PhotoMetadata.c"
			}
		}
	}
#line 1045 "../src/photos/PhotoMetadata.vala"
	if (index == NULL) {
#line 1046 "../src/photos/PhotoMetadata.vala"
		return;
#line 7584 "PhotoMetadata.c"
	}
#line 1048 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 1048 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 7590 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 1048 "../src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp4_;
#line 1048 "../src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp4__length1;
#line 1048 "../src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < current_field_collection_length1; current_field_it = current_field_it + 1) {
#line 7602 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp5_;
			HierarchicalKeywordField* current_field = NULL;
#line 1048 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 1048 "../src/photos/PhotoMetadata.vala"
			current_field = _tmp5_;
#line 7609 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp6_;
				GeeSet* writeable_set = NULL;
				GeeTreeSet* _tmp7_;
				HierarchicalKeywordField* _tmp24_;
				const gchar* _tmp25_;
				GeeSet* _tmp26_;
#line 1049 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = current_field;
#line 1049 "../src/photos/PhotoMetadata.vala"
				if (!_tmp6_->is_writeable) {
#line 1050 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (current_field);
#line 1050 "../src/photos/PhotoMetadata.vala"
					continue;
#line 7625 "PhotoMetadata.c"
				}
#line 1052 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 1052 "../src/photos/PhotoMetadata.vala"
				writeable_set = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_SET, GeeSet);
#line 7631 "PhotoMetadata.c"
				{
					GeeIterator* _current_path_it = NULL;
					GeeCollection* _tmp8_;
					GeeCollection* _tmp9_;
					GeeIterator* _tmp10_;
					GeeIterator* _tmp11_;
#line 1054 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = hierarchical_tag_index_get_all_paths (index);
#line 1054 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = _tmp8_;
#line 1054 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1054 "../src/photos/PhotoMetadata.vala"
					_tmp11_ = _tmp10_;
#line 1054 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_tmp9_);
#line 1054 "../src/photos/PhotoMetadata.vala"
					_current_path_it = _tmp11_;
#line 1054 "../src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 7652 "PhotoMetadata.c"
						GeeIterator* _tmp12_;
						gchar* current_path = NULL;
						GeeIterator* _tmp13_;
						gpointer _tmp14_;
						gchar* writeable_path = NULL;
						const gchar* _tmp15_;
						HierarchicalKeywordField* _tmp16_;
						const gchar* _tmp17_;
						gchar* _tmp18_;
						HierarchicalKeywordField* _tmp19_;
						GeeSet* _tmp22_;
						const gchar* _tmp23_;
#line 1054 "../src/photos/PhotoMetadata.vala"
						_tmp12_ = _current_path_it;
#line 1054 "../src/photos/PhotoMetadata.vala"
						if (!gee_iterator_next (_tmp12_)) {
#line 1054 "../src/photos/PhotoMetadata.vala"
							break;
#line 7671 "PhotoMetadata.c"
						}
#line 1054 "../src/photos/PhotoMetadata.vala"
						_tmp13_ = _current_path_it;
#line 1054 "../src/photos/PhotoMetadata.vala"
						_tmp14_ = gee_iterator_get (_tmp13_);
#line 1054 "../src/photos/PhotoMetadata.vala"
						current_path = (gchar*) _tmp14_;
#line 1055 "../src/photos/PhotoMetadata.vala"
						_tmp15_ = current_path;
#line 1055 "../src/photos/PhotoMetadata.vala"
						_tmp16_ = current_field;
#line 1055 "../src/photos/PhotoMetadata.vala"
						_tmp17_ = _tmp16_->path_separator;
#line 1055 "../src/photos/PhotoMetadata.vala"
						_tmp18_ = string_replace (_tmp15_, TAG_PATH_SEPARATOR_STRING, _tmp17_);
#line 1055 "../src/photos/PhotoMetadata.vala"
						writeable_path = _tmp18_;
#line 1057 "../src/photos/PhotoMetadata.vala"
						_tmp19_ = current_field;
#line 1057 "../src/photos/PhotoMetadata.vala"
						if (!_tmp19_->wants_leading_separator) {
#line 7693 "PhotoMetadata.c"
							const gchar* _tmp20_;
							gchar* _tmp21_;
#line 1058 "../src/photos/PhotoMetadata.vala"
							_tmp20_ = writeable_path;
#line 1058 "../src/photos/PhotoMetadata.vala"
							_tmp21_ = string_substring (_tmp20_, (glong) 1, (glong) -1);
#line 1058 "../src/photos/PhotoMetadata.vala"
							_g_free0 (writeable_path);
#line 1058 "../src/photos/PhotoMetadata.vala"
							writeable_path = _tmp21_;
#line 7704 "PhotoMetadata.c"
						}
#line 1060 "../src/photos/PhotoMetadata.vala"
						_tmp22_ = writeable_set;
#line 1060 "../src/photos/PhotoMetadata.vala"
						_tmp23_ = writeable_path;
#line 1060 "../src/photos/PhotoMetadata.vala"
						gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_COLLECTION, GeeCollection), _tmp23_);
#line 1054 "../src/photos/PhotoMetadata.vala"
						_g_free0 (writeable_path);
#line 1054 "../src/photos/PhotoMetadata.vala"
						_g_free0 (current_path);
#line 7716 "PhotoMetadata.c"
					}
#line 1054 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_path_it);
#line 7720 "PhotoMetadata.c"
				}
#line 1063 "../src/photos/PhotoMetadata.vala"
				_tmp24_ = current_field;
#line 1063 "../src/photos/PhotoMetadata.vala"
				_tmp25_ = _tmp24_->field_name;
#line 1063 "../src/photos/PhotoMetadata.vala"
				_tmp26_ = writeable_set;
#line 1063 "../src/photos/PhotoMetadata.vala"
				photo_metadata_set_string_multiple (self, _tmp25_, G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1048 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (writeable_set);
#line 1048 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 7734 "PhotoMetadata.c"
			}
		}
	}
}

void
photo_metadata_set_keywords (PhotoMetadata* self,
                             GeeCollection* keywords,
                             PhotoMetadataSetOption option)
{
	HierarchicalTagIndex* htag_index = NULL;
	HierarchicalTagIndex* _tmp0_;
	GeeSet* flat_keywords = NULL;
	GeeTreeSet* _tmp1_;
#line 1067 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1067 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail ((keywords == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (keywords, GEE_TYPE_COLLECTION));
#line 1068 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = hierarchical_tag_index_new ();
#line 1068 "../src/photos/PhotoMetadata.vala"
	htag_index = _tmp0_;
#line 1069 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 1069 "../src/photos/PhotoMetadata.vala"
	flat_keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_SET, GeeSet);
#line 1071 "../src/photos/PhotoMetadata.vala"
	if (keywords != NULL) {
#line 7763 "PhotoMetadata.c"
		GeeSet* _tmp19_;
		HierarchicalTagIndex* _tmp20_;
		GeeCollection* _tmp21_;
		GeeCollection* _tmp22_;
		{
			GeeIterator* _keyword_it = NULL;
			GeeIterator* _tmp2_;
#line 1072 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (keywords, GEE_TYPE_ITERABLE, GeeIterable));
#line 1072 "../src/photos/PhotoMetadata.vala"
			_keyword_it = _tmp2_;
#line 1072 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 7777 "PhotoMetadata.c"
				GeeIterator* _tmp3_;
				gchar* keyword = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				const gchar* _tmp6_;
#line 1072 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _keyword_it;
#line 1072 "../src/photos/PhotoMetadata.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 1072 "../src/photos/PhotoMetadata.vala"
					break;
#line 7789 "PhotoMetadata.c"
				}
#line 1072 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = _keyword_it;
#line 1072 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 1072 "../src/photos/PhotoMetadata.vala"
				keyword = (gchar*) _tmp5_;
#line 1073 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = keyword;
#line 1073 "../src/photos/PhotoMetadata.vala"
				if (g_str_has_prefix (_tmp6_, TAG_PATH_SEPARATOR_STRING)) {
#line 7801 "PhotoMetadata.c"
					GeeCollection* path_components = NULL;
					const gchar* _tmp7_;
					GeeList* _tmp8_;
#line 1074 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = keyword;
#line 1074 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = hierarchical_tag_utilities_enumerate_path_components (_tmp7_);
#line 1074 "../src/photos/PhotoMetadata.vala"
					path_components = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection);
#line 7811 "PhotoMetadata.c"
					{
						GeeIterator* _component_it = NULL;
						GeeCollection* _tmp9_;
						GeeIterator* _tmp10_;
#line 1076 "../src/photos/PhotoMetadata.vala"
						_tmp9_ = path_components;
#line 1076 "../src/photos/PhotoMetadata.vala"
						_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1076 "../src/photos/PhotoMetadata.vala"
						_component_it = _tmp10_;
#line 1076 "../src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 7824 "PhotoMetadata.c"
							GeeIterator* _tmp11_;
							gchar* component = NULL;
							GeeIterator* _tmp12_;
							gpointer _tmp13_;
							HierarchicalTagIndex* _tmp14_;
							const gchar* _tmp15_;
							const gchar* _tmp16_;
#line 1076 "../src/photos/PhotoMetadata.vala"
							_tmp11_ = _component_it;
#line 1076 "../src/photos/PhotoMetadata.vala"
							if (!gee_iterator_next (_tmp11_)) {
#line 1076 "../src/photos/PhotoMetadata.vala"
								break;
#line 7838 "PhotoMetadata.c"
							}
#line 1076 "../src/photos/PhotoMetadata.vala"
							_tmp12_ = _component_it;
#line 1076 "../src/photos/PhotoMetadata.vala"
							_tmp13_ = gee_iterator_get (_tmp12_);
#line 1076 "../src/photos/PhotoMetadata.vala"
							component = (gchar*) _tmp13_;
#line 1077 "../src/photos/PhotoMetadata.vala"
							_tmp14_ = htag_index;
#line 1077 "../src/photos/PhotoMetadata.vala"
							_tmp15_ = component;
#line 1077 "../src/photos/PhotoMetadata.vala"
							_tmp16_ = keyword;
#line 1077 "../src/photos/PhotoMetadata.vala"
							hierarchical_tag_index_add_path (_tmp14_, _tmp15_, _tmp16_);
#line 1076 "../src/photos/PhotoMetadata.vala"
							_g_free0 (component);
#line 7856 "PhotoMetadata.c"
						}
#line 1076 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_component_it);
#line 7860 "PhotoMetadata.c"
					}
#line 1073 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (path_components);
#line 7864 "PhotoMetadata.c"
				} else {
					GeeSet* _tmp17_;
					const gchar* _tmp18_;
#line 1079 "../src/photos/PhotoMetadata.vala"
					_tmp17_ = flat_keywords;
#line 1079 "../src/photos/PhotoMetadata.vala"
					_tmp18_ = keyword;
#line 1079 "../src/photos/PhotoMetadata.vala"
					gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection), _tmp18_);
#line 7874 "PhotoMetadata.c"
				}
#line 1072 "../src/photos/PhotoMetadata.vala"
				_g_free0 (keyword);
#line 7878 "PhotoMetadata.c"
			}
#line 1072 "../src/photos/PhotoMetadata.vala"
			_g_object_unref0 (_keyword_it);
#line 7882 "PhotoMetadata.c"
		}
#line 1083 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = flat_keywords;
#line 1083 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = htag_index;
#line 1083 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = hierarchical_tag_index_get_all_tags (_tmp20_);
#line 1083 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp21_;
#line 1083 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection), _tmp22_);
#line 1083 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp22_);
#line 7896 "PhotoMetadata.c"
	}
#line 1086 "../src/photos/PhotoMetadata.vala"
	if (keywords != NULL) {
#line 7900 "PhotoMetadata.c"
		gchar** _tmp23_;
		gint _tmp23__length1;
		GeeSet* _tmp24_;
		HierarchicalTagIndex* _tmp25_;
#line 1087 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = photo_metadata_KEYWORD_TAGS;
#line 1087 "../src/photos/PhotoMetadata.vala"
		_tmp23__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 1087 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = flat_keywords;
#line 1087 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_string_multiple (self, _tmp23_, (gint) _tmp23__length1, G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_COLLECTION, GeeCollection), option);
#line 1088 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = htag_index;
#line 1088 "../src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, _tmp25_);
#line 7917 "PhotoMetadata.c"
	} else {
		gchar** _tmp26_;
		gint _tmp26__length1;
#line 1090 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = photo_metadata_KEYWORD_TAGS;
#line 1090 "../src/photos/PhotoMetadata.vala"
		_tmp26__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 1090 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp26_, (gint) _tmp26__length1);
#line 1091 "../src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, NULL);
#line 7929 "PhotoMetadata.c"
	}
#line 1067 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (flat_keywords);
#line 1067 "../src/photos/PhotoMetadata.vala"
	_hierarchical_tag_index_unref0 (htag_index);
#line 7935 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_hierarchical_keywords (PhotoMetadata* self)
{
	HierarchicalKeywordField** _tmp0_;
	gint _tmp0__length1;
	gboolean result = FALSE;
#line 1095 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1096 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 1096 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 7950 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 1096 "../src/photos/PhotoMetadata.vala"
		field_collection = _tmp0_;
#line 1096 "../src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp0__length1;
#line 1096 "../src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < field_collection_length1; field_it = field_it + 1) {
#line 7962 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_;
			HierarchicalKeywordField* field = NULL;
#line 1096 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 1096 "../src/photos/PhotoMetadata.vala"
			field = _tmp1_;
#line 7969 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				HierarchicalKeywordField* _tmp2_;
				const gchar* _tmp3_;
				GeeList* _tmp4_;
				gboolean _tmp5_ = FALSE;
				GeeCollection* _tmp6_;
#line 1097 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = field;
#line 1097 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 1097 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_string_multiple (self, _tmp3_);
#line 1097 "../src/photos/PhotoMetadata.vala"
				values = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1099 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = values;
#line 1099 "../src/photos/PhotoMetadata.vala"
				if (_tmp6_ != NULL) {
#line 7989 "PhotoMetadata.c"
					GeeCollection* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
#line 1099 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = values;
#line 1099 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = gee_collection_get_size (_tmp7_);
#line 1099 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = _tmp8_;
#line 1099 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = _tmp9_ > 0;
#line 8001 "PhotoMetadata.c"
				} else {
#line 1099 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = FALSE;
#line 8005 "PhotoMetadata.c"
				}
#line 1099 "../src/photos/PhotoMetadata.vala"
				if (_tmp5_) {
#line 1100 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 1100 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 1100 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 1100 "../src/photos/PhotoMetadata.vala"
					return result;
#line 8017 "PhotoMetadata.c"
				}
#line 1096 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 1096 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 8023 "PhotoMetadata.c"
			}
		}
	}
#line 1103 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 1103 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8031 "PhotoMetadata.c"
}

GeeSet*
photo_metadata_get_hierarchical_keywords (PhotoMetadata* self)
{
	GeeSet* h_keywords = NULL;
	GeeSet* _tmp0_;
	HierarchicalKeywordField** _tmp1_;
	gint _tmp1__length1;
	GError* _inner_error0_ = NULL;
	GeeSet* result = NULL;
#line 1106 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1107 "../src/photos/PhotoMetadata.vala"
	_vala_assert (photo_metadata_has_hierarchical_keywords (self), "has_hierarchical_keywords()");
#line 1109 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_create_string_set (self, NULL, NULL, NULL);
#line 1109 "../src/photos/PhotoMetadata.vala"
	h_keywords = _tmp0_;
#line 1111 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 1111 "../src/photos/PhotoMetadata.vala"
	_tmp1__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 8055 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 1111 "../src/photos/PhotoMetadata.vala"
		field_collection = _tmp1_;
#line 1111 "../src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp1__length1;
#line 1111 "../src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < field_collection_length1; field_it = field_it + 1) {
#line 8067 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp2_;
			HierarchicalKeywordField* field = NULL;
#line 1111 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 1111 "../src/photos/PhotoMetadata.vala"
			field = _tmp2_;
#line 8074 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				HierarchicalKeywordField* _tmp3_;
				const gchar* _tmp4_;
				GeeList* _tmp5_;
				gboolean _tmp6_ = FALSE;
				GeeCollection* _tmp7_;
				GeeArrayList* transformed_values = NULL;
				GeeArrayList* _tmp11_;
#line 1112 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = field;
#line 1112 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = _tmp3_->field_name;
#line 1112 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = photo_metadata_get_string_multiple (self, _tmp4_);
#line 1112 "../src/photos/PhotoMetadata.vala"
				values = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1114 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = values;
#line 1114 "../src/photos/PhotoMetadata.vala"
				if (_tmp7_ == NULL) {
#line 1114 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = TRUE;
#line 8098 "PhotoMetadata.c"
				} else {
					GeeCollection* _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
#line 1114 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = values;
#line 1114 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = gee_collection_get_size (_tmp8_);
#line 1114 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = _tmp9_;
#line 1114 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = _tmp10_ < 1;
#line 8111 "PhotoMetadata.c"
				}
#line 1114 "../src/photos/PhotoMetadata.vala"
				if (_tmp6_) {
#line 1115 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 1115 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 1115 "../src/photos/PhotoMetadata.vala"
					continue;
#line 8121 "PhotoMetadata.c"
				}
#line 1117 "../src/photos/PhotoMetadata.vala"
				_tmp11_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 1117 "../src/photos/PhotoMetadata.vala"
				transformed_values = _tmp11_;
#line 8127 "PhotoMetadata.c"
				{
					GeeIterator* _current_value_it = NULL;
					GeeCollection* _tmp12_;
					GeeIterator* _tmp13_;
#line 1118 "../src/photos/PhotoMetadata.vala"
					_tmp12_ = values;
#line 1118 "../src/photos/PhotoMetadata.vala"
					_tmp13_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1118 "../src/photos/PhotoMetadata.vala"
					_current_value_it = _tmp13_;
#line 1118 "../src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 8140 "PhotoMetadata.c"
						GeeIterator* _tmp14_;
						gchar* current_value = NULL;
						GeeIterator* _tmp15_;
						gpointer _tmp16_;
#line 1118 "../src/photos/PhotoMetadata.vala"
						_tmp14_ = _current_value_it;
#line 1118 "../src/photos/PhotoMetadata.vala"
						if (!gee_iterator_next (_tmp14_)) {
#line 1118 "../src/photos/PhotoMetadata.vala"
							break;
#line 8151 "PhotoMetadata.c"
						}
#line 1118 "../src/photos/PhotoMetadata.vala"
						_tmp15_ = _current_value_it;
#line 1118 "../src/photos/PhotoMetadata.vala"
						_tmp16_ = gee_iterator_get (_tmp15_);
#line 1118 "../src/photos/PhotoMetadata.vala"
						current_value = (gchar*) _tmp16_;
#line 8159 "PhotoMetadata.c"
						{
							GeeList* transformed = NULL;
							HierarchicalKeywordField* _tmp17_;
							KeywordTransformer* _tmp18_;
							const gchar* _tmp19_;
							GeeList* _tmp20_;
							GeeArrayList* _tmp21_;
							GeeList* _tmp22_;
#line 1120 "../src/photos/PhotoMetadata.vala"
							_tmp17_ = field;
#line 1120 "../src/photos/PhotoMetadata.vala"
							_tmp18_ = _tmp17_->transformer;
#line 1120 "../src/photos/PhotoMetadata.vala"
							_tmp19_ = current_value;
#line 1120 "../src/photos/PhotoMetadata.vala"
							_tmp20_ = keyword_transformer_transform (_tmp18_, _tmp19_, &_inner_error0_);
#line 1120 "../src/photos/PhotoMetadata.vala"
							transformed = _tmp20_;
#line 1120 "../src/photos/PhotoMetadata.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8180 "PhotoMetadata.c"
								goto __catch0_g_error;
							}
#line 1121 "../src/photos/PhotoMetadata.vala"
							_tmp21_ = transformed_values;
#line 1121 "../src/photos/PhotoMetadata.vala"
							_tmp22_ = transformed;
#line 1121 "../src/photos/PhotoMetadata.vala"
							gee_array_list_add_all (_tmp21_, G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1119 "../src/photos/PhotoMetadata.vala"
							_g_object_unref0 (transformed);
#line 8191 "PhotoMetadata.c"
						}
						goto __finally0;
						__catch0_g_error:
						{
							GError* _error_ = NULL;
							const gchar* _tmp23_;
							GError* _tmp24_;
							const gchar* _tmp25_;
#line 1119 "../src/photos/PhotoMetadata.vala"
							_error_ = _inner_error0_;
#line 1119 "../src/photos/PhotoMetadata.vala"
							_inner_error0_ = NULL;
#line 1123 "../src/photos/PhotoMetadata.vala"
							_tmp23_ = current_value;
#line 1123 "../src/photos/PhotoMetadata.vala"
							_tmp24_ = _error_;
#line 1123 "../src/photos/PhotoMetadata.vala"
							_tmp25_ = _tmp24_->message;
#line 1123 "../src/photos/PhotoMetadata.vala"
							g_critical ("PhotoMetadata.vala:1123: Failed to transform tag value %s: %s", _tmp23_, _tmp25_);
#line 1119 "../src/photos/PhotoMetadata.vala"
							_g_error_free0 (_error_);
#line 8214 "PhotoMetadata.c"
						}
						__finally0:
#line 1119 "../src/photos/PhotoMetadata.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1119 "../src/photos/PhotoMetadata.vala"
							_g_free0 (current_value);
#line 1119 "../src/photos/PhotoMetadata.vala"
							_g_object_unref0 (_current_value_it);
#line 1119 "../src/photos/PhotoMetadata.vala"
							_g_object_unref0 (transformed_values);
#line 1119 "../src/photos/PhotoMetadata.vala"
							_g_object_unref0 (values);
#line 1119 "../src/photos/PhotoMetadata.vala"
							_hierarchical_keyword_field_unref0 (field);
#line 1119 "../src/photos/PhotoMetadata.vala"
							_g_object_unref0 (h_keywords);
#line 1119 "../src/photos/PhotoMetadata.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1119 "../src/photos/PhotoMetadata.vala"
							g_clear_error (&_inner_error0_);
#line 1119 "../src/photos/PhotoMetadata.vala"
							return NULL;
#line 8237 "PhotoMetadata.c"
						}
#line 1118 "../src/photos/PhotoMetadata.vala"
						_g_free0 (current_value);
#line 8241 "PhotoMetadata.c"
					}
#line 1118 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_value_it);
#line 8245 "PhotoMetadata.c"
				}
				{
					GeeArrayList* _current_value_list = NULL;
					GeeArrayList* _tmp26_;
					gint _current_value_size = 0;
					GeeArrayList* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					gint _current_value_index = 0;
#line 1129 "../src/photos/PhotoMetadata.vala"
					_tmp26_ = transformed_values;
#line 1129 "../src/photos/PhotoMetadata.vala"
					_current_value_list = _tmp26_;
#line 1129 "../src/photos/PhotoMetadata.vala"
					_tmp27_ = _current_value_list;
#line 1129 "../src/photos/PhotoMetadata.vala"
					_tmp28_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1129 "../src/photos/PhotoMetadata.vala"
					_tmp29_ = _tmp28_;
#line 1129 "../src/photos/PhotoMetadata.vala"
					_current_value_size = _tmp29_;
#line 1129 "../src/photos/PhotoMetadata.vala"
					_current_value_index = -1;
#line 1129 "../src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 8271 "PhotoMetadata.c"
						gint _tmp30_;
						gint _tmp31_;
						gchar* current_value = NULL;
						GeeArrayList* _tmp32_;
						gpointer _tmp33_;
						gchar* canonicalized = NULL;
						const gchar* _tmp34_;
						HierarchicalKeywordField* _tmp35_;
						const gchar* _tmp36_;
						gchar* _tmp37_;
						const gchar* _tmp38_;
#line 1129 "../src/photos/PhotoMetadata.vala"
						_current_value_index = _current_value_index + 1;
#line 1129 "../src/photos/PhotoMetadata.vala"
						_tmp30_ = _current_value_index;
#line 1129 "../src/photos/PhotoMetadata.vala"
						_tmp31_ = _current_value_size;
#line 1129 "../src/photos/PhotoMetadata.vala"
						if (!(_tmp30_ < _tmp31_)) {
#line 1129 "../src/photos/PhotoMetadata.vala"
							break;
#line 8293 "PhotoMetadata.c"
						}
#line 1129 "../src/photos/PhotoMetadata.vala"
						_tmp32_ = _current_value_list;
#line 1129 "../src/photos/PhotoMetadata.vala"
						_tmp33_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _current_value_index);
#line 1129 "../src/photos/PhotoMetadata.vala"
						current_value = (gchar*) _tmp33_;
#line 1130 "../src/photos/PhotoMetadata.vala"
						_tmp34_ = current_value;
#line 1130 "../src/photos/PhotoMetadata.vala"
						_tmp35_ = field;
#line 1130 "../src/photos/PhotoMetadata.vala"
						_tmp36_ = _tmp35_->path_separator;
#line 1130 "../src/photos/PhotoMetadata.vala"
						_tmp37_ = hierarchical_tag_utilities_canonicalize (_tmp34_, _tmp36_);
#line 1130 "../src/photos/PhotoMetadata.vala"
						canonicalized = _tmp37_;
#line 1134 "../src/photos/PhotoMetadata.vala"
						_tmp38_ = canonicalized;
#line 1134 "../src/photos/PhotoMetadata.vala"
						if (_tmp38_ != NULL) {
#line 8315 "PhotoMetadata.c"
							GeeSet* _tmp39_;
							const gchar* _tmp40_;
#line 1135 "../src/photos/PhotoMetadata.vala"
							_tmp39_ = h_keywords;
#line 1135 "../src/photos/PhotoMetadata.vala"
							_tmp40_ = canonicalized;
#line 1135 "../src/photos/PhotoMetadata.vala"
							gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_COLLECTION, GeeCollection), _tmp40_);
#line 8324 "PhotoMetadata.c"
						}
#line 1129 "../src/photos/PhotoMetadata.vala"
						_g_free0 (canonicalized);
#line 1129 "../src/photos/PhotoMetadata.vala"
						_g_free0 (current_value);
#line 8330 "PhotoMetadata.c"
					}
				}
#line 1111 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (transformed_values);
#line 1111 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 1111 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 8339 "PhotoMetadata.c"
			}
		}
	}
#line 1139 "../src/photos/PhotoMetadata.vala"
	result = h_keywords;
#line 1139 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8347 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_orientation (PhotoMetadata* self)
{
	GExiv2Metadata* _tmp0_;
	gboolean result = FALSE;
#line 1142 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1143 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1143 "../src/photos/PhotoMetadata.vala"
	result = gexiv2_metadata_get_orientation (_tmp0_) == GEXIV2_ORIENTATION_UNSPECIFIED;
#line 1143 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8363 "PhotoMetadata.c"
}

Orientation
photo_metadata_get_orientation (PhotoMetadata* self)
{
	GExiv2Orientation orientation = 0;
	GExiv2Metadata* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Orientation result = 0;
#line 1147 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 1150 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1150 "../src/photos/PhotoMetadata.vala"
	orientation = gexiv2_metadata_get_orientation (_tmp0_);
#line 1151 "../src/photos/PhotoMetadata.vala"
	if (orientation == GEXIV2_ORIENTATION_UNSPECIFIED) {
#line 1151 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 8384 "PhotoMetadata.c"
	} else {
#line 1151 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = orientation < ORIENTATION_MIN;
#line 8388 "PhotoMetadata.c"
	}
#line 1151 "../src/photos/PhotoMetadata.vala"
	if (_tmp2_) {
#line 1151 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = TRUE;
#line 8394 "PhotoMetadata.c"
	} else {
#line 1152 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = orientation > ORIENTATION_MAX;
#line 8398 "PhotoMetadata.c"
	}
#line 1151 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_) {
#line 1153 "../src/photos/PhotoMetadata.vala"
		result = ORIENTATION_TOP_LEFT;
#line 1153 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8406 "PhotoMetadata.c"
	} else {
#line 1155 "../src/photos/PhotoMetadata.vala"
		result = (Orientation) orientation;
#line 1155 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8412 "PhotoMetadata.c"
	}
}

void
photo_metadata_set_orientation (PhotoMetadata* self,
                                Orientation orientation)
{
	GExiv2Metadata* _tmp0_;
#line 1158 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1160 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1160 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_set_orientation (_tmp0_, (GExiv2Orientation) orientation);
#line 8427 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_gps (PhotoMetadata* self,
                        gdouble* longitude,
                        gchar** long_ref,
                        gdouble* latitude,
                        gchar** lat_ref,
                        gdouble* altitude)
{
	gdouble _vala_longitude = 0.0;
	gchar* _vala_long_ref = NULL;
	gdouble _vala_latitude = 0.0;
	gchar* _vala_lat_ref = NULL;
	gdouble _vala_altitude = 0.0;
	GExiv2Metadata* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gboolean _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean result = FALSE;
#line 1163 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1165 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1165 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_gps_info (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 1165 "../src/photos/PhotoMetadata.vala"
	_vala_longitude = _tmp1_;
#line 1165 "../src/photos/PhotoMetadata.vala"
	_vala_latitude = _tmp2_;
#line 1165 "../src/photos/PhotoMetadata.vala"
	_vala_altitude = _tmp3_;
#line 1165 "../src/photos/PhotoMetadata.vala"
	if (!_tmp4_) {
#line 1166 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 1166 "../src/photos/PhotoMetadata.vala"
		_vala_long_ref = NULL;
#line 1167 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 1167 "../src/photos/PhotoMetadata.vala"
		_vala_lat_ref = NULL;
#line 1169 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1169 "../src/photos/PhotoMetadata.vala"
		if (longitude) {
#line 1169 "../src/photos/PhotoMetadata.vala"
			*longitude = _vala_longitude;
#line 8479 "PhotoMetadata.c"
		}
#line 1169 "../src/photos/PhotoMetadata.vala"
		if (long_ref) {
#line 1169 "../src/photos/PhotoMetadata.vala"
			*long_ref = _vala_long_ref;
#line 8485 "PhotoMetadata.c"
		} else {
#line 1169 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_long_ref);
#line 8489 "PhotoMetadata.c"
		}
#line 1169 "../src/photos/PhotoMetadata.vala"
		if (latitude) {
#line 1169 "../src/photos/PhotoMetadata.vala"
			*latitude = _vala_latitude;
#line 8495 "PhotoMetadata.c"
		}
#line 1169 "../src/photos/PhotoMetadata.vala"
		if (lat_ref) {
#line 1169 "../src/photos/PhotoMetadata.vala"
			*lat_ref = _vala_lat_ref;
#line 8501 "PhotoMetadata.c"
		} else {
#line 1169 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_lat_ref);
#line 8505 "PhotoMetadata.c"
		}
#line 1169 "../src/photos/PhotoMetadata.vala"
		if (altitude) {
#line 1169 "../src/photos/PhotoMetadata.vala"
			*altitude = _vala_altitude;
#line 8511 "PhotoMetadata.c"
		}
#line 1169 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8515 "PhotoMetadata.c"
	}
#line 1172 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1172 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_long_ref);
#line 1172 "../src/photos/PhotoMetadata.vala"
	_vala_long_ref = _tmp5_;
#line 1173 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1173 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_lat_ref);
#line 1173 "../src/photos/PhotoMetadata.vala"
	_vala_lat_ref = _tmp6_;
#line 1175 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 1175 "../src/photos/PhotoMetadata.vala"
	if (longitude) {
#line 1175 "../src/photos/PhotoMetadata.vala"
		*longitude = _vala_longitude;
#line 8535 "PhotoMetadata.c"
	}
#line 1175 "../src/photos/PhotoMetadata.vala"
	if (long_ref) {
#line 1175 "../src/photos/PhotoMetadata.vala"
		*long_ref = _vala_long_ref;
#line 8541 "PhotoMetadata.c"
	} else {
#line 1175 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 8545 "PhotoMetadata.c"
	}
#line 1175 "../src/photos/PhotoMetadata.vala"
	if (latitude) {
#line 1175 "../src/photos/PhotoMetadata.vala"
		*latitude = _vala_latitude;
#line 8551 "PhotoMetadata.c"
	}
#line 1175 "../src/photos/PhotoMetadata.vala"
	if (lat_ref) {
#line 1175 "../src/photos/PhotoMetadata.vala"
		*lat_ref = _vala_lat_ref;
#line 8557 "PhotoMetadata.c"
	} else {
#line 1175 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 8561 "PhotoMetadata.c"
	}
#line 1175 "../src/photos/PhotoMetadata.vala"
	if (altitude) {
#line 1175 "../src/photos/PhotoMetadata.vala"
		*altitude = _vala_altitude;
#line 8567 "PhotoMetadata.c"
	}
#line 1175 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8571 "PhotoMetadata.c"
}

void
photo_metadata_get_gps_coords (PhotoMetadata* self,
                               GpsCoords* result)
{
	GpsCoords gps_coords = {0};
	gdouble altitude = 0.0;
	gint _tmp0_ = 0;
	GExiv2Metadata* _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gboolean _tmp5_;
	GpsCoords _tmp6_;
#line 1178 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1179 "../src/photos/PhotoMetadata.vala"
	memset (&gps_coords, 0, sizeof (GpsCoords));
#line 1181 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 1181 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = gexiv2_metadata_get_gps_info (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 1181 "../src/photos/PhotoMetadata.vala"
	gps_coords.longitude = _tmp2_;
#line 1181 "../src/photos/PhotoMetadata.vala"
	gps_coords.latitude = _tmp3_;
#line 1181 "../src/photos/PhotoMetadata.vala"
	altitude = _tmp4_;
#line 1181 "../src/photos/PhotoMetadata.vala"
	if (_tmp5_) {
#line 1181 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = 1;
#line 8605 "PhotoMetadata.c"
	} else {
#line 1181 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = 0;
#line 8609 "PhotoMetadata.c"
	}
#line 1181 "../src/photos/PhotoMetadata.vala"
	gps_coords.has_gps = _tmp0_;
#line 1182 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = gps_coords;
#line 1182 "../src/photos/PhotoMetadata.vala"
	if (_tmp6_.has_gps > 0) {
#line 8617 "PhotoMetadata.c"
		gboolean _tmp7_ = FALSE;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp13_ = FALSE;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gboolean _tmp16_;
#line 1183 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1183 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp8_;
#line 1183 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = g_strcmp0 (_tmp9_, "W") == 0;
#line 1183 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp9_);
#line 1183 "../src/photos/PhotoMetadata.vala"
		if (_tmp10_) {
#line 8636 "PhotoMetadata.c"
			GpsCoords _tmp11_;
#line 1183 "../src/photos/PhotoMetadata.vala"
			_tmp11_ = gps_coords;
#line 1183 "../src/photos/PhotoMetadata.vala"
			_tmp7_ = _tmp11_.longitude > ((gdouble) 0);
#line 8642 "PhotoMetadata.c"
		} else {
#line 1183 "../src/photos/PhotoMetadata.vala"
			_tmp7_ = FALSE;
#line 8646 "PhotoMetadata.c"
		}
#line 1183 "../src/photos/PhotoMetadata.vala"
		if (_tmp7_) {
#line 8650 "PhotoMetadata.c"
			GpsCoords _tmp12_;
#line 1184 "../src/photos/PhotoMetadata.vala"
			_tmp12_ = gps_coords;
#line 1184 "../src/photos/PhotoMetadata.vala"
			gps_coords.longitude = -_tmp12_.longitude;
#line 8656 "PhotoMetadata.c"
		}
#line 1185 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1185 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = _tmp14_;
#line 1185 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = g_strcmp0 (_tmp15_, "S") == 0;
#line 1185 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp15_);
#line 1185 "../src/photos/PhotoMetadata.vala"
		if (_tmp16_) {
#line 8668 "PhotoMetadata.c"
			GpsCoords _tmp17_;
#line 1185 "../src/photos/PhotoMetadata.vala"
			_tmp17_ = gps_coords;
#line 1185 "../src/photos/PhotoMetadata.vala"
			_tmp13_ = _tmp17_.latitude > ((gdouble) 0);
#line 8674 "PhotoMetadata.c"
		} else {
#line 1185 "../src/photos/PhotoMetadata.vala"
			_tmp13_ = FALSE;
#line 8678 "PhotoMetadata.c"
		}
#line 1185 "../src/photos/PhotoMetadata.vala"
		if (_tmp13_) {
#line 8682 "PhotoMetadata.c"
			GpsCoords _tmp18_;
#line 1186 "../src/photos/PhotoMetadata.vala"
			_tmp18_ = gps_coords;
#line 1186 "../src/photos/PhotoMetadata.vala"
			gps_coords.latitude = -_tmp18_.latitude;
#line 8688 "PhotoMetadata.c"
		}
	}
#line 1188 "../src/photos/PhotoMetadata.vala"
	*result = gps_coords;
#line 1188 "../src/photos/PhotoMetadata.vala"
	return;
#line 8695 "PhotoMetadata.c"
}

void
photo_metadata_set_gps_coords (PhotoMetadata* self,
                               GpsCoords* gps_coords)
{
	GpsCoords _tmp0_;
#line 1191 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1191 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (gps_coords != NULL);
#line 1192 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = *gps_coords;
#line 1192 "../src/photos/PhotoMetadata.vala"
	if (_tmp0_.has_gps > 0) {
#line 8711 "PhotoMetadata.c"
		gdouble altitude = 0.0;
		GExiv2Metadata* _tmp1_;
		gdouble _tmp2_ = 0.0;
		GExiv2Metadata* _tmp3_;
		GpsCoords _tmp4_;
		GpsCoords _tmp5_;
#line 1193 "../src/photos/PhotoMetadata.vala"
		altitude = 0.0;
#line 1194 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->exiv2;
#line 1194 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_get_gps_altitude (_tmp1_, &_tmp2_);
#line 1194 "../src/photos/PhotoMetadata.vala"
		altitude = _tmp2_;
#line 1195 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = self->priv->exiv2;
#line 1195 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = *gps_coords;
#line 1195 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = *gps_coords;
#line 1195 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_set_gps_info (_tmp3_, _tmp4_.longitude, _tmp5_.latitude, altitude);
#line 8734 "PhotoMetadata.c"
	} else {
		GExiv2Metadata* _tmp6_;
#line 1197 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->exiv2;
#line 1197 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_delete_gps_info (_tmp6_);
#line 8741 "PhotoMetadata.c"
	}
}

gboolean
photo_metadata_get_exposure (PhotoMetadata* self,
                             MetadataRational* exposure)
{
	MetadataRational _vala_exposure = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean result = FALSE;
#line 1200 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1201 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1201 "../src/photos/PhotoMetadata.vala"
	_vala_exposure = _tmp0_;
#line 1201 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1201 "../src/photos/PhotoMetadata.vala"
	if (exposure) {
#line 1201 "../src/photos/PhotoMetadata.vala"
		*exposure = _vala_exposure;
#line 8765 "PhotoMetadata.c"
	}
#line 1201 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8769 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_exposure_string (PhotoMetadata* self)
{
	MetadataRational exposure_time = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
#line 1204 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1206 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1206 "../src/photos/PhotoMetadata.vala"
	exposure_time = _tmp0_;
#line 1206 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1207 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1207 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8792 "PhotoMetadata.c"
	}
#line 1209 "../src/photos/PhotoMetadata.vala"
	if (!metadata_rational_is_valid (&exposure_time)) {
#line 1210 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1210 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8800 "PhotoMetadata.c"
	}
#line 1212 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureTime", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1212 "../src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1212 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8808 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_iso (PhotoMetadata* self,
                        glong* iso)
{
	glong _vala_iso = 0L;
	gboolean fetched_ok = FALSE;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean result = FALSE;
#line 1215 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1216 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.ISOSpeedRatings", &_tmp0_);
#line 1216 "../src/photos/PhotoMetadata.vala"
	_vala_iso = _tmp0_;
#line 1216 "../src/photos/PhotoMetadata.vala"
	fetched_ok = _tmp1_;
#line 1218 "../src/photos/PhotoMetadata.vala"
	if (fetched_ok == FALSE) {
#line 1219 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1219 "../src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1219 "../src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 8837 "PhotoMetadata.c"
		}
#line 1219 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8841 "PhotoMetadata.c"
	}
#line 1223 "../src/photos/PhotoMetadata.vala"
	if (_vala_iso < ((glong) 6)) {
#line 1223 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 8847 "PhotoMetadata.c"
	} else {
#line 1223 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = _vala_iso > ((glong) 409600);
#line 8851 "PhotoMetadata.c"
	}
#line 1223 "../src/photos/PhotoMetadata.vala"
	if (_tmp2_) {
#line 1224 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1224 "../src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1224 "../src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 8861 "PhotoMetadata.c"
		}
#line 1224 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8865 "PhotoMetadata.c"
	}
#line 1226 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 1226 "../src/photos/PhotoMetadata.vala"
	if (iso) {
#line 1226 "../src/photos/PhotoMetadata.vala"
		*iso = _vala_iso;
#line 8873 "PhotoMetadata.c"
	}
#line 1226 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8877 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_iso_string (PhotoMetadata* self)
{
	glong iso = 0L;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
#line 1229 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1231 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_iso (self, &_tmp0_);
#line 1231 "../src/photos/PhotoMetadata.vala"
	iso = _tmp0_;
#line 1231 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1232 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1232 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8900 "PhotoMetadata.c"
	}
#line 1234 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ISOSpeedRatings", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1234 "../src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1234 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8908 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_aperture (PhotoMetadata* self,
                             MetadataRational* aperture)
{
	MetadataRational _vala_aperture = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean result = FALSE;
#line 1237 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1238 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FNumber", &_tmp0_);
#line 1238 "../src/photos/PhotoMetadata.vala"
	_vala_aperture = _tmp0_;
#line 1238 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1238 "../src/photos/PhotoMetadata.vala"
	if (aperture) {
#line 1238 "../src/photos/PhotoMetadata.vala"
		*aperture = _vala_aperture;
#line 8931 "PhotoMetadata.c"
	}
#line 1238 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8935 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_aperture_string (PhotoMetadata* self,
                                    gboolean pango_formatted)
{
	MetadataRational aperture = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gdouble aperture_value = 0.0;
	MetadataRational _tmp2_;
	MetadataRational _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result = NULL;
#line 1241 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1243 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_aperture (self, &_tmp0_);
#line 1243 "../src/photos/PhotoMetadata.vala"
	aperture = _tmp0_;
#line 1243 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1244 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1244 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8967 "PhotoMetadata.c"
	}
#line 1246 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = aperture;
#line 1246 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = aperture;
#line 1246 "../src/photos/PhotoMetadata.vala"
	aperture_value = ((gdouble) _tmp2_.numerator) / ((gdouble) _tmp3_.denominator);
#line 1247 "../src/photos/PhotoMetadata.vala"
	aperture_value = ((gint) (aperture_value * 10.0)) / 10.0;
#line 1249 "../src/photos/PhotoMetadata.vala"
	if (pango_formatted) {
#line 1249 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = "<i>f</i>/";
#line 8981 "PhotoMetadata.c"
	} else {
#line 1249 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = "f/";
#line 8985 "PhotoMetadata.c"
	}
#line 1250 "../src/photos/PhotoMetadata.vala"
	if (fmod (aperture_value, 1) == ((gdouble) 0)) {
#line 1250 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = "%.0f";
#line 8991 "PhotoMetadata.c"
	} else {
#line 1250 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = "%.1f";
#line 8995 "PhotoMetadata.c"
	}
#line 1249 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = g_strdup_printf (_tmp5_, aperture_value);
#line 1249 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp6_;
#line 1249 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = g_strconcat (_tmp4_, _tmp7_, NULL);
#line 1249 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = _tmp8_;
#line 1249 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp7_);
#line 1249 "../src/photos/PhotoMetadata.vala"
	result = _tmp9_;
#line 1249 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9011 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_camera_make (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1253 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1254 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Make", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1254 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1254 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9027 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_camera_model (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1257 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1258 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Model", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1258 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1258 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9043 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_flash (PhotoMetadata* self,
                          glong* flash)
{
	glong _vala_flash = 0L;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
	gboolean result = FALSE;
#line 1261 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1263 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.Flash", &_tmp0_);
#line 1263 "../src/photos/PhotoMetadata.vala"
	_vala_flash = _tmp0_;
#line 1263 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1263 "../src/photos/PhotoMetadata.vala"
	if (flash) {
#line 1263 "../src/photos/PhotoMetadata.vala"
		*flash = _vala_flash;
#line 9066 "PhotoMetadata.c"
	}
#line 1263 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9070 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_flash_string (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1266 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1268 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.Flash", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1268 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1268 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9086 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_focal_length (PhotoMetadata* self,
                                 MetadataRational* focal_length)
{
	MetadataRational _vala_focal_length = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean result = FALSE;
#line 1271 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1272 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FocalLength", &_tmp0_);
#line 1272 "../src/photos/PhotoMetadata.vala"
	_vala_focal_length = _tmp0_;
#line 1272 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1272 "../src/photos/PhotoMetadata.vala"
	if (focal_length) {
#line 1272 "../src/photos/PhotoMetadata.vala"
		*focal_length = _vala_focal_length;
#line 9109 "PhotoMetadata.c"
	}
#line 1272 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9113 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_focal_length_string (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1275 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1276 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.FocalLength", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1276 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1276 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9129 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_artist (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 1285 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1286 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_ARTIST_TAGS;
#line 1286 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_ARTIST_TAGS_length1;
#line 1286 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string_interpreted (self, _tmp0_, (gint) _tmp0__length1);
#line 1286 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1286 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9151 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_copyright (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1289 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1290 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Copyright", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1290 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1290 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9167 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_software (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1293 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1294 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Software", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1294 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1294 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9183 "PhotoMetadata.c"
}

void
photo_metadata_set_software (PhotoMetadata* self,
                             const gchar* software,
                             const gchar* version)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1297 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1297 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (software != NULL);
#line 1297 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (version != NULL);
#line 1299 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup_printf ("%s %s", software, version);
#line 1299 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_;
#line 1299 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Exif.Image.Software", _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1299 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp1_);
#line 1301 "../src/photos/PhotoMetadata.vala"
	if (photo_metadata_has_iptc (self)) {
#line 1302 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.Program", software, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1303 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.ProgramVersion", version, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 9213 "PhotoMetadata.c"
	}
}

void
photo_metadata_remove_software (PhotoMetadata* self)
{
#line 1307 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1308 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Exif.Image.Software");
#line 1309 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.Program");
#line 1310 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.ProgramVersion");
#line 9228 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_exposure_bias (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1313 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1314 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureBiasValue", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1314 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1314 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9244 "PhotoMetadata.c"
}

Rating
photo_metadata_get_rating (PhotoMetadata* self)
{
	gchar* rating_string = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gint int_percent_rating = 0;
	const gchar* _tmp6_;
	Rating result = 0;
#line 1325 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 1326 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_RATING_TAGS;
#line 1326 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_RATING_TAGS_length1;
#line 1326 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string (self, _tmp0_, (gint) _tmp0__length1);
#line 1326 "../src/photos/PhotoMetadata.vala"
	rating_string = _tmp1_;
#line 1327 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = rating_string;
#line 1327 "../src/photos/PhotoMetadata.vala"
	if (_tmp2_ != NULL) {
#line 9274 "PhotoMetadata.c"
		const gchar* _tmp3_;
#line 1328 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = rating_string;
#line 1328 "../src/photos/PhotoMetadata.vala"
		result = rating_unserialize (atoi (_tmp3_));
#line 1328 "../src/photos/PhotoMetadata.vala"
		_g_free0 (rating_string);
#line 1328 "../src/photos/PhotoMetadata.vala"
		return result;
#line 9284 "PhotoMetadata.c"
	}
#line 1330 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = photo_metadata_get_string (self, "Exif.Image.RatingPercent", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1330 "../src/photos/PhotoMetadata.vala"
	_g_free0 (rating_string);
#line 1330 "../src/photos/PhotoMetadata.vala"
	rating_string = _tmp4_;
#line 1331 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = rating_string;
#line 1331 "../src/photos/PhotoMetadata.vala"
	if (_tmp5_ == NULL) {
#line 1332 "../src/photos/PhotoMetadata.vala"
		result = RATING_UNRATED;
#line 1332 "../src/photos/PhotoMetadata.vala"
		_g_free0 (rating_string);
#line 1332 "../src/photos/PhotoMetadata.vala"
		return result;
#line 9302 "PhotoMetadata.c"
	}
#line 1335 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = rating_string;
#line 1335 "../src/photos/PhotoMetadata.vala"
	int_percent_rating = atoi (_tmp6_);
#line 9308 "PhotoMetadata.c"
	{
		gint i = 0;
#line 1336 "../src/photos/PhotoMetadata.vala"
		i = 5;
#line 9313 "PhotoMetadata.c"
		{
			gboolean _tmp7_ = FALSE;
#line 1336 "../src/photos/PhotoMetadata.vala"
			_tmp7_ = TRUE;
#line 1336 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 9320 "PhotoMetadata.c"
				gint _tmp9_;
#line 1336 "../src/photos/PhotoMetadata.vala"
				if (!_tmp7_) {
#line 9324 "PhotoMetadata.c"
					gint _tmp8_;
#line 1336 "../src/photos/PhotoMetadata.vala"
					i = i - 1;
#line 1336 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = i;
#line 9330 "PhotoMetadata.c"
				}
#line 1336 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = FALSE;
#line 1336 "../src/photos/PhotoMetadata.vala"
				if (!(i >= 0)) {
#line 1336 "../src/photos/PhotoMetadata.vala"
					break;
#line 9338 "PhotoMetadata.c"
				}
#line 1337 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = RESOURCES_rating_thresholds[i];
#line 1337 "../src/photos/PhotoMetadata.vala"
				if (int_percent_rating >= _tmp9_) {
#line 1338 "../src/photos/PhotoMetadata.vala"
					result = rating_unserialize (i);
#line 1338 "../src/photos/PhotoMetadata.vala"
					_g_free0 (rating_string);
#line 1338 "../src/photos/PhotoMetadata.vala"
					return result;
#line 9350 "PhotoMetadata.c"
				}
			}
		}
	}
#line 1340 "../src/photos/PhotoMetadata.vala"
	result = rating_unserialize (-1);
#line 1340 "../src/photos/PhotoMetadata.vala"
	_g_free0 (rating_string);
#line 1340 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9361 "PhotoMetadata.c"
}

void
photo_metadata_set_rating (PhotoMetadata* self,
                           Rating rating)
{
	gint int_rating = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1348 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1349 "../src/photos/PhotoMetadata.vala"
	int_rating = rating_serialize (rating);
#line 1350 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup_printf ("%i", int_rating);
#line 1350 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_;
#line 1350 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Xmp.xmp.Rating", _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1350 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp1_);
#line 1351 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup_printf ("%i", int_rating);
#line 1351 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 1351 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Exif.Image.Rating", _tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1351 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 1353 "../src/photos/PhotoMetadata.vala"
	if (0 <= int_rating) {
#line 9395 "PhotoMetadata.c"
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1354 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = RESOURCES_rating_thresholds[int_rating];
#line 1354 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = g_strdup_printf ("%i", _tmp4_);
#line 1354 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp5_;
#line 1354 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Exif.Image.RatingPercent", _tmp6_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1354 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp6_);
#line 9409 "PhotoMetadata.c"
	} else {
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 1356 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = g_strdup_printf ("%i", int_rating);
#line 1356 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = _tmp7_;
#line 1356 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Exif.Image.RatingPercent", _tmp8_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1356 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp8_);
#line 9421 "PhotoMetadata.c"
	}
}

static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 237 "../src/photos/PhotoMetadata.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 9430 "PhotoMetadata.c"
}

static PhotoMetadataInternalPhotoPreview*
photo_metadata_internal_photo_preview_construct (GType object_type,
                                                 PhotoMetadata* owner,
                                                 const gchar* name,
                                                 guint number,
                                                 GExiv2PreviewProperties* props)
{
	PhotoMetadataInternalPhotoPreview* self = NULL;
	Dimensions _tmp0_ = {0};
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoMetadata* _tmp3_;
#line 232 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (owner), NULL);
#line 232 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 232 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (props, gexiv2_preview_properties_get_type ()), NULL);
#line 234 "../src/photos/PhotoMetadata.vala"
	dimensions_init (&_tmp0_, (gint) gexiv2_preview_properties_get_width (props), (gint) gexiv2_preview_properties_get_height (props));
#line 234 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_preview_properties_get_mime_type (props);
#line 234 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_preview_properties_get_extension (props);
#line 234 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) photo_preview_construct (object_type, name, &_tmp0_, gexiv2_preview_properties_get_size (props), _tmp1_, _tmp2_);
#line 237 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _media_metadata_ref0 (owner);
#line 237 "../src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 237 "../src/photos/PhotoMetadata.vala"
	self->owner = _tmp3_;
#line 238 "../src/photos/PhotoMetadata.vala"
	self->number = number;
#line 232 "../src/photos/PhotoMetadata.vala"
	return self;
#line 9469 "PhotoMetadata.c"
}

static PhotoMetadataInternalPhotoPreview*
photo_metadata_internal_photo_preview_new (PhotoMetadata* owner,
                                           const gchar* name,
                                           guint number,
                                           GExiv2PreviewProperties* props)
{
#line 232 "../src/photos/PhotoMetadata.vala"
	return photo_metadata_internal_photo_preview_construct (PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, owner, name, number, props);
#line 9480 "PhotoMetadata.c"
}

static GBytes*
photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base,
                                                    GError** error)
{
	PhotoMetadataInternalPhotoPreview * self;
	GExiv2PreviewProperties** props = NULL;
	PhotoMetadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	GExiv2PreviewProperties** _tmp3_;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp4_ = FALSE;
	GExiv2PreviewProperties** _tmp5_;
	gint _tmp5__length1;
	PhotoMetadata* _tmp7_;
	GExiv2Metadata* _tmp8_;
	GExiv2PreviewProperties** _tmp9_;
	gint _tmp9__length1;
	GExiv2PreviewProperties* _tmp10_;
	GExiv2PreviewImage* _tmp11_;
	GExiv2PreviewImage* _tmp12_;
	guint32 _tmp13_ = 0;
	guint8* _tmp14_;
	GBytes* _tmp15_;
	GBytes* _tmp16_;
	GBytes* result = NULL;
#line 241 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview);
#line 242 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->owner;
#line 242 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_->priv->exiv2;
#line 242 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_ = gexiv2_metadata_get_preview_properties (_tmp1_);
#line 242 "../src/photos/PhotoMetadata.vala"
	props = _tmp3_;
#line 242 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp2_);
#line 242 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 243 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = props;
#line 243 "../src/photos/PhotoMetadata.vala"
	_tmp5__length1 = props_length1;
#line 243 "../src/photos/PhotoMetadata.vala"
	if (_tmp5_ != NULL) {
#line 9530 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp6_;
		gint _tmp6__length1;
#line 243 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = props;
#line 243 "../src/photos/PhotoMetadata.vala"
		_tmp6__length1 = props_length1;
#line 243 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = ((guint) _tmp6__length1) > self->number;
#line 9539 "PhotoMetadata.c"
	} else {
#line 243 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 9543 "PhotoMetadata.c"
	}
#line 243 "../src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp4_, "props != null && props.length > number");
#line 245 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = self->owner;
#line 245 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp7_->priv->exiv2;
#line 245 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = props;
#line 245 "../src/photos/PhotoMetadata.vala"
	_tmp9__length1 = props_length1;
#line 245 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = _tmp9_[self->number];
#line 245 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = gexiv2_metadata_get_preview_image (_tmp8_, _tmp10_);
#line 245 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = _tmp11_;
#line 245 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = gexiv2_preview_image_get_data (_tmp12_, &_tmp13_);
#line 245 "../src/photos/PhotoMetadata.vala"
	_tmp15_ = g_bytes_new (_tmp14_, _tmp13_);
#line 245 "../src/photos/PhotoMetadata.vala"
	_tmp16_ = _tmp15_;
#line 245 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_tmp12_);
#line 245 "../src/photos/PhotoMetadata.vala"
	result = _tmp16_;
#line 245 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9573 "PhotoMetadata.c"
}

static void
photo_metadata_internal_photo_preview_class_init (PhotoMetadataInternalPhotoPreviewClass * klass,
                                                  gpointer klass_data)
{
#line 228 "../src/photos/PhotoMetadata.vala"
	photo_metadata_internal_photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 228 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->finalize = photo_metadata_internal_photo_preview_finalize;
#line 228 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->flatten = (GBytes* (*) (PhotoPreview*, GError**)) photo_metadata_internal_photo_preview_real_flatten;
#line 9586 "PhotoMetadata.c"
}

static void
photo_metadata_internal_photo_preview_instance_init (PhotoMetadataInternalPhotoPreview * self,
                                                     gpointer klass)
{
}

static void
photo_metadata_internal_photo_preview_finalize (PhotoPreview * obj)
{
	PhotoMetadataInternalPhotoPreview * self;
#line 228 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview);
#line 229 "../src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 228 "../src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (photo_metadata_internal_photo_preview_parent_class)->finalize (obj);
#line 9605 "PhotoMetadata.c"
}

static GType
photo_metadata_internal_photo_preview_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataInternalPhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_internal_photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadataInternalPhotoPreview), 0, (GInstanceInitFunc) photo_metadata_internal_photo_preview_instance_init, NULL };
	GType photo_metadata_internal_photo_preview_type_id;
	photo_metadata_internal_photo_preview_type_id = g_type_register_static (TYPE_PHOTO_PREVIEW, "PhotoMetadataInternalPhotoPreview", &g_define_type_info, 0);
	return photo_metadata_internal_photo_preview_type_id;
}

static GType
photo_metadata_internal_photo_preview_get_type (void)
{
	static volatile gsize photo_metadata_internal_photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_internal_photo_preview_type_id__volatile)) {
		GType photo_metadata_internal_photo_preview_type_id;
		photo_metadata_internal_photo_preview_type_id = photo_metadata_internal_photo_preview_get_type_once ();
		g_once_init_leave (&photo_metadata_internal_photo_preview_type_id__volatile, photo_metadata_internal_photo_preview_type_id);
	}
	return photo_metadata_internal_photo_preview_type_id__volatile;
}

static void
photo_metadata_class_init (PhotoMetadataClass * klass,
                           gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar** _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar** _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar** _tmp37_;
	NullKeywordTransformer* _tmp38_;
	NullKeywordTransformer* _tmp39_;
	HierarchicalKeywordField* _tmp40_;
	NullKeywordTransformer* _tmp41_;
	NullKeywordTransformer* _tmp42_;
	HierarchicalKeywordField* _tmp43_;
	ACDSeeKeywordTransformer* _tmp44_;
	ACDSeeKeywordTransformer* _tmp45_;
	HierarchicalKeywordField* _tmp46_;
	NullKeywordTransformer* _tmp47_;
	NullKeywordTransformer* _tmp48_;
	HierarchicalKeywordField* _tmp49_;
	NullKeywordTransformer* _tmp50_;
	NullKeywordTransformer* _tmp51_;
	HierarchicalKeywordField* _tmp52_;
	HierarchicalKeywordField** _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar** _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar** _tmp63_;
#line 213 "../src/photos/PhotoMetadata.vala"
	photo_metadata_parent_class = g_type_class_peek_parent (klass);
#line 213 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->finalize = photo_metadata_finalize;
#line 213 "../src/photos/PhotoMetadata.vala"
	g_type_class_adjust_private_offset (klass, &PhotoMetadata_private_offset);
#line 213 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->read_from_file = (void (*) (MediaMetadata*, GFile*, GError**)) photo_metadata_real_read_from_file;
#line 213 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_creation_date_time = (MetadataDateTime* (*) (MediaMetadata*)) photo_metadata_real_get_creation_date_time;
#line 213 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_title = (gchar* (*) (MediaMetadata*)) photo_metadata_real_get_title;
#line 213 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_comment = (gchar* (*) (MediaMetadata*)) photo_metadata_real_get_comment;
#line 809 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup ("Exif.Image.DateTime");
#line 809 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("Xmp.tiff.DateTime");
#line 809 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup ("Xmp.xmp.ModifyDate");
#line 809 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup ("Xmp.acdsee.datetime");
#line 809 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = g_new0 (gchar*, 4 + 1);
#line 809 "../src/photos/PhotoMetadata.vala"
	_tmp4_[0] = _tmp0_;
#line 809 "../src/photos/PhotoMetadata.vala"
	_tmp4_[1] = _tmp1_;
#line 809 "../src/photos/PhotoMetadata.vala"
	_tmp4_[2] = _tmp2_;
#line 809 "../src/photos/PhotoMetadata.vala"
	_tmp4_[3] = _tmp3_;
#line 809 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS = _tmp4_;
#line 809 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS_length1 = 4;
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = g_strdup ("Exif.Photo.DateTimeOriginal");
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = g_strdup ("Xmp.exif.DateTimeOriginal");
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup ("Xmp.xmp.CreateDate");
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = g_strdup ("Exif.Image.DateTime");
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = g_new0 (gchar*, 6 + 1);
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp11_[0] = _tmp5_;
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp11_[1] = _tmp6_;
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp11_[2] = _tmp7_;
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp11_[3] = _tmp8_;
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp11_[4] = _tmp9_;
#line 828 "../src/photos/PhotoMetadata.vala"
	_tmp11_[5] = _tmp10_;
#line 828 "../src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS = _tmp11_;
#line 828 "../src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 6;
#line 849 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 849 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 849 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = g_new0 (gchar*, 2 + 1);
#line 849 "../src/photos/PhotoMetadata.vala"
	_tmp14_[0] = _tmp12_;
#line 849 "../src/photos/PhotoMetadata.vala"
	_tmp14_[1] = _tmp13_;
#line 849 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS = _tmp14_;
#line 849 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 2;
#line 874 "../src/photos/PhotoMetadata.vala"
	_tmp15_ = g_strdup ("Exif.Photo.PixelXDimension");
#line 874 "../src/photos/PhotoMetadata.vala"
	_tmp16_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 874 "../src/photos/PhotoMetadata.vala"
	_tmp17_ = g_strdup ("Xmp.tiff.ImageWidth");
#line 874 "../src/photos/PhotoMetadata.vala"
	_tmp18_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 874 "../src/photos/PhotoMetadata.vala"
	_tmp19_ = g_new0 (gchar*, 4 + 1);
#line 874 "../src/photos/PhotoMetadata.vala"
	_tmp19_[0] = _tmp15_;
#line 874 "../src/photos/PhotoMetadata.vala"
	_tmp19_[1] = _tmp16_;
#line 874 "../src/photos/PhotoMetadata.vala"
	_tmp19_[2] = _tmp17_;
#line 874 "../src/photos/PhotoMetadata.vala"
	_tmp19_[3] = _tmp18_;
#line 874 "../src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS = _tmp19_;
#line 874 "../src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS_length1 = 4;
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = g_strdup ("Exif.Photo.PixelYDimension");
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp21_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp22_ = g_strdup ("Xmp.tiff.ImageLength");
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp23_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp24_ = g_new0 (gchar*, 4 + 1);
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp24_[0] = _tmp20_;
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp24_[1] = _tmp21_;
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp24_[2] = _tmp22_;
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp24_[3] = _tmp23_;
#line 881 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS = _tmp24_;
#line 881 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS_length1 = 4;
#line 940 "../src/photos/PhotoMetadata.vala"
	_tmp25_ = g_strdup ("Iptc.Application2.Caption");
#line 940 "../src/photos/PhotoMetadata.vala"
	_tmp26_ = g_strdup ("Xmp.dc.title");
#line 940 "../src/photos/PhotoMetadata.vala"
	_tmp27_ = g_strdup ("Iptc.Application2.Headline");
#line 940 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = g_strdup ("Xmp.photoshop.Headline");
#line 940 "../src/photos/PhotoMetadata.vala"
	_tmp29_ = g_strdup ("Xmp.acdsee.caption");
#line 940 "../src/photos/PhotoMetadata.vala"
	_tmp30_ = g_new0 (gchar*, 5 + 1);
#line 940 "../src/photos/PhotoMetadata.vala"
	_tmp30_[0] = _tmp25_;
#line 940 "../src/photos/PhotoMetadata.vala"
	_tmp30_[1] = _tmp26_;
#line 940 "../src/photos/PhotoMetadata.vala"
	_tmp30_[2] = _tmp27_;
#line 940 "../src/photos/PhotoMetadata.vala"
	_tmp30_[3] = _tmp28_;
#line 940 "../src/photos/PhotoMetadata.vala"
	_tmp30_[4] = _tmp29_;
#line 940 "../src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS = _tmp30_;
#line 940 "../src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS_length1 = 5;
#line 985 "../src/photos/PhotoMetadata.vala"
	_tmp31_ = g_strdup ("Exif.Photo.UserComment");
#line 985 "../src/photos/PhotoMetadata.vala"
	_tmp32_ = g_strdup ("Xmp.acdsee.notes");
#line 985 "../src/photos/PhotoMetadata.vala"
	_tmp33_ = g_new0 (gchar*, 2 + 1);
#line 985 "../src/photos/PhotoMetadata.vala"
	_tmp33_[0] = _tmp31_;
#line 985 "../src/photos/PhotoMetadata.vala"
	_tmp33_[1] = _tmp32_;
#line 985 "../src/photos/PhotoMetadata.vala"
	photo_metadata_COMMENT_TAGS = _tmp33_;
#line 985 "../src/photos/PhotoMetadata.vala"
	photo_metadata_COMMENT_TAGS_length1 = 2;
#line 1008 "../src/photos/PhotoMetadata.vala"
	_tmp34_ = g_strdup ("Xmp.dc.subject");
#line 1008 "../src/photos/PhotoMetadata.vala"
	_tmp35_ = g_strdup ("Iptc.Application2.Keywords");
#line 1008 "../src/photos/PhotoMetadata.vala"
	_tmp36_ = g_strdup ("Xmp.xmp.Label");
#line 1008 "../src/photos/PhotoMetadata.vala"
	_tmp37_ = g_new0 (gchar*, 3 + 1);
#line 1008 "../src/photos/PhotoMetadata.vala"
	_tmp37_[0] = _tmp34_;
#line 1008 "../src/photos/PhotoMetadata.vala"
	_tmp37_[1] = _tmp35_;
#line 1008 "../src/photos/PhotoMetadata.vala"
	_tmp37_[2] = _tmp36_;
#line 1008 "../src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS = _tmp37_;
#line 1008 "../src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS_length1 = 3;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp38_ = null_keyword_transformer_new ();
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp39_ = _tmp38_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp40_ = hierarchical_keyword_field_new ("Xmp.lr.hierarchicalSubject", "|", FALSE, FALSE, G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer));
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp41_ = null_keyword_transformer_new ();
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp42_ = _tmp41_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp43_ = hierarchical_keyword_field_new ("Xmp.acdsee.keywords", "|", FALSE, FALSE, G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer));
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp44_ = acd_see_keyword_transformer_new ();
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp45_ = _tmp44_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp46_ = hierarchical_keyword_field_new ("Xmp.acdsee.categories", "|", FALSE, FALSE, G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer));
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp47_ = null_keyword_transformer_new ();
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp48_ = _tmp47_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp49_ = hierarchical_keyword_field_new ("Xmp.digiKam.TagsList", "/", FALSE, TRUE, G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer));
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp50_ = null_keyword_transformer_new ();
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp51_ = _tmp50_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp52_ = hierarchical_keyword_field_new ("Xmp.MicrosoftPhoto.LastKeywordXMP", "/", FALSE, TRUE, G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer));
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp53_ = g_new0 (HierarchicalKeywordField*, 5 + 1);
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp53_[0] = _tmp40_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp53_[1] = _tmp43_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp53_[2] = _tmp46_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp53_[3] = _tmp49_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp53_[4] = _tmp52_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS = _tmp53_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 5;
#line 1279 "../src/photos/PhotoMetadata.vala"
	_tmp54_ = g_strdup ("Exif.Image.Artist");
#line 1279 "../src/photos/PhotoMetadata.vala"
	_tmp55_ = g_strdup ("Exif.Canon.OwnerName");
#line 1279 "../src/photos/PhotoMetadata.vala"
	_tmp56_ = g_strdup ("Xmp.acdsee.author");
#line 1279 "../src/photos/PhotoMetadata.vala"
	_tmp57_ = g_new0 (gchar*, 3 + 1);
#line 1279 "../src/photos/PhotoMetadata.vala"
	_tmp57_[0] = _tmp54_;
#line 1279 "../src/photos/PhotoMetadata.vala"
	_tmp57_[1] = _tmp55_;
#line 1279 "../src/photos/PhotoMetadata.vala"
	_tmp57_[2] = _tmp56_;
#line 1279 "../src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS = _tmp57_;
#line 1279 "../src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS_length1 = 3;
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp58_ = g_strdup ("Xmp.xmp.Rating");
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp59_ = g_strdup ("Iptc.Application2.Urgency");
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp60_ = g_strdup ("Xmp.photoshop.Urgency");
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp61_ = g_strdup ("Exif.Image.Rating");
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp62_ = g_strdup ("Xmp.acdsee.rating");
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp63_ = g_new0 (gchar*, 5 + 1);
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp63_[0] = _tmp58_;
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp63_[1] = _tmp59_;
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp63_[2] = _tmp60_;
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp63_[3] = _tmp61_;
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp63_[4] = _tmp62_;
#line 1317 "../src/photos/PhotoMetadata.vala"
	photo_metadata_RATING_TAGS = _tmp63_;
#line 1317 "../src/photos/PhotoMetadata.vala"
	photo_metadata_RATING_TAGS_length1 = 5;
#line 9969 "PhotoMetadata.c"
}

static void
photo_metadata_instance_init (PhotoMetadata * self,
                              gpointer klass)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
#line 213 "../src/photos/PhotoMetadata.vala"
	self->priv = photo_metadata_get_instance_private (self);
#line 250 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 250 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 251 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 252 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("<uninitialized>");
#line 252 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp1_;
#line 253 "../src/photos/PhotoMetadata.vala"
	self->priv->metadata_hash = NULL;
#line 254 "../src/photos/PhotoMetadata.vala"
	self->priv->thumbnail_md5 = NULL;
#line 9994 "PhotoMetadata.c"
}

static void
photo_metadata_finalize (MediaMetadata * obj)
{
	PhotoMetadata * self;
#line 213 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 250 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 251 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 252 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 253 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->metadata_hash);
#line 254 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->thumbnail_md5);
#line 213 "../src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (photo_metadata_parent_class)->finalize (obj);
#line 10015 "PhotoMetadata.c"
}

static GType
photo_metadata_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadata), 0, (GInstanceInitFunc) photo_metadata_instance_init, NULL };
	GType photo_metadata_type_id;
	photo_metadata_type_id = g_type_register_static (TYPE_MEDIA_METADATA, "PhotoMetadata", &g_define_type_info, 0);
	PhotoMetadata_private_offset = g_type_add_instance_private (photo_metadata_type_id, sizeof (PhotoMetadataPrivate));
	return photo_metadata_type_id;
}

GType
photo_metadata_get_type (void)
{
	static volatile gsize photo_metadata_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_type_id__volatile)) {
		GType photo_metadata_type_id;
		photo_metadata_type_id = photo_metadata_get_type_once ();
		g_once_init_leave (&photo_metadata_type_id__volatile, photo_metadata_type_id);
	}
	return photo_metadata_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

